////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmAK2.h
//
// Creator       : Kawa
// Creation Date : 10/06/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMAK2_H__
#define	__ENMAK2_H__

#define AK2_SHOTDIRBIAS			(-0.12F)	// ]̃̕oCAXl

#include "..\Wat\WK7Enemy.h"
#include "EnmBoss.h"
#include "..\Yam\YK7EffectShot.h"
#include "..\Wat\WK7Model.h"
#include "..\Wat\WK7Stage.h"
#include "..\fujita\c_setalpha.h"

// Vb^[̏
typedef struct tagSTG361SHAT
{
	WK7JObj *JObj ;		// Vb^[ JObj 

	bool closeflag ;	// ( false:JƂ  true:܂낤Ƃ )
	f32 closerate ;		// J( 1.0F:Ă  0.0F:JĂ )
	bool endflag ;		// 삪IĂ邩tO
} STG361SHAT ;

class K7EnmAK2 : public K7EnmBoss{
protected:
	enum AK2_ANG
	{
		AK2_DIR_FRONT = 0,
		AK2_DIR_MINUS ,
		AK2_DIR_PLUS
	} ;
	
	enum AK2_SHOTTYPE
	{
		AK2_SHOT_WIDE = 0,		// ChVbg
		AK2_SHOT_ONE = 1,		// _W
		AK2_SHOT_TYPENUM = 2,	// ނ̐
	} ;
	
	bool		InitFlag ;					// tO
	void		Dummy( void );
	u32			mInitProcess;				// ǂݍ݃Xe[^Xp
	WK7Model 	*mpGun;						// ef
	s16			mSecondShotTiming;			// Qڂ̃^C~O
	s16			mBulletNow;					// e

	EFFECT		*efdam ;					// _[WGtFNg
	s32 		efdamCounter ;				// _[WGtFNg̕\JE^

	EFFECT		*blur ;						// u[GtFNg
	u32			blurid ;					// u[GtFNghc

	s16			Vital ;						// ̗

	SAFERAND	WaitRand ;					// ҋ@Ԃ̘A񐔊Ǘf[^
	SAFERAND	KakuranRand ;				// ^Cv̘A񐔊Ǘf[^
	SAFERAND	NormalAtRand ;				// ʏU̍U@A񐔊Ǘf[^
	SAFERAND	IkariAtRand ;				// {莞̍U@A񐔊Ǘf[^

	EFFECT		*muz ;						// }ỸGtFNg
	u32			muzid ;						// }Ŷhc
	s32			muzzlecon ;					// }YtbVo^C~ÕJE^
	bool		shotflag ;					// Vbg邩ǂ̃tO
	f32			shotbias ;					// Vbĝxɑ΂oCAXl
	
	s32			BlurOpen ;					// u[VbgŎgpJĂ镔
	s32			BlurClose ;					// u[VbgŎgpĂ镔
	s32			BlurNum ;					// u[Vbg
	
	EFFECT		*shot ;						// VbgGtFNg
	
	bool		TurnFlag ;					// ^[tO
	AK2_ANG		TargetDir ;					// ڕW
	s32			IndexPos ;					// ړ(CfbNX)
	s32			OpenPos ;					// Jꏊ
	bool		kamaeflag ;					// \Ă邩ǂ̃tO
	bool		motionflag ;				// [VύX邩tO
	f32			TargetPos ;					// ړ
	f32			movespeed ;					// ړx
	f32			Pos ;						// ݒn( t\L)
	Vec			VecPos ;					// ݒn
	s32			WaitTime ;					// ҂
	s32			KakuranCon ;				// pJE^
	s32			KakuranType ;				// 悤ϐ
	bool		IkariMode ;					// {胂[h
	s32			DamageCon, DamageCon2 ;		// _[WJE^
	s32			DamageTime ;				// _[WHĂ̎
	
	STG361SHAT	*shat ;						// Vb^[
	
	s16			mShotNum;					// VbgJEgp
	s16			MuzzleWaitCon ;				// }YtbV̊ԊuJE^
	s32			ShotWaitTime ;				// ̑҂
	AK2_SHOTTYPE ShotType ;					// ˌ^Cv
	
	s32 		PlayMotionID ;				// ݍĐĂ郂[V
	bool		motionloop ;				// [V[v邩ǂ̃tO
	f32			motioncon ;					// [VJE^[
	f32			motiontime ;				// Đ̃[Ṽt[
	f32			motionspeed ;				// Đ̃[ṼXs[h
	bool		dmgmotionflag ;				// _[W[VtO	
	s32			dmgmotiontime ;				// _[W[V̎
	s32			dmgmotiontimecon ;			// _[W[V̍ĐԃJE^
	f32			dmgmotioncon ;				// _[W[VJE^[
	f32			dmgmotionspeed ;			// _[W[VXs[h
	
	bool		nodamegeaction ;			// _[W[VĐȂtO
	s32			pdamagecon ;				// vC[̃_[WJE^
	s32			pdamagetime ;				// vC[̃_[WHẴt[
	s32			pdamagetime2 ;				// vC[̃_[WHẴLZȂł̃t[

	bool		alphainitflag ;				// tO
	C_SetAlpha	*bodyalpha ;				// ̗pNX
	C_SetAlpha	*gunalpha ;					// epNX
	f32			alpha ;						// ݂̃At@l
	f32			alphaspeed ;				// ̑x
	bool		validalpha ;				// LtO
	f32			targetalpha ;				// ڕW̃At@l
	bool		hideflag ;					// ȂȂ邩AtO
	
	u32			mBattleCount;				// og̎
	u32			mBattleProcess;				// og̊Ǘ
	int 		mBatteleExit;				// og̏I}

	bool		DieFlag ;					// StO
	bool		InitEndFlag ;				// ItO
	bool		mVisible ;					// \A\
	bool		mVisible3 ;
	bool		mAK2BattleStart;
	s32			mod, con, con2, con3 ;
	
	s32			GlobalModeState ;			// OɌJXe[^X
	u32			mMoveProcess;				// sp^[tO
	
	Vec			mStartPos;					// X^[gʒu̕ۑ
	Vec			mEndPos;					// 点I_ʒu
	f32			mGoDir;						// 点
	
	void		createblur( void ) ;		// u[GtFNg쐬
	void		deleteblur( void ) ;		// u[GtFNg폜
	
	void		alphavalidflag( bool flag ) ;			// ̗LtOZbg
	void		alphainit(void) ;						// ̏
	void		alphaend(void) ;						// ̌n
	void		setalpha(bool disp, f32 speed=0.1F);	// l̕ύX
	void		alphaproc(void) ;						// ̃t[vZX

	void		PlayMotion( u32 id, bool loop = false, bool hokan = true, f32 speed = 1.0F ) ;	// [VĐ
	void		PlayDamageMotion( s32 time, f32 speed = 1.0F ) ;				// _[W[VĐ
	void		MotionProc( void ) ;											// [Ṽt[vZX
	f32			GetMotionTotalTime( u32 id ) ;			// [V̑Ԃ𓾂
	f32			GetMotionFrame( void ) ;				// [V̍ĐԂ𓾂
	bool		GetMotionEnd( void ) ;					// [V̏IԂ𓾂
	AK2_ANG		GetAngle( f32 angle ) ;					// fl񋓌^l𓾂( 0.0F:  Plus:w}CiX֌  Minus:wvX֌ )
	f32			GetWaitRate( void ) ;					// ړ̑҂Ԃ𓾂

	static s8	PlayDamageCallBack( SHOTOBJECT *obj, void *data ) ; // vC[̃_[W̃R[obN
	void		PlayDamageCheck( void ) ;				// vC[̃_[W`FbN
	void		PlayDamageInc( void ) ;					// vC[Ƀ_[Wǉ
	void		PlayDamageProc( void ) ;				// vC[Ƀ_[W^鏈̃t[vZX
	
	void		Die( void ) ;							// S
	void		RefreshPos( void ) ;					// WXV
	void		Ikari( void ) ;							// {胂[h
	void		DashShot( void ) ;						// _bVVbg
	void		BlurShot( void ) ;						// u[Vbg
	void		Kakuran( void ) ;						// 
	void		Damage( void ) ;						// _[W
	void		ShatEndWait( void ) ;					// ҂
	void		Shot( void ) ;							// e
	void		ShotStart( f32 bias = AK2_SHOTDIRBIAS ) ;// VbgX^[g
	void		ShotEnd( void ) ;						// VbgGh
	void		ShotProc( void ) ;						// Vbg̃t[vZX
	void		MoveSpeed( f32 speed = -1.0F ) ;		// ړx̕ύX
	void		Move( f32 pos, bool mchange = true,
						bool kamae = false, bool motion = true,
						bool teleport = false ) ;	// w̍WɈړ( true:I  false:܂ )
	bool		MoveProc( void ) ;						// ړ̃t[vZX
	void		Wait( s32 Wait = -1, bool mchange = true ) ;	// ҋ@ԂɈڍs
	void		Rot( f32 angle, bool hokan = true ) ;	// w̕Ɍ( 0.0F:  Plus:w}CiX֌  Minus:wvX֌ )
	void		RotPlayer( bool hokan = true ) ;		// vC[̕
	void		RotProc( void ) ;						// t[vZX
	void		SetVisible2( bool flag ) ;				// \
	f32			GetTPos( s32 pos ){ return (f32)pos / 3.0F ; }	// l̈ʒu\L̈ʒuɕϊ
	bool		GetMoveEnd( void ){ return TargetPos == Pos ; }	// ړIĂ邩ǂ擾( true:I false:܂ )
	void		CreateMuzzle( void ) ;					// }Yo
	void		DeleteMuzzle( void ) ;					// }Y폜
	
	void		PcDamageSet(void);
	
	void		Cmd_ResetSet(void);
	bool		Cmd_RunSet(Vec goPos);
	
	bool		PcHitTest(void);
	void		AK2_Dmg(void);
	bool		AK2_Run(void);
	void		DieMotSet(void);

	void		RunLogicSet(u32 time);
	
	void		DetachGun(void);
	s16			mRunPointPtr; 

	s32			GetShatIndex( f32 posX ) ;				// ݂̈ʒuԋ߂Vb^[̃CfbNX𓾂	( 0.0F:łx̒l  1.0F:łx̒l傫 )
	f32			GetShatCloseRate( f32 posX ) ;			// Vb^[̕𓾂( 0.0F:łx̒l  1.0F:łx̒l傫 )
	bool		GetShatCloseState( s32 ShatIndex ) ;	// Vb^[܂Ă邩擾
	void		ShatOpen( s32 ShatIndex ) ;				// Vb^[J
	void		ShatClose( s32 ShatIndex ) ;			// Vb^[
	void		ShatAllOpen( void ) ;					// SẴVb^[J
	void		ShatAllClose( void ) ;					// SẴVb^[
	void		ShatFrameProcess( void ) ;				// Vb^[̃t[vZX
	bool		CheckShatAllEnd( void ) ;				// Vb^[SĎ~܂Ă邩𓾂( true:SĎ~܂Ă  false:~܂ĂȂ )

public:
	K7EnmAK2(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio=WK7OBJ_DEFAULT_PRIO);
	~K7EnmAK2();

	void		Release(void);
	void		GetRootJointPos( Vec *pos ) ;			// S_𓾂
	WK7Model 	*GetModel(void) ;						// f擾


	inline	void SetVisible3( bool flag ){ mVisible3 = flag ; SetVisible2( mVisible ) ; }			// \
	inline	s32 GetGlobalModeState(void){ return GlobalModeState ; }
	inline	void SetGlobalModeState(s32 num){ GlobalModeState = num ; }
	
	bool	FrameProcess(void);
	bool	ControlProcess(void);
	
	inline	void SetShatData( STG361SHAT *pos ){ shat = pos ; }
	
	void	StageProc(WK7Stage *pCurrentStage);
	bool	AK2BossStart(void);
	int		AK2BossEnd(void);
	inline	bool	GetInitEndFlag(void){ return InitEndFlag ; }
	bool 	PlayCommonMotionAK2(u32 id, bool loop, bool hokan, f32 sframe=0.0f, f32 speed=1.f);
};


#ifdef	__ENMAK2_CPP__

//#define AK2_HP				(150)			// AJlgo
#define AK2_GUN_BULLET_MAX	(12*2)			// e
#define AK2_GUN_DAMAGE		(10)			// e

#define GUN_R				GUN_MP5ARFL_R

#define SECOND_SHOT_FRAME		(10)

#define RUN_SPEED			(3.5f)

#define DOOR_OPEN_FRAME		(WK7_SEC_TO_FRAME(5))

#define CALL_INIT			(0)
#define CALL_MOVE			(1)
#define CALL_WAIT			(2)


#define RUNPOINT_MAX	(4)
Vec AK2_MovePoint[RUNPOINT_MAX] = {
	{303.f,		0.f, 	280.f},
	{-303.f,	0.f, 	280.f},
	{-303.f,	0.f, 	-280.f},
	{303.f,		0.f, 	-280.f},
};



enum AK2_MOT{
	AK2_MOT_WAIT = 0,		// R
	AK2_MOT_RUN,			// 
	AK2_MOT_SHOTDASH,		// ˌ̂P
	AK2_MOT_SHOTDASH2,		// ˌ̂Q
	AK2_MOT_SHOTPOSE,		// ˌ\
	AK2_MOT_SHOTFREE,		// \[v
	AK2_MOT_SHOTNOW,		// ˌ̂P
	AK2_MOT_SHOTNOW2,		// ˌ̂Q
	AK2_MOT_SHOTRETURN,		// \߂
	AK2_MOT_RELOAD,			// [h
	AK2_MOT_TURN,			// ^[
	AK2_MOT_DAM,			// _[W
	AK2_MOT_DIE,			// S
	AK2_MOT_MAX
};

s16 MotionIDTableAK2[] = {
	20,				// R
	90,				// 
	91,				// ˌP
	92,				// ˌQ
	100,			// ˌ\
	101,			// \[v
	102,			// ˌ̂P
	103,			// ˌ̂Q
	104,			// \߂
	110,			// [h
	140,			// ^[
	150,			// _[W
	310,			// S
	-1
};


//	#define SFX_BT_HS_AK2UGI_MAX	(4)
//	static int damageSeTbl[SFX_BT_HS_AK2UGI_MAX] = {
//		SFX_BOSS_AK2_GRUNTS0,
//		SFX_BOSS_AK2_GRUNTS1,
//		SFX_BOSS_AK2_GRUNTS2,
//		SFX_BOSS_AK2_GRUNTS3
//	};

#else


#endif




#endif	//__ENMAK2_H__

