////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object {XFVg
//
// Enmang.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMFAN_CPP__

#include "EnmFAN.h"
#include "..\Yam\YK7EffectFeather.h"
#include "..\Wat\WK7Event.h"
#define EASY 0
#define FEATHER 1

#if 0
Qڂ̑VgA

qbgȊȎ̕ɃvC[̒eqbg

#define SFX_BOSS_TENSHI_NODAMAGE     ((21<<16) + 16)//Vgm[_[W{CX

炷BA˂̑LōUƁAႤ̂
x̊ԊuāAĂі炵ė~AƂ̎B
#endif



//ZߖB
#define PLAY_SHORT_SCREAM()	gpSound->mPlaySE( SFX_BOSS_FAN_DAMAGE_VOICE )
#define PLAY_HIT()	gpSound->mPlaySE( SFX_BOSS_FAN_DAMAGE_HIT )
//ߖB
#define PLAY_LONG_SCREAM()	gpSound->mPlaySE( SFX_BOSS_FAN_DIE )
//߁B([vɂȂ̂ŁAIIt)
#define PLAY_CHARGE_LOOP() gpSound->mPlaySE( SFX_BOSS_FAN_CHARGE )
#define STOP_CHARGE_LOOP()
//ˁB
#define PLAY_FIRE() gpSound->mPlaySE( SFX_BOSS_FAN_ATTACK )
//B
#define PLAY_BINGO() gpSound->mPlaySE( SFX_BOSS_FAN_BOMB )
//NオB
#define PLAY_WAKEUP() gpSound->mPlaySE( SFX_BOSS_TENSHI_WAKEUP )


#define GEN 1

s16 MotionIDTableFAN[] = {
	20,							// R
	30,							// NオB
	40,							// Ŕ[UB
	50,						// U[v
	60,						// U[ŔB
	70,						// B
	-1
};
static char *gNames[] = {"Kun__Face1", "Kun__Face2", "Kun__Face3", "Kun__Face4"};

K7EnmFAN *K7EnmFAN::instance = 0;

static
HSD_FogDesc gFogDesc = {
  GX_FOG_LIN,                                  /* fog type */
  NULL,                                        /* adjdesc */
  85.0f,                                        /* startz */
  (512.f + 1024.0f),                              /* endz */
  {255, 255, 255, 255},                         /* color */
};
void K7EnmFAN::Dummy( void )
{
}
bool K7EnmFAN::IsMyRenderID( u32 id, Vec *p )
{
#pragma unused(id)
#pragma unused(p)
#if 1
  return false;
#else
  //񂺂ႤhcԂĂB
  //DamageTest()trueԂȂ̂ρB
  //ANG̕DamageTest()trueԂĂB
  //OSReport( "%d %d\n", id, mpNpcChara->GetRenderID() );

  if( !mpNpcChara ) return false;
  if( id == mpNpcChara->GetRenderID() ){
	switch ( (s32)state ){
	case FAN_STATE_NEUTRAL:
	case FAN_STATE_SHOT:
	  if( no_hit_counter == 0 ) no_hit_counter = 60;
	  break;
	default:
	  break;
	}
	return true;
  }else{
	return false;
  }
#endif

}
static GHMGCTASK_HANDLER( HitTask );
static GHMGCTASK_HANDLER( HitTask )
{
  bool *flg = (bool*)task_get_param(0);
  *flg = true;
  task_exit();
}

K7EnmFAN::K7EnmFAN(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) :
  K7EnmBoss( enemyid, suffix, pAnchor, prio, K7FAN, MotionIDTableFAN )
{
  // Gʂ̃f[^̃Zbg
  mData.mHp			= 100;								// go
  mData.mWeakID		= NPCWEAKOBJID_HEAD;				// _
  mData.mVLossID		= NPCWEAKOBJID_LFOOT;				// ʐѕ
  mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
  mData.mScale		= 1.f;								// 
  alive = true;
#if FEATHER
  yamada_effect[0]  =  yamada_effect[1]  = yamada_effect[2]  = 0;
#endif
  die_counter = 0;
  fog = HSD_FogLoadDesc(&gFogDesc);
  instance = this;
  state.Init( FAN_STATE_SLEEP );
  for( int i=0; i<FAN_MAX_HIT; i++ ){
	face_hit_flg[i] = false;
	face_hit_counter[i] = 0;
	face_hit_obj[i] = 0;
  }
#if !EASY
  hit_counter = 0;
#else
  hit_counter = 3;
#endif
  appear = 0;
  hit_req = false;
  pause_req = false;
  stand_still_counter = 0;
#if GEN
  for( int i=0; i<FAN_MAX_GEN; i++ ){
	Vec p = {0.f,};
	gen[ i ] = new C_Generator( p, 13 );
  }
  for( int i=0; i<FAN_MAX_HIT; i++ )  gen_face[i] = 0;
#endif
  blur = 0;
  no_hit_counter = 0;
}

void K7EnmFAN::AdditionalPreRenderProcess( void )
{
  if( blur ) blur->Disp();
}
void K7EnmFAN::AdditionalPostRenderProcess( void )
{
  if( mpRootBone ) {
	GXSetZMode( GX_TRUE, GX_LEQUAL, GX_TRUE );

	GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0);
	GXSetTevOp(GX_TEVSTAGE0, GX_PASSCLR);
	GXSetNumTevStages(1);
	GXSetNumTexGens(0);
	GXSetBlendMode(GX_BM_NONE, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR);
	GXSetChanCtrl(GX_COLOR0A0,
				  GX_DISABLE,		// enable channel
				  GX_SRC_REG,		// amb source
				  GX_SRC_REG,		// mat source
				  GX_LIGHT_NULL,	// light mask
				  GX_DF_CLAMP,	// diffuse function
				  GX_AF_NONE);
	GXSetNumChans(1);
	GXColor col={255,255,255,255};
	GXSetChanMatColor( GX_COLOR0A0, col );
	GXSetChanAmbColor( GX_COLOR0A0, col );

	GXSetColorUpdate( GX_TRUE );
	GXSetAlphaUpdate( GX_FALSE );
	GXSetCullMode( GX_CULL_BACK );

	mpRootBone->RenderProcess( true, true, HSD_TRSP_OPA, RENDER_SHADOW|RENDER_EFFECT);
	HSD_StateInvalidate( HSD_STATE_ALL );
  }
}
K7EnmFAN::~K7EnmFAN()
{
#if FEATHER
  // HGtFNg̍폜˗
  for( int i=0; i<3; i++ ){
	if( yamada_effect[i] && GetEffectValidState( yamada_effect[i] ) ) ::DelReqEffect( yamada_effect[i] ) ;
	yamada_effect[i] = NULL;
  }
#endif
  if( fog ){
	HSD_FogUnref( fog );
	fog = NULL;
  }
  instance = 0;
  for( int i=0; i<FAN_MAX_HIT; i++ )GHM_SAFE_DELETE( face_hit_obj[i] );
#if GEN
  for( int i=0; i<FAN_MAX_GEN; i++ )GHM_SAFE_DELETE( gen[i] );
  for( int i=0; i<FAN_MAX_HIT; i++ )GHM_SAFE_DELETE( gen_face[i] );
#endif

  GHM_SAFE_DELETE( blur );
}
void K7EnmFAN::SetupEyeTgtPos( Vec &eye_, Vec &tgt_ )
{
  tgt_ = mPosition;
  tgt_.y += 10.f;

  Vec ppos;
  WK7PLAYERCONTROL->GetPosition(ppos);
  
  //VECSubtract( &mPosition, &ppos, &eye_ );
  VECSubtract( &ppos, &mPosition, &eye_ );
  VECNormalize( &eye_, &eye_ );
  eye_.y -= 0.4f;

  f32 dist = 15.f;
  VECScale( &eye_, &eye_, dist );
  VECAdd( &tgt_, &eye_, &eye_ );
}
bool K7EnmFAN::ControlProcess(void)
{
	if( mState==NPC_STATE_INIT ){ return WK7Npc::ControlProcess(); }
	if( GetNpcPause()==true ){ return true; }
	
#define MOTION_END( ) (GetCommonMotionState() == WK7MODEL_NOANIM)
#define MOTION_REWIND(  ) (GetCommonMotionState() == AOBJ_ANIM_REWINDED)
#define IS_MOTION( Y ) ((u32)(mot_id == Y))
#define PLAY( Y ) PlayCommonMotion( (u32)(mot_id = Y), false, false )
#define PLAY_INTRP( Y ) PlayCommonMotion( (u32)(mot_id = Y), false, true )
#define PLAY_LOOP( Y ) PlayCommonMotion( (u32)(mot_id = Y), true, false )
#define PLAY_LOOP_INTRP( Y ) PlayCommonMotion( (u32)(mot_id = Y), true, true )
#define PERCENT( X ) ((HSD_Rand()%101) > (100-X) )
#define MOT_FRAME( ) (  mpRootBone ? mpRootBone->GetCurrentMotionFrame() : 0 ) 
#define MOT_STOP() (  mpRootBone ? mpRootBone->StopMotionAll() : 0 ) 
  WK7Model *pModel;

  if ( mpNpcChara==NULL ) 		return true;
  if ( true == IsLoading() ) 		return true;											// ǂݍݒ
  if( (pModel = mpNpcChara->GetModel())==0 ) return true;
  if( pause_req  ) return true;

  if( GetNpcPause() ) return true;

  if ( mState == NPC_STATE_INIT ) goto NPC_CTRL_INIT_JUMP;
  switch( mState ){
  case NPC_STATE_INIT:
  NPC_CTRL_INIT_JUMP:
  StateInit();
  break;
  case NPC_STATE_WAIT:
  case NPC_STATE_WALK:
  case NPC_STATE_RUN:
  case NPC_STATE_TURN:
  case NPC_STATE_ATK:
  case NPC_STATE_DMG:
  case NPC_STATE_DMG_FALL:
  case NPC_STATE_LOSS:
  case NPC_STATE_DIE:
  default:
	break;
  }
  
  Vec ppos;
  {
	WK7PLAYERCONTROL->GetPosition(ppos);
	if( ppos.x == last_player_pos.x && ppos.z == last_player_pos.z ){
	  ++stand_still_counter;
	}else{
	  stand_still_counter = 0;
	}
  }
  f32 rot_div = 10.f;
  f32 rot = atan2f((f32 )ppos.x - mPosition.x, (f32 )ppos.z - mPosition.z);

  do{
	switch( (s32)state ){
	case FAN_STATE_SLEEP:
	  {
		switch( state.GetPhase() ){
		case PHASE_CTOR:{
		  mpNpcChara->SetVisible(false);
		  mHideAlphaNow       = 1.0f;
		  pModel->Hide();
		  mpNpcChara->SetRenderFlag(false);
		}break;
		case PHASE_PROC:{
		  if( appear == 1 ) state = FAN_STATE_WAKEUP;
		  if( appear == 2 ) state = FAN_STATE_NEUTRAL;
		}break;
		case PHASE_DTOR:{
		}break;
		}
	  }break;
	case FAN_STATE_WAKEUP:
	  {
		switch( state.GetPhase() ){
		case PHASE_CTOR:{
		  mpNpcChara->SetVisible(true);
		  mHideAlphaNow       = 1.0f;
		  pModel->Disp();
		  mpNpcChara->SetRenderFlag(true);
		  PLAY( FAN_MOT_WAKEUP );
		  PLAY_WAKEUP();
		}break;
		case PHASE_PROC:{
		  if( MOTION_END() ) state = FAN_STATE_NEUTRAL;
		}break;
		case PHASE_DTOR:{
		}break;
		}
	  }break;
	case FAN_STATE_STAND_STILL:
	  {
		switch( state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY_LOOP( FAN_MOT_NEUTRAL );
		}break;
		case PHASE_PROC:{
		  //^XNɎÊ҂B
		}break;
		case PHASE_DTOR:{
		}break;
		}
	  }break;
	case FAN_STATE_NEUTRAL:
	  {
		switch( state.GetPhase() ){
		case PHASE_CTOR:{
		  mpNpcChara->SetVisible(true);
		  mHideAlphaNow       = 1.0f;
		  pModel->Disp();
		  mpNpcChara->SetRenderFlag(true);
		  PLAY_LOOP( FAN_MOT_NEUTRAL );
		  stand_still_counter = 0;
		}break;
		case PHASE_PROC:{
		  if( stand_still_counter > 30 ) state = FAN_STATE_SHOT;
		  mTargetRotY = rot;
		}break;
		case PHASE_DTOR:{
		}break;
		}
	  }break;
	case FAN_STATE_SHOT:
	  {
		switch( state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY( FAN_MOT_NEUTRAL_TO_SHOT );
		  gen_counter = 0;
		  counter = 0;
		}break;
		case PHASE_PROC:{
		  if( IS_MOTION( FAN_MOT_NEUTRAL_TO_SHOT ) ){
			counter += 1;
			//vC[ƂĂ(́Au[o)
			if( stand_still_counter || blur ){
			  //LL
			  s32 blur_start = 48;
			  if( !blur && counter == blur_start ){
				mpNpcChara->mpAdditionalPreRender = this;
				HSD_JObj *root_jobj = mpNpcChara->GetJObj()->GetJObj();
				HSD_JObj *target_jobj = mpNpcChara->GetJObj("WristR_joint")->GetJObj();
				blur = new C_RadialBlur( root_jobj, target_jobj, 0 );
				PLAY_CHARGE_LOOP();
			  }

			  if( MOTION_END() ){
				PLAY_LOOP( FAN_MOT_SHOT_NEUTRAL );
				aim_pos = ppos;
				counter = 0;
				STOP_CHARGE_LOOP();
				PLAY_FIRE();
			  }
			}else{
			  //vC[t葁o猂̂߂B
			  PLAY( FAN_MOT_SHOT_TO_NEUTRAL );
			  STOP_CHARGE_LOOP();
			}
			mTargetRotY = rot;
		  }else if( IS_MOTION( FAN_MOT_SHOT_NEUTRAL ) ){
			s32 shot_length = 120;

			//B(O珇FAN_MAX_GEN)
			if( gen_counter < FAN_MAX_GEN && !(counter % FAN_GEN_TIME) ){
			  C_Vec d(aim_pos), s(mPosition), dir = d - s;
			  dir *= (f32)((gen_counter+2) / (f32)(FAN_MAX_GEN+2));
			  dir += s;
			  dir.y += 5.f;
#if GEN
			  gen[ gen_counter ]->SetPos(dir);
			  gen[ gen_counter++ ]->Fire();
#endif
			  if( gen_counter == FAN_MAX_GEN && d.Dist( ppos ) < 10.f){
				hit_req = true;
				PLAY_BINGO();
			  }
			  
			}

			//IH
			if(  ++counter > shot_length ){
			  PLAY( FAN_MOT_SHOT_TO_NEUTRAL );
			  if( blur ) {delete blur; blur = 0;}
			}

			//DB
			for( int i=0 ; i< FAN_MAX_HIT; i++ ){
			  if( face_hit_flg[i] ){
				++face_hit_counter[i];
				hit_req = false;//vC[DB
				HSD_JObjSetFlags( mpNpcChara->GetJObj(gNames[i])->GetJObj(), JOBJ_HIDDEN);
				if( ++hit_counter == FAN_MAX_HIT ) 
				  state = FAN_STATE_DEAD;
				else
				  state = FAN_STATE_DAMAGE;
			  }
			}
		  }else if( IS_MOTION( FAN_MOT_SHOT_TO_NEUTRAL ) ){
			f32 rate=1.f;
			if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE) ){
			  rate = 0.9f;
			}
			mpNpcChara->GetModel()->SetMotionRate(rate);

			if(  MOTION_END() )	state = FAN_STATE_NEUTRAL;
			//DB
			for( int i=0 ; i< FAN_MAX_HIT; i++ ){
			  if( face_hit_flg[i] ){
				++face_hit_counter[i];
				HSD_JObjSetFlags( mpNpcChara->GetJObj(gNames[i])->GetJObj(), JOBJ_HIDDEN);
				if( ++hit_counter == FAN_MAX_HIT ) 
				  state = FAN_STATE_DEAD;
				else
				  state = FAN_STATE_DAMAGE;
			  }
			}
		  }
		}break;
		case PHASE_DTOR:{
		  if( blur ) {delete blur; blur = 0;}
		  mpNpcChara->GetModel()->SetMotionRate(1.f);
		}break;
		}
	  }break;
	case FAN_STATE_DAMAGE:
	  {
		switch( state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY( FAN_MOT_DAMAGE );
		  PLAY_SHORT_SCREAM();
		  PLAY_HIT();
		}break;
		case PHASE_PROC:{
		  if( MOTION_END() ) state = FAN_STATE_NEUTRAL;
		}break;
		case PHASE_DTOR:{
		}break;
		}
	  }break;
	case FAN_STATE_DEAD:
	  {
		switch( state.GetPhase() ){
		case PHASE_CTOR:{
		  mpNpcChara->mpAdditionalPostRender = this;
		  die_counter = 0;
		  counter = 0;
		  MOT_STOP();
		K7SCR_PC_SETVISIBLE(false);		// LN^[ʂƂ̂ŁALĂ
		  PLAY_LONG_SCREAM();
		  //todo H̕オz͂ŁB
		  Vec wpos;
		  mpNpcChara->GetJObj()->GetWorldPosition(&wpos);
		  wpos.y += 50.f;
#if FEATHER
		  yamada_effect[0] = 
			CreateFeatherEffect( (u16)( VParam[ED_FEATHER][6] * 10 ), 
				 wpos,
				 VParam[ED_FEATHER][7] * 0.05F, PI_2 * VParam[ED_FEATHER][8] / 360, 
				 (u8)VParam[ED_FEATHER][3], VParam[ED_FEATHER][4] * 0.1F, VParam[ED_FEATHER][5] * 0.01F,
			   (u8)VParam[ED_FEATHER][1], (u8)VParam[ED_FEATHER][2], VParam[ED_FEATHER][9] * 0.001F, 
			   VParam[ED_FEATHER][10] * 10.0F,	1 ) ;
#endif
		}break;
		case PHASE_PROC:{
		  s32 frame = 60;
		  if( ++die_counter < frame ){
			f32 val = sinf( (f32)M_PI * die_counter / (f32)frame );
			fog->startz = (1.f-val) * gFogDesc.startz;
			fog->endz = fog->startz + 10.f + 127.f*(1.f-val);
			WK7RenderObj::SetFog( fog );
			if( die_counter == (frame/2) ){
			  mpNpcChara->SetVisible(false);
			  mHideAlphaNow       = 1.0f;
			  pModel->Hide();
			  mpNpcChara->SetRenderFlag(false);
			  if (++counter < 60) --die_counter;
			}
			if( die_counter == 10 ) PLAY_BINGO();
		  }else{
			state = FAN_STATE_GAMEOVER;
		  }
		}break;
		case PHASE_DTOR:{
		  mpNpcChara->mpAdditionalPostRender = 0;
		}break;
		}
	  }break;
	case FAN_STATE_GAMEOVER:
	  {
		switch( state.GetPhase() ){
		case PHASE_CTOR:{
		  mState = NPC_STATE_LOSS;
		  SetEnemyDieInfo(NPC_DIE_DIE);
		}break;
		case PHASE_PROC:{
		}break;
		case PHASE_DTOR:{
		}break;
		}
	  }break;
	default:
	  break;
	}

  }while( !state.Proc() );
  
  mpNpcChara->SetRotY(mTargetRotY);
  SetRotCalc( rot_div );

  for( int i=0 ; i< FAN_MAX_HIT; i++ ){
	if( face_hit_obj[i] ){
	  face_hit_obj[i]->SetEnable( true );
	  face_hit_flg[i] = false;
	}
  }

  if( no_hit_counter ){
	if( no_hit_counter == 60 ) {
		if ( K7MSK != WK7PLAYERCONTROL->GetMainID() ){
			gpSound->mPlaySE( SFX_BOSS_TENSHI_NODAMAGE );
		}
	}
	--no_hit_counter;
  }else if( DamageTest() ){
	no_hit_counter = 60;
	mDamage.mDamHitRequest = 0;
  }
  last_player_pos = ppos;

  return false;
}
bool K7EnmFAN::FrameProcess(void)
{
	MotionProcess();
	
  if( mpNpcChara!=NULL ){
		
	if( mpNpcChara->GetState()==WK7RenderObj::LOADED ){
			
	  // [VXs[hRg[
	  MotionSpeedControl();
			
	  // ŏ̈ʒuZbg̎
	  if( !mFirstPosSet ){
		mFirstPosSet = 1;

		//̓͓ȂƓȂȂĂB040108
		//		mpNpcChara->SetVisible(true);
		//mHideAlphaNow       = 1.0f;

		mpNpcChara->SetPosition(mPosition);
		// ꂪȂƑȂB
		switch( mpNpcChara->GetRenderID() ){
		case	WK7RENDEROBJ_INVALID_RENDERID:
		  //			case	WK7RENDEROBJ_RENDERID_MAX:
		case	WK7RENDEROBJ_RENDERID_DEFAULT:
		  mpNpcChara->AllocRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
		  OSReport( "fan %d\n", mpNpcChara->GetRenderID() );
		  //mpNpcChara->EnableVfxEffect();
		  break;
		default:
		  break;
		}


		//qbgIuWFNg&p[eBN쐬B
		for( int i=0; i<FAN_MAX_HIT; i++ ){
		  face_hit_obj[i] = CreateHitObj( gNames[i] );
		  face_hit_obj[i]->SetTaskHandler(HitTask);
		  face_hit_obj[i]->SetTaskParam(0,(u32)&(face_hit_flg[i] = false));
		}

#if GEN
		for( int i=0; i<FAN_MAX_HIT; i++ ){
		  gen_face[ i ] = new C_Generator( mpNpcChara->GetJObj(gNames[i])->GetJObj(), 12 );
		}
#endif
	  }
			
	  //BB
	  //[Vɂghcd̃L[Ăۂ̂ŁA
	  //t[KvB
	  for( int i=0 ; i< FAN_MAX_HIT; i++ ){
		if( face_hit_counter[i] ){
		  //ƒx点ĂB
		  s32 frm_ = 10;
		  if( ++face_hit_counter[i] >= frm_ ){
			HSD_JObjSetFlags( mpNpcChara->GetJObj(gNames[i])->GetJObj(), JOBJ_HIDDEN);
#if GEN
			if( face_hit_counter[i] == frm_ )gen_face[i]->Fire();
#endif
		  }
		}
	  }

	  if( hit_req ) {
		WK7PLAYERCONTROL->SetPcDamage(last_player_pos, 30, 0);
		hit_req = false;
	  }
	}
  }
	
  return true;
}

