// nTp[v }XNRs[

#include "EnmHN5.h"
#include "..\Kaw\KK7Effect.h"
#include "..\Kaw\KK7BattleMainTask.h"

K7EnmHN5::K7EnmHN5(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) :
  K7EnmBoss( enemyid, suffix, pAnchor, prio, K7HN5, 0 )
{
  CopyPCPackMotion( K7MSK );
  // Gʂ̃f[^̃Zbg
  mData.mHp			= 100;								// go
  mData.mWeakID		= NPCWEAKOBJID_RARM;				// _
  mData.mVLossID		= NPCWEAKOBJID_LFOOT;				// ʐѕ
  mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
  mData.mScale		= 1.f;								// 
  WK7RenderObj::SetVfxFlag( false );					// {X͂ɂ傤ɂ؂
//  mot_id = -1;
  hit_count = 0;
  WK7PLAYERCONTROL->SetPostPlayMotionCallBack(PlayerPostPlayMotionCallBack,(u32)this);
}
K7EnmHN5::~K7EnmHN5()
{
  WK7PLAYERCONTROL->SetPostPlayMotionCallBack(NULL,0);
}
bool K7EnmHN5::PlayerPostPlayMotionCallBack(WK7PlayerControlPlayMotionInfo *pInfo)
{
	if( pInfo->mParam==NULL ){
		return true;
	}
	K7EnmHN5	*pEnemy = (K7EnmHN5 *)pInfo->mParam;
	return pEnemy->_PlayerPostPlayMotionCallBack(pInfo);
}
bool K7EnmHN5::_PlayerPostPlayMotionCallBack(WK7PlayerControlPlayMotionInfo *pInfo)
{
	WK7Model	*pModel;
	if( mpNpcChara==NULL || (pModel = mpNpcChara->GetModel())==NULL ){
		return true;
	}
	if( pInfo->mCommonID==WK7MOTION_PCCMN_SPATK2 ){
		// ^łȂ
		return true;
	}
	switch( common_state ){
	case	0:	//JnOB
	case	1:	//B
	case	16:	//B
		break;
	case	2:
	default:
		return true;
	}
	WK7Npc::SetMotionIpFrame(pInfo->mIpFrame);
	PlayCommonMotion(pInfo->mCommonID,pInfo->mLoop,pInfo->mHokan,pInfo->mStartFrame,pInfo->mSpeed);
	WK7Npc::SetMotionIpFrame();
	return true;
}
bool K7EnmHN5::ControlProcess(void)
{
	bool yarareSe = false;

	switch( mState ){
	case NPC_STATE_INIT:
NPC_CTRL_INIT_JUMP:
		StateInit();
		break;
	case NPC_STATE_WAIT:
	case NPC_STATE_WALK:
	case NPC_STATE_RUN:
	case NPC_STATE_TURN:
	case NPC_STATE_ATK:
	case NPC_STATE_DMG:
	case NPC_STATE_DMG_FALL:
	case NPC_STATE_LOSS:
	case NPC_STATE_DIE:
	default:
		break;
	}
	
	if( mpNpcChara==NULL ){
		return false;
	}
	
	switch( common_state ){
	case	0:	//JnOB
		break;
	case	1:	//B
		if( DamageTest() ){
			if( ++hit_count >= 5 ){
				common_state = 2;
				hit_count = 0;
				WK7PLAYERCONTROL->SetManualVital(0.0f);
			}else{
				WK7PLAYERCONTROL->SetManualVital((5.0f - hit_count) / 5.0f);
#if 0
//				WK7PLAYERCONTROL->PlayDamageEffect();
#else
				int dmgVoiceNo;
				s16 setFireFrame = WK7_SEC_TO_FRAME(2);
				
				// _[WOŉo
				WK7PLAYERCONTROL->SetPcDamage(mDamage.mDamPos, 0, 1, -1, 0);
				
				if ( rand()&1 )	dmgVoiceNo = SFX_BOSS_HSM_PURPLE_DAMAGE1;
				else			dmgVoiceNo = SFX_BOSS_HSM_PURPLE_DAMAGE1;
				
				// ̃GtFNg
				// RGtFNgJn
				DmgFireEffectStart(setFireFrame);
				
				// Voice
				gpSound->mPlaySE3D( dmgVoiceNo, mDamage.mDamPos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );	// rdĐ
				
				yarareSe = true;
#endif
			}
			
			// UVoice
			if ( yarareSe == false ){
				gpSound->mPlaySE(SFX_BOSS_HSM_PURPLE_ATTACK);			// USE
			}
		}
		break;
	case	2:
		if( mpNpcChara->GetMotionState()==WK7MODEL_NOANIM ){
			common_state = 3;
			WK7Npc::SetMotionIpFrame(WK7PLAYER_INTERPOLATE_FRAME);
			PlayCommonMotion(WK7MOTION_PCCMN_STAND,true,true);
			WK7Npc::SetMotionIpFrame();
		}
		break;
	case	16:	//B
		if( DamageTest() ){
			WK7PLAYERCONTROL->PlayDamageEffect();
			switch( mDamage.mDamType ){
			case	DAMTYPE_GRENADE_FINAL:
				
				KK7BattleMainTask::BattleMainTaskExit(1);
				WK7PLAYERCONTROL->SetOperateEnable(false);
				
				common_state = 17;
				// 
				gpSound->mPlaySE(SFX_BOSS_HSM_PURPLE_DIE);
				WK7Npc::SetMotionIpFrame(WK7PLAYER_INTERPOLATE_FRAME);
				PlayCommonMotion(WK7MOTION_PCCMN_DIE_F,false,true);
				WK7Npc::SetMotionIpFrame();
				break;
			default:
				break;
			}
		}
		break;
	default:
		break;
	}
	
	return false;
}
bool K7EnmHN5::FrameProcess(void)
{
  MotionProcess();
  if( mpNpcChara!=NULL ){
		
	if( mpNpcChara->GetState()==WK7RenderObj::LOADED ){
			
	  // [VXs[hRg[
	  MotionSpeedControl();
			
	  // ŏ̈ʒuZbg̎
	  if( !mFirstPosSet ){

		//̓͓ȂƓȂȂĂB040108
		mpNpcChara->SetVisible(true);
		mHideAlphaNow       = 1.0f;
		mFirstPosSet = 1;
		mpNpcChara->SetPosition(mPosition);
		// ꂪȂƑȂB
		switch( mpNpcChara->GetRenderID() ){
		case	WK7RENDEROBJ_INVALID_RENDERID:
		  //			case	WK7RENDEROBJ_RENDERID_MAX:
		case	WK7RENDEROBJ_RENDERID_DEFAULT:
		  mpNpcChara->AllocRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
		  mpNpcChara->EnableVfxEffect();
		  break;
		default:
		  break;
		}
	  }

	}
  }
	
  return true;
}




