////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmMYS.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMMYS_H__
#define	__ENMMYS_H__

#include "..\Wat\WK7Enemy.h"

class K7EnmMYS : public WK7Enemy{
protected:
public:
	K7EnmMYS(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio=WK7OBJ_DEFAULT_PRIO);
	void PartsRenderIDSet(void);
	void VisibleTestDisp(void);
	void VisibleTestHide(void);
	void EneTypeReset(void);
	bool DamageMotionSelect(s16 frontFlag, u32 *pInSetMotID);
	bool HpDec(s16 inFrontFlag, s16 *pRegiDmgPoint);
	void YoroiDisp(void);
	void YoroiHide(void);
	void YoroiPartsHide(void);
	void FootSeRun(Vec myPos);
	void FootSeWalk(Vec myPos);
	bool GetNoDamage(void);
};

#endif	//__ENMMYS_H__

