////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmTEN.h
//
// Creator       : Kawa
// Creation Date : 03/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMTEN_H__
#define	__ENMTEN_H__

#include "..\Wat\WK7Enemy.h"
#include "EnmBoss.h"
#include "..\Yam\YK7EffectHeader.h"
#include "..\Wat\WK7Model.h"
#include "..\Wat\WK7Stage.h"

class K7EnmTEN : public K7EnmBoss{
protected:
	void		Dummy( void );
	u32			mInitProcess;				// ǂݍ݃Xe[^Xp
	
	void		Release(void);
	f32			mAngle;
	f32			mCircleRadius;
	f32			mHeight;
public:
	K7EnmTEN(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio=WK7OBJ_DEFAULT_PRIO);
	~K7EnmTEN();
	f32 		GetWalkSpeed(void);
	f32 		GetRunSpeed(void);
	
	virtual bool MotStatus_Wait(void);
};


#ifdef	__ENMTEN_CPP__

#define TEN_HP				(1)				// Vggo

#define RUN_SPEED			(0.6f)

enum TEN_MOT{
	TEN_MOT_WAIT = 0,		// R
	TEN_MOT_TURN,
	TEN_MOT_RUN,
	TEN_MOT_WALK,
	TEN_MOT_MAX
};

s16 MotionIDTableTEN[] = {
	20,	
	20,	
	20,
	20,
	-1
};



#else


#endif




#endif	//__ENMTEN_H__

