////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Objec
//
// EnmTIM.cpp			J ^C}[X}C
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMTIM_CPP__

#include "EnmTIM.h"

#define MDLCODE_ID				(20)			// dmHQwww ́H̔ԍifj
#define MOTCODE_ID				(20)			// dmHQwww ́H̔ԍi[Vj
#include "..\Stage\05\00\K7Stage520M00.h"
#include "..\Kaw\KK7Effect.h"
#include "..\Yam\YK7EffectBlood.h"
#include "..\Yam\YK7EffectBloodPack.h"
#include "..\Sato\SK7SpOption.h"
#include "..\Yam\YK7EffectHSDead.h"
#include "..\Wat\WK7Skill.h"
#include "..\Wat\EnmList.h"

s16 npcTypeTIMMotionIdTable[] = {
	20,							// R
	50,							// 
	60,							// 
	0,							// ^[E
	0,							// ^[
	140,						// ^[
	0,							// 
	0,							// 85cmɍU
	0,							// 150cmɍU
	0,							// _[WO
	0,							// _[W
	900,						// _[WO
	0,						// _[W
	0,						// _[WEO
	0,						// _[WE
	0,						// _[WO
	0,						// _[W
	0,						// _[WEgO
	0,						// _[WEg
	0,						// _[WgO
	0,						// _[Wg
	0,						// _[WӂƂу_EOiSj
	0,						// _[Wу_EiSj
	0,						// _[WE _E
	0,						// _[W _E
	0,						// _ER
	0,						// _E_[W
	0,						// _EȂ
	0,						// _EȂ瑖
	0,						// _E玀S
	0,						// _E85cmɍU
	0,						// _E150cmɍU
	0,							// [U[ōU
	0,							// [U[gro
	0,							// [U[grB
	0,						// ꎩR̂̂QiXs[hpj
	0,						// Xs[hX}CsJn
	0,						// Xs[hX}C
	0,						// ݍUij
	-1
};

#define TIM_RUN_SPEED_MOT (23.152f)

K7EnmTIM::K7EnmTIM(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor,int prio) : WK7Enemy(enemyid,pAnchor,prio)
{
	int i;

	// fǂݍ
	CreateModel (K7CHRID(K7ENMID(MDLCODE_ID),  suffix));
	
	// [Vǂݍ
	CreatePackMotion(npcTypeTIMMotionIdTable, MOTCODE_ID);
	
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go(Ƀf[^̕ŏ)
	mData.mWeakID		= -1;								// _
	mData.mVLossID		= -1;								// ʌ
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP03;
	mData.mScale		= 1.f;
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= mData.mWeakID;
	mData.mVLossIDBk	= mData.mVLossID;
	
	mData.mAtkPower1	= 1000;
	mData.mAtkPower2	= 1000;
	
	mData.mAtkDist		= 10.f;
	mData.mAtkDistBk	= mData.mAtkDist;
	mData.mCounterKurai	= 0;								// s
	
	for(i=0; i<TIM_WEAK_MAX; i++){
		weakDead[i] = 0;
	}
	mFirstRunVoice = false;
	deadWeakNum = 0;
}

/*
	
	
	^C}[X}CXe[W̌Ăяo悤
	
	
*/
void K7EnmTIM::StageProc(WK7Stage *pCurrentStage)
{
	static WK7JObj *pJObj;
	static int exitMode;
	K7Stage520M00 *pStage = (K7Stage520M00 *)pCurrentStage;
}


/*
	
	
	^C}[X}CXe[W̌Ăяo悤
	
	
*/
void K7EnmTIM::HitObjMake(WK7Stage *pCurrentStage)
{
	WK7Model *pModel;
	WK7JObj  *pJObj;
	int i;

	for (i=0; i<TIM_WEAK_MAX; i++){
		if ( (pModel = pCurrentChara()->GetModel()) != NULL ){
			pJObj = pModel->GetObj(pNameTIMWeakObj[i]);
			if ( pJObj != NULL ) {
				pCurrentStage->SetHitObj(pJObj, (u32 )i);
			}
		}
	}
}

/*
	
	
	^C}[X}Cpꐧ䃋[`
	
	
*/
bool K7EnmTIM::MotSet_Dmg(void)
{
	s16	frontFlag, bloodefc, vLossDown;
	u32	setMotID;
	s16 setFireFrame = -1;
//	Vec	myPos;
	bool noMotion = false;
	bool headDead = false;

	bloodefc = 1;
	vLossDown	 = 0;
	
	// ݒn̎擾
//	pCurrentChara()->GetPosition(myPos);
	
	// O
	frontFlag = 1;
	// [V
	noMotion = true;
	
	if ( DAMTYPE_TIMERHSONLY != mDamage.mDamType ){			// _[WĂ܂GtFNgo
		// RR
		if ( true == DamageGrenadeTest() ){					// }XNAOl[hɂij
		
		}else{
			
		}
		
//		BloodEfcCall(&mDamage, myPos, 0);
		
		return true;
	}
	
	// _[W̃Xs[hύX
	DmgSpeedSet(1.f);
	
	//
	// @PKI_łijSj
	// ꌂ
	// NeBJ
	//
	if ( true == TimeDieTest() ){
		
		// 1ŎEꍇ̐
		WK7PLAYERCONTROL->SEPlayCritical(mDamage.mDamType);
		
		mData.mWeakID = -1;									// Q񐁂΂Ȃ悤ɏ
		SetVisible(false);
		
		{
			EFFECT *pBlood = NULL;
			bool incMode = false;
			int getBlood = CalcBloodVal(BLOOD_D_WEAK_RATE);
			
#if 0
			GXColor color;
			
			color.r = (u8)0;
			color.g = (u8)51;
			color.b = (u8)200;
			color.a = (u8)250;
			SetHSDeadEffectColor( color );			// ɍ쐬wuX}CSGtFNg̐Fݒ肷
#endif

			TpInc((s16 )getBlood, 2);
			// ob̗̌ʂ̑
			if ( (pBlood = WK7PLAYERCONTROL->GetBloodPackEffectPtr()) != NULL ){
				// pbN[^[ǉ([^[ɎkĂ̂̊֐)
				AddBloodMeter( pBlood, (s16 )getBlood ) ;
			}
			
			mpNpcRevivalEfc = KK7BattleEffectDead(	GetYukaY(),
													mDamage.mDamDir,
													mWeakObj[NPCWEAKOBJID_WAIST].mpBone,
													0,
													mEfcBoodMode,
													mEfcBoodPoint,
													BLOODTEX_BLOOD,
													20
			);
			
			incMode = true;
			
			// ̃j[邩ǂH
			if ( incMode == true ){
				SK7SpOption		*pSpOption = GameInfo.GetSpOption();
				
				WK7PLAYERCONTROL->LastBloodEffectPtrSet(mpNpcRevivalEfc);
				pSpOption->SetState(SPOPTION_BALLET_MOVE, false);								// IvV̕\o
			}
			
			if ( pBlood != NULL ) CloseBloodMeter();
		}
		
		{
																								// Ƃ̂rd
			Vec enePos;
			pCurrentChara()->GetPosition(enePos);
			gpSound->mPlaySE3D( SFX_BT_HS_DEATH00, enePos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );
		}
		
		MotSet_Loss();
		SetEnemyDieInfo(NPC_DIE_INSTANT);
		NpcRePopTest();
		
		bloodefc = 0;
		return true;
	}
	
	// ʏ_[W
	
	switch (rand()%6){
	case 0:
		if ( false == pWK7Skill->UseAbilityTest(WK7PLAYERCONTROL->GetMainID(), SKILLABILITY_ENEMYSLOW) ){
			DmgSpeedSet(6.f);
		}else{
			pWK7Skill->UseAbilityEffectPlay(SKILLABILITY_ENEMYSLOW);
			DmgSpeedSet(0.5f);
		}
		break;
	case 1:
		DmgSpeedSet(4.f);
		break;
	case 2:
		if ( false == pWK7Skill->UseAbilityTest(WK7PLAYERCONTROL->GetMainID(), SKILLABILITY_ENEMYSLOW) ){
			DmgSpeedSet(3.f);
		}else{
			pWK7Skill->UseAbilityEffectPlay(SKILLABILITY_ENEMYSLOW);
			DmgSpeedSet(0.15f);
		}
		break;
	case 3:
		DmgSpeedSet(8.f);
		break;
	case 4:
		DmgSpeedSet(1.f);
		break;
	default:
		DmgSpeedSet(2.f);
	}
	
	//
	// @ꃂ[VS
	//
	setMotID = WK7MOTION_NPCCMN_DMG_BODY_F;
	
	// LNN^
	
	// _[Wp̃[VĐĂH
	// _ȃc̓GtFNĝ݂̕\ɂȂ
	MotPlayInit(NPC_POSMODE_PROG);
	if ( false == PlayCommonMotion(setMotID, false, true, 0.f, 1.f) ){
		return false;
	}
	mState = NPC_STATE_DMG;
	
	if ( bloodefc ){
		Vec myPos;
	
		GetPosition(myPos);
		BloodEfcCall(mDamage.mDamPos, mDamage.mDamDir, myPos, 1, mDamage.mpObjSkin, 1);
	}
	
	return true;
}

/*
	
	
	^C}[X}Cpʌ
	
	
*/
bool K7EnmTIM::TimVLoss(int id, WK7HitObjInfoType hitType, Vec hitPos)
{
	WK7Model *pModel;
	WK7JObj  *pJObj;
	Vec myPos, pcRot;
	f32 pcRotY;
	int seNo;

	// qbgȂU
	if ((hitType == WK7HITOBJINFO_TYPE_GRENADE_FIRE)
	||	(hitType == WK7HITOBJINFO_TYPE_GRENADE_THUND)
	||	(hitType == WK7HITOBJINFO_TYPE_GRENADE_GRAVI)
	){
		// Ol[hn͓Ȃ
		return false;
	}
	
	pCurrentChara()->GetPosition(myPos);
	if ( (pModel = pCurrentChara()->GetModel()) != NULL ){
		pJObj = pModel->GetObj(pNameTIMWeakObj[id]);
		if ( pJObj != NULL ) {
			
			// _[Wo
			WK7PLAYERCONTROL->GetRotY(&pcRotY);
			pcRot.x = 0.f;
			pcRot.y = pcRotY;
			pcRot.z = 0.f;
			
			// ʌ̃GtFNgo
//			KK7BattleEffectVLoss(	myPos,
//									pcRot,
//									pJObj
//			);
			
			weakDead[id] = 1;
			
			// qbgnjI i[Voj
			SetNpcDamage(	WK7PLAYERCONTROL->GetCharaPtr(),
							pcRot,									// őp
							hitPos,
							1,										// _[WlP
							DAMTYPE_TIMERHSONLY
			);
			
#if 0
			{
				GXColor color, color2;
				
				color.r   = (u8)0xff;
				color.g   = (u8)0x99;
				color.b   = (u8)0x33;
				color.a   = (u8)250;
				color2.r  = (u8)0xcc;
				color2.g  = (u8)0x33;
				color2.b  = (u8)0x00;
				color2.a  = (u8)250;
				SetHSDeadEffectColor( color, color2 );		// ɍ쐬wuX}CSGtFNg̐Fݒ肷
				
				KK7BattleEffectDead(	GetYukaY(),						// RAgU
										pcRot,
										pJObj,
										0,
										mEfcBoodMode,
										mEfcBoodPoint,
										BLOODTEX_BLOOD,
										20
				);
			}
#endif
			
			// ʏ
			pJObj->Hide(false, false);
			
			// ꐺ炷
			seNo = gpSound->mPlaySE( SFX_BT_HS_VKESSON, SOUND_SYSTEM_SE_VOLUME, SOUND_PAN_CENTER, eSETrackBattleOverlap, eSEGroupBattle00Env );			// rdĐ
			gpSound->mSetPitchSENo( seNo, (s16 )(deadWeakNum * -100) );
			
			deadWeakNum++;
			
			return true;
		}
	}
	return false;
}


/*
	
	
	^C}[X}CʂǂH
	
	
	
*/
bool K7EnmTIM::TimeDieTest(void)
{
	int i, cnt;
				
	for(i=0, cnt=0; i<TIM_WEAK_MAX; i++){
		if ( weakDead[i] ){
			cnt++;
		}
	}
	
	if ( cnt == TIM_WEAK_MAX ){
		return true;
	}
	return false;
}

/*
	
	
	^C}[X}CoǂH
	
	
	
*/
bool K7EnmTIM::TimeRunTest(void)
{
	int i, cnt;
				
	for(i=0, cnt=0; i<TIM_WEAK_MAX; i++){
		if ( weakDead[i] ){
			cnt++;
		}
	}
	
	if ( cnt >= (TIM_WEAK_MAX-1) ){
		return true;
	}
	return false;
}

/*
	
	
	\
	
	
*/
void K7EnmTIM::VisibleTestDisp(void)
{
	WK7Model *pModel;
	WK7JObj  *pJObj;
	s16 i;
	
	if( (pModel = pCurrentChara()->GetModel())!=NULL ){
		pModel->Disp();
		// ł镔ʂ͂܂
		for(i=0; i<TIM_WEAK_MAX; i++){
			if ( weakDead[i] ){
				pJObj = pModel->GetObj(pNameTIMWeakObj[i]);
				if ( pJObj != NULL ) {
					pJObj->Hide(false, false);
				}
			}
		}
	}
}

f32 K7EnmTIM::GetRunSpeed(void)
{
	// [VړʂZo
	f32 Speed = TIM_RUN_SPEED_MOT / (GetFTotalMotionFrame() / WK7_FRAME_COUNT);
	return Speed;
}


bool K7EnmTIM::Ai_Follow(f32 targetDirSabun)
{
#pragma unused(targetDirSabun)
	NPCAI	*pAi = &mAi;

		
		// oJnI
		if ( true == TimeRunTest() ){
			if ( false == mFirstRunVoice ){
				mFirstRunVoice = true;
				gpSound->mPlaySE( SFX_BT_THS_DUSH, SOUND_SYSTEM_SE_VOLUME, SOUND_PAN_CENTER, eSETrackBattleOverlap, eSEGroupBattle00Env );
			}
			mState = NPC_STATE_RUN;
			
		}else{
			mState = NPC_STATE_WALK;
		}
		
//		if ( mData.mAtkDist > mOperationDist  ){
//			if ( true == MotSet_Atk() ) return true;
//		}
		
	
	return false;
}

void K7EnmTIM::FootSeRun(Vec myPos)
{
	// [vrd{[`FW
	if(	(pCurrentChara()!=NULL)
	&&	(mData.mFootSe != 0)
	){
		WK7Model *pModel = pCurrentChara()->GetModel();
		if ((2  == GetCurrentMotionFrame())
		||	(22 == GetCurrentMotionFrame())
		){
			gpSound->mPlaySE3D( mData.mFootSe, myPos, 0 );		// rdĐ
			if( 2  == GetCurrentMotionFrame() ){
				FootPaintTestSet(NPCWEAKOBJID_RFOOT);
			}else{
				FootPaintTestSet(NPCWEAKOBJID_LFOOT);
			}
		}
	}
}


