////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmY.cpp u[N
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMY_CPP__

#include "EnmY.h"

#define MDLCODE_ID				(21)			// dmHQwww ́H̔ԍifj
#define MOTCODE_ID				(2)				// dmHQwww ́H̔ԍi[Vj

s16 npcTypeYMotionIdTable[] = {
	800,					// R
	820,					// 
	820,					// 
	0,						// ^[E
	0,						// ^[
	0,						// ^[
	0,						// UĂѓiNu쓮j
	0,						// 85cmɍU
	0,						// 150cmɍU
	0,						// _[WO
	0,						// _[W
	0,						// _[WO
	0,						// _[W
	0,						// _[WEO
	0,						// _[WE
	0,						// _[WO
	0,						// _[W
	0,						// _[WEgO
	0,						// _[WEg
	0,						// _[WgO
	0,						// _[Wg
	260,					// _[WӂƂу_EOiSj
	250,					// _[Wу_EiSj
	0,						// _[WE _E
	0,						// _[W _E
	0,						// _ER
	0,						// _E_[W
	0,						// _EȂ
	0,						// _EȂ瑖
	825,					// _E玀S
	0,						// _E85cmɍU
	0,						// _E150cmɍU
	0,						// [U[ōU
	810,					// gro
	0,						// [U[grB
	0,						// ꎩR̂̂QiXs[hpj
	0,						// Xs[hX}CsJn
	0,						// Xs[hX}C
	0,						// ݍUi_j
	0,						// ݍUiRj
	0,						// ݍUiJGfj
	0,						// ݍUiR[ej
	0,						// ݍUi}XNj
	0,						// ݍUiPrj
	0,						// iAiU[X}CpjV䒣tҋ@
	0,						// iAiU[X}CpjVA
	0,						// iAiU[X}CpjVA
	0,						// iAiU[X}CpjVA
	0,						// iAiU[X}CpjVA󒆗R
	0,						// iAiU[X}CpjVA󒆗`nA͂
	0,						// _[WE]
	0,						// _[W]
	0,						// p[cAj[Vp
	0,						// f
	0,						// f
	-1
};

#define WALK_SPEED			(0.1f)
#define RUN_SPEED			(0.1f)

#define EXTRA_PARTS_NAME	"Weak"

K7EnmY::K7EnmY(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) : WK7Enemy(enemyid,pAnchor,prio)
{
	// fǂݍ
	CreateModel (K7CHRID(K7ENMID(MDLCODE_ID),  suffix));
	
	// [Vǂݍ
	CreatePackMotion(npcTypeYMotionIdTable, MOTCODE_ID);
	
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go
	mData.mWeakID		= -1;								// ꌂ
	mData.mVLossID		= -1;								// ʐѕ
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
	mData.mScale		= 1.2f;								// 
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= -1;
	mData.mVLossIDBk	= mData.mVLossID;
	mData.mCounterKurai	= 0;								// JE^[֎~
	mData.mAtkDist		= 0.f;								// U
	mData.mAtkDistBk	= mData.mAtkDist;
	mData.mNoWaitMot	= 1;
}



/*
	
	
	p_[hc̊蓖
	
	
*/
void K7EnmY::PartsRenderIDSet(void)
{
	u32 renderidex;
	WK7Model *pModel = pCurrentChara()->GetModel();
	
	renderidex = WK7RenderObj::GetUniqueRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
	pCurrentChara()->SetRenderIDEx(renderidex);
	
	// ʂJOBJƂĂ
	if ( pModel != NULL ){
		WK7JObj *pJOBJ;
		pJOBJ   = pModel->GetObj(EXTRA_PARTS_NAME);					// IuWF񂷂̂ǂ
		if ( pJOBJ != NULL ){
			pCurrentChara()->SetRenderIDEx(pJOBJ,false,false);		// ݂ɂȂł̂OKȏꍇ
//			pCurrentChara()->SetRenderIDEx(pJOBJ,false,false);		// ݂ɂȂł̂ȏꍇ
		}
	}
}

bool K7EnmY::MotStatus_ExtPop(void)
{
	if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
		// I
		if( false == MotSet_Jet(false) ) return true;
		mState = NPC_STATE_JET;
		return false;
	}
	return false;
}


