/*

 	KK7BattleCamera.h

 Creator       : Kawakami Satoshi (GHM)
 Creation Date : 02/16/2003

*/

#ifndef	__KK7BATTLECAMERA_H__
#define	__KK7BATTLECAMERA_H__


#include "..\Lib\ghmGcAppTask.h"
#include "..\Lib\ghmGcMem.h"
#include "..\Lib\ghmGcFile.h"
#include "..\Lib\ghmGcTask.h"
#include "..\Lib\ghmGcTex.h"
#include "..\wat\K7ID.h"



class KK7BattleCamera{
protected:
public:
	KK7BattleCamera();
	~KK7BattleCamera();
	Vec					rot[2];									// ogJ
	Vec					pos[2];									// ogJ_
	Vec					tmpTarget;								// vZpAQƓ_
	
	s16					shakeCount;								// JVFCNJEg
	s16					shakeCountMax;							// JVFCNJEg}bNX
	
	f32					cFovSave;								// J̎pۑ
	f32					cFov;									// J̎pۑ
	
	void				CameraDelayCalc(f32 delay);
	void				LookSetRotCalc(f32 ArmSide, f32 ArmFront, f32 ArmHigh, Vec NowPos, Vec NowRot, Vec *pGetPos, Vec *pGetRot, bool mode = false);
	void				CameraShakeCountSet(s16 count);
	bool				ShakeParamGet(f32 *pGetRotX, f32 *pGetPosY, f32 shakeRate=1.f);
	
	void				Init(void);
};

#ifdef __KK7BATTLECAMERA_CPP__

#define SHAKE_COUNTMAX	(10)


typedef struct {
	f32		sideDist;
	f32		frontDist;
	f32		heightDist;
}CAMARM;


#else


#endif


#endif



