/*

 	KK7BattleMainTask.cpp

 	Creator       : Kawakami Satoshi (GHM)
 	Creation Date : 02/10/2003

*/

/*
	
	
	
	ogʁAQł̎
	
	ʉ 0.00
	ʉE 1.57
	ʏオ 3.14
	ʍ -1.57
	
*/
#define	__KK7BATTLEMAINTASK_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>
#include "KK7BattleMainTask.h"
#include "KK7DebugMenuTask.h"
#include "..\Wat\WK7Player.h"
#include "..\lib\ghmGcDefine.h"
#include "..\Fujita\C_Font.h"
#include "..\Kaw\KK7Prim.h"
#include "..\Kaw\KK7Effect.h"
#include "..\Wat\WK7Sight.h"
#include "..\Wat\WK7GameInfo.h"
#include "..\Wat\WK7Npc.h"
#include "..\Wat\WK7Skill.h"
#include "..\Wat\WK7SelectIF.h"
#include "..\Sato\SK7SpOption.h"
#include "..\Yam\YK7EffectSight.h"
#include "..\Yam\YK7EffectSight2.h"
#include "..\Yam\YK7EffectShutter.h"
#include "..\Wat\K7GlobalFlag.h"

//#include "..\Wat\WK7MainTask.h"
#include "..\Matsu\mK7Proc.h"
#include "..\Matsu\se\seBattle.h"
#include "..\Yam\YK7EffectHeader.h"
#include "WK7MainMenu.h"
#include "..\Wat\EnmList.h"

// RcTCgGtFNg
#define YAMADA_SIGHT

// Jwɉ]H
#define CAM_X_ROT

#if FUJITA
#include "c_impulse.h"
#include "EnmKUN.h"
#include "EnmKRR.h"
#include "EnmKIB.h"
#include "EnmUR2.h"
#include "EnmCUR.h"
extern f32 gParticleW;
extern f32 gParticleH;
extern f32 gParticleX;
extern f32 gParticleY;
#endif
extern bool PlayMotion(u32 chrid,u32 id);










// ^XNtO
static u32 BattleFrameProcessState = BATTLEFRAMEPROCESSSTATE_INIT;
u32 BattleCameraMtxChange = 0;												// ogIɃJ̃}gbNXύXĂtOi댯j
static s32 TaskIDSetUp = -1;												// I[vjO^XNID



// eft@C
#define	BATTLE_PAD_ZOOM						(HSD_PAD_Y)
#define B_LOCKON							(HSD_PAD_B)
// \AiO
#define PADANALOG_OK_RATE					(0.3f)
static bool sight_zoom_ok = true;

// TCgpẍړxiXLɂȂj
//#define	SIGHT_ROT_SPD_DEFAULT	(0.04f)					// ftHgړxipxj
//#define	SIGHT_ROT_SPD_DEFAULT	(0.045f)				// ftHgړxipxj

// TCg̃Y[̃Xs[h
#define SIGHT_ZOOM_SPEED					(10.f)
static f32 SIGHT_ZOOM_SPEED_FRAME = 10.f;

// TCgpx̃~bg
//#define	SIGHT_ROT_LIMIT			(PI/8.f)
//static f32 sight_rot_limit_X = 0.092f;
//static f32 sight_rot_limit_Y = 0.088f;
static f32 sight_rot_limit_X = 0.f;
static f32 sight_rot_limit_Y = 0.f;

#define	CAM_ROTX_LIMIT			(PI/5.0f)

#define SCR_X_CENTER	(K7APP_SCREEN_WIDTH/2)
#define SCR_Y_CENTER	(K7APP_SCREEN_HEIGHT/2)
#define WALL_X			(K7APP_SCREEN_WIDTH/4)
//#define WALL_X			(K7APP_SCREEN_WIDTH/6)
#define WALL_Y			(K7APP_SCREEN_HEIGHT/4)
//#define WALL_Y			(K7APP_SCREEN_HEIGHT/6)

//#define LOCKON_EFFECT

#ifdef LOCKON_EFFECT
typedef struct{
	WK7Npc	*mpNpc;
	EFFECT  *mpEffect;
	Vec		pos;
}LOCKON;
static  LOCKON lockOn[2];
#endif

KK7BattleMainTask battleMain;
KK7BattleMainTask *pBattleMain = &battleMain;

// #define ARM_DIST		(2.f)
//#define ARMBACK_DIST	(-1.f)

// JA[fobOp
//#define CAMARMDEBUG

// JA[fobO\
//#define CAMARMINFODEBUG

// JufobOp
//#define BURETEST
#ifdef BURETEST
	static f32 bureTestY = 0.1f;
	static f32 bureTestX = 0.1f;
#endif

#ifdef CAMARMDEBUG
static char camArmDebug = 0;
static f32 camArmSideBack[2] = {0.f, 0.f};
static f32 camArmFrontBack[2] = {0.f, 0.f};
static f32 camArmHigh = 0.f;
#endif

typedef struct {
	f32		leftLimit;
	f32		rightLimit;
}CHARARMLIMIT;


typedef struct {
	f32		Front;
	f32		Side;
	f32		High;
}SIGHTCHARAPOS;

// LN^̈ʒuW
#if BATTLE_CAM_ATTACH == 1
// gpĂ
static SIGHTCHARAPOS CharaPosArm[K7PCMAX] = {
//	O	E	
	{-2.6f,	 0.7f,	14.0f},					// DAN
	{-9.8f,	 -0.3f,	18.0f},					// GAL
	{0.5f,	 2.0f,	8.4f},					// CAT
	{0.0f,	 0.0f,	8.3f},					// HAC
	{0.f,	 0.0f,	10.f},					// HAS
	{-1.f,	 -3.f,	12.5f},					// HAY
	{-3.2f,	 2.6f,	11.4f},					// CYO
	{-3.0f,	 0.5f,	12.6f},					// KED
	{-4.3f,	-0.4f,	10.5f},					// KVN
	{-1.8f,	-0.1f,	12.9f}					// MSK
};
static SIGHTCHARAPOS CharaPosArmMSK = {
//	O	E	
	-2.9f,	0.f,	12.2f					// MSK
};
#else
static SIGHTCHARAPOS CharaPosArm[K7PCMAX] = {
//	O	E	
	{4.4f,	-0.8f,	14.f},					// DAN
	{8.3f,	-1.2f,	17.3f},					// GAL
	{0.0f,	-1.7f,	8.2f},					// CAT
	{2.0f,	-2.5f,	15.f},					// HAC
	{0.f,	-2.5f,	15.f},					// HAS
	{0.f,	-2.5f,	15.f},					// HAY
	{5.3f,	-2.7f,	10.9f},					// CYO
	{4.3f,	0.5f,	12.2f},					// KED
	{4.8f,	-0.5f,	9.8f},					// KVN
	{3.0f,	 0.0f,	13.7f}					// MSK
};
#endif

static SIGHTCHARAPOS StartCameraPos[K7PCMAX] = {
//	O	E	
	{0.f,	 0.0f,	0.0f},	// DAN
	{0.f,	 0.0f,	0.0f},	// GAL
	{0.f,	 0.0f,	0.0f},	// CAT
	{8.f,	 -0.9f,	11.f},	// HAC
	{0.f,	 0.0f,	0.0f},	// HAS
	{0.f,	 0.0f,	0.0f},	// HAY
	{0.f,	 0.0f,	0.0f},	// CYO
	{0.f,	 0.0f,	0.0f},	// KED
	{0.f,	 0.0f,	0.0f},	// KVN
	{0.f,	 0.0f,	0.0f},	// MSK
};

static SIGHTCHARAPOS StartEndCameraPos[K7PCMAX] = {
//	O	E	
	{0.f,	 0.0f,	0.0f},	// DAN
	{0.f,	 0.0f,	0.0f},	// GAL
	{0.f,	 0.0f,	0.0f},	// CAT
	{-3.f,	 -0.9f,	11.0f},	// HAC
	{-4.f,	 -0.3f,	12.0f},	// HAS
	{0.f,	 0.0f,	0.0f},	// HAY
	{0.f,	 0.0f,	0.0f},	// CYO
	{0.f,	 0.0f,	0.0f},	// KED
	{0.f,	 0.0f,	0.0f},	// KVN
	{0.f,	 0.0f,	0.0f},	// MSK
};

static SIGHTCHARAPOS ReloadCharaPosArm[K7PCMAX] = {
//	O	E	
//	{12.9f,	2.9f,	11.9f},					// DAN
	{9.7f,	4.1f,	13.1f},					// DAN
	{6.4f,	3.2f,	15.6f},					// GAL
	{12.7f,	2.9f,	5.6f},					// CAT
	{2.0f,	-2.5f,	15.f},					// HAC
	{0.f,	-2.5f,	15.f},					// HAS
	{5.f,	3.5f,	15.f},					// HAY
	{9.9f,	3.4f,	10.3f},					// CYO
	{10.6f,	4.2f,	10.6f},					// KED
	{4.8f,	-0.5f,	9.8f},					// KVN
	{15.7f,	 3.9f,	10.4f}					// MSK
};

static SIGHTCHARAPOS CounterCharaPosArm[K7PCMAX] = {
//	O	E	
//	{12.9f,	2.9f,	11.9f},					// DAN
	{9.7f,	4.1f,	13.1f},					// DAN
	{6.4f,	3.2f,	15.6f},					// GAL
	{12.7f,	2.9f,	5.6f},					// CAT
	{2.0f,	-2.5f,	15.f},					// HAC
	{0.f,	-2.5f,	15.f},					// HAS
	{0.f,	-2.5f,	15.f},					// HAY
	{9.9f,	3.4f,	10.3f},					// CYO
	{10.6f,	4.2f,	10.6f},					// KED
	{4.8f,	-0.5f,	9.8f},					// KVN
	{15.7f,	 3.9f,	10.4f}					// MSK
};


static f32 PcAimSide  = 0.f;
static f32 PcAimFront = 0.f;
static f32 PcAimHigh  = 8.3f;
static s16 CamChangeMode  = 1;

// Y[C̏
static s16 matsuZoom = 0;

// RcTCg̔ԍ
static u8	YamadaSightEnum[K7PCMAX] = {
	SIGHT_TYPE_DAN,		// DAN
	SIGHT_TYPE_GAL,		// GAL
	SIGHT_TYPE_CON,		// CAT
	SIGHT_TYPE_DAN,		// HAC
	0,					// HAS
	SIGHT_TYPE_HAY,		// HAY
	SIGHT_TYPE_CYO,		// CYO
	SIGHT_TYPE_KED,		// KED
	SIGHT_TYPE_KVN,		// KVN
	SIGHT_TYPE_MSK		// MSK
};

static s16 snapSePlay = 0;
static s16 snapTime = 0;
static s16 easySnapTime = 0;
static s16 autoSnapTime = 0;
static s16 snapTimeMAX = (s16 )WK7_SEC_TO_FRAME(1.f);						// t[I[gbNÂ邩H
static s16 easySnapTimeMAX = (s16 )WK7_SEC_TO_FRAME(2.f);					// t[I[gbNÂ邩H
static s16 autoSnapTimeMAX = (s16 )WK7_SEC_TO_FRAME(1.f);					// t[I[gbNÂ邩H

s16 KK7BattleMainTask::mBattleProcessExit = 0;

/*
	
	RXgN^
	
*/
KK7BattleMainTask::KK7BattleMainTask()
{
	// Init
	OSReport( "KK7BattleMainTask@called constractor\n" );
}

/*
	
	fXgN^
	
*/
KK7BattleMainTask::~KK7BattleMainTask()
{
	OSReport( "KK7BattleMainTask@called destractor\n" );
}


/*
	
	
	ogC^XÑZbgAbv
	
	
*/
bool KK7BattleMainTask::BattleMainTaskSetUp(ghmGcTaskController *pTaskFrameCtrl)
{
	if ( TaskIDSetUp == -1 ){
		BattleFrameProcessState = BATTLEFRAMEPROCESSSTATE_INIT;
		TaskIDSetUp = pTaskFrameCtrl->Start(KK7BattleFrameProcess, KK7BattleFrameProcessTerm, (u32)pBattleMain, 0, NULL, -1, 100);
		if ( -1 != TaskIDSetUp ){
			return true;
		}
	}
	return false;
}
/*
	
	
	ogC^XÑVbg_E
	
	
*/
bool KK7BattleMainTask::BattleMainTaskShutDown(void)
{
	BattleFrameProcessState = BATTLEFRAMEPROCESSSTATE_EXIT;
	return true;
}


/*	
	
	
	
*/

static f32 inFovSave;

bool KK7BattleMainTask::Initialize(WK7Cam *pCamera)
{
	Vec pos;

	// ogJ̏
	BattleCamera.Init();

	// ȍ
	mBattlePad	= 0;
	mBattleTrg	= 0;
	mBattlePadAnalogR 	= 0.f;
	mBattlePadAnalogL	= 0.f;
	mLpadXF32	= 0.f;
	mLpadYF32	= 0.f;
	mLpadX		= 0;
	mLpadY		= 0;
	mRpadX		= 0;
	mRpadY		= 0;
	mTargetNum	= 0;
//	mSightHandChangeCounter = 0;
	mProcess	= 0;
	mSightHand	= 0;
	mZoom		= 0;
	mZoomProcess = 0;
	mZoomNow = 0;
	mSightEnable = false;
	matsuZoom   = 0;
	mpSightRenderEfc = NULL;
	mpShutterRenderEfc = NULL;
	mpShutter2RenderEfc = NULL;
	mSightBureFlag = 0;
	mActiveCamProcess = -1;
	
	//// JNX̎擾
	mpCamera	= pCamera;
	mCamLimitFlag   = 0;
	mSightLimitFlag = 0;
	mSightHitReqest = false;
	mCamChangeMode  = BATTLECAMMODE_KAMAE;
	
	// TCg֘Ão
	//
	
	// ŏogɓĂƂ̃LW̕ۑ
	WK7PLAYERCONTROL->GetPosition(&pos);
	mSight.saveMyPos.		x		= pos.x;
	mSight.saveMyPos.		y		= pos.y;
	mSight.saveMyPos.		z		= pos.z;
	SetPosition(&pos, true);
	
//	mSight.camRot.			x		= 0.f;
//	mSight.camRot.			y		= 0.f;
//	mSight.camRot.			z		= 0.f;
//	WK7PLAYERCONTROL->GetRotY(&rot);
//	SetRotCamY(rot);
//	WK7PLAYERCONTROL->GetRotX(&rot);
//	SetRotCamX(rot);
	
	mSight.scrPos.			x		= (s16 )(K7APP_SCREEN_WIDTH/2);
	mSight.scrPos.			y		= (s16 )(K7APP_SCREEN_HEIGHT/2);
	
	
//	mSight.worldRot.		x		= 0.f;
//	WK7PLAYERCONTROL->GetRotY(&(mSight.worldRot.y));
//	mSight.worldRot.		z		= 0.f;
	
	mSight.sightRot.		x		= 0.f;
	mSight.sightRot.		y		= 0.f;
	mSight.sightRot.		z		= 0.f;
	
	mSight.sightRotBureReq.	x		= 0.f;
	mSight.sightRotBureReq.	y		= 0.f;
	mSight.sightRotBureReq.	z		= 0.f;
	
	mSight.zoomRot.	x				= 0.f;
	mSight.zoomRot.	y				= 0.f;
	mSight.zoomRot.	z				= 0.f;
	
	mSight.frameMov.		x		= 0.f;
	mSight.frameMov.		y		= 0.f;
	mSight.frameMov.		z		= 0.f;

	mSight.padMov.			x		= 0.f;
	mSight.padMov.			y		= 0.f;
	mSight.padMov.			z		= 0.f;

	snapTime = 0;
	autoSnapTime = 0;
	easySnapTime = 0;

	// p̎擾
	inFovSave = WK7CAM->GetFov();
	BattleCamera.cFovSave = inFovSave;
	BattleCamera.cFov     = BattleCamera.cFovSave;
	
	// RcTCg̃NGCg
#ifdef YAMADA_SIGHT
	
	// obpTCg
	Vec Point;
	Point.x = 320;
	Point.y = 240;
	
	{
		WK7Chara *pChara = WK7PLAYERCONTROL->GetCharaPtr();
		
		if ( NULL != pChara ){
			EFFECT *pYamEfc  = CreateSightEffect(	Point,
													(u8 )WK7PLAYERCONTROL->GetMaxBullet(),
													(u8 )WK7PLAYERCONTROL->GetBullet(),
													(u8 )YamadaSightEnum[K7CHR_MAINID(mID)]
			);
			if ( pYamEfc != NULL ){
				WK7RenderObjEffectInfo	info;
				info.Create();
				if( (mpSightRenderEfc=pChara->CreateEffect(pYamEfc,&info))!=NULL ){
					mpSightRenderEfc->SetForcedDrawFlag(1);
				}
			}else{
				mpSightRenderEfc = NULL;
			}
		}
	}
	
	SightShotModeSet(false);
#endif
	
	mStartDemo = 0;
	
	// nCf{[\
#if 0
	if ( K7GAL == WK7PLAYERCONTROL->GetMainID() ){
		if ( NULL != WK7PLAYERCONTROL->GetHandBone() ){
			WK7PLAYERCONTROL->GetHandBone()->Disp(false);
		}
		
		// Ef{[
		if ( NULL != WK7PLAYERCONTROL->GetHandRSkin() ){
			WK7PLAYERCONTROL->GetHandRSkin()->Hide(false);
		}
	}
#endif
	
	// }YQc\ɂ
//	SetMuzzle2DFlag( 1 );
	
#ifdef LOCKON_EFFECT
	lockOn[0].mpNpc		= NULL;
	lockOn[1].mpNpc		= NULL;
	lockOn[0].mpEffect	= NULL;
	lockOn[1].mpEffect	= NULL;
#endif
	
	// ̃j[ɏ
	GameInfo.GetSpOption()->SetState(SPOPTION_BALLET_CLOSE);
	GameInfo.GetSpOption()->SetChargeTube();
	
	mEasyLockOnNum = 0;
	mSightRenderFlag = false;
	
	// RpX[hς
	if ( GameInfo.GetSpOption() != NULL ) {
		GameInfo.GetSpOption()->SetReverseMode(true);
	}
	
	return TRUE;
}


/*
	
	
	\px̐ݒ
	og^XNɓuԂɈԍŏ̊px̌B
	
	<return>
	Zbg
	
	
*/
f32 KK7BattleMainTask::InitialKamaeDirSet(f32 PlRotY)
{
	WK7Npc *pNpcTarget;
	Vec *pMyPos, tPos, rot;
	f32	myRotY, enemyRotY;
	f32 SearchOkDist;

	// \pxݒ肳Ă
	if ( true == WK7PLAYERCONTROL->TestKamaeDir() ){
		return WK7PLAYERCONTROL->GetKamaeDir();
	}
	
	// ȉAAreBoĂȂ
//	if ( false == pWK7Skill->UseAbilityTest(WK7PLAYERCONTROL->GetMainID(), SKILLABILITY_FIRSTLOCKON) ){
//		return PlRotY;
//	}
	// iZjkPĂ
	if ( HSD_PadGetNormalAnalogL(0)  > PADANALOG_OK_RATE ){
		return PlRotY;
	}
	
	// ΏۂȂ
	pNpcTarget = mSortNpc[0].mpSortNpc;
	if ( NULL == pNpcTarget ){
		return PlRotY;
	}
	
	// ͈͊OiJGf͂R{j
	if ((K7KED == WK7PLAYERCONTROL->GetMainID())
	||	(K7HAC == WK7PLAYERCONTROL->GetMainID())
	) {
		SearchOkDist = INITSEARCH_OKDIST_KED;
	}else{
		SearchOkDist = INITSEARCH_OKDIST;
	}
	
	if ( mSortNpc[0].dist > SearchOkDist ){
		return PlRotY;
	}
	
	// Go
	pMyPos = GetPosition();
	pNpcTarget->GetPosition(tPos);
	{
		Vec tgt = tPos;
		rot.y = atan2f(tgt.x - pMyPos->x, tgt.z - pMyPos->z);
		rot.x = atan2f(	tgt.y - pMyPos->y,
									sqrtf((tgt.x-pMyPos->x)*(tgt.x-pMyPos->x)+(tgt.z-pMyPos->z)*(tgt.z-pMyPos->z))
									);
		rot.z = 0.f;
	}
	enemyRotY = rot.y;
	myRotY    = PlRotY;
	
	// Ɋpxeꍇixj
	rot.y -= myRotY;
	GHM_LIMIT_RANGE(rot.y, PI,-PI);
	if ( fabsf(rot.y) >  INITSEARCH_OKDIREC ){
		return PlRotY;
	}
	
	// ݒNAAɍ\܂傤
	GHM_LIMIT_RANGE(enemyRotY, PI,-PI);
	
	SetCamRotY(enemyRotY);
//	WK7PLAYERCONTROL->SetRotY(mSight.standardRot.y); 
	
	// AreBgp̃GtFNgo
//	pWK7Skill->UseAbilityEffectPlay(SKILLABILITY_FIRSTLOCKON);
	
	return enemyRotY;
}


/*	
	
	I
	
	<in>
	exitMode		1	Jɖ߂
					2	JŒ̂܂
	
*/
bool KK7BattleMainTask::BattleExit(s16 exitMode)
{
	WK7Chara *pChara = WK7PLAYERCONTROL->GetCharaPtr();

	SightShotModeSet(false);
	
	// ANVJI
	WK7PLAYERCONTROL->ActionCameraExit();
	
	// _\EBhE
#if FUJITA
	gParticleW = 0;
	gParticleH = 0;
#endif
	
#ifdef LOCKON_EFFECT
	{
		int i;
		
		for (i=0; i<2; i++){
			if ( lockOn[i].mpEffect != NULL ){
				::DelReqEffect( lockOn[i].mpEffect );
			}
		}
	}
#endif
	
	WK7SIGHT->SetVisible(false);						// nӃTCg|C^I
	
	if( mBattleProcessExit==0 ){						// ogvZXĂяoꍇ
		GameInfo.SetMode(WK7GameInfo::MOVE);			// Q[CtH[h
	}
	
	WK7SELECTIF->ReleaseItemAll();
	
	// ɂĂ̓JŒ̂܂
	if ( 2 == exitMode ){
		mpCamera->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
		
		// \߂Ƃɂrd炳ȂNGXg
		WK7PLAYERCONTROL->SetNoShotWaitSeReq();
		
		// Vb^[̃GtFNg
		if ((NULL != pChara)
		&&	(true == pChara->IsValidEffect(mpShutterRenderEfc))
		){
			pChara->ReleaseEffect(mpShutterRenderEfc);		// RcTCgGtFNgINGXg
			mpShutterRenderEfc = NULL;
		}
	
	}else{
		// ogɓĂ[hƓɂ
		mpCamera->SetMode(mCamModeSave);
		switch( mCamModeSave ){
		case	WK7Cam::WK7CAM_FREE_TARGET:
			mpCamera->SetPosition(mCamSavePos);
			mpCamera->SetTargetPosition(mCamSaveTgt);
			break;
		case	WK7Cam::WK7CAM_PATH_FOLLOW:
			WK7CAMPATHFOLLOWINFO->SetPos(WK7CamPathFollowInfo::RENEW_IM);
//			WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
//			break;
		default:
			break;
		}
	}

	
	// JNX
	mpCamera = NULL;

	// ꉞVbgtONAĂ
	WK7PLAYERCONTROL->ClearShotFlag();
	
#if 1
	// KVA̎ Visibilty ς
	if ( K7GAL == WK7PLAYERCONTROL->GetMainID() ){
		if ( NULL != WK7PLAYERCONTROL->GetHandBone() ){
			WK7PLAYERCONTROL->GetHandBone()->Hide(false);
		}
		
		// Ef{[\
		if ( NULL != WK7PLAYERCONTROL->GetHandRSkin() ){
			WK7PLAYERCONTROL->GetHandRSkin()->Disp(false);
		}
//		if ( NULL != WK7PLAYERCONTROL->GetHandLSkin() ){
//			WK7PLAYERCONTROL->GetHandLSkin()->Disp(false);
//		}
	}
#endif
	
	// vC[Rg[̃ogIZbg
	WK7PLAYERCONTROL->BattleReset();
	
	// Y[̏I
	if ( matsuZoom ){
		mZoom	  = 0;
		matsuZoom = 0;
		gpNoise->mRelease();										// mCYGtFNgI
	}
	// [hȍI
	gpNoise->mUpDownStrRelease(1);
	
	// Q[W֌W\(XyVj
//	if ( WK7PLAYERCONTROL->GetmpSpAtGauge() != NULL ){
//		KK7EffectSpAtkGaugeVisible( WK7PLAYERCONTROL->GetmpSpAtGauge(), false );
//		KK7EffectSpAtkGaugeDelete( WK7PLAYERCONTROL->GetmpSpAtGauge() );
//		WK7PLAYERCONTROL->SetmpSpAtGauge(NULL);
//	}
	// Q[W֌W\(XLj
//	if ( WK7PLAYERCONTROL->GetmpScanGauge() != NULL ){
//		KK7EffectGaugeVisible( WK7PLAYERCONTROL->GetmpScanGauge(), false );
//		KK7EffectGaugeDelete( WK7PLAYERCONTROL->GetmpScanGauge() );
//		WK7PLAYERCONTROL->SetmpScanGauge(NULL);
//	}
	
	// }YRc\ɂ
//	SetMuzzle2DFlag( 0 );
	
	// RpX[h߂
	if ( GameInfo.GetSpOption() != NULL ) {
		GameInfo.GetSpOption()->SetReverseMode(false);
	}
	
	// Ԉ֎qn[}͕\߂
	if ( K7HAC == K7CHR_MAINID(mID) ){
		WK7PLAYERCONTROL->SetVisible(true);
	}
	
	
	// Y[ɂ̓L߂
	if ((K7MSK == K7CHR_MAINID(mID))
	||	(K7KED == K7CHR_MAINID(mID))
	){
		WK7PLAYERCONTROL->BattleAlphaCtrlSet(false);
		WK7PLAYERCONTROL->SetAlphaVal(1.0f);
	}
	
	// og|[Y
	WK7Npc::NpcResetBattlePauseAll();
	
	// Vbg{^֎~
	WK7PLAYERCONTROL->ClearNoShotButton();
	
	return true;
}

/*
	
	Cog ^XN
	
	<in>
	id												IuWFNghc K7CHR_MAINID(mID)  Lhc̎擾
	
	<return>
	true			N
	false			Ns
*/
bool KK7BattleMainTask::BattleMainTaskStart(u32 id, WK7Cam *pCamera)
{
	if ( BattleFrameProcessState != BATTLEFRAMEPROCESSSTATE_INIT ) return false;
	
	BattleFrameProcessState = BATTLEFRAMEPROCESSSTATE_READY;
	//BattleCameraMtxChange = 1;
	
	KK7BattleMainTask::InitBattleProcessExit();
	
	mID = id;
	
	// J[hۑ
	mCamModeSave = pCamera->GetMode();
	if ( mCamModeSave == WK7Cam::WK7CAM_FREE_TARGET ){
		pCamera->GetPosition(mCamSavePos);
		pCamera->GetTargetPosition(mCamSaveTgt);
	}
	
	// Q[̃[hogpɑւ
	GameInfo.SetMode(WK7GameInfo::BATTLE);
	
	// G̃\[g
	EnemySort();
	
	// og^XN̏
	Initialize(pCamera);
	
	// Vbg{^֎~ɂ
	WK7PLAYERCONTROL->SetNoShotButton();
	
	// X^[gf̋N
	if (K7HAC == WK7PLAYERCONTROL->GetMainID()){
		mStartDemoTask = -100;
	}else{
		mStartDemoTask = 0;
	}
	mStartDemoCnt      = 0;
	
	return true;
}


/*
	
	Cog ^XNIiOďoj
	
	<return>
	true			N
	false			Ns
*/
void KK7BattleMainTask::BattleMainTaskExit(int mode)
{
	mBattleProcessExit = (s16 )mode;
}
s16 KK7BattleMainTask::GetBattleProcessExit(void)
{
	return mBattleProcessExit;
}


/*
	
	Cog Ԃǂ擾
	
	<return>
	true			΂Ƃ钆
	false			łȂ
*/
bool KK7BattleMainTask::GetBattleTask(void)
{
	if ( BattleFrameProcessState == BATTLEFRAMEPROCESSSTATE_READY ) return true;
	if ( BattleFrameProcessState == BATTLEFRAMEPROCESSSTATE_GO ) return true;
	return false;
}



/*
	
	og̃JƂobĂ邩ǂH
	
	<return>
	true			Yes
	false			No
*/
bool KK7BattleMainTask::GetPcCamSetMode(void)
{
	if ( BATTLECAMMODE_KAMAE == mCamChangeMode ) return true;
	return false;
}


/*
	
	
	ogɓĂƂ̃J擾
	
	
*/
void KK7BattleMainTask::BattleCameraInitInfoSet(f32 PlRotY, Vec *pPos)
{
	Vec *pOperationPos = pPos;
	
	// W̃Zbg
	BattleCamera.pos[TARGET].x = BattleCamera.pos[NOW].x = pOperationPos->x;
	BattleCamera.pos[TARGET].y = BattleCamera.pos[NOW].y = pOperationPos->y;
	BattleCamera.pos[TARGET].z = BattleCamera.pos[NOW].z = pOperationPos->z;
	
	// px̃Zbg
	BattleCamera.rot[TARGET].x = BattleCamera.rot[NOW].x = 0.f;
	BattleCamera.rot[TARGET].y = BattleCamera.rot[NOW].y = PlRotY;
	BattleCamera.rot[TARGET].z = BattleCamera.rot[NOW].z = 0.f;
	
	// Q[̃J[hύX
//	mpCamera->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//	mpCamera->StopMotion();
//	mpCamera->DetachMotion();
}



/*
	
	
	og̃I[vjON
	
	
*/
void KK7BattleMainTask::KK7BattleStartDemo(f32 enemyRotY)
{
	WK7Chara *pChara = WK7PLAYERCONTROL->GetCharaPtr();
static s16  FIRST_ZOOM_DEMO = 20;
static f32  FIRST_ZOOM_DEMO_SPEED = 0.2f;

	if ( false == WK7PLAYERCONTROL->GetPause() ) {								// l|[YĂȂƂ
		
		if ( mStartDemoCnt > 0 ){												// JE^[Dec
			mStartDemoCnt--;
		}
		
		switch (mStartDemoTask){
		case -100:
			WK7PLAYERCONTROL->SetRotY(enemyRotY);								// ␳
			LookSet(true, -2);
			CameraCalcAndSet();
			mStartDemoCnt = (s16 )(( (s16 )WK7PLAYERCONTROL->GetMotRemainFrame() / (s16 )2 ) - FIRST_ZOOM_DEMO);
			mStartDemoTask++;
			break;
		case -99:
//			WK7PLAYERCONTROL->SetRotY(enemyRotY);								// ␳
			CameraCalcAndSet();
#ifdef	_DEBUG
			if( mainMenu.IsBattleInfo()==true ){
				LookSet(false, 100);
				break;
			}
#endif
			if ( mStartDemoCnt <= 0 ){
				mStartDemoTask++;
				mStartDemoCnt = FIRST_ZOOM_DEMO;
			}
			break;
		case -98:
			// ŏ̃JvZ
			if ( mStartDemoCnt <= 0 ){
				mStartDemoTask=0;
			}
			LookSet(false, -1, FIRST_ZOOM_DEMO_SPEED);
			CameraCalcAndSet();
			break;
		case 0:
			if ((NULL != pChara)
			&&	(NULL == mpShutter2RenderEfc)
			){
				WK7RenderObjEffectInfo	info;
				info.Create();
				mpShutter2RenderEfc = NULL;
				EFFECT *pYamEfc = CreateShutterEffect( 4, 2, 4 );					// Vb^[GtFNg쐬
				if ( pYamEfc != NULL ){
					mpShutter2RenderEfc = pChara->CreateEffect(pYamEfc ,&info);
					if ( mpShutter2RenderEfc != NULL ){
						mpShutter2RenderEfc->SetForcedDrawFlag(1);
						mStartDemoTask++;
					}
				}
			}
			break;
		case 1:
			if ((NULL != pChara)
			&&	(true == pChara->IsValidEffect(mpShutter2RenderEfc))
			&&	(0 == GetShutterState(mpShutter2RenderEfc->GetEffect()))			// Vb^[u ogJɂ
			){
				// p̎擾
				inFovSave = WK7CAM->GetFov();
				
				BattleCamera.cFovSave = pWK7Skill->GetPc_Zoom();
				BattleCamera.cFov     = BattleCamera.cFovSave;
				
				// TCg_[Jn
				if ( NULL != pGetYamadaSight() ){
					// _[tO𗧂Ă
					mSightRenderFlag = true;
					SetSightEffectRenderFlag( pGetYamadaSight(), mSightRenderFlag );
				}
				
				if ( K7HAC == K7CHR_MAINID(mID) ){									// n[}Ԉ֎q͏
					WK7PLAYERCONTROL->SetVisible(false);
				}
				
				mStartDemoCnt  = 3;													// iTCg܂ł́jߎ
				mStartDemo = 1;
				mStartDemoTask++;
				
				// pXۊǒꍇAKpX܂ŃWv鏈
				{
					Vec jumpPos;
					
					WK7PLAYERPATHCONTROL->InterpolateSkip();
					WK7PLAYERCONTROL->RestorePathPosition();
					
					// XVꂽWAoǧ_WƂĐVɕۑ
					WK7PLAYERCONTROL->GetPosition(&jumpPos);
					SetBasePosition(&jumpPos);
				}
			}
			break;
		case 2:
			if ( mStartDemoCnt <= 0 ){
				SightShotModeSet(true);
				mStartDemoTask++;
			}
			break;
		case 3:
			// Vb^[̃GtFNg2
			if ((NULL != pChara)
			&&	(true == pChara->IsValidEffect(mpShutter2RenderEfc))
			){
				pChara->ReleaseEffect(mpShutter2RenderEfc);		// RcTCgGtFNgINGXg
				mpShutter2RenderEfc = NULL;
			}
			// TCg̉ғJn
			mStartDemo = 2;
			mStartDemoTask++;
			// Vbg{^֎~
			WK7PLAYERCONTROL->ClearNoShotButton();
			break;
		default:
			break;
		}
	}
}


/*
	
	
	og̃t[vZX(Vblankj
	
	
*/
GHMGCTASK_HANDLER(KK7BattleFrameProcess)
{
	s16 exit, exitMode;
	bool firstProcess;
	bool initCamInfoSet;
	KK7BattleMainTask		*pBattleMainTask = (KK7BattleMainTask *)task_get_param(0);
	bool zoom;
	f32 PlRotY, enemyFirstRotY;

	while(BattleFrameProcessState != BATTLEFRAMEPROCESSSTATE_EXIT){
		
		
		exit = 1;
		firstProcess   = true;
		initCamInfoSet = false;
		// ҋ@
		if ( BattleFrameProcessState == BATTLEFRAMEPROCESSSTATE_INIT){
			retsys();
			continue;
		}
		
		do{
			
			retsys();
			
			// Frame local init
			pBattleMainTask->ClearCamLimitFlag();
			pBattleMainTask->ClearSightLimitFlag();
			pBattleMainTask->mSight.shotRot.x = 0.f;
			pBattleMainTask->mSight.shotRot.y = 0.f;
			pBattleMainTask->mSight.shotRot.z = 0.f;
			
			if ( false == initCamInfoSet ){
				// ŏ̃JvZ
				WK7PLAYERCONTROL->GetRotY(&PlRotY);
				enemyFirstRotY = pBattleMainTask->InitialKamaeDirSet(PlRotY);
				pBattleMainTask->BattleCameraInitInfoSet(enemyFirstRotY, pBattleMainTask->pGetSaveMyPos());
				initCamInfoSet = true;
			}
			
			pBattleMainTask->KK7BattleStartDemo(enemyFirstRotY);		// X^[gf
			
			pBattleMainTask->EnemySort();								// G̃\[g
			
			if ( false == WK7PLAYERCONTROL->GetPause() ) {				// l|[YĂȂƂ
				
				// RRt[Jn
				if ( pBattleMainTask->BattlePadRead() ){				// L[ǂݎ
					
					// LƂ̓ꏈ
//					if ((NULL != pBattleMainTask->pGetYamadaSight())
//					&&	(K7HAC == K7CHR_MAINID(pBattleMainTask->mID))
//					){
//																		// Ԉ֎qn[}̎ATCgoĂƂ̓n[}
//						if (true == GetSight2DrawState( pBattleMainTask->pGetYamadaSight() ) ){
//							WK7PLAYERCONTROL->SetVisible(false);
//						}else{
//							WK7PLAYERCONTROL->SetVisible(true);
//						}
//					}
					
					if ( pBattleMainTask->mStartDemo > 0 ){
						
						if ( true == pBattleMainTask->mSightRenderFlag ){
							// `[Wx̐ݒ
							if ( pBattleMainTask->pGetYamadaSight() != NULL ){
								SetSightChargeLevel( pBattleMainTask->pGetYamadaSight(), (s32 )WK7PLAYERCONTROL->GetChargeSetUpLv() );
							}
						}
						
						if ( pBattleMainTask->mStartDemo > 1 ) {
							zoom = pBattleMainTask->ZoomControl();			// ɃTCg̃Y[̗L肳
							if ( true == pBattleMainTask->GetPcCamSetMode() ) {
								pBattleMainTask->SightRotCalc(zoom);		// TCgJ[\̃TCgpx̍쐬iL[͋j
							}
						}
						
						pBattleMainTask->ShotRotCalc();						// Vbg̍쐬
						
						pBattleMainTask->LookSet(firstProcess);				// t[̃J|WVƃJpx쐬
						
						pBattleMainTask->SightInfoPrimSet(zoom);			// TCgv~eBu֔f
						
						pBattleMainTask->BattleShotCalc();					// og̃Vbg
						
						// J𓮂
						
						if ( 0 == KK7BattleMainTask::GetBattleProcessExit() ){
							BattleCameraMtxChange = 1;
							if ( pBattleMainTask->GetCamLimitFlag() ){
								pBattleMainTask->CameraMove(zoom);
							}
							pBattleMainTask->CameraCalcAndSet();				// J̌vZ px|WV
						}
						
						pBattleMainTask->PcPosRotCalc();					// lf̈ʒu
						
						firstProcess = false;
					}
																		// Q[Wn̍XV
//					KK7EffectGaugePointSet     ( WK7PLAYERCONTROL->GetmpScanGauge(), WK7PLAYERCONTROL->GetMaxScanPoint() - WK7PLAYERCONTROL->GetNowScanPoint(), WK7PLAYERCONTROL->GetMaxScanPoint());
					
				}else{
					exit = 0;
				}
				
			}
			
	//		if ( pBattleMainTask->mStartDemo ){
	//			if ( pBattleMainTask->mStartDemo == (120 - 100) ){
	//				gpDim->mRequest(pBattleMainTask->mStartDemo*80 + (60*80));
	//			}
	//			
	//			if ( pBattleMainTask->mStartDemo < (120 - 100) ){
	//				pBattleMainTask->armback_dist = pBattleMainTask->armback_dist - 0.5f;
	//			}
	//			pBattleMainTask->mStartDemo--;
	//		}
			
	#ifdef CAMARMDEBUG
			C_Paper		paper(0,0);
			
			{
				WK7JObj *pObjWaist;
				Vec rpos, pos, cpos, tpos;
				f32 roty, rotx, rotcy;
				
				if ( (pObjWaist = WK7PLAYERCONTROL->GetWaistObjPtr()) != NULL ){
					
					pObjWaist->GetWorldPosition(&pos);
					PRINTF("\n WaistPos %5.2f %5.2f %5.2f", pos.x, pos.y, pos.z);
					WK7PLAYERCONTROL->GetPosition(rpos);
					PRINTF("\n RootPos %5.2f %5.2f %5.2f", rpos.x, rpos.y, rpos.z);
					
					
				}
				
				pBattleMainTask->mpCamera->GetPosition(cpos);
				pBattleMainTask->mpCamera->GetTargetPosition(tpos);
				rotx = pBattleMainTask->mpCamera->GetRotX();
				roty = pBattleMainTask->mpCamera->GetRotY();
				WK7PLAYERCONTROL->GetRotY(&rotcy);
				PRINTF("\n CcPos %5.2f %5.2f %5.2f", cpos.x, cpos.y, cpos.z);
				PRINTF("\n TcPos %5.2f %5.2f %5.2f", tpos.x, tpos.y, tpos.z);
				PRINTF("\n CcRot %5.2f %5.2f %5.2f", rotcy, roty, rotx);
				PRINTF("\n mode %d", camArmDebug);
				PRINTF("\n Start %5.2f %5.2f", camArmSideBack[0], camArmFrontBack[0]);
				PRINTF("\n End   %5.2f %5.2f", camArmSideBack[1], camArmFrontBack[1]);
				PRINTF("\n High  %5.2f", camArmHigh);
			}
	#endif
			
			exitMode = KK7BattleMainTask::GetBattleProcessExit();
			
			if ((BattleFrameProcessState == BATTLEFRAMEPROCESSSTATE_EXIT)
			||	(exitMode)
			){											// og^XNI
				exit = 0;
			}
			
		}while( exit );
		
		// C^XÑJ}gNXύX߂
		BattleCameraMtxChange = 0;
		// ŏogɓĂƂ̃LW߂
		WK7PLAYERCONTROL->SetPosition(&(pBattleMainTask->mSight.saveMyPos));
		pBattleMainTask->BattleExit(exitMode);
		BattleFrameProcessState = BATTLEFRAMEPROCESSSTATE_INIT;
		retsys();		// retsysdvB
		// p߂@̃^C~OŖ߂Adv
#ifdef YAMADA_SIGHT
		{
			WK7Chara *pChara = WK7PLAYERCONTROL->GetCharaPtr();
			if ((NULL != pChara)
			&&	(true == pChara->IsValidEffect(pBattleMainTask->mpSightRenderEfc))
			){
				pChara->ReleaseEffect(pBattleMainTask->mpSightRenderEfc);		// RcTCgGtFNgINGXg
				pBattleMainTask->mpSightRenderEfc = NULL;
			}
//			if ( K7MSK == WK7PLAYERCONTROL->GetMainID() ){
//				retsys();														// retsysdvB
//			}
			// Vb^[̃GtFNg
			if ((NULL != pChara)
			&&	(true == pChara->IsValidEffect(pBattleMainTask->mpShutterRenderEfc))
			){
				pChara->ReleaseEffect(pBattleMainTask->mpShutterRenderEfc);		// RcTCgGtFNgINGXg
				pBattleMainTask->mpShutterRenderEfc = NULL;
			}
		}
#endif
		WK7CAM->SetFov(inFovSave);
	}

	task_exit();
}

GHMGCTASK_HANDLER(KK7BattleFrameProcessTerm)
{
	TaskIDSetUp = -1;
}

/*
	
	
	ogł̃Rg[ǂݎ
	
	<return>
	false			og
	
*/
bool KK7BattleMainTask::BattlePadRead(void)
{
#ifdef BURETEST
	{
		C_Paper		paper(16,120);
		
		if ( PAD_BUTTON_UP & HSD_PadGetRepeat(0) )    bureTestX += 0.005f;
		if ( PAD_BUTTON_DOWN & HSD_PadGetRepeat(0) )  bureTestX -= 0.005f;
		if ( PAD_BUTTON_RIGHT & HSD_PadGetRepeat(0) ) bureTestY += 0.005f;
		if ( PAD_BUTTON_LEFT & HSD_PadGetRepeat(0) )  bureTestY -= 0.005f;
		
		{
			PRINTF("\n bureX:%5.3f\n bureY:%5.3f", bureTestX, bureTestY);
		}
	}
#endif
	
	if ( mStartDemo >= 2 ){
		mBattlePad	= HSD_PadGetButton(0);
		mBattleTrg	= HSD_PadGetTrigger(0);
		mLpadX		= HSD_PadGetStickX(0);
		mLpadY		= HSD_PadGetStickY(0);
		mLpadXF32	= HSD_PadGetNormalStickX(0);
		mLpadYF32	= HSD_PadGetNormalStickY(0);
		mBattlePadAnalogR 	= HSD_PadGetNormalAnalogR(0);
		mBattlePadAnalogL	= HSD_PadGetNormalAnalogL(0);
	}
	
	if ( BattleModeExitTest() ){
		return false;
	}
	
	return true;
}

/*
	
	
	ʓɓĂG
	Gl~[̈ʒu߂Ƀ\[g
	
	
*/
void KK7BattleMainTask::EnemySort(void)
{
	WK7Npc *pNpcTmp;
	Vec *pMyPos;
	int eneNum, setNum, i, j, s;
	s16 setKabeFlag;


	WK7CAM->SetCurrent();
	
	// 
	for(eneNum=0; eneNum<ONE_AREA_MAXENEMY ; eneNum++){
		// e[uɊi[
		mSortNpc[eneNum].mpSortNpc	= NULL;
		mSortNpc[eneNum].dist		= 0;
		mSortNpc[eneNum].kabeFlag	= 0;
	}
	
	// l̈ʒu擾
	pMyPos = GetPosition();
	
	// xS̋vZĂ

	for(setNum=0, eneNum=0, pNpcTmp=WK7Npc::GetTop() ; eneNum < ONE_AREA_MAXENEMY ; pNpcTmp=pNpcTmp->GetNext(), eneNum++){
		
		if ( pNpcTmp == NULL ) break;
		if ( pNpcTmp->SakutekiOkTest() == false ) continue;
		if ( pNpcTmp->GetEneType() == K7ENM_SU ) continue;					// ͂͂
//		if ( pNpcTmp->GetNpcState() == NPC_STATE_INIT ) continue;			// ǂݍݓĂȂ
//		if ( pNpcTmp->GetNpcState() == NPC_STATE_LOSS ) continue;			// ǂݍݓĂȂ
//		if ( pNpcTmp->GetNpcState() == NPC_STATE_DIE ) continue;			// ł܂G͑Ώۂ͂
		
		if ( WK7Npc::TYPE_ENEMY == pNpcTmp->GetType() ){
			f32 dist;
			Vec pos;
			
			// \ĂȂiNbvꂿႤ̂ŕ\ĂȂĂvZ
//			if ( false == pNpcTmp->GetVisible() ) continue;
			
			// ΏNPC̍W𓾂
			pNpcTmp->GetWaistPosition(&pos);
			
			// ΏNPC݂APC̍G͈͋́Hi𗘗pj
			if ( pNpcTmp->GetPathResult() != PATHSEARESULT_NOWALL ){
				
				// Ƒ̊ԂɏQBp_gĉIB
				// ̑
				
				if ( pNpcTmp->pCurrentChara() == NULL ) continue;
				
				if ( false == pNpcTmp->pCurrentChara()->GetRenderFlag() ){			// ΏNPCʊOȂǂŃNbvĂꍇ
					continue;
				}else{
					
					//L̃XN[W߂BiI񂵂fꂽɂւ炸AʂɈڂĂꍇ T[`ΏۂƂȂj
					Vec sp;
					f32 p[GX_PROJECTION_SZ];
					f32 v[GX_VIEWPORT_SZ];
					
					sp.z = 0.f;
					GXGetProjectionv( p );
					GXGetViewportv( v );
					GXProject( pos.x, pos.y, pos.z,								// XN[Wɓϊ
							 HSD_CObjGetViewingMtxPtr(WK7CAM->GetCObj()),p,v, &sp.x, &sp.y, &sp.z );
					
					// ʊOH
					if( (sp.x < 0) || (sp.x > WK7_SCREEN_WIDTH) || (sp.y < 0) || (sp.y > WK7_SCREEN_HEIGHT) ){
						continue;
					}
					
					//IDEĂB
					WK7SIGHT->SetPosition(sp.x, sp.y);
					WK7SIGHT->PeekData();
					
					if( WK7SIGHT->IsValidPeekData() ){
						u32 argb = WK7SIGHT->GetPeekARGB();
						
						WK7Npc	*pNpc = WK7Npc::FindARGB(argb);
						if( pNpc!=NULL && pNpc->GetType()==WK7Npc::TYPE_ENEMY){
							//ǂɉBꂽ͂ĂȂB
							setKabeFlag = -1;
							pNpcTmp->DispTumor(false);
						}else{
							//ǂƂɉBĂB
							setKabeFlag = 1;
							pNpcTmp->HideTumor();
							continue;
						}
					}else{
						continue;
					}
				}
			}else{
							// ǂɉBĂȂ
				setKabeFlag = 0;
				pNpcTmp->DispTumor(false);
			}
			
			dist = GHM_VEC_GET_DIST(&pos, pMyPos);					// i[
			
			// e[uɊi[
			mSortNpc[setNum].mpSortNpc	= pNpcTmp;
			mSortNpc[setNum].dist		= dist;
			mSortNpc[setNum].kabeFlag   = setKabeFlag;
			
			setNum++;
			
		}
	}
	
	// 
	if ( mSortNpc[0].mpSortNpc == NULL ) return;
	
	// \[g
	for(i=0; i<setNum-1; i++){
		f32 min;
		SORTNPC stackSortNpc;
		
		pNpcTmp = mSortNpc[i].mpSortNpc;
		min = mSortNpc[i].dist;
		s = i;
		for(j=i+1; j<setNum; j++){
			if ( mSortNpc[j].dist < min ){
				min = mSortNpc[j].dist;
				s = j;
			}
		}
		
		// ւ
		stackSortNpc.mpSortNpc	= mSortNpc[i].mpSortNpc;
		stackSortNpc.dist		= mSortNpc[i].dist;
		stackSortNpc.kabeFlag	= mSortNpc[i].kabeFlag;
		
		mSortNpc[i].mpSortNpc	= mSortNpc[s].mpSortNpc;
		mSortNpc[i].dist		= mSortNpc[s].dist;
		mSortNpc[i].kabeFlag	= mSortNpc[s].kabeFlag;
		
		mSortNpc[s].mpSortNpc	= stackSortNpc.mpSortNpc;
		mSortNpc[s].dist		= stackSortNpc.dist;
		mSortNpc[s].kabeFlag	= stackSortNpc.kabeFlag;
	}
}




/*
	
	
	
	ɃTCg̃Y[̗L肳
	
	<return>
	bool		true	Y[ƒiY[̎͂Ɓj
				false	Y[ƒłȂ
	
*/
bool KK7BattleMainTask::ZoomControl(void)
{
	u32		active;
	bool	zoom = false;
	bool	armDelayCalc = true;
	
	active = ActiveCameraCtrl();									// ANeBuJ
	
#ifdef CAMARMDEBUG
	if ( PAD_BUTTON_Y & HSD_PadGetTrigger(0) ) {
		camArmDebug++;
		if( camArmDebug == 5 ) camArmDebug = 0;
	}
	switch (camArmDebug) {
	case 1:				// JnSet
		if ( PAD_BUTTON_X & HSD_PadGetButton(0) ) {
			if ( PAD_BUTTON_UP & HSD_PadGetRepeat(0) ) {
				BattleCamera.cArm_High[NOW] += 0.5f;
			}
			if ( PAD_BUTTON_DOWN & HSD_PadGetRepeat(0) ) {
				BattleCamera.cArm_High[NOW] -= 0.5f;
			}
		}else{
			if ( PAD_BUTTON_UP & HSD_PadGetRepeat(0) ) {
				BattleCamera.cArm_FrontDist[NOW] += 1.f;
			}
			if ( PAD_BUTTON_DOWN & HSD_PadGetRepeat(0) ) {
				BattleCamera.cArm_FrontDist[NOW] -= 1.f;
			}
		}
		if ( PAD_BUTTON_RIGHT & HSD_PadGetRepeat(0) ) {
			BattleCamera.cArm_SideDist[NOW] += 1.f;
		}
		if ( PAD_BUTTON_LEFT & HSD_PadGetRepeat(0) ) {
			BattleCamera.cArm_SideDist[NOW] -= 1.f;
		}
		camArmFrontBack[0] = BattleCamera.cArm_FrontDist[NOW];
		camArmSideBack[0]  = BattleCamera.cArm_SideDist[NOW];
		camArmHigh  = BattleCamera.cArm_High[NOW];
		goto CAM_CALC_PASS;
		break;
	case 2:				// ISet
		if ( PAD_BUTTON_UP & HSD_PadGetRepeat(0) ) {
			BattleCamera.cArm_FrontDist[NOW] += 1.f;
		}
		if ( PAD_BUTTON_DOWN & HSD_PadGetRepeat(0) ) {
			BattleCamera.cArm_FrontDist[NOW] -= 1.f;
		}
		if ( PAD_BUTTON_RIGHT & HSD_PadGetRepeat(0) ) {
			BattleCamera.cArm_SideDist[NOW] += 1.f;
		}
		if ( PAD_BUTTON_LEFT & HSD_PadGetRepeat(0) ) {
			BattleCamera.cArm_SideDist[NOW] -= 1.f;
		}
		camArmFrontBack[1] = BattleCamera.cArm_FrontDist[NOW];
		camArmSideBack[1]  = BattleCamera.cArm_SideDist[NOW];
		goto CAM_CALC_PASS;
		break;
	case 3:				// Run
		BattleCamera.cArm_FrontDist[NOW]    = camArmFrontBack[0];
		BattleCamera.cArm_SideDist[NOW]     = camArmSideBack [0];
		BattleCamera.cArm_FrontDist[TARGET] = camArmFrontBack[1];
		BattleCamera.cArm_SideDist[TARGET]  = camArmSideBack [1];
		BattleCamera.cArm_Delay = (8.f * (WK7_FRAME_RATE / 60.f));
		camArmDebug++;
		goto CAM_CALC_PASS;
		break;
	case 4:				// Run
		if ( PAD_BUTTON_X & HSD_PadGetTrigger(0) ) {
			camArmDebug=3;
		}
		break;
	}
#endif
	
CAM_CALC_PASS:
	
	zoom = SightZoomControl(active, armDelayCalc);					// Y[Rg[
	
	return zoom;
}


/*
	
	
	Y[
	
	
	<in>
	active		ANeButO iON=[hj
	armDelay	true  :A[̃fBCvZIĂ
				false :A[̃fBCvZIĂȂ
	
	<return>
	bool		true	Y[ƒiY[̎͂Ɓj
				false	Y[ƒłȂ
	
*/
bool KK7BattleMainTask::SightZoomControl(u32 active, bool armDelay)
{
	WK7Chara *pChara = WK7PLAYERCONTROL->GetCharaPtr();

	bool zoomFlag = false;
	f32	fovMin = WK7PLAYERCONTROL->GetMinFov();
	s16 SetZoom;

#if 1
	// Y[͂Ƃ肠֎~
	if ((mBattleTrg & BATTLE_PAD_ZOOM)							// gKŐ؂ւ
	&&	(WK7PLAYERCONTROL->GetMainID() == K7KED)				// JGf̂
	&&	(true == sight_zoom_ok)
	){
		mZoom ^= 1;												// Y[nj
	}
#endif
	
	if	(WK7PLAYERCONTROL->GetMainID() == K7HAC){				// n[}͋Y[
		mZoom = 1;												// Y[nj
	}

	// Zbgp̒lɓ
	SetZoom = mZoom;
	
	if	( 1 == active ){
		SetZoom = 2;
	}
	
	if ( false == mSightEnable ){									// TCg֎~
		SetZoom = 0;												// Y[It
		BattleCamera.cFov = BattleCamera.cFovSave;
	}
	
//	if	((WK7PLAYERCONTROL->GetMainID() == K7CON)					// RŃXyVA^bNgp
//	&&	 (1 == GetSightDirectPointFlag(mpYamadaSight))
//	){
//		SetZoom = 0;												// Y[It
//	}
	
	if ( false == armDelay ){
		SetZoom = 0;												// Y[It
	}
	
	// Y[C
	switch (mZoomProcess){
	case 0:															// ҋ@
		if ( 2 == SetZoom ){
			// CM[
			if ( mZoomNow == 1 ) {
				mZoomNow     = 0;
//				mZoom        = 1;
				goto ZOOM_OUT_PROCESS_GO;
			}
		}else{
			if ( mZoomNow != SetZoom ) {
				mZoomNow = SetZoom;
				// ݂̃Y[󋵂ƃY[ςꍇ
				if ( 0 == SetZoom ){
					// Y[AEg
					mZoomProcess = -100;
					BattleCamera.cFov = fovMin;
					goto ZOOM_OUT_PROCESS_GO;
				}else{
					// Y[C
					mZoomProcess = 100;
					BattleCamera.cFov = BattleCamera.cFovSave;
					goto ZOOM_IN_PROCESS_GO;
				}
			}
		}
		break;
	case 100:														// Y[C
ZOOM_IN_PROCESS_GO:
		// NGtFNg֘A
		gpNoise->mRequest( 2400,  800, 1600 );						// mCYGtFNg
		matsuZoom = 1;
		
		// Y[̃TCgpx̕␳
		SetZoomRotX(GetSightRotX());
		SetZoomRotY(GetSightRotY());
		
//		mSight.zoomRot.x	= GetSightRotX();
//		mSight.zoomRot.y	= GetSightRotY();
//		SetSightRotX(0.f);
//		SetSightRotY(0.f);
		{
			if ((NULL != pChara)
			&&	(true == pChara->IsValidEffect(mpSightRenderEfc))
			){
				SetSightEffectAlphaSet( mpSightRenderEfc->GetEffect(), (u32 )48 );
			}
		}
//		if	(WK7PLAYERCONTROL->GetMainID() == K7KED){				// ͋Y[
//			mZoomProcess = 0;
//		}else{
			mZoomProcess = 101;
			SIGHT_ZOOM_SPEED_FRAME = (10.f);
//		}
		zoomFlag = true;
		break;
	case 101:
		{
			f32 tmp = 0.f;
		
			if ( SIGHT_ZOOM_SPEED_FRAME > 0.f ){
				tmp = (fovMin - BattleCamera.cFov) / SIGHT_ZOOM_SPEED_FRAME;
			}
			BattleCamera.cFov += tmp;
			SIGHT_ZOOM_SPEED_FRAME -= 1.f;
			if (((BattleCamera.cFov) <= fovMin)
			||	(SIGHT_ZOOM_SPEED_FRAME <= 0.f)
			){
				BattleCamera.cFov = fovMin;
				mZoomProcess = 0;
			}
			zoomFlag = true;
		}
		break;
	case -100:													// Y[AEg
ZOOM_OUT_PROCESS_GO:
		matsuZoom = 0;
		gpNoise->mRelease();										// mCYGtFNgI
		{
			if ((NULL != pChara)
			&&	(true == pChara->IsValidEffect(mpSightRenderEfc))
			){
				SetSightEffectAlphaSet( mpSightRenderEfc->GetEffect(), (u32 )48 );
			}
		}
		if ( 2 != SetZoom ){
			mZoomProcess = -101;
		}else{
			mZoomProcess = 0;
		}
		zoomFlag = true;
		break;
	case -101:
		BattleCamera.cFov += SIGHT_ZOOM_SPEED;
		if ( (BattleCamera.cFov) > (BattleCamera.cFovSave) ){
			BattleCamera.cFov = BattleCamera.cFovSave;
			mZoomProcess = 0;
		}
		zoomFlag = true;
	}
	
	// Y[Ȃ
	if ( 1 == SetZoom ){
		zoomFlag = true;
	}
	
	// Y[ɂ̓L
	// Y[̊AIɎl𔼓ɂĂ
	if ( K7KED == K7CHR_MAINID(mID) ){
		f32 alpha;
		alpha = (BattleCamera.cFov - fovMin) / (BattleCamera.cFovSave - fovMin);
		WK7PLAYERCONTROL->SetAlphaVal( alpha );
	}
	
#if FUJITA
	//TCg̃TCYwB
	if ((NULL != pChara)
	&&	(true == pChara->IsValidEffect(mpSightRenderEfc))
	){
		SIGHTEFFECT *Sight = (SIGHTEFFECT *)mpSightRenderEfc->GetEffect()->Data;
static f32 val = 1.f;
static f32 max = (128-32.f);
		gParticleW = val*max;
		gParticleH = val*max;
#define scrPos_x	320
#define scrPos_y	240
		gParticleX = scrPos_x - gParticleW*0.5f;
		gParticleY = scrPos_y - gParticleH*0.5f;
		if ( true == mSightEnable ){
			SetSightEffectWH(mpSightRenderEfc->GetEffect(), gParticleW, gParticleH  );
		}
	}
#endif
	
	return zoomFlag;
}


/*
	
	
	ۂɃY[CĂŒǂH
	
	
*/
bool KK7BattleMainTask::GetCurrentZoomIn(void)
{
	if ( mZoomProcess == 101 ){
		return true;
	}
	return false;
}



/*
	
	
	ogł̎ˌ
	
	\͂RR
	
	
*/
void KK7BattleMainTask::BattleShotCalc(void)
{
	int atkMode;
	WK7Npc *pNpcSide;
	WK7PcShotMode ShotMode;
	WK7Chara *pChara = WK7PLAYERCONTROL->GetCharaPtr();
	Vec *pMyPos;
	
static int mode = 1;
	if ( mode ){
		if ((NULL != pChara)
		&&	(true == pChara->IsValidEffect(mpSightRenderEfc))
		){
			mSightHitReqest = HitTest(2, SHOTMODE_CLEAR);
			SetSightModeFlag( mpSightRenderEfc->GetEffect(), mSightHitReqest );					// Oqbg`FbNiTCǧ`ύX邽߁j
		}else{
			mSightHitReqest = false;
		}
	}
	
	ShotMode = WK7PLAYERCONTROL->GetShotFlag();
	if ( (true == pChara->IsValidEffect(mpSightRenderEfc)) && ShotMode ){							// eˁII
		// R{͐؂
		snapTime = 0;
		
		WK7PLAYERCONTROL->ClearShotFlag();
		mSightBureFlag = 1;
		
		// Jh炷
		if ((WK7PLAYERCONTROL->GetMainID() == K7MSK)
		||	(WK7PLAYERCONTROL->GetMainID() == K7HAC)
		){
			BattleCamera.CameraShakeCountSet(0);
		}else{
			BattleCamera.CameraShakeCountSet(1);
		}
		
		// ʂFtbV
		gpFlush->mRequest(0x8f8f40, 200, 500);
		
		if ( WK7PLAYERCONTROL->GetMainID() == K7MSK ){
			atkMode = 1;
		}else{
			atkMode = 0;
		}
		
		pMyPos = GetPosition();
		
		// qbgeXg
		if ( false == HitTest(atkMode, ShotMode) ){							// qbgeXg
			// nYꍇ eo
			switch (ShotMode){
			default:
				// ʏ̒e
				WK7PLAYERCONTROL->NoDamageHitEffectPlay(ShotMode, &(mSight.worldPos));
				break;
			case SHOTMODE_GRENADE_FIRE:
				KK7HitWallEffect(*pMyPos, mSight.worldPos, 1, WK7PLAYERCONTROL->GetMainID(), false);				// }XN͒eς
				break;
			case SHOTMODE_GRENADE_THUND:
				KK7HitWallEffect(*pMyPos, mSight.worldPos, 2, WK7PLAYERCONTROL->GetMainID(), false);				// }XN͒eς
				break;
			case SHOTMODE_GRENADE_GRAVI:
				KK7HitWallEffect(*pMyPos, mSight.worldPos, 3, WK7PLAYERCONTROL->GetMainID(), false);				// }XN͒eς
				break;
			}
		}
		
	}else{
		
		/*
		
			
			ݍUeXg
			
		
		*/
		
		if ( false == WK7PLAYERCONTROL->GetShotReturnInfo() ){							// Vbg\񏈗ĂȂ
			
#ifdef	_DEBUG
//			if( mainMenu.IsBattleInfo()==true ){
//				goto AUTO_COUNTER;
//			}
#endif
			if (mBattleTrg & HSD_PAD_X){
AUTO_COUNTER:
				// ԋ߂l
				pNpcSide = mSortNpc[0].mpSortNpc;
				if ( pNpcSide != NULL ) {
					if ( NULL != WK7PLAYERCONTROL->KerenmiStartTest(pNpcSide) ){
						WK7PLAYERCONTROL->KerenmiStart(pNpcSide);
					}
				}
			}
			
		}
		
		/*
		
			
			iUeXgiTCgύX邽߂́j
			
			Fς邾ƃ_
			
		
		*/
		pNpcSide = mSortNpc[0].mpSortNpc;
		if ( pNpcSide != NULL ) {
			
			static u32 color = CMK( 204, 102, 102, 255 );
			
			if ((NULL != pChara)
			&&	(true == pChara->IsValidEffect(mpSightRenderEfc))
			){
				if ( NULL != WK7PLAYERCONTROL->DownAtkStartTest(pNpcSide, mSortNpc[0].dist, mSortNpc[0].kabeFlag, GetCamRotX()) ){
					SetSightCircleColor( mpSightRenderEfc->GetEffect(), true, color );
				}else{
					SetSightCircleColor( mpSightRenderEfc->GetEffect(), false, color );
				}
			}
		}

	}
}


/*
	
	
	ANeBuJ
	
	<return>
	n				ANeBu
	
*/
u32 KK7BattleMainTask::ActiveCameraCtrl(void)
{
//	if ( mStartDemo ){							// ANeBuʖ
//		return 1;
//	}
	
	WK7Chara *pChara = WK7PLAYERCONTROL->GetCharaPtr();
	
static f32 ReloadFovSave;
#define RELOAD_FV (80.f)
#define KERENMI_FV (90.f)
	
	// ogAJςȂ΂ȂuԂǂ̔
	if ( true == WK7PLAYERCONTROL->CamChangeBattleSpAtkTest() ){
		goto ACTIVE_CAM_CHANGE;
	}
	
	if ( BATTLECAMMODE_ACTION == mCamChangeMode ){				// [Vɂ̃JVXe
		goto ACTIVE_CAM_CHANGE;
	}
	
	switch (WK7PLAYERCONTROL->GetPcState()){
//	case PC_STATE_SPATKNOW:
	case PC_STATE_RELOAD:
	case PC_STATE_DOWNATK:
	case PC_STATE_KERENMI_ATK:
	case PC_STATE_CHARGEALL_ATK:
ACTIVE_CAM_CHANGE:
		switch (mActiveCamProcess){
		case -1:								// 
			if ((NULL != pChara)
			&&	(NULL == mpShutterRenderEfc)
			){
				WK7RenderObjEffectInfo	info;
				info.Create();
				mpShutterRenderEfc = NULL;
				EFFECT *pYamEfc = CreateShutterEffect( 3, 2, 3, 1 );				// Vb^[GtFNg쐬
				if ( pYamEfc != NULL ){
					mpShutterRenderEfc = pChara->CreateEffect(pYamEfc ,&info);
					if ( mpShutterRenderEfc != NULL ){
						mpShutterRenderEfc->SetForcedDrawFlag(1);
						mActiveCamProcess = 0;
						mShutterTiming = 0.f;
						SightShotModeSet(false);										// TCgVbg֎~
					}
				}
			}
			break;
		case 0:
			mShutterTiming += 1.f;													// Vb^[^C~OINC
			if( (NULL != pChara)
			&&	(false == pChara->IsValidEffect(mpShutterRenderEfc))				// Ns
			){
				goto ERROR_PASS1;
			}else{
				if ((NULL != pChara)
				&&	(true == pChara->IsValidEffect(mpShutterRenderEfc))
				&&	(0 == GetShutterState(mpShutterRenderEfc->GetEffect()))			// Vb^[u ogJɂ
				){
ERROR_PASS1:
					u32 ActionCamNo = 0xffffffff;
					bool ret = false;
					
					switch (WK7PLAYERCONTROL->GetPcState()){
					case PC_STATE_RELOAD:
						ActionCamNo = WK7MOTION_PCCMN_CAM_RELOAD;
						break;
					case PC_STATE_DOWNATK:
						ActionCamNo = WK7MOTION_PCCMN_CAM_DOWNATK;
						break;
					case PC_STATE_KERENMI_ATK:
						if ( WK7MOTION_PCCMN_KERENMI == WK7PLAYERCONTROL->GetMotID() ){
							ActionCamNo = WK7MOTION_PCCMN_CAM_KERENMI;
						}
						break;
					case PC_STATE_CHARGEALL_ATK:
						ActionCamNo = WK7MOTION_PCCMN_CAM_CHARGEALL;
						break;
					}
					
					if ( ActionCamNo != 0xffffffff ){
						ret = WK7PLAYERCONTROL->ActionCameraPlay(ActionCamNo, mShutterTiming, GetCamRotY());
					}
					if ( true == ret ){
						mCamChangeMode = BATTLECAMMODE_ACTION;
					}else{
						// p
						ReloadFovSave = BattleCamera.cFov;
#ifdef	_DEBUG
//						if( mainMenu.IsBattleInfo()==true ){
//							goto FOVSETPASS;
//						}
#endif
						if ( WK7PLAYERCONTROL->GetPcState() == PC_STATE_KERENMI_ATK ){
							BattleCamera.cFov = KERENMI_FV;
						}else{
							BattleCamera.cFov = RELOAD_FV;
						}
FOVSETPASS:
						mCamChangeMode = BATTLECAMMODE_RELOAD;
					}
					
					// TCg_[֎~
					if ( NULL != pGetYamadaSight() ){
						mSightRenderFlag = false;
						SetSightEffectRenderFlag( pGetYamadaSight(), mSightRenderFlag );
					}
					
					if ( WK7PLAYERCONTROL->GetPcState() == PC_STATE_RELOAD ){
						// [ho\
						gpNoise->mUpDownStrRequest( "Reload", "", "", "۰",  2400 );
						//gpNoise->mUpDownStrRequest( "Reload", "", "", "Reload",  2400 );
					}
					
					mActiveCamProcess = 1;
				}
			}
			break;
		case 1:
			if ( WK7PLAYERCONTROL->GetPcState() == PC_STATE_RELOAD ){
				// og̃[h
static 			f32 chkFrame = 8.f;
//				if ( K7MSK == WK7PLAYERCONTROL->GetMainID() ){
//static f32 mskFrame = 6.0f;
//					chkFrame = mskFrame;
//				}
				if ( WK7PLAYERCONTROL->GetMotRemainFrame() < chkFrame ){
					if ((NULL != pChara)
					&&	(true == pChara->IsValidEffect(mpShutterRenderEfc))
					){
						ChangeSutterOpneType( mpShutterRenderEfc->GetEffect() );
					}
					mActiveCamProcess = 2;
					gpNoise->mUpDownStrRelease( 1200 );				// [ho\
				}
			}else{
				// iU
				if ( WK7PLAYERCONTROL->GetMotRemainFrame() < 8.f ){
					if ((NULL != pChara)
					&&	(true == pChara->IsValidEffect(mpShutterRenderEfc))
					){
						ChangeSutterOpneType( mpShutterRenderEfc->GetEffect() );
					}
					mActiveCamProcess = 2;
				}
			}
			break;
		case 2:
			if( (NULL != pChara)
			&&	(false == pChara->IsValidEffect(mpShutterRenderEfc))				// Ns
			){
				goto ERROR_PASS2;
			}else{
				if ((NULL != pChara)
				&&	(true == pChara->IsValidEffect(mpShutterRenderEfc))
				&&	(0 == GetShutterState(mpShutterRenderEfc->GetEffect()))			// Vb^[u ogJɂ
				){
ERROR_PASS2:
					// TCg_[Jn
					if ( NULL != pGetYamadaSight() ){
						mSightRenderFlag = true;
						SetSightEffectRenderFlag( pGetYamadaSight(), mSightRenderFlag );
					}
//					SightShotModeSet(true);											// TCgVbgOK
					
					if ( BATTLECAMMODE_ACTION == mCamChangeMode ){					// [Vɂ̃JVXe
						WK7PLAYERCONTROL->ActionCameraExit();
					}else{
						// p߂
						BattleCamera.cFov = ReloadFovSave;
					}
					mCamChangeMode = BATTLECAMMODE_KAMAE;							// J߂
					mActiveCamProcess = 3;
				}
			}
			break;
		default:
			break;
		}
		return 1;
		break;
	default:
		// Vb^[̃GtFNg
		if ((NULL != pChara)
		&&	(NULL != mpShutterRenderEfc)
		&&	(true == pChara->IsValidEffect(mpShutterRenderEfc))
		&& 	(true == BattlePadRead())
		){
			pChara->ReleaseEffect(mpShutterRenderEfc);								// RcTCgGtFNgINGXg
			mpShutterRenderEfc = NULL;
		}
		mActiveCamProcess = -1;
		SightShotModeSet(true);														// TCgVbgOK
		mCamChangeMode = BATTLECAMMODE_KAMAE;
		break;
	}
	return 0;
}


/*
	
	
	ˌqbg`FbN
	
	<in>
	mode		0:	ʏe
				1:	Ol[hi}XN̂
				2:	qbg`FbN̂
	
	ShotMode	SHOTMODE_NORMALSHOT
				SHOTMODE_DANSPATK
				SHOTMODE_KVNTAMEUCHI
				SHOTMODE_CYOMAGNUM
				SHOTMODE_GALPOWER,			// KVAp[Abv̒e
				SHOTMODE_DANPOWER,			// _ep[Abv̒e
	
*/
#include "WK7HitObj.h"
bool KK7BattleMainTask::HitTest(int mode, WK7PcShotMode ShotMode)
{
	bool ret = false;
	bool normalEnemyHit = false;
	bool hitObjHit = false;
	u32			argb;
	u32			hitChkSetID;
	s16 sightPx, sightPy;
	WK7AttackInfo info;
	WK7HitObjInfoType setEnum;
	WK7Npc *pNpcTmp;
	WK7Npc *pGrenadeTyokusetuHitNpc = NULL;
	f32 dist;
	Vec pos;
	WK7Chara *pChara = WK7PLAYERCONTROL->GetCharaPtr();
	
	if ( false == mSightEnable ) return false;
	
	info.Initialize();
	
	// RcTCgqbg|WV̏ꏊE
	if ((2 != mode)
	&&	(NULL != pChara)
	&&	(true == pChara->IsValidEffect(mpSightRenderEfc))
	){
		GetSightShotPoint( mpSightRenderEfc->GetEffect(), &sightPy, &sightPx, (u8 )mSightHand ) ;
		mSightHand ^= 1;
	}else{
		// G[ꍇ́Aʐ^ɂĂ
		sightPx = (s16 )(K7APP_SCREEN_WIDTH/2);
		sightPy = (s16 )(K7APP_SCREEN_HEIGHT/2);
	}
	
	WK7SIGHT->SetPosition((f32 )sightPx, (f32 )sightPy);
	WK7SIGHT->PeekData();
	if( false == WK7SIGHT->IsValidPeekData() ) return false;
	
	argb = WK7SIGHT->GetPeekARGB();
	
	// qbg`FbNp̂hc쐬
	hitChkSetID = WK7RenderObj::ConvAlphaToRenderID((u8)(argb >> 24));
	
	// Vbg[h|WVo
	SightScreenToWorld((f32 )sightPx, (f32 )sightPy);
	
	// qbgIuWF̃^Cvw
	switch (ShotMode){
	default:
	case SHOTMODE_NORMALSHOT:		// ʏ̂
		setEnum = WK7HITOBJINFO_TYPE_NORMALSHOT;
		break;
	case SHOTMODE_DANSPATK:			// _\
		setEnum = WK7HITOBJINFO_TYPE_DANCHARGE;
		break;
	case SHOTMODE_KVNTAMEUCHI:		// Pr^E`
		setEnum = WK7HITOBJINFO_TYPE_KVNCHARGE;
		break;
	case SHOTMODE_CYOMAGNUM:		// R[e}Oi
		setEnum = WK7HITOBJINFO_TYPE_CYOMAGNUM;
		break;
	case SHOTMODE_GALPOWER:			// KVAp[Abv̒e
		setEnum = WK7HITOBJINFO_TYPE_GALPOWER;
		break;
	case SHOTMODE_DANPOWER:			// _ep[Abv̒e
		setEnum = WK7HITOBJINFO_TYPE_DANPOWER;
		break;
	case SHOTMODE_GRENADE_FIRE	:	// }XNOl[h
		setEnum = WK7HITOBJINFO_TYPE_GRENADE_FIRE;
		break;
	case SHOTMODE_GRENADE_THUND	:	// }XNd
		setEnum = WK7HITOBJINFO_TYPE_GRENADE_THUND;
		break;
	case SHOTMODE_GRENADE_GRAVI	:	// }XNk
		setEnum = WK7HITOBJINFO_TYPE_GRENADE_GRAVI;
		break;
	case SHOTMODE_KVNCHARGEALL	:	// PrOʃVbg
		setEnum = WK7HITOBJINFO_TYPE_KVNCHARGEALL;
		break;
	case SHOTMODE_MSKCHARGEALL	:	// }XNSʃVbg
		setEnum = WK7HITOBJINFO_TYPE_MSKCHARGEALL;
		break;
	}
	
	if ( (0 == mode) || (2 == mode) || (1 == mode) ) {
		// ʏ̒e̎qbg`FbNiOl[hPx
		
		// Nɂqbg`FbN
		WK7Npc	*pNpc = WK7Npc::FindARGB(argb);
		if( pNpc!=NULL ){
			if(	(pNpc->GetType()==WK7Npc::TYPE_ENEMY)
			||	(pNpc->GetType()==WK7Npc::TYPE_EXTRA)
			){
HIT_PROCESS_JUMP:
				if ( WK7PLAYERCONTROL->GetCharaPtr() != (WK7Chara *)NULL ){
					
					if ( (0 == mode) || (1 == mode) ){
						if ((SHOTMODE_DANSPATK == ShotMode)
						||	(SHOTMODE_KVNTAMEUCHI == ShotMode)
						){
							// ^E`niԍŃqbǧój
							WK7PLAYERCONTROL->SetShotReturnInfo(&(mSight.worldPos), pNpc, sightPx, sightPy, argb, &(BattleCamera.rot[NOW]));
						}else{
							WK7NpcDamType damType;
							s16 damPoint;
							bool hitGrenade = false;
							switch (ShotMode){
							case SHOTMODE_GRENADE_THUND:
								damType = DAMTYPE_GRENADE_THUND;
								hitGrenade = true;
								break;
							case SHOTMODE_GRENADE_GRAVI:
								damType = DAMTYPE_GRENADE_GRAVI;
								hitGrenade = true;
								break;
							case SHOTMODE_GRENADE_FIRE:
								damType = DAMTYPE_GRENADE_FIRE;
								hitGrenade = true;
								break;
								
							case SHOTMODE_CYOMAGNUM:
								damType	= DAMTYPE_CYOMUGNUM;
								break;
							case SHOTMODE_GALPOWER:
								damType	= DAMTYPE_GALPOWER;
								break;
							case SHOTMODE_DANPOWER:
								damType	= DAMTYPE_DANPOWER;
								break;
							default:
								damType	= DAMTYPE_NORMAL;
								break;
							}
							
							damPoint= WK7PLAYERCONTROL->GetGunDamage(ShotMode);
							
							if ( hitGrenade ){
								pNpc->SetNpcDamage(	WK7PLAYERCONTROL->GetCharaPtr(),
													BattleCamera.rot[NOW],					// Vbg
													mSight.worldPos,
													damPoint,								// _[W|Cg
													damType
								);
								
								pGrenadeTyokusetuHitNpc = pNpc;								// ڔ͈͒eqbgNPC
								
							}else{
								// qbgnjI 
								pNpc->SetNpcDamage(	WK7PLAYERCONTROL->GetCharaPtr(),
													BattleCamera.rot[NOW],					// Vbg
													mSight.worldPos,
													damPoint,
													damType,
													0.f,
													pNpc->PeekRenderIDExTest(argb)
								);
							}
							
							CallAttackCallBackTask(info, sightPx, sightPy, argb, mSight.worldPos, pNpc);
							
						}
					}else{
						// bNI܂tO𗧂Ă
						pNpc->SetLockOn();
						
						// qbg`FbN݂̂̏ꍇAXLĂȂꍇfalseŕԂ
						if ( false == pNpc->ScanTest() ){
							ret = false;
							goto HITTEST_PASS;
						}
					}
					
					normalEnemyHit = true;
					ret = true;
					
					goto HITTEST_PASS;
				}else{
					
					ret = false;
				}
			}
			//̂̈ꕔɂȂf̏B
		}else{
			u32 id = WK7RenderObj::ConvAlphaToRenderID((u8)(argb>>24));
			for(pNpc=WK7Npc::GetTop() ; pNpc!=NULL ; pNpc=pNpc->GetNext()){
				if( pNpc->IsMyRenderID((u32)id, &mSight.worldPos)==true ){
					ret = true;
					hitChkSetID = id;
					goto HIT_PROCESS_JUMP;
				}
			}
		}
		
HITTEST_PASS:
		
		// qbgIuWFŊ蓖Ăꂽn`Ƃ̃qbgeXg
		{
			WK7HitObj::InitFind();
			WK7HitObj	*pHitObj = WK7HitObj::Find(hitChkSetID);
			if( pHitObj!=NULL ){
				if( 2 != mode ){
					if ((SHOTMODE_DANSPATK != ShotMode)
					&&	(SHOTMODE_KVNTAMEUCHI != ShotMode)
					){
						WK7HitObj::HitCheck(hitChkSetID, setEnum, sightPx, sightPy, mSight.worldPos);
						hitObjHit = true;
					}
				}
				ret = true;
			}
		}
		
//		if ((SHOTMODE_DANSPATK != ShotMode)
//		&&	(SHOTMODE_KVNTAMEUCHI != ShotMode)
//		){
//			WK7HitObj::HitCheck(hitChkSetID, setEnum, sightPx, sightPy, mSight.worldPos);
//		}
		
//		// Ȍꍇ͒eȂ
//		if( 2 != mode && !(argb >> 24) && ShotMode==SHOTMODE_NORMALSHOT ){
//			ret = true;
//		}
		
		if ( 2 == mode ){								// qbg`FbN̏ꍇłAҁbNI̔RRŗĂ
			return ret;
		}
		
		if ( 1 == mode ){								// Ol[hA͈͔ɔ΂
			goto GRENADE_HANI_TEST;
		}else{
			if ((normalEnemyHit == false)				// ʏ̓GɃqbgĂȂꍇ
			&&	(hitObjHit      == false)				// n`IuWFɂqbgĂȂꍇ
			){
				if ((SHOTMODE_DANSPATK == ShotMode)
				||	(SHOTMODE_KVNTAMEUCHI == ShotMode)
				){
					// _̓\̓^E`̃nY̏ꍇ
					WK7PLAYERCONTROL->SetShotReturnInfo(&(mSight.worldPos), NULL, sightPx, sightPy, argb, &(BattleCamera.rot[NOW]));
				}else{
					// NɂĂȂieo
					CallAttackCallBackTask(info, sightPx, sightPy, argb, mSight.worldPos, NULL);
				}
			}
		}
		
		return ret;
		
	}else{
		
		if ( 1 == mode ){

GRENADE_HANI_TEST:

			// Ol[h`[̎  lrj MSK
			
			for(pNpcTmp=WK7Npc::GetTop(); pNpcTmp!=NULL; pNpcTmp=pNpcTmp->GetNext()){
				
				if(	(pNpcTmp->GetType()==WK7Npc::TYPE_ENEMY)
				||	(pNpcTmp->GetType()==WK7Npc::TYPE_EXTRA)
				){
					f32 mskBombDist		= MSK_BOMB_DIST_MAX;
					u8  mskCriticalLv	= pWK7Skill->GetSkillLv(SKILL_CRITICALSIZE, WK7PLAYERCONTROL->GetMainID());
					
					if ( pNpcTmp->GetNpcState() == NPC_STATE_INIT ) continue;			// ǂݍݓĂȂ
					if ( pNpcTmp->GetNpcState() == NPC_STATE_LOSS ) continue;			// ǂݍݓĂȂ
					
					if ( pNpcTmp->DamageGrenadeKuraiTest() == false ) continue;
					
					if ( pGrenadeTyokusetuHitNpc != NULL ){
						if ( pGrenadeTyokusetuHitNpc == pNpcTmp ) continue;				// ڃqbgNPC͏
					}
					
					// ΏNPC̍W𓾂
//					pNpcTmp->GetPosition(pos);
					GetEnemyPositionforMskHitTest(pNpcTmp, &pos);
					
					dist = GHM_VEC_GET_DIST(&pos, &mSight.worldPos);					// Sn_Ƃ̋擾
					
					mskBombDist += (mskCriticalLv * MSK_BOMB_DIST_1LV);
					
					if ( dist < mskBombDist ){
						WK7NpcDamType setDamType = DAMTYPE_GRENADE_FIRE;
						
						switch (ShotMode){
						case SHOTMODE_GRENADE_THUND:
							setDamType = DAMTYPE_GRENADE_THUND;
							break;
						case SHOTMODE_GRENADE_GRAVI:
							setDamType = DAMTYPE_GRENADE_GRAVI;
							break;
						default:
							setDamType = DAMTYPE_GRENADE_FIRE;
							break;
						}
						pNpcTmp->SetNpcDamage(	WK7PLAYERCONTROL->GetCharaPtr(),
												BattleCamera.rot[NOW],							// Vbg
												mSight.worldPos,
												WK7PLAYERCONTROL->GetGunDamage(ShotMode),		// _[W|Cg
												setDamType
						);
						CallAttackCallBackTask(info, sightPx, sightPy, argb, mSight.worldPos, pNpcTmp);
						ret = true;
					}
				}
			}
			
			if ((ret == false)
			&&	(false == WK7PLAYERCONTROL->GetShotReturnInfo())							// Vbg\񏈗ĂȂ
			){
				// NɂĂȂ
				CallAttackCallBackTask(info, sightPx, sightPy, argb, mSight.worldPos, NULL);
			}
			
			// 2004 8 22 C
//			WK7HitObj::HitCheck(hitChkSetID, setEnum, sightPx, sightPy, mSight.worldPos);
			
#if 1
			// ς~XqbgƂɂāAWallHitGtFNgoiڂ[
			return false;
#else
			// ƏԂ悤ɂ
//			return ret;
#endif
		}
		
	}
	
	return false;
}

/*
	
	
	Cxgp̃R[obN^XNĂяo
	
	
*/
void KK7BattleMainTask::CallAttackCallBackTask(WK7AttackInfo info, s16 sightPx, s16 sightPy, u32 argb, Vec hitPos, WK7Npc *pNpc, WK7AttackinfoType type)
{
	WK7Stage *pStage;
	
	// A^bNR[obN^XNĂяo
	pStage = WK7Stage::GetCurrentStage();
	
	if ( NULL != pStage ){
		info.Initialize();
		info.mID      = mID;
		info.mScreenX = (s16 )sightPx;
		info.mScreenY = (s16 )sightPy;
		info.mHitPos  = hitPos;
		info.mARGB    = argb;
		info.mTypeID  = type;
		
		if ( pNpc == NULL ){
			info.mEnemyID = 0xffffffff;
		}else{
			info.mEnemyID = pNpc->GetEneNo();
		}
		
		pStage->CallAttackCallBackTask(info);
	}
	
	
	
	
}



/*
	
	
	TCgh炷\
	
	
*/
void KK7BattleMainTask::BureRequest(Vec bureRot)
{
	mSight.sightRotBureReq = bureRot;
}

/*
	
	
	ˌ̃u̕\
	
	
*/
void KK7BattleMainTask::SightBure(f32 *rotX, f32 *rotY)
{
//	f32 buremax = WK7PLAYERCONTROL->GetGunBure();
//	f32	bure;
	f32 rate = 1.f;
//
//	if ( false == zoom ){
//		rate = 1.f;
//	}else{
//		rate = 0.5f;
//	}
	
	/*
	
		eˁIIɂu
	
	*/
	
	if ( mSightBureFlag ){																// ˌNGXgɃtO
		
		mSightBureFlag = 0;
		
#ifdef BURETEST
		*rotY += bureTestY;					// EɂԂ
		*rotX += bureTestX;					// ㉺ɂԂ
#else
		
		rate = 1.f;
		
		switch (K7CHR_MAINID(mID)){
		case K7DAN:
			*rotX +=  0.025f * rate;				// ɂԂ
			break;
		case K7GAL:
			*rotX +=  0.010f * rate;				// ɂԂ
			break;
		case K7CAT:
			*rotX += (float )((HSD_Randf() * 0.05f) - 0.025f) * rate;					// ㉺ɂԂ
	//		*rotY += -0.025f;					// ɂԂ
			break;
		case K7HAC:
			*rotX +=  0.040f * rate;	 			// ɂԂ
			break;
		case K7HAY:
			*rotX += (float )((HSD_Randf() * 0.04f) - 0.02f) * rate;					// ㉺ɂԂ
			*rotY += (float )((HSD_Randf() * 0.04f) - 0.02f) * rate;					// EɂԂ
			break;
		case K7CYO:
			*rotX += -0.028f * rate;				// ɂԂ
			*rotY += -0.028f * rate;				// ɂԂ
			break;
		case K7KED:
			*rotX +=  0.025f * rate;				// ɂԂ
			break;
		case K7KVN:
//			*rotX += -0.040f * rate;				// ɂԂ
//			*rotY += +0.040f * rate;				// EɂԂ
			break;
		case K7MSK:
			*rotX +=  0.150f * rate;				// ɂԂ
			break;
		}
#endif
	}
	
	/*
	
		\̃u
	
	*/
	{
//#define KAMAE_BURE_DEF		(0.070f)
static f32 KAMAE_BUREX_DEF = 0.0004f;			// ũftHg̒l
static f32 KAMAE_BUREY_DEF = 0.0005f;			// ũftHg̒l
static f32 KamaeRotBureX = 0.f;
static f32 KamaeRotBureY = 0.f;
static f32 KamaeRotBureXInc = 0.02f;			// pxɑĂl
static f32 KamaeRotBureYInc = 0.04f;			// pxɑĂl

		rate = pWK7Skill->GetSkillCurrentLv_Bure();
		
		KamaeRotBureX += KamaeRotBureXInc;
		GHM_LIMIT_RANGE(KamaeRotBureX, PI,-PI);
		
		KamaeRotBureY += KamaeRotBureYInc;
		GHM_LIMIT_RANGE(KamaeRotBureY, PI,-PI);
		
		*rotX += KAMAE_BUREX_DEF * cosf(KamaeRotBureX) * rate;
		*rotY += KAMAE_BUREY_DEF * cosf(KamaeRotBureY) * rate;
	}
	
	/*
	
		u\ɂu
	
	*/
	// w̃u\𑫂
	if ( mSight.sightRotBureReq.x != 0.f ){
		*rotX += mSight.sightRotBureReq.x;
		mSight.sightRotBureReq.x = 0.f;
	}
	
	//@x̃u\𑫂
	if ( mSight.sightRotBureReq.y != 0.f ){
		*rotY += mSight.sightRotBureReq.y;
		mSight.sightRotBureReq.y = 0.f;
	}
}


/*
	
	
	Y[̃u̕\
	
	
*/
void KK7BattleMainTask::SightZoomBure(f32 *rotX, f32 *rotY)
{
	if ( mSight.zoomRot.x != 0.f ){
		*rotX += mSight.zoomRot.x;
		mSight.zoomRot.x = 0.f;
	}
	
	//@x̃u\𑫂
	if ( mSight.zoomRot.y != 0.f ){
		*rotY += mSight.zoomRot.y;
		mSight.zoomRot.y = 0.f;
	}
}


/*
	
	
	TCgJ[\̃TCgpx̍쐬
	
	<in>
	zoom		true 	Y[
				false	Y[łȂ
	
*/
void KK7BattleMainTask::SightRotCalc(bool zoom)
{
	f32	rateX, rateY, SightRotXNow, SightRotYNow, tempRot, fugou;

	// Init
	mSight.frameMov.x		= 0.f;
	mSight.frameMov.y		= 0.f;
	mSight.padMov.x			= 0.f;
	mSight.padMov.y			= 0.f;
	mSight.frameMov.z		= 0.f;
	SightRotXNow			= GetSightRotX();
	SightRotYNow			= GetSightRotY();
	
	// L[̓Ã݂t[̈ړpx쐬
	
	// ̃e[uŃTCgXs[h͔f悤ɂ
	if ( true == mSightHitReqest ){
		// G߂炦ĂAɂȂ
		rateY = 0.5f;
		rateX = 0.5f;
	}else{
		rateY = 1.0f;
		rateX = 1.0f;
	}
	// Y[ɂq̈Ⴂ
	if	(WK7PLAYERCONTROL->GetMainID() == K7KED){				// ̓Y[1/10̃TCgXs[h
		if( true == zoom ){
			rateY *= 0.1f;										// ̈ړʁiYj
			rateX *= 0.1f;										// c̈ړʁiXj
		}
	}
	
	
	// ̃t[ ړʂ
	mSight.padMov.y = mSight.frameMov.y = pWK7Skill->GetPc_SightSpeed() * mLpadXF32 * rateY;
	mSight.padMov.x = mSight.frameMov.x = pWK7Skill->GetPc_SightSpeed() * mLpadYF32 * rateX;
	if ( K7SCR_GET_GLOBAL_FLAG( K7GLFL_OPT_RECONTROL ) ){
		mSight.padMov.x   *= -1.f;
		mSight.frameMov.x *= -1.f;
	}
	
	// I[gbNIp̏
//	if ( (mSight.frameMov.y == 0.f) && (mSight.frameMov.x == 0.f) ){
//		snapTime = snapTimeMAX;
//	}else{
//		snapSePlay = 1;
//	}
	
	// ˌ̃u̒l𑫂
	SightBure(&(mSight.frameMov.x), &(mSight.frameMov.y));
	
	// Y[̒l𑫂
//	SightZoomBure(&(mSight.frameMov.x), &(mSight.frameMov.y));
	// ]āATCg̕ɂ Y[̒l𑫂
	mSight.frameMov.x -= GetZoomRotX();
	mSight.frameMov.y -= GetZoomRotY();
	
	tempRot = SightRotXNow + mSight.frameMov.x;
	GHM_LIMIT_RANGE(tempRot, PI, -PI);
	if ( (SightRotXNow) < 0.f ) {
		fugou = -1.f;
	}else{
		fugou = +1.f;
	}
	// TCgpxwύX (TCgpx̃~bgeXg)
	if ((fabsf(tempRot) >= sight_rot_limit_X)
	||	(zoom)
	){
		mSightLimitFlag  = 1;
		mCamLimitFlag    = 1;
		if ( zoom ){
			SightRotXNow = tempRot;
		}else{
			SightRotXNow = sight_rot_limit_X * fugou;
		}
	}else{
		SightRotXNow     = tempRot;
	}
	
	tempRot = SightRotYNow - mSight.frameMov.y;
	GHM_LIMIT_RANGE(tempRot, PI,-PI);
	if ( (SightRotYNow) < 0.f ) {
		fugou = -1.f;
	}else{
		fugou = +1.f;
	}
	// TCgpxxύX (TCgpx̃~bgeXg)
	if ((fabsf(tempRot) >= sight_rot_limit_Y)
	||	(zoom)
	){
		mSightLimitFlag  = 1;
		mCamLimitFlag    = 1;
		if ( zoom ){
			SightRotYNow  = tempRot;
		}else{
			SightRotYNow = sight_rot_limit_Y * fugou;
		}
	}else{
		SightRotYNow     = tempRot;
	}
	
	SetSightRotX(SightRotXNow);
	SetSightRotY(SightRotYNow);
}
	
/*
	
	
	Vbg̍쐬
	
	
*/
void KK7BattleMainTask::ShotRotCalc(void)
{
	Vec sp;														// XN[|WVɕϊ
	Vec *pMyPos, tgt;
	f32	SightRotXNow, SightRotYNow;
	float AimRotY, AimRotX;

	SightRotXNow			= GetSightRotX();
	SightRotYNow			= GetSightRotY();
	
	// J̌ĂƁAJ[\𑫂āAy_Ăz쐬
	AimRotY = SightRotYNow + GetCamRotY();
	GHM_LIMIT_RANGE(AimRotY, PI,-PI);
	AimRotX = SightRotXNow + GetCamRotX();
	AimRotX = RotXLimitTest(AimRotX);
	
	// JKlÃ[hW̊o
	{
#define	SIGHT_TARGET_DIST	(100.f)
		float	zx;
		
		pMyPos = GetPosition();
		tgt.y = pMyPos->y + SIGHT_TARGET_DIST * sinf(AimRotX);
		zx    =           SIGHT_TARGET_DIST * cosf(AimRotX);
		tgt.x = pMyPos->x + zx                * sinf(AimRotY);
		tgt.z = pMyPos->z + zx                * cosf(AimRotY);
	}
	
	// XN[Wɕϊ
	{
		f32 p[GX_PROJECTION_SZ];
		f32 v[GX_VIEWPORT_SZ];
		
		sp.z = 0.f;
		GXGetProjectionv( p );
		GXGetViewportv( v );
		GXProject( tgt.x, tgt.y, tgt.z,								// XN[Wɓϊ
		HSD_CObjGetViewingMtxPtr(WK7CAM->GetCObj()),p,v, &sp.x, &sp.y, &sp.z );
	}
	
	// TCg̖ڕWXN[WƂĊi[
	mSight.scrPos.x = (s16 )sp.x;
	mSight.scrPos.y = (s16 )sp.y;
#ifdef CAMARMINFODEBUG
	C_Paper		paper(16,120);
	{
		PRINTF("\n SiRotLocal X:%5.2f Y:%5.2f", mSight.sightRot.x, mSight.sightRot.y);
		PRINTF("\n SiRotWorld Y:%5.2f", AimRotY);
//		PRINTF("\n CPos  %5.2f %5.2f", BattleCamera.rot[NOW].x, BattleCamera.rot[NOW].y);
	}
#endif

	// _Ă̊i[
	mSight.shotRot.x = AimRotX;
	mSight.shotRot.y = AimRotY;
}


/*
	
	
	TCgv~eBu֔f
	
	݂̃TCg̃XN[ł̏
	nӁARc̃TCgNX֏󂯓n
	
	<in>
	zoom		true 	Y[
				false	Y[łȂ
	
*/
void KK7BattleMainTask::SightInfoPrimSet(bool zoom)
{
#pragma unused(zoom)
	Vec sp;
	WK7Chara *pChara = WK7PLAYERCONTROL->GetCharaPtr();
	
	sp.z = 0.f;
	
	// nӃTCgNX֓o^
	WK7SIGHT->SetVisible(true);
	
#ifdef YAMADA_SIGHT
	if ((NULL != pChara)
	&&	(true == pChara->IsValidEffect(mpSightRenderEfc))
	){
		// ʏƏ
		Vec sightVec;
		sightVec.z = 0.f;
//		if ( false == zoom ){
//			sightVec.x = (float )(mSight.scrPos.x);
//			sightVec.y = (float )(mSight.scrPos.y);
//		}else{
			sightVec.x = (float )(320.f);
			sightVec.y = (float )(240.f);
//		}
		SetSightEffectPoint( mpSightRenderEfc->GetEffect(), &sightVec );
	}
#endif
	
}

/*
	
	
	`摜TCgJ[\ʒusbNAbv
	[h|WVo
	
	
*/
void KK7BattleMainTask::SightScreenToWorld(f32 px, f32 py)
{
	Vec		pos,tgt,dir,hdir;
	Vec		up = {0.0f,1.0f,0.0f};
static	f32		ddist = 0.0f;								// ƎOɕ\ꍇ͂
	f32		dist = WK7SIGHT->GetPeekDist() + ddist;
	f32		x,y,z;

	x = (f32 )px;
	y = (f32 )py;
	
	WK7SIGHT->ScreenToCamCoord(x,y,z);
	
	WK7CAM->GetPosition      (pos);
	WK7CAM->GetTargetPosition(tgt);
	
	VECSubtract    (&tgt ,&pos ,&dir);
	VECNormalize   (&dir ,&dir);
	VECCrossProduct(&dir ,&up  ,&hdir);
	VECNormalize   (&hdir,&hdir);
	VECCrossProduct(&hdir,&dir ,&up  );
	VECNormalize   (&up  ,&up);
	VECScale       (&dir ,&dir ,dist );
	VECAdd         (&pos ,&dir ,&pos );
	VECScale       (&up  ,&up  ,-y   );
	VECAdd         (&pos ,&up  ,&pos );
	VECScale       (&hdir,&hdir,x    );
	VECAdd         (&pos ,&hdir,&pos );
	
	// [h|WV̊i[
	mSight.worldPos = pos;
	
#if 0
//	// J[\̌vZ
//	WK7CAM->GetPosition(tgt);
//	{
//		Vec dir;
//		f32 zx;
//		
//		dir.x = pos.x - tgt.x;
//		dir.y = pos.y - tgt.y;
//		dir.z = pos.z - tgt.z;
//		zx    = sqrtf(dir.x * dir.x + dir.z * dir.z);
//		mSight.worldRot.y  = atan2f(dir.x,dir.z);
//		mSight.worldRot.x  = atan2f(dir.y,zx   );
//	}
#endif
}


/*
	
	
	lf̈ʒu
	
	
*/
void KK7BattleMainTask::PcPosRotCalc(void)
{
	f32 SetPcAimSide;
	f32 SetPcAimFront;
	f32 SetPcAimHigh;
//	#ifdef	_DEBUG
//		if( mainMenu.IsBattleInfo()==true ){
//			C_Paper		paper(0, 420-16);
//	//		PRINTF("  F:%3.1f S:%3.1f H:%3.1f\n", PcAimFront, PcAimSide, PcAimHigh);
//	//		PRINTF("  LX:%2.2f LY:%2.2f\n", sight_rot_limit_X, sight_rot_limit_Y);
//	//		PRINTF("  TP:%d/%d \n", WK7PLAYERCONTROL->GetNowBloodPoint(), WK7PLAYERCONTROL->GetMaxBloodPoint() );
//			PRINTF("NearNPC:%2.2f\n", GetNearNpcDist() );
//	//		PRINTF("  CamMode:%d\n", mCamChangeMode );
//	//		PRINTF("  Fov:%2.2f\n", BattleCamera.cFov );
//			
//			
//	//		if ( PAD_BUTTON_Y & HSD_PadGetButton(0) ) {
//	//			
//	//			if ( PAD_BUTTON_UP & HSD_PadGetRepeat(0) )			sight_rot_limit_X  += 0.01f;
//	//			if ( PAD_BUTTON_DOWN & HSD_PadGetRepeat(0) ){		
//	//																sight_rot_limit_X  -= 0.01f;
//	//																if ( sight_rot_limit_X < 0.f ) sight_rot_limit_X = 0.f;
//	//			}
//	//			if ( PAD_BUTTON_LEFT & HSD_PadGetRepeat(0) ){
//	//																sight_rot_limit_Y  -= 0.01f;
//	//																if ( sight_rot_limit_Y < 0.f ) sight_rot_limit_Y = 0.f;
//	//			}
//	//			if ( PAD_BUTTON_RIGHT & HSD_PadGetRepeat(0) ) 		sight_rot_limit_Y  += 0.01f;
//	//			
//	//		}else{
//	
//	#if 1
//				if ( PAD_BUTTON_Y & HSD_PadGetButton(0) ) {
//					if ( PAD_BUTTON_UP & HSD_PadGetRepeat(0) )		PcAimFront += 1.f;
//					if ( PAD_BUTTON_DOWN & HSD_PadGetRepeat(0) )	PcAimFront -= 1.f;
//				}else{
//					if ( PAD_BUTTON_X & HSD_PadGetButton(0) ) {
//						if ( PAD_BUTTON_UP & HSD_PadGetRepeat(0) )		BattleCamera.cFov  += 1.f;
//						if ( PAD_BUTTON_DOWN & HSD_PadGetRepeat(0) )	BattleCamera.cFov  -= 1.f;
//					}else{
//						if ( PAD_BUTTON_UP & HSD_PadGetRepeat(0) )		PcAimHigh  += 0.1f;
//						if ( PAD_BUTTON_DOWN & HSD_PadGetRepeat(0) )	PcAimHigh  -= 0.1f;
//					}
//				}
//				if ( PAD_BUTTON_RIGHT & HSD_PadGetRepeat(0) ) 		PcAimSide  -= 0.1f;
//				if ( PAD_BUTTON_LEFT & HSD_PadGetRepeat(0) ) 		PcAimSide  += 0.1f;
//				if ( HSD_PAD_Z & HSD_PadGetTrigger(0) ) {
//					CamChangeMode++;
//					if ( CamChangeMode >= BATTLECAMMODE_MAX ) 		CamChangeMode = 0;
//				}
//				mCamChangeMode = CamChangeMode;
//	//			if ( HSD_PAD_Z & HSD_PadGetTrigger(0) ){
//	//				if ( true == sight_zoom_ok )	sight_zoom_ok = false;
//	//				else							sight_zoom_ok = true;
//	//			}
//	//		}
//			
//			SetPcAimSide  = PcAimSide;
//			SetPcAimFront = PcAimFront;
//			SetPcAimHigh  = PcAimHigh;
//	#else
//			SetPcAimSide  = CharaPosArm[K7CHR_MAINID(mID)].Side;
//			SetPcAimFront = CharaPosArm[K7CHR_MAINID(mID)].Front;
//			SetPcAimHigh = CharaPosArm[K7CHR_MAINID(mID)].High;
//			PcAimSide     = SetPcAimSide;
//			PcAimFront    = SetPcAimFront;
//			PcAimHigh 	=	SetPcAimHigh ;
//	#endif
//		}else{
//			SetPcAimSide  = CharaPosArm[K7CHR_MAINID(mID)].Side;
//			SetPcAimFront = CharaPosArm[K7CHR_MAINID(mID)].Front;
//			SetPcAimHigh = CharaPosArm[K7CHR_MAINID(mID)].High;
//			PcAimSide     = SetPcAimSide;
//			PcAimFront    = SetPcAimFront;
//			PcAimHigh 	=	SetPcAimHigh ;
//		}
//	#else
//	#endif
	
	if ((WK7PLAYERCONTROL->GetMainID() == K7MSK)
	&&	(KK7BATTLECTRL_MSKLV_TEKKAMEN == BattleCtrl.GetMskPowerUp())
	){
		SetPcAimSide  = CharaPosArmMSK.Side;
		SetPcAimFront = CharaPosArmMSK.Front;
		SetPcAimHigh  = CharaPosArmMSK.High;
	}else{
		SetPcAimSide  = CharaPosArm[K7CHR_MAINID(mID)].Side;
		SetPcAimFront = CharaPosArm[K7CHR_MAINID(mID)].Front;
		SetPcAimHigh  = CharaPosArm[K7CHR_MAINID(mID)].High;
	}
	
#if FUJITA && BATTLE_CAM_ATTACH
	// ob̏ύX
	if ( true == GetPcCamSetMode() ) {
		Mtx ofst,rot,trs;
		MTXRotDeg( rot, 'y', 180.f );
		MTXTrans( trs, SetPcAimSide, -SetPcAimHigh, -SetPcAimFront );
		MTXConcat( trs, rot, ofst );
		WK7PLAYERCONTROL->SetCamOfstMtx( ofst );
	}else{
		WK7PLAYERCONTROL->SetPosition(pGetSaveMyPos());
		WK7PLAYERCONTROL->SetRotY(GetCamRotY());
	}
#else
	// lʒu擾
	WK7PLAYERCONTROL->GetPosition(&PcPos);
	
	// Jʒu擾
	pCamPos = GetPosition();
	
	// _Ă擾
#if 0
	AimRotY = mSight.shotRot.y;
	AimRotX = mSight.shotRot.x;
#else
	AimRotY = GetCamRotY();
	AimRotX = GetCamRotX();
#endif
	
	// A[vZ
	tmprot = AimRotY + PI/2.f;
	GHM_LIMIT_RANGE(tmprot, PI, -PI);
	
	PcPos.x = pCamPos->x + SetPcAimSide * sinf(tmprot);
	PcPos.z = pCamPos->z + SetPcAimSide * cosf(tmprot);
	
	tmprot = AimRotY + PI;
	GHM_LIMIT_RANGE(tmprot, PI, -PI);
	
	PcPos.x = PcPos.x + SetPcAimFront * sinf(tmprot);
	PcPos.z = PcPos.z + SetPcAimFront * cosf(tmprot);

	// ob̏ƂăZbg
	WK7PLAYERCONTROL->SetPosition(&PcPos);
	
	// ob̏ƂăZbg
	WK7PLAYERCONTROL->SetRotY(AimRotY);
//	WK7PLAYERCONTROL->SetRotX(-AimRotX);
#endif
}


/*
	
	
	t[̃J|WVƃJpx쐬
	
	
*/
void KK7BattleMainTask::LookSet(bool firstTest, int Process, f32 delay)
{
	Vec NowRot;
	f32 SetPcAimHigh  = 0.f;
	f32 SetPcAimSide  = 0.f;
	f32 SetPcAimFront = 0.f;


	NowRot.x = GetCamRotX();
	NowRot.y = GetCamRotY();
	NowRot.z = 0.f;
	
#ifdef	_DEBUG
	if( mainMenu.IsBattleInfo()==true ){
		if ( PAD_BUTTON_Y & HSD_PadGetButton(0) ) {
			if ( PAD_BUTTON_UP & HSD_PadGetRepeat(0) )			PcAimFront += 1.f;
			if ( PAD_BUTTON_DOWN & HSD_PadGetRepeat(0) )		PcAimFront -= 1.f;
		}else{
			if ( PAD_BUTTON_X & HSD_PadGetButton(0) ) {
				if ( PAD_BUTTON_UP & HSD_PadGetRepeat(0) )		BattleCamera.cFov  += 1.f;
				if ( PAD_BUTTON_DOWN & HSD_PadGetRepeat(0) )	BattleCamera.cFov  -= 1.f;
			}else{
				if ( PAD_BUTTON_UP & HSD_PadGetRepeat(0) )		PcAimHigh  += 0.1f;
				if ( PAD_BUTTON_DOWN & HSD_PadGetRepeat(0) )	PcAimHigh  -= 0.1f;
			}
		}
		if ( PAD_BUTTON_RIGHT & HSD_PadGetRepeat(0) ) 			PcAimSide  -= 0.1f;
		if ( PAD_BUTTON_LEFT & HSD_PadGetRepeat(0) ) 			PcAimSide  += 0.1f;
		
		SetPcAimSide  = PcAimSide;
		SetPcAimFront = PcAimFront;
		SetPcAimHigh  = PcAimHigh;
	}else{
		SetPcAimHigh  = CharaPosArm[K7CHR_MAINID(mID)].High;
		PcAimHigh     = SetPcAimHigh;
	}
#endif
	
	switch (Process){
	case -2:
		SetPcAimHigh  = StartCameraPos[K7CHR_MAINID(mID)].High;
		SetPcAimSide  = StartCameraPos[K7CHR_MAINID(mID)].Side;
		SetPcAimFront = StartCameraPos[K7CHR_MAINID(mID)].Front;
		break;
	case -1:
		SetPcAimHigh  = StartEndCameraPos[K7CHR_MAINID(mID)].High;
		SetPcAimSide  = StartEndCameraPos[K7CHR_MAINID(mID)].Side;
		SetPcAimFront = StartEndCameraPos[K7CHR_MAINID(mID)].Front;
		break;
	case 0:
		if ((WK7PLAYERCONTROL->GetMainID() == K7MSK)
		&&	(KK7BATTLECTRL_MSKLV_TEKKAMEN == BattleCtrl.GetMskPowerUp())
		){
			SetPcAimHigh  = CharaPosArmMSK.High;
		}else{
			SetPcAimHigh  = CharaPosArm[K7CHR_MAINID(mID)].High;
		}
		break;
	}
	
	BattleCamera.LookSetRotCalc(SetPcAimSide,									// TCh
								SetPcAimFront,									// tg
								SetPcAimHigh,									// 
								mSight.saveMyPos,								// {ƂȂʒu
								NowRot,											// {ƂȂpx
								NULL,
								NULL,
								firstTest
	);
	
	// J ̃fBČvZ
	BattleCamera.CameraDelayCalc(delay);
}



/*
	
	
	J̌vZ px|WV
	
	<in>
	zoom	1 Y[
			0 Y[Ŗ
	
*/
void KK7BattleMainTask::CameraCalcAndSet(void)
{
#define TORIAEZU_DIST	(100.f)
	f32 distzx;
	f32 GetRotX, GetPosY, setRotX, setRotY;
	Vec GetPos, GetRot, TargetPos, NowCamRot;
	f32 SetPcAimSide;
	f32 SetPcAimFront;
	f32 SetPcAimHigh;
	f32 shakeRate = 1.f;
	
	switch (mCamChangeMode){
	case BATTLECAMMODE_ACTION:				// ȂȂ
		break;
	case BATTLECAMMODE_KAMAE:
		// Jhp[^擾
		GetRotX = 0.f;
		GetPosY = 0.f;
		
		if ( K7HAY == K7CHR_MAINID(mID) ){
			shakeRate = 0.25f;
		}
		BattleCamera.ShakeParamGet(&GetRotX, &GetPosY, shakeRate);
		
		// Jf[^Ƃĕϊ
		setRotX = GetCamRotX() + GetRotX;
		setRotY = BattleCamera.pos[NOW].y + GetPosY;
		
		distzx = TORIAEZU_DIST * cosf(setRotX);
		BattleCamera.tmpTarget.y = setRotY                 + TORIAEZU_DIST * sinf(setRotX);
		BattleCamera.tmpTarget.x = BattleCamera.pos[NOW].x + distzx * sinf(GetCamRotY());
		BattleCamera.tmpTarget.z = BattleCamera.pos[NOW].z + distzx * cosf(GetCamRotY());
		
		// CJf[^Ƃēnӑ֓o^
		mpCamera->SetPosition(BattleCamera.pos[NOW]);
		mpCamera->SetTargetPosition(BattleCamera.tmpTarget);
		mpCamera->SetFov(BattleCamera.cFov);
		break;
	case PC_STATE_KERENMI_ATK:
		// PC_STATE_RELOAD
		NowCamRot.x = 0.f;
		NowCamRot.y = GetCamRotY();
		NowCamRot.z = 0.f;

#ifdef	_DEBUG
//		if( mainMenu.IsBattleInfo()==true ){
//			SetPcAimSide  = PcAimSide;
//			SetPcAimFront = PcAimFront;
//			SetPcAimHigh  = PcAimHigh;
//		}else{
			SetPcAimSide  = CounterCharaPosArm[K7CHR_MAINID(mID)].Side;
			SetPcAimFront = CounterCharaPosArm[K7CHR_MAINID(mID)].Front;
			SetPcAimHigh  = CounterCharaPosArm[K7CHR_MAINID(mID)].High;
//		}
#else
			SetPcAimSide  = CounterCharaPosArm[K7CHR_MAINID(mID)].Side;
			SetPcAimFront = CounterCharaPosArm[K7CHR_MAINID(mID)].Front;
			SetPcAimHigh  = CounterCharaPosArm[K7CHR_MAINID(mID)].High;
#endif
		goto ACTION_CAMERA;
		break;
	case BATTLECAMMODE_RELOAD:
		// PC_STATE_RELOAD
		NowCamRot.x = 0.f;
		NowCamRot.y = GetCamRotY();
		NowCamRot.z = 0.f;

#ifdef	_DEBUG
//		if( mainMenu.IsBattleInfo()==true ){
//			SetPcAimSide  = PcAimSide;
//			SetPcAimFront = PcAimFront;
//			SetPcAimHigh  = PcAimHigh;
//		}else{
			SetPcAimSide  = ReloadCharaPosArm[K7CHR_MAINID(mID)].Side;
			SetPcAimFront = ReloadCharaPosArm[K7CHR_MAINID(mID)].Front;
			SetPcAimHigh  = ReloadCharaPosArm[K7CHR_MAINID(mID)].High;
//		}
#else
			SetPcAimSide  = ReloadCharaPosArm[K7CHR_MAINID(mID)].Side;
			SetPcAimFront = ReloadCharaPosArm[K7CHR_MAINID(mID)].Front;
			SetPcAimHigh  = ReloadCharaPosArm[K7CHR_MAINID(mID)].High;
#endif

ACTION_CAMERA:

		BattleCamera.LookSetRotCalc(SetPcAimSide,									// TCh
									SetPcAimFront,									// tg
									SetPcAimHigh,									// 
									mSight.saveMyPos,								// {ƂȂʒu
									NowCamRot,										// {ƂȂpx
									&GetPos,
									&GetRot
		);
		
		// Jf[^Ƃĕϊ
		setRotX = GetRot.x;
		setRotY = GetPos.y;
		
		distzx = TORIAEZU_DIST * cosf(setRotX);
		TargetPos.y = setRotY  + TORIAEZU_DIST * sinf(setRotX);
		TargetPos.x = GetPos.x + distzx * sinf(GetRot.y);
		TargetPos.z = GetPos.z + distzx * cosf(GetRot.y);
		
		// CJf[^Ƃēnӑ֓o^
		mpCamera->SetPosition      (GetPos);
		mpCamera->SetTargetPosition(TargetPos);
		mpCamera->SetFov(BattleCamera.cFov);
		
		break;
	}
}


/*
	
	
	J[\~bgɓB
	Jړ鏈
	
	
*/
void KK7BattleMainTask::CameraMove(bool /*zoom*/)
{
	f32 NowRotY, NowRotX;
	bool NotKanseiFlag = true;
	bool BuiLockOn = false;
	bool AutoLockOn = false;
	bool easyLockProc = false;
	int searchPoint, i, chk;
	bool ret = false;
	Vec eneRot;

	// ~bgɒBĂƔfāAɔł̂ō̈ړʂJɔf
	NowRotY = GetCamRotY();
	NowRotX = GetCamRotX();
	
	// Y[
	NowRotX += GetZoomRotX(true);
	NowRotY += GetZoomRotY(true);
	
	NowRotY -= mSight.frameMov.y;
	GHM_LIMIT_RANGE(NowRotY, PI, -PI);
	
	NowRotX += mSight.frameMov.x;
	NowRotX = RotXLimitTest(NowRotX);
	
	// abNI
//	if ( false == BuiLockOn ){
		if ( B_LOCKON & HSD_PadGetTrigger(0) ){
			autoSnapTime = autoSnapTimeMAX;
			ret = BuiDirGet(&eneRot, mSight.worldPos, -2, 0, true);
			if ( ( ret == true ) && (autoSnapTime == autoSnapTimeMAX) ){
				AutoLockOn = true;
				mEasyLockOnNum = 1;
			}
			if ( AutoLockOn == true ){
				gpSound->mPlaySE( SFX_BT_ZOOM_OUT,	//SEԍ
						  SOUND_SYSTEM_SE_VOLUME,	//
						  SOUND_PAN_CENTER,			//p
						  eSETrackBattleOverlap,	//gbN
						  eSEGroupBattle00 );		//O[v
				NowRotY = eneRot.y;
				NowRotX = eneRot.x;
				NotKanseiFlag = false;
			}else{
				autoSnapTime = 0;
			}
		}else{
			if ( 0 < autoSnapTime ){
				ret = BuiDirGet(&eneRot, mSight.worldPos, -2, 0);
				if ( ret == true ){
					if ( (mSight.padMov.y == 0.f) && (mSight.padMov.x == 0.f) ){
						autoSnapTime--;
					}else{
						autoSnapTime = 0;
					}
					
					NowRotY = eneRot.y;
					NowRotX = eneRot.x;
					NotKanseiFlag = false;
					AutoLockOn = true;
				}
			}
		}
//	}
	
	if ((true == pWK7Skill->UseAbilityTest(WK7PLAYERCONTROL->GetMainID(), SKILLABILITY_CRITICALLOCKON))
	||	(true == pWK7Skill->UseAbilityTest(WK7PLAYERCONTROL->GetMainID(), SKILLABILITY_HEADLOCKON))
	||	(true == pWK7Skill->UseAbilityTest(WK7PLAYERCONTROL->GetMainID(), SKILLABILITY_JOINTLOCKON))
	||	(true == K7SCR_GET_GLOBAL_FLAG( K7GLFL_EASY_MODE))													// C[W[[hȏꍇ
	){
		if ((true == pWK7Skill->UseAbilityTest(WK7PLAYERCONTROL->GetMainID(), SKILLABILITY_CRITICALLOCKON))
		||	(true == K7SCR_GET_GLOBAL_FLAG( K7GLFL_EASY_MODE))
		){
				searchPoint = BUI_DIREGET_ID_WEAK;
		}else{
			if ( true == pWK7Skill->UseAbilityTest(WK7PLAYERCONTROL->GetMainID(), SKILLABILITY_HEADLOCKON) ){
				searchPoint = BUI_DIREGET_ID_HEAD;
			}else{
				searchPoint = BUI_DIREGET_ID_JOINT;
			}
		}
		// XLɃI[gbNudq
		// I[gbNIi_jI[gbNIiljI[gbNIij ̏
		{
			if ( snapTime == snapTimeMAX ){				// XLꂽuԂ̓RɂȂ
				ret = BuiDirGet(&eneRot, mSight.worldPos, searchPoint, 0, true);
				if ( ret == true ){
					gpSound->mPlaySE( SFX_BT_ZOOM_OUT,	//SEԍ
							  SOUND_SYSTEM_SE_VOLUME,	//
							  SOUND_PAN_CENTER,			//p
							  eSETrackBattleOverlap,	//gbN
							  eSEGroupBattle00 );		//O[v
					snapTime--;
				}
				if ( snapTime == snapTimeMAX ){
					snapTime = 0;
				}
			}else{
				if ( 0 < snapTime ){
					ret = BuiDirGet(&eneRot, mSight.worldPos, searchPoint, 0);
					if ( ret == true ){
						if ( (mSight.padMov.y == 0.f) && (mSight.padMov.x == 0.f) ){
							snapTime--;
						}else{
							snapTime = 0;
						}
						
						NowRotY = eneRot.y;
						NowRotX = eneRot.x;
						NotKanseiFlag = false;
//						BuiLockOn = true;
					}
				}
			}
		}
	}
	
	// SҗpA\L[bNI
//	if ( (false == BuiLockOn) && (false == AutoLockOn) ){
		if ( (PAD_BUTTON_UP|PAD_BUTTON_DOWN|PAD_BUTTON_LEFT|PAD_BUTTON_RIGHT) & HSD_PadGetTrigger(0) ){
			easySnapTime = easySnapTimeMAX;
			for(chk=mEasyLockOnNum, i=0; i<ONE_AREA_MAXENEMY; i++){
				ret = BuiDirGet(&eneRot, mSight.worldPos, -1, chk, true);
				if ( ( ret == true ) && (easySnapTime == easySnapTimeMAX) ){
					easyLockProc = true;
					break;
				}
				chk++;
				if ( chk >= ONE_AREA_MAXENEMY ) chk = 0;
			}
			mEasyLockOnNum = (s16 )(chk+1);
			if ( mEasyLockOnNum >= ONE_AREA_MAXENEMY ) mEasyLockOnNum = 0;
			
			if ( easyLockProc == true ){
				gpSound->mPlaySE( SFX_BT_ZOOM_OUT,			//SEԍ
						  SOUND_SYSTEM_SE_VOLUME,	//
						  SOUND_PAN_CENTER,			//p
						  eSETrackBattleOverlap,	//gbN
						  eSEGroupBattle00 );		//O[v
				
				NowRotY = eneRot.y;
				NowRotX = eneRot.x;
				NotKanseiFlag = false;
			}else{
				easySnapTime = 0;
			}
		}else{
			int setNum = mEasyLockOnNum - 1;
			if ( setNum >= 0 ) {
				if ( 0 < easySnapTime ){
					ret = BuiDirGet(&eneRot, mSight.worldPos, -1, setNum, true);
					if ( ret == true ){
						if ( (mSight.padMov.y == 0.f) && (mSight.padMov.x == 0.f) ){
							easySnapTime--;
						}else{
							easySnapTime = 0;
						}
						
						NowRotY = eneRot.y;
						NowRotX = eneRot.x;
						NotKanseiFlag = false;
					}
				}
			}
		}
//	}
	
	
	// Y[C̊ԂA⊮ɂ
	// I[gbNI̊ԂA⊮ɂ
//	if ( true == GetCurrentZoomIn() ){
//		NotKanseiFlag = false;
//	}
	
	// Zbg
	SetCamRotY(NowRotY, NotKanseiFlag);
	SetCamRotX(NowRotX, NotKanseiFlag);
	
	// RpXɒl
	if ( GameInfo.GetSpOption() != NULL ) {
//		rotY = GameInfo.GetSpOption()->GetConpasRot();
//		rotY += mConpasInc;
//		GHM_LIMIT_RANGE(rotY, PI, -PI);
		GameInfo.GetSpOption()->SetConpasRot(NowRotY);
	}
}







/*
	
	
	ʕ擾
	
	<return>
	true			I[gbN
	false			ĂȂ
	searchPoint		-1F\L[bNȈꍇ
					-2FabNȈꍇ
	
*/
bool KK7BattleMainTask::BuiDirGet(Vec *pRot, Vec SightPos, int searchPoint, int startEneNo, bool first)
{
	WK7Npc *pNpcTarget;
	Vec pos, tPos, footPosL, footPosR, rot;
	f32 dist1, dist2, tmp, okDist;

	pNpcTarget = mSortNpc[startEneNo].mpSortNpc;
	if ( first == true ){							// VKT[`
		pAutoLockTarget	= pNpcTarget;
	}else{											// T[`Ă̂g
		if ( pNpcTarget != pAutoLockTarget ){		// ŏ̃^[QbgƈႤGɂȂĂ܂AȂɂ
			pNpcTarget = NULL;
		}
	}
	if ( NULL == pNpcTarget ){						// ΏۂȂ
		return false;
	}
	
	// {Xɂ͖
	if ( pNpcTarget->GetID() >= K7ENM_ANG ) return false;
	
	// ꍇ͖
	if ( (-1 == searchPoint) || (-2 == searchPoint) ){
		if ((K7KED == WK7PLAYERCONTROL->GetMainID())
		||	(K7HAC == WK7PLAYERCONTROL->GetMainID())
		) {
			okDist = BJYUU_AUTOLOCKON_OKDIST_KED;
		}else{
			if ((K7GAL == WK7PLAYERCONTROL->GetMainID())
			&&	(KK7BATTLECTRL_GALLV_UP == BattleCtrl.GetGalPowerUp())
			) {
				okDist = BJYUU_AUTOLOCKON_OKDIST_GALPOWER;
			}else{
				okDist = BJYUU_AUTOLOCKON_OKDIST;
			}
		}
	}else{
		if ((K7KED == WK7PLAYERCONTROL->GetMainID())
		||	(K7HAC == WK7PLAYERCONTROL->GetMainID())
		) {
			okDist = AUTOLOCKON_OKDIST_KED;
		}else{
			okDist = AUTOLOCKON_OKDIST;
		}
	}
	if ( mSortNpc[startEneNo].dist >= okDist ) return false;
	
	// Go
	pos = BattleCamera.pos[NOW];
	
	switch (searchPoint){
	case -1:
	case -2:
		if ( false == pNpcTarget->GetWeakPosition(&tPos, NPCWEAKOBJID_WAIST) ) return false;
		break;
	case BUI_DIREGET_ID_WEAK:
		if ( false == pNpcTarget->GetWeakPosition(&tPos) ) return false;
		break;
	case BUI_DIREGET_ID_HEAD:
		if ( false == pNpcTarget->GetWeakPosition(&tPos, NPCWEAKOBJID_HEAD) ) return false;
		break;
	case BUI_DIREGET_ID_JOINT:
		if ( false == pNpcTarget->GetWeakPosition(&footPosR, NPCWEAKOBJID_RFOOT) ) return false;
		if ( false == pNpcTarget->GetWeakPosition(&footPosL, NPCWEAKOBJID_LFOOT) ) return false;
		
		dist1 = GHM_VEC_GET_DIST(&SightPos, &footPosR);
		dist2 = GHM_VEC_GET_DIST(&SightPos, &footPosL);
		if ( dist1 < dist2 ){
			tPos = footPosR;
		}else{
			tPos = footPosL;
		}
		break;
	}
	
	{
		Vec tgt = tPos;
		rot.y = atan2f(tgt.x - pos.x, tgt.z - pos.z);
		rot.x = atan2f(	tgt.y - pos.y,
									sqrtf((tgt.x-pos.x)*(tgt.x-pos.x)+(tgt.z-pos.z)*(tgt.z-pos.z))
									);
		rot.z = 0.f;
	}
	
	{
		f32 okRot;
		if ( -2 == searchPoint ){					// abNI
			okRot = PI;
		}else{
			if ( true == K7SCR_GET_GLOBAL_FLAG( K7GLFL_EASY_MODE) ){
				if ( -1 == searchPoint ){			// \L[bNI
					okRot = PI/2.f;
				}else{								// ʃbNI
					okRot = pWK7Skill->GetPc_SightSpeed() * AUTOLOCKON_OKDIREC_RATE;
				}
			}else{
				if ( -1 == searchPoint ){			// \L[bNI
					okRot = PI/2.f;
				}else{								// ʃbNI
					okRot = pWK7Skill->GetPc_SightSpeed() * AUTOLOCKON_OKDIREC_RATE;
				}
			}
		}
		
		if ( (-1 == searchPoint) || (-2 == searchPoint) ){
			tmp = rot.y - BattleCamera.rot[TARGET].y;
			GHM_LIMIT_RANGE(tmp, PI, -PI);
			if ( fabsf(tmp) > okRot ) return false;
		}else{
			tmp = rot.x - BattleCamera.rot[TARGET].x;
			GHM_LIMIT_RANGE(tmp, PI, -PI);
			if ( fabsf(tmp) > okRot ) return false;
			tmp = rot.y - BattleCamera.rot[TARGET].y;
			GHM_LIMIT_RANGE(tmp, PI, -PI);
			if ( fabsf(tmp) > okRot ) return false;
		}
	}
	
	pRot->x = rot.x;
	pRot->y = rot.y;
	pRot->z = rot.z;
	
	return true;
}






/*
	
	
	TCgˌ\ǂݒ肷
	
	
*/
bool KK7BattleMainTask::SightShotModeSet(bool flag)
{
	u8 flag8 = 0;
	WK7Chara *pChara = WK7PLAYERCONTROL->GetCharaPtr();

	if ( mSightEnable != flag ){
		if ( flag == false ){					// ᇂ̕\
			WK7Npc::HideTumorAll();
		}else{
			WK7Npc::DispTumorAll();
		}
	}
	mSightEnable = flag;
	if ((NULL != pChara)
	&&	(true == pChara->IsValidEffect(mpSightRenderEfc))
	){
		if ( true == flag ) flag8 = 1;
		SetSightLineDrawFlag( mpSightRenderEfc->GetEffect(), flag8 );
		return true;
	}
	return false;
}
bool KK7BattleMainTask::GetSightShotMode(void)
{
	return mSightEnable;
}


/*
	
	
	og^XNɌ݂̎ceύX`
	
	
*/
bool KK7BattleMainTask::NowBalletSet(s16 bullet)
{
	WK7Chara *pChara = WK7PLAYERCONTROL->GetCharaPtr();
	
	if ((NULL != pChara)
	&&	(true == pChara->IsValidEffect(mpSightRenderEfc))
	){
		SetSightShotNum(mpSightRenderEfc->GetEffect(), (u8 )bullet);
		return true;
	}
	return false;
}


/*
	
	
	og[h𔲂邩ǂ̃`FbN
	
	<return>
	true			EXIT OK
	false			
	
*/
bool KK7BattleMainTask::BattleModeExitTest(void)
{
	if ( true == WK7PLAYERCONTROL->GetFightTest() ){
		return false;
	}else{
		return true;
	}
}

/*	
	
	|WV
	
*/
void KK7BattleMainTask::SetPosition(Vec *pPos, bool flag)
{
	BattleCamera.pos[TARGET].x = pPos->x;
	BattleCamera.pos[TARGET].y = pPos->y;
	BattleCamera.pos[TARGET].z = pPos->z;
	if (flag) {
		BattleCamera.pos[NOW].x = pPos->x;
		BattleCamera.pos[NOW].y = pPos->y;
		BattleCamera.pos[NOW].z = pPos->z;
	}
}
Vec *KK7BattleMainTask::GetPosition(void)
{
	return BattleCamera.pos;
}
void KK7BattleMainTask::SetBasePosition(Vec *pPos)
{
	mSight.saveMyPos.x = pPos->x;
	mSight.saveMyPos.y = pPos->y;
	mSight.saveMyPos.z = pPos->z;
}

/*
	
	px
	
*/
void KK7BattleMainTask::SetCamRotY(f32 rot, bool flag)
{
	BattleCamera.rot[TARGET].y = rot;
	if (flag) BattleCamera.rot[NOW].y = rot;
//	mSight.camRot.y = rot;
}
void KK7BattleMainTask::SetCamRotX(f32 rot, bool flag)
{
	BattleCamera.rot[TARGET].x = rot;
	if (flag) BattleCamera.rot[NOW].x = rot;
//	mSight.camRot.x = rot;
}
void KK7BattleMainTask::SetBaseCamRotY(f32 rot)
{
	SetCamRotY(rot, true);
}

f32 KK7BattleMainTask::GetCamRotY(void)
{
	return BattleCamera.rot[NOW].y;
//	return mSight.camRot.y;
}
f32 KK7BattleMainTask::GetCamRotX(void)
{
	return BattleCamera.rot[NOW].x;
//	return mSight.camRot.x;
}

void KK7BattleMainTask::SetSightRotY(f32 rot)
{
	mSight.sightRot.y = rot;
}
void KK7BattleMainTask::SetSightRotX(f32 rot)
{
	mSight.sightRot.x = rot;
}
f32 KK7BattleMainTask::GetSightRotY(void)
{
	return mSight.sightRot.y;
}
f32 KK7BattleMainTask::GetSightRotX(void)
{
	return mSight.sightRot.x;
}

void KK7BattleMainTask::SetZoomRotY(f32 rot)
{
	mSight.zoomRot.y = rot;
}
void KK7BattleMainTask::SetZoomRotX(f32 rot)
{
	mSight.zoomRot.x = rot;
}
f32 KK7BattleMainTask::GetZoomRotY(bool decOK)
{
	f32 tmp = mSight.zoomRot.y;
	f32 backfugou = 0.f;
	
	if ( SIGHT_ZOOM_SPEED_FRAME > 0.f ){
		
		if ( mSight.zoomRot.y > 0.f ){
			backfugou = +1.f;
		}else{
			backfugou = -1.f;
		}
		
		tmp = (mSight.zoomRot.y) / SIGHT_ZOOM_SPEED_FRAME;
		if ( decOK ){
			mSight.zoomRot.y -= tmp;
		}
		
		// ]H
		if ( (mSight.zoomRot.y < 0.f) && (backfugou > 0.f) ){
			mSight.zoomRot.y = 0.f;
			tmp = mSight.zoomRot.y;
		}
		if ( (mSight.zoomRot.y > 0.f) && (backfugou < 0.f) ){
			mSight.zoomRot.y = 0.f;
			tmp = mSight.zoomRot.y;
		}
	}
	return tmp;
}
f32 KK7BattleMainTask::GetZoomRotX(bool decOK)
{
	f32 tmp = mSight.zoomRot.x;
	f32 backfugou = 0.f;
	
	if ( SIGHT_ZOOM_SPEED_FRAME > 0.f ){
		
		if ( mSight.zoomRot.x > 0.f ){
			backfugou = +1.f;
		}else{
			backfugou = -1.f;
		}
		
		tmp = (mSight.zoomRot.x) / SIGHT_ZOOM_SPEED_FRAME;
		if ( decOK ){
			mSight.zoomRot.x -= tmp;
		}
		
		// ]H
		if ( (mSight.zoomRot.x < 0.f) && (backfugou > 0.f) ){
			mSight.zoomRot.x = 0.f;
			tmp = mSight.zoomRot.x;
		}
		if ( (mSight.zoomRot.x > 0.f) && (backfugou < 0.f) ){
			mSight.zoomRot.x = 0.f;
			tmp = mSight.zoomRot.x;
		}
	}
	return tmp;
}

/*
	
	Jp{TCgp
	
*/
f32 KK7BattleMainTask::GetRotY(void)
{
	f32 roty = GetSightRotY();

	roty += GetCamRotY();
	GHM_LIMIT_RANGE(roty, PI,-PI);
	return roty;
}
f32 KK7BattleMainTask::GetRotX(void)
{
	f32 rotx = GetSightRotY();

	rotx += GetCamRotY();
	GHM_LIMIT_RANGE(rotx, PI,-PI);
	return rotx;
}



/*
	
	
	LN^̃Jw̃~bgeXg
	
	
*/
f32 KK7BattleMainTask::RotXLimitTest(f32 camRotX)
{
	GHM_LIMIT(camRotX, CAM_ROTX_LIMIT, -CAM_ROTX_LIMIT);
	return camRotX;
}

/*
	
	
	og̃Z[u|WV擾
	
	
*/
Vec *KK7BattleMainTask::pGetSaveMyPos(void)
{
	return &(mSight.saveMyPos);
}

/*
	
	
	ogTCgɂԋ߂G擾
	
	
*/
WK7Npc *KK7BattleMainTask::GetNearNpc(int id)
{
	return mSortNpc[id].mpSortNpc;
}

/*
	
	
	ogTCgɂԋ߂G̋擾
	
	
*/
f32 KK7BattleMainTask::GetNearNpcDist(int id)
{
	return mSortNpc[id].dist;
}

/*
	
	
	ogTCgɂԋ߂G̕ǔ擾
	
	
*/
s16 KK7BattleMainTask::GetNearNpcKabeFlag(int id)
{
	return mSortNpc[id].kabeFlag;
}


/*
	
	
	\̂x̍擾
	
	
*/
f32 KK7BattleMainTask::GetKamaeY(u32 mainID)
{
	if ((WK7PLAYERCONTROL->GetMainID() == K7MSK)
	&&	(KK7BATTLECTRL_MSKLV_TEKKAMEN == BattleCtrl.GetMskPowerUp())
	){
		return CharaPosArmMSK.High;
	}else{
		return CharaPosArm[mainID].High;
	}
}


/*
	
	
	}XNOl[hṕAG̃qbg莚̍W擾
	
	
*/
void KK7BattleMainTask::GetEnemyPositionforMskHitTest(WK7Npc *pNpc, Vec *pPos)
{
	switch (pNpc->GetEneType()){
	default:
		pNpc->GetPosition(*pPos);
		break;
	case K7ENM_AK2:
	case K7ENM_HNG:
		pNpc->GetWaistPosition(pPos);
		break;
	}
}


/*
	
	
	I[gbÑ`[Ws
	
	I[gbNI\ɂ
	
*/
void KK7BattleMainTask::AutoLockOnReCharge(void)
{
	snapTime = snapTimeMAX;
	snapSePlay = 1;
}

EFFECT *KK7BattleMainTask::pGetYamadaSight(void)
{
	WK7Chara *pChara = WK7PLAYERCONTROL->GetCharaPtr();
	
	if ((NULL != pChara)
	&&	(true == pChara->IsValidEffect(mpSightRenderEfc))
	){
		return mpSightRenderEfc->GetEffect();
	}
	
	return (EFFECT *)NULL;
}
/*
	
	 abNIԂǂH
	 
*/
bool GetBLockOn(void)
{
	if ( autoSnapTime ){
		return true;
	}
	return false;
}
/*
	
	 \bNIԂǂH
	 
*/
bool GetJyujiLockOn(void)
{
	if ( easySnapTime ){
		return true;
	}
	return false;
}
