////////////////////////////////////////////////////////////////////////////////
//
// GrassHopperManufacture GameCube List
//
// ghmGcList.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/09/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__GHMGCLIST_H__
#define	__GHMGCLIST_H__

#define	GHMGCLIST_ANCHOR_PRIO			(-1)
#define	GHMGCLIST_DEFAULT_PRIO			(256)

//
// List Object
//
// anchorpprioGHMGCLIST_ANCHOR_PRIOō쐬
//
class ghmGcListObj{
private:
	ghmGcListObj					*mpPrev;
	ghmGcListObj					*mpNext;
	int								mPriority;
	bool LinkPrevToNext(void);
public:
	ghmGcListObj();												// AJ[쐬p
	ghmGcListObj(ghmGcListObj *pAnchor,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~ghmGcListObj();
	
	virtual bool ChangePriority(int prio);
	inline int GetPriority(void){ return mPriority; }
	
	// 
	virtual bool Initialize(void){ return true; }
	
	// I
	virtual bool Terminate(void){ return true; }
	
	// XgɎQ
	virtual bool Join(ghmGcListObj *pAnchor,int prio);
	// Xg폜
	virtual bool Remove(void);
	
	ghmGcListObj* GetPrev(void){ return mpPrev; }
	ghmGcListObj* GetNext(void){ return mpNext; }
	
	int GetIndex(void);
	int GetIndexFromLast(void);
};

#include "ghmGcMem.h"

#endif	//__GHMGCLIST_H__

