////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Title Task
//
// MK7TitleTask.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 02/03/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7TITLETASK_CPP__

//---- include ----
#include "..\wat\WK7MenuTask.h"
#include "..\wat\WK7Sight.h"
#include "..\wat\K7GlobalFlag.h"

#include "..\sato\SK7ScenarioTask.h"			//	ύX@09/03
#include "..\sato\SK7LoadTask.h"
#include "..\sato\SK7OptionTask.h"

#include "..\\Kaw\KK7BattleMainTask.h"

#include "MK7TitleTask.h"
#include "mK7Sound.h"

//---- define ----
#define	TITLE_TEX				"Texture/title.pak"
#define	TITLE_FADEIN_WAIT_TICK	(2400)	//(2400)
#define	TITLE_FADEIN_TICK		(3520)	//(3824)(3600)
#define	TITLE_FADEOUT_TICK		(10000)	//(7200)
#define	TITLE_LAST_FADE			(1200)	//ŌKiller7SƑIꂽȊOtF[hAEg鎞(Ptick)
#define	TITLE_ALPHA_MAX			(255)

//^Cg֌W
#define	SPRT_PRI_TITLE_DIFFICULT	(8)		//ՓxI𕶎
#define	SPRT_PRI_TITLE_LOGO			(10)	//^CgS
#define	SPRT_PRI_TITLE_BLAR			(20)	//^Cgʂ̂ڂ₯
#define	SPRT_PRI_TITLE_LOGO_LINEBOX	(21)	//^CgS&
#define	SPRT_PRI_TITLE_FONT_SHADOW	(25)	//^Cgʂ̉̕e
#define	SPRT_PRI_TITLE_FONT			(30)	//^Cgʂ̕
#define	SPRT_PRI_TITLE_FONTSEL		(40)	//^Cgʂ̂Ԃ镶

#define	TITLE_SEL_NEW			(1<<0)	// NEW GAME ItO
#define	TITLE_SEL_CON			(1<<1)	// CONTINUE ItO
#define	TITLE_SEL_OPT			(1<<2)	// OPTION ItO
#define	TITLE_SEL_K7			(1<<3)	// Killer7 ItO
#define	TITLE_SEL_K1			(1<<4)	// Killer1 ItO
#define	TITLE_SEL_H7			(1<<5)	// Hopper7 ItO

#define	TITLE_FONT_SPACE_W		(16)

//Ԃ̐Fݒ
#define	TITLE_SEL_COLOR_R		(232)
#define	TITLE_SEL_COLOR_G		(16)
#define	TITLE_SEL_COLOR_B		(8)
#define	TITLE_SEL_RGBA			((u32)((TITLE_SEL_COLOR_R<<24)|(TITLE_SEL_COLOR_G<<16)|(TITLE_SEL_COLOR_B<<8)|255))
#define	TITLE_NOTSEL_COLOR_R	(220)
#define	TITLE_NOTSEL_COLOR_G	(232)
#define	TITLE_NOTSEL_COLOR_B	(255)
#define	TITLE_NOTSEL_RGBA		((u32)((TITLE_NOTSEL_COLOR_R<<24)|(TITLE_NOTSEL_COLOR_G<<16)|(TITLE_NOTSEL_COLOR_B<<8)|255))
#define	TITLE_CANT_COLOR_R		(232)
#define	TITLE_CANT_COLOR_G		(110)
#define	TITLE_CANT_COLOR_B		(173)
#define	TITLE_CANTCHOOSE_RGBA	((u32)((TITLE_CANT_COLOR_R<<24)|(TITLE_CANT_COLOR_G<<16)|(TITLE_CANT_COLOR_B<<8)|255))
#define	TITLE_SHADOW_COLOR_R	(83)
#define	TITLE_SHADOW_COLOR_G	(4)
#define	TITLE_SHADOW_COLOR_B	(2)
#define	TITLE_SHADOW_RGBA		((u32)((TITLE_SHADOW_COLOR_R<<24)|(TITLE_SHADOW_COLOR_G<<16)|(TITLE_SHADOW_COLOR_B<<8)|255))
//F̐Fݒ
#define	TITLE1_SEL_COLOR_R		(255)
#define	TITLE1_SEL_COLOR_G		(255)
#define	TITLE1_SEL_COLOR_B		(0)
#define	TITLE1_SEL_RGBA			((u32)((TITLE1_SEL_COLOR_R<<24)|(TITLE1_SEL_COLOR_G<<16)|(TITLE1_SEL_COLOR_B<<8)|255))
#define	TITLE1_NOTSEL_COLOR_R	(220)
#define	TITLE1_NOTSEL_COLOR_G	(232)
#define	TITLE1_NOTSEL_COLOR_B	(255)
#define	TITLE1_NOTSEL_RGBA		((u32)((TITLE1_NOTSEL_COLOR_R<<24)|(TITLE1_NOTSEL_COLOR_G<<16)|(TITLE1_NOTSEL_COLOR_B<<8)|255))
#define	TITLE1_CANT_COLOR_R		(241)
#define	TITLE1_CANT_COLOR_G		(233)
#define	TITLE1_CANT_COLOR_B		(131)
#define	TITLE1_CANTCHOOSE_RGBA	((u32)((TITLE1_CANT_COLOR_R<<24)|(TITLE1_CANT_COLOR_G<<16)|(TITLE1_CANT_COLOR_B<<8)|255))
#define	TITLE1_SHADOW_COLOR_R	(99)
#define	TITLE1_SHADOW_COLOR_G	(110)
#define	TITLE1_SHADOW_COLOR_B	(17)
#define	TITLE1_SHADOW_RGBA		((u32)((TITLE1_SHADOW_COLOR_R<<24)|(TITLE1_SHADOW_COLOR_G<<16)|(TITLE1_SHADOW_COLOR_B<<8)|255))
//ΐF̐̕Fݒ
#define	TITLE2_SEL_COLOR_R		(150)
#define	TITLE2_SEL_COLOR_G		(255)
#define	TITLE2_SEL_COLOR_B		(0)
#define	TITLE2_SEL_RGBA			((u32)((TITLE2_SEL_COLOR_R<<24)|(TITLE2_SEL_COLOR_G<<16)|(TITLE2_SEL_COLOR_B<<8)|255))
#define	TITLE2_NOTSEL_COLOR_R	(220)
#define	TITLE2_NOTSEL_COLOR_G	(232)
#define	TITLE2_NOTSEL_COLOR_B	(255)
#define	TITLE2_NOTSEL_RGBA		((u32)((TITLE2_NOTSEL_COLOR_R<<24)|(TITLE2_NOTSEL_COLOR_G<<16)|(TITLE2_NOTSEL_COLOR_B<<8)|255))
#define	TITLE2_CANT_COLOR_R		(241)
#define	TITLE2_CANT_COLOR_G		(233)
#define	TITLE2_CANT_COLOR_B		(131)
#define	TITLE2_CANTCHOOSE_RGBA	((u32)((TITLE2_CANT_COLOR_R<<24)|(TITLE2_CANT_COLOR_G<<16)|(TITLE2_CANT_COLOR_B<<8)|255))
#define	TITLE2_SHADOW_COLOR_R	(40)
#define	TITLE2_SHADOW_COLOR_G	(70)
#define	TITLE2_SHADOW_COLOR_B	(0)
#define	TITLE2_SHADOW_RGBA		((u32)((TITLE2_SHADOW_COLOR_R<<24)|(TITLE2_SHADOW_COLOR_G<<16)|(TITLE2_SHADOW_COLOR_B<<8)|255))
//
#define	TITLE_COLOR_R_KAN		(30)
#define	TITLE_COLOR_G_KAN		(30)
#define	TITLE_COLOR_B_KAN		(110)
#define	TITLE_RGB_KAN			((u32)((TITLE_COLOR_R_KAN<<24)|(TITLE_COLOR_G_KAN<<16)|(TITLE_COLOR_B_KAN<<8)|0))
//
#define	TITLE_COLOR_R_SHI		(80)
#define	TITLE_COLOR_G_SHI		(0)
#define	TITLE_COLOR_B_SHI		(100)
#define	TITLE_RGB_SHI			((u32)((TITLE_COLOR_R_SHI<<24)|(TITLE_COLOR_G_SHI<<16)|(TITLE_COLOR_B_SHI<<8)|0))
//
#define	TITLE_COLOR_R_KET		(120)
#define	TITLE_COLOR_G_KET		(10)
#define	TITLE_COLOR_B_KET		(10)
#define	TITLE_RGB_KET			((u32)((TITLE_COLOR_R_KET<<24)|(TITLE_COLOR_G_KET<<16)|(TITLE_COLOR_B_KET<<8)|0))
//囓
#define	TITLE_COLOR_R_BAT		(120)
#define	TITLE_COLOR_G_BAT		(255)
#define	TITLE_COLOR_B_BAT		(10)
#define	TITLE_RGB_BAT			((u32)((TITLE_COLOR_R_BAT<<24)|(TITLE_COLOR_G_BAT<<16)|(TITLE_COLOR_B_BAT<<8)|0))
//ՓxI
#define	TITLE_COLOR_R_EXP		(120)
#define	TITLE_COLOR_G_EXP		(10)
#define	TITLE_COLOR_B_EXP		(10)
#define	TITLE_RGB_EXP			((u32)((TITLE_COLOR_R_EXP<<24)|(TITLE_COLOR_G_EXP<<16)|(TITLE_COLOR_B_EXP<<8)|0))
//
#define	TITLE_RGB_WHITE			(0xffffff00)

#define	TITLE_STRING_X			(64)	//j[̕\XW

#define	TITLE_PRE_X				(TITLE_STRING_X)	//\xW
#define	TITLE_PRE_Y				(360)				//\yW
#define	TITLE_PRE_STR			"PRESS START"

#define	TITLE_NEW_X				(TITLE_STRING_X)	//\xW
#define	TITLE_NEW_Y				(300)				//\yW
#define	TITLE_NEW_STR			"NEW GAME"
#define	TITLE_CON_X				(TITLE_STRING_X)	//\xW
#define	TITLE_CON_Y				(330)				//\yW
#define	TITLE_CON_STR			"CONTINUE"
#define	TITLE_OPT_X				(TITLE_STRING_X)	//\xW
#define	TITLE_OPT_Y				(360)				//\yW
#define	TITLE_OPT_STR			"OPTION"

#define	TITLE_K7_X				(TITLE_STRING_X)	//\xW
#define	TITLE_K7_Y				(300)				//\yW
#define	TITLE_K7_STR			"KILLER7"
#define	TITLE_K1_X				(TITLE_STRING_X)	//\xW
#define	TITLE_K1_Y				(330)				//\yW
#define	TITLE_K1_STR			"KILLER8"
#define	TITLE_H7_X				(TITLE_STRING_X)	//\xW
#define	TITLE_H7_Y				(360)				//\yW
#define	TITLE_H7_STR			"HOPPER7"

#define	TITLE_STR_BLAR_W		(32)	//̗hꕝ
#define	TITLE_STR_FADEOUT_TICK	(2400)	//Iꂽ̃tF[hAEg
#define	TITLE_VOICE_PLAY_TICK	(4800)	//΂Đ鎞

#define	TITLE_CLOSERATE			(0.3f)					//ɋl߂銄
#define	TITLE_CLOSE_RATE		(1.0f-TITLE_CLOSERATE)	//ɋl߂銄
#define	TITLE_CLOSE_TICK		(1200)	//j[lɂ鎞
#define	TITLE_SPREAD_TICK		(800)	//j[L̂ɂ鎞

#define	TITLE_SHADOW_DROP_TICK	(4800)	//j[̗
#define	TITLE_SHADOW_MIN_SCALE	(200)	//ŏcg嗦
#define	TITLE_SHADOW_MAX_SCALE	(350)	//őcg嗦

#define	TITLE_LINE_RGBA				(0xA0000000)	//C̐FE[ Killer7
#define	TITLE_LINE_RGBA1			(0xA0A00000)	//C̐FE[ Killer8
#define	TITLE_LINE_RGBA2			(0x80A00000)	//C̐FE[ Hopper7
#define	TITLE_LINE_RGBA_END			(0x00000000)	//C̐FE[
#define	TITLE_LINE_ALPHA			(0x50)			//C̐FEl
#define	TITLE_LINE_MOVE_MIN_TICK	(4800)			//CړɂŒ᎞
#define	TITLE_LINE_MOVE_MAX_TICK	(4800*10)		//Cړɂō
#define	TITLE_LINE_WIDTH			(32)			//pCő啝
#define	TITLE_LINE_ANGLE_OFFSET		(20)			//cCW킹̃ItZbgl
#define	TITLE_LINE_ANGLE			(-108)			//cČX -101
#define	TITLE_LINE_DISP_WAIT		(2400)			//\܂ł̊{EGCg
#define	TITLE_LINE_DISP_TICK		(4800*15)		//GtFNg\鎞 *7
#define	TITLE_LINE_FADEIN_TICK		(4800*3)		//tF[hC鎞
#define	TITLE_LINE_FADEOUT_TICK		(4800*3)		//tF[hAEg鎞
#define	TITLE_LINE_INIT_SPEED		(4800)			//C̏x
#define	TITLE_LINE_TERM_SPEED		(400)			//C̏I[x
#define	TITLE_LINE_LENGTH_RATE		(4)				//C̒̂銄
#define	TITLE_LINE_SEVEN			(14)			//7̏cC̓Y͂̔ԍȍ~
#define	TITLE_LINE_SEVEN_ANGLE		(-218)			//7̏cČX
#define	TITLE_LINE_MOVE_WAIT		(4800*5)		//\܂ł̍ő҂

#define	TITLE_BOX_RGBA				(0xff000000)	//̐F Killer7
#define	TITLE_BOX_RGBA1				(0xffff0000)	//̐F Killer8
#define	TITLE_BOX_RGBA2				(0x96ff0000)	//̐F Hopper7
#define	TITLE_BOX_ALPHA				(0x50)			//̃l
#define	TITLE_BOX_DISP_WAIT			(9600)			//\܂ł̊{EGCg
#define	TITLE_BOX_DISP_TICK			(4800*3)		//GtFNg\鎞
#define	TITLE_BOX_FADEIN_TICK		(2400)			//tF[hC鎞
#define	TITLE_BOX_FADEOUT_TICK		(4800)			//GtFNgtF[hAEg鎞
#define	TITLE_BOX_OFFSET_RATE		(15)			//ĕ\m
#define	TITLE_BOX_OFFSET			(12)			//̕\W炷l

#define	TITLE_EFEECT_CANSEL_TICK	(4800)			//GtFNgɃ{^ăLZꍇ̃GtFNgtF[hAEg

#define	TITLE_SSM_FILE				"seTitle.ssm"	//^CgʂŎgSEg`t@C
#define	TITLE_LINE_SE_MIN_PITCH		(-1800)			//CSEĐۂ̍Œsb`
#define	TITLE_LINE_SE_MAX_PITCH		(600)			//CSEĐۂ̍ōsb`
#define	TITLE_LINE_SE_FADE_SPEED	(100)			//CSEtF[hAEg鑬x 1b=200

#define	TITLE_LOOP_FADE_TICK		(4800)			//[vÕtF[hAEgɂ鎞
#ifdef	_DEBUG
//#define	TITLE_LOOP_TICK				(4800*5)		//^Cgʂ̃[v
#define	TITLE_LOOP_TICK				(4800*30)		//^Cgʂ̃[v
#else
#define	TITLE_LOOP_TICK				(4800*30)		//^Cgʂ̃[v
#endif

#define	TITILE_A100					(255*100/100)	//At@100%
#define	TITILE_A90					(255*90/100)	//At@90%
#define	TITILE_A60					(255*60/100)	//At@60%
#define	TITILE_A50					(255*50/100)	//At@50%
#define	TITILE_A40					(255*40/100)	//At@40%
#define	TITILE_A25					(255*25/100)	//At@25%
#define	TITLE_DIFF_FADE_OUT_TICK	(9600)			//ՓxItF[hAEg

#define	TITILE_KANTOU_HPS			HPS_NANIDO1		//pHPS
#define	TITILE_SHITOU_HPS			HPS_NANIDO2		//pHPS
#define	TITILE_KETTOU_HPS			HPS_NANIDO3		//pHPS
#define	TITILE_BATTOU_HPS			HPS_MONBANKMIX	//囓pHPS

bool	gTitleGoContinue     = false;	//ReBj[ʂ֓
bool	gTitleGoOption       = false;	//IvVʂ֓
bool	gTitleRetFromSSelect = false;	//ViII߂Ă




//---- enum ----
enum{
	eTitleFontDat = 0,
	eTitleKiller7,
	eTitleKiller7Blar,
	eTitleKiller1,
	eTitleKiller1Blar,
	eTitleNanido,
	eTitleKanjiGeki,
	eTitleKanjiTouA,
	eTitleColonA,
	eTitleTextA01,
	eTitleTextA02,
	eTitleKanjiShi,
	eTitleKanjiTouB,
	eTitleColonB,
	eTitleTextB01,
	eTitleTextB02,
	eTitleKanjiTi,
	eTitleTextC,
	eTitleHopper7,
	eTitleHopper7Blar,
	eTitleKanjiBat,
	eTitleTextD,
};

//---- struct ----

//---- O[oϐ ----
s16	gTblLineX[TITLE_LOGO_X_LINE_MAX] = { 88, 111, 145, 164, 168, 188, 192, 212, 217, 235, 242, 262, 266, 286, 310, 364, 400 };
s16	gTblLineY[TITLE_LOGO_Y_LINE_MAX] = { 58, 73, 88, 98, 106, 113, 123, 129, 145, 154, 240 };
//                  K                                                                     i                             l                                            l                                            e                                                                               r                                                           7
s16	gTblBoxX0[] = {  88,  85,  83,  81,  79,  77,  73, 122, 117, 112, 107, 105, 106, 107, 144, 140, 138, 136, 135, 132, 174, 171, 168, 165, 164, 162, 160, 159, 156, 199, 195, 192, 190, 188, 187, 185, 183, 180, 216, 214, 212, 210, 208, 207, 204, 236, 230, 223, 243, 240, 239, 237, 233, 230, 266, 263, 262, 260, 258, 256, 253, 287, 284, 294, 291, 290, 317, 314, 311, 354, 351, 346, 343, 336, 332 };
s16	gTblBoxY0[] = {  88,  98, 106, 113, 123, 129, 145,  88,  98, 106, 113, 123, 129, 145,  88, 106, 113, 123, 129, 145,  58,  73,  88,  98, 106, 113, 123, 129, 145,  58,  73,  88,  98, 106, 113, 123, 129, 145,  88,  98, 106, 113, 123, 129, 145,  88, 113, 145,  88,  98, 106, 113, 129, 145,  88,  98, 106, 113, 123, 129, 145,  88,  98,  88,  98, 106,  73,  88,  98, 106, 113, 123, 129, 145, 154 };
s16	gTblBoxX1[] = { 112, 109, 107, 106, 103, 102,  98, 144, 140, 133, 128, 126, 127, 130, 165, 161, 159, 157, 156, 153, 196, 192, 189, 187, 185, 184, 182, 180, 177, 220, 216, 213, 211, 209, 208, 206, 204, 201, 236, 233, 232, 230, 228, 226, 223, 243, 237, 230, 263, 260, 259, 257, 253, 250, 287, 285, 283, 281, 279, 277, 274, 294, 291, 314, 311, 310, 408, 401, 396, 392, 389, 384, 381, 374, 369 };
s16	gTblBoxX2[] = {  86,  84,  82,  79,  78,  74,  71, 117, 112, 107, 105, 106, 106, 108, 142, 139, 137, 136, 132, 130, 171, 168, 166, 164, 163, 161, 159, 156, 154, 196, 193, 190, 189, 187, 185, 184, 180, 178, 214, 212, 211, 209, 208, 204, 202, 234, 228, 221, 241, 239, 238, 235, 230, 228, 264, 262, 261, 258, 257, 253, 251, 285, 283, 292, 290, 289, 310, 312, 310, 351, 347, 343, 336, 331, 290 };
s16	gTblBoxY2[] = {  98, 106, 113, 123, 129, 145, 154,  98, 106, 113, 123, 129, 145, 154,  98, 113, 123, 129, 145, 154,  73,  88,  98, 106, 113, 123, 129, 145, 154,  73,  88,  98, 106, 113, 123, 129, 145, 154,  98, 106, 113, 123, 129, 145, 154,  98, 123, 154,  98, 106, 113, 123, 145, 154,  98, 106, 113, 123, 129, 145, 154,  98, 106,  98, 106, 113,  88,  98, 106, 113, 123, 129, 145, 154, 240 };
s16	gTblBoxX3[] = { 110, 108, 106, 104, 102,  98,  96, 141, 133, 128, 126, 127, 130, 131, 163, 160, 158, 157, 153, 151, 193, 190, 187, 186, 184, 182, 181, 177, 175, 217, 214, 211, 210, 208, 206, 205, 201, 199, 234, 232, 231, 228, 227, 223, 221, 241, 235, 228, 261, 259, 258, 255, 250, 248, 285, 283, 282, 279, 278, 274, 272, 292, 290, 312, 310, 309, 401, 396, 393, 389, 384, 382, 374, 370, 328 };

#ifdef	_DEBUG
	static	bool gTitleOldSoundDebug;
#endif




//-----------------------------------------------------------------------------
//R[obN
//-----------------------------------------------------------------------------
bool
MK7TitleTask::InitializeCallBack(void)
{
	int	i;
	
	OSReport("MK7TitleTask Init : DefaultHeap = 0x%08x , TaskSize = 0x%08x\n",ghmGcMemGetFreeSize(),sizeof(*this));
	
#ifdef	_DEBUG
//	K7SCR_RESET_GLOBAL_FLAG( K7GLFL_GAME_CLEAR_K8 );
	gTitleOldSoundDebug = gpSound->mSetSoundDebug( false );
//	K7SCR_SET_GLOBAL_FLAG( K7GLFL_GAME_CLEAR );
//	K7SCR_SET_GLOBAL_FLAG( K7GLFL_GAME_CLEAR_K8 );
#endif
	//wiFɂ
	HSD_VISetClearClr((GXColor){0x00,0x00,0x00,0xff});
	
	//eNX`|C^
	mReslink      = NULL;
	mDat          = NULL;
	mFont.dat     = NULL;
	mTexLogo.tex  = NULL;
	mTexBlar.tex  = NULL;
	mTexLogo1.tex = NULL;
	mTexBlar1.tex = NULL;
	mTexLogo2.tex = NULL;
	mTexBlar2.tex = NULL;
	
	//̓f[^ƃXvCg|C^
	for( i = 0; i < TITLE_STRING_MAX; i++ )
	{
		mStr[i].str        = NULL;
		mStr[i].sprt       = NULL;
		mStr[i].sprtShadow = NULL;
		mStr[i].shadowProc = NULL;
	}
	mOrgX = NULL;
	mOrgY = NULL;
	
	//j[IvZX
	mTitleMenuProc = eTitleMenu;
	//j[I󋵏
	mTitleSel0 = eTitleSelNew;
	mTitleSel1 = eTitleSelKiller7;
	mTitleSel2 = eTitleSelDifficult0;
	//j[ItO
	mSelectFlag = TITLE_SEL_NEW | TITLE_SEL_OPT | TITLE_SEL_K7 | TITLE_SEL_K1 | TITLE_SEL_H7;
	//Z[uf[^΃ReBj[I\
	if( 1 )
	{
		mSelectFlag = mSelectFlag | TITLE_SEL_CON;
	}
	//VKtHg̃NGXgtO
	mFontRequest = true;
	
	//tF[h
	k7app.FadeStart( 0, 0, 1 );
	
	//SEzԍ
	for( i = 0; i < TITLE_LOGO_X_LINE_MAX; i++ )
		mLineXSENo[i] = -1;
	for( i = 0; i < TITLE_LOGO_Y_LINE_MAX; i++ )
		mLineYSENo[i] = -1;
	
	//ȍĐ
	gpSound->mPrepareStreamNo( HPS_TITLE_BACK );
	
	//g`t@Cǂݍ݊Jn
	gpSound->mReadSsm( TITLE_SSM_FILE, eBankBoss );
	
	//^Cgʂ̃[vԏ
	mLoopTime = TITLE_LOOP_TICK;
	
	//^CgʗpXg[Đ
	mTitleStreamPlay = false;
	
	//vZX
	mProc = eTitleReadData;
	
	//\^Cg̃XvCg|C^ݒ
	mpSprtLogo = &mSprtLogo;
	mpSprtBlar = &mSprtBlar;
	
	//̐F
	mRGBASel        = TITLE_SEL_RGBA;
	mRGBACantChoose = TITLE_CANTCHOOSE_RGBA;
	mRGBANotSel     = TITLE_NOTSEL_RGBA;
	mRGBAShadow     = TITLE_SHADOW_RGBA;
	
//	WK7Sight::Initialize();
	
	//ReBj[ʁAIvVʁAViIIʁA߂Ă
	if( (gTitleGoContinue == true) || (gTitleGoOption == true) || (gTitleRetFromSSelect == true) )
	{
		//ViIIʂ߂Ăꍇ
		if( gTitleRetFromSSelect == true )
		{
			mTitleSel0 = eTitleSelNew;
		}else
		//ReBj[ʂ߂Ăꍇ
		if( gTitleGoContinue == true )
		{
			mTitleSel0 = eTitleSelCon;
		}else
		//IvVʂ߂Ăꍇ
		{
			mTitleSel0 = eTitleSelOpt;
		}
		mTitleMenuProc = eTitleMenu0;
		if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1) == true )
		{
			mRGBASel        = TITLE1_SEL_RGBA;
			mRGBACantChoose = TITLE1_CANTCHOOSE_RGBA;
			mRGBANotSel     = TITLE1_NOTSEL_RGBA;
			mRGBAShadow     = TITLE1_SHADOW_RGBA;
			mTitleSel1      = eTitleSelKiller1;
			mpSprtLogo      = &mSprtLogo1;
			mpSprtBlar      = &mSprtBlar1;
		}else
		if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_HOPPER7) == true )
		{
			mRGBASel        = TITLE2_SEL_RGBA;
			mRGBACantChoose = TITLE2_CANTCHOOSE_RGBA;
			mRGBANotSel     = TITLE2_NOTSEL_RGBA;
			mRGBAShadow     = TITLE2_SHADOW_RGBA;
			mTitleSel1      = eTitleSelHopper7;
			mpSprtLogo      = &mSprtLogo2;
			mpSprtBlar      = &mSprtBlar2;
		}else
		{
			mRGBASel        = TITLE_SEL_RGBA;
			mRGBACantChoose = TITLE_CANTCHOOSE_RGBA;
			mRGBANotSel     = TITLE_NOTSEL_RGBA;
			mRGBAShadow     = TITLE_SHADOW_RGBA;
			mTitleSel1      = eTitleSelKiller7;
			mpSprtLogo      = &mSprtLogo;
			mpSprtBlar      = &mSprtBlar;
		}
	}else
	//I[h Killer7 or Killer8 or Hopper7
	{
		if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_GAME_CLEAR_K8) == true )
		{
			mRGBASel        = TITLE2_SEL_RGBA;
			mRGBACantChoose = TITLE2_CANTCHOOSE_RGBA;
			mRGBANotSel     = TITLE2_NOTSEL_RGBA;
			mRGBAShadow     = TITLE2_SHADOW_RGBA;
			mTitleSel1      = eTitleSelHopper7;
			mpSprtLogo      = &mSprtLogo2;
			mpSprtBlar      = &mSprtBlar2;
		}else
		if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_GAME_CLEAR) == true )
		{
			mRGBASel        = TITLE1_SEL_RGBA;
			mRGBACantChoose = TITLE1_CANTCHOOSE_RGBA;
			mRGBANotSel     = TITLE1_NOTSEL_RGBA;
			mRGBAShadow     = TITLE1_SHADOW_RGBA;
			mTitleSel1      = eTitleSelKiller1;
			mpSprtLogo      = &mSprtLogo1;
			mpSprtBlar      = &mSprtBlar1;
		}else
		{
			mRGBASel        = TITLE_SEL_RGBA;
			mRGBACantChoose = TITLE_CANTCHOOSE_RGBA;
			mRGBANotSel     = TITLE_NOTSEL_RGBA;
			mRGBAShadow     = TITLE_SHADOW_RGBA;
			mTitleSel1      = eTitleSelKiller7;
			mpSprtLogo      = &mSprtLogo;
			mpSprtBlar      = &mSprtBlar;
		}
	}
	
	//Z
	mSecretModeClear();
	
	return( true );
}

//-----------------------------------------------------------------------------
//IR[obN
//-----------------------------------------------------------------------------
bool
MK7TitleTask::TerminateCallBack(void)
{
	int	i;
	
//	WK7Sight::DrawSyncToken();
//	WK7Sight::Terminate();
	
	//Wf[^
	GHMGCMEM_SAFE_FREE( mOrgX );
	GHMGCMEM_SAFE_FREE( mOrgY );
	
	//̓f[^ƃXvCg
	for( i = 0; i < TITLE_STRING_MAX; i++ )
	{
		GHMGCMEM_SAFE_FREE( mStr[i].str );
		GHM_SAFE_DELETE_ARRAY( mStr[i].sprt );
		GHM_SAFE_DELETE_ARRAY( mStr[i].sprtShadow );
		GHMGCMEM_SAFE_FREE( mStr[i].shadowProc );
	}
	//\
	mpSprtLogo->mSetDispFlag( false );
	mpSprtBlar->mSetDispFlag( false );
	mSprtLogo.mSetDispFlag( false );
	mSprtBlar.mSetDispFlag( false );
	mSprtLogo1.mSetDispFlag( false );
	mSprtBlar1.mSetDispFlag( false );
	mSprtLogo2.mSetDispFlag( false );
	mSprtBlar2.mSetDispFlag( false );
	//f[^
	GHM_SAFE_DELETE( mReslink );
	
//	//wiFɂĎwFɃtF[h
//	HSD_VISetClearClr((GXColor){0x00,0x00,0x00,0x00});
//	k7app.SetFadeColor(0xa70a0b00);
//	k7app.FadeStart(0xff,0);
	
	//g`t@C
	gpSound->mReleaseSsm( TITLE_SSM_FILE );
	gpSound->mSetPitchStream( 0 );
	
#ifdef	_DEBUG
	gpSound->mSetSoundDebug( gTitleOldSoundDebug );
#endif
	
	enTitleSel0 data = mTitleSel0;
	
	ghmGcApp *pApp = GetApplication();
	delete this;
//#if defined(K7APP_MASTER) || !defined(DEBUG_MATSUZAKI)
#if 1
	if( data == eTitleSelNew )
	{
		//j[Q[
		if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1) == false )
		{
			mSecretModeClear();
		}
		gTitleGoContinue     = false;
		gTitleGoOption       = false;
		gTitleRetFromSSelect = false;
		BattleCtrl.InitNewGame();
		ghmGcMemSetAllocName("ScnTask");
		WK7PLAYERCONTROL->NewGameReset();
		GameInfo.SetClearScenarioID(-1);
		GameInfo.SetClearScenarioID2(-1);
		GameInfo.SetNewGame( true );
		new SK7ScenarioTask(pApp);
	}else
	if( data == eTitleSelCon )
	{
		//J[h[h
		mSecretModeClear();
		gTitleGoContinue     = true;
		gTitleGoOption       = false;
		gTitleRetFromSSelect = false;
		ghmGcMemSetAllocName("LoadTask");
		new SK7LoadTask(pApp);//ScenarioTask(pApp);
	}else
	if( data == eTitleSelOpt )
	{
		//IvV
		mSecretModeClear();
		gTitleGoContinue     = false;
		gTitleGoOption       = true;
		gTitleRetFromSSelect = false;
		ghmGcMemSetAllocName("OptTask");
		new SK7OptionTask(pApp);//ScenarioTask(pApp);
	}
#else
	new WK7MenuTask(pApp);
#endif
	
	return( true );
}

//-----------------------------------------------------------------------------
//t[
//-----------------------------------------------------------------------------
bool
MK7TitleTask::FrameProcess(void)
{
	//TEh
	if( gpSound != NULL )
	gpSound->mFrameProcess();
	
	//eNX`̓ǂݍ݂ƃ^CgSt[
	mTitleLogoProc();
	
	//j[̏
	if( mTitleMenuStrProc()==false ){
		return (true);
	}
	
	//^CgS̃CGtFNg
	mTitleLogoLineProc();
	
	//j[̉eʉɈړ
	mTitleFontShadowProc();
	
	//ՓxIʂ̏
	mDifficultProc();
	
	return( true );
}

//-----------------------------------------------------------------------------
//_O
//-----------------------------------------------------------------------------
bool
MK7TitleTask::RenderProcess(void)
{
	//sysdolphinԖ
	HSD_StateInvalidate(HSD_STATE_ALL);
	
	//XvCg`
	mK7Sprite::mRender();
	
	return( true );
}

//-----------------------------------------------------------------------------
//RXgN^
//-----------------------------------------------------------------------------
MK7TitleTask::MK7TitleTask(ghmGcApp *pApp,int prio) : ghmGcAppTask(pApp,prio)
{
	TRACE( "l:%d\n", ghmGcMemGetFreeSize() );
	TRACE( "s:%d\n", k7app.SmallGetFreeSize() );
}

//-----------------------------------------------------------------------------
//fXgN^
//-----------------------------------------------------------------------------
MK7TitleTask::~MK7TitleTask()
{
	//K7AppDumpMemory();
	TRACE( "l:%d\n", ghmGcMemGetFreeSize() );
	TRACE( "s:%d\n", k7app.SmallGetFreeSize() );
}

//-----------------------------------------------------------------------------
//\NGXg
// in --> stStringDat* inStrDat  f[^ۑ\̃|C^
//        s16          inX       \xW
//        s16          inY       \yW
//        char*        inStr     \
// out -> bool false  NGXgł
//             true   NGXg
//-----------------------------------------------------------------------------
bool
MK7TitleTask::mTitleFontReq( stStringDat* inStrDat, s16 inX, s16 inY, char* inStr )
{
	int	i, index;
	s32	tick;
	f32	scale;
	
	//
	GHMGCMEM_SAFE_FREE( inStrDat->str );
	GHM_SAFE_DELETE_ARRAY( inStrDat->sprt );
	GHM_SAFE_DELETE_ARRAY( inStrDat->sprtShadow );
	GHMGCMEM_SAFE_FREE( inStrDat->shadowProc );
	
	//Ȃ̓G[
	if( inStr == NULL )return( false );
	
	//\擾
	inStrDat->length = strlen( inStr );
	if( inStrDat->length == 0 )return( false );
	
	//񃁃m
	inStrDat->str = (char*)K7AppSmallMemAlloc( (int)((sizeof(char) * inStrDat->length) + 1) );
	ASSERT( inStrDat->str );
	//͕ۑ
	strcpy( inStrDat->str, inStr );
	//XvCg̃m
	ghmGcMemSetAllocName("MSprite");
	inStrDat->sprt = new mK7Sprite[inStrDat->length];
	ASSERT( inStrDat->sprt );
	//eXvCg̃m
	ghmGcMemSetAllocName("MSprite");
	inStrDat->sprtShadow = new mK7Sprite[inStrDat->length];
	ASSERT( inStrDat->sprtShadow );
	//ȅԂ̃m
	inStrDat->shadowProc = (enTitleShadowProc*)K7AppSmallMemAlloc( (int)((sizeof(enTitleShadowProc) * inStrDat->length) + 1) );
	ASSERT( inStrDat->shadowProc );
	
	//XvCg̐ݒ
	inStrDat->width = 0;
	for( i = 0; i < inStrDat->length; i++ )
	{
		if( inStrDat->str[i] != ' ' )
		{
			//̐ݒ
			switch( inStrDat->str[i] )
			{
				case	'8':
					index = 26;
					break;
				case	'7':
					index = 27;
					break;
				default:
					index = inStrDat->str[i] - 0x41;
					break;
			}
			inStrDat->sprt[i].mRelateTex( &mFont.fontTex );
			inStrDat->sprt[i].mSetWH( (s16)mFont.fontParam[index].w, (s16)mFont.fontParam[index].h );
			inStrDat->sprt[i].mSetUV0( (s16)mFont.fontParam[index].u, (s16)mFont.fontParam[index].v );
			inStrDat->sprt[i].mSetXY0( (s16)(inX + inStrDat->width), inY );
			inStrDat->sprt[i].mSetPriority( SPRT_PRI_TITLE_FONT );
			inStrDat->sprt[i].mSetDispFlag( true );
			//e̐ݒ
			inStrDat->sprtShadow[i].mRelateTex( &mFont.fontTex );
			inStrDat->sprtShadow[i].mSetWH( (s16)mFont.fontParam[index].w, (s16)mFont.fontParam[index].h );
			inStrDat->sprtShadow[i].mSetUV0( (s16)mFont.fontParam[index].u, (s16)mFont.fontParam[index].v );
			inStrDat->sprtShadow[i].mSetXY0( (s16)(inX + inStrDat->width), inY );
			inStrDat->sprtShadow[i].mSetPriority( SPRT_PRI_TITLE_FONT_SHADOW );
			inStrDat->sprtShadow[i].mSetDispFlag( true );
			inStrDat->sprtShadow[i].mSetRGBA( mRGBAShadow );
			//𑫂
			inStrDat->width += inStrDat->sprt[i].mGetW();
		}else
		{
			//Xy[X̕𑫂
			inStrDat->width += TITLE_FONT_SPACE_W;
		}
		//ȅcgɂ鎞ԂZo
		tick  = HSD_Randi(TITLE_SHADOW_DROP_TICK) + TITLE_SHADOW_DROP_TICK;
		//ȅcg嗦Zo
		scale = (f32)((f32)(HSD_Randi(TITLE_SHADOW_MAX_SCALE - TITLE_SHADOW_MIN_SCALE) + TITLE_SHADOW_MIN_SCALE) / 100.0f);
		//WL[v&cg嗦ݒ
		inStrDat->sprtShadow[i].mSetMove( inStrDat->sprt[i].mGetX0(), inStrDat->sprt[i].mGetY0(), tick );
		inStrDat->sprtShadow[i].mSetScale( eScaleH, scale, tick );
		inStrDat->sprtShadow[i].mSetFade( 255, tick );
		//ȅԂ
		inStrDat->shadowProc[i] = eTitleShadowScale;
	}
	
	return( true );
}
//-----------------------------------------------------------------------------
//ɐF
// in --> stStringDat* inStrDat  f[^ۑ\̃|C^
//        u32          inRGBA    FRGBA
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mTitleFontSetRGBA( stStringDat* inStrDat, u32 inRGBA )
{
	int	i;
	
	for( i = 0; i < inStrDat->length; i++ )
	{
		inStrDat->sprt[i].mSetRGBA( inRGBA );
	}
}
void
MK7TitleTask::mTitleSel0SetRGBA( void )
{
	//NewGameFݒ
	if( mTitleSel0 == eTitleSelNew )
	{
		if( mSelectFlag & TITLE_SEL_NEW )
		{
			mTitleFontSetRGBA( &mStr[0], mRGBASel );
		}else
		{
			mTitleFontSetRGBA( &mStr[0], TITLE_CANTCHOOSE_RGBA );
		}
	}else
	{
		mTitleFontSetRGBA( &mStr[0], TITLE_NOTSEL_RGBA );
	}
	
	//ContinueFݒ
	if( mTitleSel0 == eTitleSelCon )
	{
		if( mSelectFlag & TITLE_SEL_CON )
		{
			mTitleFontSetRGBA( &mStr[1], mRGBASel );
		}else
		{
			mTitleFontSetRGBA( &mStr[1], mRGBACantChoose );
		}
	}else
	{
		mTitleFontSetRGBA( &mStr[1], mRGBANotSel );
	}
	
	//IvVFݒ
	if( mTitleSel0 == eTitleSelOpt )
	{
		if( mSelectFlag & TITLE_SEL_OPT )
		{
			mTitleFontSetRGBA( &mStr[2], mRGBASel );
		}else
		{
			mTitleFontSetRGBA( &mStr[2], mRGBACantChoose );
		}
	}else
	{
		mTitleFontSetRGBA( &mStr[2], mRGBANotSel );
	}
}
void
MK7TitleTask::mTitleSel1SetRGBA( void )
{
	//Killer7 Fݒ
	if( mTitleSel1 == eTitleSelKiller7 )
	{
		mTitleFontSetRGBA( &mStr[0], mRGBASel );
	}else
	{
		mTitleFontSetRGBA( &mStr[0], mRGBANotSel );
	}
	
	//Killer1 Fݒ
	if( mTitleSel1 == eTitleSelKiller1 )
	{
		mTitleFontSetRGBA( &mStr[1], mRGBASel );
	}else
	{
		mTitleFontSetRGBA( &mStr[1], mRGBANotSel );
	}
	
	//Hopper7 Fݒ
	if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_GAME_CLEAR_K8) == true )
	{
		if( mTitleSel1 == eTitleSelHopper7 )
		{
			mTitleFontSetRGBA( &mStr[2], mRGBASel );
		}else
		{
			mTitleFontSetRGBA( &mStr[2], mRGBANotSel );
		}
	}
}
//-----------------------------------------------------------------------------
//^Cgʂ̃tF[hAEgݒ
// in --> u32 inSelMenu  Iꂽj[ԍ
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mSetTitleFadeOut( u32 inSelMenu )
{
	u32	i, j;
	
	//Killer7StF[hAEg
	mpSprtLogo->mSetFade( 0, TITLE_LAST_FADE );
	//Killer7S̃u[tF[hAEg
	mpSprtBlar->mSetFade( 0, TITLE_LAST_FADE );
	
	//Wf[^
	GHMGCMEM_SAFE_FREE( mOrgX );
	GHMGCMEM_SAFE_FREE( mOrgY );
	//Iꂽ𓮂߂̍WۑpɃm
	mOrgX = (f32*)K7AppSmallMemAlloc( (int)(sizeof(f32)*mStr[inSelMenu].length) );
	mOrgY = (f32*)K7AppSmallMemAlloc( (int)(sizeof(f32)*mStr[inSelMenu].length) );
	//Iꂽ̌Wݒ聕\D揇ʂグ
	for( i = 0; i < mStr[inSelMenu].length; i++ )
	{
		mOrgX[i] = mStr[inSelMenu].sprt[i].mGetX0();
		mOrgY[i] = mStr[inSelMenu].sprt[i].mGetY0();
		mStr[inSelMenu].sprt[i].mSetPriority( SPRT_PRI_TITLE_BLAR );
	}
	
	//^Cgj[̕tF[hAEgݒ
	for( i = 0; i < TITLE_STRING_MAX; i++ )
	{
		if( mStr[i].str != NULL )
		{
			for( j = 0; j < mStr[i].length; j++ )
			{
				//Iꂽ̓tF[hAEgȂ
				if( i != inSelMenu )
				{
					mStr[i].sprt[j].mSetFade( 0, TITLE_LAST_FADE );
				}
			}
		}
	}
	
	//΂SEĐ
	gpSound->mPlaySE( SFX_BT_HS_DEATH00 );
	
	//΂Iꂽ̃tF[hAEg܂ő҂
	mVoicePlayTick = TITLE_VOICE_PLAY_TICK;
}
//-----------------------------------------------------------------------------
//Iꂽj[̔ԍ擾
// in --> none
// out -> u32 IĂ郁j[ԍ
//-----------------------------------------------------------------------------
u32
MK7TitleTask::mGetSelectNo( void )
{
	return( (u32)mTitleSel0 );
	
	//IvVIꂽ`FbN
	if( mTitleSel0 == eTitleSelOpt )
	{
		//IvVIĂ1ڂ̑IڂI
		return( (u32)mTitleSel0 );
	}else
	{
		//ȊOȂ2ڂ̃j[̑IڂI
		return( (u32)mTitleSel1 );
	}
}
//-----------------------------------------------------------------------------
//IĂ郁j[̔ԍ擾
// in --> none
// out -> u32 IĂ郁j[ԍ
//-----------------------------------------------------------------------------
u32
MK7TitleTask::mGetNowSelectNo( void )
{
	//݂̃j[ڂɂĕ򂳂
	switch( mTitleMenuProc )
	{
		// NEW GAME, CONTINUE, OPTION
		case	eTitleMenu0:
			return( (u32)mTitleSel0 );
			break;
		
		// Killer7, Killer1
		case	eTitleMenu1:
			return( (u32)mTitleSel1 );
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( 0 );
}
//-----------------------------------------------------------------------------
//IĂ郁j[̕h炷
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mTitleFontShake( void )
{
	int	i;
	
	//tF[hAEgɕ̍Wh炷o
	for( i = 0; i < mStr[mGetSelectNo()].length; i++ )
	{
		mStr[mGetSelectNo()].sprt[i].mSetXY0( (s16)(mOrgX[i] + (HSD_Randi(TITLE_STR_BLAR_W)-(TITLE_STR_BLAR_W/2))),
											  (s16)(mOrgY[i] + (HSD_Randi(TITLE_STR_BLAR_W)-(TITLE_STR_BLAR_W/2))) );
	}
}
//-----------------------------------------------------------------------------
//w肵j[̕lɈړ
// in --> u32 inStringNo  lj[̔ԍ
//        s32 inTick      l̂ɂ鎞
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mTitleFontClose( u32 inStringNo, s32 inTick )
{
	int	i;
	stStringDat*	pStr = &mStr[inStringNo];
	
	//
	pStr->width = 0;
	
	//lɈړ
	for( i = 0; i < pStr->length; i++ )
	{
		//\XWݒ
		pStr->sprt[i].mSetMove( (f32)(TITLE_STRING_X + pStr->width), pStr->sprt[i].mGetY0(), inTick );
		//ۑ
		pStr->width += (s16)((f32)(pStr->sprt[i].mGetW()) * TITLE_CLOSE_RATE);
	}
}
//-----------------------------------------------------------------------------
//w肵j[̕ʕɍL
// in --> u32 inStringNo  Lj[̔ԍ
//        s32 inTick      L̂ɂ鎞
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mTitleFontSpread( u32 inStringNo, s32 inTick )
{
	int	i;
	f32	interval;
	stStringDat*	pStr = &mStr[inStringNo];
	
	//
	pStr->width = 0;
	//ԊuvZ
	interval = ((f32)K7APP_SCREEN_WIDTH - (f32)(TITLE_STRING_X * 2) - (f32)(mStr[inStringNo].sprt[pStr->length-1].mGetW())) / (pStr->length - 1);
	
	//lɈړ
	for( i = 0; i < pStr->length; i++ )
	{
		//\XWݒ
		pStr->sprt[i].mSetMove( (f32)(TITLE_STRING_X + pStr->width), pStr->sprt[i].mGetY0(), inTick );
		//ۑ
		pStr->width += interval;
	}
}
//-----------------------------------------------------------------------------
//j[ړ
// in --> u32 inMenuMax  j[I̍ő吔
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mTitleFontMove( u32 inMenuMax )
{
	u32	i;
	
	for( i = 0; i < inMenuMax; i++ )
	{
		if( mGetNowSelectNo() == i )
		{
			//L
			mTitleFontSpread( i, TITLE_SPREAD_TICK );
		}else
		{
			//l߂
			mTitleFontClose( i, TITLE_CLOSE_TICK );
		}
	}
}
//-----------------------------------------------------------------------------
//S̃CGtFNg
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mTitleLogoLineInit( void )
{
	int	i;
	
	//C̏ړx
	mLineSpeed = TITLE_LINE_INIT_SPEED;
	//7px
	mLineAngle = TITLE_LINE_ANGLE;
	
	//cpXC
	for( i = 0; i < TITLE_LOGO_X_LINE_MAX; i++ )
	{
		mLineX[i].moveTick = HSD_Randi((TITLE_LINE_MOVE_MAX_TICK-TITLE_LINE_MOVE_MIN_TICK) / 10) * 10 + (s32)mLineSpeed;
		mLineX[i].moveWait = HSD_Randi(TITLE_LINE_MOVE_WAIT) + 1;
		mLineX[i].sprt.mSetTransformBoxPrim();
		mLineX[i].sprt.mSetPriority( SPRT_PRI_TITLE_LOGO_LINEBOX );
		mLineX[i].sprt.mSetW( (s16)(HSD_Randi(TITLE_LINE_WIDTH)+1) );
		mLineX[i].sprt.mSetH( (s16)K7APP_SCREEN_HEIGHT );
		mLineX[i].sprt.mSetX2( gTblLineX[i] + TITLE_LINE_ANGLE_OFFSET );
		mLineX[i].sprt.mSetX3( mLineX[i].sprt.mGetX2() + mLineX[i].sprt.mGetW() );
		mLineX[i].sprt.mSetX0( mLineX[i].sprt.mGetX2() - (TITLE_LINE_ANGLE * mLineX[i].sprt.mGetH() / K7APP_SCREEN_HEIGHT) );
		mLineX[i].sprt.mSetX1( mLineX[i].sprt.mGetX3() - (TITLE_LINE_ANGLE * mLineX[i].sprt.mGetH() / K7APP_SCREEN_HEIGHT) );
		mLineX[i].sprt.mSetY0( -mLineX[i].sprt.mGetH() );
		mLineX[i].sprt.mSetY1( -mLineX[i].sprt.mGetH() );
		mLineX[i].sprt.mSetY2( 0 );
		mLineX[i].sprt.mSetY3( 0 );
		if( mTitleSel1 == eTitleSelKiller1 )
		{
			mLineX[i].sprt.mSetRGBA( TITLE_LINE_RGBA1 );
		}else
		if( mTitleSel1 == eTitleSelHopper7 )
		{
			mLineX[i].sprt.mSetRGBA( TITLE_LINE_RGBA2 );
		}else
		{
			mLineX[i].sprt.mSetRGBA( TITLE_LINE_RGBA );
		}
		mLineX[i].sprt.mSetDispFlag( false );
	}
	//pYC
	for( i = 0; i < TITLE_LOGO_Y_LINE_MAX; i++ )
	{
		mLineY[i].moveTick = HSD_Randi((TITLE_LINE_MOVE_MAX_TICK-TITLE_LINE_MOVE_MIN_TICK) / 10) * 10 + (s32)mLineSpeed;
		mLineY[i].moveWait = HSD_Randi(TITLE_LINE_MOVE_WAIT) + 1;
		mLineY[i].sprt.mSetBoxPrim();
		mLineY[i].sprt.mSetPriority( SPRT_PRI_TITLE_LOGO_LINEBOX );
		mLineY[i].sprt.mSetWH( (s16)K7APP_SCREEN_WIDTH, (s16)(HSD_Randi(TITLE_LINE_WIDTH)+1) );
		mLineY[i].sprt.mSetXY0( (s16)(-mLineY[i].sprt.mGetW()), gTblLineY[i] );
		if( mTitleSel1 == eTitleSelKiller1 )
		{
			mLineY[i].sprt.mSetRGBA( TITLE_LINE_RGBA1 );
		}else
		if( mTitleSel1 == eTitleSelHopper7 )
		{
			mLineY[i].sprt.mSetRGBA( TITLE_LINE_RGBA2 );
		}else
		{
			mLineY[i].sprt.mSetRGBA( TITLE_LINE_RGBA );
		}
		mLineY[i].sprt.mSetDispFlag( false );
	}
#if	0
	//cpXC
	for( i = 0; i < TITLE_LOGO_X_LINE_MAX; i++ )
	{
		mLineX[i].moveTick = HSD_Randi(TITLE_LINE_MOVE_MAX_TICK-TITLE_LINE_MOVE_MIN_TICK) + (s32)mLineSpeed;
		mLineX[i].moveWait = 0;
		mLineX[i].sprt.mSetTransformBoxPrim();
		mLineX[i].sprt.mSetPriority( SPRT_PRI_TITLE_LOGO_LINEBOX );
		mLineX[i].sprt.mSetW( (s16)(HSD_Randi(TITLE_LINE_WIDTH)+1) );
		mLineX[i].sprt.mSetH( (s16)(K7APP_SCREEN_HEIGHT * TITLE_LINE_LENGTH_RATE * TITLE_LINE_MOVE_MIN_TICK / mLineX[i].moveTick) );
		mLineX[i].sprt.mSetX2( gTblLineX[i] + TITLE_LINE_ANGLE_OFFSET );
		mLineX[i].sprt.mSetX3( mLineX[i].sprt.mGetX2() + mLineX[i].sprt.mGetW() );
		mLineX[i].sprt.mSetX0( mLineX[i].sprt.mGetX2() - (TITLE_LINE_ANGLE * mLineX[i].sprt.mGetH() / K7APP_SCREEN_HEIGHT) );
		mLineX[i].sprt.mSetX1( mLineX[i].sprt.mGetX3() - (TITLE_LINE_ANGLE * mLineX[i].sprt.mGetH() / K7APP_SCREEN_HEIGHT) );
		mLineX[i].sprt.mSetY0( -mLineX[i].sprt.mGetH() );
		mLineX[i].sprt.mSetY1( -mLineX[i].sprt.mGetH() );
		mLineX[i].sprt.mSetY2( 0 );
		mLineX[i].sprt.mSetY3( 0 );
		mLineX[i].sprt.mSetRGBA( TITLE_LINE_RGBA );
		mLineX[i].sprt.mSetRGBA0( TITLE_LINE_RGBA_END );
		mLineX[i].sprt.mSetRGBA1( TITLE_LINE_RGBA_END );
		mLineX[i].sprt.mSetMove( (f32)(mLineX[i].sprt.mGetX2() + TITLE_LINE_ANGLE), (f32)K7APP_SCREEN_HEIGHT, mLineX[i].moveTick );
		mLineX[i].sprt.mSetDispFlag( true );
	}
	//pYC
	for( i = 0; i < TITLE_LOGO_Y_LINE_MAX; i++ )
	{
		mLineY[i].moveTick = HSD_Randi(TITLE_LINE_MOVE_MAX_TICK-TITLE_LINE_MOVE_MIN_TICK) + (s32)mLineSpeed;
		mLineY[i].moveWait = 0;
		mLineY[i].sprt.mSetBoxPrim();
		mLineY[i].sprt.mSetPriority( SPRT_PRI_TITLE_LOGO_LINEBOX );
		mLineY[i].sprt.mSetWH( (s16)(K7APP_SCREEN_WIDTH * TITLE_LINE_LENGTH_RATE * TITLE_LINE_MOVE_MIN_TICK / mLineY[i].moveTick), (s16)(HSD_Randi(TITLE_LINE_WIDTH)+1) );
		mLineY[i].sprt.mSetXY0( (s16)(-mLineY[i].sprt.mGetW()), gTblLineY[i] );
		mLineY[i].sprt.mSetRGBA( TITLE_LINE_RGBA );
		mLineY[i].sprt.mSetRGBA0( TITLE_LINE_RGBA_END );
		mLineY[i].sprt.mSetRGBA2( TITLE_LINE_RGBA_END );
		mLineY[i].sprt.mSetFadeWithWait( TITLE_LINE_ALPHA, TITLE_LINE_FADEIN_TICK, HSD_Randi(TITLE_LINE_DISP_WAIT) + 1 );
		mLineY[i].sprt.mSetMove( (f32)K7APP_SCREEN_WIDTH, mLineY[i].sprt.mGetY0(), mLineY[i].moveTick );
		mLineY[i].sprt.mSetDispFlag( true );
	}
#endif
	
	//S\锠
	mSetTitleLogoBoxLocate();
}
//-----------------------------------------------------------------------------
//S̃CGtFNg
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mTitleLogoLineProc( void )
{
	int	i;
	
	//{cwɂړ͂Ȃ 04/01/18
	return;
	
	//ړxvZ
	mLineSpeed -= (f32)(TITLE_LINE_INIT_SPEED - TITLE_LINE_TERM_SPEED) / (f32)WK7_TICK_TO_FRAME((f32)(TITLE_LINE_DISP_TICK + TITLE_LINE_FADEOUT_TICK));
	if( mLineSpeed < 1.0f )mLineSpeed = 1.0f;
	
	//7̐pxvZ
	mLineAngle += (f32)(TITLE_LINE_SEVEN_ANGLE - TITLE_LINE_ANGLE) / (f32)WK7_TICK_TO_FRAME((f32)(TITLE_LINE_DISP_TICK + TITLE_LINE_FADEOUT_TICK));
	if( mLineAngle < (f32)TITLE_LINE_SEVEN_ANGLE )mLineAngle = (f32)TITLE_LINE_SEVEN_ANGLE;
	
	//cpXC
	for( i = 0; i < TITLE_LOGO_X_LINE_MAX; i++ )
	{
		if( mLineX[i].sprt.mGetMoveEnd() == true )
		{
			mLineX[i].moveTick = HSD_Randi(TITLE_LINE_MOVE_MAX_TICK-TITLE_LINE_MOVE_MIN_TICK) + (s32)mLineSpeed;
			mLineX[i].moveWait = 0;
			mLineX[i].sprt.mSetW( (s16)(HSD_Randi(TITLE_LINE_WIDTH)+1) );
			mLineX[i].sprt.mSetH( (s16)(K7APP_SCREEN_HEIGHT * TITLE_LINE_LENGTH_RATE * TITLE_LINE_MOVE_MIN_TICK / mLineX[i].moveTick) );
			mLineX[i].sprt.mSetX2( gTblLineX[i] + TITLE_LINE_ANGLE_OFFSET );
			mLineX[i].sprt.mSetX3( mLineX[i].sprt.mGetX2() + mLineX[i].sprt.mGetW() );
			//7̕pxω
			if( i > TITLE_LINE_SEVEN )
			{
				mLineX[i].sprt.mSetX0( mLineX[i].sprt.mGetX2() - (mLineAngle * mLineX[i].sprt.mGetH() / K7APP_SCREEN_HEIGHT) );
				mLineX[i].sprt.mSetX1( mLineX[i].sprt.mGetX3() - (mLineAngle * mLineX[i].sprt.mGetH() / K7APP_SCREEN_HEIGHT) );
			}else
			{
				mLineX[i].sprt.mSetX0( mLineX[i].sprt.mGetX2() - (TITLE_LINE_ANGLE * mLineX[i].sprt.mGetH() / K7APP_SCREEN_HEIGHT) );
				mLineX[i].sprt.mSetX1( mLineX[i].sprt.mGetX3() - (TITLE_LINE_ANGLE * mLineX[i].sprt.mGetH() / K7APP_SCREEN_HEIGHT) );
			}
			mLineX[i].sprt.mSetY0( -mLineX[i].sprt.mGetH() );
			mLineX[i].sprt.mSetY1( -mLineX[i].sprt.mGetH() );
			mLineX[i].sprt.mSetY2( 0 );
			mLineX[i].sprt.mSetY3( 0 );
			//7̕pxω
			if( i > TITLE_LINE_SEVEN )
			{
				mLineX[i].sprt.mSetMove( (f32)(mLineX[i].sprt.mGetX2() + mLineAngle), (f32)K7APP_SCREEN_HEIGHT, mLineX[i].moveTick );
			}else
			{
				mLineX[i].sprt.mSetMove( (f32)(mLineX[i].sprt.mGetX2() + TITLE_LINE_ANGLE), (f32)K7APP_SCREEN_HEIGHT, mLineX[i].moveTick );
			}
		}
	}
	//pYC
	for( i = 0; i < TITLE_LOGO_Y_LINE_MAX; i++ )
	{
		if( mLineY[i].sprt.mGetMoveEnd() == true )
		{
			mLineY[i].moveTick = HSD_Randi(TITLE_LINE_MOVE_MAX_TICK-TITLE_LINE_MOVE_MIN_TICK) + (s32)mLineSpeed;
			mLineY[i].moveWait = 0;
			mLineY[i].sprt.mSetWH( (s16)(K7APP_SCREEN_WIDTH * TITLE_LINE_LENGTH_RATE * TITLE_LINE_MOVE_MIN_TICK / mLineY[i].moveTick), (s16)(HSD_Randi(TITLE_LINE_WIDTH)+1) );
			mLineY[i].sprt.mSetXY0( (s16)(-mLineY[i].sprt.mGetW()), gTblLineY[i] );
			mLineY[i].sprt.mSetMove( (f32)K7APP_SCREEN_WIDTH, mLineY[i].sprt.mGetY0(), mLineY[i].moveTick );
		}
	}

}




//-----------------------------------------------------------------------------
//eNX`̓ǂݍ݂ƃ^CgSt[
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mTitleLogoProc( void )
{
	int	i, j;
	f32 rate;
	
	//eNX`̓ǂݍ݂ƃ^CgSt[
	switch( mProc )
	{
		//f[^ǂݍ
		case	eTitleReadData:
			if( mFile.mK7FileRead(TITLE_TEX, &((void*)mDat)) == eFileReadSucsess )
			{
				mReslink = new ((ghmGcResLink *)mDat)ghmGcResLink;
				ASSERT( mReslink );
				//f[^ݒ
				mSetTitleData();
				//ɐi߂
				mProc = eTitleReadSsmWait;
			}
			break;
		
		//g`t@C̓ǂݍ
		case	eTitleReadSsmWait:
			if( gpSound->mGetProcess() == eSndStandby )
			{
				////^Cgȏ
				//gpSound->mPrepareStreamNo( HPS_TITLE );
				//ɐi߂
				if( (gTitleGoContinue == true) || (gTitleGoOption == true) || (gTitleRetFromSSelect == true) )
				{
					gTitleGoContinue     = false;
					gTitleGoOption       = false;
					gTitleRetFromSSelect = false;
					//mSetLogoEffectCancel();
					mpSprtLogo->mSetDispFlag( true );
					mpSprtBlar->mSetDispFlag( true );
					gpSound->mPlaySE( SFX_TITLE_START );
					mProc = eTitleFadeWait;
				}else
				{
					//ȍĐ
					gpSound->mJustPlayStream();
					mProc = eTitleLineEffect;
				}
			}else
			{
				break;
			}
		
		//S̃CGtFNg\
		case	eTitleLineEffect:
			//pbhĎ
			if( (HSD_PadGetTrigger(0) == PAD_BUTTON_START) )//|| (HSD_PadGetTrigger(0) == PAD_BUTTON_A) )
			{
				//LZ̃tF[hAEgĂяo
				mSetLogoEffectCancel();
				//Sƃu[\
				mpSprtLogo->mSetDispFlag( true );
				mpSprtBlar->mSetDispFlag( true );
			//	mSprtLogo.mSetDispFlag( true );
			//	mSprtBlar.mSetDispFlag( true );
				//ɐi߂
				mProc = eTitleFadeWait;
			}else
			{
				//\鎞Ԃo߂̂Ŏ̃vZXɐi߂
				if( mEffectWait <= 0 )
				{
					//CGtFNgtF[hAEg
					for( i = 0; i < TITLE_LOGO_X_LINE_MAX; i++ )
					{
						mLineX[i].sprt.mSetFade( 0, TITLE_LINE_FADEOUT_TICK );
					}
					for( i = 0; i < TITLE_LOGO_Y_LINE_MAX; i++ )
					{
						mLineY[i].sprt.mSetFade( 0, TITLE_LINE_FADEOUT_TICK );
					}
					//GtFNg\Ԃݒ
					mEffectWait = TITLE_BOX_DISP_TICK;
					//SEĐ
					gpSound->mPlaySE( SFX_TITLE_LOGO );
					//ɐi߂
					mProc = eTitleBoxEffect;
				}else
				//\鎞ԂɂȂ`FbNĕ\ԂɂȂĂړƃtF[hJn
				{
					//cpXC
					for( i = 0; i < TITLE_LOGO_X_LINE_MAX; i++ )
					{
						if( mLineX[i].moveWait < 0 )
						{
							mLineX[i].moveWait = 0;
							mLineX[i].sprt.mSetFade( TITLE_LINE_ALPHA, mLineX[i].moveTick );
							mLineX[i].sprt.mSetMove( (f32)(mLineX[i].sprt.mGetX2()), 0.0f, mLineX[i].moveTick );
							mLineX[i].sprt.mSetDispFlag( true );
							rate = (f32)(TITLE_LINE_SE_MAX_PITCH - TITLE_LINE_SE_MIN_PITCH) / (f32)((TITLE_LINE_MOVE_MAX_TICK - TITLE_LINE_MOVE_MIN_TICK + TITLE_LINE_INIT_SPEED) - TITLE_LINE_INIT_SPEED);
							mLineXSENo[i] = gpSound->mPlaySEP( SFX_TITLE_LINE, (s16)(rate * mLineX[i].moveTick + TITLE_LINE_SE_MIN_PITCH) );
						}else
						{
							if( mLineX[i].moveWait != 0 )
								mLineX[i].moveWait -= WK7_TICK_PER_FRAME;
						}
						//C\ňړIĂSEtF[hAEg
						if( (mLineX[i].moveWait == 0) && (mLineXSENo[i] != -1) && (mLineX[i].sprt.mGetMoveEnd() == true) )
						{
							gpSound->mSetVolumeSENo( mLineXSENo[i], 0, TITLE_LINE_SE_FADE_SPEED );
						}
					}
					//pYC
					for( i = 0; i < TITLE_LOGO_Y_LINE_MAX; i++ )
					{
						if( mLineY[i].moveWait < 0 )
						{
							mLineY[i].moveWait = 0;
							mLineY[i].sprt.mSetFade( TITLE_LINE_ALPHA, mLineY[i].moveTick );
							mLineY[i].sprt.mSetMove( 0.0f, mLineY[i].sprt.mGetY0(), mLineY[i].moveTick );
							mLineY[i].sprt.mSetDispFlag( true );
							rate = (f32)(TITLE_LINE_SE_MAX_PITCH - TITLE_LINE_SE_MIN_PITCH) / (f32)((TITLE_LINE_MOVE_MAX_TICK - TITLE_LINE_MOVE_MIN_TICK + TITLE_LINE_INIT_SPEED) - TITLE_LINE_INIT_SPEED);
							mLineYSENo[i] = gpSound->mPlaySEP( SFX_TITLE_LINE, (s16)(rate * mLineY[i].moveTick + TITLE_LINE_SE_MIN_PITCH) );
						}else
						{
							if( mLineY[i].moveWait != 0 )
								mLineY[i].moveWait -= WK7_TICK_PER_FRAME;
						}
						//C\ňړIĂSEtF[hAEg
						if( (mLineY[i].moveWait == 0) && (mLineYSENo[i] != -1) && (mLineY[i].sprt.mGetMoveEnd() == true) )
						{
							gpSound->mSetVolumeSENo( mLineYSENo[i], 0, TITLE_LINE_SE_FADE_SPEED );
						}
					}
					mEffectWait -= WK7_TICK_PER_FRAME;
				}
			}
			break;
		
		//S̔GtFNg\
		case	eTitleBoxEffect:
			//pbhĎ
			if( (HSD_PadGetTrigger(0) == PAD_BUTTON_START) )// || (HSD_PadGetTrigger(0) == PAD_BUTTON_A) )
			{
				//LZ̃tF[hAEgĂяo
				mSetLogoEffectCancel();
				//Sƃu[\
				mpSprtLogo->mSetDispFlag( true );
				mpSprtBlar->mSetDispFlag( true );
			//	mSprtLogo.mSetDispFlag( true );
			//	mSprtBlar.mSetDispFlag( true );
				//ɐi߂
				mProc = eTitleFadeWait;
			}else
			{
				for( i = 0; i < TITLE_LOGO_BOX_MAX; i++ )
				{
					if( mBox[i].wait < 0 )
					{
						mBox[i].wait = 0;
						mBox[i].box.mSetFade( TITLE_BOX_ALPHA, TITLE_BOX_FADEIN_TICK );
					}else
					{
						if( mBox[i].wait != 0 )
							mBox[i].wait -= WK7_TICK_PER_FRAME;
					}
				}
				if( mEffectWait <= 0 )
				{
					for( i = 0; i < TITLE_LOGO_BOX_MAX; i++ )
					{
						mBox[i].box.mSetFade( 0, TITLE_BOX_FADEOUT_TICK );
					}
					//Sƃu[\
					mpSprtLogo->mSetDispFlag( true );
					mpSprtBlar->mSetDispFlag( true );
				//	mSprtLogo.mSetDispFlag( true );
				//	mSprtBlar.mSetDispFlag( true );
					//SEĐ
					gpSound->mPlaySE( SFX_TITLE_MOJI );
					//^CgȍĐ
					//gpSound->mJustPlayStream();
					//ɐi߂
					mProc = eTitleFadeWait;
				}else
				{
					mEffectWait -= WK7_TICK_PER_FRAME;
				}
			}
			break;
		
		//Killer7̃̕tF[hC҂(΂炭҂ĂtF[hC)
		case	eTitleFadeWait:
			//tF[hĎ
			if( (mTitleMenuProc == eTitleMenuFadeOut) || (mTitleMenuProc == eTitleMenuStrFadeOut) )
			{}else
			{
				//[vĎ
				if( mCheckTitleLoop() == true )
				{
					mProc = eTitleFadeOut;
				}else
				{
					if( mFadeWaitTick > 0 )
					{
						mFadeWaitTick -= WK7_TICK_PER_FRAME;
					}else
					{
						//tF[hCݒ
					//	mSprtBlar.mSetFade( TITLE_ALPHA_MAX, TITLE_FADEIN_TICK );
						mpSprtBlar->mSetFade( TITLE_ALPHA_MAX, TITLE_FADEIN_TICK );
						//ɖ߂Ăۂ̃tF[hCÕEGCgݒ
						mFadeWaitTick = TITLE_FADEIN_WAIT_TICK;
						mFadeInFlag   = true;
						mProc         = eTitleDispTitle;
					}
				}
			}
			break;
		
		//Killer7̃̕tF[hAEgݒ҂(tF[hCÎ҂)
		case	eTitleDispTitle:
			//tF[hĎ
			if( (mTitleMenuProc == eTitleMenuFadeOut) || (mTitleMenuProc == eTitleMenuStrFadeOut) )
			{}else
			{
				//[vĎ
				if( mCheckTitleLoop() == true )
				{
					mProc = eTitleFadeOut;
				}else
				{
					if( mFadeInFlag == true )
					{
						//tF[hCI҂
						if( mpSprtBlar->mGetFadeEnd() == true )
						{
							//tF[hAEgݒ
							mpSprtBlar->mSetFade( 0, TITLE_FADEOUT_TICK );
							mFadeInFlag = false;
						}
					}else
					{
						//tF[hAEgI҂
						if( mpSprtBlar->mGetFadeEnd() == true )
						{
							mProc = eTitleFadeWait;
						}
					}
				}
			}
			break;
		
		//[vÕtF[hAEg
		case	eTitleFadeOut:
		//	if( mSprtLogo.mGetFadeEnd() == true )
			if( mpSprtLogo->mGetFadeEnd() == true )
			{
				mTitleStreamPlay = false;
				//\tOOFF
				mpSprtLogo->mSetA( 255 );
				mpSprtLogo->mSetDispFlag( false );
				mpSprtBlar->mSetDispFlag( false );
			//	mSprtLogo.mSetA( 255 );
			//	mSprtLogo.mSetDispFlag( false );
			//	mSprtBlar.mSetDispFlag( false );
				//tF[hCEGCgݒ
				mFadeWaitTick = TITLE_FADEIN_WAIT_TICK;
				//CGtFNg\Ԃݒ
				mEffectWait = TITLE_LINE_DISP_TICK;
				//ȍĐ
				gpSound->mJustPlayStream();
				////^Cgȏ
				//gpSound->mPrepareStreamNo( HPS_TITLE );
				mProc     = eTitleLineEffect;
			}
			break;
		
		//Killer7Killer1̓ւ菈
		case	eTitleChange:
			switch( mTitleSel1 )
			{
				case	eTitleSelKiller7:
					mSprtLogo1.mSetFade( 0, 2400 );
					mSprtBlar1.mSetFade( 0, 2400 );
					mSprtLogo2.mSetFade( 0, 2400 );
					mSprtBlar2.mSetFade( 0, 2400 );
					mSprtLogo.mSetA( 0 );
					mSprtLogo.mSetDispFlag( true );
					mSprtLogo.mSetFade( 0xff, 2400 );
					mSprtBlar.mSetA( 0 );
					mSprtBlar.mSetDispFlag( true );
					mSprtBlar.mSetFade( 0xff, 2400 );
					mpSprtLogo = &mSprtLogo;
					mpSprtBlar = &mSprtBlar;
					mRGBASel        = TITLE_SEL_RGBA;
					mRGBACantChoose = TITLE_CANTCHOOSE_RGBA;
					mRGBANotSel     = TITLE_NOTSEL_RGBA;
					mRGBAShadow     = TITLE_SHADOW_RGBA;
					break;
				case	eTitleSelKiller1:
					mSprtLogo.mSetFade( 0, 2400 );
					mSprtBlar.mSetFade( 0, 2400 );
					mSprtLogo2.mSetFade( 0, 2400 );
					mSprtBlar2.mSetFade( 0, 2400 );
					mSprtLogo1.mSetA( 0 );
					mSprtLogo1.mSetDispFlag( true );
					mSprtLogo1.mSetFade( 0xff, 2400 );
					mSprtBlar1.mSetA( 0 );
					mSprtBlar1.mSetDispFlag( true );
					mSprtBlar1.mSetFade( 0xff, 2400 );
					mpSprtLogo = &mSprtLogo1;
					mpSprtBlar = &mSprtBlar1;
					mRGBASel        = TITLE1_SEL_RGBA;
					mRGBACantChoose = TITLE1_CANTCHOOSE_RGBA;
					mRGBANotSel     = TITLE1_NOTSEL_RGBA;
					mRGBAShadow     = TITLE1_SHADOW_RGBA;
					break;
				case	eTitleSelHopper7:
					mSprtLogo.mSetFade( 0, 2400 );
					mSprtBlar.mSetFade( 0, 2400 );
					mSprtLogo1.mSetFade( 0, 2400 );
					mSprtBlar1.mSetFade( 0, 2400 );
					mSprtLogo2.mSetA( 0 );
					mSprtLogo2.mSetDispFlag( true );
					mSprtLogo2.mSetFade( 0xff, 2400 );
					mSprtBlar2.mSetA( 0 );
					mSprtBlar2.mSetDispFlag( true );
					mSprtBlar2.mSetFade( 0xff, 2400 );
					mpSprtLogo = &mSprtLogo2;
					mpSprtBlar = &mSprtBlar2;
					mRGBASel        = TITLE2_SEL_RGBA;
					mRGBACantChoose = TITLE2_CANTCHOOSE_RGBA;
					mRGBANotSel     = TITLE2_NOTSEL_RGBA;
					mRGBAShadow     = TITLE2_SHADOW_RGBA;
					break;
			}
			//Ił郁j[ŕ
			if( mTitleMenuProc == eTitleMenu0 )
			{
				mTitleSel0SetRGBA();
			}else
			if( mTitleMenuProc == eTitleMenu1 )
			{
				mTitleSel1SetRGBA();
			}
			//̉e̐FύX
			for( i = 0; i < TITLE_STRING_MAX; i++ )
			{
				if( &mStr[i] == NULL )
				{
					break;
				}else
				{
					//null珈Ȃ
					if( mStr[i].sprtShadow != NULL )
					{
						//̐[v
						for( j = 0; j < mStr[i].length; j++ )
						{
							//\Ă邩mF
							if( mStr[i].sprtShadow[j].mGetDispFlag() == true )
							{
								//Fݒ
							//	mStr[i].sprtShadow[j].mSetRGBA( (mRGBAShadow & 0xffffff00) || (mStr[i].sprtShadow[j].mGetA()) );
								mStr[i].sprtShadow[j].mSetRGBA( mRGBAShadow );
							}
						}
					}
				}
			}
			mProc = eTitleChangeWait;
			break;
		
		//ւ菈I҂
		case	eTitleChangeWait:
		//	if( mSprtLogo.mGetFadeEnd() == true )
			if( mpSprtLogo->mGetFadeEnd() == true )
			{
				mFadeWaitTick = TITLE_FADEIN_WAIT_TICK;
				mFadeInFlag   = true;
				mProc         = eTitleDispTitle;
			}
			break;
		
		default:
			break;
	}
}
//-----------------------------------------------------------------------------
//[vĎ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
bool
MK7TitleTask::mCheckTitleLoop( void )
{
	int	i, j;
	
	//[vԌvZ
	if( mLoopTime <= 0 )
	{
		//CGtFNgXvCg
		mTitleLogoLineInit();
		//tF[hAEgݒ
		mpSprtLogo->mSetFade( 0, TITLE_LOOP_FADE_TICK );
		mpSprtBlar->mSetFade( 0, TITLE_LOOP_FADE_TICK );
	//	mSprtLogo.mSetFade( 0, TITLE_LOOP_FADE_TICK );
	//	mSprtBlar.mSetFade( 0, TITLE_LOOP_FADE_TICK );
		for( i = 0; i < TITLE_STRING_MAX; i++ )
		{
			if( mStr[i].str != NULL )
			{
				for( j = 0; j < mStr[i].length; j++ )
				{
					mStr[i].sprt[j].mSetFade( 0, TITLE_LOOP_FADE_TICK );
					mStr[i].sprtShadow[j].mSetFade( 0, TITLE_LOOP_FADE_TICK );
				}
			}
		}
		//ȍĐ
		gpSound->mPrepareStreamNo( HPS_TITLE_BACK );
		//[vԏ
		mLoopTime = TITLE_LOOP_TICK;
		//VKtHg̃NGXgtO
		mFontRequest = true;
		//\vZX
		mTitleMenuProc = eTitleMenu;
		return( true );
	}else
	{
		if( mTitleMenuProc == eTitleMenu )
		{
			mLoopTime -= WK7_TICK_PER_FRAME;
		}else
		{
			mLoopTime = TITLE_LOOP_TICK;
		}
	}
	
	return( false );
}
//-----------------------------------------------------------------------------
//j[̏
// in --> none
// out -> none
//-----------------------------------------------------------------------------
bool
MK7TitleTask::mTitleMenuStrProc( void )
{
	int	i;
	
	//j[̏
	if( (mProc == eTitleFadeWait) || (mProc == eTitleDispTitle) || (mProc == eTitleChange) || (mProc == eTitleChangeWait) )
	{
		//\
		switch( mTitleMenuProc )
		{
			// PRESS GAME START
			case	eTitleMenu:
				if( mFontRequest )
				{
					mTitleFontReq( &mStr[0], TITLE_PRE_X, TITLE_PRE_Y, TITLE_PRE_STR );
					if( mTitleSel1 == eTitleSelKiller1 )
					{
						mTitleFontSetRGBA( &mStr[0], TITLE1_SEL_RGBA );
					}else
					if( mTitleSel1 == eTitleSelHopper7 )
					{
						mTitleFontSetRGBA( &mStr[0], TITLE2_SEL_RGBA );
					}else
					{
						mTitleFontSetRGBA( &mStr[0], TITLE_SEL_RGBA );
					}
					mTitleFontSpread( 0, TITLE_SPREAD_TICK );	//L
					mSecretModeClear();
					mFontRequest = false;
				}else
				{
					//Z`FbN
					mSecretModeCheck();
					//pbh
					if( HSD_PadGetTrigger(0) == PAD_BUTTON_START )
					{
						gpSound->mPlaySE( SFX_TITLE_START );
						mFontRequest   = true;
						//Killer1I\
						if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_GAME_CLEAR) == false )
						{
							mTitleMenuProc = eTitleMenu0;
						}else
						{
							mTitleMenuProc = eTitleMenu1;
						}
					}
				}
				break;
			
			// Killer7, Killer1, Hopper7
			case	eTitleMenu1:
				if( mFontRequest )
				{
					//ƍWݒ
					mTitleFontReq( &mStr[0], TITLE_K7_X, TITLE_K7_Y, TITLE_K7_STR );
					mTitleFontReq( &mStr[1], TITLE_K1_X, TITLE_K1_Y, TITLE_K1_STR );
					mExtModeNum = eTitleSel1Max;
					if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_GAME_CLEAR_K8) == false )
					{
						mExtModeNum = eTitleSel1Max - 1;
					}else
					{
						mTitleFontReq( &mStr[2], TITLE_H7_X, TITLE_H7_Y, TITLE_H7_STR );
					}
					mTitleFontMove( mExtModeNum );
					mTitleSel1SetRGBA();
					mFontRequest = false;
				}else
				{
					//pbh
					if( (HSD_PadGetTrigger(0) == PAD_BUTTON_START)
					 || (HSD_PadGetTrigger(0) == PAD_BUTTON_A) )
					{
						// KILLER7 KILLER1 HOPPER7 I
						if( ((mTitleSel1 == eTitleSelKiller7) && (mSelectFlag & TITLE_SEL_K7))
						 || ((mTitleSel1 == eTitleSelKiller1) && (mSelectFlag & TITLE_SEL_K1))
						 || ((mTitleSel1 == eTitleSelHopper7) && (mSelectFlag & TITLE_SEL_H7)) )
						{
							//tOݒ
							switch( mTitleSel1 )
							{
								case	eTitleSelKiller7:
									K7SCR_RESET_GLOBAL_FLAG( K7GLFL_KILLER1 );
									K7SCR_RESET_GLOBAL_FLAG( K7GLFL_HOPPER7 );
									break;
								case	eTitleSelKiller1:
									K7SCR_SET_GLOBAL_FLAG( K7GLFL_KILLER1 );
									K7SCR_RESET_GLOBAL_FLAG( K7GLFL_HOPPER7 );
									break;
								case	eTitleSelHopper7:
									K7SCR_RESET_GLOBAL_FLAG( K7GLFL_KILLER1 );
									K7SCR_SET_GLOBAL_FLAG( K7GLFL_HOPPER7 );
									break;
							}
							mClearStrData();
							gpSound->mPlaySE( SFX_SYS_DECIDE );
							mFontRequest   = true;
							mTitleMenuProc = eTitleMenu0;
						}else
						//IׂȂ̂肵Ƃ
						{
							gpSound->mPlaySE( SFX_SYS_CANCEL );
						}
					}else
					if( (HSD_PadGetTrigger(0) == HSD_PAD_STICK_DOWN)
					 || (HSD_PadGetTrigger(0) == PAD_BUTTON_DOWN) )
					{
						if( mTitleSel1 < (mExtModeNum-1) )
						{
							mTitleSel1 = (enTitleSel1)((int)mTitleSel1 + 1);
							gpSound->mPlaySE( SFX_TITLE_CURSOR );
							mTitleFontMove( mExtModeNum );
							mTitleSel1SetRGBA();
							mChangeTitle();
						}
					//	mTitleSel1 = (enTitleSel1)(((u32)mTitleSel1 + 1) % mExtModeNum);
					}else
					if( (HSD_PadGetTrigger(0) == HSD_PAD_STICK_UP)
					 || (HSD_PadGetTrigger(0) == PAD_BUTTON_UP) )
					{
						if( mTitleSel1 > eTitleSelKiller7)
						{
							mTitleSel1 = (enTitleSel1)((int)mTitleSel1 - 1);
							gpSound->mPlaySE( SFX_TITLE_CURSOR );
							mTitleFontMove( mExtModeNum );
							mTitleSel1SetRGBA();
							mChangeTitle();
						}
					//	mTitleSel1 = (enTitleSel1)(((u32)mTitleSel1 + (mExtModeNum - 1)) % mExtModeNum);
					}
				}
				break;
			
			
			// NEW, CONTINUE, OPTION
			case	eTitleMenu0:
				if( mFontRequest )
				{
					//ƍWݒ
					mTitleFontReq( &mStr[0], TITLE_NEW_X, TITLE_NEW_Y, TITLE_NEW_STR );
					mTitleFontReq( &mStr[1], TITLE_CON_X, TITLE_CON_Y, TITLE_CON_STR );
					mTitleFontReq( &mStr[2], TITLE_OPT_X, TITLE_OPT_Y, TITLE_OPT_STR );
					mTitleFontMove( eTitleSel0Max );
					mTitleSel0SetRGBA();
					mFontRequest = false;
				}else
				{
					//pbh
					if( (HSD_PadGetTrigger(0) == PAD_BUTTON_START)
					 || (HSD_PadGetTrigger(0) == PAD_BUTTON_A) )
					{
						// new continue opt I
						if( ((mTitleSel0 == eTitleSelNew) && (mSelectFlag & TITLE_SEL_NEW))
						 || ((mTitleSel0 == eTitleSelCon) && (mSelectFlag & TITLE_SEL_CON))
						 || ((mTitleSel0 == eTitleSelOpt) && (mSelectFlag & TITLE_SEL_OPT)) )
						{
							gpSound->mFadeVolumeStream( 0, 200 );
							mSetTitleFadeOut( (u32)mTitleSel0 );
							mTitleMenuProc = eTitleMenuFadeOut;
						}else
						//IׂȂ̂肵Ƃ
						{
							gpSound->mPlaySE( SFX_SYS_CANCEL );
						}
					}else
					if( HSD_PadGetTrigger(0) == PAD_BUTTON_B )
					{
						if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_GAME_CLEAR) == true )
						{
							mClearStrData();
							mTitleSel0 = eTitleSelNew;
							mFontRequest = true;
							gpSound->mPlaySE( SFX_SYS_CANCEL );
							mTitleMenuProc = eTitleMenu1;
						}
					}else
					if( (HSD_PadGetTrigger(0) == HSD_PAD_STICK_DOWN)
					 || (HSD_PadGetTrigger(0) == PAD_BUTTON_DOWN) )
					{
						if( mTitleSel0 < eTitleSelOpt )
						{
							mTitleSel0 = (enTitleSel0)((int)mTitleSel0 + 1);
							gpSound->mPlaySE( SFX_TITLE_CURSOR );
							mTitleFontMove( eTitleSel0Max );
							mTitleSel0SetRGBA();
						}
						//mTitleSel0 = (enTitleSel0)(((u32)mTitleSel0 + 1) % eTitleSel0Max);
					}else
					if( (HSD_PadGetTrigger(0) == HSD_PAD_STICK_UP)
					 || (HSD_PadGetTrigger(0) == PAD_BUTTON_UP) )
					{
						if( mTitleSel0 > eTitleSelNew )
						{
							mTitleSel0 = (enTitleSel0)((int)mTitleSel0 - 1);
							gpSound->mPlaySE( SFX_TITLE_CURSOR );
							mTitleFontMove( eTitleSel0Max );
							mTitleSel0SetRGBA();
						}
						//mTitleSel0 = (enTitleSel0)(((u32)mTitleSel0 + (eTitleSel0Max - 1)) % eTitleSel0Max);
					}
				}
				break;
			
			//tF[hAEg
			case	eTitleMenuFadeOut:
				//S̃tF[hI\ɂ
				if( mpSprtLogo->mGetFadeEnd() == true ){ mpSprtLogo->mSetDispFlag( false ); }
				if( mpSprtBlar->mGetFadeEnd() == true ){ mpSprtBlar->mSetDispFlag( false ); }
				//΂SEĐԂ̊ԑ҂
				if( mVoicePlayTick <= 0 )
				{
					//Iꂽ̃tF[hAEgݒ
					for( i = 0; i < mStr[mGetSelectNo()].length; i++ )
					{
						mStr[mGetSelectNo()].sprt[i].mSetFade( 0, TITLE_STR_FADEOUT_TICK );
					}
					//VKQ[łΓՓxI\
					if( mTitleSel0 == eTitleSelNew )
					{
						mDispDifficult();
					}
					mTitleMenuProc = eTitleMenuStrFadeOut;
				}else
				{
					//ĐԂJEg
					mVoicePlayTick -= WK7_TICK_PER_FRAME;
					//tF[hAEgɕ̍Wh炷o
					mTitleFontShake();
				}
				break;
			
			case	eTitleMenuStrFadeOut:
				//S̃tF[hI\ɂ
				if( mpSprtLogo->mGetFadeEnd() == true ){ mpSprtLogo->mSetDispFlag( false ); }
				if( mpSprtBlar->mGetFadeEnd() == true ){ mpSprtBlar->mSetDispFlag( false ); }
				//Iꂽj[̃tF[hAEg҂
				if( mStr[mGetSelectNo()].sprt[0].mGetFadeEnd() == true )
				{
					GHMGCMEM_SAFE_FREE( mOrgX );
					GHMGCMEM_SAFE_FREE( mOrgY );
					//VKQ[łΓՓxI
					if( mTitleSel0 == eTitleSelNew )
					{
						mTitleMenuProc = eTitleMenu2;
						if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1) == true )
						{
							gpSound->mPlayStreamNo( TITILE_KETTOU_HPS, 255 );
							gpSound->mSetPitchStream( 0 );
						}else
						if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_HOPPER7) == true )
						{
							gpSound->mPlayStreamNo( TITILE_BATTOU_HPS, 255 );
							gpSound->mSetPitchStream( 0 );
						}else
						{
						//	gpSound->mPlayStreamNo( TITILE_KANTOU_HPS, 255 );
							gpSound->mPlayStreamNo( TITILE_SHITOU_HPS, 255 );
							gpSound->mSetPitchStream( 0 );
						}
					}else
					{
						DeleteTerminate();
					}
					return false;
				}else
				{
					//tF[hAEgɕ̍Wh炷o
					mTitleFontShake();
				}
				break;
			
			//ՓxI
			case	eTitleMenu2:
				//pbh
				if( (HSD_PadGetTrigger(0) == PAD_BUTTON_START)
				 || (HSD_PadGetTrigger(0) == PAD_BUTTON_A) )
				{
					gpSound->mFadeVolumeStream( 0, 200 );
					gpSound->mPlaySE( SFX_SYS_NANIDO_KETTEI );
					mSetFadeOutDifficult();
					//ՓxtOݒ
					if( mTitleSel2 == eTitleSelDifficult0 )
					{
						K7SCR_SET_GLOBAL_FLAG( K7GLFL_EASY_MODE );
					}else
					{
						K7SCR_RESET_GLOBAL_FLAG( K7GLFL_EASY_MODE );
					}
					//Killer8 Hopper7 ̏ꍇ EASY[h
					if( (K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1) == true)
					 || (K7SCR_GET_GLOBAL_FLAG(K7GLFL_HOPPER7) == true) )
					{
						K7SCR_RESET_GLOBAL_FLAG( K7GLFL_EASY_MODE );
					}
					mTitleMenuProc = eTitleMenu2FadeOut;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_B )
				{
					mpSprtLogo->mSetA( 0xff );
					mpSprtLogo->mSetDispFlag( true );
					mpSprtBlar->mSetDispFlag( true );
					mSetUndispDifficult();
					mClearStrData();
					mFontRequest = true;
					gpSound->mPlaySE( SFX_SYS_CANCEL );
					gpSound->mFadeVolumeStream( 0, 100 );
					mTitleSel2     = eTitleSelDifficult0;
					mTitleMenuProc = eTitleMenu0;
				}else
				if( (K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1) == false)
				 && (K7SCR_GET_GLOBAL_FLAG(K7GLFL_HOPPER7) == false) )
				{
					if( (mTitleSel2 == eTitleSelDifficult0)
					 && ((HSD_PadGetTrigger(0) == HSD_PAD_STICK_DOWN) || (HSD_PadGetTrigger(0) == PAD_BUTTON_DOWN)) )
					{
					//	gpSound->mPlayStreamNo( TITILE_SHITOU_HPS, 255 );
						gpSound->mSetPitchStream( 300 );
						gpSound->mPlaySE( SFX_SYS_NANIDO_SENTAKU );
						mTitleSel2 = eTitleSelDifficult1;
						mChangeBlink();
					}else
					if( (mTitleSel2 == eTitleSelDifficult1)
					 && ((HSD_PadGetTrigger(0) == HSD_PAD_STICK_UP) || (HSD_PadGetTrigger(0) == PAD_BUTTON_UP)) )
					{
					//	gpSound->mPlayStreamNo( TITILE_KANTOU_HPS, 255 );
						gpSound->mSetPitchStream( 0 );
						gpSound->mPlaySE( SFX_SYS_NANIDO_SENTAKU );
						mTitleSel2 = eTitleSelDifficult0;
						mChangeBlink();
					}
				}
				break;
			
			//ՓxItF[hAEg
			case	eTitleMenu2FadeOut:
				if( mSprtNanido.mGetFadeEnd() == true )
				{
					DeleteTerminate();
				}
				break;
			
			default:
				DeleteTerminate();
				return false;
		}
	}
	return true;
}
//-----------------------------------------------------------------------------
//j[̉eʉɈړ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mTitleFontShadowProc( void )
{
	int	i, j;
	s32	tick;
	f32	scale;
	
	//^CgS\̂݉ɗ
	if( (mProc == eTitleFadeWait) || (mProc == eTitleDispTitle) || (mProc == eTitleChange) || (mProc == eTitleChangeWait) )
	{
		//I𕶎tF[hAEgtF[hAEgさՓxI𒆂͗Ȃ
		if( (mTitleMenuProc == eTitleMenuFadeOut)
		 || (mTitleMenuProc == eTitleMenuStrFadeOut)
		 || (mTitleMenuProc == eTitleMenu2)
		 || (mTitleMenuProc == eTitleMenu2FadeOut) )
		{
			for( i = 0; i < TITLE_STRING_MAX; i++ )
			{
				if( &mStr[i] == NULL )
				{
					break;
				}else
				{
					//null珈Ȃ
					if( mStr[i].sprtShadow != NULL )
					{
						//̐[v
						for( j = 0; j < mStr[i].length; j++ )
						{
							//\Ă邩mF
							if( mStr[i].sprtShadow[j].mGetDispFlag() == true )
						//	 && (mStr[i].sprtShadow[j].mGetFadeEnd() == true) )
							{
								//tF[hAEgݒ
								mStr[i].sprtShadow[j].mSetFade( 0, 1200 );
							}
						}
					}
				}
			}
		}else
		{
			for( i = 0; i < TITLE_STRING_MAX; i++ )
			{
				if( &mStr[i] == NULL )
				{
					break;
				}else
				{
					//null珈Ȃ
					if( mStr[i].sprtShadow != NULL )
					{
						//̐ʉɗƂݒ
						for( j = 0; j < mStr[i].length; j++ )
						{
							//\Ă邩mF
							if( mStr[i].sprtShadow[j].mGetDispFlag() == true )
							{
								//ȅԂŏ𕪊򂳂
								switch( mStr[i].shadowProc[j] )
								{
									//cg咆
									case	eTitleShadowScale:
										//cg又IĂ牺ɗ鏈ݒ肷
										if( mStr[i].sprtShadow[j].mGetScaleEnd() == true )
										{
											//ɂ鎞ԂZo
											tick = HSD_Randi(TITLE_SHADOW_DROP_TICK) + (TITLE_SHADOW_DROP_TICK / 4);
											mStr[i].sprtShadow[j].mSetMove( mStr[i].sprtShadow[j].mGetX0(), (f32)K7APP_SCREEN_HEIGHT, tick );
											mStr[i].sprtShadow[j].mSetFade( 0, tick );
											mStr[i].sprtShadow[j].mSetScale( eScaleH, 1.0f, tick );
											mStr[i].shadowProc[j] = eTitleShadowDrop;
										}else
										{
											//cg咆XWɈlɂ
											mStr[i].sprtShadow[j].mSetX0( mStr[i].sprtShadow[j].mGetX0() );
										}
										break;
									
									//
									case	eTitleShadowDrop:
										//ɗIcg鏈ݒ肷
										if( mStr[i].sprtShadow[j].mGetMoveEnd() == true )
										{
											//W
											mStr[i].sprtShadow[j].mSetXY0( mStr[i].sprt[j].mGetX0(), mStr[i].sprt[j].mGetY0() );
											//cgɂ鎞ԂZo
											tick  = HSD_Randi(TITLE_SHADOW_DROP_TICK) + TITLE_SHADOW_DROP_TICK * 2;
											//cg嗦Zo
											scale = (f32)((f32)(HSD_Randi(TITLE_SHADOW_MAX_SCALE - TITLE_SHADOW_MIN_SCALE) + TITLE_SHADOW_MIN_SCALE) / 100.0f);
											//WL[v&cg嗦ݒ
											mStr[i].sprtShadow[j].mSetMove( mStr[i].sprt[j].mGetX0(), mStr[i].sprt[j].mGetY0(), tick );
											mStr[i].sprtShadow[j].mSetScale( eScaleH, scale, tick );
											mStr[i].sprtShadow[j].mSetFade( 255, tick );
											mStr[i].shadowProc[j] = eTitleShadowScale;
										}
										break;
									
									//ftHg
									default:
										break;
								}
							}
						}
					}
				}
			}
		}
	}
}




//-----------------------------------------------------------------------------
//LZ̃tF[hAEgĂяo
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mSetLogoEffectCancel( void )
{
	int	i;
	
	//̑xōxɐݒ
	mLineSpeed = 1.0f;
	
	//7̍ŏIpx
	mLineAngle = (f32)TITLE_LINE_SEVEN_ANGLE;
	
	//GtFNgtF[hAEg
	for( i = 0; i < TITLE_LOGO_X_LINE_MAX; i++ )
	{
		mLineX[i].sprt.mSetA( TITLE_LINE_ALPHA );
		mLineX[i].sprt.mSetFade( 0, TITLE_EFEECT_CANSEL_TICK );
		mLineX[i].sprt.mSetDispFlag( false );
	}
	for( i = 0; i < TITLE_LOGO_Y_LINE_MAX; i++ )
	{
		mLineY[i].sprt.mSetA( TITLE_LINE_ALPHA );
		mLineY[i].sprt.mSetFade( 0, TITLE_EFEECT_CANSEL_TICK );
		mLineY[i].sprt.mSetDispFlag( false );
	}
	//GtFNgtF[hAEg
	for( i = 0; i < TITLE_LOGO_BOX_MAX; i++ )
	{
		mBox[i].box.mSetA( TITLE_BOX_ALPHA );
		mBox[i].box.mSetFade( 0, TITLE_EFEECT_CANSEL_TICK );
	}
	
	//SE~
	for( i = 0; i < TITLE_LOGO_X_LINE_MAX; i++ )
	{
		if( mLineXSENo[i] != -1 )
			gpSound->mSetVolumeSENo( mLineXSENo[i], 0, TITLE_LINE_SE_FADE_SPEED );
	}
	for( i = 0; i < TITLE_LOGO_Y_LINE_MAX; i++ )
	{
		if( mLineYSENo[i] != -1 )
			gpSound->mSetVolumeSENo( mLineYSENo[i], 0, TITLE_LINE_SE_FADE_SPEED );
	}
	//SEĐ
	gpSound->mPlaySE( SFX_TITLE_LOGO );
	gpSound->mPlaySE( SFX_TITLE_MOJI );
	//HPS~
	gpSound->mFadeVolumeStream( 0, TITLE_LINE_SE_FADE_SPEED );
	//^CgȍĐJn
	gpSound->mJustPlayStream();
}
//-----------------------------------------------------------------------------
//S̍Wݒ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mSetTitleLogoBoxLocate( void )
{
	int	i;
	s16	offsetX, offsetY;
	
	for( i = 0; i < TITLE_LOGO_BOX_MAX; i++ )
	{
		//Kɂ炷Wl
		if( HSD_Randi(100) < TITLE_BOX_OFFSET_RATE )
		{
			offsetX = (s16)(HSD_Randi(TITLE_BOX_OFFSET) - (TITLE_BOX_OFFSET / 2));
			offsetY = (s16)(HSD_Randi(TITLE_BOX_OFFSET) - (TITLE_BOX_OFFSET / 2));
		}else
		{
			offsetX = 0;
			offsetY = 0;
		}
		//Wݒ
		mBox[i].wait = HSD_Randi(TITLE_BOX_DISP_WAIT) + 1;
		mBox[i].box.mSetTransformBoxPrim();
		mBox[i].box.mSetPriority( SPRT_PRI_TITLE_LOGO_LINEBOX );
		mBox[i].box.mSetX0( (f32)(gTblBoxX0[i] + offsetX) );
		mBox[i].box.mSetY0( (f32)(gTblBoxY0[i] + offsetY) );
		mBox[i].box.mSetX1( (f32)(gTblBoxX1[i] + offsetX) );
		mBox[i].box.mSetY1( (f32)(gTblBoxY0[i] + offsetY) );
		mBox[i].box.mSetX2( (f32)(gTblBoxX2[i] + offsetX) );
		mBox[i].box.mSetY2( (f32)(gTblBoxY2[i] + offsetY) );
		mBox[i].box.mSetX3( (f32)(gTblBoxX3[i] + offsetX) );
		mBox[i].box.mSetY3( (f32)(gTblBoxY2[i] + offsetY) );
		if( mTitleSel1 == eTitleSelKiller1 )
		{
			mBox[i].box.mSetRGBA( TITLE_BOX_RGBA1 );
		}else
		if( mTitleSel1 == eTitleSelHopper7 )
		{
			mBox[i].box.mSetRGBA( TITLE_BOX_RGBA2 );
		}else
		{
			mBox[i].box.mSetRGBA( TITLE_BOX_RGBA );
		}
		mBox[i].box.mSetDispFlag( true );
	}
}




//-----------------------------------------------------------------------------
//ǂݍ񂾃f[^̏
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mSetTitleData( void )
{
	//CGtFNgXvCg
	mTitleLogoLineInit();
	
	//f[^AhXݒ
	mFont.dat         = (stSentence*)mReslink->GetResource( eTitleFontDat );
	mTexLogo.tex      = (GhmGcTexHeader*)mReslink->GetResource( eTitleKiller7 );
	mTexBlar.tex      = (GhmGcTexHeader*)mReslink->GetResource( eTitleKiller7Blar );
	mTexLogo1.tex     = (GhmGcTexHeader*)mReslink->GetResource( eTitleKiller1 );
	mTexBlar1.tex     = (GhmGcTexHeader*)mReslink->GetResource( eTitleKiller1Blar );
	mTexNanido.tex    = (GhmGcTexHeader*)mReslink->GetResource( eTitleNanido );
	mTexKanjiGeki.tex = (GhmGcTexHeader*)mReslink->GetResource( eTitleKanjiGeki );
	mTexKanjiTouA.tex = (GhmGcTexHeader*)mReslink->GetResource( eTitleKanjiTouA );
	mTexColonA.tex    = (GhmGcTexHeader*)mReslink->GetResource( eTitleColonA );
	mTexTextA01.tex   = (GhmGcTexHeader*)mReslink->GetResource( eTitleTextA01 );
	mTexTextA02.tex   = (GhmGcTexHeader*)mReslink->GetResource( eTitleTextA02 );
	mTexKanjiShi.tex  = (GhmGcTexHeader*)mReslink->GetResource( eTitleKanjiShi );
	mTexKanjiTouB.tex = (GhmGcTexHeader*)mReslink->GetResource( eTitleKanjiTouB );
	mTexColonB.tex    = (GhmGcTexHeader*)mReslink->GetResource( eTitleColonB );
	mTexTextB01.tex   = (GhmGcTexHeader*)mReslink->GetResource( eTitleTextB01 );
	mTexTextB02.tex   = (GhmGcTexHeader*)mReslink->GetResource( eTitleTextB02 );
	mTexKanjiTi.tex   = (GhmGcTexHeader*)mReslink->GetResource( eTitleKanjiTi );
	mTexTextC.tex     = (GhmGcTexHeader*)mReslink->GetResource( eTitleTextC );
	mTexLogo2.tex     = (GhmGcTexHeader*)mReslink->GetResource( eTitleHopper7 );
	mTexBlar2.tex     = (GhmGcTexHeader*)mReslink->GetResource( eTitleHopper7Blar );
	mTexKanjiBat.tex  = (GhmGcTexHeader*)mReslink->GetResource( eTitleKanjiBat );
	mTexTextD.tex     = (GhmGcTexHeader*)mReslink->GetResource( eTitleTextD );
	
	//eNX`
	mK7InitTexture( &mTexLogo );
	mK7InitTexture( &mTexBlar );
	mK7InitTexture( &mTexLogo1 );
	mK7InitTexture( &mTexBlar1 );
	mK7InitTexture( &mTexNanido );
	mK7InitTexture( &mTexKanjiGeki );
	mK7InitTexture( &mTexKanjiTouA );
	mK7InitTexture( &mTexColonA );
	mK7InitTexture( &mTexTextA01 );
	mK7InitTexture( &mTexTextA02 );
	mK7InitTexture( &mTexKanjiShi );
	mK7InitTexture( &mTexKanjiTouB );
	mK7InitTexture( &mTexColonB );
	mK7InitTexture( &mTexTextB01 );
	mK7InitTexture( &mTexTextB02 );
	mK7InitTexture( &mTexKanjiTi );
	mK7InitTexture( &mTexTextC );
	mK7InitTexture( &mTexLogo2 );
	mK7InitTexture( &mTexBlar2 );
	mK7InitTexture( &mTexKanjiBat );
	mK7InitTexture( &mTexTextD );
	
	//fontf[^
	//uvwhf[^ւ̃AhXݒ
	mFont.fontParam = (stFontParam*)((char*)mFont.dat + mFont.dat->charOffset);
	//eNX`AhẌn
	mFont.fontTex.tex = (GhmGcTexHeader*)((char*)mFont.dat + mFont.dat->texOffset);
	//eNX`̏
	mK7InitTexture( &mFont.fontTex );
	
	//Killer7 XvCg
	mSprtLogo.mRelateTex( &mTexLogo );
	mSprtLogo.mSetPriority( SPRT_PRI_TITLE_LOGO );
	mSprtLogo.mSetWH( (s16)(mTexLogo.tex->mWidth), (s16)(mTexLogo.tex->mHeight) );
	mSprtLogo.mSetUV0( 0, 0 );
	mSprtLogo.mSetXY0( 0, 0 );
	mSprtLogo.mSetA( 255 );
	mSprtLogo.mSetDispFlag( false );
	
	//Killer7 blar XvCg
	mSprtBlar.mRelateTex( &mTexBlar );
	mSprtBlar.mSetPriority( SPRT_PRI_TITLE_BLAR );
	mSprtBlar.mSetWH( (s16)(mTexBlar.tex->mWidth), (s16)(mTexBlar.tex->mHeight) );
	mSprtBlar.mSetUV0( 0, 0 );
	mSprtBlar.mSetXY0( 0, 0 );
	mSprtBlar.mSetA( 0 );
	mSprtBlar.mSetDispFlag( false );
	
	//Killer1 XvCg
	mSprtLogo1.mRelateTex( &mTexLogo1 );
	mSprtLogo1.mSetPriority( SPRT_PRI_TITLE_LOGO );
	mSprtLogo1.mSetWH( (s16)(mTexLogo1.tex->mWidth), (s16)(mTexLogo1.tex->mHeight) );
	mSprtLogo1.mSetUV0( 0, 0 );
	mSprtLogo1.mSetXY0( 0, 0 );
	mSprtLogo1.mSetA( 255 );
	mSprtLogo1.mSetDispFlag( false );
	
	//Killer1 blar XvCg
	mSprtBlar1.mRelateTex( &mTexBlar1 );
	mSprtBlar1.mSetPriority( SPRT_PRI_TITLE_BLAR );
	mSprtBlar1.mSetWH( (s16)(mTexBlar1.tex->mWidth), (s16)(mTexBlar1.tex->mHeight) );
	mSprtBlar1.mSetUV0( 0, 0 );
	mSprtBlar1.mSetXY0( 0, 0 );
	mSprtBlar1.mSetA( 0 );
	mSprtBlar1.mSetDispFlag( false );
	
	//Hopper7 XvCg
	mSprtLogo2.mRelateTex( &mTexLogo2 );
	mSprtLogo2.mSetPriority( SPRT_PRI_TITLE_LOGO );
	mSprtLogo2.mSetWH( (s16)(mTexLogo2.tex->mWidth), (s16)(mTexLogo2.tex->mHeight) );
	mSprtLogo2.mSetUV0( 0, 0 );
	mSprtLogo2.mSetXY0( 0, 0 );
	mSprtLogo2.mSetA( 255 );
	mSprtLogo2.mSetDispFlag( false );
	
	//Hopper7 blar XvCg
	mSprtBlar2.mRelateTex( &mTexBlar2 );
	mSprtBlar2.mSetPriority( SPRT_PRI_TITLE_BLAR );
	mSprtBlar2.mSetWH( (s16)(mTexBlar2.tex->mWidth), (s16)(mTexBlar2.tex->mHeight) );
	mSprtBlar2.mSetUV0( 0, 0 );
	mSprtBlar2.mSetXY0( 0, 0 );
	mSprtBlar2.mSetA( 0 );
	mSprtBlar2.mSetDispFlag( false );
	
	//Փx
	mInitDifficultSprt( &mSprtNanido,    &mTexNanido,    385,  22 );
	//
	mInitDifficultSprt( &mSprtKanjiGeki, &mTexKanjiGeki,  62,  86 );
	mInitDifficultSprt( &mSprtKanjiTouA, &mTexKanjiTouA, 111,  92 );
	mInitDifficultSprt( &mSprtColonA,    &mTexColonA,    160, 102 );
	mInitDifficultSprt( &mSprtTextA01,   &mTexTextA01,   143, 148 );
	mInitDifficultSprt( &mSprtTextA02,   &mTexTextA02,   224, 175 );
	//
	mInitDifficultSprt( &mSprtKanjiShi,  &mTexKanjiShi,   64, 249 );
	mInitDifficultSprt( &mSprtKanjiTouB, &mTexKanjiTouB, 114, 247 );
	mInitDifficultSprt( &mSprtColonB,    &mTexColonB,    163, 260 );
	mInitDifficultSprt( &mSprtTextB01,   &mTexTextB01,   103, 307 );
	mInitDifficultSprt( &mSprtTextB02,   &mTexTextB02,   223, 336 );
	//
	mInitDifficultSprt( &mSprtKanjiTi,   &mTexKanjiTi,   132, 197 );
	mInitDifficultSprt( &mSprtKanjiTouC, &mTexKanjiTouA, 181, 200 );
	mInitDifficultSprt( &mSprtColonC,    &mTexColonA,    228, 207 );
	mInitDifficultSprt( &mSprtTextC,     &mTexTextC,     257, 212 );
	//囓
	mInitDifficultSprt( &mSprtKanjiBat,  &mTexKanjiBat,   62, 197 );
	mInitDifficultSprt( &mSprtKanjiTouD, &mTexKanjiTouA, 111, 200 );
	mInitDifficultSprt( &mSprtColonD,    &mTexColonA,    158, 207 );
	mInitDifficultSprt( &mSprtTextD,     &mTexTextD,     187, 212 );
	
	//tF[hCEGCgݒ
	mFadeWaitTick = TITLE_FADEIN_WAIT_TICK;
	//CGtFNg\Ԃݒ
	mEffectWait = TITLE_LINE_DISP_TICK;
}
//-----------------------------------------------------------------------------
//ՓxIXvCg
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mInitDifficultSprt( mK7Sprite* inSprt, stTexture* inTex, s16 inX, s16 inY )
{
	inSprt->mRelateTex( inTex );
	inSprt->mSetPriority( SPRT_PRI_TITLE_DIFFICULT );
	inSprt->mSetWH( (s16)(inTex->tex->mWidth), (s16)(inTex->tex->mHeight) );
	inSprt->mSetUV0( 0, 0 );
	inSprt->mSetXY0( inX, inY );
	inSprt->mSetRGBA( 0xffffff00 );
	inSprt->mSetDispFlag( false );
}
//-----------------------------------------------------------------------------
//ՓxIʂ̕\
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mDispDifficult( void )
{
	//Փx
	mSprtNanido.mSetRGBA( TITLE_RGB_EXP );
	mSprtNanido.mSetDispFlag( true );
	mSprtNanido.mSetFade( TITILE_A100, TITLE_STR_FADEOUT_TICK );
	
	if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1) == true )
	{	//Killer1
		//
		mSprtKanjiTi.  mSetRGBA( TITLE_RGB_KET );
		mSprtKanjiTouC.mSetRGBA( TITLE_RGB_KET );
		mSprtColonC.   mSetRGBA( TITLE_RGB_KET );
		mSprtTextC.    mSetRGBA( TITLE_RGB_WHITE );
		mSprtKanjiTi.  mSetDispFlag( true );
		mSprtKanjiTouC.mSetDispFlag( true );
		mSprtColonC.   mSetDispFlag( true );
		mSprtTextC.    mSetDispFlag( true );
		mSprtKanjiTi.  mSetFade( TITILE_A90, TITLE_STR_FADEOUT_TICK );
		mSprtKanjiTouC.mSetFade( TITILE_A90, TITLE_STR_FADEOUT_TICK );
		mSprtColonC.   mSetFade( TITILE_A90, TITLE_STR_FADEOUT_TICK );
		mSprtTextC.    mSetFade( TITILE_A90, TITLE_STR_FADEOUT_TICK );
		mBlinkTi.blinkProc     = eTitleDifBrink;
		mBlinkTi.flame         = 0;
		mBlinkTouC.blinkProc   = eTitleDifBrink;
		mBlinkTouC.flame       = 0;
		mBlinkColonC.blinkProc = eTitleDifBrink;
		mBlinkColonC.flame     = 0;
		mBlinkTextC.blinkProc  = eTitleDifBrink;
		mBlinkTextC.flame      = 0;
	}else
	if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_HOPPER7) == true )
	{	//Hopper7
		//囓
		mSprtKanjiBat. mSetRGBA( TITLE_RGB_BAT );
		mSprtKanjiTouD.mSetRGBA( TITLE_RGB_BAT );
		mSprtColonD.   mSetRGBA( TITLE_RGB_BAT );
		mSprtTextD.    mSetRGBA( TITLE_RGB_WHITE );
		mSprtKanjiBat. mSetDispFlag( true );
		mSprtKanjiTouD.mSetDispFlag( true );
		mSprtColonD.   mSetDispFlag( true );
		mSprtTextD.    mSetDispFlag( true );
		mSprtKanjiBat. mSetFade( TITILE_A90, TITLE_STR_FADEOUT_TICK );
		mSprtKanjiTouD.mSetFade( TITILE_A90, TITLE_STR_FADEOUT_TICK );
		mSprtColonD.   mSetFade( TITILE_A90, TITLE_STR_FADEOUT_TICK );
		mSprtTextD.    mSetFade( TITILE_A90, TITLE_STR_FADEOUT_TICK );
		mBlinkBat.blinkProc    = eTitleDifBrink;
		mBlinkBat.flame        = 0;
		mBlinkTouD.blinkProc   = eTitleDifBrink;
		mBlinkTouD.flame       = 0;
		mBlinkColonD.blinkProc = eTitleDifBrink;
		mBlinkColonD.flame     = 0;
		mBlinkTextD.blinkProc  = eTitleDifBrink;
		mBlinkTextD.flame      = 0;
	}else
	{	//Killer7
		//
		mSprtKanjiGeki.mSetRGBA( TITLE_RGB_KAN );
		mSprtKanjiTouA.mSetRGBA( TITLE_RGB_KAN );
		mSprtColonA.   mSetRGBA( TITLE_RGB_KAN );
		mSprtTextA01.  mSetRGBA( TITLE_RGB_WHITE );
		mSprtTextA02.  mSetRGBA( TITLE_RGB_WHITE );
		mSprtKanjiGeki.mSetDispFlag( true );
		mSprtKanjiTouA.mSetDispFlag( true );
		mSprtColonA.   mSetDispFlag( true );
		mSprtTextA01.  mSetDispFlag( true );
		mSprtTextA02.  mSetDispFlag( true );
		//
		mSprtKanjiShi. mSetRGBA( TITLE_RGB_SHI );
		mSprtKanjiTouB.mSetRGBA( TITLE_RGB_SHI );
		mSprtColonB.   mSetRGBA( TITLE_RGB_SHI );
		mSprtTextB01.  mSetRGBA( TITLE_RGB_WHITE );
		mSprtTextB02.  mSetRGBA( TITLE_RGB_WHITE );
		mSprtKanjiShi. mSetDispFlag( true );
		mSprtKanjiTouB.mSetDispFlag( true );
		mSprtColonB.   mSetDispFlag( true );
		mSprtTextB01.  mSetDispFlag( true );
		mSprtTextB02.  mSetDispFlag( true );
		//
		if( mTitleSel2 == eTitleSelDifficult0 )
		{
			mSprtKanjiGeki.mSetFade( TITILE_A90, TITLE_STR_FADEOUT_TICK );
			mSprtKanjiTouA.mSetFade( TITILE_A90, TITLE_STR_FADEOUT_TICK );
			mSprtColonA.   mSetFade( TITILE_A90, TITLE_STR_FADEOUT_TICK );
			mSprtTextA01.  mSetFade( TITILE_A90, TITLE_STR_FADEOUT_TICK );
			mSprtTextA02.  mSetFade( TITILE_A90, TITLE_STR_FADEOUT_TICK );
			mSprtKanjiShi. mSetFade( TITILE_A25, TITLE_STR_FADEOUT_TICK );
			mSprtKanjiTouB.mSetFade( TITILE_A25, TITLE_STR_FADEOUT_TICK );
			mSprtColonB.   mSetFade( TITILE_A25, TITLE_STR_FADEOUT_TICK );
			mSprtTextB01.  mSetFade( TITILE_A25, TITLE_STR_FADEOUT_TICK );
			mSprtTextB02.  mSetFade( TITILE_A25, TITLE_STR_FADEOUT_TICK );
			mBlinkKanjiGeki.blinkProc = eTitleDifBrink;
			mBlinkKanjiGeki.flame     = 0;
			mBlinkKanjiTouA.blinkProc = eTitleDifBrink;
			mBlinkKanjiTouA.flame     = 0;
			mBlinkColonA.blinkProc    = eTitleDifBrink;
			mBlinkColonA.flame        = 0;
			mBlinkTextA01.blinkProc   = eTitleDifBrink;
			mBlinkTextA01.flame       = 0;
			mBlinkTextA02.blinkProc   = eTitleDifBrink;
			mBlinkTextA02.flame       = 0;
			mBlinkKanjiShi.blinkProc  = eTitleDifNoBrink;
			mBlinkKanjiShi.flame      = 0;
			mBlinkKanjiTouB.blinkProc = eTitleDifNoBrink;
			mBlinkKanjiTouB.flame     = 0;
			mBlinkColonB.blinkProc    = eTitleDifNoBrink;
			mBlinkColonB.flame        = 0;
			mBlinkTextB01.blinkProc   = eTitleDifNoBrink;
			mBlinkTextB01.flame       = 0;
			mBlinkTextB02.blinkProc   = eTitleDifNoBrink;
			mBlinkTextB02.flame       = 0;
		}else
		{
			mSprtKanjiGeki.mSetFade( TITILE_A25, TITLE_STR_FADEOUT_TICK );
			mSprtKanjiTouA.mSetFade( TITILE_A25, TITLE_STR_FADEOUT_TICK );
			mSprtColonA.   mSetFade( TITILE_A25, TITLE_STR_FADEOUT_TICK );
			mSprtTextA01.  mSetFade( TITILE_A25, TITLE_STR_FADEOUT_TICK );
			mSprtTextA02.  mSetFade( TITILE_A25, TITLE_STR_FADEOUT_TICK );
			mSprtKanjiShi. mSetFade( TITILE_A90, TITLE_STR_FADEOUT_TICK );
			mSprtKanjiTouB.mSetFade( TITILE_A90, TITLE_STR_FADEOUT_TICK );
			mSprtColonB.   mSetFade( TITILE_A90, TITLE_STR_FADEOUT_TICK );
			mSprtTextB01.  mSetFade( TITILE_A90, TITLE_STR_FADEOUT_TICK );
			mSprtTextB02.  mSetFade( TITILE_A90, TITLE_STR_FADEOUT_TICK );
			mBlinkKanjiGeki.blinkProc = eTitleDifNoBrink;
			mBlinkKanjiGeki.flame     = 0;
			mBlinkKanjiTouA.blinkProc = eTitleDifNoBrink;
			mBlinkKanjiTouA.flame     = 0;
			mBlinkColonA.blinkProc    = eTitleDifNoBrink;
			mBlinkColonA.flame        = 0;
			mBlinkTextA01.blinkProc   = eTitleDifNoBrink;
			mBlinkTextA01.flame       = 0;
			mBlinkTextA02.blinkProc   = eTitleDifNoBrink;
			mBlinkTextA02.flame       = 0;
			mBlinkKanjiShi.blinkProc  = eTitleDifBrink;
			mBlinkKanjiShi.flame      = 0;
			mBlinkKanjiTouB.blinkProc = eTitleDifBrink;
			mBlinkKanjiTouB.flame     = 0;
			mBlinkColonB.blinkProc    = eTitleDifBrink;
			mBlinkColonB.flame        = 0;
			mBlinkTextB01.blinkProc   = eTitleDifBrink;
			mBlinkTextB01.flame       = 0;
			mBlinkTextB02.blinkProc   = eTitleDifBrink;
			mBlinkTextB02.flame       = 0;
		}
	}
	
	mTitleDifProc = eTitleDifFadeIn;
}
//-----------------------------------------------------------------------------
//ՓxIʂ̏
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mDifficultProc( void )
{
	if( mTitleMenuProc == eTitleMenu2 )
	{
		switch( mTitleDifProc )
		{
			//tF[hC
			case	eTitleDifFadeIn:
				if( mSprtNanido.mGetFadeEnd() == true )
				{
					mTitleDifProc = eTitleDifExec;
				}
				break;
			
			//I
			case	eTitleDifExec:
				if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1) == true )
				{
					//
					mCallBlinkProc( &mSprtKanjiTi,   &mBlinkTi,     false );
					mCallBlinkProc( &mSprtKanjiTouC, &mBlinkTouC,   false );
					mCallBlinkProc( &mSprtColonC,    &mBlinkColonC, false );
					mCallBlinkProc( &mSprtTextC,     &mBlinkTextC,  true  );
				}else
				if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_HOPPER7) == true )
				{
					//囓
					mCallBlinkProc( &mSprtKanjiBat,  &mBlinkBat,    false );
					mCallBlinkProc( &mSprtKanjiTouD, &mBlinkTouD,   false );
					mCallBlinkProc( &mSprtColonD,    &mBlinkColonD, false );
					mCallBlinkProc( &mSprtTextD,     &mBlinkTextD,  true  );
				}else
				{
					//
					mCallBlinkProc( &mSprtKanjiGeki, &mBlinkKanjiGeki, false );
					mCallBlinkProc( &mSprtKanjiTouA, &mBlinkKanjiTouA, false );
					mCallBlinkProc( &mSprtColonA,    &mBlinkColonA,    false );
					mCallBlinkProc( &mSprtTextA01,   &mBlinkTextA01,   true  );
					mCallBlinkProc( &mSprtTextA02,   &mBlinkTextA02,   true  );
					//
					mCallBlinkProc( &mSprtKanjiShi,  &mBlinkKanjiShi,  false );
					mCallBlinkProc( &mSprtKanjiTouB, &mBlinkKanjiTouB, false );
					mCallBlinkProc( &mSprtColonB,    &mBlinkColonB,    false );
					mCallBlinkProc( &mSprtTextB01,   &mBlinkTextB01,   true  );
					mCallBlinkProc( &mSprtTextB02,   &mBlinkTextB02,   true  );
				}
				break;
			
			//tF[hAEg
			case	eTitleDifFadeOut:
				break;
			
			//ftHg
			default:
				break;
		}
	}
}
//-----------------------------------------------------------------------------
//ՓxĨtF[hAEgݒ
//-----------------------------------------------------------------------------
void
MK7TitleTask::mSetFadeOutDifficult( void )
{
	mSprtNanido.mSetFade( 0, TITLE_DIFF_FADE_OUT_TICK+100 );
	if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1) == true )
	{
		//
		mSprtKanjiTi.  mSetFade( 0, TITLE_DIFF_FADE_OUT_TICK );
		mSprtKanjiTouC.mSetFade( 0, TITLE_DIFF_FADE_OUT_TICK );
		mSprtColonC.   mSetFade( 0, TITLE_DIFF_FADE_OUT_TICK );
		mSprtTextC.    mSetFade( 0, TITLE_DIFF_FADE_OUT_TICK );
	}else
	if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_HOPPER7) == true )
	{
		//囓
		mSprtKanjiBat. mSetFade( 0, TITLE_DIFF_FADE_OUT_TICK );
		mSprtKanjiTouD.mSetFade( 0, TITLE_DIFF_FADE_OUT_TICK );
		mSprtColonD.   mSetFade( 0, TITLE_DIFF_FADE_OUT_TICK );
		mSprtTextD.    mSetFade( 0, TITLE_DIFF_FADE_OUT_TICK );
	}else
	{
		//
		mSprtKanjiGeki.mSetFade( 0, TITLE_DIFF_FADE_OUT_TICK );
		mSprtKanjiTouA.mSetFade( 0, TITLE_DIFF_FADE_OUT_TICK );
		mSprtColonA.   mSetFade( 0, TITLE_DIFF_FADE_OUT_TICK );
		mSprtTextA01.  mSetFade( 0, TITLE_DIFF_FADE_OUT_TICK );
		mSprtTextA02.  mSetFade( 0, TITLE_DIFF_FADE_OUT_TICK );
		//
		mSprtKanjiShi. mSetFade( 0, TITLE_DIFF_FADE_OUT_TICK );
		mSprtKanjiTouB.mSetFade( 0, TITLE_DIFF_FADE_OUT_TICK );
		mSprtColonB.   mSetFade( 0, TITLE_DIFF_FADE_OUT_TICK );
		mSprtTextB01.  mSetFade( 0, TITLE_DIFF_FADE_OUT_TICK );
		mSprtTextB02.  mSetFade( 0, TITLE_DIFF_FADE_OUT_TICK );
	}
}
//-----------------------------------------------------------------------------
//ՓxI̔\
//-----------------------------------------------------------------------------
void
MK7TitleTask::mSetUndispDifficult( void )
{
	mSprtNanido.mSetDispFlag( false );
	//
	mSprtKanjiGeki.mSetDispFlag( false );
	mSprtKanjiTouA.mSetDispFlag( false );
	mSprtColonA.   mSetDispFlag( false );
	mSprtTextA01.  mSetDispFlag( false );
	mSprtTextA02.  mSetDispFlag( false );
	//
	mSprtKanjiShi. mSetDispFlag( false );
	mSprtKanjiTouB.mSetDispFlag( false );
	mSprtColonB.   mSetDispFlag( false );
	mSprtTextB01.  mSetDispFlag( false );
	mSprtTextB02.  mSetDispFlag( false );
	//
	mSprtKanjiTi.  mSetDispFlag( false );
	mSprtKanjiTouC.mSetDispFlag( false );
	mSprtColonC.   mSetDispFlag( false );
	mSprtTextC.    mSetDispFlag( false );
	//囓
	mSprtKanjiBat. mSetDispFlag( false );
	mSprtKanjiTouD.mSetDispFlag( false );
	mSprtColonD.   mSetDispFlag( false );
	mSprtTextD.    mSetDispFlag( false );
}
//-----------------------------------------------------------------------------
//_ŏ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mCallBlinkProc( mK7Sprite* inSprt, stBlink* inBlink, bool inOnlyBlink )
{
	switch( inBlink->blinkProc )
	{
		//IꂽƂ
		case	eTitleDifBrinkSel:
			if( inBlink->flame == 0 )
			{
				inSprt->mSetFade( TITILE_A60, WK7_FRAME_TO_TICK(7) );
			}else
			if( inBlink->flame == 10 )
			{
				inSprt->mSetA( TITILE_A100 );
			}else
			if( inBlink->flame == 11 )
			{
				inSprt->mSetA( TITILE_A50 );
			}else
			if( inBlink->flame == 12 )
			{
				inSprt->mSetA( TITILE_A100 );
			}else
			if( inBlink->flame > 12 )
			{
				inBlink->blinkProc = eTitleDifBrink;
				inBlink->flame = -1;
			}
			break;
		
		//At@50%̏ԂɂȂ
		case	eTitleDifBrink1:
			if( inBlink->flame > 2 )
			{
				//1/3̊m5t[ڂœ_ŏ֖߂
				if( (HSD_Randi(3) == 0) || (inBlink->flame == 5) )
				{
					inBlink->blinkProc = eTitleDifBrink;
					inBlink->flame = -1;
				}
			}
			break;
		
		//_łȂȂ
		case	eTitleDifBrink2:
			if( inBlink->flame > 3 )
			{
				//1/4̊m7t[ڂœ_ŏ֖߂
				if( (HSD_Randi(4) == 0) || (inBlink->flame == 7) )
				{
					inBlink->blinkProc = eTitleDifBrink;
					inBlink->flame = -1;
				}
			}
			break;
		
		//_
		case	eTitleDifBrink:
			//At@90%100%œ_
			if( (inBlink->flame % 2) == 0 )
			{
				inSprt->mSetA( TITILE_A100 );
			}else
			{
				inSprt->mSetA( TITILE_A90 );
			}
			//̓_ł̎dɂȂ\邩H
			if( inOnlyBlink == false )
			{
				//4%̊mœ_1
				if( HSD_Randi(100) < 4 )
				{
					inSprt->mSetA( TITILE_A50 );
					inBlink->blinkProc = eTitleDifBrink1;
					inBlink->flame     = -1;
				}else
				//4%̊mœ_2
				if( HSD_Randi(100) < 8 )
				{
					inBlink->blinkProc = eTitleDifBrink2;
					inBlink->flame     = -1;
				}
			}
			break;
		
		//_łȂ
		case	eTitleDifNoBrink:
			inSprt->mSetA( TITILE_A25 );
			break;
		
		//ftHg
		default:
			break;
	}
	inBlink->flame++;
}
//-----------------------------------------------------------------------------
//_ŏ̕ύX
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mChangeBlink( void )
{
	if( mTitleSel2 == eTitleSelDifficult0 )
	{
		//
		mBlinkKanjiGeki.blinkProc = eTitleDifBrinkSel;
		mBlinkKanjiTouA.blinkProc = eTitleDifBrinkSel;
		mBlinkColonA.blinkProc    = eTitleDifBrinkSel;
		mBlinkTextA01.blinkProc   = eTitleDifBrinkSel;
		mBlinkTextA02.blinkProc   = eTitleDifBrinkSel;
		mBlinkKanjiGeki.flame     = 0;
		mBlinkKanjiTouA.flame     = 0;
		mBlinkColonA.flame        = 0;
		mBlinkTextA01.flame       = 0;
		mBlinkTextA02.flame       = 0;
		//
		mBlinkKanjiShi.blinkProc  = eTitleDifNoBrink;
		mBlinkKanjiTouB.blinkProc = eTitleDifNoBrink;
		mBlinkColonB.blinkProc    = eTitleDifNoBrink;
		mBlinkTextB01.blinkProc   = eTitleDifNoBrink;
		mBlinkTextB02.blinkProc   = eTitleDifNoBrink;
	}else
	{
		//
		mBlinkKanjiGeki.blinkProc = eTitleDifNoBrink;
		mBlinkKanjiTouA.blinkProc = eTitleDifNoBrink;
		mBlinkColonA.blinkProc    = eTitleDifNoBrink;
		mBlinkTextA01.blinkProc   = eTitleDifNoBrink;
		mBlinkTextA02.blinkProc   = eTitleDifNoBrink;
		//
		mBlinkKanjiShi.blinkProc  = eTitleDifBrinkSel;
		mBlinkKanjiTouB.blinkProc = eTitleDifBrinkSel;
		mBlinkColonB.blinkProc    = eTitleDifBrinkSel;
		mBlinkTextB01.blinkProc   = eTitleDifBrinkSel;
		mBlinkTextB02.blinkProc   = eTitleDifBrinkSel;
		mBlinkKanjiShi.flame      = 0;
		mBlinkKanjiTouB.flame     = 0;
		mBlinkColonB.flame        = 0;
		mBlinkTextB01.flame       = 0;
		mBlinkTextB02.flame       = 0;
	}
}
//-----------------------------------------------------------------------------
//^Cg̕\ύX
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mChangeTitle( void )
{
	mProc = eTitleChange;						
}
//-----------------------------------------------------------------------------
//Ił镶f[^̃NA
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TitleTask::mClearStrData( void )
{
	int	i;
	
	for( i = 0; i < TITLE_STRING_MAX; i++ )
	{
		GHMGCMEM_SAFE_FREE( mStr[i].str );
		GHM_SAFE_DELETE_ARRAY( mStr[i].sprt );
		GHM_SAFE_DELETE_ARRAY( mStr[i].sprtShadow );
		GHMGCMEM_SAFE_FREE( mStr[i].shadowProc );
	}
}

//-----------------------------------------------------------------------------
//ZL[index
//-----------------------------------------------------------------------------
void
MK7TitleTask::mSecretIndexInit( void )
{
	mSecretKeyIndex = 0;
#ifdef	_DEBUG
	gpSound->mPlaySE( SFX_SYS_SUBSCREEN_BOO );
#endif
}
//-----------------------------------------------------------------------------
//Z͔
//-----------------------------------------------------------------------------
void
MK7TitleTask::mSecretModeCheck( void )
{
	u32	trigger = HSD_PadGetTrigger(0);
	
	//͂Ȃ
	if( trigger == 0 )
	{
		return;
	}
	
	//R}h͎t
	if( (mTitleSel1 == eTitleSelKiller1)				//^CgʂKiller8
	 && (K7SCR_GET_GLOBAL_FLAG(K7GLFL_SECRET) == false)	//ZĂȂ
	 && (mTitleMenuProc == eTitleMenu) )				//PressStart\
	{
		// RLYBXA
		switch( mSecretKeyIndex )
		{
			//
			case	0:
				if( trigger == PAD_BUTTON_DOWN ){
					mSecretKeyIndex++;
				}else{
					mSecretIndexInit();
				}
				break;
			
			//R
			case	1:
				if( trigger == PAD_TRIGGER_R ){
					mSecretKeyIndex++;
				}else{
					mSecretIndexInit();
				}
				break;
			
			//
			case	2:
				if( trigger == PAD_BUTTON_UP ){
					mSecretKeyIndex++;
				}else{
					mSecretIndexInit();
				}
				break;
			
			//L
			case	3:
				if( trigger == PAD_TRIGGER_L ){
					mSecretKeyIndex++;
				}else{
					mSecretIndexInit();
				}
				break;
			
			//Y
			case	4:
				if( trigger == PAD_BUTTON_Y ){
					mSecretKeyIndex++;
				}else{
					mSecretIndexInit();
				}
				break;
			
			//B
			case	5:
				if( trigger == PAD_BUTTON_B ){
					mSecretKeyIndex++;
				}else{
					mSecretIndexInit();
				}
				break;
			
			//X
			case	6:
				if( trigger == PAD_BUTTON_X ){
					mSecretKeyIndex++;
				}else{
					mSecretIndexInit();
				}
				break;
			
			//A
			case	7:
				if( trigger == PAD_BUTTON_A ){
					gpSound->mPlaySE( SFX_SYS_SUBSCREEN_CUREALL );
					K7SCR_SET_GLOBAL_FLAG( K7GLFL_SECRET );
				}else{
					mSecretIndexInit();
				}
				break;
			
			default:
				break;
		}
	}
}
//-----------------------------------------------------------------------------
//ZtONA
//-----------------------------------------------------------------------------
void
MK7TitleTask::mSecretModeClear( void )
{
	K7SCR_RESET_GLOBAL_FLAG( K7GLFL_SECRET );
	mSecretIndexInit();
}
