////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7Common
//
// mK7Common.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 11/22/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7COMMON_H__
#define	__MK7COMMON_H__

//---- include ----




//---- define ----
#ifdef	_DEBUG
#define	TRACE(...)			OSReport(__VA_ARGS__)
#else
#define	TRACE(...)
#endif




//---- typedef ----




//---- enum ----
//t@Cǂݍݏ
typedef	enum{
	eFileReadOpen,			//I[v
	eFileReadOpenError,		//I[vG[
	eFileReadRead,			//ǂݍ
	eFileReadReadError,		//ǂݍ݃G[
	eFileReadWait,			//ǂݍݏI҂
	eFileReadClose,			//N[Y
	eFileReadCloseError,	//N[YG[
	eFileReadWorking,		//t@Cǂݍݍƒ
	eFileReadSucsess,		//t@Cǂݍݐ
	eFileIOMax
}enFileRead;




//---- struct ----
//eNX`Ǘ\
struct stTexture{
	GhmGcTexHeader*	tex;	//t@Cǂݍ񂾃eNX`
	GXTexObj		obj;	//GCAvǗp
};




//---- NX ----
class	mK7File
{
	public:
		//RXgN^
		mK7File( void );
		//fXgN^
		~mK7File( void );
		
		//t@Cǂݍ݁FubN()
		enFileRead	mK7FileReadB( char* inFileName, void** inBuff );
		//t@Cǂݍ݁FmubN(񓯊)
		enFileRead	mK7FileRead( char* inFileName, void** inBuff );
		
	private:
		ghmGcFile	mFile;
		enFileRead	mFileStatus;
};




//---- ֐錾 ----
//eNX`̏
void	mK7InitTexture( stTexture* inTex );
//oCjAeNX`̏
void	mK7InitBilinearTexture( stTexture* inTex );
//Βl̎擾s16
s16		mK7GetAbsS16( s16 inNum );





//3D_O
void	mK7Render3D( void );




#endif	//__MK7COMMON_H__

