////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7Dim
//
// mK7Dim.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 04/22/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7DIM_H__
#define	__MK7DIM_H__

//---- include ----
#include "..\wat\WK7MainTask.h"
#include "mK7Sprite.h"

//---- define ----
#define	DIM_MAX			(2)		//ڂ₩ׂɎgʃRs[̐
#define	DIM_FADEIN_TICK	(600)	//ォ牺܂ŃXL鎞:tick
#define	DIM_WIDTH		(32)	//ʂڂ₩ۂ̂Ԃꕝ

//---- enum ----
//t[vZX̏
typedef	enum{
	eDimFadeIn,		//tF[hC
	eDimFadeOut,	//tF[hAEg
	eDimStopWait,	//~I҂
	eDimStandby,	//ҋ@
	eDimFrameProcMax,
}enDimFrameProc;

//---- struct ----

//---- class ----
//u[NX
class MK7Dim{
protected:
public:
	//---- ֐ ----
	//RXgN^
	MK7Dim();
	
	//fXgN^
	~MK7Dim();
	
	//
	static
	void	Init( void );
	
	//㏈
	static
	void	Term( void );
	
	//
	void	mInit( void );
	
	//NGXg
	bool	mRequest( s32 inTick = DIM_FADEIN_TICK );
	
	//~
	void	mStop( void );
	
	//t[
	void	mFrameProcess( void );
	
	//JnXW擾
	s16		mGetInitX( int i ){return((s16)((i==0)?(-DIM_WIDTH):(DIM_WIDTH)));}
	
private:
	//---- ֐ ----
	//---- ϐ ----
	enDimFrameProc	mFrameProc;
	GhmGcTexHeader	mTexHeader;
	stTexture		mTex;
	mK7Sprite		mSprtHS[DIM_MAX];		//HS
	mK7Sprite		mSprtScreen[DIM_MAX];	//
	mK7Sprite		mSprtPanel;				//HSȊO̔wiPFɂ|
	f32				mScanH;					//\ĂXvCg̍
	s32				mNowTick;				//vZp
	s32				mTick;					//ۑpEXLɂ鎞
};



//extern
extern	MK7Dim*		gpDim;



#endif	//__MK7DIM_H__




