////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki mK7Jimaku
//
// mK7Jimaku.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 11/22/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7JIMAKU_H__
#define	__MK7JIMAKU_H__

//---- include ----
#include "mK7Sprite.h"




//---- define ----
#define	JIMAKU_SPRT_MAX			(32)	//1ʂŕ\ł镶̍ő吔
#define	FILE_LENGTH				(32)	//t@C̒
#define	JIMAKU_LINE_MAX			(16)	//1͂̕ŕ\łős
#define	JIMAKU_CHAR_MAX			(32)	//1sŕ\łő啶
#define	JIMAKU_SHADOW_MAX		(4)		//eɎgeNX`
#define	JIMAKU_RUBI_DAT_MAX		(JIMAKU_CHAR_MAX/2)	//1s̃rf[^ő吔
#define	JIMAKU_RUBI_MAX			(10)	//1̃r̕

//̓f[^ɂԍ
#if	0
#define	JIMAKU_NO_FONT			((s16)(0xffff))	//tHg͂Ȃ
#define	JIMAKU_RETURN			((s16)(0xfffe))	//^[
#define	JIMAKU_SPACE_H			((s16)(0xfffd))	//pXy[X
#define	JIMAKU_SPACE_Z			((s16)(0xfffc))	//SpXy[X
#define	JIMAKU_FLAG_SATSU		((s16)(0x8000))	//uEvtO
#define	JIMAKU_FLAG_SHI			((s16)(0x7000))	//uvtO
#else
#define	JIMAKU_NO_FONT			((0xffff))	//tHg͂Ȃ
#define	JIMAKU_RETURN			((0xfffe))	//^[
#define	JIMAKU_SPACE_H			((0xfffd))	//pXy[X
#define	JIMAKU_SPACE_Z			((0xfffc))	//SpXy[X
#define	JIMAKU_ENG				((0xfffb))	//pꕶ(1oCg1oCgꂼɕf[^)
#define	JIMAKU_FLAG_SATSU		((0x8000))	//uEvtO
#define	JIMAKU_FLAG_SHI			((0x7000))	//uvtO
#endif

//r֌Wdefine
#define	JIMAKU_RUBI_W			(15)			//r̕
#define	JIMAKU_RUBI_H			(16)			//r̍
#define	JIMAKU_RUBI_W_NUM		(34)			//eNX`̒ɕł鉡̕




//---- enum ----
//t[vZX̏
typedef	enum{
	eJimakuSystemRead,			//VXef[^̓ǂݍݒ
	eJimakuDataReadReq,			//f[^ǂݍ݃NGXg
	eJimakuDataRead,			//f[^ǂݍݒ
	eJimakuDataSet,				//f[^ݒ
	eJimakuStartWait,			//\܂ł̃EGCg
	eJimakuFadeIn,				//tF[hC
	eJimakuWaitByTime,			//\Eԑ҂
	eJimakuWaitByKey,			//\EL[͑҂
	eJimakuFadeOut,				//tF[hAEg
	eJimakuStandby,				//ҋ@
	eJimakuFrameProcMax,
}enJimakuFrameProc;

//TEht[vZX̏
typedef	enum{
	eJmkSndStartWait,		//Đ܂ł̃EGCg
	eJmkSndPlayStream,		//Đ
	eJmkSndWaitPlayEnd,		//ĐI҂
	eJmkSndStandby,			//TEhҋ@
	eJmkSndFrameProcMax,
}enJmkSndFrameProc;

//wi̐i
typedef	enum{
	eLeft,
	eRight,
	eBottom,
}enJimakuBackDir;

//\EGCg̎
typedef	enum{
	eJimakuDataWait,		//f[^̒gɔC
	eJimakuKeyWait,			//L[҂
	eJimakuWaitKindMax,
}enJimakuWaitKind;

//̐Lk̏
typedef	enum{
	eJmkElasticStandby,		//ҋ@
	eJmkElasticN,			//LтĂ
	eJmkElasticWait,		//LтԂł̑҂
	eJmkElasticT,			//kł
	eJmkElasticMax,
}enJmkElastic;

//Lт镶̎
typedef	enum{
	eElSatsu,
	eElShi,
	eElKindMax,
}enElasticKind;




//---- struct ----
//rf[^
typedef	struct{
	s8		fromNum;					//ڂ
	s8		toNum;						//
	s16		charID[JIMAKU_RUBI_MAX];	//r̃eNX`ԍ
}stRubiDat;

//1̕̕\ɕKvȃp[^
typedef	struct{
	s32		wait;						//Đ܂ł̃EGCg
	char	hpsFileName[FILE_LENGTH];	//t@C
	char	mthFileName[FILE_LENGTH];	//pN[Vt@C
	s16		backLocate;					//wi\Jnʒu
	s16		countinue;					//
	s16		key;						//L[͑҂tO
}stInfo;
//1̕̕\ɕKvȃp[^
typedef	struct{
	s32			wait;							//\Jn܂ł̃EGCg
	s32			disptime;						//\
	s16			chardat[JIMAKU_CHAR_MAX];		//̓f[^
	stRubiDat	rubidat[JIMAKU_RUBI_DAT_MAX];	//rf[^
}stJimaku;
//1f[^
typedef	struct{
	stInfo		info;
	stJimaku	jimaku[JIMAKU_LINE_MAX];
}stOneSentence;

//X̃tHg̃p[^
struct stFontParam{
	u16		u;
	u16		v;
	u16		w;
	u16		h;
};

//̓f[^
struct stSentence{
	s16		num;				//͂̐
	s16		charNum;			//̎ނ̐
	u32		offset;				//͂̃f[^ꏊ܂ł̃ItZbg
	u32		charOffset;			//uvwhĂf[^܂ł̃ItZbg
	u32		texOffset;			//eNX`f[^܂ł̃ItZbg
	u32		sMotionOffset;		//VFCv[Vf[^f[^܂ł̃ItZbg
	u32		sMotionSizeTbl[];	//eVFCv[VTCYe[u
};

//wipXvCgǗ\
typedef	struct{
	s16		priority;		//\D揇
	s16		w;				//̕
	s16		x0;				//XvCg\Wx0
	s16		y0;				//XvCg\py0
	s16		x1;				//XvCg\Wx1
	s16		y1;				//XvCg\py1
	s16		x2;				//XvCg\Wx2
	s16		y2;				//XvCg\py2
	s16		x3;				//XvCg\Wx2
	s16		y3;				//XvCg\py2
	u32		rgba;			//RGBA
	bool	flag;			//ėptO
	stMove	move[4];		//ړ
	stFade	fade;			//tF[h
}stJimakuSprite;

//Lт镶̊Ǘ
typedef	struct{
	s16				mNum;			//Lт鐔
	mK7Sprite*		mSprt;			//LтXvCgւ̃|C^
	enJmkElastic*	mElastic;		//LтXvCgԂւ̃|C^
	s16*			mElasticWait;	//LтĂԂ\鎞
	s16				mIndexTbl[JIMAKU_SPRT_MAX];	//XvCgtOݒ肳Ăe[u
}stElastic;




//---- class ----
class MK7Jimaku{
protected:
public:
	//---- ֐ ----
	MK7Jimaku();
	~MK7Jimaku();
	
	//̏
	static
	void	Init( void );
	void	mInit( void );
	
	//\̂߂̖t[
	void	mFrameProcess( void );
	
	//`揈
	void	mRenderBack( void );

	//̏I
	static
	void	Term( void );
	void	mTerm( void );
	
	//̏Ԏ擾
	enJimakuFrameProc	mGetStatus( void ){return(mFrameProc);}
	
	//̃f[^ǂݍ
	bool	mReadReq( char* inFileName );
	
	//ݓǂݍł鎚f[^͐̕𓾂
	s16		mGetSentenceNumMax( void );
	
	//f[^̂AhXݒ肷
	bool	mDataSet( void* inDat );
	//̕\~ăX^oCԂɂ܂
	bool	mDispStop( void );
	
	//r̃eNX`f[^ւ̃|C^擾
	GhmGcTexHeader*	mGetRubiTexPtr( void ){return(mTexRubi.tex);}
	
	//\JE^[̈ꎞ~
	bool	mSetPause( void );
	//\JE^[̈ꎞ~
	bool	mReleasePause( u32 inTick=0 );
	//|[YԂ̎擾
	bool	mGetPauseFlag( void ){return(mPauseFlag);}
	
	//̕\xݒ
	f32		mSetDispSpeed( f32 inSpeed );
	
private:
	//---- ֐ ----
	//\I`FbN
	bool	mDispEndCheck( void );

	//̕\Fݒ
	bool	mColorSet( void );
	
	//̕Z^O
	void	mCentering( int inWidth );
	//ëړ
	void	mJmkShadowMoveProc( void );

	//̃tF[hCI`FbN
	bool	mCheckFadeInEnd( void );
	//tF[hCݒ
	void	mSetFadeIn( void );
	//̃tF[hC
	bool	mFadeIn( void );
	//̃tF[hAEgݒ
	void	mSetFadeOut( void );
	//̃tF[hAEg
	bool	mFadeOut( void );
	
	//wĩtF[h
	void	mBackSprtFade( void );
	//wïړ
	void	mBackSprtMove( void );

	//\̂߂̃t[
	void	mJmkFrameProc( void );
	
	//̐Lт镔̃XvCgݒ
	void	mJmkElasticSetSprt( stElastic* inEl, enElasticKind inKind );
	//̐Lт镔̃XvCg̃t[
	void	mJmkElasticFrameProcFunc( stElastic* inEl, enElasticKind inKind );
	//̐Lт镔̃XvCg̃t[Ăяo
	void	mJmkElasticFrameProc( void );
	//̐Lт镔ɎgpϐȂǂ̏I
	void	mJmkElasticTerm( stElastic* inEl );

	//t@CNX
	mK7File				mFile;
	
	//---- ϐ ----
	enJimakuFrameProc	mFrameProc;				//̃t[
	enJimakuWaitKind	mWaitKind;				//\EGCg̎
	s16					mDispNum;				//\͔ԍ
	bool				mKeyWaitFlag;			//L[͑҂tO
	u32					mRGBA;					//RGBA
	s16					mSentenceIndex;			//͂ւindex
	s16					mLineIndex;				//sւindex
	stTexture			mTex;					//eNX`
	mK7Sprite			mSprt[JIMAKU_SPRT_MAX];	//\pXvCg
	mK7Sprite			mSprtSS[JIMAKU_SPRT_MAX][JIMAKU_SHADOW_MAX];//̉XvCg
	mK7Sprite			mSprtS[JIMAKU_SPRT_MAX];			//傫eXvCg
	u8					mSprtSMoveFlag[JIMAKU_SPRT_MAX];	//傫e̓tO
	f32					mSprtSOrgX[JIMAKU_SPRT_MAX];		//傫ěxW
	f32					mSprtSOrgY[JIMAKU_SPRT_MAX];		//傫ěyW
	u8					mAdvCurAnmWait;			//摗J[\̃Aj[VEGCg
	stTexture			mTexRubi;				//reNX`
	stSentence*			mDat;					//t@Cǂݍ񂾃f[^
	stOneSentence*		mSentenceDat;			//͂̓Ăf[^ւ̃|C^
	stFontParam*		mFParam;				//uvwhl̓Ăe[uւ̃|C^
	char				mFileName[16];			//ݕ\Ă鎚̃f[^t@C
	stJimakuSprite		mBackSprt;				//wi
	enJimakuBackDir		mBackSprtDir;			//wi̐i
	s32					mLastDispSprtNum;		//ŌɃtF[hC镶̃XvCgindex
	char				mVoiceFile[256];		//t@C
	
	s32					mStartWaitTime;			//\܂ł̎
	s32					mDisptime;				//\Ă鎞
	s32					mVoiceWaitTime;			//Đ܂ł̃EGCg
	
	bool				mBackFadeInFlag;		//witF[hC邩tO
	u8					mBackEndFlag;			//wi\̑tO
	
	stElastic			mESatsu;				//uEv̐Lт镔Ǘ
	stElastic			mEShi;					//uv̐Lт镔Ǘ
	
	bool				mRubiFlag;				//r\tO
	mK7Sprite			mSprtRubi[JIMAKU_RUBI_DAT_MAX][JIMAKU_RUBI_MAX];	//rXvCg
	
	f32					mTotalTick;				//\ԂĎtick
	bool				mPauseFlag;				//̒~p|[YtO
	
	f32					mSpeed;					//̕\x
};

//extern
extern	MK7Jimaku*	gpJimaku;



#endif	//__MK7JIMAKU_H__


