////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7Proc
//
// mK7Proc.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/22/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7PROC_CPP__

//---- include ----
#include "mK7Proc.h"

//---- define ----

//---- O[oϐ ----




//---- ֐ ----
//-----------------------------------------------------------------------------
//쐬̏
// in --> none
// out -> bool false  s
//             true   
//-----------------------------------------------------------------------------
bool
mK7InitProc( void )
{
	//
	MK7Jimaku::Init();
	
	//mCY
	MK7Noise::Init();
	
	//tbV
	MK7Flush::Init();
	
	//ʂڂ
	MK7Dim::Init();
	
	//^C|
	MK7TypoMng::Init();
	
	////|WVCtH 04/04/20 delete
	//MK7PosInfo::Init();
	
	//gbLOmCY
	MK7TNoise::Init();
	
	//\
	MK7CharaDispMng::Init();
	
	//pebv
	MK7EngTelop::Init();
	
	return( true );
}




//-----------------------------------------------------------------------------
//쐬̏I
// in --> none
// out -> bool false  s
//             true   
//-----------------------------------------------------------------------------
bool
mK7TermProc( void )
{
	//I
	MK7Jimaku::Term();
	
	//mCYI
	MK7Noise::Term();
	
	//tbVI
	MK7Flush::Term();
	
	//ʂڂI
	MK7Dim::Term();
	
	//^C|I
	MK7TypoMng::Term();
	
	////|WVCtHI 04/04/20 delete
	//MK7PosInfo::Term();
	
	//gbLOmCYI
	MK7TNoise::Term();
	
	//\I
	MK7CharaDispMng::Term();
	
	//pebvI
	MK7EngTelop::Term();
	
	//[r[~
	if(gpMovie!=NULL)gpMovie->mStop();
	
	return( true );
}




//-----------------------------------------------------------------------------
//쐬̃t[
// in --> none
// out -> bool false  s
//             true   
//-----------------------------------------------------------------------------
bool
mK7FrameProc( void )
{
	//
	if( gpJimaku != NULL )
	gpJimaku->mFrameProcess();
	
	//^C|
	if( gpTypoMng != NULL )
	gpTypoMng->mFrameProcess();
	
	//tbV
	if( gpFlush != NULL )
	gpFlush->mFrameProcess();
	
	//ڂ₯
	if( gpDim != NULL )
	gpDim->mFrameProcess();
	
	//ʃmCY
	if( gpNoise != NULL )
	gpNoise->mFrameProcess();
	
	//gbLOmCY
	if( gpTNoise != NULL )
	gpTNoise->mFrameProcess();
	
	////|WVCtH 04/04/20 delete
	//if( gpPosInfo != NULL )
	//gpPosInfo->mFrameProcess();
	
	//\
	if( gpCharaDispMng != NULL )
	gpCharaDispMng->mFrameProcess();
	
	//pebv
	if( gpEngTelop != NULL )
	gpEngTelop->mFrameProcess();
	
	//TEh
	if( gpSound != NULL )
	gpSound->mFrameProcess();
	
	return( true );
}




//-----------------------------------------------------------------------------
//쐬̃_[
// in --> none
// out -> bool false  s
//             true   
//-----------------------------------------------------------------------------
bool
mK7RenderProc( void )
{
	//wi_O
	if( gpJimaku != NULL )
	gpJimaku->mRenderBack();
	
	//ʃmCY
	if( gpNoise != NULL )
	gpNoise->mRender();
	
	//XvCg`
	mK7Sprite::mRender();
	
	//tbV`揈
	if( gpFlush != NULL )
	gpFlush->mRender();
	
	//gbLOmCY
	if( gpTNoise != NULL )
	gpTNoise->mRender();
	
	////|WVCtH 04/04/20 delete
	//if( gpPosInfo != NULL )
	//gpPosInfo->mRender();
	
	return( true );
}




//-----------------------------------------------------------------------------
//ꂼ̏̏IĂ邩`FbN֐
// in --> none
// out -> bool false  
//             true   SĂ̏̏IĂ܂
//-----------------------------------------------------------------------------
bool
mK7CheckInitEnd( void )
{
	//ҋ@ԂɂȂ`FbN
	if( gpJimaku != NULL )
	{
		if( gpJimaku->mGetStatus() != eJimakuStandby )
			return( false );
	}else
	{
		return( false );
	}
	
	//mCYGtFNgҋ@ԂɂȂ`FbN
	if( gpNoise != NULL )
	{
		//mCY
		if( gpNoise->mGetFrameProc() != eNoiseStandby )
			return( false );
		//ԐmCY
		if( gpNoise->mGetSandFrameProc() != eSandStandby )
			return( false );
	}else
	{
		return( false );
	}
	
	//^C|\ҋ@ԂɂȂ`FbN
	if( gpTypoMng != NULL )
	{
		if( gpTypoMng->mGetStatus() != eTypoFontStandby )
			return( false );
	}else
	{
		return( false );
	}
	
	//SĂ̏ҋ@
	return( true );
}








