////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Breaker
//
// SK7PanelBreaker.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 12/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELBREAKER_H__
#define	__SK7PANELBREAKER_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	
#define	BREAKER_NONE				(0)	//	ĂȂ
#define	BREAKER_GREEN				(1)	//	O[̂݃I
#define	BREAKER_ORANGE				(2)	//	IŴ݃I
#define BREAKER_ALL					(3)	//	ǂĂ


//	Ԃl
#define	NOT_PLAY					(-1)//	LZ
//#define BREAKER_GREEN_OFF			(0)	//	O[
//#define BREAKER_ORANGE_OFF			(1)	//	IW
#define BREAKER_GREEN_ON			(2)	//	O[
#define BREAKER_ORANGE_ON			(3)	//	IW

//	eNX`[pX
#define	PNL030401TEX_BG			"Texture/030401/EVENT_030401.BIN"
#define	PNL030401TEX_ON_O		"Texture/030401/O.BIN"
#define	PNL030401TEX_ON_G		"Texture/030401/G.BIN"


//---- class ----
class SK7PanelBreaker : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CHECK,
		PROC_TIME,
		PROC_CANCEL,
	}eInputCodeProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_ON_O,
		LOAD_ON_G,
	}eLoadTexProc;

protected:
	eInputCodeProc			m_Proc;
	eLoadTexProc			m_TexProc;
	s8						m_cSelect;
	s8						m_chState;
	int						m_iTime;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spSwitchO;			
	SK7Sprite				m_spSwitchG;			
	
public:
	SK7PanelBreaker( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelBreaker();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELBREAKER_H__
