////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel SK7PanelEnd
//
// SK7PanelEnd.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELEND_H__
#define	__SK7PANELEND_H__

#include "SK7PanelBase.h"
#include "SK7Sprite.h"
#include "../yam/YK7Effect.h"


//	eNX`[ԍ
enum{
	TEX_060000_SUDA=0,
	TEX_060000_THE,
	TEX_060000_SUDA2,
	TEX_060000_THE2,
	TEX_060000_THANK,
	TEX_060000_CAPCOM,
	TEX_060000_MAX,
};


//---- class ----
class SK7PanelEnd : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_ROTATION,
		PROC_STOP,
		PROC_NOISE,
		PROC_RED_FADE,
		PROC_FADE,
		PROC_DRAW,
		PROC_WAIT,
		PROC_CANCEL,
	}eFrameProc;
	
	enum{
		FRAME_FONT_ALIVE=0,
		FRAME_FONT_DEATH,
		FRAME_FONT_NONE,
	};
	
	enum{
		LOAD_PACK_DATA=0,
		LOAD_EFFECT,
	};
	
protected:
	eFrameProc				m_Proc;
	eFrameProc				m_Next;
	
	SK7Sprite				m_spBG;
//	SK7Sprite				m_spMei;
	SK7Sprite				m_spBlack;
	s8						m_chTexNo;
	s8						m_chLoad;
	bool					m_bFade;
	int						m_iTime;
	EFFECT*					m_pEffect;

public:
	SK7PanelEnd( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelEnd();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
};

#endif	//__SK7PANELEND_H__
