////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel HOTEL
//
// SK7PanelHotelElevator.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELHOTELELEVATOR_H__
#define	__SK7PANELHOTELELEVATOR_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"


//	Ԃl
#define		ELEHOTLE_CANCEL		(-1)	//
#define		ELEHOTLE_1F			(0)
#define		ELEHOTLE_2F			(1)
#define		ELEHOTLE_3F			(2)
#define		ELEHOTLE_4F			(3)
#define		ELEHOTLE_5F			(4)
#define		ELEHOTLE_6F			(5)
#define		ELEHOTLE_7F			(6)
#define		ELEHOTLE_R			(7)

//	
enum{
	ELEVATOR_HOTELBG=0,
	ELEVATOR_HOTEL1F,
	ELEVATOR_HOTEL2F,
	ELEVATOR_HOTEL3F,
	ELEVATOR_HOTEL4F,
	ELEVATOR_HOTEL5F,
	ELEVATOR_HOTEL6F,
	ELEVATOR_HOTEL7F,
	ELEVATOR_HOTELROOF,
	ELEVATOR_HOTELMAX,
};



//---- class ----
class SK7PanelHotelElevator : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CANCEL,
		PROC_TIME,
		PROC_CHECK,
	}eFrameProc;
	

protected:
	eFrameProc				m_Proc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spSwitch;
	s8						m_chSelect;
	int						m_iTime;
	
public:
	SK7PanelHotelElevator( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelHotelElevator();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELHOTELELEVATOR_H__
