
////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Locker
//
// SK7PanelLocker.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELLOCKER_H__
#define	__SK7PANELLOCKER_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"


//	ԂłB
#define	LOCKER_CANCEL				(-1)
#define	LOCKER_MISS					(0)
#define	LOCKER_OK					(1)

//	͐ĂBiO`Tj


//	eNX`[pX
#define	PNL011201TEX_BG				"Texture/011201/CoinLocker_BG.BIN"
#define	PNL011201TEX_KEY			"Texture/011201/CoinLocker_key.BIN"
#define	PNL011201TEX_NO				"Texture/011201/CoinLocker_nmbr.BIN"


//---- class ----
class SK7PanelLocker : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_TIME,
		PROC_MESSAGE,
		PROC_MESSAGE2,
		PROC_CANCEL,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_KEY,
		LOAD_NO,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spKey;
	SK7Sprite				m_spNo;	
		
public:
	SK7PanelLocker( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelLocker();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELTOILET_H__
