////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel PsychoTest
//
// SK7PanelPsychoTest.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 12/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELPSYCHOTEST_H__
#define	__SK7PANELPSYCHOTEST_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	Ԃ
#define	TEST_CURRENT_ANS				(0)	//	NA
#define	TEST_MISS_ANS					(-1)//	~X


enum{
	TEX_020301_Q1=0,
	TEX_020301_Q2,
	TEX_020301_Q3,
	TEX_020301_Q4,
	TEX_020301_Q5,
	TEX_020301_Q6,
	TEX_020301_Q7,
	TEX_020301_LGT,
	TEX_020301_MAX,
};

//---- class ----
class SK7PanelPsychoTest : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_MESSAGE,
		PROC_WHITE_OUT,
		PROC_WHITE_IN,
		PROC_CHECK,
		PROC_CANCEL,
	}eInputCodeProc;
	
protected:
	eInputCodeProc			m_Proc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spSwitch;
	SK7Sprite				m_spWhite;
	
	s8						m_chSelect;
	s8						m_chQNo;
	bool					m_bAnswer;
	
public:
	SK7PanelPsychoTest( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelPsychoTest();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELPSYCHOTEST_H__
