////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Roulette
//
// SK7PanelRoulette.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELROULETTE_H__
#define	__SK7PANELROULETTE_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	߂l
#define	ROULETTE_KEY_GET			(1)			//	Qbg
#define	ROULETTE_KEY_NONE			(0)		//	ς
#define	ROULETTE_CANCEL				(-1)



#define	BALL_SIZE					(22)
#define	ROULETTE_ANSWER_NUM			(14)
#define	ANSWER_13					(8)

//	eNX`[pX
#define	PNL011503TEX_BG				"Texture/011503/Rl1_BG.BIN"
#define	PNL011503TEX_BALL			"Texture/011503/Rl1_sphere.BIN"


//---- class ----
class SK7PanelRoulette : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CANCEL,
		PROC_MESSAGE,
		PROC_CHECK,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_BALL,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spBall[ROULETTE_ANSWER_NUM];
	s8						m_chSelect;
	
public:
	SK7PanelRoulette( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelRoulette();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELROULETTE_H__
