////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Secom
//
// SK7PanelSecom.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELSECOM_H__
#define	__SK7PANELSECOM_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	߂l & 
#define	SECOM_OFF					(0)	//	XCb`It
#define	SECOM_ON					(1)	//	XCb`I
#define	SECOM_POSTER_OFF			(2)	//	XCb`ItL[͂Ȃ
#define	SECOM_POSTER_ON				(3) //	XCb`IL[͂Ȃ
#define	SECOM_MESSAGE				(10)//	messagê

//	߂lɎgȂłB
#define	SWITCH_ON					(0)
#define	SWITCH_OFF					(1)
#define	SWITCH_POSTER_ON			(2)
#define	SWITCH_POSTER_OFF			(3)

//	eNX`[pX
#define	PNL035005TEX_BG				"Texture/035005/secom00.BIN"
#define	PNL035005TEX_SWITCH			"Texture/035005/secom01.BIN"
#define	PNL035005TEX_LAMP			"Texture/035005/secom02.BIN"


//---- class ----
class SK7PanelSecom : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CANCEL,
		PROC_MESSAGE,
		PROC_END,
		PROC_CHECK,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_SWITCH,
		LOAD_LAMP,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spLamp[2];
	SK7Sprite				m_spSwitch[2];
	s8						m_chSelect;
	
public:
	SK7PanelSecom( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelSecom();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELSECOM_H__
