////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel SK7PanelStaff1
//
// SK7PanelStaff1.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELSTAFF1_H__
#define	__SK7PANELSTAFF1_H__

#include "SK7PanelBase.h"
#include "SK7Sprite.h"
#include "SK7Font.h"

#define		STAFF_TEX_NUM		(15)

//---- class ----
class SK7PanelStaff1 : public SK7PanelBase
{
	typedef enum{
		eLoad=0,
		eFade,
		eKan,
		eFadeMain,
		eFadeMain2,
		eFade2,
		eMain,
		eEnd,
	}eProc;

	typedef enum{
		eLFont=0,
		eLBG,
	}eData;
	
protected:
	SK7Sprite			m_spBlack;
	SK7Sprite			m_spStaff[STAFF_TEX_NUM];
	SK7Sprite			m_spBG;
	SK7Sprite			m_spFade;
	f32					m_fSpeed;
	eProc				m_eProc;
	eData				m_eLoad;
	int					m_iTime;
	
	bool	Move();
	
public:
	SK7PanelStaff1( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelStaff1();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	Load();
};

#endif	//__SK7PANELSTAFF1_H__
