////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Valve
//
// SK7PanelValve.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELVALVE_H__
#define	__SK7PANELVALVE_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	߂l
#define	VALVE_OFF					(0)	//	ouIt
#define	VALVE_ON					(1)		//	ouI


//	eNX`[pX
#define	PNL035015TEX_BG				"Texture/035015/motosen00.BIN"
#define	PNL035015TEX_COCK			"Texture/035015/motosen01.BIN"
#define	PNL035015TEX_CENTER			"Texture/035015/motosen02.BIN"


//---- class ----
class SK7PanelValve : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_MOVE_VALVE,
		PROC_CANCEL,
		PROC_MESSAGE,
		PROC_CHECK,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_CENTER,
		LOAD_COCK,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spValve;
	SK7Sprite				m_spCenter;
	s8						m_chSelect;
	f32						m_fAngle;

public:
	SK7PanelValve( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelValve();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	bool	MoveValve( s8 flag );
};

#endif	//__SK7PANELVALVE_H__
