////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Switch 00
//
// mK7PanelSwitch00.h
// @̃̕Cg̃XCb`
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 09/25/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7PANELSWITCH00_H__
#define	__MK7PANELSWITCH00_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"

//---- enum ----
typedef	enum{
	ePanelSwitch00ReadTexOff,
	ePanelSwitch00ReadTexOn,
	ePanelSwitch00DispOff,
	ePanelSwitch00DispOn,
	ePanelSwitch00Decide,
	ePanelSwitch00Cancel,
	ePanelSwitch00Message,
	ePanelSwitch00MessageEnd,
	ePanelSwitch00StatsuMax,
}ePanelSwitch00Proc;



//---- class ----
class mK7PanelSwitch00 : public SK7PanelBase
{
protected:
	ePanelSwitch00Proc	mProc;
	
	SK7Sprite			mSpOff;			//XCb`It
	SK7Sprite			mSpOn;			//XCb`I
	
	bool				mSelectFlag;	//IʃtO
	bool				mLastCheck;		//Ō̊mFtO
	bool				mInitSelectFlag;//ItO
		
//	EFFECT*				mEfSight;		//TCgGtFNg
	u32					mKeyTime;		//key
		
public:
	mK7PanelSwitch00( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~mK7PanelSwitch00();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );
	
	// 싖ݒ֐
	virtual void mSetCtrlFlag( bool inBool );

	// _Oݒ֐
	virtual void mSetRender( bool inBool );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
};

#endif	//__MK7PANELSWITCH00_H__
