////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Switch 01
//
// mK7PanelSwitch01.h
// @̃XCb`
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 09/26/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7PANELSWITCH01_H__
#define	__MK7PANELSWITCH01_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"

//---- enum ----
typedef	enum{
	ePanelSwitch01ReadTexOff,
	ePanelSwitch01ReadTexOn,
	ePanelSwitch01DispOff,
	ePanelSwitch01DispOn,
	ePanelSwitch01Decide,
	ePanelSwitch01Cancel,
	ePanelSwitch01Message,
	ePanelSwitch01MessageEnd,
	ePanelSwitch01StatsuMax,
}ePanelSwitch01Proc;



//---- class ----
class mK7PanelSwitch01 : public SK7PanelBase
{
protected:
	ePanelSwitch01Proc	mProc;
	
	SK7Sprite			mSpOff;			//XCb`It
	SK7Sprite			mSpOn;			//XCb`I
	
	bool				mSelectFlag;	//IʃtO
	bool				mLastCheck;		//Ō̊mFtO
	bool				mInitSelectFlag;//ItO
	
//	EFFECT*				mEfSight;		//TCgGtFNg
	u32					mKeyTime;		//key
	
public:
	mK7PanelSwitch01( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~mK7PanelSwitch01();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );
	
	// 싖ݒ֐
	virtual void mSetCtrlFlag( bool inBool );

	// _Oݒ֐
	virtual void mSetRender( bool inBool );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// ̑Iڎ擾֐
	bool	mGetSelect( void ){return(mSelectFlag);}
	
	// ̏Ԏ擾֐
	ePanelSwitch01Proc	mGetProc( void ){return(mProc);}
};

#endif	//__MK7PANELSWITCH01_H__
