////////////////////////////////////////////////////////////////////////////////
//
// Killer7 PlayEfHSScan
//
// K7PlayEfHSScan.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 06/16/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7PLAYEFHSSCAN_H__
#define	__K7PLAYEFHSSCAN_H__

#include "..\Wat\WK7Play.h"
#include "..\Fujita\C_SetAlpha.h"

#define	K7PLAYEFFECT_HSSCAN_TICK			(2400)
#define	K7PLAYEFFECT_HSNONSCAN_ALPHA		(0.3f)

class K7PlayEfHSScanInstance : public WK7PlayEffectInstance{
protected:
	WK7JObj				*mpJObj;
public:
	K7PlayEfHSScanInstance(WK7PlayEffect *pContainer,ghmGcListObj *pAnchor,WK7JObj *pJObj,WK7JObj *pHSJObj);
	virtual ~K7PlayEfHSScanInstance();
	
	virtual bool FrameProcess(bool stopReq);
	virtual bool RenderProcess(void);
};

class K7PlayEfHSScan : public WK7PlayEffect{
protected:
	WK7JObj				**mppJObj;
	int					mJObjNum;
public:
	WK7JObj* GetJObj(int index);
	inline int GetJObjNum(void){ return mJObjNum; }
	
	K7PlayEfHSScan(WK7Play *pPlay,ghmGcListObj *pAnchor,WK7JObj *pJObj,const char *pObjName);
	K7PlayEfHSScan(WK7Play *pPlay,ghmGcListObj *pAnchor,WK7JObj *pJObj,const char **ppObjName);
	virtual ~K7PlayEfHSScan();
	
	virtual WK7PlayEffectInstance* CreateInstance(WK7JObj *pJObj);
};

#endif	//__K7PLAYEFHSSCAN_H__

