////////////////////////////////////////////////////////////////////////////////
//
// Killer7 PlayEfMonotone
//
// K7PlayEfMonotone.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 06/18/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7PLAYEFMONOTONE_H__
#define	__K7PLAYEFMONOTONE_H__

#include "..\Wat\WK7Play.h"

class K7PlayEfMonotoneInstance : public WK7PlayEffectInstance{
protected:
	bool		mRender;
	bool		mZUpDate;
	u32			mColor;
public:
	K7PlayEfMonotoneInstance(WK7PlayEffect *pContainer,ghmGcListObj *pAnchor,WK7JObj *pJObj,u32 color);
	virtual ~K7PlayEfMonotoneInstance();
	
	virtual bool FrameProcess(bool stopReq);
};

class K7PlayEfMonotone : public WK7PlayEffect{
protected:
	bool		mRender;
	bool		mZUpDate;
	bool		mFullScreen;
	u32			mColor;
public:
	K7PlayEfMonotone(WK7Play *pPlay,ghmGcListObj *pAnchor,WK7JObj *pJObj,u32 color=0xffffffff);
	virtual ~K7PlayEfMonotone();
	
	virtual WK7PlayEffectInstance* CreateInstance(WK7JObj *pJObj);
};

#endif	//__K7PLAYEFMONOTONE_H__

