#ifndef __RELMODULE_SETUP__H__
#define __RELMODULE_SETUP__H__

#ifdef __cplusplus
extern "C" {
#endif

void ModuleConstructors(void);
void ModuleDestructors(void);
void _prolog();
void _epilog();
void _unresolved();

/*
 * Specify RELMODULE_EXPORT for any functions you
 * want to export from your module. This guarantees
 * they will not be deadstripped from the module.
 */
#define RELMODULE_EXPORT __declspec(export)

#ifdef __cplusplus
}
#endif


#endif 