////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Death
//
// SK7Death.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 12/22/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7DEATH_H__
#define	__SK7DEATH_H__

#include "..\Lib\ghmGcAppTask.h"
#include "..\Lib\ghmGcMem.h"
#include "../wat/WK7Archive.h"
#include "../matsu/mK7Jimaku.h"
#include "SK7Sprite.h"
#include "SK7Font.h"

//	Ԃl	-----------------------------------
#define		RETURN_SAIGEKI		(0)
#define		RETURN_SYUGEKI		(1)



#define		NOT_DREW_NUM		(4)
#define		DEATH_SELECT_NUM	(6)//9)
#define		DEATH_SELECT_NO_MAX	(2)//(5)
#define		DEATH_EX_NUM		(5)
#define		HANE_NUM			(5)
#define		SELECT_FONT_NUM_MAX	(40)


typedef struct{
	Vec CamPos;
	Vec	TargetPos;
}PLAYER_CAMERA;

typedef struct{
	char*	NotDraw[NOT_DREW_NUM];
}VISIBLE_OFF;

typedef struct{
	SK7Sprite	spHane;
	int			iSetTime;		//	ړ܂łɂ鎞
	int			iMoveTime;		//	ړ܂ł̎
	int			iHaneTime;		//	͂˂鎞
	bool		bMoveFlag;		//	ړĂǂ
}FONT_HANE;


#ifdef __SK7DEATH_CPP__
char* tblPlayerName[]=
{
	"/Texture/gameover/DAN_N.dat",			//	_
	"/Texture/gameover/DAN_N.dat",			//	_
	"/Texture/gameover/CAT_N.dat",			//	R
	"/Texture/gameover/CAT_N.dat",			//	R
	"/Texture/gameover/KED_S.dat",			//	
	"/Texture/gameover/KED_S.dat",			//	
	"/Texture/gameover/MSK_N.dat",			//	}XN
	"/Texture/gameover/MSK_N.dat",			//	}XN
	"/Texture/gameover/KVN_N.dat",			//	Pr
	"/Texture/gameover/KVN_N.dat",			//	Pr
	"/Texture/gameover/Gal_N.dat",			//	KVA
	"/Texture/gameover/Gal_N.dat",			//	KVA
	"/Texture/gameover/CYO_N.dat",			//	R[e
	"/Texture/gameover/CYO_N.dat",			//	R[e
	"/Texture/gameover/MSK_M04.dat",		//	}XNtexs
	"/Texture/gameover/MSK_M05.dat",		//	}XNfinal
	"/Texture/gameover/MSK_M06.dat",		//	}XNmask
	"/Texture/gameover/HAY_M00.dat",		//	On[}
};

char* tblPlayerMotionName[]=
{
	"/Texture/gameover/DAN_DeadFrnt.dat",	//	_
	"/Texture/gameover/DAN_DeadBack.dat",	//	_
	"/3DData/Motion/Chara/Cat/CAT_0310.dat",//	R
	"/3DData/Motion/Chara/Cat/CAT_0320.dat",//	R
	NULL,
	NULL,
	NULL,//"/3DData/Motion/Chara/MSK/MSK_0310.dat",//	}XN
	NULL,//"/3DData/Motion/Chara/MSK/MSK_0320.dat",//	}XN
	NULL,//"/3DData/Motion/Chara/KVN/KVN_0310.dat",//	Pr
	NULL,//"/3DData/Motion/Chara/KVN/KVN_0320.dat",//	Pr
	NULL,//	"/3DData/Motion/Chara/Gal/GAL_0310.dat",//	KVA
	NULL,//"/3DData/Motion/Chara/Gal/GAL_0320.dat",//	KVA
	NULL,//"/3DData/Motion/Chara/CYO/CYO_0310.dat",//	R[e
	NULL,//"/3DData/Motion/Chara/CYO/CYO_0320.dat",//	R[e
	NULL,//MSKLv1
	NULL,//MSKLv2
	NULL,//MSKLv3
	NULL,//n[
};


char* tblFaceMotionName[]=
{ 
	"/Texture/gameover/DAN_SHI.dat",//	_
	"/Texture/gameover/DAN_SHI.dat",//	_
	"/Texture/gameover/CAT_SHI.dat",//	R
	"/Texture/gameover/CAT_SHI.dat",//	R
	"/Texture/gameover/KED_SHI.dat",//	
	"/Texture/gameover/KED_SHI.dat",//	
	"/Texture/gameover/MSK_SHI.dat",//	}XN
	"/Texture/gameover/MSK_SHI.dat",//	}XN
	"/Texture/gameover/KVN_SHI.dat",//	Pr
	"/Texture/gameover/KVN_SHI.dat",//	Pr
	"/Texture/gameover/GAL_SHI.dat",//	KVA
	"/Texture/gameover/GAL_SHI.dat",//	KVA
	"/Texture/gameover/CYO_SHI.dat",//	R[e
	"/Texture/gameover/CYO_SHI.dat",//	R[e
	"/Texture/gameover/MSK_M04_SHI.dat",//	}XNTEX
	"/Texture/gameover/MSK_M05_SHI.dat",//	}XNFIN
	"/Texture/gameover/MSK_M06_SHI.dat",//	}XNKAMEN
	"/Texture/gameover/HAY_M00_SHI.dat",//	n[
};

char* tblFaceObjName[]=
{
	"Dan_face",		//	_
	"Dan_face",		//	_
	"Head",			//	R
	"Head",			//	R
	"AnimFace",		//	
	"AnimFace",			//	
	"MSK_Face",			//	}XN
	"MSK_Face",			//	}XN
	"Kvn_Head",			//	Pr
	"Kvn_Head",			//	Pr
	"Gal_Face",  			//	KVA
	"Gal_Face",  			//	KVA
	"CYO_Face",     		//	R[e
	"CYO_Face",     		//	R[e
	"MSK_Face",			//TEX}XN
	"Head",			//FIN}XN
	"MSK_Head",			//KAMEN}XN
	"YH_Face",			//n[
};

VISIBLE_OFF		tblVisibleName[]=
{
	"Dan_Body","Dan_hand",NULL,NULL,			//	_
	"Dan_Body","Dan_hand",NULL,NULL,			//	_
	"BodyUpper","BodyLower","HandL_Low","HandR_Low",          		  	//	R
	"BodyUpper","BodyLower","HandL_Low","HandR_Low",          		  	//	R
	NULL,NULL,NULL,NULL,						//	
	NULL,NULL,NULL,NULL,						//	
	"Coat","MSK_Body",NULL,NULL,  						//	}XN
	"Coat","MSK_Body",NULL,NULL,  						//	}XN
	"Kvn_Body",NULL,NULL,NULL,  						//	Pr
	"Kvn_Body",NULL,NULL,NULL,  						//	Pr
	"Gal_Body",NULL,NULL,NULL,  						//	KVA
	"Gal_Body",NULL,NULL,NULL,  						//	KVA
	"CYO_Body","CYO_Shirts",NULL,NULL,  						//	R[e
	"CYO_Body","CYO_Shirts",NULL,NULL,  						//	R[e
	"MSK_Body","Coat","HandR_Low","HandL_Low",			//	eLTX}XN
	"Body","Cover_breastR","Cover_breastL","Hands_High",			//	eLTXt@Ci
	"MSK_Body","Coat","HandR_Low","HandL_Low",			//	eLTXS
	"HAY_Body","HandR_Low","WristL_joint",NULL,			//	n
};


//	[VƎ̓̕p
const u8 tblMouthTime[]={
	10,10,		//	_
	7, 7,		//	R
	7, 7,		//	
	7, 7,		//	܂
	7, 7,		//	Pr
	7, 7,		//	KVA
	7, 7,		//	R[e
	7, 7,		//	eLTX}XN
	7, 7,		//	t@Ci}XN
	7, 7,		//	S
	3, 3,		//	n[
};
#endif


//	Lԍ	--------------------------------------
enum{ 
	PLAYER_DAN_FRONT,	//	_@O
	PLAYER_DAN_BACK,	//	_@
	PLAYER_CAT_FRONT,	//	R@O
	PLAYER_CAT_BACK,	//	R@
	PLAYER_KED_FRONT,	//	Ł@O
	PLAYER_KED_BACK,	//	Ł@
	PLAYER_MSK_FRONT,	//	}XN@O
	PLAYER_MSK_BACK,	//	}XN@
	PLAYER_KVN_FRONT,	//	Pr@O
	PLAYER_KVN_BACK,	//	Pr@
	PLAYER_GAL_FRONT,	//	KVA@O
	PLAYER_GAL_BACK,	//	KVA@
	PLAYER_CYO_FRONT,	//	R[e@O
	PLAYER_CYO_BACK,	//	R[e@
	PLAYER_MSK_TEXAS,	//	eLTX}XN
	PLAYER_MSK_FINAL,	//	t@Ci}XN
	PLAYER_MSK_KAMEN,	//	Sʃ}XN
	PLAYER_HAY,			//	On[}
};


#define		BLOOD_PAT_TEX		"Texture/gameover/particle_blood.BIN"
#define		BLOOD_DEATH			"Texture/gameover/Death.BIN"
//#define		RETRY_FONT			"Texture/gameover/retry.BIN"
#define		DEATH_BLOOD_NUM		(400)


//	Q[I[o[NX
class SK7Death
{
	typedef enum{
		PROC_LOAD=0,
		PROC_MAIN,
		PROC_TIME,
		PROC_FADE_STOP,
		PROC_BLOOD_MAIN,
		PROC_MOVE_DEATH,
		PROC_FADECHECK,
		PROC_MOVE_BLOOD,
		PROC_SELECTBG_FADE,
		PROC_RED_FADE,
		PROC_RETRY,
		PROC_FADE_MAIN,
		PROC_END_SELECT,
		PROC_END,
	}eProc;
	
	typedef enum{
		LOAD_MODEL=0,
		LOAD_MOTION,
		LOAD_FACE,
		LOAD_BLOOD_PAT,
		LOAD_RETRY,
		LOAD_END_DATA,
		LOAD_END_BG,
		LOAD_BLOOD_DEATH,
	}lProc;

protected:
	bool						m_bRender;				// `tO
	bool						m_bCtrl;				// 싖tO
	bool						m_bGameOverFlag;
	bool						m_bBloodDrawFlag;
	bool						m_bRetryFlag;
	bool						m_bEndFlag;
	int							m_iTime;
	int							m_iCameraTime;
	
	eProc						m_Proc;
	lProc						m_LoadProc;
	
	Vec							m_vSpeed;							

	WK7Archive*					m_pArchive;
	WK7Model*					m_pModel;
	WK7Archive*					m_pMotionArc;
	WK7Archive*					m_pFaceArc;
	WK7ModelMotion* 			m_pMotion;
	WK7ModelMotion* 			m_pFaceMotion;
	
	SK7File						m_File;
	SK7Font						m_Font[DEATH_SELECT_NUM];
	SK7Font						m_FontB[DEATH_SELECT_NUM];

	SK7Sprite					m_spDeath;
	SK7Sprite					m_spFade;
	SK7Sprite					m_spWhite;
	SK7Sprite					m_spScreen;
	SK7Sprite					m_spCharaWhite;
	SK7Sprite					m_spLastFade;
	SK7Sprite					m_spBg;
	TEX_DATA					m_BloodTex;
	FONT_HANE					m_FHane[HANE_NUM];
	FONT_HANE					m_BHane[HANE_NUM];
	Vec							m_vBloodPos[DEATH_BLOOD_NUM];
	f32							m_fFov;
	f32							m_fFontEx[DEATH_EX_NUM];
	f32							m_fOneFontEx[SELECT_FONT_NUM_MAX];
	f32							m_fAngle;
	f32							m_fSize;
	s16							m_sAlpha[DEATH_SELECT_NO_MAX];
	int							m_iCharaNo;
	int							m_iSelect;
	bool						m_bSoundFlag;
	int							m_iMoveTime[DEATH_SELECT_NO_MAX];
	int							m_iSetTime[DEATH_SELECT_NO_MAX];
	int							m_iExTime;
	

	//	֐	-----------------------------------------------------
	void					InitHane();
	void					SetSelectFont();
	void					SetSelectEx();
	void					SetSelectHane();
	void					SetHaneState();
	void					MoveSelectFont();
	void					MoveSelectEx();
	void					MoveSelectHane();
public:
	SK7Death( u32 CharaNo, bool GameOverFlag = true );
	~SK7Death();

	// t[
	bool  FrameProcess(void);
	
	// _O
	bool  RenderProcess(void);
	
	// t@CǂݍݏI擾֐
	bool  GetFileReadEnd(void);

	// II擾֐
	bool  GetMenuEnd(void);

	// 싖ݒ֐
	void  SetCtrlFlag(bool flag){ m_bCtrl=flag; }

	// _O
	void  SetRender(bool flag){ m_bRender=flag; }
	
	//	OEČEI擾	
	int		GetSelectNo(){	return m_iSelect;}

	//	[h
	bool	LoadData();
	
	
	void	DrawBlood();
	
	//	gړ
	bool	MoveFov();
	bool	MoveCamera();
	void	PlayFaceMotion();
};

#endif	//__SK7DEATH_H__
