////////////////////////////////////////////////////////////////////////////////
//
// Killer7 IMenuBase
//
// SK7IMenuBase.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/02/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7IMENUBASE_H__
#define	__SK7IMENUBASE_H__

#include "..\Lib\ghmGcAppTask.h"
#include "..\Lib\ghmGcMem.h"



typedef	enum{
	eMenuPolaroid=0,
	eMenuVoiceMemo,
	eMenuHatoMemo,
	eMenuUlmeyda,
	eMenuColor,
	eMenuMap,
	eMenuIDMax,
	eMenuIDStart = 0,
}eMenuID;



//	ACej[x[XNX
class SK7IMenuBase
{
protected:
	bool						m_bRender;				// `tO
	bool						m_bCtrl;				// 싖tO

public:
	SK7IMenuBase();
	virtual ~SK7IMenuBase();
	
	static SK7IMenuBase* Create(u8 id, u8 no=0);

	// t[
	virtual bool  FrameProcess(void){ return true; }
	
	// _O
	virtual bool RenderProcess(void){ return true; }
	
	// t@CǂݍݏI擾֐
	virtual bool GetFileReadEnd(void){ return true; }

	// II擾֐
	virtual bool GetMenuEnd(void){ return true; }

	// 싖ݒ֐
	virtual void SetCtrlFlag(bool flag){ m_bCtrl=flag; }

	// _O
//	virtual void SetRender(bool flag){ m_bRender=flag; }	
	virtual void SetRender(bool flag);
};

#endif	//__SK7IMENUBASE_H__
