////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Pack
//
// SK7PackData.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 04/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PACKDATA_H__
#define	__SK7PACKDATA_H__

#include "SK7Common.h"
#include "WK7Archive.h"
#include "../Yam/YK7String.h"

//
//	pbNNX
class SK7PackData
{
protected:
	SK7File			m_File;
	ghmGcResLink*	m_pResLink;								//	N\[X
	void*			m_pPackData;	//	f[^

public:
	SK7PackData();
	~SK7PackData();
	 
	bool			OpenPack	( char* filename );
	bool			GetTexture	( TEX_DATA* pTex, int no );	//	eNX`擾
	bool			GetModel	( WK7Archive** pArc, WK7Model** pModel,	int no );
	bool			GetMotion	( WK7Archive** pArc, WK7ModelMotion** pMotion, int no );
	bool			GetYamFont	( YK7StrImage* pFont,int no );
	void*			GetData		( int no );
};

#endif	//__SK7PACKDATA_H__
