////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Test Task
//
// SK7PanelBase.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/22/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELBASE_H__
#define	__SK7PANELBASE_H__

#include "..\Lib\ghmGcAppTask.h"
#include "..\Lib\ghmGcMem.h"

#include "../Yam/YK7Effect.h"
#include "../Yam/YK7EffectMessage.h"
#include "../Yam/YK7EffectPanelCursor.h"
//#include "../Yam/YK7EffectSight.h"
#include "../matsu/mK7Sound.h"
#include "SK7Sprite.h"
#include "../Yam/YK7String.h"
#include "../matsu/mK7Jimaku.h"


//sʂ\鎞(4800tick=1b)
#define	PANEL_LAST_WAIT			(4800)

//CreatȇŎwł
#define	PANEL_INIT_ARRANGE		(-1)	//plԌĂяo
//mGetResult֐Ŏ擾łԂl
#define	PANEL_OPERATE_CANCEL	(-1)	//plLZ
#define	PANEL_WORKING			(-2)	//pl쒆:eNX`ǂݍ݂Ȃ

//CheckAnswer̕Ԃl
#define	PANEL_CHECK_WORKING		(-1)	//҂
#define	PANEL_CHECK_RETURN		(0)		//߂
#define	PANEL_CHECK_SET			(1)		//

//@J[\̃TCY
#define	PNL_CURSOL_SIZE			(32)
#define	PNL_CURSOL_ANIME_NUM	(6)

//	J[\ړ
#define	CURSOL_DIR_UP			(1<<0)
#define	CURSOL_DIR_DOWN			(1<<1)
#define	CURSOL_DIR_RIGHT		(1<<2)
#define	CURSOL_DIR_LEFT			(1<<3)


typedef	enum{
	ePanel000101  = 0,
	ePanel000102,
	ePanel000104,
	ePanel000201,
	ePanel000304,
	ePanel000401,
	ePanel000501,
	ePanel000502,
	ePanel000603,
	ePanel000606,
	ePanel007201,
	ePanel007301,
	ePanel007307,
	ePanel010600,
	ePanel010700,
	ePanel010701,
	ePanel010401,
	ePanel010402,
	ePanel010403,
	ePanel011201,
	ePanel011301,
	ePanel011304,
	ePanel011305,
	ePanel011308,
	ePanel011309,
	ePanel011310,
	ePanel011402,
	ePanel011403,
	ePanel011404,
	ePanel011406,
	ePanel011502,
	ePanel011503,
	ePanel011506,
	ePanel011602,
	ePanel011603,
	ePanel011604,
	ePanel011606,
	ePanel011607,
	ePanel011608,
	ePanel020101,
	ePanel020103,
	ePanel020105,
	ePanel020107,
	ePanel020108,
	ePanel020109,
	ePanel020110,
	ePanel020111,
	ePanel020112,
	ePanel020113,
	ePanel020114,
	ePanel020115,
	ePanel020116,
	ePanel020117,
	ePanel020118,
	ePanel020119,
	ePanel020120,
	ePanel020121,
	ePanel020122,
	ePanel020123,
	ePanel020124,
	ePanel020125,
	ePanel030101,
	ePanel030102,
	ePanel030103,
	ePanel030104,
	ePanel030105,
	ePanel030106,
	ePanel030201,
	ePanel030202,
	ePanel030203,
	ePanel030204,
	ePanel030205,
	ePanel030206,
	ePanel030301,
	ePanel030401,
	ePanel030402,
	ePanel030403,
	ePanel030404,
	ePanel030409,
	ePanel030414,


	ePanel030515,
	ePanel030516,
	ePanel030517,
	ePanel030518,
	ePanel030519,
	ePanel030520,

	ePanel030901,
	
	
	//		-------------------
	eRakum000101,
	eRakum000102,
	eRakum000103,
	eRakum000501,
	eRakum000502,
	
	eRakum010001,
	eRakum010002,
	eRakum010003,
	
	eRakum011201,
	eRakum011301,
	eRakum011501,
	
	eRakum030201,
	eRakum030301,
	
	ePanelDebug,
	ePanelIDMax,
	ePanelIDStart = 0,
}ePanelID;

//	enum
typedef enum {
	ePanelBaseLoad=0,
	ePanelBaseMove,
	ePanelBaseMoveEnd,
	ePanelBaseCheck,
	ePanelBaseReturn,
	ePanelBaseSet,
}eCheckProc;

typedef enum{
	eMesLoad=0,
	eMesCheck,
	eMesEnd,
}eMesProc;

//	tHg̎
enum{
	PANEL_FONT_NONE=0,
	PANEL_FONT_YAMADA,
	PANEL_FONT_MATSU,
};
	
#ifdef	_DEBUG
struct SK7PanelDebugMenuTable{
	ePanelID					m_eID;
	const char					*m_pMenuName;
};
#endif

class SK7PanelBase; 
typedef	SK7PanelBase* SK7PanelCreateFunc(u32 evno,s32 now,s32 now2  );

//---------------------------------------
//	plx[XNX
//---------------------------------------
class SK7PanelBase
{
	
protected:
	s32 						m_sNowAnswer;			// ݂̃AT[
	s32							m_sNow2Answer;
	s32							m_sLastWait;			// Ō̕\EGCg
	u32							m_EffectID;
	u32							m_CheckID;
	u32							m_MessageID;
	bool						m_bSaveDir[4];
	bool						m_bRender;				// `tO
	bool						m_bCtrl;				// 싖tO
	bool						m_bDirDrawFlag;
	eCheckProc					m_Proc;
	eMesProc					m_MecProc;				
	s8							m_cCheckJmbHandle;
	EFFECT*						m_pEffectMessage;
	EFFECT*						m_pEffectCheck;
	EFFECT*						m_pEffectCursol;


	//	pbNt@C	-----------------------------------
	SK7File						m_File;
	ghmGcResLink*				m_pResLink;			//	N\[X
	void*						m_pPackData;		//	f[^
	TEX_DATA*					m_pTexture;			//	eNX`[f[^
	YK7StrImage* 				m_pYFont;			//	RctHg
	stSentence*					m_pSentence;		//	tHg
	stSentence*					m_pSentence2;		//	tHg


	static SK7PanelCreateFunc*	m_pPanelCreateFunc;

public:
	SK7PanelBase( s32 Now=PANEL_INIT_ARRANGE, s32 now2=PANEL_INIT_ARRANGE, bool CursolFlag=true, bool SoundFlag=false );
	virtual ~SK7PanelBase();
	static u32					m_lEventNo;				//	Cxgԍ	
	static SK7PanelBase* Create(ePanelID id,s32 now=PANEL_INIT_ARRANGE, s32 now2=PANEL_INIT_ARRANGE );
	static SK7PanelBase* Create(u32 evno,s32 now=PANEL_INIT_ARRANGE, s32 now2=PANEL_INIT_ARRANGE );
	static SK7PanelBase* CreatePanel01(u32 evno,s32 now,s32 now2 );
	static SK7PanelBase* CreatePanel02(u32 evno,s32 now,s32 now2 );
	static SK7PanelBase* CreatePanel03(u32 evno,s32 now,s32 now2 );
	static SK7PanelBase* CreatePanel04(u32 evno,s32 now,s32 now2 );
	static SK7PanelBase* CreatePanel05(u32 evno,s32 now,s32 now2 );
	static SK7PanelBase* CreatePanel06(u32 evno,s32 now,s32 now2 );
	static SK7PanelBase* CreatePanel07(u32 evno,s32 now,s32 now2 );

	static void SetCreatePanelFunc(SK7PanelCreateFunc *pfunc){ m_pPanelCreateFunc = pfunc; }
	static SK7PanelCreateFunc* GetCreatePanelFunc(void){ return m_pPanelCreateFunc; }

	// t[
	virtual s16  FrameProcess(void){ return 0; }
	
	// _O
	virtual bool RenderProcess(void){ return true; }
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd(void){ return true; }

	// 싖ݒ֐
	virtual void mSetCtrlFlag(bool flag){ m_bCtrl=flag; SetCursolDisp(flag); }

	// _O
	virtual void mSetRender(bool flag){ m_bRender=flag; }
	
	// II擾֐
	virtual bool mGetSelectEnd(void){ return true; }

	// Iڎ擾֐
	virtual s32 mGetResult(void){ return 0; }
	
	
	// II`FbN֐
	s8 			CheckAnswer( s16 No=-1, bool Cursol = false, bool cancel = true );
		
	//	J[\``FbN
	void		SetCursolDisp( bool flag ){ if( m_pEffectCursol == NULL || CheckEffectValidState(m_pEffectCursol,m_EffectID) == FALSE  ) return; SetPanelCursorDrawFlag( m_pEffectCursol, flag );  }
	
	//	J[\WZbg
	void		SetCursolPosition(Vec* vPos){ 	if( m_pEffectCursol == NULL || CheckEffectValidState(m_pEffectCursol,m_EffectID) == FALSE ) return; SetPanelCursorPosition( m_pEffectCursol, (s16)vPos->x, (s16)vPos->y ); }
	
	//	J[\TCYZbg
	void		SetCursolSize( f32 x, f32 y ){ 	if( m_pEffectCursol == NULL || CheckEffectValidState(m_pEffectCursol,m_EffectID) == FALSE ) return; SetPanelCursorSize( m_pEffectCursol, (u16)x, (u16)y ); }
	
	//	J[\ړZbg
	void		SetCursolDir( s8 dir , u8 state = true);
	
	//	J[\bZ[W
	void		DeleteCursolMessage(){	if( m_pEffectCursol == NULL || CheckEffectValidState(m_pEffectCursol,m_EffectID) == FALSE ) return; ::DelReqEffect( m_pEffectCursol ); }
	
	//	J[\bZ[W`ݒ
	void		SetMessageVisible( bool flag ){ if( m_pEffectCursol != NULL ){ SetPanelCursorOkCancelSelectDrawFlag( m_pEffectCursol, flag ); }  }
	
	//	bZ[W`FbN
	bool		DrawMessage( u16 MesNo );
	
	//	pbNeNX`[[h
	bool		LoadPackData( char*, u8, u8 font = PANEL_FONT_NONE, u8 fontnum=1 );

	//	J[\̏I`FbN
	bool		GetPanelCursolEnd();
	
#ifdef	_DEBUG
	static const SK7PanelDebugMenuTable* GetDebugMenuTable(ePanelID id);
#endif
	bool	PanelDebugFont( s32* Answer, s8 min, s8 max, bool Move=true );
};



//-----------------------------------------
//	fobNNX
//------------------------------------------
class SK7PanelDebug : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CANCEL,
	}eInputCodeProc;
	
protected:
	eInputCodeProc			m_Proc;
		
public:
	SK7PanelDebug( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelDebug();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
};

#endif	//__SK7PANELBASE_H__
