////////////////////////////////////////////////////////////////////////////////
//
// Killer7 SK7SpOption
//
// SK7SpOption.cpp
//	
// Creator       : Sato Shinya (GHM)
// Creation Date : 02/24/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7SPOPTION_CPP__
//#define	__EYE_EX_ONCE__
#define	__CODE_DRAW__
//#define	__NOUDE_DRAW__
#include <dolphin.h>
#include <sysdolphin\baselib.h>
#include "SK7Common.h"
#include "../matsu/mk7Sound.h"
#include "SK7Special.h"
#include "SK7SpOption.h"
#include "../matsu/mK7Noise.h"
#include "../wat/Blood.h"
#include "../scn/K7Scn04.h"
#include "../Yam/YK7EffectConveBlood.h"
#include "../Yam/YK7EffectCharge.h"
#include "../wat/WK7SelectIF.h"


//	IvVړ^C	***********************************************
#define		OPTION_MOVE_TIME		(12)
#define		BALLET_MOVE_TIME		(12)

//	EBhE	***********************************************
#define		OPTION_WINDOW_SIZEX		(100.0f)
#define		OPTION_WINDOW_SIZEY		(480.0f)
#define		OPTION_WIDDOW_SIZERX	(100)
#define		OPTION_WINDOW_SPEED		(15)

//		*******************************************************
#define		EYE_NUM					(5)
#define		RED_EYE_COLOR			(0xb00000ff)
#define		EYE_ANIME_TIME			(3)
#define		EYE_BALL_X				(19*0.5f)
#define		EYE_EX_TIME				(20.0f)

//	}V	-----------------------------------------------
#define		MACHINE_A_X				(540)
#define		MACHINE_A_Y				(262)
#define		MACHINE_B_X				(546)
#define		MACHINE_B_Y				(362)
#define		MACHINE_C_RX			(610)
#define		MACHINE_C_RY			(362)
#define		MACHINE_C_LX			(550)
#define		MACHINE_C_LY			(395)
#define		MACHINE_COLOR			(0xa3a39bff)
#define		MACHINE_UNDER_SIZE		(46)
#define		MACHINE_THICK_X			(50)
#define		MACHINE_THICK_Y			(365)
#define		MACHINE_THIN_X			(50)
#define		MACHINE_THIN_Y			(340)

//		-----------------------------------------
#define		SHIKEN_A_X				(475)
#define		SHIKEN_A_Y				(352)
#define		SHIKEN_B_X				(484)
#define		SHIKEN_B_Y				(357)
#define		SHIKEN_IN_X				(490)
#define		SHIKEN_IN_Y				(362)
#define		SHIKEN_IN_SIZEX			(2)
#define		SHIKEN_IN_SIZEY			(80)
#define		SHIKEN_IN_COLOR			(0xffffff7f)
#define		SHIKEN_BLOOD_SIZEX		(10)
#define		SHIKEN_B_ALPHA			(140)//0xBF)
#define		SHIKENKAN_NUM_Y			(293)
#define		SHIKENKAN_MAX_X			(65)
#define		SHIKEN_BLOOD_COLOR		(0xf01994ff)
#define		SHIKEN_BLOOD_COLOR2		(0x9e0c70ff)

//#define		RGB_COLOR(r,g,b,a)		((r<<24)+(g<<16)+(b<<8)+a)

//		----------------------------------------------
#define		BLOOD_THICK_LINEX		(416)
#define		BLOOD_THICK_LINEY		(305)
#define		BLOOD_THIN_LINEX		(490)
#define		BLOOD_THIN_LINEY		(353)
#define		BLOOD_THICK_TIME		(20)
#define		BLOOD_THIN_TIME			(20)
#define		BLOOD_THICK_SIZE		(30)
#define		BLOOD_THIN_SIZE			(30)
#define		BLOOD_TIME				(2)
#define		BLOOD_THICK_MOVE_Y		(8.0f)

//	R[hg	--------------------------------------
#define		CODE_WAKU_UP_X			(592)
#define		CODE_WAKU_UP_Y			(104)
#define		CODE_WAKU_DOWN_X		(594)
#define		CODE_WAKU_DOWN_Y		(183)
#define		CODE_WAKU_LEFT_X		(538)
#define		CODE_WAKU_LEFT_Y		(58)
#define		CODE_KAZARI_X			(510)
#define		CODE_KAZARI_Y			(182)
#define		CODE_WAKU_SIZE_X		(8)
#define		CODE_WAKU_SIZE_Y		(103)
#define		CODE_FONT_X				(544)
#define		CODE_FONT_Y				(103)
#define		CODE_FONT_SIZEY			(20)
#define		CODE_FONT_SPEED			(3)

//	m[h	----------------------------------------
#define		NOUDO_X					(540)
#define		NOUDO_Y					(183)
#define		NOUDO_FONT_GAPX			(50)
#define		NOUDO_FONT_Y			(202)
#define		NOUDO_KASAN_X			(18)

#define		KASAN_SIZE_NORMAL		(40)
#define		KASAN_SIZE_BIG			(70)
#define		KASAN_EX_SIZE			(15.0f)
#define		KASAN_TIME				(180)
#define		KASAN_EX_TIME			(15)
#define		KASAN_ALPHA_END			(5)

//	RpX	---------------------------------
#define		CONPAS_CIRCLE_X			(16)
#define		CONPAS_CIRCLE_Y			(30)
#define		CONPAS_KASAN_X			(28)
#define		CONPAS_KASAN_Y			(8)
#define		CONPAS_N_X				(45)
#define		CONPAS_N_Y				(23)
#define		CONPAS_S_X				(45)
#define		CONPAS_S_Y				(91)
#define		CONPAS_W_X				(11)
#define		CONPAS_W_Y				(61)
#define		CONPAS_E_X				(78)
#define		CONPAS_E_Y				(59)
#define		CONPAS_CENTER_X			(35)
#define		CONPAS_CENTER_Y			(40)
#define		CONPAS_SHADOW_ALPHA		(80)
#define		CONPAS_SHADOW_COLOR		(0x00000060)
#define		CONPAS_SIZE_X			(30)
#define		CONPAS_SIZE_Y			(50)
#define		CONPAS_HALF_SIZEX		(CONPAS_SIZE_X*0.5f)
#define		CONPAS_HALF_SIZEY		(CONPAS_SIZE_Y*0.5f)
#define		CONPAS_R				(36)
#define		CONPAS_ESIZE_X			(16)
#define		CONPAS_ESIZE_Y			(20)
#define		CONPAS_HALF_ESIZEX		(CONPAS_ESIZE_X*0.5f)
#define		CONPAS_HALF_ESIZEY		(CONPAS_ESIZE_Y*0.5f)
#define		CONPAS_ECENTER_X		(43.0625f)
#define		CONPAS_ECENTER_Y		(53.8f)
#define		CONPAS_ER				(35.8f)
#define		CONPAS_ENEMY_ALPHA_FRAME (12)


//	̏	------------------------------------
#define		UNDER_X					(0)
#define 	UNDER_Y					(444)
#define		UNDER_SIZEX				(100)
#define		UNDER_SIZEY				(36)

//	ǃRł͂Ȃ	----------------------------
#define		SP_SORE_X				(143)
#define		SP_SORE_Y				(400)

#define		MOVE_WINDOW_X			(640.0f)

const VEC2 tblTubePos[]={	476,273,	412,273,	412,289,	485,289,	485,329,	};
const VEC2 tblKasanPos[]={	 580,286,	608,318,	576,355,	613,361,	578,395,	594,431, 557,314,	};
const f32 tblEyeBallY[]={ 1.3f,3.0f,4.0f,7.5f, };//12.0f, 12.5f, 15.0f, 17.5f };//21.0f, 22.0f, 24.0f, 28.0f };//17.0f, 15.0f, 17.0f, };

void 	CheckBloodMoveStartCallBack( void* Data );


//========================================================================
//					RXgN^
//========================================================================
SK7SpOption::SK7SpOption()
{
	int i;
	m_bRenderFlag 	= false;
	m_bControlFlag 	= false;
	m_bMoveFlag		= false;
	m_bMoveBloodFlag= false;
	m_bSEFlag		= false;
	m_bRedFlag		= false;
	m_bWinMoveFlag	= false;
	m_bAllBloodMoveFlag = false;
	m_bBossFlag		= false;
	m_bCodeFlag		= false;
	m_bNoudoDrawFlag= false;
	m_iMoveAddTime  = 0;
	m_iMoveSetTime  = 0;
	m_iBloodNextTime= 0;
//	m_chBulletNum	= 0;
	m_fEyeMoveX		= 0;
	m_fUnderX		= 0;
	m_fMeterX		= 0;
	m_ulEffectID	= 0;
	m_fMoveY		= MACHINE_UNDER_SIZE;
	m_fBloodY		= PACK_GAUGE_DOWNY;
	m_usThickBlood 	= 0;
	m_usThinBlood	= 0;
	m_usSerumBlood	= 0;
	m_fNoudoX		= 0;
	m_usBloodPoint	= 0;
	m_iBloodTime	= 0;
	m_fShikenX		= SHIKENKAN_MAX_X-OPTION_WINDOW_SIZEX;
	m_ucMaxThinBlood= 255;
	m_eProc 		= SPOPTION_BALLET_CLOSE;
	m_eBloodProc	= BLOOD_PROC_CHECK;
	m_pBFont		= NULL;
	m_pYFont		= NULL;
	m_pEfCharge 	= NULL;
	memset( m_chMoveFont, 0, sizeof(s8)*CODE_FONT_LINE );
	
	m_usThickBlood 	= K7EVENT_GL_VAR(SpBloodThick);
	m_usThinBlood 	= K7EVENT_GL_VAR(SpBloodThin);
	m_usSerumBlood 	= K7EVENT_GL_VAR(SpBloodSerum);
//	m_chBulletNum 	= K7EVENT_GL_VAR(SpBullet);

	//		************************************************	
	m_spEye.SetTexSprite( EYE_X, EYE_Y, g_pSpData->GetTexture(TEX_EYE), 1, EYE_NUM, 0 );
	m_spEye.SetFlag		( true, RENDER_FLAG );
	m_spEye2.SetTexSprite( EYE_X, EYE_Y+tblEyeBallY[0], g_pSpData->GetTexture(TEX_EYE2), 1, EYE_NUM-1, 0 );
	m_spEye2.SetFlag	( false, RENDER_FLAG );
	memset( &m_Eye, 0, sizeof( EYE_STATE ) );	
	m_spEye.SetFlag( true, CENTER_FLAG );
	m_spEye2.SetFlag( true, CENTER_FLAG );

	
	//	EBhE	*****************************************************
	m_spWindow.SetSprite( OPTION_WINDOW_X, 0, OPTION_WIDDOW_SIZERX, OPTION_WINDOW_SIZEY, 0x0000007f );
	m_spWindow.SetFlag	( false, RENDER_FLAG );

	m_spWindowUp.SetSprite( OPTION_WINDOW_X, 0, OPTION_WIDDOW_SIZERX, OPTION_WINDOW_SIZEY, OPTION_WINDOW_COLOR );
	m_spWindowUp.SetColor4( 0x000000b2, 0x00000000, 0x000000b2, 0x00000000 );
	m_spWindowUp.SetFlag	( false, RENDER_FLAG );
	m_spWindowUp.SetFlag	( true, V4COLOR_FLAG );

	//	}V쐬	**************************************************
	CreateMacine();
	SetMacineRender( false );
	
	//	Z	*************************************************
	InitKasan();
	
	//	R[hg쐬	**************************************************
#ifdef __CODE_DRAW__
	m_Code.WakuTop.SetTexSprite		( CODE_WAKU_UP_X, CODE_WAKU_UP_Y, g_pSpData->GetTexture(TEX_SIDE_006) );
	SET_SPRITE_ROT					( &m_Code.WakuTop, 90, CODE_WAKU_UP_X, CODE_WAKU_UP_Y, CODE_WAKU_SIZE_X, CODE_WAKU_SIZE_Y );
	m_Code.WakuTop.SetIncX			( -MOVE_WINDOW_X );
	m_Code.WakuUnder.SetTexSprite	( CODE_WAKU_DOWN_X, CODE_WAKU_DOWN_Y, g_pSpData->GetTexture(TEX_SIDE_006) );
	SET_SPRITE_ROT					( &m_Code.WakuUnder, 90, CODE_WAKU_DOWN_X, CODE_WAKU_DOWN_Y, CODE_WAKU_SIZE_X, CODE_WAKU_SIZE_Y );
	m_Code.WakuUnder.SetIncX		( -MOVE_WINDOW_X );
	m_Code.WakuLeft.SetTexSprite	( CODE_WAKU_LEFT_X-MOVE_WINDOW_X, CODE_WAKU_LEFT_Y, g_pSpData->GetTexture(TEX_SIDE_006) );
	m_Code.Kazari.SetTexSprite		( CODE_KAZARI_X-MOVE_WINDOW_X, CODE_KAZARI_Y, g_pSpData->GetTexture(TEX_KAZARI_005) );
	m_Code.Kazari.SetSTTwo			( 1.0f, 0.0f, 0.0f, 1.0f );
	m_Code.WakuTop.SetColor			( 0x000000ff );
	m_Code.WakuUnder.SetColor		( 0x000000ff );
	m_Code.WakuLeft.SetColor		( 0x000000ff );
	m_Code.Kazari.SetColor			( 0x000000ff );
	m_Code.CodeX 					= CODE_FONT_X;
	m_Code.bStartFlag 				= false;
	m_Code.FontNo					= 0;
	m_Code.FontTime 				= 0;
	m_Code.FontLine					= 0;
	m_Code.CommentNo				= 0;
#endif
	//	RpX	********************************************
	for( i = 0; i < 2; i++ ){
		m_Conpas.spCircle[i].SetTexSprite	( CONPAS_CIRCLE_X+i*2, CONPAS_CIRCLE_Y+i*2, g_pSpData->GetTexture(TEX_CONP_CIRCLE) );
		m_Conpas.spCircle[i].SetAlpha		( CONPAS_SHADOW_ALPHA );
		m_Conpas.spCircle[i].SetVisible		( true );
	}
	
	for( i = 0; i < CONPAS_FONT_NUM; i++ ){
		m_Conpas.spN[i].SetTexSprite	( CONPAS_N_X+i, CONPAS_N_Y+i, g_pSpData->GetTexture(TEX_CONP_N) );
		if( i != 0 )					m_Conpas.spN[i].SetColor		( CONPAS_SHADOW_COLOR );
		m_Conpas.spN[i].SetVisible		( true );
		m_Conpas.spS[i].SetTexSprite	( CONPAS_S_X+i, CONPAS_S_Y+i, g_pSpData->GetTexture(TEX_CONP_S) );
		if( i != 0 )					m_Conpas.spS[i].SetColor		( CONPAS_SHADOW_COLOR );
		m_Conpas.spS[i].SetVisible		( true );
		m_Conpas.spW[i].SetTexSprite	( CONPAS_W_X+i, CONPAS_W_Y+i, g_pSpData->GetTexture(TEX_CONP_W) );
		if( i != 0 )					m_Conpas.spW[i].SetColor		( CONPAS_SHADOW_COLOR );
		m_Conpas.spW[i].SetVisible		( true );
		m_Conpas.spE[i].SetTexSprite	( CONPAS_E_X+i, CONPAS_E_Y+i, g_pSpData->GetTexture(TEX_CONP_E) );
		if( i != 0 )					m_Conpas.spE[i].SetColor		( CONPAS_SHADOW_COLOR );
		m_Conpas.spE[i].SetVisible		( true );
	}
	m_Conpas.spKasan.SetTexSprite	( CONPAS_KASAN_X, CONPAS_KASAN_Y, g_pSpData->GetTexture(TEX_CONP_CONPAS_KASAN) );
	m_Conpas.spKasan.SetBlendNo		( SPR_BLEND_ONE );
	m_Conpas.spKasan.SetVisible		( true );
	
	m_Conpas.spEnemyKasan.SetTexSprite	( CONPAS_KASAN_X, CONPAS_KASAN_Y, g_pSpData->GetTexture(TEX_ENEMY_KASAN) );
	m_Conpas.spEnemyKasan.SetBlendNo	( SPR_BLEND_ONE );
	m_Conpas.spEnemyKasan.SetVisible	( true );
	
	f32 yrot;
	WK7PLAYERCONTROL->GetRotY(&yrot);
	m_Conpas.fAngle 		= yrot;
	m_Conpas.fEnemyAngle	= 0;
	m_Conpas.bEnemyRender	= false;
	m_Conpas.bReverseState 	= false;
	
	//	Zx	***********************************************
#ifdef __NOUDE_DRAW__
	m_spNoudo.SetTexSprite( NOUDO_X-MOVE_WINDOW_X, NOUDO_Y, g_pSpData->GetTexture(TEX_NODE) );
	m_spNoudo.SetColor( 0x000000ff );
	m_spNoudoBack.SetTexSprite( NOUDO_X-MOVE_WINDOW_X+NOUDO_KASAN_X, NOUDO_Y, g_pSpData->GetTexture(TEX_MACINE_KASANB) );
	m_spNoudoBack.SetBlendNo( SPR_BLEND_ONE ); 
	m_spNoudoBack.SetAlpha( 0xa0 );
#endif
	//	RctHg[h	***********************************************
	ghmGcMemSetAllocName("SK7SPO");
	m_pYFont = new YK7StrImage;
	m_pYFont->LoadMem( g_pSpData->GetYFontData() );
	ghmGcMemSetAllocName("SK7SPO");
	m_pBFont = new YK7StrImage;
	m_pBFont->LoadMem( g_pSpData->GetYFontData(1) );

	//	Ǎ쐬	**************************************************
	m_Shiken.Waku.SetTexSprite	( SHIKEN_A_X-MOVE_WINDOW_X, SHIKEN_A_Y, g_pSpData->GetTexture(TEX_SIKENKAN_A) );
	m_Shiken.Kan.SetTexSprite	( SHIKEN_B_X-MOVE_WINDOW_X, SHIKEN_B_Y, g_pSpData->GetTexture(TEX_SIKENKAN_B) );	
	m_Shiken.Kan.SetAlpha		( SHIKEN_B_ALPHA );
	m_Shiken.In.SetSprite		( SHIKEN_IN_X-MOVE_WINDOW_X, SHIKEN_IN_Y, SHIKEN_IN_SIZEX, SHIKEN_IN_SIZEY, SHIKEN_IN_COLOR );
	m_Shiken.Blood.SetTexSprite	( SHIKEN_B_X-MOVE_WINDOW_X, SHIKEN_B_Y+SHIKEN_IN_SIZEY, g_pSpData->GetTexture(TEX_BLOOD) );
	m_Shiken.Blood.SetTwoSize	( SHIKEN_BLOOD_SIZEX, 0.0f );
	m_Shiken.Blood.SetFlag		( true, SIZE_FLAG );
	m_Shiken.Blood.SetColor		( SHIKEN_BLOOD_COLOR );

	//	̍	*********************************************************
	m_spUnder.SetSprite		( UNDER_X-UNDER_SIZEX, UNDER_Y, UNDER_SIZEX, UNDER_SIZEY, 0x000000ff );
	
	//	ǃRł͂Ȃ
	m_Sore.Time 		= 0;
	m_Sore.SelectFlag 	= false;
	m_Sore.spFont.SetTexSprite	( SP_SORE_X, SP_SORE_Y, g_pSpData->GetTexture(TEX_MOJI_SORE) );
	m_Sore.spFont.SetVisible	( false );
	m_Sore.spPlate.SetTexSprite	( SP_SORE_X, SP_SORE_Y, g_pSpData->GetTexture(TEX_MOJI_PLATE) );
	m_Sore.spPlate.SetColor		( 0x000000ff );
	m_Sore.spPlate.SetVisible	( false );
	
	//	Rc	******************************************************
	SetEffectCharge();
}

//========================================================================
//					fXgN^
//========================================================================
SK7SpOption::~SK7SpOption()
{
	DeleteEffect( m_pEfCharge );
	SetConveBloodIncBloodCallBackFunction( NULL, NULL );
	
	if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_SCENARIO_CLEAR ) ){
		m_usThickBlood 	= 0;
		m_usThinBlood	= 0;
		BattleCtrl.SetBpGauge( BP_THICK, 0 );
		BattleCtrl.SetBpGauge( BP_THIN, 0 );
		K7EVENT_GL_VAR(SpBloodThick) 	= 0;
		K7EVENT_GL_VAR(SpBloodThin)		= 0;
	}else{
		K7EVENT_GL_VAR(SpBloodThick) = m_usThickBlood;
		K7EVENT_GL_VAR(SpBloodThin)	= m_usThinBlood;
	}
	K7EVENT_GL_VAR(SpBloodSerum) = m_usSerumBlood;
	
	GHM_SAFE_DELETE( m_pYFont );
	GHM_SAFE_DELETE( m_pBFont );
}


//========================================================================
//					t[
//========================================================================
bool 	SK7SpOption::FrameProcess(void)
{		
	if( !m_bControlFlag ) 	return true;

	//	̃R[obN	--------------------------------------------------
	SetConveBloodIncBloodCallBackFunction( CheckBloodMoveStartCallBack, &m_bAllBloodMoveFlag );

	//	RpXZbg	
	f32 yrot;
	if( m_Conpas.bReverseState ){
		yrot = m_Conpas.fAngle;
	}else{
		WK7PLAYERCONTROL->GetRotY(&yrot);
		m_Conpas.fAngle = yrot;
	}
	yrot = -yrot+PI*0.5f-WK7SelectIF::GetStageDirOffset();
	SET_SPRITE_ROT( &m_Conpas.spKasan, MTXRadToDeg(yrot), CONPAS_CENTER_X+CONPAS_R*cosf( yrot )+CONPAS_HALF_SIZEX, CONPAS_CENTER_Y+CONPAS_R*sinf( yrot )+CONPAS_HALF_SIZEY, CONPAS_SIZE_X, CONPAS_SIZE_Y );
	//	Gl~[p	----------------------------------------------------------
	f32 EYrot = m_Conpas.fEnemyAngle;
	EYrot = -EYrot+PI*0.5f-WK7SelectIF::GetStageDirOffset();
	SET_SPRITE_ROT( &m_Conpas.spEnemyKasan, MTXRadToDeg(EYrot), CONPAS_ECENTER_X+CONPAS_ER*cosf( EYrot )+CONPAS_HALF_ESIZEX, CONPAS_ECENTER_Y+CONPAS_ER*sinf( EYrot )+CONPAS_HALF_ESIZEY, CONPAS_ESIZE_X, CONPAS_ESIZE_Y );	
	if( m_Conpas.bEnemyRender ){
		m_Conpas.spEnemyKasan.AddAlpha( CONPAS_ENEMY_ALPHA_FRAME );
	}else{
		m_Conpas.spEnemyKasan.DownAlpha( CONPAS_ENEMY_ALPHA_FRAME );
	}
	
	//	t}t[	
	BloodFrameProcess();
	m_bAllBloodMoveFlag = false;
	
	//	EBhEړt[		
	WindowFrameProcess();
	
	//	ڋʐԂȂ邩`FbN	
	if( m_usThinBlood >= BLOOD_SPABILITY ){
		m_bRedFlag = true;
	}else{
		m_bRedFlag = false;
	}
	if( m_spEye.CheckFlag( RENDER_FLAG ) )	m_spEye2.SetVisible( m_bRedFlag );

	//	ڋʃAj[V	
	MoveEyeAnime();
	
	//	ǂł͂Ȃ	
	if( m_Sore.spFont.CheckFlag( RENDER_FLAG ) )	MoveSore();
	return true;
}


//========================================================================
//					_O
//========================================================================
bool 	SK7SpOption::RenderProcess(void)
{
	if( !m_bRenderFlag ) 	return true;

	int i;

	//	ړEBhE	*********************************
	m_spWindow.Render();
	m_spUnder.Render();

	//	ڂ̕\	**********************************************
	m_spEye.Render();
	if( !m_Eye.NotDrawFlag )	m_spEye2.Render();

	//	}V	------------------------------------------------
	m_Macine.BodyA.Render();
	m_Macine.BodyB.Render();
	m_Macine.BodyC[0].Render();
	m_Macine.BodyC[1].Render();

	for( i = 0; i < MACHINE_TUBE_NUM; i++ )		m_Macine.Tube[i].Render();
	
	//	uh߂	-----------------------------------------
	GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
	m_Macine.BloodThick.Render();	

	//		------------------------------------------------
	m_Shiken.Waku.Render();
	m_Macine.BloodThin.Render();
	m_Shiken.Blood.Render();
	m_Shiken.Kan.Render();
	m_Shiken.In.Render();

	//	ǃ`[W	----------------------------------------
	if( CheckEffectValidState( m_pEfCharge, m_ulEffectID ) == TRUE ){
		MoveEffect(m_pEfCharge);
		DrawEffect(m_pEfCharge);
	}

	m_spWindowUp.Render();

	//	R[hg	-------------------------------------------
#ifdef __CODE_DRAW__
	m_Code.WakuTop.Render();	
	m_Code.WakuUnder.Render();	
	m_Code.WakuLeft.Render();	
	m_Code.Kazari.Render();		
#endif
	//	RpX	**************************************
	for( i = 0; i < 2; i++ ){
		m_Conpas.spCircle[i].Render();
	}
	for( i = CONPAS_FONT_NUM-1; i >= 0; i-- ){
		m_Conpas.spN[i].Render();
		m_Conpas.spS[i].Render();
		m_Conpas.spW[i].Render();
		m_Conpas.spE[i].Render();
	}
	m_Conpas.spEnemyKasan.Render();
	if( m_spEye.GetExX() >= 1.0f )	m_Conpas.spKasan.Render();
	GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );

	//	Zx	**********************************************
#ifdef __NOUDE_DRAW__
	m_spNoudoBack.Render();
	//	uh߂	-----------------------------------------
	GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
	m_spNoudo.Render();
#endif

#ifdef __CODE_DRAW__
	RenderMoveCode();		//	R[h̕`	
#endif

	for( i = 0; i < MACHINE_KASAN_NUM; i++ )	m_Kasan[i].sprite.Render();

	RenderNoudoFont();

	m_Sore.spPlate.Render();
	m_Sore.spFont.Render();
	return true;
}


//========================================================================
//					R[obN
//========================================================================
void 		CheckBloodMoveStartCallBack( void* Data )
{
	*((bool*)Data) = true;
}

//========================================================================
//					tt[
//========================================================================
void 	SK7SpOption::_BloodFrameProcess(void)
{
	int Answer=0;
	//̌vZ	**************************************
	s8 IncPoint = 1;
	//	ĈړIĂȂƂ
	if( BattleCtrl.GetBpGauge( BP_THIN ) > 0 && !m_Macine.bThinMoveFlag ){
		Answer = BattleCtrl.IncBpGauge( BP_THIN, -IncPoint );
		m_usThinBlood += IncPoint;
		if( m_usThinBlood >= m_ucMaxThinBlood*BLOOD_PACK ){
			m_usThinBlood = (u16)(m_ucMaxThinBlood*BLOOD_PACK);
		}			
		//	ׂďo؂	-----------------------------
		if( Answer <= 0 ){
			m_Macine.bThinMoveFlag 	= true;
			m_Macine.bThinEndFlag 	= true;
		}
	}				
	if( ++m_iBloodTime >= BLOOD_TIME ){
		//	ĈړIĂȂƂ
		if( BattleCtrl.GetBpGauge( BP_THICK ) > 0 && !m_Macine.bThickMoveFlag ){
			Answer = BattleCtrl.IncBpGauge( BP_THICK, -IncPoint );
			m_usThickBlood += IncPoint;
			if( m_usThickBlood >= BLOOD_THICK_GAUGE_MAX ){
				m_usThickBlood = BLOOD_THICK_GAUGE_MAX;
			}
			//	ׂďo؂	-----------------------------
			if( Answer <= 0 ){
				m_Macine.bThickMoveFlag = true;
				m_Macine.bThickEndFlag 	= true;
			}
		}
		m_iBloodTime = 0;
	}
}

//========================================================================
//					tt[
//========================================================================
bool 	SK7SpOption::BloodFrameProcess(void)
{		
	CheckThickMoveStart();
	CheckThinMoveStart();
	if( m_Macine.bThickMoveFlag )	MoveBloodThick();
	if( m_Macine.bThinMoveFlag )	MoveBloodThin();

	//	Z̐c`FbN	:::::::::::::::::::::::::::::::::::::
	for( int i = 0; i < MACHINE_KASAN_NUM; i++ ){
		if( m_Kasan[i].Time <= -1 )	continue;
		
		//	I	------------------------------------------
		if( ++m_Kasan[i].Time >= KASAN_TIME ){
			m_Kasan[i].Time = -1;
		}
	}
	//	IAt@	============================================
	for( int i = 0; i < MACHINE_KASAN_NUM; i++ ){
		if( m_Kasan[i].Time == -1 ){
			m_Kasan[i].sprite.DownAlpha( KASAN_ALPHA_END );
		}
	}
	
	//	tI`FbN		-----------------------------------------------------
	if( (BattleCtrl.GetBpGauge( BP_THIN ) > 0 || BattleCtrl.GetBpGauge( BP_THICK ) > 0) && m_bAllBloodMoveFlag ){
		if( !m_bSEFlag ){
			gpSound->mPlaySE( SFX_SYS_SUBSCREEN_POMPBLOOD );
			m_bSEFlag = true;
		}
#ifdef __CODE_DRAW__
		m_Code.bStartFlag = true;		//	R[hĂ悵
#endif
		//	Zgk	:::::::::::::::::::::::::::::::::::::
		m_Macine.AddTime++;
		if( m_Macine.AddTime <= KASAN_EX_TIME ){
			for( int i = 0; i < MACHINE_KASAN_NUM; i++ ){
				m_Kasan[i].sprite.SetIncSizeXY( -KASAN_EX_SIZE/KASAN_EX_TIME, -KASAN_EX_SIZE/KASAN_EX_TIME );
			}
		}else if( m_Macine.AddTime <= KASAN_EX_TIME*2 ){
			for( int i = 0; i < MACHINE_KASAN_NUM; i++ ){
				m_Kasan[i].sprite.SetIncSizeXY( KASAN_EX_SIZE/KASAN_EX_TIME, KASAN_EX_SIZE/KASAN_EX_TIME );
			}
		}else{
			m_Macine.AddTime = 0;
		}
		//	t}
		_BloodFrameProcess();
	}else{
		if( BattleCtrl.GetBpGauge( BP_THIN ) > 0 || BattleCtrl.GetBpGauge( BP_THICK ) > 0 ){
			if( ++m_iBloodNextTime > 90 ){
				//	t}
				_BloodFrameProcess();
			}
		}else{
			m_iBloodNextTime = 0;
		}
		m_bSEFlag = false;
	}
	SetStoreNo();
	return true;
}

//========================================================================
//					EBhEt[
//========================================================================
bool 	SK7SpOption::WindowFrameProcess(void)
{
	if( GetBloodPointEnd() && m_eProc == SPOPTION_BALLET_MOVE ){
		m_eProc = SPOPTION_BALLET_CLOSE;
	}
	
	switch( m_eProc )
	{
	//	ړ	**********************************************************
	case SPOPTION_CHARGE_MOVE:
	case SPOPTION_BALLET_MOVE:
		MoveLeftWindow( true );
		break;
		
	//	߂	**********************************************************
	case SPOPTION_BALLET_CLOSE:
//		if( BattleCtrl.GetBpGauge( BP_THIN ) > 0 || BattleCtrl.GetBpGauge( BP_THICK ) > 0 )	break;
		if( !GetBloodPointEnd() )	break;
		MoveLeftWindow( false );
		break;
		
	//	ł߂
	case SPOPTION_DEMO_CLOSE:
		if( BattleCtrl.GetBpGauge( BP_THIN ) <= 0 && BattleCtrl.GetBpGauge( BP_THICK ) <= 0 ){
			if( GetBloodPointEnd() ){
				m_eProc = SPOPTION_BALLET_CLOSE;
			}
			break;
		}
		MoveLeftWindow( false );
		break;
	
	//	BĂ҂	******************************************************
	case SPOPTION_STANBY:
		break;
			
	//	o	**********************************************************
	case SPOPTION_EXIT:
		break;
	}
	return true;	
}

//========================================================================
//					EBhEǏ
//========================================================================
EFFECT*		SK7SpOption::SetEffectCharge()
{
	if( CheckEffectValidState( m_pEfCharge, m_ulEffectID ) == FALSE ){
		m_pEfCharge = CreateChargeEffect( 3 );
		m_ulEffectID = GetEffectID( m_pEfCharge );
		if( m_pEfCharge != NULL ){
			SetChargeEffectAutoFlag	( m_pEfCharge, false );
			SetEffectIndeManageFlag	( m_pEfCharge, true );
			SetChargeEffectInFlag	( m_pEfCharge, true );
		}
	}
	return m_pEfCharge;
}

//========================================================================
//					`[uGtFNg̍폜
//========================================================================
void		SK7SpOption::DeleteTubeEffect()
{
	DeleteEffect( m_pEfCharge );
}


//========================================================================
//					EBhEړ
//========================================================================
void		SK7SpOption::SetState( eProc proc, bool set )
{
#pragma unused( set )
	
	switch( proc ){
	case SPOPTION_CHARGE_MOVE:
	case SPOPTION_BALLET_MOVE:
		if( GameInfo.GetSpecial() != NULL )	break;
		if( m_eProc == SPOPTION_DEMO_CLOSE && proc == SPOPTION_CHARGE_MOVE ){
			m_eProc = proc;
			break;
		}
		if( m_eProc != SPOPTION_DEMO_CLOSE && m_eProc != SPOPTION_CHARGE_MOVE ){
			m_eProc = proc;
			break;
		}
		m_spWindow.SetFlag	( true, RENDER_FLAG );
		m_spWindowUp.SetFlag( true, RENDER_FLAG );
		m_spUnder.SetVisible( true );
		SetMacineRender		( true );
		
#ifdef __CODE_DRAW__
		m_Code.WakuTop.SetVisible		( true );
		m_Code.WakuUnder.SetVisible		( true );
		m_Code.WakuLeft.SetVisible		( true );
		m_Code.Kazari.SetVisible		( true );
#endif
#ifdef __NOUDE_DRAW__
		m_spNoudo.SetVisible			( true );
		m_spNoudoBack.SetVisible		( true );
#endif
		break;
		
	case SPOPTION_DEMO_CLOSE:
	case SPOPTION_BALLET_CLOSE:
		//	XyVƂ͂Ȃ	
		if( GameInfo.GetSpecial() != NULL )	break;
		if( m_eProc != SPOPTION_DEMO_CLOSE )	m_eProc = proc;
		break;
	
	case SPOPTION_STANBY:
		if ( (true == set) ){
			if( m_eProc != proc )	m_eProc = proc;
			m_spWindow.SetVisible	( false );
			m_spWindowUp.SetVisible	( false );
		}
		
		m_fShikenX = SHIKENKAN_MAX_X-OPTION_WINDOW_SIZEX;
		if( CheckEffectValidState( m_pEfCharge, m_ulEffectID ) == TRUE ){
			SetChargeEffectInRate( m_pEfCharge, 0.0f );
		}
		break;
	case SPOPTION_EXIT:
		break;
	}
}


//========================================================================
//					EBhEړ
//========================================================================
bool		SK7SpOption::MoveLeftWindow( bool State )
{	
//	if( !m_bMoveFlag ) return true;
	
	f32 MoveWinX  = OPTION_WINDOW_SPEED;//(OPTION_WINDOW_SIZEX/OPTION_MOVE_TIME);
	if( !State ) MoveWinX = -MoveWinX;

	m_spWindow.SetX0	( m_spWindow.GetX0()+MoveWinX );	//	EBhE
	m_spWindowUp.SetX0	( m_spWindowUp.GetX0()+MoveWinX );	//	EBhE
	m_spUnder.SetX0		( m_spUnder.GetX0()+MoveWinX );
	SetMacinePos		( MoveWinX, 0 );	
	m_fShikenX	+= MoveWinX;
	m_fMeterX	+= MoveWinX;
	
	if( State ){
		if( m_spWindow.GetX0() >= 0 ){
			m_spWindow.SetX0( 0 );
		}
		if( m_spWindowUp.GetX0() >= 0 ){
			m_spWindowUp.SetX0( 0 );
		}
		if( m_spUnder.GetX0() >= 0 )	{
			m_spUnder.SetX0( 0 );
		}
		if( m_spWindow.GetX0() >= 0 ){
			SetMacineLeftPos(true);
		}
		if( m_fShikenX > SHIKENKAN_MAX_X ){
			m_fShikenX = SHIKENKAN_MAX_X;
		}
		if( m_fMeterX > MACHINE_THICK_X ){
			m_fMeterX = MACHINE_THICK_X;
		}
	}else{
		if( m_spWindow.GetX0() <= OPTION_WINDOW_X ){
			m_spWindow.SetX0( OPTION_WINDOW_X );
		}
		if( m_spWindowUp.GetX0() <= OPTION_WINDOW_X ){
			m_spWindowUp.SetX0( OPTION_WINDOW_X );
		}
		if( m_spUnder.GetX0() <= OPTION_WINDOW_X )	{
			m_spUnder.SetX0( OPTION_WINDOW_X );
		}
		if( m_spWindow.GetX0() <= OPTION_WINDOW_X ){
			SetMacineLeftPos(false);
		}		
		if( m_fShikenX <= -OPTION_WINDOW_SIZEX+SHIKENKAN_MAX_X ){
			m_fShikenX = -OPTION_WINDOW_SIZEX+SHIKENKAN_MAX_X;
		}
		if( m_fMeterX < MACHINE_THICK_X-OPTION_WINDOW_SIZEX ){
			m_fMeterX = MACHINE_THICK_X-OPTION_WINDOW_SIZEX;
		}
	}
	//	ǈړ
#if 0
	switch( WK7PLAYERCONTROL->GetMainID() ){
	case K7DAN:
	case K7CYO:
	case K7KVN:
	case K7MSK:
#endif
	f32 NowRate;
	f32 MoveEffectX = 1.0f/((f32)OPTION_WINDOW_SIZEX/(f32)OPTION_WINDOW_SPEED);
	if( CheckEffectValidState( m_pEfCharge, m_ulEffectID ) == TRUE ){
		if( State ){
			NowRate = GetChargeEffectInRate( m_pEfCharge )+MoveEffectX;
			if( NowRate >= 1.0f ) NowRate = 1.0f;
		}else{
			NowRate = GetChargeEffectInRate( m_pEfCharge )-MoveEffectX;
			if( NowRate <= 0.0f ) NowRate = 0.0f;
		}
		SetChargeEffectInRate( m_pEfCharge,  NowRate );
	}
#if 0
		break;
	default:
		break;
	}
#endif
#ifdef __NOUDE_DRAW__
	m_spNoudo.SetIncX			( MoveWinX );
	m_spNoudoBack.SetIncX		( MoveWinX );
#endif

	return false;
}

//========================================================================
//					IvV`悷邩ǂB
//========================================================================
void		SK7SpOption::SetRenderOption( bool State )
{
	m_spWindow.SetVisible		( State );
	m_spWindowUp.SetVisible	( State );
	m_spUnder.SetVisible		( State );
	SetMacineRender				( State );
#ifdef __CODE_DRAW__
	m_Code.WakuTop.SetVisible	( State );
	m_Code.WakuUnder.SetVisible	( State );
	m_Code.WakuLeft.SetVisible	( State );
	m_Code.Kazari.SetVisible	( State );
#endif
#ifdef __NOUDE_DRAW__
	m_spNoudo.SetVisible		( State );
	m_spNoudoBack.SetVisible	( State );
#endif
	SetNoudoRender				( State );
}

//========================================================================
//					ڂ\邩ǂ
//========================================================================
void		SK7SpOption::SetRenderEye( bool State )
{
	m_spEye.SetFlag( State, RENDER_FLAG );
	if( State ){
		if( !m_bRedFlag ){
			m_spEye2.SetVisible( false );
		}else{
			m_spEye2.SetVisible( true );
		}
	}else{
		m_bRedFlag = false;
		m_spEye2.SetVisible( false );
	}
	SetRenderConpas( State );
}

//========================================================================
//					RpX`
//========================================================================
void		SK7SpOption::SetRenderConpas( bool State )
{
	int i;
	for( i = 0; i < 2; i++ ){
		m_Conpas.spCircle[i].SetVisible( State );
	}
	for( i = CONPAS_FONT_NUM-1; i >= 0; i-- ){
		m_Conpas.spN[i].SetVisible( State );
		m_Conpas.spS[i].SetVisible( State );
		m_Conpas.spW[i].SetVisible( State );
		m_Conpas.spE[i].SetVisible( State );
	}
	m_Conpas.spKasan.SetVisible( State );	
	m_Conpas.spEnemyKasan.SetVisible( State );
}

//========================================================================
//					ACe쐬
//========================================================================
void		SK7SpOption::CreateItem( u8 state )
{
	switch( state ){
	case ITEM_BALLET:
		break;
	}
//	m_chBulletNum++;
}

//========================================================================
//					ACe폜
//========================================================================
void		SK7SpOption::DeleteItem( u8 state )
{
	//	炷***********************************
//	if( --m_chBulletNum < 0 )	m_chBulletNum = 0;

	switch( state ){
	case ITEM_BALLET:
		break;
	}
}

//========================================================================
//					eې擾
//========================================================================
s8		SK7SpOption::GetBalletNum()
{
	s8 num=0;
	int i;
	for( i = 0;i < SP_BULLET_NUM; i++ ){
		if( tblBulletNo[GameInfo.GetScenarioFlow()].No[i] == NULL )		break;
		if( K7SCR_EVHASITEM( K7EVITEM_TAMAID(tblBulletNo[GameInfo.GetScenarioFlow()].No[i]) )==true ){
			if( K7SCR_EVISUSEDITEM( K7EVITEM_TAMAID(tblBulletNo[GameInfo.GetScenarioFlow()].No[i]) )!=true ){
				num++;
			}
		}
	}
	return num;
}

//========================================================================
//					EBhEړset
//========================================================================
void		SK7SpOption::SetOptionX()
{
	m_fEyeMoveX 	= m_spEye.GetX0();
	m_Macine.vPos.x = m_Macine.BodyA.GetX0();
	m_Macine.vPos.y = m_Macine.BodyA.GetY0();
#ifdef __CODE_DRAW__
	m_Code.MoveX	= m_Code.WakuLeft.GetX0();
#endif
	m_fUnderX		= m_spUnder.GetX0();
}

//========================================================================
//					EBhEړ
//========================================================================
void		SK7SpOption::MoveOptionX( bool state )
{
	f32 MoveX = MOVE_WINDOW_X/SP_MOVE_FRAME;
	f32 MoveY = (MACHINE_A_Y - m_Macine.vPos.y)/SP_MOVE_FRAME;
	if( !state )	MoveX = -MoveX;
	
	if( state ){
		m_spEye.SetX0	( m_spEye.GetX0()+(EYE_RIGHT_X - m_fEyeMoveX)/SP_MOVE_FRAME );  
		m_spEye2.SetX0	( m_spEye.GetX0() );
		m_spUnder.SetIncX ( (540-m_fUnderX)/SP_MOVE_FRAME );
		SetMacinePos	( (MACHINE_A_X - m_Macine.vPos.x)/SP_MOVE_FRAME , MoveY );		//	}Vړ
		m_fMoveY += MoveY;
#ifdef __CODE_DRAW__		
		m_Code.WakuTop.SetIncX		( (CODE_WAKU_LEFT_X - m_Code.MoveX)/SP_MOVE_FRAME );
		m_Code.WakuUnder.SetIncX	( (CODE_WAKU_LEFT_X - m_Code.MoveX)/SP_MOVE_FRAME );
		m_Code.WakuLeft.SetIncX		( (CODE_WAKU_LEFT_X - m_Code.MoveX)/SP_MOVE_FRAME );
		m_Code.Kazari.SetIncX		( (CODE_WAKU_LEFT_X - m_Code.MoveX)/SP_MOVE_FRAME );
#endif
	}else{
		m_spEye.SetIncX			( (EYE_X - EYE_RIGHT_X)/SP_MOVE_FRAME );
		m_spEye2.SetIncX		( (EYE_X - EYE_RIGHT_X)/SP_MOVE_FRAME );
		m_spUnder.SetIncX		( MoveX );
		
		SetMacinePos			( MoveX, -MoveY );		//	}Vړ
		m_fMoveY -= MoveY;
#ifdef __NOUDE_DRAW__
		m_spNoudo.SetIncX		( MoveX );			//	Zx
		m_spNoudoBack.SetIncX	( MoveX );
#endif
#ifdef __CODE_DRAW__
		m_Code.WakuTop.SetIncX		( MoveX );
		m_Code.WakuUnder.SetIncX	( MoveX );
		m_Code.WakuLeft.SetIncX		( MoveX );
		m_Code.Kazari.SetIncX		( MoveX );
#endif
	}	
	m_Macine.BloodThick.SetIncX( MoveX );
	m_Macine.BloodThin.SetIncX ( MoveX );

	m_Shiken.Waku.SetIncX	( MoveX );
	m_Shiken.Kan.SetIncX	( MoveX );
	m_Shiken.In.SetIncX		( MoveX );
	m_Shiken.Blood.SetIncX	( MoveX );
}

//========================================================================
//					R[h
//========================================================================
void		SK7SpOption::RenderMoveCode()
{
#ifdef __CODE_DRAW__
	const char* comment[21]={ 
		"GetBlood In",
		"Complete OK",
		"++C Lines is",
		"Include True", 
		"copy data OK",		
		"new Create",
		"killer7 That",
		"BattleCtrl 1",
		"Memcpy True", 
		"Gauge Over",
		"#define Init",
		"Sprite Code",
		"MoveLine in",
		"Special No",
		"const char*",
		"if this-> ?",
		"while 0 and",
		"continue; ",
		"float int",
		"switch()case",
		"Next Line Ok",
	};

	//	oĂƂ̂	------------------------------------------------
	if( m_bCodeFlag ){	
		//	font̕ړ
		if( ++m_Code.FontTime > CODE_FONT_SPEED ){
			m_Code.FontTime = 0;
			m_Code.FontNo++;
		}
		char string[12][255];
		memset( string, '\0', sizeof(char)*255*12);
	 	const char* Onefont = comment[m_Code.FontLine];

		//	Ō܂Ō	------------------------------
		if( Onefont[m_Code.FontNo] == '\0' ){
			m_chMoveFont[m_Code.FontLine] = (s8)m_Code.CommentNo;
			m_Code.FontLine++;					//	s𑝂₷
			m_Code.CommentNo = rand()%21;
			m_Code.FontNo = 0;
			//	sK葽ȂsO
			if( m_Code.FontLine >= CODE_FONT_LINE ){
				m_Code.FontLine = 0;
			}
		}
		//	s1sȏ̂Ƃ	----------------------------------
		if( m_Code.FontLine > 0 ){
			for( int i = 0; i < m_Code.FontLine; i++ ){
				if( m_Code.FontLine < CODE_FONT_LINE ){
					int Num=12;
					memcpy( string[i], comment[m_chMoveFont[i]], (u32)Num );
				}else{
					int Num2=12;
					memcpy( string[i], comment[m_chMoveFont[i]], (u32)Num2 );
				}
			}
		}
		//	݂̂
		memcpy( string[m_Code.FontLine], comment[m_Code.CommentNo], m_Code.FontNo );
		for( int i = 0; i < m_Code.FontLine+1; i++ ){
			m_pYFont->DrawSetup();
			m_pYFont->SetColor2( 0x000000ff );
			m_pYFont->SetExRate( 0.8f );
			m_pYFont->DrawFSStr( m_Code.WakuLeft.GetX0()+6, CODE_FONT_Y+i*CODE_FONT_SIZEY*0.8f , false, true, "%s", string[i]  ); 
		}
	}else{
		m_Code.FontNo	= 0;
		m_Code.FontLine = 0;
		m_Code.FontTime = 0;
	}
#endif
}


//========================================================================
//					ZxtHg
//========================================================================
void		SK7SpOption::RenderNoudoFont()
{
	if( m_fShikenX > -OPTION_WINDOW_SIZEX+SHIKENKAN_MAX_X ){
		//	ǖ{\	---------------------------------------------------------------
		if( CheckEffectValidState( m_pEfCharge, m_ulEffectID ) == TRUE ){
			m_pBFont->DrawSetup();
			m_pBFont->SetColor2( 0x000000ff );
			m_pBFont->SetExRate( 0.7f );
			m_pBFont->DrawFSStr( m_fShikenX+2, SHIKENKAN_NUM_Y+2, true, true, "%d", (m_usThinBlood/BLOOD_PACK)-GetChargeEffectChargeNum(m_pEfCharge) ); 
			m_pBFont->DrawFSStr( m_fShikenX-2, SHIKENKAN_NUM_Y-2, true, true, "%d", (m_usThinBlood/BLOOD_PACK)-GetChargeEffectChargeNum(m_pEfCharge) ); 

			m_pBFont->DrawSetup();
			m_pBFont->SetColor2( 0xffffffff );
			m_pBFont->SetExRate( 0.7f );
			m_pBFont->DrawFSStr( m_fShikenX, SHIKENKAN_NUM_Y, true, true, "%d", (m_usThinBlood/BLOOD_PACK)-GetChargeEffectChargeNum(m_pEfCharge)  ); 
		}
	}

	if( GetBloodPointEnd() )	return;
	if( !m_bNoudoDrawFlag ) 	return;
	
	//	Z̎擾ʕ\	-----------------------------------------------------------
	if(	BattleCtrl.GetBpGauge( BP_THICK ) > 0 ){
		m_pBFont->DrawSetup();
		m_pBFont->SetColor2( 0xff0000ff );
		m_pBFont->SetExRate( 1.1f );
		m_pBFont->SetJikan( -3 );
		m_pBFont->DrawFSStr( m_fMeterX+1, 	MACHINE_THICK_Y+1, 	true, true, "%d", m_usThickBlood ); 
		m_pBFont->DrawSetup();
		m_pBFont->SetColor2( 0x000000ff );
		m_pBFont->SetExRate( 1.1f );
		m_pBFont->DrawFSStr( m_fMeterX, 	MACHINE_THICK_Y, 	true, true, "%d", m_usThickBlood );
	}
	m_pBFont->SetJikan( 0 );
}


//========================================================================
//					ǐ̃Zbg
//========================================================================
void		SK7SpOption::SetChargeTube()
{
	//	ǂ̐̃`FW
	if( CheckEffectValidState( m_pEfCharge, m_ulEffectID ) == TRUE ){
		SetChargeEffectTubeNum( m_pEfCharge, WK7PLAYERCONTROL->GetChargeSetUpLvMax() );
	}
}

//========================================================================
//					EBhE
//========================================================================
void		SK7SpOption::InitOptionWindow()
{
	m_spEye.SetX0		(EYE_X);
	m_spEye2.SetX0		(EYE_X);//+EYE_BALL_X);
	m_spWindow.SetX0	(OPTION_WINDOW_X);
	m_spWindowUp.SetX0	(OPTION_WINDOW_X);
	m_spUnder.SetX0		(UNDER_X-UNDER_SIZEX);
	m_fShikenX		= SHIKENKAN_MAX_X-OPTION_WINDOW_SIZEX;
	m_fMeterX		= MACHINE_THICK_X-OPTION_WINDOW_SIZEX;
	InitTimer();	
	SetChargeTube();
	if( CheckEffectValidState( m_pEfCharge, m_ulEffectID ) == TRUE ){
		SetChargeEffectInRate( m_pEfCharge, 0.0f );
	}

#ifdef __NOUDE_DRAW__
	m_spNoudo.SetX0			( NOUDO_X-MOVE_WINDOW_X );
	m_spNoudoBack.SetX0		( NOUDO_X+NOUDO_KASAN_X-MOVE_WINDOW_X );
#endif	
	m_Shiken.Waku.SetX0		( SHIKEN_A_X-MOVE_WINDOW_X );
	m_Shiken.Kan.SetX0		( SHIKEN_B_X-MOVE_WINDOW_X );
	m_Shiken.In.SetX0		( SHIKEN_IN_X-MOVE_WINDOW_X );
	m_Shiken.Blood.SetX0	( SHIKEN_B_X-MOVE_WINDOW_X );

	m_Macine.BodyA.SetXY0	( MACHINE_A_X-MOVE_WINDOW_X, MACHINE_A_Y+MACHINE_UNDER_SIZE );
	m_Macine.BodyB.SetXY0	( MACHINE_B_X-MOVE_WINDOW_X, MACHINE_B_Y+MACHINE_UNDER_SIZE );
	m_Macine.BodyC[0].SetXY0( MACHINE_C_LX-MOVE_WINDOW_X, MACHINE_C_LY+MACHINE_UNDER_SIZE );
	m_Macine.BodyC[1].SetXY0( MACHINE_C_RX-MOVE_WINDOW_X, MACHINE_C_RY+MACHINE_UNDER_SIZE );
	m_fMoveY		= MACHINE_UNDER_SIZE;
	for( int i = 0; i < MACHINE_KASAN_NUM; i++ ){
		m_Kasan[i].sprite.SetY0	( tblKasanPos[i].y+MACHINE_UNDER_SIZE );	
	}
	int i;
	for( i = 0; i < MACHINE_TUBE_NUM; i++ ){
		m_Macine.Tube[i].SetX0( tblTubePos[i].x-MOVE_WINDOW_X );
	}
	for( i = 0; i < MACHINE_KASAN_NUM; i++ ){
		m_Kasan[i].sprite.SetX0	( tblKasanPos[i].x-MOVE_WINDOW_X );
	}

	m_Macine.BloodThick.SetX0( BLOOD_THICK_LINEX-MOVE_WINDOW_X );
	m_Macine.BloodThick.SetX1( BLOOD_THICK_LINEX-MOVE_WINDOW_X );
	m_Macine.BloodThin.SetX0 ( BLOOD_THIN_LINEX-MOVE_WINDOW_X );
	m_Macine.BloodThin.SetX1( BLOOD_THIN_LINEX-MOVE_WINDOW_X );
#ifdef __CODE_DRAW__
	m_Code.WakuTop.SetXY0			( CODE_WAKU_UP_X, CODE_WAKU_UP_Y );//, g_pSpData->GetTexture(TEX_SIDE_006) );
	SET_SPRITE_ROT					( &m_Code.WakuTop, 90, CODE_WAKU_UP_X, CODE_WAKU_UP_Y, CODE_WAKU_SIZE_X, CODE_WAKU_SIZE_Y );
	m_Code.WakuTop.SetIncX			( -MOVE_WINDOW_X );
	m_Code.WakuUnder.SetXY0			( CODE_WAKU_DOWN_X, CODE_WAKU_DOWN_Y );//, g_pSpData->GetTexture(TEX_SIDE_006) );
	SET_SPRITE_ROT					( &m_Code.WakuUnder, 90, CODE_WAKU_DOWN_X, CODE_WAKU_DOWN_Y, CODE_WAKU_SIZE_X, CODE_WAKU_SIZE_Y );
	m_Code.WakuUnder.SetIncX		( -MOVE_WINDOW_X );
	m_Code.WakuLeft.SetX0			( CODE_WAKU_LEFT_X-MOVE_WINDOW_X );
	m_Code.Kazari.SetX0				( CODE_KAZARI_X-MOVE_WINDOW_X );
#endif
}


//========================================================================
//					ڂ̃eNX`[Zbg
//========================================================================
u8		SK7SpOption::SetEyeTexture( f32 Hp )
{
	if( m_Eye.Flag )	return (u8)m_spEye.GetTexNo();
	s16 HpData = (s16)(Hp * 100.0f);

	if( HpData == 100 ){
		m_spEye.SetTexNo( 0 );
		m_spEye2.SetTexNo( 0 );
		m_spEye2.SetY0( EYE_Y+tblEyeBallY[0] );
	}else if( HpData >= 69 ){
		m_spEye.SetTexNo( 1 );
		m_spEye2.SetTexNo( 1 );
		m_spEye2.SetY0( EYE_Y+tblEyeBallY[1] );
	}else if( HpData >= 49 ){
		m_spEye.SetTexNo( 2 );
		m_spEye2.SetTexNo( 2 );
		m_spEye2.SetY0( EYE_Y+tblEyeBallY[2] );
	}else if( HpData > 0   ){
		m_spEye.SetTexNo( 3 );
		m_spEye2.SetTexNo( 3 );
		m_spEye2.SetY0( EYE_Y+tblEyeBallY[3] );
	}else{
		m_spEye.SetTexNo( 4 );
		m_spEye2.SetVisible( false );
	}
	return (u8)m_spEye.GetTexNo();
}

//========================================================================
//					ڂ̃eNX`[GET
//========================================================================
u8		SK7SpOption::GetEyeNo( f32 Hp )
{
	s16 HpData = (s16)(Hp * 100.0f);

	if( HpData == 100 )		return 0;
	else if( HpData >= 69 )	return 1;
	else if( HpData >= 49 )	return 2;
	else if( HpData > 0   )	return 3;
	else 					return 4;
}


//========================================================================
//					ڂ̃Aj
//========================================================================
void		SK7SpOption::SetEyeAniem( f32 StartHp, f32 EndHp )
{
	m_Eye.StartNo 	= SetEyeTexture( StartHp );
	m_Eye.EndNo		= SetEyeTexture( EndHp );
	m_Eye.Time 		= 0;
	m_Eye.Flag		= true;
	m_spEye.SetTexNo( (u8)m_Eye.StartNo );
	m_spEye2.SetTexNo( (u8)m_Eye.StartNo );
	m_spEye2.SetY0( EYE_Y+tblEyeBallY[m_Eye.StartNo] );
}


//========================================================================
//					ڂ̃AjZbg
//========================================================================
void		SK7SpOption::SetEyeAnime2()
{
	s16 NowHp, MaxHp;
	f32 AnswerHp;
	
	//	L̂gôl`wƌݒn擾	---------------------------------------
	WK7PLAYERCONTROL->GetDataHp( WK7PLAYERCONTROL->GetMainID(), &NowHp, &MaxHp );

	//	JgL̉	==============================================
	AnswerHp = (f32)WK7PLAYERCONTROL->GetHp()/(f32)MaxHp;			//	񕜑O̒l

	//	AjZbg	-----------------------------------------------------
	SetEyeAniem( AnswerHp, AnswerHp );
}

//========================================================================
//					ڂ̃Aj&gk
//========================================================================
void		SK7SpOption::SetEyeExpan(s8 state)
{
	m_Eye.State		=	state;
	switch( state ){
	case EYE_EXSTATE_NORMAL:
		m_Eye.ExTime 	= 	0;
		m_spEye.SetEX( 1.0f );
		m_spEye2.SetEX( 1.0f );
		break;
	case EYE_EXSTATE_SMALL:
#ifdef __EYE_EX_ONCE__
		m_Eye.ExTime 	= 	0;
		m_spEye.SetEX( 1.0f );
		m_spEye2.SetEX( 1.0f );
#else
		m_Eye.ExTime = (int)(EYE_EX_TIME - m_Eye.ExTime);
#endif
		break;
	case EYE_EXSTATE_BIG:
#ifdef __EYE_EX_ONCE__
		m_Eye.ExTime 	= 	0;
		m_spEye.SetEX( 0.0f );
		m_spEye2.SetEX( 0.0f );
#else
		m_Eye.ExTime = (int)(EYE_EX_TIME - m_Eye.ExTime);
#endif
		break;
	}
}


//========================================================================
//					ڂ̃Aj&gk
//========================================================================
void		SK7SpOption::MoveEyeAnime()
{
	//	Aj[V
	if( m_Eye.Flag ){
		if( ++m_Eye.Time >= EYE_ANIME_TIME ){
			m_Eye.Time = 0;
			m_Eye.StartNo++;
			if( m_Eye.StartNo >= EYE_MAX_NUM ){
				m_spEye.SetTexNo( (u8)m_Eye.EndNo );
				m_spEye2.SetTexNo( (u8)m_Eye.EndNo );
				m_spEye2.SetY0( EYE_Y+tblEyeBallY[m_Eye.EndNo] );
				m_Eye.NotDrawFlag = false;
				m_Eye.Flag = false;
			}else{
				m_spEye.SetTexNo( (u8)m_Eye.StartNo );
				if( m_Eye.StartNo != 4 ){
					m_spEye2.SetTexNo( (u8)m_Eye.StartNo );
					m_spEye2.SetVisible( true );
					m_spEye2.SetY0( EYE_Y+tblEyeBallY[m_Eye.StartNo] );
					m_Eye.NotDrawFlag = false;
				}else{
					m_Eye.NotDrawFlag = true;
					m_spEye2.SetVisible( false );
				}
			}
		}
	}
	//	gk
	m_Eye.ExTime++;
	switch( m_Eye.State ){
	case EYE_EXSTATE_BIG:
		m_spEye.SetEX	( m_spEye.GetExX()+1.0f/EYE_EX_TIME );
		m_spEye2.SetEX	( m_spEye2.GetExX()+1.0f/EYE_EX_TIME );
		if( m_spEye.GetExX() >= 1.0f ) 	m_spEye.SetEX( 1.0f );
		if( m_spEye2.GetExX() >= 1.0f ) m_spEye2.SetEX( 1.0f );
		if( m_Eye.ExTime >= EYE_EX_TIME ){
//			m_Eye.State 	= EYE_EXSTATE_NORMAL;
			m_Eye.ExTime 	= 0;
		}
		break;
	case EYE_EXSTATE_SMALL:
		m_spEye.SetEX	( m_spEye.GetExX()-(1.0f/EYE_EX_TIME) );
		m_spEye2.SetEX	( m_spEye2.GetExX()-(1.0f/EYE_EX_TIME) );
		if( m_spEye.GetExX() <= 0.0f ) 	m_spEye.SetEX( 0.0f );
		if( m_spEye2.GetExX() <= 0.0f ) m_spEye2.SetEX( 0.0f );
		if( m_Eye.ExTime >= EYE_EX_TIME ){
//			m_Eye.State 	= EYE_EXSTATE_NORMAL;
			m_Eye.ExTime = 0;
		}
		break;
	case EYE_EXSTATE_NORMAL:
		m_Eye.ExTime = 0;
		break;
	}
}

//========================================================================
//					}V쐬
//========================================================================
void		SK7SpOption::CreateMacine()	
{
	int i;
	m_Macine.AddTime = m_Macine.SetTime = m_Macine.ThinTime	= m_Macine.ThickTime = 0;
	m_Macine.KasanSize = KASAN_SIZE_NORMAL;
	m_Macine.vPos.x	= 0.0f;
	m_Macine.vPos.y	= 0.0f;
	m_Macine.bThickEndFlag 	= m_Macine.bThinEndFlag	= true;
	m_Macine.bThickMoveFlag = m_Macine.bThinMoveFlag= false;
	
	m_Macine.BodyA.SetTexSprite		( MACHINE_A_X-640, 	MACHINE_A_Y+MACHINE_UNDER_SIZE, 	g_pSpData->GetTexture(TEX_MACINE_A));
	m_Macine.BodyB.SetTexSprite		( MACHINE_B_X-640, 	MACHINE_B_Y+MACHINE_UNDER_SIZE, 	g_pSpData->GetTexture(TEX_MACINE_B));
	m_Macine.BodyC[0].SetTexSprite	( MACHINE_C_LX-640, MACHINE_C_LY+MACHINE_UNDER_SIZE,	g_pSpData->GetTexture(TEX_MACINE_C));
	m_Macine.BodyC[1].SetTexSprite	( MACHINE_C_RX-640, MACHINE_C_RY+MACHINE_UNDER_SIZE, 	g_pSpData->GetTexture(TEX_MACINE_C));	
	
	m_Macine.BodyA.SetColor( MACHINE_COLOR );
	m_Macine.BodyB.SetColor( MACHINE_COLOR );
	m_Macine.BodyC[0].SetColor( MACHINE_COLOR );
	m_Macine.BodyC[1].SetColor( MACHINE_COLOR );
	
	for( i = 0; i < MACHINE_TUBE_NUM; i++ ){
		m_Macine.Tube[i].SetTexSprite( tblTubePos[i].x-640, tblTubePos[i].y, g_pSpData->GetTexture((u8)(TEX_TUBE_A+i)) );
		m_Macine.Tube[i].SetAlpha( 0x8A );
	}
	
	m_Macine.BloodThick.SetTexLineSprite( BLOOD_THICK_LINEX-640, BLOOD_THICK_LINEY, BLOOD_THICK_LINEX, BLOOD_THICK_LINEY, g_pSpData->GetTexture(TEX_BLOOD),BLOOD_THICK_SIZE  );
	m_Macine.BloodThick.SetColor		( BEAKER_BLOOD_COLOR2);
	m_Macine.BloodThin.SetTexLineSprite	( BLOOD_THIN_LINEX-640, BLOOD_THIN_LINEY, BLOOD_THIN_LINEY, BLOOD_THIN_LINEY, g_pSpData->GetTexture(TEX_BLOOD),BLOOD_THIN_SIZE  );
	m_Macine.BloodThin.SetColor(SHIKEN_BLOOD_COLOR);
}

//========================================================================
//					߂Z
//========================================================================
void		SK7SpOption::InitKasan()	
{
	for( int i = 0; i < MACHINE_KASAN_NUM; i++ ){
		m_Kasan[i].sprite.SetTexSprite	( tblKasanPos[i].x-640, tblKasanPos[i].y+m_fMoveY, g_pSpData->GetTexture(TEX_MACINE_KASAN));
		m_Kasan[i].sprite.SetFlag		( true, SIZE_FLAG|CENTER_FLAG );
		m_Kasan[i].sprite.SetBlendNo	( SPR_BLEND_ONE );
		m_Kasan[i].sprite.SetTwoSize	( KASAN_SIZE_NORMAL, KASAN_SIZE_NORMAL );
		m_Kasan[i].Time = -1;
		m_Kasan[i].Size = false;
	}
}

//========================================================================
//					߂̍쐬
//========================================================================
void		SK7SpOption::SetStoreNo()
{
	//	ǂ̌		-----------------------------------------------
#if 0
	m_Shiken.Blood.SetSizeY( -((f32)(m_usThinBlood%BLOOD_PACK) * ((f32)SHIKEN_IN_SIZEY/(f32)BLOOD_PACK) ));
	if( m_usThinBlood >= BLOOD_PACK ){
		if( (m_usThinBlood%BLOOD_PACK)==0 )	m_Shiken.Blood.SetSizeY( -SHIKEN_IN_SIZEY );
	}
#endif
	if( m_usThinBlood >= BLOOD_PACK ){
		m_Shiken.Blood.SetSizeY( -SHIKEN_IN_SIZEY );
	}else{
		m_Shiken.Blood.SetSizeY(0);
	}
}

//========================================================================
//					}VWZbg
//========================================================================
void		SK7SpOption::SetMacinePos( f32 x, f32 y )
{
	int i;
	
	m_Macine.BodyA.SetIncXY( x, y );
	m_Macine.BodyB.SetIncXY( x, y );
	m_Macine.BodyC[0].SetIncXY( x, y );
	m_Macine.BodyC[1].SetIncXY( x, y );
	
	for( i = 0; i < MACHINE_TUBE_NUM; i++ )		m_Macine.Tube[i].SetIncX( x );
	for( i = 0; i < MACHINE_KASAN_NUM; i++ )	m_Kasan[i].sprite.SetIncXY( x, y );	
}

//========================================================================
//					}VWZbg
//========================================================================
void		SK7SpOption::SetMacineLeftPos( bool state )
{
	int i;
	
	if( state ){
		m_Macine.BodyA.SetX0( MACHINE_A_X-MOVE_WINDOW_X+OPTION_WINDOW_SIZEX );
		m_Macine.BodyB.SetX0( MACHINE_B_X-MOVE_WINDOW_X+OPTION_WINDOW_SIZEX );
		m_Macine.BodyC[0].SetX0( MACHINE_C_LX-MOVE_WINDOW_X+OPTION_WINDOW_SIZEX );
		m_Macine.BodyC[1].SetX0( MACHINE_C_RX-MOVE_WINDOW_X+OPTION_WINDOW_SIZEX );
		
		for( i = 0; i < MACHINE_TUBE_NUM; i++ )		m_Macine.Tube[i].SetX0( tblTubePos[i].x-MOVE_WINDOW_X+OPTION_WINDOW_SIZEX );	
		for( i = 0; i < MACHINE_KASAN_NUM; i++ )	m_Kasan[i].sprite.SetX0( tblKasanPos[i].x-MOVE_WINDOW_X+OPTION_WINDOW_SIZEX );	
	}else{
		m_Macine.BodyA.SetX0( MACHINE_A_X-MOVE_WINDOW_X );
		m_Macine.BodyB.SetX0( MACHINE_B_X-MOVE_WINDOW_X );
		m_Macine.BodyC[0].SetX0( MACHINE_C_LX-MOVE_WINDOW_X );
		m_Macine.BodyC[1].SetX0( MACHINE_C_RX-MOVE_WINDOW_X );
		
		for( i = 0; i < MACHINE_TUBE_NUM; i++ )		m_Macine.Tube[i].SetX0( tblTubePos[i].x-MOVE_WINDOW_X );	
		for( i = 0; i < MACHINE_KASAN_NUM; i++ )	m_Kasan[i].sprite.SetX0( tblKasanPos[i].x-MOVE_WINDOW_X );	
	}
}

//========================================================================
//					}V`Zbg
//========================================================================
void		SK7SpOption::SetMacineRender( bool State )
{
	int i;
	m_Macine.BodyA.SetVisible( State );
	m_Macine.BodyB.SetVisible( State );
	m_Macine.BodyC[0].SetVisible( State );
	m_Macine.BodyC[1].SetVisible( State );
	
	for( i = 0; i < MACHINE_TUBE_NUM; i++ )		m_Macine.Tube[i].SetVisible( State );
}


//========================================================================
//					Z`Zbg
//========================================================================
void		SK7SpOption::SetKasanRender( bool State )
{	
	for( int i = 0; i < MACHINE_KASAN_NUM; i++ ){
		m_Kasan[i].sprite.SetVisible( State );
	}
}

//========================================================================
//					̔
//========================================================================
bool		SK7SpOption::MoveBloodThin()
{
	//	Ō̌oĂƂ	------------------------
	if( m_Macine.bThinEndFlag ){
		m_Macine.BloodThin.SetXY0	( m_Macine.BloodThin.GetX0(), m_Macine.BloodThin.GetY0() + ((SHIKEN_B_Y+SHIKEN_IN_SIZEY)-BLOOD_THIN_LINEY)/BLOOD_THIN_TIME);
	}else{
		m_Macine.BloodThin.SetXY1	( m_Macine.BloodThin.GetX0(), m_Macine.BloodThin.GetY1() + ((SHIKEN_B_Y+SHIKEN_IN_SIZEY)-BLOOD_THIN_LINEY)/BLOOD_THIN_TIME );  
	}
	if( ++m_Macine.ThinTime >= BLOOD_THIN_TIME ){
		m_Macine.bThinMoveFlag = false;
		m_Macine.ThinTime = 0;
		return true;
	}
	return false;
}

//========================================================================
//					̈ړ
//========================================================================
bool		SK7SpOption::MoveBloodThick()
{
	//	Ō̌oĂƂ	------------------------
	if( m_Macine.bThickEndFlag ){
		m_Macine.BloodThick.SetXY0	( m_Macine.BloodThick.GetX0(), m_Macine.BloodThick.GetY0() + BLOOD_THICK_MOVE_Y );//(BEAKER_BOTTOM_Y-BLOOD_THICK_LINEY)/BLOOD_THICK_TIME);
		if( BEAKER_BOTTOM_Y < m_Macine.BloodThick.GetY0() ){
			m_Macine.BloodThick.SetY0( BEAKER_BOTTOM_Y );
			m_Macine.bThickMoveFlag = false;
			m_Macine.ThickTime = 0;
			return true;
		}
	}else{
		m_Macine.BloodThick.SetXY1	( m_Macine.BloodThick.GetX0(), m_Macine.BloodThick.GetY1() + (BEAKER_BOTTOM_Y-BLOOD_THICK_LINEY)/BLOOD_THICK_TIME );
		if( BEAKER_BOTTOM_Y < m_Macine.BloodThick.GetY1() ){
			m_Macine.BloodThick.SetY1( BEAKER_BOTTOM_Y );
			m_Macine.bThickMoveFlag = false;
			m_Macine.ThickTime = 0;			
			return true;
		}
	}
	
#if 0
	if( ++m_Macine.ThickTime >= BLOOD_THICK_TIME ){
		m_Macine.bThickMoveFlag = false;
		m_Macine.ThickTime = 0;
		return true;
	}
#endif
	return false;
}


//========================================================================
//					Z̃X^[g`FbN	
//========================================================================
void		SK7SpOption::CheckThickMoveStart()
{	
	if( m_Macine.bThickEndFlag ){
		if( BattleCtrl.GetBpGauge( BP_THICK ) > 0 ){
			m_Macine.bThickMoveFlag = true;
			m_Macine.bThickEndFlag = false;
			m_Macine.BloodThick.SetXY0( m_Macine.BloodThick.GetX0(), BLOOD_THICK_LINEY );
			m_Macine.BloodThick.SetXY1( m_Macine.BloodThick.GetX0(), BLOOD_THICK_LINEY );
			m_Macine.BloodThick.SetVisible	( true );	//	tC`
		}else{
//			m_Macine.BloodThick.SetXY0( m_Macine.BloodThick.GetX0(), BEAKER_BOTTOM_Y-BLOOD_THICK_LINEY );
//			m_Macine.BloodThick.SetXY1( m_Macine.BloodThick.GetX0(), BEAKER_BOTTOM_Y-BLOOD_THICK_LINEY );
		}
	}
}


//========================================================================
//					̃X^[g`FbN
//========================================================================
void		SK7SpOption::CheckThinMoveStart()
{
	if( m_Macine.bThinEndFlag ){
		if( BattleCtrl.GetBpGauge( BP_THIN ) > 0 ){
			m_Macine.bThinMoveFlag = true;
			m_Macine.bThinEndFlag = false;
			m_Macine.BloodThin.SetXY0( m_Macine.BloodThin.GetX0(), BLOOD_THIN_LINEY );
			m_Macine.BloodThin.SetXY1( m_Macine.BloodThin.GetX0(), BLOOD_THIN_LINEY );
			m_Macine.BloodThin.SetVisible	( true );	//	tC`
		}else{
			m_Macine.BloodThin.SetXY0( m_Macine.BloodThin.GetX0(), (SHIKEN_B_Y+SHIKEN_IN_SIZEY) );
			m_Macine.BloodThin.SetXY1( m_Macine.BloodThin.GetX0(), (SHIKEN_B_Y+SHIKEN_IN_SIZEY) );
		}
	}
}

//========================================================================
//					r[J[̕`Zbg
//========================================================================
void 	SK7SpOption::SetBeakerRender( bool State )
{		
	m_Shiken.Waku.SetVisible	( State );
	m_Shiken.Kan.SetVisible		( State );
	m_Shiken.In.SetVisible		( State );
	m_Shiken.Blood.SetVisible	( State );
}

//========================================================================
//					̎擾
//========================================================================
u16			SK7SpOption::GetBloodGauge(int type)
{
	switch( type ){
	case BP_THICK:	return m_usThickBlood;
	case BP_THIN:	return m_usThinBlood;
	case BP_SERUM:	return m_usSerumBlood;
	}
	return 0;
}


//========================================================================
//					̃Zbg
//========================================================================
void		SK7SpOption::SetBloodGauge(int type, u16 Point)
{
	switch( type ){
	case BP_THICK:
		m_usThickBlood = Point;
		break;
	case BP_THIN:
		m_usThinBlood = Point;
		break;
	case BP_SERUM:
		m_usSerumBlood = Point;
		break;
	}
}

//========================================================================
//					̃CNg
//========================================================================
u16			SK7SpOption::IncBloodGauge(int type, s16 IncPoint)
{
	switch( type ){
	case BP_THICK:
		m_usThickBlood += IncPoint;
		if( m_usThickBlood >= BLOOD_THICK_GAUGE_MAX ){
			m_usThickBlood = BLOOD_THICK_GAUGE_MAX;
		}
		return m_usThickBlood;

	case BP_THIN:
		m_usThinBlood += IncPoint;
		if( m_usThinBlood >= m_ucMaxThinBlood*BLOOD_PACK ){
			m_usThinBlood = (u16)(m_ucMaxThinBlood*BLOOD_PACK);
		}
		return m_usThinBlood;

	case BP_SERUM:
		return m_usSerumBlood;
	}
	return 0;
}

//========================================================================
//				wuX}CS̎擾_SET
//========================================================================
void 		SK7SpOption::GetMachineBloodPoint( Vec* pV )
{
	u8 tblKasanNo[MACHINE_KASAN_NUM];
	memset( tblKasanNo, 0, sizeof(u8)*MACHINE_KASAN_NUM );
	int No=0;
	for( int i = 0; i < MACHINE_KASAN_NUM; i++ ){
		if( m_Kasan[i].Time != -1 ){
			tblKasanNo[No] = (u8)i;
			No++;
		}
	}
	if( No == 0 ){
		No = 2;
	}
	int KNo = rand()%No;
	pV->x = tblKasanPos[tblKasanNo[KNo]].x-540;
	pV->y = tblKasanPos[tblKasanNo[KNo]].y+m_fMoveY;
	pV->z = 0;
	
#ifdef _DEBUG
	if( (pV->x > 640 || pV->x < -640 || pV->y > 800 || pV->y < -480 )){
		OSReport("ERR!! SATO POSITION MISS!!" );
	}
#endif
}


//========================================================================
//				wuX}CS̎擾_SET
//========================================================================
void 		SK7SpOption::SetGetBloodPoint( SK7BloodSize inSize, SK7BloodJoint inJoin )
{
	int KasanNum=0;
	//	Z	-------------------------------------------------------
	switch( inJoin ){
	case BLOOD_JOIN_ALL:		KasanNum = 5; break;
	case BLOOD_JOIN_HEAD:		KasanNum = 2; break;
	case BLOOD_JOIN_OTHER: 		KasanNum = 1; break;
	}
	//	ĂȂZ	-----------------------------------------
	for( int i = 0; i < MACHINE_KASAN_NUM; i++ ){
		//	ZȂƂ	----------------------------------------
		if( KasanNum <= 0 )	return;
		//	nĵ	---------------------------------------------
		if( m_Kasan[i].Time == -1 ){
			m_Kasan[i].Time = 0;
			m_Kasan[i].sprite.SetVisible( true );
			m_Kasan[i].sprite.SetAlpha( 0xff );
			switch( inSize ){
			case BLOOD_SIZE_BIG:
				m_Kasan[i].sprite.SetTwoSize( KASAN_SIZE_BIG, KASAN_SIZE_BIG ); 
				m_Kasan[i].Size = true;
				break;
			case BLOOD_SIZE_SML:
			default:
				m_Kasan[i].sprite.SetTwoSize( KASAN_SIZE_NORMAL, KASAN_SIZE_NORMAL ); 
				m_Kasan[i].Size = false;
				break;
			}
			KasanNum--; 
		}
	}
	//	ԃ^C	----------------------------
	int kasanTimeNo = 0;
	for( int i = 1; i < MACHINE_KASAN_NUM; i++ ){
		if( m_Kasan[kasanTimeNo].Time < m_Kasan[i].Time ){
			kasanTimeNo = i;
		}
	}
	//	܂cĂƂ ㏑	-----------------------------------
	if( KasanNum > 0 ){
		for( int j = 0; j < 2; j++ ){
			if( j == 1 ){
				kasanTimeNo = 0;
			}
			for( int i = kasanTimeNo; i < MACHINE_KASAN_NUM; i++ ){
				//	ZȂƂ	----------------------------------------
				if( KasanNum <= 0 )	return;
				m_Kasan[i].Time = 0;
				m_Kasan[i].sprite.SetVisible( true );
				m_Kasan[i].sprite.SetAlpha( 0xff );
				switch( inSize ){
				case BLOOD_SIZE_BIG:
					m_Kasan[i].sprite.SetTwoSize( KASAN_SIZE_BIG, KASAN_SIZE_BIG ); 
					m_Kasan[i].Size = true;
					break;
				case BLOOD_SIZE_SML:
				default:
					m_Kasan[i].sprite.SetTwoSize( KASAN_SIZE_NORMAL, KASAN_SIZE_NORMAL ); 
					m_Kasan[i].Size = false;
					break;
				}
				KasanNum--; 
			}
		}
	}
}
//========================================================================
//				ZI擾
//========================================================================
bool 		SK7SpOption::GetBloodPointEnd()
{
	//	ĂȂZ	-----------------------------------------
	for( int i = 0; i < MACHINE_KASAN_NUM; i++ ){
		if( m_Kasan[i].sprite.GetAlpha() != 0 ){
			return false;
		}
	}
	return true;
}


//========================================================================
//				ǂł͂Ȃ
//========================================================================
void		SK7SpOption::MoveSore()
{
	bool retcode = false;
	if( ++m_Sore.Time >= 1  ){
		f32 Angle = MTXDegToRad(rand()%360);
		f32 Rad	  = rand()%3;
		m_Sore.spFont.SetXY0	( SP_SORE_X+(Rad*cosf(Angle)),  SP_SORE_Y+(Rad*sinf(Angle)));
		m_Sore.spPlate.SetXY0	( SP_SORE_X+(Rad*cosf(Angle)),  SP_SORE_Y+(Rad*sinf(Angle)));
		m_Sore.Time = 0;
	}
}


