////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Scn03
//
// K7Scn03.cpp
//
// Creator       : Kawakami Satoshi (GHM)
// Creation Date : 08/24/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7SCN03_CPP__
#pragma	warn_unusedarg			off

////////////////////////////////////////////////////////////////////////////////
// CxgfXNv^`
////////////////////////////////////////////////////////////////////////////////

#define	K7EV_BODY_PART
#include ".\K7Scn03.h"

#include "..\Wat\WK7MainTask.h"
#include "..\Wat\WK7Npc.h"
#include "..\Wat\WK7Enemy.h"
#include "..\Yam\YK7MapSelect.h"
#include "..\Yam\YK7MapSelect.h"

////////////////////////////////////////////////////////////////////////////////
// nh`
////////////////////////////////////////////////////////////////////////////////

#include "..\Fujita\C_Font.h"

K7EV_HANDLER(K7SCN03_Init)
{
	u32	stgid;
	u32	chrid;
	
	//inGame~
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	//ViIisxɂĕ
	switch( GameInfo.GetScenarioFlow() )
	{
		//Vn
		case	 K7SCNF_ISZ:
			K7SCR_MOON_START();
			K7SCR_MOON_WAIT();
			
			k7app.FadeStart( 0, 4800 );
			k7app.SetFadeColor( 0 );
			
			WK7Play::StorePlayTB();
			
			WK7Play*	pPlay;
			u32			playno;
			
			//---- 02010101 ----
			WK7Play::StorePlayTB();
			WK7Play::SetTermCaptureRenderOn(true);
			//L
			playno = K7EVENTPLAY(03010101);
			while( (pPlay=WK7Play::Create(playno)) == NULL ){ K7SCR_RETSYS(); }
			pPlay->Prepare();
			while( pPlay->GetState() != WK7Play::PREPARED ){ K7SCR_RETSYS(); }
			pPlay->Start();
			K7SCR_RETSYS();
			//LI҂
			while( pPlay->GetState() != WK7Play::PLAYED ){ K7SCR_RETSYS(); }
			//LI
			pPlay->SetVisibleAll( false );
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			GHM_SAFE_DELETE( pPlay );
			WK7Play::SetPlayed( playno, true );
			K7SCR_BLACK_FADEOUT();

			//---- 02020101 ----
			WK7Play::SetInitCaptureRenderOff(true);
			WK7Play::SetTermCaptureRenderOn (false);
			//L
			playno = K7EVENTPLAY(03020101);
			while( (pPlay=WK7Play::Create(playno)) == NULL ){ K7SCR_RETSYS(); }
			pPlay->Prepare();
			while( pPlay->GetState() != WK7Play::PREPARED ){ K7SCR_RETSYS(); }
			pPlay->Start();
			K7SCR_RETSYS();
			K7SCR_BLACK_FADEIN();
			//LI҂
			while( pPlay->GetState() != WK7Play::PLAYED ){ K7SCR_RETSYS(); }
			K7SCR_NOISE_REQUEST();
			WK7Play::SetInitCaptureRenderOff(false);
			//LI
			pPlay->SetVisibleAll( false );
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			GHM_SAFE_DELETE( pPlay );
			WK7Play::SetPlayed( playno, true );
			
#if	0
			WK7Play::PlayTB( K7EVENTPLAY(03010101) );	//J[eBXsE
			WK7Play::PlayTB( K7EVENTPLAY(03020101) );	//KVAH
#endif
			WK7Play::RestorePlayTB();
			
			//KĂACeݒ
			K7SCR_SET_GLOBAL_FLAG( K7GLFL_RING_FIRE );
			K7SCR_SET_GLOBAL_FLAG( K7GLFL_RING_WATER );
			K7SCR_SET_GLOBAL_FLAG( K7GLFL_RING_WIND );
			break;
		
		//J[eBX@
		case	 K7SCNF_CUR:
			//KĂACeݒ
			K7SCR_SET_GLOBAL_FLAG( K7GLFL_RING_FIRE );
			K7SCR_SET_GLOBAL_FLAG( K7GLFL_RING_WATER );
			K7SCR_SET_GLOBAL_FLAG( K7GLFL_RING_PAST );
			K7SCR_SET_GLOBAL_FLAG( K7GLFL_RING_WIND );
			break;
		
		//ftHg
		default:
			break;
	}
	
	//KVẢƂ
	stgid = K7STGID( 120, 0 );
	chrid = K7CHRID( K7GAL, 0 );
	
	gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue, NOISE_SE_NORMAL );
	while(gpNoise->mGetSandFrameProc() != eSandExec){K7SCR_RETSYS();}
	
	K7SCR_STG_CREATE_B( stgid );
	K7SCR_PC_CREATE( chrid );		//fǂݍ
	K7SCR_PC_MOTIONCREATE( chrid );	//[Vǂݍ
	K7SCR_PC_CREATEWAIT();			//ǂݍݑ҂
	K7SCR_STG_SET_CURRENT( stgid );
	
	WK7Stage::SetCameraStartPosition( stgid );
	K7SCR_RETSYS();
	
	//VnViIJnȂ̂ŌtF[hNA
	if( GameInfo.GetScenarioFlow() == K7SCNF_ISZ )
	{
		k7app.FadeStart( 0, 4800 );
		k7app.SetFadeColor( 0 );
	}
	
	K7SCR_PC_VISIBLE( true );
	K7SCR_RETSYS();
	K7SCR_STG_VISIBLE( stgid, true );
	
	return;
}

K7EV_HANDLER(K7SCN03_Term)
{
	K7SCR_RETSYS();
}

////////////////////////////////////////////////////////////////////////////////
// nhe[u
////////////////////////////////////////////////////////////////////////////////

#define	K7EV_TBL_PART
#include ".\K7Scn03.h"

#include "..\REL\REL_Setup.h"

#define	K7EV_VAR_EDIT
#include "..\Scn\K7Scn03.h"
#undef	K7EV_VAR_EDIT

#include "..\sato\SK7IMenuMap.h"
#define	__SK7MAPCREATE03__
#include "..\sato\map\SK7StageMap03.h" 


#include "..\Stage\K7Stage.h"
#define	__K7STAGECREATE_INCLUDE__
#include	".\info\K7StageCreate.h"
WK7Stage* WK7Stage::CreateStageScn03(u32 id,int prio)
{
	K7STG_CREATE_DECL_START()
#include	".\info\K7StageCreate.h"
	K7STG_CREATE_DECL_END()
	return NULL;
}

#define	__ENMCREATE_INCLUDE__
#include	"..\Wat\EnmCreate.h"
WK7Npc* WK7Npc::CreateScn03(u32 type,u32 suffix)
{
	ENM_CREATE_DECL_START()
#include	"..\Wat\EnmCreate.h"
	ENM_CREATE_DECL_END()
	return NULL;
}

#include "..\sato\SK7PanelBase.h"
#define	__SK7PANELCREATE_INCLUDE__
#include "..\sato\SK7PanelCreate.h"
SK7PanelBase* SK7PanelBase::CreatePanel03(u32 evno,s32 now, s32 now2 )
{
	switch( evno ){
#include "..\sato\SK7PanelCreate.h"
	}
	return NULL;
}

static	WK7StageBpCamInfo	K7ScnBpCamInfo[] = {
#include	"..\Stage\Info\K7StageBpCamInfo.h"
WK7STGBPCAMINF_END()
static	WK7StageDoorInfo	K7ScnDoorInfo[] = {
#include	"..\Stage\Info\K7StageDoorInfo.h"
WK7STGDRINF_END()
static	WK7StagePlaceInfo	K7ScnPlaceInfo[] = {
#include	"..\Stage\Info\K7StagePlaceInfo.h"
WK7STGPLINF_END()
static	WK7StageTamaInfo	K7ScnTamaInfo[] = {
#include	"..\Stage\Info\K7StageTamaInfo.h"
WK7STGTAMAINF_END()
static	WK7StageSoundInfo	K7ScnSoundInfo[] = {
#include	"..\Stage\Info\K7StageSoundInfo.h"
WK7STGSOUNDINF_END()
static	WK7StageSpCond		K7ScnSpCond[] = {
#include	"..\Stage\Info\K7StageSpCond.h"
WK7STGSPCOND_END()

RELMODULE_EXPORT void _prolog(void)
{
	ModuleConstructors();
	
	SK7PanelBase::SetCreatePanelFunc(SK7PanelBase::CreatePanel03);
	SK7IMenuMap::SetScnIconTable( tblScenarioIcon03 );
	SK7IMenuMap::SetItmIconTable( tblItemIcon03 );
	WK7Npc::SetNpcCreateFunc(WK7Npc::CreateScn03);
	WK7Stage::SetScenarioDoorInfo (K7ScnDoorInfo );
	WK7Stage::SetScenarioPlaceInfo(K7ScnPlaceInfo);
	WK7Stage::SetScenarioTamaInfo (K7ScnTamaInfo );
	WK7Stage::SetScenarioSoundInfo(K7ScnSoundInfo);
	WK7Stage::SetScenarioSpCond   (K7ScnSpCond   );
	WK7Stage::SetScenarioBpCamInfo(K7ScnBpCamInfo);
	WK7Stage::SetCreateStageFunc(WK7Stage::CreateStageScn03);
	WK7EVENTCONTROLLER->SetScenarioEventHandler(K7EV_SCN_HANDLER_TABLE(K7SCN03));
	WK7EVENTCONTROLLER->SetScenarioEventDesc   (K7EV_SCN_DESC_TABLE   (K7SCN03));
	WK7Event::SetIDTable  (K7EV_SCN_IDTABLE  (K7SCN03));
	WK7EventItem::SetTable(K7EV_SCN_ITEMTABLE(K7SCN03));
	WK7GAMEINFO_SETFLAGNAME(K7EV_SCN_FLAGNAME(K7SCN03));
	WK7GAMEINFO_SETVARTYPE(K7EV_SCN_VARTYPENAMEBODY(K7SCN03));
	if( GameInfo.GetContinue()==false ){
#define	K7EV_VAR_INIT
#include "..\Scn\K7Scn03.h"
#undef	K7EV_VAR_INIT
	}
#define	K7EV_VAR_DEBUG
#include "..\Scn\K7Scn03.h"
#undef	K7EV_VAR_DEBUG
}

/*
 * _epilog is called before the the module is unlinked
 * This executes the static destructors for the module.
 */

RELMODULE_EXPORT void _epilog(void)
{
	ModuleDestructors();
	
	WK7Npc::SetNpcCreateFunc(NULL);
	WK7Stage::SetCreateStageFunc(NULL);
	WK7Stage::SetScenarioDoorInfo (NULL);
	WK7Stage::SetScenarioPlaceInfo(NULL);
	WK7Stage::SetScenarioTamaInfo (NULL);
	WK7Stage::SetScenarioSoundInfo(NULL);
	WK7Stage::SetScenarioSpCond   (NULL);
	WK7Stage::SetScenarioBpCamInfo(NULL);
	WK7EVENTCONTROLLER->SetScenarioEventHandler(NULL);
	WK7EVENTCONTROLLER->SetScenarioEventDesc   (NULL);
	WK7Event::SetIDTable  (NULL);
	WK7EventItem::SetTable(NULL);
	WK7GAMEINFO_SETFLAGNAME(NULL);
	WK7GAMEINFO_SETVARTYPE(NULL);
}

/*
 * _unresolved is called if a module attempts
 * to call a symbol that is not present in another module.
 * If _unresolved is not specified, the branch to the symbol
 * will instead branch back to itself.
 */

RELMODULE_EXPORT void _unresolved(void)
{
	u32		i;
	u32*	p;
	
	OSReport("\nError: Unlinked function called in module %s.\n", __FILE__);
	OSReport("Address:      Back Chain    LR Save\n");
	for (i = 0, p = (u32*) OSGetStackPointer(); // get current sp
	     p && (u32) p != 0xffffffff && i++ < 16;
	     p = (u32*) *p)                         // get caller sp
	{
		OSReport("0x%08x:   0x%08x    0x%08x\n", p, p[0], p[1]);
	}
	OSReport("\n");
}

