////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Scn07
//
// K7Scn07.cpp
//
// Creator       : Kawakami Satoshi (GHM)
// Creation Date : 08/24/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7SCN07_CPP__
#pragma	warn_unusedarg			off

////////////////////////////////////////////////////////////////////////////////
// CxgfXNv^`
////////////////////////////////////////////////////////////////////////////////

// Xe[WbZ[Wft@C

#define	K7SCN07_STG701M01_WATERDOWN		(0)
#define	K7SCN07_STG701M01_GETKEY		(1)
#define	K7SCN07_STG702M02_CLOSE210		(0)
#define	K7SCN07_STG702M07_CLOSE210		(0)
#define	K7SCN07_STG706M00_SPRINKLER		(0)

#define	K7EV_BODY_PART
#include ".\K7Scn07.h"

#include "..\Wat\WK7MainTask.h"
#include "..\Wat\WK7Npc.h"
#include "..\Wat\WK7Enemy.h"
#include "..\Wat\WK7Item.h"
#include "..\Wat\WK7Tutorial.h"
#include "..\Kaw\KK7BattleCtrl.h"
#include "..\Kaw\KK7BattleMainTask.h"
#include "..\Panel\SK7PanelManageKey.h"
#include "..\Panel\SK7PanelToilet.h"
#include "..\Panel\MK7PanelSwitch01.h"
#include ".\K7Scn07Kaw.h"
#include "..\Yam\YK7MapSelect.h"
#include "..\Yam\YK7StageTitle.h"
#include "..\Sato\SK7Special.h"

void K7SCN07_BrokenObj(u32 stgid,WK7JObj *pJObj);
void K7SCN07_BrokenObj(u32 stgid,const char *pobjname);
void K7SCN07_Stg703M03_BrokenObj(u32 evid);

////////////////////////////////////////////////////////////////////////////////
// nh`
////////////////////////////////////////////////////////////////////////////////

#include "..\Fujita\C_Font.h"

////////////////////////////////////////////////////////////////////////////////
// ViII
K7EV_HANDLER(K7SCN07_Init)
{
	
	K7SCR_ENTER_PLAYMODE();
	
	K7SCR_MOON_START();
	K7SCR_MOON_WAIT();
	
	// ZR}h͂ɂAAv̐𑝂₷
	if ( true ==  K7SCR_GET_GLOBAL_FLAG( K7GLFL_SECRET ) ){
		if ( GameInfo.GetSpOption() != NULL ){
			GameInfo.GetSpOption()->SetBloodGauge(BP_SERUM, 4000 );			// Av100
		}
	}
	
	WK7Play::StorePlayTB();
//	WK7Play::SetTermCaptureRenderOn(true);
#if	1
	WK7Play*	pPlay;
	while( (pPlay=WK7Play::Create(K7EVENTPLAY(00010101))) == NULL ){ K7SCR_RETSYS(); }
	pPlay->Prepare();
	while( pPlay->GetState() != WK7Play::PREPARED ){ K7SCR_RETSYS(); }
	pPlay->Start();
	K7SCR_RETSYS();
	while(pPlay->GetState()!=WK7Play::PLAYED){ K7SCR_RETSYS(); }
	pPlay->SetVisibleAll( false );
	WK7CAM->SetCinemaScopeMode( false );
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	GHM_SAFE_DELETE( pPlay );
#else
	WK7Play::PlayTB(K7EVENTPLAY(00010101));
#endif
//	WK7Play::SetInitCaptureRenderOff(true);
//	WK7Play::SetTermCaptureRenderOn (false);
//	WK7Play::PlayTB(K7EVENTPLAY(00010102));
//	WK7Play::SetInitCaptureRenderOff(false);
	WK7Play::RestorePlayTB();
	
	K7SCR_SCENARIO_TITLE_DISP( ST_CELTIC );
	
	int			index;
	u32			stgid = K7STGID(771,3);
	u32			chrid = K7CHRID(K7GAL,0);
	const char	*pBranchPointName;
	const char	*pPathName;
	int			dir;
	
	pBranchPointName = "set0";
	pPathName        = "curve19";
	
	if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1)==false && K7SCR_GET_GLOBAL_FLAG(K7GLFL_HOPPER7)==false ){
		
		WK7Tutorial::Initialize();
		GameInfo.ReleaseScenarioSSM();
		gpSound->mReadSsm(WK7TUTORIAL_SSM_NAME,eBankScenario);
		while( gpSound->mGetProcess()!=eSndStandby ){
			K7SCR_RETSYS();
		}
		
		WK7Tutorial	*pTutorial = WK7Tutorial::GetInstance();
		if( pTutorial!=NULL ){
			while( pTutorial->IsLoading()==true ){
				K7SCR_RETSYS();
			}
			pTutorial->SetRender    (true);
			pTutorial->DispIwazaru  (3);
			pTutorial->DispMessage  (TUTOMSG_TUTO_QUERY);
			pTutorial->DispBack     ();
			pTutorial->SetSelectMode(true);
		}
		
		while( (index=pTutorial->GetSelectIndex())<0 ){
			K7SCR_RETSYS();
		}
		
		if( index!=WK7TUTORIAL_SELECT_YES ){
			gpSound->mReleaseSsm(WK7TUTORIAL_SSM_NAME);
			GameInfo.ReadScenarioSSM();
			while( gpSound->mGetProcess()!=eSndStandby ){
				K7SCR_RETSYS();
			}
		}
		
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,SFX_SCE0_MAP_CHANGE_DOOR_HEAVY_OPEN)==false ){
			K7SCR_RETSYS();
		}
		if( pTutorial!=NULL ){
			pTutorial->SetRender(false);
			pTutorial->HideIwazaru();
			pTutorial->HideMessage();
			pTutorial->HideBack   ();
			pTutorial->SetSelectMode(false);
		}
		if( index!=WK7TUTORIAL_SELECT_YES ){
			WK7Tutorial::Terminate();
		}
		
		if( index==WK7TUTORIAL_SELECT_YES ){
			stgid = K7STGID(771,4);
			pBranchPointName = "set1";
			pPathName        = "ps0000";
			dir              = WK7PATHINFO_INITDIR_TGTDIR_REV;
		}else{
			dir              = WK7PATHINFO_INITDIR_TGTDIR;
		}
		
	}else{
		
		index = WK7TUTORIAL_SELECT_NO;
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,SFX_SCE0_MAP_CHANGE_DOOR_HEAVY_OPEN)==false ){
			K7SCR_RETSYS();
		}
		
	}
	
	k7app.FadeStart(0,0);
	k7app.SetFadeColor(0);
	
	WK7Stage::SetChanging(true);
	
	K7SCR_STG_CREATE_B   (stgid);
	K7SCR_PC_CREATE      (chrid);				// fǂݍ
	K7SCR_PC_MOTIONCREATE(chrid);				// [Vǂݍ
	K7SCR_PC_CREATEWAIT();						// ǂݍݑ҂
	K7SCR_STG_SET_CURRENT(stgid);
	K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR(pBranchPointName,pPathName,0.0f,dir);
	
	K7SCR_RETSYS();
	
//	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
//		K7SCR_RETSYS();
//	}
	
	K7SCR_STG_VISIBLE    (stgid,true);
	K7SCR_PC_VISIBLE     (true);
	WK7Stage::SetCameraStartPosition(stgid);
	WK7Stage::SandRelease(stgid);
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		K7SCR_RETSYS();
	}
	WK7Stage::SetChanging(false);
	
	if( index!=WK7TUTORIAL_SELECT_YES ){
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
	}
	
}

K7EV_HANDLER(K7SCN07_Term)
{
}
// ViII
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// ėpCxg
//	K7EV_HANDLER(K7SCN07_EV000101)
//	{
//		K7SCR_PANEL_SETPANELID(ePanel000101,K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000101));
//		K7SCR_PANEL_START();
//		K7SCR_PANEL_TERMWAIT();
//		switch( K7SCR_PANEL_GETRESULT() ){
//		case	1:
//			K7SCR_SET_SCENARIO_FLAG(K7SCN07_EVFL_000101);
//			break;
//		case	0:
//			K7SCR_RESET_SCENARIO_FLAG(K7SCN07_EVFL_000101);
//			break;
//		default:
//			break;
//		}
//		K7SCR_RETSYS();
//		K7SCR_PANEL_EXIT();
//		K7SCR_EVCONDCHANGE();
//	}

//	bool K7SCN07_EV000102_TASK(int id);
//	K7EV_HANDLER(K7SCN07_EV000110)
//	{
//		K7SCN07_EV000102_TASK(0);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000111)
//	{
//		K7SCN07_EV000102_TASK(1);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000112)
//	{
//		K7SCN07_EV000102_TASK(2);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000113)
//	{
//		K7SCN07_EV000102_TASK(3);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000114)
//	{
//		K7SCN07_EV000102_TASK(4);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000115)
//	{
//		K7SCN07_EV000102_TASK(5);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000102)
//	{
//		K7SCN07_EV000102_TASK(6);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000116)
//	{
//		K7SCN07_EV000102_TASK(7);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000117)
//	{
//		K7SCN07_EV000102_TASK(8);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000118)
//	{
//		K7SCN07_EV000102_TASK(9);
//	}

//	K7EV_HANDLER(K7SCN07_EV000104)
//	{
//		K7SCR_PANEL_SETPANELID(ePanel000104,K7EVENT_SCN_VAR(K7SCN07,EVVA_000104));
//		K7SCR_PANEL_START();
//		K7SCR_PANEL_TERMWAIT();
//		s32		result;
//		if( (result=K7SCR_PANEL_GETRESULT()) >= 0 ){
//			K7EVENT_SCN_VAR(K7SCN07,EVVA_000104) = result;
//		}
//		K7SCR_RETSYS();
//		K7SCR_PANEL_EXIT();
//		K7SCR_EVCONDCHANGE();
//	}

//	K7EV_HANDLER(K7SCN07_EV000105)
//	{
//		// Stage701M03
//		// ǗlX}Cj
//		// Kiւ̌擾
//		K7SCR_EVSETITEM(K7EVITEM_KEY(000102),true);
//		
//		K7SCR_STGC_MESSAGE_B(0);				// u1KKǐvɓꂽ
//		
//		K7SCR_EVCONDCHANGE();
//	}

//	K7EV_HANDLER(K7SCN07_EV000106)
//	{
//		// Stage701M01
//		// ꂽgC
//		
//		// UegC
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000603)==FALSE || K7SCR_EVHASITEM(K7EVITEM_KEY(000103))==TRUE ){
//			// ܂JMĂȂ
//			K7SCR_DEBUGPRINT("EVENT_000106 : need EVENT_000603");
//			K7SCR_STGC_MESSAGE_B(K7SCN07_STG701M01_WATERDOWN);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		
//		// {C[̃JMɓꂽ
//		K7SCR_EVSETITEM(K7EVITEM_KEY(000103),true);
//		K7SCR_STGC_MESSAGE_B(K7SCN07_STG701M01_GETKEY);
//		K7SCR_EVCONDCHANGE();
//	}

//	K7EV_HANDLER(K7SCN07_EV000107)
//	{
//		// Stage701M09
//		// {C[
//		// Xs[hX}Cj
//		// nKĩJM
//		K7SCR_EVSETITEM(K7EVITEM_KEY(000104),true);
//		K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_GETKEY);
//		K7SCR_EVCONDCHANGE();
//	}

// @I
//	K7EV_HANDLER(K7SCN07_EV000108)
//	{
//		WK7PathBranchPointObjJObj	*pSelectObj = (WK7PathBranchPointObjJObj *)K7EV_GETEVENTPARAM(0);
//		WK7JObj						*pJObj;
//		if( (pJObj=pSelectObj->GetJObj())!=NULL ){
//			char		objname[64];
//			sprintf(objname,"broken_%s",pJObj->GetName());
//			K7SCN07_BrokenObj(K7STGID(701,5),objname);
//		}
//		gpSound->mPlaySE(SFX_SCE0_DRY_BREAK);
//		K7SCR_EVCONDCHANGE();
//	}
//	
//	// @_~[
//	K7EV_HANDLER(K7SCN07_EV000108DUMMY)
//	{
//		WK7PathBranchPointObjJObj	*pSelectObj = (WK7PathBranchPointObjJObj *)K7EV_GETEVENTPARAM(0);
//		WK7JObj						*pJObj;
//		if( (pJObj=pSelectObj->GetJObj())!=NULL ){
//			char		objname[64];
//			sprintf(objname,"broken_%s",pJObj->GetName());
//			K7SCN07_BrokenObj(K7STGID(701,5),objname);
//		}
//		gpSound->mPlaySE(SFX_SCE0_DRY_BREAK);
//		K7SCR_EVCONDCHANGE();
//	}

//K7EV_HANDLER(K7SCN07_EV000109)
//{
//	// Stage701M01
//	// hAmuj
//}

//	K7EV_HANDLER(K7SCN07_EV000201)
//	{
//		// Stage702M11
//		// ʘH̏ƖXCb`
//		K7SCR_PANEL_SETPANELID(ePanel000201,K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000201));
//		K7SCR_PANEL_START();
//		K7SCR_PANEL_TERMWAIT();
//		switch( K7SCR_PANEL_GETRESULT() ){
//		case	1:
//			K7SCR_SET_SCENARIO_FLAG(K7SCN07_EVFL_000201);
//			break;
//		case	0:
//			K7SCR_RESET_SCENARIO_FLAG(K7SCN07_EVFL_000201);
//			break;
//		default:
//			break;
//		}
//		K7SCR_RETSYS();
//		K7SCR_PANEL_EXIT();
//		K7SCR_EVCONDCHANGE();
//	}

K7EV_HANDLER(K7SCN07_EV000304)
{
}

void K7SCN07_BrokenObj(u32 stgid,WK7JObj *pJObj)
{
	WK7Stage	*pStage = WK7RenderObj::GetStage(stgid);
	if( pStage==NULL || pJObj==NULL || pJObj->GetChild()==NULL ){
		return;
	}
	pJObj->Disp(false,true);
	pStage->WK7RenderObj::CreateEffectBreak(pJObj->GetChild());
}

void K7SCN07_BrokenObj(u32 stgid,const char *pobjname)
{
	WK7Stage	*pStage = WK7RenderObj::GetStage(stgid);
	if( pStage==NULL || pobjname==NULL ){
		return;
	}
	K7SCN07_BrokenObj(stgid,pStage->GetJObj(pobjname));
}

void K7SCN07_Stg703M03_BrokenObj(u32 evid)
{
	WK7Stage	*pStage = WK7RenderObj::GetStage(K7STGID(703,3));
	if( pStage==NULL ){
		return;
	}
	char		objname[32];
	sprintf(objname,"broken_event_%06x",evid);
	K7SCN07_BrokenObj(K7STGID(703,3),objname);
	
	WK7JObj		*pJObj;
	Vec			pos;
	sprintf(objname,"event_%06x",evid);
	if( (pJObj=pStage->GetJObj(objname))==NULL ){
		return;
	}
	pJObj->GetPosition(&pos);
	pos.y = 0.f;
	KK7DoorSmokeEffect(pos);
}

//	K7EV_HANDLER(K7SCN07_EV000305)
//	{
//		gpSound->mPlaySE(SFX_SCE0_WINDOW_BREAK);
//		K7SCN07_Stg703M03_BrokenObj(0x000305);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000306)
//	{
//		gpSound->mPlaySE(SFX_SCE0_WINDOW_BREAK);
//		K7SCN07_Stg703M03_BrokenObj(0x000306);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000307)
//	{
//		gpSound->mPlaySE(SFX_SCE0_WINDOW_BREAK);
//		K7SCN07_Stg703M03_BrokenObj(0x000307);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000308)
//	{
//		gpSound->mPlaySE(SFX_SCE0_WINDOW_BREAK);
//		K7SCN07_Stg703M03_BrokenObj(0x000308);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000309)
//	{
//		gpSound->mPlaySE(SFX_SCE0_WINDOW_BREAK);
//		K7SCN07_Stg703M03_BrokenObj(0x000309);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000310)
//	{
//		gpSound->mPlaySE(SFX_SCE0_WINDOW_BREAK);
//		K7SCN07_Stg703M03_BrokenObj(0x000310);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000311)
//	{
//		// 
//		gpSound->mPlaySE(SFX_SCE0_WINDOW_BREAK);
//		K7SCN07_Stg703M03_BrokenObj(0x000311);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000312)
//	{
//		gpSound->mPlaySE(SFX_SCE0_WINDOW_BREAK);
//		K7SCN07_Stg703M03_BrokenObj(0x000312);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000313)
//	{
//		gpSound->mPlaySE(SFX_SCE0_WINDOW_BREAK);
//		K7SCN07_Stg703M03_BrokenObj(0x000313);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000314)
//	{
//		// 
//		gpSound->mPlaySE(SFX_SCE0_WINDOW_BREAK);
//		K7SCN07_Stg703M03_BrokenObj(0x000314);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000315)
//	{
//		gpSound->mPlaySE(SFX_SCE0_WINDOW_BREAK);
//		K7SCN07_Stg703M03_BrokenObj(0x000315);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000316)
//	{
//		gpSound->mPlaySE(SFX_SCE0_WINDOW_BREAK);
//		K7SCN07_Stg703M03_BrokenObj(0x000316);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000317)
//	{
//		gpSound->mPlaySE(SFX_SCE0_WINDOW_BREAK);
//		K7SCN07_Stg703M03_BrokenObj(0x000317);
//	}

//	K7EV_HANDLER(K7SCN07_EV000401)
//	{
//		// Stage704M01
//		// _[c
//		if( K7SCR_EVHASITEM(K7EVITEM_KEY(000402))==false ){
//			K7SCR_EVSETITEM(K7EVITEM_KEY(000402),true);
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_GETKEY);
//		}
//		K7SCR_EVCONDCHANGE();
//	}

K7EV_HANDLER(K7SCN07_EV000403)
{
}

//	K7EV_HANDLER(K7SCN07_EV000502)
//	{
//		// TeǗ̃XCb`
//		K7SCR_PANEL_SETPANELID(ePanel000502,K7EVENT_SCN_VAR(K7SCN07,EVVA_000502));
//		K7SCR_PANEL_START();
//		K7SCR_PANEL_TERMWAIT();
//		s32	result;
//		if( (result=K7SCR_PANEL_GETRESULT()) ){
//			K7EVENT_SCN_VAR(K7SCN07,EVVA_000502) = result;
//		}
//		K7SCR_RETSYS();
//		K7SCR_PANEL_EXIT();
//		K7SCN07_Stg705M03OpenDoor(true,true);
//		
//		switch( result ){
//		case	1:
//		case	2:{
//			
//	static	Vec		campos[2] = { { 43.603f,14.687f,-135.111f },{ 55.168f,13.696f,-326.593f } };
//	static	Vec		camtgt[2] = { { 54.914f,12.168f,-167.417f },{ 55.108f,12.168f,-360.879f } };
//			
//			result--;
//			
//			K7SCR_ENTER_PLAYMODE();
//			
//			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//			WK7CAM->SetPosition      (campos[result]);
//			WK7CAM->SetTargetPosition(camtgt[result]);
//			
//			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
//				WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//				WK7CAM->SetPosition      (campos[result]);
//				WK7CAM->SetTargetPosition(camtgt[result]);
//				GHMGCTASK_RETSYS();
//			}
//			
//			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//			WK7CAM->SetPosition      (campos[result]);
//			WK7CAM->SetTargetPosition(camtgt[result]);
//			
//			K7SCR_TIMEWAIT(1 * 4800);
//			
//			K7SCN07_Stg705M03OpenDoor(false);
//			
//			K7SCR_TIMEWAIT(4 * 4800);
//	
//			K7SCR_EXIT_PLAYMODE();
//			
//			}break;
//		case	0:
//			break;
//		}
//		
//		K7SCR_EVCONDCHANGE();
//	}

//	K7EV_HANDLER(K7SCN07_EV000602)
//	{
//		K7SCR_STG_EVOBJ_VISIBLE(K7STGID(706,1),K7SCN07_EVENT_000602,false);
//		K7SCR_SET_SCENARIO_FLAG(K7SCN07_EVFL_000602);
//		K7SCR_SET_GLOBAL_FLAG(K7GF_K7MSK_LEVELUP);
//		K7SCR_STGC_MESSAGE_B(0);
//		gpSound->mPlaySE(SFX_SCE0_MSK_LVUP);
//		K7SCR_EVCONDCHANGE();
//	}

//	K7EV_HANDLER(K7SCN07_EV000603)
//	{
//		// UegC
//		s32		state;
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000604)==TRUE ){
//			// ܂Ă
//			state = IN_WATER;
//		}else{
//			state = NOT_WATER;
//		}
//		K7SCR_PANEL_SETPANELID(ePanel000603,state);
//		K7SCR_PANEL_START();
//		K7SCR_PANEL_TERMWAIT();
//		K7SCR_RETSYS();
//		K7SCR_PANEL_EXIT();
//		if( K7SCR_PANEL_GETRESULT()!=TRUE ){
//			// gCɐȂ
//			return;
//		}
//		// gCɐ
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_B);
//		K7SCR_SET_SCENARIO_FLAG(K7SCN07_EVFL_000603);
//		K7SCR_EVCONDCHANGE();
//	}

K7EV_HANDLER(K7SCN07_EV000605)
{
	// Stage706M00
	// LԂ̔iʘHj
	// hAJȂ
	K7SCR_DEBUGPRINT("DOOR_000603 Closed : need Mask's mantle & shot!!");
	K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
	K7SCR_EVCONDCHANGE();
}

K7EV_HANDLER(K7SCN07_EV000606)
{
	// pjbN[XCb`
	K7SCR_PANEL_SETPANELID(ePanel000101,K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000606));
	K7SCR_PANEL_START();
	K7SCR_PANEL_TERMWAIT();
	switch( K7SCR_PANEL_GETRESULT() ){
	case	1:
		K7SCR_SET_SCENARIO_FLAG(K7SCN07_EVFL_000606);
		break;
	case	0:
		K7SCR_RESET_SCENARIO_FLAG(K7SCN07_EVFL_000606);
		break;
	default:
		break;
	}
	K7SCR_RETSYS();
	K7SCR_PANEL_EXIT();
	K7SCR_EVCONDCHANGE();
}

K7EV_HANDLER(K7SCN07_EV000701)
{
	// {XJn
	u32		stgid = K7STGID(707,1);
	u32		chrid = K7CHRID(K7HAC,0);
	
	gpNoise->mSandRequest(eSandLongNoise);
	
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7PLAYERCONTROL->SetDataHp(WK7PLAYERCONTROL->GetMainID(), WK7PLAYERCONTROL->GetHp());		// ݂̂goqɃL̃f[^e[uɔf
	WK7PLAYERCONTROL->Reset();
	WK7PLAYERCONTROL->ReleaseAll();
	
	K7SCR_STG_RELEASE    (K7SCR_STG_GET_CURRENTID());
	K7SCR_STG_CREATE_B   (stgid);
	
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	
	retsys();
	WK7PLAYERCONTROL->CreateModel(chrid);
	WK7PLAYERCONTROL->CreatePackMotion(chrid);
	retsys();
	while( true == WK7PLAYERCONTROL->IsLoading() ){
		retsys();
	}
	
	WK7PLAYERCONTROL->SetVisible(true);
	WK7PLAYERPATHCONTROL->CameraRenew();
	
	K7SCR_STG_SET_CURRENT(stgid);
	K7SCR_STG_VISIBLE    (stgid,true);
	
	WK7Stage::SetRenderStage(false);
	WK7Chara::SetRenderChara(false);
	WK7Item::SetRenderItem  (false);
	
	gpNoise->mSandRelease();
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
//	K7SCR_EXIT_PLAYMODE();
	
	K7SCR_DEBUGPRINT     ("Encounter BOSS !!");
}
// ėpCxg
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// hACxg
//	K7EV_HANDLER(K7SCN07_EVDOOR000101)
//	{
//		// Stage701M00
//		// TKւ̃Gx[^
//		if( K7SCR_EVHASITEM(K7EVITEM_KEY(000403))==false ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000101 Closed : need KEY_000403");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}

//	K7EV_HANDLER(K7SCN07_EVDOOR000102)
//	{
//		// Stage701M00
//		// nւ̔
//		if( K7SCR_EVHASITEM(K7EVITEM_KEY(000104))==false ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000102 Closed : need KEY_000104");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}

//	K7EV_HANDLER(K7SCN07_EVDOOR000103)
//	{
//		// Stage701M00
//		// Kiւ̔
//		if( K7SCR_EVHASITEM(K7EVITEM_KEY(000102))==false ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000103 Closed : need KEY_000102");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}

//K7EV_HANDLER(K7SCN07_EVDOOR000104)
//{
//	K7SCR_EVCONDCHANGE();
//}

//	K7EV_HANDLER(K7SCN07_EVDOOR000105)
//	{
//		// Stage701M05
//		// @
//		if( K7SCR_EVHASITEM(K7EVITEM_KEY(000101))==false ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000105 Closed : need KEY_000101");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}

//	K7EV_HANDLER(K7SCN07_EVDOOR000106)
//	{
//		// Stage701M06
//		// POR
//		if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000104)!=ROOM_NO_103 ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000104 Closed : Room103");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}

//	K7EV_HANDLER(K7SCN07_EVDOOR000107)
//	{
//		// Stage701M01
//		// ؐ
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000109)==FALSE ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000107 Closed : need to break Knob");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}


//	K7EV_HANDLER(K7SCN07_EVDOOR000108)
//	{
//		// Stage701M00
//		// {C[ւ̔
//		if( K7SCR_EVHASITEM(K7EVITEM_KEY(000103))==false ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000108 Closed : need KEY_000103");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//	//	// nKĩJMiƂ肠j
//	//	K7SCR_EVSETITEM(K7EVITEM_KEY(000104),true);
//		K7SCR_DEF_CALLDOOREVENT();
//	}

//	K7EV_HANDLER(K7SCN07_EVDOOR000203)
//	{
//		// Stage702M11
//		// QOR
//		if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000104)!=ROOM_NO_203 ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000203 Closed : Room203");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}
//	
//	K7EV_HANDLER(K7SCN07_EVDOOR000205)
//	{
//		// Stage702M11
//		// QOT
//		if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000104)!=ROOM_NO_205 ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000205 Closed : Room205");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}
//	
//	K7EV_HANDLER(K7SCN07_EVDOOR000206)
//	{
//		// Stage702M11
//		// QOU
//		if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000104)!=ROOM_NO_206 ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000206 Closed : Room206");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}
//	
//	K7EV_HANDLER(K7SCN07_EVDOOR000207)
//	{
//		// Stage702M11
//		// QOV
//		if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000104)!=ROOM_NO_207 ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000207 Closed : Room207");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}
//	
//	K7EV_HANDLER(K7SCN07_EVDOOR000208)
//	{
//		// Stage702M11
//		// QOW
//		if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000104)!=ROOM_NO_208 ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000208 Closed : Room208");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}
//	
//	
//	K7EV_HANDLER(K7SCN07_EVDOOR000209)
//	{
//		// Stage702M11
//		// QOX
//		if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000104)!=ROOM_NO_209 ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000209 Closed : Room209");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}
//	

//	K7EV_HANDLER(K7SCN07_EVDOOR000210)
//	{
//		// Stage702M11
//		// QPO
//		if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000104)!=ROOM_NO_210 ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000210 Closed : Room210");
//			switch( K7SCR_STG_GET_CURRENTID() ){
//			case	K7STGID(702,7):
//				K7SCR_STGC_MESSAGE_B(K7SCN07_STG702M02_CLOSE210);
//				break;
//			case	K7STGID(702,2):
//				K7SCR_STGC_MESSAGE_B(K7SCN07_STG702M02_CLOSE210);
//				break;
//			default:
//				K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//				break;
//			}
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}

//	K7EV_HANDLER(K7SCN07_EVDOOR000211)
//	{
//		// Stage702M00
//		// 
//		if( WK7Stage::GetCurrentStageID()==K7STGID(702,11) ){
//			// kȂJ
//			K7SCR_SET_SCENARIO_FLAG(K7SCN07_DRFL_000211);
//		}
//	//	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_DRFL_000212)==FALSE ){
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_DRFL_000211)==FALSE ){
//			K7SCR_DEBUGPRINT("DOOR_000211 Closed : need DOOR_000212 opened");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}

//	K7EV_HANDLER(K7SCN07_EVDOOR000212)
//	{
//		// Stage702M07
//		// QPO
//		if( K7SCR_EVHASITEM(K7EVITEM_KEY(000201))==false ){
//			K7SCR_DEBUGPRINT("DOOR_000212 Closed : need KEY_000201");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_SET_SCENARIO_FLAG(K7SCN07_DRFL_000212);
//		K7SCR_DEF_CALLDOOREVENT();
//	}


void K7SCN07_Stg702M03_BrokenObj(u32 evid);
void K7SCN07_Stg702M03_BrokenObj(u32 evid)
{
	WK7Stage	*pStage = WK7RenderObj::GetStage(K7STGID(703,3));
	if( pStage==NULL ){
		return;
	}
	char		objname[32];
	sprintf(objname,"broken_event_%06x",evid);
	K7SCN07_BrokenObj(K7STGID(703,3),objname);
	
	WK7JObj		*pJObj;
	Vec			pos;
	sprintf(objname,"event_%06x",evid);
	if( (pJObj=pStage->GetJObj(objname))==NULL ){
		return;
	}
	pJObj->GetPosition(&pos);
	pos.y = 0.f;
	KK7DoorSmokeEffect(pos);
}


//	K7EV_HANDLER(K7SCN07_EVDOOR000213)
//	{
//		WK7Stage	*pStage = WK7RenderObj::GetStage(K7STGID(702,1));
//		Vec pos;
//		// Stage702M01
//		// ꂩ̕ǂP
//		
//		if( pStage==NULL ){
//			return;
//		}
//		
//		K7SCN07_BrokenObj(K7STGID(702,1), "door_000213_AccessA");
//		
//		// 
//		pos.x = 174.979f;
//		pos.y = 0.f;
//		pos.z = -340.291f;
//		KK7DoorSmokeEffect(pos);
//		
//		gpSound->mPlaySE(SFX_SCE0_WALL_BREAK);
//	}

//	K7EV_HANDLER(K7SCN07_EVDOOR000214)
//	{
//		WK7Stage	*pStage = WK7RenderObj::GetStage(K7STGID(702,7));
//		Vec pos;
//		// Stage702M07
//		// ꂩ̕ǂQ
//		
//		if( pStage==NULL ){
//			return;
//		}
//		
//		K7SCN07_BrokenObj(K7STGID(702,7), "door_000214_AccessA");
//		
//		// 
//		pos.x = -61.529f;
//		pos.y = 0.f;
//		pos.z = -491.351f;
//		KK7DoorSmokeEffect(pos);
//		
//		gpSound->mPlaySE(SFX_SCE0_WALL_BREAK);
//	}

//	K7EV_HANDLER(K7SCN07_EVDOOR000215)
//	{
//		WK7Stage	*pStage = WK7RenderObj::GetStage(K7STGID(702,7));
//		Vec pos;
//		// Stage702M07
//		// ꂩ̕ǂR
//		
//		if( pStage==NULL ){
//			return;
//		}
//		
//		K7SCN07_BrokenObj(K7STGID(702,7), "door_000215_AccessB");
//		
//		// 
//		pos.x = -40.381f;
//		pos.y = 0.f;
//		pos.z = -350.f;
//		KK7DoorSmokeEffect(pos);
//		
//		gpSound->mPlaySE(SFX_SCE0_WALL_BREAK);
//	}

//	K7EV_HANDLER(K7SCN07_EVDOOR000216)
//	{
//		// Stage702M07
//		// ʘHk[
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_DRFL_000212)==FALSE ){
//			K7SCR_DEBUGPRINT("DOOR_000216 Closed : need DOOR_000212 opened");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}

//	K7EV_HANDLER(K7SCN07_EVDOOR000301)
//	{
//		// Stage703M01
//		// ROP
//		if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000104)!=ROOM_NO_301 ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000301 Closed : Room301");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}
//	
//	K7EV_HANDLER(K7SCN07_EVDOOR000302)
//	{
//		// Stage703M01
//		// ROQ
//		if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000104)!=ROOM_NO_302 ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000302 Closed : Room302");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}
//	
//	K7EV_HANDLER(K7SCN07_EVDOOR000303)
//	{
//		// Stage703M01
//		// ROR
//		if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000104)!=ROOM_NO_303 ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000303 Closed : Room303");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}
//	
//	K7EV_HANDLER(K7SCN07_EVDOOR000304)
//	{
//		// Stage703M01
//		// ROS
//		if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000104)!=ROOM_NO_304 ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000304 Closed : Room304");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}

//	K7EV_HANDLER(K7SCN07_EVDOOR000305)
//	{
//		// Stage703M01
//		// ReʘHiSKւ̔j
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_DRFL_000305)==TRUE ){
//			K7SCR_DEF_CALLDOOREVENT();
//		}else{
//			// Ípl
//			K7SCR_PANEL_SETPANELID(ePanel000304,K7SCR_GET_SCENARIO_FLAG(K7SCN07_DRFL_000305));
//			K7SCR_PANEL_START();
//			K7SCR_PANEL_TERMWAIT();
//			switch( K7SCR_PANEL_GETRESULT() ){
//			case	1:
//				K7SCR_SET_SCENARIO_FLAG(K7SCN07_DRFL_000305);
//				break;
//			case	0:
//				K7SCR_RESET_SCENARIO_FLAG(K7SCN07_DRFL_000305);
//				break;
//			default:
//				break;
//			}
//			K7SCR_RETSYS();
//			K7SCR_PANEL_EXIT();
//			K7SCR_EVCONDCHANGE();
//			K7SCR_PANEL_EXITWAIT();
//			
//			K7SCR_TIMEWAIT(4800);
//			
//			if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_DRFL_000305)==TRUE ){
//				K7SCR_DEF_CALLDOOREVENT();
//			}
//		}
//	}

//	K7EV_HANDLER(K7SCN07_EVDOOR000401)
//	{
//		// Stage704M00
//		// xbh[ւ̔
//		if( K7SCR_EVHASITEM(K7EVITEM_KEY(000401))==false ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000401 Closed : need KEY_000401");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}

//	K7EV_HANDLER(K7SCN07_EVDOOR000402)
//	{
//		// Stage704M03
//		// f@ւ̔
//		if( K7SCR_EVHASITEM(K7EVITEM_KEY(000402))==false ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000402 Closed : need KEY_000402");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}

//	K7EV_HANDLER(K7SCN07_EVDOOR000501)
//	{
//		// Stage705M03
//		// TOP
//		if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000502)!=1 ){
//			K7SCR_DEBUGPRINT("DOOR_000501 Closed : controll panel -> normal");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}
//	
//	K7EV_HANDLER(K7SCN07_EVDOOR000502)
//	{
//		// Stage705M03
//		// TOQ
//		if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000502)!=1 ){
//			K7SCR_DEBUGPRINT("DOOR_000502 Closed : controll panel -> normal");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}
//	
//	K7EV_HANDLER(K7SCN07_EVDOOR000503)
//	{
//		// Stage705M03
//		// TOR
//		if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000502)!=1 ){
//			K7SCR_DEBUGPRINT("DOOR_000503 Closed : controll panel -> normal");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}

K7EV_HANDLER(K7SCN07_EVDOOR000504)
{
	// Stage705M03
	// TOS
	if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000502)!=2 ){
		K7SCR_DEBUGPRINT("DOOR_000504 Closed : controll panel -> hard");
		K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
		K7SCR_EVCONDCHANGE();
		return;
	}
	K7SCR_DEF_CALLDOOREVENT();
}

K7EV_HANDLER(K7SCN07_EVDOOR000505)
{
	// Stage705M03
	// TOT
	if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000502)!=2 ){
		K7SCR_DEBUGPRINT("DOOR_000505 Closed : controll panel -> hard");
		K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
		K7SCR_EVCONDCHANGE();
		return;
	}
	K7SCR_DEF_CALLDOOREVENT();
}

K7EV_HANDLER(K7SCN07_EVDOOR000506)
{
	// Stage705M03
	// TOU
	if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000502)!=2 ){
		K7SCR_DEBUGPRINT("DOOR_000506 Closed : controll panel -> hard");
		K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
		K7SCR_EVCONDCHANGE();
		return;
	}
	K7SCR_DEF_CALLDOOREVENT();
}

K7EV_HANDLER(K7SCN07_EVDOOR000507)
{
	// Stage705M03
	// TOV
	if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000502)!=2 ){
		K7SCR_DEBUGPRINT("DOOR_000507 Closed : controll panel -> hard");
		K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
		K7SCR_EVCONDCHANGE();
		return;
	}
	K7SCR_DEF_CALLDOOREVENT();
}

K7EV_HANDLER(K7SCN07_EVDOOR000508)
{
	// Stage705M03
	// TOW
	if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000502)!=2 ){
		K7SCR_DEBUGPRINT("DOOR_000508 Closed : controll panel -> hard");
		K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
		K7SCR_EVCONDCHANGE();
		return;
	}
	K7SCR_DEF_CALLDOOREVENT();
}

K7EV_HANDLER(K7SCN07_EVDOOR000509)
{
	// Stage705M03
	// TOX
	if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000502)!=2 ){
		K7SCR_DEBUGPRINT("DOOR_000509 Closed : controll panel -> hard");
		K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
		K7SCR_EVCONDCHANGE();
		return;
	}
	K7SCR_DEF_CALLDOOREVENT();
}

K7EV_HANDLER(K7SCN07_EVDOOR000510)
{
	// Stage705M03
	// TPO
	if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000502)!=2 ){
		K7SCR_DEBUGPRINT("DOOR_000510 Closed : controll panel -> hard");
		K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
		K7SCR_EVCONDCHANGE();
		return;
	}
	K7SCR_DEF_CALLDOOREVENT();
}

K7EV_HANDLER(K7SCN07_EVDOOR000511)
{
	// Stage705M03
	// TPP
	if( K7EVENT_SCN_VAR(K7SCN07,EVVA_000502)!=2 ){
		K7SCR_DEBUGPRINT("DOOR_000511 Closed : controll panel -> hard");
		K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
		K7SCR_EVCONDCHANGE();
		return;
	}
	K7SCR_DEF_CALLDOOREVENT();
}

//	K7EV_HANDLER(K7SCN07_EVDOOR000512)
//	{
//		// Stage705M03
//		// Ueւ̊Ki
//		if( K7SCR_EVHASITEM(K7EVITEM_KEY(000501))==false ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_000512 Closed : need KEY_000501");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}

//	K7EV_HANDLER(K7SCN07_EVDOOR000601)
//	{
//		// Stage706M00
//		// iʘHj
//		// hAJȂ
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_DRFL_000601)==FALSE ){
//			K7SCR_DEBUGPRINT("DOOR_000601 Closed : need explode HS");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}
//	
//	K7EV_HANDLER(K7SCN07_EVDOOR000602)
//	{
//		// Stage706M00
//		// iʘHj
//		// hAJȂ
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_DRFL_000602)==FALSE ){
//			K7SCR_DEBUGPRINT("DOOR_000602 Closed : need explode HS");
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		K7SCR_DEF_CALLDOOREVENT();
//	}


//	K7EV_HANDLER(K7SCN07_EVDOOR000603)
//	{
//		// Stage706M00
//		// LԂ̔iʘHjj
//		if( WK7PLAYERCONTROL->GetMainID()!=K7MSK ){
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		if( K7SCR_GET_GLOBAL_FLAG(K7GF_K7MSK_LEVELUP)!=TRUE ){
//			K7SCR_EVCONDCHANGE();
//			return;
//		}
//		WK7HitObjJObj		*pHitObj = (WK7HitObjJObj *)K7EV_GETEVENTPARAM(0);
//		WK7JObj				*pJObj   = pHitObj->GetJObj();
//		char				objname[128];
//		if( pJObj!=NULL ){
//			WK7PathNurbs	*pPath = pHitObj->GetClosePath();
//			sprintf(objname,"broken_%s",pJObj->GetName());
//			K7SCN07_BrokenObj(K7STGID(706,0),objname);
//			Vec			pos = { 54.0f , 0.0f , -315.0f };
//			KK7DoorSmokeEffect(pos);
//			pJObj->Hide(false,true);
//			pPath->SetEnable  (true);
//			pPath->SetEnableEx(true);
//		}
//		K7SCR_SET_SCENARIO_FLAG(K7SCN07_DRFL_000603);
//		// GtFNg
//		gpSound->mPlaySE(SFX_SCE0_WALL_BREAK);
//		K7SCR_EVCONDCHANGE();
//	}
//	

// hACxg
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// }bvCxg
//K7EV_HANDLER(K7SCN07_EVMAP000101)
//{
//	// }bvɓꂽ
//	K7SCR_EVSETITEM(K7EVITEM_MAP(000101),true);
//	K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_GETMAP);
//	K7SCR_EVCONDCHANGE();
//}
// }bvCxg
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Cxg
//K7EV_HANDLER(K7SCN07_EVMEMO000101)
//{
//	// ɓꂽ
//	K7SCR_EVSETITEM(K7EVITEM_MEMO(000101),true);
//	K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_GETMEMO);
//	K7SCR_EVCONDCHANGE();
//}

K7EV_HANDLER(K7SCN07_EVMEMO000402)
{
	// ɓꂽ
	K7SCR_EVSETITEM(K7EVITEM_MEMO(000402),true);
	K7SCR_STGC_MESSAGE_B(0);
	K7SCR_EVCONDCHANGE();
}
// Cxg
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//	Xe[WVOO
//  
////////////////////////////////////////////////////////////////////////////////
K7EV_HANDLER(K7SCN07_Stg700M00Current)
{
//	gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//	gpSound->mPlayStreamNo(HPS_TENSHI_D);
}


////////////////////////////////////////////////////////////////////////////////
//	Xe[WVOP
//  ZeBbNPK
////////////////////////////////////////////////////////////////////////////////

// ʘH
//	K7EV_HANDLER(K7SCN07_Stg701M00Init)
//	{
//		K7SCN07_FlagInit();
//		WK7PlayerChangeTaskforScenario00(K7CHRID(K7DAN,0));
//		WK7Npc::NpcAutoCreateAllB(K7EV_GETEVENTPARAM(0));
//		gpSound->mPlaySE3D(	SFX_SCE0_AMB_FAN_LOOP,			// 󒲃t@̉iȂpƂOHƂ񍳘H̋߂ɔzuƕω̊ƁEEEj
//							(Vec){7.863F,28.0F,-141.0F}
//		);
//	
//	}

//	K7EV_HANDLER(K7SCN07_Stg701M00Current)
//	{
//	//	WK7PLAYERCONTROL->ChangeChkPoint();
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_B);
//	}

//	K7EV_HANDLER(K7SCN07_Stg701M00Term)
//	{
//		gpSound->mStopSE(SFX_SCE0_AMB_FAN_LOOP);			// 󒲃t@̉~߂
//	}

//	K7EV_HANDLER(K7SCN07_Stg701M00CondChange)
//	{
//		// ɃCxggp\
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000101,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000102,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000103,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000108,true);
//	}

// POP
//	K7EV_HANDLER(K7SCN07_Stg701M01Init)
//	{
//		K7SCN07_FlagInit();
//	//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7DAN,0));
//		WK7Npc::NpcAutoCreateAllB(K7EV_GETEVENTPARAM(0));
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg701M01Current)
//	{
//		WK7Stage	*pStage = WK7RenderObj::GetStage(K7STGID(701,1));
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_B);
//		
//		if( pStage!=NULL ){
//	static		Vec		point = { -57.840f , 30.000f , -229.013f };
//			pStage->CreateEffectDropWater(point,6.466f);
//		}
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg701M01CondChange)
//	{
//		if( K7SCR_EVHASITEM(K7EVITEM_KEY(000603))==false ){
//			K7SCR_EVSETENABLE(K7SCN07_EVENT_000106,true);
//		}else{
//			K7SCR_EVSETENABLE(K7SCN07_EVENT_000106,false);
//		}
//	//	K7SCR_EVSETENABLE(K7SCN07_DOOR_000107,true);
//		// ngiPOPjȂ
//		K7SCR_EVNO_SETENABLE(K7EVITEM_MEMO(000101),false);
//	}

// POQ
K7EV_HANDLER(K7SCN07_Stg701M02Init)
{
//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7DAN,0));
//	WK7Npc::NpcAutoCreateAllB(K7EV_GETEVENTPARAM(0));
}

K7EV_HANDLER(K7SCN07_Stg701M02Current)
{
	gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
	gpSound->mPlayStreamNo(HPS_TENSHI_B);
}

K7EV_HANDLER(K7SCN07_Stg701M02CondChange)
{
}

// POR
//	K7EV_HANDLER(K7SCN07_Stg701M03Init)
//	{
//	//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7DAN,0));
//		WK7Npc::NpcAutoCreateAllB(K7EV_GETEVENTPARAM(0));
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg701M03Current)
//	{
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_B);
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg701M03CondChange)
//	{
//	}

// Ǘl
//	K7EV_HANDLER(K7SCN07_Stg701M04Init)
//	{
//	//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7DAN,0));
//		WK7Npc::NpcAutoCreateAllB(K7EV_GETEVENTPARAM(0));
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg701M04Current)
//	{
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_B);
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg701M04CondChange)
//	{
//		// ɃCxggp\
//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000104,true);
//	}


//	K7EV_HANDLER(K7SCN07_Stg701M05Init)
//	{
//	//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7DAN,0));
//		WK7Npc::NpcAutoCreateAllB(K7EV_GETEVENTPARAM(0));
//	}
//	K7EV_HANDLER(K7SCN07_Stg701M05Create)
//	{
//		WK7Stage	*pStage = WK7RenderObj::GetStage(K7STGID(701,5));
//		if( pStage==NULL ){
//			return;
//		}
//		_K7SCN07_Stg701M05Info.Initialize();
//		pStage->CreateOwnStageMotion( 500);
//		pStage->CreateOwnStageMotion( 501);
//		K7SCN07_Stg701M05Table	*pTable = K7SCN07_Stg701M05_GetTable(0);
//		pTable->mpDrumRotSpeed = &K7EVENT_SCN_VAR(K7SCN07,EVVA_000110); pTable++;
//		pTable->mpDrumRotSpeed = &K7EVENT_SCN_VAR(K7SCN07,EVVA_000111); pTable++;
//		pTable->mpDrumRotSpeed = &K7EVENT_SCN_VAR(K7SCN07,EVVA_000112); pTable++;
//		pTable->mpDrumRotSpeed = &K7EVENT_SCN_VAR(K7SCN07,EVVA_000113); pTable++;
//		pTable->mpDrumRotSpeed = &K7EVENT_SCN_VAR(K7SCN07,EVVA_000114); pTable++;
//		pTable->mpDrumRotSpeed = &K7EVENT_SCN_VAR(K7SCN07,EVVA_000115); pTable++;
//		pTable->mpDrumRotSpeed = &K7EVENT_SCN_VAR(K7SCN07,EVVA_000102); pTable++;
//		pTable->mpDrumRotSpeed = &K7EVENT_SCN_VAR(K7SCN07,EVVA_000116); pTable++;
//		pTable->mpDrumRotSpeed = &K7EVENT_SCN_VAR(K7SCN07,EVVA_000117); pTable++;
//		pTable->mpDrumRotSpeed = &K7EVENT_SCN_VAR(K7SCN07,EVVA_000118); pTable++;
//	}
//	K7EV_HANDLER(K7SCN07_Stg701M05Term)
//	{
//		int		i;
//		for(i=0 ; i<10 ; i++){
//			_K7SCN07_Stg701M05Info.StopSE(i);
//		}
//		_K7SCN07_Stg701M05Info.StopKeySE();
//		gMask.Start(0,0,0);
//	}

//	K7EV_HANDLER(K7SCN07_Stg701M05Current)
//	{
//		WK7Stage	*pStage;
//		WK7JObj		*pJObj;
//		WK7JObj		*pJObjKey = NULL;
//		int			i;
//		
//		for(i=0 ; i<K7SCN07_STG701M05TABLE_NUM ; i++){
//			K7SCN07_Stg701M05_DryingMachineAlphaSetup(K7SCN07_Stg701M05_GetHitObjName(i));
//		}
//		if( (pStage = WK7RenderObj::GetStage(K7STGID(701,5)))!=NULL ){
//			if( (pJObjKey=pStage->PlayMotion("key_group",501,NULL))!=NULL ){
//				pJObjKey->SetMotionLoop(true);
//				pJObjKey->Hide(false,true);
//			}
//			for(i=0 ; i<K7SCN07_STG701M05TABLE_NUM ; i++){
//				if( (pJObj=pStage->PlayMotion(K7SCN07_Stg701M05_GetDrumObjName(i),500,K7SCN07_Stg701M05_MotionName))!=NULL ){
//					pJObj->SetMotionLoop(true);
//					pJObj->SetMotionRate(K7SCN07_Stg701M05_GetDrumRotSpeed(i));
//				}
//				int		flag = K7SCN07_Stg701M05_GetDrumFlagID(i);
//				if( K7SCR_GET_SCENARIO_FLAG(flag)==TRUE ){
//					_K7SCN07_Stg701M05Info.PlaySE(i,SFX_SCE0_DRY_ON_LOOP);
//					if( i==K7SCN07_STG701M05TABLE_RIGHTNO && K7SCR_EVHASITEM(K7EVITEM_KEY(000101))==false ){
//						_K7SCN07_Stg701M05Info.PlayKeySE();
//					}
//				}
//			}
//		}
//		
//		while( (pStage = WK7RenderObj::GetStage(K7STGID(701,5)))!=NULL ){
//			for(i=0 ; i<K7SCN07_STG701M05TABLE_NUM ; i++){
//				if( (pJObj=pStage->GetJObj(K7SCN07_Stg701M05_GetDrumObjName(i)))==NULL ){
//					continue;
//				}
//				f32	spd = K7SCN07_Stg701M05_GetDrumRotSpeed(i);
//	#define	K7SCN07_STG701M05_ROTSPEED		(2.0f)
//				if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_Stg701M05_GetDrumFlagID(i))==TRUE ){
//					spd += WK7_TICK_TO_FRAME(K7SCN07_STG701M05_ROTSPEED);
//					if( i==K7SCN07_STG701M05TABLE_RIGHTNO && pJObjKey!=NULL && K7SCR_EVHASITEM(K7EVITEM_KEY(000101))==false ){
//						pJObjKey->Disp(false,true);
//					}
//				}else{
//					spd -= WK7_TICK_TO_FRAME(K7SCN07_STG701M05_ROTSPEED);
//					if( i==K7SCN07_STG701M05TABLE_RIGHTNO && pJObjKey!=NULL && K7SCR_EVHASITEM(K7EVITEM_KEY(000101))==false ){
//						pJObjKey->Hide(false,true);
//					}
//				}
//				if( spd < 0.0f ){
//					spd = 0.0f;
//				}else if( spd > 1.0f ){
//					spd = 1.0f;
//				}
//				K7SCN07_Stg701M05_SetDrumRotSpeed(i,spd);
//				pJObj->SetMotionRate(spd,false,true);
//			}
//			K7SCR_RETSYS();
//		}
//	}

//	K7EV_HANDLER(K7SCN07_Stg701M05CondChange)
//	{
//		bool	kansouki;
//		// ɃCxggp\
//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000101,true);
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000101)==TRUE ){
//			kansouki = true;
//		}else{
//			kansouki = false;
//		}
//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000102,kansouki);
//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000110,kansouki);
//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000111,kansouki);
//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000112,kansouki);
//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000113,kansouki);
//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000114,kansouki);
//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000115,kansouki);
//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000116,kansouki);
//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000117,kansouki);
//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000118,kansouki);
//	}

//	// ւ̒ʘH
//	K7EV_HANDLER(K7SCN07_Stg701M06Init)
//	{
//	//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7DAN,0));
//		WK7Npc::NpcAutoCreateAllB(K7EV_GETEVENTPARAM(0));
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg701M06Current)
//	{
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_B);
//	}

//	K7EV_HANDLER(K7SCN07_Stg701M06CondChange)
//	{
//		// ɃCxggp\
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000106,true);
//	}

//	// Ki QF~Ă
//	K7EV_HANDLER(K7SCN07_Stg701M08Init)
//	{
//		WK7PlayerChangeTaskforScenario00(K7CHRID(K7DAN,0));
//		WK7Npc::NpcAutoCreateAllB(K7EV_GETEVENTPARAM(0));
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg701M08Current)
//	{
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_B);
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg701M08CondChange)
//	{
//	}

//	// {C[
//	K7EV_HANDLER(K7SCN07_Stg701M09Init)
//	{
//	//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7DAN,0));
//		WK7Npc::NpcAutoCreateAllB(K7EV_GETEVENTPARAM(0));
//		gpSound->mPlaySE3D(	SFX_SCE0_AMB_BOILER_LOOP,
//							(Vec){134.0F,12.0F,-391.0F}
//		);													// {C[SEĐ
//		
//		// Xs[hX}C̐ݒ
//		{
//			WK7Npc *pNpcSpeedSmile;
//			
//			pNpcSpeedSmile = WK7Npc::Find(ENENO_7_701_08);
//			
//			pNpcSpeedSmile->SpeedSet(4.f);						// Xs[h
//	//		pNpcSpeedSmile->AiModeSet_SpeedSmileSet();			// `hXs[hX}C[hɂ
//		}
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg701M09Current)
//	{
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_B);
//		
//		while( K7SCR_STG_GET_CURRENTID()==K7STGID(701,9) ){
//			
//			if( K7SCR_EVHASITEM(K7EVITEM_KEY(000104))==false ){						// nKĩJM肵ĂȂ
//				// |bv̓G
//				WK7Npc *pNpc;
//				
//				pNpc = WK7Npc::Find(ENENO_7_701_09);
//				if ( NULL != pNpc ){
//					if ( true == pNpc->AiModeSet_TestPop() ){
//						pNpc->AiModeSet_PopGo((int )(60 + rand()%120));				// |bvwnm
//					}
//				}
//				pNpc = WK7Npc::Find(ENENO_7_701_10);
//				if ( NULL != pNpc ){
//					if ( true == pNpc->AiModeSet_TestPop() ){
//						pNpc->AiModeSet_PopGo((int )(60 + rand()%120));				// |bvwnm
//					}
//				}
//				pNpc = WK7Npc::Find(ENENO_7_701_11);
//				if ( NULL != pNpc ){
//					if ( true == pNpc->AiModeSet_TestPop() ){
//						pNpc->AiModeSet_PopGo((int )(60 + rand()%120));				// |bvwnm
//					}
//				}
//			}
//			
//			K7SCR_RETSYS();
//		}
//		
//		
//	}

//	K7EV_HANDLER(K7SCN07_Stg701M09Term)
//	{
//		// {C[SE~߂
//		gpSound->mStopSE(SFX_SCE0_AMB_BOILER_LOOP);
//	}
//	
//	
//	K7EV_HANDLER(K7SCN07_Stg701M09CondChange)
//	{
//	}

// Gx[^@TF炨Ă
K7EV_HANDLER(K7SCN07_Stg701M10Init)
{
	WK7PlayerChangeTaskforScenario00(K7CHRID(K7DAN,0));
//	WK7Npc::NpcAutoCreateAllB(K7EV_GETEVENTPARAM(0));
}

K7EV_HANDLER(K7SCN07_Stg701M10Current)
{
	gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
	gpSound->mPlayStreamNo(HPS_TENSHI_B);
}

K7EV_HANDLER(K7SCN07_Stg701M10CondChange)
{
}

// nւ̊Ki@7F~Ă
//K7EV_HANDLER(K7SCN07_Stg701M11Init)
//{
//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7DAN,0));
////	WK7Npc::NpcAutoCreateAllB(K7EV_GETEVENTPARAM(0));
//}
//
//K7EV_HANDLER(K7SCN07_Stg701M11Current)
//{
//	gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//	gpSound->mPlayStreamNo(HPS_TENSHI_B);
//}
//
//K7EV_HANDLER(K7SCN07_Stg701M11CondChange)
//{
//}

////////////////////////////////////////////////////////////////////////////////
//	Xe[WVOQ
//  ZeBbNQK
////////////////////////////////////////////////////////////////////////////////
//	K7EV_HANDLER(K7SCN07_Stg702M00Init)
//	{
//		WK7PlayerChangeTaskforScenario00(K7CHRID(K7CON,0));
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg702M00Current)
//	{
//	//	WK7PLAYERCONTROL->ChangeChkPoint();
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_A);
//	}

//	K7EV_HANDLER(K7SCN07_Stg702M00CondChange)
//	{
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000203,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000205,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000206,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000207,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000208,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000209,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000210,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000211,true);
//	//	K7SCR_EVSETENABLE(K7SCN07_DOOR_000212,true);
//	}

//	K7EV_HANDLER(K7SCN07_Stg702M01Init)
//	{
//	//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7CON,0));
//	//	{
//	//		Vec pos;
//	//		pos.x = 174.979f;
//	//		pos.y = 0.f;
//	//		pos.z = -340.291f;
//	//		gpSound->mPlaySE3D( SFX_SCE0_MAP_SUKIMAKAZE, pos, 2);			// ԕSEĐ
//	//	}
//	}

//	K7EV_HANDLER(K7SCN07_Stg702M01Current)
//	{
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_A);
//	}

//	K7EV_HANDLER(K7SCN07_Stg702M01CondChange)
//	{
//		// ngiQOUjȂ
//		K7SCR_EVNO_SETENABLE(K7EVITEM_MEMO(000202),false);
//	}

//	K7EV_HANDLER(K7SCN07_Stg702M01Term)
//	{
//		// ԕSE~߂
//	//	gpSound->mStopSE(SFX_SCE0_MAP_SUKIMAKAZE);
//	}

K7EV_HANDLER(K7SCN07_Stg702M03Init)
{
//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7CON,0));
}

K7EV_HANDLER(K7SCN07_Stg702M03Current)
{
	gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
	gpSound->mPlayStreamNo(HPS_TENSHI_A);
}

K7EV_HANDLER(K7SCN07_Stg702M03CondChange)
{
}

//	K7EV_HANDLER(K7SCN07_Stg702M07Init)
//	{
//	//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7CON,0));
//	//	{
//	//		Vec pos;
//	//		pos.x = -61.529f;
//	//		pos.y = 0.f;
//	//		pos.z = -491.351f;
//	//		gpSound->mPlaySE3D( SFX_SCE0_MAP_SUKIMAKAZE, pos, 2);			// ԕSEĐ
//	//	}
//	//	{
//	//		Vec pos;
//	//		pos.x = -40.381f;
//	//		pos.y = 0.f;
//	//		pos.z = -350.f;
//	//		gpSound->mPlaySE3D( SFX_SCE0_MAP_SUKIMAKAZE, pos, 2);			// ԕSEĐ
//	//	}
//	}

//	K7EV_HANDLER(K7SCN07_Stg702M07Current)
//	{
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_A);
//	}

//	K7EV_HANDLER(K7SCN07_Stg702M07CondChange)
//	{
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg702M07Term)
//	{
//		// ԕSE~߂
//	//	gpSound->mStopSE(SFX_SCE0_MAP_SUKIMAKAZE);
//	}

//	void K7SCN07_Stg702M11LightRenderTask(ghmGcTask *);
//	void K7SCN07_Stg702M11LightRenderTask(ghmGcTask *)
//	{
//		WK7Stage	*pStage;
//		while( (pStage=WK7RenderObj::GetStage(K7STGID(702,11)))!=NULL ){
//			if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000201)==TRUE ){
//				K7SCN07_Stg702M11LightSetRender(false);
//			}else{
//				K7SCN07_Stg702M11LightSetRender(true);
//			}
//			if( pStage->GetRenderFlag()==true && WK7Stage::GetRenderStage()==true ){
//				if( WK7CAM->SetCurrent()==true ){
//					WK7Light::DispStart();
//					pStage->DispLight();
//					WK7Light::DispEnd();
//					K7SCN07_Stg702M11LightRender();
//					WK7CAM->EndCurrent();
//				}
//			}
//			K7SCR_RETSYS();
//		}
//	}
//	K7EV_HANDLER(K7SCN07_Stg702M11Init)
//	{
//		WK7Npc::NpcAutoCreateAllB(K7EV_GETEVENTPARAM(0));
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000201)==TRUE ){
//			K7SCN07_Stg702M11LightSetRender(false);
//		}else{
//			K7SCN07_Stg702M11LightSetRender(true);
//		}
//		GET_WK7MAINTASK_RENDERPROCESSTASKPTR()->Start(K7SCN07_Stg702M11LightRenderTask,0,0,NULL,-1,WK7MAINTASK_PRE_SCREENCAPTURE_TASK_PRIO + 1);
//	//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7CON,0));
//	}

//	K7EV_HANDLER(K7SCN07_Stg702M11Current)
//	{
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_A);
//	}

//	K7EV_HANDLER(K7SCN07_Stg702M11CondChange)
//	{
//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000201,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000203,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000205,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000206,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000207,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000208,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000209,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000210,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000211,true);
//	//	K7SCR_EVSETENABLE(K7SCN07_DOOR_000212,true);
//	}

// Ki RF炨Ă
//	K7EV_HANDLER(K7SCN07_Stg702M14Init)
//	{
//		WK7PlayerChangeTaskforScenario00(K7CHRID(K7CON,0));
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg702M14Current)
//	{
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_A);
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg702M14CondChange)
//	{
//	}

////////////////////////////////////////////////////////////////////////////////
//	Xe[WVOR
//	ZeBbNRK
////////////////////////////////////////////////////////////////////////////////
//	K7EV_HANDLER(K7SCN07_Stg703M01Init)
//	{
//		WK7PlayerChangeTaskforScenario00(K7CHRID(K7KED,0));
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg703M01Current)
//	{
//	//	WK7PLAYERCONTROL->ChangeChkPoint();
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_C);
//	}

//	K7EV_HANDLER(K7SCN07_Stg703M01CondChange)
//	{
//	//	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000304)==0 ){
//	//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000304,true);
//	//	}else{
//	//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000304,false);
//	//	}
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000301,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000302,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000303,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000304,true);
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000305,true);
//	}

//	K7EV_HANDLER(K7SCN07_Stg703M02Init)
//	{
//	//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7KED,0));
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg703M02Current)
//	{
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_C);
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg703M02CondChange)
//	{
//	}

//	K7EV_HANDLER(K7SCN07_Stg703M03Init)
//	{
//		K7SCN07_Stg703M03InitKawa();
//	//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7KED,0));
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg703M03Current)
//	{
//		WK7Stage	*pStage;
//	
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_C);
//		do{
//			K7SCN07_Stg703M03CurrentKaw();
//			K7SCR_RETSYS();
//			
//			if( (pStage = WK7Stage::GetCurrentStage())==NULL ){
//				break;
//			}
//			if( pStage->GetID()!=K7STGID(703,3) ){
//				break;
//			}
//			
//		}while( 1 );
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg703M03CondChange)
//	{
//	}

// 4F~Ă
//	K7EV_HANDLER(K7SCN07_Stg703M04Init)
//	{
//		WK7PlayerChangeTaskforScenario00(K7CHRID(K7KED,0));
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg703M04Current)
//	{
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_C);
//	}



////////////////////////////////////////////////////////////////////////////////
//	Xe[WVOS
//	ZeBbNSK
////////////////////////////////////////////////////////////////////////////////
//	K7EV_HANDLER(K7SCN07_Stg704M00Init)
//	{
//		WK7PlayerChangeTaskforScenario00(K7CHRID(K7KVN,0));
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg704M00Current)
//	{
//	//	WK7PLAYERCONTROL->ChangeChkPoint();
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_A);
//	}
//	K7EV_HANDLER(K7SCN07_Stg704M00CondChange)
//	{
//	}

//	K7EV_HANDLER(K7SCN07_Stg704M01Init)
//	{
//		// ngiSeVяjȂ
//		K7SCR_EVNO_SETENABLE(K7EVITEM_MEMO(000401),false);
//	//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7DAN,0));
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg704M01Current)
//	{
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_A);
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg704M01CondChange)
//	{
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000401,true);
//	}

//	K7EV_HANDLER(K7SCN07_Stg704M03Create)
//	{
//		WK7Stage	*pStage = WK7RenderObj::GetStage(K7STGID(704,3));
//		if( pStage==NULL ){
//			return;
//		}
//		pStage->CreateOwnStageMotion( 300);
//		pStage->CreateOwnStageMotion( 301);
//	}
//int		K7SCN07_Stg704M03_HangingSwingID = -1;
//	K7EV_HANDLER(K7SCN07_Stg704M03Init)
//	{
//	//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7DAN,0));
//	}
//	K7EV_HANDLER(K7SCN07_Stg704M03Term)
//	{
//		if( K7SCN07_Stg704M03_HangingSwingID >= 0 ){
//			gpSound->mStopSENo(K7SCN07_Stg704M03_HangingSwingID);
//			K7SCN07_Stg704M03_HangingSwingID = -1;
//		}
//	}
//	K7EV_HANDLER(K7SCN07_Stg704M03Current)
//	{
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_A);
//		WK7Stage	*pStage = WK7RenderObj::GetStage(K7STGID(704,3));
//		if( pStage==NULL ){
//			return;
//		}
//		WK7JObj		*pJObj;
//		pJObj = pStage->GetJObj("KBT_down");
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000402)==TRUE ){
//			if( pJObj!=NULL ) pJObj->Disp(false,true);
//		}else{
//			if( pJObj!=NULL ) pJObj->Hide(false,true);
//			if( (pJObj=pStage->PlayMotion("event_000403",300))!=NULL ){
//				pJObj->SetMotionLoop(true);
//				Vec		pos;
//				pJObj->GetPosition(pos);
//				K7SCN07_Stg704M03_HangingSwingID = gpSound->mPlaySE3D(SFX_SCE0_HANGING_SWING_LOOP,pos);
//			}
//		}
//	}
//	K7EV_HANDLER(K7SCN07_Stg704M03CondChange)
//	{
//		bool	flag;
//		K7SCR_EVSETENABLE(K7SCN07_DOOR_000402,true);
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000402)==TRUE ){
//			if( K7SCR_EVHASITEM(K7EVITEM_KEY(000401))==TRUE ){
//				flag = false;
//			}else{
//				flag = true;
//			}
//		}else{
//			flag = false;
//		}
//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000404,flag);
//		K7SCR_STG_EVOBJ_VISIBLE(K7STGID(704,3),K7SCN07_EVENT_000404,flag);
//	}

//	K7EV_HANDLER(K7SCN07_EV000402)
//	{
//		// Stage704M03
//		WK7Stage	*pStage = WK7RenderObj::GetStage(K7STGID(704,3));
//		WK7JObj		*pJObj;
//		if( pStage==NULL ){
//			return;
//		}
//		
//		Vec		campos = {-63.602f,16.605f,-508.478f};
//		Vec		camtgt = {-56.918f,18.505f,-519.716f};
//		
//		// 퓬鏈
//		KK7BattleMainTask::BattleMainTaskExit();
//		
//		while( battleMain.GetBattleTask()==true ){
//			K7SCR_ENTER_PLAYMODE();
//			WK7PLAYERCONTROL->SetOperateEnable(false);
//			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//			WK7CAM->SetPosition      (campos);
//			WK7CAM->SetTargetPosition(camtgt);
//			K7SCR_RETSYS();
//		}
//		
//		K7SCR_ENTER_PLAYMODE();
//		WK7PLAYERCONTROL->SetOperateEnable(false);
//		WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//		WK7CAM->SetPosition      (campos);
//		WK7CAM->SetTargetPosition(camtgt);
//		K7SCR_RETSYS();
//		
//		while( GameInfo.GetMode()!=WK7GameInfo::PLAY ){
//			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//			WK7CAM->SetPosition      (campos);
//			WK7CAM->SetTargetPosition(camtgt);
//			K7SCR_RETSYS();
//		}
//		
//		WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//		WK7CAM->SetPosition      (campos);
//		WK7CAM->SetTargetPosition(camtgt);
//		
//		K7SCR_TIMEWAIT(2400);
//		
//		if( (pJObj=pStage->PlayMotion("event_000403",301))!=NULL ){
//			pJObj->SetMotionLoop(false);
//		}
//		gpSound->mPlaySE(SFX_SCE0_HANGING_ROPE_CUT);
//		
//		if( K7SCN07_Stg704M03_HangingSwingID >= 0 ){
//			gpSound->mStopSENo(K7SCN07_Stg704M03_HangingSwingID);
//			K7SCN07_Stg704M03_HangingSwingID = -1;
//		}
//		
//		while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){
//			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//			WK7CAM->SetPosition      (campos);
//			WK7CAM->SetTargetPosition(camtgt);
//			K7SCR_RETSYS();
//		}
//		
//		gpSound->mPlaySE(SFX_SCE0_HANGING_FALL);
//		
//		if( (pJObj = pStage->GetJObj("KBT_down"))!=NULL ){
//			pJObj->Disp(false,true);
//		}
//		
//		K7SCR_TIMEWAIT(2400);
//		
//		K7SCR_EVCONDCHANGE();
//		
//		K7SCR_EXIT_PLAYMODE();
//		
//		WK7PLAYERCONTROL->SetOperateEnable(true);
//	}

//	K7EV_HANDLER(K7SCN07_EV000404)
//	{
//		K7SCR_EVSETITEM(K7EVITEM_KEY(000401),true);
//		K7SCR_SET_SCENARIO_FLAG(K7SCN07_EVENT_000404);
//		K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_GETKEY);
//		K7SCR_EVCONDCHANGE();
//	}
////////////////////////////////////////////////////////////////////////////////
//	Xe[WVOT
//  ZeBbNTK
////////////////////////////////////////////////////////////////////////////////
//	K7EV_HANDLER(K7SCN07_Stg705M00Init)
//	{
//		WK7PlayerChangeTaskforScenario00(K7CHRID(K7CYO,0));
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg705M00Current)
//	{
//	//	WK7PLAYERCONTROL->ChangeChkPoint();
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_A);
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg705M00CondChange)
//	{
//	}

K7EV_HANDLER(K7SCN07_Stg705M01Init)
{
//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7CYO,0));
}

K7EV_HANDLER(K7SCN07_Stg705M01Current)
{
	gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
	gpSound->mPlayStreamNo(HPS_TENSHI_A);
}

K7EV_HANDLER(K7SCN07_Stg705M01CondChange)
{
}

//	K7EV_HANDLER(K7SCN07_Stg705M02Init)
//	{
//	//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7CYO,0));
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg705M02Current)
//	{
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_A);
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg705M02CondChange)
//	{
//	}

//	K7EV_HANDLER(K7SCN07_Stg705M03Create)
//	{
//		WK7Stage	*pStage = WK7RenderObj::GetStage(K7STGID(705,3));
//		gpK7SCN07_Stg705M03Info = NULL;
//		if( pStage==NULL ){
//			return;
//		}
//		pStage->CreateOwnStageMotion( 300);
//		while( WK7RenderObj::CreateEffectAnimResource(ANIMID_FIRE)==NULL ){
//			K7SCR_RETSYS();
//		}
//	}

// UF炨Ă邩
//	K7EV_HANDLER(K7SCN07_Stg705M03Init)
//	{
//		int		i;
//		WK7PlayerChangeTaskforScenario00(K7CHRID(K7CYO,0));
//		for(i=0 ; i<4 ; i++){
//			K7SCN07_Stg705M03_LampAlphaSetup(pLampObjName[i]);
//		}
//		K7SCN07_Stg705M03OpenDoor(true);
//	}

//	K7EV_HANDLER(K7SCN07_Stg705M03Term)
//	{
//		while( WK7RenderObj::ReleaseEffectAnimResource(ANIMID_FIRE)==false ){
//			K7SCR_RETSYS();
//		}
//	}

//	K7EV_HANDLER(K7SCN07_Stg705M03Current)
//	{
//		WK7Stage				*pStage = WK7RenderObj::GetStage(K7STGID(705,3));
//		K7SCN07_Stg705M03Info	info;
//		int					i;
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_A);
//		if( pStage==NULL ){
//			return;
//		}
//		gpK7SCN07_Stg705M03Info = &info;
//		Vec		size;
//		while( CheckEasyAnimPackLoadState(ANIMID_FIRE)==FALSE ){
//			K7SCR_RETSYS();
//		}
//		for(i=0 ; i<4 ; i++){
//			info.mpEffect[i] = NULL;
//			if( (info.mpJObj[i] = pStage->GetJObj(pLampObjName[i]))==NULL ){
//				continue;
//			}
//			info.mpJObj[i]->GetPosition(info.pos[i]);
//			info.pos[i].y -= 6.5f;
//			size.x  = 0.8f;
//			size.y  = 1.5f;
//			size.z  = 0.0f;
//			if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000503+i)==TRUE ){
//				info.pos[i].y = 0.0f;
//				WK7RenderObjEffect *pFireEffect;
//				if( (pFireEffect = pStage->CreateEffectModelFire((const char *)NULL,4,&info.pos[i],4.0f))!=NULL ){
//					pFireEffect->SetDamageID(BattleCtrl.CreateDamagePos(info.pos[i],K7SCN07_Stg705M03_LampFireDist,0.0f,KK7BATTLECTRL_DAMAGEPOINT_BIT_ENEMY,1000,1));
//				}
//			}else{
//				if( (info.mpEffect[i] = pStage->CreateEffectEasyAnim(ANIMID_FIRE,info.pos[i],size,0))==NULL ){
//					continue;
//				}
//			}
//		}
//		while( K7SCR_STG_GET_CURRENTID()==K7STGID(705,3) ){
//			K7SCR_RETSYS();
//		}
//		gpK7SCN07_Stg705M03Info = NULL;
//	}

//	K7EV_HANDLER(K7SCN07_EV000503)
//	{
//		// vjk
//		if( gpK7SCN07_Stg705M03Info==NULL ){ return; }
//		gpSound->mPlaySE(SFX_SCE0_LAMP_BREAK);
//		K7SCN07_Stg705M03_LampFallDown(gpK7SCN07_Stg705M03Info->mpEffect[0],gpK7SCN07_Stg705M03Info->pos[0]);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000504)
//	{
//		// vjkQ
//		if( gpK7SCN07_Stg705M03Info==NULL ){ return; }
//		gpSound->mPlaySE(SFX_SCE0_LAMP_BREAK);
//		K7SCN07_Stg705M03_LampFallDown(gpK7SCN07_Stg705M03Info->mpEffect[1],gpK7SCN07_Stg705M03Info->pos[1]);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000505)
//	{
//		// vjQ
//		if( gpK7SCN07_Stg705M03Info==NULL ){ return; }
//		gpSound->mPlaySE(SFX_SCE0_LAMP_BREAK);
//		K7SCN07_Stg705M03_LampFallDown(gpK7SCN07_Stg705M03Info->mpEffect[2],gpK7SCN07_Stg705M03Info->pos[2]);
//	}
//	
//	K7EV_HANDLER(K7SCN07_EV000506)
//	{
//		// vj
//		if( gpK7SCN07_Stg705M03Info==NULL ){ return; }
//		gpSound->mPlaySE(SFX_SCE0_LAMP_BREAK);
//		K7SCN07_Stg705M03_LampFallDown(gpK7SCN07_Stg705M03Info->mpEffect[3],gpK7SCN07_Stg705M03Info->pos[3]);
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg705M03CondChange)
//	{
//	}

//	/*
//		
//		ɂ낤̂񂠂镔
//		
//	*/
//	struct K7SCN07_Stg705M04Candle{
//		WK7RenderObjEffect			*mpEffect;
//		WK7JObj						*mpJObj;
//	};
//	struct K7SCN07_Stg705M04Info{
//		K7SCN07_Stg705M04Candle		mCandle[10];
//		bool						mIsFlickering;
//		Vec							mWind;
//		f32							mWindPower;
//		void Initialize(bool flickering);
//		void ChangeFlickering(bool flickering);
//		void FrameProcess(void);
//	};
//	#define	K7SCN07_STG705M04_WINDPOWER_MAX			(0.1f)
//	#define	K7SCN07_STG705M04_WINDPOWER_MIN			(0.0f)
//	void K7SCN07_Stg705M04Info::Initialize(bool flickering)
//	{
//		int							i;
//		char						objname[64];
//		WK7Stage					*pStage;
//		K7SCN07_Stg705M04Candle		*pCandle;
//		pStage = WK7Stage::GetStage(K7STGID(705,4));
//		mWind.x = 1.0f;
//		mWind.y = 0.0f;
//		mWind.z = 0.0f;
//		if( (mIsFlickering = flickering)==true ){					// N[[쓮Ă
//			gpSound->mPlaySE(SFX_SCE0_COOLER_RUN_LOOP);				// N[[̓쉹
//			mWindPower = K7SCN07_STG705M04_WINDPOWER_MAX;
//		}else{														// N[[쓮ĂȂ
//			mWindPower = 0.0f;
//		}
//		gpSound->mPlaySE(SFX_SCE0_ROUSOKU);							// 낤̔R鉹Jn
//		
//		for(i=0,pCandle=mCandle ; i<10 ; i++,pCandle++){
//			sprintf(objname,"locator_candle%d",i+1);
//			if( pStage!=NULL ){
//				Vec		point;
//				WK7JObj	*pJObj = pStage->GetJObj(objname);
//				pCandle->mpJObj = pJObj;
//				if( pJObj!=NULL ){
//					pJObj->GetWorldPosition(point);
//				}else{
//					point.x = 
//					point.y = 
//					point.z = 0.0f;
//				}
//				if( (pCandle->mpEffect = pStage->CreateEffectModelFire((const char *)NULL,2,&point,1.0f))!=NULL && pCandle->mpEffect->GetEffect()!=NULL ){
//					SetWindModelFireEffect(pCandle->mpEffect->GetEffect(),mWind,mWindPower);
//				}
//			}else{
//				pCandle->mpJObj   = NULL;
//				pCandle->mpEffect = NULL;
//			}
//		}
//		ChangeFlickering(flickering);
//	}
//	void K7SCN07_Stg705M04Info::ChangeFlickering(bool flickering)
//	{
//		mIsFlickering = flickering;
//	}
//	void K7SCN07_Stg705M04Info::FrameProcess(void)
//	{
//		int							i;
//		K7SCN07_Stg705M04Candle		*pCandle;
//		bool						flickering_change = true;
//	//static f32	max = K7SCN07_STG705M04_WINDPOWER_MAX;
//	//static f32	min = K7SCN07_STG705M04_WINDPOWER_MIN;
//		if( mIsFlickering==true ){
//	//		mWindPower += (max - min) * 0.05f;
//	//		if( mWindPower > max ){
//	//			mWindPower = max;
//			mWindPower += (K7SCN07_STG705M04_WINDPOWER_MAX - K7SCN07_STG705M04_WINDPOWER_MIN) * 0.05f;
//			if( mWindPower > K7SCN07_STG705M04_WINDPOWER_MAX ){
//				mWindPower = K7SCN07_STG705M04_WINDPOWER_MAX;
//				flickering_change = false;
//			}
//		}else{
//	//		mWindPower -= (max - min) * 0.05f;
//	//		if( mWindPower < min ){
//	//			mWindPower = min;
//			mWindPower -= (K7SCN07_STG705M04_WINDPOWER_MAX - K7SCN07_STG705M04_WINDPOWER_MIN) * 0.05f;
//			if( mWindPower < K7SCN07_STG705M04_WINDPOWER_MIN ){
//				mWindPower = K7SCN07_STG705M04_WINDPOWER_MIN;
//				flickering_change = false;
//			}
//		}
//		if( flickering_change==false ){
//			return;
//		}
//		for(i=0,pCandle=mCandle ; i<10 ; i++,pCandle++){
//			if( pCandle->mpJObj==NULL || pCandle->mpEffect==NULL || pCandle->mpEffect->GetEffect()==NULL ){
//				continue;
//			}
//			SetWindModelFireEffect(pCandle->mpEffect->GetEffect(),mWind,mWindPower);
//		}
//	}

//	K7EV_HANDLER(K7SCN07_Stg705M04Create)
//	{
//		gpK7SCN07_Stg705M04Info = NULL;
//		while( WK7RenderObj::CreateEffectAnimResource(ANIMID_FIRE)==NULL ){
//			K7SCR_RETSYS();
//		}
//	}
//	K7EV_HANDLER(K7SCN07_Stg705M04Init)
//	{
//	//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7CYO,0));
//	}

//	K7EV_HANDLER(K7SCN07_Stg705M04Term)
//	{
//		while( WK7RenderObj::ReleaseEffectAnimResource(ANIMID_FIRE)==false ){
//			K7SCR_RETSYS();
//		}
//		gpSound->mStopSE(SFX_SCE0_COOLER_RUN_LOOP);				// N[[̓쉹~
//		gpSound->mStopSE(SFX_SCE0_ROUSOKU);						// 낤̔R鉹~
//	}

//	K7EV_HANDLER(K7SCN07_Stg705M04Current)
//	{
//		WK7Stage					*pStage;
//		K7SCN07_Stg705M04Info		info;
//		bool						isflickering;
//		
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_A);
//		gpK7SCN07_Stg705M04Info = &info;
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000501)==TRUE ){
//			isflickering = true;
//		}else{
//			isflickering = false;
//		}
//		while( CheckEasyAnimPackLoadState(ANIMID_FIRE)==FALSE ){
//			K7SCR_RETSYS();
//		}
//		info.Initialize(isflickering);
//		while( 1 ){
//			K7SCR_RETSYS();
//			if( (pStage = WK7Stage::GetCurrentStage())==NULL ){
//				break;
//			}
//			if( pStage->GetID()!=K7STGID(705,4) ){
//				break;
//			}
//			
//	//		if( HSD_PadGetTrigger(1) & HSD_PAD_Y ){
//	//			info.ChangeFlickering(true);
//	//		}
//	//		if( HSD_PadGetTrigger(1) & HSD_PAD_X ){
//	//			info.ChangeFlickering(false);
//	//		}
//			
//			info.FrameProcess();
//			
//		}
//		gpK7SCN07_Stg705M04Info = NULL;
//	}
//	


//	K7EV_HANDLER(K7SCN07_EV000501)
//	{
//		// TeN[[̃XCb`
//		K7SCR_PANEL_SETPANELID(ePanel000501,K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000501));
//		K7SCR_PANEL_START();
//		K7SCR_PANEL_TERMWAIT();
//		switch( K7SCR_PANEL_GETRESULT() ){
//		case	1:
//			K7SCR_SET_SCENARIO_FLAG(K7SCN07_EVFL_000501);
//			if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000501A)==TRUE ){
//				if( gpK7SCN07_Stg705M04Info!=NULL ){
//					gpK7SCN07_Stg705M04Info->ChangeFlickering(true);
//				}
//			}
//			gpSound->mPlaySE(SFX_SCE0_COOLER_RUN_LOOP);				// N[[̓쉹Jn
//			break;
//		case	0:
//			K7SCR_RESET_SCENARIO_FLAG(K7SCN07_EVFL_000501);
//			if( gpK7SCN07_Stg705M04Info!=NULL ){
//				gpK7SCN07_Stg705M04Info->ChangeFlickering(false);
//			}
//			gpSound->mStopSE(SFX_SCE0_COOLER_RUN_LOOP);				// N[[̓쉹~
//			break;
//		default:
//			break;
//		}
//		K7SCR_RETSYS();
//		K7SCR_PANEL_EXIT();
//		
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000501 )==TRUE &&
//		    K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000501A)!=TRUE ){
//			
//			K7SCR_SET_SCENARIO_FLAG(K7SCN07_EVFL_000501A);
//			
//	static int	eneid[] = {
//		ENENO_7_705_10,
//		ENENO_7_705_12,
//		ENENO_7_705_13,
//		ENENO_7_705_14,
//		ENENO_7_705_15,
//		ENENO_7_705_16,
//		ENENO_7_705_17,
//		ENENO_7_705_18,
//		-1,
//	};
//			
//			Vec			campos = { -48.542f , 20.279f , -208.404f };
//			Vec			camtgt = { -23.706f , 13.303f , -223.990f };
//			
//			while( GameInfo.GetMode()==WK7GameInfo::PANELMODE ){
//				WK7CAM->SetMode          (WK7Cam::WK7CAM_FREE_TARGET);
//				WK7CAM->SetPosition      (campos);
//				WK7CAM->SetTargetPosition(camtgt);
//				K7SCR_RETSYS();
//			}
//			
//			if( gpK7SCN07_Stg705M04Info!=NULL ){
//				gpK7SCN07_Stg705M04Info->ChangeFlickering(true);
//			}
//			
//			WK7PLAYERCONTROL->SetOperateEnable(false);
//			WK7CAM->SetMode          (WK7Cam::WK7CAM_FREE_TARGET);
//			WK7CAM->SetPosition      (campos);
//			WK7CAM->SetTargetPosition(camtgt);
//			
//			K7SCR_TIMEWAIT(2 * 4800);
//			
//			WK7Npc		*pNpc;
//			Vec			pos = { 0.0f,0.0f,0.0f };
//			int			i;
//			for(i=0 ; eneid[i]>=0 ; i++){
//				if( (pNpc = WK7Npc::Find((u32)eneid[i]))==NULL ){
//					continue;
//				}
//				pNpc->SetNpcDamageEvent(pos,1000,1);
//			}
//			
//			K7SCR_TIMEWAIT(6 * 4800);
//			
//			WK7PLAYERCONTROL->SetOperateEnable(true);
//			WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
//			
//		}
//		
//		K7SCR_EVCONDCHANGE();
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg705M04CondChange)
//	{
//	}

////////////////////////////////////////////////////////////////////////////////
//	Xe[WVOU
//  ZeBbNUK
////////////////////////////////////////////////////////////////////////////////
//	struct Stg706M00DoorInfo{
//		const char			*mpName;
//		int					mFlag;
//	};
//	static	Stg706M00DoorInfo	doorInfo[] = {
//		{ "door_000601"  , K7SCN07_DRFL_000601 },
//		{ "door_000602"  , K7SCN07_DRFL_000602 },
//		{ NULL           , -1                  },
//	};
//	void K7SCN07_Stg706M00_BrokenObj(const char *pobjname);
//	void K7SCN07_Stg706M00_BrokenObj(const char *pobjname)
//	{
//		WK7Stage	*pStage = WK7RenderObj::GetStage(K7STGID(706,0));
//		if( pStage==NULL ){
//			return;
//		}
//		char		objname[32];
//		sprintf(objname,"broken_%s",pobjname);
//		K7SCN07_BrokenObj(K7STGID(706,0),objname);
//		
//		WK7JObj		*pJObj;
//		Vec			pos;
//		if( (pJObj=pStage->GetJObj(pobjname))==NULL ){
//			return;
//		}
//		pJObj->GetPosition(&pos);
//		pos.x -= 5.0f;
//		KK7DoorSmokeEffect(pos);
//	}

//	K7EV_HANDLER(K7SCN07_EV000601)
//	{
//		WK7Stage	*pStage = WK7Stage::GetStage(K7STGID(706,0));
//		if( pStage==NULL ){
//			return;
//		}
//		WK7Npc		*pNpc = (WK7Npc *)K7EV_GETEVENTPARAM(0);
//		if( pNpc->GetType()!=WK7Npc::TYPE_ENEMY ){
//			return;
//		}
//		Vec					objpos;
//		Vec					enmpos;
//		WK7JObj				*pJObj;
//		Stg706M00DoorInfo	*pDoorInfo;
//		
//		pNpc->GetPosition(enmpos);
//		
//		for(pDoorInfo=doorInfo ; pDoorInfo->mpName!=NULL ; pDoorInfo++){
//			
//			if( K7SCR_GET_SCENARIO_FLAG(pDoorInfo->mFlag)==TRUE ){
//				// łɔj
//				continue;
//			}
//			
//			if( (pJObj = pStage->GetJObj(pDoorInfo->mpName))==NULL ){
//				continue;
//			}
//			
//			pJObj->GetWorldPosition(objpos);
//			
//			f32		dist = VECDistance(&objpos,&enmpos);
//			
//			if( dist > 30.0f ){
//				continue;
//			}
//			
//			K7SCN07_Stg706M00_BrokenObj(pDoorInfo->mpName);
//			
//			pJObj->Hide(false,true);
//			K7SCR_SET_SCENARIO_FLAG(pDoorInfo->mFlag);
//			
//		}
//		
//	}

//	K7EV_HANDLER(K7SCN07_Stg706M00Create)
//	{
//		WK7Stage	*pStage = WK7Stage::GetStage(K7STGID(706,0));
//		if( pStage==NULL ){
//			return;
//		}
//		while( WK7RenderObj::CreateEffectBillResource(BILLEFF_SPRINKLER)==NULL ){
//			K7SCR_RETSYS();
//		}
//	}

//static	Vec		spl_point = { 48.0f , 30.0f , -250.0f };
static	Vec		spl_point[5] = {
	{  43.2f , 28.5f , -239.5f },
	{ -45.0f , 28.5f , -273.5f },
	{ -45.0f , 28.5f , -208.2f },
	{ 132.0f , 28.5f , -273.5f },
	{ 132.0f , 28.5f , -208.2f },
};
//	K7EV_HANDLER(K7SCN07_EV000604)
//	{
//		// XvN[
//		WK7Stage	*pStage = WK7RenderObj::GetStage(K7STGID(706,0));
//		if( pStage!=NULL ){
//			int		i;
//			for(i=0 ; i<5 ; i++){
//				while( pStage->CreateBillBoardEffect(BILLEFF_SPRINKLER,spl_point[i],0.0f)==NULL ){
//					K7SCR_RETSYS();
//				}
//			}
//		}
//		K7SCR_SET_SCENARIO_FLAG(K7SCN07_EVFL_000604);
//		K7SCR_STGC_MESSAGE_B(K7SCN07_STG706M00_SPRINKLER);
//		K7SCR_EVCONDCHANGE();
//	}

//	K7EV_HANDLER(K7SCN07_Stg706M00Init)
//	{
//		WK7Stage	*pStage = WK7Stage::GetStage(K7STGID(706,0));
//		WK7HitObj	*pHitObj;
//		WK7PlayerChangeTaskforScenario00(K7CHRID(K7MSK,0));
//		WK7HitObj::InitFind();
//		if( (pHitObj = WK7HitObj::FindEventNo(K7EVENTDOOR(000603)))!=NULL ){
//			WK7HitObjJObj	*pHitObjJObj = (WK7HitObjJObj *)pHitObj;
//			WK7JObj			*pJObj       = pHitObjJObj->GetJObj();
//			WK7PathNurbs	*pPath       = pHitObjJObj->GetClosePath();
//			if( pJObj!=NULL ){
//				if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_DRFL_000603)==TRUE ){
//					pJObj->Hide(false,true);
//				}else{
//					pJObj->Disp(false,true);
//				}
//			}
//			if( pPath!=NULL ){
//				if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_DRFL_000603)==TRUE ){
//					pPath->SetEnable  (true);
//					pPath->SetEnableEx(true);
//				}else{
//					pPath->SetEnable  (false);
//					pPath->SetEnableEx(false);
//				}
//			}
//		}
//		if( pStage!=NULL ){
//			WK7JObj				*pJObj;
//			Stg706M00DoorInfo	*pDoorInfo;
//			for(pDoorInfo=doorInfo ; pDoorInfo->mpName!=NULL ; pDoorInfo++){
//				if( (pJObj=pStage->GetJObj(pDoorInfo->mpName))==NULL ){
//					continue;
//				}
//				if( K7SCR_GET_SCENARIO_FLAG(pDoorInfo->mFlag)==TRUE ){
//					pJObj->Hide(false,true);
//				}else{
//					pJObj->Disp(false,true);
//				}
//			}
//			while( CheckBillboardEffectIDState(BILLEFF_SPRINKLER)==FALSE ){
//				K7SCR_RETSYS();
//			}
//			// XvN[
//			if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000604)==TRUE ){
//				int		i;
//				for(i=0 ; i<5 ; i++){
//					while( pStage->CreateBillBoardEffect(BILLEFF_SPRINKLER,spl_point[i],0.0f)==NULL ){
//						K7SCR_RETSYS();
//					}
//				}
//			}
//		}
//	}

//	K7EV_HANDLER(K7SCN07_Stg706M00Term)
//	{
//		WK7Stage	*pStage = WK7Stage::GetStage(K7STGID(706,0));
//		if( pStage!=NULL ){
//			pStage->ReleaseEffectBillBoard(BILLEFF_SPRINKLER);
//		}
//		while( WK7RenderObj::ReleaseEffectBillResource(BILLEFF_SPRINKLER)==NULL ){
//			K7SCR_RETSYS();
//		}
//	}

//	K7EV_HANDLER(K7SCN07_Stg706M00Current)
//	{
//	//	WK7PLAYERCONTROL->ChangeChkPoint();
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_B);
//		
//		while( K7SCR_STG_GET_CURRENTID()==K7STGID(706,0) ){
//			
//			// |bv̓G
//			WK7Npc *pNpc;
//			
//			pNpc = WK7Npc::Find(ENENO_7_706_01);
//			if ( NULL != pNpc ){
//				if ( true == pNpc->AiModeSet_TestPop() ){
//					pNpc->AiModeSet_PopGo();				// |bvwnm
//				}
//			}
//			
//			K7SCR_RETSYS();
//		}
//	}

K7EV_HANDLER(K7SCN07_Stg706M00CondChange)
{
//	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000603)==TRUE ){
//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000603,false);
//	}else{
//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000603,true);
//	}
	K7SCR_EVSETENABLE(K7SCN07_EVENT_000606,true);
//	K7SCR_EVSETENABLE(K7SCN07_DOOR_000601,true);
//	K7SCR_EVSETENABLE(K7SCN07_DOOR_000602,true);
}


//	K7EV_HANDLER(K7SCN07_Stg706M00MskSpAtk)
//	{
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000604)==TRUE ){
//			return;
//		}
//		
//		WK7Stage		*pStage;
//		Vec				pos;
//	static	Vec			center = { 48.0f , 0.0f , -250.0f };
//		
//		K7SCR_TIMEWAIT(5 * 4800);
//		
//		while( 1 ){
//			
//			if( (pStage = WK7Stage::GetCurrentStage())==NULL ){
//				break;
//			}
//			
//			if( pStage->GetID()!=K7STGID(706,0) ){
//				break;
//			}
//			
//			if( WK7PLAYERCONTROL->SpAtkTest()==false ){
//				break;
//			}
//			
//			WK7PLAYERCONTROL->GetPosition(&pos);
//			
//			f32	dist = VECDistance(&center,&pos);
//			
//			if( dist < 30.0f ){
//				// XvN[
//				K7SCR_CALLIM_EVENT(K7SCN07_EVENT_000604);
//				break;
//			}
//			
//			K7SCR_RETSYS();
//		}
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg706M01Init)
//	{
//	//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7MSK,0));
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg706M01Current)
//	{
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_B);
//	}

//	K7EV_HANDLER(K7SCN07_Stg706M01CondChange)
//	{
//	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_000602)==TRUE ){
//		K7SCR_STG_EVOBJ_VISIBLE(K7STGID(706,1),K7SCN07_EVENT_000602,false);
//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000602,false);
//	}else{
//		K7SCR_STG_EVOBJ_VISIBLE(K7STGID(706,1),K7SCN07_EVENT_000602,true);
//		K7SCR_EVSETENABLE(K7SCN07_EVENT_000602,true);
//	}
//	}

////////////////////////////////////////////////////////////////////////////////
//	Xe[WVOV
//  ZeBbNVK
////////////////////////////////////////////////////////////////////////////////
//	K7EV_HANDLER(K7SCN07_Stg707M00Init)
//	{
//	//	WK7PlayerChangeTaskforScenario00(K7CHRID(K7CYO,0));
//	}
//	
//	K7EV_HANDLER(K7SCN07_Stg707M00Current)
//	{
//		gpSound->mSetDspRateAll(K7SCN07_REVERB_DEF);
//		gpSound->mPlayStreamNo(HPS_TENSHI_E);
//	}

#if 0
extern	void Stg707M01Init(ghmGcTask *pTask);
K7EV_HANDLER(K7SCN07_Stg707M01Init)
{
	Stg707M01Init(pTask);
//	GET_WK7MAINTASK()->DeleteTerminate();
}
#else
K7EV_HANDLER(K7SCN07_Stg707M01Init)
{
}

K7EV_HANDLER(K7SCN07_Stg707M01Current)
{
}
#endif

////////////////////////////////////////////////////////////////////////////////
// nhe[u
////////////////////////////////////////////////////////////////////////////////


#define	K7EV_TBL_PART
#include ".\K7Scn07.h"


#include "..\REL\REL_Setup.h"



#define	K7EV_VAR_EDIT
#include "..\Scn\K7Scn07.h"
#undef	K7EV_VAR_EDIT


#include "..\sato\SK7IMenuMap.h"
#define	__SK7MAPCREATE07__
#include "..\sato\map\SK7StageMap07.h" 

	
#include "..\Stage\K7Stage.h"
#define	__K7STAGECREATE_INCLUDE__
#include	".\info\K7StageCreate.h"
WK7Stage* WK7Stage::CreateStageScn07(u32 id,int prio)
{
	K7STG_CREATE_DECL_START()
#include	".\info\K7StageCreate.h"
	K7STG_CREATE_DECL_END()
	return NULL;
}

#include "..\sato\SK7PanelBase.h"
#define	__SK7PANELCREATE_INCLUDE__
#include "..\sato\SK7PanelCreate.h"
SK7PanelBase* SK7PanelBase::CreatePanel07(u32 evno,s32 now, s32 now2 )
{
	switch( evno ){
#include "..\sato\SK7PanelCreate.h"
	}
	return NULL;
}

#define	__ENMCREATE_INCLUDE__
#include	"..\Wat\EnmCreate.h"
WK7Npc* WK7Npc::CreateScn07(u32 type,u32 suffix)
{
	ENM_CREATE_DECL_START()
#include	"..\Wat\EnmCreate.h"
	ENM_CREATE_DECL_END()
	return NULL;
}

static	WK7StageBpCamInfo	K7ScnBpCamInfo[] = {
#include	"..\Stage\Info\K7StageBpCamInfo.h"
WK7STGBPCAMINF_END()
static	WK7StageDoorInfo	K7ScnDoorInfo[] = {
#include	"..\Stage\Info\K7StageDoorInfo.h"
WK7STGDRINF_END()
static	WK7StagePlaceInfo	K7ScnPlaceInfo[] = {
#include	"..\Stage\Info\K7StagePlaceInfo.h"
WK7STGPLINF_END()
static	WK7StageTamaInfo	K7ScnTamaInfo[] = {
#include	"..\Stage\Info\K7StageTamaInfo.h"
WK7STGTAMAINF_END()
static	WK7StageSoundInfo	K7ScnSoundInfo[] = {
#include	"..\Stage\Info\K7StageSoundInfo.h"
WK7STGSOUNDINF_END()
static	WK7StageSpCond		K7ScnSpCond[] = {
#include	"..\Stage\Info\K7StageSpCond.h"
WK7STGSPCOND_END()

RELMODULE_EXPORT void _prolog(void)
{
	ModuleConstructors();
	
	SK7PanelBase::SetCreatePanelFunc(SK7PanelBase::CreatePanel07);
	SK7IMenuMap::SetScnIconTable( tblScenarioIcon07 );
	SK7IMenuMap::SetItmIconTable( tblItemIcon07 );
	WK7Stage::SetCreateStageFunc  (WK7Stage::CreateStageScn07);
	WK7Stage::SetScenarioDoorInfo (K7ScnDoorInfo );
	WK7Stage::SetScenarioPlaceInfo(K7ScnPlaceInfo);
	WK7Stage::SetScenarioTamaInfo (K7ScnTamaInfo );
	WK7Stage::SetScenarioSoundInfo(K7ScnSoundInfo);
	WK7Stage::SetScenarioSpCond   (K7ScnSpCond   );
	WK7Stage::SetScenarioBpCamInfo(K7ScnBpCamInfo);
	WK7Npc::SetNpcCreateFunc(WK7Npc::CreateScn07);
	WK7EVENTCONTROLLER->SetScenarioEventHandler(K7EV_SCN_HANDLER_TABLE(K7SCN07));
	WK7EVENTCONTROLLER->SetScenarioEventDesc   (K7EV_SCN_DESC_TABLE   (K7SCN07));
	WK7Event::SetIDTable  (K7EV_SCN_IDTABLE  (K7SCN07));
	WK7EventItem::SetTable(K7EV_SCN_ITEMTABLE(K7SCN07));
	WK7GAMEINFO_SETFLAGNAME(K7EV_SCN_FLAGNAME(K7SCN07));
	WK7GAMEINFO_SETVARTYPE(K7EV_SCN_VARTYPENAMEBODY(K7SCN07));
	if( GameInfo.GetContinue()==false ){
#define	K7EV_VAR_INIT
#include "..\Scn\K7Scn07.h"
#undef	K7EV_VAR_INIT
	}
#define	K7EV_VAR_DEBUG
#include "..\Scn\K7Scn07.h"
#undef	K7EV_VAR_DEBUG
}

/*
 * _epilog is called before the the module is unlinked
 * This executes the static destructors for the module.
 */

RELMODULE_EXPORT void _epilog(void)
{
	ModuleDestructors();
	
	WK7Stage::SetCreateStageFunc(NULL);
	WK7Stage::SetScenarioBpCamInfo(NULL);
	WK7Stage::SetScenarioDoorInfo (NULL);
	WK7Stage::SetScenarioPlaceInfo(NULL);
	WK7Stage::SetScenarioTamaInfo (NULL);
	WK7Stage::SetScenarioSoundInfo(NULL);
	WK7Stage::SetScenarioSpCond   (NULL);
	WK7Npc::SetNpcCreateFunc(NULL);
	WK7EVENTCONTROLLER->SetScenarioEventHandler(NULL);
	WK7EVENTCONTROLLER->SetScenarioEventDesc   (NULL);
	WK7Event::SetIDTable  (NULL);
	WK7EventItem::SetTable(NULL);
	WK7GAMEINFO_SETFLAGNAME(NULL);
	WK7GAMEINFO_SETVARTYPE(NULL);
}

/*
 * _unresolved is called if a module attempts
 * to call a symbol that is not present in another module.
 * If _unresolved is not specified, the branch to the symbol
 * will instead branch back to itself.
 */

RELMODULE_EXPORT void _unresolved(void)
{
	u32		i;
	u32*	p;
	
	OSReport("\nError: Unlinked function called in module %s.\n", __FILE__);
	OSReport("Address:      Back Chain    LR Save\n");
	for (i = 0, p = (u32*) OSGetStackPointer(); // get current sp
	     p && (u32) p != 0xffffffff && i++ < 16;
	     p = (u32*) *p)                         // get caller sp
	{
		OSReport("0x%08x:   0x%08x    0x%08x\n", p, p[0], p[1]);
	}
	OSReport("\n");
}

