////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage771M01
//
// K7Stage771M01.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/26/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE771M01_H__
#define	__K7STAGE771M01_H__

#include "..\..\..\Wat\WK7Stage.h"
#include "..\..\K7Stage.h"

class K7Stage771M01 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage771M01();
	K7Stage771M01(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	bool	mAmbPlaySE;
public:
	virtual ~K7Stage771M01();
	
	virtual bool CreateCallBack(void);
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool SpAbilityCallBack (WK7SpAbilityInfo &);
	virtual bool BpLeaveCallBack   (WK7BpInfo        &);
	virtual bool SetCurrentCallBack(void);		// JgXe[Wɐݒ莞
};

#ifdef __K7STAGE771M01_CPP__


enum K7STAGE771M01_ONESHOTCAM{
	MOVE_DOOR,
	TRAVIS,
	KIKAZARU,
	CAM771M01_HS_PRESEN_START,
	CAM771M01_HS_PRESEN_END,
};

K7StageEventOneShotCamera K7Stage771M01_Camera[] = {
	{{140.653f, 14.696f, -272.551f},{122.534f, 13.829f, -270.670f}},
	{{117.660f, 9.745f, -353.169f},{131.385f, 8.113f, -333.826f}},
	{{134.398f, 24.745f, -419.981f},{135.831f, 10.152f, -401.268f}},
	{{-23.484f, 11.236f, -102.588f},{-23.952f, 11.738f, -78.824f}},		// Jn
	{{-20.018f, 11.236f, -357.669f},{-20.485f, 11.738f, -333.905f}},	// END
};

#endif

#endif	//__K7STAGE771M01_H__

