////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage771M03
//
// K7Stage771M03.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE771M03_CPP__

#include "..\..\Scn\K7Scn07.h"
#include ".\K7Stage771M03.h"
#include "..\..\Wat\WK7Zan.h"
#include "..\..\Wat\WK7Item.h"
//#include "..\..\Wat\WK7Tutorial.h"

//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage771M03::K7Stage771M03(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage771M03_Camera);
//	GameInfo.SetScenarioFlow( K7SCNF_CEL );
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage771M03::~K7Stage771M03()
{
}

//------------------------------------------------------------------------------
//iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
//------------------------------------------------------------------------------
bool
K7Stage771M03::InitializeCallBack( void )
{
	//IԂɂ
	SetSelectObjFlag( K7STGID(771,0), "branchF", 0, true );
	SetPassPathFlag ( K7STGID(771,0), "branchF", 2, true );
	
	return( true );
}

//------------------------------------------------------------------------------
//LCxg
//------------------------------------------------------------------------------
bool
K7Stage771M03::PlayEventCallBack( WK7PlayEventInfo &info )
{
#if	1
	WK7Play	*pPlay;
	u32		charaid = K7CHRID(K7DAN,0);
	switch( info.mEventNo ){
	case	K7EVENTPLAY(00020101):
		if( WK7Play::HasPlayed(info.mEventNo)==TRUE ){
			return false;
		}
		
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
			GHMGCTASK_RETSYS();
		}
		
		s16		storedBgmID = gpSound->mGetPlayStreamNo();
		
		WK7PLAYERCONTROL->Reset();
		WK7PLAYERCONTROL->ReleaseAll();
		WK7PLAYERCONTROL->SetOperateEnable(false);
		retsys();
		
		while( (pPlay = WK7Play::Create(K7EVENTPLAY(00020101)))==NULL ){
			GHMGCTASK_RETSYS();
		}
		
		pPlay->Prepare();
		
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
		
		WK7Play::StorePlayTB();
		
		while( pPlay->GetState()!=WK7Play::PREPARED ){
			GHMGCTASK_RETSYS();
		}
		
		pPlay->Start();
		GHMGCTASK_RETSYS();
		
		while( gpNoise->mSandRelease()==false ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}
		
		while( pPlay->GetState()!=WK7Play::PLAYED ){
			GHMGCTASK_RETSYS();
		}
		
		WK7Play::SetPlayed(info.mEventNo,true);
		
		//L`FWLImCY
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,SFX_SCE0_MAP_CHANGE_DOOR_BIG_OPEN)==false ){
			GHMGCTASK_RETSYS();
		}
		
		pPlay->SetVisibleAll(false);
		GHMGCTASK_RETSYS();
		GHMGCTASK_RETSYS();
		GHM_SAFE_DELETE(pPlay);
		
		//_ƃg}tBA
		u32		playno;
		playno = K7EVENTPLAY(00020103);
		if( WK7Play::HasPlayed(playno)==false ){
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			SetRenderFlag(false);
			//771M03Xe[W
			WK7Stage::DeleteStage(this);
			
			K7SCR_PLAY_PREPARE(playno);
			while( (pPlay = WK7Play::Find(playno))==NULL ){
				K7SCR_RETSYS();
			}
			while( pPlay->GetState()!=WK7Play::PREPARED ){
				K7SCR_RETSYS();
			}
			while( gpNoise->mSandRelease(NULL,NULL,NULL,NULL,SFX_SCE0_MAP_CHANGE_DOOR_BIG_CLOSE)==false ){
				K7SCR_RETSYS();
			}
			pPlay->Start();
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
			while( pPlay->GetState()!=WK7Play::PLAYED ){
				K7SCR_RETSYS();
			}
			K7SCR_NOISE_REQUEST();
			pPlay->ReleaseRequest();
			while( WK7Play::GetTop()!=NULL ){
				K7SCR_RETSYS();
			}
			K7SCR_RETSYS();
			
			//Xe[Wǂݍ
			K7SCR_STG_CREATE_B( K7STGID(771,0) );
			//LN^ǂݍ
			WK7PLAYERCONTROL->CreateModel(K7CHRID(K7DAN, 0));
			WK7PLAYERCONTROL->CreatePackMotion(K7CHRID(K7DAN, 0));
			while( true == WK7PLAYERCONTROL->IsLoading() ){
				K7SCR_RETSYS();
			}
			WK7PLAYERCONTROL->SetVisible(true);
			WK7PLAYERCONTROL->ChangeCallback();
			
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			
			{
				u32	stgid   = K7STGID( 771, 0 );
				//Xe[W؂ւ
//				K7SCR_NOISE_REQUEST();
				WK7Play::RestorePlayTB();
				WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
				//Xe[W\
				K7SCR_STG_VISIBLE( stgid, true );
				K7SCR_STG_SET_CURRENT( stgid );
				SetCurrentPath(	GetPathNurbsAll("curve15"),
								0.900f,
								0,									// 0:forward 1:back
								WK7PATHINFO_INITDIR_TGTDIR );		// : wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
				Vec	initpos;
				WK7PLAYERPATHCONTROL->GetCurrentPosition(&initpos);
				WK7CAMPATHFOLLOWINFO->SetStageStartMode              (true);
				WK7CAMPATHFOLLOWINFO->SetStageStartCamPosition       ((Vec){-12.502f, 2.341f, 66.804f});
				WK7CAMPATHFOLLOWINFO->SetStageStartCamTargetPosition ((Vec){-8.406f, 7.129f, 76.275f});
				WK7CAMPATHFOLLOWINFO->SetStageStartTargetInitPosition(initpos);
				WK7CAMPATHFOLLOWINFO->SetStageStartDist( 3.0f );
				while( gpNoise->mGetSandFrameProc() != eSandExec ){K7SCR_RETSYS();}
				while( gpNoise->mSandRelease("Lobby","","","ް",NOISE_SE_NORMAL) == false ){K7SCR_RETSYS();}
				while( gpNoise->mGetSandFrameProc() != eSandStandby ){K7SCR_RETSYS();}
				//SandRelease();
			}
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
		}
		return false;
	default:
		break;
	}
	return true;
#else
	WK7Play	*pPlay;
	u32		charaid = K7CHRID(K7DAN,0);
	switch( info.mEventNo ){
	case	K7EVENTPLAY(00020101):
		if( WK7Play::HasPlayed(info.mEventNo)==TRUE ){
			return false;
		}
		
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
			GHMGCTASK_RETSYS();
		}
		
		s16		storedBgmID = gpSound->mGetPlayStreamNo();
		
		WK7PLAYERCONTROL->Reset();
		WK7PLAYERCONTROL->ReleaseAll();
		WK7PLAYERCONTROL->SetOperateEnable(false);
		retsys();
		
		while( (pPlay = WK7Play::Create("00020101"))==NULL ){
			GHMGCTASK_RETSYS();
		}
		
		pPlay->Prepare();
		
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
		
		WK7Play::StorePlayTB();
		
		while( pPlay->GetState()!=WK7Play::PREPARED ){
			GHMGCTASK_RETSYS();
		}
		
		pPlay->Start();
		GHMGCTASK_RETSYS();
		
		while( gpNoise->mSandRelease()==false ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}
		
		while( pPlay->GetState()!=WK7Play::PLAYED ){
			GHMGCTASK_RETSYS();
		}
		
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
			GHMGCTASK_RETSYS();
		}
		
		pPlay->SetVisibleAll(false);
		GHMGCTASK_RETSYS();
		GHMGCTASK_RETSYS();
		GHM_SAFE_DELETE(pPlay);
		
		WK7Play::RestorePlayTB();
		
		WK7PLAYERCONTROL->CreateModel(charaid);
		WK7PLAYERCONTROL->CreatePackMotion(charaid);
		while( true == WK7PLAYERCONTROL->IsLoading() ){
			retsys();
		}
		
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
		
		WK7PLAYERCONTROL->SetVisible(true);
		
		WK7PLAYERPATHCONTROL->CameraRenew();
		WK7PLAYERCONTROL->ChangeCallback();
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		
		//_̍Wړ
		K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("play_00020101","curve18",1.0f,WK7PATHINFO_INITDIR_TGTDIR);
//		K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("branchF_d10_771M00branchF","curve18",0.0f,WK7PATHINFO_INITDIR_TGTDIR);
//		K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("play_00020101","curve15",0.5f,WK7PATHINFO_INITDIR_TGTDIR_REV);
//		K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("play_00020101","Entranceway_camera1_fix",0.75f,WK7PATHINFO_INITDIR_TGTDIR_REV);
		gpSound->mPlayStreamNo(storedBgmID);
		
		while( gpNoise->mSandRelease()==false ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}
		
		WK7Play::SetPlayed(info.mEventNo,true);
		
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		
		return false;
	default:
		break;
	}
	return true;
#endif
}

bool K7Stage771M03::DoorEventCallBack(WK7DoorEventInfo &info)
{
#pragma	unused(info)
	return( true );
#if 0
	u32		playno;
	switch( info.mEventNo ){
	case	K7EVENTDOOR(007101):			// ŏ̔ g}tBAƑ
		playno = K7EVENTPLAY(00020103);
		if( WK7Play::HasPlayed(playno)==false ){
			WK7Play		*pPlay;
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue, SFX_SCE0_MAP_CHANGE_DOOR_BIG_OPEN);
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			SetRenderFlag(false);
			WK7PLAYERCONTROL->SetVisible(false);
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			WK7PLAYERCONTROL->Reset();
			WK7PLAYERCONTROL->ReleaseAll();
			WK7PLAYERCONTROL->SetOperateEnable(false);
			WK7Stage::DeleteStage(this);
			
			WK7Play::StorePlayTB();
			K7SCR_PLAY_PREPARE(playno);
			while( (pPlay = WK7Play::Find(playno))==NULL ){
				K7SCR_RETSYS();
			}
			while( pPlay->GetState()!=WK7Play::PREPARED ){
				K7SCR_RETSYS();
			}
			while( gpNoise->mSandRelease()==false ){
				K7SCR_RETSYS();
			}
			pPlay->Start();
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
			while( pPlay->GetState()!=WK7Play::PLAYED ){
				K7SCR_RETSYS();
			}
			gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NONE);
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			pPlay->ReleaseRequest();
			while( WK7Play::GetTop()!=NULL ){
				K7SCR_RETSYS();
			}
			K7SCR_RETSYS();
			K7SCR_STG_CREATE_B(info.mNextStageID);
			WK7PLAYERCONTROL->CreateModel(K7CHRID(K7DAN, 0));
			WK7PLAYERCONTROL->CreatePackMotion(K7CHRID(K7DAN, 0));
			while( true == WK7PLAYERCONTROL->IsLoading() ){
				K7SCR_RETSYS();
			}
			WK7PLAYERCONTROL->SetVisible(true);
			WK7PLAYERCONTROL->ChangeCallback();
			
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
		#if	0
			WK7StagePlaceInfo		*pPlaceInfo;
			K7SCR_STG_SET_CURRENT(info.mNextStageID);
			K7SCR_STG_SET_CURRENT_PATH_POINT(info.mNextBpName);
			K7SCR_STG_VISIBLE(info.mNextStageID,true);
			WK7CAMPATHFOLLOWINFO->SetStageStartMode(false);
			WK7CAM->SetBranchPointMode(false);
			WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
			pPlaceInfo = GetPlaceInfo(info.mNextStageID,info.mNextBpName);
			SetCameraStartPosition(pPlaceInfo);
			SandRelease(pPlaceInfo);
			WK7Play::RestorePlayTB();
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
		#else
			{
				u32	stgid   = K7STGID( 771, 0 );
				//Xe[W؂ւ
				K7SCR_NOISE_REQUEST();
				WK7Play::RestorePlayTB();
				WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
				//Xe[Wǂݍ
//				K7SCR_STG_CREATE_B( stgid );
				K7SCR_STG_VISIBLE( stgid, true );
				K7SCR_STG_SET_CURRENT( stgid );
				SetCurrentPath(	GetPathNurbsAll("curve15"),
								0.900f,
								0,									// 0:forward 1:back
								WK7PATHINFO_INITDIR_TGTDIR );		// : wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
				Vec	initpos;
				WK7PLAYERPATHCONTROL->GetCurrentPosition(&initpos);
				WK7CAMPATHFOLLOWINFO->SetStageStartMode              (true);
				WK7CAMPATHFOLLOWINFO->SetStageStartCamPosition       ((Vec){-11.200f, 15.586f, 62.248f});
				WK7CAMPATHFOLLOWINFO->SetStageStartCamTargetPosition ((Vec){-9.266f, 10.077f, 85.656f});
				WK7CAMPATHFOLLOWINFO->SetStageStartTargetInitPosition(initpos);
				WK7CAMPATHFOLLOWINFO->SetStageStartDist( 3.0f );
				SandRelease();
			}
		#endif
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			
			return false;
		}
		break;
	default:
		break;
	}
	return true;
#endif
}

bool K7Stage771M03::CreateCallBack(void)
{
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_TUTO)==TRUE ){
		return true;
	}
//	CreateOwnChara(K7CHRID(K7ZA2,0));													// CU
//	WK7RenderObj::CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_CHR,K7MOTID(K7ZA2,20));		// ҋ@
//	WK7RenderObj::CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_CHR,K7MOTID(K7ZA2,30));		// o
//	WK7RenderObj::CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_CHR,K7MOTID(K7ZA2,40));		// ޏo
	return true;
}

bool K7Stage771M03::SetCurrentCallBack(void)
{
	WK7StagePlaceInfo		*pPlaceInfo;
	
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_TUTO)==TRUE ){
		if( GetPrevStageID()==K7STGID(771,4) ){
			SetManualBranch(true);
			while( WK7Stage::IsChanging()==true ){
				K7SCR_RETSYS();
			}
			pPlaceInfo = GetPlaceInfo(WK7PLAYERPATHCONTROL->GetCurrentPathName());
			SetCameraStartPosition(pPlaceInfo);
			WK7Stage::SetRenderStage(true);
			WK7Chara::SetRenderChara(true);
			WK7Item::SetRenderItem  (true);
			while( SandRelease(pPlaceInfo)==false ){
				K7SCR_RETSYS();
			}
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
			SetManualBranch(false);
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			return true;
		}
		return true;
	}
	
#if 0
	SetManualBranch(true);
	
	while( WK7Stage::IsChanging()==true ){
		K7SCR_RETSYS();
	}
	
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	WK7Tutorial::Initialize();
	
	WK7Tutorial	*pTutorial = WK7Tutorial::GetInstance();
	if( pTutorial!=NULL ){
		while( pTutorial->IsLoading()==true ){
			K7SCR_RETSYS();
		}
		pTutorial->SetRender(true);
	}
	
	K7SCR_SET_SCENARIO_FLAG(K7SCN07_TUTO);
	
	pPlaceInfo = GetPlaceInfo(WK7PLAYERPATHCONTROL->GetCurrentPathName());
	SetCameraStartPosition(pPlaceInfo);
	while( SandRelease(pPlaceInfo)==false ){
		K7SCR_RETSYS();
	}
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		K7SCR_RETSYS();
	}
	
	SetManualBranch(false);
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
#endif
	
	return true;
#if 0
	SetCurrentCallBackDefaultProc();
	while( WK7Stage::IsChanging()==true ){
		K7SCR_RETSYS();
	}
	
	WK7Chara		*pChara = GetOwnChara(K7CHRID(K7ZA2,0));
	WK7Model		*pModel = GetOwnModel(K7OBJTYPE_CHR,K7CHRID(K7ZA2,0));
	WK7ModelMotion	*pModelMotion[3];
	
	pModelMotion[0] = GetOwnModelMotion(K7MOT_ATTR|K7OBJTYPE_CHR,K7MOTID(K7ZA2,20));
	pModelMotion[1] = GetOwnModelMotion(K7MOT_ATTR|K7OBJTYPE_CHR,K7MOTID(K7ZA2,30));
	pModelMotion[2] = GetOwnModelMotion(K7MOT_ATTR|K7OBJTYPE_CHR,K7MOTID(K7ZA2,40));
	
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE ();
	K7SCR_PC_VISIBLE      (false);
	
//	while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
//		K7SCR_RETSYS();
//	}
	
	SetZanEventInfo(K7EVENTZAN(000001));
	GameInfo.SetZanCharaID          (K7CHRID(K7ZA2,0));
	GameInfo.SetZanMesID            (0);
	GameInfo.SetMode                (WK7GameInfo::ZAN);
	GameInfo.SetZanNoiseCancel      (true);
	GameInfo.SetZanCinemaScopeCancel(true);
	GameInfo.SetZanManual           (true);
	GameInfo.SetZanCharaLoadCancel  (true);
	GameInfo.SetZanInitWait         (true);
	
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		K7SCR_RETSYS();
	}
	
	FixCam(TUTOCAM);
	
static	bool	dbg = false;
	if( pChara!=NULL ){
		
		Vec				plpos;
		Vec				/*pos,*/tgt,dir;
		f32				roty;
static	f32				dist = 15.0f;
		
		WK7JObj			*pJObj;
		
		WK7PLAYERCONTROL->GetPosition(&plpos);
		WK7PLAYERCONTROL->GetRotY    (&roty );
		dir.z = dist * cosf(roty);
		dir.x = dist * sinf(roty);
		dir.y = 0.0f;
		VECAdd(&plpos,&dir,&tgt);
		
		roty += HALF_PI;
//		roty += PI;
		GHM_LIMIT_RANGE(roty,PI,-PI);
		pChara->SetRenderFlag(true);
		pChara->SetPosition  (tgt);
		pChara->SetRotY      (roty);
		
		tgt.y += 15.0f;
		if( pModel!=NULL && (pJObj=pModel->GetTopObj())!=NULL ){
			pJObj->CreateAlphaControl(WK7ZAN_FADE_ALPHA,false);
			if( (pJObj=pModel->GetObj(K7CHRBONE_SKULL))!=NULL ){
				pJObj->GetWorldPosition(tgt);
			}
		}
		
		plpos.y += 10.0f;
		WK7CAM->SetPosition      (plpos);
		WK7CAM->SetTargetPosition(tgt);
		
	}
	
	if( pModel!=NULL ){
		
		if( pModelMotion[1]!=NULL ){
			pModel->AttachMotion (pModelMotion[1]);
			pModel->PlayMotion   ();
			pModel->SetMotionLoop(false);
			pModel->StopMotion   ();
		}
		
	}
	
	WK7CAM->SetCinemaScopeMode(true);
	
	while( gpNoise->mSandRelease()==false ){
		K7SCR_RETSYS();
	}
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		K7SCR_RETSYS();
	}
	
	if( pModel!=NULL ){
		
		if( pModelMotion[1]!=NULL ){
			pModel->ReplayMotion();
		}
		
		while( pModel->GetMotionState() != WK7MODEL_NOANIM ){
			K7SCR_RETSYS();
		}
		
		if( pModelMotion[0]!=NULL ){
			pModel->AttachMotion (pModelMotion[0]);
			pModel->PlayMotion   ();
			pModel->SetMotionLoop(true);
		}
	}
	
	while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_INITWAIT ){
		K7SCR_RETSYS();
	}
	GameInfo.SetZanInitWait(false);
	
	while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERMWAIT ){
		K7SCR_RETSYS();
	}
	
	if( dbg==true ){
		while( !(HSD_PadGetTrigger(1) & HSD_PAD_A) ){
			K7SCR_RETSYS();
		}
	}
	
	if( pModel!=NULL ){
		
		if( pModel!=NULL && pModelMotion[2]!=NULL ){
			pModel->AttachMotion (pModelMotion[2]);
			pModel->PlayMotion   ();
			pModel->SetMotionLoop(false);
		}
		
		while( pModel->GetMotionState() != WK7MODEL_NOANIM ){
			K7SCR_RETSYS();
		}
		
	}
	
	while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
		K7SCR_RETSYS();
	}
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		K7SCR_RETSYS();
	}
	
	while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY ){
		K7SCR_RETSYS();
	}
	GameInfo.SetZanNoiseCancel      (false);
	GameInfo.SetZanCinemaScopeCancel(false);
	GameInfo.SetZanManual           (false);
	GameInfo.SetZanCharaLoadCancel  (false);
	
	WK7CAM->SetCinemaScopeMode(false);
	
	if( pChara!=NULL ){
		pChara->SetRenderFlag(false);
	}
	K7SCR_RETSYS();
	
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	K7SCR_PC_VISIBLE    (true);
	
	SetCameraStartPosition();
	while( SandRelease()==false ){
		K7SCR_RETSYS();
	}
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		K7SCR_RETSYS();
	}
	
	K7SCR_SET_SCENARIO_FLAG(K7SCN07_TUTO);
	
	K7SCR_EXIT_PLAYMODE ();
	K7SCR_EXIT_DEMOPAUSE();
	
	return false;
#endif
}

