////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage771M04
//
// K7Stage771M04.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 07/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE771M04_H__
#define	__K7STAGE771M04_H__

#include "..\..\..\Wat\WK7Stage.h"
#include "..\..\K7Stage.h"

class K7Stage771M04 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage771M04();
	K7Stage771M04(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	WK7Npc		*mpEnemy[2];
	int			mTutoProc;
	
	bool ScanTest(void);
	bool EnemyPop(void);
	bool EnemyEscape(void);
	bool EnemyLossTest(void);
	
	virtual bool LoadAfterInit3(void);
	virtual bool IsLoadingAfterInit3(void);
public:
	virtual ~K7Stage771M04();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool TerminateCallBack (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
//	virtual bool EventCallBack     (WK7EventInfo     &){ return true; }		// Cxg
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool BpLeaveCallBack   (WK7BpInfo        &){ return true; }		// _o
	virtual bool BpArriveCallBack  (WK7BpInfo        &);
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
//	virtual bool HitObjCallBack    (WK7HitObjInfo    &){ return true; }		// qbgIuWF
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &){ return true; }		// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &){ return true; }		// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &){ return true; }		// erCxgiZ[u|Cgj
//	virtual bool PlayEventCallBack (WK7PlayEventInfo &);					// LCxg
	virtual bool PathTurnCallBack  (WK7PathTurnInfo  &);
	virtual bool PathChangeCallBack(WK7PathChangeInfo &);

};

#ifdef __K7STAGE771M04_CPP__


enum K7STAGE771M04_ONESHOTCAM{
	TUTOCAM,
};

K7StageEventOneShotCamera K7Stage771M04_Camera[] = {
	{{-9.493f, 14.899f, 263.599f},{-9.773f, 11.442f, 285.616f}},
};

#endif

#endif	//__K7STAGE771M04_H__

