////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage772M02
//
// K7Stage772M02.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/26/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE772M02_H__
#define	__K7STAGE772M02_H__

#include "..\..\..\Wat\WK7Stage.h"
#include "..\..\K7Stage.h"

class K7Stage772M02 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage772M02();
	K7Stage772M02(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	bool	mAmbPlaySE;
public:
	virtual ~K7Stage772M02();
	
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool SpAbilityCallBack (WK7SpAbilityInfo      &);
	virtual bool ZanEventCallBack  (WK7ZanEventInfo       &);
	virtual bool DoorEventCallBack (WK7DoorEventInfo      &);
	virtual bool BpLeaveCallBack   (WK7BpInfo             &);
	virtual bool SetCurrentCallBack(void);		// JgXe[Wɐݒ莞
};

#ifdef __K7STAGE772M02_CPP__


enum K7STAGE772M02_ONESHOTCAM{
	SECTRET1,
	TRAVIS,
	CAM772DOOR2LAUNDLY,
	CAM772M01BOMB,	//bomb!
	CAM772M02_HS_PRESEN_START,
	CAM772M02_HS_PRESEN_END,
};


K7StageEventOneShotCamera K7Stage772M02_Camera[] = {
	{{-146.057f, 11.678f, -609.365f},{-143.427f, 8.666f, -589.883f}},
	{{-123.668f, 10.782f, -691.823f},{-136.250f, 8.217f, -672.597f}},
	{{164.654f, 13.614f, -576.505f},{160.748f, 15.520f, -571.559f}},	//h[[ւ̔
	{{1.539f, 7.968f, -525.085f},{-18.775f, 15.795f, -535.482f}},		//bomb!
	{{-142.229f, 13.546f, -503.043f},{-142.889f, 13.245f, -479.777f}},	// HSЉp
	{{-141.999f, 13.546f, -673.305f},{-142.659f, 13.245f, -650.039f}},	// HSЉpY[
};

#endif

#endif	//__K7STAGE772M02_H__

