////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage773M02
//
// K7Stage773M02.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE773M02_CPP__

#include "..\..\..\Scn\K7Scn07.h"
#include ".\K7Stage773M02.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Kaw\KK7Effect.h"
#include "..\..\..\Yam\YK7EffectDraft.h"

//bZ[W
#define	MES773M02_00	(0)		//{INA
//[Vꗗ
#define	MOT773M02_R		(0)		//{IEړ
#define	MOT773M02_L		(1)		//{Iړ
#define	MOT773M02_02	(2)		//Rpl̊WJ

#if	0
//̃\[X̃O[oϐ
static	bool	g773M02CtrlPnlFlag = false;
#endif

#define	K7STAGE773M02_BROKENWALL_RIDDLE_PATHNAME		"event_007311_0"
#define	K7STAGE773M02_SHELF_RIDDLE_PATHNAME				"event_007312_0"

#define	K7STAGE773M02_BROKENWALL_WINDNAME				"wind1"

K7STAGE_BROKENWALLINFO_START(K7Stage773M02_BrokenWallInfo)
	K7STAGE_BROKENWALLINFO_CAM(K7EVENTNO(007303) , "event_007303" , "pass_msk0" , K7SCN07_SP_773M02 , BROKEN_WALL)
K7STAGE_BROKENWALLINFO_END()

static Vec windPos = {122.966f, 12.878f, -480.850f};

//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage773M02::K7Stage773M02(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mpWindEffect = NULL;
	SetOneShotCamLocTbl(K7Stage773M02_Camera);
	SetBrokenWallInfo  (K7Stage773M02_BrokenWallInfo);
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage773M02::~K7Stage773M02()
{
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool K7Stage773M02::CreateCallBack( void )
{
//K7SCR_EVSETITEM( K7EVITEM_KEY(035001), true );
	//[Vt@C
	CreateOwnStageMotion( MOT773M02_R );
	CreateOwnStageMotion( MOT773M02_L );
	CreateOwnStageMotion( MOT773M02_02 );
	
	return( true );
}

#if	0
//------------------------------------------------------------------------------
// iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
//------------------------------------------------------------------------------
//K7STAGE_KIHANKUITABLE_START(K7Stage773M02Kui)
//	K7STAGE_KIHANKUITABLE_CAM(1,K7EVENTTAMA(007301),-1.301f, 18.522f, -549.858f, -5.772f, 16.145f, -571.798f)
//	K7STAGE_KIHANKUITABLE_CAM(2,K7EVENTTAMA(007302),-1.301f, 18.522f, -549.858f, -5.772f, 16.145f, -571.798f)
//	K7STAGE_KIHANKUITABLE_CAM(3,K7EVENTTAMA(007303),-1.301f, 18.522f, -549.858f, -5.772f, 16.145f, -571.798f)
//K7STAGE_KIHANKUITABLE_END()
bool K7Stage773M02::InitializeCallBack(void)
{
//	CreateKui(K7Stage773M02Kui);
	
	//{ȈԎ擾
	mBookshelfLocate0 = eBookshelfInit;
	mBookshelfLocate1 = eBookshelfInit;
	mBookshelfLocate2 = eBookshelfInit;
	mBookshelfLocate3 = eBookshelfInit;
	mBookshelfLocate4 = eBookshelfInit;
	//Xe[W̖{I̔zu͈ړAjȂ
	mBookshelfMove = false;
	//{I̍WXV
	mBookshelfMoveProc();
	
	K7SCR_EVCONDCHANGE();
	return true;
}

//------------------------------------------------------------------------------
//{Ïړ
//------------------------------------------------------------------------------
void K7Stage773M02::mSetBookshelfMove( u8 inOldLoc, u8 inNowLoc, char* inLeftBs, char* inRightBs )
{
	WK7JObj* pJObj = NULL;
	
	if( inOldLoc != inNowLoc )
	{
		//{I͂Ȃ
		if( inNowLoc == eBookshelfNone )
		{
			//zȕꍇ
			if( inOldLoc == eBookshelfInit )
			{
				//̖{IɈړAjĐ
				if( (pJObj = PlayMotion(inLeftBs,MOT773M02_L,"Ashelf02")) != NULL )
				{
					pJObj->SetMotionLoop( false );
					pJObj->PlayMotion( -1.0f, false, 0.0f, false, true );
				}
				//E̖{IEɈړAjĐ
				if( (pJObj = PlayMotion(inRightBs,MOT773M02_R,"Ashelf02")) != NULL )
				{
					pJObj->SetMotionLoop( false );
					pJObj->PlayMotion( -1.0f, false, 0.0f, false, true );
				}
			}else
			{
			//ړAj̏ꍇ
				//̖{I
				if( inOldLoc == eBookshelfLeft )
				{	//̖{IɈړAjĐ
					if( (pJObj = PlayMotion(inLeftBs,MOT773M02_L,"Ashelf02")) != NULL )
					{
						gpSound->mPlaySE( SFX_SCE0_MOVE_BOOKSHELF );
						pJObj->SetMotionLoop( false );
					}
				}else
				//E̖{I
				if( inOldLoc == eBookshelfRight )
				{	//E̖{IEɈړAjĐ
					if( (pJObj = PlayMotion(inRightBs,MOT773M02_R,"Ashelf02")) != NULL )
					{
						gpSound->mPlaySE( SFX_SCE0_MOVE_BOOKSHELF );
						pJObj->SetMotionLoop( false );
					}
				}
			}
		}else
		//̖{I
		if( inNowLoc == eBookshelfLeft )
		{
			//zȕꍇ
			if( inOldLoc == eBookshelfInit )
			{
				//E̖{IEɈړAjĐ
				if( (pJObj = PlayMotion(inRightBs,MOT773M02_R,"Ashelf02")) != NULL )
				{
					pJObj->SetMotionLoop( false );
					pJObj->PlayMotion( -1.0f, false, 0.0f, false, true );
				}
				//̖{IEɂɈړAjĐ
				if( (pJObj = PlayMotion(inLeftBs,MOT773M02_R,"Ashelf02")) != NULL )
				{
					pJObj->SetMotionLoop( false );
					pJObj->PlayMotion( -1.0f, false, 0.0f, false, true );
				}
			}else
			{
			//ړAj̏ꍇ
				//E̖{I
				if( inOldLoc == eBookshelfRight )
				{	//E̖{IEɈړAjĐ
					if( (pJObj = PlayMotion(inRightBs,MOT773M02_R,"Ashelf02")) != NULL )
					{
						gpSound->mPlaySE( SFX_SCE0_MOVE_BOOKSHELF );
						pJObj->SetMotionLoop( false );
					}
				}
				//̖{IEɂɈړAjĐ
				if( (pJObj = PlayMotion(inLeftBs,MOT773M02_R,"Ashelf02")) != NULL )
				{
					gpSound->mPlaySE( SFX_SCE0_MOVE_BOOKSHELF );
					pJObj->SetMotionLoop( false );
				}
			}
		}else
		//E̖{I
		if( inNowLoc == eBookshelfRight )
		{
			//zȕꍇ
			if( inOldLoc == eBookshelfInit )
			{
				//̖{IɈړAjĐ
				if( (pJObj = PlayMotion(inLeftBs,MOT773M02_L,"Ashelf02")) != NULL )
				{
					pJObj->SetMotionLoop( false );
					pJObj->PlayMotion( -1.0f, false, 0.0f, false, true );
				}
				//E̖{IɂɈړAjĐ
				if( (pJObj = PlayMotion(inRightBs,MOT773M02_L,"Ashelf02")) != NULL )
				{
					pJObj->SetMotionLoop( false );
					pJObj->PlayMotion( -1.0f, false, 0.0f, false, true );
				}
			}else
			{
			//ړAj̏ꍇ
				//̖{I
				if( inOldLoc == eBookshelfLeft )
				{	//̖{IɈړAjĐ
					if( (pJObj = PlayMotion(inLeftBs,MOT773M02_L,"Ashelf02")) != NULL )
					{
						gpSound->mPlaySE( SFX_SCE0_MOVE_BOOKSHELF );
						pJObj->SetMotionLoop( false );
					}
				}
				//E̖{IɂɈړAjĐ
				if( (pJObj = PlayMotion(inRightBs,MOT773M02_L,"Ashelf02")) != NULL )
				{
					gpSound->mPlaySE( SFX_SCE0_MOVE_BOOKSHELF );
					pJObj->SetMotionLoop( false );
				}
			}
		}
	}
}

//------------------------------------------------------------------------------
//5̖{Ïړ
//------------------------------------------------------------------------------
void
K7Stage773M02::mBookshelfMoveProc( void )
{
	//{IړĂ͂ȂtOĂȂΖ{Iړ
	if( g773M02CtrlPnlFlag == false )
	{
		//1
		mSetBookshelfMove( mBookshelfLocate0, K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_0), "Ashelf02", "Ashelf01" );
		//2
		mSetBookshelfMove( mBookshelfLocate1, K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_1), "Bshelf02", "Bshelf01" );
		//3
		mSetBookshelfMove( mBookshelfLocate2, K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_2), "Cshelf02", "Cshelf01" );
		//4
		mSetBookshelfMove( mBookshelfLocate3, K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_3), "Dshelf02", "Dshelf01" );
		//5
		mSetBookshelfMove( mBookshelfLocate4, K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_4), "Eshelf02", "Eshelf01" );
		//{Ïʒuۑ
		mBookshelfLocate0 = K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_0);
		mBookshelfLocate1 = K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_1);
		mBookshelfLocate2 = K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_2);
		mBookshelfLocate3 = K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_3);
		mBookshelfLocate4 = K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_4);
	}else
	{
	//plȀꍇ̏zu(̌ɈړAj邽߂ɈړO̔zuɂĂ)
		//1
		mSetBookshelfMove( mBookshelfLocate0, mOldBookshelfLocate0, "Ashelf02", "Ashelf01" );
		//2
		mSetBookshelfMove( mBookshelfLocate1, mOldBookshelfLocate1, "Bshelf02", "Bshelf01" );
		//3
		mSetBookshelfMove( mBookshelfLocate2, mOldBookshelfLocate2, "Cshelf02", "Cshelf01" );
		//4
		mSetBookshelfMove( mBookshelfLocate3, mOldBookshelfLocate3, "Dshelf02", "Dshelf01" );
		//5
		mSetBookshelfMove( mBookshelfLocate4, mOldBookshelfLocate4, "Eshelf02", "Eshelf01" );
		//{Ïʒuۑ
		mBookshelfLocate0 = mOldBookshelfLocate0;
		mBookshelfLocate1 = mOldBookshelfLocate1;
		mBookshelfLocate2 = mOldBookshelfLocate2;
		mBookshelfLocate3 = mOldBookshelfLocate3;
		mBookshelfLocate4 = mOldBookshelfLocate4;
	}
}
#endif

bool K7Stage773M02::SetCurrentCallBack(void)
{
	K7SCR_EVCONDCHANGE();
	return true;
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage773M02::CondChangeCallBack( void )
{
	WK7JObj		*pWindJObj;
	EFFECT		*pWindEffect;
	bool		wind;

	pWindJObj = GetJObj(K7STAGE773M02_BROKENWALL_WINDNAME);
	K7SCR_JOBJ_HIDE(pWindJObj);
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_SP_773M02)==true ){
		wind = false;
	}else{
		if( WK7PLAYERCONTROL->GetMainID()==K7CAT ){
			wind = true;
		}else{
			wind = false;
		}
	}
	if( pWindJObj!=NULL ){
		if( wind==true && GetCurrentStageID()==mID ){
			if( IsValidEffect(mpWindEffect)==false ){
				WK7RenderObjEffectInfo	info;
				info.Create();
				if( (pWindEffect = ::CreateDraft2Effect(pWindJObj,(s32)VParam[ED_DRAFT][2]))!=NULL ){
					mpWindEffect = CreateEffect(pWindEffect,&info);
					CatWindSePlay(windPos, K7SCN07_SP_773M02, SFX_SCE0_SUKIMAKAZE);
				}
			}
		}else{
			if( mpWindEffect!=NULL ){
//				ReleaseEffect(mpWindEffect);
				DelReqEffect(mpWindEffect);
				mpWindEffect = NULL;
			}
		}
	}
	
	WK7PathNurbs*	pPath;
	WK7JObj*		pJObj;
	
	//Rpl̊Wݒ
	SimpleSetStartMotion( "panel_animation", MOT773M02_02 );
#if	0
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007307) == true )
	{
		SimpleSetLastMotion( "panel_animation", MOT773M02_02 );
	}else
	{
		SimpleSetStartMotion( "panel_animation", MOT773M02_02 );
	}
#endif
	
	//h[œ肵}Ă邩
	if( (pJObj=GetJObj("pendant00")) != NULL )
	{
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007307_1) == TRUE )
		{
			pJObj->Disp( false, true );
		}else
		{
			pJObj->Hide( false, true );
		}
	}
	//E\Nœ肵}Ă邩
	if( (pJObj=GetJObj("pendant01")) != NULL )
	{
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007307_2) == TRUE )
		{
			pJObj->Disp( false, true );
		}else
		{
			pJObj->Hide( false, true );
		}
	}
	
	//{I\ݒ
	SimpleModelHide( "Ashelf02" );
	SimpleModelHide( "Bshelf01" );
	SimpleModelHide( "Cshelf02" );
	SimpleModelHide( "Dshelf01" );
	SimpleModelHide( "Eshelf02" );
	
	//pXݒ
	if( (pPath = GetPathNurbs("DeadEnd00A")) != NULL )
	{
		//{ȈԂŃpXω
		if( (K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007307_1) == true)
		 && (K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007307_2) == true) )
#if	0
		if( (K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_0) == 0)
		 && (K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_1) == 0)
		 && (K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_2) == 0)
		 && (K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_3) == 0)
		 && (K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_4) == 0) )
#endif
		{	//[ɂĂΒʉ߃pX
			pPath->SetEnable( true );
			pPath->SetEnableEx( true );
			K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE773M02_SHELF_RIDDLE_PATHNAME,true );
			//plCxg
			K7SCR_EVNO_SETENABLE( K7EVENTNO(007307), false );
			K7SCR_SET_SCENARIO_FLAG( EV007300PASSHOLEWAY );
			SimpleSetLastMotion( "Ashelf01", MOT773M02_R, "Ashelf02" );
			SimpleSetLastMotion( "Bshelf02", MOT773M02_L, "Ashelf02" );
			SimpleSetLastMotion( "Cshelf01", MOT773M02_R, "Ashelf02" );
			SimpleSetLastMotion( "Dshelf02", MOT773M02_L, "Ashelf02" );
			SimpleSetLastMotion( "Eshelf01", MOT773M02_R, "Ashelf02" );
		}else
		{	//[ɂĂȂΒʉ߃pXȂ
			pPath->SetEnable( false );
			pPath->SetEnableEx( false );
			K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE773M02_SHELF_RIDDLE_PATHNAME,false);
			K7SCR_EVNO_SETENABLE( K7EVENTNO(007307), true );
			K7SCR_RESET_SCENARIO_FLAG( EV007300PASSHOLEWAY );
			SimpleSetLastMotion( "Ashelf01", MOT773M02_L, "Ashelf02" );
			SimpleSetLastMotion( "Bshelf02", MOT773M02_R, "Ashelf02" );
			SimpleSetLastMotion( "Cshelf01", MOT773M02_L, "Ashelf02" );
			SimpleSetLastMotion( "Dshelf02", MOT773M02_R, "Ashelf02" );
			SimpleSetLastMotion( "Eshelf01", MOT773M02_L, "Ashelf02" );
		}
	}
	
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_SP_773M02)==TRUE ){
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE773M02_BROKENWALL_RIDDLE_PATHNAME,true );
	}else{
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE773M02_BROKENWALL_RIDDLE_PATHNAME,false);
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool K7Stage773M02::EventCallBack( WK7EventInfo &info )
{
	WK7JObj *pJObj;
	
	switch( info.mEventNo )
	{
		//{I𓮂Rg[pl
		case	K7EVENTNO( 007307 ):
			//h[œ肵}Ă邩
			if( ((pJObj=GetJObj("pendant00")) != NULL)						//IuWFNgmF
			 && (K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007307_1) == FALSE)	//}Ă邩mF
			 && (K7SCR_GET_SCENARIO_FLAG(EV007307STRANGE) == true) )		//Ă邩mF
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				//JύX
				FixCam( CONTROL_PANEL_CAM );
				K7SCR_TIMEWAIT( 2400 );
				gpSound->mPlaySE( SFX_SYS_AKASICITEM_SET );
				pJObj->Disp( false, true );
				K7SCR_TIMEWAIT( 2400 );
				K7SCR_SET_SCENARIO_FLAG( K7SCN07_EVFL_007307_1 );
				K7SCR_EVSETITEM( K7EVITEM_KEY(007307), false );
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
			}
			//E\Nœ肵}Ă邩
			if( ((pJObj=GetJObj("pendant01")) != NULL)						//IuWFNgmF
			 && (K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007307_2) == FALSE)	//}Ă邩mF
			 && (K7SCR_GET_SCENARIO_FLAG(EV007308STRANGE) == true) )		//Ă邩mF
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				//JύX
				FixCam( CONTROL_PANEL_CAM );
				K7SCR_TIMEWAIT( 2400 );
				gpSound->mPlaySE( SFX_SYS_AKASICITEM_SET );
				pJObj->Disp( false, true );
				K7SCR_TIMEWAIT( 2400 );
				K7SCR_SET_SCENARIO_FLAG( K7SCN07_EVFL_007307_2 );
				K7SCR_EVSETITEM( K7EVITEM_KEY(007308), false );
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
			}
			// ---- pl𑀍삷Cxg ----
			//svcȑ`2Ƃ͂߂Ă甭
			if( (K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007307_1) == TRUE)
			 && (K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007307_2) == TRUE) )
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				//{IړJn
				FixCam( BOOKSHELF_MOVE_CAM );
				gpSound->mPlaySE( SFX_SYS_EV_CLEAR );
				gpSound->mPlaySE( SFX_SCE0_MOVE_BOOKSHELF );
				SimplePlayMotion( "Ashelf01", MOT773M02_R, "Ashelf02" );
				SimplePlayMotion( "Bshelf02", MOT773M02_L, "Ashelf02" );
				SimplePlayMotion( "Cshelf01", MOT773M02_R, "Ashelf02" );
				SimplePlayMotion( "Dshelf02", MOT773M02_L, "Ashelf02" );
				SimplePlayMotion( "Eshelf01", MOT773M02_R, "Ashelf02" );
				K7SCR_STGC_MESSAGE_B( MES773M02_00 );
				K7SCR_EVCONDCHANGE();
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
			}else
			{
				//䂩bZ[W
				FixCamWithRiddle( CONTROL_PANEL_CAM );
			}
#if	0
			// ---- }Cxg ----
			//h[œ肵}Ă邩
			if( ((pJObj=GetJObj("pendant00")) != NULL)						//IuWFNgmF
			 && (K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007307_1) == FALSE)	//}Ă邩mF
			 && (K7SCR_GET_SCENARIO_FLAG(EV007307STRANGE) == true) )		//Ă邩mF
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				//JύX
				FixCam( CONTROL_PANEL_CAM );
				K7SCR_TIMEWAIT( 2400 );
				gpSound->mPlaySE( SFX_SYS_AKASICITEM_SET );
				pJObj->Disp( false, true );
				K7SCR_TIMEWAIT( 2400 );
				K7SCR_SET_SCENARIO_FLAG( K7SCN07_EVFL_007307_1 );
				K7SCR_EVSETITEM( K7EVITEM_KEY(007307), false );
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
			}
			//E\Nœ肵}Ă邩
			if( ((pJObj=GetJObj("pendant01")) != NULL)						//IuWFNgmF
			 && (K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007307_2) == FALSE)	//}Ă邩mF
			 && (K7SCR_GET_SCENARIO_FLAG(EV007308STRANGE) == true) )		//Ă邩mF
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				//JύX
				FixCam( CONTROL_PANEL_CAM );
				K7SCR_TIMEWAIT( 2400 );
				gpSound->mPlaySE( SFX_SYS_AKASICITEM_SET );
				pJObj->Disp( false, true );
				K7SCR_TIMEWAIT( 2400 );
				K7SCR_SET_SCENARIO_FLAG( K7SCN07_EVFL_007307_2 );
				K7SCR_EVSETITEM( K7EVITEM_KEY(007308), false );
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
			}
			// ---- pl𑀍삷Cxg ----
			//svcȑ`2Ƃ͂߂Ă甭
			if( (K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007307_1) == TRUE)
			 && (K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007307_2) == TRUE) )
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				//W܂JĂȂΊJ鉉o
				if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007307) == FALSE )
				{
					//_؂ւ
					FixCam( CONTROL_PANEL_CAM );
					//W̊JAjĐ
					SimplePlayMotionB( "panel_animation", MOT773M02_02 );
					//WJtOON
					K7SCR_SET_SCENARIO_FLAG( K7SCN07_EVFL_007307 );
				}
				//plAɖ{I𓮂ȂtO𗧂Ă
				g773M02CtrlPnlFlag = true;
				//plÖʒuۑ
				mOldBookshelfLocate0 = mBookshelfLocate0;
				mOldBookshelfLocate1 = mBookshelfLocate1;
				mOldBookshelfLocate2 = mBookshelfLocate2;
				mOldBookshelfLocate3 = mBookshelfLocate3;
				mOldBookshelfLocate4 = mBookshelfLocate4;
				//plĂяo
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(007307), 0 );
				K7SCR_PANEL_START();
				K7SCR_PANEL_TERMWAIT();
				K7SCR_RETSYS();
				K7SCR_PANEL_EXIT();
				//zuWƈႤꍇ͖{IAj
				if( (mOldBookshelfLocate0 != K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_0))
				 || (mOldBookshelfLocate1 != K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_1))
				 || (mOldBookshelfLocate2 != K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_2))
				 || (mOldBookshelfLocate3 != K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_3))
				 || (mOldBookshelfLocate4 != K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_4)) )
				{
					//plAɖ{I𓮂ȂtO߂
					g773M02CtrlPnlFlag = false;
					//{I̔züړAj
					mBookshelfMove = true;
					//{I̍WXV
					mBookshelfMoveProc();
					//pX̐ݒȂ
					K7SCR_EVCONDCHANGE();
					//NAȂ烁bZ[W\
					if( (K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_0) == 0)
					 && (K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_1) == 0)
					 && (K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_2) == 0)
					 && (K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_3) == 0)
					 && (K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_4) == 0) )
					{
						FixCam( BOOKSHELF_MOVE_CAM );
						K7SCR_PANEL_EXITWAIT();
						gpSound->mPlaySE( SFX_SYS_EV_CLEAR );
						K7SCR_STGC_MESSAGE_B( MES773M02_00 );
						//plCxg
						K7SCR_EVNO_SETENABLE( K7EVENTNO(007307), false );
					}else
					{
						FixCam( BOOKSHELF_MOVE_CAM );
						K7SCR_PANEL_EXITWAIT();
						K7SCR_TIMEWAIT( 4800 * 4 );
					}
				}else
				{
					WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
					K7SCR_PANEL_EXITWAIT();
				}
				//plAɖ{I𓮂ȂtO߂
				g773M02CtrlPnlFlag = false;
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
			}else
			{
				//䂩bZ[W
				FixCamWithRiddle( CONTROL_PANEL_CAM );
			}
#endif
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
// hACxg
//------------------------------------------------------------------------------
bool
K7Stage773M02::DoorEventCallBack(WK7DoorEventInfo &info)
{
#pragma	unused(info)
//	switch( info.mEventNo ){
//	case	K7EVENTDOOR(007301):
//		if( KihanGateIsOpened()==false ){
//			K7SCR_ENTER_PLAYMODE();
//			K7SCR_ENTER_DEMOPAUSE();
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EXIT_PLAYMODE();
//			K7SCR_EXIT_DEMOPAUSE();
//			K7SCR_EVCONDCHANGE();
//			return false;
//		}
//		break;
//	default:
//		break;
//	}
	return true;
}

bool K7Stage773M02::BpLeaveCallBack(WK7BpInfo &info)
{
	u32		eventNo = GetBpEventNo(info);
	int		pathNo  = GetBpPathNo (info);
	if( pathNo!=0 ){
		return true;
	}
	switch( eventNo ){
	case	K7EVENTNO(007311):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_SP_773M02)==TRUE ){
			return true;
		}
		break;
	case	K7EVENTNO(007312):
		if( (K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007307_1) == TRUE)
		 && (K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007307_2) == TRUE) ){
			return true;
		}
#if	0
		if( (K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_0) == 0)
		 && (K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_1) == 0)
		 && (K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_2) == 0)
		 && (K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_3) == 0)
		 && (K7EVENT_SCN_VAR(K7SCN07,EVBS_007307_4) == 0) ){
			return true;
		}
#endif
		break;
	default:
		return true;
	}
	gpSound->mPlaySE(SFX_SYS_APPEAR_RIDDLE);
	return true;
}

bool K7Stage773M02::CharaChangeCallBack(WK7CharaChangeInfo &info)
{
#pragma	unused(info)
	K7SCR_EVCONDCHANGE();
	return true;
}

