////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage773M03
//
// K7Stage773M03.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/26/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE773M03_H__
#define	__K7STAGE773M03_H__

#include "..\..\..\Wat\WK7Stage.h"
#include "..\..\K7Stage.h"

class K7Stage773M03 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage773M03();
	K7Stage773M03(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	void	mInitHitObj( u32 inEvNo );			//qbgIuWF̏
	void	mInitDarts( void );					//_[cQ[̏
	void	mSetDartsPosAndShot( int inPosNo );	//_[cQ[̃|WVݒƎˌ
	bool	mPlayDarts( void );					//_[cQ[
	void	mAppearFairy( void );				//do
	
	bool	mDartsTarget1;						//_[c̓I1ɓ
	bool	mDartsTarget2;						//_[c̓I2ɓ
	bool	mDartsTarget3;						//_[c̓I3ɓ
	bool	mPlayDartsFlag;						//_[cQ[
	bool	mCheckFire;							//e
	bool	mAmbPlaySE;
	
public:
	virtual ~K7Stage773M03();
	
//	virtual bool CreateCallBack    (void);									// iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
	virtual bool InitializeCallBack(void);									// iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
	virtual bool CondChangeCallBack(void);									// ԕύXitOɂԕύX邽߂ɗpj
//	virtual bool TerminateCallBack (void);									// Iȉj
	virtual bool SetCurrentCallBack(void);									// JgXe[Wɐݒ莞
	virtual bool EventCallBack     (WK7EventInfo     &);					// Cxg
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &);					// hACxg
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool BpLeaveCallBack   (WK7BpInfo        &){ return true; }		// _o
//	virtual bool BpArriveCallBack  (WK7BpInfo        &){ return true; }		// _
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
	virtual bool HitObjCallBack    (WK7HitObjInfo    &);					// qbgIuWF
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &){ return true; }		// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &){ return true; }		// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &){ return true; }		// erCxgiZ[u|Cgj
	virtual bool AttackCallBack    (WK7AttackInfo    &);					// v[[̍U

};

#ifdef __K7STAGE773M03_CPP__


enum K7STAGE773M03_ONESHOTCAM{
	EV_DARTS_RIDDLE,
	EV_DARTS_TARGET1,
	EV_DARTS_TARGET2,
	EV_DARTS_TARGET3,
	EV_DARTS_POS1_1,
	EV_DARTS_POS1_2,
	EV_DARTS_POS1_3,
	EV_DARTS_POS2_1,
	EV_DARTS_POS2_2,
	EV_DARTS_POS2_3,
	EV_DARTS_POS3_1,
	EV_DARTS_POS3_2,
	EV_DARTS_POS3_3,
	EV_POP_FAIRY,
	EV_AFTER_DARTS_CLEAR,
};

K7StageEventOneShotCamera K7Stage773M03_Camera[] = {
	{{92.787f, 13.898f, -115.426f},{113.929f, 13.093f, -119.161f}},		//PBȊO_[cɃANZXƂ̓䂩J
	{{32.437f, 10.077f, -127.494f},{53.855f, 14.424f, -120.096f}},		//_[c̓Iւ̃J
	{{30.317f, 10.077f, -131.151f},{53.017f, 14.212f, -131.156f}},		//_[c̓Iւ̃J
	{{33.060f, 10.077f, -132.596f},{52.938f, 14.034f, -143.623f}},		//_[c̓IEւ̃J
	{{56.267f,  0.000f, -122.334f},{63.915f,  0.000f, -122.151f}},		//̓Iւ̗ʒu1 
	{{41.896f,  0.000f, -125.141f},{55.028f,  0.000f, -118.529f}},		//̓Iւ̗ʒu2 ߂
	{{48.443f,  3.000f, -121.994f},{54.192f,  3.000f, -122.072f}},		//̓Iւ̗ʒu3 
	{{56.820f,  0.000f, -130.826f},{64.468f,  0.000f, -130.643f}},		//̓Iւ̗ʒu1 
	{{41.888f,  0.000f, -131.358f},{56.570f,  0.000f, -130.783f}},		//̓Iւ̗ʒu2 ߂
	{{48.004f,  3.000f, -131.017f},{53.754f,  3.000f, -131.095f}},		//̓Iւ̗ʒu3 
	{{57.725f,  0.000f, -139.910f},{65.373f,  0.000f, -139.727f}},		//E̓Iւ̗ʒu1 
	{{40.978f,  0.000f, -137.977f},{54.905f,  0.000f, -142.680f}},		//E̓Iւ̗ʒu2 ߂
	{{48.041f,  3.000f, -140.031f},{53.790f,  3.000f, -140.109f}},		//E̓Iւ̗ʒu3 
	{{89.982f, 10.545f, -245.838f},{108.854f, 8.089f, -234.110f}},		//d̏oʒuւ̃J
	{{95.715f, 13.528f, -164.894f},{98.622f, 12.478f, -141.638f}},		//_[cNÃJ
};

#endif

#endif	//__K7STAGE773M03_H__

