////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage773M05
//
// K7Stage773M05.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE773M05_CPP__

#include "..\..\..\Scn\K7Scn07.h"
#include ".\K7Stage773M05.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Kaw\kk7sound.h"
#include "..\..\..\Wat\K7GlobalFlag.h"
#include "..\..\..\Yam\YK7EffectBillboard.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"
#include "..\..\..\Yam\YK7EffectModelFire.h"
#include "..\..\..\sato\SK7SpecialData.h"

//bZ[W
#define	MES773M05_00			(0)		//XvN[쓮
#define	MES773M05_USE_FIRE_RING	(1)		//̎wւg
//[V
#define	MOT773M04_04	(4)		//Stage773M04̌Ajԍ



//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage773M05::K7Stage773M05(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage773M05_Camera );
	mpSprinkler = NULL;
	mpFire      = NULL;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage773M05::~K7Stage773M05()
{
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage773M05::CreateCallBack( void )
{
	// r{[h̃eNX`f[^ǂݍ
	while( WK7RenderObj::CreateEffectBillResource(BILLEFF_SPRINKLER) == NULL )
	{
		K7SCR_RETSYS();
	}
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_FIRE) == NULL )
	{
		K7SCR_RETSYS();
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage773M05::CondChangeCallBack( void )
{
	//XvN[쓮
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007309) == TRUE )
	{
		mSprinklerStart();
		K7SCR_EVNO_SETENABLE( K7EVENTNO(007309), false );
	}else
	{
		mSprinklerStop();
		K7SCR_EVNO_SETENABLE( K7EVENTNO(007309), true );
	}
	
	//gC̐𗬂ĂCxg
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007310) == TRUE )
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(007310), false );
	}else
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(007310), true );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
// Iȉj
//------------------------------------------------------------------------------
bool
K7Stage773M05::TerminateCallBack( void )
{
	//XvN[~
	mSprinklerStop();
	
	// r{[h̃eNX`f[^̊J
	while( WK7RenderObj::ReleaseEffectBillResource(BILLEFF_SPRINKLER) == NULL )
	{
		K7SCR_RETSYS();
	}
	while( WK7RenderObj::ReleaseEffectAnimResource(ANIMID_FIRE) == NULL )
	{
		K7SCR_RETSYS();
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage773M05::EventCallBack( WK7EventInfo &info )
{
	switch( info.mEventNo )
	{
		//XvN[Cxg
		case	K7EVENTNO( 007309 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			//XvN[쓮`FbN
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007309) == FALSE )
			{
				//XvN[쓮ACeĂ邩`FbN
				if( K7SCR_EVEQUIPRING(RING_FIRE) == true )
				{
					//w֎gpbZ[W
					FixCam( EV_SPRINKLER_CAM );
					K7SCR_STGC_MESSAGE_B( MES773M05_USE_FIRE_RING );
					////΂̃GtFNg\
					//mDispFireEffect( true );
					////EGCg
					//K7SCR_TIMEWAIT( 4800 * 2 );
					//GtFNg\
					mSprinklerStart();
					//EGCg
					K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
					////΂̃GtFNg\
					//mDispFireEffect( false );
					////bZ[W\
					//K7SCR_STGC_MESSAGE_B( MES773M05_00 );
					//XvN[쓮tOON
					K7SCR_SET_SCENARIO_FLAG( K7SCN07_EVFL_007309 );
					//WNV
					K7SCR_EVNO_SETENABLE( K7EVENTNO(007309), false );
				}else
				{
					FixCamWithRiddle( EV_SPRINKLER_CAM );
				}
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
			break;
		
		//gCCxg
		case	K7EVENTNO( 007310 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			//XvN[쓮`FbN
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007309) == TRUE )
			{
				//XvN[~
				mSprinklerStop();
				//x񉹂Ȃ邽߃XvN[tOꎞƂ
				K7SCR_RESET_SCENARIO_FLAG( K7SCN07_EVFL_007309 );
				//gCpls
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(000603), 1 );
				K7SCR_PANEL_START();
				K7SCR_PANEL_TERMWAIT();
				K7SCR_RETSYS();
				GameInfo.SetPanelNoiseCancel( true );
				K7SCR_PANEL_EXIT();
				K7SCR_PANEL_EXITWAIT();
				GameInfo.SetPanelNoiseCancel( false );
				//gCplŐ𗬂Cxg
				if( K7SCR_PANEL_GETRESULT() != -1 )
				{
					//inGame~
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					K7SCR_PC_SETVISIBLE( false );
					//ꂽV[\
					mDispCarriedKey();
					//gC̐𗬂tOON
					K7SCR_SET_SCENARIO_FLAG( K7SCN07_EVFL_007310 );
					//WNV
					K7SCR_EVNO_SETENABLE( K7EVENTNO(007310), false );
				}else
				{
					WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
					gpNoise->mSandRelease();
				}
				//XvN[tOON
				K7SCR_SET_SCENARIO_FLAG( K7SCN07_EVFL_007309 );
				K7SCR_EVCONDCHANGE();
			}else
			{
				//gCpls
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(000603), 0 );
				K7SCR_PANEL_START();
				K7SCR_PANEL_TERMWAIT();
				K7SCR_RETSYS();
				K7SCR_PANEL_EXIT();
				WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
				K7SCR_PANEL_EXITWAIT();
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//΂̃GtFNg\E\
//------------------------------------------------------------------------------
void
K7Stage773M05::mDispFireEffect( bool inDisp )
{
	Vec loc = { -140.147f, 26.500f, -213.993f };
	if( inDisp == false )
	{
		if( mpFire != NULL )
		{
			ReleaseEffect( mpFire );
			mpFire = NULL;
		}
		gpSound->mStopSE( SFX_SCE0_FIRE_L_LOOP );
	}else
	{
		if( mpFire == NULL )
		{
			while( (mpFire=CreateEffectModelFire((const char*)NULL,MFIRE_CANDLE,&loc,0.7f)) == NULL )
			{
				K7SCR_RETSYS();
			}
		}
		gpSound->mPlaySE( SFX_SCE0_FIRE_L_LOOP );
	}
}
//------------------------------------------------------------------------------
//XvN[Jn
//------------------------------------------------------------------------------
void
K7Stage773M05::mSprinklerStart( void )
{
	Vec	loc = { -140.147f, 29.452f, -213.993f };
	
	if( mpSprinkler == NULL )
	{
		while( (mpSprinkler=CreateBillBoardEffect(BILLEFF_SPRINKLER,loc,0.0f)) == NULL )
		{
			K7SCR_RETSYS();
		}
	}
	gpSound->mStopSE( SFX_SCE0_SPRINKLER );
	gpSound->mStopSE( SFX_SCE0_SPRINKLER_ALARM );
	K7SCR_RETSYS();
	gpSound->mPlaySE( SFX_SCE0_SPRINKLER );
	gpSound->mPlaySE( SFX_SCE0_SPRINKLER_ALARM );
}
//------------------------------------------------------------------------------
//XvN[~
//------------------------------------------------------------------------------
void
K7Stage773M05::mSprinklerStop( void )
{
	if( mpSprinkler != NULL )
	{
		ReleaseEffect( mpSprinkler );
		mpSprinkler = NULL;
	}
	gpSound->mStopSE( SFX_SCE0_SPRINKLER );
	gpSound->mStopSE( SFX_SCE0_SPRINKLER_ALARM );
}
//------------------------------------------------------------------------------
//ꂽV[\
//------------------------------------------------------------------------------
void
K7Stage773M05::mDispCarriedKey( void )
{
	u32			stgid;
	WK7JObj*	pJObj;
	WK7Stage*	pStage;
	
	// ---- Stage773M04Ăяo ----
//	//mCY
//	gpNoise->mSandRequest(eSandLongNoise);
//	while( gpNoise->mGetSandFrameProc()!=eSandExec ){K7SCR_RETSYS()};
	//Xe[WIDݒ
	stgid = K7STGID( 773, 4 );
	//773M05Xe[W
	K7SCR_STG_VISIBLE( mID, false );
	K7SCR_PC_SETVISIBLE( false );
	//XvN[~
	mSprinklerStop();
	//773M04Xe[WĂяo
	K7SCR_STG_CREATE_B( stgid );
	K7SCR_PC_SETVISIBLE( false );
	//Jς
	FixCam( EV_GET_KEY_CAM );
	//773M04Xe[W\
	K7SCR_STG_VISIBLE( stgid, true );
	//̗AjĐ
	pStage = WK7Stage::GetStage( stgid );
	pStage->CreateOwnStageMotion( MOT773M04_04 );
	while( pStage->IsOwnMotionObjLoaded() != true )
	{
		K7SCR_RETSYS();
	}
	//plԃmCY
	gpNoise->mSandRelease();
	//IfgEt@t@[
	gpSound->mPlaySE( SFX_SYS_TRUE );
	if( (pJObj = pStage->PlayMotion("key",MOT773M04_04)) != NULL )
	{
		pJObj->Disp( false, true );
		//h[[̌ACeoĂ
		pJObj->SetMotionLoop( false );
		K7SCR_TIMEWAIT( 3200 );
		gpSound->mPlaySE( SFX_SCE0_DROP_ITEM_IN_LAUNDRY );
		while( pJObj->GetMotionState(false,true) != WK7MODEL_NOANIM )
		{
			K7SCR_RETSYS();
		}
	}
	
	// ---- Stage773M05ɖ߂Ă ----
	//mCY
	K7SCR_NOISE_REQUEST();
	//773M04Xe[W
	K7SCR_STG_VISIBLE( stgid, false );
	//773M04Xe[W
	K7SCR_STG_RELEASE( stgid );
	//773M05Xe[W\
	K7SCR_STG_VISIBLE( mID, true );
	//LN^\
	K7SCR_PC_SETVISIBLE( true );
	
		// 041004
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		//XvN[tOON
		K7SCR_SET_SCENARIO_FLAG( K7SCN07_EVFL_007309 );
		
	//XvN[Jn
	K7SCR_EVCONDCHANGE();
	//mSprinklerStart();
	//JPCtH[ɖ߂
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
	//mCY
	K7SCR_NOISE_RELEASE();
}

