////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage776M02
//
// K7Stage776M02.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/26/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE776M02_H__
#define	__K7STAGE776M02_H__

#include "..\..\..\Wat\WK7Stage.h"
#include "..\..\K7Stage.h"

class K7Stage776M02 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage776M02();
	K7Stage776M02(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	EFFECT*	mpEffect;
	bool	mAngelCamera;
	
	void	PreBattleAngel( void );			//Vg̑O
	void	PreBattleFallenAngel( void );	//Vg̑O
	bool	BattleAngel( void );			//Vg
	bool	BattleFallenAngel( void );		//Vg
	
	void	BrockPath( void );			//pX
	void	ReleasePath( void );			//pX
	
public:
	virtual ~K7Stage776M02();
	
	virtual bool CreateCallBack    (void);									// iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//	virtual bool InitializeCallBack(void)              { return true; }		// iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
//	virtual bool CondChangeCallBack(void)              { return true; }		// ԕύXitOɂԕύX邽߂ɗpj
	virtual bool TerminateCallBack (void);									// Iȉj
	virtual bool SetCurrentCallBack(void);									// JgXe[Wɐݒ莞
//	virtual bool EventCallBack     (WK7EventInfo     &){ return true; }		// Cxg
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &){ return true; }		// hACxg
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool BpLeaveCallBack   (WK7BpInfo        &){ return true; }		// _o
//	virtual bool BpArriveCallBack  (WK7BpInfo        &){ return true; }		// _
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
//	virtual bool HitObjCallBack    (WK7HitObjInfo    &){ return true; }		// qbgIuWF
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &){ return true; }		// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &){ return true; }		// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &){ return true; }		// erCxgiZ[u|Cgj
	virtual bool PathChangeCallBack(WK7PathChangeInfo &);
	
//	virtual int GetCamSetID(void){ return -1; }
	virtual WK7CamSet* GetCamSet(u32 chrid);
};

#ifdef __K7STAGE776M02_CPP__


enum K7STAGE776M02_ONESHOTCAM{
	EV_HAC_CAM,
	EV_CHARCHG_HAC_2CAM,
	EV_CHARCHG_HAC_2PC,
	EV_CHARCHG_DAN_2CAM,
	EV_CHARCHG_DAN_2PC,
};


K7StageEventOneShotCamera K7Stage776M02_Camera[] = {
	{{61.f, 7.f, 169.f},{65.f, 6.f, 176.f}},
	{{74.933f, 31.381f, 194.171f},{62.705f, 27.121f, 209.873f}},		//L`FWEĎJւ̃J
	{{65.580f, 25.683f, 204.270f},{68.537f, 29.033f, 201.761f}},		//L`FWEPCւ̃J
	{{72.993f, 37.092f, 164.892f},{57.940f, 32.460f, 168.685f}},		//_ɑĎJւ̃J
	{{57.219f, 20.354f, 164.655f},{64.227f, 34.915f, 165.795f}},		//_ɑĎJJ
};

#endif

#endif	//__K7STAGE776M02_H__

