////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage103M00
//
// K7Stage103M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE103M00_H__
#define	__K7STAGE103M00_H__

#include "..\K7Stage.h"

class K7Stage103M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage103M00();
	K7Stage103M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage103M00();
	
	virtual bool CondChangeCallBack(void);
	virtual bool InitializeCallBack( void );
	virtual bool SetCurrentCallBack(void);
	virtual bool DoorEventCallBack(WK7DoorEventInfo &);
};

#ifdef	__K7STAGE103M00_CPP__

enum K7STAGE103M00_ONESHOTCAM{
	DOOR_010002,
	DOOR_010009,
	CAM103M00_HS_PRESEN_START,
	CAM103M00_HS_PRESEN_END,
};

K7StageEventOneShotCamera	K7Stage103M00_Camera[] = {
	{{-575.846f, 12.709f, -300.979f},{-518.797f, 9.601f, -310.525f}},		// uq̌vgƂ̉o
//	{{ -201.578f, 11.170f, -280.252f},{-188.038f, 9.804f, -272.835f}},		// uq̌vgƂ̉o
	{{80.525f, 11.177f, 4.115f},{50.911f, 9.749f, -2.751f}},				// Ői߂Ȃ
	{{-23.880f, 13.037f, -37.156f},{-23.038f, 12.138f, -7.168f}},			// HSЉp
	{{-23.213f, 13.037f, -170.477f},{-22.370f, 12.138f, -140.489f}},		// HSЉpY[
};

//enum{
//	K7STAGE103M00_MES_LOCKED_KEY = 0			,		// |Ă
//	K7STAGE103M00_MES_USE_KYAKUSHITSU_KEY		,		// uq̌vg
//	K7STAGE103M00_MES_CANT_ADVANCE_BY_FLAME		,		// Ői߂Ȃ
//};

#endif

#endif	//__K7STAGE103M00_H__

