////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage104M00
//
// K7Stage104M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE104M00_H__
#define	__K7STAGE104M00_H__

#include "..\K7Stage.h"

class K7Stage104M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	u32					mTimer;
	C_SetAlpha			*mpSetAlpha;
	WK7AnimLinearF		mAlpha;
	bool				mShishiodoshiSE;
	Vec					mShishiodoshiPos;
	
	bool LightUpCheck(void);
	
	K7Stage104M00();
	K7Stage104M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	bool _ShisiodoshiJObjCallBackFunc(WK7JObj *pJObj);
	static bool ShisiodoshiJObjCallBackFunc(WK7JObj *pJObj,void *pData);
public:
	virtual ~K7Stage104M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
	virtual bool CondChangeCallBack(void);
	virtual bool HitObjCallBack    (WK7HitObjInfo    &);
};

#ifdef	__K7STAGE104M00_CPP__

enum K7STAGE104M00_ONESHOTCAM{
	EVENT_010400,
	LIGHTUP,
	LIGHTPOS,
};

K7StageEventOneShotCamera	K7Stage104M00_Camera[] = {
	{{-53.947f, 4.376f, 9.917f},{-37.037f, 6.457f, 35.264f}},			// Ủo
	{{-2.803f, 12.947f, -7.308f},{-24.875f, 3.608f, -34.234f}},			// QeCgAbv
	{{-65.236f, -4.177f, 37.793f},{-51.937f, 1.079f, 25.561f}},			// Ɩʒu
};

enum{
	K7STAGE104M00_MES_LIGHTUP = 0				,		// QKCgAbvꂽ
	K7STAGE104M00_MES_LIGHTOFF					,		// ƖݒuĂ
	K7STAGE104M00_MES_LIGHTON					,		// Ɩ_Ă
};

//enum K7STAGE104M00_ONESHOTCAM{
//	DOOR_010001,
//};
//
//K7StageEventOneShotCamera	K7Stage104M00_Camera[] = {
//	{ {128.723f, 12.855f, -26.186f},{143.608f, 11.343f, -31.857f}},			// ǔvgƂ̉o
//};

//#define	K7STAGE104M00_MES_LOCKED_KEY				(0)		// |Ă
//#define	K7STAGE104M00_MES_USE_CHASHITSU_KEY			(1)		// ǔvg

#endif

#endif	//__K7STAGE104M00_H__

