////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage106M00
//
// K7Stage106M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE106M00_H__
#define	__K7STAGE106M00_H__

#include "..\K7Stage.h"

class K7Stage106M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	WK7AnimLinearF					mAlpha;
	C_SetAlpha						*mpSetAlpha[4];
	
	WK7JObj* GetOpenPicObj(void);
	WK7JObj* GetClosePicObj(void);
	WK7JObj* GetOpenModelObj(void);
	WK7JObj* GetCloseModelObj(void);
	WK7JObj* GetItemObj(void);
	bool OverlapHangingScroll(void);
	
	K7Stage106M00();
	K7Stage106M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage106M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool SetCurrentCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
	virtual bool HitObjCallBack    (WK7HitObjInfo    &);
};

#ifdef	__K7STAGE106M00_CPP__

enum K7STAGE106M00_ONESHOTCAM{
	EVENT_015200,
	EVENT_015200_2,
	EVENT_015201,
	EVENT_015202,
	CAM106M00_HS_PRESEN_START,
	CAM106M00_HS_PRESEN_END,
};

K7StageEventOneShotCamera	K7Stage106M00_Camera[] = {
	{{85.763f, 6.327f, 28.112f},{84.337f, 6.609f, 30.146f}},			// 
//	{{89.818f, 5.041f, 22.268f},{83.822f, 7.965f, 27.535f}},			// 
//	{{94.626f, 5.527f, 19.002f},{75.471f, 9.302f, 31.678f}},			// 
	{{0.754f, 11.836f, 23.994f},{8.903f, 11.587f, 26.401f}},			// |
	{{-5.778f, 8.477f, 20.594f},{16.225f, 12.932f, 26.746f}},			// |
	{{-5.778f, 8.477f, 20.594f},{16.225f, 12.932f, 26.746f}},			// e
	{{9.028f, 4.404f, 469.210f},{-14.204f, 5.813f, 468.870f}},			// HSЉp
	{{91.685f, 4.404f, 469.320f},{68.453f, 5.813f, 468.980f}},			// HSЉpY[
	
//	{{-15.778f, 7.700f, -19.280f},{13.897f, 9.959f, -26.400f}},			// ǔvɓꂽƂ̉o
};

enum{
	K7STAGE106M00_MES_BLOOM_FLOWER = 0			,		// |̉Ԃ炢
	K7STAGE106M00_MES_DEAD_FLOWER				,		// |̉Ԃ͌͂Ă
	K7STAGE106M00_MES_DEAD_FLOWER2				,		// Ԃ͂Ă
	K7STAGE106M00_MES_GET_MIRACLE_OBJ			,		// svcȑ`肵
	K7STAGE106M00_MES_USE_WATER_RING			,		// ̎wւK
};

#endif

#endif	//__K7STAGE106M00_H__

