////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage109M00
//
// K7Stage109M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE109M00_CPP__

#include ".\K7Stage109M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn01.h"

K7Stage109M00::K7Stage109M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
}

K7Stage109M00::~K7Stage109M00()
{
}

bool K7Stage109M00::SetCurrentCallBack(void)
{
	return true;
}

bool K7Stage109M00::CondChangeCallBack(void)
{
	if( K7SCR_EVHASITEM(K7EVITEM_KEY(010002))==true ){
		K7SCR_EVNO_SETENABLE(K7EVENTNO(010400),false);
	}else{
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010401)==TRUE &&
		    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010402)==TRUE &&
		    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010403)==TRUE ){
			K7SCR_EVNO_SETENABLE(K7EVENTNO(010400),true);
		}else{
			K7SCR_EVNO_SETENABLE(K7EVENTNO(010400),false);
		}
	}
	return true;
}

bool K7Stage109M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(010400):
		// U
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010401)==TRUE &&
		    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010402)==TRUE &&
		    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010403)==TRUE ){
			// JMɓꂽ
			K7SCR_EVSETITEM(K7EVITEM_KEY(010002),true);
			
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
			// Jς
			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
			WK7CAM->SetPosition      (K7Stage109M00_Camera[EVENT_010400].pos);
			WK7CAM->SetTargetPosition(K7Stage109M00_Camera[EVENT_010400].tgt);
			K7SCR_PC_SETVISIBLE(false);
			
			gpSound->mPlaySE(SFX_SYS_TRUE);
			
			K7SCR_STGC_MESSAGE_B(K7STAGE109M00_MES_GET_KEY);			// uq̌vɓꂽ
			
			K7SCR_PC_RETURNVISIBLE();
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
		}
		K7SCR_EVCONDCHANGE();
		break;
	case	K7EVENTNO(010401):
		// FP
		K7SCR_PANEL_SETPANELID_NOPARAM(ePanel010401);
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		if( K7SCR_PANEL_GETRESULT() > 0 ){
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010401);
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010401)==TRUE &&
			    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010402)==TRUE &&
			    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010403)==TRUE ){
				gpSound->mPlaySE(SFX_SYS_TRUE);
			}
		}
		K7SCR_RETSYS();
		K7SCR_PANEL_EXIT();
		K7SCR_EVCONDCHANGE();
		break;
	case	K7EVENTNO(010402):
		// FQ
		K7SCR_PANEL_SETPANELID_NOPARAM(ePanel010402);
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		if( K7SCR_PANEL_GETRESULT() > 0 ){
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010402);
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010401)==TRUE &&
			    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010402)==TRUE &&
			    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010403)==TRUE ){
				gpSound->mPlaySE(SFX_SYS_TRUE);
			}
		}
		K7SCR_RETSYS();
		K7SCR_PANEL_EXIT();
		K7SCR_EVCONDCHANGE();
		break;
	case	K7EVENTNO(010403):
		// FR
		K7SCR_PANEL_SETPANELID_NOPARAM(ePanel010403);
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		if( K7SCR_PANEL_GETRESULT() > 0 ){
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010403);
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010401)==TRUE &&
			    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010402)==TRUE &&
			    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010403)==TRUE ){
				gpSound->mPlaySE(SFX_SYS_TRUE);
			}
		}
		K7SCR_RETSYS();
		K7SCR_PANEL_EXIT();
		K7SCR_EVCONDCHANGE();
		break;
	default:
		break;
	}
	return true;
}

