////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage110M00
//
// K7Stage110M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE110M00_CPP__

#include ".\K7Stage110M00.h"
//#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn01.h"
#include "..\..\..\Yam\YK7EffectModelFire.h"

K7Stage110M00::K7Stage110M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage110M00_Camera);
}

K7Stage110M00::~K7Stage110M00()
{
}

bool K7Stage110M00::InitializeCallBack(void)
{
	WK7JObj		*pObj = GetJObj("burn");
	if( pObj!=NULL ){
		pObj->Hide(false,true);
		CreateEffectModelFire(pObj,MFIRE_WALL);
	}
	return true;
}

bool K7Stage110M00::SetCurrentCallBack(void)
{
	return true;
}

bool K7Stage110M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
//	case	K7EVENTDOOR(010004):
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_DRFL_010004)!=TRUE ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_010004 Closed");
//			
//			K7SCR_ENTER_PLAYMODE();
//			K7SCR_ENTER_DEMOPAUSE();
//			
//			// Jς
//			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//			WK7CAM->SetPosition      (K7Stage110M00_Camera[DOOR_010004].pos);
//			WK7CAM->SetTargetPosition(K7Stage110M00_Camera[DOOR_010004].tgt);
//			K7SCR_PC_SETVISIBLE(false);
//			
//			K7SCR_STGC_MESSAGE_B(K7STAGE110M00_MES_DONT_OPEN_THIS_SIDE);
//			
//			K7SCR_PC_RETURNVISIBLE();
//			K7SCR_EXIT_PLAYMODE();
//			K7SCR_EXIT_DEMOPAUSE();
//			
//			K7SCR_EVCONDCHANGE();
//			return false;
//		}
//		break;
	case	K7EVENTDOOR(010005):
//		if( K7SCR_EVHASITEM(K7EVITEM_KEY(010003))==false ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_010005 Closed : need KEY_010003");
//			
//			K7SCR_ENTER_PLAYMODE();
//			K7SCR_ENTER_DEMOPAUSE();
//			
//			// Jς
//			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//			WK7CAM->SetPosition      (K7Stage110M00_Camera[DOOR_010005].pos);
//			WK7CAM->SetTargetPosition(K7Stage110M00_Camera[DOOR_010005].tgt);
//			K7SCR_PC_SETVISIBLE(false);
//			
//			K7SCR_STGC_MESSAGE_B(K7STAGE110M00_MES_LOCKED_KEY);
//			
//			K7SCR_PC_RETURNVISIBLE();
//			K7SCR_EXIT_PLAYMODE();
//			K7SCR_EXIT_DEMOPAUSE();
//			
//			K7SCR_EVCONDCHANGE();
//			return false;
//		}
		u32		no = K7EVENTPLAY(01050102);
		if( WK7Play::HasPlayed(no)==false ){
			
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
#if 0
			K7SCR_PLAY_INIT_KEEP_PLAYER();
			K7SCR_PLAY_CREATE(no);
			K7SCR_PLAY_LOADWAIT(no);
			K7SCR_PLAY_PREPARE(no);
			K7SCR_PLAY_PREPAREWAIT(no);
			K7SCR_PLAY_START(no);
			K7SCR_PLAY_PLAYWAIT(no);
//			K7SCR_PLAY_RELEASE(no);
			K7SCR_PLAY_TERM();
#endif
			
			K7SCR_PLAY_INIT();
			K7SCR_PLAY_START_B(no);
			K7SCR_PLAY_TERM();
			
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
		}else{
			DoorError(DOOR_010005,K7STAGE110M00_MES_LOCKED_DOOR);
		}
		return false;
	case	K7EVENTDOOR(010006):
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_DRFL_010005)!=TRUE ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_010008 Closed");
//			
//			K7SCR_ENTER_PLAYMODE();
//			K7SCR_ENTER_DEMOPAUSE();
//			
//			// Jς
//			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//			WK7CAM->SetPosition      (K7Stage110M00_Camera[DOOR_010006].pos);
//			WK7CAM->SetTargetPosition(K7Stage110M00_Camera[DOOR_010006].tgt);
//			K7SCR_PC_SETVISIBLE(false);
//			
//			K7SCR_STGC_MESSAGE_B(K7STAGE110M00_MES_LOCKED_DOOR);
//			
//			K7SCR_PC_RETURNVISIBLE();
//			K7SCR_EXIT_PLAYMODE();
//			K7SCR_EXIT_DEMOPAUSE();
//			
//			K7SCR_EVCONDCHANGE();
//			return false;
//		}else{
//			// Jf
//			if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_DRFL_010006)==false ){
//				
//				K7SCR_SET_SCENARIO_FLAG(K7SCN01_DRFL_010006);
//				
//				K7SCR_ENTER_PLAYMODE();
//				K7SCR_ENTER_DEMOPAUSE();
//				
//				// Jς
//				WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//				WK7CAM->SetPosition      (K7Stage110M00_Camera[DOOR_010006].pos);
//				WK7CAM->SetTargetPosition(K7Stage110M00_Camera[DOOR_010006].tgt);
//				K7SCR_PC_SETVISIBLE(false);
//				
//				gpSound->mPlaySE(SFX_SYS_EV_CLEAR);
//				
//				K7SCR_STGC_MESSAGE_B(K7STAGE110M00_MES_UNLOCKED_HANARE);
//														// ̃bNOꂽ
//				
//				K7SCR_PC_RETURNVISIBLE();
//				K7SCR_EXIT_PLAYMODE();
//				K7SCR_EXIT_DEMOPAUSE();
//			}
//		}
		if( WK7Play::HasPlayed(K7EVENTPLAY(01050102))==true ){
			break;
		}
		DoorError(DOOR_010006,K7STAGE110M00_MES_LOCKED_DOOR);
		return false;
	default:
		break;
	}
	return true;
}

