////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage115M01 LXMOL
//
// K7Stage115M01.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/31/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE115M01_CPP__

#include "..\..\..\Scn\K7Scn01.h"
#include ".\K7Stage115M01.h"
//#include "..\..\..\Wat\WK7Event.h"

K7Stage115M01::K7Stage115M01(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage115M01_Camera);
}

K7Stage115M01::~K7Stage115M01()
{
}


/*
	
	
	
*/
bool K7Stage115M01::InitializeCallBack(void)
{
	return true;
}

/*
	
	Jg
	
	
*/
bool K7Stage115M01::SetCurrentCallBack(void)
{
	if( WK7PLAYERCONTROL->GetMainID()!=K7HAC ||
	    GetPrevStageID() != K7STGID(182,0) ){
		return true;
	}
	
	SetManualBranch(true);
	while( WK7Stage::IsChanging()==true ){
		K7SCR_RETSYS();
	}
	
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	WK7StagePlaceInfo		*pPlaceInfo;
	pPlaceInfo = GetPlaceInfo("branchB");
	SetCameraStartPosition(pPlaceInfo);
	while( SandRelease(pPlaceInfo)==false ){
		K7SCR_RETSYS();
	}
	
	u32	pcid = GetAlivePcID(K7MSK);
	
	FixCam( CHANGE_CHARA );
	K7SCR_TIMEWAIT( 4800 * 2 );
	WatchCameraB( K7Stage115M01_Camera[CHANGE_CHARA_1].tgt,
				  K7Stage115M01_Camera[CHANGE_CHARA_1].pos,
				  K7CHRID(pcid,0), 1 );
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	SetManualBranch(false);
	
	return true;
}

