////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage117M00
//
// K7Stage117M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE117M00_H__
#define	__K7STAGE117M00_H__

#include "..\K7Stage.h"
#include "..\..\..\Wat\WK7Player.h"
#include "..\..\..\Enm\EnmK.h"

class K7Stage117M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	WK7RenderObjEffect		*mpRainEffect;
	
	K7Stage117M00();
	K7Stage117M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	K7EnmK	*pNpcSu;
public:
	virtual ~K7Stage117M00();
	
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool BpLeaveCallBack   (WK7BpInfo        &);
	virtual bool SpAbilityCallBack (WK7SpAbilityInfo &);
	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &);
	virtual bool ZanEventCallBack  (WK7ZanEventInfo  &);
	virtual bool EventCallBack     (WK7EventInfo     &);
	
	virtual bool SetCurrentCallBack(void);
	virtual bool HitObjCallBack    (WK7HitObjInfo &);
};

#ifdef	__K7STAGE117M00_CPP__

enum K7STAGE117M00_ONESHOTCAM{
	SECTRET_0,
	SECTRET_1,
	SECTRET_2,
	SECTRET_3,
	SECTRET_4,
	JUMP_0,
	JUMP_1,
};

K7StageEventOneShotCamera K7Stage117M00_Camera[] = {
	// JGfE
	{{-446.358f, 5.766f, -636.577f},{-455.830f, 2.165f, -631.140f}},
	{{-453.876f, 1.511f, -640.149f},{-461.355f, -2.200f, -648.057f}},
	{{-471.627f, 1.511f, -631.705f},{-479.106f, -2.200f, -639.613f}},
	{{-442.489f, 7.461f, -621.019f},{-451.830f, 2.600f, -616.398f}},
	{{-439.435f, 3.725f, -641.596f},{-431.048f, -0.392f, -648.301f}},
	// R[eWv
	{{-40.465f, 5.884f, -642.240f},{-36.453f, 0.859f, -634.581f}},
//	{{-24.485f, 43.193f, -655.913f},{-2.469f, 46.638f, -659.366f}},
	{{-24.308f, 45.168f, -667.950f},{-1.856f, 44.472f, -669.191f}},
};

enum{
	K7STAGE117M00_MES_JUMP = 0			,		// ɏ
};

#endif

#endif	//__K7STAGE117M00_H__

