////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage118M00
//
// K7Stage118M00.cpp		Ln@t@gX}C
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/14/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE118M00_CPP__

#include "..\..\Scn\K7Scn01.h"
#include ".\K7Stage118M00.h"
#include "..\..\info\K7StageSoundInfo.h"
#include "..\..\Wat\WK7CharaPresent.h"

K7Stage118M00::K7Stage118M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage118M00_Camera);
	GameInfo.SetMenuMapEnable(false);
}

K7Stage118M00::~K7Stage118M00()
{
	GameInfo.SetMenuMapEnable(true);
	GameInfo.SetBossFlag(false);
	WK7PLAYERCONTROL->BattlePadRegulationClear();
}

bool K7Stage118M00::InitializeCallBack(void)
{
	WK7Npc	*pEnemy = WK7Npc::Find(K7STAGE118M00_KIHAN_HS);
	
	if( WK7Npc::GetEnemyDieTest(K7STAGE118M00_KIHAN_HS)==false ){
		// LnX}C͐Ă	}jAu`ݒ
		SetManualBranch( true );
	}
	return true;
}


bool K7Stage118M00::SetCurrentCallBack(void)
{
	WK7Npc	*pEnemy = WK7Npc::Find(K7STAGE118M00_KIHAN_HS);
	
	if( WK7Npc::GetEnemyDieTest(K7STAGE118M00_KIHAN_HS)==true ){
		// t@gX}C͎ł
		//ȍĐ
		gpSound->mSetDspRateAll(K7SOUND_REVERB_SML);
		gpSound->mPlayStreamNo( HPS_SPEED_HS );
		return true;
	}else{
		/// LA
		WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_BOSSBATTLE);
	}

	GameInfo.SetBossFlag(true);
	
	if( pEnemy != NULL ){
		
		while( pEnemy->GetNpcState() == NPC_STATE_INIT ){
			K7SCR_RETSYS();
		}
		
		// ȍĐ
		gpSound->mSetDspRateAll(K7SOUND_REVERB_SML);
		gpSound->mPlayStreamNo( HPS_SPEED_HS );
		
		while( WK7Stage::IsChanging() != false ){
			K7SCR_RETSYS();
		}
		
		//inGame~
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_KIHAN_HS_FUK) == false ){
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_KIHAN_HS_FUK);
			
			// Ln叉߂
			
			KihanDemoFirst(pEnemy, HS_POS0, HS_POS1, 0,  253,  202,  -8,  73, 774, 100,
			1	);
			
		}else{
			
			// LnQڈȍ~
			
			KihanDemo(K7STAGE118M00_KIHAN_HS, HS_RETURN);
			
		}
		
		// {XsJn
		while( pEnemy->KihanBoss_AiRun() == false ){
			K7SCR_RETSYS();
		}
		
		K7SCR_PC_SETVISIBLE(true);
		SetCameraStartPosition(WK7Stage::GetCurrentStageBpName());
		//JPCtH[ɖ߂
		WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
		
		K7SCR_RETSYS();
		K7SCR_CHARAPRESENT_DEBUGEND();
		K7SCR_TIMEWAIT(K7SCR_CP_RELEASETIME);
		
		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
	}
	
	// }jAu`NA
	SetManualBranch( false );
	
	return false;
}

bool K7Stage118M00::DieNpcCallBack(WK7DieNpcInfo &info)
{
	if( info.mpNpc==NULL ){
		return true;
	}
	switch( info.mpNpc->GetEneNo() ){
	case	K7STAGE118M00_KIHAN_HS:
		if ( info.mpNpc->GetDieMode() != NPC_DIE_JIBAKU ){
			gpSound->mSetDspRateAll(K7SOUND_REVERB_SML);
			//gpSound->mPlayStreamNo( HPS_SAFE_PLACE );
		}
		GameInfo.SetBossFlag(false);
		K7SCR_EVCONDCHANGE();
//		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(015003),true);
		break;
	default:
		break;
	}
	return true;
}

bool K7Stage118M00::CondChangeCallBack(void)
{
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(015003),WK7Npc::GetEnemyDieTest(K7STAGE118M00_KIHAN_HS)==true);
	return true;
}

