////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage133M00
//
// K7Stage133M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE133M00_H__
#define	__K7STAGE133M00_H__

#include "..\K7Stage.h"
#include "..\..\..\Wat\WK7Player.h"
#include "..\..\..\Enm\EnmK.h"

class K7Stage133M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage133M00();
	K7Stage133M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	bool mDeskOpen;
	bool DeskOpen(int se);
	K7EnmK	*pNpcSu;
public:
	virtual ~K7Stage133M00();
	virtual bool CreateCallBack    (void);
	virtual bool TerminateCallBack (void);
	virtual bool InitializeCallBack(void);
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &);		// hACxg
	virtual bool EventCallBack     (WK7EventInfo     &);		// Cxg
	virtual bool SetCurrentCallBack(void);
	virtual bool SpAbilityCallBack(WK7SpAbilityInfo &info);
	virtual bool CondChangeCallBack(void);
	virtual bool BpLeaveCallBack(WK7BpInfo &info);
	virtual bool PathChangeCallBack(WK7PathChangeInfo     &);		// pXύX

//	virtual bool InitializeCallBack(void)              { return true; }		// iǂݍݏÎɑ΂鏉j
//	virtual bool TerminateCallBack (void)              { return true; }		// Iȉj
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
	virtual bool HitObjCallBack    (WK7HitObjInfo    &);
};

#ifdef __K7STAGE133M00_CPP__


enum K7STAGE133M00_ONESHOTCAM{
	ONESHOTCAM_011502_RESULT,
	ONESHOTCAM_011506,
	JUMP_0,
	JUMP_1,
	ONESHOTCAM_011601,
	CAM133M00_HS_PRESEN_START,
	CAM133M00_HS_PRESEN_END,
};


K7StageEventOneShotCamera K7Stage133M00_Camera[] = {
	{{74.037f, 6.038f, -12.982f},{78.189f, 13.208f, -22.293f}},				// e
	{{366.912f, 17.508f, 64.315f},{357.304f, 16.815f, 76.681f}},			// npl
	{{248.804f, 8.652f, -207.707f},{254.927f, 2.002f, -186.515f}},			// Wv
	{{222.689f, 47.039f, -223.332f},{212.185f, 60.885f, -236.197f}},		// Wv
	{{234.451f, 36.771f, -261.984f},{225.726f, 48.079f, -257.188f}},		// `
	{{265.039f, 9.695f, -98.078f},{288.279f, 10.943f, -98.496f}},			// HSЉp
	{{165.043f, 12.259f, -96.929f},{188.283f, 13.506f, -97.347f}},			// HSЉpY[
};

#endif

#endif	//__K7STAGE133M00_H__

