////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage134M00 prSKL   
//
// K7Stage134M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE134M00_CPP__

#include "..\..\..\Scn\K7Scn01.h"
#include "..\..\..\Wat\WK7Event.h"
#include ".\K7Stage134M00.h"
#include "..\..\..\Matsu\MK7Sound.h"
#include "..\..\..\Panel\SK7PanelIno.h"
//#include "..\..\..\Panel\SK7PanelShika.h"
//#include "..\..\..\Panel\SK7PanelCho.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"

// [V
#define	MOT134M00_00	(0)		//Gx[^̔J
#define	MOT134M00_01	(1)		//Gx[^̔

#define MOT134M00_DESKOPEN	(3)				// Jiej
#define MOT134M00_MONCLOSE	(4)				// 傪܂
#define MOT134M00_MONOPEN	(5)				// 傪J

// f
#define MDL134M00_DESK			"Drawer"			// o
#define MDL134M00_CAGE			"Cage"				// Siq
#define MDL134M00_ELEVATORDOOR	"ElevatorGroup01"	// Gx[^[̃hA
#define MDL134M00_LASER			"LaserBeam"			// [U[
#define MDL134M00_TAMA			"tama_011601"

// bZ[W
#define MES134M00_INOPOSTER		(0)			// CmVVr[̃|X^[\Ă
#define MES134M00_SHIKAPOSTER	(1)			// orr[̃|X^[\Ă
#define MES134M00_TYOUPOSTER	(2)			// `Er[̃|X^[\Ă

// pX
//#define PATH134M00_CENCER		"event_011611_0"			// ZT[̕pX
#define PATH134M00_CENCER		"PASS_CAGE"					// ZT[̕pX


// En
//	#define	K7STAGE134M00_CLOSE_PATHNAME		"PASS_KED"				// pXO
//	#define	K7STAGE134M00_RIDDLE_PATHNAME		"event_011613_0"		// JpXO
//	#define	K7STAGE134M00_BROKEN_NAME			"event_011613_ked"		// ǂ̖O

#define	K7STAGE134M00_LASER_PATHNAME		"event_011611_0"		// [U[̌ŒJ


K7Stage134M00::K7Stage134M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mDeskOpen = false;
	mDoorMode = 0;
	SetOneShotCamLocTbl(K7Stage134M00_Camera);
}

K7Stage134M00::~K7Stage134M00()
{
}


/*
	
	NGCg
	
*/
bool K7Stage134M00::CreateCallBack(void)
{
	//[Vt@C
	CreateOwnStageMotion( MOT134M00_00 );
	CreateOwnStageMotion( MOT134M00_01 );
	
	CreateOwnStageMotion(MOT134M00_DESKOPEN);
	CreateOwnStageMotion(MOT134M00_MONOPEN);
	CreateOwnStageMotion(MOT134M00_MONCLOSE);
	//LLGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	return true;
}

bool K7Stage134M00::TerminateCallBack(void)
{
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	return true;
}

/*
	
	Jg
	
*/
bool K7Stage134M00::SetCurrentCallBack(void)
{
	SetCurrentCallBackDefaultProc();
	
	// SiqĎ
	while( K7SCR_STG_GET_CURRENTID() == K7STGID(134,0) ){
		
		BrockadePath();
		
		K7SCR_RETSYS();
	}
	
	return true;
}

/*
	
	
	
*/
bool K7Stage134M00::InitializeCallBack(void)
{
	K7SCR_EVCONDCHANGE();
	return true;
}

bool K7Stage134M00::CondChangeCallBack(void)
{
	WK7JObj *pJObj;
	
	DeskOpen(0);
	ReleaseTamaEffect();
	if( PanelAllOKTest() == true ){									// SẴplI
		if ( K7SCR_EVHASITEM(K7EVITEM_TAMA(011601)) == false ){		// eO
			K7SCR_EVNO_SETENABLE(K7EVITEM_TAMA(011601),  true);
			CreateTamaEffect(K7EVITEM_TAMA(011601));
		}else{
			if( (pJObj=GetJObj(MDL134M00_TAMA)) != NULL ){
				pJObj->Hide(false,true);									// e
			}
			K7SCR_EVNO_SETENABLE(K7EVITEM_TAMA(011601),  false);
		}
	}else{
		K7SCR_EVNO_SETENABLE(K7EVITEM_TAMA(011601),  false);
	}
	
	// EVENT_011602 ̂pl
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011602)==TRUE ){		// I
		K7SCR_EVNO_SETENABLE(K7EVENTNO(011602), false);				// ̃Cxg֎~
	}else{
		K7SCR_EVNO_SETENABLE(K7EVENTNO(011602), true);
	}
	
	// EVENT_011603 pl
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011603)==TRUE ){		// I
		K7SCR_EVNO_SETENABLE(K7EVENTNO(011603), false);				// ̃Cxg֎~
	}else{
		K7SCR_EVNO_SETENABLE(K7EVENTNO(011603), true);
	}
	
	// EVENT_011604 傤pl
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011604)==TRUE ){		// I
		K7SCR_EVNO_SETENABLE(K7EVENTNO(011604), false);				// ̃Cxg֎~
	}else{
		K7SCR_EVNO_SETENABLE(K7EVENTNO(011604), true);
	}
	
	// [U[
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011605_LASER)==TRUE ){
		
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE134M00_LASER_PATHNAME,true);			// J
		
		WK7JObj *pJObj = GetJObj(MDL134M00_LASER);
		if ( pJObj != NULL ){
			pJObj->Hide(false, true);
		}
	}

//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011613)==TRUE ){
//			K7SCR_STG_SET_PATHENABLE       (K7STAGE134M00_CLOSE_PATHNAME ,true);
//			K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE134M00_RIDDLE_PATHNAME,true);
//			HideJObj(K7STAGE134M00_BROKEN_NAME, false, true);
//		}else{
//			K7SCR_STG_SET_PATHENABLE       (K7STAGE134M00_CLOSE_PATHNAME ,false);
//			K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE134M00_RIDDLE_PATHNAME,false);
//			DispJObj(K7STAGE134M00_BROKEN_NAME, false, true);
//		}
	return true;
}




bool K7Stage134M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTDOOR(011601):
		if ( false == K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011605_LASER) ){
			// L|[Y
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
			FixCam( ONESHOTCAM_LASEROFF );
			
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
			
			// [U[
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011605_LASER);
			K7SCR_EVCONDCHANGE();
			
			gpSound->mPlaySE(SFX_SCE1_KAKU_LASER_STOP);							// [U[
			
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
			
			//L|[Y
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
		}
		break;
	}
	return true;
}

/*
	
	Cxg
	
*/
bool K7Stage134M00::EventCallBack(WK7EventInfo &info)
{
//	u32 mesNo, camNo;
	bool panelOK = false;
	s32  result;

	switch( info.mEventNo ){
	// EVENT_011602 ̂pl
	case	K7EVENTNO(011602):
		K7SCR_PANEL_SETPANELID_NOPARAM(ePanel011602);
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		if( (result = K7SCR_PANEL_GETRESULT()) == INO_OK ){				// I
			panelOK = true;
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011602);
			K7SCR_EVNO_SETENABLE(K7EVENTNO(011602), false);				// ̃Cxg֎~
		}
		K7SCR_RETSYS();
		if ( (true == panelOK) && (true == PanelAllOKTest()) ){
			FixCam(ONESHOTCAM_DESK);
		}
		K7SCR_PANEL_EXIT();
		K7SCR_EVCONDCHANGE();
		break;
	// EVENT_011603 pl
	case	K7EVENTNO(011603):
		K7SCR_PANEL_SETPANELID_NOPARAM(ePanel011603);
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		if( (result = K7SCR_PANEL_GETRESULT()) == 1 ){			// I
			panelOK = true;
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011603);
			K7SCR_EVNO_SETENABLE(K7EVENTNO(011603), false);				// ̃Cxg֎~
		}
		K7SCR_RETSYS();
		if ( (true == panelOK) && (true == PanelAllOKTest()) ){
			FixCam(ONESHOTCAM_DESK);
		}
		K7SCR_PANEL_EXIT();
		K7SCR_EVCONDCHANGE();
		break;
	// EVENT_011604 傤pl
	case	K7EVENTNO(011604):
		K7SCR_PANEL_SETPANELID_NOPARAM(ePanel011604);
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		if( (result = K7SCR_PANEL_GETRESULT()) == 1 ){				// I
			panelOK = true;
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011604);
			K7SCR_EVNO_SETENABLE(K7EVENTNO(011604), false);				// ̃Cxg֎~
		}
		K7SCR_RETSYS();
		if ( (true == panelOK) && (true == PanelAllOKTest()) ){
			FixCam(ONESHOTCAM_DESK);
		}
		K7SCR_PANEL_EXIT();
		K7SCR_EVCONDCHANGE();
		break;
	}
	
	// eCxg̍쓮`FbN
	if ( (true == panelOK) && (true == PanelAllOKTest()) ){
		
		K7SCR_PANEL_EXITWAIT();
		
		// L|[Y
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE(true);									// l
		
		gpSound->mPlaySE(SFX_SYS_EV_CLEAR);							// 
		DeskOpen(1);
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
		gpSound->mPlaySE(SFX_SYS_CAMERA_ZOOM);						// Y[op SE
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
		
		// L|[Y
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_EXIT_PLAYMODE();
		K7SCR_PC_SETVISIBLE(true);									// l\
	}
	
	return false;
}


/*	
	
	
	qbgIuWF
	
	
*/
bool K7Stage134M00::HitObjCallBack(WK7HitObjInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(011609):						// |^N
		Vec Pos0 = {212.503f, 0.101f, -116.431f};
		BombObj(info.mpJObj, K7STG_DEFAULT_BOMBOBJ_DIST, &Pos0);
		return false;
		break;
	case	K7EVENTNO(011610):						// |^N
		Vec Pos = {170.203f, 0.101f, -117.812f};
		BombObj(info.mpJObj, K7STG_DEFAULT_BOMBOBJ_DIST, &Pos);
		return false;
		break;
	}
	return true;
}


/*
	
	J
	
*/
bool K7Stage134M00::DeskOpen(int se)
{
	WK7JObj		*pJObj;
	
	if ( false == PanelAllOKTest() ) return false;
	
	if ( mDeskOpen == false ){
		mDeskOpen = true;
	}else{
		return false;
	}
	
	if( (pJObj=PlayMotion(MDL134M00_DESK, MOT134M00_DESKOPEN))!=NULL ){
		pJObj->SetMotionLoop(false);
		if ( se ){
			gpSound->mPlaySE(SFX_SCE1_KAKU_HIKIDASHI_OPEN);			// J
		}
		
		while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){
			K7SCR_RETSYS();
		}
		return true;
	}
	return false;
}


/*
	
	
	ׂẴplǂH
	
	
*/
bool K7Stage134M00::PanelAllOKTest(void)
{
	if(	(K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011602)==TRUE)
	&&	(K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011603)==TRUE)
	&&	(K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011604)==TRUE)
	){
		K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_01160X_ALL);					// ACRǗpƂėĂ
		return true;
	}else{
		return false;
	}
}


//------------------------------------------------------------------------------
//_o
//------------------------------------------------------------------------------
bool K7Stage134M00::BpLeaveCallBack( WK7BpInfo &info )
{
	u32	evno   = GetBpEventNo( info );
	int	pathNo = GetBpPathNo( info );
	if( evno==0xffffffff )
		return( true );
	
	switch( evno ){
	//ZT[O
	case	K7EVENTNO(011611):
		//PrœłȂΖ߂
		if ( WK7PLAYERCONTROL->SpAtkKvnTest() == false ){
			if ( !pathNo ){
				// ̂ق֍s
				//pX
				K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011611_PATH);			// pX
			}else{
				// ̂߂
				//pX
				K7SCR_RESET_SCENARIO_FLAG(K7SCN01_EVFL_011611_PATH);		// pX
			}
		}else{
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011611);					// PrŃpXʂ܂B
		}
		
		//L|[Y
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		if( true == BrockadePath() ){										// ̊J߂sꂽꍇ
			//JύX
//			FixCam( CAM035004GARAGE );
		}
		
		//L|[Y
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		
		break;
	//ftHg
	default:
		break;
	}
	
	return( true );
}


//------------------------------------------------------------------------------
//pX
//------------------------------------------------------------------------------
bool K7Stage134M00::BrockadePath(void)
{
	WK7PathNurbs*	pPath = GetPathNurbs(PATH134M00_CENCER);
	
	if( (K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011611_PATH) == true)
	&&	(K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011605_LASER) == false)				// [U[󂳂ĂȂ
	){
		//pX𕕍
		if( pPath != NULL ){
			pPath->SetEnable( false );
			pPath->SetEnableEx( false );
		}
		return DoorLockB(1);
	}else{
		if( pPath != NULL ){
			pPath->SetEnable( true );
			pPath->SetEnableEx( true );
		}
		return DoorLockB(0);
	}
}

//------------------------------------------------------------------------------
//hAbN[VĐ
//------------------------------------------------------------------------------
bool K7Stage134M00::DoorLockB(int mode)
{
	WK7JObj*	pJObj;

	if ( mode ){
		// ܂
		if ( mDoorMode != mode ){
			mDoorMode = mode;
			if( (pJObj = PlayMotion(MDL134M00_CAGE, MOT134M00_MONCLOSE)) != NULL ){
				
				FixCam( ONESHOTCAM_SAKUCLOSE );
				
				gpSound->mPlaySE(SFX_SCE1_KAKU_SAKU_CLOSE);
				
				pJObj->SetMotionLoop( false );
				while( pJObj->GetMotionState() != WK7MODEL_NOANIM )
				{
					K7SCR_RETSYS();
				}
			}
			return true;
		}
	}else{
		// J
		if ( mDoorMode != mode ){
			mDoorMode = mode;
			if( (pJObj = PlayMotion(MDL134M00_CAGE, MOT134M00_MONOPEN)) != NULL ){
				
				FixCam( ONESHOTCAM_SAKUCLOSE );
				
				gpSound->mPlaySE(SFX_SCE1_KAKU_SAKU_OPEN);
				
				pJObj->SetMotionLoop( false );
				while( pJObj->GetMotionState() != WK7MODEL_NOANIM )
				{
					K7SCR_RETSYS();
				}
			}
			return true;
		}
	}
	return false;
}

/*
	
	G񂾂R[
	
*/
bool K7Stage134M00::DieNpcCallBack(WK7DieNpcInfo &info)
{
	WK7Npc *pNpc = info.mpNpc;
	
	if ( ENENO_1_134M00_3_KEY == pNpc->GetEneNo() ){		// G|bvp
		K7SCR_SET_SCENARIO_FLAG(K7SCN01_ENFL_POP3);
		return false;
	}
	
	return true;
}





