////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage135M00 prTK
//
// K7Stage135M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE135M00_CPP__

#include "..\..\..\Scn\K7Scn01.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Matsu\MK7Sound.h"
#include "..\..\..\sato\SK7SpecialData.h"

#include ".\K7Stage135M00.h"

// [V
#define	MOT135M00_00					(0)		//Gx[^̔J
#define	MOT135M00_01					(1)		//Gx[^̔
#define MOT135M00_SHEETBROW				(3) 	 //łV[g
#define MOT135M00_MONINIT				(6)		// 傪܂܁il

// f
#define MDL135M00_ELEVATORDOOR			"ElevatorGroup01"		// Gx[^[̃hA
#define MDL135M00_SHEET					"Sheet01"				// V[g

// [V
// bZ[W
#define MES135M00_USERING				(0)		// ̎wւK

K7Stage135M00::K7Stage135M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
//	mSheetOpen = false;
	SetOneShotCamLocTbl(K7Stage135M00_Camera);
}

K7Stage135M00::~K7Stage135M00()
{
}

/*
	
	NGCg
	
*/
bool K7Stage135M00::CreateCallBack(void)
{
	//[Vt@C
	CreateOwnStageMotion( MOT135M00_00 );
	CreateOwnStageMotion( MOT135M00_01 );
	CreateOwnStageMotion( MOT135M00_SHEETBROW );
	CreateOwnStageMotion( MOT135M00_MONINIT );
	return true;
}

bool K7Stage135M00::CondChangeCallBack(void)
{
	K7SCR_STG_SET_JUNCTION_PASS_EVNO(K7EVENTNO(011701));
	return true;
}


/*
	
	Jg
	
*/
bool K7Stage135M00::SetCurrentCallBack(void)
{
	WK7JObj		*pJObj;

	// V[gƂς
	if ( true == K7SCR_GET_SCENARIO_FLAG(K7SCN01_DRFL_011701) ){
		// IuWF
		if( (pJObj=GetJObj(MDL135M00_SHEET)) != NULL )
		{
			pJObj->Hide( false, true );
		}
	}
	
	//136M00痈ꍇ̓Gx[^Cxg
	if( GetPrevStageID() == K7STGID(136,0) ){
		
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		while( IsChanging()==true ){
			K7SCR_RETSYS();
		}
		{
			WK7JObj*	pJObj;
			if( (pJObj = PlayMotion(MDL135M00_ELEVATORDOOR, MOT135M00_MONINIT)) != NULL ){
				pJObj->SetMotionLoop( false );
			}
		}
		ElevGetOff( ELEV_CAMERA_POS, ELEV_PLAYER_POS, MDL135M00_ELEVATORDOOR, MOT135M00_00, 0, SFX_SCE1_ELV_OPEN );
		
		WK7Stage::SetCurrentPath(	WK7Stage::GetPathNurbsAll("ElevatorPath"),
									1.f,
									1,									// Back
	//								WK7PATHINFO_INITDIR_TGTDIR			// 
									WK7PATHINFO_INITDIR_TGTDIR_REV		// wォ
		);
		
		// ŒJ̐ݒ
		WK7StagePlaceInfo		*pPlaceInfo;
		pPlaceInfo = GetPlaceInfo(mID,"curve10");
		SetCameraStartPosition(pPlaceInfo);
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		SandRelease(pPlaceInfo);
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			GHMGCTASK_RETSYS();
		}
		WK7PLAYERPATHCONTROL->SetBranchPointFix(false);
		WK7PLAYERPATHCONTROL->SetActive(true);
		
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		
	}
	
	return true;
}



/*
	
	hA
	
*/
bool K7Stage135M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	// hA
	switch( info.mEventNo ){
	case	K7EVENTDOOR(011701):
										//̎wւ𑕔Ă邩H
		if (false == K7SCR_GET_SCENARIO_FLAG(K7SCN01_DRFL_011701) ){
			if( K7SCR_EVEQUIPRING(RING_WIND) == true ){
				
				//inGame~
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				
				//V[gAbv
				FixCam( ONESHOTCAM_NAZO );
				K7SCR_STGC_MESSAGE_B( MES135M00_USERING );
				
				gpSound->mPlaySE(SFX_SCE1_KAKU_RING_WIND);		// prFrj[V[gĔłij
				
				K7SCR_TIMEWAIT(2400*3);
				
				SheetOpen(1);
				
				K7SCR_TIMEWAIT(2400);
				
				gpSound->mPlaySE(SFX_SYS_EV_CLEAR);
				
				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
				
				K7SCR_SET_SCENARIO_FLAG(K7SCN01_DRFL_011701);
				
				// L|[Y
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_EVCONDCHANGE();
			}else{
				// ̎wւ𑕔ĂȂ
				//inGame~
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				
				FixCam(ONESHOTCAM_NAZO);
				
				gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );
				
				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
				
				// L|[Y
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				return false;
			}
		}
		break;
	}
	return true;
}

/*
	
	Cxg
	
*/
bool K7Stage135M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	// EVENT_011701 L̃Gx[^pl
	case	K7EVENTNO(011701):
		//Gx[^ɏ
		ElevGetOn( ELEV_CAMERA_POS, ELEV_PLAYER_POS, MDL135M00_ELEVATORDOOR, MOT135M00_01, 0, SFX_SCE1_ELV_CLOSE );
		
#if 1
		{	// 蓮Xe[Wǂݑւ
			u32		stgid;
			u32		mIDBack;
			
			stgid = K7STGID(136, 0);				// B1F֌
			
			// L|[Y
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
			gpNoise->mSandRequest(eSandLongNoise);
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
			SetChanging(true);
			mIDBack = mID;
			K7SCR_STG_RELEASE    (mID);
			WK7Stage::SetPrevStageID(mIDBack);
			K7SCR_STG_CREATE_B   (stgid);
			K7SCR_STG_SET_CURRENT(stgid);
			K7SCR_STG_VISIBLE    (stgid,true);
			SetChanging(false);
		}
		
		return true;
#endif
		
		// J[VĐ
//		{
//			WK7JObj		*pJObj;
//			
//			// L|[Y
//			K7SCR_ENTER_PLAYMODE();
//			K7SCR_ENTER_DEMOPAUSE();
//			
//			if( (pJObj=PlayMotion("ElevatorGroup01", 0))!=NULL ){
//				pJObj->SetMotionLoop(false);
//				while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){			// ĐI܂ő҂
//					K7SCR_RETSYS();
//				}
//			}
//		}
//		Scn1BranchJumpB("set_Elevator");
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_DE2_DEAD)==FALSE ){
//			// ߂ăGx[^[ɏAf|[CxgJn
//			Scn1DE2EventB();
//		}
		break;
	}
	
	return false;
}



/*
	
	G񂾂R[
	
*/
bool K7Stage135M00::DieNpcCallBack(WK7DieNpcInfo &info)
{
	WK7Npc *pNpc = info.mpNpc;
	
	if ( ENENO_1_135M00_1_KEY == pNpc->GetEneNo() ){		// G|bvp
		K7SCR_SET_SCENARIO_FLAG(K7SCN01_ENFL_POP4_0);
		return false;
	}
	if ( ENENO_1_135M00_2_KEY == pNpc->GetEneNo() ){		// G|bvp
		K7SCR_SET_SCENARIO_FLAG(K7SCN01_ENFL_POP4_1);
		return false;
	}
	if ( ENENO_1_135M00_3_KEY == pNpc->GetEneNo() ){		// G|bvp
		K7SCR_SET_SCENARIO_FLAG(K7SCN01_ENFL_POP4_2);
		return false;
	}
	if ( ENENO_1_135M00_4_KEY == pNpc->GetEneNo() ){		// G|bvp
		K7SCR_SET_SCENARIO_FLAG(K7SCN01_ENFL_POP4_3);
		return false;
	}
	
	if ( (true == K7SCR_GET_SCENARIO_FLAG(K7SCN01_ENFL_POP4_0))
	&&	 (true == K7SCR_GET_SCENARIO_FLAG(K7SCN01_ENFL_POP4_1))
	&&	 (true == K7SCR_GET_SCENARIO_FLAG(K7SCN01_ENFL_POP4_2))
	&&	 (true == K7SCR_GET_SCENARIO_FLAG(K7SCN01_ENFL_POP4_3))
	){
		K7SCR_SET_SCENARIO_FLAG(K7SCN01_ENFL_POP4);
	}
	
	return true;
}


bool K7Stage135M00::SheetOpen(int se)
{
	WK7JObj		*pJObj;

	if( (pJObj=PlayMotion(MDL135M00_SHEET, MOT135M00_SHEETBROW))!=NULL ){
		
		pJObj->SetMotionLoop(false);
		
		if ( se ) gpSound->mPlaySE( SFX_SCE1_KAKU_VINYLSHEET_TOBU );		//prFrj[V[gĔłiłj
		
		while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){
			K7SCR_RETSYS();
		}
		return true;
	}
	
	return false;
}


/*	
	
	
	qbgIuWF
	
	
*/
bool K7Stage135M00::HitObjCallBack(WK7HitObjInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(011704):						// |^N
		Vec Pos0 = {287.420f, -0.108f, -56.144f};
		BombObj(info.mpJObj, K7STG_DEFAULT_BOMBOBJ_DIST, &Pos0);
		return false;
		break;
	}
	return true;
}

