////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage137M00 pr@O
//
// K7Stage137M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE137M00_CPP__

#include "..\..\..\Scn\K7Scn01.h"
#include ".\K7Stage137M00.h"
#include "..\..\..\Wat\WK7Player.h"
#include "..\..\..\Wat\WK7Npc.h"
#include "..\..\..\Matsu\MK7Sound.h"

// bZ[W
#define MES137M00_CARFRONT			(0)  //Ԃ̃{lbg
//#define MES137M00_JIHANKI			(1)  //̋@̃hAJ

K7Stage137M00::K7Stage137M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mStageInit = false;
	SetOneShotCamLocTbl(K7Stage137M00_Camera);
}

K7Stage137M00::~K7Stage137M00()
{
}

bool K7Stage137M00::CreateCallBack(void)
{
	CreateOwnStageMotion(0);
	return true;
}

bool K7Stage137M00::InitializeCallBack(void)
{
	return true;
}

bool K7Stage137M00::SetCurrentCallBack(void)
{
	SetCurrentCallBackDefaultProc();
	
	while ( false == IsOwnMotionObjLoaded() ){
		K7SCR_RETSYS();
	}
	
	// ̋@I[vς
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_DRFL_011305)==TRUE ){
		WK7JObj		*pJObj;
		if( (pJObj=PlayMotion("VendingMachine01", 0, NULL, -1.f))!=NULL ){
			pJObj->SetMotionLoop(false);
		}
	}
	
	if( GetPrevStageID() != WK7STAGE_GALSTAGEID ){
		mStageInit = true;
	}else{
		SetManualBranch(true);
	}
	
	if( mStageInit==true ){
		return true;
	}
	
	while( WK7Stage::IsChanging() != false ){
		K7SCR_RETSYS();
	}
	
//	// ʒuݒiViIprX^[gʒuj
	WK7Stage::SetCurrentPath(	WK7Stage::GetPathNurbsAll("curve3"),
								3.247f,
								0,									// Forward
								WK7PATHINFO_INITDIR_TGTDIR			// 
//								WK7PATHINFO_INITDIR_TGTDIR_REV		// wォ
	);
	SetCameraStartPosition();
	
	SandRelease();																// mCYJiXe[Wj
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	SetManualBranch(false);
	mStageInit = true;
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return false;
}

/*
	
	̋@̔
	
	<return>
	true			ʏiGAWvj
	false			ꏈ
	
*/
bool K7Stage137M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	bool ret;
	switch( info.mEventNo ){
	case	K7EVENTDOOR(011305):			// ̋@̃hA
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_DRFL_011305)==FALSE ){
			ret = JihankiOpenEvent();
			if ( ret == true ){
				K7SCR_SET_SCENARIO_FLAG(K7SCN01_DRFL_011305);
			}
			return ret;
		}
		break;
	}
	return true;
}


/*
	
	̋@̔
	
	
*/
bool K7Stage137M00::JihankiOpenEvent(void)
{
	// L|[Y
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	//plĂяo
#if 0
	K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(011302), 1 );
#else
	K7SCR_PANEL_SETPANELEVNO_NOPARAM(K7EVENTNO(011302));
#endif
	K7SCR_PANEL_START();
	K7SCR_PANEL_TERMWAIT();
//	K7SCR_PANEL_EXIT();
//	K7SCR_PANEL_EXITWAIT();
	if( K7SCR_PANEL_GETRESULT() == 1 ){
	// Jς
		FixCam(ONESHOTCAM_011302);
		K7SCR_PANEL_EXIT();
		K7SCR_PANEL_EXITWAIT();
	}else{
		K7SCR_PANEL_EXIT();
		K7SCR_PANEL_EXITWAIT();
		
		// L|[Y
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		return false;
	}
	
	// L|[Y
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	// Jς
	FixCam(ONESHOTCAM_011302);
	
	// Wait
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
	
	// [VĐ
	{
		WK7JObj		*pJObj;
		if( (pJObj=PlayMotion("VendingMachine01", 0))!=NULL ){
			
			pJObj->SetMotionLoop(false);
			
			gpSound->mPlaySE(SFX_SCE1_MOVE_VENDER);						// ̔@ړ
			
			while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){			// ĐI܂ő҂
				K7SCR_RETSYS();
			}
		}
	}
	
	gpSound->mPlaySE( SFX_SYS_EV_CLEAR );
	
	// Wait
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
	
//	K7SCR_STGC_MESSAGE_B(0);											// BʘH
	
	// L|[Y
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return true;
}

bool K7Stage137M00::EventCallBack( WK7EventInfo &info )
{
	switch( info.mEventNo ){
	case	K7EVENTNO(011301):
		//inGame~
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE( false );
		
		//JύX
		FixCam(ONESHOTCAM_011301);
		
		K7SCR_STGC_MESSAGE_B(MES137M00_CARFRONT);
		
		//inGameĊJ
		K7SCR_PC_SETVISIBLE( true );
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		break;
	//ftHg
	default:
		break;
	}
	
	return( true );
}



bool K7Stage137M00::BpLeaveCallBack(WK7BpInfo &info)
{
	u32	evno = GetBpEventNo(info);
	if( evno==0xffffffff ){
		return true;
	}
//	int	pathno = GetBpPathNo(info);
//	if( pathno < 0 ){
//		return true;
//	}
	
	switch( evno ){
	case	K7EVENTNO(011311):											// ĎJ
	case	K7EVENTNO(011312):											// ĎJ
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011311)==FALSE ){
			if ( WK7PLAYERCONTROL->GetMainID() != K7KVN ){
				
				K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011311);
				
				// L|[Y
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				
				
				if ( evno == K7EVENTNO(011311) ){
					FixCam(ONESHOTCAM_011311_0);
					// Wait
					K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
					WatchCameraB( K7Stage137M00_Camera[ONESHOTCAM_011311].tgt,
								  K7Stage137M00_Camera[ONESHOTCAM_011311].pos,
								  K7CHRID(K7KVN,0), 1 );
				}else{
					FixCam(ONESHOTCAM_011311_0);
					// Wait
					K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
					WatchCameraB( K7Stage137M00_Camera[ONESHOTCAM_011312].tgt,
								  K7Stage137M00_Camera[ONESHOTCAM_011312].pos,
								  K7CHRID(K7KVN,0), 1 );
				}
				return true;
			}
		}
		break;
	}
	return false;
}
