////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage147M00
//
// K7Stage147M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE147M00_H__
#define	__K7STAGE147M00_H__

#include "..\K7Stage.h"

class K7Stage147M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage147M00();
	K7Stage147M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	WK7RenderObjEffect*	mpWindEffect;
	bool mPanelOpen;
	bool PanelOpen(int se=0);
	EFFECT *KazeEffectCreate(Vec Point);
public:
	virtual ~K7Stage147M00();
	virtual bool InitializeCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &);
	virtual bool SetCurrentCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool CharaChangeCallBack( WK7CharaChangeInfo & );
	virtual bool BpLeaveCallBack(WK7BpInfo &);
	virtual bool CreateCallBack    (void);
	
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &);		// hACxg
	
//	virtual bool InitializeCallBack(void)              { return true; }		// iǂݍݏÎɑ΂鏉j
//	virtual bool TerminateCallBack (void)              { return true; }		// Iȉj
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
};

#ifdef __K7STAGE147M00_CPP__


enum K7STAGE147M00_ONESHOTCAM{
	ONESHOTCAM_011201,
	ONESHOTCAM_011202_OPEN,
	ONESHOTCAM_011202_SUSI,
	ONESHOTCAM_011202_PANELOPEN,
};


K7StageEventOneShotCamera K7Stage147M00_Camera[] = {
	{{173.735f, -0.159f, -148.238f},{157.489f, 15.002f, -96.072f}},			// bJ[̒ɏҏisbLO鎞j
	{{63.784f, 16.005f, 38.314f},{45.529f, 16.478f, 25.330f}},				// X[W[̔J
	{{65.213f, 15.082f, 36.249f},{51.840f, 16.123f, 35.388f}},				// X[W[Abv
	{{-29.927f, 14.877f, 51.707f},{-11.490f, 14.621f, 51.959f}}				// plJƂ
};

#endif

#endif	//__K7STAGE147M00_H__

