////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage204M00
//
// K7Stage204M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/23/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE204M00_CPP__

#include "..\..\..\Scn\K7Scn02.h"
#include ".\K7Stage204M00.h"
#include "..\..\..\Yam\YK7EffectLensFlare.h"
#include "..\..\..\Wat\WK7Item.h"
#include "..\..\..\Matsu\mK7Movie.h"

K7Stage204M00::K7Stage204M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage204M00_Camera );
}

K7Stage204M00::~K7Stage204M00()
{
	// n
	::DeleteEffect( LensFlare ) ;
	::ReleaseLensFlareTexture() ;
}

//`````````````````````````````````````````````````
//			NGCg
//`````````````````````````````````````````````````
bool K7Stage204M00::CreateCallBack(void)
{
	CreateOwnStageMotion( 0 );			
	return true;
}


//`````````````````````````````````````````````````
//		iǂݍݏÎɑ΂鏉j 
//`````````````````````````````````````````````````
bool	K7Stage204M00::InitializeCallBack( void )
{
	// YtA
	if( GetJObj("sun") != NULL )
	{
		::SetupLensFlareTexture() ;
		while( ::CheckLensFlareTexture() == FALSE ){
			K7SCR_RETSYS() ;
		}
		LensFlare = ::CreateLensFlareEffect( GetJObj("sun") ) ;
	}

	//	x	--------------------------------------------
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN02_EVFL_020401) ){
		K7SCR_EVNO_SETENABLE( K7EVENTNO(020401), false );
		PlayMotion(0,-1.0f);
		SetMotionLoop(false);
		K7SCR_STG_SET_PATHENABLE( "pass_guard", true);
		K7SCR_EVNO_SETENABLE( K7EVENTNO(020401), false );			
	}else{
		K7SCR_STG_SET_PATHENABLE( "pass_guard", false);
	}
	return true;
}

//`````````````````````````````````````````````````
//			Cxg
//`````````````````````````````````````````````````
bool K7Stage204M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
		
//		x[r[		
		
	case	K7EVENTNO(020401):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN02_EVFL_020401) )	return true;
		//inGame~
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE( true );
		//	[r[Đ
//		K7SCR_MOVIE_PLAY(K7MOV_GURAD);				
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		while( gpNoise->mSandRequest(eSandLongNoise)==false ){
			GHMGCTASK_RETSYS();
		}
		while( WK7Stage::ReleaseStageArchive()==false ){
			K7SCR_RETSYS();
		}
		while( WK7Stage::IsReleasedStageArchive()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->ReleaseTempData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->IsReleasedData()==false ){
			K7SCR_RETSYS();
		}
		while( gpMovie->mGetStatus()!=eMvProcStandby ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
		while( gpNoise->mSandRelease()==false ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}
		PlayMovie3(K7MOV_GURAD);

		while( gpNoise->mSandRequest(eSandLongNoise)==false ){
			GHMGCTASK_RETSYS();
		}
		while( WK7EVENTCONTROLLER->IsReleasedData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->LoadData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7Stage::RestoreStageArchive()==false ){
			K7SCR_RETSYS();
		}
		while( WK7Stage::IsRestoredStageArchive()==false ){
			K7SCR_RETSYS();
		}
		FixCam( 0 );
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
		while( gpNoise->mSandRelease()==false ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}

		K7SCR_RETSYS();
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();

		K7SCR_PC_VISIBLE( true );
		K7SCR_RETSYS();
		K7SCR_TIMEWAIT( 4800*1 );
		//[VX^[g
		PlayMotion(0,0.0f);
		SetMotionLoop(false);
		gpSound->mPlaySE(SFX_SCE2_6MOJI_UNLOCK);
		while( GetMotionState()!=WK7MODEL_NOANIM ){
			K7SCR_RETSYS();
		}
		K7SCR_TIMEWAIT( 4800*1 );
		//pX	
		K7SCR_STG_SET_PATHENABLE( "pass_guard", true );
		K7SCR_SET_SCENARIO_FLAG(K7SCN02_EVFL_020401);
		K7SCR_EVNO_SETENABLE( K7EVENTNO(020401), false );			//	WNV폜

		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE( true );
		return true;
	}
	return false;
}


//`````````````````````````````````````````````````
//			G񂾂Ƃ̃EC_RC擾Cxg
//`````````````````````````````````````````````````
bool K7Stage204M00::DieNpcCallBack(WK7DieNpcInfo &info)
{
#pragma unused( info )
#if 0
	WK7Npc *pNpc = info.mpNpc;
	//	EC_r
	switch( pNpc->GetEneNo() ){
	case ENENO_2_204M00_1:
	case ENENO_2_204M00_2:
	case ENENO_2_204M00_3:
	case ENENO_2_204M00_4:
	case ENENO_2_204M00_5:
		K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL)++;		//_Qbg
		if( K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL) > K7SCN02_ULMEDAL_MAX ){
			K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL) = K7SCN02_ULMEDAL_MAX;
		}
		break;
	}
#endif
	return true;
}
