////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage206M00 EC_ Xe[W
//
// K7Stage206M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/23/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE206M00_CPP__

#include "..\..\..\Scn\K7Scn02.h"
#include ".\K7Stage206M00.h"
#include "..\..\..\Matsu\mK7Movie.h"

#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Kaw\KK7BattleCtrl.h"
#include "..\..\..\Enm\EnmUR2.h"
K7Stage206M00::K7Stage206M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	GameInfo.SetMenuMapEnable(false);
	GameInfo.SetBossFlag     (true );
	/// LA
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_BOSSBATTLE);
}

bool K7Stage206M00::TerminateCallBack(void)
{
	gpSound->mReleaseSsm( "seBossUr2.ssm");
	return true;
}

bool K7Stage206M00::SetCurrentCallBack( void )
{
#if 1
  //ǂJɂȂ܂ő҂
  while( WK7Stage::IsChanging() != false ) K7SCR_RETSYS();
	
  //eLg[B
  s32 song_change = 0;
  gpSound->mPlayStreamNo(HPS_CLOUDSMAN_H); 
  gpSound->mReadSsm( "seBossUr2.ssm", eBankBoss );

  WK7PathNurbs*	pPath;
  if( (pPath = GetPathNurbs("curve24")) != NULL ){
	pPath->SetEnable( false );
	pPath->SetEnableEx( false );
  }
//	if( (pPath = GetPathNurbs("curve1")) != NULL ){
//	  pPath->SetEnable( false );
//	  pPath->SetEnableEx( false );
//	}

  //łɃfǂ̃tOB
  if( K7SCR_GET_SCENARIO_FLAG( FIRST_UR2_DEMO ) ){
	song_change = 1;
	gpSound->mStopStream();
	gpSound->mPlayStreamNo(HPS_SENTOU_SILENCE);
  }
			
  s32 counter = 0;
  while( 1 ){
	C_Vec pos, tgt;
	f32 fov;
	if( K7EnmUR2::IsGameOver() ){
	  break;
	}else  if( K7EnmUR2::IsCamReq( pos, tgt, fov ) ){
	  KK7BattleMainTask::BattleMainTaskExit(2);
	  
	  K7SCR_ENTER_PLAYMODE_B();
	  WK7PLAYERCONTROL->SetOperateEnable(false);
	  //WK7CAM->SetCinemaScopeMode(true);
	  WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);

	  while( K7EnmUR2::IsCamReq( pos, tgt, fov ) ){

		//JCxgB
		if( 0==song_change ){
		  gpSound->mStopStream();
		  gpSound->mPlayStreamNo(HPS_SENTOU_SILENCE);
		  song_change = 1;
		}else if( 1==song_change ){
		  if( K7EnmUR2::GetState() == UR2_STATE_DIE ){
			gpSound->mStopStream();
			song_change = 2;
		  }
		}else if( 2==song_change ){
		  if( K7EnmUR2::GetState() == UR2_STATE_ENDING1 ){
			gpSound->mPlayStreamNo(HPS_BOSS_URUEND);
			song_change = 3;
		  }
		}else if( 3==song_change ){
		  if( K7EnmUR2::GetState() == UR2_STATE_ENDING3 ){
			gpSound->mFadeVolumeStream(0, 20 * 200);
			song_change = 4;
		  }
		}

		WK7CAM->SetPosition(pos);
		WK7CAM->SetTargetPosition(tgt);
		WK7CAM->SetFov(fov);
		
		counter++;
		K7SCR_RETSYS();
		if ( false == WK7RenderObj::IsValid(this) ){
		  // Ă܂ǂHiob
		  WK7PLAYERCONTROL->BattlePadRegulationSet();
		  gpSound->mStopStream();
   	  	  K7SCR_RESET_SCENARIO_FLAG( K7SCN02_EVFL_020314 );		//|
		  return true;
		}
	  }

	  K7SCR_SET_SCENARIO_FLAG( FIRST_UR2_DEMO );

	  WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	  WK7PLAYERCONTROL->SetOperateEnable(true);
	  //WK7CAM->SetCinemaScopeMode(false);
	  
	  if( song_change!=4 ){
		K7SCR_EXIT_PLAYMODE();
	  }
	}
	K7SCR_RETSYS();
	if ( false == WK7RenderObj::IsValid(this) ){
	  // Ă܂ǂHiob
	  WK7PLAYERCONTROL->BattlePadRegulationSet();
	  gpSound->mStopStream();
  	  K7SCR_RESET_SCENARIO_FLAG( K7SCN02_EVFL_020314 );		//|
	  return true;
	}
  }
  
  //////////////////////////////////////////////////////////
  //Q[IBLցB
  //////////////////////////////////////////////////////////
  {
	gpSound->mStopStream();
  }

  gpSound->mReleaseSsm( "seBossUr2.ssm");
#if 1
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	while( gpNoise->mSandRequest(eSandLongNoise)==false ){
		GHMGCTASK_RETSYS();
	}
	
	WK7PLAYERCONTROL->Reset();
	WK7PLAYERCONTROL->ReleaseAll();
	WK7PLAYERCONTROL->SetOperateEnable(false);
	K7SCR_STG_RELEASE(mID);
	K7SCR_TIMEWAIT( 4800*5 );

	while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
		K7SCR_RETSYS();
	}
	while( WK7EVENTCONTROLLER->ReleaseTempData()==false ){
		K7SCR_RETSYS();
	}
	while( WK7EVENTCONTROLLER->IsReleasedData()==false ){
		K7SCR_RETSYS();
	}
	while( gpMovie->mGetStatus()!=eMvProcStandby ){
		K7SCR_RETSYS();
	}
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	while( gpNoise->mSandRelease()==false ){
		K7SCR_RETSYS();
	}
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		K7SCR_RETSYS();
	}
#ifdef	_DEBUG
	ghmGcFile*	pfile=NULL;
	pfile = new ghmGcFile;
	if( pfile->Open("/Movie/clemence.h4m")==true ){
		pfile->Close();
		GHM_SAFE_DELETE( pfile );
#endif
	while( gpMovie->mRequest("/Movie/clemence.h4m")==false ){
		K7SCR_RETSYS();
	}
#ifdef	_DEBUG
	}
#endif
	while( gpMovie->mGetStatus()!=eMvProcStandby ){
		if( gpMovie->mGetFrame() >= 1 && (HSD_PadGetTrigger(0) & HSD_PAD_START) ){
			gpMovie->mStop();
			while( gpMovie->mGetStatus()!=eMvProcStandby ){
				K7SCR_RETSYS();
			}
			break;
		}
		K7SCR_RETSYS();
	}
//	while( gpNoise->mSandRequest(eSandLongNoise)==false ){
//		GHMGCTASK_RETSYS();
//	}
	while( WK7EVENTCONTROLLER->IsReleasedData()==false ){
		K7SCR_RETSYS();
	}
	while( WK7EVENTCONTROLLER->LoadData()==false ){
		K7SCR_RETSYS();
	}
	while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
		K7SCR_RETSYS();
	}
	K7SCR_RETSYS();	

//	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
//		GHMGCTASK_RETSYS();
//	}
//	while( gpNoise->mSandRelease()==false ){
//		K7SCR_RETSYS();
//	}
//	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
//		K7SCR_RETSYS();
//	}
#endif
#endif
	SK7ScenarioEnd*		m_pSceEnd;
	m_pSceEnd = new SK7ScenarioEnd;
	m_pSceEnd->LoadData();
	m_pSceEnd->FrameProcess();
	m_pSceEnd->Release();
	GHM_SAFE_DELETE( m_pSceEnd );
	
	// EC_̃Gl~[nEg̒ǉ
	BattleCtrl.IncTotalEnemyHunt(1);
	
	K7SCR_RETSYS();
	GameInfo.SetMode     (WK7GameInfo::TERM           );
	GameInfo.SetTermState(WK7GameInfo::TERMSTATE_CLEAR);
	K7SCR_RETSYS();

  return true;
}

K7Stage206M00::~K7Stage206M00()
{
	GameInfo.SetMenuMapEnable(true );
	GameInfo.SetBossFlag     (false);
	/// LA
	WK7PLAYERCONTROL->BattlePadRegulationClear();
}

bool K7Stage206M00::PathChangeCallBack(WK7PathChangeInfo &info)
{
#pragma	unused(info)
	WK7PathNurbs	*pPath = GetPathNurbs("curve1");
	if( pPath==NULL ){
		return true;
	}
	bool	flag;
	if( pPath==WK7PLAYERPATHCONTROL->GetCurrentPath() ){
		flag = true;
	}else{
		flag = false;
	}
	pPath->SetEnable  (flag);
	pPath->SetEnableEx(flag);
	return true;
}

