////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage20M00
//
// K7Stage209M00.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 04/16/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE209M00_CPP__

#include ".\K7Stage209M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn02.h"
#include "..\..\..\Sato\SK7PanelBase.h"
#include "..\..\..\Wat\WK7GameInfo.h"
#include "..\..\..\Sato\SK7SpecialData.h"
#include "..\..\..\Matsu\mK7Movie.h"
#include "..\..\..\Yam\YK7EffectLensFlare.h"
#include "..\..\..\kaw\KK7Sound.h"

//`````````````````````````````````````````````````
//			RXgN^
//`````````````````````````````````````````````````
K7Stage209M00::K7Stage209M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	m_iSeNo			= 0;
	m_bTrainSE		= false;
	m_bMoveFlag		= false;

	m_iTrainNum = rand()%(TRAIN_ALL_NUM-TRAIN_MINI_NUM)+TRAIN_MINI_NUM;
	K7SCR_RESET_SCENARIO_FLAG( K7SCN02_ENFL_POP19 );
}

//`````````````````````````````````````````````````
//			fXgN^
//`````````````````````````````````````````````````
K7Stage209M00::~K7Stage209M00()
{
	// n
	::DeleteEffect( LensFlare ) ;
	::ReleaseLensFlareTexture() ;
}


//`````````````````````````````````````````````````
//			Jg
//`````````````````````````````````````````````````
bool	K7Stage209M00::SetCurrentCallBack(void)
{
	SetCurrentCallBackDefaultProc();
	while( WK7RenderObj::IsValid(this)==true && GetState()==LOADED ){
		MoveTrain();
		K7SCR_RETSYS();
	}
	return true;
}

//`````````````````````````````````````````````````
//			NGCg
//`````````````````````````````````````````````````
bool K7Stage209M00::CreateCallBack(void)
{
	return true;
}

//`````````````````````````````````````````````````
//		iǂݍݏÎɑ΂鏉j
//`````````````````````````````````````````````````
bool	K7Stage209M00::InitializeCallBack( void )
{
	// YtA
	if( GetJObj("sun") != NULL )
	{
		::SetupLensFlareTexture() ;
		while( ::CheckLensFlareTexture() == FALSE ){
			K7SCR_RETSYS() ;
		}
		LensFlare = ::CreateLensFlareEffect( GetJObj("sun") ) ;
	}

	InitTrain();
	return true;
}

//`````````````````````````````````````````````````
//			Cxg
//`````````````````````````````````````````````````
bool K7Stage209M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
		
//		|X^[		

	case	K7EVENTNO(020203):
 	case	K7EVENTNO(020208):
		K7SCR_PANEL_SETPANELEVNO_NOPARAM(info.mEventNo);
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		K7SCR_RETSYS();
		K7SCR_PANEL_EXIT();
		K7SCR_EVCONDCHANGE(); 
		return true;

	default:	
		break;
	}	
	return false;
}

#if 0
//`````````````````````````````````````````````````
//			hACxg
//`````````````````````````````````````````````````
bool K7Stage209M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	return false;
}
#endif

		
//`````````````````````````````````````````````````
//			G񂾂Ƃ̃EC_RC擾Cxg
//`````````````````````````````````````````````````
bool K7Stage209M00::DieNpcCallBack(WK7DieNpcInfo &info)
{
	WK7Npc *pNpc = info.mpNpc;
	
	//	EC_r
	switch( pNpc->GetEneNo() ){
//	case ENENO_2_209M01_6:
	case ENENO_2_209M01_3:
		K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL)++;		//_Qbg
//		gpSound->mPlaySE( SFX_SCE2_ULMAYDA_MEDAL_GET );
		if( K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL) > K7SCN02_ULMEDAL_MAX ){
			K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL) = K7SCN02_ULMEDAL_MAX;
		}
		break;
	case ENENO_2_209M00_1:
		K7SCR_SET_SCENARIO_FLAG( K7SCN02_ENFL_POP4_0 );
		break;
	case ENENO_2_209M00_2:
		K7SCR_SET_SCENARIO_FLAG( K7SCN02_ENFL_POP4_1 );
		break;
	}
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_ENFL_POP4_0 )==true && 
		K7SCR_GET_SCENARIO_FLAG( K7SCN02_ENFL_POP4_1 )==true )
	{
		K7SCR_SET_SCENARIO_FLAG( K7SCN02_ENFL_POP4 );
	}
	return true;
}


//`````````````````````````````````````````````````
//			Ԉړ
//`````````````````````````````````````````````````
void		K7Stage209M00::InitTrain()
{
	int i;
	Vec vPos;
	char name[255];
	for( i = 0; i < TRAIN_ALL_NUM; i++ ){
		if( i < m_iTrainNum ){
			if( i == 0 )	sprintf( name, TRAIN_FIRST );
			else if( i == m_iTrainNum-1 ) 	sprintf( name, TRAIN_LAST );
			else	sprintf( name, "t%02d", i );
			mpModel->GetObj( name )->GetWorldPosition( &vPos ); 
			vPos.x = TRAIN_FIRST_X+(TRAIN_SIZE_X*i);
			vPos.y = TRAIN_Y;
			mpModel->GetObj( name )->SetWorldPosition( &vPos ); 
			mpModel->GetObj( name )->Disp();
		}else{
			if( i == 11 ) break;
			if( i == m_iTrainNum ){
				sprintf( name, "t%02d", m_iTrainNum-1 );
				mpModel->GetObj( name )->Hide( false, true );
			}
			sprintf( name, "t%02d", i );
			mpModel->GetObj( name )->Hide( false, true );
		}
	}
}

//`````````````````````````````````````````````````
//			ԈړCxg
//`````````````````````````````````````````````````
void		K7Stage209M00::MoveTrain()
{
	Vec vPos,vChara;
	char name[255];
	WK7PLAYERCONTROL->GetPosition( &vChara );
	for( int i = 0; i < m_iTrainNum; i++ ){
		if( i == 0 )	sprintf( name, TRAIN_FIRST );
		else if( i == m_iTrainNum-1 ) 	sprintf( name, TRAIN_LAST );
		else	sprintf( name, "t%02d", i );
		mpModel->GetObj( name )->GetWorldPosition( &vPos ); 
		if( vChara.z <= TRAIN_STOP_Z0 ){
			if( vChara.z <= TRAIN_STOP_Z1 ){
				vPos.x -= 0.0f;
			}else{
				vPos.x -= (vChara.z-TRAIN_STOP_Z1)/(TRAIN_STOP_Z0-TRAIN_STOP_Z1)*TRAIN_SPEED;
			}
		}else{
			vPos.x -= TRAIN_SPEED;
		}
		mpModel->GetObj( name )->SetWorldPosition( &vPos ); 
		//	Ԍ̗
		if( m_iTrainNum-1 != i )	continue;
		if( vPos.x <= TRAIN_END_X ){
			m_iTrainNum = rand()%(TRAIN_ALL_NUM-TRAIN_MINI_NUM)+TRAIN_MINI_NUM;			
			InitTrain();
		}
	}
		//	TEhvZ
	Vec vFirst, vLast, vAns;
	mpModel->GetObj( TRAIN_FIRST )->GetWorldPosition( &vFirst ); 
	mpModel->GetObj( TRAIN_LAST )->GetWorldPosition( &vLast ); 
	
	if( vFirst.x > 0 ){
		vAns = vFirst;
	}else if( vLast.x < 0 ){
		vAns = vLast;
	}else{
		vAns.x = vAns.y = 0;
		vAns.z = vLast.z;
	}
	//	sb`vZ
	s16 Pitch=0;
	
	if( vChara.z <= TRAIN_STOP_Z1 ){
		if( m_bTrainSE && m_bMoveFlag ){
			gpSound->mStopSE( SFX_SCE2_TRAIN_LOOP );
			gpSound->mPlaySE3D( SFX_SCE2_TEXAS_TRAIN_STOP, vAns, 1, 255 );			
			m_bTrainSE  = false;
			m_bMoveFlag = false;
		}
	}else{
		if( !m_bMoveFlag ){
			gpSound->mPlaySE3D( SFX_SCE2_TEXAS_TRAIN_START, vAns, 1, 255 );			
		}
		m_bMoveFlag = true;
		if( vChara.z <= TRAIN_STOP_Z0 ){
			Pitch = (s16)((vChara.z-TRAIN_STOP_Z0)*15);			
		}else{
			Pitch = 0;
		}
		MoveTrainSound( &vAns, Pitch );	
	}
}

//`````````````````````````````````````````````````
//			ԈړCxg
//`````````````````````````````````````````````````
void		K7Stage209M00::MoveTrainSound( Vec* vPos, s16 inPitch )
{
	u8		getVolume, getPan;
	if( m_bTrainSE == false ){
		m_iSeNo = gpSound->mPlaySE( SFX_SCE2_TRAIN_LOOP );
		m_bTrainSE = true;
	}
	// {[쐬
	seVolCalc( *vPos, TRAIN_MAX_VOLUME, &getVolume, &getPan, 1);
	// {[ύXit[wj
	gpSound->mSetVolumeSENo( m_iSeNo, getVolume, 1 );
	// pύXit[wj
	gpSound->mSetPanSENo( m_iSeNo, getPan );
	//zԍŃsb`ݒ
	gpSound->mSetPitchSENo( m_iSeNo, inPitch );
}
