////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage203M00
//
// K7Stage213M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/23/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE213M00_CPP__

#include ".\K7Stage213M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Sato\SK7PanelBase.h"
#include "..\..\..\Scn\K7Scn02.h"
#include "..\..\..\Yam\YK7EffectLensFlare.h"

//`````````````````````````````````````````````````
//			RXgN^
//`````````````````````````````````````````````````
K7Stage213M00::K7Stage213M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage213M00_Camera );
}

//`````````````````````````````````````````````````
//			fXgN^
//`````````````````````````````````````````````````
K7Stage213M00::~K7Stage213M00()
{
	// n
	::DeleteEffect( LensFlare ) ;
	::ReleaseLensFlareTexture() ;
}

#if 0
//`````````````````````````````````````````````````
//			NGCg
//`````````````````````````````````````````````````
bool K7Stage213M00::CreateCallBack(void)
{
	return true;
}
#endif

//`````````````````````````````````````````````````
//		iǂݍݏÎɑ΂鏉j
//`````````````````````````````````````````````````
bool	K7Stage213M00::InitializeCallBack( void )
{
	// YtA
	if( GetJObj("sun") != NULL )
	{
		::SetupLensFlareTexture() ;
		while( ::CheckLensFlareTexture() == FALSE ){
			K7SCR_RETSYS() ;
		}
		LensFlare = ::CreateLensFlareEffect( GetJObj("sun") ) ;
	}
	
	return true;
}


//`````````````````````````````````````````````````
//			Cxg
//`````````````````````````````````````````````````
bool K7Stage213M00::EventCallBack(WK7EventInfo &info)
{
#pragma unused(info)
	return false;
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool	K7Stage213M00::CondChangeCallBack( void )
{
#if 1
	//R[êJ
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN02_DRFL_021301) == false )
	{
		SimpleModelDisp( "cyo_padlock_on" );
		SimpleModelHide( "cyo_padlock_off" );
	}else
	{
		SimpleModelHide( "cyo_padlock_on" );
		SimpleModelDisp( "cyo_padlock_off" );
	}
#endif
	return( true );
}


//`````````````````````````````````````````````````
//			hACxg
//`````````````````````````````````````````````````
bool K7Stage213M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){		
	case	K7EVENTDOOR(021301):
		if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_DRFL_021301 )==false ){			//	CxgĂȂ
			if( WK7PLAYERCONTROL->GetMainID() == K7CYO ){
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				WK7Npc::NpcVisibleAll(false);
				SimpleCyoPicking( "cyo_picking", 0 );
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_SET_SCENARIO_FLAG( K7SCN02_DRFL_021301 );
				K7SCR_EVCONDCHANGE();
				K7SCR_RETSYS();
				WK7Npc::NpcVisibleAll(true);
				info.mCinemaScopeClear = true;
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
			}else{
				gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );		//䉹
				FixCamMes( 0, 0 );
//				FixCamSysMes( 1, K7SCR_SYSMES_CLOSED_BY_KEY );
				return( false );
			}
		}
		break;
	}
	return true;
}

//`````````````````````````````````````````````````
//			G񂾂Ƃ̃EC_RC擾Cxg
//`````````````````````````````````````````````````
bool K7Stage213M00::DieNpcCallBack(WK7DieNpcInfo &info)
{
#pragma unused(info)
	return true;
}

