////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage306M00
//
// K7Stage306M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE306M00_H__
#define	__K7STAGE306M00_H__

#include "..\K7Stage.h"

class K7Stage306M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage306M00();
	K7Stage306M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	void	CatSliding( bool inCamMotion, u32 inCamID=0xffffffff );	//Lbg
	
	WK7ModelMotion*	mpCatMotionSlow;	//Lbg[V
	WK7ModelMotion*	mpCatMotion;		//Lbg[V
	
public:
	virtual ~K7Stage306M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
//	virtual bool CondChangeCallBack(void)              { return true; }		// ԕύXitOɂԕύX邽߂ɗpj
//	virtual bool TerminateCallBack (void)              { return true; }		// Iȉj
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &){ return true; }		// hACxg retrun true  pXɊ܂܂郊NɃWvB
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
	
};

#ifdef __K7STAGE306M00_CPP__


enum K7STAGE306M00_ONESHOTCAM{
	CAM306M00CATGO,
	CAM306M00CATBACK,
	CAM306M00CATGOMOT,		//LbgړsEړ
	CAM306M00CATBACKMOT,	//LbgړAEړ
	CAM306M_030515,			//{[h
};


K7StageEventOneShotCamera K7Stage306M00_Camera[] = {
	{{-2122.876f, 2.395f, -1598.366f},{-2143.952f, 1.631f, -1598.356f}},
	{{-2132.434f, 2.395f, -1598.402f},{-2111.344f, 2.306f, -1598.408f}},
	{{-2143.057f, 3.719f, -1596.646f},{-2166.608f, 2.778f, -1592.731f}},
	{{-2118.679f, 4.446f, -1602.361f},{-2095.119f, 1.034f, -1604.385f}},
	{{-2472.415f, 15.466f, -1588.532f},{-2440.821f, 24.588f, -1620.015f}},
};

#endif

#endif	//__K7STAGE306M00_H__

