////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage307M00
//
// K7Stage307M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE307M00_H__
#define	__K7STAGE307M00_H__

#include "..\K7Stage.h"

class K7Stage307M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage307M00();
	K7Stage307M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	const char* GetPairPath(const char *pPathName);
	WK7RenderObjEffect			*mpWindEffect;
public:
	virtual ~K7Stage307M00();
	
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack(WK7EventInfo &);
	
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &){ return true; }		// hACxg retrun true  pXɊ܂܂郊NɃWvB
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
	virtual bool HitObjCallBack    (WK7HitObjInfo    &);
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &){ return true; }		// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &){ return true; }		// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &){ return true; }		// erCxgiZ[u|Cgj
	virtual bool BpLeaveCallBack   (WK7BpInfo        &);
	virtual bool CharaChangeCallBack(WK7CharaChangeInfo &);

};

#ifdef __K7STAGE307M00_CPP__

static	const char	*pLoopTable[][2] = {
	{ "curve04" , "curve02" },
	{ "curve05" , "curve03" },
};

enum K7STAGE307M00_ONESHOTCAM{
	EV_030501,
	CAM307M_030516,
	CAM307M_030517
};


K7StageEventOneShotCamera K7Stage307M00_Camera[] = {
	{{-2146.816f, 12.764f, -2033.459f},{-2117.588f, 12.492f, -2042.399f}},				// ǔj
	{{-2137.528f, 14.991f, -1685.011f},{-2107.659f, 16.511f, -1637.149f}},				// {[hƂ
	{{-2273.735f, 15.506f, -1988.454f},{-2255.380f, 23.223f, -2008.448f}},				// {[hƂ2
};

#endif

#endif	//__K7STAGE307M00_H__

