////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage308M00
//
// K7Stage308M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE308M00_H__
#define	__K7STAGE308M00_H__

#include "..\K7Stage.h"

class K7Stage308M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage308M00();
	K7Stage308M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	void NuigurumiInit(void);
	WK7JObj *NuigurumiPlayMotion(s8 *pObjName, u8 motNo);
	void NuigurumiStartDemo(void);
	bool DaizaPlayMotion(void);
	bool RoomPlayMotion(void);
	bool NuigurumiEndTest(int mode=0);
	bool IsNuigurumiGame(void);
	bool DaizaBrokenMotion(f32 sFrame=0.f);
	
public:
	virtual ~K7Stage308M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
//	virtual bool TerminateCallBack (void)              { return true; }		// Iȉj
	virtual bool SetCurrentCallBack(void);
//	virtual bool EventCallBack     (WK7EventInfo     &){ return true; }		// Cxg
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
	virtual bool HitObjCallBack    (WK7HitObjInfo    &);
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &){ return true; }		// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &){ return true; }		// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &){ return true; }		// erCxgiZ[u|Cgj

};

#ifdef __K7STAGE308M00_CPP__

enum K7STAGE308M00_ONESHOTCAM{
	EV_030502,
	EV_030502_NO,
};

enum NUIGURUMI_NUM{
	NUI_event_030507,
	NUI_event_030508,
	NUI_event_030509,
	NUI_event_030510,
	NUI_event_030511,
	NUI_event_030512,
	NUI_event_030513,
	NUI_event_030514,
	NUI_event_MAX,
};

typedef struct {
	u8		motNo;					// ĐĂ郂[V
	s16		frame;					// 䎞
	int		evFlag;					// CxgtO
	s8		*pObjName;				// IuWFNgO
	WK7JObj	*pJObj;					// ĐԂ
}NUIGURUMI;

static char *pNuigurumiName[] = {
	"event_030507",
	"event_030508",
	"event_030509",
	"event_030510",
	"event_030511",
	"event_030512",
	"event_030513",
	"event_030514",
};

static NUIGURUMI nuigurumi[NUI_event_MAX];

K7StageEventOneShotCamera K7Stage308M00_Camera[] = {
	{{-2264.875f, 21.636f, -1853.146f},{-2263.513f, 21.909f, -1822.980f}},			// ˂݃[bgJnII
	{{-2260.582f, 16.309f, -1687.398f},{-2261.178f, 13.072f, -1738.230f}},			// J܂
};

#endif

#endif	//__K7STAGE308M00_H__

