////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage313M00 װïݼݓ@
//
// K7Stage313M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE313M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage313M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"
#include "..\..\..\Yam\YK7EffectLight.h"
#include "..\..\..\Yam\YK7EffectTeleport.h"

// bZ[W
#define MES313M00_SPCYO_JUMP		(0)

// pX
#define PATH313M00_SPCYO_JUMPSAKI	"CYO_JUMP"

#define PATH313M00_FROM_312M02		"furve4"

//f
#define	MDL313_DOOR						"animation"
#define	MDL313_SOFA						"sofa_anime"

//[V
#define	MOT313_DOOROPEN		(0)							// I[v
#define	MOT313_SOFAMOVE		(1)							// \t@[ړ

K7Stage313M00::K7Stage313M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage313M00_Camera);
}

K7Stage313M00::~K7Stage313M00()
{
}


/*
	
	NGCg
	
*/
bool K7Stage313M00::CreateCallBack(void)
{
	// [Vǂݍ
	CreateOwnStageMotion(MOT313_DOOROPEN);
	CreateOwnStageMotion(MOT313_SOFAMOVE);
	
	return true;
}


bool K7Stage313M00::CondChangeCallBack(void)
{
	return true;
}


/*
	
	
	
*/
bool K7Stage313M00::InitializeCallBack(void)
{
	if ( K7SCR_GET_SCENARIO_FLAG(K7SCN03_DRFL_030703) == true ){
		// 蓮Xe[Wnm
		SetManualBranch(true);
	}
	if( WK7Stage::GetPrevStageID()==K7STGID(312,2) ){
		K7SCR_STG_SET_PATHENABLE(PATH313M00_FROM_312M02,true);
	}
	return true;
}


/*
	
	
	I
	
	
*/
bool K7Stage313M00::TerminateCallBack(void)
{
	return true;
}




/*
	
	
	Jg
	
	
*/
bool K7Stage313M00::SetCurrentCallBack(void)
{
	if ( K7SCR_GET_SCENARIO_FLAG(K7SCN03_DRFL_030703) == true ){
		K7SCR_RESET_SCENARIO_FLAG(K7SCN03_DRFL_030703);
		
		// 蓮Xe[Wnm
		// L|[Y
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		// mCY炷
		SandRelease(SFX_SCE3_MAP_CHANGE_DOOR_WOOD_CLOSE);																// mCYJiXe[Wj
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			GHMGCTASK_RETSYS();
		}
		
		// L|[Y
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		
		SetManualBranch(false);
	}
	return true;
}



/*
	
	
	Cxg
	
	
*/
bool K7Stage313M00::EventCallBack(WK7EventInfo &info)
{
	WK7JObj	*pJObj;

	switch( info.mEventNo ){
	// װïݼݓ@ \t@[[hւ̓
	case	K7EVENTNO(030707):
		// L|[Y
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE(false);
		
		// \t@[ړ̋
		gpSound->mPlayStreamNo(HPS_ISZK_SOFA313);
		
		// Jς
		WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
		WK7CAM->SetPosition      (K7Stage313M00_Camera[EV_030707].pos);
		WK7CAM->SetTargetPosition(K7Stage313M00_Camera[EV_030707].tgt);
		
		
		if( (pJObj=PlayMotion(MDL313_DOOR, MOT313_DOOROPEN))!=NULL ){					// J[V
			gpSound->mPlaySE(SFX_SCE3_SOFAROAD_DOOR);
			pJObj->SetMotionLoop(false);
		}
		if( (pJObj=PlayMotion(MDL313_SOFA, MOT313_SOFAMOVE))!=NULL ){					// \t@[[V
//			gpSound->mPlaySE(SFX_SCE3_SOFAROAD_DRIVE);
			pJObj->SetMotionLoop(false);
		}
		
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(3));
		
		// L|[Y
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		
		K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_030901);
#if 1
		{
			u32		stgid = K7STGID(327, 0);
//			u32		stgid = K7STGID(315, 0);
			
			// L|[Y
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
			gpNoise->mSandRequest(eSandLongNoise);
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
			K7SCR_PC_SETVISIBLE  (true);
			K7SCR_STG_RELEASE    (mID);
			K7SCR_STG_CREATE_B   (stgid);
			K7SCR_STG_SET_CURRENT(stgid);
			K7SCR_STG_VISIBLE    (stgid,true);
			
			WK7Stage::SandRelease(stgid);
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
			
			// L|[Y
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
		}
#endif
		return true;
		break;
	}
	return true;
}


/*
	
	
	u`|Cgoiʉ߁j
	
	
*/
bool K7Stage313M00::BpLeaveCallBack(WK7BpInfo &info)
{
	u32	evno = GetBpEventNo(info);
	if( evno==0xffffffff ){
		return true;
	}
	int	pathno = GetBpPathNo(info);
	switch( evno ){
	case	K7EVENTNO(030708):
		if( WK7PLAYERCONTROL->GetMainID()!=K7GAL ){
			
			// L|[Y
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
			K7SCR_NOISE_REQUEST();
			
			K7SCR_TIMEWAIT( 4800 );
			SetCurrentPath(	GetPathNurbsAll("curve2"),
							0.937f,
							1,									// 0:forward 1:back
							WK7PATHINFO_INITDIR_TGTDIR );		// : wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
			WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
			K7SCR_TIMEWAIT( 2400 );
			
			// Jς
			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
			WK7CAM->SetPosition      (K7Stage313M00_Camera[EV_030708].pos);
			WK7CAM->SetTargetPosition(K7Stage313M00_Camera[EV_030708].tgt);
			
			K7SCR_NOISE_RELEASE();
			
			// Wait
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
			
			// ĎJ̏
			WatchCameraB(K7Stage313M00_Camera[EV_030708_2].tgt, K7Stage313M00_Camera[EV_030708_2].pos, K7CHRID(K7GAL,0), 1, true);
			
			// L|[Y
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			
			return false;
		}
		break;
	case	K7EVENTNO(030709):					// R[e\͓J
	case	K7EVENTNO(030755):					// R[e\͓J
		if( pathno == 0 ){
			// SE
			if ( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030709_SPCYO)==false ){
				gpSound->mPlaySE(SFX_SYS_APPEAR_RIDDLE);
			}
			K7SCR_STG_SET_PATHENABLE(PATH313M00_FROM_312M02,false);
			return false;
		}
		return true;
		break;
	}
	
	return true;
}



bool K7Stage313M00::SpAbilityCallBack(WK7SpAbilityInfo &info)
{
	switch( info.mAbilityID ){
	case	PC_SPA_BOOST_JUMP:
		WK7PlayerSpInfoCyo*	pCyoInfo = WK7PLAYERCONTROL->GetSpInfoCyo();
		
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030709_SPCYO)==TRUE ){
//			WK7PLAYERCONTROL->SetSpAbilityCancel(true);
//			return false;
//		}
		
		K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_030709_SPCYO);					// ACR߂ɗĂ
		
		pCyoInfo->mpToBpName      = PATH313M00_SPCYO_JUMPSAKI;
		pCyoInfo->mFromPos.x      = -332.030f;
		pCyoInfo->mFromPos.y      =  172.615f;
		pCyoInfo->mFromPos.z      = -2260.162f;
		pCyoInfo->mFromRotY       =  1.571f;
		pCyoInfo->mToPos  .x      = -309.437f;
		pCyoInfo->mToPos  .y      =  206.982f;
		pCyoInfo->mToPos  .z      = -2259.691f;
		pCyoInfo->mToRotY         =  1.571f;
		pCyoInfo->mStageMessage   = true;
		pCyoInfo->mStageMessageID = MES313M00_SPCYO_JUMP;
		FixCam(JUMP_0);
		while( WK7PLAYERCONTROL->GetSpProc() < SPCYO_JUMPWAIT ){
			K7SCR_RETSYS();
		}
		FixCam(JUMP_1);
		while( WK7PLAYERCONTROL->GetSpProc()!=SPCYO_IDLE ){
			K7SCR_RETSYS();
		}
		
		return false;
		break;

	default:
		break;
	}
	return true;
}


//------------------------------------------------------------------------------
//cvOCxg
//------------------------------------------------------------------------------
bool K7Stage313M00::ZanEventCallBack( WK7ZanEventInfo &info )
{
	switch( info.mEventNo )
	{
		case	K7EVENTZAN(030014):
			if( K7SCR_EVHASITEM(K7EVENTZAN(030014)) == false ){
				//inGame~
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				
				//cvOĂяo
				SetZanEventInfo( K7EVENTZAN(030014) );
				
				GameInfo.SetZanMesID( 0 );
				GameInfo.SetZanTermWait( true );
				GameInfo.SetMode( WK7GameInfo::ZAN );
				while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERMWAIT )
				{
					K7SCR_RETSYS();
				}
				GameInfo.SetZanTermWait( false );
				while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY )
				{
					K7SCR_RETSYS();
				}
				
				K7SCR_EVSETITEM( K7EVENTZAN(030014),   true);	//cvO
				
				K7SCR_SYS_ITEMGET_IS(K7SCR_SYSMES_GETTAMA,15,SFX_SYS_GET_BULLET);
				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1.0f));
				K7SCR_EVSETITEM(K7EVITEM_TAMA(030709), true);	// e
				K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_SPCYO_END);					// ACR߂ɗĂ
				K7SCR_EVCONDCHANGE();
				//JPCtH[ɖ߂
				WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
//				WK7CAMPATHFOLLOWINFO->SetPathCamera(NULL);		// ŒJ͂
//				WK7CAMPATHFOLLOWINFO->SetMode(WK7CamPathFollowInfo::FOLLOW_MODE);
				K7SCR_SYS_ITEMGET_VALID_B(K7SCR_SYSMES_GETTAMA);
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
				return( false );
			}
			break;
		default:
			break;
	}
	return( true );
}




