////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage316M00
//
// K7Stage316M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE316M00_H__
#define	__K7STAGE316M00_H__

#include "..\K7Stage.h"
#include "..\..\..\sato\SK7ScenarioEnd.h"

class K7Stage316M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage316M00();
	K7Stage316M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	bool			mEnd;
//	SK7ScenarioEnd	mScnEnd;
	bool			mAkaneHide;
public:
	virtual ~K7Stage316M00();
	virtual bool InitializeCallBack(void);
	virtual bool SetCurrentCallBack(void);
	virtual bool CreateCallBack    (void);
	virtual bool CondChangeCallBack(void);
//	virtual bool BpLeaveCallBack(WK7BpInfo &);
	virtual bool BpArriveCallBack  (WK7BpInfo &);
	virtual bool TerminateCallBack (void);
	
//	virtual bool EventCallBack     (WK7EventInfo     &){ return true; }		// Cxg
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &){ return true; }		// hACxg retrun true  pXɊ܂܂郊NɃWvB
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
	
};


#ifdef __K7STAGE316M00_CPP__

enum K7STAGE316M00_ONESHOTCAM{
	DR_030703,
};


K7StageEventOneShotCamera K7Stage316M00_Camera[] = {
	{{-230.745f, 113.443f, -2259.890f},{-170.421f, 110.672f, -2258.721f}},				// [vJn
};

#endif

#endif	//__K7STAGE316M00_H__

