////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage325M03
//
// K7Stage325M03.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE325M03_H__
#define	__K7STAGE325M03_H__

#include "..\K7Stage.h"

class K7Stage325M03 : public WK7Stage{
	friend class WK7Stage;
	int mPlayBgm;
protected:
	K7Stage325M03();
	K7Stage325M03(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	void TreasureBoxMotionPlay(int motno);
public:
	virtual ~K7Stage325M03();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool TerminateCallBack (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &){ return true; }		// hACxg retrun true  pXɊ܂܂郊NɃWvB
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
	
};

#ifdef __K7STAGE325M03_CPP__


enum K7STAGE325M03_ONESHOTCAM{
	EV_030408,
	ONESHOTCAM_ENEMYGO,
	ONESHOTCAM_PICK,
	ONESHOTCAM_KEYUP,
	ONESHOTCAM_SUSIE,
	ONESHOTCAM_SUSIEUP,
};


K7StageEventOneShotCamera K7Stage325M03_Camera[] = {
	{{-402.682f, -14.655f, -1209.369f},{-413.618f, 1.193f, -1220.865f}},		// 󔠃Vbg
	{{-393.601f, -24.655f, -1466.928f},{-389.012f, -23.472f, -1445.010f}},		// Gl~[o
	{{-401.965f, -9.233f, -1220.645f},{-397.309f, -3.416f, -1237.956f}},		//sbLO
	{{-403.960f, -11.469f, -1201.435f},{-404.029f, -10.297f, -1220.246f}},		//sbLOAbv
	{{-404.661f, -10.151f, -1207.826f},{-418.964f, -4.696f, -1217.001f}},		//X[W[ڃVbg
	{{-393.442f, -22.451f, -1196.911f},{-401.116f, -13.022f, -1211.313f}},		//X[W̎wփAbv
};

#endif

#endif	//__K7STAGE325M03_H__

