////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage327M00
//
// K7Stage327M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE327M00_H__
#define	__K7STAGE327M00_H__

#include "..\K7Stage.h"

#define K7STAGE327M00_LOT_LGT_MAX		(4)

class K7Stage327M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage327M00();
	K7Stage327M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	EFFECT *pRotLgt[K7STAGE327M00_LOT_LGT_MAX];
public:
	virtual ~K7Stage327M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
//	virtual bool CondChangeCallBack(void)              { return true; }		// ԕύXitOɂԕύX邽߂ɗpj
	virtual bool TerminateCallBack (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
	
};

#ifdef __K7STAGE327M00_CPP__

enum K7STAGE327M00_ONESHOTCAM{
	CAM327M00_HS_PRESEN_START,
	CAM327M00_HS_PRESEN_END,
};

K7StageEventOneShotCamera	K7Stage327M00_Camera[] = {
	{{-4.130f, -70.691f, -1266.354f},{-4.554f, -69.900f, -1243.094f}},			// HSЉp
	{{-2.139f, -66.227f, -1402.991f},{-2.563f, -65.437f, -1379.731f}},			// HSЉpY[
};

// 邭郉Cg̐ݒuꏊ
Vec rotStg327LgtPos[K7STAGE327M00_LOT_LGT_MAX] = {
	{-220.436f, 145.255f, -1000.f},
	{-92.482f,  145.255f, -1000.f},
	{92.036f,   145.255f, -1000.f},
	{213.795f,  145.255f, -1000.f}
};

#endif

#endif	//__K7STAGE327M00_H__

