////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage352M00 J[eBX̉Ɓ@
//
// K7Stage352M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 01/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE352M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage352M00.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Kaw\KK7Effect.h"
#include "..\..\..\sato\SK7SpecialData.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"
#include "..\..\..\Yam\YK7EffectDraft.h"
#include "..\..\..\Yam\YK7EffectModelFire.h"
#include "..\..\..\Kaw\KK7Sound.h"

//f
#define	MDL352M00_STATUE	"event_035003"		//嗇
#define	MDL352M00_MON		"tobira"			//K[Wւ̔
#define	MDL352M00_TAMA		"tama"				//e
#define	MDL352M00_WATER		"BlackWater"		//ra̐
#define	MDL352M00_STRANGE	"Zoukeibutu"		//svcȑ`
//[V
#define	MOT352M00_DRCL	(0)		//܂
#define	MOT352M00_DROP	(1)		//J
#define	MOT352M00_02	(2)		//e
//bZ[W
#define MES352M00_00	(0)		//svcȑ`肵
#define MES352M00_01	(1)		//
#define MES352M00_02	(2)		//svcȑ`o
#define MES352M00_03	(3)		//ŖĂ
#define MES352M00_04	(4)		//eꂽ
#define MES352M00_05	(5)		//Ă
#define	MES352M00_USE_FIRE_RING	(6)	//̎wւg




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage352M00::K7Stage352M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage352M00_Camera );
	mFire = NULL;
	//̃Xe[WɓƂ͂ǂȂƂłK[W̔͊JĂ
	K7SCR_SET_SCENARIO_FLAG( DR035004 );
	mAmbPlaySE = false;
}
//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage352M00::~K7Stage352M00()
{
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//-----------------------------------------------------------------------------
bool
K7Stage352M00::CreateCallBack( void )
{
	//[Vt@C
	CreateOwnStageMotion( MOT352M00_DRCL );
	CreateOwnStageMotion( MOT352M00_DROP );
	CreateOwnStageMotion( MOT352M00_02 );
	
	//LLGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	//GtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_FIRE) == NULL )
	{
		K7SCR_RETSYS();
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Iȉj
//------------------------------------------------------------------------------
bool
K7Stage352M00::TerminateCallBack( void )
{
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_FIRE);
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage352M00::SetCurrentCallBack( void )
{
	//SEɃo[uȂ
	gpSound->mSetDspRateAll( 0 );
	
	//̎ĂWNVƗ
	if( K7SCR_GET_SCENARIO_FLAG(EV035003) == TRUE )
	{
		gpSound->mPlayStreamNo( HPS_CURTIES_C );
	}else
	{
		gpSound->mPlayStreamNo( HPS_CURTIES_E );
	}
	
	if( mAmbPlaySE == false )
	{
		KK7SoundLoopSePlayVolumeChange((Vec){-711.221f, 24.566f, -673.075f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE3_AMB_MUSHI1 );
		KK7SoundLoopSePlayVolumeChange((Vec){102.891f, 40.539f, -19.122f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE3_AMB_MUSHI1 );
		mAmbPlaySE = true;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage352M00::CondChangeCallBack( void )
{
	//e
	if( K7SCR_EVHASITEM(K7EVITEM_TAMA(035001)) == true )
	{	//ef\
		SimpleModelHide( MDL352M00_TAMA );
		ReleaseTamaEffect();
	}else
	{
		//嗇
		if( K7SCR_GET_SCENARIO_FLAG(EV035003) == true )
		{	//eĂ
			SimpleModelDisp( MDL352M00_TAMA );
			CreateTamaEffect(MDL352M00_TAMA );
		}else
		{	//ef\
			SimpleModelHide( MDL352M00_TAMA );
			ReleaseTamaEffect();
		}
	}

	//---- 嗇 ----
	//̎ĂWNVƗ
	if( K7SCR_GET_SCENARIO_FLAG(EV035003) == TRUE )
	{
		//嗇ւ̃WNV\
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035003), false );
		//嗇f\
		SimpleModelHide( MDL352M00_STATUE );
		//eĂeւ̃WNV
		if( K7SCR_EVHASITEM(K7EVITEM_TAMA(035001)) == TRUE )
		{	//WNV\
			K7SCR_EVNO_SETENABLE( K7EVENTTAMA(035001), false );
		}else
		//eĂȂ̂ŃWNV\&f\
		{	//WNV\
			K7SCR_EVNO_SETENABLE( K7EVENTTAMA(035001), true );
		}
	}else
	{
		//嗇ւ̃WNV\
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035003), true );
		//嗇f\
		SimpleModelDisp( MDL352M00_STATUE );
		//eWNV
		K7SCR_EVNO_SETENABLE( K7EVENTTAMA(035001), false );
	}
	
	//---- K[W ----
	if( K7SCR_GET_SCENARIO_FLAG(DR035004) == false )
	{
		SimpleSetStartMotion( MDL352M00_MON, MOT352M00_DROP );
	}else
	{
		SimpleSetLastMotion( MDL352M00_MON, MOT352M00_DROP );
	}
	
	//---- [U[ ----
	if( K7SCR_GET_SCENARIO_FLAG(EV035005) == true )
	{
		SimpleModelHide( "laser" );
	}else
	{
		SimpleModelDisp( "laser" );
	}
	
	//---- ra ----
	//
	if( K7SCR_GET_SCENARIO_FLAG(EV035013) == true )
	{
		SimpleModelHide( MDL352M00_WATER );
	}else
	{
		SimpleModelDisp( MDL352M00_WATER );
	}
	//svcȑ`擾
	if( K7SCR_GET_SCENARIO_FLAG(EV035013STRANGE) == true )
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035013), false );
		SimpleModelHide( MDL352M00_STRANGE );
	}else
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035013), true );
		SimpleModelDisp( MDL352M00_STRANGE );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage352M00::EventCallBack( WK7EventInfo &info )
{
	Vec			posFire  = { -281.005f, 31.740f, -488.503f };
	Vec			posSmoke = { -288.120f, 23.160f, -479.625f };
	
	switch( info.mEventNo )
	{
		//嗇
		case	K7EVENTNO( 035003 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			FixCamWithRiddle( CAM035003STATUE );
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			break;
		
		//ra
		case	K7EVENTNO( 035013 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			//ĂȂ
			if( K7SCR_GET_SCENARIO_FLAG(EV035013) == FALSE )
			{
				//̎wւ𑕔Ă
				if( K7SCR_EVEQUIPRING(RING_FIRE) == true )
				{
					//JύX
					FixCam( CAM035013DRAIN );
					K7SCR_STGC_MESSAGE_B( MES352M00_USE_FIRE_RING );
				//	//GtFNg\
				//	if( mFire == NULL )
				//	{
				//		gpSound->mPlaySE( SFX_SCE3_CUR_TANK_FIRE );
				//		if( ((mFire=CreateEffectModelFire((const char*)NULL,MFIRE_CANDLE,&posFire,0.5f)) != NULL)
				//		 && (mFire->GetEffect() != NULL) )
				//		{
				//			SetWindModelFireEffect( mFire->GetEffect(),
				//									(Vec){posSmoke.x-posFire.x,posSmoke.y-posFire.y,posSmoke.z-posFire.z},
				//									0.05f );
				//		}
				//	}
				//	K7SCR_TIMEWAIT( 4800 * 3 );
				//	if( mFire != NULL )
				//	{
				//		DelReqEffect( mFire );
				//		mFire = NULL;
				//	}
					//CGtFNg\
					gpSound->mPlaySE( SFX_SCE3_CUR_TANK_JOUHATSU );
					CreateEffectSmoke( posSmoke, 3.0f );
					//̕\
					SimpleModelHide( MDL352M00_WATER );
					K7SCR_TIMEWAIT( 3840 );
					gpSound->mPlaySE( SFX_SYS_TRUE );
					K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK-3840 );
					////bZ[W\
					//K7SCR_STGC_MESSAGE_B( MES352M00_02 );
					//tOON
					K7SCR_SET_SCENARIO_FLAG( EV035013 );
				}else
				{
					FixCamMesWithRiddle( CAM035013DRAIN, MES352M00_03 );
				}
			}else
			//
			{
				//svcȑ`
				K7SCR_EVSETITEM( K7EVITEM_KEY(035013), true );
				K7SCR_SET_SCENARIO_FLAG( EV035013STRANGE );
				//WNV
				K7SCR_EVNO_SETENABLE( K7EVENTNO(035013), false );
				//Jݒ
				FixCam( CAM035013DRAIN );
				K7SCR_TIMEWAIT( 4800 * 2 );
				//ACe擾ʂ\
				SimpleItemGetMes( MES352M00_00, MDL352M00_STRANGE, true );
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool
K7Stage352M00::DoorEventCallBack( WK7DoorEventInfo &info )
{
	switch( info.mEventNo )
	{
		//K[Wւ̔
		case	K7EVENTDOOR( 035001 ):
			//Ăꍇ
			if( K7SCR_GET_SCENARIO_FLAG(DR035004) == FALSE )
			{
				FixCamWithRiddle( CAM035004SENSOR );
				return( false );
			}
	    	break;
		
		//v[ւ̔
		case	K7EVENTDOOR( 035005 ):
			if( K7SCR_GET_SCENARIO_FLAG(DR036200) == false )
			{
				FixCamMes( CAM0352M00_DOOR_POOL, MES352M00_05 );
				return( false );
			}else
			{
				//AJl̃plŃCg_H
				if( K7SCR_GET_SCENARIO_FLAG(EV0361POOL_LIGHT_ON) == false )
				{	//΂Ă
					info.mNextStageID = K7STGID( 362, 1 );
					strcpy( info.mNextBpName, "door_035112" );
				}else
				{	//΂_Ă
					info.mNextStageID = K7STGID( 362, 0 );
				}
			}
			break;

		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//_o
//------------------------------------------------------------------------------
bool
K7Stage352M00::BpLeaveCallBack( WK7BpInfo &info )
{
	u32	evno   = GetBpEventNo( info );
	int	pathNo = GetBpPathNo( info );
	if( evno==0xffffffff )
		return( true );
	
	//K[W̃ZT[󂵂ĂȂ΃ZT[쓮
	if( K7SCR_GET_SCENARIO_FLAG(EV035005) == false )
	{
		switch( evno )
		{
			//ZT[
			case	K7EVENTNO( 035004 ):
				//PrœłȂΖ߂
				if( (pathNo == 0)									//ɒʉ߁H
				 && (WK7PLAYERCONTROL->SpAtkKvnTest() == false) )	//H
				{
					//L|[Y
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					//ĂԂɂ
					K7SCR_RESET_SCENARIO_FLAG( DR035004 );
					//JύX
					FixCam( CAM035004GARAGE );
					//Aj[VĐ
					gpSound->mPlaySE( SFX_SCE3_CUR_ALARMDOOR );
					gpSound->mPlaySE( SFX_SCE3_SECURITY_ACTIVATED );
					SimplePlayMotionB( MDL352M00_MON, MOT352M00_DRCL );
					//L|[Y
					K7SCR_EXIT_PLAYMODE();
					K7SCR_EXIT_DEMOPAUSE();
				}
				break;
			
			//ZT[O
			case	K7EVENTNO( 035014 ):
				//ĂΊJ
				if( K7SCR_GET_SCENARIO_FLAG(DR035004) == FALSE )
				{
					//L|[Y
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					//ĂԂɂ
					K7SCR_SET_SCENARIO_FLAG( DR035004 );
					//JύX
					FixCam( CAM035004GARAGE );
					//JAj[VĐ
					gpSound->mPlaySE( SFX_SCE3_CUR_ALARMDOOR );
					gpSound->mPlaySE( SFX_SCE3_SECURITY_DEACTIVATED );
					SimplePlayMotionB( MDL352M00_MON, MOT352M00_DROP );
					//L|[Y
					K7SCR_EXIT_PLAYMODE();
					K7SCR_EXIT_DEMOPAUSE();
				}
				break;
			
			//ftHg
			default:
				break;
		}
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//qbgIuWF
//------------------------------------------------------------------------------
bool
K7Stage352M00::HitObjCallBack( WK7HitObjInfo &info )
{
	switch( info.mEventNo )
	{
		//嗇
		case	K7EVENTNO( 035003 ):
			if( info.mTypeID == WK7HITOBJINFO_TYPE_DANCHARGE )
			{
				//ogIB
				KK7BattleMainTask::BattleMainTaskExit( 2 );
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				FixCam( CAM035003STATUE_BREAKING );
				
				//嗇tOON
				K7SCR_SET_SCENARIO_FLAG( EV035003 );
				//嗇WNV
				K7SCR_EVNO_SETENABLE( K7EVENTNO(035003), false );
				//eWNV\
				K7SCR_EVNO_SETENABLE(K7EVENTTAMA(035001),true);
				//IuWF
				info.mpJObj->Hide( false, true );
				BrokenObj( MDL352M00_STATUE );
				//
				KK7DoorSmokeEffect( (Vec){-531.704f,0.000f,-859.160f} );
				gpSound->mPlaySE( SFX_SCE3_CUR_STATUE_BREAK );
				while( GameInfo.SetMode(WK7GameInfo::PLAY)==false ){
					K7SCR_RETSYS();
				}
				
				//L|[Y
				K7SCR_TIMEWAIT( 4800*2 );
				
				//eĂ
				gpSound->mPlaySE( SFX_SYS_CAMERA_ZOOM );
				SimpleModelDisp( MDL352M00_TAMA );
				FixCamMes( CAM035003STATUEBREAK, MES352M00_04 );
				//JPCtH[ɖ߂
				K7SCR_PC_SETVISIBLE( true );
				WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
				gpSound->mPlayStreamNo( HPS_CURTIES_C );
				K7SCR_EVCONDCHANGE();
				//L|[Y
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
			}else
			{
				info.SetHitObjEnable(true);
				return( false );
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

