////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage354M00 J[eBX̉Ɓ@
//
// K7Stage354M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 01/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE354M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage354M00.h"
#include "..\..\..\sato\SK7SpecialData.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"
#include "..\..\..\Yam\YK7EffectModelFire.h"
#include "..\..\..\Yam\YK7EffectBillboard.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Kaw\KK7Effect.h"
#include "..\..\..\Yam\YK7EffectPool.h"
#include "..\..\..\Yam\YK7EffectDraft.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"

//pX
#define	PATH354M00FIREPLACE		"event_035009_0"	//gFJ̃pX
#define	PATH354M00_MSKWALL_1	"event_035018_0"	//}XNŔj󂷂ǂ̓JpX
#define	PATH354M00_MSKWALL_2	"event_035019_0"	//}XNŔj󂷂ǂ̓JpX
#define	PATH354M00_MSK			"pass_msk"			//ǔjɒʉ߂łpX
//f
#define	MDL354M00_SBULLET		"tama"				//e
#define	MDL354M00_WALL			"event_035017"		//}XNŔj󂷂
#define	MDL354M00_POOL_ON		"light_on"			//362M00̃CgON
#define	MDL354M00_POOL_OFF		"light_off"			//362M00̃CgOFF
#define	MDL354M00_POOL_LIGHT	"light_00%d"		//362M00̃Cg
#define	MDL354M00_POOL_LIGHT4	"light_004"			//362M00̃Cg4
#define	MDL354M00_POOL_LIGHT5	"light_005"			//362M00̃Cg5
#define	MDL354M00_POOL_LIGHT6	"light_006"			//362M00̃Cg6
#define	MDL354M00_POOL			"pool"				//v[̐
#define	MDL354M00_WIND1			"Dust"				//n_1
#define	MDL354M00_WIND2			"Danro"				//n_2
//bZ[W
#define	MES354M00_CHIMNEY		(0)		//˓ɏ
#define	MES354M00_POOLON		(1)		//v[̖肪_
#define	MES354M00_POOLOFF		(2)		//v[̖肪
#define	MES354M00_LOCKDOOR		(3)		//Α献|Ă悤
#define	MES354M00_DUSTCHUTE		(4)		//_XgV[go
#define	MES354M00_USE_FIRE_RING		(5)	//̎wւg
#define	MES354M00_USE_WIND_RING		(6)	//̎wւg
#define	MES354M00_USE_WATER_RING	(7)	//̎wւg
#define	MES354M00_RIDDLE_FIRE			(8)	//gFɉ΂_
#define	MES354M00_RIDDLE_PUTOUT_FIRE	(9)	//gF̉΂
//[V
#define	MOT354M00_CAT_LANDING	K7MOTID(K7CAT,521)	//n

#define	FIRESIZE354M00		(3.0f)	//̑傫
#define	POOL_LIGHT_SPEED	(2400)	//v[̃Cg̕\tick
#define	POOL_LIGHT_NUM		(9)		//v[̃Cg
#define	LOC354M00POOL_X			(-375.295f)
#define	LOC354M00POOL_Y			(12.857f)
#define	LOC354M00POOL_Z			(-1124.98f)
#define	LOC354M00POOL_X_SIZE	(280.000f)
#define	LOC354M00POOL_Z_SIZE	(180.000f)
#define	STG354M00_CAM_TICK		(4800*5)		//Jړɂ鎞

static Vec windPos = {-185.731f, 29.870f, -1231.742f};



//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage354M00::K7Stage354M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage354M00_Camera );
	mFire         = NULL;
//	mWater        = NULL;
	mpWindEffect1 = NULL;
	mpWindEffect2 = NULL;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage354M00::~K7Stage354M00()
{
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage354M00::CreateCallBack( void )
{
	//Lbg̒n[V
	WK7RenderObj::CreateOwnMotionObj( K7MOT_ATTR|K7OBJTYPE_CHR, MOT354M00_CAT_LANDING );
	
	//LLGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	//GtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_FIRE) == NULL )
	{
		K7SCR_RETSYS();
	}
	//GtFNg
	while( WK7RenderObj::CreateEffectBillResource(BILLEFF_SPRINKLER) == NULL )
	{
		K7SCR_RETSYS();
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
//------------------------------------------------------------------------------
bool
K7Stage354M00::InitializeCallBack( void )
{
	//Lbg̒n[V
	mpCatMotion = GetOwnModelMotion( K7MOT_ATTR|K7OBJTYPE_CHR, MOT354M00_CAT_LANDING );
	
	return( true );
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage354M00::CondChangeCallBack( void )
{
	WK7JObj*	pJObj;
	EFFECT*		pWindEffect;
	
	//LԂւ̔JĂZRplCxg͔Ȃ
	if( K7SCR_GET_SCENARIO_FLAG(DR035102) == false )
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035012), true );
	}else
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035012), false );
	}
	
	//e
	if( K7SCR_EVHASITEM(K7EVITEM_TAMA(035002)) == false )
	{
		SimpleModelDisp( MDL354M00_SBULLET );
		CreateTamaEffect(MDL354M00_SBULLET );
	}else
	{
		SimpleModelHide( MDL354M00_SBULLET );
		ReleaseTamaEffect();
	}
	
	//gFւ̓J͏ɏ(KvȂȂ)
	K7SCR_STG_SET_DISABLEPATHCAMERA( PATH354M00FIREPLACE, true );
	//gF̉΂Ă邩mF
	if( K7SCR_GET_SCENARIO_FLAG(EV035008) == false )
	{
		//---- ΂_Ă ----
		K7SCR_SET_SCENARIO_FLAG( EV035008FIRE );
		DispFireplaceEffect();
		PoolLightOn();
		//gF̉ɍsWNV
		K7SCR_STG_SET_PATHENABLE( "pass_coyote", false );
		//eWNV
		K7SCR_EVNO_SETENABLE( K7EVENTTAMA(035002), false );
		//gFւ̃WNV\
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035008), true );
	}else
	{
		//---- ΂Ă ----
		K7SCR_RESET_SCENARIO_FLAG( EV035008FIRE );
		StopFireplaceEffect();
		PoolLightOff();
		//gF̉ɍsWNV
		K7SCR_STG_SET_PATHENABLE( "pass_coyote", true );
		//eĂȂ΃WNV\
		if( K7SCR_EVHASITEM(K7EVITEM_TAMA(035002)) == FALSE )
		{
			K7SCR_EVNO_SETENABLE( K7EVENTTAMA(035002), true );
		}
		//gFւ̃WNV͏
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035008), false );
	}
	
	//ǂ
	if( K7SCR_GET_SCENARIO_FLAG(EV035017) == false )
	{
		K7SCR_STG_SET_PATHENABLE( PATH354M00_MSK, false );
		SimpleModelDisp( MDL354M00_WALL );
		K7SCR_STG_SET_DISABLEPATHCAMERA( PATH354M00_MSKWALL_1, false );
		K7SCR_STG_SET_DISABLEPATHCAMERA( PATH354M00_MSKWALL_2, false );
		if( WK7PLAYERCONTROL->GetMainID() == K7CAT && GetCurrentStageID()==mID )
		{
			WK7RenderObjEffectInfo	info;
			info.Create();
			if( ((pJObj=GetJObj(MDL354M00_WIND1)) != NULL)
			 && (IsValidEffect(mpWindEffect1) == false)
			 && ((pWindEffect = ::CreateDraft2Effect(pJObj,(s32)VParam[ED_DRAFT][2])) != NULL) )
			{
				mpWindEffect1 = CreateEffect( pWindEffect ,&info);
			}
			info.Create();
			if( ((pJObj=GetJObj(MDL354M00_WIND2)) != NULL)
			 && (IsValidEffect(mpWindEffect2) == false)
			 && ((pWindEffect = ::CreateDraft2Effect(pJObj,(s32)VParam[ED_DRAFT][2])) != NULL) )
			{
				mpWindEffect2 = CreateEffect( pWindEffect ,&info);
			}
			CatWindSePlay(windPos, EV035017, SFX_SCE3_SUKIMAKAZE);
		}else
		{
			if( mpWindEffect1 != NULL )
			{
//				ReleaseEffect( mpWindEffect1 );
				DelReqEffect( mpWindEffect1 );
				mpWindEffect1 = NULL;
			}
			if( mpWindEffect2 != NULL )
			{
//				ReleaseEffect( mpWindEffect2 );
				DelReqEffect( mpWindEffect2 );
				mpWindEffect2 = NULL;
			}
		}
	}else
	{
		K7SCR_STG_SET_PATHENABLE( PATH354M00_MSK, true );
		SimpleModelHide( MDL354M00_WALL );
		K7SCR_STG_SET_DISABLEPATHCAMERA( PATH354M00_MSKWALL_1, true );
		K7SCR_STG_SET_DISABLEPATHCAMERA( PATH354M00_MSKWALL_2, true );
		if( mpWindEffect1 != NULL )
		{
			ReleaseEffect( mpWindEffect1 );
			mpWindEffect1 = NULL;
		}
		if( mpWindEffect2 != NULL )
		{
			ReleaseEffect( mpWindEffect2 );
			mpWindEffect2 = NULL;
		}
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//L`FW
//------------------------------------------------------------------------------
bool
K7Stage354M00::CharaChangeCallBack( WK7CharaChangeInfo &info )
{
#pragma	unused(info)
	K7SCR_EVCONDCHANGE();
	return( true );
}

//------------------------------------------------------------------------------
//Iȉj
//------------------------------------------------------------------------------
bool
K7Stage354M00::TerminateCallBack( void )
{
	//GtFNgJ
	StopFireplaceEffect();
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_FIRE);
	//GtFNg
	WK7RenderObj::ReleaseEffectBillResource(BILLEFF_SPRINKLER);
	
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	
	// GԂ̂肠
	WK7PLAYERCONTROL->ClearMuteki();
	
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage354M00::SetCurrentCallBack( void )
{
	WK7Model* pPcModel;
	WK7JObj*  pJObj;
	Vec       pos;
	
	//gF̌ʉ炷
	PlayFireplaceSE();
	
	//PCLbgőÕXe[W358M00_XgV[goĂ
	if( (WK7PLAYERCONTROL->GetMainID() == K7CAT) && (GetPrevStageID() == K7STGID(358,0)) )
	{
		SetManualBranch( true );
		while( WK7Stage::IsChanging() == true )
		{
			K7SCR_RETSYS();
		}
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_STG_VISIBLE( K7STGID(354,0), true );
		K7SCR_PC_VISIBLE( true );
		//Lbg[VĐ
		if( (pJObj=GetJObj("dust_chuet_end")) != NULL )
		{
			pJObj->GetWorldPosition( pos );
		}
		pPcModel = WK7PLAYERCONTROL->GetCharaModel();
		WK7PLAYERPATHCONTROL->SetEnable( false );
		WK7PLAYERCONTROL->SetEnable( false );
		WK7PLAYERCONTROL->SetPosition( &pos );
		WK7PLAYERCONTROL->SetRotY( -HALF_PI );
		FixCam( CAM354M00_DUSTCHUTE_OUT );
		pPcModel->AttachMotion( mpCatMotion );
		//mCYJiXe[Wj
		SandRelease();
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){GHMGCTASK_RETSYS();}
		//Lbg[VĐ
		gpSound->mPlaySE( SFX_SCE3_CON_DUSTSHOOT_OUT );
		pPcModel->PlayMotion();
		pPcModel->SetMotionLoop( false );
		//ĐI҂
		while( pPcModel->GetMotionState() != WK7MODEL_NOANIM )
		{
			K7SCR_RETSYS();
		}
		//vC[ړԂɂ
		K7SCR_NOISE_REQUEST();
		WK7PLAYERPATHCONTROL->SetEnable( true );
		WK7PLAYERCONTROL->SetEnable( true );
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		//ړJnpXɏ悹
		SetCurrentPath(	GetPathNurbsAll("curve23"),
						0.791f,
						1,									// 0:forward 1:back
						WK7PATHINFO_INITDIR_TGTDIR );		// :WK7PATHINFO_INITDIR_TGTDIR wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
		Vec	initpos;
		WK7PLAYERPATHCONTROL->GetCurrentPosition(&initpos);
		WK7CAMPATHFOLLOWINFO->SetStageStartMode              (true);
		WK7CAMPATHFOLLOWINFO->SetStageStartCamPosition       ((Vec){-232.601f, 38.145f, -1415.176f});
		WK7CAMPATHFOLLOWINFO->SetStageStartCamTargetPosition ((Vec){-213.546f, 34.910f, -1395.614f});
		WK7CAMPATHFOLLOWINFO->SetStageStartTargetInitPosition(initpos);
		WK7CAMPATHFOLLOWINFO->SetStageStartDist( 3.0f );
		//WK7CAM->SetCinemaScopeMode( false );
		K7SCR_NOISE_RELEASE();
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		SetManualBranch( false );
	}
	
	SetCurrentCallBackDefaultProc();
	
	K7SCR_EVCONDCHANGE();
	
	while( K7SCR_STG_GET_CURRENTID() == K7STGID(354,0) ){
		Vec pcPos;
		
		WK7PLAYERCONTROL->GetPosition(pcPos);
		if ( pcPos.y > 50.f ){						// Gȍ
			WK7PLAYERCONTROL->SetMuteki();
		}else{
			WK7PLAYERCONTROL->ClearMuteki();
		}
		K7SCR_RETSYS();
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage354M00::EventCallBack( WK7EventInfo &info )
{
	switch( info.mEventNo )
	{
		//ʑ356M00̃ZR싖pl
		case	K7EVENTNO( 035012 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			//ZR\ł΃pl邾
			if( K7SCR_GET_SCENARIO_FLAG(EV035012) == FALSE )
			{
				//plĂяo
				//StopFireplaceEffect();
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(035012), 0 );
				K7SCR_PANEL_START();
				K7SCR_PANEL_TERMWAIT();
				K7SCR_RETSYS();
				K7SCR_PANEL_EXIT();
				K7SCR_PANEL_EXITWAIT();
			}else
			//\pľĂяo
			{
				//plĂяo
				//StopFireplaceEffect();
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(035012), 1 );
				K7SCR_PANEL_START();
				K7SCR_PANEL_TERMWAIT();
				K7SCR_RETSYS();
				K7SCR_PANEL_EXIT();
				K7SCR_PANEL_EXITWAIT();
				//ZR𑀍\ɂtOON
				if( K7SCR_PANEL_GETRESULT() == 0 )
				{
					K7SCR_RESET_SCENARIO_FLAG( EV035012 );
					gpSound->mStopSE( SFX_SCE3_CUR_ALARM );
				}
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			break;
		
		//gFCxg
		case	K7EVENTNO( 035008 ):
			//΂Ă邩mF
			if( K7SCR_GET_SCENARIO_FLAG(EV035008) == FALSE )
			{
				//---- ΂_Ăꍇ ----
				//̎wւ𑕔Ă邩H
				if( K7SCR_EVEQUIPRING(RING_WIND) == true )
				{
					//inGame~
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					//gF̉
					FixCam( CAM354M00FIREPLACE );
					K7SCR_STGC_MESSAGE_B( MES354M00_USE_WIND_RING );
					gpSound->mPlaySE( SFX_SYS_RING_WIND_COMMON );
					GoOutFireplaceEffect();
					//SetPoolLight( false );
					//ĂtOON
					K7SCR_SET_SCENARIO_FLAG( EV035008 );
					//ԕύX
					K7SCR_EVCONDCHANGE();
					//inGameĊJ
					K7SCR_EXIT_PLAYMODE();
					K7SCR_EXIT_DEMOPAUSE();
				}else
				//̎wւ𑕔Ă邩H
				if( K7SCR_EVEQUIPRING(RING_WATER) == true )
				{
					//inGame~
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					//gF̉
					FixCam( CAM354M00FIREPLACE );
					K7SCR_STGC_MESSAGE_B( MES354M00_USE_WATER_RING );
					GoOutFireplaceEffectByWater();
					//SetPoolLight( false );
					//ĂtOON
					K7SCR_SET_SCENARIO_FLAG( EV035008 );
					//ԕύX
					K7SCR_EVCONDCHANGE();
					//inGameĊJ
					K7SCR_EXIT_PLAYMODE();
					K7SCR_EXIT_DEMOPAUSE();
				}else
				//KvȎwւ𑕔ĂȂ̂œJ&䉹
				{
					FixCamMesWithRiddle( CAM354M00FIREPLACE, MES354M00_RIDDLE_PUTOUT_FIRE );
				}
			}
#if	0
			else
			{
				//---- ΂Ăꍇ ----
				//̎wւ𑕔Ă邩
				if( K7SCR_EVEQUIPRING(RING_FIRE) == true )
				{
					//inGame~
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					//gF̉_
					FixCam( CAM354M00FIREPLACE );
					K7SCR_STGC_MESSAGE_B( MES354M00_USE_FIRE_RING );
					StartFireplaceEffect();
					SetPoolLight( true );
					//ĂtOOFF
					K7SCR_RESET_SCENARIO_FLAG( EV035008 );
					//ԕύX
					K7SCR_EVCONDCHANGE();
					//inGameĊJ
					K7SCR_EXIT_PLAYMODE();
					K7SCR_EXIT_DEMOPAUSE();
				}else
				{
				//	FixCamWithRiddle( CAM354M00FIREPLACE );
					FixCamMesWithRiddle( CAM354M00FIREPLACE, MES354M00_RIDDLE_FIRE );
				}
			}
#endif
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool
K7Stage354M00::DoorEventCallBack( WK7DoorEventInfo &info )
{
	switch( info.mEventNo )
	{
		//v[
		case	K7EVENTDOOR( 035003 ):
			if( K7SCR_GET_SCENARIO_FLAG(DR035003) == false )
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				FixCamMes( CAM354M00_LOCKDOOR, MES354M00_LOCKDOOR );
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
				return( false );
			}else
			{
				//AJl̃plŃCg_H
				if( K7SCR_GET_SCENARIO_FLAG(EV0361POOL_LIGHT_ON) == false )
				{	//΂Ă
					info.mNextStageID = K7STGID( 362, 1 );
					strcpy( info.mNextBpName, "door_035109" );
				}else
				{	//΂_Ă
					info.mNextStageID = K7STGID( 362, 0 );
				}
			}
			break;
		
		//_XgV[go
		case	K7EVENTDOOR( 035004 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			FixCamMes( CAM354M00_DUSTCHUTE, MES354M00_DUSTCHUTE );
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
			return( false );
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//_o
//------------------------------------------------------------------------------
bool
K7Stage354M00::BpLeaveCallBack( WK7BpInfo &info )
{
	u32	eventNo  = GetBpEventNo( info );
	int	pathNo   = GetBpPathNo( info );
	
	switch( eventNo )
	{
		//gFO
		case	K7EVENTNO( 035009 ):
			return( true );
			#if	0
			if( pathNo == 0 )
			{
				//gF̉΂Ă邩mF
				if( K7SCR_GET_SCENARIO_FLAG(EV035008) == FALSE )
				{
					//---- ΂_Ă ----
					//̎wւ𑕔Ă䉹͖炳Ȃ
					if( (K7SCR_EVEQUIPRING(RING_WIND) == true)
					 || (K7SCR_EVEQUIPRING(RING_WATER) == true) )
					{
						return( true );
					}
				}else
				{
					//---- ΂Ă ----
					//̎wւ𑕔Ă䉹͖炳Ȃ
					if( K7SCR_EVEQUIPRING(RING_FIRE) == true )
					{
						return( true );
					}
				}
			}else
			{
				return( true );
			}
			#endif
			break;
		
		//gF
		case	K7EVENTNO( 035008 ):
			return( true );
			#if	0
			if( strcmp(info.GetNextPathName(),PATH354M00FIREPLACE) == 0 )
			{
				//gF̉΂Ă邩mF
				if( K7SCR_GET_SCENARIO_FLAG(EV035008) == FALSE )
				{
					//---- ΂_Ă ----
					//̎wւ𑕔Ă䉹͖炳Ȃ
					if( K7SCR_EVEQUIPRING(RING_WIND) == true )
					{
						return( true );
					}
				}else
				{
					//---- ΂Ă ----
					//̎wւ𑕔Ă䉹͖炳Ȃ
					if( K7SCR_EVEQUIPRING(RING_FIRE) == true )
					{
						return( true );
					}
				}
			}else
			{
				return( true );
			}
			#endif
			break;
		
		//gF
		case	K7EVENTNO( 035010 ):
			if( pathNo == 0 )
			{
				//łR[eWvĂ䉹͖炳Ȃ
				if( K7SCR_GET_SCENARIO_FLAG(EV035010) == true )
				{
					return( true );
				}
			}else
			{
				return( true );
			}
			break;
		
		//}XNŔj󂷂
		case	K7EVENTNO( 035018 ):
		case	K7EVENTNO( 035019 ):
			if( pathNo == 0 )
			{
				//ǂ󂵂Ă䉹͖炳Ȃ
				if( K7SCR_GET_SCENARIO_FLAG(EV035017) == true )
				{
					return( true );
				}
			}else
			{
				return( true );
			}
			break;
		
		//ftHg
		default:
			return( true );
	}
	
	//SEĐ
	gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );
	
	return( true );
}

//------------------------------------------------------------------------------
//XyV\͎gp
//------------------------------------------------------------------------------
bool
K7Stage354M00::SpAbilityCallBack( WK7SpAbilityInfo &info )
{
	switch( info.mAbilityID )
	{
		case	PC_SPA_BOOST_JUMP:
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			//Wv
			CyoJumpLand();
			//WvtOON
			K7SCR_SET_SCENARIO_FLAG( EV035010 );
			//pXJgȂ
			K7SCR_STG_SET_DISABLEPATHCAMERA( "event_035010", false );
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			return( false );
			break;
		
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//qbgIuWF
//------------------------------------------------------------------------------
bool
K7Stage354M00::HitObjCallBack( WK7HitObjInfo &info )
{
	switch( info.mEventNo )
	{
		//
		case	K7EVENTNO( 035017 ):
			if( WK7PLAYERCONTROL->GetMainID() == K7MSK )
			{
				//퓬I
				KK7BattleMainTask::BattleMainTaskExit(2);
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				//ǂtOON
				K7SCR_SET_SCENARIO_FLAG( EV035017 );
				K7SCR_STG_SET_PATHENABLE( PATH354M00_MSK, true );
				K7SCR_STG_SET_DISABLEPATHCAMERA( PATH354M00_MSKWALL_1, true );
				K7SCR_STG_SET_DISABLEPATHCAMERA( PATH354M00_MSKWALL_2, true );
				//IuWF
				info.mpJObj->Hide( false, true );
				BrokenObj( MDL354M00_WALL );
				//
				KK7DoorSmokeEffect( (Vec){-178.196f, 35.102f, -1230.243f} );
				//Jݒ
				SetMskWallCam( CAM354M00_MSK_WALL );
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//cvOCxg
//------------------------------------------------------------------------------
bool
K7Stage354M00::ZanEventCallBack( WK7ZanEventInfo &info )
{
	switch( info.mEventNo )
	{
		//gFgBX
		case	K7EVENTZAN(035001):
			K7SCR_SET_SCENARIO_FLAG( EV0354TALK_TRAVIS );
			break;
		
		default:
			break;
	}
	return( true );
}

//------------------------------------------------------------------------------
//gFGtFNg\
//------------------------------------------------------------------------------
void
K7Stage354M00::DispFireplaceEffect( void )
{
	Vec      	loc;
	WK7JObj*	pJObj;
	
	//̕\W擾
	if( (pJObj=GetJObj("fire_locator")) != NULL )
	{
		pJObj->GetWorldPosition( loc );
	}else
	{
		loc.x = loc.y = loc.z = 0.0f;
	}
	
	if( ((mFire == NULL) || (IsValidEffect(mFire) == false))
	 && ((mFire=CreateEffectModelFire((const char*)NULL,MFIRE_RUMP,&loc,FIRESIZE354M00)) != NULL)
	 && (mFire->GetEffect() != NULL) )
	{
		SetWindModelFireEffect( mFire->GetEffect(), (Vec){-0.2f,0.0f,-1.0f}, 0.0f );
	}
}

//------------------------------------------------------------------------------
//gFGtFNg~߂
//------------------------------------------------------------------------------
void
K7Stage354M00::StopFireplaceEffect( void )
{
	if( gpSound->mCheckSE(SFX_SCE3_CUR_DANRO) == true )
	{
		gpSound->mStopSE(SFX_SCE3_CUR_DANRO);
	}
	if( (mFire != NULL) || (IsValidEffect(mFire) == true) )
	{
		gpSound->mPlaySE( SFX_SCE3_CUR_DANRO_KIERU );
		DelReqEffect( mFire );
	}
	mFire = NULL;
}

//------------------------------------------------------------------------------
//gF̉΂_
//------------------------------------------------------------------------------
void
K7Stage354M00::StartFireplaceEffect( void )
{
	DispFireplaceEffect();
	PlayFireplaceSE();
	K7SCR_TIMEWAIT( 4800 );
}

//------------------------------------------------------------------------------
//gF̉΂
//------------------------------------------------------------------------------
void
K7Stage354M00::GoOutFireplaceEffect( void )
{
	if( mFire != NULL )
	{
		SetWindModelFireEffect( mFire->GetEffect(), (Vec){1.0f,0.0f,0.0f}, 0.6f );
		K7SCR_TIMEWAIT( 4800 );
		StopFireplaceEffect();
		K7SCR_TIMEWAIT( 4800 );
	}
}

//------------------------------------------------------------------------------
//gF̉΂(̎w)
//------------------------------------------------------------------------------
void
K7Stage354M00::GoOutFireplaceEffectByWater( void )
{
	Vec      	loc;
	WK7JObj*	pJObj;
	
	//̕\W擾
	if( (pJObj=GetJObj("fire_locator")) != NULL )
	{
		pJObj->GetWorldPosition( loc );
	}else
	{
		loc.x = loc.y = loc.z = 0.0f;
	}
	loc.y += 20.0f;
	
//	//o
//	if( mWater == NULL )
//	{
//		while( (mWater=CreateBillBoardEffect(BILLEFF_SPRINKLER,loc,0.0f)) == NULL )
//		{
//			K7SCR_RETSYS();
//		}
//		K7SCR_TIMEWAIT( 4800 );
//	}
	//΂
	if( mFire != NULL )
	{
		StopFireplaceEffect();
		K7SCR_TIMEWAIT( 4800 );
	}
//	//~߂
//	if( mWater != NULL )
//	{
//		ReleaseEffect( mWater );
//		mWater = NULL;
//	}
}

//------------------------------------------------------------------------------
//v[邭Ȃ
//------------------------------------------------------------------------------
void
K7Stage354M00::PoolLightOn( void )
{
	WK7JObj*	pJObj;
	
	if( (pJObj=GetJObj("on1")) != NULL )
	{
		pJObj->Disp( false, true );
	}
	if( (pJObj=GetJObj("off1")) != NULL )
	{
		pJObj->Hide( false, true );
	}
}

//------------------------------------------------------------------------------
//v[ÂȂ
//------------------------------------------------------------------------------
void
K7Stage354M00::PoolLightOff( void )
{
	WK7JObj*	pJObj;
	
	if( (pJObj=GetJObj("on1")) != NULL )
	{
		pJObj->Hide( false, true );
	}
	if( (pJObj=GetJObj("off1")) != NULL )
	{
		pJObj->Disp( false, true );
	}
}

#if	0
//------------------------------------------------------------------------------
//v[̃Cgݒ
//------------------------------------------------------------------------------
void
K7Stage354M00::PoolLightAnm( bool inLight, u32 inCamID, WK7JObj* inPJObj )
{
	FixCam( inCamID );
	
	if( inLight == false )
	{
		gpSound->mPlaySE( SFX_SCE3_CUR_POOLLIGHT_OFF );
		AlphaObjChange( NULL, inPJObj, POOL_LIGHT_SPEED );
	}else
	{
		gpSound->mPlaySE( SFX_SCE3_CUR_POOLLIGHT_ON );
		AlphaObjChange( inPJObj, NULL, POOL_LIGHT_SPEED );
	}
	
	K7SCR_TIMEWAIT( POOL_LIGHT_SPEED );
}
//------------------------------------------------------------------------------
//v[̃Cgݒ
// in --> bool inLight  false  Cg
//                      true   Cg_
// out -> none
//------------------------------------------------------------------------------
void
K7Stage354M00::SetPoolLight( bool inLight )
{
	WK7JObj*	pJObj;
	WK7JObj*	pJObjOn;
	WK7JObj*	pJObjOff;
	WK7Stage*	pStage;
	u32			stgid;
	int			i;
	char     	objname[64];
	EFFECT*		mpPool = NULL;
	u8			streamVol;
	
	//---- Stage362M02Ăяo ----
	K7SCR_NOISE_REQUEST();
	streamVol = gpSound->mGetVolumeStream();
	gpSound->mFadeVolumeStream( (u8)(streamVol*30/100), 200 );
	if( mpWindEffect1 != NULL )
	{
		ReleaseEffect( mpWindEffect1 );
		mpWindEffect1 = NULL;
	}
	if( mpWindEffect2 != NULL )
	{
		ReleaseEffect( mpWindEffect2 );
		mpWindEffect2 = NULL;
	}
	if( (mFire != NULL) || (IsValidEffect(mFire) == true) )
	{
		gpSound->mPlaySE( SFX_SCE3_CUR_DANRO_KIERU );
		DelReqEffect( mFire );
	}
	mFire = NULL;
	K7SCR_PC_SETVISIBLE( false );
	//Xe[WIDݒ
	stgid = K7STGID( 362, 2 );
	//354Xe[W
	K7SCR_STG_VISIBLE( mID, false );
	//362Xe[WĂяo
	K7SCR_STG_CREATE_B( stgid );
	pStage   = WK7Stage::GetStage( stgid );
	pJObjOn  = pStage->GetJObj( MDL354M00_POOL_ON );
	pJObjOff = pStage->GetJObj( MDL354M00_POOL_OFF );
	//362Xe[W\
	K7SCR_STG_VISIBLE( stgid, true );
	if( K7SCR_GET_SCENARIO_FLAG(EV035108) == false )
	{
		mpPool = CreatePoolEffect( LOC354M00POOL_X_SIZE, LOC354M00POOL_Z_SIZE,
								   VParam[ED_POOL][7] * 0.1F,
								   (Vec){ LOC354M00POOL_X, LOC354M00POOL_Y, LOC354M00POOL_Z } );
	}
	//v[̃CgԐݒ
	if( K7SCR_GET_SCENARIO_FLAG(EV035008) == false )
	{	//CgON
		pJObjOn->Disp( false, true );
		pJObjOff->Hide( false, true );
		if( mpPool != NULL ){ChangePoolColor( mpPool, CMK( VParam[ED_POOL][13], VParam[ED_POOL][14], VParam[ED_POOL][15], VParam[ED_POOL][16] ) ) ;}
		for( i = 0; i < POOL_LIGHT_NUM; i++ )
		{
			sprintf( objname, MDL354M00_POOL_LIGHT, i + 1 );
			pJObj = pStage->GetJObj( objname );
			pJObj->Disp( false, true );
		}
	}else
	{	//CgOFF
		pJObjOn->Hide( false, true );
		pJObjOff->Disp( false, true );
		if( mpPool != NULL ){ChangePoolColor( mpPool, 0x404040ff );}
		for( i = 0; i < POOL_LIGHT_NUM; i++ )
		{
			sprintf( objname, MDL354M00_POOL_LIGHT, i + 1 );
			pJObj = pStage->GetJObj( objname );
			pJObj->Hide( false, true );
		}
	}
	//Jς
	FixCam( CAM354M00POOL );
	//G̕\
	WK7Npc::NpcVisibleAll( false );
	K7SCR_NOISE_RELEASE();
	K7SCR_TIMEWAIT( POOL_LIGHT_SPEED );
	//_邩
	if( inLight == false )
	{	//---- Cg ----
		//Cg
		PoolLightAnm( false, CAM354M00_POOL_LIGHT4, pStage->GetJObj(MDL354M00_POOL_LIGHT4) );
		PoolLightAnm( false, CAM354M00_POOL_LIGHT5, pStage->GetJObj(MDL354M00_POOL_LIGHT5) );
		PoolLightAnm( false, CAM354M00_POOL_LIGHT6, pStage->GetJObj(MDL354M00_POOL_LIGHT6) );
		//Xe[Wf\&\ݒ
		pJObjOn->Hide( false, true );
		pJObjOff->Disp( false, true );
		if( mpPool != NULL ){ChangePoolColor( mpPool, 0x404040ff );}
		for( i = 0; i < POOL_LIGHT_NUM; i++ )
		{
			sprintf( objname, MDL354M00_POOL_LIGHT, i + 1 );
			pJObj = pStage->GetJObj( objname );
			pJObj->Hide( false, true );
		}
		// Jς
		FixCam( CAM354M00_POOL_INIT );
		WK7CAM->SetFov( 59.840f );
		WK7CAM->StartLinearInterpolateOnLinearPath( K7Stage354M00_Camera[CAM354M00_POOL_TERM].pos, K7Stage354M00_Camera[CAM354M00_POOL_TERM].tgt, WK7_TICK_TO_FRAME(STG354M00_CAM_TICK)*2 );
		K7SCR_TIMEWAIT( STG354M00_CAM_TICK );
		K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
		//FixCamMes( CAM354M00_POOL_TERM, MES354M00_POOLOFF );
	}else
	{	//---- Cg_ ----
		//Cg
		PoolLightAnm( true, CAM354M00_POOL_LIGHT4, pStage->GetJObj(MDL354M00_POOL_LIGHT4) );
		PoolLightAnm( true, CAM354M00_POOL_LIGHT5, pStage->GetJObj(MDL354M00_POOL_LIGHT5) );
		PoolLightAnm( true, CAM354M00_POOL_LIGHT6, pStage->GetJObj(MDL354M00_POOL_LIGHT6) );
		//Xe[Wf\&\ݒ
		pJObjOn->Disp( false, true );
		pJObjOff->Hide( false, true );
		if( mpPool != NULL ){ChangePoolColor( mpPool, CMK( VParam[ED_POOL][13], VParam[ED_POOL][14], VParam[ED_POOL][15], VParam[ED_POOL][16] ) ) ;}
		for( i = 0; i < POOL_LIGHT_NUM; i++ )
		{
			sprintf( objname, MDL354M00_POOL_LIGHT, i + 1 );
			pJObj = pStage->GetJObj( objname );
			pJObj->Disp( false, true );
		}
		// Jς
		FixCam( CAM354M00_POOL_INIT );
		WK7CAM->SetFov( 59.840f );
		WK7CAM->StartLinearInterpolateOnLinearPath( K7Stage354M00_Camera[CAM354M00_POOL_TERM].pos, K7Stage354M00_Camera[CAM354M00_POOL_TERM].tgt, WK7_TICK_TO_FRAME(STG354M00_CAM_TICK)*2 );
		K7SCR_TIMEWAIT( STG354M00_CAM_TICK );
		K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
		//FixCamMes( CAM354M00_POOL_TERM, MES354M00_POOLON );
	}
	//inGame~
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	//---- Stage354M00ɖ߂Ă ----
	K7SCR_NOISE_REQUEST();
	gpSound->mFadeVolumeStream( streamVol, 200 );
	if( mpPool != NULL ){DeleteEffect( mpPool );}
	//362Xe[W
	K7SCR_STG_VISIBLE( stgid, false );
	//362Xe[W
	K7SCR_STG_RELEASE( stgid );
	//354Xe[W\
	K7SCR_STG_VISIBLE( mID, true );
	//LN^\
	K7SCR_PC_SETVISIBLE( true );
	//΂_ۂɒgF̃pXɂ狭ړ
	if( (inLight == true) && (strcmp(WK7PLAYERPATHCONTROL->GetCurrentPathName(),"pass_coyote") == 0) )
	{
		SetCurrentPath(	GetPathNurbsAll(PATH354M00FIREPLACE),
						0.900f,
						1,									//0:forward 1:back
						WK7PATHINFO_INITDIR_TGTDIR );		// wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
	}
	//JPCtH[
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
	//G̕\ONɂ
	WK7Npc::NpcVisibleAll( true );
	//JPCtH[ɖ߂
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
	//gF̉̐ݒ
	if( inLight == true )
	{
		K7SCR_RESET_SCENARIO_FLAG( EV035008 );
		K7SCR_EVCONDCHANGE();
	}
	K7SCR_NOISE_RELEASE();
}
#endif

//------------------------------------------------------------------------------
//R[ẽWv`n
//------------------------------------------------------------------------------
void
K7Stage354M00::CyoJumpLand( void )
{
	WK7PlayerSpInfoCyo	*pCyoInfo = WK7PLAYERCONTROL->GetSpInfoCyo();
	pCyoInfo->mpToBpName      = "branchD";
	pCyoInfo->mFromPos.x      =  -139.946f;
	pCyoInfo->mFromPos.y      =    25.728f;
	pCyoInfo->mFromPos.z      = -1132.049f;
	pCyoInfo->mFromRotY       =     1.571f;
	pCyoInfo->mToPos  .x      =  -130.253f;
	pCyoInfo->mToPos  .y      =    65.108f;
	pCyoInfo->mToPos  .z      = -1132.049f;
	pCyoInfo->mToRotY         =     1.571f;
	pCyoInfo->mStageMessage   = true;
	pCyoInfo->mStageMessageID = MES354M00_CHIMNEY;
	pCyoInfo->mLandingSE      = true;
	pCyoInfo->mLandingSEID    = SFX_PC_CYO_CHAKUCHI_CONC;
	
	//Jݒ
	FixCam( CAM354M00JUMPBOTTOM );
	//Wv[VĐ
	while( WK7PLAYERCONTROL->GetSpProc() < SPCYO_JUMPWAIT )
	{
		K7SCR_RETSYS();
	}
	
	//Jݒ
	FixCam( CAM354M00JUMPUPPER );
	//n[VĐ
	while( WK7PLAYERCONTROL->GetSpProc()!=SPCYO_IDLE )
	{
		K7SCR_RETSYS();
	}
}

//------------------------------------------------------------------------------
//gF̌ʉ炷
//------------------------------------------------------------------------------
void
K7Stage354M00::PlayFireplaceSE( void )
{
	Vec      	loc;
	WK7JObj*	pJObj;
	
	//΂_Ă特炷
	if( K7SCR_GET_SCENARIO_FLAG(EV035008) == FALSE )
	{
		//̕\W擾
		if( (pJObj=GetJObj("fire_locator")) != NULL )
		{
			pJObj->GetWorldPosition( loc );
		}else
		{
			loc.x = loc.y = loc.z = 0.0f;
		}
		//gF̌ʉݒ
		if( gpSound->mCheckSE(SFX_SCE3_CUR_DANRO) == false )
		{
			KK7SoundLoopSePlayVolumeChange( loc, K7SCR_STG_GET_CURRENTID(), SFX_SCE3_CUR_DANRO );
		}
	}
}
