////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage356M00 J[eBX̉Ɓ@ʑ
//
// K7Stage356M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 01/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE356M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage356M00.h"

//bZ[W
#define	MES356M00_00	(0)		//ZLeBɂ胍bNĂ
#define	MES356M00_01	(1)		//LԂ̔̃bNꂽ
//[V
#define	MOT356M00_DOORHALL	(0)	//LԂ̔J
//f
#define	MDL356M00_DOORHALL	"hall_door"




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage356M00::K7Stage356M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage356M00_Camera );
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage356M00::~K7Stage356M00()
{
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage356M00::CreateCallBack( void )
{
	//[Vt@C
	CreateOwnStageMotion( MOT356M00_DOORHALL );
	
	return( true );
}
//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage356M00::CondChangeCallBack( void )
{
	//ZR1
	if( K7SCR_GET_SCENARIO_FLAG(EV035101) == TRUE )
	{
		//ς݂łΏ
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035101), false );
	}else
	{
		//\
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035101), true );
	}
	
	//ZR2
	if( K7SCR_GET_SCENARIO_FLAG(EV035102) == TRUE )
	{
		//ς݂łΏ
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035102), false );
	}else
	{
		//\
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035102), true );
	}
	
	//gF̉΂Ă邩mF
	if( K7SCR_GET_SCENARIO_FLAG(EV035008) == FALSE )
	{	//gF̉΂_Ă
		SimpleModelDisp( "on1" );
		SimpleModelHide( "off1" );
	}else
	{	//gF̉΂Ă
		SimpleModelHide( "on1" );
		SimpleModelDisp( "off1" );
	}
	
	//LԂ̔JĂ
	if( K7SCR_GET_SCENARIO_FLAG(DR035102) == true )
	{
		SimpleSetLastMotion( MDL356M00_DOORHALL, MOT356M00_DOORHALL );
	}else
	{
		SimpleSetStartMotion( MDL356M00_DOORHALL, MOT356M00_DOORHALL );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage356M00::EventCallBack( WK7EventInfo &info )
{
	switch( info.mEventNo )
	{
		//ZR1
		case	K7EVENTNO( 035101 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			//ZRsł΃pl邾
			if( K7SCR_GET_SCENARIO_FLAG(EV035012) == TRUE )
			{
				//plĂяo
			//	K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(035005), 3 );
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(035005), 10 );
				K7SCR_PANEL_START();
				K7SCR_PANEL_TERMWAIT();
				K7SCR_RETSYS();
				K7SCR_PANEL_EXIT();
				K7SCR_PANEL_EXITWAIT();
			}else
			//ZR
			{
				//plĂяo
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(035005), 1 );
				K7SCR_PANEL_START();
				K7SCR_PANEL_TERMWAIT();
				K7SCR_RETSYS();
				GameInfo.SetPanelNoiseCancel( true );
				K7SCR_PANEL_EXIT();
				K7SCR_PANEL_EXITWAIT();
				GameInfo.SetPanelNoiseCancel( false );
				//ZRtOON
				if( K7SCR_PANEL_GETRESULT() == 0 )
				{
					K7SCR_SET_SCENARIO_FLAG( EV035101 );
					//ԕύX
					K7SCR_EVCONDCHANGE();
					//SȂLԂ̔J
					UnlockHallDoor();
				}
				K7SCR_NOISE_RELEASE();
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			break;
		
		//ZR2
		case	K7EVENTNO( 035102 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			//ZRsł΃pl邾
			if( K7SCR_GET_SCENARIO_FLAG(EV035012) == TRUE )
			{
				//plĂяo
			//	K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(035005), 3 );
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(035005), 10 );
				K7SCR_PANEL_START();
				K7SCR_PANEL_TERMWAIT();
				K7SCR_RETSYS();
				K7SCR_PANEL_EXIT();
				K7SCR_PANEL_EXITWAIT();
			}else
			//ZR
			{
				//plĂяo
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(035005), 1 );
				K7SCR_PANEL_START();
				K7SCR_PANEL_TERMWAIT();
				K7SCR_RETSYS();
				K7SCR_PANEL_EXIT();
				K7SCR_PANEL_EXITWAIT();
				//ZRtOON
				if( K7SCR_PANEL_GETRESULT() == 0 )
				{
					K7SCR_SET_SCENARIO_FLAG( EV035102 );
					//ԕύX
					K7SCR_EVCONDCHANGE();
					//SȂLԂ̔J
					UnlockHallDoor();
				}
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool
K7Stage356M00::DoorEventCallBack( WK7DoorEventInfo &info )
{
	switch( info.mEventNo )
	{
		//LԂւ̔
		case	K7EVENTDOOR( 035102 ):
			if( K7SCR_GET_SCENARIO_FLAG(DR035102) == FALSE )
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				//JŒ胁bZ[W
				FixCamMes( CAM356M00HALLDOOR, MES356M00_00 );
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				return( false );
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//LԂւ̔̌J
//------------------------------------------------------------------------------
void
K7Stage356M00::UnlockHallDoor( void )
{
	WK7JObj*	pJObj;
	
	//SẴZRĂLԂւ̔J
//	if( (K7SCR_GET_SCENARIO_FLAG(EV035101) == TRUE)
//	 && (K7SCR_GET_SCENARIO_FLAG(EV035102) == TRUE)
//	 && (K7SCR_GET_SCENARIO_FLAG(EV035103) == TRUE)
//	 && (K7SCR_GET_SCENARIO_FLAG(EV035104) == TRUE) )
	if( K7SCR_GET_SCENARIO_FLAG(EV035101) == true )
	{
		//inGame~
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		//LԂւ̔JtOON
		K7SCR_SET_SCENARIO_FLAG( DR035102 );
		//JŒ胁bZ[W
		FixCam( CAM356M00HALLDOOR );
		K7SCR_NOISE_RELEASE();
		//J
		gpSound->mPlaySE( SFX_SCE3_CUR_HIROMA_UNLOCK );
		if( (pJObj = PlayMotion(MDL356M00_DOORHALL,MOT356M00_DOORHALL)) != NULL )
		{
			pJObj->SetMotionLoop( false );
			while( pJObj->GetMotionState() != WK7MODEL_NOANIM )
			{
				K7SCR_RETSYS();
			}
		}
		//K7SCR_STGC_MESSAGE_B( MES356M00_01 );
		K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
		K7SCR_NOISE_REQUEST();
		WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
	}
}
