////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage361M00 J[eBX̉Ɓ@L
//
// K7Stage361M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 01/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE361M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage361M00.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Wat\WK7Player.h"
#include "..\..\..\Wat\WK7Item.h"
#include "..\..\..\Yam\YK7EffectPool.h"

//O
#define	DOOR361M00EXIT	"door_035103_back_356M00door_035102"
//bZ[W
#define	MES361M00_00	(0)		//v[ւ̔J
//[V
#define	MOT361M00_ALL_SHUTTER_CLOSE	(0)	//Vb^[ES
#define	MOT361M00_ALL_SHUTTER_OPEN	(1)	//Vb^[JES
#define	MOT361M00_SHUTTER_CLOSE		(2)	//Vb^[
#define	MOT361M00_SHUTTER_OPEN		(3)	//Vb^[J
#define	MOT361M00_DOORPOOL			(0)	//v[̔J
//f
#define	MDL361M00SHUTTER	"anim"		//Vb^[
#define	MDL361M00DOORPOOL	"pool_door"	//v[̔
#define	MDL361M00_AKANE		"akane"		//AJl
#define MDL361M00ONESHUTTER	"shat"		//ʃVb^[
//JԎ
#define MDL361M00_CAMTIME	(10)
//v[֌W
#define	MDL362M02_POOL_ON		"light_on"		//362M00̃CgON
#define	MDL362M02_POOL_OFF		"light_off"		//362M00̃CgOFF
#define	MDL362M02_POOL_LIGHT	"light_00%d"	//362M00̃Cg
#define	MDL362M02_POOL_LIGHT4	"light_004"		//362M00̃Cg4
#define	MDL362M02_POOL_LIGHT5	"light_005"		//362M00̃Cg5
#define	MDL362M02_POOL_LIGHT6	"light_006"		//362M00̃Cg6
#define	MDL362M02_POOL			"pool"			//v[̐
#define	POOL_LIGHT_SPEED		(2400)			//v[̃Cg̕\tick
#define	POOL_LIGHT_NUM			(9)				//v[̃Cg
#define	LOC362M02POOL_X			(-375.295f)
#define	LOC362M02POOL_Y			(12.857f)
#define	LOC362M02POOL_Z			(-1124.98f)
#define	LOC362M02POOL_X_SIZE	(280.000f)
#define	LOC362M02POOL_Z_SIZE	(180.000f)
#define	STG362M02_CAM_TICK		(4800*5)		//Jړɂ鎞

// Vb^[
static const char *STG361_Shat[] =
{
	"move_shat", "move_shat1", "move_shat2", "move_shat3",
} ;



//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage361M00::K7Stage361M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage361M00_Camera );
	pNpcAK2 = NULL ;
	GameInfo.SetMenuMapEnable(false);
	GameInfo.SetBossFlag     (true );
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage361M00::~K7Stage361M00()
{
	GameInfo.SetMenuMapEnable(true );
	GameInfo.SetBossFlag     (false);
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage361M00::CreateCallBack( void )
{
	//[Vt@C
	CreateOwnStageMotion( MOT361M00_ALL_SHUTTER_CLOSE );
	CreateOwnStageMotion( MOT361M00_ALL_SHUTTER_OPEN );
	CreateOwnStageMotion( MOT361M00_SHUTTER_CLOSE );
	CreateOwnStageMotion( MOT361M00_SHUTTER_OPEN );
	//CreateOwnStageMotion( MOT361M00_DOORPOOL );
	
	return( true );
}

//------------------------------------------------------------------------------
//iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
//------------------------------------------------------------------------------
bool
K7Stage361M00::InitializeCallBack(void)
{
	// AJlQ擾
	pNpcAK2    = (K7EnmAK2 *)WK7Npc::Find(ENENO_AK2);
	//AJl|ĂH
	if( K7SCR_GET_SCENARIO_FLAG(EV036000) == false )
	{
		pNpcAK2->SetVisible3( true ) ;
	}else
	{
		pNpcAK2->SetVisible3( false ) ;
	}

	// y
	gpSound->mFadeVolumeStream( 0, 200 ) ;

	return( true );
}


//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage361M00::CondChangeCallBack( void )
{
	//AJl|ĂH
	if( K7SCR_GET_SCENARIO_FLAG(EV036000) == false )
	{
		SimpleModelHide( MDL361M00_AKANE );
	}else
	{
		SimpleModelDisp( MDL361M00_AKANE );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage361M00::SetCurrentCallBack( void )
{
//	WK7JObj*	pJObj;
	
	//Jf[^G[`FbN
	if( mpOneShotCamera == NULL )
	{
		return( false );
	}
	
	//AJl|ĂH
	if( K7SCR_GET_SCENARIO_FLAG(EV036000) == TRUE )
	{
		//---- AJl|Ă ----
		//v[̏Ɩ_H
		if( K7SCR_GET_SCENARIO_FLAG(EV0361POOL_LIGHT_ON) == true )
		{
			K7SCR_EVNO_SETENABLE( K7EVENTNO(035105), false );	//ZRւ̃WNV
		}
		//Vb^[Ă
		
		return true;
	}
	
	SetMoveModeCancel(true);
	
	//AJlEĂсȈꍇ̓Xe[WړɃpXړĂ
	if( WK7Play::HasPlayed(K7EVENTPLAY(03080402)) == true )
	{
		SetManualBranch( true );
		//ǂJɂȂ܂ő҂ǐ̎wJLɂ邽߁j
		while( WK7Stage::IsChanging() != false )
		{
			K7SCR_RETSYS();
		}
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		//PC̗ʒu𒲐
		SetCurrentPath(	GetPathNurbsAll("curve2"),
						0.100f,
						1,									//0:forward 1:back
						WK7PATHINFO_INITDIR_TGTDIR );		// wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
		WK7PLAYERPATHCONTROL->SetBranchPointFix(false);
		WK7PLAYERPATHCONTROL->SetActive(true);
		//Jݒ
		Vec	initpos;
		WK7PLAYERPATHCONTROL->GetCurrentPosition(&initpos);
		WK7CAMPATHFOLLOWINFO->SetStageStartMode              (true);
	//	WK7CAMPATHFOLLOWINFO->SetStageStartCamPosition       ((Vec){28.456f, 32.684f, -1723.609f});
	//	WK7CAMPATHFOLLOWINFO->SetStageStartCamTargetPosition ((Vec){23.342f, 31.321f, -1715.124f});
		WK7CAMPATHFOLLOWINFO->SetStageStartCamPosition       ((Vec){-59.880f, 23.720f, -1579.739f});
		WK7CAMPATHFOLLOWINFO->SetStageStartCamTargetPosition ((Vec){-40.345f, 30.859f, -1595.785f});
		WK7CAMPATHFOLLOWINFO->SetStageStartTargetInitPosition(initpos);
		WK7CAMPATHFOLLOWINFO->SetStageStartDist( 3.0f );
		//
		SandRelease( GetID(), SFX_SCE3_MAP_CHANGE_CUR_DOOR_WOOD_CLOSE );
		K7SCR_RETSYS();
		while( gpNoise->mGetSandFrameProc() != eSandStandby )
		{
			K7SCR_RETSYS();
		}
		SetManualBranch( false );
		SetMoveModeCancel( false );
	}else
	{
		//ǂJɂȂ܂ő҂
		while( WK7Stage::IsChanging() != false )
		{
			K7SCR_RETSYS();
		}
	}
	
	//---- AJl|ĂȂ ----
	gpSound->mStopStream();
	//inGame~
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	//ZRւ̃WNV
	K7SCR_EVNO_SETENABLE( K7EVENTNO(035105), false );
	//LԂopX
	K7SCR_STG_SET_PATHENABLE( DOOR361M00EXIT, false );
	//AJloL
	if( WK7Play::HasPlayed(K7EVENTPLAY(03080402)) == false )
	{
		K7SCR_NOISE_REQUEST();
		K7SCR_CHARAGEKI_PREPARE( K7EVENTPLAY(03080402) );
		K7SCR_NOISE_RELEASE();
		K7SCR_CHARAGEKI_END_WAIT( K7EVENTPLAY(03080402) );
		K7SCR_NOISE_REQUEST();
		K7SCR_CHARAGEKI_TERM( K7EVENTPLAY(03080402) );
		WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
		//PC̗ʒu𒲐
		SetCurrentPath(	GetPathNurbsAll("curve2"),
						0.100f,
						1,									//0:forward 1:back
						WK7PATHINFO_INITDIR_TGTDIR );		// wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
		WK7PLAYERPATHCONTROL->SetBranchPointFix(false);
		WK7PLAYERPATHCONTROL->SetActive(true);
		K7SCR_NOISE_RELEASE();
	}
	//inGameĊJ
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	{
		bool hr ;

		/// LA
		WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_BOSSBATTLE);
		
		// AJl
		hr = BattleAkane() ;
		
		/// LANA
		WK7PLAYERCONTROL->BattlePadRegulationSet();

		if( hr == false )
		{
			// lꂽ
			return( true );
		}
	}
	//AJl|ĂtOON
	K7SCR_SET_SCENARIO_FLAG( EV036000 );
	K7SCR_EVCONDCHANGE();
	//inGame~
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	// y
	gpSound->mFadeVolumeStream( 0, 100 ) ;
	//AJlSL
	K7SCR_NOISE_REQUEST();
	K7SCR_TIMEWAIT( 2400 );
	K7SCR_CHARAGEKI_PREPARE( K7EVENTPLAY(03080403) );
	K7SCR_NOISE_RELEASE();
	K7SCR_CHARAGEKI_END_WAIT( K7EVENTPLAY(03080403) );
	K7SCR_NOISE_REQUEST();
	K7SCR_CHARAGEKI_TERM( K7EVENTPLAY(03080403) );
	SetCurrentPath(	GetPathNurbsAll("curve2"),
					0.000f,
					1,									//0:forward 1:back
					WK7PATHINFO_INITDIR_TGTDIR );		// wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
	K7SCR_EVNO_SETENABLE( K7EVENTNO(035105), true );
	K7SCR_NOISE_RELEASE();
	
	//inGameĊJ
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage361M00::EventCallBack( WK7EventInfo &info )
{
	switch( info.mEventNo )
	{
		//ZR̃pl
		case	K7EVENTNO( 035105 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			//plĂяo
			GameInfo.SetPanelReleaseCancel( true );
			K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(035005), 1 );
			K7SCR_PANEL_START();
			K7SCR_PANEL_TERMWAIT();
			GameInfo.SetPanelNoiseCancel( true );
			K7SCR_PANEL_EXIT();
			K7SCR_PANEL_EXITWAIT();
			GameInfo.SetPanelNoiseCancel( false );
			GameInfo.SetPanelReleaseCancel( false );
			if( K7SCR_PANEL_GETRESULT() == 0 )
			{
				//v[ւ̔J
				K7SCR_SET_SCENARIO_FLAG( EV0361_OPEN_DOOR );
				//OpenPoolDoor();
				SetPoolLight();
				K7SCR_RESET_SCENARIO_FLAG( EV0361_OPEN_DOOR );
				//ZRւ̃WNV
				K7SCR_EVNO_SETENABLE( K7EVENTNO(035105), false );
				//v[̃Cg_
				K7SCR_SET_SCENARIO_FLAG( EV0361POOL_LIGHT_ON );
				//LԂopX\
				K7SCR_STG_SET_PATHENABLE( DOOR361M00EXIT, true );
			}else
			{
				K7SCR_PC_SETVISIBLE( true );
				K7SCR_NOISE_RELEASE();
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//v[̃Cgݒ
//------------------------------------------------------------------------------
void
K7Stage361M00::PoolLightAnm( bool inLight, u32 inCamID, WK7JObj* inPJObj )
{
	FixCam( inCamID );
	
	if( inLight == false )
	{
		gpSound->mPlaySE( SFX_SCE3_CUR_POOLLIGHT_OFF );
		AlphaObjChange( NULL, inPJObj, POOL_LIGHT_SPEED );
	}else
	{
		gpSound->mPlaySE( SFX_SCE3_CUR_POOLLIGHT_ON );
		AlphaObjChange( inPJObj, NULL, POOL_LIGHT_SPEED );
	}
	
	K7SCR_TIMEWAIT( POOL_LIGHT_SPEED );
}
//------------------------------------------------------------------------------
//v[̃Cgݒ
// in --> bool inLight  false  Cg
//                      true   Cg_
// out -> none
//------------------------------------------------------------------------------
void
K7Stage361M00::SetPoolLight( void )
{
	WK7JObj*	pJObj;
	WK7JObj*	pJObjOn;
	WK7JObj*	pJObjOff;
	WK7Stage*	pStage;
	u32			stgid;
	int			i;
	char     	objname[64];
	EFFECT*		mpPool = NULL;
	u8			streamVol;
	
	//---- Stage362M02Ăяo ----
	//K7SCR_NOISE_REQUEST();
	streamVol = gpSound->mGetVolumeStream();
	gpSound->mFadeVolumeStream( (u8)(streamVol*30/100), 200 );
	K7SCR_PC_SETVISIBLE( false );
	//Xe[WIDݒ
	stgid = K7STGID( 362, 2 );
	//361Xe[W
	K7SCR_STG_VISIBLE( mID, false );
	//362Xe[WĂяo
	K7SCR_STG_CREATE_B( stgid );
	pStage   = WK7Stage::GetStage( stgid );
	pJObjOn  = pStage->GetJObj( MDL362M02_POOL_ON );
	pJObjOff = pStage->GetJObj( MDL362M02_POOL_OFF );
	//362Xe[W\
	K7SCR_STG_VISIBLE( stgid, true );
	//v[GtFNg쐬
	mpPool = CreatePoolEffect( LOC362M02POOL_X_SIZE, LOC362M02POOL_Z_SIZE,
							   VParam[ED_POOL][7] * 0.1F,
							   (Vec){ LOC362M02POOL_X, LOC362M02POOL_Y, LOC362M02POOL_Z } );
	//v[̃CgԐݒ胉CgOFF
	pJObjOn->Hide( false, true );
	pJObjOff->Disp( false, true );
	if( mpPool != NULL ){ChangePoolColor( mpPool, 0x404040ff );}
	for( i = 0; i < POOL_LIGHT_NUM; i++ )
	{
		sprintf( objname, MDL362M02_POOL_LIGHT, i + 1 );
		pJObj = pStage->GetJObj( objname );
		pJObj->Hide( false, true );
	}
	//Jς
	FixCam( CAM362M02_POOL );
	//G̕\
	WK7Npc::NpcVisibleAll( false );
	K7SCR_NOISE_RELEASE();
	K7SCR_TIMEWAIT( POOL_LIGHT_SPEED );
	//---- Cg_ ----
	PoolLightAnm( true, CAM362M02_POOL_LIGHT4, pStage->GetJObj(MDL362M02_POOL_LIGHT4) );
	PoolLightAnm( true, CAM362M02_POOL_LIGHT5, pStage->GetJObj(MDL362M02_POOL_LIGHT5) );
	PoolLightAnm( true, CAM362M02_POOL_LIGHT6, pStage->GetJObj(MDL362M02_POOL_LIGHT6) );
	//Xe[Wf\&\ݒ
	pJObjOn->Disp( false, true );
	pJObjOff->Hide( false, true );
	if( mpPool != NULL ){ChangePoolColor( mpPool, CMK( VParam[ED_POOL][13], VParam[ED_POOL][14], VParam[ED_POOL][15], VParam[ED_POOL][16] ) ) ;}
	for( i = 0; i < POOL_LIGHT_NUM; i++ )
	{
		sprintf( objname, MDL362M02_POOL_LIGHT, i + 1 );
		pJObj = pStage->GetJObj( objname );
		pJObj->Disp( false, true );
	}
	// Jς
	FixCam( CAM362M02_POOL_INIT );
	WK7CAM->SetFov( 59.840f );
	WK7CAM->StartLinearInterpolateOnLinearPath( K7Stage361M00_Camera[CAM362M02_POOL_TERM].pos, K7Stage361M00_Camera[CAM362M02_POOL_TERM].tgt, WK7_TICK_TO_FRAME(STG362M02_CAM_TICK)*2 );
	K7SCR_TIMEWAIT( STG362M02_CAM_TICK );
	K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
	//inGame~
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	//---- Stage361M00ɖ߂Ă ----
	K7SCR_NOISE_REQUEST();
	gpSound->mFadeVolumeStream( streamVol, 200 );
	if( mpPool != NULL ){DeleteEffect( mpPool );}
	//362Xe[W
	K7SCR_STG_VISIBLE( stgid, false );
	//362Xe[W
	K7SCR_STG_RELEASE( stgid );
	//354Xe[W\
	K7SCR_STG_VISIBLE( mID, true );
	//LN^\
	K7SCR_PC_SETVISIBLE( true );
	//JPCtH[
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
	//G̕\ONɂ
	WK7Npc::NpcVisibleAll( true );
	FixCam( CAM361M00SHUTTER );
	K7SCR_NOISE_RELEASE();
	//Vb^[J[VĐ
	gpSound->mPlaySE( SFX_SCE3_CUR_SHUTTER_OPEN );
	SimplePlayMotionB( MDL361M00SHUTTER, MOT361M00_ALL_SHUTTER_OPEN );
	K7SCR_TIMEWAIT( 4800*2 )
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
}

//------------------------------------------------------------------------------
//v[̔J
//------------------------------------------------------------------------------
#if	0
void
K7Stage361M00::OpenPoolDoor( void )
{
	u32			stgid;
	WK7JObj*	pJObj;
	WK7Stage*	pStage;
	
	//---- Stage355M00Ăяo ----
	K7SCR_PC_SETVISIBLE( false );
	//Xe[WIDݒ
	stgid = K7STGID( 355, 0 );
	//361Xe[W
	K7SCR_STG_VISIBLE( mID, false );
	//355Xe[WĂяo
	K7SCR_STG_CREATE_B( stgid );
	//355Xe[W\
	K7SCR_STG_VISIBLE( stgid, true );
	//Xe[W[V
	pStage = WK7Stage::GetStage( stgid );
	pStage->CreateOwnStageMotion( MOT361M00_DOORPOOL );
	while( pStage->IsOwnMotionObjLoaded() != true )
	{
		K7SCR_RETSYS();
	}
	// Jς
	FixCam( CAM361M00POOL );
	//mCY
	K7SCR_PC_SETVISIBLE( false );
	K7SCR_NOISE_RELEASE();
	//inGame~
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	K7SCR_PC_SETVISIBLE( false );
	//J
	gpSound->mPlaySE( SFX_SYS_ELEV_DOOR );
	if( (pJObj=pStage->PlayMotion(MDL361M00DOORPOOL,MOT361M00_DOORPOOL)) != NULL )
	{
		pJObj->SetMotionLoop( false );
		while( pJObj->GetMotionState() != WK7MODEL_NOANIM )
		{
			K7SCR_RETSYS();
		}
	}
	K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
	//K7SCR_STGC_MESSAGE_B( MES361M00_00 );
	//inGame~
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	//---- Stage361M00ɖ߂Ă ----
	//mCY
	K7SCR_NOISE_REQUEST();
	//355Xe[W
	K7SCR_STG_VISIBLE( stgid, false );
	//355Xe[W
	K7SCR_STG_RELEASE( stgid );
	//361Xe[W\
	K7SCR_STG_VISIBLE( mID, true );
	//LN^\
	K7SCR_PC_SETVISIBLE( true );
	FixCam( CAM361M00SHUTTER );
	//mCY
	K7SCR_NOISE_RELEASE();
	//Vb^[J[VĐ
	gpSound->mPlaySE( SFX_SCE3_CUR_SHUTTER_OPEN );
	SimplePlayMotionB( MDL361M00SHUTTER, MOT361M00_ALL_SHUTTER_OPEN );
	K7SCR_TIMEWAIT( 4800*2 )
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
}
#endif

//------------------------------------------------------------------------------
//AJl
//------------------------------------------------------------------------------
bool
K7Stage361M00::BattleAkane( void )
{
	// ɃAJl

	// Vb^[̏
	ShatInit() ;
	pNpcAK2->SetShatData( shat ) ;

	// ҂
	while( pNpcAK2->GetInitEndFlag() == false )
	{
		pNpcAK2->StageProc(WK7Stage::GetCurrentStage());
		K7SCR_RETSYS();
	}
	
	// 蔻L
	{
		WK7JObj		*pJObj = GetJObj("alpha");
		static	HSD_PEDesc	pedesc = {
			//J[AAt@AŒAt@݁AZobt@SăGiuB
			ENABLE_COLOR_UPDATE|ENABLE_ALPHA_UPDATE|ENABLE_DST_ALPHA|ENABLE_COMPARE|ENABLE_ZUPDATE|ENABLE_DITHER|BEFORE_TEX,
			// GXSetAlphaCompare(),ref0,ref1
			0,0,
			// GXSetDstAlpha(),dst_alpha
			WK7RENDEROBJ_RENDERID_DEFAULT_ALPHA,
			// GXSetBlendMode(),type,src_factor,dst_factor,logic_op
			GX_BM_BLEND,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR,
			//GXSetZMode(),func
			GX_LEQUAL,
			//GXAlphaCompare,comp0,op,comp1
			GX_ALWAYS,GX_AOP_AND,GX_ALWAYS
		};
		if( pJObj!=NULL ){
			pJObj->SetPE(&pedesc,false,true);
			pJObj->SetNoZUpdate(false,false,true);
		}
	}
	
	// 퓬Jn
	pNpcAK2->AK2BossStart() ;
	while( pNpcAK2->GetGlobalModeState() == 0 )
	{
		if( WK7PLAYERCONTROL->PcDieTest() == true ) goto PLAYER_DIE ;
		pNpcAK2->StageProc(WK7Stage::GetCurrentStage());
		K7SCR_RETSYS();
	}
	
	// Vb^[
	{
		WK7JObj *JObj ;
		
		// [VĐ
		if( (JObj=PlayMotion(MDL361M00SHUTTER,MOT361M00_ALL_SHUTTER_CLOSE,NULL)) != NULL )
		{
			s32 i ;
		
			JObj->SetMotionLoop( false ,false, true );
			for( i = 0 ; i < STG361_SHATNUM ; i ++ )
			{
				shat[i].JObj->StopMotion(false,true) ;
			} 
		}
	}

	// 퓬I܂ő҂	
	pNpcAK2->SetGlobalModeState( 1000 ) ;
	while( pNpcAK2->GetGlobalModeState() == 1000 )
	{
		if( WK7PLAYERCONTROL->PcDieTest() == true ) goto PLAYER_DIE ;
		pNpcAK2->StageProc(WK7Stage::GetCurrentStage());
		K7SCR_RETSYS();
	}
	
	// 퓬
	KK7BattleMainTask::BattleMainTaskExit( 2 );
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();

	// JZbg
	{
		Vec apos, cpos, cpos2, apos2, vc, vt ;
		s32 i ;
		f32 rate, rate2 ;
		
		WK7CAM->GetTargetPosition( apos2 ) ;
		WK7CAM->GetPosition( cpos2 ) ;
		
		pNpcAK2->GetRootJointPos( &apos ) ;
		cpos.x = apos.x + 10.0F ;
		cpos.y = apos.y + 10.0F ;
		cpos.z = apos.z + 10.0F ;
		
		// 
		for( i = 0 ; i < MDL361M00_CAMTIME ; i ++ )
		{
			rate = (f32)i / ( MDL361M00_CAMTIME - 1 ) ;
			rate2 = 1.0F - rate ;
			vc.x = cpos.x * rate + cpos2.x * rate2 ;
			vc.y = cpos.y * rate + cpos2.y * rate2 ;
			vc.z = cpos.z * rate + cpos2.z * rate2 ;

			vt.x = apos.x * rate + apos2.x * rate2 ;
			vt.y = apos.y * rate + apos2.y * rate2 ;
			vt.z = apos.z * rate + apos2.z * rate2 ;
		
			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
			WK7CAM->SetPosition      (vc);
			WK7CAM->SetTargetPosition(vt);
			
			if( WK7PLAYERCONTROL->PcDieTest() == true ) goto PLAYER_DIE ;
			K7SCR_RETSYS() ;
		}
	}
	pNpcAK2->SetGlobalModeState( 2 ) ;		// Ԑ

	// ҂
	while( pNpcAK2->GetGlobalModeState() == 2 )
	{
		if( WK7PLAYERCONTROL->PcDieTest() == true ) goto PLAYER_DIE ;
		pNpcAK2->StageProc(WK7Stage::GetCurrentStage());
		K7SCR_RETSYS();
	}

	// J߂
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	pNpcAK2->SetGlobalModeState( 4 ) ;		// Ԑ
	
	// ҂
	while( pNpcAK2->AK2BossEnd() == false )
	{
		if( WK7PLAYERCONTROL->PcDieTest() == true ) goto PLAYER_DIE ;
		pNpcAK2->StageProc(WK7Stage::GetCurrentStage());
		K7SCR_RETSYS();
	}

	K7SCR_STG_SET_DISABLEPATHCAMERA( "curve1", true );
	K7SCR_STG_SET_DISABLEPATHCAMERA( "curve2", true );
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	DefaultPathChangeProcess() ;

	return( true );
	
PLAYER_DIE :
	pNpcAK2->Release() ;
	return( false ) ;
}

// Vb^[̏s
void
K7Stage361M00::ShatInit( void )
{
	s32 i ;
	STG361SHAT *st ;
	WK7ModelMotion *Motion ;
	
	// [V̎擾
	Motion = GetOwnStageMotion( MOT361M00_SHUTTER_CLOSE )->GetModelMotion() ;
	
	st = shat ;
	for( i = 0 ; i < STG361_SHATNUM ; i ++, st ++ )
	{
		// ̏
		st->JObj 		= GetJObj( STG361_Shat[i] )->GetChild() ;
		st->closeflag 	= false ;
		st->closerate 	= 0.0F ;
		st->endflag		= true ;

		// [ṼA^b`
		st->JObj->AttachFindMotion( Motion, true, true ) ;
	}
}


