////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage362M01 J[eBX̉Ɓ@v[EÂ
//
// K7Stage362M01.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 01/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE362M01_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage362M01.h"
#include "..\..\..\Yam\YK7EffectPool.h"

//bZ[W
#define	MES362M01_NEEDLIGHT		(0)		//肪Kv
#define	MES362M01_DOOR_UNLOCK	(1)		//J
#define	MES362M01_DOOR_LOCK		(2)		//Ă
//f
#define	MDL362M01_CYO_PICKING_POS	"cyo_picking_354"	//R[eJW
#define	MDL362M01_LOCK_ON			"cyo_padlock_on"	//̂Ă
#define	MDL362M01_LOCK_OFF			"cyo_padlock_off"	//̊JĂ

#define	LOC362M01POOL_X			(-375.295f)
#define	LOC362M01POOL_Y			(12.857f)
#define	LOC362M01POOL_Z			(-1124.98f)
#define	LOC362M01POOL_X_SIZE	(280.000f)
#define	LOC362M01POOL_Z_SIZE	(180.000f)

#define	STG362M01_CAM_TICK		(4800*5)		//Jړɂ鎞




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage362M01::K7Stage362M01(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage362M01_Camera );
	mpPool = NULL;
	K7SCR_RESET_SCENARIO_FLAG( EV036201 );
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage362M01::~K7Stage362M01()
{
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage362M01::CondChangeCallBack( void )
{
	//v[WNV
	K7SCR_EVNO_SETENABLE( K7EVENTNO(035116), false );
	
	//v[̐H
	if( K7SCR_GET_SCENARIO_FLAG(EV035108) == false )
	{
		if( mpPool == NULL )
		{
			mpPool = CreatePoolEffect( LOC362M01POOL_X_SIZE, LOC362M01POOL_Z_SIZE,
									   VParam[ED_POOL][7] * 0.1F,
									   (Vec){ LOC362M01POOL_X, LOC362M01POOL_Y, LOC362M01POOL_Z } );
			ChangePoolColor( mpPool, 0x404040ff );
		}
	}else
	{
		if( mpPool != NULL )
		{
			DeleteEffect( mpPool );
			mpPool = NULL;
		}
	}
	
	//ւ̔
	if( K7SCR_GET_SCENARIO_FLAG(DR035003) == false )
	{
		SimpleModelDisp( MDL362M01_LOCK_ON );
		SimpleModelHide( MDL362M01_LOCK_OFF );
	}else
	{
		SimpleModelHide( MDL362M01_LOCK_ON );
		SimpleModelDisp( MDL362M01_LOCK_OFF );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage362M01::SetCurrentCallBack( void )
{
	f32	fov;
	
	gpSound->mFadeVolumeStream( 0, 200*2 );
	gpSound->mSetDspRateAll( 0 );
	//354355痈ꍇ͌n
	if( (GetPrevStageID() == K7STGID(354,0))
	 || (GetPrevStageID() == K7STGID(355,0)) )
	{
		//ǂJɂȂ܂ő҂
		while( WK7Stage::IsChanging() != false )
		{
			K7SCR_RETSYS();
		}
		//inGame~
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE( false );
		FixCam( CAM362M01POOL_INIT );
		fov = WK7CAM->GetFov();
		WK7CAM->SetFov( GetDefaultCameraFov() );
		WK7CAM->StartLinearInterpolateOnLinearPath( K7Stage362M01_Camera[CAM362M01POOL].pos, K7Stage362M01_Camera[CAM362M01POOL].tgt, WK7_TICK_TO_FRAME(STG362M01_CAM_TICK)*2);
		WK7CAM->SetFov( GetDefaultCameraFov() );
		K7SCR_TIMEWAIT( STG362M01_CAM_TICK );
		K7SCR_STGC_MESSAGE_B( MES362M01_NEEDLIGHT );
		WK7CAM->SetFov( fov );
		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE( true );
	}
	
	gpSound->mPlayStreamNo( HPS_CURTIES_C );
	return( false );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage362M01::EventCallBack( WK7EventInfo &info )
{
	switch( info.mEventNo )
	{
		//v[
		case	K7EVENTNO( 035116 ):
			FixCamMes( CAM362M01POOL, MES362M01_NEEDLIGHT );
			break;
		
		//
		case	K7EVENTNO( 035119 ):
			FixCamMes( CAM362M01_WIRENET, MES362M01_NEEDLIGHT );
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool
K7Stage362M01::DoorEventCallBack( WK7DoorEventInfo &info )
{
	switch( info.mEventNo )
	{
		//V[gJbg
		case	K7EVENTDOOR( 035109 ):
			if( K7SCR_GET_SCENARIO_FLAG(DR035003) == false )
			{
				if( WK7PLAYERCONTROL->GetMainID() == K7CYO )
				{
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					SimpleCyoPicking( MDL362M01_CYO_PICKING_POS, CAM362M01_CYO_PICKING );
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					K7SCR_SET_SCENARIO_FLAG( DR035003 );
					K7SCR_EVCONDCHANGE();
					K7SCR_PC_SETVISIBLE( false );
					FixCam( CAM362M01_LOCKDOOR );
					K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
					info.mCinemaScopeClear = true;
					//K7SCR_STGC_MESSAGE_B( MES362M01_DOOR_UNLOCK );
					K7SCR_PC_SETVISIBLE( true );
					K7SCR_EXIT_PLAYMODE();
					K7SCR_EXIT_DEMOPAUSE();
				}else
				{
					FixCamMesWithRiddle( CAM362M01_LOCKDOOR, MES362M01_DOOR_LOCK );
					return( false );
				}
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
// _
//------------------------------------------------------------------------------
bool
K7Stage362M01::BpArriveCallBack( WK7BpInfo &info )
{
	switch( GetBpEventNo(info) )
	{
		case	K7EVENTNO(035119):
			if( K7SCR_GET_SCENARIO_FLAG(EV036201) == false )
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				FixCam( CAM362M01POOL_INIT );
				WK7CAM->StartLinearInterpolateOnLinearPath( K7Stage362M01_Camera[CAM362M01POOL].pos, K7Stage362M01_Camera[CAM362M01POOL].tgt, WK7_TICK_TO_FRAME(STG362M01_CAM_TICK)*2 );
				K7SCR_TIMEWAIT( STG362M01_CAM_TICK );
				K7SCR_STGC_MESSAGE_B( MES362M01_NEEDLIGHT );
				K7SCR_SET_SCENARIO_FLAG( EV036201 );
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
			}
			break;
		default:
			break;
	}
	
	return( true );
}
