////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage364M00 J[eBX̉Ɓ@nʘH
//
// K7Stage364M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 01/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE364M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage364M00.h"
#include "..\..\Yam\YK7EffectEyeScan.h"
#include "..\..\..\Wat\WK7Item.h"




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage364M00::K7Stage364M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage364M00_Camera );
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage364M00::~K7Stage364M00()
{
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage364M00::CreateCallBack( void )
{
	//ԖF؏
	LoadEyeScanTex();
	
	return( true );
}

//------------------------------------------------------------------------------
//Iȉj
//------------------------------------------------------------------------------
bool
K7Stage364M00::TerminateCallBack( void )
{
	//ԖF؏I
	ReleaseEyeScanTex();
	
	return( true );
}
	
//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool
K7Stage364M00::DoorEventCallBack( WK7DoorEventInfo &info )
{
	u32 pcID;
	EFFECT*	eyeScan = NULL;
	
	switch( info.mEventNo )
	{
		//ԖF
		case	K7EVENTDOOR( 035104 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			pcID = WK7PLAYERCONTROL->GetMainID();
			//ʒuݒ
			SetCurrentPath(	GetPathNurbsAll("curve5"),
							1.000f,
							0,									//0:forward 1:back
							WK7PATHINFO_INITDIR_TGTDIR );		// wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
			//AChO[VɂȂ܂ő҂
			if( WK7PLAYERCONTROL->GetPcState() != PC_STATE_WAIT )
			{
				K7SCR_RETSYS();
			}
			K7SCR_TIMEWAIT( 800 );
			//LbgłȂ΃[V|[Y
			if( pcID != K7CAT )WK7PLAYERCONTROL->SetPause();
			K7SCR_TIMEWAIT( 400 );
			//ԖFؑuJݒ
			gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );
			FixCam( CAM364M00EYETELLER );
			K7SCR_TIMEWAIT( 7200 );
			//PC̖ڂւ̃J
			FixCam( CAM364M00EYE_DAN + pcID );
			while( CheckEyeScanTex() != true )
			{
				K7SCR_RETSYS();
			}
			eyeScan = CreateEyeScanEffect();
			while( GetEyeScanEndState(eyeScan) == false )
			{
				K7SCR_RETSYS();
			}
			if( pcID == K7DAN )
			{
				//_ꍇ͒ʉ
				K7SCR_SET_SCENARIO_FLAG( EV0364DAN_EYESCAN );
				gpSound->mPlaySE( SFX_SCE3_CUR_RETINACHECK_OK );
				//inGameĊJ
				if( pcID != K7CAT )WK7PLAYERCONTROL->ResetPause();
				//LĐ
				if( WK7Play::HasPlayed(K7EVENTPLAY(03050107)) == false )
				{
					K7SCR_NOISE_REQUEST();
					gpSound->mStopStream();
					if( eyeScan != NULL )
					{
						DeleteEffect( eyeScan );
						eyeScan = NULL;
					}
					K7SCR_CHARAGEKI_PREPARE( K7EVENTPLAY(03050107) );
					K7SCR_NOISE_RELEASE();
					K7SCR_CHARAGEKI_END_WAIT( K7EVENTPLAY(03050107) );
					K7SCR_NOISE_REQUEST();
					K7SCR_CHARAGEKI_TERM( K7EVENTPLAY(03050107) );
				}
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				return( true );
			}else
			{
				//_ȊO͒ʂȂ
				gpSound->mPlaySE( SFX_SCE3_CUR_RETINACHECK_FAILURE );
				//inGameĊJ
				if( pcID != K7CAT )WK7PLAYERCONTROL->ResetPause();
				//JPCtH[ɖ߂
				WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
				if( eyeScan != NULL )
				{
					K7SCR_RETSYS();
					DeleteEffect( eyeScan );
					eyeScan = NULL;
				}
				K7SCR_RETSYS();
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				return( false );
			}
	    	break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

