////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage445M00 yh~jJzg@[@̉L
//
// K7Stage445M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE445M00_CPP__

#include "..\..\..\Scn\K7Scn04.h"
#include ".\K7Stage445M00.h"
#include "..\Yam\YK7MapSelect.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Kaw\KK7Effect.h"
#include "..\..\..\Yam\YK7EffectScreen.h"

//f
#define	MDL445M00_HS_NEST	"event_040414"	//HS̑ɂȂ肩̂
#define	MDL445M00_DOOR		"ani_door"		//g@[@̃hA
//[V
#define	MOT445M00_DOOR_OPEN	(0)				//g@[@̃hAJ

#define	STG445M00_INTO_DOOR_FRAME	(60.0f)	//̒֓̂ɂ鎞




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage445M00::K7Stage445M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage445M00_Camera );
	mpEffectLensFlare = NULL;
//	mScnEnd.LoadData();
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage445M00::~K7Stage445M00()
{
	ReleaseEffectLensFlare();
//	mScnEnd.Release();
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage445M00::CreateCallBack( void )
{
	//[Vt@C
	CreateOwnStageMotion( MOT445M00_DOOR_OPEN );
	
	// YtA
	SetupEffectLensFlare();
	
	return( true );
}

bool
K7Stage445M00::InitializeCallBack( void )
{
	while( CheckSetupEffectLensFlare()==false ){
		K7SCR_RETSYS() ;
	}
	mpEffectLensFlare = CreateEffectLensFlare("sun_alpha");
	
	//IԂɂ
	SetSelectObjFlag( K7STGID(444,0), "door_040403", 1, true );
	SetPassPathFlag ( K7STGID(444,0), "door_040403", 1, true );
	
	return true;
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage445M00::CondChangeCallBack( void )
{
	//g@[@̔
	if( GameInfo.GetScenarioFlow() == K7SCNF_DM1 )
	{
		SimpleSetStartMotion( MDL445M00_DOOR, MOT445M00_DOOR_OPEN );
	}else
	{
		SimpleSetLastMotion( MDL445M00_DOOR, MOT445M00_DOOR_OPEN );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool
K7Stage445M00::DoorEventCallBack( WK7DoorEventInfo &info )
{
	switch( info.mEventNo )
	{
		//Lo
		case	K7EVENTDOOR( 040402 ):
			FixCamWithRiddle( CAM445M00_HS_NEST );
			return( false );
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//qbgIuWF
//------------------------------------------------------------------------------
bool
K7Stage445M00::HitObjCallBack( WK7HitObjInfo &info )
{
	EFFECT* pEffect;
	
	switch( info.mEventNo )
	{
		//HS̑ɂȂ肩̕
		case	K7EVENTNO( 040414 ):
			if( info.mTypeID == WK7HITOBJINFO_TYPE_DANCHARGE )
			{
				GameInfo.InitOptionWindow();
				gpSound->mFadeVolumeStream( 0, 100 );
				K7SCR_SET_SCENARIO_FLAG( EV445BREAK_HS_NEST );
				//IuWF
				info.mpJObj->Hide( false, true );
				BrokenObj( MDL445M00_HS_NEST );
				//
				KK7DoorSmokeEffect( (Vec){-0.090f, 73.823f, -0.576f} );
				//ogIB
				KK7BattleMainTask::BattleMainTaskExit( 2 );
				while( GameInfo.SetMode(WK7GameInfo::PLAY) == false )
				{
					K7SCR_RETSYS();
				}
				//inGame~
				K7SCR_PC_SETVISIBLE( false );
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				//JĒɓ
				FixCam( CAM445M00_DOOR_START );
				K7SCR_TIMEWAIT( 3600 );
				k7app.FadeStart(0x00,0);
				k7app.SetFadeColor(0xffffffff);
				if( ( pEffect = CreateScreenEffect() ) != NULL )
				{
					SetScreenEffectAddFlag( pEffect, FALSE ) ;
					SetScreenEffectDrawFlag( pEffect, TRUE ) ;
					SetScreenEffectExRate( pEffect, 1.05F ) ;		// g嗦ύX
					SetScreenEffectAlpha( pEffect, 0.90F ) ;		// `掞̃At@lZbg
				}
				gpSound->mPlaySE( SFX_SCE4_TREVOR_HSDOOR );
				SimplePlayMotion( MDL445M00_DOOR, MOT445M00_DOOR_OPEN );
				k7app.FadeStart(0xff,WK7_FRAME_TO_TICK((u32)STG445M00_INTO_DOOR_FRAME));
				WK7CAM->StartLinearInterpolateOnLinearPath( mpOneShotCamera[CAM445M00_DOOR_TERM].pos,
															mpOneShotCamera[CAM445M00_DOOR_TERM].tgt,
															STG445M00_INTO_DOOR_FRAME );
				K7SCR_TIMEWAIT( WK7_FRAME_TO_TICK((u32)STG445M00_INTO_DOOR_FRAME) );
				k7app.FadeStart(0x00,0);
				//[r[Đ
				K7SCR_NOISE_REQUEST();
				DeleteEffect( pEffect );
				K7SCR_STG_VISIBLE( mID, false );
				K7SCR_STAGE_RELEASE();
				
				K7SCR_NOISE_RELEASE();
				//[r[ĐEg@[
				K7SCR_MOVIE_PLAY_NO_NOISE( K7MOV_04050301 );
				
				K7SCR_STAGE_RESTORE();
				
				gpSound->mStopStream();
				//ViII
//				mScnEnd.LoadData();
//				mScnEnd.FrameProcess();
//				mScnEnd.Release();
				k7app.FadeStart( 0, 1 );
				K7SCR_RETSYS();
				//ViIֈڍs
				GameInfo.SetScenarioFlow( K7SCNF_DM2 );
				K7SCR_CHANGE_SCENARIO_DATA();
				
				WK7PLAYERCONTROL->ReleaseArchive();
				while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
					K7SCR_RETSYS();
				}
				K7SCR_RETSYS();
				WK7Stage::DeleteStage(this);
				
				// LN^X^[gn_Zbg
				WK7PLAYERCONTROL->ChangeStartChkPoint();
				//}bvړ
				GameInfo.MapSelectInit( MAP_CORRIDOR, MAP_GAL_HOME );
				while( GameInfo.CheckMapSelectEnd() == false )
				{
					K7SCR_RETSYS();
				}
				GameInfo.MapSelectEnd();
				
//				K7SCR_MOON_START2();
//				K7SCR_MOON_WAIT();
				
				//KVẢƂ
				u32	stgid = K7STGID( 120, 0 );
				K7SCR_NOISE_REQUEST();
				//Xe[Wǂݍ
				K7SCR_STG_CREATE_B( stgid );
				WK7PLAYERCONTROL->RestoreArchive();
				while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::LOADED ){
					K7SCR_RETSYS();
				}
				K7SCR_NOISE_REQUEST_WAIT();
				K7SCR_STG_VISIBLE( stgid, true );
				K7SCR_STG_SET_CURRENT( stgid );
				WK7Stage::SetCameraStartPosition( stgid );
				
				return false;
			}else
			{
				info.SetHitObjEnable(true);
				return( false );
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}
