////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage430M00 yj[[Nzu[hEFC
//
// K7Stage430M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE430M00_CPP__

#include "..\..\..\Scn\K7Scn04.h"
#include ".\K7Stage430M00.h"
#include "..\..\..\Enm\EnmBoss.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Kaw\KK7BattleCtrl.h"
#include "..\..\..\Wat\WK7Item.h"
#include "..\..\..\Wat\WK7GameInfo.h"
#include "..\..\..\Sato\SK7SpOption.h"
#include "..\..\..\Yam\YK7EffectMuzzle.h"
#include "..\..\..\Yam\YK7EffectHSDead.h"
#include "..\..\..\Matsu\MK7Movie.h"
#include "..\..\..\Fujita\C_Font.h"
#include "..\..\..\Yam\YK7EffectFlashBom.h"

/*

	PnTbh n[}Rs[
	QnTu[ _Rs[
	RnTuE Rs[
	SnTfbh PBRs[
	TnTp[v }XNRs[
	UnTzCg LbgRs[
	WnTsN KVARs[
	XnTS[h R[eRs[

*/
//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage430M00::K7Stage430M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage430M00_Camera);
	state.Init( PROLOGUE );
	mBackupBloodGauge = 0;
	GameInfo.SetSpecialEnable(false);
	GameInfo.SetMenuMapEnable(false);
	GameInfo.SetBossFlag     (true );
	mEnemyGunDataID[0] = 
	mEnemyGunDataID[1] = -1;
	mStageInit = false;
	mFrameCountTrigger = false;
	mFrameCount = 0;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage430M00::~K7Stage430M00()
{
	int		i;
	for(i=0 ; i<2 ; i++){
		if( mEnemyGunDataID[i] >= 0 ){
			DetachGunModel2   (mEnemyGunDataID[i]);
			ReleaseGunArchive2(mEnemyGunDataID[i]);
		}
		mEnemyGunDataID[i] = -1;
	}
	WK7Npc::ReleaseAll();
	WK7PLAYERCONTROL->SetManualVitalDisp(false);
	WK7PLAYERCONTROL->SetPathEnable(true);
	WK7PLAYERCONTROL->BattlePadRegulationClear();
	gpSound->mReleaseSsm( "seBossHsm.ssm" );
	GameInfo.SetSpecialEnable(true);
	GameInfo.SetMenuMapEnable(true);
	GameInfo.SetBossFlag     (false);
	WK7PLAYERCONTROL->SetTurnAble        (true );
	WK7PLAYERCONTROL->SetCamRevDisable   (false);
	WK7PLAYERCONTROL->SetSpAbilityDisable(false);
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
//bool
//K7Stage430M00::EventCallBack( WK7EventInfo &info )
//{
//	switch( info.mEventNo )
//	{
//		//
//		case	K7EVENTNO( 043000 ):
//			//inGame~
//			K7SCR_ENTER_PLAYMODE_B();
//			K7SCR_ENTER_DEMOPAUSE();
//			K7SCR_NOISE_REQUEST();
//			K7SCR_STG_VISIBLE( K7STGID(430,0), false );
//			K7SCR_PC_VISIBLE( false );
//			K7SCR_STAGE_RELEASE();
//			K7SCR_NOISE_RELEASE();
//			//[r[ĐEnTsN班
//			K7SCR_MOVIE_PLAY_NO_NOISE( K7MOV_GURAD );
//			//[r[ĐENQ[
//			K7SCR_MOVIE_PLAY_NO_NOISE( K7MOV_GURAD );
//			K7SCR_STAGE_RESTORE();
//			//ViII
//			mScnEnd.FrameProcess();
//			k7app.FadeStart( 0, 1 );
//			K7SCR_RETSYS();
//			//Q[I
//			GameInfo.SetMode     (WK7GameInfo::TERM           );
//			GameInfo.SetTermState(WK7GameInfo::TERMSTATE_CLEAR);
//			break;
//		
//		//ftHg
//		default:
//			break;
//	}
//	
//	return( true );
//}


bool
K7Stage430M00::InitializeCallBack( void )
{
	SetManualBranch(true);
	//  OSReport( "%0x\n", WK7Npc::Create(ENENO_HM1) );
	return true;
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage430M00::CreateCallBack( void )
{
	WK7PLAYERCONTROL->SetManualVitalDisp(true);
	WK7PLAYERCONTROL->SetManualVital(1.0f);
	
	WK7RenderObj::CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_CHR,K7MOTID(K7HN3, 600));
	WK7RenderObj::CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_CHR,K7MOTID(K7HN4, 600));
	
	K7EnmBoss::SetCommonState( 0 );
	
	gpSound->mReadSsm( "seBossHsm.ssm", eBankBoss );
	
	return( true );
}

bool K7Stage430M00::LoadAfterInit3(void)
{
	mPanel.Load();
	return WK7Stage::LoadAfterInit3();
}

bool K7Stage430M00::IsLoadingAfterInit3(void)
{
	if( mPanel.IsLoading()==true ){
		return true;
	}
	return WK7Stage::IsLoadingAfterInit3();
}

bool K7Stage430M00::FrameProcess(void)
{
	mPanel.FrameProcess();
	return WK7Stage::FrameProcess();
}

struct K7Stage430M00_MatchInfo{
	u32			mEnemyNo;
	int			mMatchID;
	int			mIntroSE;
	Vec			mPlayerPos;
	f32			mPlayerRotY;
	Vec			mEnemyPos;
	f32			mEnemyRotY;
};

#define	PLROT		(-2.390f)
#define	PLPOS		{56.887f, 1.0f, 507.477f}
#define	ENEROT		(0.751f)
#define	ENEPOS		{12.688f, 1.0f, 459.887f}
static K7Stage430M00_MatchInfo	matchInfo[] = {
	{ ENENO_HN2,5,SFX_BOSS_HSM_6TH_VS,PLPOS,PLROT,ENEPOS,ENEROT,},		//dan
	{ ENENO_HN8,7,SFX_BOSS_HSM_8TH_VS,PLPOS,PLROT,ENEPOS,ENEROT,},		//gal
	{ ENENO_HN6,1,SFX_BOSS_HSM_2ND_VS,PLPOS,PLROT,ENEPOS,ENEROT,},		//cat
	{ ENENO_HM1,0,SFX_BOSS_HSM_1ST_VS,PLPOS,PLROT,ENEPOS,ENEROT,},		//hac		
	{ ENENO_HM1,0,SFX_BOSS_HSM_1ST_VS,PLPOS,PLROT,ENEPOS,ENEROT,},		//has
	{ ENENO_HM1,0,SFX_BOSS_HSM_1ST_VS,PLPOS,PLROT,ENEPOS,ENEROT,},		//hay
	{ ENENO_HN9,2,SFX_BOSS_HSM_3RD_VS,PLPOS,PLROT,ENEPOS,ENEROT,},		//cyo
	{ ENENO_HN3,3,SFX_BOSS_HSM_4TH_VS,PLPOS,PLROT,ENEPOS,ENEROT,},		//ked
	{ ENENO_HN4,4,SFX_BOSS_HSM_5TH_VS,PLPOS,PLROT,ENEPOS,ENEROT,},		//kvn
	{ ENENO_HN5,6,SFX_BOSS_HSM_7TH_VS,PLPOS,PLROT,ENEPOS,ENEROT,},		//msk
};

void K7Stage430M00::ReleaseHandsomeMan(void)
{
	int		i;
	
	for(i=0 ; i<2 ; i++){
		if( mEnemyGunDataID[i] >= 0 ){
			DetachGunModel2   (mEnemyGunDataID[i]);
			ReleaseGunArchive2(mEnemyGunDataID[i]);
		}
		mEnemyGunDataID[i] = -1;
	}
	WK7Npc::ReleaseAll();
}

void K7Stage430M00::CreateHandsomeMan(u32 charaid)
{
	K7Stage430M00_MatchInfo	*pMatchInfo = matchInfo + charaid;
	PCDATA					pcData;
	WK7Npc					*pNpc;
	
	WK7PlayerControl::InitDataSet(charaid,pcData);
	
	if( (pNpc = WK7Npc::Find(pMatchInfo->mEnemyNo))==NULL ){
		
		while( (pNpc = WK7Npc::Create(pMatchInfo->mEnemyNo))==NULL ){
			K7SCR_RETSYS();
		}
		while( pNpc->GetReleaseState()!=WK7Npc::LOADED ){
			K7SCR_RETSYS();
		}
		
		if( 0 <= pcData.mGunTypeR ){
			while( (mEnemyGunDataID[0]=LoadGunArchive2((s8)pcData.mGunTypeR)) < 0 ){
				K7SCR_RETSYS();
			}
		}
		if( 0 <= pcData.mGunTypeL ){
			while( (mEnemyGunDataID[1]=LoadGunArchive2((s8)pcData.mGunTypeL)) < 0 ){
				K7SCR_RETSYS();
			}
		}
	}
	while( pNpc->GetReleaseState()!=WK7Npc::LOADED ){
		K7SCR_RETSYS();
	}
	if( pNpc!=NULL ){
		pNpc->SetPosition(pMatchInfo->mEnemyPos );
		pNpc->SetRotY    (pMatchInfo->mEnemyRotY);
	}
	
	WK7Chara	*pChara;
	
	if( pNpc!=NULL && (pChara=pNpc->pCurrentChara())!=NULL ){
		if( mEnemyGunDataID[0] >= 0 ){
			while( CheckGunArchiveLoad(mEnemyGunDataID[0])==TRUE ){
				K7SCR_RETSYS();
			}
			AttachGunModel2(mEnemyGunDataID[0],
			                NULL,
			                pChara->GetModel(),
			                GUN_HAND_R
			);
		}
		if( mEnemyGunDataID[1] >= 0 ){
			while( CheckGunArchiveLoad(mEnemyGunDataID[1])==TRUE ){
				K7SCR_RETSYS();
			}
			AttachGunModel2(mEnemyGunDataID[1],
			                NULL,
			                pChara->GetModel(),
			                GUN_HAND_L
			);
		}
	}
	
}

void K7Stage430M00::ChangeChr(u32 charaid)
{
	if( charaid >= K7PCMAX ){
		return;
	}
	
	K7EnmBoss::SetCommonState( 0 );
	
	u32				id_ = K7CHRID(charaid,0);
	bool			playerRelease = false;
	PCDATA			pcData;
	
	WK7PlayerControl::InitDataSet(charaid,pcData);
	
	K7Stage430M00_MatchInfo	*pMatchInfo = matchInfo + charaid;
	
	K7SCR_ENTER_PLAYMODE_B();
	
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_NO_WAIT);
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7PLAYERCONTROL->SetEnableOnly(true);
	
	WK7Npc	*pNpc,*pNext;
	int		i;
	
	for(i=0 ; i<2 ; i++){
		if( mEnemyGunDataID[i] >= 0 ){
			DetachGunModel2   (mEnemyGunDataID[i]);
			ReleaseGunArchive2(mEnemyGunDataID[i]);
		}
		mEnemyGunDataID[i] = -1;
	}
	
	for(pNpc=WK7Npc::GetTop() ; pNpc!=NULL ; pNpc=pNext){
		pNext = pNpc->GetNext();
		if( pNpc->GetEneNo()==pMatchInfo->mEnemyNo ){
			continue;
		}
		delete pNpc;
	}
//	WK7Npc::ReleaseAll();
	
	if( WK7PLAYERCONTROL->GetMainID() != charaid ){
		
		gpNoise->mSandRequest(eSandLongNoise);
		
		WK7PLAYERCONTROL->SetDataHp(WK7PLAYERCONTROL->GetMainID(), WK7PLAYERCONTROL->GetHp());
		WK7PLAYERCONTROL->Reset();
		WK7PLAYERCONTROL->ReleaseAll();
		
		playerRelease = true;
	}
	
	if( (pNpc = WK7Npc::Find(pMatchInfo->mEnemyNo))==NULL ){
		
		while( (pNpc = WK7Npc::Create(pMatchInfo->mEnemyNo))==NULL ){
			K7SCR_RETSYS();
		}
		while( pNpc->GetReleaseState()!=WK7Npc::LOADED ){
			K7SCR_RETSYS();
		}
		
		if( 0 <= pcData.mGunTypeR ){
			while( (mEnemyGunDataID[0]=LoadGunArchive2((s8)pcData.mGunTypeR)) < 0 ){
				K7SCR_RETSYS();
			}
		}
		if( 0 <= pcData.mGunTypeL ){
			while( (mEnemyGunDataID[1]=LoadGunArchive2((s8)pcData.mGunTypeL)) < 0 ){
				K7SCR_RETSYS();
			}
		}
	}
	while( pNpc->GetReleaseState()!=WK7Npc::LOADED ){
		K7SCR_RETSYS();
	}
	if( pNpc!=NULL ){
		pNpc->SetPosition(pMatchInfo->mEnemyPos );
		pNpc->SetRotY    (pMatchInfo->mEnemyRotY);
	}
	
	if( playerRelease==true ){
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			K7SCR_RETSYS();
		}
		
		K7SCR_RETSYS();
		WK7PLAYERCONTROL->CreateModel(id_);
		WK7PLAYERCONTROL->CreatePackMotion(id_);
		K7SCR_RETSYS();
		while( true == WK7PLAYERCONTROL->IsLoading() ){
			K7SCR_RETSYS();
		}
		
		WK7PLAYERCONTROL->SetOperateEnable(false);
		
		WK7PLAYERCONTROL->SetVisible(true);
		WK7PLAYERPATHCONTROL->CameraRenew();
		WK7PLAYERCONTROL->ChangeCallback();
	//	WK7PLAYERCONTROL->SetPosition(&pMatchInfo->mPlayerPos );
	//	WK7PLAYERCONTROL->SetRotY    ( pMatchInfo->mPlayerRotY);
		
		SetCurrentPath(	GetPathNurbsAll("curve2"),
						0.121f,
						0,									// 0:forward 1:back
						WK7PATHINFO_INITDIR_TGTDIR_REV );
		
		gpNoise->mSandRelease();
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}
	}
	
	WK7Chara	*pChara;
	
	if( pNpc!=NULL && (pChara=pNpc->pCurrentChara())!=NULL ){
		if( mEnemyGunDataID[0] >= 0 ){
			while( CheckGunArchiveLoad(mEnemyGunDataID[0])==TRUE ){
				K7SCR_RETSYS();
			}
			AttachGunModel2(mEnemyGunDataID[0],
			                NULL,
			                pChara->GetModel(),
			                GUN_HAND_R
			);
		}
		if( mEnemyGunDataID[1] >= 0 ){
			while( CheckGunArchiveLoad(mEnemyGunDataID[1])==TRUE ){
				K7SCR_RETSYS();
			}
			AttachGunModel2(mEnemyGunDataID[1],
			                NULL,
			                pChara->GetModel(),
			                GUN_HAND_L
			);
		}
	}
	
	gpSound->mPlaySE(pMatchInfo->mIntroSE);
	mPanel.OpeningStart(pMatchInfo->mMatchID);
	
	WK7JObj		*pJObj;
	Vec			campos,camtgt,camdir;
	f32			roty;
	
static	f32		dist = 10.0f;
static	f32		pl_intro_sec = 1.5f;
static	f32		np_intro_sec = 1.5f;
	
	// v[[LЉ
	if( (pChara=WK7PLAYERCONTROL->GetCharaPtr())!=NULL && (pJObj=pChara->GetJObj(K7CHRBONE_NECK))!=NULL ){
		
		pJObj->GetWorldPosition(camtgt);
		WK7PLAYERCONTROL->GetRotY(&roty);
		camdir.x = dist * sinf(roty);
		camdir.y = 0.0f;
		camdir.z = dist * cosf(roty);
		VECAdd(&camdir,&camtgt,&campos);
		
		roty     =  camdir.x;
		camdir.x =  camdir.z;
		camdir.z = -roty;
		
		VECAdd(&camdir,&campos,&campos);
		VECAdd(&camdir,&camtgt,&camtgt);
		
		WK7CAM->SetMode          (WK7Cam::WK7CAM_FREE_TARGET);
		WK7CAM->SetPosition      (campos);
		WK7CAM->SetTargetPosition(camtgt);
		
		VECScale(&camdir,&camdir,-2.0f);
		VECAdd(&camdir,&campos,&campos);
		VECAdd(&camdir,&camtgt,&camtgt);
		
		WK7CAM->StartLinearInterpolateOnLinearPath(campos,
		                                           camtgt,
		                                           pl_intro_sec * 60.0f);
		
		K7SCR_TIMEWAIT((int)WK7_SEC_TO_TICK(pl_intro_sec));
		
	}
	
	// nT}Љ
	if( (pChara=pNpc->pCurrentChara())!=NULL && (pJObj=pChara->GetJObj(K7CHRBONE_NECK))!=NULL ){
		
		pJObj->GetWorldPosition(camtgt);
		roty = pNpc ->GetRotY();
		camdir.x = dist * sinf(roty);
		camdir.y = 0.0f;
		camdir.z = dist * cosf(roty);
		VECAdd(&camdir,&camtgt,&campos);
		
		roty     =  camdir.x;
		camdir.x = -camdir.z;
		camdir.z =  roty;
		
		VECAdd(&camdir,&campos,&campos);
		VECAdd(&camdir,&camtgt,&camtgt);
		
		WK7CAM->SetMode          (WK7Cam::WK7CAM_FREE_TARGET);
		WK7CAM->SetPosition      (campos);
		WK7CAM->SetTargetPosition(camtgt);
		
		VECScale(&camdir,&camdir,-2.0f);
		VECAdd(&camdir,&campos,&campos);
		VECAdd(&camdir,&camtgt,&camtgt);
		
		WK7CAM->StartLinearInterpolateOnLinearPath(campos,
		                                           camtgt,
		                                           np_intro_sec * 60.0f);
		
		K7SCR_TIMEWAIT((int)WK7_SEC_TO_TICK(np_intro_sec));
	}
	
	FixCam(OPENING_CAM);
	
	while( mPanel.WaitingOpening()==false ){
		K7SCR_RETSYS();
	}
	
	while( gpSound->mCheckSE(pMatchInfo->mIntroSE)==true ){
		K7SCR_RETSYS();
	}
	
static	f32		restartwait = 0.25f;
	K7SCR_TIMEWAIT((int)WK7_SEC_TO_TICK(restartwait));
	
	mPanel.OpeningRestart();
	
	while( mPanel.IsOver()==false ){
		K7SCR_RETSYS();
	}
	
	WK7PLAYERCONTROL->SetManualVitalDisp(true);
	WK7PLAYERCONTROL->SetManualVital(1.0f);
	
	//Jn`B
	K7EnmBoss::SetCommonState( 1 );
	K7SCR_EXIT_DEMOPAUSE();
	K7SCR_EXIT_PLAYMODE();
	
	WK7PLAYERCONTROL->SetTurnAble        (false);
	WK7PLAYERCONTROL->SetCamRevDisable   (true);
	WK7PLAYERCONTROL->SetSpAbilityDisable(true);
	
	WK7PLAYERCONTROL->SetOperateEnable(true);
	WK7PLAYERCONTROL->BattlePadRegulationReSet(BPADREG_NO_WAIT);
	WK7PLAYERCONTROL->BattlePadRegulationReSet(BPADREG_KAMAE_NO);
}
void K7Stage430M00::EndMatch(u32 charaid)
{
	if( charaid >= K7PCMAX ){
		return;
	}
	K7Stage430M00_MatchInfo	*pMatchInfo = matchInfo + charaid;
	KK7BattleMainTask::BattleMainTaskExit(1);
	K7SCR_ENTER_PLAYMODE_B();
//	K7SCR_ENTER_DEMOPAUSE();
	WK7PLAYERCONTROL->SetOperateEnable(false);
	FixCam(OPENING_CAM);
	mPanel.EndingStart(pMatchInfo->mMatchID);
	gpSound->mPlaySE(SFX_BOSS_HSM_BATTLE_END);
}
bool K7Stage430M00::RenderProcess(void)
{
	C_Paper		paper(32,32);
	
	if( mFrameCountTrigger==true ){
		mFrameCount++;
	}
	
#ifndef	K7APP_MASTER
	PRINTF("Count = %d\n",mFrameCount);
#endif
	
	return WK7Stage::RenderProcess();
}
void K7Stage430M00::ChangeMskToFinal(void)
{
	EFFECT			*pPcBombEfc = NULL;
	int				tick;
	bool			zupdate;
	bool			render;
	Vec				pos;
	f32				roty;
	s8				gunDataID[2] = { -1,-1 };
	WK7Chara		*pTmpChara = NULL;
	WK7Chara		*pChara = WK7PLAYERCONTROL->GetCharaPtr();
	WK7JObj			*pJObj  = NULL;
	WK7ModelMotion	*pModelMotion = WK7PLAYERCONTROL->GetCmnModelMotion((int)WK7PLAYERCONTROL->GetMotID());
	int				i;
	WK7StageMotion	*pStageMotion =  CreateOwnStageMotion(0);
	WK7CameraMotion	*pCameraMotion = NULL;
	PCDATA			pcData;
	
	WK7PLAYERCONTROL->InitDataSet(WK7PLAYERCONTROL->GetMainID(),pcData);
	
	if( pStageMotion!=NULL ){
		while( pStageMotion->GetState() != WK7MotionObj::LOADED ){
			K7SCR_RETSYS();
		}
		pCameraMotion = pStageMotion->GetCameraMotion();
	}
	
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_NO_WAIT);
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7PLAYERCONTROL->GetPosition(&pos);
	WK7PLAYERCONTROL->GetRotY(&roty);
	
	if( pChara!=NULL ){
		if( 0 <= pcData.mGunTypeR ){
			while( (gunDataID[0]=LoadGunArchive2((s8)pcData.mGunTypeR)) < 0 ){
				K7SCR_RETSYS();
			}
		}
		if( 0 <= pcData.mGunTypeL ){
			while( (gunDataID[1]=LoadGunArchive2((s8)pcData.mGunTypeL)) < 0 ){
				K7SCR_RETSYS();
			}
		}
		if( (pTmpChara = WK7RenderObj::CreateChara(pChara->GetID()))!=NULL ){
			while( pTmpChara->GetState()!=WK7RenderObj::LOADED ){
				K7SCR_RETSYS();
			}
			pTmpChara->CreatePrivateLight();
			pTmpChara->SetStageLight(false);
//			pTmpChara->SetRenderFlag(true);
			pTmpChara->SetPosition(pos);
			pTmpChara->SetRotY(roty);
			pTmpChara->SetClothEnable(false);
			WK7Model	*pModel;
			if( (pModel = pTmpChara->GetModel())!=NULL ){
				pModel->AttachMotion(pModelMotion);
				pModel->PlayMotion  (-1.0f);
				pModel->SetMotionLoop(false);
				pJObj = pModel->GetObj(K7CHRBONE_WAIST);
				pJObj->CopyUserDefinedMatrix(WK7PLAYERCONTROL->GetWaistObjPtr());
//				pJObj->CopyTRS(WK7PLAYERCONTROL->GetWaistObjPtr());
			}
			if( gunDataID[0] >= 0 ){
				while( CheckGunArchiveLoad(gunDataID[0])==TRUE ){
					K7SCR_RETSYS();
				}
				AttachGunModel2(gunDataID[0],
				                NULL,
				                pTmpChara->GetModel(),
				                GUN_HAND_R
				);
			}
			if( gunDataID[1] >= 0 ){
				while( CheckGunArchiveLoad(gunDataID[1])==TRUE ){
					K7SCR_RETSYS();
				}
				AttachGunModel2(gunDataID[1],
				                NULL,
				                pTmpChara->GetModel(),
				                GUN_HAND_L
				);
			}
		}
	}
	
	K7SCR_RETSYS();
	pTmpChara->SetRenderFlag(true);
	
	WK7PLAYERCONTROL->SetEnableOnly(true );
	WK7PLAYERCONTROL->SetVisible(false);
	WK7PLAYERCONTROL->ReleaseArchive();
	while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
		K7SCR_RETSYS();
	}
	// t@Ci
	BattleCtrl.MskPowerUp(KK7BATTLECTRL_MSKLV_FINAL);
	WK7PLAYERCONTROL->RestoreArchive();
	while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::LOADED ){
		K7SCR_RETSYS();
	}
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_NO_WAIT);
	WK7PLAYERCONTROL->SetVisible(false);
	WK7PLAYERCONTROL->RestorePathPosition();
	WK7PLAYERCONTROL->_MotSet_Wait(false);
	WK7PLAYERCONTROL->SetPosition(&pos);
	WK7PLAYERPATHCONTROL->CameraRenew();
	WK7PLAYERCONTROL->ChangeCallback();
	
	if( pCameraMotion != NULL ){
		
		WK7CAM->SetMode      (WK7Cam::WK7CAM_FREE_TARGET);
		WK7CAM->AttachMotion (pCameraMotion);
		WK7CAM->PlayMotion   ();
		WK7CAM->SetMotionLoop(false);
		WK7CAM->FrameProcess ();
		
		WK7CAM->SetRelativePosition(pos);
		WK7CAM->SetRelativeRotX(0.0f);
		WK7CAM->SetRelativeRotY(roty);
		WK7CAM->SetRelativeRotZ(0.0f);
		
		K7SCR_TIMEWAIT(146 * 160);
		
	}
	
	render  = screenImageMonoColor.GetRender ();
	zupdate = screenImageMonoColor.GetZUpdate();
	screenImageMonoColor.SetRender (true );
	screenImageMonoColor.SetZUpdate(false);
	
	mFrameCountTrigger = true;
	
	screenImageMonoColor.SetA(0x00);
	screenImageMonoColor.SetA(0xff,WK7_SEC_TO_TICK(0.5f));
	while( screenImageMonoColor.IsAnimatingA()==true ){
		K7SCR_RETSYS();
	}
	
	while( (pPcBombEfc = GameInfo.PcBomb(pJObj,pos,roty,0,1))==NULL ){
		K7SCR_RETSYS();
	}
	
//	K7SCR_TIMEWAIT(100);
	
	while( false==GetHSDeadConveState(pPcBombEfc) ){
		GHMGCTASK_RETSYS();
	}
	
	pTmpChara->SetRenderFlag(false);
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	for(i=0 ; i<2 ; i++){
		if( gunDataID[i] >= 0 ){
			DetachGunModel2   (gunDataID[i]);
			ReleaseGunArchive2(gunDataID[i]);
		}
		gunDataID[i] = -1;
	}
	GHM_SAFE_DELETE(pTmpChara);
	
	for(tick=WK7_SEC_TO_TICK(2) ; tick > 0 ; tick -= WK7_TICK_PER_FRAME){
		K7SCR_RETSYS();
	}
//	if( true==GetEffectValidState(pPcBombEfc) ){
//		DeleteEffect(pPcBombEfc);
//	}
	
	while( (pPcBombEfc = GameInfo.PcBomb(1,1))==NULL ){
		K7SCR_RETSYS();
	}
	
	if( (pChara=WK7PLAYERCONTROL->GetCharaPtr())!=NULL ){
		pChara->StopMotion();
	}
	while( false==GetHSDeadConveState(pPcBombEfc) ){
		K7SCR_RETSYS();
	}
	WK7PLAYERCONTROL->SetVisible(true);							// \
	if( pChara!=NULL ){
		pChara->ReplayMotion();
	}
	while( true == GetEffectValidState(pPcBombEfc) ){			// obj߂̃GtFNgI҂
		K7SCR_RETSYS();
	}
	
	screenImageMonoColor.SetA(0x00,WK7_SEC_TO_TICK(1.0f));
	while( screenImageMonoColor.IsAnimatingA()==true ){
		GHMGCTASK_RETSYS();
	}
	
	mFrameCountTrigger = false;
	
	screenImageMonoColor.SetRender (render );
	screenImageMonoColor.SetZUpdate(zupdate);
	screenImageMonoColor.SetA(0xff,0);
	
	// \͍\`I
	
	WK7PLAYERCONTROL->SetEnableOnly(false);
	WK7PLAYERCONTROL->PlayMotion(WK7MOTION_PCCMN_SPATK2,false,true,0.0f);
	
//	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(284.0f / 60.0f));
	gpSound->mPlaySE(SFX_SCE4_MSK_LVUPVOICE_FINAL);
	
	while( WK7PLAYERCONTROL->PcGetMotionState()!=WK7MODEL_NOANIM ){
		K7SCR_RETSYS();
	}
	
	while( WK7CAM->GetMotionState()!=WK7MODEL_NOANIM ){
		K7SCR_RETSYS();
	}
	
	gpSound->mPlaySE(SFX_SCE4_MSK_FINALLEVELUP);
	K7SCR_RETSYS();
	while( gpSound->mCheckSE(SFX_SCE4_MSK_FINALLEVELUP)==true ){
		K7SCR_RETSYS();
	}
	
	WK7CAM->StopMotion();
	WK7CAM->DetachMotion();
	
	mBackupBloodGauge = WK7PLAYERCONTROL->GetBloodGauge(BP_THIN);
	WK7PLAYERCONTROL->SetBloodGauge(BP_THIN,BLOOD_SPABILITY * 5);
	WK7PLAYERCONTROL->SetBloodUseDisable(true);
	WK7PLAYERCONTROL->SetManualVitalDisp(true);
	WK7PLAYERCONTROL->SetManualVital(1.0f);
	K7EnmBoss::SetCommonState( 16 );
	K7SCR_RETSYS();
//	while( WK7PLAYERCONTROL->PcGetMotionState()!=WK7MODEL_NOANIM ){
//		K7SCR_RETSYS();
//	}
	
	WK7PLAYERCONTROL->SetEnableOnly(true);
//	FixCam(OPENING_CAM);
	K7SCR_PC_VISIBLE( true );
//	K7SCR_NOISE_RELEASE();
//	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(3));
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
	
//	K7SCR_EXIT_DEMOPAUSE();
	K7SCR_EXIT_PLAYMODE();
	WK7PLAYERCONTROL->BattlePadRegulationReSet(BPADREG_NO_WAIT);
	WK7PLAYERCONTROL->SetOperateEnable(true);
	WK7CAM->ClearRelativePosition();
	WK7CAM->ClearRelativeRotation();
	WK7CAM->FrameProcess();
}
//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool K7Stage430M00::SetCurrentCallBack( void )
{
	if( mStageInit==true ){
		return true;
	}
	
	mStageInit = true;
	
//	C_Vec		ppos_,encount_pos_(45.0f, 0.f, 1753.f);
	Vec			ppos_,encount_pos_ = PLPOS;
//	WK7Play		*pPlay;
//	u32			playno;
	
	gpSound->mSetDspRateAll(0);
	gpSound->mStopStream();
//	SetCurrentCallBackDefaultProc();
	
	while( WK7Stage::IsChanging()==true ){
		K7SCR_RETSYS();
	}
	
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7PLAYERCONTROL->SetDataHp(WK7PLAYERCONTROL->GetMainID(), WK7PLAYERCONTROL->GetHp());
	WK7PLAYERCONTROL->Reset();
	WK7PLAYERCONTROL->ReleaseAll();
	
	u32		chrid = K7CHRID(K7HAC,0);
	K7SCR_RETSYS();
	WK7PLAYERCONTROL->CreateModel(chrid);
	WK7PLAYERCONTROL->CreatePackMotion(chrid);
	K7SCR_RETSYS();
	while( true == WK7PLAYERCONTROL->IsLoading() ){
		K7SCR_RETSYS();
	}
	
	WK7PLAYERCONTROL->SetTurnAble        (false);
	WK7PLAYERCONTROL->SetCamRevDisable   (true);
	WK7PLAYERCONTROL->SetSpAbilityDisable(true);
	WK7PLAYERCONTROL->SetOperateEnable   (false);
	WK7PLAYERCONTROL->SetVisible(true);
	WK7PLAYERPATHCONTROL->CameraRenew();
	WK7PLAYERCONTROL->ChangeCallback();
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_KAMAE_NO);
	
//	mPanel.Load();
	K7EnmBoss::SetCommonState( 0 );
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	
	WK7Npc					*pNpc;
	K7Stage430M00_MatchInfo	*pMatchInfo = matchInfo + K7HAC;
	while( (pNpc = WK7Npc::Find(pMatchInfo->mEnemyNo))==NULL ){
		K7SCR_RETSYS();
	}
	while( pNpc->GetReleaseState()!=WK7Npc::LOADED ){
		K7SCR_RETSYS();
	}
	if( pNpc!=NULL ){
		pNpc->SetPosition(pMatchInfo->mEnemyPos );
		pNpc->SetRotY    (pMatchInfo->mEnemyRotY);
	}
	
	WK7StagePlaceInfo		*pPlaceInfo;
	pPlaceInfo = GetPlaceInfo(mID,"branchA");
	SetCameraStartPosition(pPlaceInfo);
	SandRelease(pPlaceInfo);
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	WK7PLAYERCONTROL->SetOperateEnable(true);
	SetManualBranch(false);
	
	while( 1 ){
		
		if( WK7RenderObj::IsValid(this)==false && GetState()!=LOADED ){
			return false;
		}
		
		//vC[̈ʒuB
		if ( NULL != WK7PLAYERCONTROL->GetWaistObjPtr() ) {
			WK7PLAYERCONTROL->GetWaistObjPtr()->GetWorldPosition(ppos_);
		}
		
		if( (s32)state > PROLOGUE ){
			WK7PLAYERCONTROL->SetTurnAble( false );
			WK7PLAYERCONTROL->SetWalkAble( false );
			WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_HANSAM);
		}
		
		do{
			switch( (s32)state ){
			case PROLOGUE:
				//vC[Ɏʒu܂ŕĂ炤B
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					break;
				case PHASE_PROC:
					ppos_.y = encount_pos_.y;
					if( GHM_VEC_DIST(&ppos_,&encount_pos_) < 1.0f ){
//					ppos_.y = encount_pos_.y = 0.f;
//					if( ppos_.Dist( encount_pos_ ) < 5.f ){
						WK7PLAYERCONTROL->SetPathEnable(false);
						gpSound->mSetDspRateAll(0);
						gpSound->mPlayStreamEx (HPS_BOSS_HSM,VOLUME_MUSIC,false);
						state = ENCOUNTER_HAY2RED;
#ifndef	K7APP_MASTER
//						state = ENCOUNTER_DAN2BLUE;
//						state = ENCOUNTER_KVN2DEAD;
//						state = ENCOUNTER_KED2BROWN;
//						state = ENCOUNTER_MSK2PURPLE;
//						state = ENCOUNTER_GAL2PINK;
#endif
					}
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			//n[}ƐԁB--------------------------- vs 1
			case ENCOUNTER_HAY2RED:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					ChangeChr(K7HAC);
					break;
				case PHASE_PROC:
					state = FIGHTING_HAY2RED;
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			case FIGHTING_HAY2RED:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					break;
				case PHASE_PROC:
					//B
					if( K7EnmBoss::GetCommonState() == 2 ){
						gpSound->mPlaySE(SFX_PC_HAC_1GEKI);				// 1ŎEꍇ̐
						EndMatch(K7HAC);
						state = ENDING_HAY2RED;
					}
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			case ENDING_HAY2RED:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					break;
				case PHASE_PROC:
					//ʔ\ĎցB
					if( mPanel.IsOver()==true ){
						state = ENCOUNTER_CAT2WHITE;
					}
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			//RƔB--------------------------------- vs 6
			case ENCOUNTER_CAT2WHITE:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					ChangeChr(K7CAT);
					break;
				case PHASE_PROC:
					state = FIGHTING_CAT2WHITE;
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			case FIGHTING_CAT2WHITE:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					break;
				case PHASE_PROC:
					if( K7EnmBoss::GetCommonState() == 2 ){
						// Lbĝ
						gpSound->mPlaySE(SFX_PC_CAT_DEAD);				// LbgS
//						gpSound->mPlaySE(SFX_BOSS_HSM_WHTPEARL_KIME);	//  white
						WK7PLAYERCONTROL->SetEnable(false);
						WK7PLAYERCONTROL->PlayMotion(WK7MOTION_PCCMN_DIE_F,false,true,0.0f);
						EndMatch(K7CAT);
						state = ENDING_CAT2WHITE;
					}
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			case ENDING_CAT2WHITE:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					break;
				case PHASE_PROC:
					if( mPanel.IsOver()==true ){
						state = ENCOUNTER_COY2GOLD;
					}
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			//R[eƋB--------------------------------- vs 9
			case ENCOUNTER_COY2GOLD:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					ChangeChr(K7CYO);
					break;
				case PHASE_PROC:
					state = FIGHTING_COY2GOLD;
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			case FIGHTING_COY2GOLD:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					break;
				case PHASE_PROC:
					if( K7EnmBoss::GetCommonState() == 2 ){
						gpSound->mPlaySE(SFX_PC_CYO_1GEKI);				// 1ŎEꍇ̐
						EndMatch(K7CYO);
						state = ENDING_COY2GOLD;
					}
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			case ENDING_COY2GOLD:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					break;
				case PHASE_PROC:
					if( mPanel.IsOver()==true ){
						state = ENCOUNTER_KED2BROWN;
					}
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			//JGfƒB--------------------------------- vs 3
			case ENCOUNTER_KED2BROWN:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					ChangeChr(K7KED);
					break;
				case PHASE_PROC:
					state = FIGHTING_KED2BROWN;
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			case FIGHTING_KED2BROWN:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					break;
				case PHASE_PROC:
					switch( K7EnmBoss::GetCommonState() ){
					case	3:
						KK7BattleMainTask::BattleMainTaskExit(2);
						WK7CAM->StopMotion();
						WK7CAM->DetachMotion();
						SetDefaultCameraDesc( true );
						FixCam(OPENING_CAM);
						WK7PLAYERCONTROL->SetOperateEnable(false);
						K7SCR_ENTER_PLAYMODE_B();
						K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(0.125f));
						K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(0.125f));
						WK7PLAYERCONTROL->SetEnable       (false);
						WK7PLAYERCONTROL->PlayMotion      (WK7MOTION_PCCMN_DIE_F,false,true,96.0f);
						// JGf̂
						gpSound->mPlaySE(SFX_PC_KED_DEAD);
						while( WK7PLAYERCONTROL->PcGetMotionState()!=WK7MODEL_NOANIM ){
							K7SCR_RETSYS();
						}
						EndMatch(K7KED);
						state = ENDING_KED2BROWN;
						break;
					}
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			case ENDING_KED2BROWN:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					break;
				case PHASE_PROC:
					if( mPanel.IsOver()==true ){
						state = ENCOUNTER_KVN2DEAD;
					}
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			//PBƃfbhB--------------------------------- vs 4
			case ENCOUNTER_KVN2DEAD:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					ChangeChr(K7KVN);
					break;
				case PHASE_PROC:
					state = FIGHTING_KVN2DEAD;
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			case FIGHTING_KVN2DEAD:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					break;
				case PHASE_PROC:
					if( K7EnmBoss::GetCommonState()==3 ){
						KK7BattleMainTask::BattleMainTaskExit(1);
						WK7PLAYERCONTROL->SetOperateEnable(false);
						K7SCR_ENTER_PLAYMODE_B();
						FixCam(OPENING_CAM);
						K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(0.125f));
						WK7PLAYERCONTROL->SetEnable       (false);
						WK7PLAYERCONTROL->PlayMotion      (WK7MOTION_PCCMN_DIE_F,false,true,0.0f);

						// PB̂
//						gpSound->mPlaySE(SFX_PC_KVN_DEAD);		// ׂȂ̂łȂ
						while( WK7PLAYERCONTROL->PcGetMotionState()!=WK7MODEL_NOANIM ){
							K7SCR_RETSYS();
						}
						EndMatch(K7KVN);
						state = ENDING_KVN2DEAD;
					}
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			case ENDING_KVN2DEAD:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					break;
				case PHASE_PROC:
					if( mPanel.IsOver()==true ){
						state = ENCOUNTER_DAN2BLUE;
					}
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			//_ƐB--------------------------------- vs 2
			case ENCOUNTER_DAN2BLUE:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					ChangeChr(K7DAN);
					break;
				case PHASE_PROC:
					state = FIGHTING_DAN2BLUE;
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			case FIGHTING_DAN2BLUE:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					break;
				case PHASE_PROC:
					if( K7EnmBoss::GetCommonState() == 2 ){
						gpSound->mPlaySE(SFX_PC_DAN_1GEKI);				// 1ŎEꍇ̐
						EndMatch(K7DAN);
						state = ENDING_DAN2BLUE;
					}
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			case ENDING_DAN2BLUE:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					break;
				case PHASE_PROC:
					if( mPanel.IsOver()==true ){
						state = ENCOUNTER_MSK2PURPLE;
					}
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			//}XNƎB--------------------------------- vs 5
			case ENCOUNTER_MSK2PURPLE:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					ChangeChr(K7MSK);
					break;
				case PHASE_PROC:
					state = FIGHTING_MSK2PURPLE;
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			case FIGHTING_MSK2PURPLE:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					break;
				case PHASE_PROC:
					if( K7EnmBoss::GetCommonState() == 2 ){
						KK7BattleMainTask::BattleMainTaskExit(1);
						WK7PLAYERCONTROL->SetOperateEnable(false);
						K7SCR_ENTER_PLAYMODE_B();
						FixCam(OPENING_CAM);
						K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(0.125f));
						WK7PLAYERCONTROL->SetEnable(false);
						WK7PLAYERCONTROL->PlayMotion(WK7MOTION_PCCMN_DIE_F,false,true,96.0f);
						// }XN̂
						gpSound->mPlaySE(SFX_PC_MSK_DEAD);
//						gpSound->mPlaySE(SFX_BOSS_HSM_PURPLE_KIME);			//  purple
						while( WK7PLAYERCONTROL->PcGetMotionState()!=WK7MODEL_NOANIM ){
							K7SCR_RETSYS();
						}
						gpSound->mFadeVolumeStream( 0, 100 );
						while( gpSound->mGetVolumeStream() > 0 ){
							K7SCR_RETSYS();
						}
						gpSound->mStopStream();
						ChangeMskToFinal();
						gpSound->mPlayStreamEx (HPS_BOSS_HSM,VOLUME_MUSIC,false);
						state = FIGHTING_FINALMSK2PURPLE;
					}
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			case FIGHTING_FINALMSK2PURPLE:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					break;
				case PHASE_PROC:
					if( K7EnmBoss::GetCommonState() == 17 ){
						if ( PC_STATE_WAIT == WK7PLAYERCONTROL->GetState() ){
							EndMatch(K7MSK);
							state = ENDING_MSK2PURPLE;
							WK7PLAYERCONTROL->SetBloodUseDisable(false);
							WK7PLAYERCONTROL->SetBloodGauge(BP_THIN,mBackupBloodGauge);
						}
					}
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			case ENDING_MSK2PURPLE:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					break;
				case PHASE_PROC:
					if( mPanel.IsOver()==true ){
						state = ENCOUNTER_GAL2PINK;
					}
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			//KVAƃsNB--------------------------------- vs 8
			case ENCOUNTER_GAL2PINK:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					ChangeChr(K7GAL);
					K7SCR_ENTER_PLAYMODE_B();
//					K7SCR_ENTER_DEMOPAUSE();
					WK7PLAYERCONTROL->SetOperateEnable(false);
					WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_NO_WAIT);
					break;
				case PHASE_PROC:
					state = FIGHTING_GAL2PINK;
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			case FIGHTING_GAL2PINK:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					break;
				case PHASE_PROC:
					if( state.GetPhaseCounter() < 30 ){
						break;
					}
					
					K7SCR_ENTER_PLAYMODE_B();
					
					EFFECT	*pEffect;
					Vec		pos = ENEPOS;
					pos.y += 10.0f;
					
					k7app.SetFadeColor(0xffffffff);
					k7app.FadeStart(0xff,WK7_SEC_TO_TICK(2));
					if( (pEffect = CreateFlashBomEffect(pos))!=NULL ){
						K7SCR_TIMEWAIT(WK7_FRAME_TO_TICK(2 * WK7_FRAME_RATE));
					}
					
//					K7SCR_NOISE_REQUEST();
					
					gpSound->mFadeVolumeStream( 0, 100 );
					
//					mPanel.Release();
//					ReleaseHandsomeMan();
					
					K7SCR_PC_VISIBLE( false );
					WK7Chara::SetRenderChara(false);
					WK7Stage::SetRenderStage(false);
					WK7Item::SetRenderItem  (false);
					
					K7SCR_RETSYS();
					K7SCR_RETSYS();
					
					WK7PLAYERCONTROL->SetOperateEnable(false);
					WK7PLAYERCONTROL->Reset();
					WK7PLAYERCONTROL->ReleaseAll();
					WK7Stage::DeleteStage(this);
					
//					K7SCR_STAGE_RELEASE();
					
//					K7SCR_NOISE_RELEASE();
					
					while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
						K7SCR_RETSYS();
					}
					while( WK7EVENTCONTROLLER->ReleaseTempData()==false ){
						K7SCR_RETSYS();
					}
					while( WK7EVENTCONTROLLER->IsReleasedData()==false ){
						K7SCR_RETSYS();
					}
					while( gpMovie->mGetStatus()!=eMvProcStandby ){
						K7SCR_RETSYS();
					}
					
					//[r[ĐEnTsN班
					PlayMovie3(K7MOV_04060902);
					
					//[r[ĐENQ[
					PlayMovie3(K7MOV_04070101);
					
//					K7SCR_NOISE_REQUEST();
					
					while( WK7EVENTCONTROLLER->IsReleasedData()==false ){
						K7SCR_RETSYS();
					}
					while( WK7EVENTCONTROLLER->LoadData()==false ){
						K7SCR_RETSYS();
					}
					while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
						K7SCR_RETSYS();
					}
					
//					K7SCR_STAGE_RESTORE();
//					CreateHandsomeMan(K7GAL);
//					{
//						WK7Npc	*pNpc;
//						if( (pNpc = WK7Npc::Find(ENENO_HN8))!=NULL ){
//							pNpc->SetForcedVisible(FALSE);
//						}
//					}
					
					WK7Chara::SetRenderChara(true );
					WK7Stage::SetRenderStage(true );
					WK7Item::SetRenderItem  (true );
					
//					FixCam(OPENING_CAM);
//					K7SCR_PC_VISIBLE( true );
//					K7SCR_NOISE_RELEASE();
//					EndMatch(K7GAL);
//					state = ENDING_GAL2PINK;
					goto scn_end;
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			case ENDING_GAL2PINK:
				switch( state.GetPhase() ){
				case PHASE_CTOR:
					break;
				case PHASE_PROC:
					if( mPanel.IsOver()==true ){
						goto scn_end;
					}
					break;
				case PHASE_DTOR:
					break;
				}
				break;
			}
			
		}while( !state.Proc() );
		
		K7SCR_RETSYS();
	}
scn_end:
	
	gpSound->mFadeVolumeStream(0,200);
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1.0f));
	
	SK7ScenarioEnd		scnEnd;
	scnEnd.LoadData();
	scnEnd.FrameProcess();
	scnEnd.Release();
	
	GameInfo.SetMode     (WK7GameInfo::TERM           );
	GameInfo.SetTermState(WK7GameInfo::TERMSTATE_CLEAR);
	return false;
}


K7Stage430M00_PanelTile::K7Stage430M00_PanelTile()
{
	Init();
}

K7Stage430M00_PanelTile::~K7Stage430M00_PanelTile()
{
	Release();
}

bool K7Stage430M00_PanelTile::Init(void)
{
	mTexNum   = 0;
	mTexID    = 0;
	mProc     = 0;
	mInitWait = 0;
	mpTex     = NULL;
	return true;
}

bool K7Stage430M00_PanelTile::Release(void)
{
	GHM_SAFE_DELETE_ARRAY(mpTex);
	Init();
	return true;
}

bool K7Stage430M00_PanelTile::SetTexture(void **ppTex)
{
	mTexNum = 0;
	GHM_SAFE_DELETE_ARRAY(mpTex);
	if( ppTex==NULL ){
		return true;
	}
	for( ; ppTex[mTexNum]!=NULL ; mTexNum++){}
	if( mTexNum <= 0 ){
		return true;
	}
	ghmGcMemSetAllocName("430PTex");
	if( (mpTex=new stTexture[mTexNum])==NULL ){
		return false;
	}
	int		i;
	for(i=0 ; i<mTexNum ; i++){
		mpTex[i].tex = (GhmGcTexHeader *)ppTex[i];
		mK7InitTexture(&mpTex[i]);
	}
	mSprite.mRelateTex(mpTex);
	mSprite.mSetWH ((short)mpTex[0].tex->mWidth,(short)mpTex[0].tex->mHeight);
	mSprite.mSetUV0(0,0);
	if( mTexID >= mTexNum ){
		mTexID  = 0;
	}
	return true;
}

short K7Stage430M00_PanelTile::GetW(void)
{
	return mSprite.mGetW();
}

bool K7Stage430M00_PanelTile::SetTexture(void *pTex)
{
	void	*ptex[2];
	ptex[0] = pTex;
	ptex[1] = NULL;
	return SetTexture(ptex);
}

bool K7Stage430M00_PanelTile::SetTexture(int index,void *pTex)
{
	if( index < 0 || index >= mTexNum || mpTex==NULL ){
		return false;
	}
	mpTex[index].tex = (GhmGcTexHeader *)pTex;
	mK7InitTexture(&mpTex[index]);
	return true;
}

bool K7Stage430M00_PanelTile::SetXY(s16 x,s16 y)
{
	mSprite.mSetXY0(x,y);
	return true;
}

bool K7Stage430M00_PanelTile::SetRGBA(u32 rgb0,u32 rgb1)
{
	mSprite.mSetRGBA0(rgb0);
	mSprite.mSetRGBA1(rgb0);
	mSprite.mSetRGBA2(rgb1);
	mSprite.mSetRGBA3(rgb1);
	return true;
}

bool K7Stage430M00_PanelTile::GetRGBA(u32 *rgb0,u32 *rgb1)
{
	if( rgb0!=NULL ){
		*rgb0 = mSprite.mGetRGBA0();
	}
	if( rgb1!=NULL ){
		*rgb1 = mSprite.mGetRGBA2();
	}
	return true;
}

u32 K7Stage430M00_PanelTile::GetA(void)
{
	return mSprite.mGetA();
}

bool K7Stage430M00_PanelTile::SetFade(u8 a,s32 tick)
{
	mSprite.mSetFade(a,tick);
	return true;
}

bool K7Stage430M00_PanelTile::SetDispFlag(bool flag)
{
	mSprite.mSetDispFlag(flag);
	return true;
}

bool K7Stage430M00_PanelTile::SetAddMode(bool flag)
{
	if( flag==true ){
		mSprite.mSetSpriteAddAlphaPrim();
	}else{
		mSprite.mSetSpritePrim();
	}
	return true;
}

bool K7Stage430M00_PanelTile::SetScale(enScaleDir dir,f32 scale,s32 tick)
{
	mSprite.mSetScale(dir,scale,tick);
	return true;
}

bool K7Stage430M00_PanelTile::StartAnim(void)
{
	mProc = 1;
	return true;
}

bool K7Stage430M00_PanelTile::StopAnim(void)
{
	mProc = 0;
	return true;
}

bool K7Stage430M00_PanelTile::SetInitWait(int wait)
{
	mInitWait = wait;
	return true;
}

bool K7Stage430M00_PanelTile::FrameProcess(void)
{
	if( mpTex==NULL ){ 
		return true;
	}
	if( mInitWait > 0 ){
		mInitWait--;
		return true;
	}
	if( mProc ){
		mTexID++;
		if( mTexID >= mTexNum ){
			mTexID  = 0;
		}
		mSprite.mRelateTex(mpTex + mTexID);
	}
	return true;
}

K7Stage430M00_PanelTileGrad::K7Stage430M00_PanelTileGrad()
{
	Init();
}

K7Stage430M00_PanelTileGrad::~K7Stage430M00_PanelTileGrad()
{
	Release();
}

bool K7Stage430M00_PanelTileGrad::Init(void)
{
	mTileGrad.Init();
	mTileEdge.Init();
	mTileEdge.SetRGBA(0x000000ff,0x000000ff);
	return true;
}

bool K7Stage430M00_PanelTileGrad::Release(void)
{
	mTileGrad.Release();
	mTileEdge.Release();
	Init();
	return true;
}

bool K7Stage430M00_PanelTileGrad::SetTexture(void *pTex0,void *pTex1)
{
	mTileGrad.SetTexture(pTex0);
	mTileEdge.SetTexture(pTex1);
	return true;
}

bool K7Stage430M00_PanelTileGrad::SetXY(s16 x,s16 y)
{
	mTileGrad.SetXY(x,y);
	mTileEdge.SetXY(x,y);
	return true;
}

bool K7Stage430M00_PanelTileGrad::SetRGBA(u32 rgb0,u32 rgb1)
{
	mTileGrad.SetRGBA(rgb0,rgb1);
	return true;
}

bool K7Stage430M00_PanelTileGrad::GetRGBA(u32 *rgb0,u32 *rgb1)
{
	mTileGrad.GetRGBA(rgb0,rgb1);
	return true;
}

u32 K7Stage430M00_PanelTileGrad::GetA(void)
{
	return mTileGrad.GetA();
}

bool K7Stage430M00_PanelTileGrad::SetFade(u8 a,s32 tick)
{
	mTileGrad.SetFade(a,tick);
	mTileEdge.SetFade(a,tick);
	return true;
}

bool K7Stage430M00_PanelTileGrad::SetDispFlag(bool flag)
{
	mTileGrad.SetDispFlag(flag);
	mTileEdge.SetDispFlag(flag);
	return true;
}

bool K7Stage430M00_PanelTileGrad::SetAddMode(bool flag)
{
	mTileGrad.SetAddMode(flag);
	mTileEdge.SetAddMode(flag);
	return true;
}

bool K7Stage430M00_PanelTileGrad::SetScale(enScaleDir dir,f32 scale,s32 tick)
{
	mTileGrad.SetScale(dir,scale,tick);
	mTileEdge.SetScale(dir,scale,tick);
	return true;
}

bool K7Stage430M00_PanelTileGrad::FrameProcess(void)
{
	mTileGrad.FrameProcess();
	mTileEdge.FrameProcess();
	return true;
}

K7Stage430M00_PanelFont::K7Stage430M00_PanelFont()
{
	Init();
}

K7Stage430M00_PanelFont::~K7Stage430M00_PanelFont()
{
	Release();
}

bool K7Stage430M00_PanelFont::Init(void)
{
	mTex.tex    = NULL;
	mpSprite    = NULL;
	mSpriteNum  = 0;
	mpSentence  = NULL;
	mpFontParam = NULL;
	return true;
}

bool K7Stage430M00_PanelFont::Release(void)
{
	SetSentence(NULL,NULL);
	Init();
	return true;
}

bool K7Stage430M00_PanelFont::SetSentence(stJimaku *pSentence,stFontParam *pFontParam)
{
	GHM_SAFE_DELETE_ARRAY(mpSprite);
	if( pSentence==NULL || pFontParam==NULL ){
		return true;
	}
	int		i,j;
	s16		x;
	for(i=0,mSpriteNum=0 ; i<JIMAKU_CHAR_MAX ; i++,mSpriteNum++){
		if( pSentence->chardat[i]==(s16)JIMAKU_NO_FONT ){
			break;
		}
		if( pSentence->chardat[i]==(s16)JIMAKU_SPACE_Z ){
			mSpriteNum--;
		}
	}
	if( mSpriteNum <= 0 ){
		return true;
	}
	ghmGcMemSetAllocName("430Sprt");
	if( (mpSprite=new mK7Sprite[mSpriteNum])==NULL ){
		mSpriteNum = 0;
		return false;
	}
	mpSentence  = pSentence;
	mpFontParam = pFontParam;
	RelateTex();
	x = 0;
	for(i=0,j=0 ; i<mSpriteNum ; i++,j++){
		if( pSentence->chardat[j]==(s16)JIMAKU_SPACE_Z ){
			i--;
			x += 16;
			continue;
		}
		pFontParam = mpFontParam + pSentence->chardat[j];
		mpSprite[i].mSetWH ((short)pFontParam->w,(short)pFontParam->h);
		mpSprite[i].mSetUV0((short)pFontParam->u,(short)pFontParam->v);
		mpSprite[i].mSetXY0(x,0);
		x += pFontParam->w;
	}
	return true;
}

bool K7Stage430M00_PanelFont::SetTexture(void *pTex)
{
	mTex.tex = (GhmGcTexHeader *)pTex;
	mK7InitTexture(&mTex);
	RelateTex();
	return true;
}

bool K7Stage430M00_PanelFont::RelateTex(void)
{
	if( mTex.tex==NULL || mSpriteNum<=0 || mpSprite==NULL ){
		return false;
	}
	int		i;
	for(i=0 ; i<mSpriteNum ; i++){
		mpSprite[i].mRelateTex(&mTex);
	}
	return true;
}

bool K7Stage430M00_PanelFont::SetXY(s16 x,s16 y)
{
	if( mSpriteNum<=0 || mpSprite==NULL ){
		return false;
	}
	int		i;
	f32		d = x - mpSprite[0].mGetX0();
	for(i=0 ; i<mSpriteNum ; i++){
		mpSprite[i].mSetXY0(mpSprite[i].mGetX0() + d,y);
	}
	return true;
}

bool K7Stage430M00_PanelFont::SetCXY(s16 cx,s16 y)
{
	if( mSpriteNum<=0 || mpSprite==NULL ){
		return false;
	}
	int		i;
	f32		cx0;
	cx0 = (mpSprite[mSpriteNum-1].mGetX0() + mpSprite[mSpriteNum-1].mGetW() - mpSprite[0].mGetX0()) * 0.5f + mpSprite[0].mGetX0();
	for(i=0 ; i<mSpriteNum ; i++){
		mpSprite[i].mSetXY0(cx + (mpSprite[i].mGetX0() - cx0),y);
	}
	return true;
}

f32 K7Stage430M00_PanelFont::GetX(void)
{
	if( mSpriteNum<=0 || mpSprite==NULL ){
		return -1;
	}
	return mpSprite[0].mGetX0();
}

f32 K7Stage430M00_PanelFont::GetY(void)
{
	if( mSpriteNum<=0 || mpSprite==NULL ){
		return -1;
	}
	return mpSprite[0].mGetY0();
}

u32 K7Stage430M00_PanelFont::GetW(void)
{
	if( mSpriteNum<=0 || mpSprite==NULL ){
		return 0;
	}
	return (u32)(mpSprite[mSpriteNum-1].mGetX0() + mpSprite[mSpriteNum-1].mGetW() - mpSprite[0].mGetX0());
}

u32 K7Stage430M00_PanelFont::GetH(void)
{
	if( mSpriteNum<=0 || mpSprite==NULL ){
		return 0;
	}
	int		i;
	u32		h = 0;
	for(i=0 ; i<mSpriteNum ; i++){
		if( h < mpSprite[i].mGetH() ){
			h = mpSprite[i].mGetH();
		}
	}
	return h;
}

bool K7Stage430M00_PanelFont::SetRGBA(u32 rgb0,u32 rgb1)
{
	int		i;
	for(i=0 ; i<mSpriteNum ; i++){
		mpSprite[i].mSetRGBA0(rgb0);
		mpSprite[i].mSetRGBA1(rgb0);
		mpSprite[i].mSetRGBA2(rgb1);
		mpSprite[i].mSetRGBA3(rgb1);
	}
	return true;
}

bool K7Stage430M00_PanelFont::GetRGBA(u32 *rgb0,u32 *rgb1)
{
	if( mSpriteNum<=0 || mpSprite==NULL ){
		return false;
	}
	if( rgb0!=NULL ){
		*rgb0 = mpSprite[0].mGetRGBA0();
	}
	if( rgb1!=NULL ){
		*rgb1 = mpSprite[0].mGetRGBA2();
	}
	return true;
}

bool K7Stage430M00_PanelFont::SetFade(u8 a,s32 tick)
{
	int		i;
	for(i=0 ; i<mSpriteNum ; i++){
		mpSprite[i].mSetFade(a,tick);
	}
	return true;
}

bool K7Stage430M00_PanelFont::SetDispFlag(bool flag)
{
	int		i;
	for(i=0 ; i<mSpriteNum ; i++){
		mpSprite[i].mSetDispFlag(flag);
	}
	return true;
}

bool K7Stage430M00_PanelFont::SetAddMode(bool flag)
{
	int		i;
	if( flag==true ){
		for(i=0 ; i<mSpriteNum ; i++){
			mpSprite[i].mSetSpriteAddAlphaPrim();
		}
	}else{
		for(i=0 ; i<mSpriteNum ; i++){
			mpSprite[i].mSetSpritePrim();
		}
	}
	return true;
}

bool K7Stage430M00_PanelFont::SetScale(enScaleDir dir,f32 scale,s32 tick)
{
	if( mSpriteNum<=0 || mpSprite==NULL ){
		return false;
	}
	f32		cx;
	f32		w = GetW();
	int		i;
	cx = mpSprite[0].mGetX0() + w * 0.5f;
	for(i=0 ; i<mSpriteNum ; i++){
		mpSprite[i].mSetXY0 ((s16)((mpSprite[i].mGetX0() - cx) * scale + cx),
		                     (s16)  mpSprite[i].mGetY0());
		mpSprite[i].mSetScale(dir,scale,tick);
		if( tick==1 ){
			mpSprite[i].mScaleProc();
		}
	}
	return true;
}

bool K7Stage430M00_PanelFont::FrameProcess(void)
{
	return true;
}

K7Stage430M00_Panel::K7Stage430M00_Panel()
{
	Init();
}

K7Stage430M00_Panel::~K7Stage430M00_Panel()
{
	Release();
}

bool K7Stage430M00_Panel::Init(void)
{
	mWaitFlag           = 0;
	mMatchID            = 0;
	mpKiller7Name       = NULL;
	mKiller7NameNum     = 0;
	mpHandsomeManName   = NULL;
	mHandsomeManNameNum = 0;
	mpFontData          = NULL;
	mpFontParam         = NULL;
	mpFile              = NULL;
	mState              = IDLE;
	mProc               = -1;
	mMode               = -1;
	mpLoadData          = NULL;
	mpResource          = NULL;
	return true;
}

bool K7Stage430M00_Panel::Release(void)
{
	int		i;
	for(i=0 ; i<3 ; i++){
		mInadumaTile[i].Release();
	}
	mGameTile.Release();
	for(i=0 ; i<K7STAGE430M00_PANEL_STARTTILE_NUM ; i++){
		mStartTile[i].Release();
	}
	mVsTile         .Release();
	mWinTile        .Release();
	mLoseTile       .Release();
	mKiller7Tile    .Release();
	mHandsomeManTile.Release();
	for(i=0 ; i<mKiller7NameNum ; i++){
		mpKiller7Name[i].Release();
	}
	for(i=0 ; i<mHandsomeManNameNum ; i++){
		mpHandsomeManName[i].Release();
	}
	for(i=0 ; i<2 ; i++){
		mWinNum[i].Release();
		mWinStr[i].Release();
	}
	GHM_SAFE_DELETE      (mpFile);
	GHM_SAFE_DELETE_ARRAY(mpKiller7Name    );
	GHM_SAFE_DELETE_ARRAY(mpHandsomeManName);
	GHMGCMEM_SAFE_FREE   (mpLoadData       );
	Init();
	return true;
}

bool K7Stage430M00_Panel::Load(void)
{
	if( mState!=IDLE ){
		return false;
	}
	GHM_SAFE_DELETE(mpFile);
	ghmGcMemSetAllocName("430File");
	if( (mpFile=new ghmGcFile)==NULL ){
		return false;
	}
	if( mpFile->Open("/Wat/HandsomeMan.rsl")==false ){
		return false;
	}
	if( (mpLoadData = mpFile->Read())==NULL ){
		return false;
	}
	mState = LOADING;
	return true;
}

bool K7Stage430M00_Panel::IsLoading(void)
{
	if( mState==LOADING ){
		return true;
	}
	return false;
}

bool K7Stage430M00_Panel::SetMatchTexture(int match)
{
	ghmGcResGroup	*pGroup,*pSubGroup;
	if( mpResource==NULL ){
		return false;
	}
	if( (pGroup=mpResource->GetGroup(1))==NULL ){
		return false;
	}
	if( (pSubGroup = pGroup->GetGroup(match))==NULL ){
		return false;
	}
	mGameTile.SetTexture(pSubGroup->GetResource(0),pSubGroup->GetResource(1));
	return true;
}

bool K7Stage430M00_Panel::SetWinSentence(int side,int num)
{
	if( side < 0 || side > 1 ){
		return false;
	}
	if( num < 0 || num >= 10 ){
		return false;
	}
	u32	rgb0,rgb1;
	stOneSentence	*pOneSentence;
	pOneSentence = (stOneSentence *)((u32)mpFontData + mpFontData->offset    );
	mWinNum[side].GetRGBA(&rgb0,&rgb1);
	mWinNum[side].SetSentence(pOneSentence->jimaku + num,mpFontParam);
	mWinNum[side].SetRGBA( rgb0, rgb1);
	return true;
}

bool K7Stage430M00_Panel::SetOpeningDispName(int tick,bool disp)
{
	if( mMatchID < 0 || mMatchID > 7 ){
		return false;
	}
	int			i;
	u8			inita,fadea;
	for(i=0 ; i<mKiller7NameNum ; i++){
		mpKiller7Name[i].SetDispFlag(false);
	}
	for(i=0 ; i<mHandsomeManNameNum ; i++){
		mpHandsomeManName[i].SetDispFlag(false);
	}
	if( disp==true ){
		inita = 0x00;
		fadea = 0xff;
	}else{
		inita = 0xff;
		fadea = 0x00;
	}
static	s16	SIDE_MARGIN	 = (54);
	mpKiller7Name    [mMatchID + 1].SetDispFlag(true);
	mpKiller7Name    [mMatchID + 1].SetFade    (inita,0);
	mpKiller7Name    [mMatchID + 1].SetFade    (fadea,tick);
	mpKiller7Name    [mMatchID + 1].SetXY      (SIDE_MARGIN,229);
//	mpKiller7Name    [mMatchID + 1].SetXY      ( 74,229);
	K7Stage430M00_PanelFont		*pHandsomeManName;
	short						w;
	pHandsomeManName = mpHandsomeManName;
	w = (short)pHandsomeManName->GetW();
	pHandsomeManName->SetFade    (inita,0);
	pHandsomeManName->SetFade    (fadea,tick);
	pHandsomeManName->SetDispFlag(true);
	pHandsomeManName->SetXY      ((short)(WK7_SCREEN_WIDTH-SIDE_MARGIN-w),221);
//	pHandsomeManName->SetXY      (395,221);
	
	pHandsomeManName = mpHandsomeManName + (mMatchID + 1);
	w = (short)pHandsomeManName->GetW();
	pHandsomeManName->SetDispFlag(true);
	pHandsomeManName->SetFade    (inita,0);
	pHandsomeManName->SetFade    (fadea,tick);
	pHandsomeManName->SetXY      ((short)(WK7_SCREEN_WIDTH-SIDE_MARGIN-w),251);
//	pHandsomeManName->SetXY      (395,251);
	return true;
}

bool K7Stage430M00_Panel::SetEndDispName(void)
{
	int			i;
	for(i=0 ; i<mKiller7NameNum ; i++){
		mpKiller7Name[i].SetDispFlag(false);
	}
	for(i=0 ; i<mHandsomeManNameNum ; i++){
		mpHandsomeManName[i].SetDispFlag(false);
	}
	if( mMatchID < 0 || mMatchID > 7 ){
		return false;
	}
	K7Stage430M00_PanelFont		*pName;
//	if( Win()==true ){
		pName = mpKiller7Name     + (mMatchID + 1);
		pName->SetDispFlag(true);
		pName->SetFade    (0xff,0);
		pName->SetCXY     (320,87);
//	}else{
//		f32		w  = mpHandsomeManName->GetW();
//		f32		dw = 16.0f;
//		pName = mpHandsomeManName + (mMatchID + 1);
//		w += pName->GetW();
//		w += dw;
//		w *= 0.5f;
//		mpHandsomeManName->SetDispFlag(true);
//		mpHandsomeManName->SetFade    (0xff,0);
//		mpHandsomeManName->SetXY      ((s16)(320-w),87);
//		pName            ->SetDispFlag(true);
//		pName            ->SetFade    (0xff,0);
//		pName            ->SetXY      ((s16)(mpHandsomeManName->GetX() + mpHandsomeManName->GetW() + dw),
//		                               87);
//	}
	return true;
}

bool K7Stage430M00_Panel::Initialize(void)
{
	if( (mpResource = new(mpLoadData) ghmGcResLink)==NULL ){
		return false;
	}
	int				i;
	ghmGcResGroup	*pGroup;
	stOneSentence	*pOneSentence;
	void			*pFontTexture;
	// f[^
	if( (mpFontData = (stSentence *)mpResource->GetResource(0))==NULL ){
		return false;
	}
	mpFontParam  = (stFontParam   *)((u32)mpFontData + mpFontData->charOffset);
	pOneSentence = (stOneSentence *)((u32)mpFontData + mpFontData->offset    );
	pFontTexture = (void          *)((u32)mpFontData + mpFontData->texOffset );
	if( mpFontData->num >= 3 ){
		mWinNum[0].SetTexture (pFontTexture);
		mWinNum[1].SetTexture (pFontTexture);
		mWinStr[0].SetTexture (pFontTexture);
		mWinStr[1].SetTexture (pFontTexture);
		mWinNum[0].SetSentence(pOneSentence->jimaku + 0,mpFontParam);
		mWinNum[0].SetRGBA(0xf10000ff,0xf10000ff);
		mWinNum[1].SetSentence(pOneSentence->jimaku + 0,mpFontParam);
		mWinNum[1].SetRGBA(0x06b7e0ff,0x06b7e0ff);
		mWinStr[0].SetSentence(pOneSentence->jimaku + 10,mpFontParam);
		mWinStr[0].SetXY  (153,305);
		mWinStr[0].SetRGBA(0xe6e6e6ff,0xe6e6e6ff);
		mWinStr[1].SetSentence(pOneSentence->jimaku + 10,mpFontParam);
		mWinStr[1].SetXY  (463,305);
		mWinStr[1].SetRGBA(0xe6e6e6ff,0xe6e6e6ff);
		pOneSentence++;
		for(i=0 ; i<JIMAKU_LINE_MAX ; i++){
			if( pOneSentence->jimaku[i].chardat[0]==(s16)JIMAKU_NO_FONT ){
				mKiller7NameNum = i;
				break;
			}
		}
		if( mKiller7NameNum > 0 ){
			ghmGcMemSetAllocName("430PFnt");
			if( (mpKiller7Name=new K7Stage430M00_PanelFont[mKiller7NameNum])==NULL ){
				return false;
			}
			for(i=0 ; i<mKiller7NameNum ; i++){
				mpKiller7Name[i].SetTexture (pFontTexture);
				mpKiller7Name[i].SetSentence(pOneSentence->jimaku + i,mpFontParam);
			}
		}
		pOneSentence++;
		for(i=0 ; i<JIMAKU_LINE_MAX ; i++){
			if( pOneSentence->jimaku[i].chardat[0]==(s16)JIMAKU_NO_FONT ){
				mHandsomeManNameNum = i;
				break;
			}
		}
		if( mHandsomeManNameNum > 0 ){
			ghmGcMemSetAllocName("430PFnt");
			if( (mpHandsomeManName=new K7Stage430M00_PanelFont[mHandsomeManNameNum])==NULL ){
				return false;
			}
			for(i=0 ; i<mHandsomeManNameNum ; i++){
				mpHandsomeManName[i].SetTexture (pFontTexture);
				mpHandsomeManName[i].SetSentence(pOneSentence->jimaku + i,mpFontParam);
			}
			mpHandsomeManName[0].SetScale(eScaleWH,0.75f,1);
		}
	}
	// 
	SetMatchTexture(0);
	mGameTile.SetDispFlag(false);
	mGameTile.SetRGBA    (0xfa4646ff,0xd9009aff);
	mGameTile.SetXY      (116,72);
	// Killer7
	if( (pGroup=mpResource->GetGroup(2))!=NULL ){
		mKiller7Tile.SetTexture(pGroup->GetResource(0),pGroup->GetResource(1));
		mKiller7Tile.SetDispFlag(false);
		mKiller7Tile.SetRGBA    (0xf10000ff,0xf10000ff);
		mKiller7Tile.SetXY      ( 63,259);
	}
	// nT}
	if( (pGroup=mpResource->GetGroup(3))!=NULL ){
		mHandsomeManTile.SetTexture(pGroup->GetResource(0),pGroup->GetResource(1));
		mHandsomeManTile.SetDispFlag(false);
		mHandsomeManTile.SetRGBA    (0x06b7e0ff,0x06b7e0ff);
		mHandsomeManTile.SetXY      (395,251);
	}
	// Win
	if( (pGroup=mpResource->GetGroup(4))!=NULL ){
		mWinTile.SetTexture(pGroup->GetResource(0),pGroup->GetResource(1));
		mWinTile.SetDispFlag(false);
		mWinTile.SetRGBA    (0xffffffff,0x906a00ff);
		mWinTile.SetXY      (208,118);
	}
	// Lose
	if( (pGroup=mpResource->GetGroup(5))!=NULL ){
		mLoseTile.SetTexture(pGroup->GetResource(0),pGroup->GetResource(1));
		mLoseTile.SetDispFlag(false);
		mLoseTile.SetRGBA    (0xffffffff,0x535353ff);
		mLoseTile.SetXY      (219,118);
	}
	// Vs
	if( (pGroup=mpResource->GetGroup(6))!=NULL ){
		mVsTile.SetTexture(pGroup->GetResource(0),pGroup->GetResource(1));
		mVsTile.SetDispFlag(false);
		mVsTile.SetRGBA    (0xf10074ff,0x02add8ff);
		mVsTile.SetXY      (224,169);
	}
	// nW
	if( (pGroup=mpResource->GetGroup(7))!=NULL ){
		for(i=0 ; i<K7STAGE430M00_PANEL_STARTTILE_NUM ; i++){
			mStartTile[i].SetTexture(pGroup->GetResource(0),pGroup->GetResource(1));
			mStartTile[i].SetDispFlag(false);
			mStartTile[i].SetRGBA    (0xffffffff,0x535353ff);
			mStartTile[i].SetXY      (152,182);
		}
		for(i=1 ; i<K7STAGE430M00_PANEL_STARTTILE_NUM ; i++){
			mStartTile[i].SetFade(38,0);
			mStartTile[i].SetAddMode (true);
		}
	}
	// ȃAj
	if( (pGroup=mpResource->GetGroup(8))!=NULL ){
		void	*pTex[11];
		for(i=0 ; i<10 ; i++){
			pTex[i] = pGroup->GetResource(i);
		}
		pTex[i] = NULL;
		for(i=0 ; i<3 ; i++){
			mInadumaTile[i].SetTexture(pTex);
			mInadumaTile[i].SetDispFlag(false);
			mInadumaTile[i].SetRGBA    (0xffffffff,0xffffffff);
			mInadumaTile[i].SetAddMode (true);
		}
static	s16		ofs = -70;
		mInadumaTile[0].SetXY(378,(s16)(135 + ofs));
		mInadumaTile[0].SetInitWait(1);
		mInadumaTile[1].SetXY(141,(s16)(154 + ofs));
		mInadumaTile[1].SetScale(eScaleW,-0.7f,1);
		mInadumaTile[1].SetScale(eScaleH, 0.7f,1);
		mInadumaTile[1].SetInitWait(5);
		mInadumaTile[2].SetXY(252,(s16)(161 + ofs));
		mInadumaTile[2].SetScale(eScaleWH,0.75f,1);
		mInadumaTile[2].SetInitWait(3);
	}
	return true;
}

bool K7Stage430M00_Panel::AllHide(void)
{
	int		i;
	mGameTile       .SetDispFlag(false);
	mGameTile       .SetFade    (0xff,0);
	mVsTile         .SetDispFlag(false);
	mVsTile         .SetFade    (0xff,0);
	for(i=0 ; i<K7STAGE430M00_PANEL_STARTTILE_NUM ; i++){
		mStartTile[i].SetDispFlag(false);
	}
	mStartTile[0]   .SetFade    (0xff,0);
	mWinTile        .SetDispFlag(false);
	mWinTile        .SetFade    (0xff,0);
	mLoseTile       .SetDispFlag(false);
	mLoseTile       .SetFade    (0xff,0);
	mHandsomeManTile.SetDispFlag(false);
	mHandsomeManTile.SetFade    (0xff,0);
	mKiller7Tile    .SetDispFlag(false);
	mKiller7Tile    .SetFade    (0xff,0);
	for(i=0 ; i<3 ; i++){
		mInadumaTile[i].SetDispFlag(false);
		mInadumaTile[i].SetFade    (0xff,0);
	}
	if( mpKiller7Name!=NULL ){
		for(i=0 ; i<mKiller7NameNum ; i++){
			mpKiller7Name[i].SetDispFlag(false);
		}
	}
	if( mpHandsomeManName!=NULL ){
		for(i=0 ; i<mHandsomeManNameNum ; i++){
			mpHandsomeManName[i].SetDispFlag(false);
		}
	}
	for(i=0 ; i<2 ; i++){
		mWinNum[i].SetDispFlag(false);
		mWinStr[i].SetDispFlag(false);
	}
	return true;
}

bool K7Stage430M00_Panel::FrameProcess(void)
{
	switch( mState ){
	case	IDLE:
		break;
	case	LOADING:
		if( mpLoadData==NULL ){
			break;
		}
		if( mpFile!=NULL && mpFile->GetState()!=ghmGcFile::READFINISH ){
			break;
		}
		GHM_SAFE_DELETE(mpFile);
		Initialize();
		mState = LOADED;
		break;
	case	LOADED:
//#ifndef	K7APP_MASTER
//static	int		_match = 0;
//		if( HSD_PadGetTrigger(1) & HSD_PAD_Y ){
//			_match++;
//			if( _match > 7 ){
//				_match = 0;
//			}
//		}
//		if( HSD_PadGetTrigger(1) & HSD_PAD_A ){
//			OpeningStart(_match);
//		}
//		if( HSD_PadGetTrigger(1) & HSD_PAD_B ){
//			EndingStart(_match);
//		}
//#endif
		break;
	default:
		break;
	}
	if( mState!=LOADED ){
		return true;
	}
	int		i,j;
	switch( mMode ){
	case	0:
		// I[vjO
		switch( mProc ){
		case	0:
			AllHide();
			mGameTile.SetDispFlag(true);
			mVsTile  .SetFade    (0x00,0);
			mCounter = 0;
			mProc++;
			mGameTileRGB[0][0].SetValue(0xff);
			mGameTileRGB[0][1].SetValue(0xff);
			mGameTileRGB[0][2].SetValue(0xff);
			mGameTileRGB[1][0].SetValue(0xff);
			mGameTileRGB[1][1].SetValue(0xff);
			mGameTileRGB[1][2].SetValue(0xff);
			break;
		case	1:
			if( mCounter < WK7_TICK_PER_SEC / 30 * 5 ){
				break;
			}
			SetOpeningDispName(WK7_TICK_PER_SEC / 30 * 5,true);
			mVsTile.SetDispFlag(true);
			mVsTile.SetFade    (0xff,(WK7_TICK_PER_SEC / 30 * 5));
			mCounter = 0;
			mProc++;
#define	VSFADE_TICK		(WK7_TICK_PER_SEC / 30 * 5)
#define	GTFADE_TICK		(WK7_TICK_PER_SEC / 30 * 10)
			mGameTileRGB[0][0].Play(0xfa,GTFADE_TICK);
			mGameTileRGB[0][1].Play(0x46,GTFADE_TICK);
			mGameTileRGB[0][2].Play(0x46,GTFADE_TICK);
			mGameTileRGB[1][0].Play(0xd9,GTFADE_TICK);
			mGameTileRGB[1][1].Play(0x00,GTFADE_TICK);
			mGameTileRGB[1][2].Play(0x9a,GTFADE_TICK);
			break;
		case	2:
			if( mCounter < VSFADE_TICK ){
				break;
			}
			for(i=0 ; i<3 ; i++){
				mInadumaTile[i].SetDispFlag(true);
				mInadumaTile[i].StartAnim();
			}
			mProc++;
			mCounter = 0;
			break;
		case	3:
			if( mCounter < 2 * WK7_TICK_PER_SEC ){
				break;
			}
			mWaitFlag = 1;
			mProc = 16;
			break;
		case	16:
			break;
		case	17:
			mGameTile.SetFade(0x00,(WK7_TICK_PER_SEC / 30 * 10));
			mVsTile  .SetFade(0x00,(WK7_TICK_PER_SEC / 30 * 10));
			SetOpeningDispName(WK7_TICK_PER_SEC / 30 * 10,false);
			for(i=0 ; i<3 ; i++){
				mInadumaTile[i].SetFade(0x00,(WK7_TICK_PER_SEC / 30 * 10));
			}
			mProc++;
			mCounter = 0;
			break;
		case	18:
			if( mCounter < WK7_TICK_PER_SEC / 30 * 10 ){
				break;
			}
			mScaleIndex = 1;
			mScale.SetValue(8.0f);
			mScale.Play    (1.0f,5 * WK7_TICK_PER_SEC / 30);
			mCounter = 0;
			mStartTile[0].SetDispFlag(true);
			mProc++;
			gpSound->mPlaySE(HSD_Randi(SFX_BOSS_HSM_HAJIME_D - SFX_BOSS_HSM_HAJIME_A + 1) + SFX_BOSS_HSM_HAJIME_A);
			break;
		case	19:
			if( mScaleIndex < K7STAGE430M00_PANEL_STARTTILE_NUM ){
				mStartTile[mScaleIndex].SetDispFlag(true);
				mStartTile[mScaleIndex].SetScale   (eScaleWH,mScale.GetValue(),1);
				mScaleIndex++;
			}
			if( mScale.IsAnimating()==true ){
				break;
			}
			mScaleIndex = 1;
			mProc++;
			break;
		case	20:
			if( mScaleIndex < K7STAGE430M00_PANEL_STARTTILE_NUM ){
				mStartTile[mScaleIndex].SetDispFlag(false);
				mScaleIndex++;
				break;
			}
			mProc++;
			mCounter = 0;
			mStartTile[0].SetFade(0x00,(WK7_TICK_PER_SEC / 30 * 5));
			break;
		case	21:
			if( mCounter < WK7_TICK_PER_SEC / 30 * 5 ){
				break;
			}
			mCounter = 0;
			mProc++;
			break;
		default:
			mMode = -1;
			mWaitFlag = 0;
			AllHide();
			break;
		}
		break;
	case	1:
		// GfBO
		switch( mProc ){
		case	0:
			AllHide();
			if( Win()==true ){
				mWinTile.SetDispFlag(true);
			}else{
				mLoseTile.SetDispFlag(true);
			}
			mKiller7Tile    .SetDispFlag(true);
			mHandsomeManTile.SetDispFlag(true);
			switch( mMatchID ){
			case	0: SetWinSentence(0,1); SetWinSentence(1,0); break;
			case	1: SetWinSentence(0,1); SetWinSentence(1,1); break;
			case	2: SetWinSentence(0,2); SetWinSentence(1,1); break;
			case	3: SetWinSentence(0,2); SetWinSentence(1,2); break;
			case	4: SetWinSentence(0,2); SetWinSentence(1,3); break;
			case	5: SetWinSentence(0,3); SetWinSentence(1,3); break;
			case	6: SetWinSentence(0,4); SetWinSentence(1,3); break;
			case	7:
			default:   SetWinSentence(0,5); SetWinSentence(1,3); break;
			}
			for(i=0 ; i<2 ; i++){
				mWinNum[i].SetScale(eScaleWH,1.1f,1);
				mWinNum[i].SetXY   ((s16)(mWinStr[i].GetX() - mWinNum[i].GetW()),
				                    (s16) mWinStr[i].GetY());
				mWinNum[i].SetDispFlag(true);
				mWinStr[i].SetDispFlag(true);
			}
			SetEndDispName();
			mCounter = 0;
			mProc++;
			break;
		case	1:
			if( mCounter < WK7_SEC_TO_TICK(5)){
				break;
			}
			mCounter = 0;
			mProc++;
			break;
		default:
			mMode = -1;
			AllHide();
			break;
		}
		break;
	default:
		break;
	}
	mCounter += WK7_TICK_PER_FRAME;
	mStartTile[0].SetScale(eScaleWH,mScale.GetValue(),1);
	u32		rgb[2];
	for(i=0 ; i<2 ; i++){
		for(j=0 ; j<3 ; j++){
			mGameTileRGB[i][j].FrameProcess();
		}
		rgb[i]  = mGameTile.GetA();
		rgb[i] |= (mGameTileRGB[i][0].GetValue() << 24)|(mGameTileRGB[i][1].GetValue() << 16)|(mGameTileRGB[i][2].GetValue() << 8);
	}
	mGameTile.SetRGBA(rgb[0],rgb[1]);
	mScale.FrameProcess();
	for(i=0 ; i<3 ; i++){
		mInadumaTile[i].FrameProcess();
	}
	for(i=0 ; i<K7STAGE430M00_PANEL_STARTTILE_NUM ; i++){
		mStartTile[i].FrameProcess();
	}
	mGameTile       .FrameProcess();
	mVsTile         .FrameProcess();
	mWinTile        .FrameProcess();
	mLoseTile       .FrameProcess();
	mKiller7Tile    .FrameProcess();
	mHandsomeManTile.FrameProcess();
	if( mpKiller7Name!=NULL ){
		for(i=0 ; i<mKiller7NameNum ; i++){
			mpKiller7Name[i].FrameProcess();
		}
	}
	if( mpHandsomeManName!=NULL ){
		for(i=0 ; i<mHandsomeManNameNum ; i++){
			mpHandsomeManName[i].FrameProcess();
		}
	}
	return true;
}

bool K7Stage430M00_Panel::OpeningStart(int match)
{
	SetMatchTexture(match);
	mMatchID = match;
	mMode    = 0;
	mProc    = 0;
	mCounter = 0;
	return true;
}

bool K7Stage430M00_Panel::WaitingOpening(void)
{
	if( mMode!=0 ){
		return false;
	}
	if( mWaitFlag!=1 ){
		return false;
	}
	return true;
}

bool K7Stage430M00_Panel::OpeningRestart(void)
{
	if( mMode!=0 ){
		return false;
	}
	if( mWaitFlag!=1 ){
		return false;
	}
	mProc++;
	return true;
}

bool K7Stage430M00_Panel::EndingStart(int match)
{
	mMatchID = match;
	mMode    = 1;
	mProc    = 0;
	mCounter = 0;
	return true;
}

bool K7Stage430M00_Panel::IsOver(void)
{
	if( mMode >= 0 ){
		return false;
	}
	return true;
}

bool K7Stage430M00_Panel::Win(void)
{
	switch( mMatchID ){
	case	0:
	case	2:
	case	5:
	case	6:
	case	7:
		return true;
	default:
		break;
	}
	return false;
}

