////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage520M00
//
// K7Stage520M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE520M00_H__
#define	__K7STAGE520M00_H__

#include "..\..\K7Stage.h"
#include "..\..\..\Enm\EnmTIM.h"

#include ".\K7StageHotelBase.h"

#define	K7STAGE520M00_KIHAN_HS		ENENO_5_520M00_KIHAN_TIME

class K7Stage520M00 : public K7StageHotelBase{
	friend class WK7Stage;
protected:
	K7Stage520M00();
	K7Stage520M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	K7EnmTIM	*pNpcTim;
public:
	virtual ~K7Stage520M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool HitObjCallBack(WK7HitObjInfo &info);
//	virtual bool TerminateCallBack (void)              { return true; }		// Iȉj
	virtual bool SetCurrentCallBack(void);
//	virtual bool EventCallBack     (WK7EventInfo     &){ return true; }		// Cxg
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool BpLeaveCallBack   (WK7BpInfo        &);
//	virtual bool BpArriveCallBack  (WK7BpInfo        &){ return true; }		// _
	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &);
//	virtual bool HitObjCallBack    (WK7HitObjInfo    &){ return true; }		// qbgIuWF
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &){ return true; }		// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &){ return true; }		// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &){ return true; }		// erCxgiZ[u|Cgj
//	virtual bool SpAbilityCallBack (WK7SpAbilityInfo &);

};

#ifdef __K7STAGE520M00_CPP__


enum K7STAGE520M00_ONESHOTCAM{
	CAM520M00HSINIT,
	CAM520M00HSTERM,
	CAM520M00HSRETURN,
};


K7StageEventOneShotCamera K7Stage520M00_Camera[] = {
	{{95.831f, 9.823f, 71.844f},{94.275f, 11.340f, 106.380f}},
	{{92.977f, 9.823f, -234.094f},{91.421f, 11.340f, -199.558f}},
	{{92.517f, 11.878f, -243.670f},{92.206f, 12.269f, -208.737f}},
};


#endif

#endif	//__K7STAGE520M00_H__

