////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage522M00
//
// K7Stage522M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE522M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage522M00.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"

K7Stage522M00::K7Stage522M00(ghmGcListObj *pAnchor,int prio) : K7StageHotelBase(pAnchor,prio)
{
//	SetOneShotCamLocTbl(K7Stage522M00_Camera);
}

K7Stage522M00::~K7Stage522M00()
{
}

bool K7Stage522M00::CreateCallBack(void)
{
	//LLGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	return true;
}

bool K7Stage522M00::TerminateCallBack(void)
{
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	return true;
}

bool K7Stage522M00::SetCurrentCallBack(void)
{
	gpSound->mSetDspRateAll(20);
	if( GameInfo.GetScenarioFlow()==K7SCNF_HT2 ){
		gpSound->mPlayStreamEx(HPS_HOTEL_B,K7SCR05_HOTEL_ROOM_VOLUME);
	}else{
		gpSound->mPlayStreamEx(HPS_HOTEL_A,K7SCR05_HOTEL_ROOM_VOLUME);
	}
	while( WK7Stage::IsChanging()==true ){
		K7SCR_RETSYS();
	}
	Vec		pos;
	s8		subno;
	WK7PLAYERPATHCONTROL->GetCurrentPosition(&pos);
	if( pos.x < 0.0f ){
		subno = 1;
	}else{
		subno = 0;
	}
	SetStageMapFlag(subno,true);
	GameInfo.SetMenuMapSubNo(subno);
	return false;
}

bool K7Stage522M00::CondChangeCallBack(void)
{
	bool		tamaevflag,evCon;
	InitPath();
	if( GameInfo.GetScenarioFlow()!=K7SCNF_HT2 ){
		evCon = false;
		if( K7SCR_EVHASITEM(K7EVITEM_TAMA(051201))==TRUE ){
			tamaevflag = false;
		}else{
			tamaevflag = true;
		}
	}else{
		tamaevflag = false;
		if( WK7Play::HasPlayed(K7EVENTPLAY(05090202))==true ){
			K7SCR_SET_SCENARIO_FLAG( K7SCN05_CGFL_052200 );
			evCon = false;
		}else{
			evCon = true;
		}
	}
	K7SCR_EVNO_SETENABLE(K7EVENTNO  (050201),evCon);
	K7SCR_EVNO_SETENABLE(K7EVENTTAMA(051201),tamaevflag);
	K7SCR_STG_SET_PATHENABLE("curve20",false);
	RenewTamaEffect(K7EVENTTAMA(051201));
	SetVisibleTamaJObj(K7EVENTTAMA(051201),!K7SCR_EVHASITEM(K7EVITEM_TAMA(051201)));
	SetVisibleJObj("Bloodstain",GameInfo.GetScenarioFlow()==K7SCNF_HT2,false,true);
	return true;
}

bool K7Stage522M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(050201):
		WK7PlayEventInfo	playEventInfo;
		playEventInfo.Initialize();
		playEventInfo.mEventNo = K7EVENTPLAY(05090202);
		PlayEventTask(playEventInfo);
		return false;
	default:
		break;
	}
	return true;
}

