////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage559M00 ywZz
//
// K7Stage559M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 04/17/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE559M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage559M00.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Wat\WK7Item.h"

//pX
#define	PAT559M00_FINGERPRINT	"SPAS01"			//wƍւ̃pX
#define	PAT559M00_SAFE			"SPAS02"			//ɂւ̃pX
//f
#define	MDL559M00_DOORNUMBER	"Door1"				//Í͔
#define	MDL559M00_DOORFINGER	"Door2"				//wƍ
//[V
#define	MOT559M00_DOORNUMBER_OP	(0)					//Í͔J
#define	MOT559M00_DOORFINGER_OP	(1)					//wƍJ
#define	MOT559M00_GAL_HAND		K7MOTID(K7GAL,650)	//KVAwF
//bZ[W
#define	MES559M00_GET_TAPE			(0)				//e[v肵
#define	MES559M00_FINGERPRINT_FALSE	(1)				//wƍs
#define	MES559M00_FINGERPRINT_TRUE	(2)				//wƍ
#define	MES559M00_GET_STRANGE		(3)				//svcȑ`擾




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage559M00::K7Stage559M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage559M00_Camera );
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage559M00::~K7Stage559M00()
{
	//wƍZbg
	K7SCR_RESET_SCENARIO_FLAG( EV055701 );
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage559M00::CreateCallBack( void )
{
	//[Vt@C
	CreateOwnStageMotion( MOT559M00_DOORNUMBER_OP );
	CreateOwnStageMotion( MOT559M00_DOORFINGER_OP );
	WK7RenderObj::CreateOwnMotionObj( K7MOT_ATTR|K7OBJTYPE_CHR, MOT559M00_GAL_HAND );
	
	return( true );
}

//------------------------------------------------------------------------------
//iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
//------------------------------------------------------------------------------
bool
K7Stage559M00::InitializeCallBack( void )
{
	mpGalMotion = GetOwnModelMotion( K7MOT_ATTR|K7OBJTYPE_CHR, MOT559M00_GAL_HAND );
	return( true );
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage559M00::CondChangeCallBack( void )
{
	//Í
	if( K7SCR_GET_SCENARIO_FLAG(EV055700) == false )
	{	//ʉ߂ĂȂ
		K7SCR_EVNO_SETENABLE( K7EVENTNO(055700), true );			//pl
		K7SCR_STG_SET_PATHENABLE( PAT559M00_FINGERPRINT, false );	//pX
		SimpleSetStartMotion( MDL559M00_DOORNUMBER, MOT559M00_DOORNUMBER_OP );
	}else
	{	//ʉ߂
		K7SCR_EVNO_SETENABLE( K7EVENTNO(055700), false );			//plȂ
		K7SCR_STG_SET_PATHENABLE( PAT559M00_FINGERPRINT, true );	//pX
		SimpleSetLastMotion( MDL559M00_DOORNUMBER, MOT559M00_DOORNUMBER_OP );
	}
	
	//wƍ
	if( K7SCR_GET_SCENARIO_FLAG(EV055701) == false )
	{	//ʉ߂ĂȂ
		K7SCR_EVNO_SETENABLE( K7EVENTNO(055701), true );	//wƍ
		K7SCR_STG_SET_PATHENABLE( PAT559M00_SAFE, false );	//pX
		SimpleSetStartMotion( MDL559M00_DOORFINGER, MOT559M00_DOORFINGER_OP );
	}else
	{	//ʉ߂
		K7SCR_EVNO_SETENABLE( K7EVENTNO(055701), false );	//wƍȂ
		K7SCR_STG_SET_PATHENABLE( PAT559M00_SAFE, true );	//pX
		SimpleSetLastMotion( MDL559M00_DOORFINGER, MOT559M00_DOORFINGER_OP );
	}
	
	//Ƀpl
	if( K7SCR_GET_SCENARIO_FLAG(EV055702) == false )
	{	//JĂȂ
		K7SCR_EVNO_SETENABLE( K7EVENTNO(055702), true );
	}else
	{	//J
		K7SCR_EVNO_SETENABLE( K7EVENTNO(055702), false );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage559M00::SetCurrentCallBack( void )
{
	//2FL痈ꍇ͕Kwƍ
	if( GetPrevStageID() == K7STGID(551,2) )
	{
		K7SCR_RESET_SCENARIO_FLAG( EV055701 );
		K7SCR_EVCONDCHANGE();
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage559M00::EventCallBack( WK7EventInfo &info )
{
	switch( info.mEventNo )
	{
		//plEÍ(:72712 bJ[:55549)
		case	K7EVENTNO( 055700 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			//plĂяo
			K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(055700), 0 );
			K7SCR_PANEL_START();
			K7SCR_PANEL_TERMWAIT();
			K7SCR_RETSYS();
			K7SCR_PANEL_EXIT();
			WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
			K7SCR_PANEL_EXITWAIT();
			//`FbN
			if( K7SCR_PANEL_GETRESULT() == 1 )
			{
				//FixCam( CAM559M00_DOOR );
				gpSound->mPlaySE( SFX_SCE5_SCL_GAKKO_DOOR_ANSHOU );
				SimplePlayMotionB( MDL559M00_DOORNUMBER, MOT559M00_DOORNUMBER_OP );
				K7SCR_SET_SCENARIO_FLAG( EV055700 );
				K7SCR_EVCONDCHANGE();
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
			break;
		
		//wƍ
		case	K7EVENTNO( 055701 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			//KVAH
			if( WK7PLAYERCONTROL->GetMainID() == K7GAL )
			{
				GalFingerPrint();
			}else
			{
				FixCamMes( CAM559M00_FINGERPRINT, MES559M00_FINGERPRINT_FALSE );
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
			break;
		
		//Ƀpl`L
		case	K7EVENTNO( 055702 ):
			//ɂJĂȂ΋ɂJ
			if( K7SCR_GET_SCENARIO_FLAG(EV055702) == false )
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				//ɃplĂяo
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(055702), 0 );
				K7SCR_PANEL_START();
				K7SCR_PANEL_TERMWAIT();
				K7SCR_RETSYS();
				GameInfo.SetPanelNoiseCancel( true );
				K7SCR_PANEL_EXIT();
				K7SCR_PANEL_EXITWAIT();
				GameInfo.SetPanelNoiseCancel( false );
				//`FbN
				if( K7SCR_PANEL_GETRESULT() == 0 )
				{
					K7SCR_SET_SCENARIO_FLAG( EV055702 );
					K7SCR_EVCONDCHANGE();
					//inGame~
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					K7SCR_PC_SETVISIBLE( false );
					//L
					K7SCR_CHARAGEKI_PREPARE( K7EVENTPLAY(05500201) );
					//mCY
					K7SCR_NOISE_RELEASE();
					//LI҂
					K7SCR_CHARAGEKI_END_WAIT( K7EVENTPLAY(05500201) );
					//svcȑ`擾
					K7SCR_EVSETITEM( K7EVITEM_KEY(055700), true );
					K7SCR_SET_SCENARIO_FLAG( EV055700STRANGE );
					SetEffectSoundOffFlag( false );
					K7SCR_STG_ITEMGET( MES559M00_GET_STRANGE );
					K7SCR_STG_ITEMGET_NOTDISPLAYED_B( MES559M00_GET_STRANGE );
					K7SCR_PC_SETVISIBLE( true );
					//LI
					K7SCR_CHARAGEKI_TERM( K7EVENTPLAY(05500201) );
					WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
					K7SCR_STG_ITEMGET_VALID_B( MES559M00_GET_STRANGE );
				}else
				{
					WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
					K7SCR_PC_SETVISIBLE( true );
					K7SCR_NOISE_RELEASE();
				}
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//KVAwƍ
//------------------------------------------------------------------------------
void
K7Stage559M00::GalFingerPrint( void )
{
	Vec pos = { -52.025f, 59.9f, -434.977f };
	
	WK7Model* pPcModel = WK7PLAYERCONTROL->GetCharaModel();
	
	WK7PLAYERPATHCONTROL->SetEnable( false );
	WK7PLAYERCONTROL->SetPosition( &pos );
	WK7PLAYERCONTROL->SetRotY( -HALF_PI );
	
	FixCam( CAM559M00_GAL_FINGERPRINT );
	
	if( pPcModel != NULL )
	{
		WK7PLAYERCONTROL->SetEnable( false );
		//KVA[VĐ
		pPcModel->AttachMotion( mpGalMotion );
		pPcModel->PlayMotion();
		pPcModel->SetMotionLoop( false );
		K7SCR_TIMEWAIT( 6080 );
		gpSound->mPlaySE( SFX_SCE5_SCL_GAKKO_FINGERPRINT );
		//ĐI҂
		while( pPcModel->GetMotionState() != WK7MODEL_NOANIM )
		{
			K7SCR_RETSYS();
		}
	}
	
	gpSound->mPlaySE( SFX_SYS_TRUE );
	K7SCR_STGC_MESSAGE_B( MES559M00_FINGERPRINT_TRUE );

	FixCam( CAM559M00_FINGERPRINTDOOR );
	gpSound->mPlaySE( SFX_SCE5_SCL_GAKKO_DOOR_SAFE );
	SimplePlayMotionB( MDL559M00_DOORFINGER, MOT559M00_DOORFINGER_OP );
	K7SCR_TIMEWAIT( 2400 );
	K7SCR_SET_SCENARIO_FLAG( EV055701 );
	K7SCR_EVCONDCHANGE();
	
	if( pPcModel != NULL )
	{
		WK7PLAYERCONTROL->NextMotionHokanEnableRequest();
		WK7PLAYERCONTROL->SetEnable( true );
	}
	
	WK7PLAYERPATHCONTROL->SetEnable( true );
	SetCurrentPath(	GetPathNurbsAll("curve4"),
					1.000f,
					0,									// 0:forward 1:back
					WK7PATHINFO_INITDIR_TGTDIR_REV );	// :WK7PATHINFO_INITDIR_TGTDIR wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
	K7SCR_RETSYS();
//	K7SCR_TIMEWAIT( 1200 );
}
