////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage578M00
//
// K7Stage578M00.cpp
//
// Creator       : 
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE578M00_CPP__

#include ".\K7Stage578M00.h"
#include "..\Scn\K7Scn07.h"
#include "..\Scn\K7Scn01.h"
#include "..\Scn\K7Scn03.h"
#include "..\Scn\K7Scn05.h"

#define	STG578M00_BAN_CHRID		K7CHRID(K7BAN,0)
#define	STG578M00_BAN_MOTID		K7MOTID(K7BAN,20)

#define	MES578M00_00	(0)		//eԂɓn

#define	STG578M00_CLOSED_PATHNAME	"K7_pass01"

bool	K7Stage578M00::mShortCutEnable = true;

bool K7Stage578M00::SetKihanShortCutEnable(bool flag)
{
	mShortCutEnable = flag;
	return true;
}

bool K7Stage578M00::GetKihanShortCutEnable(void)
{
	return mShortCutEnable;
}

static K7Stage578M00_LinkInfo	_K7Stage578M00_LinkInfo[] = {
	//      3       4
	//      
	//      
	//  
	//        
	// 2        
	//  
	//          1
	//
	//            y1z                           y4z
	{ K7SCNF_CEL,{{K7STGID(775, 1),"door_007502",1},{K7STGID(573, 0),"branchA1"   ,4}} },	//ZeBbN
	{ K7SCNF_FUK,{{K7STGID(112, 0),"door_015002",1},{K7STGID(573, 0),"branchA2"   ,4}} },	//tNV}
	{ K7SCNF_KAK,{{K7STGID(134, 0),"door_011601",1},{K7STGID(573, 0),"branchA6"   ,4}} },	//pr
	{ K7SCNF_ISZ,{{K7STGID(327, 0),"door_030602",1},{K7STGID(573, 0),"branchA3"   ,4}} },	//CVUJh
	{ K7SCNF_CUR,{{K7STGID(362, 0),"door_035105",1},{K7STGID(573, 0),"branchA4"   ,4}} },	//J[eBX@
	{ K7SCNF_SCL,{{K7STGID(551, 2),"branchI"    ,1},{K7STGID(573, 0),"branchA5"   ,4}} },	//wZ
	{ K7SCNF_HT1,{{K7STGID(517, 0),"door_051704",1},{K7STGID(573, 0),"branchA7"   ,4}} },	//ze
	//            y2z                           y3z
	{ K7SCNF_CEL,{{K7STGID(775, 2),"door_007501",2},{K7STGID(776, 0),"door_007606",3}} },	//ZeBbN
	{ K7SCNF_FUK,{{K7STGID(118, 0),"door_015003",2},{K7STGID(116, 0),"branchA"    ,3}} },	//tNV}
	{ K7SCNF_KAK,{{K7STGID(138, 0),"door_011602",2},{K7STGID(134, 1),"branchE"    ,3}} },	//pr
	{ K7SCNF_ISZ,{{K7STGID(328, 0),"door_030604",2},{K7STGID(329, 0),"door_030605",3}} },	//CVUJh
	{ K7SCNF_CUR,{{K7STGID(365, 0),"door_035107",2},{K7STGID(364, 0),"door_035108",3}} },	//J[eBX@
	{ K7SCNF_SCL,{{K7STGID(557, 0),"branchA"    ,2},{K7STGID(551, 2),"branchH"    ,3}} },	//wZ
	{ K7SCNF_HT1,{{K7STGID(520, 0),"door_051706",2},{K7STGID(519, 0),"door_051705",3}} },	//ze
	{ -1        ,{{0xffffffff     ,NULL         ,0},{0xffffffff     ,NULL         ,0}} },
};

K7Stage578M00_PointInfo* K7Stage578M00::GetPointInfo(K7ScenarioFlow flow,int param)
{
	K7Stage578M00_LinkInfo	*pLinkInfo;
	int						i;
	for(pLinkInfo=_K7Stage578M00_LinkInfo ; pLinkInfo->mPoint[0].mStageID!=0xffffffff ; pLinkInfo++){
		if( pLinkInfo->mScenarioFlow!=flow ){
			continue;
		}
		for(i=0 ; i<2 ; i++){
			if( pLinkInfo->mPoint[i].mParam==param ){
				return &pLinkInfo->mPoint[i];
			}
		}
	}
	return NULL;
}

K7Stage578M00_PointInfo* K7Stage578M00::GetLinkPoint(u32 stgid,const char *pBpName)
{
	K7Stage578M00_LinkInfo	*pInfo;
	int						i;
	for(pInfo=_K7Stage578M00_LinkInfo ; pInfo->mPoint[0].mStageID!=0xffffffff ; pInfo++){
		for(i=0 ; i<2 ; i++){
			if( pInfo->mPoint[i].mStageID!=stgid ){
				continue;
			}
			if( pInfo->mPoint[i].mpBpName==NULL ){
				continue;
			}
			if( pBpName!=NULL ){
				if( strcmp(pInfo->mPoint[i].mpBpName,pBpName)!=0 ){
					continue;
				}
			}
			return &pInfo->mPoint[i ^ 1];
			
		}
	}
	return NULL;
}

//ZeBbN
static u32		_K7Stage578M00_Scn07C_TamaList[] = {
	K7EVITEM_TAMA(007101),
	K7EVITEM_TAMA(007401),
	0xffffffff,
};
//tNV}
static u32		_K7Stage578M00_Scn01F_TamaList[] = {
	K7EVITEM_TAMA(010000),
//	K7EVITEM_TAMA(010001),
//	K7EVITEM_TAMA(010002),
	0xffffffff,
};
//pr
static u32		_K7Stage578M00_Scn01K_TamaList[] = {
	K7EVITEM_TAMA(011301),
	K7EVITEM_TAMA(011401),
	K7EVITEM_TAMA(011501),
	K7EVITEM_TAMA(011601),
	0xffffffff,
};
//CVUJh
static u32		_K7Stage578M00_Scn03I_TamaList[] = {
//	K7EVITEM_TAMA(030201),
	K7EVITEM_TAMA(030401),
	K7EVITEM_TAMA(030501),
	K7EVITEM_TAMA(030709),
	0xffffffff,
};
//J[eBX@
static u32		_K7Stage578M00_Scn03C_TamaList[] = {
	K7EVITEM_TAMA(035001),
	K7EVITEM_TAMA(035002),
	K7EVITEM_TAMA(035003),
	0xffffffff,
};
//wZ
static u32		_K7Stage578M00_Scn05S_TamaList[] = {
	K7EVITEM_TAMA(055100),
	0xffffffff,
};
//ze
static u32		_K7Stage578M00_Scn05H_TamaList[] = {
	K7EVITEM_TAMA(051101),
	K7EVITEM_TAMA(051201),
	K7EVITEM_TAMA(051301),
	K7EVITEM_TAMA(051401),
	K7EVITEM_TAMA(051501),
	K7EVITEM_TAMA(051601),
	K7EVITEM_TAMA(051701),
	0xffffffff,
};

#include ".\00\00\K7Stage775M02.h"
#include ".\01\00\K7Stage118M00.h"
#include ".\01\01\K7Stage138M00.h"
#include ".\03\00\K7Stage328M00.h"
#include ".\03\01\K7Stage365M00.h"
#include ".\05\01\K7Stage557M00.h"
#include ".\05\00\K7Stage520M00.h"

static K7Stage578M00_BanCond	_K7Stage578M00_BanCond[] = {
	// ԐlÕXe[W  NAtO     Lngr           KveۃXg
	{ K7STGID(775, 1)  , K7SCN07_EVFL_007500, K7STAGE775M02_KIHAN_HS , _K7Stage578M00_Scn07C_TamaList },	//ZeBbN
	{ K7STGID(112, 0)  , K7SCN01_BAN_FUK    , K7STAGE118M00_KIHAN_HS , _K7Stage578M00_Scn01F_TamaList },	//tNV}
	{ K7STGID(134, 0)  , K7SCN01_BAN_KAK    , K7STAGE138M00_KIHAN_HS , _K7Stage578M00_Scn01K_TamaList },	//pr
	{ K7STGID(327, 0)  , K7SCN03_BAN_ISZ    , K7STAGE328M00_KIHAN_HS , _K7Stage578M00_Scn03I_TamaList },	//CVUJh
	{ K7STGID(362, 0)  , K7SCN03_BAN_CUR    , K7STAGE365M00_KIHAN_HS , _K7Stage578M00_Scn03C_TamaList },	//J[eBX@
	{ K7STGID(551, 2)  , K7SCN05_BAN_SCL    , K7STAGE557M00_KIHAN_HS , _K7Stage578M00_Scn05S_TamaList },	//wZ
	{ K7STGID(517, 0)  , K7SCN05_BAN_HTL    , K7STAGE520M00_KIHAN_HS , _K7Stage578M00_Scn05H_TamaList },	//ze
	{ 0xffffffff       , -1                 , 0xffffffff             , NULL                           },
};

bool K7Stage578M00::GetKihanClear(K7ScenarioFlow flow)
{
	K7Stage578M00_PointInfo		*pPointInfo = GetPointInfo(flow,1);
	if( pPointInfo==NULL ){
		return true;
	}
	K7Stage578M00_BanCond		*pBanCond;
	for(pBanCond=_K7Stage578M00_BanCond ; pBanCond->mPrevStageID!=0xffffffff ; pBanCond++){
		if( pBanCond->mPrevStageID!=pPointInfo->mStageID ){
			continue;
		}
		if( WK7Npc::GetEnemyDieTest(pBanCond->mKihanEnemyNo)==false ){
//		if( K7SCR_GET_SCENARIO_FLAG(pBanCond->mFlagID)==FALSE ){
			return false;
		}else{
			return true;
		}
	}
	return true;
}

K7Stage578M00_PointInfo* K7Stage578M00::GetKihanShortCut(K7ScenarioFlow flow,int param)
{
	if( GetKihanShortCutEnable()==false ){
		return NULL;
	}
	if( GetKihanClear(flow)==false ){
		return NULL;
	}
	switch( param ){
	case	1: return GetPointInfo(flow,3);
	case	3: return GetPointInfo(flow,1);
	default:
		break;
	}
	return NULL;
}

//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage578M00::K7Stage578M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mReturnStageID      = 0xffffffff;
	mReturnParam        = 0xffffffff;
	memset(mReturnBpName,0,sizeof(mReturnBpName));
	mpBan               = NULL;
	mpBanModel          = NULL;
	mpBanStandbyMotion  = NULL;
	mpBanCond           = NULL;
	SetOneShotCamLocTbl( K7Stage578M00_Camera );
	GameInfo.SetMenuMapEnable(false);
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage578M00::~K7Stage578M00()
{
	GameInfo.SetMenuMapEnable(true);
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂bool
//------------------------------------------------------------------------------
bool
K7Stage578M00::CreateCallBack( void )
{
	mpBan = CreateOwnChara( STG578M00_BAN_CHRID );
	WK7RenderObj::CreateOwnMotionObj( K7MOT_ATTR|K7OBJTYPE_CHR, STG578M00_BAN_MOTID );
	
	mReturnStageID = mPrevStageID;
	switch( mReturnStageID ){
	case	K7STGID(573,0):
		mReturnParam = 4;
		break;
	default:
		mReturnParam = WK7Stage::GetCurrentStageParam();
		break;
	}
	if( mpPrevStagePathName != NULL ){
		strncpy(mReturnBpName,mpPrevStagePathName,WK7DOOREVENT_BPNAME_MAX-1);
	}else if( mpPrevStageBpName != NULL ){
		strncpy(mReturnBpName,mpPrevStageBpName,WK7DOOREVENT_BPNAME_MAX-1);
	}
	K7Stage578M00_BanCond	*pBanCond;
	mpBanCond = NULL;
	for(pBanCond=_K7Stage578M00_BanCond ; pBanCond->mPrevStageID!=0xffffffff ; pBanCond++){
		if( pBanCond->mPrevStageID==mPrevStageID ){
			mpBanCond = pBanCond;
			break;
		}
	}
	if( mpBanCond==NULL ){
		K7Stage578M00_PointInfo		*pPointInfo = GetLinkPoint(mPrevStageID,mReturnBpName);
		if( pPointInfo != NULL ){
			for(pBanCond=_K7Stage578M00_BanCond ; pBanCond->mPrevStageID!=0xffffffff ; pBanCond++){
				if( pBanCond->mPrevStageID==pPointInfo->mStageID ){
					mpBanCond = pBanCond;
					break;
				}
			}
		}
	}
	return( true );
}

//------------------------------------------------------------------------------
//iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsBbool
//------------------------------------------------------------------------------
bool
K7Stage578M00::InitializeCallBack( void )
{
	mpBan              = GetOwnChara( STG578M00_BAN_CHRID );
	mpBanModel         = GetOwnModel( K7OBJTYPE_CHR, STG578M00_BAN_CHRID );
	mpBanStandbyMotion = GetOwnModelMotion( K7MOT_ATTR|K7OBJTYPE_CHR, STG578M00_BAN_MOTID );
	if( mpBanModel!=NULL && mpBanStandbyMotion!=NULL )
	{
		mpBanModel->AttachMotion( mpBanStandbyMotion );
		mpBanModel->PlayMotion();
		mpBanModel->SetPosition( 0.000f, 0.000f, -50.000f );
		mpBanModel->SetRotY( 0.0f );
		//mpSmaModel->SetPosition(31.059f, 0.086f, 13.141f);
		//mpSmaModel->SetRotY    (-PI * 0.5f);
		mpBan->SetRenderFlag( true );
	}
	K7SCR_STG_SET_PATHENABLE("K7_pass03",false);
	
	bool	shortcut = K7Stage578M00::GetKihanShortCutEnable();
	K7Stage578M00::SetKihanShortCutEnable(false);
	switch( mReturnParam ){
	case	1:
		K7SCR_STG_SET_JUNCTION_PASS(K7STGID(775,1),"door_007502");
		break;
	case	2:
		K7SCR_STG_SET_JUNCTION_PASS(K7STGID(775,2),"door_007503");
		break;
	case	3:
		K7SCR_STG_SET_JUNCTION_PASS(K7STGID(776,0),"door_007606");
		break;
	case	4:
		K7SCR_STG_SET_JUNCTION_PASS(K7STGID(573,0),"branchA1");
		break;
	default:
		break;
	}
	K7Stage578M00::SetKihanShortCutEnable(shortcut);
	return( true );
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage578M00::CondChangeCallBack( void )
{
	if( mpBanCond==NULL ){
		return true;
	}
	
	//pXݒ
	
	//Lnʉ߂łtOĂ΃pX\
	if( K7SCR_GET_SCENARIO_FLAG(mpBanCond->mFlagID)==TRUE )
	{	//ʉ߃pX
		K7SCR_STG_SET_PATHENABLE(STG578M00_CLOSED_PATHNAME,true );
		//ԃWNV
		K7SCR_EVNO_SETENABLE( K7EVENTNO(987801), false );
	}else
	{	//ʉ߃pXȂ
		K7SCR_STG_SET_PATHENABLE(STG578M00_CLOSED_PATHNAME,false);
		//ԃWNV\
		K7SCR_EVNO_SETENABLE( K7EVENTNO(987801), true );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage578M00::SetCurrentCallBack( void )
{
	gpSound->mSetDspRateAll(20);
	switch( mReturnParam )
	{
		case	1:
		case	2:
			gpSound->mPlayStreamNo( HPS_MONBANFLONT );
			break;
		
		case	3:
		case	4:
			gpSound->mPlayStreamNo( HPS_MONBAN );
			break;
		
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage578M00::EventCallBack( WK7EventInfo &info )
{
	u32		mesno = 1;
	switch( info.mEventNo )
	{
		//ԂƂ̉b
		case	K7EVENTNO( 987801 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			
			//eĂOKCxg
			if( mpBanCond!=NULL ){
				int		i;
				for(i=0 ; mpBanCond->mpTamaList[i]!=0xffffffff ; i++){
					if( K7SCR_EVHASITEM(mpBanCond->mpTamaList[i])==FALSE ){
						mesno = 0;
						break;
					}
				}
			}
			
			if( mesno && mpBanCond!=NULL )
			{
				//Lnʉ߂łtOON
				K7SCR_SET_SCENARIO_FLAG( mpBanCond->mFlagID );
			}
			
			Monban( K7EVENTZAN(007801), mesno );
			
			if( mesno )
			{
				int		i;
				for(i=0 ; mpBanCond->mpTamaList[i]!=0xffffffff ; i++){
					K7SCR_EVUSEITEM(mpBanCond->mpTamaList[i],true);
				}
				gpSound->mPlaySE( SFX_SYS_EV_CLEAR );
			}
			
			//pXύX
			K7SCR_EVCONDCHANGE();
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//ԂƂ̉b
//------------------------------------------------------------------------------
void
K7Stage578M00::Monban( u32 inEvNo, u32 inNo )
{
	WK7ZanEventInfo zanEventInfo;
	
	zanEventInfo.Initialize();
	zanEventInfo.mEventNo = inEvNo;
	zanEventInfo.mpStage  = this;
	GameInfo.SetZanMesID( inNo );
	GameInfo.SetZanTermWait( true );
	GameInfo.SetZanCharaLoadCancel( true );
	CallZanEventCallBackTask( zanEventInfo );
	while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERMWAIT )
	{
		K7SCR_RETSYS();
	}
	//JPCtH[ɖ߂
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
	GameInfo.SetZanTermWait( false );
	K7SCR_ENTER_PLAYMODE_B();
}

//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool
K7Stage578M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	K7Stage578M00_PointInfo		*pPointInfo;
	switch( info.mEventNo ){
	case	K7EVENTDOOR(980001):
		if( mReturnParam==1 ){
			break;
		}else{
			if( (pPointInfo = GetLinkPoint(mReturnStageID,mReturnBpName))!=NULL ){
				info.mNextStageID = pPointInfo->mStageID;
				if( pPointInfo->mpBpName!=NULL ){
					strncpy(info.mNextBpName,pPointInfo->mpBpName,WK7DOOREVENT_BPNAME_MAX-1);
				}
			}
			return true;
		}
		break;
	case	K7EVENTDOOR(980002):
		switch( mReturnParam ){
		case	2:
			break;
		case	3:
			if( (pPointInfo = GetLinkPoint(mReturnStageID,mReturnBpName))!=NULL ){
				info.mNextStageID = pPointInfo->mStageID;
				if( pPointInfo->mpBpName!=NULL ){
					strncpy(info.mNextBpName,pPointInfo->mpBpName,WK7DOOREVENT_BPNAME_MAX-1);
				}
			}
			return true;
		default:
			return true;
		}
		break;
	case	K7EVENTDOOR(980003):
		switch( mReturnParam ){
		case	2:
			if( (pPointInfo = GetLinkPoint(mReturnStageID,mReturnBpName))!=NULL ){
				info.mNextStageID = pPointInfo->mStageID;
				if( pPointInfo->mpBpName!=NULL ){
					strncpy(info.mNextBpName,pPointInfo->mpBpName,WK7DOOREVENT_BPNAME_MAX-1);
				}
			}
			return true;
		case	3:
			break;
		default:
			return true;
		}
		break;
	case	K7EVENTDOOR(980004):
		if( mReturnStageID==K7STGID(573,0) ){
			break;
		}else{
			if( (pPointInfo = GetLinkPoint(mReturnStageID,mReturnBpName))!=NULL ){
				info.mNextStageID = pPointInfo->mStageID;
				if( pPointInfo->mpBpName!=NULL ){
					strncpy(info.mNextBpName,pPointInfo->mpBpName,WK7DOOREVENT_BPNAME_MAX-1);
				}
			}
			return true;
		}
		break;
	//---- ȕύX ----
	//L
	case	K7EVENTDOOR(980101):
	case	K7EVENTDOOR(980103):
		gpSound->mPlayStreamNo( HPS_MONBAN );
		return true;
	//ԕ
	case	K7EVENTDOOR(980102):
	case	K7EVENTDOOR(980104):
		gpSound->mPlayStreamNo( HPS_MONBANFLONT );
		K7SCR_EVCONDCHANGE();
		return true;
	default:
		return true;
	}
	if( mReturnStageID != 0xffffffff ){
		info.mNextStageID = mReturnStageID;
		strncpy(info.mNextBpName,mReturnBpName,WK7DOOREVENT_BPNAME_MAX-1);
	}
	return true;
}

