////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage Door Info
//
// K7StageDoorInfo.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 01/27/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGEDOORINFO_H__
#define	__K7STAGEDOORINFO_H__

//	WK7STGDRINF_DEF  (mid,pfx,se)
//	WK7STGDRINF      (mid,pfx,tomid,topfx,se)
//	WK7STGDRINF_BP   (mid,pfx,bp,tomid,topfx,se)
//	WK7STGDRINF_BP2BP(mid,pfx,bp,tomid,topfx,tobp,se)

#ifdef	__K7SCN01_CPP__
	//////////////////////////////////////////////////////////////////
	// tNV}
	WK7STGDRINF2     (100, 0,190, 1,SFX_SCE1_MAP_CHANGE_GENKAN_OPEN,SFX_SCE1_MAP_CHANGE_GENKAN_CLOSE)
	WK7STGDRINF2     (190, 1,100, 0,SFX_SCE1_MAP_CHANGE_GENKAN_OPEN,SFX_SCE1_MAP_CHANGE_GENKAN_CLOSE)
	
	WK7STGDRINF2     (100, 0,101, 0,SFX_SCE1_MAP_CHANGE_GENKAN_OPEN,SFX_SCE1_MAP_CHANGE_GENKAN_CLOSE)
	WK7STGDRINF2     (101, 0,100, 0,SFX_SCE1_MAP_CHANGE_GENKAN_OPEN,SFX_SCE1_MAP_CHANGE_GENKAN_CLOSE)
	
	WK7STGDRINF2     (101, 0,103, 0,SFX_SCE1_MAP_CHANGE_NOREN_OPEN,SFX_SCE1_MAP_CHANGE_NOREN_CLOSE)
	WK7STGDRINF2     (103, 0,101, 0,SFX_SCE1_MAP_CHANGE_NOREN_OPEN,SFX_SCE1_MAP_CHANGE_NOREN_CLOSE)
	
	WK7STGDRINF2     (100, 0,105, 0,SFX_SCE1_MAP_CHANGE_NOREN_OPEN,SFX_SCE1_MAP_CHANGE_NOREN_CLOSE)
	WK7STGDRINF2     (105, 0,100, 0,SFX_SCE1_MAP_CHANGE_NOREN_OPEN,SFX_SCE1_MAP_CHANGE_NOREN_CLOSE)
	
	WK7STGDRINF2     (105, 0,105, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	
	WK7STGDRINF2     (115, 0,115, 1, SFX_SCE1_MAP_CHANGE_KIDAI_OPEN, SFX_SCE1_MAP_CHANGE_KIDAI_CLOSE )
	WK7STGDRINF2     (115, 1,115, 0, SFX_SCE1_MAP_CHANGE_KIDAI_OPEN, SFX_SCE1_MAP_CHANGE_KIDAI_CLOSE )
	
	WK7STGDRINF2     (115, 1,182, 0, SFX_SCE1_FUSUMA_SLOW, NOISE_SE_NONE )
	WK7STGDRINF2     (182, 0,115, 1, SFX_SCE1_FUSUMA_SLOW, NOISE_SE_NONE )
	
	WK7STGDRINF2     (116, 0,116, 0, SFX_SCE1_FUSUMA_SLOW,NOISE_SE_NONE)
	WK7STGDRINF2     (116, 0,182, 0, SFX_SCE1_FUSUMA_SLOW,NOISE_SE_NONE)
	WK7STGDRINF2     (182, 0,116, 0, SFX_SCE1_FUSUMA_SLOW,NOISE_SE_NONE)
	
	//ҍ`
	WK7STGDRINF2     (105, 0,101, 1, SFX_SYS_SAND_NOISE, NOISE_SE_NONE)
	WK7STGDRINF2     (101, 1,105, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE)
	//`X[W[
	WK7STGDRINF2     (101, 1,101, 1, SFX_SYS_SAND_NOISE, NOISE_SE_NONE)
	//m̊ԁ`ʎ
	WK7STGDRINF2     (102, 0,107, 0, SFX_SCE1_MAP_CHANGE_KIDAI_OPEN, SFX_SCE1_MAP_CHANGE_KIDAI_CLOSE)
	WK7STGDRINF2     (107, 0,102, 0, SFX_SCE1_MAP_CHANGE_KIDAI_OPEN, SFX_SCE1_MAP_CHANGE_KIDAI_CLOSE)
	//ʎ`L
	WK7STGDRINF2     (107, 0,181, 0, SFX_SCE1_MAP_CHANGE_KIDAI_OPEN, SFX_SCE1_MAP_CHANGE_KIDAI_CLOSE)
	WK7STGDRINF2     (181, 0,107, 0, SFX_SCE1_MAP_CHANGE_KIDAI_OPEN, SFX_SCE1_MAP_CHANGE_KIDAI_CLOSE)
	//L`
	WK7STGDRINF2     (181, 0,112, 0, SFX_SCE1_MAP_CHANGE_GENKAN_OPEN, SFX_SCE1_MAP_CHANGE_GENKAN_CLOSE)
	WK7STGDRINF2     (112, 0,181, 0, SFX_SCE1_MAP_CHANGE_GENKAN_OPEN, SFX_SCE1_MAP_CHANGE_GENKAN_CLOSE)
	//`I[i[OLiLnj
	WK7STGDRINF2     (112, 0,116, 0, SFX_SCE1_MAP_CHANGE_KIDAI_OPEN,   SFX_SCE1_MAP_CHANGE_KOUSIDO_CLOSE)
	WK7STGDRINF2     (116, 0,112, 0, SFX_SCE1_MAP_CHANGE_KOUSIDO_OPEN, SFX_SCE1_MAP_CHANGE_KIDAI_CLOSE  )
	
	//n[}
	WK7STGDRINF2     (190, 1,121, 0, SFX_SCE1_MAP_CHANGE_KISHOU_OPEN,  SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     (121, 0,190, 1, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE1_MAP_CHANGE_KISHOU_CLOSE  )
	
	WK7STGDRINF2     (103, 0,121, 0, SFX_SCE1_MAP_CHANGE_FUKU_HAC_OPEN,SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     (121, 0,103, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE1_MAP_CHANGE_FUKU_HAC_CLOSE)
	
	WK7STGDRINF2     (119, 0,121, 0, SFX_SCE1_MAP_CHANGE_KOUSIDO_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     (121, 0,119, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE1_MAP_CHANGE_KOUSIDO_CLOSE )
	
	WK7STGDRINF2     (107, 0,121, 0, SFX_SCE1_MAP_CHANGE_KOUSIDO_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     (121, 0,107, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE1_MAP_CHANGE_KOUSIDO_CLOSE )
	
	WK7STGDRINF2     (112, 0,121, 0, SFX_SCE1_MAP_CHANGE_SAKU_OPEN   , SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     (121, 0,112, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE1_MAP_CHANGE_SAKU_CLOSE    )
	
	WK7STGDRINF2     (115, 1,121, 0, SFX_SCE1_MAP_CHANGE_KIDAI_OPEN,   SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     (121, 0,115, 1, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE1_MAP_CHANGE_KIDAI_CLOSE   )
	
	WK7STGDRINF2     (181, 0,121, 0, SFX_SCE1_MAP_CHANGE_KIDAI_OPEN,   SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     (121, 0,181, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE1_MAP_CHANGE_KIDAI_CLOSE   )
	
	WK7STGDRINF2     (190, 0,190, 1, SFX_SCE1_MAP_CHANGE_SAKU_OPEN, SFX_SCE1_MAP_CHANGE_SAKU_CLOSE )
	WK7STGDRINF2     (190, 1,190, 0, SFX_SCE1_MAP_CHANGE_SAKU_OPEN, SFX_SCE1_MAP_CHANGE_SAKU_CLOSE )
	
	//KVA@o
	WK7STGDRINF2     (120, 0,190, 0, SFX_SYS_SAND_NOISE, SFX_SCE1_MAP_CHANGE_GENKAN_CLOSE )
	
	//Xe[W`ԁij
	WK7STGDRINF2     (112, 0,578, 0, SFX_SCE1_MAP_CHANGE_KIDAI_OPEN,   SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE )
	WK7STGDRINF2     (578, 0,112, 0, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN, SFX_SCE1_MAP_CHANGE_KIDAI_CLOSE   )
	//h[`Ln
	WK7STGDRINF2     (118, 0,573, 0, SFX_SYS_MAP_CHANGE_SENKANDOME, SFX_SYS_MAP_CHANGE_SENKANDOME )
	WK7STGDRINF2     (573, 0,118, 0, SFX_SYS_MAP_CHANGE_SENKANDOME, SFX_SYS_MAP_CHANGE_SENKANDOME )
	//Ln`
	WK7STGDRINF2     (118, 0,578, 0, SFX_SCE1_MAP_CHANGE_KOUSIDO_OPEN, SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE )
	WK7STGDRINF2     (578, 0,118, 0, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN, SFX_SCE1_MAP_CHANGE_KOUSIDO_CLOSE )
	//ԁ`Xe[Wioj
	WK7STGDRINF2     (116, 0,578, 0, SFX_SCE1_MAP_CHANGE_GENKAN_OPEN,  SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE )
	WK7STGDRINF2     (578, 0,116, 0, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN, SFX_SCE1_MAP_CHANGE_GENKAN_CLOSE  )
	
	//////////////////////////////////////////////////////////////////
	// pr
	WK7STGDRINF2     (133, 0,133, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	
	WK7STGDRINF2     (137, 0,131, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (131, 0,137, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	
	//n[}
	WK7STGDRINF2     (137, 0,121, 0, SFX_SCE1_MAP_CHANGE_KAKU_DOOR_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE   )
	WK7STGDRINF2     (121, 0,137, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN  , SFX_SCE1_MAP_CHANGE_KAKU_DOOR_CLOSE )
	
	WK7STGDRINF2     (131, 0,121, 0, SFX_SYS_MAP_CHANGE_HACROOM_DEFIN,   SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE   )
	WK7STGDRINF2     (121, 0,131, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,   SFX_SYS_MAP_CHANGE_HACROOM_DEFOUT   )
	
	WK7STGDRINF2     (132, 0,121, 0, SFX_SYS_MAP_CHANGE_HACROOM_DEFIN,   SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE   )
	WK7STGDRINF2     (121, 0,132, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,   SFX_SYS_MAP_CHANGE_HACROOM_DEFOUT   )
	
	WK7STGDRINF2     (133, 0,121, 0, SFX_SYS_MAP_CHANGE_HACROOM_DEFIN,   SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE   )
	WK7STGDRINF2     (121, 0,133, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,   SFX_SYS_MAP_CHANGE_HACROOM_DEFOUT   )
	
	WK7STGDRINF2     (134, 0,121, 0, SFX_SCE1_MAP_CHANGE_KAKU_DOOR_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE   )
	WK7STGDRINF2     (121, 0,134, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN  , SFX_SCE1_MAP_CHANGE_KAKU_DOOR_CLOSE )
	
	WK7STGDRINF2     (134, 1,121, 0, SFX_SCE1_MAP_CHANGE_KAKU_DOOR_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE   )
	WK7STGDRINF2     (121, 0,134, 1, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN  , SFX_SCE1_MAP_CHANGE_KAKU_DOOR_CLOSE )
	
	WK7STGDRINF2     (135, 0,121, 0, SFX_SCE1_MAP_CHANGE_KAKU_DOOR_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE   )
	WK7STGDRINF2     (121, 0,135, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN  , SFX_SCE1_MAP_CHANGE_KAKU_DOOR_CLOSE )
	
	//4F`niGx[^ړmCYj
	WK7STGDRINF2     (134, 1,136, 0,  SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (136, 0,134, 1,  SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	
	//KVA@o
	WK7STGDRINF2     (120, 0,137, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	
	//Xe[W`ԁij
	WK7STGDRINF2     (134, 0,578, 0, SFX_SCE1_MAP_CHANGE_KAKU_DOOR_OPEN, SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE   )
	WK7STGDRINF2     (578, 0,134, 0, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN,   SFX_SCE1_MAP_CHANGE_KAKU_DOOR_CLOSE )
	//h[`Ln
	WK7STGDRINF2     (138, 0,573, 0, SFX_SYS_MAP_CHANGE_SENKANDOME,      SFX_SYS_MAP_CHANGE_SENKANDOME       )
	WK7STGDRINF2     (573, 0,138, 0, SFX_SYS_MAP_CHANGE_SENKANDOME,      SFX_SYS_MAP_CHANGE_SENKANDOME       )
	//Ln`
	WK7STGDRINF2     (138, 0,578, 0, SFX_SCE1_MAP_CHANGE_KAKU_DOOR_OPEN, SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE   )
	WK7STGDRINF2     (578, 0,138, 0, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN,   SFX_SCE1_MAP_CHANGE_KAKU_DOOR_CLOSE )
	//ԁ`Xe[Wioj
	WK7STGDRINF2     (134, 1,578, 0, SFX_SCE1_MAP_CHANGE_KAKU_DOOR_OPEN, SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE   )
	WK7STGDRINF2     (578, 0,134, 1, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN,   SFX_SCE1_MAP_CHANGE_KAKU_DOOR_CLOSE )
	
#endif

#ifdef	__K7SCN02_CPP__
	//////////////////////////////////////////////////////////////////
	// eLTX
	WK7STGDRINF2     	 (200, 0,201, 0, SFX_SCE2_MAP_CHANGE_MAINGATE_OPENCLOSE, NOISE_SE_NONE )
	WK7STGDRINF2     	 (201, 0,200, 0, SFX_SCE2_MAP_CHANGE_MAINGATE_OPENCLOSE, NOISE_SE_NONE )
	WK7STGDRINF2     	 (201, 0,201, 1, SFX_SCE2_MAP_CHANGE_SAKU_OPENCLOSE, NOISE_SE_NONE )
	WK7STGDRINF2     	 (201, 1,201, 0, SFX_SCE2_MAP_CHANGE_SAKU_OPENCLOSE, NOISE_SE_NONE )
	WK7STGDRINF2     	 (201, 1,209, 0, SFX_SCE2_MAP_CHANGE_CHUOU_OPENCLOSE, NOISE_SE_NONE )
	WK7STGDRINF2     	 (209, 0,201, 1, SFX_SCE2_MAP_CHANGE_CHUOU_OPENCLOSE, NOISE_SE_NONE )
	WK7STGDRINF2     	 (202, 0,209, 0, SFX_SCE2_MAP_CHANGE_DINER_OPEN, SFX_SCE2_MAP_CHANGE_DINER_CLOSE )
	WK7STGDRINF2     	 (209, 0,202, 0, SFX_SCE2_MAP_CHANGE_DINER_OPEN, SFX_SCE2_MAP_CHANGE_DINER_CLOSE )
	WK7STGDRINF2     	 (213, 0,208, 0, SFX_SCE2_MAP_CHANGE_FUSAIRON_OPEN, SFX_SCE2_MAP_CHANGE_FUSAIRON_CLOSE )
	WK7STGDRINF2     	 (208, 0,213, 0, SFX_SCE2_MAP_CHANGE_FUSAIRON_OPEN, SFX_SCE2_MAP_CHANGE_FUSAIRON_CLOSE )
	WK7STGDRINF2     	 (208, 0,210, 0, SFX_SCE2_MAP_CHANGE_WINDOW_OPEN, SFX_SYS_SAND_NOISE )
	WK7STGDRINF2     	 (208, 0,211, 0, SFX_SCE2_MAP_CHANGE_WINDOW_OPEN, SFX_SYS_SAND_NOISE )
	WK7STGDRINF2     	 (208, 0,212, 0, SFX_SCE2_MAP_CHANGE_WINDOW_OPEN, SFX_SYS_SAND_NOISE )
	WK7STGDRINF2     	 (210, 0,208, 0, SFX_SYS_SAND_NOISE, SFX_SCE2_MAP_CHANGE_WINDOW_CLOSE )
	WK7STGDRINF2     	 (211, 0,208, 0, SFX_SYS_SAND_NOISE, SFX_SCE2_MAP_CHANGE_WINDOW_CLOSE )
	WK7STGDRINF2     	 (212, 0,208, 0, SFX_SYS_SAND_NOISE, SFX_SCE2_MAP_CHANGE_WINDOW_CLOSE )
	WK7STGDRINF2     	 (209, 0,209, 1, SFX_SCE2_MAP_CHANGE_TRAIN_OPEN, SFX_SCE2_MAP_CHANGE_TRAIN_CLOSE )
	WK7STGDRINF2     	 (209, 1,209, 0, SFX_SCE2_MAP_CHANGE_TRAIN_OPEN, SFX_SCE2_MAP_CHANGE_TRAIN_CLOSE )
	WK7STGDRINF2     	 (203, 0,203, 1, SFX_SCE2_MAP_CHANGE_TEXASFENCE_OPEN, SFX_SCE2_MAP_CHANGE_TEXASFENCE_CLOSE )
	WK7STGDRINF2     	 (203, 1,203, 0, SFX_SCE2_MAP_CHANGE_TEXASFENCE_OPEN, SFX_SCE2_MAP_CHANGE_TEXASFENCE_CLOSE )
	WK7STGDRINF2     	 (204, 0,203, 0, SFX_SCE2_MAP_CHANGE_AUTOGLASS_OPENCLOSE, NOISE_SE_NONE )
	WK7STGDRINF2     	 (203, 1,204, 0, SFX_SCE2_MAP_CHANGE_AUTOGLASS_OPENCLOSE, NOISE_SE_NONE )
	WK7STGDRINF2     	 (204, 0,203, 1, SFX_SCE2_MAP_CHANGE_AUTOGLASS_OPENCLOSE, NOISE_SE_NONE )
	WK7STGDRINF2     	 (205, 1,206, 0, SFX_SCE2_MAP_CHANGE_AMBULANCE, NOISE_SE_NONE )
	WK7STGDRINF2_BP		 (208, 0,"door_020803", 201, 1, SFX_SCE2_MAP_CHANGE_RESIDENTIALGATE_OPENCLOSE, NOISE_SE_NONE )
	WK7STGDRINF2_BP		 (201, 1,"door_020103", 208, 0, SFX_SCE2_MAP_CHANGE_RESIDENTIALGATE_OPENCLOSE, NOISE_SE_NONE )
	WK7STGDRINF2_BP2BP	 (201, 1,"door_020102", 208, 0, "door_020801", SFX_SCE2_MAP_CHANGE_FUSAWOOD_OPEN, SFX_SCE2_MAP_CHANGE_FUSAWOOD_CLOSE )
	WK7STGDRINF2_BP2BP	 (208, 0,"door_020801", 201, 1, "door_020102", SFX_SCE2_MAP_CHANGE_FUSAWOOD_OPEN, SFX_SCE2_MAP_CHANGE_FUSAWOOD_CLOSE )
	
	//ZZX
	WK7STGDRINF2     	 (208, 0,208, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//R`X֋ǑO
	WK7STGDRINF2		 (203, 0,209, 1, SFX_SCE2_MAP_CHANGE_FUSAWOOD_OPEN, SFX_SCE2_MAP_CHANGE_FUSAWOOD_CLOSE )
	WK7STGDRINF2		 (209, 1,203, 0, SFX_SCE2_MAP_CHANGE_FUSAWOOD_OPEN, SFX_SCE2_MAP_CHANGE_FUSAWOOD_CLOSE )
	//R`n[}
	WK7STGDRINF2     	 (203, 0,121, 0, SFX_SYS_MAP_CHANGE_HACROOM_DEFIN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     	 (121, 0,203, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SYS_MAP_CHANGE_HACROOM_DEFOUT )
	//1stCtցr
	WK7STGDRINF2     	 (204, 0,205, 0, SFX_SCE2_MAP_CHANGE_AUTOGLASS_OPENCLOSE, SFX_SYS_SAND_NOISE                      )
	WK7STGDRINF2     	 (205, 0,204, 0, SFX_SYS_SAND_NOISE,                      SFX_SCE2_MAP_CHANGE_AUTOGLASS_OPENCLOSE )
	
	//KVA@o
	WK7STGDRINF2         (120, 0,200, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	
	//n[}
	WK7STGDRINF2     	 (201, 0,121, 0, SFX_SCE2_MAP_CHANGE_DINER_OPEN,   SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     	 (121, 0,201, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE2_MAP_CHANGE_DINER_CLOSE   )
	WK7STGDRINF2     	 (208, 0,121, 0, SFX_SCE2_MAP_CHANGE_DINER_OPEN,   SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     	 (121, 0,208, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE2_MAP_CHANGE_DINER_CLOSE   )
	WK7STGDRINF2     	 (209, 1,121, 0, SFX_SCE2_MAP_CHANGE_DINER_OPEN,   SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )	
	WK7STGDRINF2     	 (121, 0,209, 1, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE2_MAP_CHANGE_DINER_CLOSE   )
	WK7STGDRINF2     	 (203, 0,121, 0, SFX_SCE2_MAP_CHANGE_DINER_OPEN,   SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     	 (121, 0,203, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE2_MAP_CHANGE_DINER_CLOSE   )
	WK7STGDRINF2     	 (209, 0,121, 0, SFX_SCE2_MAP_CHANGE_DINER_OPEN,   SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     	 (121, 0,209, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE2_MAP_CHANGE_DINER_CLOSE   )
	WK7STGDRINF2     	 (121, 0,204, 0, SFX_SCE2_MAP_CHANGE_AUTOGLASS_OPENCLOSE, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE       )
	WK7STGDRINF2     	 (204, 0,121, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,        SFX_SCE2_MAP_CHANGE_AUTOGLASS_OPENCLOSE )
	
#endif

#ifdef	__K7SCN03_CPP__
	//////////////////////////////////////////////////////////////////
	// VniCVUJhj
	WK7STGDRINF2     (329, 0,316, 0, SFX_SCE3_MAP_CHANGE_REVOLVER_DOOR_IN, SFX_SCE3_MAP_CHANGE_REVOLVER_DOOR_OUT )
	WK7STGDRINF2     (316, 0,329, 0, SFX_SCE3_MAP_CHANGE_REVOLVER_DOOR_IN, SFX_SCE3_MAP_CHANGE_REVOLVER_DOOR_OUT )
	
	WK7STGDRINF2     (326, 0,321, 0, SFX_SCE3_MAP_CHANGE_AUTODOOR_GLASS_OPEN, SFX_SCE3_MAP_CHANGE_AUTODOOR_GLASS_CLOSE )
	WK7STGDRINF2     (321, 0,326, 0, SFX_SCE3_MAP_CHANGE_AUTODOOR_GLASS_OPEN, SFX_SCE3_MAP_CHANGE_AUTODOOR_GLASS_CLOSE )
	
	WK7STGDRINF2     (325, 0,324, 0, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_CLOSE )
	WK7STGDRINF2     (324, 0,325, 0, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_CLOSE )
	
	WK7STGDRINF2     (325, 1,324, 0, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_CLOSE )
	WK7STGDRINF2     (324, 0,325, 1, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_CLOSE )
	
	WK7STGDRINF2     (325, 2,324, 0, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_CLOSE )
	WK7STGDRINF2     (324, 0,325, 2, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_CLOSE )
	
	WK7STGDRINF2     (325, 3,324, 0, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_CLOSE )
	WK7STGDRINF2     (324, 0,325, 3, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_CLOSE )
	
	WK7STGDRINF2     (306, 0,307, 0, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_CLOSE       )
	WK7STGDRINF2     (307, 0,306, 0, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_HEAVY_CLOSE )
	
	WK7STGDRINF2     (306, 0,327, 0, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_HEAVY_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_HEAVY_CLOSE )
	WK7STGDRINF2     (327, 0,306, 0, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_HEAVY_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_HEAVY_CLOSE )
	
	WK7STGDRINF2     (312, 0,327, 0, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_HEAVY_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_HEAVY_CLOSE )
	WK7STGDRINF2     (327, 0,312, 0, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_HEAVY_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_HEAVY_CLOSE )
	
	WK7STGDRINF2     (310, 0,327, 0, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_HEAVY_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_HEAVY_CLOSE )
	WK7STGDRINF2     (327, 0,310, 0, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_HEAVY_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_HEAVY_CLOSE )
	
	WK7STGDRINF2     (326, 0,327, 0, SFX_SCE3_MAP_CHANGE_AUTODOOR_GLASS_OPEN, SFX_SCE3_MAP_CHANGE_AUTODOOR_GLASS_CLOSE )
	WK7STGDRINF2     (327, 0,326, 0, SFX_SCE3_MAP_CHANGE_AUTODOOR_GLASS_OPEN, SFX_SCE3_MAP_CHANGE_AUTODOOR_GLASS_CLOSE )
	
	WK7STGDRINF2     (326, 0,324, 0, SFX_SCE3_MAP_CHANGE_AUTODOOR_GLASS_OPEN, SFX_SCE3_MAP_CHANGE_AUTODOOR_GLASS_CLOSE )
	WK7STGDRINF2     (324, 0,326, 0, SFX_SCE3_MAP_CHANGE_AUTODOOR_GLASS_OPEN, SFX_SCE3_MAP_CHANGE_AUTODOOR_GLASS_CLOSE )
	
	WK7STGDRINF2     (312, 0,312, 1, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_CLOSE )
	WK7STGDRINF2     (312, 1,312, 0, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_CLOSE )
	
	WK7STGDRINF2     (312, 1,312, 2, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_CLOSE )
	WK7STGDRINF2     (312, 2,312, 1, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_CLOSE )
	
	WK7STGDRINF2     (312, 2,312, 0, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_CLOSE )
	WK7STGDRINF2     (312, 0,312, 2, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_CLOSE )
	
	WK7STGDRINF2     (312, 2,313, 0, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_CLOSE )
	WK7STGDRINF2     (313, 0,312, 2, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_CLOSE )
	
	WK7STGDRINF2     (308, 0,309, 0, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_CLOSE )
	WK7STGDRINF2     (309, 0,308, 0, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_CLOSE )
	
	WK7STGDRINF2     (313, 0,313, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	
	//GgX`A[P[h
	WK7STGDRINF2     (300, 0,321, 0, SFX_SCE3_MAP_CHANGE_PARK_GATE, NOISE_SE_NONE )
	WK7STGDRINF2     (321, 0,300, 0, SFX_SCE3_MAP_CHANGE_PARK_GATE, NOISE_SE_NONE )
	//L[ebh}VŒ\t@ō~
	WK7STGDRINF2     (313, 0, 327, 0, SFX_SYS_SAND_NOISE,                       SFX_SCE3_MAP_CHANGE_DOOR_WOOD_HEAVY_CLOSE )
	WK7STGDRINF2     (327, 0, 313, 0, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_HEAVY_OPEN, SFX_SYS_SAND_NOISE                        )
	//qoqo(L[ebh}VNAďoĂɍL֖߂)
	WK7STGDRINF2     (327, 0,327, 0,  SFX_SCE3_MAP_CHANGE_AUTODOOR_GLASS_OPEN, SFX_SCE3_MAP_CHANGE_AUTODOOR_GLASS_CLOSE )
	//Loop the Loop`Squeakers Attack
	WK7STGDRINF2     (307, 0,308, 0, SFX_SYS_MAP_CHANGE_HACROOM_DEFIN, SFX_SYS_MAP_CHANGE_HACROOM_DEFOUT )
	WK7STGDRINF2     (308, 0,307, 0, SFX_SYS_MAP_CHANGE_HACROOM_DEFIN, SFX_SYS_MAP_CHANGE_HACROOM_DEFOUT )
	//qo`r[(LnNA)
	WK7STGDRINF2     (329, 0,327, 0, SFX_SCE3_MAP_CHANGE_DOOR_GLASS_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_GLASS_CLOSE )
	WK7STGDRINF2     (327, 0,329, 0, SFX_SCE3_MAP_CHANGE_DOOR_GLASS_OPEN, SFX_SCE3_MAP_CHANGE_DOOR_GLASS_CLOSE )
	
	//n[}
	WK7STGDRINF2     (300, 0,121, 0, SFX_SCE3_MAP_CHANGE_ISZKENTRANCEHAC,      SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE         )
	WK7STGDRINF2     (121, 0,300, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,         SFX_SCE3_MAP_CHANGE_ISZKENTRANCEHAC       )
	
	WK7STGDRINF2     (326, 0,121, 0, SFX_SCE3_MAP_CHANGE_DOOR_IRON_LIGHT_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE         )
	WK7STGDRINF2     (121, 0,326, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,         SFX_SCE3_MAP_CHANGE_DOOR_IRON_LIGHT_CLOSE )
	
	WK7STGDRINF2     (325, 2,121, 0, SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE         )
	WK7STGDRINF2     (121, 0,325, 2, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,         SFX_SCE3_MAP_CHANGE_DOOR_IRON_HEAVY_CLOSE )
	
	WK7STGDRINF2     (327, 0,121, 0, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_OPEN,       SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE         )
	WK7STGDRINF2     (121, 0,327, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,         SFX_SCE3_MAP_CHANGE_DOOR_WOOD_HEAVY_CLOSE )
	
	WK7STGDRINF2     (329, 0,121, 0, SFX_SCE3_MAP_CHANGE_DOOR_IRON_LIGHT_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE         )
	WK7STGDRINF2     (121, 0,329, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,         SFX_SCE3_MAP_CHANGE_DOOR_IRON_LIGHT_CLOSE )
	
	//KVA@o
	WK7STGDRINF2     (120, 0,300, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	
	//Xe[W`ԁij
	WK7STGDRINF2     (327, 0,578, 0, SFX_SCE3_MAP_CHANGE_DOOR_GLASS_OPEN,      SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE         )
	WK7STGDRINF2     (578, 0,327, 0, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN,         SFX_SCE3_MAP_CHANGE_DOOR_GLASS_CLOSE      )
	//h[`Ln
	WK7STGDRINF2     (328, 0,573, 0, SFX_SYS_MAP_CHANGE_SENKANDOME,            SFX_SYS_MAP_CHANGE_SENKANDOME             )
	WK7STGDRINF2     (573, 0,328, 0, SFX_SYS_MAP_CHANGE_SENKANDOME,            SFX_SYS_MAP_CHANGE_SENKANDOME             )
	//Ln`
	WK7STGDRINF2     (328, 0,578, 0, SFX_SCE3_MAP_CHANGE_DOOR_WOOD_HEAVY_OPEN, SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE         )
	WK7STGDRINF2     (578, 0,328, 0, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN,         SFX_SCE3_MAP_CHANGE_DOOR_WOOD_HEAVY_CLOSE )
	//ԁ`Xe[Wioj
	WK7STGDRINF2     (329, 0,578, 0, SFX_SCE3_MAP_CHANGE_DOOR_GLASS_OPEN,     SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE          )
	WK7STGDRINF2     (578, 0,329, 0, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN,        SFX_SCE3_MAP_CHANGE_DOOR_GLASS_CLOSE       )
	
	
	//////////////////////////////////////////////////////////////////
	// J[eBX@
	WK7STGDRINF2     (354, 0,355, 0, SFX_SCE3_MAP_CHANGE_CUR_DOOR_GLASS_HIKI_OPEN, SFX_SCE3_MAP_CHANGE_CUR_DOOR_GLASS_HIKI_CLOSE )
	WK7STGDRINF2     (355, 0,354, 0, SFX_SCE3_MAP_CHANGE_CUR_DOOR_GLASS_HIKI_OPEN, SFX_SCE3_MAP_CHANGE_CUR_DOOR_GLASS_HIKI_CLOSE )
	
	WK7STGDRINF2     (352, 0,353, 0, SFX_SCE3_MAP_CHANGE_CURTISPULLBIG_OPEN, SFX_SCE3_MAP_CHANGE_CURTISPULLBIG_CLOSE )
	WK7STGDRINF2     (353, 0,352, 0, SFX_SCE3_MAP_CHANGE_CURTISPULLBIG_OPEN, SFX_SCE3_MAP_CHANGE_CURTISPULLBIG_CLOSE )
	
	WK7STGDRINF2     (356, 0,361, 0, SFX_SCE3_MAP_CHANGE_CURTISHIROMA_OPEN, SFX_SCE3_MAP_CHANGE_CURTISHIROMA_CLOSE )
	WK7STGDRINF2     (361, 0,356, 0, SFX_SCE3_MAP_CHANGE_CURTISHIROMA_OPEN, SFX_SCE3_MAP_CHANGE_CURTISHIROMA_CLOSE )
	
	WK7STGDRINF2     (352, 0,362, 1, SFX_SCE3_MAP_CHANGE_CURTISPULLBIG_OPEN, SFX_SCE3_MAP_CHANGE_CURTISPULLBIG_CLOSE )
	WK7STGDRINF2     (362, 1,352, 0, SFX_SCE3_MAP_CHANGE_CURTISPULLBIG_OPEN, SFX_SCE3_MAP_CHANGE_CURTISPULLBIG_CLOSE )
	
	WK7STGDRINF2     (354, 0,354, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	
	//S`J[eBX@
	WK7STGDRINF2     (350, 0,351, 0, SFX_SCE3_MAP_CHANGE_CUR_GATE, NOISE_SE_NONE )
	WK7STGDRINF2     (351, 0,350, 0, SFX_SCE3_MAP_CHANGE_CUR_GATE, NOISE_SE_NONE )
	//J[eBX@`
	WK7STGDRINF2     (351, 0,352, 0, SFX_SCE3_MAP_CHANGE_CUR_GATE, NOISE_SE_NONE )
	WK7STGDRINF2     (352, 0,351, 0, SFX_SCE3_MAP_CHANGE_CUR_GATE, NOISE_SE_NONE )
	//`{
	WK7STGDRINF2     (352, 0,354, 0, SFX_SCE3_MAP_CHANGE_CUR_DOOR_GLASS_HIKI_OPEN, SFX_SCE3_MAP_CHANGE_CUR_DOOR_GLASS_HIKI_CLOSE )
	WK7STGDRINF2     (354, 0,352, 0, SFX_SCE3_MAP_CHANGE_CUR_DOOR_GLASS_HIKI_OPEN, SFX_SCE3_MAP_CHANGE_CUR_DOOR_GLASS_HIKI_CLOSE )
	//ʘH`邢v[
	WK7STGDRINF2     (355, 0,362, 0, SFX_SCE3_MAP_CHANGE_CURTISPULLBIG_OPEN, SFX_SCE3_MAP_CHANGE_CURTISPULLBIG_CLOSE )
	WK7STGDRINF2     (362, 0,355, 0, SFX_SCE3_MAP_CHANGE_CURTISPULLBIG_OPEN, SFX_SCE3_MAP_CHANGE_CURTISPULLBIG_CLOSE )
	//ʘH`Âv[
	WK7STGDRINF2     (355, 0,362, 1, SFX_SCE3_MAP_CHANGE_CURTISPULLBIG_OPEN, SFX_SCE3_MAP_CHANGE_CURTISPULLBIG_CLOSE )
	WK7STGDRINF2     (362, 1,355, 0, SFX_SCE3_MAP_CHANGE_CURTISPULLBIG_OPEN, SFX_SCE3_MAP_CHANGE_CURTISPULLBIG_CLOSE )
	//ʘH`ʑ
	WK7STGDRINF2     (355, 0,356, 0, SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_OPEN, SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_CLOSE )
	WK7STGDRINF2     (356, 0,355, 0, SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_OPEN, SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_CLOSE )
	//ʑxbh[{i_XgV[gō~j
	WK7STGDRINF2     (358, 0,354, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//Âv[`{iV[gJbgj
	WK7STGDRINF2     (362, 1,354, 0, SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_OPEN, SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_CLOSE )
	WK7STGDRINF2     (354, 0,362, 1, SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_OPEN, SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_CLOSE )
	//邢v[`{iV[gJbgj
	WK7STGDRINF2     (362, 0,354, 0, SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_OPEN, SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_CLOSE )
	WK7STGDRINF2     (354, 0,362, 0, SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_OPEN, SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_CLOSE )
	//邢v[`iV[gJbgj
	WK7STGDRINF2     (352, 0,362, 0, SFX_SCE3_MAP_CHANGE_CUR_DOOR_WOOD_OPEN, SFX_SCE3_MAP_CHANGE_CUR_DOOR_WOOD_CLOSE )
	WK7STGDRINF2     (362, 0,352, 0, SFX_SCE3_MAP_CHANGE_CUR_DOOR_WOOD_OPEN, SFX_SCE3_MAP_CHANGE_CUR_DOOR_WOOD_CLOSE )
	//BʘH`邢v[(LnNA)
	WK7STGDRINF2     (364, 0,362, 0, SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_OPEN, SFX_SCE3_MAP_CHANGE_CURTISPOOL_CLOSE     )
	WK7STGDRINF2     (362, 0,364, 0, SFX_SCE3_MAP_CHANGE_CURTISPOOL_OPEN,     SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_CLOSE )
	//BʘH`(J[eBX) _ŔJ
	WK7STGDRINF2     (364, 0,363, 0, SFX_SCE3_MAP_CHANGE_CURTISHIDDEN2_OPEN, NOISE_SE_NONE )
	
	//KVA@`S
	WK7STGDRINF2     (120, 0,350, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	
	//n[}
	WK7STGDRINF2     (351, 0,121, 0, SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE        )
	WK7STGDRINF2     (121, 0,351, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,        SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_CLOSE )
	
	WK7STGDRINF2     (354, 0,121, 0, SFX_SCE3_MAP_CHANGE_CURTISWOODPULL_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE        )
	WK7STGDRINF2     (121, 0,354, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,        SFX_SCE3_MAP_CHANGE_CURTISWOODPULL_CLOSE )
	
	WK7STGDRINF2     (356, 0,121, 0, SFX_SCE3_MAP_CHANGE_CUR_DOOR_GLASS_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE        )
	WK7STGDRINF2     (121, 0,356, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,        SFX_SCE3_MAP_CHANGE_CUR_DOOR_GLASS_CLOSE )
	
	WK7STGDRINF2     (362, 0,121, 0, SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE        )
	WK7STGDRINF2     (121, 0,362, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,        SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_CLOSE )
	
	WK7STGDRINF2     (364, 0,121, 0, SFX_SCE3_MAP_CHANGE_CURTISHIDDEN_OPEN,   SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE        )
	WK7STGDRINF2     (121, 0,364, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,        SFX_SCE3_MAP_CHANGE_CURTISHIDDEN_CLOSE   )
	
	//Xe[W`ԁij
	WK7STGDRINF2     (362, 0,578, 0, SFX_SCE3_MAP_CHANGE_CURTISPOOL_OPEN,     SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE        )
	WK7STGDRINF2     (578, 0,362, 0, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN,        SFX_SCE3_MAP_CHANGE_CURTISPOOL_CLOSE     )
	//h[`Ln
	WK7STGDRINF2     (365, 0,573, 0, SFX_SYS_MAP_CHANGE_SENKANDOME,           SFX_SYS_MAP_CHANGE_SENKANDOME            )
	WK7STGDRINF2     (573, 0,365, 0, SFX_SYS_MAP_CHANGE_SENKANDOME,           SFX_SYS_MAP_CHANGE_SENKANDOME            )
	//Ln`
	WK7STGDRINF2     (365, 0,578, 0, SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_OPEN, SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE        )
	WK7STGDRINF2     (578, 0,365, 0, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN,        SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_CLOSE )
	//ԁ`Xe[Wioj
	WK7STGDRINF2     (364, 0,578, 0, SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_OPEN, SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE        )
	WK7STGDRINF2     (578, 0,364, 0, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN,        SFX_SCE3_MAP_CHANGE_CURTISPULLMINI_CLOSE )
	
	
#endif

#ifdef	__K7SCN04_CPP__
	//////////////////////////////////////////////////////////////////
	// h~jJ
	WK7STGDRINF2     (410, 0,411, 0, SFX_SCE4_MAP_CHANGE_WDOOR_IRON_OPEN, SFX_SCE4_MAP_CHANGE_WDOOR_IRON_CLOSE )
	WK7STGDRINF2     (411, 0,410, 0, SFX_SCE4_MAP_CHANGE_WDOOR_IRON_OPEN, SFX_SCE4_MAP_CHANGE_WDOOR_IRON_CLOSE )
	
	WK7STGDRINF2     (441, 0,441, 1, SFX_SCE4_MAP_CHANGE_DOOR_WOOD_OPEN, SFX_SCE4_MAP_CHANGE_DOOR_WOOD_CLOSE )
	WK7STGDRINF2     (441, 1,441, 0, SFX_SCE4_MAP_CHANGE_DOOR_WOOD_OPEN, SFX_SCE4_MAP_CHANGE_DOOR_WOOD_CLOSE )
	
	WK7STGDRINF2     (444, 0,413, 0, SFX_SCE4_MAP_CHANGE_DOOR_WARP_OPEN, SFX_SCE4_MAP_CHANGE_DOOR_WARP_CLOSE )
	WK7STGDRINF2     (413, 0,444, 0, SFX_SCE4_MAP_CHANGE_DOOR_WARP_OPEN, SFX_SCE4_MAP_CHANGE_DOOR_WARP_CLOSE )
	
	WK7STGDRINF2     (444, 0,420, 1, SFX_SCE4_MAP_CHANGE_DOOR_WARP_OPEN, SFX_SCE4_MAP_CHANGE_DOOR_WARP_CLOSE )
	WK7STGDRINF2     (420, 1,444, 0, SFX_SCE4_MAP_CHANGE_DOOR_WARP_OPEN, SFX_SCE4_MAP_CHANGE_DOOR_WARP_CLOSE )
	
	WK7STGDRINF2     (444, 0,441, 0, SFX_SCE4_MAP_CHANGE_DOOR_WARP_OPEN, SFX_SCE4_MAP_CHANGE_DOOR_WARP_CLOSE )
	WK7STGDRINF2     (441, 0,444, 0, SFX_SCE4_MAP_CHANGE_DOOR_WARP_OPEN, SFX_SCE4_MAP_CHANGE_DOOR_WARP_CLOSE )
	
	WK7STGDRINF2     (444, 0,445, 0, SFX_SCE4_MAP_CHANGE_TREVOR_OPEN, SFX_SCE4_MAP_CHANGE_TREVOR_CLOSE )
	WK7STGDRINF2     (445, 0,444, 0, SFX_SCE4_MAP_CHANGE_TREVOR_OPEN, SFX_SCE4_MAP_CHANGE_TREVOR_CLOSE )
	
	WK7STGDRINF2     (411, 0,121, 0, SFX_SCE4_MAP_CHANGE_DOOR_WOOD_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE   )
	WK7STGDRINF2     (121, 0,411, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,   SFX_SCE4_MAP_CHANGE_DOOR_WOOD_CLOSE )
	WK7STGDRINF2     (413, 0,121, 0, SFX_SCE4_MAP_CHANGE_DOOR_WOOD_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE   )
	WK7STGDRINF2     (121, 0,413, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,   SFX_SCE4_MAP_CHANGE_DOOR_WOOD_CLOSE )
	WK7STGDRINF2     (420, 0,121, 0, SFX_SCE4_MAP_CHANGE_WDOOR_WOOD_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE    )
	WK7STGDRINF2     (121, 0,420, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,    SFX_SCE4_MAP_CHANGE_WDOOR_WOOD_CLOSE )
	WK7STGDRINF2     (423, 0,121, 0, SFX_SCE4_MAP_CHANGE_WDOOR_WOOD_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE    )
	WK7STGDRINF2     (121, 0,423, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,    SFX_SCE4_MAP_CHANGE_WDOOR_WOOD_CLOSE )
	WK7STGDRINF2     (441, 0,121, 0, SFX_SCE4_MAP_CHANGE_DOOR_WOOD_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE   )
	WK7STGDRINF2     (121, 0,441, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,   SFX_SCE4_MAP_CHANGE_DOOR_WOOD_CLOSE )
	WK7STGDRINF2     (444, 0,121, 0, SFX_SCE4_MAP_CHANGE_DOOR_WOOD_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE   )
	WK7STGDRINF2     (121, 0,444, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,   SFX_SCE4_MAP_CHANGE_DOOR_WOOD_CLOSE )
	WK7STGDRINF2     (442, 0,121, 0, SFX_SCE4_MAP_CHANGE_DOOR_WOOD_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE   )
	WK7STGDRINF2     (121, 0,442, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,   SFX_SCE4_MAP_CHANGE_DOOR_WOOD_CLOSE )
	
	WK7STGDRINF2     (415, 0,415, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	
	//KVA@o
	WK7STGDRINF2     (120, 0,410, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	
	//////////////////////////////////////////////////////////////////
	// j[[N
	//KVA@o
	WK7STGDRINF2     (120, 0,430, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	
#endif

#ifdef	__K7SCN05_CPP__
	//////////////////////////////////////////////////////////////////
	// ze
	WK7STGDRINF2     (517, 0,519, 0, SFX_SCE5_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SCE5_MAP_CHANGE_DOOR_IRON_CLOSE )
	WK7STGDRINF2     (519, 0,517, 0, SFX_SCE5_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SCE5_MAP_CHANGE_DOOR_IRON_CLOSE )
	
	WK7STGDRINF2     (511, 0,121, 0, SFX_SCE5_MAP_CHANGE_DOOR_IRON_OPEN  , SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE     )
	WK7STGDRINF2     (121, 0,511, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN    , SFX_SCE5_MAP_CHANGE_DOOR_IRON_CLOSE   )
	WK7STGDRINF2     (512, 0,121, 0, SFX_SCE5_MAP_CHANGE_DOOR_COMMON_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE     )
	WK7STGDRINF2     (121, 0,512, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN    , SFX_SCE5_MAP_CHANGE_DOOR_COMMON_CLOSE )
	WK7STGDRINF2     (513, 0,121, 0, SFX_SCE5_MAP_CHANGE_DOOR_COMMON_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE     )
	WK7STGDRINF2     (121, 0,513, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN    , SFX_SCE5_MAP_CHANGE_DOOR_COMMON_CLOSE )
	WK7STGDRINF2     (514, 0,121, 0, SFX_SCE5_MAP_CHANGE_DOOR_COMMON_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE     )
	WK7STGDRINF2     (121, 0,514, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN    , SFX_SCE5_MAP_CHANGE_DOOR_COMMON_CLOSE )
	WK7STGDRINF2     (515, 0,121, 0, SFX_SCE5_MAP_CHANGE_DOOR_COMMON_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE     )
	WK7STGDRINF2     (121, 0,515, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN    , SFX_SCE5_MAP_CHANGE_DOOR_COMMON_CLOSE )
	WK7STGDRINF2     (516, 0,121, 0, SFX_SCE5_MAP_CHANGE_DOOR_COMMON_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE     )
	WK7STGDRINF2     (121, 0,516, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN    , SFX_SCE5_MAP_CHANGE_DOOR_COMMON_CLOSE )
	WK7STGDRINF2     (517, 0,121, 0, SFX_SCE5_MAP_CHANGE_DOOR_COMMON_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE     )
	WK7STGDRINF2     (121, 0,517, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN    , SFX_SCE5_MAP_CHANGE_DOOR_COMMON_CLOSE )
	
	//1F`2F ELVړimCYj
	WK7STGDRINF2     (511, 0,512, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (512, 0,511, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//1F`3F ELVړimCYj
	WK7STGDRINF2     (511, 0,513, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (513, 0,511, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//1F`4F ELVړimCYj
	WK7STGDRINF2     (511, 0,514, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (514, 0,511, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//1F`5F ELVړimCYj
	WK7STGDRINF2     (511, 0,515, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (515, 0,511, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//1F`6F ELVړimCYj
	WK7STGDRINF2     (511, 0,516, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (516, 0,511, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//1F`7F ELVړimCYj
	WK7STGDRINF2     (511, 0,517, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (517, 0,511, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//2F`3F ELVړimCYj
	WK7STGDRINF2     (512, 0,513, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (513, 0,512, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//2F`4F ELVړimCYj
	WK7STGDRINF2     (512, 0,514, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (514, 0,512, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//2F`5F ELVړimCYj
	WK7STGDRINF2     (512, 0,515, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (515, 0,512, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//2F`6F ELVړimCYj
	WK7STGDRINF2     (512, 0,516, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (516, 0,512, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//2F`7F ELVړimCYj
	WK7STGDRINF2     (512, 0,517, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (517, 0,512, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//3F`4F ELVړimCYj
	WK7STGDRINF2     (513, 0,514, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (514, 0,513, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//3F`5F ELVړimCYj
	WK7STGDRINF2     (513, 0,515, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (515, 0,513, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//3F`6F ELVړimCYj
	WK7STGDRINF2     (513, 0,516, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (516, 0,513, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//3F`7F ELVړimCYj
	WK7STGDRINF2     (513, 0,517, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (517, 0,513, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//4F`5F ELVړimCYj
	WK7STGDRINF2     (514, 0,515, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (515, 0,514, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//4F`6F ELVړimCYj
	WK7STGDRINF2     (514, 0,516, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (516, 0,514, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//4F`7F ELVړimCYj
	WK7STGDRINF2     (514, 0,517, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (517, 0,514, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//5F`6F ELVړimCYj
	WK7STGDRINF2     (515, 0,516, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (516, 0,515, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//5F`7F ELVړimCYj
	WK7STGDRINF2     (515, 0,517, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (517, 0,515, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//6F`7F ELVړimCYj
	WK7STGDRINF2     (516, 0,517, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (517, 0,516, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	//7F` ELVړimCYj
	WK7STGDRINF2     (517, 0,518, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (518, 0,517, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )

	//KVA@o
	WK7STGDRINF2     (120, 0,511, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	
	//Xe[W`ԁij
	WK7STGDRINF2     (517, 0,578, 0, SFX_SCE5_MAP_CHANGE_DOOR_IRON_OPEN,   SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE     )
	WK7STGDRINF2     (578, 0,517, 0, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN,     SFX_SCE5_MAP_CHANGE_DOOR_IRON_CLOSE   )
	//h[`Ln
	WK7STGDRINF2     (520, 0,573, 0, SFX_SYS_MAP_CHANGE_SENKANDOME,        SFX_SYS_MAP_CHANGE_SENKANDOME         )
	WK7STGDRINF2     (573, 0,520, 0, SFX_SYS_MAP_CHANGE_SENKANDOME,        SFX_SYS_MAP_CHANGE_SENKANDOME         )
	//Ln`
	WK7STGDRINF2     (520, 0,578, 0, SFX_SCE5_MAP_CHANGE_DOOR_COMMON_OPEN, SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE     )
	WK7STGDRINF2     (578, 0,520, 0, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN,     SFX_SCE5_MAP_CHANGE_DOOR_COMMON_CLOSE )
	//ԁ`Xe[Wioj
	WK7STGDRINF2     (519, 0,578, 0, SFX_SCE5_MAP_CHANGE_DOOR_IRON_OPEN,   SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE     )
	WK7STGDRINF2     (578, 0,519, 0, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN,     SFX_SCE5_MAP_CHANGE_DOOR_IRON_CLOSE   )
	
	
	//////////////////////////////////////////////////////////////////
	// wZ
	WK7STGDRINF2     (551, 1,551, 3, SFX_SCE5_MAP_CHANGE_SCL_WDOOR_IRON_HEAVY_OPEN, SFX_SCE5_MAP_CHANGE_SCL_WDOOR_IRON_HEAVY_CLOSE )
	WK7STGDRINF2     (551, 3,551, 1, SFX_SCE5_MAP_CHANGE_SCL_WDOOR_IRON_HEAVY_OPEN, SFX_SCE5_MAP_CHANGE_SCL_WDOOR_IRON_HEAVY_CLOSE )
	
	WK7STGDRINF2     (551, 3,560, 0, SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_HEAVY_OPEN, SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_HEAVY_CLOSE )
	WK7STGDRINF2     (560, 0,551, 3, SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_HEAVY_OPEN, SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_HEAVY_CLOSE )
	
	WK7STGDRINF2     (558, 0,552, 0, SFX_SYS_MAP_CHANGE_HACROOM_DEFIN, SFX_SYS_MAP_CHANGE_HACROOM_DEFOUT )
	WK7STGDRINF2     (552, 0,558, 0, SFX_SYS_MAP_CHANGE_HACROOM_DEFIN, SFX_SYS_MAP_CHANGE_HACROOM_DEFOUT )
	
	WK7STGDRINF2     (552, 0,553, 0, SFX_SYS_SAND_NOISE, SFX_SCE5_MAP_CHANGE_SCL_WDOOR_IRON_HEAVY_CLOSE )
	WK7STGDRINF2     (553, 0,120, 0, SFX_SCE5_MAP_CHANGE_SCL_WDOOR_IRON_HEAVY_OPEN, SFX_SYS_SAND_NOISE )
	
	WK7STGDRINF2     (551, 0,121, 0, SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE       )
	WK7STGDRINF2     (121, 0,551, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,       SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_CLOSE )
	WK7STGDRINF2     (551, 1,121, 0, SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE       )
	WK7STGDRINF2     (121, 0,551, 1, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,       SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_CLOSE )
	WK7STGDRINF2     (551, 2,121, 0, SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE       )
	WK7STGDRINF2     (121, 0,551, 2, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,       SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_CLOSE )
	
	//iJj`1F~i~KEJ
	WK7STGDRINF2     (552, 0,551, 0, SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_HEAVY_OPEN, SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_HEAVY_CLOSE )
	WK7STGDRINF2     (551, 0,552, 0, SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_HEAVY_OPEN, SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_HEAVY_CLOSE )
	//1F~i~KEJ`1FEJ
	WK7STGDRINF2     (551, 0,551, 4, SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_OPEN, SFX_SCE5_MAP_CHANGE_WDOOR_WOOD_CLOSE )
	WK7STGDRINF2     (551, 4,551, 0, SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_OPEN, SFX_SCE5_MAP_CHANGE_WDOOR_WOOD_CLOSE )
	//1FEJ`1FL^KEJ
	WK7STGDRINF2     (551, 4,551, 1, SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_OPEN, SFX_SCE5_MAP_CHANGE_WDOOR_WOOD_CLOSE )
	WK7STGDRINF2     (551, 1,551, 4, SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_OPEN, SFX_SCE5_MAP_CHANGE_WDOOR_WOOD_CLOSE )
	//2FEJ`2FEJiLnNAj
	WK7STGDRINF2     (551, 2,551, 2, SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_OPEN, SFX_SCE5_MAP_CHANGE_WDOOR_WOOD_CLOSE )
	//RE`EVc`W`EVc
	WK7STGDRINF2     (551, 4,551, 1, SFX_SCE5_MAP_CHANGE_DOOR_WOOD_OPEN, SFX_SCE5_MAP_CHANGE_WDOOR_WOOD_CLOSE )
	WK7STGDRINF2     (551, 1,551, 4, SFX_SCE5_MAP_CHANGE_DOOR_WOOD_OPEN, SFX_SCE5_MAP_CHANGE_WDOOR_WOOD_CLOSE )
	//VNhE(560,0)`2FEJ(551,2)
	WK7STGDRINF2     (560, 0,551, 2, SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_OPEN, SFX_SCE5_MAP_CHANGE_WDOOR_WOOD_CLOSE )
	WK7STGDRINF2     (551, 2,560, 0, SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_OPEN, SFX_SCE5_MAP_CHANGE_WDOOR_WOOD_CLOSE )
	
	//Xe[W`ԁij
	WK7STGDRINF2     (551, 2,578, 0, SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_OPEN,   SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE    )
	WK7STGDRINF2     (578, 0,551, 2, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN,         SFX_SCE5_MAP_CHANGE_WDOOR_WOOD_CLOSE )
	//h[`Ln
	WK7STGDRINF2     (557, 0,573, 0, SFX_SYS_MAP_CHANGE_SENKANDOME, SFX_SYS_MAP_CHANGE_SENKANDOME )
	WK7STGDRINF2     (573, 0,557, 0, SFX_SYS_MAP_CHANGE_SENKANDOME, SFX_SYS_MAP_CHANGE_SENKANDOME )
	//Ln`
	WK7STGDRINF2     (557, 0,578, 0, SFX_SYS_MAP_CHANGE_HACROOM_DEFIN, SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE )
	WK7STGDRINF2     (578, 0,557, 0, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN, SFX_SYS_MAP_CHANGE_HACROOM_DEFOUT )
	//ԁ`Xe[Wioj
	//WK7STGDRINF2     (551, 2,578, 0, SFX_SCE5_MAP_CHANGE_DOOR_IRON_OPEN,   SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE   )
	//WK7STGDRINF2     (578, 0,551, 2, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN,     SFX_SCE5_MAP_CHANGE_DOOR_IRON_CLOSE )

	//KVA@o
	WK7STGDRINF2     (120, 0,552, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
#endif

#ifdef	__K7SCN06_CPP__
	//////////////////////////////////////////////////////////////////
	// R͓
	WK7STGDRINF2     (570, 0,571, 0, SFX_SCE6_MAP_CHANGE_SLIDE_DOOR_WOOD_OPEN, SFX_SCE6_MAP_CHANGE_SLIDE_DOOR_WOOD_CLOSE )
	WK7STGDRINF2     (571, 0,570, 0, SFX_SCE6_MAP_CHANGE_SLIDE_DOOR_WOOD_OPEN, SFX_SCE6_MAP_CHANGE_SLIDE_DOOR_WOOD_CLOSE )
	
	WK7STGDRINF2     (571, 1,572, 0, SFX_SCE6_MAP_CHANGE_SLIDE_DOOR_WOOD_OPEN, SFX_SCE6_MAP_CHANGE_SLIDE_DOOR_WOOD_CLOSE )
	WK7STGDRINF2     (572, 0,571, 1, SFX_SCE6_MAP_CHANGE_SLIDE_DOOR_WOOD_OPEN, SFX_SCE6_MAP_CHANGE_SLIDE_DOOR_WOOD_CLOSE )
	
	WK7STGDRINF2     (572, 0,573, 0, SFX_SCE6_MAP_CHANGE_WDOOR_HEAVY_OPEN, SFX_SCE6_MAP_CHANGE_WDOOR_HEAVY_CLOSE )
	WK7STGDRINF2     (573, 0,572, 0, SFX_SCE6_MAP_CHANGE_WDOOR_HEAVY_OPEN, SFX_SCE6_MAP_CHANGE_WDOOR_HEAVY_CLOSE )
	
	WK7STGDRINF2     (573, 0,574, 0, SFX_SCE6_MAP_CHANGE_WDOOR_HEAVY_OPEN, SFX_SCE6_MAP_CHANGE_SHUTTER_CLOSE )
	WK7STGDRINF2     (574, 0,573, 0, SFX_SCE6_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SCE6_MAP_CHANGE_WDOOR_HEAVY_CLOSE )
	
	WK7STGDRINF2     (574, 0,575, 0, SFX_SCE6_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SCE6_MAP_CHANGE_DOOR_IRON_CLOSE )
	WK7STGDRINF2     (575, 0,574, 0, SFX_SCE6_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SCE6_MAP_CHANGE_DOOR_IRON_CLOSE )
	
	WK7STGDRINF2     (575, 0,121, 1, SFX_SCE6_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SCE6_MAP_CHANGE_DOOR_IRON_CLOSE )
	WK7STGDRINF2     (121, 1,575, 0, SFX_SCE6_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SCE6_MAP_CHANGE_DOOR_IRON_CLOSE )
	
	WK7STGDRINF2     (120, 0,121, 1, SFX_SYS_MAP_CHANGE_HACROOM_DEFIN, SFX_SYS_MAP_CHANGE_HACROOM_DEFOUT )
	WK7STGDRINF2     (121, 1,120, 0, SFX_SYS_MAP_CHANGE_HACROOM_DEFIN, SFX_SYS_MAP_CHANGE_HACROOM_DEFOUT )
	
#endif

#ifdef	__K7SCN07_CPP__
	//////////////////////////////////////////////////////////////////
	// ZeBbN
	WK7STGDRINF2     (771, 3,771, 0, SFX_SCE0_MAP_CHANGE_DOOR_BIG_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_BIG_CLOSE )
	WK7STGDRINF2     (771, 0,771, 3, SFX_SCE0_MAP_CHANGE_DOOR_BIG_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_BIG_CLOSE )
	
	WK7STGDRINF2     (771, 0,121, 0, SFX_SCE0_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     (121, 0,771, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_IRON_CLOSE )
	
	WK7STGDRINF2     (772, 1,121, 0, SFX_SCE0_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     (121, 0,772, 1, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_IRON_CLOSE )
	
	WK7STGDRINF2     (772, 2,772, 3, SFX_SCE0_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_IRON_CLOSE )
	WK7STGDRINF2     (772, 3,772, 2, SFX_SCE0_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_IRON_CLOSE )
	
	WK7STGDRINF2     (773, 0,121, 0, SFX_SCE0_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     (121, 0,773, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_IRON_CLOSE )
	
	WK7STGDRINF2     (773, 1,773, 5, SFX_SCE0_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_IRON_CLOSE )
	WK7STGDRINF2     (773, 5,773, 1, SFX_SCE0_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_IRON_CLOSE )
	
	WK7STGDRINF2     (773, 4,121, 0, SFX_SCE0_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     (121, 0,773, 4, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_IRON_CLOSE )
	
	WK7STGDRINF2     (773, 4,772, 2, SFX_SCE0_MAP_CHANGE_DOOR_HEAVY_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_HEAVY_CLOSE )
	WK7STGDRINF2     (772, 2,773, 4, SFX_SCE0_MAP_CHANGE_DOOR_HEAVY_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_HEAVY_CLOSE )
	
	WK7STGDRINF2     (774, 0,121, 0, SFX_SCE0_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     (121, 0,774, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_IRON_CLOSE )
	
	WK7STGDRINF2     (774, 1,774, 2, SFX_SCE0_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_IRON_CLOSE )
	WK7STGDRINF2     (774, 2,774, 1, SFX_SCE0_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_IRON_CLOSE )
	
	WK7STGDRINF2     (774, 2,774, 3, SFX_SCE0_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_IRON_CLOSE )
	WK7STGDRINF2     (774, 3,774, 2, SFX_SCE0_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_IRON_CLOSE )
	
	WK7STGDRINF2     (774, 2,121, 0, SFX_SCE0_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     (121, 0,774, 2, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_IRON_CLOSE )
	
	WK7STGDRINF2     (775, 1,121, 0, SFX_SCE0_KANAAMI_AKU,             SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     (121, 0,775, 1, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE0_KANAAMI_AKU              )
	
	WK7STGDRINF2     (776, 0,121, 0, SFX_SCE0_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE )
	WK7STGDRINF2     (121, 0,776, 0, SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_IRON_CLOSE )
	
	WK7STGDRINF2     (776, 0,776, 1, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	WK7STGDRINF2     (776, 1,776, 0, SFX_SYS_SAND_NOISE, NOISE_SE_NONE )
	
	WK7STGDRINF2     (776, 3,707, 1, SFX_SCE0_MAP_CHANGE_DOOR_HEAVY_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_HEAVY_CLOSE )
	WK7STGDRINF2     (707, 1,776, 3, SFX_SCE0_MAP_CHANGE_DOOR_HEAVY_OPEN, SFX_SCE0_MAP_CHANGE_DOOR_HEAVY_CLOSE )
	
	//Xe[W`ԁij
	WK7STGDRINF2     (775, 1,578, 0, SFX_SCE0_MAP_CHANGE_DOOR_MID_OPEN,  SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE   )
	WK7STGDRINF2     (578, 0,775, 1, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN,   SFX_SCE0_MAP_CHANGE_DOOR_MID_CLOSE )
	//h[`Ln
	WK7STGDRINF2     (775, 2,573, 0, SFX_SCE0_MAP_CHANGE_DOOR_IRON_OPEN, SFX_SYS_MAP_CHANGE_SENKANDOME       )
	WK7STGDRINF2     (573, 0,775, 2, SFX_SYS_MAP_CHANGE_SENKANDOME,      SFX_SCE0_MAP_CHANGE_DOOR_IRON_CLOSE )
	//Ln`
	WK7STGDRINF2     (775, 2,578, 0, SFX_SCE0_MAP_CHANGE_DOOR_BIG_OPEN,  SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE   )
	WK7STGDRINF2     (578, 0,775, 2, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN,   SFX_SCE0_MAP_CHANGE_DOOR_BIG_CLOSE )
	//ԁ`Xe[Wioj
	WK7STGDRINF2     (776, 0,578, 0, SFX_SCE0_MAP_CHANGE_DOOR_MID_OPEN,  SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE   )
	WK7STGDRINF2     (578, 0,776, 0, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN,   SFX_SCE0_MAP_CHANGE_DOOR_MID_CLOSE )
#endif

#ifdef	__K7STAGE_CPP__
	
	//////////////////////////////////////////////////////////////////
	// KVA@
	WK7STGDRINF2     (120, 0,121, 0, SFX_SYS_MAP_CHANGE_HACROOM_DEFIN, SFX_SYS_MAP_CHANGE_HACROOM_DEFOUT )
	WK7STGDRINF2     (121, 0,120, 0, SFX_SYS_MAP_CHANGE_HACROOM_DEFIN, SFX_SYS_MAP_CHANGE_HACROOM_DEFOUT )
	
	WK7STGDRINF2     (120, 0,122, 0, SFX_SCE6_MAP_CHANGE_AKAZUNOMA_IN, SFX_SCE6_MAP_CHANGE_AKAZUNOMA_OUT )
	WK7STGDRINF2     (122, 0,120, 0, SFX_SCE6_MAP_CHANGE_AKAZUNOMA_IN, SFX_SCE6_MAP_CHANGE_AKAZUNOMA_OUT )
	
	
	//////////////////////////////////////////////////////////////////
	// n[}
	
	
	//////////////////////////////////////////////////////////////////
	// Ԏ
	WK7STGDRINF2     (578, 0,578, 0, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN, SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE )
	WK7STGDRINF2     (578, 0,578, 0, SFX_SYS_MAP_CHANGE_DOOR_MON_OPEN, SFX_SYS_MAP_CHANGE_DOOR_MON_CLOSE )
	
	WK7STGDRINF2     (573, 0,578, 0, SFX_SYS_MAP_CHANGE_SENKANDOME, SFX_SYS_MAP_CHANGE_SENKANDOME )
	WK7STGDRINF2     (578, 0,573, 0, SFX_SYS_MAP_CHANGE_SENKANDOME, SFX_SYS_MAP_CHANGE_SENKANDOME )
	
#endif
	
#endif	//__K7STAGEDOORINFO_H__

