////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage Info
//
// K7StageInfo.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGEINFO_H__
#define	__K7STAGEINFO_H__

#ifdef	__K7SCN01_CPP__
#endif

#ifdef	__K7SCN02_CPP__
#endif

#ifdef	__K7SCN03_CPP__
#endif

#ifdef	__K7SCN04_CPP__
#endif

#ifdef	__K7SCN05_CPP__
#endif

#ifdef	__K7SCN06_CPP__
#endif

#ifdef	__K7SCN07_CPP__
#endif

#ifdef	__K7STAGE_CPP__
	//            Scn           StageID Flow           Area           HR  SO  SP MP CamSet
	
	// tNV}
	K7STG_LIST_CAM(K7SCN01      ,100, 0,K7SCNF_FUK    ,K7AREA_FUK    , 0,  4, 56, 1,8)
	K7STG_LIST_CAM(K7SCN01      ,101, 0,K7SCNF_FUK    ,K7AREA_FUK    , 0,  6, 60, 1,8)
	K7STG_LIST_CAM(K7SCN01      ,101, 1,K7SCNF_FUK    ,K7AREA_FUK    , 0, 10, 52, 1,3)
	K7STG_LIST_CAM(K7SCN01      ,102, 0,K7SCNF_FUK    ,K7AREA_FUK    , 0, 10,108, 1,8)
	K7STG_LIST_CAM(K7SCN01      ,103, 0,K7SCNF_FUK    ,K7AREA_FUK    , 1,  8, 68, 1,8)
	K7STG_LIST    (K7SCN01      ,104, 0,K7SCNF_FUK    ,K7AREA_FUK    , 0, 12, 60, 1)
	K7STG_LIST    (K7SCN01      ,105, 0,K7SCNF_FUK    ,K7AREA_FUK    , 0,  8, 28, 1)
	K7STG_LIST_CAM(K7SCN01      ,106, 0,K7SCNF_FUK    ,K7AREA_FUK    , 0, 10, 72, 1,8)
	K7STG_LIST_CAM(K7SCN01      ,107, 0,K7SCNF_FUK    ,K7AREA_FUK    , 1, 10, 36, 1,8)
	K7STG_LIST    (K7SCN01      ,108, 0,K7SCNF_FUK    ,K7AREA_FUK    , 1,  8, 76, 1)
	K7STG_LIST_CAM(K7SCN01      ,112, 0,K7SCNF_FUK    ,K7AREA_FUK    , 1, 18, 88, 1,8)
	K7STG_LIST    (K7SCN01      ,113, 0,K7SCNF_FUK    ,K7AREA_FUK    , 0, 10, 20, 1)
	K7STG_LIST    (K7SCN01      ,113, 1,K7SCNF_FUK    ,K7AREA_FUK    , 1, 10, 24, 1)
	K7STG_LIST    (K7SCN01      ,113, 2,K7SCNF_FUK    ,K7AREA_FUK    , 0,  8, 16, 1)
	K7STG_LIST    (K7SCN01      ,113, 3,K7SCNF_FUK    ,K7AREA_FUK    , 0, 10, 20, 1)
	K7STG_LIST    (K7SCN01      ,115, 0,K7SCNF_FUK    ,K7AREA_FUK    , 0,  2,  8, 1)
	K7STG_LIST    (K7SCN01      ,115, 1,K7SCNF_FUK    ,K7AREA_FUK    , 1,  6, 12, 1)
	K7STG_LIST_CAM(K7SCN01      ,116, 0,K7SCNF_FUK    ,K7AREA_FUK    , 0, 10, 40, 1,8)
	K7STG_LIST_CAM(K7SCN01      ,117, 0,K7SCNF_FUK    ,K7AREA_FUK    , 0,  4, 44, 1,8)
	K7STG_LIST    (K7SCN01      ,118, 0,K7SCNF_FUK    ,K7AREA_FUK    , 0,  4, 20, 1)
	K7STG_LIST_CAM(K7SCN01      ,119, 0,K7SCNF_FUK    ,K7AREA_FUK    , 1,  2, 32, 1,3)
	K7STG_LIST_CAM(K7SCN01      ,180, 0,K7SCNF_FUK    ,K7AREA_FUK    , 0,  6, 32, 1,8)
	K7STG_LIST_CAM(K7SCN01      ,181, 0,K7SCNF_FUK    ,K7AREA_FUK    , 1,  4, 16, 1,8)
	K7STG_LIST    (K7SCN01      ,182, 0,K7SCNF_FUK    ,K7AREA_FUK    , 0,  4,  4, 1)
	K7STG_LIST    (K7SCN01      ,190, 0,K7SCNF_FUK    ,K7AREA_FUK    , 0,  4,  8, 1)
	K7STG_LIST    (K7SCN01      ,190, 1,K7SCNF_FUK    ,K7AREA_FUK    , 1,  6, 20, 1)
	
	// pr
	K7STG_LIST    (K7SCN01      ,130, 0,K7SCNF_KAK    ,K7AREA_KAK    , 0,  8,112, 1)
	K7STG_LIST    (K7SCN01      ,131, 0,K7SCNF_KAK    ,K7AREA_KAK    , 1, 14, 72, 1)
	K7STG_LIST    (K7SCN01      ,132, 0,K7SCNF_KAK    ,K7AREA_KAK    , 1,  8, 32, 1)
	K7STG_LIST    (K7SCN01      ,133, 0,K7SCNF_KAK    ,K7AREA_KAK    , 1, 14, 52, 2)
	K7STG_LIST    (K7SCN01      ,134, 0,K7SCNF_KAK    ,K7AREA_KAK    , 1, 14, 68, 1)
	K7STG_LIST    (K7SCN01      ,134, 1,K7SCNF_KAK    ,K7AREA_KAK    , 1,  6, 16, 1)
	K7STG_LIST    (K7SCN01      ,135, 0,K7SCNF_KAK    ,K7AREA_KAK    , 1,  8, 28, 1)
	K7STG_LIST_CAM(K7SCN01      ,136, 0,K7SCNF_KAK    ,K7AREA_KAK    , 0,  6, 28, 1,2)
	K7STG_LIST    (K7SCN01      ,137, 0,K7SCNF_KAK    ,K7AREA_KAK    , 1,  6, 32, 1)
	K7STG_LIST    (K7SCN01      ,138, 0,K7SCNF_KAK    ,K7AREA_KAK    , 0,  4,  8, 1)
	K7STG_LIST    (K7SCN01      ,147, 0,K7SCNF_KAK    ,K7AREA_KAK    , 0,  8, 12, 1)
	K7STG_LIST    (K7SCN01      ,160, 0,K7SCNF_KAK    ,K7AREA_KAK    , 0,  0, 12, 1)
	
	// eLTX
	K7STG_LIST    (K7SCN02      ,200, 0,K7SCNF_TXS    ,K7AREA_TXS    , 0,  4, 16, 1)
	K7STG_LIST_CAM(K7SCN02      ,201, 0,K7SCNF_TXS    ,K7AREA_TXS    , 1, 14,116, 1,8)
	K7STG_LIST    (K7SCN02      ,201, 1,K7SCNF_TXS    ,K7AREA_TXS    , 0, 10, 36, 1)
	K7STG_LIST    (K7SCN02      ,202, 0,K7SCNF_TXS    ,K7AREA_TXS    , 0, 10, 24, 1)
	K7STG_LIST_CAM(K7SCN02      ,203, 0,K7SCNF_TXS    ,K7AREA_TXS    , 1,  6, 44, 1,10)
	K7STG_LIST_CAM(K7SCN02      ,203, 1,K7SCNF_TXS    ,K7AREA_TXS    , 0,  6, 68, 1,10)
	K7STG_LIST    (K7SCN02      ,204, 0,K7SCNF_TXS    ,K7AREA_TXS    , 1,  8, 28, 1)
	K7STG_LIST    (K7SCN02      ,205, 0,K7SCNF_TXS    ,K7AREA_TXS    , 0,  6, 28, 1)
	K7STG_LIST_CAM(K7SCN02      ,206, 0,K7SCNF_TXS    ,K7AREA_TXS    , 0,  0, 48, 1,9)
	K7STG_LIST    (K7SCN02      ,207, 0,K7SCNF_TXS    ,K7AREA_TXS    , 0,  4,  4, 1)
	K7STG_LIST_CAM(K7SCN02      ,208, 0,K7SCNF_TXS    ,K7AREA_TXS    , 1, 38,156, 1,8)
	K7STG_LIST_CAM(K7SCN02      ,209, 0,K7SCNF_TXS    ,K7AREA_TXS    , 1, 10, 56, 1,8)
	K7STG_LIST_CAM(K7SCN02      ,209, 1,K7SCNF_TXS    ,K7AREA_TXS    , 1, 12, 84, 1,8)
	K7STG_LISTM   (K7SCN02      ,210, 0,5,K7SCNF_TXS  ,K7AREA_TXS    , 0,  2,  8, 1)
	K7STG_LIST    (K7SCN02      ,211, 0,K7SCNF_TXS    ,K7AREA_TXS    , 0,  6,  8, 1)
	K7STG_LIST    (K7SCN02      ,212, 0,K7SCNF_TXS    ,K7AREA_TXS    , 0,  4, 12, 1)
	K7STG_LIST    (K7SCN02      ,213, 0,K7SCNF_TXS    ,K7AREA_TXS    , 0,  6,  8, 1)
	
	// VniCVUJhj
	K7STG_LIST    (K7SCN03      ,300, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 1,  6, 20, 1)
	K7STG_LIST    (K7SCN03      ,301, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0, 22, 56, 1)
	K7STG_LIST    (K7SCN03      ,302, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  4,  4, 1)
	K7STG_LIST    (K7SCN03      ,303, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  8, 16, 1)
	K7STG_LIST    (K7SCN03      ,304, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0, 28,116, 1)
	K7STG_LIST    (K7SCN03      ,305, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  4, 16, 1)
	K7STG_LIST    (K7SCN03      ,305, 1,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  4, 20, 1)
	K7STG_LIST    (K7SCN03      ,305, 2,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  4, 20, 1)
	K7STG_LIST    (K7SCN03      ,305, 3,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  4, 20, 1)
	K7STG_LIST    (K7SCN03      ,306, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  8, 56, 1)
	K7STG_LIST    (K7SCN03      ,307, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  4, 36, 1)
	K7STG_LIST    (K7SCN03      ,308, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  4, 24, 1)
	K7STG_LIST    (K7SCN03      ,309, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  6, 52, 1)
	K7STG_LIST    (K7SCN03      ,310, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  4, 48, 1)
	K7STG_LIST    (K7SCN03      ,311, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  4,  4, 1)
	K7STG_LIST    (K7SCN03      ,312, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0, 10, 56, 1)
	K7STG_LIST    (K7SCN03      ,312, 1,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  6, 40, 1)
	K7STG_LIST    (K7SCN03      ,312, 2,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  4, 28, 1)
	K7STG_LIST    (K7SCN03      ,313, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  6, 36, 1)
	K7STG_LIST    (K7SCN03      ,314, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  4,  4, 1)
//	K7STG_LIST    (K7SCN03      ,315, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  4,  8, 1)
	K7STG_LIST    (K7SCN03      ,316, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  0, 36, 1)
	K7STG_LIST    (K7SCN03      ,321, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  4, 36, 1)
//	K7STG_LIST    (K7SCN03      ,322, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 1,  4, 32, 1)
//	K7STG_LIST    (K7SCN03      ,323, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 1, 12, 68, 1)
//	K7STG_LIST    (K7SCN03      ,323, 1,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  8, 16, 1)
//	K7STG_LIST_CAM(K7SCN03      ,323, 2,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  6, 28, 1,8)
	K7STG_LIST_CAM(K7SCN03      ,324, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0, 20, 92, 1,8)
	K7STG_LIST_CAM(K7SCN03      ,325, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  6, 40, 1,1)
	K7STG_LIST_CAM(K7SCN03      ,325, 1,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  8, 36, 1,1)
	K7STG_LIST_CAM(K7SCN03      ,325, 2,K7SCNF_ISZ    ,K7AREA_ISZ    , 1,  6, 52, 1,1)
	K7STG_LIST_CAM(K7SCN03      ,325, 3,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  6, 36, 1,1)
	K7STG_LIST    (K7SCN03      ,326, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 1,  8, 92, 1)
	K7STG_LIST    (K7SCN03      ,327, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 2, 20,100, 1)
	K7STG_LIST    (K7SCN03      ,328, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 0,  4,  8, 1)
	K7STG_LIST    (K7SCN03      ,329, 0,K7SCNF_ISZ    ,K7AREA_ISZ    , 1,  6, 16, 1)
	
	//J[eBX@
	K7STG_LIST    (K7SCN03      ,350, 0,K7SCNF_CUR    ,K7AREA_CUR    , 0,  4,  4, 1)
	K7STG_LIST    (K7SCN03      ,351, 0,K7SCNF_CUR    ,K7AREA_CUR    , 1,  8, 28, 1)
	K7STG_LIST    (K7SCN03      ,352, 0,K7SCNF_CUR    ,K7AREA_CUR    , 0, 18, 72, 1)
	K7STG_LIST    (K7SCN03      ,353, 0,K7SCNF_CUR    ,K7AREA_CUR    , 0, 10, 24, 1)
	K7STG_LIST    (K7SCN03      ,354, 0,K7SCNF_CUR    ,K7AREA_CUR    , 1, 20, 96, 1)
	K7STG_LIST_CAM(K7SCN03      ,355, 0,K7SCNF_CUR    ,K7AREA_CUR    , 0,  6, 60, 1,3)
	K7STG_LIST    (K7SCN03      ,356, 0,K7SCNF_CUR    ,K7AREA_CUR    , 1,  8, 64, 1)
	K7STG_LIST    (K7SCN03      ,357, 0,K7SCNF_CUR    ,K7AREA_CUR    , 0, 12, 32, 1)
	K7STG_LIST    (K7SCN03      ,358, 0,K7SCNF_CUR    ,K7AREA_CUR    , 0,  8, 16, 1)
	K7STG_LIST    (K7SCN03      ,359, 0,K7SCNF_CUR    ,K7AREA_CUR    , 0,  8, 12, 1)
	K7STG_LIST    (K7SCN03      ,361, 0,K7SCNF_CUR    ,K7AREA_CUR    , 0,  2, 12, 1)
	K7STG_LIST_CAM(K7SCN03      ,362, 0,K7SCNF_CUR    ,K7AREA_CUR    , 1, 18,152, 1,3)
	K7STG_LIST    (K7SCN03      ,362, 1,K7SCNF_CUR    ,K7AREA_CUR    , 0,  8, 32, 1)
	K7STG_LIST    (K7SCN03      ,363, 0,K7SCNF_CUR    ,K7AREA_CUR    , 0,  0,  4, 1)
	K7STG_LIST    (K7SCN03      ,364, 0,K7SCNF_CUR    ,K7AREA_CUR    , 1,  6, 28, 1)
	K7STG_LIST    (K7SCN03      ,365, 0,K7SCNF_CUR    ,K7AREA_CUR    , 0,  4,  8, 1)
	
	//h~jJ
	K7STG_LIST    (K7SCN04      ,410, 0,K7SCNF_DM1    ,K7AREA_DOM    , 0,  4, 16, 1)
	K7STG_LIST    (K7SCN04      ,411, 0,K7SCNF_DM1    ,K7AREA_DOM    , 1, 12, 56, 1)
	K7STG_LIST    (K7SCN04      ,412, 0,K7SCNF_DM1    ,K7AREA_DOM    , 0,  6,120, 1)
	K7STG_LIST    (K7SCN04      ,413, 0,K7SCNF_DM1    ,K7AREA_DOM    , 1, 14, 60, 1)
	K7STG_LIST    (K7SCN04      ,415, 0,K7SCNF_DM1    ,K7AREA_DOM    , 0, 12,100, 1)
	K7STG_LIST    (K7SCN04      ,420, 0,K7SCNF_DM1    ,K7AREA_DOM    , 1,  8, 16, 1)
	K7STG_LIST    (K7SCN04      ,420, 1,K7SCNF_DM1    ,K7AREA_DOM    , 0,  8, 36, 1)
	K7STG_LIST    (K7SCN04      ,421, 0,K7SCNF_DM1    ,K7AREA_DOM    , 0,  8, 96, 1)
	K7STG_LIST    (K7SCN04      ,422, 0,K7SCNF_DM1    ,K7AREA_DOM    , 0,  4, 12, 1)
	K7STG_LIST    (K7SCN04      ,423, 0,K7SCNF_DM1    ,K7AREA_DOM    , 1,  8, 20, 1)
	K7STG_LIST_CAM(K7SCN04      ,425, 0,K7SCNF_DM1    ,K7AREA_DOM    , 0,  4, 36, 1,3)
	K7STG_LIST    (K7SCN04      ,441, 0,K7SCNF_DM1    ,K7AREA_DOM    , 1, 12, 48, 1)
	K7STG_LIST    (K7SCN04      ,441, 1,K7SCNF_DM1    ,K7AREA_DOM    , 0,  6, 16, 1)
	K7STG_LIST_CAM(K7SCN04      ,442, 0,K7SCNF_DM1    ,K7AREA_DOM    , 1, 10, 76, 1,0)
	K7STG_LIST    (K7SCN04      ,443, 0,K7SCNF_DM1    ,K7AREA_DOM    , 0,  6, 36, 1)
	K7STG_LIST_CAM(K7SCN04      ,444, 0,K7SCNF_DM1    ,K7AREA_DOM    , 1, 26,128, 1,3)
	K7STG_LIST_CAM(K7SCN04      ,444, 1,K7SCNF_DM1    ,K7AREA_DOM    , 0,  4, 64, 1,3)
	K7STG_LIST    (K7SCN04      ,445, 0,K7SCNF_DM1    ,K7AREA_DOM    , 0,  4, 12, 1)
	//j[[N
	K7STG_LIST    (K7SCN04      ,430, 0,K7SCNF_DM2    ,K7AREA_DOM    , 0,  2, 20, 1)
	
	// ze
	K7STG_LIST_CAM(K7SCN05      ,511, 0,K7SCNF_UNKNOWN,K7AREA_HTL    , 1,  6, 40, 1,3)
	K7STG_LIST_CAM(K7SCN05      ,512, 0,K7SCNF_UNKNOWN,K7AREA_HTL    , 1,  6, 88, 1,3)
	K7STG_LIST_CAM(K7SCN05      ,513, 0,K7SCNF_UNKNOWN,K7AREA_HTL    , 1,  4, 72, 1,3)
	K7STG_LIST_CAM(K7SCN05      ,514, 0,K7SCNF_UNKNOWN,K7AREA_HTL    , 1,  2, 60, 1,3)
	K7STG_LIST_CAM(K7SCN05      ,515, 0,K7SCNF_UNKNOWN,K7AREA_HTL    , 1,  0, 68, 1,3)
	K7STG_LIST_CAM(K7SCN05      ,516, 0,K7SCNF_UNKNOWN,K7AREA_HTL    , 1,  4, 72, 1,3)
	K7STG_LIST_CAM(K7SCN05      ,517, 0,K7SCNF_UNKNOWN,K7AREA_HTL    , 1,  8, 20, 1,3)
	K7STG_LIST_CAM(K7SCN05      ,518, 0,K7SCNF_UNKNOWN,K7AREA_HTL    , 0,  6, 36, 1,3)
	K7STG_LIST_CAM(K7SCN05      ,519, 0,K7SCNF_UNKNOWN,K7AREA_HTL    , 0,  4,  8, 1,3)
	K7STG_LIST_CAM(K7SCN05      ,520, 0,K7SCNF_UNKNOWN,K7AREA_HTL    , 0,  4,  4, 1,3)
	K7STG_LIST_CAM(K7SCN05      ,522, 0,K7SCNF_UNKNOWN,K7AREA_HTL    , 0,  6, 16, 2,3)
	K7STG_LIST_CAM(K7SCN05      ,523, 0,K7SCNF_UNKNOWN,K7AREA_HTL    , 0,  8, 32, 2,3)
	K7STG_LIST_CAM(K7SCN05      ,524, 0,K7SCNF_UNKNOWN,K7AREA_HTL    , 0, 12, 32, 2,3)
	K7STG_LIST_CAM(K7SCN05      ,525, 0,K7SCNF_UNKNOWN,K7AREA_HTL    , 0, 12, 24, 2,3)
	K7STG_LIST_CAM(K7SCN05      ,526, 0,K7SCNF_UNKNOWN,K7AREA_HTL    , 0,  8, 12, 1,3)
	
	//wZ
	K7STG_LIST    (K7SCN05      ,551, 0,K7SCNF_SCL    ,K7AREA_SCL    , 1, 14,112, 1)
	K7STG_LIST    (K7SCN05      ,551, 1,K7SCNF_SCL    ,K7AREA_SCL    , 1,  8,104, 1)
	K7STG_LIST    (K7SCN05      ,551, 2,K7SCNF_SCL    ,K7AREA_SCL    , 2,  8, 56, 1)
	K7STG_LIST    (K7SCN05      ,551, 3,K7SCNF_SCL    ,K7AREA_SCL    , 1, 10, 52, 1)
	K7STG_LIST    (K7SCN05      ,551, 4,K7SCNF_SCL    ,K7AREA_SCL    , 0,  4, 52, 1)
	K7STG_LIST    (K7SCN05      ,552, 0,K7SCNF_SCL    ,K7AREA_SCL    , 0, 12,116, 1)
	K7STG_LIST    (K7SCN05      ,553, 0,K7SCNF_SCL    ,K7AREA_SCL    , 0,  6, 24, 1)
	K7STG_LIST    (K7SCN05      ,554, 0,K7SCNF_SCL    ,K7AREA_SCL    , 0,  4,  8, 1)
	K7STG_LIST    (K7SCN05      ,554, 1,K7SCNF_SCL    ,K7AREA_SCL    , 0,  4, 12, 1)
	K7STG_LIST    (K7SCN05      ,554, 2,K7SCNF_SCL    ,K7AREA_SCL    , 0,  4,  4, 1)
	K7STG_LIST    (K7SCN05      ,554, 3,K7SCNF_SCL    ,K7AREA_SCL    , 0,  4, 12, 1)
	K7STG_LIST    (K7SCN05      ,554, 4,K7SCNF_SCL    ,K7AREA_SCL    , 0,  4,  8, 1)
	K7STG_LIST    (K7SCN05      ,554, 5,K7SCNF_SCL    ,K7AREA_SCL    , 0,  4,  8, 1)
	K7STG_LIST    (K7SCN05      ,554, 6,K7SCNF_SCL    ,K7AREA_SCL    , 0,  4,  8, 1)
	K7STG_LIST    (K7SCN05      ,554, 7,K7SCNF_SCL    ,K7AREA_SCL    , 0,  4,  8, 1)
	K7STG_LIST    (K7SCN05      ,554, 8,K7SCNF_SCL    ,K7AREA_SCL    , 0,  4,  8, 1)
	K7STG_LIST    (K7SCN05      ,554, 9,K7SCNF_SCL    ,K7AREA_SCL    , 0,  4,  8, 1)
	K7STG_LIST    (K7SCN05      ,554,10,K7SCNF_SCL    ,K7AREA_SCL    , 0,  4,  4, 1)
	K7STG_LIST    (K7SCN05      ,554,11,K7SCNF_SCL    ,K7AREA_SCL    , 0,  6,  8, 1)
	K7STG_LIST    (K7SCN05      ,554,12,K7SCNF_SCL    ,K7AREA_SCL    , 0,  8, 12, 1)
	K7STG_LIST    (K7SCN05      ,555, 0,K7SCNF_SCL    ,K7AREA_SCL    , 0, 10, 52, 1)
	K7STG_LIST    (K7SCN05      ,556, 0,K7SCNF_SCL    ,K7AREA_SCL    , 0,  4,  8, 1)
	K7STG_LIST    (K7SCN05      ,557, 0,K7SCNF_SCL    ,K7AREA_SCL    , 0,  6, 40, 1)
	K7STG_LIST    (K7SCN05      ,558, 0,K7SCNF_SCL    ,K7AREA_SCL    , 0,  6, 48, 1)
	K7STG_LIST    (K7SCN05      ,559, 0,K7SCNF_SCL    ,K7AREA_SCL    , 0, 10, 24, 1)
	K7STG_LIST    (K7SCN05      ,560, 0,K7SCNF_SCL    ,K7AREA_SCL    , 0,  6, 24, 1)
	
	//R͓
	K7STG_LIST    (K7SCN06      ,570, 0,K7SCNF_GNK    ,K7AREA_GNK    , 0,  2, 24, 1)
	K7STG_LIST_CAM(K7SCN06      ,571, 0,K7SCNF_GNK    ,K7AREA_GNK    , 0,  4, 80, 1,0)
	K7STG_LIST    (K7SCN06      ,572, 0,K7SCNF_GNK    ,K7AREA_GNK    , 0,  4, 24, 1)
	K7STG_LIST    (K7SCN06      ,574, 0,K7SCNF_GNK    ,K7AREA_GNK    , 0,  4, 44, 1)
	K7STG_LIST    (K7SCN06      ,575, 0,K7SCNF_GNK    ,K7AREA_GNK    , 0,  4, 40, 1)
	K7STG_LIST    (K7SCN06      ,600, 0,K7SCNF_GNK    ,K7AREA_GNK    , 0,  0,  8, 1)
	K7STG_LIST    (K7SCN06      ,122, 0,K7SCNF_GNK    ,K7AREA_GAL    , 0,  2, 56, 1)
	K7STG_LIST    (K7SCN06      ,121, 1,K7SCNF_GNK    ,K7AREA_HAR    , 1,  6, 16, 1)	// n[}tO1ŌŒ
	
	//ZeBbN
	K7STG_LIST    (K7SCN07      ,707, 1,K7SCNF_CEL    ,K7AREA_CEL    , 0,  2,  8, 1)
	K7STG_LIST_CAM(K7SCN07      ,771, 0,K7SCNF_CEL    ,K7AREA_CEL    , 1,  4, 20, 1,0)
	K7STG_LIST_CAM(K7SCN07      ,771, 1,K7SCNF_CEL    ,K7AREA_CEL    , 0, 12, 44, 1,0)
	K7STG_LIST_CAM(K7SCN07      ,771, 2,K7SCNF_CEL    ,K7AREA_CEL    , 0,  8, 20, 1,0)
	K7STG_LIST_CAM(K7SCN07      ,771, 3,K7SCNF_CEL    ,K7AREA_CEL    , 0,  2,  8, 1,0)
	K7STG_LIST_CAM(K7SCN07      ,771, 4,K7SCNF_CEL    ,K7AREA_CEL    , 0, 16, 44, 1,0)
	K7STG_LIST_CAM(K7SCN07      ,772, 0,K7SCNF_CEL    ,K7AREA_CEL    , 0,  6, 24, 1,3)
	K7STG_LIST_CAM(K7SCN07      ,772, 1,K7SCNF_CEL    ,K7AREA_CEL    , 1,  4, 20, 1,0)
	K7STG_LIST_CAM(K7SCN07      ,772, 2,K7SCNF_CEL    ,K7AREA_CEL    , 0, 10, 64, 1,0)
	K7STG_LIST_CAM(K7SCN07      ,772, 3,K7SCNF_CEL    ,K7AREA_CEL    , 0,  6, 16, 1,0)
	K7STG_LIST_CAM(K7SCN07      ,773, 0,K7SCNF_CEL    ,K7AREA_CEL    , 1,  8, 52, 1,3)
	K7STG_LIST_CAM(K7SCN07      ,773, 1,K7SCNF_CEL    ,K7AREA_CEL    , 0,  8, 16, 1,0)
	K7STG_LIST_CAM(K7SCN07      ,773, 2,K7SCNF_CEL    ,K7AREA_CEL    , 0, 12, 72, 1,0)
//	K7STG_LIST_CAM(K7SCN07      ,773, 3,K7SCNF_CEL    ,K7AREA_CEL    , 0,  8, 12, 1,0)
	K7STG_LIST_CAM(K7SCN07      ,773, 4,K7SCNF_CEL    ,K7AREA_CEL    , 1, 10, 48, 1,0)
	K7STG_LIST_CAM(K7SCN07      ,773, 5,K7SCNF_CEL    ,K7AREA_CEL    , 0,  6,  4, 1,0)
	K7STG_LIST_CAM(K7SCN07      ,774, 0,K7SCNF_CEL    ,K7AREA_CEL    , 1,  6, 36, 1,3)
	K7STG_LIST_CAM(K7SCN07      ,774, 1,K7SCNF_CEL    ,K7AREA_CEL    , 0,  4,  8, 1,0)
	K7STG_LIST_CAM(K7SCN07      ,774, 2,K7SCNF_CEL    ,K7AREA_CEL    , 1, 14, 80, 1,0)
	K7STG_LIST_CAM(K7SCN07      ,774, 3,K7SCNF_CEL    ,K7AREA_CEL    , 0,  4,  4, 1,0)
	K7STG_LIST_CAM(K7SCN07      ,774, 4,K7SCNF_CEL    ,K7AREA_CEL    , 0,  2,  8, 1,0)
	K7STG_LIST_CAM(K7SCN07      ,775, 0,K7SCNF_CEL    ,K7AREA_CEL    , 0,  4, 20, 1,3)
	K7STG_LIST_CAM(K7SCN07      ,775, 1,K7SCNF_CEL    ,K7AREA_CEL    , 1,  6, 52, 1,7)
	K7STG_LIST_CAM(K7SCN07      ,775, 2,K7SCNF_CEL    ,K7AREA_CEL    , 0,  4,  4, 1,0)
	K7STG_LIST_CAM(K7SCN07      ,776, 0,K7SCNF_CEL    ,K7AREA_CEL    , 1,  4, 16, 1,0)
	K7STG_LIST_CAM(K7SCN07      ,776, 1,K7SCNF_CEL    ,K7AREA_CEL    , 0,  6, 44, 1,3)
	K7STG_LIST_CAM(K7SCN07      ,776, 2,K7SCNF_CEL    ,K7AREA_CEL    , 0,  4, 24, 1,0)
	K7STG_LIST_CAM(K7SCN07      ,776, 3,K7SCNF_CEL    ,K7AREA_CEL    , 0,  2,  4, 1,0)
	
	//
	K7STG_LIST_CAM(K7SCN_UNKNOWN,573, 0,K7SCNF_UNKNOWN,K7AREA_GNK    , 0, 34, 64, 1,8)
	K7STG_LIST_CAM(K7SCN_UNKNOWN,578, 0,K7SCNF_UNKNOWN,K7AREA_GNK    , 0, 18, 40, 1,3)
	K7STG_LIST    (K7SCN_UNKNOWN,120, 0,K7SCNF_UNKNOWN,K7AREA_GAL    , 1,  2, 36, 1)
	K7STG_LIST    (K7SCN_UNKNOWN,121, 0,K7SCNF_UNKNOWN,K7AREA_HAR    , 0,  6, 12, 1)	// n[}̓XgŒ
#endif
	
#endif	//__K7STAGEINFO_H__

