////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage Sound Info
//
// K7StageSoundInfo.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/01/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGESOUNDINFO_H__
#define	__K7STAGESOUNDINFO_H__

// ft@C͂ 
#define	K7SOUND_REVERB_DEF		(35)
#define	K7SOUND_REVERB_BIG		(50)
#define	K7SOUND_REVERB_SML		(20)
#define	K7SOUND_REVERB_NON		(0)
// ft@C͂ 

//	WK7PATH_FOOTSE_WOOD			(1)		// ؂̘L
//	WK7PATH_FOOTSE_STONE		(2)		// ΁C̃RN[g
//	WK7PATH_FOOTSE_WOOD1		(3)		// ~~؂̘L
//	WK7PATH_FOOTSE_ROOF			(4)		// ̏
//	WK7PATH_FOOTSE_STONEW		(5)		// GꂽRN[g
//	WK7PATH_FOOTSE_STONEC		(6)		// ꂢȃRN[g
//	WK7PATH_FOOTSE_GROUND		(7)		// y
//	WK7PATH_FOOTSE_GRASS		(8)		// 
//	WK7PATH_FOOTSE_MUD			(9)		// D

#ifdef	__K7SCN01_CPP__
	WK7STGSOUNDINF          (190, 0,HPS_RAKUJITU_G    ,K7SOUND_REVERB_NON)
	WK7STGSOUNDINF          (190, 1,HPS_RAKUJITU_C    ,K7SOUND_REVERB_NON)
	WK7STGSOUNDINF          (100, 0,HPS_RAKUJITU_A    ,K7SOUND_REVERB_SML)
	WK7STGSOUNDINF          (101, 0,HPS_RAKUJITU_C    ,K7SOUND_REVERB_NON)
	WK7STGSOUNDINF_F        (101, 1,HPS_RAKUJITU_G    ,K7SOUND_REVERB_NON, WK7PATH_FOOTSE_ROOF)
	WK7STGSOUNDINF          (102, 0,HPS_RAKUJITU_B    ,K7SOUND_REVERB_DEF)
	WK7STGSOUNDINF          (103, 0,HPS_RAKUJITU_B    ,K7SOUND_REVERB_SML)
	WK7STGSOUNDINF          (104, 0,HPS_RAKUJITU_F    ,K7SOUND_REVERB_SML)
	WK7STGSOUNDINF          (105, 0,HPS_RAKUJITU_F    ,K7SOUND_REVERB_SML)
	WK7STGSOUNDINF          (106, 0,HPS_RAKUJITU_A    ,K7SOUND_REVERB_SML)
	WK7STGSOUNDINF          (107, 0,HPS_RAKUJITU_H    ,K7SOUND_REVERB_SML)
	WK7STGSOUNDINF          (108, 0,HPS_RAKUJITU_C    ,K7SOUND_REVERB_SML)
//	WK7STGSOUNDINF          (109, 0,HPS_RAKUJITU_C    ,K7SOUND_REVERB_SML)
//	WK7STGSOUNDINF          (110, 0,HPS_RAKUJITU_D    ,K7SOUND_REVERB_SML)
//	WK7STGSOUNDINF          (111, 0,HPS_RAKUJITU_D    ,K7SOUND_REVERB_SML)
	WK7STGSOUNDINF          (112, 0,HPS_RAKUJITU_I    ,K7SOUND_REVERB_NON)
	WK7STGSOUNDINF          (113, 0,HPS_RAKUJITU_E    ,K7SOUND_REVERB_SML)
	WK7STGSOUNDINF          (113, 1,HPS_RAKUJITU_E    ,K7SOUND_REVERB_SML)
	WK7STGSOUNDINF          (113, 2,HPS_RAKUJITU_E    ,K7SOUND_REVERB_SML)
	WK7STGSOUNDINF          (113, 3,HPS_RAKUJITU_E    ,K7SOUND_REVERB_SML)
	WK7STGSOUNDINF          (114, 0,HPS_RAKUJITU_E    ,K7SOUND_REVERB_SML)
	WK7STGSOUNDINF          (115, 0,HPS_RAKUJITU_D    ,K7SOUND_REVERB_DEF)
	WK7STGSOUNDINF          (115, 1,HPS_RAKUJITU_A    ,K7SOUND_REVERB_SML)
	WK7STGSOUNDINF          (116, 0,HPS_RAKUJITU_A    ,K7SOUND_REVERB_SML)
	WK7STGSOUNDINF          (117, 0,HPS_RAKUJITU_C    ,K7SOUND_REVERB_NON)
//	WK7STGSOUNDINF          (118, 0,HPS_RAKUJITU_D    ,K7SOUND_REVERB_SML)	//LnɂJbg
	WK7STGSOUNDINF          (119, 0,HPS_RAKUJITU_D    ,K7SOUND_REVERB_SML)
	WK7STGSOUNDINF          (180, 0,HPS_RAKUJITU_D    ,K7SOUND_REVERB_SML)
	WK7STGSOUNDINF          (181, 0,HPS_RAKUJITU_D    ,K7SOUND_REVERB_SML)
	WK7STGSOUNDINF          (182, 0,HPS_RAKUJITU_A    ,K7SOUND_REVERB_DEF)
	
	// pr
	WK7STGSOUNDINF          (130, 0,HPS_KRAKUJITU_G   ,K7SOUND_REVERB_BIG)
	WK7STGSOUNDINF          (131, 0,HPS_KRAKUJITU_E   ,K7SOUND_REVERB_DEF)
	WK7STGSOUNDINF          (132, 0,HPS_KRAKUJITU_D   ,K7SOUND_REVERB_DEF)
	WK7STGSOUNDINF          (133, 0,HPS_KRAKUJITU_B   ,K7SOUND_REVERB_DEF)
	WK7STGSOUNDINF          (134, 0,HPS_KRAKUJITU_E   ,K7SOUND_REVERB_DEF)
	WK7STGSOUNDINF          (134, 1,HPS_KRAKUJITU_E   ,K7SOUND_REVERB_DEF)
	WK7STGSOUNDINF          (135, 0,HPS_KRAKUJITU_A   ,K7SOUND_REVERB_NON)
//	WK7STGSOUNDINF          (136, 0,HPS_KRAKUJITU_F   ,K7SOUND_REVERB_BIG)
	WK7STGSOUNDINF          (137, 0,HPS_KRAKUJITU_A   ,K7SOUND_REVERB_NON)
	WK7STGSOUNDINF          (147, 0,HPS_KRAKUJITU_C   ,K7SOUND_REVERB_SML)
#endif

#ifdef	__K7SCN02_CPP__
//		eLTX		
	//
	WK7STGSOUNDINF          (200, 0,HPS_CLOUDSMAN_A   ,K7SOUND_REVERB_NON)		//ύX
	//HP
	WK7STGSOUNDINF          (201, 0,HPS_CLOUDSMAN_B   ,K7SOUND_REVERB_NON)		//ύX
	//HQiQ[gOj
	WK7STGSOUNDINF          (201, 1,HPS_CLOUDSMAN_B   ,K7SOUND_REVERB_NON)		//ύX
	//_Ci[X
	WK7STGSOUNDINF          (202, 0,HPS_CLOUDSMAN_C   ,K7SOUND_REVERB_SML)		//ύX
	//RiX֋ǃEj
	WK7STGSOUNDINF          (203, 0,HPS_CLOUDSMAN_B_DUSH,K7SOUND_REVERB_NON)	//E  B_DUSH
	//SeXgO
	WK7STGSOUNDINF          (203, 1,HPS_CLOUDSMAN_B_DUSH,K7SOUND_REVERB_NON)	//E  B_DUSH
	//1stLIFE
	WK7STGSOUNDINF          (204, 0,HPS_CLOUDSMAN_G   ,K7SOUND_REVERB_NON)		//ύX
	//r
	WK7STGSOUNDINF          (205, 0,HPS_CLOUDSMAN_H   ,K7SOUND_REVERB_NON)		//ύX
	//ً}ԗ
	WK7STGSOUNDINF          (206, 0,HPS_SENTOU_SILENCE,K7SOUND_REVERB_NON)		//ύX
	//hbOXgAB
//	WK7STGSOUNDINF          (207, 0,HPS_CLOUDSMAN_D   ,K7SOUND_REVERB_NON)		//폜
	//ZX
	WK7STGSOUNDINF          (208, 0,HPS_CLOUDSMAN_E   ,K7SOUND_REVERB_NON)		//ύX
	//HRiؑOj
	WK7STGSOUNDINF          (209, 0,HPS_CLOUDSMAN_B   ,K7SOUND_REVERB_NON)		//B_DUSH  B
	//HSiX֋ǑOj
	WK7STGSOUNDINF          (209, 1,HPS_CLOUDSMAN_B   ,K7SOUND_REVERB_NON)		//B_DUSH  B
	//Z
	WK7STGSOUNDINF          (210, 0,HPS_CLOUDSMAN_E_DUSH,K7SOUND_REVERB_NON)	//ύX
	WK7STGSOUNDINF          (211, 0,HPS_CLOUDSMAN_E_DUSH,K7SOUND_REVERB_NON)	//ύX
	WK7STGSOUNDINF          (212, 0,HPS_CLOUDSMAN_E_DUSH,K7SOUND_REVERB_NON)	//ύX
	//_Ci[
	WK7STGSOUNDINF          (213, 0,HPS_CLOUDSMAN_D   ,K7SOUND_REVERB_NON)		//E_DUSH  D
#endif


#ifdef	__K7SCN03_CPP__
	// VniCVUJhj
	WK7STGSOUNDINF          (300, 0,HPS_ISZK_A        ,K7SCN03_REVERB_NON)
//	WK7STGSOUNDINF          (321, 0,HPS_ISZK_H        ,K7SCN03_REVERB_DEF)
//	WK7STGSOUNDINF          (322, 0,HPS_SAFE_PLACE    ,K7SCN03_REVERB_DEF)
//	WK7STGSOUNDINF          (323, 0,HPS_ISZK_J        ,K7SCN03_REVERB_DEF)
//	WK7STGSOUNDINF          (323, 1,HPS_ISZK_E        ,K7SCN03_REVERB_DEF)
//	WK7STGSOUNDINF          (323, 2,HPS_KRAKUJITU_C   ,K7SCN03_REVERB_DEF)
//	WK7STGSOUNDINF          (324, 0,HPS_ISZK_I        ,K7SCN03_REVERB_NON)
	WK7STGSOUNDINF          (325, 0,HPS_ISZK_D1       ,K7SCN03_REVERB_BIG)
	WK7STGSOUNDINF          (325, 1,HPS_ISZK_D2       ,K7SCN03_REVERB_BIG)
	WK7STGSOUNDINF          (325, 2,HPS_ISZK_D3       ,K7SCN03_REVERB_BIG)
	WK7STGSOUNDINF          (325, 3,HPS_ISZK_D4       ,K7SCN03_REVERB_BIG)
	WK7STGSOUNDINF          (306, 0,HPS_ISZK_L        ,K7SCN03_REVERB_DEF)
	WK7STGSOUNDINF          (307, 0,HPS_ISZK_C        ,K7SCN03_REVERB_BIG)
	WK7STGSOUNDINF          (308, 0,HPS_ISZK_B        ,K7SCN03_REVERB_BIG)
	WK7STGSOUNDINF          (309, 0,HPS_ISZK_N        ,K7SCN03_REVERB_DEF)
	WK7STGSOUNDINF          (310, 0,HPS_ISZK_M        ,K7SCN03_REVERB_BIG)
	WK7STGSOUNDINF          (312, 0,HPS_CHOIR         ,K7SCN03_REVERB_SML)
	WK7STGSOUNDINF          (312, 1,HPS_CHOIR2        ,K7SCN03_REVERB_SML)
	WK7STGSOUNDINF          (312, 2,HPS_CHOIR3        ,K7SCN03_REVERB_SML)
	WK7STGSOUNDINF          (313, 0,HPS_CHOIR4        ,K7SCN03_REVERB_NON)
//	WK7STGSOUNDINF          (314, 0,HPS_ISZK_J        ,K7SCN03_REVERB_DEF)
//	WK7STGSOUNDINF          (315, 0,HPS_SAFE_PLACE_B  ,K7SCN03_REVERB_DEF)
	WK7STGSOUNDINF          (316, 0,HPS_ISZK_J        ,K7SCN03_REVERB_NON)
	WK7STGSOUNDINF          (326, 0,HPS_SAFE_PLACE_C  ,K7SCN03_REVERB_SML)
	WK7STGSOUNDINF          (327, 0,HPS_ISZK_K        ,K7SCN03_REVERB_NON)
//	WK7STGSOUNDINF          (328, 0,HPS_SPEED_HS      ,K7SCN03_REVERB_SML)	//LnɂJbg
	WK7STGSOUNDINF          (329, 0,HPS_SAFE_PLACE_E  ,K7SCN03_REVERB_SML)
	
	//J[eBX@
	WK7STGSOUNDINF          (350, 0,HPS_CURTIES_C     ,K7SCN03_REVERB_NON)			//S
	WK7STGSOUNDINF          (351, 0,HPS_CURTIES_D     ,K7SCN03_REVERB_NON)			//
//	WK7STGSOUNDINF          (352, 0,HPS_FREEMOVE_A    ,K7SCN03_REVERB_NON)			//
	WK7STGSOUNDINF          (353, 0,HPS_KRAKUJITU_C   ,K7SCN03_REVERB_SML)			//Ԍ
	WK7STGSOUNDINF          (354, 0,HPS_CURTIES_A     ,K7SCN03_REVERB_DEF)			//
	WK7STGSOUNDINF          (355, 0,HPS_CURTIES_D     ,K7SCN03_REVERB_NON)			//ʘH
	WK7STGSOUNDINF          (356, 0,HPS_CURTIES_B     ,K7SCN03_REVERB_DEF)			//ʑ1
	WK7STGSOUNDINF_VOLFADE  (357, 0,HPS_CURTIES_B     ,K7SCN03_REVERB_SML, 50, true)	//ʑ2
	WK7STGSOUNDINF_VOLFADE  (358, 0,HPS_CURTIES_B     ,K7SCN03_REVERB_SML, 50, true)	//ʑ3
	WK7STGSOUNDINF          (361, 0,HPS_IDOU_SYOUEN   ,K7SCN03_REVERB_DEF)			//L
	WK7STGSOUNDINF          (362, 0,HPS_CURTIES_D     ,K7SCN03_REVERB_NON)			//v[
//	WK7STGSOUNDINF          (362, 1,HPS_CURTIES_C     ,K7SCN03_REVERB_NON)			//v[EÂ
//	WK7STGSOUNDINF          (363, 0,HPS_HAGESHI       ,K7SCN03_REVERB_BIG)			//E{X
	WK7STGSOUNDINF          (364, 0,HPS_SAFE_PLACE_E  ,K7SCN03_REVERB_BIG)			//nʘH
//	WK7STGSOUNDINF          (365, 0,HPS_HAGESHI       ,K7SCN03_REVERB_BIG)			//LnɂJbg
#endif

#ifdef	__K7SCN04_CPP__
	//h~jJ
	WK7STGSOUNDINF          (410, 0,HPS_BUNSIN_D      ,K7SOUND_REVERB_NON)			//h~jJEO
	WK7STGSOUNDINF          (411, 0,HPS_BUNSIN_B      ,K7SOUND_REVERB_NON)			//h~jJEOL
	WK7STGSOUNDINF          (412, 0,HPS_BUNSIN_L      ,K7SOUND_REVERB_NON)			//h~jJE̊X
	WK7STGSOUNDINF          (413, 0,HPS_BUNSIN_J      ,K7SOUND_REVERB_NON)			//h~jJEʂ
	WK7STGSOUNDINF          (415, 0,HPS_BUNSIN_A      ,K7SOUND_REVERB_NON)			//h~jJEZX
	WK7STGSOUNDINF          (420, 0,HPS_BUNSIN_F      ,K7SOUND_REVERB_BIG)			//h~jJE1K
	WK7STGSOUNDINF          (420, 1,HPS_BUNSIN_G      ,K7SOUND_REVERB_BIG)			//h~jJE2K
//	WK7STGSOUNDINF          (421, 0,HPS_SAFE_PLACE    ,K7SOUND_REVERB_DEF)			//h~jJEʘH
//	WK7STGSOUNDINF          (422, 0,HPS_BUNSIN_M      ,K7SOUND_REVERB_DEF)			//h~jJEB
	WK7STGSOUNDINF          (423, 0,HPS_SAFE_PLACE    ,K7SOUND_REVERB_NON)			//h~jJE
	WK7STGSOUNDINF          (425, 0,HPS_BUNSIN_I      ,K7SOUND_REVERB_SML)			//h~jJEKi
	WK7STGSOUNDINF          (441, 0,HPS_BUNSIN_B      ,K7SOUND_REVERB_NON)			//h~jJEZʘH
//	WK7STGSOUNDINF          (441, 1,HPS_BUNSIN_D      ,K7SOUND_REVERB_SML)			//h~jJEAgG
	WK7STGSOUNDINF          (442, 0,HPS_SAFE_PLACE_C  ,K7SOUND_REVERB_NON)			//h~jJEKiʘH
	WK7STGSOUNDINF          (443, 0,HPS_BUNSIN_C      ,K7SOUND_REVERB_NON)			//h~jJEԍL
	WK7STGSOUNDINF          (444, 0,HPS_BUNSIN_E      ,K7SOUND_REVERB_NON)			//h~jJEg@[@
	WK7STGSOUNDINF          (444, 1,HPS_BUNSIN_C      ,K7SOUND_REVERB_NON)			//h~jJEu
	WK7STGSOUNDINF          (445, 0,HPS_BUNSIN_K      ,K7SOUND_REVERB_NON)			//h~jJEg@[@L
	//j[[NEu[hEFC
//	WK7STGSOUNDINF          (430, 0,HPS_BOSS_HSM      ,K7SOUND_REVERB_NON)
#endif

#ifdef	__K7SCN05_CPP__
	//ze
	WK7STGSOUNDINF          (511, 0,HPS_HOTEL_C       ,K7SOUND_REVERB_DEF)			//zePe
	WK7STGSOUNDINF          (518, 0,HPS_STOP_STREAM   ,K7SOUND_REVERB_DEF)			//ze
	WK7STGSOUNDINF          (519, 0,HPS_HOTEL_B       ,K7SOUND_REVERB_DEF)			//zeuho[iobNCg̒j̑̕Oj
	
	//wZ
//	WK7STGSOUNDINF          (551, 0,HPS_SCHOOL_D      ,K7SOUND_REVERB_DEF)				//1FLno1
	WK7STGSOUNDINF          (551, 1,HPS_SCHOOL_A      ,K7SOUND_REVERB_DEF)				//1FLno2
	WK7STGSOUNDINF          (551, 4,HPS_SCHOOL_A      ,K7SOUND_REVERB_DEF)				//1FLno3
	WK7STGSOUNDINF          (551, 2,HPS_SAFE_PLACE_C  ,K7SOUND_REVERB_DEF)				//2FLno1
	WK7STGSOUNDINF          (551, 3,HPS_SCHOOL_C      ,K7SOUND_REVERB_DEF)				//2FLno2
	WK7STGSOUNDINF          (552, 0,HPS_SCHOOL_B      ,K7SOUND_REVERB_NON)				//O
	WK7STGSOUNDINF          (553, 0,HPS_SCHOOL_F      ,K7SOUND_REVERB_BIG)				//̈
	WK7STGSOUNDINF_VOLFADE  (554, 0,HPS_SAME_STREAM   ,K7SOUND_REVERB_SML, 50, true)	//
	WK7STGSOUNDINF_VOLFADE  (554, 1,HPS_SAME_STREAM   ,K7SOUND_REVERB_SML, 50, true)	//
	WK7STGSOUNDINF_VOLFADE  (554, 2,HPS_SAME_STREAM   ,K7SOUND_REVERB_SML, 50, true)	//
	WK7STGSOUNDINF_VOLFADE  (554, 3,HPS_SAME_STREAM   ,K7SOUND_REVERB_SML, 50, true)	//
	WK7STGSOUNDINF_VOLFADE  (554, 4,HPS_SAME_STREAM   ,K7SOUND_REVERB_SML, 50, true)	//
	WK7STGSOUNDINF_VOLFADE  (554, 5,HPS_SAME_STREAM   ,K7SOUND_REVERB_SML, 50, true)	//
	WK7STGSOUNDINF_VOLFADE  (554, 6,HPS_SAME_STREAM   ,K7SOUND_REVERB_SML, 50, true)	//
	WK7STGSOUNDINF_VOLFADE  (554, 7,HPS_SAME_STREAM   ,K7SOUND_REVERB_SML, 50, true)	//
	WK7STGSOUNDINF_VOLFADE  (554, 8,HPS_SAME_STREAM   ,K7SOUND_REVERB_SML, 50, true)	//
	WK7STGSOUNDINF_VOLFADE  (554, 9,HPS_SAME_STREAM   ,K7SOUND_REVERB_SML, 50, true)	//
	WK7STGSOUNDINF_VOLFADE  (554,10,HPS_SAME_STREAM   ,K7SOUND_REVERB_SML, 50, true)	//
	WK7STGSOUNDINF_VOLFADE  (554,11,HPS_SAME_STREAM   ,K7SOUND_REVERB_SML, 50, true)	//
	WK7STGSOUNDINF_VOLFADE  (554,12,HPS_SAME_STREAM   ,K7SOUND_REVERB_SML, 50, true)	//
	WK7STGSOUNDINF			(555, 0,HPS_SCHOOL_E      ,K7SOUND_REVERB_SML)				//f[^
	WK7STGSOUNDINF			(556, 0,HPS_SCHOOL_E      ,K7SOUND_REVERB_SML)				//qgC
//	WK7STGSOUNDINF          (557, 0,HPS_CURTIES_C     ,K7SOUND_REVERB_BIG)				//} LnHS
	WK7STGSOUNDINF			(558, 0,HPS_SCHOOL_E      ,K7SOUND_REVERB_SML)				//Z
	WK7STGSOUNDINF			(559, 0,HPS_SCHOOL_E      ,K7SOUND_REVERB_SML)				//
//	WK7STGSOUNDINF          (560, 0,HPS_FREEMOVE_A    ,K7SOUND_REVERB_BIG)				//H
#endif

#ifdef	__K7SCN06_CPP__
	//R͓
	WK7STGSOUNDINF          (570, 0,HPS_GUNKAN_C      ,K7SOUND_REVERB_NON)				//
	WK7STGSOUNDINF          (571, 0,HPS_GUNKAN_B      ,K7SOUND_REVERB_SML)				//
	WK7STGSOUNDINF          (572, 0,HPS_GUNKAN_C      ,K7SOUND_REVERB_NON)				//RVA܂
	WK7STGSOUNDINF          (573, 0,HPS_GUNKAN        ,K7SOUND_REVERB_BIG)				//z[
	WK7STGSOUNDINF          (574, 0,HPS_GUNKAN_B      ,K7SOUND_REVERB_DEF)				//Ki
	WK7STGSOUNDINF          (575, 0,HPS_STOP_STREAM   ,K7SOUND_REVERB_DEF)				//A
	WK7STGSOUNDINF          (122, 0,HPS_GUNKAN_D      ,K7SOUND_REVERB_DEF)				//Atn[}
	WK7STGSOUNDINF          (121, 1,HPS_LAST_ROOM     ,K7SOUND_REVERB_BIG)				//Ō̕
#endif

#ifdef	__K7SCN07_CPP__
	WK7STGSOUNDINF_F        (771, 0,HPS_SAFE_PLACE    ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
	WK7STGSOUNDINF_F        (771, 1,HPS_TENSHI_D      ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
	WK7STGSOUNDINF_F        (771, 2,HPS_TENSHI_D      ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
	WK7STGSOUNDINF_F        (771, 3,HPS_STOP_STREAM   ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)

	WK7STGSOUNDINF_F        (772, 0,HPS_SAFE_PLACE_B  ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
	WK7STGSOUNDINF_F        (772, 1,HPS_TENSHI_B      ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
	WK7STGSOUNDINF_F        (772, 2,HPS_IDOU          ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
	WK7STGSOUNDINF_VOLFADE_F(772, 3,HPS_SAME_STREAM   ,K7SOUND_REVERB_SML, 40, true,WK7PATH_FOOTSE_STONE)

	WK7STGSOUNDINF_F        (773, 0,HPS_SAFE_PLACE_B  ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
	WK7STGSOUNDINF_F        (773, 1,HPS_TENSHI_E      ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
	WK7STGSOUNDINF_F        (773, 2,HPS_TENSHI_E      ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
//	WK7STGSOUNDINF_F        (773, 3,HPS_KRAKUJITU_D   ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
	WK7STGSOUNDINF_F        (773, 4,HPS_KRAKUJITU_C   ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
	WK7STGSOUNDINF_VOLFADE_F(773, 5,HPS_SAME_STREAM   ,K7SOUND_REVERB_SML, 40, true,WK7PATH_FOOTSE_STONE)

	WK7STGSOUNDINF_F        (774, 0,HPS_SAFE_PLACE_C  ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
	WK7STGSOUNDINF_F        (774, 1,HPS_TENSHI_A      ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
	WK7STGSOUNDINF_F        (774, 2,HPS_TENSHI_A      ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
	WK7STGSOUNDINF_VOLFADE_F(774, 3,HPS_SAME_STREAM   ,K7SCN07_REVERB_DEF, 40, true,WK7PATH_FOOTSE_STONE)
	WK7STGSOUNDINF_F        (774, 4,HPS_KRAKUJITU_B   ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)

	WK7STGSOUNDINF_F        (775, 0,HPS_SAFE_PLACE_D  ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
	WK7STGSOUNDINF_F        (775, 1,HPS_TENSHI_C      ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
//	WK7STGSOUNDINF_F        (775, 2,HPS_SPEED_HS      ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)	//LnɂJbg

	WK7STGSOUNDINF_F        (776, 0,HPS_SAFE_PLACE_E  ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
	WK7STGSOUNDINF_F        (776, 1,HPS_SAFE_PLACE_E  ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
	WK7STGSOUNDINF_F        (776, 2,HPS_TENSHI_A      ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
	WK7STGSOUNDINF_F        (776, 3,HPS_TENSHI_A      ,K7SCN07_REVERB_DEF,WK7PATH_FOOTSE_STONE)
	
	WK7STGSOUNDINF_F        (707, 1,HPS_STOP_STREAM   ,K7SOUND_REVERB_BIG,WK7PATH_FOOTSE_STONE)
	
#endif

#ifdef	__K7STAGE_CPP__
	//KVẢ(ReinEX)
	WK7STGSOUNDINF          (120, 0,HPS_STOP_STREAM   ,SOUND_DEFAULT_DSP_RATE)
	//n[}
	WK7STGSOUNDINF          (121, 0,HPS_HORAIZON_B    ,SOUND_DEFAULT_DSP_RATE)
	
	//Ԃ̕
	//WK7STGSOUNDINF          (578, 0,HPS_MONBANFLONT   ,K7SCN07_REVERB_DEF)
	WK7STGSOUNDINF          (573, 0,HPS_GUNKAN        ,K7SOUND_REVERB_BIG)

#endif

#endif	//__K7STAGESOUNDINFO_H__

