////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Player Skill Table
//
// PcSkill.h
//
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__PCSKILL_H__
#define	__PCSKILL_H__

#ifdef	__WK7SKILL_CPP__

/*
	
	XLx l
	
*/
static u8 SkillLevelInitTbl[][SKILL_MAX] = {
//		mGunPower	mShotCancel	mBure	mCriticalSize
		{0,			0,			0,		0				},	// K7DAN
		{0,			0,			0,		0				},	// K7GAL
		{0,			0,			0,		0				},	// K7CAT
		{0,			0,			0,		0				},	// K7HAC
		{0,			0,			0,		0				},	// K7HAS
		{0,			0,			0,		0				},	// K7HAY
		{0,			0,			0,		0				},	// K7CYO
		{0,			0,			0,		0				},	// K7KED
		{0,			0,			0,		0				},	// K7KVN
		{0,			0,			0,		0				}	// K7MSK
};

/*
	
	XLx ől
	
*/
static u8 SkillLevelMaxTbl[][SKILL_MAX] = {
//		mGunPower	mShotCancel	mBure	mCriticalSize	
		{5,			5,			5,		5				},	// K7DAN
		{5,			5,			5,		5				},	// K7GAL
		{5,			5,			5,		5				},	// K7CAT
		{0,			0,			0,		0				},	// K7HAC
		{5,			5,			5,		5				},	// K7HAS
		{0,			0,			0,		0				},	// K7HAY
		{5,			5,			5,		5				},	// K7CYO
		{5,			5,			5,		5				},	// K7KED
		{5,			5,			5,		5				},	// K7KVN
		{5,			5,			5,		5				}	// K7MSK
};

/*
	
	mHp
	
*/
static s16 HpTbl[] = {
//		mHp		
		150,		//K7DAN
		200,		//K7GAL
		100,		//K7CAT
		400,		//K7HAC
		 50,		//K7HAS
		300,		//K7HAY
		150,		//K7CYO
		100,		//K7KED
		150,		//K7KVN
		250,		//K7MSK
};
static f32 MoveSpeedRate[] = {
//		mMoveSpeedRate		
		1.5f,		//K7DAN5
		1.3f,		//K7GAL3
		2.0f,		//K7CAT9
		0.9f,		//K7HAC0
		0.9f,		//K7HAS0
		1.2f,		//K7HAY2
		1.6f,		//K7CYO6
		1.4f,		//K7KED4
		1.7f,		//K7KVN7
		1.3f,		//K7MSK3
};
static f32 SightSpeed[] = {
//		mSightSpeed		
		0.043f,		//K7DAN7
		0.045f,		//K7GAL9
		0.040f,		//K7CAT4
		0.003f,		//K7HAC1
		0.003f,		//K7HAS1
		0.042f,		//K7HAY5
		0.030f,		//K7CYO3
//		0.004f,		//K7KED0
		0.040f,		//K7KED0
		0.044f,		//K7KVN8
		0.037f,		//K7MSK2
};
static f32 PoseSpeed[] = {
//		mPoseSpeed		
		2.4f,		//K7DAN7
		2.4f,		//K7GAL9
		2.4f,		//K7CAT9
		1.2f,		//K7HAC0
		1.2f,		//K7HAS0
		2.4f,		//K7HAY9
		2.4f,		//K7CYO7
		2.2f,		//K7KED5
		2.4f,		//K7KVN9
		2.0f,		//K7MSK4
};
static f32 ReloadSpeed[] = {
//		mReloadSpeed		
		3.2f,		//K7DAN6
		3.1f,		//K7GAL5
		3.5f,		//K7CAT9
		2.6f,		//K7HAC0
		2.6f,		//K7HAS0
		3.3f,		//K7HAY7
		3.3f,		//K7CYO7
		3.0f,		//K7KED4
		2.6f,		//K7KVN0
		2.9f,		//K7MSK3
};

static f32 Zoom[] = {
//		mZoom		
		38.f,		//K7DAN6
		44.f,		//K7GAL3
		44.f,		//K7CAT3
		 9.f,		//K7HAC9
		85.f,		//K7HAS0
		40.f,		//K7HAY5
		38.f,		//K7CYO6
//		 9.f,		//K7KED9
		35.f,		//K7KED9
		42.f,		//K7KVN4
		45.f,		//K7MSK0
};

/*
	͂̎w֑̃xȔꍇ
*/
static  s16 Lv6Power[] = {
		48,			//K7DAN
		25,			//K7GAL
		28,			//K7CAT
		120,		//K7HAC
		120,		//K7HAS
		120,		//K7HAY
		45,			//K7CYO
		38,			//K7KED
		30,			//K7KVN
		186,		//K7MSK
};

static  s16 Lv6Power_PowerUp[] = {
		60,			//K7DAN
		0,			//K7GAL
		0,			//K7CAT
		0,			//K7HAC
		0,			//K7HAS
		0,			//K7HAY
		0,			//K7CYO
		0,			//K7KED
		0,			//K7KVN
		0,			//K7MSK
};


/*
	
	XL̃xƂ̒le[uiDAN
	
*/
static PCGROWSKILLPARAM GrowSkillParamTblDAN[GRAWSKILL_LEVEL_MAX] = {
//			mGunPower	mShotCancel	mBure	mCriticalSize	
/*0*/	{	25,			17,				0.7f,	1.6f,			},	// Lv0
/*1*/	{	28,			16,				0.6f,	1.7f,			},	// Lv1
/*2*/	{	31,			15,				0.5f,	1.8f,			},	// Lv2
/*3*/	{	34,			12,				0.4f,	1.9f,			},	// Lv3
/*4*/	{	37,			11,				0.3f,	2.0f,			},	// Lv4
/*5*/	{	40,			10,				0.2f,	2.2f,			},	// Lv5
};



/*
	
	XL̃xƂ̒le[uiDANp[Abv
	
*/
static PCGROWSKILLPARAM GrowSkillParamTblDAN_PowerUp[GRAWSKILL_LEVEL_MAX] = {
//			mGunPower	mShotCancel	mBure	mCriticalSize	
/*0*/	{	28,			16,				0.6f,	1.8f,			},	// Lv0
/*1*/	{	31,			15,				0.5f,	1.9f,			},	// Lv1
/*2*/	{	34,			14,				0.4f,	2.0f,			},	// Lv2
/*3*/	{	37,			11,				0.3f,	2.1f,			},	// Lv3
/*4*/	{	40,			10,				0.2f,	2.2f,			},	// Lv4
/*5*/	{	50,			 9,				0.1f,	2.4f,			},	// Lv5
};


/*
	
	XL̃xƂ̒le[uiGAL
	
*/
static PCGROWSKILLPARAM GrowSkillParamTblGAL[GRAWSKILL_LEVEL_MAX] = {
//			mGunPower	mShotCancel	mBure	mCriticalSize	
/*0*/	{	8,			17,				0.5f,	1.2f,			},	// Lv0
/*1*/	{	10,			16,				0.4f,	1.3f,			},	// Lv1
/*2*/	{	13,			15,				0.3f,	1.4f,			},	// Lv2
/*3*/	{	16,			12,				0.2f,	1.5f,			},	// Lv3
/*4*/	{	18,			11,				0.1f,	1.6f,			},	// Lv4
/*5*/	{	21,			10,				0.1f,	1.8f,			},	// Lv5
};

/*
	
	XL̃xƂ̒le[uiGALp[Abv
	
*/
static PCGROWSKILLPARAM GrowSkillParamTblGAL_PowerUp[GRAWSKILL_LEVEL_MAX] = {
//			mGunPower	mShotCancel	mBure	mCriticalSize	
/*0*/	{	30,			17,				0.4f,	1.3f,			},	// Lv0
/*1*/	{	32,			16,				0.3f,	1.4f,			},	// Lv1
/*2*/	{	35,			15,				0.2f,	1.5f,			},	// Lv2
/*3*/	{	38,			12,				0.1f,	1.6f,			},	// Lv3
/*4*/	{	41,			11,				0.1f,	1.7f,			},	// Lv4
/*5*/	{	45,			10,				0.1f,	1.9f,			},	// Lv5
};

/*
	
	XL̃xƂ̒le[uiCON
	
*/
static PCGROWSKILLPARAM GrowSkillParamTblCON[GRAWSKILL_LEVEL_MAX] = {
//			mGunPower	mShotCancel	mBure	mCriticalSize	
/*0*/	{	10,			11,				0.9f,	1.1f,			},	// Lv0
/*1*/	{	13,			10,				0.8f,	1.2f,			},	// Lv1
/*2*/	{	16,			9,				0.7f,	1.3f,			},	// Lv2
/*3*/	{	18,			8,				0.6f,	1.4f,			},	// Lv3
/*4*/	{	21,			7,				0.5f,	1.5f,			},	// Lv4
/*5*/	{	24,			6,				0.4f,	1.7f,			},	// Lv5
};

/*
	
	XL̃xƂ̒le[uiHAC
	
*/
static PCGROWSKILLPARAM GrowSkillParamTblHAC[GRAWSKILL_LEVEL_MAX] = {
//			mGunPower	mShotCancel	mBure	mCriticalSize	
/*0*/	{	100,		70,				0.2f,	1.7f,			},	// Lv0

/*1*/	{	10,			16,				0.9f,	0.9f,			},	// Lv1
/*2*/	{	13,			15,				0.8f,	1.0f,			},	// Lv2
/*3*/	{	16,			12,				0.7f,	1.1f,			},	// Lv3
/*4*/	{	18,			11,				0.6f,	1.2f,			},	// Lv4
/*5*/	{	21,			10,				0.5f,	1.3f,			},	// Lv5
};

/*
	
	XL̃xƂ̒le[uiHAY
	
*/
static PCGROWSKILLPARAM GrowSkillParamTblHAY[GRAWSKILL_LEVEL_MAX] = {
//			mGunPower	mShotCancel	mBure	mCriticalSize	
/*0*/	{	45,			4,				0.2f,	3.8f,			},	// Lv0
/*1*/	{	45,			4,				0.2f,	3.8f,			},	// Lv0
/*2*/	{	45,			4,				0.2f,	3.8f,			},	// Lv0
/*3*/	{	45,			4,				0.2f,	3.8f,			},	// Lv0
/*4*/	{	45,			4,				0.2f,	3.8f,			},	// Lv0
/*5*/	{	45,			4,				0.2f,	3.8f,			},	// Lv0

//	/*0*/	{	20,			8,				0.8f,	2.0f,			},	// Lv0
///*1*/	{	30,			7,				0.6f,	2.2f,			},	// Lv1
///*2*/	{	40,			6,				0.5f,	2.4f,			},	// Lv2
///*3*/	{	55,			5,				0.4f,	2.6f,			},	// Lv3
///*4*/	{	80,			5,				0.3f,	3.0f,			},	// Lv4
///*5*/	{	100,		4,				0.1f,	3.8f,			},	// Lv5
};

/*
	
	XL̃xƂ̒le[uiCYO
	
*/
static PCGROWSKILLPARAM GrowSkillParamTblCYO[GRAWSKILL_LEVEL_MAX] = {
//			mGunPower	mShotCancel	mBure	mCriticalSize	
/*0*/	{	20,			15,				0.8f,	1.4f,			},	// Lv0
/*1*/	{	23,			14,				0.7f,	1.6f,			},	// Lv1
/*2*/	{	26,			13,				0.6f,	1.8f,			},	// Lv2
/*3*/	{	30,			12,				0.5f,	2.0f,			},	// Lv3
/*4*/	{	34,			10,				0.4f,	2.3f,			},	// Lv4
/*5*/	{	38,			8,				0.3f,	2.7f,			},	// Lv5
};

/*
	
	XL̃xƂ̒le[uiKED
	
*/
static PCGROWSKILLPARAM GrowSkillParamTblKED[GRAWSKILL_LEVEL_MAX] = {
//			mGunPower	mShotCancel	mBure	mCriticalSize	
/*0*/	{	16,			17,				0.5f,	1.4f,			},	// Lv0
/*1*/	{	18,			16,				0.4f,	1.5f,			},	// Lv1
/*2*/	{	21,			15,				0.3f,	1.6f,			},	// Lv2
/*3*/	{	24,			14,				0.2f,	1.7f,			},	// Lv3
/*4*/	{	27,			13,				0.1f,	1.8f,			},	// Lv4
/*5*/	{	32,			11,				0.1f,	2.0f,			},	// Lv5
#if 0
/*6*/	{	36,			9,				0.4f,	1.9f,			},	// Lv6
/*7*/	{	39,			8,				0.3f,	2.0f,			},	// Lv7
/*8*/	{	42,			7,				0.2f,	2.1f,			},	// Lv8
/*9*/	{	100,		6,				0.1f,	2.2f,			},	// Lv9
#endif
};

/*
	
	XL̃xƂ̒le[uiKVN
	
*/
static PCGROWSKILLPARAM GrowSkillParamTblKVN[GRAWSKILL_LEVEL_MAX] = {
//			mGunPower	mShotCancel	mBure	mCriticalSize	
/*0*/	{	10,			17,				0.0f,	1.3f,			},	// Lv0
/*1*/	{	13,			16,				0.0f,	1.4f,			},	// Lv1
/*2*/	{	16,			15,				0.0f,	1.5f,			},	// Lv2
/*3*/	{	18,			14,				0.0f,	1.6f,			},	// Lv3
/*4*/	{	21,			13,				0.0f,	1.7f,			},	// Lv4
/*5*/	{	24,			12,				0.0f,	1.9f,			},	// Lv5
#if 0
/*6*/	{	27,			9,				0.0f,	1.7f,			},	// Lv6
/*7*/	{	30,			8,				0.0f,	1.8f,			},	// Lv7
/*8*/	{	33,			7,				0.0f,	1.9f,			},	// Lv8
/*9*/	{	100,		6,				0.0f,	2.0f,			},	// Lv9
#endif
};

/*
	
	XL̃xƂ̒le[uiMSK
	
*/
static PCGROWSKILLPARAM GrowSkillParamTblMSK[GRAWSKILL_LEVEL_MAX] = {
//			mGunPower	mShotCancel	mBure	mCriticalSize	
/*0*/	{	90,			17,				1.0f,	1.1f,			},	// Lv0
/*1*/	{	100,		16,				0.9f,	1.2f,			},	// Lv1
/*2*/	{	115,		15,				0.8f,	1.3f,			},	// Lv2
/*3*/	{	135,		12,				0.7f,	1.4f,			},	// Lv3
/*4*/	{	165,		11,				0.6f,	1.5f,			},	// Lv4
/*5*/	{	200,		10,				0.5f,	1.7f,			},	// Lv5
#if 0
/*6*/	{	210,		9,				0.4f,	1.5f,			},	// Lv6
/*7*/	{	220,		8,				0.3f,	1.6f,			},	// Lv7
/*8*/	{	230,		7,				0.2f,	1.7f,			},	// Lv8
/*9*/	{	240,		6,				0.1f,	1.8f,			},	// Lv9
#endif
};

/*
	
	XLRXg
	
*/
static u8 SkillLevelCostTblDAN[][SKILL_MAX] = {
//		mGunPower	mShotCancel	mBure	mCriticalSize	
/*0*/	{1,			1,			1,		1				},	// 
/*1*/	{2,			2,			2,		2				},	// 
/*2*/	{4,			4,			4,		4				},	// 
/*3*/	{10,		10,			10,		10				},	// 
/*4*/	{26,		26,			26,		26				}	// 
};
static u8 SkillLevelCostTblCON[][SKILL_MAX] = {
//		mGunPower	mShotCancel	mBure	mCriticalSize	
/*0*/	{1,			1,			1,		1				},	// 
/*1*/	{2,			2,			2,		2				},	// 
/*2*/	{4,			4,			4,		4				},	// 
/*3*/	{10,		10,			10,		10				},	// 
/*4*/	{26,		26,			26,		26				}	// 
};
static u8 SkillLevelCostTblKED[][SKILL_MAX] = {
//		mGunPower	mShotCancel	mBure	mCriticalSize	
/*0*/	{1,			1,			1,		1				},	// 
/*1*/	{2,			2,			2,		2				},	// 
/*2*/	{4,			4,			4,		4				},	// 
/*3*/	{10,		10,			10,		10				},	// 
/*4*/	{26,		26,			26,		26				}	// 
};
static u8 SkillLevelCostTblCYO[][SKILL_MAX] = {
//		mGunPower	mShotCancel	mBure	mCriticalSize	
/*0*/	{1,			1,			1,		1				},	// 
/*1*/	{2,			2,			2,		2				},	// 
/*2*/	{4,			4,			4,		4				},	// 
/*3*/	{10,		10,			10,		10				},	// 
/*4*/	{26,		26,			26,		26				}	// 
};
static u8 SkillLevelCostTblKVN[][SKILL_MAX] = {
//		mGunPower	mShotCancel	mBure	mCriticalSize	
/*0*/	{1,			1,			1,		1				},	// 
/*1*/	{2,			2,			2,		2				},	// 
/*2*/	{4,			4,			4,		4				},	// 
/*3*/	{10,		10,			10,		10				},	// 
/*4*/	{26,		26,			26,		26				}	// 
};
static u8 SkillLevelCostTblMSK[][SKILL_MAX] = {
//		mGunPower	mShotCancel	mBure	mCriticalSize	
/*0*/	{1,			1,			1,		1				},	// 
/*1*/	{2,			2,			2,		2				},	// 
/*2*/	{4,			4,			4,		4				},	// 
/*3*/	{10,		10,			10,		10				},	// 
/*4*/	{26,		26,			26,		26				}	// 
};




/*
	
		JE^[U
	
*/
static ABILITYCOST cost_SKILLABILITY_COUNTERATTACK[K7PCMAX] = {
//		mGunPower	mShotCancel	mBure		mCriticalSize	
	{	2,			2,				2,			2,			},	// K7DAN
	{	99,			0,				0,			0,			},	// K7GAL
	{	2,			2,				2,			2,			},	// K7CAT
	{	99,			0,				0,			0,			},	// K7HAC
	{	99,			0,				0,			0,			},	// K7HAS
	{	99,			0,				0,			0,			},	// K7HAY
	{	2,			2,				2,			2,			},	// K7CYO
	{	1,			1,				1,			1,			},	// K7KED
	{	2,			2,				2,			2,			},	// K7KVN
	{	1,			1,				1,			1,			},	// K7MSK
};

/*
	
		iU
	
*/
static ABILITYCOST cost_SKILLABILITY_DOWNATTACK[K7PCMAX] = {
//		mGunPower	mShotCancel	mBure		mCriticalSize	
	{	1,			1,				0,			0,			},	// K7DAN
	{	0,			0,				0,			0,			},	// K7GAL
	{	1,			1,				0,			0,			},	// K7CAT
	{	99,			0,				0,			0,			},	// K7HAC
	{	99,			0,				0,			0,			},	// K7HAS
	{	99,			0,				0,			0,			},	// K7HAY
	{	1,			1,				0,			0,			},	// K7CYO
	{	1,			1,				0,			0,			},	// K7KED
	{	1,			1,				0,			0,			},	// K7KVN
	{	1,			1,				0,			0,			},	// K7MSK
};

/*
	
		_bNI
	
*/
static ABILITYCOST cost_SKILLABILITY_CRITICALLOCKON[K7PCMAX] = {
//		mGunPower	mShotCancel	mBure		mCriticalSize	
	{	5,			5,				5,			5,			},	// K7DAN
	{	99,			5,				5,			5,			},	// K7GAL
	{	4,			4,				4,			4,			},	// K7CAT
	{	99,			5,				5,			5,			},	// K7HAC
	{	99,			5,				5,			5,			},	// K7HAS
	{	99,			5,				5,			5,			},	// K7HAY
	{	5,			5,				5,			5,			},	// K7CYO
	{	4,			4,				4,			4,			},	// K7KED
	{	5,			5,				5,			5,			},	// K7KVN
	{	5,			5,				5,			5,			},	// K7MSK
};

/*
	
		wbhbNI
	
*/
static ABILITYCOST cost_SKILLABILITY_HEADLOCKON[K7PCMAX] = {
//		mGunPower	mShotCancel	mBure		mCriticalSize	
	{	0,			0,				3,			3,			},	// K7DAN
	{	99,			0,				0,			0,			},	// K7GAL
	{	99,			0,				0,			0,			},	// K7CAT
	{	99,			0,				0,			0,			},	// K7HAC
	{	99,			0,				0,			0,			},	// K7HAS
	{	99,			0,				0,			0,			},	// K7HAY
	{	99,			0,				0,			0,			},	// K7CYO
	{	99,			0,				0,			0,			},	// K7KED
	{	99,			0,				0,			0,			},	// K7KVN
	{	99,			0,				0,			0,			},	// K7MSK
};

/*
	
		bNI
	
*/
static ABILITYCOST cost_SKILLABILITY_JOINTLOCKON[K7PCMAX] = {
//		mGunPower	mShotCancel	mBure		mCriticalSize	
	{	99,			0,				0,			0,			},	// K7DAN
	{	99,			0,				0,			0,			},	// K7GAL
	{	99,			0,				0,			0,			},	// K7CAT
	{	99,			0,				0,			0,			},	// K7HAC
	{	99,			0,				0,			0,			},	// K7HAS
	{	99,			0,				0,			0,			},	// K7HAY
	{	0,			2,				2,			0,			},	// K7CYO
	{	99,			0,				0,			0,			},	// K7KED
	{	99,			0,				0,			0,			},	// K7KVN
	{	99,			0,				0,			0,			},	// K7MSK
};

/*
	
		^E`
	
*/
static ABILITYCOST cost_SKILLABILITY_CHARGESHOT[K7PCMAX] = {
//		mGunPower	mShotCancel	mBure		mCriticalSize	
	{	0,			0,				0,			0,			},	// K7DAN
	{	99,			0,				0,			0,			},	// K7GAL
	{	99,			0,				0,			0,			},	// K7CAT
	{	99,			0,				0,			0,			},	// K7HAC
	{	99,			0,				0,			0,			},	// K7HAS
	{	99,			0,				0,			0,			},	// K7HAY
	{	0,			0,				0,			0,			},	// K7CYO
	{	99,			0,				0,			0,			},	// K7KED
	{	0,			0,				0,			0,			},	// K7KVN
	{	0,			0,				0,			0,			},	// K7MSK
};

/*
	
		ꌂʌ
	
*/
static ABILITYCOST cost_SKILLABILITY_DEADLYBLOW[K7PCMAX] = {
//		mGunPower	mShotCancel	mBure		mCriticalSize	
	{	99,			0,				0,			0,			},	// K7DAN
	{	99,			0,				0,			0,			},	// K7GAL
	{	99,			0,				0,			0,			},	// K7CAT
	{	99,			0,				0,			0,			},	// K7HAC
	{	99,			0,				0,			0,			},	// K7HAS
	{	99,			0,				0,			0,			},	// K7HAY
	{	4,			0,				0,			4,			},	// K7CYO
	{	99,			0,				0,			0,			},	// K7KED
	{	99,			0,				0,			0,			},	// K7KVN
	{	99,			0,				0,			0,			},	// K7MSK
};

/*
	
		ZJho[XgiP̒ełQAŔˁj
	
*/
static ABILITYCOST cost_SKILLABILITY_DOUBLEQUICKSHOT[K7PCMAX] = {
//		mGunPower	mShotCancel	mBure		mCriticalSize	
	{	 0,			2,				0,			0,			},	// K7DAN
	{	99,			0,				0,			0,			},	// K7GAL
	{	99,			0,				0,			0,			},	// K7CAT
	{	99,			0,				0,			0,			},	// K7HAC
	{	99,			0,				0,			0,			},	// K7HAS
	{	99,			0,				0,			0,			},	// K7HAY
	{	 0,			3,				0,			0,			},	// K7CYO
	{	 0,			3,				0,			0,			},	// K7KED
	{	99,			0,				0,			0,			},	// K7KVN
	{	99,			0,				0,			0,			},	// K7MSK
};

/*
	
		gvo[XgiP̒ełRAŔˁj
	
*/
static ABILITYCOST cost_SKILLABILITY_TRIPLEQUICKSHOT[K7PCMAX] = {
//		mGunPower	mShotCancel	mBure		mCriticalSize	
	{	 0,			4,				0,			0,			},	// K7DAN
	{	99,			0,				0,			0,			},	// K7GAL
	{	99,			0,				0,			0,			},	// K7CAT
	{	99,			0,				0,			0,			},	// K7HAC
	{	99,			0,				0,			0,			},	// K7HAS
	{	99,			0,				0,			0,			},	// K7HAY
	{	99,			0,				0,			0,			},	// K7CYO
	{	99,			0,				0,			0,			},	// K7KED
	{	99,			0,				0,			0,			},	// K7KVN
	{	99,			0,				0,			0,			},	// K7MSK
};

/*
	
		QAbNI
	
*/
static ABILITYCOST cost_SKILLABILITY_DOUBLECHAIN[K7PCMAX] = {
//		mGunPower	mShotCancel	mBure		mCriticalSize	
	{	99,			0,				0,			0,			},	// K7DAN
	{	99,			0,				0,			0,			},	// K7GAL
	{	99,			0,				0,			0,			},	// K7CAT
	{	99,			0,				0,			0,			},	// K7HAC
	{	99,			0,				0,			0,			},	// K7HAS
	{	99,			0,				0,			0,			},	// K7HAY
	{	99,			0,				0,			0,			},	// K7CYO
	{	99,			0,				0,			0,			},	// K7KED
	{	99,			0,				0,			0,			},	// K7KVN
	{	99,			0,				0,			0,			},	// K7MSK
};

/*
	
		RAbNI
	
*/
static ABILITYCOST cost_SKILLABILITY_TRIPLECHAIN[K7PCMAX] = {
//		mGunPower	mShotCancel	mBure		mCriticalSize	
	{	99,			0,				0,			0,			},	// K7DAN
	{	99,			0,				0,			0,			},	// K7GAL
	{	99,			0,				0,			0,			},	// K7CAT
	{	99,			0,				0,			0,			},	// K7HAC
	{	99,			0,				0,			0,			},	// K7HAS
	{	99,			0,				0,			0,			},	// K7HAY
	{	99,			0,				0,			0,			},	// K7CYO
	{	99,			0,				0,			0,			},	// K7KED
	{	99,			0,				0,			0,			},	// K7KVN
	{	99,			0,				0,			0,			},	// K7MSK
};

/*
	
		QA_bNI
	
*/
static ABILITYCOST cost_SKILLABILITY_DEADLYCHAIN[K7PCMAX] = {
//		mGunPower	mShotCancel	mBure		mCriticalSize	
	{	99,			0,				0,			0,			},	// K7DAN
	{	99,			0,				0,			0,			},	// K7GAL
	{	99,			0,				0,			0,			},	// K7CAT
	{	99,			0,				0,			0,			},	// K7HAC
	{	99,			0,				0,			0,			},	// K7HAS
	{	99,			0,				0,			0,			},	// K7HAY
	{	99,			0,				0,			0,			},	// K7CYO
	{	99,			0,				0,			0,			},	// K7KED
	{	99,			0,				0,			0,			},	// K7KVN
	{	99,			0,				0,			0,			},	// K7MSK
};

/*
	
		Ĝ炢[VxȂ
	
*/
static ABILITYCOST cost_SKILLABILITY_ENEMYSLOW[K7PCMAX] = {
//		mGunPower	mShotCancel	mBure		mCriticalSize	
	{	4,			0,				0,			4,			},	// K7DAN
	{	99,			1,				1,			1,			},	// K7GAL
	{	99,			1,				1,			1,			},	// K7CAT
	{	99,			0,				0,			0,			},	// K7HAC
	{	99,			0,				0,			0,			},	// K7HAS
	{	99,			0,				0,			0,			},	// K7HAY
	{	99,			1,				1,			1,			},	// K7CYO
	{	99,			1,				1,			1,			},	// K7KED
	{	3,			0,				0,			3,			},	// K7KVN
	{	99,			1,				1,			1,			},	// K7MSK
};

/*
	
		VCXp[NOiEhVbgj
	
*/
static ABILITYCOST cost_SKILLABILITY_ROUNDSHOT[K7PCMAX] = {
//		mGunPower	mShotCancel	mBure		mCriticalSize	
	{	99,			0,				0,			0,			},	// K7DAN
	{	99,			0,				0,			1,			},	// K7GAL
	{	99,			0,				0,			1,			},	// K7CAT
	{	99,			0,				0,			1,			},	// K7HAC
	{	99,			0,				0,			1,			},	// K7HAS
	{	99,			0,				0,			1,			},	// K7HAY
	{	99,			0,				0,			1,			},	// K7CYO
	{	99,			0,				0,			1,			},	// K7KED
	{	3,			2,				2,			2,			},	// K7KVN
	{	99,			0,				0,			1,			},	// K7MSK
};



#else



#endif

#endif

