////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Watanabe Define
//
// WK7Define.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/09/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7DEFINE_H__
#define	__WK7DEFINE_H__

//#include "..\Lib\ghmGcDefine.h"

#define	WK7_FNAME_MAX				(256)

#define	WK7_SCREEN_WIDTH			K7APP_SCREEN_WIDTH
#define	WK7_SCREEN_HEIGHT			K7APP_SCREEN_HEIGHT

#define	WK7_SCREEN_CENTER_X			(WK7_SCREEN_WIDTH /2)
#define	WK7_SCREEN_CENTER_Y			(WK7_SCREEN_HEIGHT/2)

#define	WK7_3DDATA_FOLDER			"3Ddata/"
#define	WK7_MODEL_FOLDER			"Model/"
#define	WK7_MOTION_FOLDER			"Motion/"
#define	WK7_CHARA_FOLDER			"Chara/"
#define	WK7_STAGE_FOLDER			"Stage/"
#define	WK7_ITEM_FOLDER				"Item/"

#define	WK7_FRAME_COUNT				(2)										// Qt
#define	WK7_FRAME_RATE				(60/WK7_FRAME_COUNT)					// frame / sec
#define	WK7_TICK_PER_SEC			(4800)									// tick / sec
#define	WK7_TICK_PER_FRAME			((int)(WK7_TICK_PER_SEC/WK7_FRAME_RATE))
#define	WK7_SEC_PER_TICK			(1.0f / 4800.0f)						// sec / tick

#define	WK7_INV_FRAME_RATE			(1.0f / WK7_FRAME_RATE)

#define	WK7_SEC_TO_TICK(sec)		((u32)((sec) * WK7_TICK_PER_SEC))
#define	WK7_TICK_TO_SEC(tick)		((tick) * (f32)WK7_SEC_PER_TICK)

#define	WK7_FRAME_TO_TICK(frame)	((frame) * WK7_TICK_PER_FRAME)
#define	WK7_TICK_TO_FRAME(tick)		((tick) / WK7_TICK_PER_FRAME)

#define	WK7_FRAME_TO_SEC(frame)		((frame) / WK7_FRAME_RATE)
#define	WK7_SEC_TO_FRAME(sec)		((u32)((sec) * WK7_FRAME_RATE))

#define WK7_DEFAULT_FADE_TICK		WK7_SEC_TO_TICK(0.5f)

#include ".\K7App.h"

#endif	//__WK7DEFINE_H__

