////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Non Player Charactor Object
//
// WK7Npc.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7NPC_H__
#define	__WK7NPC_H__

//#include <sysdolphin\baselib.h>
//#include "..\Lib\ghmGcDefine.h"
//#include "..\Lib\ghmGcColl.h"
#include "..\Yam\YK7EffectHeader.h"
#include ".\WK7Player.h"
#include ".\WK7Chara.h"
#include ".\WK7Obj.h"
#include ".\WK7EnemyList.h"
//#include ".\K7ID.h"
#include "..\Fujita\C_setalpha.h"
#if FUJITA
#include "..\Fujita\c_trigon.h"
#include "..\Fujita\c_tumor.h"
#endif

class WK7NpcFindData;

// pX
enum WK7PathSearchResult{
	PATHSEARESULT_WALL    = 0	,			// Ƒ̊ԂɏQB
	PATHSEARESULT_HITAREA = -1	,			// Ƒ̊ԂɏQiRWj
	PATHSEARESULT_NOWALL  = 1	,			// Ƒ̊ԂɏQ
};

// mob̃Xe[^Xp
enum WK7NpcControlState{
	NPC_STATE_INIT = 0,			// l
	NPC_STATE_WAIT,				// R
	NPC_STATE_TURN,				// ^[
	NPC_STATE_RUN,				// 
	NPC_STATE_WALK,				// 
	NPC_STATE_JET,				// 
	NPC_STATE_ATK,				// U
	NPC_STATE_DMG,				// ꒆ
	NPC_STATE_DMG_FALL,			// |ꒆ
	NPC_STATE_DOWN,				// _E
	NPC_STATE_DOWN_DMG,			// _Eꒆ
	NPC_STATE_DIE,				// ꎀS
	NPC_STATE_LOSS,				// ꎀSA
	NPC_STATE_SHOTPOSE,			// ˌ\
	NPC_STATE_SHOTFREE,			// ˌR
	NPC_STATE_SHOTNOW,			// ˌ
	NPC_STATE_SHOTWAIT,			// ˌEGCg
	NPC_STATE_RELOAD,			// [h
	NPC_STATE_POP,				// |bvw
	NPC_STATE_REPOPWAIT,		// |bvҋ@
	NPC_STATE_EVENT,			// Cxg
	NPC_STATE_EXTPOP,			// o
	NPC_STATE_LASERSINK,		// [U[grB
	NPC_STATE_SPD_WAIT,			// ꎩR̂̂QiXs[hpj
	NPC_STATE_SPD_MOVESTART,	// Xs[hX}CsJn
	NPC_STATE_SPD_EGG,			// Xs[hX}C
	NPC_STATE_KERENMI_DMG,		// ݋炢
	NPC_STATE_HSBORN,			// gr܂ꒆ
	NPC_STATE_TAMAGOHAKI,		// f
	NPC_STATE_TAMAGOHAKARE,		// fꒆ
	NPC_STATE_FALL,				// 
	NPC_STATE_FALLEND,			// I
	NPC_STATE_DMGWARP,			// _[W[v
	NPC_STATE_DIVING,			// _CrOX}CԒ
	NPC_STATE_ACTION,			// ANV
	NPC_STATE_ZOMBIWAIT,		// QĂԁiłȂj
	NPC_STATE_ZOMBIPOP,			// QĂԂNオ
	NPC_STATE_ESCAPE,			// PCGAO̎̃GXP[v
	NPC_STATE_MAX,				// Ԃ̍ől
};


// mob̈ړ[h
enum WK7NpcMovePosMode{
	NPC_POSMODE_PROG,
	NPC_POSMODE_DATA,
};

// mob̂`h
enum WK7NpcAi{
	NPCAI_INIT = 0,							// l
	NPCAI_WAIT_EVENT,						// ҋ@iCxgj
	NPCAI_WAIT_EVENT_GO,					// JnR}hs
	NPCAI_FIRST_ATK,						// 
	NPCAI_WAIT,								// ҋ@i_j
	NPCAI_SERACH,							// G
	NPCAI_FOLLOW,							// ǔ
	NPCAI_EXIT	,							// I
};


// mob̃`[gAp̃R}h
enum WK7NpcTutorial{
	NPCTUTO_INIT = 0,						// R}hl
	NPCTUTO_WAIT,							// R}hҋ@
	NPCTUTO_FIRSTPOP,						// |bv
	NPCTUTO_ESCAPE,							// 
};


// mob̎񂾂Ƃ̃^Cv
enum WK7NpcDieMode{
	NPC_DIE_JIBAKU = 1,						// 
	NPC_DIE_INSTANT,						// ꌂKE
	NPC_DIE_DIE,							// ʂɎS
};


// _p
typedef struct _NPCWEAK{
//	WK7JObj 	*mpHide;					// {[iIuWFNg\E\pj
	WK7JObj 	*mpBone;					// {[i蔻pj
	WK7JObj 	*mpSkin;					// XLiGtFNgŎgpj
	s16			mWeakDam;					// ʂƂ̃_[Wilȏ~ςꂽjj
}NPCWEAK;

// XL
typedef struct _SCAN{
	WK7RenderObjEffect	*mpScanMarkerRenderObjEffect;
	EFFECT				*mpScanMarkerEfc;			// GtFNgpigpĂȂj
	s16					frame;						// o
}SCAN;

// mobf[^
typedef struct _NPCDATA{
	s16			mHp;						// qbg|Cg
	s16			mHpBk;						// qbg|Cg
	s16			mWeakID;					// _hc
	s16			mWeakIDBk;					// _hc
	s16			mVLossID;					// ʐтhc
	s16			mVLossIDBk;					// ʐтhc
	int			mFootSe;					// 
	f32			mScale;						// XP[
	u8			mCounterKurai;				// JE^[U炢\H
	u8			mMultiChara;				// ƂgrĂ
	u8			mBloodTexNum;				// GtFNg̃eNX`ԍit[HSpj
	u8			mTypeEggOya;				// fe
	u8			mTypeEgg;					// 
	u8			mTypeBig;					// ln
	u8			mCeiling;					// VtO
	u8			mNoWaitMot;					// R̃[VĂȂ
	f32			mAtkDist;					// U
	f32			mAtkDistBk;					// U
	f32			mBombDist;					// Δj
	f32			mBombDistBk;				// Δj
	u32			mAtkPower1;					// U͂P
	u32			mAtkPower2;					// U͂Q
	s8			mTumorEfcType;				// cᇕ\ ^CvID
	bool		mNoMove;					// ړȂ
	u16			mBloodVolume;				// Ă錌̗
	u8			mHopper;					// zbp[}[h
}NPCDATA;


// `h
typedef struct _NPCAI{
	WK7NpcAi	mMode;						// `h[h
	u32			mCount;						// ėpJE^[
	union{
		struct{
			u32	mRunPlz      : 1;			// tO
			u32	mFlagPad     :31;
		};
		u32		mFlag;
	};
}NPCAI;


// NPC̃Xs[hRg[p
typedef struct _NPCSPEED{
	f32			mMotSpSpeed[2];			// [VXs[hXyVA^bNȂǍŗD掞Ǘp
	f32			mMotSpeed[2];				// [VXs[hǗp
	f32			mMotDmgSpeed[2];			// [VXs[h_[WǗp
}NPCSPEED;

// _[Wiᇁj
typedef struct _TUMOR{
	s16			mLv;							// ᇃx
	s16			mLvMax;							// ᇃxiő僌xj
	u32			mRecover;						// ᇂ߂鎞
}TUMOR;

// _[W
typedef struct _NPCDAMAGE{
	WK7Chara		*mpDamChara;				// _[W^l
	WK7JObj 		*mpObjBone;					// _[W֐߃{[
	WK7JObj 		*mpObjSkin;					// _[W֐߃XL
	s16				mNearHitID;					// _[W֐߂̂hc
	Vec				mDamDir;					// _[W
	Vec				mDamPos;					// _[WƂ̃|WVi[hj
	s16				mDamPoint;					// _[Wl
	f32				mDamTameRate;				// _[Wߋ
	WK7NpcDamType	mDamType;					// _[W^Cv
	
	s16				mDamHitRequest;				// _[W炢܂\tO
	s16				mDamHitNextRequest;			// _[W炢܂\tOiǉUpj
	u8				mDamWeakHitOk;				// _qbgOKH
	u8				mDamExHitOk;				// ʃqbgOKHi蓖ĂĂꍇj
//	s16				mDamScrX;					// _[WHƂ̃XN[Ww
//	s16				mDamScrY;					// _[WHƂ̃XN[Wx
	
	s16				mDamBackTiming;				// ]̏oJE^[
	s16				mDamDieCount;				// S܂ł̃JE^[
	TUMOR			mTumor;						// ᇃVXe
}NPCDAMAGE;


// P[V̊Ǘe[umobpiꂪ[VɊmۂj
class WK7NpcMotion : public ghmGcListObj{
public:
	enum State{
		IDLE = 0,
		LOADING,
		LOADED,
		RELEASEARCHIVE,
		RELEASEDARCHIVE,
		RESTOREARCHIVE,
	};
protected:
	WK7CharaMotion			*mpMotion;				// [V
	u32						mMotionID;				// [Vhc
	int						mCommonMotionID;		// ʃ[Vhc
	State					mState;
	
	WK7NpcMotion();
	
	bool LoadingProcess(void);
	bool ReleaseArchiveProcess(void);
	bool RestoreArchiveProcess(void);
	bool SetState(State state);
public:
	WK7NpcMotion(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	virtual ~WK7NpcMotion();
	
	inline WK7NpcMotion* GetPrev(void){ return (WK7NpcMotion *)ghmGcListObj::GetPrev(); }
	inline WK7NpcMotion* GetNext(void){ return (WK7NpcMotion *)ghmGcListObj::GetNext(); }
	inline State GetState(void){ return mState; }
	
	inline u32 GetID(void){ return mMotionID; }
	inline int GetCommonMotionID(void){ return mCommonMotionID; }
	
	bool CreateMotion(u32 motid,int cmnid);
	bool ReleaseMotion(void);
	inline WK7CharaMotion* GetMotion(void){ return mpMotion; }
	
	bool ReleaseArchive(void);
	bool RestoreArchive(void);
	bool FrameProcess(void);
	
	bool IsLoading(void);
};

#define SFX_BT_HS_WARAI_START_MAX	(2)
#define SFX_BT_HS_JIBAKU_MAX		(1)
#define SFX_BT_HS_DEATH_MAX			(3)

#define	WK7NPC_VALID_POSX				(1)
#define	WK7NPC_VALID_POSY				(2)
#define	WK7NPC_VALID_POSZ				(4)

#define	WK7NPC_FINDTARGET_NORMAL		(1)
#define	WK7NPC_FINDTARGET_SILHOUETTE	(2)
#define	WK7NPC_FINDTARGET_BOTH			(WK7NPC_FINDTARGET_SILHOUETTE|WK7NPC_FINDTARGET_NORMAL)
#define	WK7NPC_FINDTARGET_DEFAULT		(WK7NPC_FINDTARGET_NORMAL)


#define E18_CORE_SIMPLE	(0)			// RAP
#define E18_CORE_PLURAL	(1)			// RA


typedef	WK7Npc* WK7NpcCreateFunc(u32 type,u32 suffix);

//
// Non Player Charactor Object
//
class WK7Npc : public WK7Obj{
public:
	enum Type{
		TYPE_NPC = 0,
		TYPE_ENEMY,
		TYPE_EXTRA,
	};
	enum ReleaseState{
		IDLE = 0,
		LOADED,
		RELEASEARCHIVE,
		RELEASEDARCHIVE,
		RESTOREARCHIVE,
	};
protected:
	static ghmGcListObj		mAnchor;
	static bool				mSilhouetteAll;
	static ghmGcViewVolume	mViewVolume;
	static bool				mPauseAll;
	static s16				mNoCounter;
	static WK7NpcCreateFunc	*mpCreateFunc;
	static bool				mPopAllEnable;
	static u8				mTumorHideAll;
	
	u32						mID;					// hc
	u32						mModelID;				// fhc
	u32						mEggModelID;			// fipjhc
	u32						mEneNo;					// Gl~[mn
	s16						mNo;					// ǗpAʂԍ
	u32						mOyaEneNo;				// HS̏ꍇɎgpAeHS̔ԍ
	
	u32						mMotID;					// [Vhc
	
	Type					mType;					// ^Cv
	u32						mEneType;				// Gl~[orGLXg̃^Cv
	
	
	u32						mStageID;				// oXe[Whc
	u32						mParam;					// p[^
	
	u32						mPopState;				// |bvw
	s16						mPopNum;				// |bv񐔁i-1ƖA0ł܂j
	s16						mPopNumInit;			// |bv񐔐ݒȕl
	f32						mPopTime;				// |bv
	
	u32						mEggRenderIDSave;		// ̊{_[IDZ[u
	
	f32						mSakuteki;				// G͈
	WK7NpcControlState		mState;					// vC[
	
	WK7NpcMovePosMode		mMovePosMode;			// [Vړ̈ړ[h
	
	WK7Chara				*mpNpcChara;			// ʏL
	WK7Chara				*mpEggChara;			// ʏLij
	WK7JObj 				*mpRootBone;			// XP[p̃[g{[
	NPCWEAK					mWeakObj[NPCWEAKOBJID_MAX];	// _IuWFNg
	
	WK7RenderObjEffect		*mpFireEffect;			// GtFNgpiRj
	WK7Chara				*mpFireChara;			// HLiۑj
	s16						mFireFrame;				// ̔RĂ鎞
	WK7RenderObjEffect		*mpThundEffect;			// GtFNgpiтj
	WK7Chara				*mpThundChara;			// dHLiۑj
	s16						mThundFrame;			// d̔RĂ鎞
	WK7RenderObjEffect		*mpGraviEffect;			// GtFNgpid́j
	WK7Chara				*mpGraviChara;			// d͂HLiۑj
	s16						mGraviFrame;			// d͂̔RĂ鎞
	WK7RenderObjEffect		*mpFootPaintEfc;		// ՃGtFNg
	WK7RenderObjEffect		*mpKirakiraEfc;			// ~tFIpGtFNg
	WK7RenderObjEffect		*mpLaserTame;			// f[U[̗
	WK7RenderObjEffect		*mpJetR;				// ~NpWFbg
	WK7RenderObjEffect		*mpJetL;				// ~NpWFbg
	WK7RenderObjEffect		*mpJet3;				// ~NpWFbg
	WK7RenderObjEffect		*mpJet4;				// ~NpWFbg
	WK7RenderObjEffect		*mpLaserBombEfc;		// [U[HS̃[U[
	WK7RenderObjEffect		*mpFlushBom;			// ~NX}C̑Me
	WK7RenderObjEffect		*mpJibakuEfc;			// HS̎̃GtFNg
	
	int 					mLoopFootSEno;			// SEԂl
	int 					mLoopTENFlushSE;		// SEԂl
	int 					mShoutSE;				// SEԂliSE
	u8						mLoopSEVolSet;			// [vSẼ{[
	u8						mLoopSEVolNow;			// [vSẼ{[
	
	int						mCoreType;				// pARÃ^Cv
	
	bool					mEfcBoodMode;			// ̎kGtFNgɕϊ
	Vec						mEfcBoodPoint;			// k|Cg
	
	WK7JObj					*mpObjExtra;			// GNXg[V𗬂񂾃IuWFNg
	
	
	ghmGcListObj			mMotionAnchor;			// [VAJ[
	
	f32						mOperationDir;			// l
	f32						mOperationDist;			// lƂ̋
	Vec						mOperationPos;			// l̈ʒu
	s16						mOperationPathResult;	// l̃pX
	s16						mWaitCount;				// 삵Ƃ̋xe
	s16						mCommonCount;			// ėpJEg
	u8						mHaizuriFlag;			// ͂tO
	u8						mCeilingFlag;			// VԃtO
	s16						mPoizunCount;			// ŔJEg
	s16						mJibakuFrame;			// X}C̏ꍇ̎܂ł̎
	s16						mTamagoBornCount;		// fJEg
	u8						mLaserProcess;			// [U[fvZX
	s16						mDamageWarpCount;		// _[WɃ[v
	u8						mDamageWarpProcess;		// _[W[vvZX
	u8						mWanderProcess;			// pj[`vZX
	s16						mLaserStartCount;		// [U[JnJEg
	s16						mEscapCount;			// GXP[vJEg
	u8						mEscapeProcess;			// GXP[vvZX
	s16						mCoinGetCounter;		// RCQbĝrdȂ炷p
	int						mCoinSeNo;				// RCQbgrdԍ
	
	u8						mRevivalProcess;		// p
	EFFECT					*mpNpcRevivalEfc;		// p̌GtFNg
	
	s16						mSilhouette;			// VGbgitrue..VGbg}Afalse..ʌj
	bool					mVisible;				// \tOi񂾂ƂƂAłƂɏj
	int						mForcedVisible;			// \tO
	
	s16						mHide;					// BtO 0ҋ@1o-1
	s16						mHideMode;				// B郂[h̐ݒ 0Fm[} 1Fꃏ[v
	s16						mStartNoiseProcess;		// õGtFNgvZXǗ
	f32						mStartNoiseFrame;		// õGtFNg
	f32						mHideAlphaNow;			// B铧x
	f32						mHideAlphaSet;			// B铧xiݒlj
	C_SetAlpha				*mpAlpha_set;
	C_Generator				*mpGen;
	
	u32						mDieMode;				// 񂾂Ƃ̏
	WK7NpcTutorial			mTutorialCmd;			// `[gApR}h
	u8						mDownSE;				// _Êrd
	s16						mCoreNum;				// RA̐

#if FUJITA
	bool					mDoPathSearch;	
	bool					mReflected;	
	C_Vec					mReflectedPos;
	C_Vec					mLastSafePos;
	C_Vec					mLastDir;				// O̐isB
	f32						mLastDirY;				// O̐isx
	C_Vec					mDstPos;				// l̍W
	C_Trigon				*mpLastHitTrigon;
	HSD_JObj				*mpTargetJObj;
	HSD_JObj				*mpTargetParentJObj;
	s32						mTVNoiseCounter,mTVNoiseFrame;	
	//_B
	void CreateWeakPoint( HSD_JObj *_jobj );
	void ReleaseWeakPoint( void );
	void PlayWeakPoint( Vec &eye, f32 dist );
	//ᇁB
	C_TumorSet				*mpTumor;	
	void CreateTumor( void );
	void PlayTumor( Vec &eye, f32 dist );
	
	//ermCYB
	void StartTVNoise( s32 );
	void StopTVNoise( void );
	void AdditionalPreRenderProcess( void );
#endif
	
	f32						mRotY;					// 
	f32						mTargetRotY;			// iڕWj
	Vec						mPosition;				// ʒu
	Vec						mInitPos;				// ʒuۑ
	f32						mYukaHeight;			// ̍
	f32						mDefHeight;				// ۑ
	f32						mDefRakkaSpeed;			// Xs[h
	
	f32						mDefMotSpeed;			// [VĐɂftHg[VXs[h

	
	SCAN					mScan;					// XL}[J[GtFNg
	s16						mScanFlag;				// XLjOĂtO
	
	NPCDATA					mData;					// mob̃f[^iO̓̓f[^ƂĂj
	
	NPCAI					mAi;					// `h
	
	WK7NpcMotion			*mpNpcMotion[WK7MOTION_NPCCMN_NUM];			// [Ve[u
	NPCSPEED				mSpeed;					// Xs[hǗp
	
													// ʃ[Vz
	union{
		struct{
			u32				mFirstPosSet      : 1;		// ʒuݒ
			u32				mControlOK        : 1;		// sJnOK
			u32				mFirstlaugh       : 1;		// ŏ̏΂
			u32				mPause            : 1;		// |[Y
			u32				mBattlePause      : 1;		// |[Yiog̃|[YŎgj
			u32				mNoPause          : 1;		// |[Y_tO
			u32				mNoPauseBack      : 1;		// |[Y_tOiÕtOobNAbv
			u32				mDieEvCall        : 1;		// SCxgR[Ǘp
			u32				mEgg              : 1;		// ԂǂH
			u32				mAiWallBomb       : 1;		// ǂ܂œ玩Ŕjigr`hj
			u32				mAiEscape         : 1;		// l瓦悤Ƃigr`hj
			u32				mTamagoBornEnable : 1;		// f\igrpj
			u32				mNoJointBroken    : 1;		// ʌȂ
			u32				mFirstDisp        : 1;		// zu
			u32				mFirstMove        : 1;		// Jn
			u32				mZakoBoss         : 1;		// G{XɊiグꂽ^Cv
			u32				mCounterSignal    : 1;		// JE^[p̃VOi}
			u32				mBurn             : 1;		// RĂ
			u32				mThund            : 1;		// тĂ
			u32				mGravi            : 1;		// kĂ
			u32				mYoroiBroken      : 1;		// Zꂽ
			u32				mTumorHide        : 1;		// ᇕ\
			u32				mLockOn           : 1;		// bNIꂽǂH
			u32				mTutorial         : 1;		// `[gAp̓G
			u32				mFantCounter      : 1;		// t@gHSJE^[U
			u32				mPosCheckEneWalk  : 1;		// EnemyWalkɏʒu邩ǂ̃`FbN
			u32				mFlagPad          : 6;
		};
		u32					mFlag;
	};
	
	WK7SelectObj			*mpSelectObj;
	ReleaseState			mReleaseState;				// Tuʂ̃j[֓Ƃ̃[X
	f32						mReleaseMotionFrame;		// Tuʂ̃j[֓Ƃ̃[Xi[VJgt[ۑ
	bool					mReleaseMotionLoop;			// Tuʂ̃j[֓Ƃ̃[Xi[V[v
	static	f32				mIpFrame;
	WK7NpcControlState		mReleaseStateBk;
	
	WK7Npc();										// ftHgRXgN^֎~
	WK7Npc(u32 id,Type type,ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	void Release(void);
	void Reset(void);
	virtual void EneTypeReset(void);
	
	int CreateModel(u32 mdlid, bool TypeEgg=false);
	bool CreateModelInit(void);
#if FUJITA
	//{Xl[~ŐKႤ̂ŁAEnm*.cppŃI[o[ChB
	virtual void CreatePackMotion(s16 *pTabelePtr, u32 motCodeId, u32 startMotID=0);
#else	
	void CreatePackMotion(s16 *pTabelePtr, u32 motCodeId, u32 startMotID=0);
#endif
	WK7NpcMotion* CreateMotion(u32 motid, int cmnid);
	WK7NpcMotion* FindMotion(u32 motid);
//	WK7CharaMotion* FindCharaMotion(u32 motid);
	bool StopCommonMotion(void);
	bool ReplayCommonMotion(int mode=0);
	int GetCommonMotionState(void);
	bool TestMotion(u32 id);
	
	virtual f32 GetWalkSpeed(void);
	virtual f32 GetRunSpeed(void);
	virtual f32 GetHaizuriWalkSpeed(void);
	virtual f32 GetHaizuriRunSpeed(void);
	virtual f32 GetJetSpeed(void);
	
	void MotPlayInit(WK7NpcMovePosMode nextMode);
	virtual bool MotSet_Wait(bool hokan);
	bool MotSet_Wait_ENM_K(bool hokan);
	virtual bool MotSet_Extra(void);
	
	virtual bool MotStatus_Wait(void);
	virtual bool MotSet_Turn(void);
	virtual bool MotStatus_Turn(void);
	bool MoveHitTest(f32 defaultSpeed, f32 defaultDir, Vec enePos, bool searchMode, bool posset=true, bool doPathSearchMode=false, bool inWallHitBomb=false);
	bool MotSet_Walk(f32 operationDist, bool searchMode);
	virtual bool MotSet_Run(bool hokan=true);
	bool MotSet_Jet(bool hokan=false, bool motKeep=false, bool searchMode=true);
	bool MotSet_Wander(void);
	bool MotSet_Atk(f32 speed=1.f);
	virtual bool MotStatus_Atk(void);
	bool DamageTest(void);
	bool MotStatus_Dmg(void);
	bool MotStatus_Dmg_Fall(void);
	bool MotSet_Loss(void);
	bool MotStatus_Loss(void);
	virtual bool MotStatus_Die(void);
	bool MotStatus_Pop(void);
	bool MotStatus_RePopWait(void);
	s16 GetNearObjID(Vec hitPos);
	void DamageInit(void);
	bool AtkTest(s32 mode);
	void ScanControl(void);
	void ScanControlRelease(void);
	void HideControl(void);
	void HideControlRelease(void);
	bool MotionSpeedControl(void);
	bool MotSet_ExtPop(void);
	virtual bool MotStatus_ExtPop(void);
	bool MotSet_LaserSink(void);
	bool MotStatus_LaserSink(void);
	bool MotSet_Spd_Wait(bool hokan);
	bool MotSet_Spd_MoveStart(void);
	bool MotSatus_Spd_MoveStart(void);
	bool MotSet_HsBomb(void);
	bool MotStatus_HsBomb(void);
	bool MotSet_TamagoHaki(void);
	bool MotStatus_TamagoHaki(void);
	bool MotSet_TamagoHakare(void);
	bool MotStatus_TamagoHakare(void);
	bool MotSet_Fall(bool hokan=false);
	bool MotStatus_Fall(void);
	bool MotSet_FallEnd(void);
	bool MotStatus_FallEnd(void);
	bool FallPosMove(f32 ySpeed);
	bool MotSet_DmgWarp(void);
	bool MotStatus_DmgWarp(void);
	bool MotSet_DivingPop(void);
	bool MotStatus_DivingPop(void);
	bool MotSet_ZombiWait(s16 WaitTime);
	bool MotStatus_ZombiWait(void);
	bool MotSet_ZombiPop(void);
	bool MotStatus_ZombiPop(void);

	
	virtual bool HpDec(s16 inFrontFlag, s16 *pRegiDmgPoint);
	int VLossTest(s16 nowWeakID, u8 mode=0);
	bool DamageNoMotionTest(u32 reserveMotID);
	s16 DamageRegistTest(s16 inPoint, s16 inFrontFlag);
	bool DieMotionTest(u32 *pInSetMotID);
	bool DamageCriticalTest(s16 inFrontFlag, u8 *pChain);
	virtual bool DamageMotionSelect(s16 frontFlag, u32 *pInSetMotID);
	void VisibleTest(void);
	void TumorRecover(void);
	virtual void VisibleTestDisp(void);
	virtual void VisibleTestHide(void);
	bool NoClipTest(void);
	
	f32 GetSpeedRate(void);
	virtual bool StateInit(bool passflag=true);
	bool FirstAiSetUp(void);
	virtual bool Ai(void);
	virtual bool Ai_Follow(f32 targetDirSabun);
	virtual bool MotSet_Dmg(void);
	virtual bool MotSet_DmgExtra(void);
	bool OiuchiDamageTest(void);
	void ScanAtkPenalty(void);

	bool ControlTest(void);
	void FirstlaughTest(int mode=0);
	
	bool MotionProcess(void);
	bool ReleaseProcess(void);
	bool ReleaseArchiveProcess(void);
	bool RestoreArchiveProcess(void);
	bool SetReleaseState(ReleaseState state);
	bool FlowerHSDeadTest(void);
	bool FlowerHSTest(void);
//	s8 FlowerHSTest(void);
	bool HSEffectProcess(void);
	
	void DmgSpeedSet(f32 speed);
	void SpSpeedSet(f32 speed);
	
	void PopPointSearch(Vec *pGetPos=NULL);
	void RePopSakutekiSet(void);
	
	void DieEnd(void);
	bool MotStatus_KerenmiDmg(void);
	bool KerenmiSignalCall(void);
	
	bool JibakuTest(void);
	bool FlowerHSJibakuTest(void);
	bool JibakuFrameSet(void);
	void BornSetUp(int HsChange, Vec *pNewPos, f32 NewRotY);
	bool EggRepopTest(void);
	
	WK7Npc *pTamagoHakareTest(void);
	bool TamagoHakiPreTest(void);
	bool TamagoHakiRequest(WK7Npc *pOyaNpc);
	void TpInc(s16 incTp, int mode=0);
	
	bool HSEffect_Poizun(void);
	
	bool HSEffect_LaserTame(void);
	bool HSEffect_LaserTamePosUpDate(void);
	void HSEffect_LaserTameTerm(void);
	
	void NpcRenew(void);
	bool SakutekiTest(void);
	
	void HeadHSBomb(void);
	u32 GetBackHSDmgMot(s16 inFrontFlag);
	
	virtual bool GetNoDamage(void);
	bool BackHSRollDmgClearTest(void);
//	bool GetBackHSNoDamage(void);
//	bool GetDivingHSNoDamage(void);
//	bool GetSuNoDamage(void);
	
	bool CreateKiraKira(void);
	virtual bool SetKiraKiraPos(void);
	void DelKiraKira(void);
	
	bool CreateJet(void);
	void DelJet(void);
	bool CreateJet2(void);
	void DelJet2(void);
	
	bool HSEffect_LaserShot(void);
	bool HSEffect_LaserShotPosUpDate(void);
	bool CreateLaserBomb(Vec pcPos);
	void DelLaserBomb(void);
	bool NpcRePopTest(void);
	
	bool DamageRegistTestPROT(void);
	
	// p[c_[IDHS̃_[ID̊蓖
	virtual void PartsRenderIDSet(void);
	
	bool CreateFlushBom(void);
	void FlushBomFrameProcess(void);
	void FlushBomRenderProcess(void);
	void DelFlushBom(void);
	void SePitchChange(int seNo);
	
	bool DmgFireEffectStart(s16 time, WK7JObj *pJObj=NULL);
	bool DmgFireEffectEnd(int mode=0);
	bool DmgFireEffectTest(void);
	
	bool DmgThundEffectStart(s16 time, WK7JObj *pJObj=NULL);
	bool DmgThundEffectEnd(int mode=0);
	bool DmgThundEffectTest(void);
	
	bool DmgGraviEffectStart(s16 time, WK7JObj *pJObj=NULL);
	bool DmgGraviEffectEnd(int mode=0);
	bool DmgGraviEffectTest(void);
	
	void UruCoinSetUp(void);
	
	virtual void FootSeWalk(Vec myPos);
	virtual void FootSeRun(Vec myPos);
	
	bool ComboMessagePlay(u8 chainOk);
	int CalcBloodVal(f32 bloodRate);
	
	bool SetEnemyDieInfoTest(u32 dieMode);
	bool AiMoveTest(void);
	
	bool EscapePreTest(void);
	bool EscapeStageTest(void);
	bool MotStatus_Escape(void);
	
	bool CreateJibakuEfc(Vec waistPos, u32 suffix, f32 size);
	void DelJibakuEfc(void);
	s16 GetBloodEffectNum(void);
	f32 GetYukaY(void);
	bool EnemySlowTest(bool noMotion);
	bool ENM_SU_FinalDmg(void);
	
public:
	
	void WaistToRoot(void);
	bool PlayCommonMotion(u32 id, bool loop, bool hokan, f32 sframe=0.0f, f32 speed=1.f);
	bool MotSet_Escape(bool kyoudsei=false, bool areaOut=false);
	
	NPCDAMAGE					mDamage;				// _[Wp
	
	virtual ~WK7Npc();
	
	inline WK7Npc* GetPrev(void){ return (WK7Npc *)ghmGcListObj::GetPrev(); }
	inline WK7Npc* GetNext(void){ return (WK7Npc *)ghmGcListObj::GetNext(); }
	inline static WK7Npc* GetTop(void){ return (WK7Npc *)mAnchor.GetNext(); }
	
	static bool SetMotionIpFrame(f32 frame=-1.0f);
	inline static f32 GetMotionIpFrame(void){ return mIpFrame; }
	
	virtual bool IsMyRenderID( u32 /*id*/, Vec */*p*/ ){ return false; }
	
	void SetInitPos(const Vec &pos);
	
	bool ReleaseModel(void);
	bool ReleaseMotionAll(void);
	
	void GetRot(Vec *pTgt, Vec *pPos, Vec *pGet);
	
	static bool InitializeAll(void);
	static bool TerminateAll(void);
	static void WK7NpcNoCounterClear(void);
	inline static void SetNpcCreateFunc(WK7NpcCreateFunc *pFunc){ mpCreateFunc=pFunc; }
	inline static WK7NpcCreateFunc* GetNpcCreateFunc(void){ return mpCreateFunc; }
	
	// JgXe[WɉNPCSǂݍ
//	static bool NpcAutoCreateAll(u32 stgid);
//	static bool NpcAutoCreateIsLoading(void);
//	static bool NpcAutoCreateAllB(u32 stgid);
	bool ReleaseArchive(void);
	bool RestoreArchive(void);
	inline ReleaseState GetReleaseState(void){ return mReleaseState; }
	
#if FUJITA
	void ReleaseTumor(void);
#endif
	
	s16 GetRandWeakID(void);
	
	// Q[Jn̏
	void NpcGameInit(void);
	
	// _[W`FbNi_[Wj
	virtual bool DamageCheckProcess(void);
	
	// Rg[iIuWFNgj
	virtual bool ControlProcess(void);
	virtual bool ExtraControlProcess(void);
	
	// t[iʒu␳Ȃǁj
	virtual bool FrameProcess(void);
	bool RenderProcess(void);
	static bool RenderProcessAll(void);
	
	static bool DamageCheckProcessAll(void);
	static bool ControlProcessAll(void);
	static bool FrameProcessAll(void);
	
	static WK7Npc* Create(u32 eneNo);
	static WK7Npc* CreateStatic(u32 type,u32 suffix);
	static WK7Npc* CreateScn01(u32 type,u32 suffix);
	static WK7Npc* CreateScn02(u32 type,u32 suffix);
	static WK7Npc* CreateScn03(u32 type,u32 suffix);
	static WK7Npc* CreateScn04(u32 type,u32 suffix);
	static WK7Npc* CreateScn05(u32 type,u32 suffix);
	static WK7Npc* CreateScn06(u32 type,u32 suffix);
	static WK7Npc* CreateScn07(u32 type,u32 suffix);
	static WK7Npc* Find(u32 eneNo);
	static WK7Npc* Find(u32 id,u32 stgid,u32 param=0);
	static WK7Npc* FindARGB(u32 argb,u32 target=WK7NPC_FINDTARGET_DEFAULT);
	static WK7Npc* FindRenderID(u32 id,u32 target=WK7NPC_FINDTARGET_DEFAULT);
	static WK7Npc* Find(WK7NpcFindData &finddata);
	static bool ReleaseAll(void);
	static bool ReleaseStageNpc(u32 stgid);
	static bool ReleaseStageNpcAll(u32 stgid);
//	void SetInitPosition(void);
	
	inline u32 GetID(void){ return mID; }
	inline u32 GetModelID(void){ return mModelID; }
	inline u32 GetEneNo(void){ return mEneNo; }
	inline u32 GetStageID(void){ return mStageID; }
	inline u32 GetParam(void){ return mParam; }
	inline Type GetType(void){ return mType; }
	inline u32 GetEneType(void){ return mEneType; }
	inline u32 GetOyaEneNo(void){ return mOyaEneNo; }

/*
	inline void SetDamageHitRequest(void){ mDamageHitRequest = 1; }
	inline s16 GetDamageHitRequest(void){ return mDamageHitRequest; }
	inline void SetDamageScrPosition(s16 x, s16 y){ mDamScrX = x; mDamScrY = y; }
	inline s16 GetDamageScrPosX(void){ return mDamScrX; }
	inline s16 GetDamageScrPosY(void){ return mDamScrY; }
*/
	
	bool MotSet_ShotPose(f32 dev, u32 setMotID);
	bool MotStatus_ShotPose(u32 setMotID);
	bool MotSet_ShotNow(f32 dev, u32 setMotID, s8 gunMuzzle);
	bool MotStatus_ShotNow(int nextProcess, u32 setMotID);
	bool MotStatus_ShotWait(u32 setMotID);
	bool MotStatus_Reload(u32 setMotID);
	
	void SetForcedVisible(int flag=-1){ mForcedVisible=flag; }
	int GetForcedVisible(void){ return mForcedVisible; }
	
	bool SetVisible(bool flag);
	bool GetVisible(void);
	bool IsLoading(void);
	
	bool SetPosition(const Vec& pos);
	bool SetPosition(WK7JObj *pJObj,u32 flag=WK7NPC_VALID_POSX|WK7NPC_VALID_POSY|WK7NPC_VALID_POSZ);
	bool SetTargetRotY(f32 targety, bool flag=false);
	f32 SetRotCalc(f32 div);
	bool GetPosition(Vec& pos);
	bool GetWaistPosition(Vec *pPosition){
		if ( mWeakObj[NPCWEAKOBJID_WAIST].mpBone != NULL ){
			mWeakObj[NPCWEAKOBJID_WAIST].mpBone->GetWorldPosition(pPosition);
			return true;
		}
		return false;
	}
	bool GetWeakPosition(Vec *pPosition, s16 joint=-1);
	bool SetRotY(f32 roty);
	f32 GetRotY(void);
	
	static void SetSilhouetteAll(bool flag){ mSilhouetteAll=flag; }
	static bool GetSilhouetteAll(void){ return mSilhouetteAll; }
	
//	inline WK7Chara* GetNpcChara(void){ return mpNpcChara; }
//	inline WK7Chara* GetEggChara(void){ return mpEggChara; }
	
	u32 GetCharaRenderID(void);
//	u32 GetSilCharaRenderID(void);
	bool PeekRenderIDExTest(u32 argb);
	
	bool SetEnemyDieInfo(u32 dieMode, bool noCount=false);
	u32 GetCurrentMotionFrame(void);
	u32 GetTotalMotionFrame(void);
	f32 GetFTotalMotionFrame(void);
	
	// _[W̃Zbg
	bool SetNpcDamage(WK7Chara *pPcChara, Vec shotDir, Vec damPos, s16 damPoint, WK7NpcDamType damType, f32 damTameRate=0.f, bool renderExHit=false);
	
	// XL֌W
	inline void SetScanFlag(void){ mScanFlag = 1; }							// XLJn\
	inline void EndScanFlag(void){											// XLI\
		if ( 0 != GetScanFlag() ){
			mScanFlag = -1;
		}
	}
	inline s16 GetScanFlag(void){ return mScanFlag; }
	bool ScanPreTest(void);
	bool ScanTest(void);
	bool FantCounterTest(void){ return mFantCounter; }
	
	// BEo
	inline void HideModeHideReq(void){
		if ( 0 != mHide ){
			mHide = -1;
		}
	}						// B郊NGXg
	inline s16 GetHideFlag(void){ return mHide; }
							// oNGXg
	bool StartHide(bool compel=false, bool effect=false, f32 effectTim=105.f, s16 inMode=0);
	
	// ݂̂go擾
	s16	GetHp(void){ return mData.mHp; }
	
	// Ă錌̗ʂ̎擾
	u16	GetBloodVolume(void){ return mData.mBloodVolume; }
	
	// Oďo
	static int GetEnemyTotalHitPoint(u32 stgid=0xffffffff);
	static bool GetEnemyDieTest(u32 EneNo);									// w EneNo ̎S󋵂eXg 0:Ă 1:ł
	static ENEMYLIST* GetEnemyList(u32 EneNo);								// w EneNo  ENEMYLIST|C^擾
	
	// NPC̃Xs[hƂiOďoj
	static bool NpcSpSpeedSetAll(f32 speed=1.f);
	static bool NpcSpeedSetAll(f32 speed=1.f);
	void SpeedSet(f32 speed);
	
	// mobp̂̌̃GtFNg̍Đ
	void BloodEfcCall(Vec DamPos, Vec DamDir, Vec myPos, s16 regiDamPoint, WK7JObj *pJOBjIN=NULL, int noSe=0, int bloodSoumen=1);
	
	// _[W̃ZbgiCxgpj damPos:_[Wʒu  
//	void SetNpcDamageEvent(Vec damPos, s16 damPoint, WK7NpcDamType damType=DAMTYPE_NORMAL, f32 damTameRate=0.f);
	void SetNpcDamageEvent(Vec damPos, s16 damPoint, WK7NpcDamType damType=DAMTYPE_NORMAL, f32 damTameRate=0.f, bool renderExHit=false);
	
	// `h֘AA̐֘A
	bool AiModeSet_PopGo(int frame=0);										// Aĩ[hCxgҋ@ԂsJnɂ
	bool AiModeSet_TestPop(void);											// |bv[hw̓G݃|bv҂Ԃł邩ǂH
	bool AiModeSet_Exit(void);												// Aĩ[hCxgҋ@Ԃ狭Iɂ
//	bool AiModeSet(WK7NpcAi setMode);
	
	// Xe[^X֘A
	void SetNpcState(WK7NpcControlState state){ mState = state; }
	WK7NpcControlState GetNpcState(void){ return mState; }
	
	// lƂ̋Apx
	f32 GetOperationDist(void){ return mOperationDist; }
	f32 GetOperationDir(void) { return mOperationDir; }
	
	// S󋵂̎擾 enum WK7NpcDieMode
	u32 GetDieMode(void){ return mDieMode; }

	// 񂾂Ƃ̌̃GtFNgj[hk[hɂ
	void SetDieEffectModeChange(bool flag){ mEfcBoodMode = flag; }
	bool GetDieEffectModeChange(void){ return 	mEfcBoodMode; }
	void SetDieEffectModePos(Vec Point){ mEfcBoodPoint = Point; }
	
	// |[Y֌W
	bool GetNpcPause(void);
	
	static void NpcVisibleAll(bool flag);
	static void SetNpcPauseAll(bool flag);
	static bool GetNpcPauseAll(void);
	static void NpcPauseAll(void);
	static void NpcResetPauseAll(void);
	static void NpcPopAllEnable(bool flag);				// SĂ̓G̃|bv֎~
	static bool GetNpcPopAll(void);
	
	bool GetPause(void);
	bool SetPause(int mode=1);
	bool ResetPause(void);
	
	static void NpcBattlePauseAll(void);
	static void NpcResetBattlePauseAll(void);
	bool GetBattlePause(void);
	bool SetBattlePause(void);
	bool ResetBattlePause(void);
	bool SetNoPause(void);
	bool ResetNoPause(void);
	bool MotSet_Pop(bool visible);
	
	// [J[h֘A
	static s8 MemCard_GetDieInfo(int id);
	static void MemCard_SetDieInfo(int id, s8 info);
	
	// G͈͂̐ݒ
	void	SetSakuteki(f32 dist){ mSakuteki = dist; }
	f32		GetSakuteki(void){ return mSakuteki; }
	
	// [U[HS̃[U[UJn̍}
	bool SetLaserAtk(void);
	
	// XLłAeĂǂǂH
	bool ScanHitTest(void);
	
	// pX̌ʂ擾
	s16 GetPathResult(void){ return mOperationPathResult; }
	
	// ݍU̍Đ
	bool MotSet_KerenmiDmg(u32 pcID);
	
	// Ln{XsJnɂ
	bool KihanBoss_AiRun(void);
	
	// ͂Ԃ擾
	bool HaizuriTest(void);
	bool HaizuriSet(bool flag);
	s16 GetHaizuri(void){ return mHaizuriFlag; }
	
	// ʒuZbgǂH
	bool FirstPosSetTest(void);
	// ԂǂH
	bool EggTest(void);
	// ^Cv̓GǂH
	bool EggTypeTest(void);
	
	// JgL̃|C^擾
	WK7Chara *pCurrentChara(void);
	
	bool FootPaintTestSet(int boneID, int rFoot=-1);
	
	// VԂ擾
	bool CeilingTest(void);
	
	
	// 񂾂mob𕜊 
	bool NpcRevivalSetUp(Vec *pPos=NULL, f32 setRotY=999.f);
	bool NpcRevivalGo(void);
	
	// JE^[U\ȊJnt[擾
	u32 GetKerenmiFrame(void);
	
	// JE^[炢̃^Cv擾
	int GetKerenmiType(void);
	
	// ᇃGtFNg̃^Cv擾
	s8 GetTumorEfcType(void);
	void SetTumorEfcType(s8 setType);
	
	// wuX}C̑̊i擾
	int BodySizeGet(void);

	// ZbgAbvǂH
	bool SetUpTest(void);
	
	// mob̍GΏۂƂĂ݂Ă悢Xe[^X
	bool SakutekiOkTest(void);
	
	// Ol[h̏
	bool DamageGrenadeTest(void);
	int  DamageGrenadeSet(s16 regiDmgPoint, s16 *pFront=NULL);
	
	// ᇕ\̕\\
	bool DispTumor( bool dispTest=true );
	bool HideTumor( void );
	static void DispTumorAll(void);
	static void HideTumorAll(void);
	
	// bNIꂽ֘A
	void SetLockOn(void);
	u32 GetLockOn(void);
	
	// Oďo
	static void OtherNpcJibakuEfcEnd(void);
	
	// ЉpLݒNA
	void SyoukaiClear(void);
	
	// GOl[h_[WĂǂԂ`FbN
	bool DamageGrenadeKuraiTest(void);
	
	// `[gAR}h̏󋵂擾
	WK7NpcTutorial GetTutorialCmd(void);
	// `[gAR}hݒ
	bool SetTutorialCmd(WK7NpcTutorial cmd);
	
	// Ă邩ǂH
	bool LiveTest(void);
};

class WK7NpcFindData{
	friend class WK7Npc;
protected:
	bool				mInitialized;
	u32					mStageID;
	WK7Npc				*mpCurrentNpc;
public:
	WK7NpcFindData();
	bool Initialize(u32 stgid=0xffffffff);
};

#ifdef	__WK7NPC_CPP__

typedef struct _NPCWEAKNAMETABLE{
	char 	*mpHide;					// {[iIuWFNg\E\pj
	char 	*mpBone;					// {[i蔻pj
	char 	*mpSkin;					// XLiGtFNgŎgpj
}NPCWEAKNAMETABLE;

// mob̎_IuWFNgOꗗ
NPCWEAKNAMETABLE  npcWeakObjNameTable[NPCWEAKOBJID_MAX] = {
	{K7CHRBONE_WAIST,		K7CHRBONE_WAIST,		K7CHRSKIN_WAIST},			// 
	{K7CHRBONE_SKULL,		K7CHRBONE_SKULL,		K7CHRSKIN_HEAD},			// 
	{K7CHRBONE_HUMERUS_R1,	K7CHRBONE_ULNA_R,		K7CHRSKIN_ARM_R},			// Er
	{K7CHRBONE_HUMERUS_L1,	K7CHRBONE_ULNA_L,		K7CHRSKIN_ARM_L},			// r
	{K7CHRBONE_HIP_R,		K7CHRBONE_THIGH_R,		K7CHRSKIN_LEG_R},			// E
	{K7CHRBONE_HIP_L,		K7CHRBONE_THIGH_L,		K7CHRSKIN_LEG_L}			// 
};

NPCWEAKNAMETABLE  npcBigWeakObjNameTable[NPCWEAKOBJID_MAX] = {
	{K7CHRBONE_WAIST,		K7CHRBONE_WAIST,		K7CHRSKIN_WAIST},			// 
	{K7CHRBONE_SKULL,		K7CHRBONE_SKULL,		K7CHRSKIN_HEAD},			// 
	{K7CHRBONE_HUMERUS_R1,	K7CHRBONE_ULNA_R,		K7CHRSKIN_ARM_R},			// Er
	{K7CHRBONE_HUMERUS_L1,	K7CHRBONE_ULNA_L,		K7CHRSKIN_ARM_L},			// r
	{K7CHRBONE_HIP_R,		K7CHRBONE_SHIN_R,		K7CHRSKIN_LEG_R},			// E
	{K7CHRBONE_HIP_L,		K7CHRBONE_SHIN_L,		K7CHRSKIN_LEG_L}			// 
};

//GHMGCTASK_HANDLER(AutoNpcCreateTask);

#else

extern int waraiStartSeTbl[SFX_BT_HS_WARAI_START_MAX];
extern int waraiJibakuSeTbl[SFX_BT_HS_JIBAKU_MAX];
extern int waraiDeathSeTbl[SFX_BT_HS_DEATH_MAX];

// Extern ---
//GHMGCTASK_HANDLER(AutoNpcCreateTask);

// extern ENESET AllEnemyList[];


#endif

#endif	//__WK7NPC_H__

