////////////////////////////////////////////////////////////////////////////////
//
// Killer7 SceneDesc
//
// WK7SceneDesc.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/08/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7SCENEDESC_CPP__

//#include <dolphin.h>
#include ".\WK7SceneDesc.h"

void* WK7SceneDesc::operator new(u32,HSD_Archive *pArchive)
{
	return HSD_ArchiveGetPublicAddress(pArchive,"scene_data");
}

bool WK7SceneDesc::GetModelAnimExist(void)
{
	C_ModelSet		*pModelSet;
	u32				i,modelSetNum = GetModelSetNum();
	for(i=0 ; i<modelSetNum ; i++){
		pModelSet = GetModelSet(i);
		if( pModelSet->adjointlist       !=NULL && pModelSet->adjointlist       [0]!=NULL ){
			return true;
		}
		if( pModelSet->matanimjointlist  !=NULL && pModelSet->matanimjointlist  [0]!=NULL ){
			return true;
		}
		if( pModelSet->shapeanimjointlist!=NULL && pModelSet->shapeanimjointlist[0]!=NULL ){
			return true;
		}
	}
	return false;
}

bool WK7SceneDesc::GetCameraAnimExist(void)
{
	C_CameraSet		*pCameraSet = GetCameraSet();
	if( pCameraSet!=NULL && pCameraSet->camanimlist!=NULL && pCameraSet->camanimlist[0]!=NULL ){
		return true;
	}
	return false;
}

bool WK7SceneDesc::GetLightAnimExist(void)
{
	C_LightSet		*pLightSet;
	u32				i,LightSetNum = GetLightSetNum();
	for(i=0 ; i<LightSetNum ; i++){
		pLightSet = GetLightSet(i);
		if( pLightSet->lightanimlist!=NULL && pLightSet->lightanimlist[0]!=NULL ){
			return true;
		}
	}
	return false;
}

