///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7CharChange
//
// YK7CharChange.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 07/22/2003
//
///////////////////////////////////////////////////////////////////////////////

#ifndef __YK7CHARCHANGE
#define __YK7CHARCHANGE

// include --------------------------------------
#include <dolphin.h>
#include "./YK7Model.h"
#include "./YK7Effect.h"
#include "./YK7TestTask.h"
#include "./YK7String.h"
#include "./CSelect.h"
#include "../Lib/ghmGcTex.h"
#include "../Lib/ghmGcResLink.h"
#include "../Wat/WK7MainTask.h"

// define ---------------------------------------

enum
{
	VOICE_DEF = 0,
	VOICE_CELTIC,
	VOICE_FUKUSHIMA,
	VOICE_KAKUBUILL,
	VOICE_TEXAS,
	VOICE_ISHIZAKALAND,
	VOICE_CATHISUHOUSE,
	VOICE_DOMINICA,
	VOICE_HOTEL,
	VOICE_SCHOOL,
} ;

#define CHARNUM		 	9				// `FWIłLN^̐
#define CHANNELNUM		12				// `l̐

// }XÑfCfbNX
enum MASK_MODEL_INDEX
{
	MASK_MODEL_DEFAULT = 0,		// W}XN
	MASK_MODEL_TEXAS = 1,		// eLTX}XN
	MASK_MODEL_FINAL = 2,		// t@Ci}XN
	MASK_MODEL_TEKKAMEN = 3,	// SΖʃ}XN
	MASK_MODEL_NUM = 4,			// f̐
} ;

// fZbgCfbNX
enum CHARMODEL_INDEX
{
	CHAR_MODEL_CELTIC = 0,			// ZeBbN
	CHAR_MODEL_FUKUSHIMA = 1,		// tNV}
	CHAR_MODEL_KAKUBUILL = 2,		// pr
	CHAR_MODEL_TEXAS = 3,			// eLTX
	CHAR_MODEL_ISHIZAKALAND = 4,	// CVUJh
	CHAR_MODEL_CATHISUHOUSE = 5,	// J[eBX@
	CHAR_MODEL_DOMINICA = 6,		// h~jJ
	CHAR_MODEL_BROADWAY = 7,		// u[hEGC
	CHAR_MODEL_HOTEL01 = 8,			// zeP
	CHAR_MODEL_SCHOOL = 9,			// wZ
	CHAR_MODEL_HOTEL02 = 10,		// zeQ
} ;

// data type ------------------------------------

// LN^Ƃ̃f[^\
typedef struct tagCHARCHANGE_ONECHARDATA
{
	u8 				SetUpState ;	// Xe[^X( 0:ĂȂ  1:  2: )

	YMODEL			model ;			// ff[^
	YMODEL			motion ;		// [Vf[^
	YMODEL			turnmotion ;	// ^[[V
	YMODEL			GunModel[2] ;	// ẽff[^
//	WK7Model 		*GunModel[2] ;	// eff[^( 0:E 1: )
//	s32 			GunDataID[2] ;	// eff[^hc
} CHARCHANGE_ONECHARDATA ;

// LN^`FWp\
typedef struct tagCHARCHANGE
{
	CHARCHANGE_ONECHARDATA CharData[CHARNUM] ;	// LN^̃eNX`[

	s32 		Scene ;					// V[( 0:L`FW  1:L  2: )

	bool		charF ;					// LN^tO
	bool		drF ;					// ҏtO
	bool		lampF ;					// XCb`Iv`tO
	bool		screenF ;				// ʂ`悷邩tO
	bool		plugF ;					// vO`悷邩̃tO

	YMODEL		DrM ;					// ҃ff[^
	YMODEL		DrA1 ;					// ҃f[Vf[^P(˂)
	YMODEL		DrA2 ;					// ҃f[Vf[^Q()
	YMODEL		DrA3 ;					// ҃f[Vf[^R()
	YMODEL		*DrActA ;
	
	YMODEL		SignM ;					// Ŕf
	YMODEL		SignA1 ;				// ɒuĂ
	YMODEL		SignA2 ;				// |郂[V
	YMODEL		SignA3 ;				// |Ă
	YMODEL		*SignA ;

	YMODEL		BldMM ;					// }Vf
//	YMOTION		BldMA ;					// }V[V
	YMODEL		BldLine01 ;				// 㕔eւ̗ꍞ݊Jnp^[
	YMODEL		BldLine02 ;				// 㕔eւ̗ꍞݏIp^[
	YMODEL		BldLine06 ;				// @ւ̗ꍞ݊Jnp^[
	YMODEL		BldLine03 ;				// @ւ̗ꍞݏIp^[
	YMODEL		BldBoto03 ;				// 㕔e@tʂ͂ˏオp^[ilocatorǉ  boto03_loca j
	YMODEL		BldBoto02 ;				// 㕔e@t̑p^[ilocatorǉ  Blood_boto02_loca j
	YMODEL		BldLump ;				// @탉v_

	YMODEL		DeadBody ;				// Ƀ{fB
	YMODEL		DeadBodyMotion ;		// Ƀ{fB[V

	CSelect 	select ;				// IpNX
	YMODEL		stagemodel ;			// Xe[W̃f
	TEXDATA 	TVTex ;					// er̃eNX`
	TEXDATA 	ChannelTex ;			// `leNX`
	TEXDATA		LampTex ;				// XCb`IveNX`
//	TEXDATA 	NumberTex ;				// `lԍeNX`
	TEXDATA		PlugTex ;				// vOeNX`
	TEXDATA		NoiseTex ;				// mCYeNX`
	TEXDATA 	NameTex[CHARNUM] ;		// LN^̃l[eNX`[
	TEXDATA		hs_icon ;				// wuX}C̃ACR
	TEXDATA		kakeru ;				// w~x
	TEXDATA		nin ;					// wlx
	YK7StrImage *Font ;					// suʑSʂŎgptHg
	YK7StrImage *KanaFont ;				// suʑSʂŎgpJitHg
	TEXDATA		SmallAmpTex ;			// AṽeNX`
	TEXDATA		BigAmpTex ;				// 傫AṽeNX`
	TEXDATA		VeryBigAmpTex ;			// 傫AṽeNX`
	TEXDATA		SwitchTex ;				// XCb`̃eNX`
	TEXDATA		ChNumTex ;				// `lio[eNX`

	void 	(*Frame)(void) ;			// t[vZX֐
	void 	(*Render)(void) ;			// _OvZX֐

	u8 		InitFlag ;					// tO
	u8 		EndFlag ;					// ItO
	u8 		ReleaseFlag ;				// tO
	s32 	EndChar ;					// 肵L
	u16		Mode1, Mode2 ;				// [h
	s32 	Counter ;					// ėpJE^[
	s32		AddSerum ;					// ǉ錌̗
	s32		AddSerum2 ;					// ۂɑ錌t̗
	f32		FCounter ;					// float ^ėpJE^[
	s8		CharDelOffWait ;			// LN^`~JE^
	s8		CharDelState ;				// LN^폜JE^[
	
	s32		BldOperationSE ;
	s32		BldChargeSE ;
	s32		BldForwardSE ;
	s32		CharVoice ;

	u32 	OldInput ;					// Õt[ł̓
	u32 	EdgeInput ;					// GbW

	s8 		OldSelectChar ;				// O܂őIĂL
	s8 		SelectChar ;				// I𒆂̃LN^
	
	EFFECT 	*Noise ;					// mCYGtFNg
	EFFECT 	*Gauge, *OldGauge ;			// Q[WGtFNg

	u8 		ChangeCharMap[CHARNUM] ;	// ύX\L}bv
	u8 		addParam[4] ;				// ep[^̏㏸l
	u8		addall ;					// ㏸ʂ̑

	u8 		NotCancelFlag ;				// LZoȂtO
	
	char	RemString[1024] ;			// 
	f32		RemX ;						// ̃XN[
	
	u8		*AblTbl ;					// oAreB̃e[u
	u8		BrinkCounter ;				// _ŗpJE^
	s32		DrawAblY ;					// ʈԏɕ`悷鏊ĂAreB̃CfbNX
	
	s32		CharSoundTableNumber ;		// gpLN^TEhe[uԍ

	MASK_MODEL_INDEX	MaskModelNumber ;	// gp}XÑf̃CfbNX
	CHARMODEL_INDEX		CharModelNumber ;	// gpLN^f̃CfbNX

	ghmGcResLink	*Pack ;				// pbNf[^
	YK7File			PackFile ;			// pbNǂݍݗpt@Cǂݍ݃NX
	void			*PackBuf ;			// pbNobt@
	
	YK7ResLink 		*ModelPack ;		// LN^fpbNt@C

	u8		SwitchDrawFlag ;			// XCb``tO
	u8 		ChannelCounter ;			// `lJE^[
	u8		MadDrZoomFlag ;				// }bhhN^[Y[tO
	bool	CharChangeFlag ;			// LN^`FWǂ
	
	bool	InitStartFlag ;				// JntO
	s32		icon, imod ;				// pϐ
	
	u8		LampType ;							// \郉v^Cv( 0:  1:ԃv  2:΃v  3:΃vI  4:ԃvG[ )
	s32		LampCon1, LampCon2, LampCon3 ;		// v\pJE^
	
	s32		RecMaxPressRate ;					// őAőx
	s32		RecPressCounter ;					// AŃJE^
	s32		RecFrameCounter ;					// t[JE^
	s32		RecVital ;							// ̗
	u8 		RecNoPressTime ;					// ĂȂt[
	u8		RecDownCounter ;					// ĂȂČn߂Ăx
	u8		RecBrinkCon1, RecBrinkCon2 ;		// _ŏpJE^
	u32		RecInputState, RecEdgeInputState ;	// pbhp̓͏
	u32		RecEdgeInputTemp ;
	s32		RecRensyaSE ;						// Aˎ̂rd

	u8		NoizeSoundFlag ;					// mCYĐtO
	s32 	NoizeSoundID ;

	PADSamplingCallback OldPadCallBack ;		// ȑÕR[obN֐
	OSAlarm	Alarm ;
} CHARCHANGE ;

// data -----------------------------------------

// function proto type --------------------------

extern s8	StartInitCharChange( void ) ;					// vOň񂾂Ăԏ
extern s8	InitCharChange( u8 NotCancelFlag = FALSE, s32 CurrentChar = K7GAL, u8 SwitchOnFlag = FALSE, s32 CharSoundTableNumber = 0 ) ;	// LN^`FW̏
extern s8	CheckCharChangeSetup( void ) ;					// LN^`FW̏ǂ擾( TRUE:  FALSE:܂ )
extern s8	EndCharChange( void ) ;							// LN^`FW̌ns
extern s8	FrameProcessCharChange( void ) ;				// LN^`FŴPt[̏s
extern s8	RenderProcessCharChange( void ) ;				// LN^`FW݂̌̏Ԃ`悷

extern s8	GetCharChangeState( void ) ;					// LN^`FW̏Ԃ𓾂( TRUE:s  FALSE:I͊ɏIĂ )
extern s32	GetSelectChar( void ) ;							// ILN^̂hc𓾂
extern void	SetCharChangeMask( u8 CharID, u8 flag=1 ) ;		// ̃LN^IłȂ悤ɂ
extern void	ClearCharChangeMask( void ) ;					// SetCharChangeMask ֐̐ݒAׂẴLN^IłԂɂ

extern s8	PadUpdateInput( void ) ;						// pbh͂̍XV
extern u32	GetPadInput( void ) ;							// pbh̓͂𓾂
extern u32	GetPadEdgeInput( void ) ;						// pbh̃GbW͂𓾂
extern void	SetCharChangeMaskAuto( void );					// goÕL L`FWłȂ悤ɂ

extern void _DrawScanLine( s8 alpha = -1, bool CharGekiMode = false ) ;	// XLC`悷
extern void _DrawTVScreen( void ) ;										// erʏ{
extern void SetCharChangeMaskModelIndex( MASK_MODEL_INDEX index ) ; 	// L`FWʂŎgp}XÑfݒ肷
extern void SetCharChangeModelIndex( CHARMODEL_INDEX index ) ;			// L`FWʂŎgppL̈ߑZbgw肷

extern void _DrawNoiseScreen( u8 alpha, TEXDATA *Tex = NULL, bool CharGekiMode = false ) ;			// mCY̕`

#endif
