///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCentLight
//
// YK7EffectCentLight.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 03/16/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTCENTLIGHT_H
#define __YK7EFFECTCENTLIGHT_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"

// define ---------------------------------------

#define MAXROLLLINE_NUM			1000				// C̍ő吔

// datatype -------------------------------------

// WGtFNgʃf[^
typedef struct tagCENTLIGHTUNION
{
//	u8 Dummy ;
	WK7JObj *JObj ;			// ǔ JObj
} CENTLIGHTUNION ;

// CIuWFNgf[^
typedef struct tagCENTLIGHTOBJECT
{
	u8 vflag ;					// LtO
	f32 r ;						// [~̒a
	f32 rotp ;					// \ʒu
	f32 rot ;					// \
	f32 len ;					// 
	f32 wait ;					// S܂ł̋
	f32 waitspeed ;				// S܂ł̋炷x
	
	f32 speed ;					// 鑬x
} CENTLIGHTOBJECT ;

// WGtFNgf[^
typedef struct tagCENTLIGHTEFFECT
{
	WK7JObj *JObj ;						// ǔJObj

	CENTLIGHTOBJECT *Obj ;				// ̃f[^ւ̃|C^
	s32 ObjNum ;						// ̐
	s32 MaxObjNum ;						// IuWFNg̍ő吔

	u32 Color ;							// F
	u8 Pos2DFlag ;						// QcWwtO
	f32 LineWidth ;						// ̑

	f32 MaxSpeed, MinSpeed ;			// ő呬xAŏx
	f32 MaxR, MinR ;					// ő唼aAŏa
	f32 MaxLength, MinLength ;			// ő咷Aŏ
	f32 MaxWait, MinWait ;				// S܂ł̋̍őlAŏl
	f32 MaxWaitSpeed, MinWaitSpeed ;	// S܂ł̋k߂ő呬xAŏx
	
	f32 CreateCost ;					// IuWFNg쐬RXg
	f32 CreateCounter ;					// IuWFNg쐬JE^[
	Vec Pos ;							// oW
} CENTLIGHTEFFECT ;

// WGtFNg^XNɓnf[^
typedef struct tagCENTLIGHTEFFECTTACKPARAM
{
	Vec Pos ;							// \W
	f32 MaxSpeed, MinSpeed ;			// ő呬xAŏx
	f32 MaxR, MinR ;					// ő唼aAŏa
	f32 MaxLength, MinLength ;			// ő咷Aŏ
	f32 MaxWait, MinWait ;				// S܂ł̋̍őlAŏl
	f32 MaxWaitSpeed, MinWaitSpeed ;	// S܂ł̋k߂ő呬xAŏx
	f32 LineWidth ;						// ̑
	f32 CreateCost ;					// 쐬RXg
	s32 MaxObjNum ;						// IuWFNg̍ő吔
	u32 Color ;							// F
	u8 Pos2DFlag ;						// QcWwtO
} CENTLIGHTEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitCentLightData( void ) ;				// WGtFNg̋ʃf[^
extern s8 CheckCentLightData( void ) ;				// WGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndCentLightData( void ) ;				// WGtFNg̋ʃf[^n

extern EFFECT *CreateCentLightEffect( 				// WGtFNg쐬
						Vec Pos,							// \W
						f32 MaxSpeed, f32 MinSpeed,			// ő呬xAŏx
						f32 MaxR, f32 MinR,					// ő唼aAŏa
						f32 MaxLength, f32 MinLength,		// ő咷Aŏ
						f32 MaxWait, f32 MinWait,			// S܂ł̋̍őlAŏl
						f32 MaxWaitSpeed, f32 MinWaitSpeed,	// S܂ł̋k߂ő呬xAŏx
						f32 LineWidth,						// ̑
						f32 CreateCost,						// 쐬RXg
						s32 MaxObjNum,						// IuWFNg̍ő吔
						u32 Color,							// F
						u8 Pos2DFlag,						// QcWwtO
						s32 Priority = 2000 ) ;	
extern s8 ReleaseCentLightEffect( EFFECT *Effect ) ;						// WGtFNǧns
extern s8 MoveCentLightEffect( EFFECT *Effect ) ;							// WGtFNgPt[
extern s8 DrawCentLightEffect( EFFECT *Effect ) ;							// WGtFNg`悷

extern s8 SetCentLightPos( Vec Pos, EFFECT *Effect ) ;						// GtFNg̍WύX
extern s8 SetCentLightHomingJObj( WK7JObj *JObj ) ;							// ɍ쐬WGtFNgWǔ JObj o^
extern s8 SetCentLightHomingJObj2( WK7JObj *JObj ) ;						// nꂽ JObj  "MuzFlash00_V1" ToAꍇ͏ɂ̃P[^ǔ

#endif
