///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCut2
//
// YK7EffectCut2.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/09/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTCUT2_H
#define __YK7EFFECTCUT2_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"

// define ---------------------------------------

#define KVN_KNIFE_NUM	(4)			// iCt̐

// datatype -------------------------------------

// JbgQGtFNgʃf[^
typedef struct tagCUT2UNION
{
	u8 dummy ;
} CUT2UNION ;

// JbgQGtFNgf[^
typedef struct tagCUT2EFFECT
{
	Vec pos ;					// W
	Vec speed ;					// x

	WK7Model *model ;			// iCt̃f
	EFFECT *blur1, *blur2 ;		// u[GtFNg
	u32 blur1ID, blur2ID ;		// GtFNghc
	
	s32 time ;					// \
	s32 con ;
} CUT2EFFECT ;

// jumVbgGtFNgf[^
typedef struct tagKVNSHOTEFFECT
{
	EFFECT *effect[2][KVN_KNIFE_NUM] ;
	u32 effectID[2][KVN_KNIFE_NUM] ;
	s32 mod, con ;
	Vec pos, dir ;
	f32 speed ;
} KVNSHOTEFFECT ;

// prototype ------------------------------------

extern s8 InitCut2Data( void ) ;			// JbgQGtFNg̋ʃf[^
extern s8 CheckCut2Data( void ) ;			// JbgQGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndCut2Data( void ) ;			// JbgQGtFNg̋ʃf[^n

extern EFFECT *CreateCut2Effect(
								Vec pos,								// W
								f32 speed,								// x
								u32 InColor, u32 OutColor,				// OƓ̐F
								Vec *dir = NULL, Vec *target = NULL,	// Ⴕ̓^[Qbg
								s32 time = 90,							// \
								s32 Priority = -1 ) ;			// JbgQGtFNg쐬

extern s8 ReleaseCut2Effect( EFFECT *Effect ) ;				// JbgQGtFNǧns
extern s8 MoveCut2Effect( EFFECT *Effect ) ;				// JbgQGtFNgPt[
extern s8 DrawCut2Effect( EFFECT *Effect ) ;				// JbgQGtFNg`悷





extern s8 InitKvnShotData( void ) ;			// PrVbgGtFNg̋ʃf[^
extern s8 CheckKvnShotData( void ) ;		// PrVbgGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndKvnShotData( void ) ;			// PrVbgGtFNg̋ʃf[^n

extern EFFECT *CreateKvnShotEffect(
								Vec pos,								// W
								f32 speed,								// x
								Vec *dir = NULL, Vec *target = NULL,	// Ⴕ̓^[Qbg
								s32 Priority = -1 ) ;					// PrVbgGtFNg쐬

extern s8 ReleaseKvnShotEffect( EFFECT *Effect ) ;						// PrVbgGtFNǧns
extern s8 MoveKvnShotEffect( EFFECT *Effect ) ;							// PrVbgGtFNgPt[
extern s8 DrawKvnShotEffect( EFFECT *Effect ) ;							// PrVbgGtFNg`悷

#endif

