///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectDamage
//
// YK7EffectDamage.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 08/11/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTDAMAGE_H
#define __YK7EFFECTDAMAGE_H

// include --------------------------------------

#include "./YK7Effect.h"
#include "./YK7Break.h"

// define ---------------------------------------

#define MAX_OBJECTNUM			10
//#define MAX_LENGTHOBJNUM		40

// datatype -------------------------------------

// _[WGtFNgʃf[^
typedef struct tagDAMAGEUNION
{
	u8 Dummy ;
} DAMAGEUNION ;

// _[WGtFNgIuWFNg
typedef struct tagDAMAGEOBJECT
{
	WK7JObj *JObj ;				// ]Ă{[ JObj 
	u32 Counter ;				// JE^[
	u32 VertexNumber ;			// _f[^̃io[
	Vec Direction ;				// ]Ă JObj Ƃ̑ΓIȕ
	Vec Position ;				// ]Ă JObj Ƃ̑ΓIȍW
	
	s32 WaitCounter ;			// ҂
} DAMAGEOBJECT ;


// _[WGtFNgf[^
typedef struct tagDAMAGEEFFECT
{
	WK7JObj *JObj ;							// { JObj 
	DAMAGEOBJECT Object[MAX_OBJECTNUM] ;	// IuWFNg̃f[^
	u16 ObjectNum ;							// IuWFNg̐
	u32 Counter ;							// JE^
	s32 MaxWait ;							// ˑ҂ő厞
	s32 MaxTime ;							// ˍő厞
	s32 AllTime ;							// ˑ
	f32	YukaY ;								// ̍
} DAMAGEEFFECT ;

// _[WGtFNgŎg\
typedef struct tagDAMAGEEFFECTINIT
{
	DAMAGEEFFECT *Data ;					// DAMAAGEEFFECT ւ̃|C^
	u32 PolygonNum ;						// |S̐
	u16 MaxObjectNum ;						// IuWFNg̍ő吔
	f32 HitRate ;							// IuWFNgˌɑI肳m
	WK7JObj *ActJObj ;						// ANeBu JObj
	u32 Counter ;
} DAMAGEEFFECTINIT ;

/*
// _vpŎgpf[^\
typedef struct tagDAMAGEEFFECTFUNCCHIP DAMAGEEFFECTFUNCCHIP ;
struct tagDAMAGEEFFECTFUNCCHIP
{
	f32 Length ;						// 
	WK7JObj *JObj ;						// _܂ JObj
	s32 Number ;						// JObj ̒_io[
	
	DAMAGEEFFECTFUNCCHIP *Next, *Back ;	// ̃oւ̃|C^
} ;

// _vpŎgpf[^\
typedef struct tagDAMAGEEFFECTFUNC
{
	s32 Num ;				// 
	s32 MaxNum ;			// ő吔
	Vec Point ;				// rW
	
	WK7JObj *JObj ;			//  JObj
	s32 PointCounter ;		//  JObj ̒_JE^[

	DAMAGEEFFECTFUNCCHIP Chip[MAX_LENGTHOBJNUM] ;	// pɎgp`bv
	DAMAGEEFFECTFUNCCHIP *LastChip ;				// Ō̃`bv
} DAMAGEEFFECTFUNC ;
*/

// _[WGtFNg^XNɓnf[^
typedef struct tagDAMAGEEFFECTTACKPARAM
{
	WK7JObj		*JObj ;
	s32 		MaxWait ;				// ˑ҂ő厞
	s32			MaxTime ;				// ˍő厞
	s32			AllTime ;				// ˑ
	f32			YukaY ;					// ̍
} DAMAGEEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitDamageData( void ) ;				// _[WGtFNg̋ʃf[^
extern s8 CheckDamageData( void ) ;				// _[WGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndDamageData( void ) ;				// _[WGtFNg̋ʃf[^n

extern EFFECT *CreateDamageBlood( WK7JObj *JObj, Vec Point, u8 Num, f32 YukaY, s32 Time = -1, f32 Power = 1.0F, u8 Type = 0 ) ;			// _[WGtFNg̏ꏊw^
extern EFFECT *CreateDamageEffect( WK7JObj *JObj, s32 MaxWait, s32 MaxTime,
									 s32 AllTime, f32 YukaY, s32 Priority = -2 ) ;	// _[WGtFNg쐬
extern s8 ReleaseDamageEffect( EFFECT *Effect ) ;							// _[WGtFNǧns
extern s8 MoveDamageEffect( EFFECT *Effect ) ;								// _[WGtFNgPt[
extern s8 DrawDamageEffect( EFFECT *Effect ) ;								// _[WGtFNg`悷

#endif
