///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectDent
//
// YK7EffectDent.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/19/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------

#include "./YK7EffectDent.h"
#include "../Wat/WK7MainTask.h"

// define ---------------------------------------

#define SCREEN_WIDTHDIVNUM		32			// ʂ̉̕
#define SCREEN_HEIGHTDIVNUM		24			// ʂ̏c̕

// datatype -------------------------------------

// data -----------------------------------------

DENTUNION DenUnion ;

// function code --------------------------------

// ʉ݃GtFNg̋ʃf[^
extern s8 InitDentData( void )
{
	MEMINIT( DenUnion ) ;

	// I
	return 0 ;
}

// ʉ݃GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckDentData( void )
{
	return TRUE ;
}

// ʉ݃GtFNg̋ʃf[^n
extern s8 EndDentData( void )
{
	MEMINIT( DenUnion ) ;
	
	// I
	return 0 ;
}

// ʉ݂̃GtFNg쐬
extern EFFECT *CreateDentEffect( u8 Point2DFlag, Vec Point, f32 Power,
									f32 Ritu, u32 Time, u8 StopFlag,  s32 Priority )
{
	DENTEFFECT *Dent ;
	EFFECT *Effect ;
	
	// Vʉ݃f[^쐬
	Effect = AddEffectData( EFF_DENT, (void**)&Dent, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	// ʉ݃f[^
	Dent->Point = Point ;
	Dent->Power = Power * 10000.0F ;
	Dent->Ritu = Ritu ;
	Dent->Time = Time * 8 / 11 ;
	Dent->Counter = 0 ;
	Dent->Mode = 0 ;
	Dent->StopFlag = StopFlag ;
	Dent->Point2DFlag = Point2DFlag ;
		
	// I
	return Effect ;
}

// ʉ݂̃GtFNǧns
extern s8 ReleaseDentEffect( EFFECT *Effect )
{
	DENTEFFECT *DentEffect = ( DENTEFFECT * )Effect->Data ;

	// ɂ邱ƂȂ
	return 0 ;
}

// ʉ݂̃GtFNgPt[
extern s8 MoveDentEffect( EFFECT *Effect )
{
	DENTEFFECT *DentEffect = ( DENTEFFECT * )Effect->Data ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// [hKlɂĂ폜
	if( DentEffect->Mode == 3 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
/*	else
	{
		// JE^߂
		DentEffect->Counter ++ ;
	}
*/
	
	// I
	return 0 ;
}
	
// ʉ݂̃GtFNg`悷
extern s8 DrawDentEffect( EFFECT *Effect )
{
	DENTEFFECT *DentEffect = ( DENTEFFECT * )Effect->Data ;
//	int DrawNum ;
	DENTUNION *DentUnion = &DenUnion ;
	Vec BrPoint ;
//	static Vec Map[SCREEN_HEIGHTDIVNUM+1][SCREEN_WIDTHDIVNUM+1] ;
	Vec (*Map)[SCREEN_WIDTHDIVNUM+1] = ( Vec (*)[SCREEN_WIDTHDIVNUM+1] )WorkBuffer ;

	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_NONE, EF_TEV_USETEX ) ;							// `̏
	
	// W𓾂
	if( DentEffect->Point2DFlag == FALSE )
		GetScreenPosition( &DentEffect->Point, &BrPoint ) ;
	else
		BrPoint = DentEffect->Point ;
		
	// ʂ̕`Ԃ擾鏈
	{
		screenImageFullColor.ScreenCopy() ;					// ʂ̎擾
		
		// eNX`̃[h
		GTLOAD( screenImageFullColor.GetTexObj() ) ;
	}
	
	// _tH[}bg̃Zbg
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGB, GX_RGB565, 0 ) ;
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_U16, UVSHFTBIT ) ;

	// iq̒_f[^p
	{
		u16 i, j ;
		Vec *Point ;
		f32 r, sx, sy, k, maxr, maxz  ;
		const f32 d = 1115.7475601F ;
		
		switch( DentEffect->Mode )
		{
		case 0 :
			{
				f32 Sx, S, Sxdd, Sxd, t ;
				
				t = (f32)DentEffect->Counter ;
				Sx = 2 / (f32)DentEffect->Time ;
				Sxd = Sx / (f32)DentEffect->Time ;
				Sxdd = Sx - Sxd * t ;
				S = ( ( Sx + Sxdd ) * t ) / 2 ;

				k = S ;
				if( StopFlag == FALSE )
				{
					if( DentEffect->Counter == DentEffect->Time )
					{
						DentEffect->Counter = 0 ;
						DentEffect->Mode ++ ;
					}
					else
					{
						DentEffect->Counter ++ ;
					}
				}
			}
			break ;
			
		case 1 :
			{
				u16 Time ;
				
				Time = (u16)( DentEffect->Time / 4 ) ;
				if( Time < 1 ) Time = 1 ;

				k = 1.0F ;
				if( StopFlag == FALSE && DentEffect->StopFlag == FALSE )
				{
					if( DentEffect->Counter == Time )
					{
						DentEffect->Counter = 0 ;
						DentEffect->Mode ++ ;
					}
					else
					{
						DentEffect->Counter ++ ;
					}
				}
			}
			break ;
			
		case 2 :
			{
				u16 Time ;
				
				Time = (u16)( DentEffect->Time / 8 ) ;
				if( Time <= 1 ) Time = 2 ;
			
				k = 1.0F - (f32)DentEffect->Counter / Time ;
				if( StopFlag == FALSE )
				{
					if( DentEffect->Counter == Time )
					{
						DentEffect->Counter = 0 ;
						DentEffect->Mode ++ ;
					}
					else
					{
						DentEffect->Counter ++ ;
					}
				}
			}
			break ;
			
		case 3 :
			k = 0 ;
			break ;
		}

		// ׂĂ̒_f[^		
		maxz = 0.0F ;
		Point = &Map[0][0] ;
		for( i = 0 ; i < SCREEN_HEIGHTDIVNUM + 1 ; i ++ )
		{
			for( j = 0 ; j < SCREEN_WIDTHDIVNUM + 1 ; j ++, Point ++ )
			{
				// ʏ̍WZo
				Point->y = ( i * SCH / SCREEN_HEIGHTDIVNUM ) ;
				Point->x = ( j * SCW / SCREEN_WIDTHDIVNUM ) ;

				// ւޒS_̋Zlo
				{
					sx = BrPoint.x - Point->x ;
					sy = ( BrPoint.y - Point->y ) * 1.33333F ;
					{
						r = sx * sx ;
						r += sy * sy ;
						r = sqrt( r ) ;
						maxr = pow( -( - DentEffect->Power / DentEffect->Ritu ), 0.5F ) ;
						r = r ;    
						if( r < 0.0F )
						{
							Point->z = 0.0F ;
						}
						else
						{
							Point->z = DentEffect->Power - ( r * r ) * DentEffect->Ritu ;
							Point->z *= k ;
						}
					}

					if( i == 0 || i == SCREEN_HEIGHTDIVNUM || j == 0 || j == SCREEN_WIDTHDIVNUM )
					{
						if( maxz < Point->z )
							maxz = Point->z ;
					}
					else
					{
						Point->z = Point->z ;
					}
				}
			}
		}

		Point = &Map[0][0] ;
		for( i = 0 ; i < SCREEN_HEIGHTDIVNUM + 1 ; i ++ )
		{
			for( j = 0 ; j < SCREEN_WIDTHDIVNUM + 1 ; j ++, Point ++ )
			{
				// ZlɎˉe{
				{
					Point->z -= maxz ;
					Point->z /= 50.0F ;
					if( Point->z > 0 )
					{
						Point->x = ( Point->x - BrPoint.x ) / ( ( Point->z + d ) / d ) + BrPoint.x ;
						Point->y = ( Point->y - BrPoint.y ) / ( ( Point->z + d ) / d ) + BrPoint.y ;
					}
					else
					{
						Point->z += d ;
						if( Point->z < 0 ) Point->z = 0.001F ;
						Point->x = ( Point->x - BrPoint.x ) / ( Point->z / d ) + BrPoint.x ;
						Point->y = ( Point->y - BrPoint.y ) / ( Point->z / d ) + BrPoint.y ;
					}
				}
				Point->z = 200.0F ;
			}
		}
	}

	// `揈
	{
		u16 i, j, Color ;

		GBGN( GX_TRIANGLES, SCREEN_WIDTHDIVNUM * SCREEN_HEIGHTDIVNUM * 2 * 3 ) ;
		{
			Color = GXPackedRGBA4( 255, 255, 255, 255 ) ;
		
			// ̐JԂ
			for( i = 0 ; i < SCREEN_HEIGHTDIVNUM ; i ++ )
			{
				for( j = 0 ; j < SCREEN_WIDTHDIVNUM ; j ++ )
				{
					// W̏o
					GP2( Map[i][j].x, Map[i][j].y ) ;			GXColor1u16( Color ) ;   GT2( j * UVSCALE / SCREEN_WIDTHDIVNUM,			i * UVSCALE / SCREEN_HEIGHTDIVNUM ) ; 
					GP2( Map[i][j+1].x, Map[i][j+1].y ) ;		GXColor1u16( Color ) ;   GT2( ( j + 1 ) * UVSCALE / SCREEN_WIDTHDIVNUM,	i * UVSCALE / SCREEN_HEIGHTDIVNUM ) ; 
					GP2( Map[i+1][j].x, Map[i+1][j].y ) ;		GXColor1u16( Color ) ;   GT2( j * UVSCALE / SCREEN_WIDTHDIVNUM,			( i + 1 ) * UVSCALE / SCREEN_HEIGHTDIVNUM ) ; 
					
					GP2( Map[i+1][j].x, Map[i+1][j].y ) ;		GXColor1u16( Color ) ;   GT2( j * UVSCALE / SCREEN_WIDTHDIVNUM, 		( i + 1 ) * UVSCALE / SCREEN_HEIGHTDIVNUM ) ; 
					GP2( Map[i][j+1].x, Map[i][j+1].y ) ;		GXColor1u16( Color ) ;   GT2( ( j + 1 ) * UVSCALE / SCREEN_WIDTHDIVNUM,	i * UVSCALE / SCREEN_HEIGHTDIVNUM ) ; 
					GP2( Map[i+1][j+1].x, Map[i+1][j+1].y ) ;	GXColor1u16( Color ) ;   GT2( ( j + 1 ) * UVSCALE / SCREEN_WIDTHDIVNUM,	( i + 1 ) * UVSCALE / SCREEN_HEIGHTDIVNUM ) ; 
				}
			}
		}
		GXEnd() ;
	}
	
	// I
	return 0 ;
}
