///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectDraft
//
// YK7EffectDraft.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 01/08/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTDRAFT_H
#define __YK7EFFECTDRAFT_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"
#include "./YK7Break.h"

// define ---------------------------------------

#define DFOBJ_BACKPOSNUM			20			// L^cW̐

// datatype -------------------------------------

// ԕGtFNgʃf[^
typedef struct tagDRAFTUNION
{
	u8 Dummy ;
} DRAFTUNION ;

// ԕIuWFNg
typedef struct tagDRAFTOBJECT
{
	u8 UseFlag ;							// gptO
	Vec Pos[DFOBJ_BACKPOSNUM] ;				// W
	Vec Dir, DDir ;							// 
	f32 DirT ;								// ̐ڏ
	f32 Speed, SSpeed ;						// Xs[h 
	f32 a ;									// At@
	GXColor Color ;							// F
	u8 HokoriFlag ;							// ǂ
} DRAFTOBJECT ;

// ԕGtFNgf[^
typedef struct tagDRAFTEFFECT
{
	DRAFTOBJECT *ObjP ;				// IuWFNg
	s32 ObjNum ;					// IuWFNg̐
	s32 ObjMaxNum ;					// IuWFNg̍ő吔
	
	f32 OneCreateCount ;			// IuWFNgӂɕKvȃJEg̒l
	f32 CreateCounter ;				// IuWFNg쐬JE^

	BASICMESH *Mesh ;				// ԕpbV
	f32 MeshArea ;					// ԕpbV̖ʐ
	Vec CenterPos ;					// ԕbV̒S_
	f32 Speed ;						// ̃Xs[h
	f32 FadeSp ;					// tF[hAEg̑x
	f32 InitDirT ;					// px
} DRAFTEFFECT ;

// ԕGtFNgf[^p\
typedef struct tagDRAFTEFFECTTASKPARAM
{
	WK7JObj *DraftMesh ;			// ԕpbV
	s32 ObjMaxNum ;					// IuWFNg̍ő吔
	f32 Speed ;						// ̃Xs[h
} DRAFTEFFECTTASKPARAM ;


// ԕQGtFNgf[^
typedef struct tagDRAFT2EFFECT
{
	EFFECT *Draft ;					// ԕGtFNg
	u32 DraftID ;
	s32 Counter ;					// ڑ҂JE^[
	f32 t ;							// ڏ

	s32 InitDirCounter ;			// pxpڑ҂JE^[
	f32 InitDirt ;					// pxpڏ

	f32 NowCreateSp, NextCreateSp ;	// 쐬x
	f32 NowInitDir, NextInitDir ;	// px
	f32 NowSpeed, NextSpeed ;		// x
} DRAFT2EFFECT ;

// ԕQGtFNgf[^p\
typedef struct tagDRAFT2EFFECTTASKPARAM
{
	WK7JObj *DraftMesh ;			// ԕpbV
	s32 ObjMaxNum ;					// IuWFNg̍ő吔
} DRAFT2EFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitDraftData( void ) ;			// ԕGtFNg̋ʃf[^
extern s8 CheckDraftData( void ) ;			// ԕGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndDraftData( void ) ;				// ԕGtFNg̋ʃf[^n

extern EFFECT *CreateDraftEffect( WK7JObj *DraftMesh, s32 ObjMaxNum,
									f32 Speed = -1, f32 FadeSp = -1, f32 InitDirT = -1.0F, s32 Priority = -130 ) ;		// ԕGtFNg쐬
extern s8 ReleaseDraftEffect( EFFECT *Effect ) ;							// ԕGtFNǧns
extern s8 MoveDraftEffect( EFFECT *Effect ) ;								// ԕGtFNgPt[
extern s8 DrawDraftEffect( EFFECT *Effect ) ;								// ԕGtFNg`悷

extern s8 SetDraftEffectCreateSpeed( EFFECT *Effect, f32 CreSpeed ) ;	// ԕ̍쐬Xs[hύX
extern s8 SetDraftEffectSpeed( EFFECT *Effect, f32 Speed ) ;			// ԕ̃Xs[hύX
extern s8 SetDraftEffectFadeSp( EFFECT *Effect, f32 FadeSp ) ;			// ԕ̃tF[hAEg̑xύX
extern s8 SetDraftEffectInitDirT( EFFECT *Effect, f32 InitDirT ) ;		// ԕ̏pxύX




extern s8 InitDraft2Data( void ) ;			// ԕ2GtFNg̋ʃf[^
extern s8 CheckDraft2Data( void ) ;			// ԕ2GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndDraft2Data( void ) ;				// ԕ2GtFNg̋ʃf[^n

extern EFFECT *CreateDraft2Effect( WK7JObj *DraftMesh, s32 ObjMaxNum, s32 Priority = -1 ) ;			// ԕ2GtFNg쐬
extern s8 ReleaseDraft2Effect( EFFECT *Effect ) ;					// ԕ2GtFNǧns
extern s8 MoveDraft2Effect( EFFECT *Effect ) ;						// ԕ2GtFNgPt[
extern s8 DrawDraft2Effect( EFFECT *Effect ) ;						// ԕ2GtFNg`悷

extern s8 DelReqDraft2Effect( EFFECT *Effect ) ;					// 폜NGXgs


#endif

