///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectFade
//
// YK7EffectFade.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 02/04/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTFADE_H
#define __YK7EFFECTFADE_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// tF[hGtFNgʃf[^
typedef struct tagFADEUNION
{
	u8 Dummy ;
} FADEUNION ;

// tF[hGtFNgf[^
typedef struct tagFADEEFFECT
{
	GXColor Color ;					// F
	
	f32 AlphaSpeed ;				// At@̕ωx
	f32 Alpha ;						// At@l
	u8 FadeFlag ;					// tF[h邩ǂtO
} FADEEFFECT ;

// tF[hGtFNg^XNɓnf[^
typedef struct tagFADEEFFECTTACKPARAM
{
	GXColor Color ;					// F
	f32 AlphaSpeed ;				// At@̕ωx
} FADEEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitFadeData( void ) ;				// tF[hGtFNg̋ʃf[^
extern s8 CheckFadeData( void ) ;				// tF[hGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndFadeData( void ) ;					// tF[hGtFNg̋ʃf[^n

extern EFFECT *CreateFadeEffect( GXColor Color, f32 AlphaSpeed, s32 Priority = 6000 ) ;	// tF[hGtFNg쐬
extern s8 ReleaseFadeEffect( EFFECT *Effect ) ;											// tF[hGtFNǧns
extern s8 MoveFadeEffect( EFFECT *Effect ) ;											// tF[hGtFNgPt[
extern s8 DrawFadeEffect( EFFECT *Effect ) ;											// tF[hGtFNg`悷

extern s8 SetFadeEffectFlag( s8 Flag, EFFECT *Effect ) ;					// tF[h邩ǂ̃tOZbg
extern s8 SetFadeEffectAlphaSpeed( f32 AlphaSpeed, EFFECT *Effect ) ;		// tF[h̃At@̕ωxύX
extern s8 GetFadeEffectState( EFFECT *Effect ) ;							// tF[h̏Ԃ擾( TRUE:tF[h؂Ă  FALSE:tF[hĂȂ )

#endif
