///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectFlash2
//
// YK7EffectFlash2.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 02/02/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTFLASH2_H
#define __YK7EFFECTFLASH2_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

#define FLASH2_DIRMAXNUM		100

// datatype -------------------------------------

// tbVQGtFNgʃf[^
typedef struct tagFLASH2UNION
{
	bool Flash2Valid ;			// Q̃tbVo邩ǂ̃tO
	u8 Flash2Wait ;				// Q̃tbVo܂ł̎
	u32 Flash2Color ;			// ̃tbV̐F
} FLASH2UNION ;

// tbVIuWFNgf[^
typedef struct tagFLASH2OBJ
{
	u8 Brink ;			// _ŏp
	f32 xzrot, oirrot ;	// 
	f32 Width ;			// 
} FLASH2OBJ ;

// tbVQGtFNgf[^
typedef struct tagFLASH2EFFECT
{
	bool Flash2Valid ;			// Q̃tbVo邩ǂ̃tO
	u8 Flash2Wait ;				// Q̃tbVo܂ł̎

	Vec Pos ;								// 钆S_
	FLASH2OBJ Obj[FLASH2_DIRMAXNUM] ; 		// ̏
	s32 ObjNum ;							// ̐

	f32 Wait ;							// oԊu
	f32 Counter ;						// JE^
	f32 Length ;						// 

	f32 MaxWidth, MinWidth ;			// ̍ő̕ƍŏ̕
	GXColor Color ;						// F
	
	f32 Fl1Width ;					// LP̍L
	f32 Fl2Width ;					// LQ̍L
	u32 Fl2Color ;					// LQ̐F
	u32 FlCounter ;					// tbV֌W̃JE^[

	f32 a ;							// Ŝ̃At@
} FLASH2EFFECT ;

// tbVQGtFNg^XNɓnf[^
typedef struct tagFLASH2EFFECTTACKPARAM
{
	Vec Pos ;							// 钆S_
	s32 Wait ;							// oԊu
	f32 Length ;						// 

	f32 MaxWidth, MinWidth ;			// ̍ő̕ƍŏ̕
	GXColor Color ;						// F
} FLASH2EFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitFlash2Data( void ) ;				// tbVQGtFNg̋ʃf[^
extern s8 CheckFlash2Data( void ) ;				// tbVQGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndFlash2Data( void ) ;				// tbVQGtFNg̋ʃf[^n

extern EFFECT *CreateFlash2Effect( 	Vec Pos,							// 钆S_
									f32 Wait,							// oԊu
									f32 Length,							// 

									f32 MaxWidth, f32 MinWidth,			// ̍ő̕ƍŏ̕
									GXColor Color,						// F
									s32 Priority = -1 ) ;		// tbVQGtFNg쐬
extern s8 ReleaseFlash2Effect( EFFECT *Effect ) ;										// tbVQGtFNǧns
extern s8 MoveFlash2Effect( EFFECT *Effect ) ;											// tbVQGtFNgPt[
extern s8 DrawFlash2Effect( EFFECT *Effect ) ;											// tbVQGtFNg`悷

extern s8 Flash2EffectFlash2Setup( bool Valid, u8 Wait, u32 Color ) ;		// Q̃tbṼZbgAbv


#endif
