///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectFlashBom
//
// YK7EffectFlashBom.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/13/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectFlashBom.h"
#include "./YK7EffectFlash2.h"

// define ---------------------------------------

#define PRM			(s32)VParam[ED_FLASHBOM]

#define WHITETIME	(PRM[0])

// data -----------------------------------------

FLASHBOMUNION flbu ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// MGtFNg̋ʃf[^
extern s8 InitFlashBomData( void )
{
	MEMINIT( flbu ) ;

	return 0 ;
}

// MGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckFlashBomData( void )
{
	return TRUE ;
}

// MGtFNg̋ʃf[^n
extern s8 EndFlashBomData( void )
{
	MEMINIT( flbu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// MGtFNg쐬
extern EFFECT *CreateFlashBomEffect(
									Vec Pos,					// W
									s32 Wait,					// ܂ł̎
									s32 Priority )				// MGtFNg쐬
{
	EFFECT *Effect, *Flash2 ;
	FLASHBOMEFFECT *fb ;
	GXColor Color ;
	
	Flash2EffectFlash2Setup( true, (u8)Wait, 0xffffffff ) ;
	*((u32 *)&Color) = CMK( VParam[ED_FLASH2][4], VParam[ED_FLASH2][5], VParam[ED_FLASH2][6], VParam[ED_FLASH2][7] ) ;
	Flash2 = CreateFlash2Effect( Pos,								// 钆S_
								(f32)VParam[ED_FLASH2][0] * 0.1F,	// oԊu	
								VParam[ED_FLASH2][1],				// 
								VParam[ED_FLASH2][2] * 0.1F, VParam[ED_FLASH2][3] * 0.1F,	// ̍ő̕ƍŏ̕
								Color ) ;
	if( Flash2 == NULL ) return NULL ;
	
	// VMf[^쐬
	Effect = AddEffectData( EFF_FLASHBOM, (void**)&fb, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	memset( fb, 0, sizeof( FLASHBOMEFFECT ) ) ;

	// ̏
	fb->wait = Wait ;
	fb->Flash2 = Flash2 ;
	fb->Flash2ID = GetEffectID( fb->Flash2 ) ;
	fb->mod = fb->con = 0 ;

	// I
	return Effect ;
}

// MGtFNǧns
extern s8 ReleaseFlashBomEffect( EFFECT *Effect )
{
	FLASHBOMEFFECT *fb = ( FLASHBOMEFFECT * )Effect->Data ;
	
	if( CheckEffectValidState( fb->Flash2, fb->Flash2ID ) == TRUE ) DeleteEffect( fb->Flash2 ) ;

	// I
	return 0 ;
}

// MGtFNgPt[
extern s8 MoveFlashBomEffect( EFFECT *Effect )
{
	FLASHBOMEFFECT *fb = ( FLASHBOMEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	if( Effect->DelReqFlag == TRUE )
	{
		if( CheckEffectValidState( fb->Flash2, fb->Flash2ID ) == TRUE ) DelReqEffect( fb->Flash2 ) ;
		else
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
	}
	else
	{
		fb->con ++ ;
		if( fb->con >= WHITETIME + fb->wait )
		{
			DelReqEffect( Effect ) ;
			return 0 ;
		}
	}
	
	if( Effect->IndeManageFlag )
	{
		if( CheckEffectValidState( fb->Flash2, fb->Flash2ID ) == TRUE )
			MoveEffect( fb->Flash2 ) ;
	}

	// I
	return 0 ;
}

// MGtFNg`悷
extern s8 DrawFlashBomEffect( EFFECT *Effect )
{
	FLASHBOMEFFECT *fb = ( FLASHBOMEFFECT * )Effect->Data ;

	if( Effect->IndeManageFlag )
	{
		if( CheckEffectValidState( fb->Flash2, fb->Flash2ID ) == TRUE )
			DrawEffect( fb->Flash2 ) ;
	}

	// I
	return 0 ;
}

// MGtFNg̓ƗǗtOZbg
extern s8 IndeFlashBomEffect( EFFECT *Effect, s8 Flag )
{
	FLASHBOMEFFECT *fb = ( FLASHBOMEFFECT * )Effect->Data ;

	if( CheckEffectValidState( fb->Flash2, fb->Flash2ID ) == TRUE )
		SetEffectIndeManageFlag( fb->Flash2, Flag ) ;

	// I
	return 0 ;
}


