///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectFlower
//
// YK7EffectFlower.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 01/13/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define _SPGAGE

// include --------------------------------------
#include "./YK7EffectFlower.h"
#include "./YK7EffectSpSkillGage.h"

// define ---------------------------------------

#define FLOWERNAME			"/Yam/Effect/Flower/Flower"

#define CONVEBLOODPAT_ONELINENUM		2
#define CONVEBLOODPAT_NUM			(CONVEBLOODPAT_ONELINENUM*CONVEBLOODPAT_ONELINENUM)
#define CONVEBLOODONE_SIZE			( UVSCALE / CONVEBLOODPAT_ONELINENUM )

#define ADD_Y		0
#define TEXNUM		1

// datatype -------------------------------------

// data -----------------------------------------

FLOWERUNION FlwUnion ;

const s32 FlowerPos[BLOODTEX_NUM][FLOWER_GRAPHNUM][2] =
{
	{ 0, ADD_Y,  0, 84 + ADD_Y,  0, 0,  0, 0,  0, 0 },		// 
	{ 0, ADD_Y,  0, 64 + ADD_Y,  0, 0,  0, 0,  0, 0 },		// o			ij		F		_
	{ 0, ADD_Y,  0, 64 + ADD_Y,  0, 0,  0, 0,  0, 0 },		// 			iȈj	FF		R
	{ 0, ADD_Y,  0, 64 + ADD_Y,  0, 0,  0, 0,  0, 0 },		// OWIX	ij	FsN	JGf
	{ 0, ADD_Y,  0, 64 + ADD_Y,  0, 0,  0, 0,  0, 0 },		// A		ij	Fi)	R[e
	{ 0, ADD_Y,  0, 64 + ADD_Y,  0, 0,  0, 0,  0, 0 },		// Ɋy		iej	FIW	}XN
	{ 0, ADD_Y,  0, 64 + ADD_Y,  0, 0,  0, 0,  0, 0 },		// N		i􂢁j	F		PB

	{ 0, ADD_Y,  0, 64 + ADD_Y,  0, 0,  0, 0,  0, 0 },		// @			i_j	FF		n[}
	{ 0, ADD_Y,  0, 64 + ADD_Y,  0, 0,  0, 0,  0, 0 },		// 			íj	F		KVA
} ;

// function code --------------------------------

// Ԃ̋ʃf[^
extern s8 InitFlowerData( void )
{
	MEMINIT( FlwUnion ) ;

	// I
	return 0 ;
}

// ԃGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckFlowerData( void )
{
	return TRUE ;
}

// Ԃ̋ʃf[^n
extern s8 EndFlowerData( void )
{
	s32 i ;

	return 0 ;
	
	// Yꂪxo
	for( i = 0 ; i < BLOODTEX_NUM ; i ++ )
	{
		if( FlwUnion.FlData[i].RefCount != 0 )
		{
			OSReport( "ԃeNX`̉Yꂪ܂ TexNo %d \n", i ) ;
		}
	}

	MEMINIT( FlwUnion ) ;

	// I
	return 0 ;
}


// ԃGtFNg쐬
extern EFFECT *CreateFlowerEffect( s32 TexNumber, s32 Priority )
{
	FLOWEREFFECT *Flower ;
	EFFECT *Effect ;

#ifdef _SPGAGE
	{
		Vec Point ;
		
		Point.x = VParam[ED_SAR][11] ;
		Point.y = VParam[ED_SAR][12] ;
		Point.z = 0.0F ;
		return CreateSpSkillGageEffect( Point, 1 ) ;
	}
#endif

	// Vԃf[^쐬
	Effect = AddEffectData( EFF_FLOWER, (void**)&Flower, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// ԃf[^
	Flower->TexNumber = TexNumber ;
//	Flower->ChargeState = 1.0F ;
	Flower->DrawFlag = FALSE ;
	Flower->a = Flower->t = 0.0F ;

	// I
	return Effect ;
}

// ԃGtFNǧns
extern s8 ReleaseFlowerEffect( EFFECT *Effect )
{
	FLOWEREFFECT *Flower = ( FLOWEREFFECT * )Effect->Data ;

	// ɂ邱ƂȂ
	return 0 ;
}

// ԃGtFNgPt[
extern s8 MoveFlowerEffect( EFFECT *Effect )
{
	FLOWEREFFECT *Fl = ( FLOWEREFFECT * )Effect->Data ;
	FLOWERDATA *Flw = &FlwUnion.FlData[Fl->TexNumber] ;

	if( (FLOWEREFFECT *)NULL == Fl ) return 0 ;
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// ̃eNX`ǂݍ܂ĂȂ牽I
	if( CheckFlowerData() == FALSE ) return 0 ;

	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	if( Flw->ChargeState == 1.0F )
	{
		Flw->CompCounter ++ ;
		if( Flw->CompCounter >= VParam[ED_FLOWER][9] ) Flw->CompFlag = TRUE ;
	}
	else
	{
		Flw->CompCounter = 0 ;
	}
	
//	if( Fl->ChargeState == 1.0F )
	if( Flw->ChargeState == 1.0F && Flw->CompFlag == TRUE/*Flw->VertList->VertNum*/ )
//	if( 0 )
	{
		if( Fl->t == 1.0F )
		{
			Fl->a += (f32)VParam[ED_FLOWER][2] * 0.01F ;
			if( Fl->a > 1.0F ) Fl->a = 1.0F ;
		}
		else
		{
			Fl->t += (f32)VParam[ED_FLOWER][1] * 0.01F ;
			if( Fl->t > 1.0F ) Fl->t = 1.0F ;
			Fl->a = 0.0F ;
		}
	}
	else
	{
		if( Fl->a != 0.0F )
		{
			Fl->a -= VParam[ED_FLOWER][2] * 0.01F ;
			if( Fl->a < 0.0F ) Fl->a = 0.0F ;
		}
		else
		{
			if( Fl->t != 0.0F )
			{
				Fl->t -= VParam[ED_FLOWER][3] * 0.01F ;
				if( Fl->t < 0.0F ) Fl->t = 0.0F ;
			}
		}
	}
		

	// I
	return 0 ;
}
	
// ԃGtFNg`悷
extern s8 DrawFlowerEffect( EFFECT *Effect )
{
	FLOWEREFFECT *Fl = ( FLOWEREFFECT * )Effect->Data ;
	FLOWERDATA *Flw = &FlwUnion.FlData[Fl->TexNumber] ;
	FLOWEROBJ *Ob ;
	s32 i ;
	u8 a ;
	const s32 *Pos ;
	GhmGcTexHeader *Head ;

	return 0 ;

	if( (FLOWEREFFECT *)NULL == Fl ) return 0 ;
	if( Fl->DrawFlag == FALSE ) return 0 ;
	if( CheckSetupFlower( Fl->TexNumber ) == FALSE ) return 0 ;
	if( CheckFlowerData() == FALSE ) return 0 ;
	if( FlwUnion.AllNotDrawFlag == TRUE ) return 0 ;

	// At@l̎Zo
	a = (u8)( 255 * ( 1.0F - Fl->a ) ) ; 

	// ԕق`悷
	if( Flw->ObjCompNum != 0 && a != 0 )
	{
		u32 Num ;
		Vec tp[4] ;
		EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;
		GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_U16, UVSHFTBIT ) ;

		// eNX`̃[h
		GTLOAD( &GetBloodTex((u8)FlwUnion.LastTexNumber)->Obj ) ;

		tp[0].x = (f32)VParam[ED_FLOWER][5] * -0.5F ;	tp[0].y = (f32)VParam[ED_FLOWER][5] * -0.5F ;
		tp[1].x = (f32)VParam[ED_FLOWER][5] * +0.5F ;	tp[1].y = (f32)VParam[ED_FLOWER][5] * -0.5F ;
		tp[2].x = (f32)VParam[ED_FLOWER][5] * +0.5F ;	tp[2].y = (f32)VParam[ED_FLOWER][5] * +0.5F ;
		tp[3].x = (f32)VParam[ED_FLOWER][5] * -0.5F ;	tp[3].y = (f32)VParam[ED_FLOWER][5] * +0.5F ;

		Num = Flw->ObjCompNum ;
		if( Num * 4 > 65535 ) Num = 65535 / 4 ;
		GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( Num * 4 ) ) ;
		Ob = Flw->VertObj ;
		for( i = 0 ; i < Num ; Ob ++ )
		{
			if( Ob->UseFlag == TRUE )
			{
				i ++ ;

				switch( Ob->RotType )
				{
				case 0 :
					GP2( tp[0].x + Ob->x, tp[0].y + Ob->y  ) ; GC1( 255, a ) ; GT2( Ob->Pu, Ob->Pv ) ;
					GP2( tp[1].x + Ob->x, tp[1].y + Ob->y  ) ; GC1( 255, a ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), Ob->Pv ) ;
					GP2( tp[2].x + Ob->x, tp[2].y + Ob->y  ) ; GC1( 255, a ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
					GP2( tp[3].x + Ob->x, tp[3].y + Ob->y  ) ; GC1( 255, a ) ; GT2( Ob->Pu, (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
					break ;
					
				case 1 :
					GP2( tp[0].x + Ob->x, tp[0].y + Ob->y  ) ; GC1( 255, a ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), Ob->Pv ) ;
					GP2( tp[1].x + Ob->x, tp[1].y + Ob->y  ) ; GC1( 255, a ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
					GP2( tp[2].x + Ob->x, tp[2].y + Ob->y  ) ; GC1( 255, a ) ; GT2( Ob->Pu, (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
					GP2( tp[3].x + Ob->x, tp[3].y + Ob->y  ) ; GC1( 255, a ) ; GT2( Ob->Pu, Ob->Pv ) ;
					break ;
					
				case 2 :
					GP2( tp[0].x + Ob->x, tp[0].y + Ob->y  ) ; GC1( 255, a ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
					GP2( tp[1].x + Ob->x, tp[1].y + Ob->y  ) ; GC1( 255, a ) ; GT2( Ob->Pu, (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
					GP2( tp[2].x + Ob->x, tp[2].y + Ob->y  ) ; GC1( 255, a ) ; GT2( Ob->Pu, Ob->Pv ) ;
					GP2( tp[3].x + Ob->x, tp[3].y + Ob->y  ) ; GC1( 255, a ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), Ob->Pv ) ;
					break ;
					
				case 3 :
					GP2( tp[0].x + Ob->x, tp[0].y + Ob->y  ) ; GC1( 255, a ) ; GT2( Ob->Pu, (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
					GP2( tp[1].x + Ob->x, tp[1].y + Ob->y  ) ; GC1( 255, a ) ; GT2( Ob->Pu, Ob->Pv ) ;
					GP2( tp[2].x + Ob->x, tp[2].y + Ob->y  ) ; GC1( 255, a ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), Ob->Pv ) ;
					GP2( tp[3].x + Ob->x, tp[3].y + Ob->y  ) ; GC1( 255, a ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
					break ;

				}
			}
		}
		GXEnd() ;
	}
	
	// Ԃ`
	{
		EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;
		
		// ԕق`
		GTLOAD2( Flw->Tex[0] ) ;
		Pos = &FlowerPos[Fl->TexNumber][0][0] ;
		Head = Flw->Tex[0].Data.Header ;
		GBGN( GX_QUADS, 4 ) ;
		{
			GP2( Pos[0],				Pos[1]  ) ;					GC1( 255, (u8)( Fl->a * 255 ) ) ;	GT( 0.0F, 0.0F ) ;
			GP2( Pos[0] + Head->mWidth,	Pos[1]  ) ;					GC1( 255, (u8)( Fl->a * 255 ) ) ;	GT( 1.0F, 0.0F ) ;
			GP2( Pos[0] + Head->mWidth,	Pos[1] + Head->mHeight  ) ;	GC1( 255, (u8)( Fl->a * 255 ) ) ;	GT( 1.0F, 1.0F ) ;
			GP2( Pos[0],				Pos[1] + Head->mHeight  ) ;	GC1( 255, (u8)( Fl->a * 255 ) ) ;	GT( 0.0F, 1.0F ) ;
		}
		GXEnd() ;
	}

	// I
	return 0 ;
}

// `[WZbg(1.0F:őlBҋ@   0.0F:܂ĂȂ)
extern s8 SetFlowerRate( f32 GageRate, EFFECT *Effect )
{
	return 0 ;
	
#ifdef _SPGAGE
	return SetSpSkillGageRate( GageRate, Effect ) ;
#endif

	FLOWEREFFECT *Fl = ( FLOWEREFFECT * )Effect->Data ;
	FLOWERDATA *Flw = &FlwUnion.FlData[Fl->TexNumber] ;

//	Flower->ChargeState = GageRate ;
	Flw->ChargeState = GageRate ;
	if( Flw->ChargeState == 0.0F )
	{
		memset( Flw->VertFlag, 0, sizeof( u8 ) * Flw->VertList->VertNum ) ;
		Flw->CompNum = 0 ;

		memset( Flw->VertObj, 0, sizeof( FLOWEROBJ ) * Flw->VertList->VertNum ) ;
		Flw->ObjCompNum = 0 ;
		
		Flw->CompFlag = FALSE ;
		Flw->CompCounter = 0 ;
	}
	
	// I
	return 0 ;
}

// Ԃ`悷邩ǂ̃tOZbg
extern s8 SetFlowerRenderFlag( u8 RenderFlag, EFFECT *Effect )
{
	return 0 ;

#ifdef _SPGAGE
	return SetSpSkillGageRenderFlag( RenderFlag, Effect ) ;
#endif

	FLOWEREFFECT *Flower = ( FLOWEREFFECT * )Effect->Data ;
	
	Flower->DrawFlag = (s8)RenderFlag ;

	// I
	return 0 ;
}

// ԃeNX`̃ZbgAbvs
extern s8 SetupFlower( s32 TexNumber )
{
	FLOWERDATA *Flw = &FlwUnion.FlData[TexNumber] ;

	return 0 ;

	// ܂ǂݍ܂ĂȂǂݍ
	if( Flw->RefCount == 0 )
	{
		char FileName[128] ;
		s32 i ;
	
		for( i = 0 ; i < TEXNUM/*FLOWER_GRAPHNUM*/ ; i ++ )
		{
			sprintf( FileName, "%s%02d_%02d.BIN", FLOWERNAME, TexNumber, i ) ;
//			ATexLoadSet( FileName, &Flw->Tex[i] ) ;
			TexLoadSet( FileName, &Flw->Tex[i] ) ;
		}

		// _Xgǂݍ
		{
			u32 Size ;
		
			Flw->VertFile = NULL ;
			Flw->VertList = NULL ;
			Flw->VertFlag = NULL ;
		
			Flw->VertFile = new ghmGcFile ;
			if( Flw->VertFile == NULL ) return -1 ;
			sprintf( FileName, "%s%02d_%02d.BIN", FLOWERNAME, TexNumber, 2 ) ;
			if( Flw->VertFile->Open( FileName ) == false )
			{
				delete Flw->VertFile ;
				Flw->VertFile = NULL ;
				return -1 ;
			}

			Flw->VertList = ( VERTLIST * )K7AppSmallMemAllocName( (s32)( Size = Flw->VertFile->GetLength(true) ), "Y_FlwVert" ) ;
			if( Flw->VertList == NULL )
			{
				delete Flw->VertFile ;
				Flw->VertFile = NULL ;
				return -1 ;
			}
			
			// ǂݍ݊Jn
			Flw->VertFile->Read( Flw->VertList, 0, (s32)Flw->VertFile->GetLength(true) ) ;
		}
	}
	
	// JE^CNg
	Flw->RefCount ++ ;

	// I
	return 0 ;
}

// ԃeNX`̌ns
extern s8 ReleaseFlower( s32 TexNumber )
{
	FLOWERDATA *Flw = &FlwUnion.FlData[TexNumber] ;
	s32 i ;
	
	return 0 ;

	// ǂݍ܂ĂȂ牽I
	if( Flw->RefCount == 0 ) return FALSE ;

	// QƃJE^CNg
	Flw->RefCount -- ;
	
	// QƐOɂȂeNX`
	if( Flw->RefCount == 0 )
	{
		for( i = 0 ; i < TEXNUM/*FLOWER_GRAPHNUM*/ ; i ++ )
		{
//			ATexRelease( &Flw->Tex[i] ) ;
			TexRelease( &Flw->Tex[i] ) ;
		}
		
		CLOSECHK(Flw->VertFile) ;
		if( Flw->VertList != NULL )
		{
			K7AppSmallMemFree( Flw->VertList ) ;
			Flw->VertList = NULL ;
		}
		if( Flw->VertFlag != NULL )
		{
			ghmGcMemFree( Flw->VertFlag ) ;
			Flw->VertFlag = NULL ;
		}
		if( Flw->VertObj != NULL )
		{
			ghmGcMemFree( Flw->VertObj ) ;
			Flw->VertObj = NULL ;
		}

		Flw->CompNum = 0 ;
		Flw->ObjCompNum = 0 ;
	}

	// I
	return 0 ;
}


// ԃeNX`̃ZbgAbvĂ邩𒲂ׂ( TRUE:  FALSE:܂ )
extern s8 CheckSetupFlower( s32 TexNumber )
{
	FLOWERDATA *Flw = &FlwUnion.FlData[TexNumber] ;
	s32 i ;

	return TRUE ;

	// ǂݍ܂ĂȂ牽I
	if( Flw->RefCount == 0 ) return FALSE ;
	
	// ǂꂩłǂݍ܂ĂȂʖ
	for( i = 0 ; i < TEXNUM/*FLOWER_GRAPHNUM*/ ; i ++ )
//		if( ATexLoadChk( &Flw->Tex[i] ) == FALSE ) return FALSE ;
		if( TexLoadChk( &Flw->Tex[i] ) == FALSE ) return FALSE ;

	if( CHKFILELOAD(Flw->VertFile) == FALSE ) return FALSE ;
	if( Flw->VertFile != NULL )
	{
		CLOSECHK(Flw->VertFile) ;
		
		// f[^rbOGfBA烊gGfBAɕϊ
		{
			VERT2D *V2D ;
		
			Flw->VertList->VertNum = (u32)( ( ( (u8 *)&Flw->VertList->VertNum )[3] << 24 ) |
										( ( (u8 *)&Flw->VertList->VertNum )[2] << 16 ) |
										( ( (u8 *)&Flw->VertList->VertNum )[1] << 8 ) |
										( ( (u8 *)&Flw->VertList->VertNum )[0] ) ) ;
			V2D = ( VERT2D * )( (u8 *)Flw->VertList + sizeof( VERTLIST ) ) ;
			for( i = 0 ; i < Flw->VertList->VertNum ; i ++, V2D ++ )
			{
				V2D->x = (u16)( ( ((u8 *)&V2D->x)[1] << 8 ) | ( ((u8 *)&V2D->x)[0] ) ) ;
				V2D->y = (u16)( ( ((u8 *)&V2D->y)[1] << 8 ) | ( ((u8 *)&V2D->y)[0] ) ) ;
			}
		}
	}
	
	if( Flw->VertFlag == NULL )
	{
		// tOɕKvȃmۂ
		Flw->VertFlag = ( u8 * )( ghmGcMemAllocName( (s32)( Flw->VertList->VertNum * sizeof( u8 ) ), "Y_VRTFLAG" ) ) ;
		if( Flw->VertFlag == NULL ) return FALSE ;
		memset( Flw->VertFlag, 0, Flw->VertList->VertNum * sizeof( u8 ) ) ;
	}

	if( Flw->VertObj == NULL )
	{
		// `pIuWFNgɕKvȃmۂ
		Flw->VertObj = ( FLOWEROBJ * )( ghmGcMemAllocName( (s32)( Flw->VertList->VertNum * sizeof( FLOWEROBJ ) ), "Y_VRTOBJ" ) ) ;
		if( Flw->VertObj == NULL ) return FALSE ;
		memset( Flw->VertObj, 0, Flw->VertList->VertNum * sizeof( FLOWEROBJ ) ) ;
	}

	// I
	return TRUE ;
}
	
// ԕقł䂭ׂW擾
extern s32 GetFlowerObjPos( s32 TexNumber, Vec *Pos )
{
/*	Pos->y = Pos->x = 0 ;
	return 0 ;
*/
	return 0 ;

	FLOWERDATA *Flw = &FlwUnion.FlData[TexNumber] ;
	u32 Num, i, j/*, SNum*/ ;
	VERT2D *V2D ;
	
	// ɔ΂ԕقׂ͂Ĕł邩𒲂ׂ
//	SNum = (u32)( Flw->VertList->VertNum * Flw->ChargeState ) ;
//	if( Flw->CompNum >= SNum )
	if( Flw->CompNum >= Flw->VertList->VertNum )
	{
		// ΂ԕقׂĔłꍇ͍܂Ŕ񂾂Ƃ̂
		// Wn
		Num = ( Flw->CompNum * rand() / RAND_MAX ) % Flw->CompNum + 1 ;
		V2D = ( VERT2D * )( (u8 *)Flw->VertList + sizeof( VERTLIST ) ) ;
		for( i = 0, j = 0 ; ; i ++ )
		{
			if( Flw->VertFlag[i] == TRUE )
			{
				j ++ ;
				if( j == Num )
				{
					Pos->x = V2D[i].x + FlowerPos[TexNumber][0][0] ;
					Pos->y = V2D[i].y + FlowerPos[TexNumber][0][1] ;
					Pos->z = 0.0F ;
					break ;
				}
			}
		}
	}
	else
	{
		// ΂ԕقꍇ͂T
		Num = ( ( Flw->VertList->VertNum/*SNum*/ - Flw->CompNum ) * rand() / RAND_MAX ) %
				 ( Flw->VertList->VertNum/*SNum*/ - Flw->CompNum ) + 1 ;
		V2D = ( VERT2D * )( (u8 *)Flw->VertList + sizeof( VERTLIST ) ) ;
		for( i = 0, j = 0 ; ; i ++ )
		{
			if( Flw->VertFlag[i] == FALSE )
			{
				j ++ ;
				if( j == Num )
				{
					Pos->x = V2D[i].x + FlowerPos[TexNumber][0][0] ;
					Pos->y = V2D[i].y + FlowerPos[TexNumber][0][1] ;
					Pos->z = 0.0F ;
					break ;
				}
			}
		}
		
		// ΂ԕق̐𑝂₷
		Flw->VertFlag[i] = TRUE ;
		Flw->CompNum ++ ;
	}

	// I
	return (s32)i ;
}

// ԕق̕`Zbg
extern s8 SetFlowerDrawObj( s32 TexNumber, BLOODOBJECT *Obj, s32 VertNumber )
{
	return 0 ;

	FLOWERDATA *Flw = &FlwUnion.FlData[TexNumber] ;
	FLOWEROBJ *Ob = &Flw->VertObj[VertNumber] ;
	VERT2D *V2D = &((VERT2D *)( (u8 *)Flw->VertList + sizeof( VERTLIST ) ))[VertNumber] ;
	
	// IuWFNgɕKvȏ𖄂ߍ
//	Ob->x = Obj->x ;
//	Ob->y = Obj->y ;
	Ob->x = V2D->x + FlowerPos[TexNumber][0][0] ;
	Ob->y = V2D->y + FlowerPos[TexNumber][0][1] ;
	Ob->Pu = Obj->Pu ;
	Ob->Pv = Obj->Pv ;
	Ob->RotType = Obj->RotType ;
	
	// ܂gpł͂Ȃꍇ̓JEg
	if( Ob->UseFlag == FALSE )
	{
		Ob->UseFlag = TRUE ;
		Flw->ObjCompNum ++ ;
		
		if( Flw->ObjCompNum == Flw->CompNum )
		{
			Flw->CompFlag = TRUE ;
		}
	}

	FlwUnion.LastTexNumber = TexNumber ;

	// I
	return 0 ;
}
	
// Ԃ\Ă邩ǂ擾
extern s8 GetFlowerCompFlag( s32 TexNumber )
{
	return 0 ;

	FLOWERDATA *Flw = &FlwUnion.FlData[TexNumber] ;

	return Flw->CompFlag ;
}

// ׂẲԃGtFNgɉe`悷邩ǂtOݒ肷
extern s8 SetFlowerAllDrawFlag( s8 Flag )
{
	return 0 ;

	FlwUnion.AllNotDrawFlag = !Flag ;
	
	// I
	return 0 ;
}






