///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectFlower
//
// YK7EffectFlower.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 01/13/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTFLOWER_H
#define __YK7EFFECTFLOWER_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "./YK7EffectBlood.h"

// define ---------------------------------------

#define FLOWER_GRAPHNUM			5				// Ԉӂ̃eNX`̐

// datatype -------------------------------------

// ȂQW\
typedef struct tagVERT2D
{
	u16 x, y ;
} VERT2D ;

// _\
typedef struct tagVERTLIST
{
	u32 VertNum ;				// _̑
} VERTLIST ;

// ԕٕ`pŏ\
typedef struct tagFLOWEROBJ
{
	u8 UseFlag ;				// gptO
	f32 x, y ;					// W
	u16 Pu, Pv ;				// eNX`W
	u8 RotType ;				// ]^Cv
} FLOWEROBJ ;

// ԃf[^
typedef struct tagFLOWERDATA
{
	s32 RefCount ;						// QƃJE^
//	ATEXDATA Tex[FLOWER_GRAPHNUM] ;		// ԃeNX`
	TEXDATA Tex[FLOWER_GRAPHNUM] ;		// ԃeNX`
	ghmGcFile *VertFile ;				// _f[^t@C
	VERTLIST *VertList ;				// _f[^Xg
	u8 *VertFlag ;						// _܂ǂ̃tO̔zւ̃|C^
	FLOWEROBJ *VertObj ;				// _̕`zւ̃|C^
	u32 ObjCompNum ;					// _IuWFNggpꂽ
	u32 CompNum ;						// ܂(͖܂\)_̐
	f32 ChargeState ;					// `[W
	s8 CompFlag ;						// ܂tO
	u32 CompCounter ;					// ܂؂JE^
} FLOWERDATA ;

// ԋʃf[^
typedef struct tagFLOWERUNION
{
	FLOWERDATA FlData[BLOODTEX_NUM] ;	// Ԃ̃f[^
	s32 LastTexNumber ;					// Ōɐݒ肳ꂽԂ̔ԍ
	s8 AllNotDrawFlag ;
} FLOWERUNION ;

// ԃf[^
typedef struct tagFLOWEREFFECT
{
	s32 TexNumber ;						// Ԃ̃^Cv

	f32 t, a ;							// \

	s8 DrawFlag ;						// `tO
} FLOWEREFFECT ;

// Ԉf[^p\
typedef struct tagFLOWEREFFECTTASKPARAM
{
	s32 FlType ;						// Ԃ̃^Cv
} FLOWEREFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitFlowerData( void ) ;				// Ԃ̋ʃf[^
extern s8 CheckFlowerData( void ) ;				// ԃGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndFlowerData( void ) ;				// Ԃ̋ʃf[^n

extern EFFECT *CreateFlowerEffect( s32 TexNumber, s32 Priority = 1 ) ;	// Ԃ쐬
extern s8 ReleaseFlowerEffect( EFFECT *Effect ) ;					// Ԃ̌ns
extern s8 MoveFlowerEffect( EFFECT *Effect ) ;						// ԂPt[
extern s8 DrawFlowerEffect( EFFECT *Effect ) ;						// Ԃ`悷

extern s8 SetFlowerRate( f32 GageRate, EFFECT *Effect ) ;			// `[WZbg(1.0F:őlBҋ@   0.0F:܂ĂȂ)
extern s8 SetFlowerRenderFlag( u8 RenderFlag, EFFECT *Effect ) ;	// Ԃ`悷邩ǂ̃tOZbg

extern s8 SetupFlower( s32 TexNumber ) ;			// ԃeNX`̃ZbgAbvs
extern s8 ReleaseFlower( s32 TexNumber ) ;			// ԃeNX`̌ns
extern s8 CheckSetupFlower( s32 TexNumber ) ;		// ԃeNX`̃ZbgAbvĂ邩𒲂ׂ( TRUE:  FALSE:܂ )

extern s32 GetFlowerObjPos( s32 TexNumber, Vec *Pos ) ;								// ԕقł䂭ׂW擾
extern s8 SetFlowerDrawObj( s32 TexNumber, BLOODOBJECT *Obj, s32 VertNumber ) ;		// ԕق̕`Zbg
extern s8 GetFlowerCompFlag( s32 TexNumber ) ;										// Ԃ\Ă邩ǂ擾
extern s8 SetFlowerAllDrawFlag( s8 Flag ) ;											// ׂẲԃGtFNgɉe`悷邩ǂtOݒ肷


#endif