///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectGMark
//
// YK7EffectGMark.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/19/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTGMARK_H
#define __YK7EFFECTGMARK_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"
#include "./YK7Break.h"

// define ---------------------------------------

// datatype -------------------------------------

// Weqbg}[NGtFNgʃf[^
typedef struct tagGMARKUNION
{
	u8 dummy ;
} GMARKUNION ;

// Weqbg}[NGtFNgIuWFNgf[^
typedef struct tagGMARKOBJECT
{
	u8 validf ;				// LtO
	Vec pos ;				// W
	Vec speed ;				// Xs[h
	f32 size ;				// TCY
	f32 sizespeed ;			// TCYXs[h
} GMARKOBJECT ;

// Weqbg}[NGtFNgf[^
typedef struct tagGMARKEFFECT
{
	WK7JObj *JObj ;						// JObj IuWFNg
	MODEL *model ;						// JObj ͂f

	GMARKOBJECT *obj ;					// IuWFNgzւ̃|C^
	s32 objnum ;						// IuWFNg̐
	s32 maxobjnum ;						// ő吔
	
	f32 maxsize, minsize ;				// őTCYŏTCY
	f32 maxspeed, minspeed ;			// őXs[hŏXs[h
	f32 maxExSpeed, minExSpeed ;		// őkxŏkx

	f32 crerate ;						// ʐϕӂ̍쐬m
	f32 crecounter ;					// 쐬JE^

	u32 color ;							// F
} GMARKEFFECT ;

// prototype ------------------------------------

extern s8 InitGMarkData( void ) ;			// Weqbg}[NGtFNg̋ʃf[^
extern s8 CheckGMarkData( void ) ;			// Weqbg}[NGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndGMarkData( void ) ;			// Weqbg}[NGtFNg̋ʃf[^n

extern EFFECT *CreateGMarkEffect(
						WK7JObj *JObj,					// JObj IuWFNg
						s32 maxobjnum,					// ő吔

						f32 maxsize, f32 minsize,		// őTCYŏTCY
						f32 maxspeed, f32 minspeed,		// őXs[hŏXs[h
						f32 maxExSpeed, f32 minExSpeed,	// őkxŏkx

						f32 crerate,					// ʐϕӂ̍쐬m

						u32 color,						// F
						s32 Priority = -1 ) ;			// Weqbg}[NGtFNg쐬

extern s8 ReleaseGMarkEffect( EFFECT *Effect ) ;				// Weqbg}[NGtFNǧns
extern s8 MoveGMarkEffect( EFFECT *Effect ) ;				// Weqbg}[NGtFNgPt[
extern s8 DrawGMarkEffect( EFFECT *Effect ) ;				// Weqbg}[NGtFNg`悷

#endif

