///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectHSDead
//
// YK7EffectHSDead.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/27/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectHSDead.h"
#include "./YK7EffectBlood.h"
#include "./YK7EffectSound.h"
#include "./YK7Break.h"
#include "./YK7EffectMesh.h"
#include "./YK7EffectImpact.h"
#include "./YK7EffectConveBlood.h"
#include "../matsu/mk7Sound.h"
#include "../matsu/se/seBattle.h"
#include "./YK7EffectConveBlood2.h"

// define ---------------------------------------

#define DEFAULT_BINFONUM	11000

// datatype -------------------------------------

// data -----------------------------------------

HSDEADUNION HSDUnion ;

/*
const u32 BloodSE[] = 
{
	SFX_BT_FHS_WHITE,		// t[HSUE
	SFX_BT_FHS_YELLOW,		// t[HSUE	
	SFX_BT_FHS_PINK,		// t[HSUEsN
	SFX_BT_FHS_BLUE,		// t[HSUE
	SFX_BT_FHS_ORANGE,		// t[HSUEIW
	SFX_BT_FHS_BLACK,		// t[HSUE
	SFX_BT_FHS_VERMILLION,	// t[HSUEF
	SFX_BT_FHS_SPOTTED,		// t[HSUE_
} ;
*/

// function proto type --------------------------

extern void CreateHSDeadEffect3( WK7JObj *JObj, void *Data ) ;		// wuX}CSGtFNg쐬

// function code --------------------------------

// wuX}CSGtFNg̋ʃf[^
extern s8 InitHSDeadData( void )
{
	MEMINIT( HSDUnion ) ;
	
	HSDUnion.TimeRate = 1.0F ;
	HSDUnion.colorflag = false ;
	HSDUnion.noGRateFlag = false ;
	HSDUnion.RangeFlag = false ;
	HSDUnion.DirIgnoreFlag = false ;
	HSDUnion.MinPowerFlag = false ;
	HSDUnion.FadeYFlag = false ;

	
	// I
	return 0 ;
}

// wuX}CSGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckHSDeadData( void )
{
	return TRUE ;
}

// wuX}CSGtFNg̋ʃf[^n
extern s8 EndHSDeadData( void )
{
	MEMINIT( HSDUnion ) ;

	// I
	return 0 ;
}


// wuX}CSGtFNg쐬
extern void CreateHSDeadEffect3( WK7JObj *JObj, void *Data )
{
	HSDEADEFFECT *hd = ( HSDEADEFFECT * )Data ;
	HSDEADEFFECTTASKPARAM *Param = &hd->Param ;
	EFFECT *Effect ;
	BLOODEFFECT *Blood ;

	// \ɂȂĂ珈Ȃ
//	if( ( JObj->GetJObj()->flags & JOBJ_HIDDEN ) == 0 )
	{
		f32 Power, Size, MaxPower  ;
		u8 Time, Flag ;
		GXColor Color1, Color2 ;
		u32 Num ;
		
		if( Param->ConveFlag == FALSE && Param->BloodTexNumber == 0 && Param->BloodTexNumber != BLOODTEX_NORMALFLOWER && GetActBloodMeter() == NULL )
		{
			Flag = (u8)GetConveBloodFlag() ;
			Time = (u8)VParam[ED_CBLOOD][2];
			Power = VParam[ED_CBLOOD][1] * 0.0001F ;
			Size = 0.32F * VParam[ED_HSD1][5] * 0.1F ;
			MaxPower = Param->Power ;
			Num = Param->BloodNum ;
		}
		else
		{
			if( Param->BloodTexNumber == BLOODTEX_FEATHER )
			{
				Size = 0.224F ; 
				MaxPower = 0.1F ;
				Num = 133 ;
			}
			else
			{
				Size = 0.32F * VParam[ED_HSD1][5] * 0.1F ;
				MaxPower = Param->Power ;
				Num = Param->BloodNum ;
			}
			
			Power = Param->ConvePower * 10.0F ;
			Flag = Param->ConveFlag ;
			Time = Param->ConveWaitTime ;
			
		}
	
		// ̃GtFNg𔭐
		if( Param->ReverseFlag )
		{
			if( HSDUnion.colorflag )
			{
				SetConveBlood2Color( *((u32 *)&HSDUnion.color1), *((u32 *)&HSDUnion.color2) ) ;
			}
				
		
			// ꍇ̏
			Effect = CreateConveBlood2Effect( JObj,
									(f32)VParam[ED_CONVEBLOOD2][0] * 1.0F, (f32)VParam[ED_CONVEBLOOD2][1] * 1.0F,
									(f32)VParam[ED_CONVEBLOOD2][2] * 0.001F,
									(f32)VParam[ED_CONVEBLOOD2][3] * 0.01F,
									(f32)VParam[ED_CONVEBLOOD2][4] * 0.5F /*1.0F*/ ) ;
			
/*			if( hd->EffNum < MAXBLOODEFFECTNUM && Effect != NULL )
			{
				hd->Eff[hd->EffNum] = Effect ;
				hd->EffID[hd->EffNum] = GetEffectID( Effect ) ;
				hd->EffNum ++ ;
			}
*/
			if( Effect != NULL )
			{
				hd->Eff = Effect ;
				hd->EffID = GetEffectID( Effect ) ;
				Effect = 0 ;
			}
		}
		else
		{
			// ʂ̃GtFNg
			if( Param->Mode == 0 || Param->Mode == 4 )
			{
				Color1.r = (u8)VParam[ED_HSD1][9] ;		Color1.g = (u8)VParam[ED_HSD1][10] ;	Color1.b = (u8)VParam[ED_HSD1][11] ;
				Color2.r = (u8)VParam[ED_HSD1][12] ;	Color2.g = (u8)VParam[ED_HSD1][13] ;	Color2.b = (u8)VParam[ED_HSD1][14] ;
				
				if( HSDUnion.colorflag )
				{
//					Color1 = HSDUnion.color ;
					SetBloodColor( *((u32 *)&HSDUnion.color1), *((u32 *)&HSDUnion.color2) ) ;
					*((u32 *)&Color2) = 0 ;
				}
				
				if( HSDUnion.sizeflag ) Size = HSDUnion.size ;
				
				Effect = CreateVLossBloodEffect( JObj->GetJObj(),
													Param->Direction,
													MaxPower,
													hd->MinPowerFlag ? MaxPower * hd->MinPower : 0.0F,
													Num,
													Param->YukaY,
													TRUE,
													hd->noGRateFlag ? hd->noGRate : 0.1F,
													hd->RangeFlag ? hd->DirIgnore : ( ( Param->Mode == 0 ? VParam[ED_HSD1][23] : VParam[ED_HSD1][24] ) * 0.01F ),
													hd->RangeFlag ? hd->Range : PI / 4.0F,
													Size,
													0,
													(u8)( Param->Wait * Param->TimeRate ),
													(u16)(VParam[ED_HSD1][3] * 10 * Param->FadeOutWait * Param->TimeRate ),
													(u16)( VParam[ED_HSD1][4] * Param->FadeOutWait ),
													VParam[ED_HSD2][7] * 0.1F,
													PI_2 / 360.0F * VParam[ED_HSD2][6] * 0.1F,
													hd->FadeYFlag ? hd->FadeY : (f32)VParam[ED_HSD2][9],
													(u16)( VParam[ED_HSD2][10] * Param->TimeRate ), 
													Color1, Color2,
													(u16)(VParam[ED_HSD1][8]*10),
													(u8)( VParam[ED_HSD1][15] * Param->TimeRate ),
													VParam[ED_HSD1][17] * 0.01F,
													-1,
													VParam[ED_HSD1][16],
													VParam[ED_HSD1][6],
													Flag,
													Time,
													Power,
													Param->BloodTexNumber,
													Param->BInfo == NULL,
													Param->Priority
													 ) ;
			}
			else
			{
				Color1.r = (u8)VParam[ED_HSD2][12] ;	Color1.g = (u8)VParam[ED_HSD2][13] ;	Color1.b = (u8)VParam[ED_HSD2][14] ;
				Color2.r = (u8)VParam[ED_HSD2][15] ;	Color2.g = (u8)VParam[ED_HSD2][16] ;	Color2.b = (u8)VParam[ED_HSD2][17] ;

				if( HSDUnion.colorflag )
				{
//					Color1 = HSDUnion.color ;
					*((u32 *)&Color2) = 0 ;
					SetBloodColor( *((u32 *)&HSDUnion.color1), *((u32 *)&HSDUnion.color2) ) ;
				}
				
				if( HSDUnion.sizeflag ) Size = HSDUnion.size ;
				
				Effect = CreateVLossBloodEffect( JObj->GetJObj(),							// JObj
													Param->Direction,						// Direction
													MaxPower,								// MaxPower
													hd->MinPowerFlag ? MaxPower * hd->MinPower : 0.0F,	// MinPower
													Num,									// BloodNum
													Param->YukaY,							// YukaY
													TRUE,									// PerspectiveFlag
													hd->noGRateFlag ? hd->noGRate : 0.1F,	// NoGBlood
													hd->RangeFlag ? hd->DirIgnore : VParam[ED_HSD1][23] * 0.01F,			// DirIgnore
													hd->RangeFlag ? hd->Range : PI / 4.0F,	// Range
													Size,									// BloodSize
													Param->Mode,							// Mode
													(u8)( Param->Wait * Param->TimeRate ),	// WaitTime
													(u16)( VParam[ED_HSD2][3] * Param->FadeOutWait * Param->TimeRate ),	// FadeOutTime
													(u16)( VParam[ED_HSD2][4] * Param->FadeOutWait ),					// FadeRandTime
													VParam[ED_HSD2][7] * 0.1F,						// SinWidth
													PI_2 / 360.0F * VParam[ED_HSD2][6] * 0.1F,		// SinSpeed
													hd->FadeYFlag ? hd->FadeY : (f32)VParam[ED_HSD2][8],						// FadeY
													(u16)( VParam[ED_HSD2][9] * Param->TimeRate ),	// FadeSpeedTime
													Color1, Color2,							// Color1, Color2
													(u8)( VParam[ED_HSD2][11] * Param->TimeRate ),	// ColorMoveTime
													(u8)VParam[ED_HSD2][18],				// ColorRand
													0.0F,									// SmokeRate
													-1,										// SoundID
													0.0F,									// WindPower
													10,										// WindTime
													Flag,									// ConveFlag
													Time,									// ConveWaitTime
													Power,									// ConvePower
													Param->BloodTexNumber,					// BloodTexNumber
													Param->BInfo == NULL,					// MeshFlag
													Param->Priority
										) ;
			}

/*			if( hd->EffNum < MAXBLOODEFFECTNUM && Effect != NULL )
			{
				hd->Eff[hd->EffNum] = Effect ;
				hd->EffID[hd->EffNum] = GetEffectID( Effect ) ;
				hd->EffNum ++ ;
			}
*/
			if( Effect != NULL )
			{
				hd->Eff = Effect ;
				hd->EffID = GetEffectID( Effect ) ;
			}
		}

		// _擾w肪擾
		if( Param->BInfo != NULL && Effect != NULL )
		{
			BLOODOBJECT *Obj ;
			BLOODINFO *BI ;
			Blood = ( BLOODEFFECT * )Effect->Data ;
			u32 Num, i ;

			Obj = Blood->ObjP ;
			Num = Blood->BloodNum ;
			BI = &Param->BInfo[Param->BInfoNum] ;
			for( i = 0 ; i < Num ; i ++, Obj ++, BI ++ )
			{
				if( Param->BInfoNum >= Param->BInfoMaxNum )
				{
					Param->BInfoNum = Param->BInfoNum ;
					break ;
				}

				BI->Point.x = Obj->x ;	BI->Point.y = Obj->y ;	BI->Point.z = Obj->z ;
				BI->Speed.x = Obj->sx ;	BI->Speed.y = Obj->sy ;	BI->Speed.z = Obj->sz ;
				BI->Acceleration.x = Obj->ssx ;	BI->Acceleration.y = Obj->ssy ;	BI->Acceleration.z = Obj->ssz ;
				
				Param->BInfoNum ++ ;
			}

			// ătOĂGtFNg͍폜
			if( Param->BloodEffectDeleteFlag == TRUE ) DeleteEffect( Effect, TRUE ) ;
		}
		else
		if( Param->BInfo != NULL && Effect == NULL )
		{
			Param->BInfo = Param->BInfo ;
			return ;
		}
	}
}

// ̍WƔł䂭擾
extern s32 ConvModelBlood( BLOODINFO **Info, WK7Model *Model, u16 Num, f32 Power )
{
	s32 BInfoNum ;

	// mۂ
//	*Info = ( BLOODINFO * )K7AppSmallMemAllocName( DEFAULT_BINFONUM * sizeof( BLOODINFO ), "Y_CnvMB" ) ;
	*Info = ( BLOODINFO * )ghmGcMemAlloc( DEFAULT_BINFONUM * sizeof( BLOODINFO ) ) ;
	if( *Info == NULL ) return -1 ;
	
	// f猌_f[^쐬
	CreateHSDeadEffect( Model->GetObj(0), (Vec){0.0F,0.0F,0.0F}, Power, -10000.0F,
						Num, 1, 0,
						*Info, DEFAULT_BINFONUM, &BInfoNum, TRUE,
						FALSE, 0, 0.0F,
						0 ) ;
				
	// 擾_̐Ԃ
	return BInfoNum ;
}


// wuX}CSGtFNg쐬
extern EFFECT *CreateHSDeadEffect( WK7JObj *JObj, Vec Direction, f32 Power, f32 YukaY,
									u16 BloodNum, u8 Wait, u8 Mode, 
									BLOODINFO *BInfo, u32 BInfoMaxNum, s32 *BInfoNumBuffer, u8 BloodEffectDeleteFlag,
									u8 ConveFlag, u8 ConveWaitTime, f32 ConvePower,
									u8 BloodTexNumber, s8 ImpactFlag, s8 ReverseFlag,
									f32 FadeOutWait, s32 Priority )
{
	Vec Point ;
	EFFECT *ef ;
	HSDEADEFFECT *hd ; 
	f32 TimeRate ;
	bool noGRateFlag ;
	f32 noGRate ;
	bool RangeFlag ;
	f32 Range ;
	bool DirIgnoreFlag ;
	f32 DirIgnore ;
	bool MinPowerFlag ;
	f32 MinPower ;
	bool FadeYFlag ;
	f32 FadeY ;

	MinPowerFlag = HSDUnion.MinPowerFlag ;
	HSDUnion.MinPowerFlag = false ;
	MinPower = HSDUnion.MinPower ;

	DirIgnoreFlag = HSDUnion.DirIgnoreFlag ;
	HSDUnion.DirIgnoreFlag = false ;
	DirIgnore = HSDUnion.DirIgnore ;

	RangeFlag = HSDUnion.RangeFlag ;
	HSDUnion.RangeFlag = false ;
	Range = HSDUnion.Range ;
	
	noGRateFlag = HSDUnion.noGRateFlag ;
	HSDUnion.noGRateFlag = false ;
	noGRate = HSDUnion.noGRate ;
	
	TimeRate = HSDUnion.TimeRate ;
	HSDUnion.TimeRate = 1.0F ;
	
	FadeYFlag = HSDUnion.FadeYFlag ;
	HSDUnion.FadeYFlag = false ;
	FadeY = HSDUnion.FadeY ;
	
	
	// W擾	
	Point.x = JObj->GetJObj()->mtx[0][3] ;
	Point.y = JObj->GetJObj()->mtx[1][3] ;
	Point.z = JObj->GetJObj()->mtx[2][3] ;

	// GtFNg̒ǉ
	ef = AddEffectData( EFF_HSDEAD, (void **)&hd, Priority ) ;
	if( ef == NULL )
	{
		HSDUnion.colorflag = false ;
		return NULL ;
	}
	memset( hd, 0, sizeof( HSDEADEFFECT ) ) ;
	
	hd->noGRate = noGRate ;
	hd->noGRateFlag = noGRateFlag ;

	hd->Range = Range ;
	hd->RangeFlag = RangeFlag ;

	hd->DirIgnore = DirIgnore ;
	hd->DirIgnoreFlag = DirIgnoreFlag ;

	hd->MinPower = MinPower ;
	hd->MinPowerFlag = MinPowerFlag ;

	hd->FadeY = FadeY ;
	hd->FadeYFlag = FadeYFlag ;


	// _f[^Ȃꍇ̂ݎs
	if( BInfo == NULL )
	{
		// h炷
		if( ImpactFlag == TRUE && ReverseFlag == FALSE )
		{
#ifdef FRAME_30
			CreateImpactEffect( 10, 5, (Vec){0.0F, 0.0F, 0.0F}, 5, 0, TRUE ) ;
#else
			CreateImpactEffect( 10, 5, (Vec){0.0F, 0.0F, 0.0F}, 10, 0, TRUE ) ;
#endif	
		}
		
		if( GetEffectSoundOffFlag() == FALSE )
		{
			// o[X̏ꍇƂłȂꍇŖ炷ω
			if( ReverseFlag == TRUE )
			{
				PlayEffectSE3D( SFX_SYS_CHARA_CHANGE_GATHER, Point, 0,  SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env ) ;
			}
			else
			{
				// ɕω炷
				if( Wait != 0 ) PlayEffectSE3D( SFX_BT_WEAK_DEATH, Point, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env ) ;

				// ̃GtFNg𔭐
				{
					if( Mode != 3 )
					{
						if( Mode != 2 ) CreateSoundEffect( SFX_BT_WEAK_DEATH_BOMB, (u32)( ( Wait + VParam[ED_HSD1][21] ) * TimeRate ), Point ) ;
					}
					else
					{
						if( BloodTexNumber != 0 )
						{
							CreateSoundEffect( SFX_BT_HS_DEATH/*BloodSE[BloodTexNumber-1]*/, (u32)( Wait * TimeRate ), Point ) ;
						}
						else
						{
							CreateSoundEffect( SFX_BT_HS_DEATH, (u8)( Wait * TimeRate ), Point ) ;
						}
					}
				}
			}
		}
	}

	// bV JObj 𑖍
	{
		hd->Param.JObj = JObj ;
		hd->Param.Direction = Direction ;
		hd->Param.Power = Power ;
		hd->Param.YukaY = YukaY ;
		hd->Param.BloodNum = BloodNum ;
		hd->Param.Wait = Wait ;
		hd->Param.Mode = Mode ;
		hd->Param.Priority = Priority ;
		hd->Param.BInfo = BInfo ;
		hd->Param.BInfoMaxNum = BInfoMaxNum ;
		hd->Param.BInfoNum = 0 ;
		hd->Param.BloodEffectDeleteFlag = BloodEffectDeleteFlag ;
		hd->Param.ConveFlag = ConveFlag ;
		hd->Param.ConveWaitTime = ConveWaitTime ;
		hd->Param.ConvePower = ConvePower ;
		hd->Param.BloodTexNumber = BloodTexNumber ;
		hd->Param.ReverseFlag = ReverseFlag ;
		hd->Param.FadeOutWait = FadeOutWait ;
		hd->Param.TimeRate = TimeRate ;

//		ScanPrimitiveJObj( JObj, CreateHSDeadEffect3, hd, FALSE ) ;
		CreateHSDeadEffect3( JObj, hd ) ;

		// ̏Ăꍇ͎擾Ԃ
		if( BInfoNumBuffer != NULL ) *BInfoNumBuffer = (s32)hd->Param.BInfoNum ;
	}

	HSDUnion.colorflag = false ;
	HSDUnion.sizeflag = false ;
	
	// I
	return ef ;
}

// wuX}CSGtFNǧns
extern s8 ReleaseHSDeadEffect( EFFECT *Effect )
{
	HSDEADEFFECT *hd = ( HSDEADEFFECT * )Effect->Data ;
//	s32 i ;
	
/*	for( i = 0 ; i < hd->EffNum ; i ++ )
	{
		if( CheckEffectValidState( hd->Eff[i], hd->EffID[i] ) == TRUE ) DeleteEffect( hd->Eff[i] ) ;
	}
*/

	if( CheckEffectValidState( hd->Eff, hd->EffID ) == TRUE ) DeleteEffect( hd->Eff ) ;

/*
	if( HSDeadEffect->MeshEffect != NULL )
	{
		DeleteEffect( HSDeadEffect->MeshEffect ) ;
	}
*/
	// I
	return 0 ;
}

// wuX}CSGtFNgPt[
extern s8 MoveHSDeadEffect( EFFECT *Effect )
{
	HSDEADEFFECT *hd = ( HSDEADEFFECT * )Effect->Data ;
//	s32 i ;

/*
	HSDeadEffect->Counter -- ;

	if( HSDeadEffect->Counter == 0 )
	{
		DeleteEffect( HSDeadEffect->MeshEffect ) ;
		DeleteEffect( Effect ) ;
	}
*/
	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	if( CheckEffectValidState( hd->Eff, hd->EffID ) == FALSE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
/*
	for( i = 0 ; i < hd->EffNum ; i ++ )
	{
		if( CheckEffectValidState( hd->Eff[i], hd->EffID[i] ) == TRUE ) break ;
	}
	if( i == hd->EffNum )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
*/

	// I
	return 0 ;
}

// wuX}CSGtFNg`悷
extern s8 DrawHSDeadEffect( EFFECT *Effect )
{
	HSDEADEFFECT *HSDeadEffect = ( HSDEADEFFECT * )Effect->Data ;

	// I
	return 0 ;
}					

// Iǂ𓾂( TRUE:  FALSE:܂ )
extern s8 GetHSDeadConveState( EFFECT *Effect )
{
	HSDEADEFFECT *hd = ( HSDEADEFFECT * )Effect->Data ;
//	s32 i ;
	
	if( hd->Param.ReverseFlag == FALSE ) return TRUE ;
	
	return (s8)( ( CheckEffectValidState( hd->Eff, hd->EffID ) == TRUE &&
			 		GetConveBlood2EffectState( hd->Eff ) == 0 ) ? FALSE : TRUE ) ;
/*
	for( i = 0 ; i < hd->EffNum ; i ++ )
	{
		if( CheckEffectValidState( hd->Eff[i], hd->EffID[i] ) == TRUE &&
			GetConveBlood2EffectState( hd->Eff[i] ) == 0 ) break ;
	}
	return (s8)( i == hd->EffNum ? TRUE : FALSE ) ;
*/
}

// wuX}CSGtFNg̓쎞Ԃɑ΂␳lݒ肷
extern s8 SetHSDeadEffectTimeRate( f32 Rate )
{
	HSDUnion.TimeRate = Rate ;
	
	return 0 ;
}

// ɍ쐬wuX}CSGtFNg̐Fݒ肷
extern s8 SetHSDeadEffectColor( u32 color1, u32 color2 )
{
	*((u32 *)&HSDUnion.color1) = color1 ;
	*((u32 *)&HSDUnion.color2) = color2 ;
	HSDUnion.colorflag = true ;

	return true ;
}

// ɍ쐬wuX}CSGtFNg̐Fݒ肷
extern s8 SetHSDeadEffectColor( GXColor color1, GXColor color2 )
{
	HSDUnion.color1 = color1 ;
	HSDUnion.color2 = color2 ;
	HSDUnion.colorflag = true ;

	return true ;
}

// ɍ쐬wuX}CSGtFNǧ̃TCYݒ肷
extern s8 SetHSDeadEffectBloodSize( f32 Size )
{
	HSDUnion.sizeflag = true ;
	HSDUnion.size = Size ;
	
	return true ;
}

// wuX}CSGtFNg̏d͂̉e̊ݒ肷
extern s8 SetHSDeadEffectNoGBloodRate( f32 Rate )
{
	HSDUnion.noGRate = Rate ;
	HSDUnion.noGRateFlag = true ;
	
	return true ;
}

// ɍ쐬wuX}CSGtFNǧłɑ΂镝
extern s8 SetHSDeadEffectRange( f32 Range )
{
	HSDUnion.Range = Range ;
	HSDUnion.RangeFlag = true ;
	
	return true ;
}

// ɍ쐬wuX}CSGtFNǧł𖳎闦
extern s8 SetHSDeadEffectDirIgnore( f32 DirIgnore )
{
	HSDUnion.DirIgnore = DirIgnore ;
	HSDUnion.DirIgnoreFlag = true ;
	
	return true ;
}

// ɍ쐬wuX}CSGtFNǧłŏx̗
extern s8 SetHSDeadEffectMinPower( f32 MinPower )
{
	HSDUnion.MinPower = MinPower ;
	HSDUnion.MinPowerFlag = true ;
	
	return true ;
}

// ɍ쐬wuX}CSGtFNǧn߂鍂ݒ肷
extern s8 SetHSDeadEffectFadeY( f32 FadeY )
{
	HSDUnion.FadeY = FadeY ;
	HSDUnion.FadeYFlag = true ;
	
	return true ;
}

