///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectHSLaser
//
// YK7EffectHSLaser.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 01/16/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTHSLASER_H
#define __YK7EFFECTHSLASER_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// gr[U[GtFNgʃf[^
typedef struct tagHSLASERUNION
{
	u8 Dummy ;
} HSLASERUNION ;

// gr[U[GtFNgf[^
typedef struct tagHSLASEREFFECT
{
	Vec Pos, Dir ;						// ˓_ƌ
	f32 Length ;						// 
	f32 Width ;							// 
	GXColor Color ;						// F
	u16 DivNum ;						// 
	f32 LightRate ;						// gr[U[̌̋̃oCAX
	f32 YukaY ;							// ̍

	EFFECT *RingShot ;					// OVbg
	EFFECT *Laser ;						// [U[GtFNg

	s8 DrawFlag ;						// `tO(nIȂ)
	s8 CrtFlag ;						// gr[U[邩tO(tF[hȂǂ^Cv)

	s8 FastDeleteFlag ;					// 폜tO
} HSLASEREFFECT ;

// gr[U[GtFNg^XNɓnf[^
typedef struct tagHSLASEREFFECTTACKPARAM
{
	Vec Pos ;							// ˓_
	f32 Length ;						// 
	f32 Width ;							// 
	GXColor Color ;						// F
	u16 DivNum ;						// 
	f32 YukaY ;							// ̍

	f32 RingSpace ;						// O̊Ԋu
	f32 RingSpeed ;						// ÕXs[h
	f32 RingCounter ;					// OJE^
	f32 RingWidth ;						// O̕
} HSLASEREFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitHSLaserData( void ) ;				// gr[U[GtFNg̋ʃf[^
extern s8 CheckHSLaserData( void ) ;			// gr[U[GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndHSLaserData( void ) ;				// gr[U[GtFNg̋ʃf[^n

extern EFFECT *CreateHSLaserEffect( Vec Pos, Vec Dir, f32 Length, f32 Width,
									GXColor Color, u16 DivNum, f32 YukaY,
									f32 RingSpace, f32 RingSpeed,
									f32 RingCounter, f32 RingWidth, s32 Priority = -1 ) ;	// gr[U[GtFNg쐬
extern s8 ReleaseHSLaserEffect( EFFECT *Effect ) ;										// gr[U[GtFNǧns
extern s8 MoveHSLaserEffect( EFFECT *Effect ) ;											// gr[U[GtFNgPt[
extern s8 DrawHSLaserEffect( EFFECT *Effect ) ;											// gr[U[GtFNg`悷

extern s8 SetHSLaserEffectPos( EFFECT *Effect, Vec *Pos, Vec *Dir ) ;					// gr[U[GtFNg̔˓_ƌݒ肷
extern s8 SetHSLaserEffectDrawFlag( EFFECT *Effect, s8 DrawFlag ) ;						// gr[U[GtFNg`悷邩ǂZbg(nIȂ)
extern s8 SetHSLaserEffectRenderFlag( EFFECT *Effect, s8 RenderFlag ) ;					// gr[U[GtFNg`悷邩ǂZbg(tF[ho[W)
extern s8 FastDelHSLaserEffect( EFFECT *Effect ) ;										// gr[U[GtFNg̑폜NGXgs

#endif
