///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectHeliExp
//
// YK7EffectHeliExp.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 07/03/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectHeliExp.h"
#include "./YK7EffectImpact.h"
#include "./YK7EffectExplode.h"
#include "./YK7EffectLine.h"
#include "../matsu/mk7Sound.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

HELIEXPUNION HliUnion ;

// function proto type --------------------------

// function code --------------------------------

// wGtFNg̋ʃf[^
extern s8 InitHeliExpData( void )
{
	MEMINIT( HliUnion ) ;

	// I
	return 0 ;
}

// wGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckHeliExpData( void )
{
	return TRUE ;
}


// wGtFNg̋ʃf[^n
extern s8 EndHeliExpData( void )
{
	MEMINIT( HliUnion ) ;

	// I
	return 0 ;
}


// wuX}CpGtFNg쐬
extern EFFECT *CreateHSExpEffect( Vec Point, s32 Priority )
{
//	GXColor Color ;

	// 炷
	if( GetEffectSoundOffFlag() == FALSE ) PlayEffectSE3D( SFX_BT_EXPLODE_02, Point, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env ) ;

	// GtFNg𔭓
	CreateExplodeEffect( Point, VParam[ED_HSEXP2][6] * 0.1F, 0, Priority ) ;

	// CGtFNgf[^쐬	
/*	Color.r = (u8)VParam[ED_HSEXP2][13] ;	Color.g = (u8)VParam[ED_HSEXP2][14] ;
	Color.b = (u8)VParam[ED_HSEXP2][15] ;	Color.a = (u8)VParam[ED_HSEXP2][16] ;
	CreateLineEffect( FALSE, 0, Color, Point,
						 VParam[ED_HSEXP2][6], 0.79037613804053F * VParam[ED_HSEXP2][9], VParam[ED_HSEXP2][12] * 0.1F,
						 VParam[ED_HSEXP2][17] * 0.1F, VParam[ED_HSEXP2][17] * 0.01F, (Vec){1.0F,0.0F,0.0F},
						 PI / 9.0F, 1.0F, VParam[ED_HSEXP2][18] * 0.01F,
						 VParam[ED_HSEXP2][19], VParam[ED_HSEXP2][20], VParam[ED_HSEXP2][11],
						 TRUE, LINE_TYPE_NORMAL, 0, 0.0F, NULL, 0,
						 Priority + 1 ) ;
*/

/*
	// ʂGtFNg쐬
	#define MAX_LENGTH 30.0F 
	#define MIN_LENGTH 10.0F
	#define MAX_POWER 100.0F 
	#define MIN_POWER 10.0F
	{
		f32 dx, dy, dz, r, Power ;
		Mtx View ;
		
		// r[s擾
		HSD_CObjGetViewingMtx( GetEffectCamera(), View ) ; 
		dx = Point.x - View[0][3] ;
		dy = Point.y - View[1][3] ;
		dz = Point.z - View[2][3] ;
		r = sqrt( dx * dx + dy * dy + dz * dz ) ;
		if( r > MAX_LENGTH ) Power = MIN_POWER ;
		else if( r < MIN_LENGTH ) Power = MAX_POWER ;
		else Power = ( MAX_POWER - MIN_POWER ) * ( ( MAX_LENGTH - MIN_LENGTH ) - ( r - MIN_LENGTH ) ) /
					 ( MAX_LENGTH - MIN_LENGTH ) + MIN_POWER ;
		CreateImpactEffect( Power, Power - Power / 2, (Vec){0.0F, 0.0F, 0.0F}, 30, 0, TRUE, Priority + 4 ) ;
	}
*/
	// I
	return NULL ;
}


// w̃GtFNg쐬
extern EFFECT *CreateHeliExpEffect( Vec Point, s32 Priority )
{
	GXColor Color ;

	// 炷
	if( GetEffectSoundOffFlag() == FALSE ) PlayEffectSE3D( SFX_BT_EXPLODE_02, Point, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env ) ;
	
	// GtFNg𔭓
	CreateExplodeEffect( Point, VParam[ED_EXP][0] * 0.1F, (u8)VParam[ED_EXP][15] ) ;

	// CGtFNgf[^쐬	
	Color.r = (u8)VParam[ED_EXP][7] ;	Color.g = (u8)VParam[ED_EXP][8] ;
	Color.b = (u8)VParam[ED_EXP][9] ;	Color.a = (u8)VParam[ED_EXP][10] ;
	CreateLineEffect( FALSE, 0, Color, Point,
						 VParam[ED_EXP][0], 0.79037613804053F * VParam[ED_EXP][2], VParam[ED_EXP][6] * 0.1F,
						 VParam[ED_EXP][11] * 0.1F, VParam[ED_EXP][11] * 0.01F, (Vec){1.0F,0.0F,0.0F},
						 PI / 9.0F, 1.0F, VParam[ED_EXP][12] * 0.01F,
						 VParam[ED_EXP][13], VParam[ED_EXP][14], VParam[ED_EXP][5],
						 TRUE, LINE_TYPE_NORMAL, 0, 0.0F, NULL, 0, 
						 Priority + 1 ) ;

	// ʂGtFNg쐬
	#define MAX_LENGTH 30.0F 
	#define MIN_LENGTH 10.0F
	#define MAX_POWER 100.0F 
	#define MIN_POWER 10.0F
	{
		f32 dx, dy, dz, r, Power ;
		Mtx View ;
		
		// r[s擾
		HSD_CObjGetViewingMtx( GetEffectCamera(), View ) ; 
		dx = Point.x - View[0][3] ;
		dy = Point.y - View[1][3] ;
		dz = Point.z - View[2][3] ;
		r = sqrt( dx * dx + dy * dy + dz * dz ) ;
		if( r > MAX_LENGTH ) Power = MIN_POWER ;
		else if( r < MIN_LENGTH ) Power = MAX_POWER ;
		else Power = ( MAX_POWER - MIN_POWER ) * ( ( MAX_LENGTH - MIN_LENGTH ) - ( r - MIN_LENGTH ) ) /
					 ( MAX_LENGTH - MIN_LENGTH ) + MIN_POWER ;
		CreateImpactEffect( Power, Power - Power / 2, (Vec){0.0F, 0.0F, 0.0F}, 30, 0, TRUE, Priority + 4 ) ;
	}

	// I
	return NULL ;
}

// w̃GtFNǧns
extern s8 ReleaseHeliExpEffect( EFFECT * )
{
	// I
	return 0 ;
}

// w̃GtFNgPt[
extern s8 MoveHeliExpEffect( EFFECT * )
{
	// I
	return 0 ;
}

// w̃GtFNg`悷
extern s8 DrawHeliExpEffect( EFFECT * )
{
	// I
	return 0 ;
}					

