///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectHitMark
//
// YK7EffectHitMark.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/24/2003
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectHitMark.h"
//#include "./YK7EffectLine.h"
#include "./YK7EffectBlood.h"
//#include "./YK7EffectFlyBlood.h"
//#include "./YK7EffectDamage.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

HITMARKUNION HitMUnion ;

// function proto type --------------------------

// function code --------------------------------

// qbg}[NGtFNg̋ʃf[^
extern s8 InitHitMarkData( void )
{
	MEMINIT( HitMUnion ) ;

	// I
	return 0 ;
}

// qbg}[NGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckHitMarkData( void )
{
	return TRUE ;
}


// qbg}[NGtFNg̋ʃf[^n
extern s8 EndHitMarkData( void )
{
	MEMINIT( HitMUnion ) ;

	// I
	return 0 ;
}




// qbg}[NGtFNg쐬
extern EFFECT *CreateHitMarkEffect( u8 DamagePower, Vec Point, Vec Direction, WK7JObj *JObj, f32 YukaY, bool BloodFlag, s32 Priority )
{
	EFFECT *Effect ;
	HITMARKEFFECT *HitMarkP ;
	
	// Vqbg}[Nf[^쐬
	Effect = AddEffectData( EFF_HITMARK, (void**)&HitMarkP, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// p[^ׂĕۑ
	HitMarkP->DamagePower = DamagePower ;
	HitMarkP->Point = Point ;
	HitMarkP->ParentJObj = JObj->GetJObj() ;
	HitMarkP->Target.x = Point.x + Direction.x ;
	HitMarkP->Target.y = Point.y + Direction.y ;
	HitMarkP->Target.z = Point.z + Direction.z ;
	HitMarkP->Fire1Flag = FALSE ;
	HitMarkP->Fire2Flag = FALSE ;
	HitMarkP->Fire3Flag = FALSE ;
	HitMarkP->K7JObj = JObj ;
	
	//  HSD_JObj 쐬
	HitMarkP->FreeJObj = HSD_JObjAlloc() ;
	
	// ьGtFNg̍쐬
	{
/*		GXColor Color ;

		Color.r = (u8)VParam[ED_FLYBLOOD][14] ;
		Color.g = (u8)VParam[ED_FLYBLOOD][15] ;
		Color.b = (u8)VParam[ED_FLYBLOOD][16] ;
		CreateFlyBloodEffect( Point, Direction, PI / 40 * VParam[ED_FLYBLOOD][2], VParam[ED_FLYBLOOD][0] * 0.1F, VParam[ED_FLYBLOOD][1] * 0.1F,  
								PI / 40 * VParam[ED_FLYBLOOD][6], PI / 40 * VParam[ED_FLYBLOOD][7], VParam[ED_FLYBLOOD][4] * 0.01F,
								1.0F - VParam[ED_FLYBLOOD][5] * 0.001F, VParam[ED_FLYBLOOD][18] * 0.001F, (u8)VParam[ED_FLYBLOOD][3], 1.0F,
								VParam[ED_FLYBLOOD][19], VParam[ED_FLYBLOOD][20],
								Color, (u8)VParam[ED_FLYBLOOD][17],
								VParam[ED_FLYBLOOD][22] * 0.001f, (s16)VParam[ED_FLYBLOOD][23], JObj, 0,
								VParam[ED_FLYBLOOD][13] * 0.01F, 0,
								50, 50 ) ;

//		CreateDamageEffect( JObj,
//							 (u8)VParam[ED_DAMAGE][0], (u8)VParam[ED_DAMAGE][1], (u8)VParam[ED_DAMAGE][2] ) ;
*/	}

	// exNgƒeW𒅒en_Ɉԋ߂ HSD_JObj ̃[JWɗƂ
	{
		Mtx InvMtx ;
	
		HSD_JObjSetupMatrix( HitMarkP->ParentJObj ) ;
		HitMarkP->FreeJObj->flags = HitMarkP->ParentJObj->flags ;
		MTXInverse( HitMarkP->ParentJObj->mtx, InvMtx ) ;
		MTXMultVec( InvMtx, &HitMarkP->Target, &HitMarkP->Target ) ;
		MTXMultVec( InvMtx, &Point, &HitMarkP->Point ) ;
	}
	
	// GtFNg𔭐
/*	CreateBloodEffect( Point, Direction, 2.0F, 1.0F, 300, 1.0F,
						1.0F, TRUE, TRUE, 0.1F, 1.0F / 20.0F,
						PI / 8.0F, 0.44F ) ;
*/
	if( BloodFlag == true )
	{
		GXColor Color1, Color2 ;
	
		Color1.r = (u8)VParam[ED_HITM][15] ; Color1.g = (u8)VParam[ED_HITM][16] ; Color1.b = (u8)VParam[ED_HITM][17] ;
		Color2.r = (u8)VParam[ED_HITM][18] ; Color2.g = (u8)VParam[ED_HITM][19] ; Color2.b = (u8)VParam[ED_HITM][20] ;
		CreateBloodEffect( Point, Direction,
							VParam[ED_HITM][5] * 0.01F,
							VParam[ED_HITM][5] * 0.05F,
							VParam[ED_HITM][3 + DamagePower * 3],
							1.0F,
							YukaY,
							TRUE,
							0.0F,
							0.01F,
							PI / 40.0F * VParam[ED_HITM][4 + DamagePower * 3],
							0.22F * VParam[ED_HITM][12] * 0.01F,
							1,
							0,
							VParam[ED_HITM][0],
							VParam[ED_HITM][1],
							0.0F, 0.0F, 0.0F,
							VParam[ED_HITM][13],
							Color1, Color2,
							FEED_TIME, (u8)VParam[ED_HITM][14],
							0.0F, -1,
							0.0F, 0 ) ;
	}
	
	// 򖗃GtFNg쐬
/*	{
		GXColor Color ;
		Vec Point, Dir ;
		
		Color.r = (u8)VParam[ED_FLYBLOOD][14] ;
		Color.g = (u8)VParam[ED_FLYBLOOD][15] ;
		Color.b = (u8)VParam[ED_FLYBLOOD][16] ;
		Point.x = 0.0F ;	Point.y = 0.0F ;	Point.z = 0.0F ;
		Dir.x = 0.0F ;		Dir.y = 0.0F ;		Dir.z = 0.0F ;
		CreateFlyBloodEffect( Point, Dir, PI / 40 * VParam[ED_FLYBLOOD][2], VParam[ED_FLYBLOOD][0] * 0.1F, VParam[ED_FLYBLOOD][1] * 0.1F,  
								PI / 40 * VParam[ED_FLYBLOOD][6], PI / 40 * VParam[ED_FLYBLOOD][7], VParam[ED_FLYBLOOD][4] * 0.01F,
								1.0F - VParam[ED_FLYBLOOD][5] * 0.001F, VParam[ED_FLYBLOOD][18] * 0.001F, (u8)VParam[ED_FLYBLOOD][3], 1.0F,
								VParam[ED_FLYBLOOD][19], VParam[ED_FLYBLOOD][20],
								Color, (u8)VParam[ED_FLYBLOOD][17],
								VParam[ED_FLYBLOOD][22] * 0.001f, 10, JObj, (u32)( rand() * 100 / RAND_MAX ),
								0.0F, 0 ) ;
	}
*/	

	//  HSD_JObj ̃Xe[^XZbg
	{
		Mtx temp, *Mt ;

		Vec Up = { 0.0F, 1.0F, 0.0F }, Target ;

		Target.x = Point.x + Direction.x ;
		Target.y = Point.y + Direction.y ;
		Target.z = Point.z + Direction.z ;
		
		if( VECDotProduct( &Direction, &Up ) > 0.999999F )
		{
			Up.x = 1.0F ;
			Up.y = 0.0F ;
			Up.z = 0.0F ;
		}

		// sZbg
		{
			Mt = &HitMarkP->FreeJObj->mtx ;
			MTXLookAt( temp, &Point, &Up, &Target ) ;
			(*Mt)[0][0] = temp[0][0] ;	(*Mt)[0][1] = temp[1][0] ;	(*Mt)[0][2] = temp[2][0] ;	(*Mt)[0][3] = Point.x ;
			(*Mt)[1][0] = temp[0][1] ;	(*Mt)[1][1] = temp[1][1] ;	(*Mt)[1][2] = temp[2][1] ;	(*Mt)[1][3] = Point.y ;
			(*Mt)[2][0] = temp[0][2] ;	(*Mt)[2][1] = temp[1][2] ;	(*Mt)[2][2] = temp[2][2] ;	(*Mt)[2][3] = Point.z ;
		}
	
		// 򖗃p[eBN𔭐
		HitMarkP->Blood1 = HitMarkP->Blood2 = HitMarkP->Blood3 = NULL ;
//		if( DamagePower >= 0 ) HitMarkP->Blood1 = new C_Generator( HitMarkP->FreeJObj, 0 ) ;
//		if( DamagePower >= 1 ) HitMarkP->Blood2 = new C_Generator( HitMarkP->FreeJObj, 1 ) ;
//		if( DamagePower >= 2 ) HitMarkP->Blood3 = new C_Generator( HitMarkP->FreeJObj, 2 ) ;

		if( DamagePower >= 0 )
//		if( 0 ) 
		{
			HitMarkP->Blood1 = new C_Generator( HitMarkP->FreeJObj, 0 ) ;
			if( HitMarkP->Blood1 == NULL ){ DeleteEffect( Effect ) ; return NULL ; }
//			HitMarkP->Blood1 = new C_Generator( HitMarkP->FreeJObj, 5 ) ;
			HitMarkP->Blood1->Fire() ;
		}
		if( DamagePower >= 1 )
//		if( 0 ) 
		{
			HitMarkP->Blood2 = new C_Generator( HitMarkP->FreeJObj, 1 ) ;
			if( HitMarkP->Blood2 == NULL ){ DeleteEffect( Effect ) ; return NULL ; }
			HitMarkP->Blood2->Fire() ;
		}
		if( DamagePower >= 2 )
//		if( 0 ) 
		{
			HitMarkP->Blood3 = new C_Generator( HitMarkP->FreeJObj, 2 ) ;
			if( HitMarkP->Blood3 == NULL ){ DeleteEffect( Effect ) ; return NULL ; }
			HitMarkP->Blood3->Fire() ;
		}
/*		if( DamagePower >= 0 )
		{
			HitMarkP->Blood1 = new C_Generator( HitMarkP->ParentJObj, 0 ) ;
			HitMarkP->Blood1->Fire() ;
		}
		if( DamagePower >= 1 )
		{
			HitMarkP->Blood2 = new C_Generator( HitMarkP->ParentJObj, 1 ) ;
			HitMarkP->Blood2->Fire() ;
		}
		if( DamagePower >= 2 )
		{
			HitMarkP->Blood3 = new C_Generator( HitMarkP->ParentJObj, 2 ) ;
			HitMarkP->Blood3->Fire() ;
		}
*/	}

	// I
	return Effect ;
}

// qbg}[NGtFNǧns
extern s8 ReleaseHitMarkEffect( EFFECT *Effect )
{
	HITMARKEFFECT *HitMarkP = ( HITMARKEFFECT * )Effect->Data ;

	if( HitMarkP->FreeJObj != NULL ) HSD_JObjUnref( HitMarkP->FreeJObj ) ;
	if( HitMarkP->Blood1 != NULL ) delete HitMarkP->Blood1 ;
	if( HitMarkP->Blood2 != NULL ) delete HitMarkP->Blood2 ;
	if( HitMarkP->Blood3 != NULL ) delete HitMarkP->Blood3 ;

	// I
	return 0 ;
}

// qbg}[NGtFNgPt[
extern s8 MoveHitMarkEffect( EFFECT *Effect )
{
	HITMARKEFFECT *HitMark = ( HITMARKEFFECT * )Effect->Data ;
	Vec Point, Target, Up ;
	Mtx mtx, *Mt ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// 򖗂グ̂ɎgĂ HSD_JObj ̍sύX
	HSD_JObjSetupMatrix( HitMark->ParentJObj ) ;
	
	// [JɗƂ񂾍WA烏[hW𓾂
	MTXMultVec( HitMark->ParentJObj->mtx, &HitMark->Target, &Target ) ;
	MTXMultVec( HitMark->ParentJObj->mtx, &HitMark->Point, &Point ) ;

	// [hW HSD_JObj ̐Vs쐬
	Up.x = 0.0F ; Up.y = 1.0F ; Up.z = 0.0F ;
	{
		Vec Direction ;

		VECSubtract( &Target, &Point, &Direction ) ;
		VECNormalize( &Direction, &Direction ) ;
		if( VECDotProduct( &Direction, &Up ) > 0.999999F )
		{
			Up.x = 1.0F ;
			Up.y = 0.0F ;
			Up.z = 0.0F ;
		}
	}
	Mt = &HitMark->FreeJObj->mtx ;
	MTXLookAt( mtx, &Point, &Up, &Target ) ;
	(*Mt)[0][0] = mtx[0][0] ;	(*Mt)[0][1] = mtx[1][0] ;	(*Mt)[0][2] = mtx[2][0] ;	(*Mt)[0][3] = Point.x ;
	(*Mt)[1][0] = mtx[0][1] ;	(*Mt)[1][1] = mtx[1][1] ;	(*Mt)[1][2] = mtx[2][1] ;	(*Mt)[1][3] = Point.y ;
	(*Mt)[2][0] = mtx[0][2] ;	(*Mt)[2][1] = mtx[1][2] ;	(*Mt)[2][2] = mtx[2][2] ;	(*Mt)[2][3] = Point.z ;

	// `FbN
	{
		if( HitMark->Blood1 != NULL && HitMark->Fire1Flag == FALSE && HitMark->Blood1->IsAlive() != 0 ) HitMark->Fire1Flag = TRUE ;
		if( HitMark->Blood2 != NULL && HitMark->Fire2Flag == FALSE && HitMark->Blood2->IsAlive() != 0 ) HitMark->Fire2Flag = TRUE ;
		if( HitMark->Blood3 != NULL && HitMark->Fire3Flag == FALSE && HitMark->Blood3->IsAlive() != 0 ) HitMark->Fire3Flag = TRUE ;
	}
	
	
	// ׂăp[eBNĂ폜
	{
		u8 Num ;
		
		Num = 0 ;
		if( HitMark->Blood1 != NULL && HitMark->Fire1Flag == TRUE && HitMark->Blood1->IsAlive() == 0 ) Num ++ ;
		if( HitMark->Blood2 != NULL && HitMark->Fire2Flag == TRUE && HitMark->Blood2->IsAlive() == 0 ) Num ++ ;
		if( HitMark->Blood3 != NULL && HitMark->Fire3Flag == TRUE && HitMark->Blood3->IsAlive() == 0 ) Num ++ ;
		
		if( Num >= HitMark->DamagePower + 1 )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
	}

	// I
	return 0 ;
}

// qbg}[NGtFNg`悷
extern s8 DrawHitMarkEffect( EFFECT *Effect )
{
	HITMARKEFFECT *HitMarkEffect = ( HITMARKEFFECT * )Effect->Data ;
	
	// I
	return 0 ;
}					







