///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectHitMark
//
// YK7EffectHitMark.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/24/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTHITMARK_H
#define __YK7EFFECTHITMARK_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "./YK7Break.h"
#include "../fujita/C_Particle.h"

// define ---------------------------------------

// datatype -------------------------------------

// qbg}[NGtFNgʃf[^
typedef struct tagHITMARKUNION
{
	u8 Dummy ;
} HITMARKUNION ;

// qbg}[NGtFNgf[^
typedef struct tagHITMARKEFFECT
{
	u8 DamagePower ;		// _[W̑傫( 0:_[W 1:_[W 2:_[W )
	Vec Point ;				// eW
	Vec Target ;			// eW猌򖗂ԕ̃xNg
	WK7JObj *K7JObj ;		// en_Ɉԋ߂ WK7JObj ւ̃|C^
	HSD_JObj *ParentJObj ;	// en_Ɉԋ߂ HSD_JObj ւ̃|C^
	HSD_JObj *FreeJObj ;	// p[eBNp HSD_JObj ւ̃|C^
	C_Generator	*Blood1 ;	// 򖗃xP
	C_Generator	*Blood2 ;	// 򖗃xQ
	C_Generator	*Blood3 ;	// 򖗃xR
	u8 Fire1Flag ; 
	u8 Fire2Flag ; 
	u8 Fire3Flag ; 
} HITMARKEFFECT ;

// qbg}[NGtFNg^XNɓnf[^
typedef struct tagHITMARKEFFECTTACKPARAM
{
	u8 DamagePower ;		// _[W̑傫( 0:_[W 1:_[W 2:_[W )
	Vec Point ;				// eW
	Vec Direction ;			// ẽxNg
	WK7JObj *JObj ;			// en_Ɉԋ߂WK7JObj
	f32 YukaY ;				// ̍
} HITMARKEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitHitMarkData( void ) ;				// qbg}[NGtFNg̋ʃf[^
extern s8 CheckHitMarkData( void ) ;			// qbg}[NGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndHitMarkData( void ) ;				// qbg}[NGtFNg̋ʃf[^n

extern EFFECT *CreateHitMarkEffect(
						 u8 		DamagePower,			// _[W̑傫( 0: 1: 2: )
						 Vec 		Point,					// W
						 Vec 		Direction,				// 
						 WK7JObj 	*JObj,					// e_Ɉԋ߂ JObj
						 f32 		YukaY,					// ̍
						 bool		BloodFlag = true,		// GtFNg쐬邩ǂ̃tO
						 s32 Priority = -2 ) ;// qbg}[NGtFNg쐬
extern s8 ReleaseHitMarkEffect( EFFECT *Effect ) ;									// qbg}[NGtFNǧns
extern s8 MoveHitMarkEffect( EFFECT *Effect ) ;										// qbg}[NGtFNgPt[
extern s8 DrawHitMarkEffect( EFFECT *Effect ) ;										// qbg}[NGtFNg`悷

#endif
