///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectImpact
//
// YK7EffectImpact.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/09/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectImpact.h"
#include "../Wat/WK7MainTask.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

IMPACTUNION ImpUnion ;

// function code --------------------------------

// ʂGtFNg̋ʃf[^
extern s8 InitImpactData( void )
{
	MEMINIT( ImpUnion ) ;
	
	// I
	return 0 ;
}

// ʗhGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckImpactData( void )
{
	return TRUE ;
}

// ʂGtFNg̋ʃf[^n
extern s8 EndImpactData( void )
{
	MEMINIT( ImpUnion ) ;
	
	// I
	return 0 ;
}


// ʂ̃GtFNg쐬
extern EFFECT *CreateImpactEffect( f32 MaxImpact, f32 MinImpact, Vec Direction, u16 Time,
									 u16 Wait, u8 LinerFlag, s32 Priority )
{
	IMPACTEFFECT *Impact ;
	EFFECT *Effect ;
	
	// Vʂf[^쐬
	Effect = AddEffectData( EFF_IMPACT, (void**)&Impact, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	// ʂf[^ۑ
	if( Direction.x != 0.0F || Direction.y != 0.0F )
	{
		Direction.x *= -1 ;
		Direction.y *= -1 ;
		VECNormalize( &Direction, &Direction ) ;
	}
	Impact->Direction = Direction ;
	Impact->MaxImpact = MaxImpact ;
	Impact->MinImpact = MinImpact ;
	Impact->Time = Time ;
	Impact->LinerFlag = LinerFlag ;
	Impact->Wait = Wait ;
	Impact->Counter = 0 ;
	Impact->Counter2 = Wait ;
	Impact->Flag = FALSE ;

	// I
	return Effect ;
}

// ʂ̃GtFNǧns
extern s8 ReleaseImpactEffect( EFFECT *Effect )
{
	IMPACTEFFECT *ImpactEffect = ( IMPACTEFFECT * )Effect->Data ;

	// ɂ邱ƂȂ
	return 0 ;
}

// ʂ̃GtFNgPt[
extern s8 MoveImpactEffect( EFFECT *Effect )
{
	IMPACTEFFECT *ImpactEffect = ( IMPACTEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	// K莞Ԃo߂ĂhxZbgs
	if( ImpactEffect->Counter2 == ImpactEffect->Wait )
	{
		f32 Power ;

		// h̋Zbg	
		if( ImpactEffect->LinerFlag == TRUE )
		{
			Power = ImpactEffect->MinImpact + ( ImpactEffect->MaxImpact - ImpactEffect->MinImpact )
					 * ( ImpactEffect->Time - ImpactEffect->Counter ) / ImpactEffect->Time ; 
		}
		else
		{
			Power = rand() * ( ImpactEffect->MaxImpact - ImpactEffect->MinImpact ) / RAND_MAX + ImpactEffect->MinImpact ;
		}
		
		// Zbg
		if( ImpactEffect->Direction.x == 0.0F && ImpactEffect->Direction.y == 0.0F )
		{
			f32 r ;
			
			r = rand() * PI_2 / RAND_MAX ;
			ImpactEffect->Ix = cos( r ) * Power ;
			ImpactEffect->Iy = sin( r ) * Power ;
		}
		else
		{
			ImpactEffect->Ix = ImpactEffect->Direction.x * Power ;
			ImpactEffect->Iy = ImpactEffect->Direction.y * Power ;
			if( ImpactEffect->Flag == TRUE )
			{
				ImpactEffect->Ix *= -1 ;
				ImpactEffect->Iy *= -1 ;
				ImpactEffect->Flag = FALSE ;
			}
			else
			{
				ImpactEffect->Flag = TRUE ;
			}
		}
		
		// JE^Zbg
		ImpactEffect->Counter2 = 0 ;
	}
	else
	{
		ImpactEffect->Counter2 ++ ;
	}
	
	// 莞Ԍo߂Ă폜
	if( ImpactEffect->Counter == ImpactEffect->Time )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	else
	{
		ImpactEffect->Counter ++ ;
	}
	
	// I
	return 0 ;
}
	
// ʂ̃GtFNg`悷
extern s8 DrawImpactEffect( EFFECT *Effect )
{
	IMPACTEFFECT *Ip = ( IMPACTEFFECT * )Effect->Data ;

	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_NONE, EF_TEV_USETEX ) ;		// 
	screenImageFullColor.ScreenCopy() ;											// ʂ̎擾
	GTLOAD( screenImageFullColor.GetTexObj() ) ;
	DrawTex3( Ip->Ix, Ip->Iy, Ip->Ix + SCW, Ip->Iy + SCH, NULL, 0xffffffff )	;		// ʕ`

	// I
	return 0 ;
}
