///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectLensFlare
//
// YK7EffectLensFlare.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/24/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTLENSFLARE_H
#define __YK7EFFECTLENSFLARE_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"

// define ---------------------------------------

// YtA^Cv
enum LENSFLARETEXTYPE
{
	LENSFLARETEX_ADD = 0,		// Zp
	LENSFLARETEX_ALPHA,		// p
} ;

#define LENSFLARE_TEXNUM		6		// YtÃeNX`̐

// datatype -------------------------------------

// YtAGtFNgf[^
typedef struct tagLENSFLAREEFFECT
{
	GXDrawSyncCallback oldcallback ;
//	WK7ScreenImage *Image ;
	WK7JObj *JObj ;
	u8 alpha ;
	Vec SunPos ;
	
	bool AlphaModeFlag ;
	u8 MaxAlpha, MinAlpha ;
} LENSFLAREEFFECT ;

// YtAGtFNgʃf[^
typedef struct tagLENSFLAREUNION
{
	EFFECT *Active ;
	u32 ActiveID ;
	bool SetupFlag ;					// ZbgAbvtO
	bool SetupStartFlag ;				// ZbgAbvX^[gtO
	TEXDATA Tex[LENSFLARE_TEXNUM] ;		// eNX`

	LENSFLARETEXTYPE type ;
	
} LENSFLAREUNION ;

// prototype ------------------------------------

extern s8 InitLensFlareData( void ) ;			// YtAGtFNg̋ʃf[^
extern s8 CheckLensFlareData( void ) ;			// YtAGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndLensFlareData( void ) ;			// YtAGtFNg̋ʃf[^n

extern EFFECT *CreateLensFlareEffect(
						WK7JObj *JObj,						// z JObj
						bool AlphaModeFlag = false,			// őz𔻒f邩̃tO
						u8 MaxAlpha = 0, u8 MinAlpha = 0, 	// őz𔻒fꍇ̑zƔ肷At@l͈̔
						s32 Priority = -130 ) ;			// YtAGtFNg쐬

extern s8 ReleaseLensFlareEffect( EFFECT *Effect ) ;				// YtAGtFNǧns
extern s8 MoveLensFlareEffect( EFFECT *Effect ) ;				// YtAGtFNgPt[
extern s8 DrawLensFlareEffect( EFFECT *Effect ) ;				// YtAGtFNg`悷

extern s8 SetupLensFlareTexture( LENSFLARETEXTYPE type = LENSFLARETEX_ADD ) ;	// YtAGtFNg̃eNX`̏Jn
extern s8 CheckLensFlareTexture( void ) ;										// YtAGtFNg̃eNX`̏̊`FbN( TRUE:  FALSE:܂ )
extern s8 ReleaseLensFlareTexture( void ) ;										// YtAGtFNg̃eNX`̌n

#endif

