///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectMagnum
//
// YK7EffectMagnum.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/24/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectMagnum.h"
#include "./YK7EffectSmoke2.h"
#include "./YK7EffectMuzzle.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

MAGNUMUNION mgu ;


// function proto type --------------------------

// function code --------------------------------

// }OiGtFNg̋ʃf[^
extern s8 InitMagnumData( void )
{
	MEMINIT( mgu ) ;

	return 0 ;
}

// }OiGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckMagnumData( void )
{
	return TRUE ;
}

// }OiGtFNg̋ʃf[^n
extern s8 EndMagnumData( void )
{
	MEMINIT( mgu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}



const u8 __MugTable[] =
{	100,		6,		10,		50,		50,
	10,		15,		71,		98,		12,

	128,		128,		128,		25,		166,
	0,		0,		0,		0,		0,

	0,		0,		0,		0,		0,
	0,		0,		0,		0,		0 } ;

// }OiGtFNg쐬
extern EFFECT *CreateMagnumEffect(
								WK7JObj *JObj,					// z JObj
								s32 Priority )
{
	EFFECT *Effect ;
	MAGNUMEFFECT *lf ;
	Vec pos ;

	// V}Oif[^쐬
	Effect = AddEffectData( EFF_MAGNUM, (void**)&lf, Priority ) ;
	if( Effect == NULL ) return NULL ;
	memset( lf, 0, sizeof( MAGNUMEFFECT ) ) ;
	
	// R[ȅȅe̍W𓾂
	if( JObj == NULL )
	{
		if( GetGunModel( GUN_ENFIELD_R ) == NULL ) goto ERR ;
		JObj = GetGunModel( GUN_ENFIELD_R )->GetObj( "MuzFlash00_S1" ) ;
		if( JObj == NULL ) goto ERR ;
	}
	GetJObjPos( JObj->GetJObj(), &pos ) ;
	
	// GtFNg̍쐬
/*	lf->Smoke =	CreateSmoke2Effect( pos,				// pos
									(s32)VParam[ED_SMOKE2][0] * 10,		// maxnum
									
									VParam[ED_SMOKE2][1] * 0.01F,		// yspeed
									VParam[ED_SMOKE2][2] * 0.001F,		// xspeed
									VParam[ED_SMOKE2][3] * PI_2 / 1000.0F,	// rot1sp
									VParam[ED_SMOKE2][4] * PI_2 / 1000.0F,	// rot2sp
									
									VParam[ED_SMOKE2][5] * 0.01F,		// crerate
									
									VParam[ED_SMOKE2][6] * 0.01F,		// size
									
									VParam[ED_SMOKE2][7] * 0.01F,		// maxalpha
									VParam[ED_SMOKE2][8] * 0.001F,		// upalphaspeed
									VParam[ED_SMOKE2][9] * 0.001F,		// downalphaspeed
									
									CMK( VParam[ED_SMOKE2][10], VParam[ED_SMOKE2][11], VParam[ED_SMOKE2][12], VParam[ED_SMOKE2][13] ),		// color
									VParam[ED_SMOKE2][15] * 0.1F,		// drawarea
									(s32)VParam[ED_SMOKE2][14] ) ;		// dietime
*/
	lf->Smoke =	CreateSmoke2Effect( pos,				// pos
									(s32)__MugTable[0] * 10,		// maxnum
									
									__MugTable[1] * 0.01F,		// yspeed
									__MugTable[2] * 0.001F,		// xspeed
									__MugTable[3] * PI_2 / 1000.0F,	// rot1sp
									__MugTable[4] * PI_2 / 1000.0F,	// rot2sp
									
									__MugTable[5] * 0.01F,		// crerate
									
									__MugTable[6] * 0.01F,		// size
									
									__MugTable[7] * 0.01F,		// maxalpha
									__MugTable[8] * 0.001F,		// upalphaspeed
									__MugTable[9] * 0.001F,		// downalphaspeed
									
									CMK( __MugTable[10], __MugTable[11], __MugTable[12], __MugTable[13] ),		// color
									__MugTable[15] * 0.1F,		// drawarea
									(s32)__MugTable[14] ) ;		// dietime
	if( lf->Smoke == NULL ) goto ERR ;
	lf->SmokeID = GetEffectID( lf->Smoke ) ;

	// JObj ۑ
	lf->JObj = JObj ;
	
	// I
	return Effect ;
	
ERR :
	DeleteEffect( Effect ) ;
	return NULL ;
}

// }OiGtFNǧns
extern s8 ReleaseMagnumEffect( EFFECT *Effect )
{
	MAGNUMEFFECT *lf = ( MAGNUMEFFECT * )Effect->Data ;

	// GtFNg̍폜
	if( CheckEffectValidState( lf->Smoke, lf->SmokeID ) == TRUE )
		DeleteEffect( lf->Smoke ) ;
	
	// I
	return 0 ;
}

// }OiGtFNgPt[
extern s8 MoveMagnumEffect( EFFECT *Effect )
{
	MAGNUMEFFECT *lf = ( MAGNUMEFFECT * )Effect->Data ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// I
	if( CheckEffectValidState( lf->Smoke, lf->SmokeID ) == FALSE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// W킹
	{
		Vec pos ;
		GetJObjPos( lf->JObj->GetJObj(), &pos ) ;
		SetSmoke2EffectPos( lf->Smoke, pos ) ;
	}
	
	// I
	return 0 ;
}


// }OiGtFNg`悷
extern s8 DrawMagnumEffect( EFFECT *Effect )
{
	Effect = Effect ;
	
	// Ȃ
	return 0 ;
}

