///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectMesh
//
// YK7EffectMesh.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/30/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTMESH_H
#define __YK7EFFECTMESH_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "./YK7Break.h"

// define ---------------------------------------

// datatype -------------------------------------

// bVGtFNgʃf[^
typedef struct tagMESHUNION
{
	TEXDATA TestTex ;		// eXgeNX`
} MESHUNION ;

// bVGtFNgf[^
typedef struct tagMESHEFFECT
{
//	MESH *Mesh ;			// bVf[^
	Vec Point ;				// W
	u32 Counter ;			// JE^[
	u8 DeleteCounter ;		// 폜]oẴt[JEgJE^
//	BASICMESH *BasMesh ;	// x[VbNbV
	BASICMODEL *BasModel ;	// x[VbNf

	u8 Alpha ;				// At@
	u8 LightFlag ;			// CgtO

	u8 ReleaseFlag ;		// GtFNg鎞Ƀff[^폜邩ǂ̃tO

	u32 Color ;				// F	
 	bool AddFlag ;			// ZuhtO
} MESHEFFECT ;

// bVGtFNg^XNɓnf[^
typedef struct tagMESHEFFECTTACKPARAM
{
	MESH *Mesh ;			// bVf[^ւ̃|C^
	Vec Point ;				// W
} MESHEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitMeshData( void ) ;								// bVGtFNg̋ʃf[^
extern s8 CheckMeshData( void ) ;								// bVGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndMeshData( void ) ;									// bVGtFNg̋ʃf[^n

//extern void MeshEffectTask( ghmGcTask *pTask ) ;				// bVGtFNg^XN

extern EFFECT *CreateMeshEffect(
							BASICMODEL *BasModel,				// \郁bV
							Vec Point,							// \W
							u8 ReleaseFlag = TRUE,				// GtFNg鎞Ƀff[^폜邩ǂ̃tO
						 	u32 Color = CMK( 200,0,0,128 ),		// F	
						 	bool AddFlag = true,				// ZuhtO
							s32 Priority = -130 ) ;		// bVGtFNg쐬
extern s8 ReleaseMeshEffect( EFFECT *Effect ) ;					// bVGtFNǧns
extern s8 MoveMeshEffect( EFFECT *Effect ) ;					// bVGtFNgPt[
extern s8 DrawMeshEffect( EFFECT *Effect ) ;					// bVGtFNg`悷

extern s8 SetMeshEffectAlpha( EFFECT *Effect, u8 Alpha ) ;		// `掞̃At@lݒ肷
extern s8 SetMeshEffectLightValidFlag( EFFECT *Effect, u8 Flag ) ;	// Cg̗Lݒ肷

#endif
