///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectMuzzleFlash
//
// YK7EffectMuzzle.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/19/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTMUZZLE_H
#define __YK7EFFECTMUZZLE_H


// include --------------------------------------
#include "./YK7Effect.h"
#include "../fujita/c_particle.h"
#include "../Lib/ghmGcFile.h"

// define ---------------------------------------

#define MAX_GUNDATANUM			(GUN_NUM*2)		// 쐬ł郂ff[^̐
#define FST_TEXNUM				3				// ʂ猩p VParts eNX`̎ނ̐
#define FST_TEXNUM2				8

enum
{
	MUZ_TYPE_H = 0,		// ^Cv
	MUZ_TYPE_V = 1,		// r{[h^Cv
	MUZ_TYPE_X = 2,		// XeNX`^Cv
	MUZ_TYPE_S = 3,		// X[N^Cv
} ;

// datatype -------------------------------------

// ẽf[^A[JCuǗp\
typedef struct tagGUNARCDATA
{
	WK7Archive		*MotionArc ;		// }YtbṼ[Vf[^i[ꂽA[JCu
	WK7Archive		*ModelArc ;			// ẽff[^i[ꂽA[JCu

//	TEXDATA			Fst[FST_TEXNUM] ;	// MuzzleFlash_FstP3.BIN
	s32				Count ;				// QƂĂ鐔
	
	bool			FstTexFlag ;		// FSTeNX`v肩ǂ̃tO
} GUNARCDATA ;

// ẽf[^Ǘp\
typedef struct tagGUNDATA
{
	u8 UseFlag ;								// gpǂ̃tO
	u8 GunID ;									// 쐬̏ef[^ւ̃|C^

	WK7ModelMotion	*MotionData ;				// }YtbṼ[Vf[^
	WK7Model		*ModelData ;				// ẽff[^(ff[^vꂽꍇ)

	WK7ModelMotion	*UserMotionData ;			// }YtbṼ[Vf[^(œǂݍłȂꍇ̃f[^)
	WK7Model		*UserModelData ;			// ẽff[^(œǂݍłȂꍇ̃f[^)
	WK7JObj			*UserJObjData ;				// ẽf JObj(œǂݍłȂꍇ̃f[^)

	WK7JObj			*AttachJObj ;				// ẽfA^b`ĂIuWFNg
	EFFECT			*MuzzleEffect ;				// ̏ẽ}YtbVgĂIuWFNg
} GUNDATA ;


// }YtbVGtFNgʃf[^
typedef struct tagMUZZLEUNION
{
	TEXDATA X1 ;				// MuzzleFlash_X1.BIN
	TEXDATA V1 ;				// MuzzleFlash_V1.BIN
	TEXDATA H1 ;				// MuzzleFlash_H1.BIN

	TEXDATA FstTex[FST_TEXNUM2][FST_TEXNUM] ;	// erseNX`
	u32 FstTexCount[FST_TEXNUM2] ;				// erseNX`JEg

	s32 GunDataID[GUN_NUM] ;			// ef[^ID
	GUNARCDATA GunArc[GUN_NUM] ;		// eA[JCuf[^
	GUNDATA GunData[MAX_GUNDATANUM] ;	// ẽf[^
	u8 GunDataNum ;						// ef[^
	u8 Render2DFlag ;					// Qcy|_OtO

	u8 MuzzleNumberUserSetFlag ;
	u8 UserSetMuzzleNumber ;
	u8 CartridgeEffect3DSoundFlag ;		// J[gbWGtFNgRcɂ邩ǂ̃tO
} MUZZLEUNION ;

// }YtbVp_f[^
typedef struct tagMUZZLEVERTEX
{
	Vec Point ;				// _
	Vec Scale ;				// TCY
} MUZZLEVERTEX ;

// }YtbVp[cf[^
typedef struct tagMUZZLEPARTS
{
	Mtx TransMtx ;
	HSD_JObj *JObj, *JObj2 ;	// JObject
	Vec Point ;					// W
	char Type ;					// ^Cv
	u8 Flag ;					// tO
	C_Generator	*Smoke ;		// p[eBN
	u8 MtxCopyFlag ;			// Rs[tO
	f32 RotRand ;				// ]
	u8 DrawFlag ;				// `tO
} MUZZLEPARTS ;

// }YtbVIuWFNgf[^
typedef struct tagMUZZLEOBJECT
{
	MUZZLEPARTS *SParts ;								// ̃p[eBÑNX
	u8 SNum ;											// ̃p[eBN̐
	MUZZLEPARTS *VParts ;								// r{[h^Cvp[c̃f[^zւ̃|C^
	u8 VNum ;											// r{[h^Cvp[c̐
	MUZZLEPARTS *HParts ;								// y^Cvp[c̃f[^zւ̃|C^
	u8 HNum ;											// y^Cvp[c̐
	MUZZLEPARTS *XParts ;								// XeNX`ŕ`悷f[^zւ̃|C^
	u8 XNum ;											// XeNX`ŕ`悷p[c̐

	f32 r1, r2 ;						// _l

	u8 FstNumber ;						// erseNX`io[
	u8 HReverseFlag, VReverseFlag ;		// ]tO
} MUZZLEOBJECT ;

// }YtbVGtFNgf[^
typedef struct tagMUZZLEEFFECT
{
	s8 GunDataID ;						// gpĂêhc
	s8 DetachFlag ;						// ɃAj[V͏o^b`Ă邩tO
	s8 SoundFlag ;
	s8 CountFlag ;
	u32 MuzCounter ;
	u8 CartridgeEffect3DSoundFlag ;

	s8 DirectJObjFlag ;				// e JObj 𒼐ڎ󂯎tO
	s8 MotionAttachFlag ;			// [VA^b`tO
	WK7ModelMotion *GunMotion ;		// tꍇ̏ẽ[V
	WK7JObj *DirectJObj ;			// tꂽ WK7JObj

	WK7JObj *Cartridge ;				// J[gbWIuWFNg̃|C^
	u8 CartridgeFlag ;					// J[gbWrotO
	WK7JObj *GunModel ;					// ẽff[^IuWFNg̃|C^
	MUZZLEOBJECT Obj ;					// }YtbVf[^
	u16 Counter ;						// JE^[
	f32 YukaY ;							// ̍
	s8 MuzzleFlag ;						// }YtbVoǂ̏( TRUE:o FALSE:܂oĂȂ )
	f32 KnifeRot ;						// ]l
} MUZZLEEFFECT ;

// }YtbV̈f[^
typedef struct tagMUZZLEEFFECTTASKPARAM
{
	WK7JObj *GunModel ;					// ẽff[^IuWFNg̃|C^
	s8 GunID ;							// êhc
	f32 YukaY ;							// ̍
} MUZZLEEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitMuzzleData( void ) ;				// }YtbVGtFNg̋ʃf[^
extern s8 CheckMuzzleData( void ) ;				// }YtbVGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndMuzzleData( void ) ;				// }YtbVGtFNg̋ʃf[^n

extern EFFECT *CreateMuzzleEffect( s8 GunID, f32 YukaY = 0.0F, WK7JObj *GJObj = NULL, s8 MotionAttach = FALSE, s32 Priority = -5/*, u8 ReloadTypeFlag = FALSE*/ ) ;	// }YtbṼGtFNg쐬
extern s8 ReleaseMuzzleEffect( EFFECT *Effect ) ;								// }YtbṼGtFNǧns
extern s8 MoveMuzzleEffect( EFFECT *Effect ) ;									// }YtbṼGtFNgPt[
extern s8 DrawMuzzleEffect( EFFECT *Effect ) ;									// }YtbṼGtFNg`悷

extern s8 LoadGunArchive( s8 GunID, bool FstTexFlag = true ) ;					// w̏ẽf[^ǂݍ
extern s8 CheckGunArchiveLoad( s8 GunID ) ;										// w̏e̓ǂݍݏI҂( ߂l TRUE:܂ǂݍݏIĂȂ FALSE:ǂݍ݂͏IĂ )
extern s8 ReleaseGunArchive( s8 GunID ) ;										// w̏ẽf[^J

extern s8 SetUserGunModel( s8 GunID, WK7Model *Model, WK7ModelMotion *Motion, WK7JObj *JObj = NULL ) ;	// Oŗpӂff[^o^
extern s8 ResetUserGunModel( s8 GunID ) ;										// Off[^̓o^ԂZbg
//extern s8 EndGunData( s8 GunDataID ) ;										// n

extern WK7Model *AttachGunModel( s8 GunID, WK7JObj *JObj, WK7Model *Model = NULL, s8 Hand = 0 ) ;		// ff[^A WK7JObj Ɏw̏ẽfA^b`
extern s8 AttachGunMotion( s8 GunID ) ;									// ẽfɃ[VA^b`( Type:0 }Y[V  Type:1 [h[V )
extern s8 DetachGunModel( s8 GunID ) ;									// A^b`
extern GUNDATA *GetGunData( s8 GunID ) ;								// ŵhc̏ẽf[^擾
extern WK7Model *GetGunModel( s8 GunID ) ;								// ŵhc̏ẽff[^擾
extern WK7Model *CopyGunModel( s8 GunID ) ;								// ŵhc̏ẽff[^𕡐
extern WK7ModelMotion *GetGunMotion( s8 GunID ) ;						// ŵhc̏ẽ[Vf[^擾
extern WK7JObj *GetGunJObj( s8 GunID ) ;								// ŵhc̏êin擾
extern s8 ChangeGunModelQuality( s8 GunID, u8 HiModelFlag ) ;			// ŵhc̏ẽff[^̃ff[^̃NIeBύX

extern s8 SetMuzzleCartridgeSound3DFlag( void ) ;						// ɍ쐬}YtbVJ[gbWGtFNg̉Rcɂ邩ǂ̃tOZbg
extern s8 SetMuzzle2DFlag( u8 Render2DFlag ) ;							// }YtbVQc|SŃ_O邩tOZbg
extern s8 SetMuzzleNumberUserSetFlag( u8 Flag ) ;
extern s8 SetUserMuzzleNumber( u8 Number ) ;

extern s8 CheckMuzzleAction( EFFECT *Effect ) ;										// }YtbVoĂ邩ǂ擾



extern EFFECT *CreateMuzzleEffect2( s8 GunDataID, f32 YukaY = 0.0F, WK7JObj *GJObj = NULL, s8 MotionAttach = FALSE, s32 Priority = -5/*, u8 ReloadTypeFlag = FALSE*/ ) ;	// }YtbṼGtFNg쐬

extern s8 LoadGunArchive2( s8 GunID, bool FstTexFlag = true ) ;					// w̏ẽf[^ǂݍ
extern s8 CheckGunArchiveLoad2( s8 GunDataID ) ;								// w̏e̓ǂݍݏI҂( ߂l TRUE:܂ǂݍݏIĂȂ FALSE:ǂݍ݂͏IĂ )
extern s8 ReleaseGunArchive2( s8 GunDataID ) ;									// w̏ẽf[^J

extern s8 SetUserGunModel2( s8 GunDataID, WK7Model *Model, WK7ModelMotion *Motion, WK7JObj *JObj = NULL ) ;	// Oŗpӂff[^o^
extern s8 ResetUserGunModel2( s8 GunDataID ) ;									// Off[^̓o^ԂZbg

extern WK7Model *AttachGunModel2( s8 GunDataID, WK7JObj *JObj, WK7Model *Model = NULL, s8 Hand = 0 ) ;		// ff[^A WK7JObj Ɏw̏ẽfA^b`
extern s8 AttachGunMotion2( s8 GunDataID ) ;														// ẽfɃ[VA^b`( Type:0 }Y[V  Type:1 [h[V )
extern s8 DetachGunModel2( s8 GunDataID ) ;														// A^b`
extern GUNDATA *GetGunData2( s8 GunDataID ) ;													// ŵhc̏ẽf[^擾
extern WK7Model *GetGunModel2( s8 GunDataID ) ;													// ŵhc̏ẽff[^擾
extern WK7Model *CopyGunModel2( s8 GunDataID ) ;												// ŵhc̏ẽff[^𕡐
extern WK7ModelMotion *GetGunMotion2( s8 GunDataID ) ;											// ŵhc̏ẽ[Vf[^擾
extern WK7JObj *GetGunJObj2( s8 GunDataID ) ;													// ŵhc̏êin擾
extern s8 ChangeGunModelQuality2( s8 GunDataID, u8 HiModelFlag ) ;								// ŵhc̏ẽff[^̃ff[^̃NIeBύX
extern HSD_JObj *GetMuzzlePosJObj( s8 GunID ) ;										// }YtbVW HSD_JObj 擾

#endif

