///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectNoise
//
// YK7EffectNoise.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 08/07/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------

#include "./YK7EffectNoise.h"
#include "../matsu/mk7Sound.h"
#include "../Wat/WK7MainTask.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

NOISEUNION NSUnion ;

// function proto type --------------------------

// function code --------------------------------

// mCYGtFNg̋ʃf[^
extern s8 InitNoiseData( void )
{
	MEMINIT(NSUnion) ;

	// I
	return 0 ;
}

// mCYGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckNoiseData( void )
{
	return TRUE ;
}

// mCYGtFNg̋ʃf[^n
extern s8 EndNoiseData( void )
{
	MEMINIT(NSUnion) ;

	// I
	return 0 ;
}

// mCỸGtFNg쐬
extern EFFECT *CreateNoiseEffect( s8 UseTexAlphaFlag, bool NotNoizeLineFlag, s32 Priority )
{
	EFFECT *Effect ;
	NOISEEFFECT *Noise ;

	// VmCYf[^쐬
	Effect = AddEffectData( EFF_NOISE, (void**)&Noise, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// f[^
	memset( Noise, 0, sizeof( NOISEEFFECT ) ) ;
	Noise->Num = 0 ;
	Noise->Line = 0 ;
	Noise->UseTexAlphaFlag = UseTexAlphaFlag ;
	Noise->NotNoizeLineFlag = NotNoizeLineFlag ;
	Noise->CharGekiModeFlag = false ;
	
	// I
	return Effect ;
}

// mCYGtFNg̃mCY𑝂₷
extern s8 AddNoiseLine( EFFECT *Effect, u8 AddNum, u16 Width, u16 Speed, u16 RotSpeed, s32 Sound )
{
	NOISEEFFECT *Noise = ( NOISEEFFECT * )Effect->Data ;
	NOISEOBJECT *Ns ;
	u8 AddNoiseNum ;
	u32 i ;

	// ʉĐ
	if( Sound != -1 && GetEffectSoundOffFlag() == FALSE )
		PlayEffectSE( Sound, SOUND_SYSTEM_SE_VOLUME, SOUND_PAN_CENTER, eSETrackSystemOverlap, eSEGroupSystem00Env ) ;
				
	// ǉmCY̐Zbg
	AddNoiseNum = AddNum ;

	// ǉ
	for( i = 0 ; i < AddNoiseNum ; i ++ )
	{
		// ɂς̏ꍇ͉ɏI
		if( Noise->Num == NOISE_MAXNUM ) return -1 ;

		// gĂȂmCYf[^T
		for( Ns = Noise->Data ; Ns->UseFlag == TRUE ; Ns ++ ){}
		
		// mCỸp[^Zbg
		Ns->UseFlag = TRUE ;
		Ns->Width = rand() * ( Width - Width / 10 ) / RAND_MAX + Width / 10 ;
		Ns->Speed = (u16)( rand() * ( Speed - Speed / 3 ) / RAND_MAX + Speed / 3 ) ;
		Ns->Point = 0 ;
		Ns->Helz = rand() * ( RotSpeed - RotSpeed / 10 ) / RAND_MAX + RotSpeed / 10 ;

		// mCY̐𑝂₷
		Noise->Num ++ ;
	}
	
	// I
	return 0 ;
}


// mCỸGtFNǧns
extern s8 ReleaseNoiseEffect( EFFECT *Effect )
{
	NOISEEFFECT *Noise = ( NOISEEFFECT * )Effect->Data ;

	// ɂ邱ƂȂ

	// I
	return 0 ;
}

// mCỸGtFNgt[ړ
extern s8 MoveNoiseEffect( EFFECT *Effect )
{
	NOISEEFFECT *Noise = ( NOISEEFFECT * )Effect->Data ;
	NOISEOBJECT *Ns ;
	u32 i, Num ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// ׂẴmCY
	Ns = Noise->Data ;
	Num = Noise->Num ;
	for( i = 0 ; i < Num ; Ns ++ )
	{
		if( Ns->UseFlag == TRUE )
		{
			i ++ ;
		
			// _WύX
			Ns->Point += Ns->Speed ;

			// ʊOɏoI
			if( (s32)Ns->Point - ( PI2DIV / Ns->Helz ) >= WK7_SCREEN_HEIGHT )
			{
				Ns->UseFlag = FALSE ;
				
				// mCY̐炷
				Noise->Num -- ;
			}
		}
	}
	
	// mCYCi߂
	Noise->Line += VParam[ED_NOISE][4] ;
	if( Noise->Line > WK7_SCREEN_HEIGHT ) Noise->Line = 0 ;
	
	// I
	return 0 ;
}					

// mCỸGtFNg`悷
#define MOVT			(32)
#define MOVB			(384)
extern s8 DrawNoiseEffect( EFFECT *Effect )
{
	NOISEEFFECT *Noise = ( NOISEEFFECT * )Effect->Data ;
	NOISEOBJECT *Ns ;
//	static f32 NoiseMap[WK7_SCREEN_HEIGHT] ;
	f32 *NoiseMap = (f32 *)WorkBuffer ;
	u32 i ;
	s32 j, Rot ;
	s32 h, y ;
	
	if( Noise->CharGekiModeFlag == true )
	{
		y = MOVT ;
		h = MOVB - MOVT ;
	}
	else
	{
		y = 0 ;
		h = SCH ;
	}
		
	
	// ݂̉ʎ荞
	if( Noise->UseTexAlphaFlag == FALSE ) screenImageFullColor.ScreenCopy() ;
	
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;		// `̏

	// `揀
	{
		GXSetLineWidth( 6, GX_TO_ONE ) ;

		// eNX`̃[h
		GTLOAD( screenImageFullColor.GetTexObj() ) ;

		// ̑Zbg
		GXSetLineWidth( (u8)6, GX_TO_ONE ) ;
		GXEnableTexOffsets( GX_TEXCOORD0, GX_DISABLE, GX_DISABLE ) ;
	}

	// mCY}bv
	memset( NoiseMap, 0, sizeof( f32 ) * h ) ;
	
	// mCY}bv쐬
	Ns = Noise->Data ;
	for( i = 0 ; i < Noise->Num ; Ns ++ )
	{
		// mCYL珈s
		if( Ns->UseFlag == TRUE )
		{
			i ++ ;
		
			// ܂ő
			j = Ns->Point - PI2DIV / Ns->Helz ;
			Rot = 0 ;
			if( j < 0 )
			{
				Rot = j * Ns->Helz ;
				j = 0 ;
			}
			for( ; j < h && Rot < PI2DIV ; j ++, Rot += Ns->Helz )
				NoiseMap[j] += SIN(Rot) * Ns->Width ;
		}
	}

	// `揈Jn
	{
		u16 a ;
		u8 r, g, b ;
		
		if( Noise->UseTexAlphaFlag == FALSE )
		{
			GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );
	//		GXSetTevOp(GX_TEVSTAGE0, GX_MODULATE );
			GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_TEXC, GX_CC_RASC, GX_CC_ZERO ) ; 
	   		GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_4, GX_TRUE, GX_TEVPREV ) ;
			GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_ZERO, GX_CA_ZERO, GX_CA_ONE ) ; 
			GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV ) ;
		}
		else
		{
			GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );
	//		GXSetTevOp(GX_TEVSTAGE0, GX_MODULATE );
			GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_TEXC, GX_CC_RASC, GX_CC_ZERO ) ; 
	   		GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_4, GX_TRUE, GX_TEVPREV ) ;
			GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_TEXA, GX_CA_RASA, GX_CA_ZERO ) ; 
			GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV ) ;
			EffectBlendModeSetup( EF_BLEND_NONE ) ;
			GXSetAlphaCompare( GX_GREATER, 10, GX_AOP_AND, GX_ALWAYS, 0 ) ;
		}

//GX_TB_ADDHALF

		// ̑Zbg
		GXSetLineWidth( (u8)6, GX_TO_ONE ) ;
		GXEnableTexOffsets( GX_TEXCOORD0, GX_DISABLE, GX_DISABLE ) ;
	
		GBGN( GX_LINES, h * 2 ) ;
		{
			r = (u8)VParam[ED_CHARCHANGE][10] ;
			g = (u8)VParam[ED_CHARCHANGE][11] ;
			b = (u8)VParam[ED_CHARCHANGE][12] ;
		
			for( i = 0 ; i < h ; i ++ )
			{
				a = (u16)( fabs(NoiseMap[i]) * VParam[ED_CHARCHANGE][9] / VParam[ED_CHARCHANGE][8] ) ;
				if( a > VParam[ED_CHARCHANGE][9] ) a = VParam[ED_CHARCHANGE][9] ; 

				GP2( NoiseMap[i], i + y ) ;
				GC4( (u8)( 64 + ( ( r * a ) / VParam[ED_CHARCHANGE][9] ) ), (u8)( 64 + ( ( g * a ) / VParam[ED_CHARCHANGE][9] ) ), (u8)( 64 + ( ( b * a ) / VParam[ED_CHARCHANGE][9] ) ), 255 ) ;
				GT( 0.0F, (f32)( i + y ) / SCH ) ;

				GP2( NoiseMap[i] + WK7_SCREEN_WIDTH, i + y ) ;
				GC4( (u8)( 64 + ( ( r * a ) / VParam[ED_CHARCHANGE][9] ) ), (u8)( 64 + ( ( g * a ) / VParam[ED_CHARCHANGE][9] ) ), (u8)( 64 + ( ( b * a ) / VParam[ED_CHARCHANGE][9] ) ), 255 ) ;
				GT( 1.0F, (f32)( i + y ) / SCH ) ;
			}
		}
		GXEnd() ;
		GXSetAlphaCompare( GX_ALWAYS, 0, GX_AOP_OR, GX_ALWAYS, 0 ) ;
	}

	// mCY烉C`
//	if( Noise->Num == 0 )
	if( Noise->UseTexAlphaFlag == FALSE && Noise->NotNoizeLineFlag == false )
	{
		// ݂̉ʎ荞
		if( Noise->Line > y && Noise->Line + VParam[ED_NOISE][6] < y + h )
		{
			screenImageFullColor.ScreenCopy() ;
		
			GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );
			GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_TEXC ) ; 
	   		GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;
			GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_ZERO, GX_CA_ZERO, GX_CA_ONE ) ; 
			GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;

			GXBegin( GX_QUADS, GX_VTXFMT0, (u16)4 ) ;
			{
				GP2( VParam[ED_NOISE][5], 		Noise->Line ) ;							GCX( 0xffffffff ) ; GT( 0.0F, (f32)Noise->Line / SCH ) ;
				GP2( SCW + VParam[ED_NOISE][5], Noise->Line ) ;							GCX( 0xffffffff ) ; GT( 1.0F, (f32)Noise->Line / SCH ) ;
				GP2( SCW + VParam[ED_NOISE][5], Noise->Line + VParam[ED_NOISE][6] ) ;	GCX( 0xffffffff ) ; GT( 1.0F, (f32)( Noise->Line + VParam[ED_NOISE][6] ) / SCH ) ;
				GP2( VParam[ED_NOISE][5], 		Noise->Line + VParam[ED_NOISE][6] ) ;	GCX( 0xffffffff ) ; GT( 0.0F, (f32)( Noise->Line + VParam[ED_NOISE][6] ) / SCH ) ;
			}
			GXEnd() ;
		}

		return 0 ;
	}

	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;		// `̏
	
	// I
	return 0 ;
}					

// mCYC̐擾
extern s8 GetNoiseLineNum( EFFECT *Effect )
{
	NOISEEFFECT *Noise = ( NOISEEFFECT * )Effect->Data ;
	
	return (s8)Noise->Num ;
}

// VlXRl[hɂ邩ǂ̃tOZbg
extern s8 SetNoiseCharGekiModeFlag( EFFECT *Effect, bool flag )
{
	NOISEEFFECT *Noise = ( NOISEEFFECT * )Effect->Data ;
	
	Noise->CharGekiModeFlag = flag ;
	
	return 0 ;
}
