///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectPool
//
// YK7EffectPool.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/13/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTPOOL_H
#define __YK7EFFECTPOOL_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

#define POOL_SIZE		128
#define POOL_WSX 		2
#define POOL_WSY 		2
#define POOL_ZM			256
#define POOL_WEIGHT		2
#define POOL_WEIGHTO	(POOL_WEIGHT-4)

// datatype -------------------------------------

// v[GtFNgʃf[^
typedef struct tagPOOLUNION
{
	TEXDATA pooltex ;
} POOLUNION ;

// v[IuWFNgf[^
typedef struct tagPOOLOBJECT
{
} POOLOBJECT ;

// v[GtFNgf[^
typedef struct tagPOOLEFFECT
{
	Vec Pos ;
	f32 length ;
	f32 xsize, zsize ;
	f32 height ;
	u32 xdiv, zdiv ;
	f32 count ;
/*	
	s32 Pow[ POOL_WSY * 2 ][ POOL_WSX * 2 ] ;
	s32 ZValue[4][POOL_SIZE * POOL_SIZE] ;
	u8 count2 ;
*/
	u32 color ;
} POOLEFFECT ;

// v[GtFNg^XNɓnf[^
typedef struct tagPOOLEFFECTTACKPARAM
{
} POOLEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitPoolData( void ) ;			// v[GtFNg̋ʃf[^
extern s8 CheckPoolData( void ) ;			// v[GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndPoolData( void ) ;				// v[GtFNg̋ʃf[^n

extern EFFECT *CreatePoolEffect(
									f32 xsize, f32 zsize,		// ͈
									f32 height,					// 
									Vec Pos,					// W
									s32 Priority = -130 ) ;		// v[GtFNg쐬
extern s8 ReleasePoolEffect( EFFECT *Effect ) ;					// v[GtFNǧns
extern s8 MovePoolEffect( EFFECT *Effect ) ;					// v[GtFNgPt[
extern s8 DrawPoolEffect( EFFECT *Effect ) ;					// v[GtFNg`悷

extern s8 ChangePoolPos( EFFECT *Effect, Vec Pos ) ;			// v[̈ʒuύX
extern s8 ChangePoolColor( EFFECT *Effect, u32 color ) ;		// v[̒_J[ύX

#endif

