///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectScanLine
//
// YK7EffectScanLine.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 11/17/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------

#include "./YK7EffectScanLine.h"
#include "../matsu/mk7Sound.h"
#include "../Wat/WK7MainTask.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

static SCANLINEUNION SLUnion ;

// function proto type --------------------------

// function code --------------------------------

// GtFNg̋ʃf[^
extern s8 InitScanLineData( void )
{
	MEMINIT(SLUnion) ;

	// I
	return 0 ;
}

// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckScanLineData( void )
{
	return TRUE ;
}


// GtFNg̋ʃf[^n
extern s8 EndScanLineData( void )
{
	// I
	return 0 ;
}

// ̃GtFNg쐬
extern EFFECT *CreateScanLineEffect( s8 LineWidth, u8 Alpha, s32 Priority )
{
	EFFECT *Effect ;
	SCANLINEEFFECT *ScanLine ;

	// Vf[^쐬
	Effect = AddEffectData( EFF_SCANLINE, (void**)&ScanLine, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// f[^
	ScanLine->LineWidth = LineWidth ;
	ScanLine->Alpha = Alpha ;

	// I
	return Effect ;
}


// ̃GtFNǧns
extern s8 ReleaseScanLineEffect( EFFECT *Effect )
{
	SCANLINEEFFECT *ScanLine = ( SCANLINEEFFECT * )Effect->Data ;

	// ɂ邱ƂȂ

	// I
	return 0 ;
}

// ̃GtFNgt[ړ
extern s8 MoveScanLineEffect( EFFECT *Effect )
{
	SCANLINEEFFECT *ScanLine = ( SCANLINEEFFECT * )Effect->Data ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE ) 
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// I
	return 0 ;
}					

// ̃GtFNg`悷
extern s8 DrawScanLineEffect( EFFECT *Effect )
{
	SCANLINEEFFECT *ScanLine = ( SCANLINEEFFECT * )Effect->Data ;
	u16 i, Num, y ;
	u32 color ;

	// `揀
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_NOTEX ) ;

	// ̑Zbg
	GXSetLineWidth( (u8)( 6 * VParam[ED_CHARCHANGE][1] ), GX_TO_ONE ) ;
	
	// ̕`
	color = CMK2( 0, ScanLine->Alpha ) ;
	Num = (u16)( 480 / ( ScanLine->LineWidth * 2 ) ) ;
	GBGN( GX_LINES, Num * 2 ) ;
	{
		y = 0 ;
		for( i = 0 ; i < Num ; i ++, y += ScanLine->LineWidth * 2 )
		{
			GP2( 0,		y ) ; GCX( color ) ;
			GP2( SCW, 	y ) ; GCX( color ) ;
		}
	}
	GXEnd() ;		
	
	// I
	return 0 ;
}					





