///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSeenSound
//
// YK7EffectSeenSound.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/08/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSEENSOUND_H
#define __YK7EFFECTSEENSOUND_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

#define SEENSOUND_MAXOBJNUM			20

// datatype -------------------------------------

// 鉹GtFNgʃf[^
typedef struct tagSEENSOUNDUNION
{
} SEENSOUNDUNION ;

// 鉹IuWFNgf[^
typedef struct tagSEENSOUNDOBJECT
{
	u8 vflag ;		// LtO
	f32 r ;			// ͈
	f32 alpha ;		// 
} SEENSOUNDOBJECT ;

// 鉹GtFNgf[^
typedef struct tagSEENSOUNDEFFECT
{
	SEENSOUNDOBJECT obj[SEENSOUND_MAXOBJNUM] ;
	u32 objnum ;
	
	Vec pos ;			// W

	u32 crecounter ;	// 쐬JE^
	u32 crewait ;		// 쐬҂

	f32 alpha, alphaspeed ;		// At@ƃAt@Xs[h
	f32 speed ;
	u32 color1, color2 ;
	f32 width ;	
	
	bool oneflag ;		// ̂݃tO
	
} SEENSOUNDEFFECT ;

// 鉹GtFNg^XNɓnf[^
typedef struct tagSEENSOUNDEFFECTTACKPARAM
{
	Vec pos ;					// W
	
	u32 crewait ;				// 쐬҂
	u32 time ;					// \
	f32 outspeed ;				// 鑬x
	f32 width ;					// 
	GXColor color1, color2 ;	// F
	f32 speed ;					// x
} SEENSOUNDEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitSeenSoundData( void ) ;			// 鉹GtFNg̋ʃf[^
extern s8 CheckSeenSoundData( void ) ;			// 鉹GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndSeenSoundData( void ) ;				// 鉹GtFNg̋ʃf[^n

extern EFFECT *CreateSeenSoundEffect(
									Vec pos,							// W
									u32 crewait,						// 쐬҂
									u32 time,							// \
									f32 outspeed,						// 鑬x
									f32 width,							// 
									GXColor color1, GXColor color2,		// F
									f32 speed,							// L鑬x
									bool oneflag = false,				// ̂݃tO
									s32 Priority = -130 ) ;				// 鉹GtFNg쐬

extern s8 ReleaseSeenSoundEffect( EFFECT *Effect ) ;										// 鉹GtFNǧns
extern s8 MoveSeenSoundEffect( EFFECT *Effect ) ;											// 鉹GtFNgPt[
extern s8 DrawSeenSoundEffect( EFFECT *Effect ) ;											// 鉹GtFNg`悷

#endif

