///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectShutter
//
// YK7EffectShutter.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 10/06/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSHUTTER_H
#define __YK7EFFECTSHUTTER_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// Vb^[GtFNgʃf[^
typedef struct tagSHUTTERUNION
{
	u8 Dummy ;
} SHUTTERUNION ;

// Vb^[GtFNgf[^
typedef struct tagSHUTTEREFFECT
{
	u8 Mode ;						// 0:㏟ɏ  1:Ȃ

	u8 CloseTime ;					// ܂܂ł̃t[
	u8 CloseWait ;					// ܂Ă҂
	u8 OpenTime ;					// J܂ł̎

	f32 CloseRate ;					// ܂(1.0F:܂肫Ă  0.0F:JĂ)
	u8 StartMode, TargetMode ;		// Jn̊JƖڕW̊J
	s8 NextMode ;
	
	s16 State ;						// (0:܂Ăr  1:܂  2:JĂr)
	s16 Counter ;					// JE^[
	s8 AutoOpenFlag ;				// 莞Ԍo߂ƎŃVb^[JÃtO
} SHUTTEREFFECT ;

// Vb^[GtFNgf[^p\
typedef struct tagSHUTTEREFFECTTASKPARAM
{
	u8 CloseTime ;					// ܂܂ł̃t[
	u8 CloseWait ;					// ܂Ă҂
	u8 OpenTime ;					// J܂ł̎
} SHUTTEREFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitShutterData( void ) ;				// Vb^[GtFNg̋ʃf[^
extern s8 CheckShutterData( void ) ;			// Vb^[GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndShutterData( void ) ;				// Vb^[GtFNg̋ʃf[^n

extern EFFECT *CreateShutterEffect( u8 CloseTime, u8 CloseWait, u8 OpenTime, u8 Mode = 0, s8 AutoOpenFlag = TRUE, s32 Priority = 127 ) ;					// Vb^[GtFNg쐬
extern s8 ReleaseShutterEffect( EFFECT *Effect ) ;	// Vb^[GtFNǧns
extern s8 MoveShutterEffect( EFFECT *Effect ) ;		// Vb^[GtFNgPt[
extern s8 DrawShutterEffect( EFFECT *Effect ) ;		// Vb^[GtFNg`悷

extern s8 GetShutterState( EFFECT *Effect ) ;		// Vb^[̏Ԃ擾( 0:Vb^[͕܂肫Ă  1:Vb^[͊JĂ )
extern s8 ChangeSutterOpneType( EFFECT *Effect ) ;	// Vb^[̊J[h؂ւ
extern s8 OpenShutterEffect( EFFECT *Effect ) ;		// Vb^[ŊJݒɂĂȂꍇÅ֐ŊJ

#endif