///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSkill
//
// YK7EffectSkill.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/12/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectSkill.h"
#include "./YK7EffectElec.h"
#include "./YK7EffectSmoke.h"
#include "./YK7EffectExplode.h"
#include "./YK7EffectHSExplode.h"

// define ---------------------------------------

#define PRM				(s32)VParam[ED_SKILL]

// data -----------------------------------------

// datatype -------------------------------------

// function proto type --------------------------

extern void __JObjDir3( WK7JObj *JObj, DIR3 *Dir ) ;			// WKJObj  ZɂO𓾂

// function code --------------------------------

// WKJObj  ZɂO𓾂
extern void __JObjDir3( WK7JObj *JObj, DIR3 *Dir )
{
	Vec dir ;
	
	 GetJObjZVec( JObj->GetJObj(), &dir ) ;
	 GetDir3( dir, Dir ) ;
}

// wuX}C_[WpdGtFNg
extern EFFECT *CreateElecHSEffect(
									ELEC_TYPE type,						// d^Cv
									WK7JObj *JObj,						// Ǐ] JObj 
									f32 topheight, f32 bottomheight,	// d̏̒_̍Ɖ̒_̍
									s32 Priority
									 )
{
	EFFECT *Effect ;
	ELECHSEFFECT *el ;
	Vec st, ed ;

	// GtFNgf[^̒ǉ
	Effect = AddEffectData( EFF_ELECHS, (void **)&el, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	// f[^̕ۑ
	el->JObj 			= JObj ;
	el->topheight 		= topheight ;
	el->bottomheight 	= bottomheight ;
	el->type 			= type ;
	
	// W̎Zo
	{
		DIR3 dir ;
		Vec pos ;
	
		// O𓾂
		__JObjDir3( JObj, &dir ) ;
		
		// W𓾂
		GetJObjPos( JObj->GetJObj(), &pos ) ;
		
		// Q_𓾂
		GetDirPos( &dir, &st, 0.0F, el->topheight, 0.0F ) ;
		GetDirPos( &dir, &ed, 0.0F, -el->bottomheight, 0.0F ) ;
		st.x += pos.x ;	st.y += pos.y ;	st.z += pos.z ;
		ed.x += pos.x ;	ed.y += pos.y ;	ed.z += pos.z ;
	}
	
	// dGtFNg̍쐬
	if( ( el->elec = CreateElecEffect( type, st, ed ) ) == NULL )
	{
		DeleteEffect( Effect ) ;
		return NULL ;
	}

	return Effect ;
}

// wuX}C_[WpdGtFNg
extern s8 ReleaseElecHSEffect( EFFECT *Effect )
{
	ELECHSEFFECT *el = ( ELECHSEFFECT * )Effect->Data ;
	
	if( el->elec != NULL ) DeleteEffect( el->elec ) ;
	
	return 0 ;
}

// wuX}C_[WpdGtFNgt[vZX
extern s8 MoveElecHSEffect( EFFECT *Effect )
{
	ELECHSEFFECT *el = ( ELECHSEFFECT * )Effect->Data ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// WXV
	{
		DIR3 dir ;
		Vec st, ed, pos ;
	
		// O𓾂
		__JObjDir3( el->JObj, &dir ) ;

		// W𓾂
		GetJObjPos( el->JObj->GetJObj(), &pos ) ;
		
		// Q_𓾂
		GetDirPos( &dir, &st, 0.0F, el->topheight, 0.0F ) ;
		GetDirPos( &dir, &ed, 0.0F, -el->bottomheight, 0.0F ) ;
		st.x += pos.x ;	st.y += pos.y ;	st.z += pos.z ;
		ed.x += pos.x ;	ed.y += pos.y ;	ed.z += pos.z ;
		
		// Zbg
		SetElecPos( el->elec, st, ed ) ;
	}

	return 0 ;
}


// }XN̓d{쐬
extern EFFECT *CreateMskSparkBom( Vec pos )
{
	EFFECT *ef ;
	
	// 
	SetHSExplodeEffectSoundOffFlag( true ) ;
	ef = CreateSmokeExplodeEffect( pos, 2.0F, EXP_MSK_SPARK ) ;

	// d̍쐬	
	{
		Vec p, t ;
		EFFECT *ef ;

		t = p = pos ;
		p.x -= PRM[0] ;
		t.x += PRM[0] ;
		ef = CreateElecEffect( EL_MSK_BOM, p, t ) ;
		if( ef != NULL ) SetEffectLifeTime( ef, PRM[1] ) ;
		ef = CreateElecEffect( EL_MSK_BOM, p, t ) ;
		if( ef != NULL ) SetEffectLifeTime( ef, PRM[1] ) ;
	}
	
	return ef ;
}



