///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSteam
//
// YK7EffectSteam.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 01/31/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSTEAM_H
#define __YK7EFFECTSTEAM_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "./YK7EffectBillBoard.h"
#include "../Wat/Wk7Model.h"

// define ---------------------------------------

// datatype -------------------------------------

// CGtFNgʃf[^
typedef struct tagSTEAMUNION
{
	u8 Dummy ;
} STEAMUNION ;

// CGtFNgf[^
typedef struct tagSTEAMEFFECT
{
	EFFECT *BillEff ;			// r{[hGtFNg
	u32 BillEffID ;				// r{[hGtFNĝhc

	WK7JObj *JObj ;				// CoWĂ JObj ւ̃|C^
	f32 CreateSpeed ;			// 쐬x
	f32 CreateCounter ;			// C쐬JE^
	f32 Size ;					// C̑傫
} STEAMEFFECT ;

// CGtFNgf[^p\
typedef struct tagSTEAMEFFECTTASKPARAM
{
	WK7JObj *JObj ;				// CoWĂ JObj ւ̃|C^
	f32 CreateSpeed ;			// 쐬x
	f32 Size ;					// C̑傫
} STEAMEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitSteamData( void ) ;				// CGtFNg̋ʃf[^
extern s8 CheckSteamData( void ) ;			// CGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndSteamData( void ) ;				// CGtFNg̋ʃf[^n

extern EFFECT *CreateSteamEffect(	WK7JObj *JObj,				// CoWĂ JObj ւ̃|C^
									f32 CreateSpeed,			// 쐬x
									f32 Size,					// C̑傫
									s32 BillID = BILLEFF_STEAM,	// r{[h^Cv
									s32 Priority = -3 ) ;		// CGtFNg쐬
extern s8 ReleaseSteamEffect( EFFECT *Effect ) ;				// CGtFNǧns
extern s8 MoveSteamEffect( EFFECT *Effect ) ;					// CGtFNgPt[
extern s8 DrawSteamEffect( EFFECT *Effect ) ;					// CGtFNg`悷

extern s8 SetSteamEffectSize( EFFECT *Effect, f32 Size ) ;		// C̃TCY𒲐

#endif