///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectString
//
// YK7EffectString.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 03/13/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSTRING_H
#define __YK7EFFECTSTRING_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "./YK7String.h"
#include "./YK7Move.h"

// define ---------------------------------------

#define STR_MAXLENGTH	(128)		// ̍ő咷
#define STR_MAXNUM		(15)		// o镶̍ő吔

// datatype -------------------------------------

// GtFNgʃf[^
typedef struct tagSTRINGUNION
{
	YK7StrImage font ;			// C[Wf[^
	EFFECT *list[STR_MAXNUM] ;	// GtFNg̃Xg
	s32 num ;					// oĂ镶̐
	s32 con ;					// ޏoԌvpJE^
	u32 NowTime ;				// s
} STRINGUNION ;

// GtFNgf[^
typedef struct tagSTRINGEFFECT
{
	bool outflag ;				// ޏotO
	CMov pos ;					// W( x:0.0F~1.0F )
	char str[STR_MAXLENGTH] ;	// `悷镶
	u16 count ;					// JE^
	s8 mode ;					// 
	u32 color ;					// F
	f32 y ;						// W
	f32 movey ;					// ړׂ
	
	f32 exX, exY ;				// g嗦
} STRINGEFFECT ;

// prototype ------------------------------------

extern s8 InitStringData( void ) ;			// GtFNg̋ʃf[^
extern s8 CheckStringData( void ) ;			// GtFNg̏풓f[^̓ǂݍ݊𒲂ׂ( TRUE: FALSE:܂ )
extern s8 EndStringData( void ) ;			// GtFNg̋ʃf[^n

extern EFFECT *CreateStringEffect( 	char *string,
									u32 color = 0xffffffff,	// F
									f32 exX = 1.0F, f32 exY = 1.0F,
									s32 Priority = 2000 ) ;	// GtFNg쐬
extern s8 ReleaseStringEffect( EFFECT *Effect ) ;						// GtFNǧns
extern s8 MoveStringEffect( EFFECT *Effect ) ;							// GtFNgPt[
extern s8 DrawStringEffect( EFFECT *Effect ) ;							// GtFNg`悷

#endif
