///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectTeleport
//
// YK7EffectTeleport.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 02/02/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTTELEPORT_H
#define __YK7EFFECTTELEPORT_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"

// define ---------------------------------------

#define TELEPOBJ_MAXNUM		30

// datatype -------------------------------------

// e|[gGtFNgʃf[^
typedef struct tagTELEPORTUNION
{
	u8 Dummy ;
} TELEPORTUNION ;

// e|[gGtFNgIuWFNgf[^
typedef struct tagTELEPORTOBJECT
{
	f32 Width ;				// a
	f32 Height ;			// 
	f32 mHeight ;			// ڕW̍
	f32 MaxHeight ;			// ő̍
	f32 a ;					// At@l
	f32 ma ;				// ڕW̃At@l
	f32 SinCounter ;		// TCJE^[
	f32 SinSpeed ;			// TC̑x
	u16 Wait ;				// 쓮܂ł̎
	u8 ScaleExFlag ;		// Q{̃XP[ڎwĂ邩tO
} TELEPORTOBJECT ;

// e|[gGtFNgf[^
typedef struct tagTELEPORTEFFECT
{
	u8 DeleteCounter ;						// 폜JE^[

	Vec Pos ;								// W
	s32 TexNumber ;							// gpeNX`io[
	TELEPORTOBJECT Obj[TELEPOBJ_MAXNUM] ;	// e|[g̃IuWFNg

	f32 Width ;								// ŏ̕
	f32 Height ;							// ő̍

	f32 MaxSinSpeed, MinSinSpeed ;			// TCXs[h̍ŏlƍől

	GXColor Color ;							// F
	f32 mHyouSpeed ;						// ڕW̒lɋ߂Â	
	f32 HeightSubRate ;						// Ƃɍ闦
	u8 ScaleExFlag ;						// Q{̃XP[ڎwĂ邩tO
} TELEPORTEFFECT ;

// e|[gGtFNgf[^p\
typedef struct tagTELEPORTEFFECTTASKPARAM
{
	Vec Pos ;								// GtFNg̒SW
	s32 TexNumber ;							// gpeNX`io[

	f32 Width ;								// ŏ̕
	f32 Height ;							// ő̍

	f32 MaxSinSpeed, MinSinSpeed ;			// TCXs[h̍ŏlƍől

	f32 mHyouSpeed ;						// ڕW̒lɋ߂Â	
	f32 HeightSubRate ;						// Ƃɍ闦

	GXColor Color ;							// F
} TELEPORTEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitTeleportData( void ) ;			// e|[gGtFNg̋ʃf[^
extern s8 CheckTeleportData( void ) ;			// e|[gGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndTeleportData( void ) ;			// e|[gGtFNg̋ʃf[^n

extern EFFECT *CreateTeleportEffect(
					Vec Pos,								// GtFNg̒SW
					s32 TexNumber,							// gpeNX`io[

					f32 Width,								// ŏ̕
					f32 Height,								// ő̍

					f32 MaxSinSpeed, f32 MinSinSpeed,		// TCXs[h̍ŏlƍől

					f32 mHyouSpeed,							// ڕW̒lɋ߂Â	
					f32 HeightSubRate,						// Ƃɍ闦
					
					GXColor Color,							// F

					s32 Priority = -1 ) ;							// e|[gGtFNg쐬
extern s8 ReleaseTeleportEffect( EFFECT *Effect ) ;					// e|[gGtFNǧns
extern s8 MoveTeleportEffect( EFFECT *Effect ) ;					// e|[gGtFNgPt[
extern s8 DrawTeleportEffect( EFFECT *Effect ) ;					// e|[gGtFNg`悷

extern s8 DelReqTeleportEffect( EFFECT *Effect ) ;					// 폜NGXgs
extern s8 SetTeleportEffectRenderFlag( s8 Flag, EFFECT *Effect, s8 ScaleExFlag = TRUE ) ;	// `tOZbg

#endif