///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectVLoss
//
// YK7EffectVLoss.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/03/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTVLoss_H
#define __YK7EFFECTVLoss_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"

// define ---------------------------------------

// datatype -------------------------------------

#if 0
/*
// uGtFNgʃf[^
typedef struct tagVLOSSUNION
{
	TEXTURE TestTex ;		// eXgeNX`
} VLOSSUNION ;

// IuWFNgf[^
typedef struct tagVLOSSOBJ
{
	Vec Point ;
	Vec Speed ;
} VLOSSOBJ ;

// uGtFNgf[^
typedef struct tagVLOSSEFFECT
{
	BASICMESH *BasMesh ;	// ȈՃbVf[^
	MESH *Mesh ;			// bVf[^
	Vec Point ;				// {W
	u32 Counter ;			// JE^[

//	VLOSSOBJ *Object ;		// eIuWFNg̍W
//	u32 ObjectNum ;			// IuWFNg̐
//	f32 YukaHeight ;		// ̍
} VLOSSEFFECT ;

// uGtFNg^XNɓnf[^
typedef struct tagVLOSSEFFECTTACKPARAM
{
	HSD_PObj *PObj ;		// v~eBuIuWFNg
	Vec Point ;				// W
	f32 YukaHeight ;		// ̍
} VLOSSEFFECTTASKPARAM ;
*/
#else


// uGtFNgʃf[^
typedef struct tagVLOSSUNION
{
	u8 Dummy ;
} VLOSSUNION ;

// uGtFNgf[^
typedef struct tagVLOSSEFFECT
{
	u8 Dummy ;
} VLOSSEFFECT ;

// uGtFNg^XNɓnf[^
typedef struct tagVLOSSEFFECTTACKPARAM
{
	HSD_JObj *JObj ;		// 镔ʂ HSD_JObj 
	Vec Direction ;			// 
	f32 Power ;				// ̐
	f32 YukaY ;				// ̍(yWl)
	u16 BloodNum ;			// юUl̗ʁB(P`Rʂ育낾Ǝv܂)
	u8 Wait ;
	u8 BloodTexNumber ;		// eNX`io[
} VLOSSEFFECTTASKPARAM ;

#endif

// prototype ------------------------------------

extern s8 InitVLossData( void ) ;				// uGtFNg̋ʃf[^
extern s8 CheckVLossData( void ) ;				// uGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndVLossData( void ) ;				// uGtFNg̋ʃf[^n

//extern void VLossEffectTask( ghmGcTask *pTask ) ;				// uGtFNg^XN

//extern EFFECT *CreateVLossEffect( HSD_PObj *PObj, Vec Point, f32 YukaHeight, s32 Priority = 100 ) ;	// uGtFNg쐬
extern EFFECT *CreateVLossEffect( WK7JObj *JObj, Vec Direction, f32 Power, f32 YukaY
									,u16 BloodNum, u8 Wait = 0,
									u8 ConveFlag = FALSE, u8 ConveWaitTime = 10, f32 ConvePower = 1.0F,
									u8 BloodTexNumber = 0, s32 Priority = -130 ) ;	// uGtFNg쐬
extern s8 ReleaseVLossEffect( EFFECT *Effect ) ;							// uGtFNǧns
extern s8 MoveVLossEffect( EFFECT *Effect ) ;								// uGtFNgPt[
extern s8 DrawVLossEffect( EFFECT *Effect ) ;								// uGtFNg`悷

#endif