///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectVapor
//
// YK7EffectVapor.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/24/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTVAPOR_H
#define __YK7EFFECTVAPOR_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"

// define ---------------------------------------

// ݒς݃p[^hc
enum
{
	VP_775M01 = 0,		// 775M01 p
	VP_775M02 = 1,		// 775M02 p
} ;

// datatype -------------------------------------

// CGtFNgʃf[^
typedef struct tagVAPORUNION
{
	u8 dummy ;
} VAPORUNION ;

// CGtFNgIuWFNgf[^
typedef struct tagVAPOROBJECT
{
	u8 validf ;
	Vec pos ;
	Vec speed ;
	f32 size, rot ;
	f32 alpha ;
} VAPOROBJECT ;

// CGtFNgf[^
typedef struct tagVAPOREFFECT
{
	VAPOROBJECT *obj ;
	s32 objnum ;
	s32 objmaxnum ;

	WK7JObj *JObj ;
	Vec pos, dir ;		// JObj Ȃꍇ
	f32 speed ;
	f32 air ;
	f32 maxsize, minsize ;
	f32 sizespeed ;
	f32 rotspeed ;
	f32 rotrange ;
	u32 color ;
	f32 initalpha ;
	f32 fadespeed ;
	
	f32 crerate ;
	f32 crecounter ;

	u32 outtime ;
	u32 stoptime ;
	
	s32 mod, con ;
	s32 soundid ;
} VAPOREFFECT ;

// prototype ------------------------------------

extern s8 InitVaporData( void ) ;			// CGtFNg̋ʃf[^
extern s8 CheckVaporData( void ) ;			// CGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndVaporData( void ) ;			// CGtFNg̋ʃf[^n

extern EFFECT *CreateVaporEffect(
								u8 type,								// ^Cv( 0:775M01p  1:775M02p )
								WK7JObj *JObj,
								Vec *pos = NULL, Vec *dir = NULL,		// JObj Ȃꍇ
								s32 Priority = -130 ) ;					// CGtFNg쐬

extern EFFECT *CreateVaporEffect(
								s32 objmaxnum,
								f32 crerate,
								
								WK7JObj *JObj,
								Vec *pos, Vec *dir,		// JObj Ȃꍇ
								f32 speed,
								f32 air,
								f32 maxsize, f32 minsize,
								f32 sizespeed,
								f32 rotspeed,
								f32 rotrange,
								u32 color,
								s32 drawtime,
								f32 fadespeed,
								u32 outtime,
								u32 stoptime,
								
								s32 soundid,
								s32 Priority = -130 ) ;			// CGtFNg쐬

extern s8 ReleaseVaporEffect( EFFECT *Effect ) ;						// CGtFNǧns
extern s8 MoveVaporEffect( EFFECT *Effect ) ;							// CGtFNgPt[
extern s8 DrawVaporEffect( EFFECT *Effect ) ;							// CGtFNg`悷

#endif

