///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectWave
//
// YK7EffectWave.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/11/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTWAVE_H
#define __YK7EFFECTWAVE_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// gGtFNgʃf[^
typedef struct tagWAVEUNION
{
	u8 Dummy ;
} WAVEUNION ;

// gGtFNgf[^
typedef struct tagWAVEEFFECT
{
	Vec Point ;					// ʂւ܂RcW
	f32 Height ;				// g̍
	f32 SubAcceHeight ;			// g̍̌x
	f32 Length ;				// g̒
	f32 SubAcceLength ;			// g̒̌x
	f32 Speed ;					// g̑x
	f32 SubAcceSpeed ;			// g̑x̌x
	f32 r ;						// g̔a
	
	u8 SubBlendFlag ;			// ZtO
	GXColor SubColor ;			// ZJ[
} WAVEEFFECT ;

// gGtFNgf[^p\
typedef struct tagWAVEEFFECTTASKPARAM
{
	Vec Point ;					// ʂւ܂RcW
	f32 Height ;				// g̍
	f32 SubAcceHeight ;			// g̍̌x
	f32 Length ;				// g̒
	f32 SubAcceLength ;			// g̒̌x
	f32 Speed ;					// g̑x
	f32 SubAcceSpeed ;			// g̑x̌x
	
	u8 SubBlendFlag ;			// ZtO
	GXColor SubColor ;			// ZJ[
} WAVEEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitWaveData( void ) ;			// gGtFNg̋ʃf[^
extern s8 CheckWaveData( void ) ;			// gGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndWaveData( void ) ;				// gGtFNg̋ʃf[^n

extern EFFECT *CreateWaveEffect( Vec Point, f32 Height,	f32 SubAcceHeight,	f32 Length, f32 SubAcceLength,
									f32 Speed, f32 SubAcceSpeed, u8 SubBlendFlag, GXColor SubColor, s32 Priority = 2000 ) ;// gGtFNg쐬
extern s8 ReleaseWaveEffect( EFFECT *Effect ) ;											// gGtFNǧns
extern s8 MoveWaveEffect( EFFECT *Effect ) ;											// gGtFNgPt[
extern s8 DrawWaveEffect( EFFECT *Effect ) ;											// gGtFNg`悷

#endif