// =============================================================================
//
//	t@Cǂݍ݃NX
//
//	YK7File.h
//
//	Creator			: Takumi Yamada(GHM)
//	Creation Date	: 04/26/04
//
// =============================================================================

// dCN[hh~p`
#ifndef __YK7FILE
#define __YK7FILE

// include --------------------------------------
#include "../Lib/ghmGcFile.h"
#include "../Lib/ghmGcTask.h"
#include "../Lib/ghmGcResLink.h"

// define ---------------------------------------

#define YK7FILE_DEFAULT_ONESIZE		(1024 * 1024)

// data type ------------------------------------

// class ----------------------------------------

// t@CANZXNX
class YK7File
{
public :
	enum STATE
	{
		ST_READ = 0,		// ǂݍݒ
		ST_CLOSE = 1,		// t@C
		ST_IDLE = 2,		// ĂȂ
		ST_NOOPEN = 3,		// t@CJĂȂ
	} ;
	
private :
	
	STATE		State ;			// 

	void 		*DestBuf ;		// ǂݍݎɎgpǍobt@
	int 		StartOffset ;	// JnItZbg
	int 		CompLength ;	// ǂݍݏITCY
	int 		DestLength ;	// ǂݍޑŜ̃TCY
	
	unsigned int FileSize ;		// t@C̃TCY

	int 		OneLength ;		// ɓǂݍƂTCY
	ghmGcFile 	*CFile ;		// t@CǂݍݗpNX	
	ghmGcTask	*CTask ;		// t[vZXĂԃ^XÑ|C^

public :

	YK7File( int OneLength = -1 )
	{ Init( OneLength ) ; }
	virtual ~YK7File(){ Close() ; }

/*
	inline void Init( int OneLength = -1 )
	{
		State = ST_NOOPEN ;
		this->OneLength = OneLength == -1 ? YK7FILE_DEFAULT_ONESIZE : OneLength ;
	}
*/
	inline void Init( int OneLength = -1 )
	{
		State = ST_NOOPEN ;
		this->OneLength = OneLength ;
	}

	bool Open( char *Path ) ;								// t@CJ
	inline unsigned int GetLength( void ){ return FileSize ; }		// TCY擾
	bool Read( void *Buffer, int Offset, int Length ) ;		// t@Cǂݍ
	bool Cancel( bool sync = false ) ;						// ǂݍ݃LZ
	bool Close( bool sync = false ) ;						// t@C
	inline bool CloseB( void ){ return Close( true ) ;} 	// t@C(^)
	
	bool Process( void ) ;									// t[vZX
	inline bool FrameProcess( void ){ return Process() ; }

	STATE GetState( void ) ;								// Ԃ擾
} ;

// \[XNNX
class YK7ResLink
{
public :
	enum STATE
	{
		ST_NOOPEN = 0,			// ĂȂ
		ST_READ = 1,			// ǂݍݒ
		ST_IDLE = 2,			// ǂݍݏI
		ST_ERROR = 3,			// G[
	} ;

private :

	void 			*buffer ;		// obt@
	ghmGcResLink 	*reslink ;		// \[XNNX
	YK7File 		*file ;			// t@CNX
	
	u32 			size ;			// \[XNt@C̃TCY
	STATE			state ;			// 
	s32				mod ;			// Ԑ

	bool FrameProcess( void ) ;		// t[vZX

public :

	YK7ResLink()
	{
		buffer = NULL ;
		reslink = NULL ;
		file = NULL ;
		size = 0 ;
		state = ST_NOOPEN ;
	}
	virtual ~YK7ResLink(){ Release() ; }
	
	bool Read( char *Path ) ;											// t@Cǂݍ
	inline STATE GetState( void ){ FrameProcess() ; return state ; }	// Ԃ擾
	bool Release( void ) ;												// f[^

	inline ghmGcResLink *GetGroup( void ){ return reslink ; }	// \[XNNX̃|C^擾
} ;



#endif

