////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Test Task
//
// YK7TestTask.h
//
// Creator       : Takumi Yamada(GHM)
// Creation Date : 04/24/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__YK7TESTTASK_H__
#define	__YK7TESTTASK_H__

#include "..\Lib\ghmGcAppTask.h"
#include "..\Lib\ghmGcMem.h"
#include "..\Lib\ghmGcFile.h"
#include "../Wat/WK7MainTask.h"

// Jf[^
typedef struct tagCAMERA
{
	f32 Length, ARot, BRot ;
	Vec Lock ;
	Vec Up ;
	HSD_CObj *CObj ;
} CAMERA ;

CAMERA *GetCamera( void ) ;
extern void CameraInit( void ) ;													// J̏
extern void CameraSet( Vec Lock, f32 Length, f32 ARot, f32 BRot, Vec Up ) ;			// J̃Xe[^XZbg
extern void GetCameraPoint( Point3d *PointBuf ) ;									// J̍W𓾂
extern void CameraFlush( void ) ;													// J̃Xe[^XɃf[^JIuWFNg̏ԂtbV
extern void CameraMove( void ) ;													// J̑

class YK7TestTask : public ghmGcAppTask{
protected:
public:
	YK7TestTask(ghmGcApp *pApp,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~YK7TestTask();
	
	// R[obN
	virtual bool InitializeCallBack(void);
	
	// t[
	virtual bool FrameProcess(void);
	
	// IR[obN
	virtual bool TerminateCallBack(void);
	
	// _O
	virtual bool RenderProcess(void);
};

#endif	//__YK7TESTTASK_H__

