#ifndef ___C_BACKLIGHT_H___
#define ___C_BACKLIGHT_H___

//#include "common.h"
#include "c_vec.h"
#define BACKLIGHT (C_BackLight::GetInstance())
class C_BackLight{
 public:
  static C_BackLight &GetInstance( void );
  C_BackLight( void );
  void Set( HSD_JObj *jobj, f32 _intensity, HSD_LObj *lobj=0, HSD_TObjDesc *tobj_desc=0 );
  void Clear( HSD_JObj *jobj );
 protected:
 private:
  static C_BackLight *instance;
  bool manual;
  void _Clear( HSD_JObj *_jobj );
  void _Set( HSD_JObj *_jobj, f32 _intensity, 
			 C_Vec &_pos, C_Vec &_dir, f32 _ang, HSD_TObjDesc *_tobj_desc );
};
#endif
