#ifndef ___C_CYCLIC_H___
#define ___C_CYCLIC_H___

class C_Cyclic{
  public:
	C_Cyclic( s32 m0, s32 m1 ){
		num = _min = m0;
		_max = m1;
	}
	s32 operator++( void ){
		if( ++num >= _max  ) num = _min;
		return num;
	}
	s32 operator--( void ){
		if( --num < _min  ) num = _max-1;
		return num;
	}
	s32 operator=( int n ){
		num = n;
		if( num >= _max ) num = _max-1;
		if( num < _min ) num = _min;
		return num;
	}
	operator s32(){ return (s32)num; }
	operator u32(){ return (u32)num; }

	void ChangeMax( s32 m0 ){
		_max = m0;
		this->operator=( num );
	}
  private:
	s32 num,_min,_max;
};
#endif
