#ifndef ___C_JOBJ_H___
#define ___C_JOBJ_H___

//#include "common.h"
#include "c_scenedesc.h"

//sysdolphinjobj̃bp[B
//
class C_JObj{
 public:
  //RXgN^
  //
  C_JObj(C_ModelSet* ms) : model_set(ms){
	jobj = HSD_JObjLoadJoint(model_set->joint);
  }
  C_JObj() : model_set(0){ jobj = HSD_JObjAlloc(); }

  //fXgN^
  //
  virtual ~C_JObj(){	if(jobj) HSD_JObjUnref(jobj); }

  //OňĂB
  //
  HSD_JObj* GetJObj(const char* name = 0) const;
  HSD_DObj* GetDObj(const char* name) const;

  //擪JointƂĂB
  //
  const HSD_Joint* GetJoint() const { return model_set->GetJoint(); }

  //ANV̐B
  //
  u32 GetActionNum() const { return model_set->GetActionNum(); }

  //ANVwB
  //
  void SetAction(const char* name);
  void SetAction(u32 no);

  //Đ[gB
  //
  void SetRate(f32 rate){
	HSD_ForeachAnim(jobj, JOBJ_TYPE, ALL_TYPE_BITS
					, (HSD_ForeachFunc)HSD_AObjSetRate, AOBJ_ARG_AF, rate);
  }
  //Đt[B
  //
  void SetCurrentFrame(f32 time){
	HSD_ForeachAnim(jobj, JOBJ_TYPE, ALL_TYPE_BITS
					, (HSD_ForeachFunc)HSD_AObjSetCurrentFrame, AOBJ_ARG_AF, time);
  }

  //ԏ̍sԂB
  //
  MtxPtr GetMatrixPtr( void ){
	HSD_JObjSetupMatrix(jobj);
	return jobj->mtx;
  }

  virtual void Proc(){ HSD_JObjAnimAll(jobj); }
  virtual void Disp();
 private:
  HSD_JObj*	jobj;
  C_ModelSet*	model_set;
};

#endif

	
