#ifndef ___C_SCENEDESC_H___
#define ___C_SCENEDESC_H___

//#include "common.h"
//sysdolphinscene.h̃bp[B
//sysdolphiñRo[^[̏o͂A
//ɐH킹鎖ŁAɊ܂܂A
//fACgAJAtHÔS̃f[^A
//C̃|C^̌`ŃANZXłB
//%SYSDOLPHIN_ROOT%/include/sysdolphin/scene.h QƁB

//ÃCCQ͖ߍ񂾖O,
//eIuWFNgB
inline const char* _GetDescName( char** d )
{
  return (d[-1]) ? d[-1] : "";
}
inline const char* GetDescName(const HSD_Joint* desc)
{
  return _GetDescName( (char**)desc );
}
inline const char* GetDescName(const HSD_AnimJoint* desc)
{
  return _GetDescName( (char**)desc );
}
inline const char* GetDescName(const HSD_DObjDesc* desc)
{
  return _GetDescName( (char**)desc );
}
inline const char* GetDescName(const HSD_CameraAnim* desc)
{
  return _GetDescName( (char**)desc );
}
inline const char* GetDescName(const HSD_LightDesc* desc)
{
  return _GetDescName( (char**)desc );
}
inline const char* GetDescName(const HSD_LightAnim* desc)
{
  return _GetDescName( (char**)desc );
}
inline const char* GetDescName(const HSD_FogAnim* desc)
{
  return _GetDescName( (char**)desc );
}

//f
class C_ModelSet : public HSD_SceneModelSet{
 public:
  HSD_Joint* GetJoint() const { return joint; }

  //ANV̐B
  u32 GetActionNum() const;
  //Aj[Vf[^B
  void GetAction(const char* name, HSD_AnimJoint*& aj
				 , HSD_MatAnimJoint*& mj, HSD_ShapeAnimJoint*& sj) const;
  void GetAction(u32 no, HSD_AnimJoint*& aj
				 , HSD_MatAnimJoint*& mj, HSD_ShapeAnimJoint*& sj) const;
  //DObj( mobjpobj܂Ƃ߂́j𖼑OňB
  HSD_DObjDesc* GetDObjDesc(const char* name) const{
	return GetJointDObjDesc(GetJoint(), name);
  }

  void* operator new(u32, void* p){ return p; }
 private:

  //zu`ȊOnewȂB
  void* operator new( size_t );
  HSD_DObjDesc* GetJointDObjDesc(HSD_Joint* joint, const char* name) const;
};

//J
class C_CameraSet : public HSD_SceneCameraSet{
 public:
  //--- CameraDesc߂ ---
  HSD_CameraDesc* GetCameraDesc() const { return camdesc; }

  //--- Action߂ ---
  u32 GetActionNum() const;

  //--- Action߂ ---
  HSD_CameraAnim* GetAction(const char* name) const;
  HSD_CameraAnim* GetAction(u32 no) const { return camanimlist[no]; }		

  //--- zu`new ---
  void* operator new(u32, void* p){ return p; }
 private:
  //zu`ȊOnewȂB
  void* operator new( size_t );
};

//Cg
class C_LightSet : public HSD_SceneLightSet{
 public:
  //--- LightDesc߂ ---
  HSD_LightDesc* GetLightDesc() const { return lightdesc; }

  //--- Action߂ ---
  u32 GetActionNum() const;

  //--- Action߂ ---
  HSD_LightAnim* GetAction(const char* name) const;
  HSD_LightAnim* GetAction(u32 no) const { return lightanimlist[no]; }

  //--- zu`new ---
  void* operator new(u32, void* p){ return p; }
 private:
  //zu`ȊOnewȂB
  void* operator new( size_t );
};

//tHO
class C_FogSet : public HSD_SceneFogSet {
 public:
  //--- FogDesc߂ ---
  HSD_FogDesc* GetFogDesc() const { return desc; }

  //--- Action߂ ---
  u32 GetActionNum() const;

  //--- Action߂ ---
  HSD_FogAnim* GetAction(const char* name) const;
  HSD_FogAnim* GetAction(u32 no) const { return animlist[no]; }

  //--- zu`new ---
  void* operator new(u32, void* p){ return p; }
 private:
  //zu`ȊOnewȂB
  void* operator new( size_t );
};

//4Zbgɂ́B
class C_SceneDesc : public HSD_SceneDesc{
 public:
  //ModelSetB
  u32 GetModelSetNum() const;

  //ModelSet擾B
  C_ModelSet* GetModelSet(const char* name) const;
  C_ModelSet* GetModelSet(u32 no) const {
	if(models == 0 || models[no] == 0)	return 0;
	return new (models[no]) C_ModelSet;
  }

  //CameraSet擾
  C_CameraSet* GetCameraSet() const {
	if(camera == 0)	return 0;
	return new (camera) C_CameraSet;
  }

  //CgZbg̐B
  u32 GetLightSetNum() const;

  //CgZbg擾B
  C_LightSet* GetLightSet(const char* name) const;
  C_LightSet* GetLightSet(u32 no) const {
	if(lights == 0 && lights[no] == 0)	return 0;
	return new (lights[no]) C_LightSet;
  }

  //tHOZbg擾B
  C_FogSet* GetFogSet() const {
	if(fog == 0)	return 0;
	return new (fog) C_FogSet;
  }
  void Print( void ) const;
  void* operator new(u32, void* p);

 private:
  //zu`ȊOnewȂB
  void* operator new( size_t );
  void PrintJoint(HSD_Joint* joint, int nest, bool* node) const;

};
#endif
