////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmAKN.h
//
// Creator       : Kawa
// Creation Date : 10/06/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMAKN_H__
#define	__ENMAKN_H__

#include "..\Wat\WK7Enemy.h"
#include "EnmBoss.h"
#include "..\Yam\YK7EffectHeader.h"
#include "..\Wat\WK7Model.h"
#include "..\Wat\WK7Stage.h"
#include "..\Yam\YK7EffectShot.h"

class K7EnmAKN : public K7EnmBoss{
protected:
	void		Dummy( void );
	u32			mInitProcess;				// ǂݍ݃Xe[^Xp
	WK7Model 	*mpGun;						// ef
//	s16			mSecondShotTiming;			// Qڂ̃^C~O
//	s16			mBulletNow;					// e
	s16			mPcDamageSetCount;			// obɃ_[W^JE^
	s16			mShotDamage;				// ëЗ
	
	s16			mShotCount;					// ˌĂ鎞 +ˌ -ˌҋ@
	u32			mBattleCount;				// og̎
	u32			mBattleProcess;				// og̊Ǘ
	int 		mBatteleExit;				// og̏I}
	s16			mMuteki;					// _[Wǂh~p̖G
	
	u32			mMoveProcess;				// sp^[tO
	f32			mRunSpeed;					// Xs[h
	f32			mBoost;						// [g
	f32			mBoostMax;					// [gő
	
	Vec			mStartPos;					// X^[gʒu̕ۑ
	Vec			mEndPos;					// 点I_ʒu
	f32			mGoDir;						// 点
	
	s32			mMuzzlecon ;				// }YtbVo^C~ÕJE^
	bool		mShotflag ;					// Vbg邩ǂ̃tO
	f32			mShotbias ;					// Vbĝxɑ΂oCAXl
	s16			mMuzzleWaitCon ;			// }YtbV̊ԊuJE^
	EFFECT		*mpMuz;						// }ỸGtFNg
	WK7RenderObjEffect *mShotEfc;			// VbgGtFNg
	u32			mMuzid;						// }Ŷhc
	s32			pdamagecon ;				// vC[̃_[WJE^
	s32			pdamagetime ;				// vC[̃_[WHẴt[
	s32			pdamagetime2 ;				// vC[̃_[WHẴLZȂł̃t[
	
	bool 		mValidAlpha;				// LtO
	bool		mAlphaInitflag;				// tO
	C_SetAlpha	*bodyalpha;					// ̗pNX
	C_SetAlpha	*gunalpha;					// epNX
	f32			mNowAlpha;					// ݂̃At@l
	f32			mTargetAlpha;				// ̑xiڕW
	f32			mAlphaSpeed;				// ̑x
	bool		mHideflag;					// ȂȂ邩AtO
	
	s16			mRunPointPtr; 				// AJlɌꏊ̃|C^
	
	void		PcDamageSet(void);
	
	void		Cmd_ResetSet(void);
	bool		Cmd_RunSet(Vec goPos);
	
	bool		PcHitTest(void);
	void		AKN_Dmg(void);
	bool		AKN_Run(void);
	void		DieMotSet(void);

	void		RunLogicSet(u32 time);
	
	void		Release(void);
	void		DetachGun(void);
	
	void 		AiTest_NestShot(void);

	void 		ShotStart( f32 bias );
	void 		ShotEnd( void );
	void 		ShotProc( void );
	
	void 		CreateMuzzle( void );
	void 		DeleteMuzzle( void );
	void 		PlayDamageCheck( void );
	void 		PlayDamageInc( void );
	void 		PlayDamageProc( void );
	
	void 		AlphaProc(void);
	void 		AlphaValidflag(bool flag);
	void 		AlphaInit(void);
	void 		AlphaEnd(void);
	void 		SetAlpha(bool disp, f32 speed);
	
	f32 		LgtDistRate(void);
	bool 		AknDamageTest(void);
	
	WK7Model	 *GetModel(void);
	
	static s8 PlayDamageCallBack( SHOTOBJECT *obj, void *data ) ; // vC[̃_[W̃R[obN
	
public:
	K7EnmAKN(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio=WK7OBJ_DEFAULT_PRIO);
	~K7EnmAKN();
	
	static	int	mAKNBattleStart;
	
	bool	FrameProcess(void);
	bool	ControlProcess(void);
	

	void	StageProc(WK7Stage *pCurrentStage);
	int		AKNBossEnd(void);
	void 	VisibleTest(void);
	bool 	PlayCommonMotionAKN(u32 id, bool loop, bool hokan, f32 sframe=0.0f, f32 speed=1.f);
	
};


#ifdef	__ENMAKN_CPP__

//#define AKN_HP				(150)			// AJlgo
#define AKN_GUN_BULLET_MAX	(12*2)			// e
#define AKN_GUN_DAMAGE		(10)			// e

#define GUN_R				GUN_MP5ARFL_R

#define SECOND_SHOT_FRAME	(10)

#define DOOR_OPEN_FRAME		(WK7_SEC_TO_FRAME(5))

#define CALL_INIT			(0)
#define CALL_MOVE			(1)
#define CALL_WAIT			(2)


#define RUNPOINT_MAX	(4)
Vec AKN_MovePoint[RUNPOINT_MAX] = {
	{303.f,		0.f, 	280.f},
	{-303.f,	0.f, 	280.f},
	{-303.f,	0.f, 	-280.f},
	{303.f,		0.f, 	-280.f},
};

#define POSSORT_MAX (9)
Vec AKN_LightPoint[POSSORT_MAX] = {
	{303.f,		0.f, 	280.f},
	{-303.f,	0.f, 	280.f},
	{-303.f,	0.f, 	-280.f},
	{303.f,		0.f, 	-280.f},
	{-0.694f, 0.f, 306.734f},
	{-300.156f, 0.f, 7.229f},
	{-0.242f, 0.f, -292.521f},
	{299.189f, 0.f, 8.084f},
	{-0.722f, 0.f, 7.305f},
};




enum AKN_MOT{
	AKN_MOT_WAIT = 0,		// R
	AKN_MOT_RUN,			// 
	AKN_MOT_SHOTDASHR,		// ˌR
	AKN_MOT_SHOTDASHL,		// ˌL
	AKN_MOT_TURN,			// ^[
	AKN_MOT_DAM,			// _[W
	AKN_MOT_DIE,			// S
	AKN_MOT_MAX
};

s16 MotionIDTableAKN[] = {
	20,				// R
	90,				// 
	91,				// ˌR
	92,				// ˌL
	140,			// ^[
	150,			// _[W
	310,			// S
	-1
};


//	#define SFX_BT_HS_AKNUGI_MAX	(4)
//	static int damageSeTbl[SFX_BT_HS_AKNUGI_MAX] = {
//		SFX_BOSS_AKN_GRUNTS0,
//		SFX_BOSS_AKN_GRUNTS1,
//		SFX_BOSS_AKN_GRUNTS2,
//		SFX_BOSS_AKN_GRUNTS3
//	};

#else


#endif




#endif	//__ENMAKN_H__

