
////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object {XFVg
//
// Enmang.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMANG_CPP__

#include "EnmANG.h"
#include "WK7Stage.h"
#include "..\Fujita\C_Vfx.h"
#include "..\Yam\YK7EffectFeather.h"

s16 MotionIDTableANG[] = {
	20,							// R
	30,							// S
	40,							//ĂB
	-1
};

#if 0
Rڂ̓VgiĂƂj

VgɃvC[UہALVoice_Ŗ炵ė~
Ƃ̎B

#define SFX_BOSS_KUNANGEL_R2242      ((21<<16) + 17)//Vg3 Us{CXuEtttttttv
#define SFX_BOSS_KUNANGEL_R2243      ((21<<16) + 18)//Vg3 Us{CXuoJ݂v
#define SFX_BOSS_KUNANGEL_R2244      ((21<<16) + 19)//Vg3 Us{CXuLALv
#define SFX_BOSS_KUNANGEL_R2245      ((21<<16) + 20)//Vg3 Us{CXůAfCv
#define SFX_BOSS_KUNANGEL_R2246      ((21<<16) + 21)//Vg3 Us{CXu~~~iC|jYv
#define SFX_BOSS_KUNANGEL_R2247      ((21<<16) + 22)//Vg3 U{CXuoHipjv
#endif

//  VgJn
//  
//  wɂS̃NE̊
//  NE̊тɊ炪ׂf܂
//  
//  4ڂ̊ƑVg͉HɂȂĊgUA
//  ̉H֑֋z܂f
//  
//  Cӈړ
//  
//  ƃn[}Ƀ`FWi]ʂj
//  
//  NE̕ɓ
//  
//  H̐ĂȂVg֎qɍĂf
//  Vgł͂Ȃł
//  
//  VgɌĂȂ
//  VgƃNElAuJGtFNgB
//  
//  w̃KXʂɉfĂVgƁAtbVAEgB
//  
//  NEƂ̃L

#define FEATHER 1
#define EASY 0

#define HOLE_PRE 10
#define HOLE_POST 40
#define HOLE_FRM (HOLE_PRE+HOLE_POST)

//H
#define PLAY_HIT_WING() gpSound->mPlaySE( SFX_BOSS_ANG_WINGBREAK )
//G
#define PLAY_DOWN1() gpSound->mPlaySE( SFX_BOSS_ANG_DOWN_A )
#define PLAY_DOWN2() gpSound->mPlaySE( SFX_BOSS_ANG_DOWN_B )
#define PLAY_DIRTY() gpSound->mPlaySE( (SFX_BOSS_KUNANGEL_R2242 + (HSD_Rand()%6)) )
static 
char *gNames[] = {"WING1", "WING2", "WING3", "WING4"};

K7EnmANG *K7EnmANG::instance = 0;

static
HSD_FogDesc gFogDesc = {
  GX_FOG_LIN,                                  /* fog type */
  NULL,                                        /* adjdesc */
  85.0f,                                        /* startz */
  (512.f + 1024.0f),                              /* endz */
  {255, 255, 255, 255},                         /* color */
};
void K7EnmANG::Dummy( void )
{
}
static GHMGCTASK_HANDLER( HitTask );
static GHMGCTASK_HANDLER( HitTask )
{
  bool *flg = (bool*)task_get_param(0);
  *flg = true;
  task_exit();
}

K7EnmANG::K7EnmANG(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) :
  K7EnmBoss( enemyid, suffix, pAnchor, prio, K7ANG, MotionIDTableANG )
{
  // Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go
	mData.mWeakID		= NPCWEAKOBJID_HEAD;				// _
	mData.mVLossID		= NPCWEAKOBJID_LFOOT;				// ʐѕ
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
	mData.mScale		= 1.f;								// 
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= mData.mWeakID;
	mData.mVLossIDBk	= mData.mVLossID;
  alive = true;
#if FEATHER
  yamada_effect[0]  =  yamada_effect[1]  = yamada_effect[2]  = 0;
#endif
  die_counter = 0;
  fog = HSD_FogLoadDesc(&gFogDesc);
  instance = this;
  for( int i=0; i<ANG_MAX_HIT; i++ ) wing_hit_obj[i] = 0;
  state.Init( ANG_STATE_NEUTRAL );
#if !EASY
  hit_counter = 0;
#else
  hit_counter = 3;
#endif
  MotPlayInit(NPC_POSMODE_PROG);
  game_state = ANG_GAME_STATE0;
  hole = 0;
  hole_alpha = 224;//eLg[ɈԂłȂB
  for( int i=0 ; i< ANG_MAX_HIT; i++ ){
	wing_hit_flg[i] = false;
  }
}

K7EnmANG::~K7EnmANG()
{
  if( hole ) delete hole;
  // HGtFNg̍폜˗
#if FEATHER
  for( int i=0; i<3; i++ ){
	if( yamada_effect[i] && GetEffectValidState( yamada_effect[i] ) ) ::DelReqEffect( yamada_effect[i] ) ;
	yamada_effect[i] = NULL;
  }
#endif
  for( int i=0; i<ANG_MAX_HIT; i++ )GHM_SAFE_DELETE( wing_hit_obj[i] );
  if( fog ){
	HSD_FogUnref( fog );
	fog = NULL;
  }
  instance = 0;
}
void K7EnmANG::AdditionalPreRenderProcess( void )
{
  if( game_state == ANG_GAME_STATE1 )  if( hole ) hole->Disp();
}
bool K7EnmANG::ControlProcess(void)
{
	if( mState==NPC_STATE_INIT ){ return WK7Npc::ControlProcess(); }
	if( GetNpcPause()==true ){ return true; }
	
#define MOTION_END( ) (GetCommonMotionState() == WK7MODEL_NOANIM)
#define MOTION_REWIND(  ) (GetCommonMotionState() == AOBJ_ANIM_REWINDED)
#define IS_MOTION( Y ) ((u32)(mot_id == Y))
#define PLAY( Y ) PlayCommonMotion( (u32)(mot_id = Y), false, false )
#define PLAY_INTRP( Y ) PlayCommonMotion( (u32)(mot_id = Y), false, true )
#define PLAY_LOOP( Y ) PlayCommonMotion( (u32)(mot_id = Y), true, false )
#define PLAY_LOOP_INTRP( Y ) PlayCommonMotion( (u32)(mot_id = Y), true, true )
#define PERCENT( X ) ((HSD_Rand()%101) > (100-X) )
#define MOT_FRAME( ) (  mpRootBone ? mpRootBone->GetCurrentMotionFrame() : 0 ) 
  WK7Model *pModel;

  if ( mpNpcChara==NULL ) 		return true;
  if ( true == IsLoading() ) 		return true;											// ǂݍݒ
  if( (pModel = mpNpcChara->GetModel())==0 ) return true;
  if ( mState == NPC_STATE_INIT ) goto NPC_CTRL_INIT_JUMP;
	
  if( GetNpcPause() ) return true;

  switch( mState ){
  case NPC_STATE_INIT:
  NPC_CTRL_INIT_JUMP:
  StateInit();
  break;
  case NPC_STATE_WAIT:
  case NPC_STATE_WALK:
  case NPC_STATE_RUN:
  case NPC_STATE_TURN:
  case NPC_STATE_ATK:
  case NPC_STATE_DMG:
  case NPC_STATE_DMG_FALL:
  case NPC_STATE_LOSS:
  case NPC_STATE_DIE:
  default:
	break;
  }
  
  switch( game_state ){
  case ANG_GAME_STATE0:
	return ControlProcess776();
  case ANG_GAME_STATE1:
	return ControlProcess707();
  case ANG_GAME_STATE2:{
	pModel->Hide();
	mpNpcChara->SetRenderFlag(false);
	mpNpcChara->SetVisible(false);
	return false;
  }break;
  default: break;
  }
  return false;
}
bool K7EnmANG::ControlProcess707(void)
{
  do{
	switch( (s32)state ){
	case ANG_STATE_NEUTRAL:
	  {
		switch( state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY_LOOP( ANG_MOT_SIT );
		}break;
		case PHASE_PROC:{
		  if( IS_MOTION( ANG_MOT_SIT ) ){
		  }else{
			PLAY_LOOP( ANG_MOT_SIT );
		  }
#if 0
		  for( int i=0 ; i< ANG_MAX_HIT; ++i ){
			HSD_JObjSetFlags( mpNpcChara->GetJObj(gNames[i])->GetJObj(), JOBJ_HIDDEN);
		  }
#endif
//		  OSReport( "%d\n", state.GetPhaseCounter() );
		  mpNpcChara->EnableVfxEffect();
		  if ( true == DamageTest() ){
		    if( !hole ){
			  hole = new C_Hole( mDamage.mpObjBone->GetJObj(), 
								 &mDamage.mDamDir,
								 mDamage.mDamPos.x, 
								 mDamage.mDamPos.y, 
								 mDamage.mDamPos.z, 2.0f, HOLE_PRE, HOLE_POST, hole_alpha );
			  mpNpcChara->mpAdditionalPreRender = this;
			  WK7RenderObj::GetVFX()->SetTargetAlpha( hole_alpha );
			  gpSound->mPlaySE( SFX_BOSS_ANGKUN_HIT_NODAMAGE );
			}
			mDamage.mDamHitRequest = 0;
		  }
		}break;
		case PHASE_DTOR:{
		}break;
		}
	  }break;
	default:
	  break;
	}
  }while( !state.Proc() );
  return false;
}

bool K7EnmANG::ControlProcess776(void)
{
  do{
	switch( (s32)state ){
	case ANG_STATE_NEUTRAL:
	  {
		switch( state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY_LOOP( ANG_MOT_NEUTRAL );
		}break;
		case PHASE_PROC:{
		  for( int i=0 ; i< ANG_MAX_HIT; ++i ){
			if( wing_hit_flg[i] ){
			  ++hit_counter;
			  HSD_JObjSetFlags( mpNpcChara->GetJObj(gNames[i])->GetJObj(), JOBJ_HIDDEN);
			  PLAY_HIT_WING();
#if FEATHER
			  if( yamada_effect[0] && GetEffectValidState( yamada_effect[0] ) ) ::DelReqEffect( yamada_effect[0] ) ;
			  yamada_effect[0] = 
				CreateFeatherEffect( VParam[ED_FEATHER][13], 
				 mPosition,
				 VParam[ED_FEATHER][7] * 0.05F, PI_2 * VParam[ED_FEATHER][8] / 360, 
				 (u8)VParam[ED_FEATHER][3], VParam[ED_FEATHER][4] * 0.1F, VParam[ED_FEATHER][5] * 0.01F,
				 (u8)VParam[ED_FEATHER][1], (u8)VParam[ED_FEATHER][2], VParam[ED_FEATHER][9] * 0.001F, 
				 VParam[ED_FEATHER][10] * 10.0F,	0, mpNpcChara->GetModel()->GetObj( "Root_joint" ), (s8)VParam[ED_FEATHER][14] ) ;
#endif
			}
		  }
		  if( hit_counter == 4 ) state = ANG_STATE_DAMAGE;
		}break;
		case PHASE_DTOR:{
		}break;
		}
	  }break;
	case ANG_STATE_DAMAGE:
	  {
		switch( state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY( ANG_MOT_DEAD );
		}break;
		case PHASE_PROC:{
			// SE炷
			f32 Frame = MOT_FRAME();
			switch( (s32)Frame ){
			case  70:	PLAY_DOWN1(); break;
			case 106:	PLAY_DOWN2(); break;
			default: break;
			}
			if( MOTION_END() ) state = ANG_STATE_DEAD;
		}break;
		case PHASE_DTOR:{
		}break;
		}
	  }break;
	case ANG_STATE_DEAD:
	  {
		switch( state.GetPhase() ){
		case PHASE_CTOR:{
		  if( alive ) alive = false;
		  mState = NPC_STATE_LOSS;
		  SetEnemyDieInfo(NPC_DIE_DIE);
		}break;
		case PHASE_PROC:{
		}break;
		case PHASE_DTOR:{
		}break;
		}
	  }break;
	default:
	  break;
	}

  }while( !state.Proc() );

  for( int i=0 ; i< ANG_MAX_HIT; i++ ){
	if( wing_hit_obj[i] ) wing_hit_obj[i]->SetEnable( true );
	wing_hit_flg[i] = false;
  }

  return false;
}


bool K7EnmANG::FrameProcess(void)
{
	MotionProcess();

  if( mpNpcChara!=NULL ){
		
	if( mpNpcChara->GetState()==WK7RenderObj::LOADED ){
			
	  if( hole ){
		s32 frm = hole->Proc();
		if( frm ){
		  f32 val = sinf( (f32)M_PI * (HOLE_FRM - frm) / (f32)HOLE_FRM )*0.5f;
		  WK7RenderObj::VFXSetIntensity( val );
		}else{
		  //ӂĂ
		  PLAY_DIRTY();
		  delete hole;
		  hole = 0;
		  mpNpcChara->mpAdditionalPreRender = 0;
		  WK7RenderObj::GetVFX()->SetTargetAlpha( -1 );
		  WK7RenderObj::VFXSetIntensity( 0.f );		  
		}
	  }
	  // [VXs[hRg[
	  MotionSpeedControl();
			
	  // ŏ̈ʒuZbg̎
	  if( !mFirstPosSet ){
			mFirstPosSet = 1;
	
			//̓͓ȂƓȂȂĂB040108
			mpNpcChara->SetVisible(true);
			mHideAlphaNow       = 1.0f;
	
			mpNpcChara->SetPosition(mPosition);
			// ꂪȂƑȂB
			switch( mpNpcChara->GetRenderID() ){
			case	WK7RENDEROBJ_INVALID_RENDERID:
			  //			case	WK7RENDEROBJ_RENDERID_MAX:
			case	WK7RENDEROBJ_RENDERID_DEFAULT:
			  mpNpcChara->AllocRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
			  OSReport( "ang %d\n", mpNpcChara->GetRenderID() );
			  //mpNpcChara->EnableVfxEffect();
			  break;
			default:
			  break;
			}
	
	
			//qbgIuWFNg쐬B
			for( int i=0; i<ANG_MAX_HIT; i++ ){
			  wing_hit_obj[i] = CreateHitObj( gNames[i] );
			  wing_hit_obj[i]->SetTaskHandler(HitTask);
			  wing_hit_obj[i]->SetTaskParam(0,(u32)&(wing_hit_flg[i] = false));
			}
	  }
	}
  }
	
  return true;
}



