////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object ʎY^Xs[hX}C
//
// EnmC.cpp		ftHgőĂ
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMC_CPP__

#include "EnmC.h"
#include "..\Wat\WK7EventScript.h"
#include "..\Wat\K7GlobalFlag.h"

#define MDLCODE_ID				(2)			// dmHQwww ́H̔ԍifj
#define MOTCODE_ID				(2)			// dmHQwww ́H̔ԍi[Vj

s16 npcTypeCMotionIdTable[] = {
	20,							// R
	50,							// 
	930,						// 
	0,							// ^[E
	0,							// ^[
	140,						// ^[
	60,							// UĂѓiNu쓮j
	420,						// 85cmɍU
	410,						// 150cmɍU
	150,						// _[WO
	160,						// _[W
	170,						// _[WO
	180,						// _[W
	190,						// _[WEO
	290,						// _[WE
	200,						// _[WO
	300,						// _[W
	210,						// _[WEgO
	220,						// _[WEg
	230,						// _[WgO
	240,						// _[Wg
	260,						// _[WӂƂу_EOiSj
	250,						// _[Wу_EiSj
	310,						// _[WE _E
	320,						// _[W _E
	330,						// _ER
	340,						// _E_[W
	350,						// _EȂ
	360,						// _EȂ瑖
	400,						// _E玀S
	440,						// _E85cmɍU
	430,						// _E150cmɍU
	0,							// [U[ōU
	0,							// [U[gro
	0,							// [U[grB
	0,							// ꎩR̂̂QiXs[hpj
	0,							// Xs[hX}CsJn
	0,							// Xs[hX}C
	500,						// ݍUi_j
	650,						// ݍUiRj
	450,						// ݍUiJGfj
	460,						// ݍUiR[ej
	470,						// ݍUi}XNj
	490,						// ݍUiPrj
	700,						// f
	0,							// f
	-1
};

// e[u
static int eneFootSeTbl[] = {
	SFX_BT_HS_FOOT_STEP00,
	SFX_BT_HS_FOOT_STEP01,
	SFX_BT_HS_FOOT_STEP02,
	SFX_BT_HS_FOOT_STEP03,
	SFX_BT_HS_FOOT_STEP04,
	SFX_BT_HS_FOOT_STEP05
};

// Ȃ΂e[u
static int eneLaughSeTbl[] = {
	SFX_BT_RHS_RUNA,
	SFX_BT_RHS_RUNB,
	SFX_BT_RHS_RUNC
};

K7EnmC::K7EnmC(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor,int prio) : WK7Enemy(enemyid,pAnchor,prio)
{
	// fǂݍ
	if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_HOPPER7) ){	// zbp[[h
		CreateModel (K7CHRID(K7ENMID(31),  0));
		mData.mHopper = 1;
	}else{
		CreateModel (K7CHRID(K7ENMID(MDLCODE_ID),  suffix));
	}
	
	// [Vǂݍ
	CreatePackMotion(npcTypeCMotionIdTable, MOTCODE_ID);
	
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go
//	mData.mWeakID		= NPCWEAKOBJID_WAIST;				// _

	// jO̎_͏㔼ĝ
	switch (rand()%3){
	case 0:
		mData.mWeakID	= NPCWEAKOBJID_LARM;
		break;
	case 1:
		mData.mWeakID	= NPCWEAKOBJID_RARM;
		break;
	default:
		mData.mWeakID	= NPCWEAKOBJID_HEAD;
	}
	
	mData.mVLossID		= NPCWEAKOBJID_RFOOT;				// ʐѕ
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP02;			// 
	mData.mScale		= 1.f;								// 
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= NPCWEAKOBJID_MAX;					// ăZbg_ł邱Ƃ̎w
	mData.mVLossIDBk	= mData.mVLossID;
	mData.mCounterKurai	= 1;
}

#define R_FOOT_TIMING	16
#define L_FOOT_TIMING	34

#define R_LAUGH_TIMING	12
#define L_LAUGH_TIMING	30

void K7EnmC::FootSeRun(Vec myPos)
{
	if(	(pCurrentChara()!=NULL)
	&&	(mData.mFootSe != 0)
	){
		WK7Model *pModel = pCurrentChara()->GetModel();
		if ((R_FOOT_TIMING  == GetCurrentMotionFrame())
		||	(L_FOOT_TIMING == GetCurrentMotionFrame())
		){
			gpSound->mPlaySE3D( (int )eneFootSeTbl[rand()%6], myPos, 0 );		// rdĐ
			if( R_FOOT_TIMING  == GetCurrentMotionFrame() ){
				FootPaintTestSet(NPCWEAKOBJID_RFOOT);
			}else{
				FootPaintTestSet(NPCWEAKOBJID_LFOOT);
			}
		}
		if ((R_LAUGH_TIMING  == GetCurrentMotionFrame())
		||	(L_LAUGH_TIMING == GetCurrentMotionFrame())
		){
			gpSound->mPlaySE3D( (int )eneLaughSeTbl[rand()%3], myPos, 0 );		// ΂
		}
	}
}


