////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmA.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMKIB_H__
#define	__ENMKIB_H__

#include "..\Wat\WK7Enemy.h"
#include "EnmBoss.h"
#include "EnmKRR.h"
class K7EnmKIB : public K7EnmBoss{
  friend class K7EnmKRR;
 private:
  static K7EnmKIB *instance;
 protected:
  void Dummy( void );
  WK7HitObjJObj *brain_hit_obj,*debri_hit_obj;
  bool brain_hit,debri_hit;
  HSD_JObj *head_jobj,*debri_jobj;
  u32 mot_id;
  s32 atk_counter;
  s32 AtkWait(void);
  bool IsHit(void);
 public:
  virtual bool IsMyRenderID( u32 id ,Vec *p );
  static K7EnmKIB *GetInstance( void );
  K7EnmKIB(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio=WK7OBJ_DEFAULT_PRIO);
  ~K7EnmKIB();
  bool FrameProcess(void);
  bool ControlProcess(void);
};

#endif	//__ENMKIB_H__

