////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmA.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMKUN_H__
#define	__ENMKUN_H__

#include "..\Wat\WK7Enemy.h"
#include "EnmBoss.h"
#include "..\fujita\c_hole.h"
#include "..\fujita\c_radialblur.h"
enum KUN_GAME_STATE{
  KUN_GAME_STATE0,	//ĂVǧɃoĂB
  KUN_GAME_STATE1	//̑OŎɂɂB
};
#define KUN (*K7EnmKUN::GetInstance())
class K7EnmKUN : public K7EnmBoss{
protected:
  static bool alive;
  static K7EnmKUN *instance;
  void Dummy( void );
  virtual ~K7EnmKUN();
  C_Hole *hole;
  C_RadialBlur *blur;
  C_Vec dam_pos;
  f32 save_intensity;
  u8 hole_alpha;
  s32 appear_count;
  HSD_Fog *fog;
  bool disp_start;
  EFFECT *yamada_effect;
  KUN_GAME_STATE game_state;
  s32 mot_id;
  s32 counter;
public:
  static K7EnmKUN *GetInstance( void ){ return instance; }
  static inline bool IsAlive( void ){return alive;}
  inline void SetAlive( void ){ alive = true;}
  static bool HitRightHand( Vec &pos );
  static bool IsAppeard(void);
  static Vec *GetHitPos(void);
  static void Start( void ){
	if( instance ) instance->disp_start = true;
  }
  static void StopHand(void){
	if( instance && instance->blur ){
	  delete instance->blur;
	  instance->blur = 0;
	}
  }
  K7EnmKUN(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio=WK7OBJ_DEFAULT_PRIO-2);
  void AdditionalPreRenderProcess( void );
  void AdditionalPostRenderProcess( void );
  bool FrameProcess(void);
  bool ControlProcess(void);
  inline void SetGameState( KUN_GAME_STATE s_ ){ game_state = s_;  }
};

#endif	//__ENMKUN_H__

