////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmP.cpp veNgX}C
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMP_CPP__

#include "EnmP.h"

#define MDLCODE_ID				(9)			// dmHQwww ́H̔ԍifj
#define MOTCODE_ID				(9)			// dmHQwww ́H̔ԍi[Vj

s16 npcTypePMotionIdTable[] = {
	20,							// R
	50,							// 
	0,							// 
	0,						// ^[E
	0,						// ^[
	0,						// ^[
	0,							// UĂѓiNu쓮j
	0,							// 85cmɍU
	0,							// 150cmɍU
	0,						// _[WO
	0,						// _[W
	0,						// _[WO
	0,						// _[W
	0,						// _[WEO
	0,						// _[WE
	0,						// _[WO
	0,						// _[W
	0,						// _[WEgO
	0,						// _[WEg
	0,						// _[WgO
	0,						// _[Wg
	260,						// _[WӂƂу_EOiSj
	250,						// _[Wу_EiSj
	0,						// _[WE _E
	0,						// _[W _E
	0,						// _ER
	0,						// _E_[W
	0,						// _EȂ
	0,						// _EȂ瑖
	0,						// _E玀S
	0,						// _E85cmɍU
	0,						// _E150cmɍU
	0,							// [U[ōU
	0,							// [U[gro
	0,							// [U[grB
	0,							// ꎩR̂̂QiXs[hpj
	0,							// Xs[hX}CsJn
	0,							// Xs[hX}C
	0,						// ݍUi_j
	0,						// ݍUiRj
	0,						// ݍUiJGfj
	0,						// ݍUiR[ej
	0,						// ݍUi}XNj
	0,						// ݍUiPrj
	0,							// f
	0,							// f
	-1
};

// e[u(veNgj
static int eneProtFootSeTbl[] = {
	SFX_BT_PRHS_WALK_A,
	SFX_BT_PRHS_WALK_B,
	SFX_BT_PRHS_WALK_C,
	SFX_BT_PRHS_WALK_D,
};


K7EnmP::K7EnmP(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) : WK7Enemy(enemyid,pAnchor,prio)
{
	// fǂݍ
	CreateModel (K7CHRID(K7ENMID(MDLCODE_ID),  suffix));
	
	// [Vǂݍ
	CreatePackMotion(npcTypePMotionIdTable, MOTCODE_ID);
	
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go
	mData.mWeakID		= -1;								// ꌂ
	mData.mVLossID		= -1;								// ʐѕ
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
	mData.mScale		= 1.2f;								// 
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= -1;
	mData.mVLossIDBk	= mData.mVLossID;
	mData.mCounterKurai	= 0;
	mData.mAtkDist		= 0.f;								// U
	mData.mTypeBig		= 1;
	mData.mAtkDistBk	= mData.mAtkDist;
}

void K7EnmP::FootSeWalk(Vec myPos)
{
	// rdĐ
	// [vrd{[`FW
	if ((26 == GetCurrentMotionFrame())
	||	(78 == GetCurrentMotionFrame())
	){
		gpSound->mPlaySE3D( (int )eneProtFootSeTbl[rand()%4], myPos, 0 );		// rdĐ
		if( 26  == GetCurrentMotionFrame() ){
			FootPaintTestSet(NPCWEAKOBJID_LFOOT);
		}else{
			FootPaintTestSet(NPCWEAKOBJID_RFOOT);
		}
	}
}



