////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmTIM.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMTIM_H__
#define	__ENMTIM_H__

#include "..\Wat\WK7Enemy.h"

#define TIM_WEAK_MAX		(8)

class K7EnmTIM : public WK7Enemy{
protected:
	
	u8	weakDead[TIM_WEAK_MAX];
	bool mFirstRunVoice;
	int deadWeakNum;
	
public:
	K7EnmTIM(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio=WK7OBJ_DEFAULT_PRIO);
//	bool FrameProcess(void);
	void StageProc(WK7Stage *pCurrentStage);
	void HitObjMake(WK7Stage *pCurrentStage);
	bool MotSet_Dmg(void);
	bool TimVLoss(int id, WK7HitObjInfoType hitType, Vec hitPos);
	bool TimeDieTest(void);
	bool TimeRunTest(void);
	void VisibleTestDisp(void);
	f32 GetRunSpeed(void);
	bool Ai_Follow(f32 targetDirSabun);
	void FootSeRun(Vec myPos);
};

#ifdef	__ENMTIM_CPP__

char *pNameTIMWeakObj[TIM_WEAK_MAX] = {
	"Spine_joint1",
	"Spine_joint2",
	"ScapulaR_joint",
	"RadiusR_joint",
	"HumerusL_joint1",
	"Skull_joint",
	"ThighR_joint",
	"HipL_joint",
};


#else


#endif

#endif	//__ENMTIM_H__

