////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmU.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMU_H__
#define	__ENMU_H__

#include "..\Wat\WK7Enemy.h"

class K7EnmU : public WK7Enemy{
protected:
	bool mMabuta;
	bool mDownEfc;
	void MabutaHide(void);
	void MabutaDisp(void);
public:
	K7EnmU(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio=WK7OBJ_DEFAULT_PRIO);
	void PartsRenderIDSet(void);
	bool MotSet_Extra(void);
	bool MotStatus_Atk(void);
	void EneTypeReset(void);
	void VisibleTestDisp(void);
	void VisibleTestHide(void);
	f32 GetWalkSpeed(void);
	f32 GetRunSpeed(void);
};


#endif	//__ENMU_H__

