////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmX.cpp Z~bNX}Ci{Xj
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

/*
	
	
	˂炢Ɣ]
	
	
	
*/

#define	__ENMX_CPP__

#include "EnmX.h"
#include "..\Kaw\KK7BattleMainTask.h"

#define MDLCODE_ID				(22)			// dmHQwww ́H̔ԍifj
#define MOTCODE_ID				(22)			// dmHQwww ́H̔ԍi[Vj

s16 npcTypeXMotionIdTable[] = {
	20,							// R
	50,							// 
	50,							// 
	0,							// ^[E
	0,							// ^[
	140,						// ^[
	0,							// UĂѓiNu쓮j
	0,							// 85cmɍU
	0,							// 150cmɍU
	0,						// _[WO
	0,						// _[W
	0,						// _[WO
	0,						// _[W
	0,						// _[WEO
	0,						// _[WE
	0,						// _[WO
	0,						// _[W
	0,						// _[WEgO
	0,						// _[WEg
	0,						// _[WgO
	0,						// _[Wg
	0,						// _[WӂƂу_EOiSj
	0,						// _[Wу_EiSj
	0,						// _[WE _E
	0,						// _[W _E
	0,						// _ER
	0,						// _E_[W
	0,						// _EȂ
	0,						// _EȂ瑖
	0,						// _E玀S
	0,						// _E85cmɍU
	0,						// _E150cmɍU
	0,							// [U[ōU
	0,							// [U[gro
	0,							// [U[grB
	0,							// ꎩR̂̂QiXs[hpj
	0,							// Xs[hX}CsJn
	0,							// Xs[hX}C
	0,						// ݍUi_j
	0,						// ݍUiRj
	0,						// ݍUiJGfj
	0,						// ݍUiR[ej
	0,						// ݍUi}XNj
	0,						// ݍUiPrj
	0,							// f
	0,							// f
	-1
};

#define EXTRA_PARTS_NAME		"Weak"

#define ENMX_BOMB_DIST			(50.f)

// e[u(veNgj
static int eneFootSeTbl[] = {
	SFX_BT_PRHS_WALK_A,
	SFX_BT_PRHS_WALK_B,
	SFX_BT_PRHS_WALK_C,
	SFX_BT_PRHS_WALK_D,
};

K7EnmX::K7EnmX(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) : WK7Enemy(enemyid,pAnchor,prio)
{
	// fǂݍ
	CreateModel (K7CHRID(K7ENMID(MDLCODE_ID),  suffix));
	
	// [Vǂݍ
	CreatePackMotion(npcTypeXMotionIdTable, MOTCODE_ID);
	
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go
	mData.mWeakID		= -1;								// ꌂ
	mData.mVLossID		= -1;								// ʐѕ
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
	mData.mScale		= 1.2f;								// 
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= -1;
	mData.mVLossIDBk	= mData.mVLossID;
	mData.mCounterKurai	= 0;
	mData.mAtkDist		= 0.f;								// U
	mData.mAtkDistBk	= mData.mAtkDist;
	
//	mData.mBombDist		= ENMX_BOMB_DIST;					// U͈͋
//	mData.mBombDistBk	= mData.mBombDist;
	
	mEndPos.x			= 0.f;
	mEndPos.y			= 0.f;
	mEndPos.z			= 0.f;
	
	mData.mTypeBig		= 1;
	
	mRunPointPtr		= 0;
	mRunDirec			= +1;
	mRunDirecBk			= mRunDirec;
	mTurnCount			= 0;
	RunPointCalc();
}

/*
	
	
	p_[hc̊蓖
	
	
*/
void K7EnmX::PartsRenderIDSet(void)
{
	u32 renderidex;
	WK7Model *pModel = pCurrentChara()->GetModel();
	
	renderidex = WK7RenderObj::GetUniqueRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
	pCurrentChara()->SetRenderIDEx(renderidex);
	
	// ʂJOBJƂĂ
	if ( pModel != NULL ){
		WK7JObj *pJOBJ;
		pJOBJ   = pModel->GetObj(EXTRA_PARTS_NAME);					// IuWF񂷂̂ǂ
		if ( pJOBJ != NULL ){
			pCurrentChara()->SetRenderIDEx(pJOBJ,false,false);		// ݂ɂȂł̂OKȏꍇ
//			pCurrentChara()->SetRenderIDEx(pJOBJ,false,false);		// ݂ɂȂł̂ȏꍇ
		}
	}
}



/*
	
	
	蒆
	
	
*/
bool K7EnmX::MotSet_Run(bool hokan)
{
	f32	targetDirSabun;
	Vec	myPos;
	Vec	dir;
	f32 distRest, pcRotY;
	f32 speed = 2.f;

	// 胂[V̍Đ
	if ( mMotID != WK7MOTION_NPCCMN_RUN ){
		MotPlayInit(NPC_POSMODE_PROG);
		if( false == PlayCommonMotion(WK7MOTION_NPCCMN_RUN, true, hokan, speed ) ){
			return false;
		}
	}else{
		
		mpNpcChara->GetPosition(myPos);							// ݒn̎擾
		
		// ړIl̕I
		dir.x = mEndPos.x - myPos.x;
		dir.z = mEndPos.z - myPos.z;
		mGoDir = atan2f((f32 )dir.x, (f32 )dir.z);
		
		// PCƂ̊px
		if ( pBattleMain->GetBattleTask() == true ){
			pcRotY = pBattleMain->GetCamRotY();
		}else{
			WK7PLAYERCONTROL->GetRotY(&pcRotY);
		}
		
		{
			
			SetTargetRotY(mGoDir);
			SetRotCalc(4.f);
			
			// rdĐ
			if(	mpNpcChara!=NULL ){
				WK7Model *pModel = mpNpcChara->GetModel();
				if ((14 == pModel->GetCurrentMotionFrame())
				||	(34 == pModel->GetCurrentMotionFrame())
				){
					gpSound->mPlaySE3D( (int )eneFootSeTbl[rand()%4], myPos, 1, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );		// rdĐ
				}
			}
			
			// ړ
			myPos.x += (GetRunSpeed() * speed) * sinf(mRotY);
			myPos.z += (GetRunSpeed() * speed) * cosf(mRotY);
			
			SetPosition(myPos);
			
			// ړIn܂ŒǂH
			distRest = GHM_VEC_GET_DIST(&mEndPos, &myPos);
			if ( distRest <= (GetRunSpeed() * (speed * 2.f)) ){
				RunPointCalc();
#define  NOTURNWAIT  (12)
				mTurnCount = NOTURNWAIT;
			}
		}
		
		targetDirSabun = pcRotY - mGoDir;
		if ( targetDirSabun ){
			GHM_LIMIT_RANGE(targetDirSabun, PI, -PI);
		}else{
			targetDirSabun = 0.f;
		}
		if ( fabsf(targetDirSabun) >= (PI/3.f*2.f) ){
			// Ă bNꂽ]
			if ( mTurnCount > 0 ){
				mTurnCount--;
			}else{
				if ( GetLockOn() && (mState != NPC_STATE_TURN) ){
					RunDirecChange();
					RunPointCalc(1);
				}
			}
		}
		
		// ]邩ǂH
		if ( mRunDirec != mRunDirecBk ){
			mRunDirecBk = mRunDirec;
			if ( true == MotSet_Turn() ) {
				int seNo;
				
				seNo = gpSound->mPlaySE3D(SFX_BT_CHS_TURN, myPos, 1, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );		// rdĐ
				SePitchChange(seNo);
				return true;
			}
		}
	}
	return true;
}


bool K7EnmX::RunPointCalc(int mode)
{
#pragma unused(mode)
	Vec myPos;

	if ( mpNpcChara != NULL ){
		mpNpcChara->GetPosition(myPos);
		mEndPos		= ENMX_MovePoint[mRunPointPtr];
	}
	
	mRunPointPtr += mRunDirec;
	
	if ( mRunPointPtr >= RUNPOINT_MAX ){
		mRunPointPtr = 0;
	}else{
		if ( mRunPointPtr < 0 ){
			mRunPointPtr = (RUNPOINT_MAX-1);
		}
	}
	
	return true;
}

void K7EnmX::RunDirecChange(void)
{
	if ( mRunDirec > 0 ){
		mRunDirec = -1;
	}else{
		mRunDirec = +1;
	}
	
	// |C^Qi߂
	
	mRunPointPtr += mRunDirec;
	
	if ( mRunPointPtr >= RUNPOINT_MAX ){
		mRunPointPtr = 0;
	}else{
		if ( mRunPointPtr < 0 ){
			mRunPointPtr = (RUNPOINT_MAX-1);
		}
	}
	
	mRunPointPtr += mRunDirec;
	
	if ( mRunPointPtr >= RUNPOINT_MAX ){
		mRunPointPtr = 0;
	}else{
		if ( mRunPointPtr < 0 ){
			mRunPointPtr = (RUNPOINT_MAX-1);
		}
	}
}


/*
	
	
	ȖG^C~O擾
	
	<return>
	true			G
	false			GȂ
	
*/
bool K7EnmX::GetNoDamage(void)
{
//	if ((GetNpcState() == NPC_STATE_TURN)			// ^[
//	&&	(1 != mDamage.mDamExHitOk)					// n[gɃqbgĂȂ
//	){
//		return true;
//	}
	return false;
}


/*
	
	
	^[
	
	<return>
	true				󂯕tnj
	false				󂯕tʖ
	
*/
bool K7EnmX::MotSet_Turn(void)
{
	MotPlayInit(NPC_POSMODE_DATA);
	if ( false == PlayCommonMotion(WK7MOTION_NPCCMN_TURN_B, false, true, 0.f) ){
		return false;
	}
	mState = NPC_STATE_TURN;
	return true;
}

/*
	
	
	^[
	
	<return>
	true	VK[VZbgꂽ
	false	[V̂܂
	
*/
bool K7EnmX::MotStatus_Turn(void)
{
	f32 nowDirec;

	// I
	if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
		// I
		
		pCurrentChara()->GetRotY(&nowDirec);
		nowDirec += PI;
		GHM_LIMIT_RANGE(nowDirec, PI, -PI);
		SetTargetRotY(nowDirec, true);
		mTurnCount = 8;
		
		if( false == MotSet_Run(false) ) return true;
		mState = NPC_STATE_RUN;
	}
	return false;
}



