////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmX.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMX_H__
#define	__ENMX_H__

#include "..\Wat\WK7Enemy.h"

class K7EnmX : public WK7Enemy{
protected:
	Vec			mEndPos;					// 点I_ʒu
	f32			mGoDir;						// 点
	s16			mRunPointPtr; 
	s8			mRunDirec; 					//  0: 1:t
	s8			mRunDirecBk; 				//  0: 1:t
	u32			mTurnCount; 				// 
public:
	K7EnmX(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio=WK7OBJ_DEFAULT_PRIO);
	bool MotSet_Run(bool hokan);
	bool RunPointCalc(int mode=0);
	void RunDirecChange(void);
	bool MotStatus_Turn(void);
	void PartsRenderIDSet(void);
	bool GetNoDamage(void);
	bool MotSet_Turn(void);
};

#ifdef	__ENMX_CPP__

#define RUNPOINT_MAX	(8)
Vec ENMX_MovePoint[RUNPOINT_MAX] = {
	{-2921.483f, 0.f, -2019.599f},
	{-2950.773f, 0.f, -2047.012f},
	{-3088.540f, 0.f, -2032.282f},
	{-3130.091f, 0.f, -1996.431f},
	{-3117.158f, 0.f, -1821.040f},
	{-3041.112f, 0.f, -1800.562f},
	{-2918.830f, 0.f, -1848.129f},
	{-2914.976f, 0.f, -1949.141f},
};

#else

#endif


#endif	//__ENMX_H__

