
/*

	og[h̓Rg[

 	KK7BattleCtrl.cpp

 	Creator       : Kawakami Satoshi (GHM)
 	Creation Date : 10/05/2003

*/

#define	__KK7BATTLECTRL_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>
#include "..\lib\ghmGcDefine.h"
#include "KK7BattleCtrl.h"
#include "..\Fujita\C_Font.h"
#include "..\Wat\WK7MainTask.h"
#include "..\Wat\WK7Cam.h"
#include "..\Wat\WK7Player.h"
#include "..\Wat\WK7Event.h"
#include "..\Wat\WK7Npc.h"
#include "..\Wat\WK7Skill.h"
#include "..\Wat\WK7Stage.h"
#include "..\Kaw\KK7Util.h"
#include "..\Wat\Blood.h"
#include "..\Wat\EnmList.h"
#include "..\Wat\WK7GameInfo.h"
#include "..\Wat\K7GlobalFlag.h"
#include "..\Sato\SK7Special.h"


#define	NO_MODELLOAD

#define GAL_DEADRECOVER_DIST	(20.f)


/*
	
	RXgN^
	
*/
KK7BattleCtrl::KK7BattleCtrl()
{
	// Init
//	OSReport( "KK7BattleCtrl@called constractor\n" );
	
	mDamagePosIdCounter = 0;
	mGalPowerUp = 0;				// yZ[u[hΏہzKVAp[Abv
	mDanPowerUp = 0;				// yZ[u[hΏہz_p[Abv
	mMskPowerUp = 0;				// yZ[u[hΏہz}XNp[Abv
	mCreateSerumVolume = 0;			// yZ[u[hΏہz쐬Av̗
	mTvEnemyCount = 0;				// yZ[u[hΏہzgp(?)G̗
	mTotalEnemyHunt = 0;			// yZ[u[hΏہz
	mTotalReCallNum = 0;			// yZ[u[hΏہz
	mComboCount     = 0;			// yZ[u[hΏہz
}


/*
	
	fXgN^
	
*/
KK7BattleCtrl::~KK7BattleCtrl()
{
	// Init
//	OSReport( "KK7BattleCtrl@called destractor\n" );
	
	
}



/*
	
	
	ogRg[^XN
	j[Q[
	
	
*/
void KK7BattleCtrl::InitNewGame(void)
{
	mGalPowerUp = 0;				// KVAp[Abv
	mDanPowerUp = 0;				// _p[Abv
	mMskPowerUp = 0;				// }XNp[Abv
	mTvEnemyCount = 0;				// yZ[u[hΏہzgp(?)G̗
	mCreateSerumVolume = 0;			// yZ[u[hΏہz쐬Av̗
	mTotalEnemyHunt = 0;			// yZ[u[hΏہz|G̐
	mTotalReCallNum = 0;			// erʓ̈N
	WK7Skill::Init();				// LN^[̃p[^̏
}


/*
	
	
	ogRg[^XN
	ViI
	
	
*/
void KK7BattleCtrl::InitScenario(void)
{
	if( GameInfo.GetContinue()==false ){
		DeadPlayerInit();
		InitDefaultReCallChara();			// L[Lݒ
		mTotalEnemyHunt = 0;				// |G̐
	}
	InitStage();
}


/*
	
	
	ogRg[^XN
	ViItH[
	
	
*/
void KK7BattleCtrl::InitScenarioFlow(void)
{
	mComboCount = 0;						// R{JEgiViIɃZbgj
	mTotalReCallNum = 0;					//  erʓ̈N
	mTvEnemyCount = 0;						//  gp(?)G̗
	SetBpGauge(BP_THICK, 	(int )0);		//@ZiAvϊÕTuʂɂăr[J[ɗ܂ĂAj
	SetBpGauge(BP_THIN,		(int )0);		//@i`[ŴƂɎgAj
	if ( NULL != GameInfo.GetSpOption() ){
		GameInfo.GetSpOption()->SetBloodGauge( BP_THICK, 0 );
		GameInfo.GetSpOption()->SetBloodGauge( BP_THIN, 0 );
	}
	GalPowerUp(0);
	DanPowerUp(0);
	MskPowerUp(0);
}


void KK7BattleCtrl::DeadPlayerInit(void)
{
	int i;
	for(i=0; i<K7PCMAX; i++){
		mDeadPlayer[i].Init();
	}
}

void KK7BattleCtrl::InitDefaultReCallChara(void)
{
	
	ReleaseDeadTask();
//	DeadPlayerInit();
	
	// LInAe[u
	mPcInfo.ScenarioReset();
	
	// n[}͎gȂ
	PcReCallSet (K7HAC, 0);
	PcSelOKSet  (K7HAC, 0);
	
	if ( false == K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1) ){
		PcReCallSet (K7HAY, 0);
		PcSelOKSet  (K7HAY, 0);
	}else{
		// L[P̎
		switch( GameInfo.GetScenarioFlow() ){
		case	K7SCNF_HT2:
		case	K7SCNF_GNK:
			PcReCallSet (K7HAY, 0);
			PcSelOKSet  (K7HAY, 0);
			break;
		default:
			PcReCallSet (K7HAY, 1);
			PcSelOKSet  (K7HAY, 1);
			break;
		}
	}
	
	// ȉAقƃViIς
	PcReCallSet (K7GAL, 1);
	
	// L[L̉
	switch( GameInfo.GetScenarioFlow() ){
	case	K7SCNF_CEL:
		PcReCallSet (K7DAN, 1);
		PcReCallSet (K7KED, 1);
		PcReCallSet (K7CAT, 1);
		PcReCallSet (K7CYO, 1);
		break;
	case	K7SCNF_FUK:
		PcReCallSet (K7CYO, 1);
		PcReCallSet (K7MSK, 1);
		PcReCallSet (K7KED, 1);
		break;
	case	K7SCNF_KAK:
		PcReCallSet (K7KVN, 1);
		PcReCallSet (K7MSK, 1);
		PcReCallSet (K7CYO, 1);
		break;
	case	K7SCNF_TXS:
		PcReCallSet (K7CYO, 1);
		PcReCallSet (K7KED, 1);
		PcReCallSet (K7MSK, 1);
		break;
	case	K7SCNF_ISZ:
		PcReCallSet (K7CAT, 1);
		PcReCallSet (K7MSK, 1);
		PcReCallSet (K7CYO, 1);
		break;
	case	K7SCNF_CUR:
		PcReCallSet (K7CAT, 1);
		PcReCallSet (K7DAN, 1);
		PcReCallSet (K7KVN, 1);
		PcReCallSet (K7MSK, 1);
		break;
	case	K7SCNF_DM1:
	case	K7SCNF_DM2:
		PcReCallSet (K7DAN, 1);
		PcReCallSet (K7CAT, 1);
		PcReCallSet (K7MSK, 1);
		break;
	case	K7SCNF_GNK:
		PcReCallSet (K7GAL, 0);
		PcSelOKSet  (K7GAL, 0);
	case	K7SCNF_HT2:
		PcReCallSet (K7DAN, 0);
		PcReCallSet (K7CAT, 0);
		PcReCallSet (K7CYO, 0);
		PcReCallSet (K7KED, 0);
		PcReCallSet (K7KVN, 0);
		PcReCallSet (K7MSK, 0);
		
		PcSelOKSet  (K7DAN, 0);
		PcSelOKSet  (K7CAT, 0);
		PcSelOKSet  (K7CYO, 0);
		PcSelOKSet  (K7KED, 0);
		PcSelOKSet  (K7KVN, 0);
		PcSelOKSet  (K7MSK, 0);
		break;
	case	K7SCNF_HT1:
	case	K7SCNF_SCL:
	default:
		PcReCallSet (K7DAN, 1);
		PcReCallSet (K7CAT, 1);
		PcReCallSet (K7CYO, 1);
		PcReCallSet (K7KED, 1);
		PcReCallSet (K7KVN, 1);
		PcReCallSet (K7MSK, 1);
		break;
	}
}

/*
	
	
	ogRg[^XN
	ViII
	
	
*/
void KK7BattleCtrl::ReleaseScenario(void)
{
	int i;

	for(i=0; i<K7PCMAX; i++){
		EndDeadTask((u32 )i);
	}
	
//	mDeadPlayer.ReleaseModel();
}


/*
	
	
	ogRg[^XN
	Xe[WZbg
	
	
*/
void KK7BattleCtrl::InitStage(void)
{
	AllReleaseDamagePos();
}


/*
	
	
	t[vZX
	
	
*/
void KK7BattleCtrl::FrameProcess(void)
{
	
	DamagePosCtrlFrameProcess();						// _[WRg[At[
	
}


/*
	
	
	_[WRg[AɎl荞ł邩`FbN
	
	
	<return>
	true 	荞ł܂
	false 	Z[t
	
*/
bool KK7BattleCtrl::DamagePosCtrlMainCharaInTest(Vec Pos)
{
	KK7BattleCtrl_DamagePos	*pDamage = (KK7BattleCtrl_DamagePos *)GetTopDamagePos();

	if ( NULL == pDamage ) return false;
	
	while( pDamage != NULL ){
		f32 dist;
		
		// lɗLȂ́iêŖj
		if ( KK7BATTLECTRL_DAMAGEPOINT_BIT_PC & pDamage->mDamListBit ){
			pDamage = pDamage->GetNext();
			continue;
		}
		
		// GEGLXgɗLȂ
		if ( (KK7BATTLECTRL_DAMAGEPOINT_BIT_ENEMY|KK7BATTLECTRL_DAMAGEPOINT_BIT_EXTRA) & pDamage->mDamListBit ){
			dist = GHM_VEC_GET_DIST(&Pos, &pDamage->mDamPos);							// Sn_Ƃ̋擾
			if ( dist < pDamage->mDamDist ){
				// 荞ł
				return true;
			}
		}
		pDamage = pDamage->GetNext();
	}
	
	return false;
}

/*
	
	
	_[WRg[At[
	
	
*/
bool KK7BattleCtrl::DamagePosCtrlFrameProcess(void)
{
	KK7BattleCtrl_DamagePos	*pDamage = (KK7BattleCtrl_DamagePos *)GetTopDamagePos();
	KK7BattleCtrl_DamagePos	*pDamageBk;

	if ( NULL == pDamage ) return false;
	
	while( pDamage != NULL ){
		f32 dist;
		Vec waistPos;
		
		// lɗLȂ
		if ( KK7BATTLECTRL_DAMAGEPOINT_BIT_PC & pDamage->mDamListBit ){
			if ( true == WK7PLAYERCONTROL->GetWaistPosition(&waistPos) ){
				dist = GHM_VEC_GET_DIST(&waistPos, &pDamage->mDamPos);										// Sn_Ƃ̋擾
				if ( dist < pDamage->mDamDist ){
					// l픚
					WK7PLAYERCONTROL->SetPcDamage(pDamage->mDamPos, (s16 )pDamage->mDamPoint, 0);			// |WVA_[WlA[h 0
				}
			}
		}
		
		// GEGLXgɗLȂ
		if ( (KK7BATTLECTRL_DAMAGEPOINT_BIT_ENEMY|KK7BATTLECTRL_DAMAGEPOINT_BIT_EXTRA) & pDamage->mDamListBit ){
			WK7Npc *pNpcTmp;
			
			for(pNpcTmp=WK7Npc::GetTop(); pNpcTmp!=NULL; pNpcTmp=pNpcTmp->GetNext()){
				if(	(pNpcTmp->GetType()==WK7Npc::TYPE_ENEMY)
				||	(pNpcTmp->GetType()==WK7Npc::TYPE_EXTRA)
				){
					if ( pNpcTmp->GetNpcState() == NPC_STATE_INIT ) continue;			// ǂݍݓĂȂ
					if ( pNpcTmp->GetNpcState() == NPC_STATE_LOSS ) continue;			// ǂݍݓĂȂ
					
					pNpcTmp->GetWaistPosition(&waistPos);
					dist = GHM_VEC_GET_DIST(&waistPos, &pDamage->mDamPos);				// Sn_Ƃ̋擾
					if ( dist < pDamage->mDamDist ){
						// Ge
						
						pNpcTmp->SetNpcDamageEvent(pDamage->mDamPos, (s16 )pDamage->mDamPoint, (WK7NpcDamType )pDamage->mDamType);
						
					}
				}
			}
			
		}
		
		// Next擾Ă
		pDamageBk = pDamage;
		pDamage = pDamage->GetNext();
		
		// IuWFNgɗLȂ
		
		// LԂmF
		if ( pDamageBk->mDamFrame > 0.f ){
			pDamageBk->mDamFrame -= 1.f;
			if ( pDamageBk->mDamFrame <= 0.f ){
				ReleaseDamagePos(pDamageBk);
			}
		}else{
			// X 0.f ͉̕ivɕ\
		}
		
	}
	
	return false;
}

/*
	
	
	_[W̍쐬
	
	<in>
	pos		ʒu
	dist	L͈
	frame	L
	bit		LΏە KK7BATTLECTRL_DAMAGEPOINT_BIT_ALL ƑS
	point	_[Wl
	type	_[W^Cv	0Fe 1FOl[h
	
	<return>
	u32		n Ǘԍ
	
*/
u32 KK7BattleCtrl::CreateDamagePos(Vec pos, f32 dist, f32 frame, u32 bit, u32 point, WK7NpcDamType type)
{
	KK7BattleCtrl_DamagePos	*pDamage = new KK7BattleCtrl_DamagePos(&mDamagePosAnchor, mDamagePosIdCounter);
	u32 setid;

	setid = mDamagePosIdCounter; mDamagePosIdCounter++;
	
	pDamage->mDamPos		= pos;
	pDamage->mDamDist		= dist;
	pDamage->mDamFrame		= frame;
	pDamage->mDamListBit	= bit;
	pDamage->mDamPoint		= point;
	pDamage->mDamType		= type;
	
	return setid;
}


/*
	
	
	_[W̎擾
	
	<in>
	id		ǗID
	
	<return>
	NULL	݂Ȃ
	n		f[^|C^
	
*/
KK7BattleCtrl_DamagePos* KK7BattleCtrl::FindDamagePos(u32 id)
{
	KK7BattleCtrl_DamagePos	*pDamageTop = (KK7BattleCtrl_DamagePos *)GetTopDamagePos();
	
	while( pDamageTop != NULL ){
		if( pDamageTop->GetID() == id ){
			return pDamageTop;
		}
		pDamageTop = pDamageTop->GetNext();
	}
	return NULL;
}


/*
	
	
	_[W̑SJ
	
	<return>
	true	JOK
	false	JsiJĂj
	
*/
void KK7BattleCtrl::AllReleaseDamagePos(void)
{
	KK7BattleCtrl_DamagePos	*pDamageTop = (KK7BattleCtrl_DamagePos *)GetTopDamagePos();
	
	while( pDamageTop != NULL ){
		ReleaseDamagePos(pDamageTop);
		pDamageTop = pDamageTop->GetNext();
	}
}



/*
	
	
	_[W̊J
	
	<in>
	id		ǗID
	
	<return>
	true	JOK
	false	JsiJĂj
	
*/
bool KK7BattleCtrl::ReleaseDamagePos(u32 id)
{
	KK7BattleCtrl_DamagePos	*pDamage = (KK7BattleCtrl_DamagePos *)FindDamagePos(id);
	
	if ( NULL != pDamage ){
		delete pDamage;
		return true;
	}
	return false;
}


/*
	
	
	_[W̊J
	
	<in>
	id		ǗID
	
	<return>
	true	JOK
	false	JsiJĂj
	
*/
bool KK7BattleCtrl::ReleaseDamagePos(KK7BattleCtrl_DamagePos *pDamage)
{
	if ( NULL != pDamage ){
		delete pDamage;
		return true;
	}
	return false;
}

bool KK7BattleCtrl::RestoreDeadTask(void)
{
	u32		i;
	for(i=0 ; i<K7PCMAX ; i++){
		u32		chrid = mDeadPlayer[i].GetID();
		u32		stgid = mDeadPlayer[i].GetStageID();
		if( K7CHR_MAINID(chrid)!=i ){
			mDeadPlayer[i].Init();
			continue;
		}
		mDeadPlayer[i].SetID(0xffffffff,0xffffffff);
		StartDeadTask(chrid,stgid);
	}
	return true;
}
bool KK7BattleCtrl::ReleaseDeadTask(void)
{
	int		i;
	for(i=0 ; i<K7PCMAX ; i++){
		StopDeadTask((u32)K7CHRID(i,0));
	}
	return true;
}
/*
	
	
	̊Ǘ^XN̊Jn
	
	<return>
	true 	󂯕tL
	false	󂯕ti[vł邮񂷂Ɓj
	
*/
bool KK7BattleCtrl::StartDeadTask(u32 set_mID, u32 set_mStageID)
{
	u32 mainID = K7CHR_MAINID(set_mID);

	if ( 0xffffffff != mDeadPlayer[mainID].GetID() ){
		return false;
	}
	
	int	taskid;
	if ( -1 == (taskid=GET_WK7MAINTASK_FRAMEPROCESSTASKPTR()->Start(KK7BattleCtrlDeadTask,
	                                                                KK7BattleCtrlDeadTaskTerm,
	                                                                (u32)set_mID,
	                                                                (u32)set_mStageID)) ){
		return false;
	}
	mDeadPlayer[mainID].SetTaskID(taskid);
	return true;
}
bool KK7BattleCtrl::StopDeadTask(u32 set_mID)
{
	u32 mainID = K7CHR_MAINID(set_mID);

	if ( mDeadPlayer[mainID].GetTaskID() < 0 ){
		return false;
	}
	GET_WK7MAINTASK_FRAMEPROCESSTASKPTR()->Stop(mDeadPlayer[mainID].GetTaskID());
	return true;
}

/*
	
	
	̊Ǘ^XN̏INGXg
	
	
*/
void KK7BattleCtrl::EndDeadTaskAll(void)
{
	int i;

	for(i=0; i<K7PCMAX; i++){
		EndDeadTask((u32 )i);
	}
}


/*
	
	
	̊Ǘ^XN̏INGXg
	
	<return>
	true 	󂯕tL
	false	󂯕t
	
*/
bool KK7BattleCtrl::EndDeadTask(u32 mainID)
{
	if ( 0xffffffff == mDeadPlayer[mainID].GetID() ){
		return false;
	}
	if ( 1 == mDeadPlayer[mainID].GetReleaseRequest() ){
		return false;
	}
	mDeadPlayer[mainID].ReleaseRequest();
	return true;
}




/*
	
	
	ob̎SԂeXg
	
	<in>
	mainID 	obhcԍ K7ID.h Q
	
	<return>
	true			ł
	false			Ă
	
*/
bool KK7BattleCtrl::PcDieTest(u32 mainID)
{
	return mPcInfo.GetDieInfo(mainID);
}

/*
	
	
	ob̎SԂݒ肷
	
	<in>
	mainID 	obhcԍ K7ID.h Q
	
	int			1	
				0	Ă
	
*/
void KK7BattleCtrl::PcDieSet(u32 mainID, int info)
{
	mPcInfo.SetDieInfo(mainID, info);
}


/*
	
	
	ob̉ԂeXg
	
	<in>
	mainID 	obhcԍ K7ID.h Q
	
	<return>
	true			Ă
	false			ĂȂ
	
*/
bool KK7BattleCtrl::PcCollectTest(u32 mainID)
{
	return mPcInfo.GetCollectInfo(mainID);
}

/*
	
	
	ob̉Ԃݒ肷
	
	<in>
	mainID 	obhcԍ K7ID.h Q
	
	int			1	Ă
				0	ĂȂ
	
*/
void KK7BattleCtrl::PcCollectSet(u32 mainID, int info)
{
	mPcInfo.SetCollectInfo(mainID, info);
}


/*
	
	
	ob̌ĂыNԂeXg
	
	<in>
	mainID 	obhcԍ K7ID.h Q
	
	<return>
	true			ĂыNĂ
	false			ĂыNĂȂ
	
*/
bool KK7BattleCtrl::PcReCallTest(u32 mainID)
{
	return mPcInfo.GetReCallInfo(mainID);
}

/*
	
	
	ob̌ĂыNԂݒ肷
	
	<in>
	mainID 	obhcԍ K7ID.h Q
	
	int			1	ĂыNĂ
				0	ĂыNĂȂ
	
*/
void KK7BattleCtrl::PcReCallSet(u32 mainID, int info)
{
	mPcInfo.SetReCallInfo(mainID, info);
}


/*
	
	
	ob̃LI\ԂeXg
	
	<in>
	mainID 	obhcԍ K7ID.h Q
	
	<return>
	true			LI\
	false			LIs
	
*/
bool KK7BattleCtrl::PcSelOKTest(u32 mainID)
{
	return mPcInfo.GetSelOKInfo(mainID);
}

/*
	
	
	ob̃LI\Ԃݒ肷
	
	<in>
	mainID 	obhcԍ K7ID.h Q
	
	int			1	LI\
				0	LIs
	
*/
void KK7BattleCtrl::PcSelOKSet(u32 mainID, int info)
{
	mPcInfo.SetSelOKInfo(mainID, info);
}

/*
	
	
	aoQ[W֘A
	
	
*/
/*
	
	
	ubh|Cg̎擾
	
	
*/
int KK7BattleCtrl::GetBpGauge(int type)
{
	return mPcInfo.GetBpGauge(type);
}
/*
	
	
	ubh|Cg̐ݒ
	
	<in>
	Point			ݒ
	
*/
void KK7BattleCtrl::SetBpGauge(int type, int Point)
{
	mPcInfo.SetBpGauge(type, Point);
}
/*
	
	
	ubh|Cg̑
	
	<in>
	IncPoint		
	
	<return>
					̃|Cg
	
*/
int KK7BattleCtrl::IncBpGauge(int type, int IncPoint)
{
	return mPcInfo.IncBpGauge(type, IncPoint);
}


// ------------------------------------------------------------------------------------------------

/*
	
	
	񐔂̉Z
	
	
*/
u32 KK7BattleCtrl::GetTotalEnemyHunt(void)
{
	return mTotalEnemyHunt;
}
void KK7BattleCtrl::SetTotalEnemyHunt(u32 num)
{
	mTotalEnemyHunt = num;
}
u32 KK7BattleCtrl::IncTotalEnemyHunt(int num)
{
	mTotalEnemyHunt += num;
	return mTotalEnemyHunt;
}


// ------------------------------------------------------------------------------------------------

/*
	
	
	N񐔂̉Z
	
	
*/
u32 KK7BattleCtrl::GetTotalReCallNum(void)
{
	return mTotalReCallNum;
}
void KK7BattleCtrl::SetTotalReCallNum(u32 num)
{
	mTotalReCallNum = num;
}
u32 KK7BattleCtrl::IncTotalReCallNum(int num)
{
	mTotalReCallNum += num;
	return mTotalReCallNum;
}


// ------------------------------------------------------------------------------------------------

/*
	
	
	쐬Av̗
	
	
*/
u32 KK7BattleCtrl::GetCreateSerumVolume(void)
{
	return mCreateSerumVolume;
}
void KK7BattleCtrl::SetCreateSerumVolume(u32 num)
{
	mCreateSerumVolume = num;
}
u32 KK7BattleCtrl::IncCreateSerumVolume(int num)
{
	mCreateSerumVolume += num;
	return mCreateSerumVolume;
}


// ------------------------------------------------------------------------------------------------

/*
	
	
	gp(?)G̗
	
	
*/
u32 KK7BattleCtrl::GetTvEnemyCount(void)
{
	return mTvEnemyCount;
}
void KK7BattleCtrl::SetTvEnemyCount(u32 num)
{
	mTvEnemyCount = num;
}
u32 KK7BattleCtrl::IncTvEnemyCount(int num)
{
	mTvEnemyCount += num;
	return mTvEnemyCount;
}


// ------------------------------------------------------------------------------------------------

/*
	
	
	eLp[Abvn
	
	
*/
void KK7BattleCtrl::GalPowerUp(u8 Lv)
{
	mGalPowerUp = Lv;
}
u8 KK7BattleCtrl::GetGalPowerUp(void)
{
	return mGalPowerUp;
}
void KK7BattleCtrl::DanPowerUp(u8 Lv)
{
	mDanPowerUp = Lv;
}
u8 KK7BattleCtrl::GetDanPowerUp(void)
{
	return mDanPowerUp;
}
void KK7BattleCtrl::MskPowerUp(u8 Lv)
{
	mMskPowerUp = Lv;
}
u8 KK7BattleCtrl::GetMskPowerUp(void)
{
	return mMskPowerUp;
}



// ------------------------------------------------------------------------------------------------

/*
	
	
	R{JEg
	
	
*/
u32 KK7BattleCtrl::GetComboCount(void)
{
	return mComboCount;
}
u32 KK7BattleCtrl::IncComboCount(int num)
{
	mComboCount += num;
	return mComboCount;
}
void KK7BattleCtrl::SetComboCount(u32 num)
{
	mComboCount = num;
}
void KK7BattleCtrl::ClearComboCount(void)
{
	mComboCount = 0;
}

// ------------------------------------------------------------------------------------------------

/*
	
	
	KK7BattleCtrl_DamagePos class ֐Q
	
	
*/
// RXgN^
KK7BattleCtrl_DamagePos::KK7BattleCtrl_DamagePos(ghmGcListObj *pAnchor, u32 id) : ghmGcListObj(pAnchor)
{
	mId				= id;
	
	mDamPos.x		= 0.f;
	mDamPos.y		= 0.f;
	mDamPos.z		= 0.f;
	mDamDist		= 0.f;
	mDamListBit		= 0;
	mDamPoint		= 0;
	mDamType		= DAMTYPE_NORMAL;
}

KK7BattleCtrl_DamagePos::~KK7BattleCtrl_DamagePos()
{
}


// ------------------------------------------------------------------------------------------------

/*
	
	
	̊֘A
	
	
*/
void KK7DeadPlayer::Init(void)
{
	mpPcDead          = (WK7Chara *)NULL;
	mID               = 0xffffffff;
	mMainID           = K7CHR_MAINID(mID);
	mSuffix           = K7CHR_SUFFIX(mID);
	mStageID          = 0xffffffff;
	mReleaseRequest   = 0;
	mTaskID           = -1;
	
	mPosition.x       = 0.f;
	mPosition.y       = 0.f;
	mPosition.z       = 0.f;
	
	mRotY             = 0.f;
}

/*
	
	
	vC[LN^̂hcZbg
	
	
*/
void KK7DeadPlayer::SetID(u32 id, u32 stageid)
{
	mID       = id;
	mMainID   = K7CHR_MAINID(mID);
	mSuffix   = K7CHR_SUFFIX(mID);
	mStageID  = stageid;
}


/*
	
	
	̃L̃NGCg
	
	
*/
bool KK7DeadPlayer::CreateModel(u32 SetmID)
{
	if( SetmID != 0xffffffff ){
		
#ifndef	NO_MODELLOAD
		if( (mpPcDead = WK7RenderObj::CreateChara(NewmID)) == NULL ){
			return false;
		}
#endif
		return true;
	}
	
	return false;
}



/*
	
	
	̃f̏IiJj
	
	
*/
bool KK7DeadPlayer::ReleaseModel(void)
{
	GHM_SAFE_DELETE(mpPcDead);
	return true;
}


/*
	
	
	̃f̓ǂݍ݂́AIĂ̂ǂH 
	
	<return>
	true			ǂݍݒ
	false			ǂݍݏI
	
*/
bool KK7DeadPlayer::IsLoading(void)
{
#ifdef	NO_MODELLOAD
	return true;
#else
	if( mpPcDead!=NULL ){
		if( mpPcDead->GetState()!=WK7RenderObj::LOADED ){
			return true;
		}
	}
	return false;
#endif
}


/*
	
	
	̃f̕\\
	
*/
void KK7DeadPlayer::SetVisible(bool flag)
{
	if( mpPcDead!=NULL ){
		mpPcDead->SetRenderFlag(flag);
	}
}


/*
	
	
	ʒu擾
	
	<return>
	true 	󂯕tL
	false	󂯕t
	
*/
bool KK7DeadPlayer::GetPosition(Vec *pos)
{
	WK7Chara		*pChara;
	WK7Model		*pModel;
	if( (pChara = WK7RenderObj::GetChara(mID))!=NULL ){
		if( (pModel = pChara->GetModel()) != NULL ){
			pModel->GetPosition(pos);
			return true;
		}
	}
	return false;
}


/*
	
	
	ʒuݒ
	
	<return>
	true 	󂯕tL
	false	󂯕t
	
*/
bool KK7DeadPlayer::SetPosition(Vec pos)
{
	mPosition       = pos;
	return true;
}


bool KK7DeadPlayer::SetPosition(void)
{
	WK7Chara		*pChara;
	WK7Model		*pModel;
	if( (pChara = WK7RenderObj::GetChara(mID))!=NULL ){
		if( (pModel = pChara->GetModel()) != NULL ){
			pModel->SetPosition(mPosition);
			return true;
		}
	}
	return false;
}


/*
	
	
	px擾
	
	<return>
	true 	󂯕tL
	false	󂯕t
	
*/
bool KK7DeadPlayer::GetRotY(f32 *roty)
{
	WK7Chara		*pChara;
	WK7Model		*pModel;
	Vec				Rotation;
	if( (pChara = WK7RenderObj::GetChara(mID))!=NULL ){
		if( (pModel = pChara->GetModel()) != NULL ){
			if ( true == pModel->GetRotation(Rotation) ) {
				*roty = Rotation.y;
				return true;
			}
		}
	}
	return false;
}


/*
	
	
	pxݒ
	
	<return>
	true 	󂯕tL
	false	󂯕t
	
*/
bool KK7DeadPlayer::SetRotY(f32 roty)
{
	mRotY = roty;
	return true;
}

bool KK7DeadPlayer::SetRotY(void)
{
	WK7Chara		*pChara;
	WK7Model		*pModel;
	Vec				Rotation;
	if( (pChara = WK7RenderObj::GetChara(mID))!=NULL ){
		if( (pModel = pChara->GetModel()) != NULL ){
			if ( true == pModel->GetRotation(Rotation) ) {
				Rotation.y = mRotY;
				pModel->SetRotation(Rotation.x, Rotation.y, Rotation.z);
				return true;
			}
		}
	}
	return false;
}


/*
	
	
	KV[̉CxgĂǂeXg
	
	<return>
	true 	ĂOK
	false	_
	
*/
bool KK7DeadPlayer::GalDeadRecoverTest(void)
{
	
	// ΏەKVő݂Ă邩ǂH
																				
	if ( false == WK7PLAYERCONTROL->GetOperateEnable() ) return false;			// s\Ȃ_
	if ( true == WK7PLAYERCONTROL->GetPause() ) return false;					// |[Y̎_
	if ( K7GAL != WK7PLAYERCONTROL->GetMainID() ) return false;					// KVȊO̎_
	
	if ((PC_STATE_WAIT == WK7PLAYERCONTROL->GetPcState())						// LXe[^X̎
	||	(PC_STATE_RUN  == WK7PLAYERCONTROL->GetPcState())
	||	(PC_STATE_WALK == WK7PLAYERCONTROL->GetPcState())
	||	(PC_STATE_TURN == WK7PLAYERCONTROL->GetPcState())
	){
		Vec GalPos;
		f32 dist;
		
		WK7PLAYERCONTROL->GetPosition(&GalPos);									// W̎擾
		
		dist = GHM_VEC_GET_DIST(&GalPos, &mPosition);
		if ( dist <= GAL_DEADRECOVER_DIST ) {									// 苗ȓȂ
			WK7PLAYERCONTROL->DamageInit();										// ^C~OŃ_[W𕉂ĂꍇA_[W͖ƂƂ
			return true;
		}
	}
	return false;
}


bool KK7DeadPlayer::StoreSaveData(KK7DeadPlayerSaveData *pSaveData)
{
	if( pSaveData==NULL ){
		return false;
	}
	pSaveData->mID       = mID;
	pSaveData->mStageID  = mStageID;
	pSaveData->mDir      = mDir;
	pSaveData->mPosition = mPosition;
	return true;
}

bool KK7DeadPlayer::RestoreSaveData(KK7DeadPlayerSaveData *pSaveData)
{
	if( pSaveData==NULL ){
		return false;
	}
	mID       = pSaveData->mID;
	mMainID   = K7CHR_MAINID(mID);
	mSuffix   = K7CHR_SUFFIX(mID);
	mStageID  = pSaveData->mStageID;
	mDir      = pSaveData->mDir;
	mPosition = pSaveData->mPosition;
	mRotY     = atan2f(mDir.x,mDir.z);
	return true;
}


/*
	
	
	̏Ǘ̃^XN
	
	
*/
GHMGCTASK_HANDLER(KK7BattleCtrlDeadTask)
{
	u32	 SetmID       = (u32 )task_get_param(0);
	u32	 SetmStageID  = (u32 )task_get_param(1);
	KK7DeadPlayer *pDeadPlayer = &(BattleCtrl.mDeadPlayer[K7CHR_MAINID(SetmID)]);
	s16 exit, task, loadok, galtask;
	WK7Stage *pCurrentStage;
	u32 MainID, Suffix, NewmID;
	
	while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
		retsys();
	}
	
	exit = 1;
	task = 0;
	galtask = 0;
	
	// SetmID 烁CIDoāAVerɕϊ
	MainID   = K7CHR_MAINID(SetmID);		// CIDo
	Suffix   = 3;							// Ver
	
	NewmID = K7CHRID(MainID, Suffix);
	
	// IDZbgĂ
	pDeadPlayer->SetID(NewmID, SetmStageID);
	
	do{
		if(	((pCurrentStage = WK7Stage::GetCurrentStage())!=NULL)
		&&	(pCurrentStage->GetID() == SetmStageID)
		){
			loadok = 1;
		}else{
			loadok = 0;
		}
		
//		switch (task){
//		case 0:
//			if ((loadok)
//			&&	(true == pDeadPlayer->CreateModel(NewmID))
//			){
//				task++;
//			}
//			break;
//		case 1:
//			if ( false == pDeadPlayer->IsLoading() ){
//				task++;
//			}
//			break;
//		case 2:
//			// \\
//			if(	loadok ){
//				// \
//				pDeadPlayer->SetVisible(true);
//				
//				// WZbg
//				pDeadPlayer->SetPosition();
//				
//				// pxZbg
//				pDeadPlayer->SetRotY();
//				
//			}else{
//				// \
//				pDeadPlayer->ReleaseModel();
//				task = 0;
//			}
//			break;
//		default:
//			break;
//		}
		
		
		// fǂݍݏIǂ܂ĂƁÅԂɎ̂ʂ蔲Ă܂\̂ loadok ̏藧Ă璲ׂ
		if (loadok){
			// KV[CxgJn`FbN
			if ((0 == galtask)
			&&	(true == pDeadPlayer->GalDeadRecoverTest())
			){
				// KV[^XN̋N
				
				// Ԃl -1 ̎͋NĂȂ
				if ( -1 != GET_WK7MAINTASK_FRAMEPROCESSTASKPTR()->StartIM(WK7PlayerGalDeadRecoverTask, (u32)pDeadPlayer->pGetPosition(), (u32)pDeadPlayer->GetMainID()) ){
					galtask = 1;
				}
			}
		}
		
		retsys();
		
		// I
		if ( 1 == (pDeadPlayer->GetReleaseRequest()) ){
			exit = 0;
		}
		
	}while(exit);
	
	pDeadPlayer->ReleaseModel();
	
	retsys();
	
	pDeadPlayer->Init();
	
	task_exit();
}

GHMGCTASK_HANDLER(KK7BattleCtrlDeadTaskTerm)
{
	u32	 SetmID       = (u32 )task_get_param(0);
	u32	 SetmStageID  = (u32 )task_get_param(1);
	KK7DeadPlayer *pDeadPlayer = &(BattleCtrl.mDeadPlayer[K7CHR_MAINID(SetmID)]);
	
	pDeadPlayer->ReleaseModel();
	pDeadPlayer->SetTaskID(-1);
//	pDeadPlayer->Init();
}

// ------------------------------------------------------------------------------------------------

/*
	
	
	obhmen֘A֐Q
	
	
*/


/*
	
	RXgN^
	
*/
KK7PCInfo::KK7PCInfo()
{
	int i;

	for (i=0; i<BP_MAX; i++){
		mBpGauge[i] = 0;
	}
	
	ScenarioReset();
}

/*
	
	fXgN^
	
*/
KK7PCInfo::~KK7PCInfo()
{
}

void KK7PCInfo::ScenarioReset(void)
{
	mDieInfoBit		= 0x00000000;				// PłAjɂȂ
	mCollectInfoBit	= 0xffffffff;				// PLN^suɏo
	mReCallInfoBit	= 0x00000000;				// PĂяoĂȂ
//	mReCallInfoBit	= 0xffffffff;				// PĂяoĂ
	mSelOKInfoBit	= 0xffffffff;				// P\
}

/*
	
	S󋵂̎擾
	
	true		ł
	
*/
bool KK7PCInfo::GetDieInfo(u32 mainID)
{
	if ( mDieInfoBit & (1<<mainID) ) {
		return true;
	}else{
		return false;
	}
}

/*
	
	S󋵂̐ݒ
	
	int			1	
				0	Ă
*/
void KK7PCInfo::SetDieInfo(u32 mainID, int info)
{
	if ( info ){
		mDieInfoBit |= (1<<mainID);
	}else{
		mDieInfoBit &= ~(1<<mainID);
	}
}

/*
	
	󋵂̎擾
	
	true		Ă
	
*/
bool KK7PCInfo::GetCollectInfo(u32 mainID)
{
	if ( mCollectInfoBit & (1<<mainID) ) {
		return true;
	}else{
		return false;
	}
}

/*
	
	󋵂̐ݒ
	
	int			1	Ă
				0	ĂȂ
*/
void KK7PCInfo::SetCollectInfo(u32 mainID, int info)
{
	if ( info ){
		mCollectInfoBit |= (1<<mainID);
	}else{
		mCollectInfoBit &= ~(1<<mainID);
	}
}

/*
	
	ĂыN󋵂̎擾
	
	true		ĂыNĂ
	
*/
bool KK7PCInfo::GetReCallInfo(u32 mainID)
{
	if ( mReCallInfoBit & (1<<mainID) ) {
		return true;
	}else{
		return false;
	}
}

/*
	
	ĂыN󋵂̐ݒ
	
	int			1	ĂыNĂ
				0	ĂыNĂȂ
*/
void KK7PCInfo::SetReCallInfo(u32 mainID, int info)
{
	if ( info ){
		mReCallInfoBit |= (1<<mainID);
	}else{
		mReCallInfoBit &= ~(1<<mainID);
	}
}

/*
	
	LI󋵂̎擾
	
	true		LI \
	
*/
bool KK7PCInfo::GetSelOKInfo(u32 mainID)
{
	if ( mSelOKInfoBit & (1<<mainID) ) {
		return true;
	}else{
		return false;
	}
}

/*
	
	LI󋵂̐ݒ
	
	int			1	LI󋵉\
				0	LI󋵕s
*/
void KK7PCInfo::SetSelOKInfo(u32 mainID, int info)
{
	if ( info ){
		mSelOKInfoBit |= (1<<mainID);
	}else{
		mSelOKInfoBit &= ~(1<<mainID);
	}
}

// ------------------------------------------------------------------------------------------------

/*
	
	
	ubh|Cg֘A
	
	
*/



/*
	
	
	ubh|Cg̎擾
	
	
*/
int KK7PCInfo::GetBpGauge(int type)
{
	return mBpGauge[type];
}


/*
	
	
	ubh|Cg̐ݒ
	
	<in>
	Point			ݒ
	
*/
void KK7PCInfo::SetBpGauge(int type, int Point)
{
	mBpGauge[type] = Point;
}


/*
	
	
	ubh|Cg̑
	
	<in>
	IncPoint		
	
	<return>
					̃|Cg
	
*/
int KK7PCInfo::IncBpGauge(int type, int IncPoint)
{
	int max, now;
	
	
	switch (type){
	case BP_SERUM:
		max				= BLOOD_SERUM_GAUGE_MAX;
		break;
	case BP_THICK:
		max				= BLOOD_THICK_GAUGE_MAX;
		break;
	case BP_THIN:
		max				= BLOOD_THIN_GAUGE_MAX;
		break;
	}
	
	now = mBpGauge[type] + IncPoint;
	
	if ( now > max ){
		mBpGauge[type] = max;
	}else{
		if ( now < 0 ){
			mBpGauge[type] = 0;
		}else{
			mBpGauge[type] = now;
		}
	}
	
	return mBpGauge[type];
}
// Z[u[hp
void KK7PCInfo::GetPcInfo(u32 *pInDie, u32 *pInCollect, u32 *pInReCall, u32 *pInSelOK)
{
	*pInDie		= mDieInfoBit;
	*pInCollect	= mCollectInfoBit;
	*pInReCall	= mReCallInfoBit;
	*pInSelOK	= mSelOKInfoBit;
}
void KK7PCInfo::SetPcInfo(u32 inDie, u32 inCollect, u32 inReCall, u32 inSelOK)
{
	mDieInfoBit		= inDie;
	mCollectInfoBit	= inCollect;
	mReCallInfoBit	= inReCall;
	mSelOKInfoBit	= inSelOK;
}



/*
	
	
	AũViItEƂMAXl̎擾
	
	
*/
u32 KK7BattleCtrl::GetSerumVolumeMax(K7ScenarioFlow inScenarioFlow)
{
	u32 serum = 0;

	switch (inScenarioFlow){
	case K7SCNF_CEL:									// ZeBbN
		serum = DEF_AMPOULE_CEL;
		break;
	case K7SCNF_FUK:									// tNV}
		serum = DEF_AMPOULE_FUK;
		break;
	case K7SCNF_KAK:									// pr
		serum = DEF_AMPOULE_KAK;
		break;
	case K7SCNF_TXS:									// eLTX
		serum = DEF_AMPOULE_TXS;
		break;
	case K7SCNF_ISZ:									// VniCVUJhj
		serum = DEF_AMPOULE_ISZ;
		break;
	case K7SCNF_CUR:									// J[eBX@
		serum = DEF_AMPOULE_CUR;
		break;
	case K7SCNF_DM1:									// h~jJO
		serum = DEF_AMPOULE_DM1;
		break;
	case K7SCNF_DM2:									// h~jJij[[Nj
		serum = DEF_AMPOULE_DM1;
		break;
	case K7SCNF_HT1:									// zeP
		serum = DEF_AMPOULE_HT1;
		break;
	case K7SCNF_SCL:									// wZ
		serum = DEF_AMPOULE_SCL;
		break;
	case K7SCNF_HT2:									// zeQ
		serum = DEF_AMPOULE_HT2;
		break;
	case K7SCNF_GNK:									// R͓
		serum = DEF_AMPOULE_GNK;
		break;
	}
	return serum;
}



// Z[u
//         bool WK7GameInfo::StoreSaveData(SK7SaveData *pSaveData)

// [h
//         bool WK7GameInfo::RestoreSaveData(SK7SaveData *pSaveData)



/*
	
	Z[un
	
	CxgtOFXe[WJn̕
	
	GL̏
	GDietO
	
	񂾃L̏
	mDieInfoBit		
	mCollectInfoBit	
	mReCallInfoBit	
	mSelOKInfoBit	
	
	z[|Cg
	
	eL̗
	WK7PLAYERCONTROL->GetDataHp(deadMainID, NULL, &GetMaxHp);
	WK7PLAYERCONTROL->SetDataHp(deadMainID, GetMaxHp);
	
	
	vfiEXLj
	void SetSkillLv(u8 setLv, u32 skillID, u32 mainID=0xffffffff);
	void SetSkillExp(u32 setExp, u32 skillID, u32 mainID=0xffffffff);
	u8  GetSkillLv(u32 skillID, u32 mainID=0xffffffff);
	u32 GetSkillExp(u32 skillID, u32 mainID=0xffffffff);
	
*/
