////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Test Task
//
// MK7TestTask.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 22/09/2002
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7TESTTASK_CPP__

//---- include ----
#include "..\wat\WK7MenuTask.h"
#include "MK7TestTask.h"
#include "mK7Proc.h"
#include "mK7Sound.h"




//---- define ----

//---- enum ----

//---- struct ----

//---- O[oϐ ----
MK7Typos*		typo0;
MK7Typos*		typo1;
MK7CharaDisp*	gName0;
MK7CharaDisp*	gName1;





//-----------------------------------------------------------------------------
//RXgN^
//-----------------------------------------------------------------------------
MK7TestTask::MK7TestTask(ghmGcApp *pApp,int prio) : ghmGcAppTask(pApp,prio)
{
}

//-----------------------------------------------------------------------------
//fXgN^
//-----------------------------------------------------------------------------
MK7TestTask::~MK7TestTask()
{
}

//-----------------------------------------------------------------------------
//R[obN
//-----------------------------------------------------------------------------
bool
MK7TestTask::InitializeCallBack(void)
{
	OSReport("MK7TestTask Init : DefaultHeap = 0x%08x , TaskSize = 0x%08x\n",ghmGcMemGetFreeSize(),sizeof(*this));

	//g`t@Cǂݍ
	//gpSound->mReadEventSsmReq( "Event/00/00010105.rsl" );
	//ǂݍݏI҂
	//while( gpSound->mGetProcess() != eSndStandby )
	//{
	//	gpSound->mFrameProcess();
	//	GHMGCTASK_RETSYS();
	//};
	
	//ʂ^
//	HSD_VISetClearClr((GXColor){0xff,0xff,0xff,0x00});
	
	//
	mTemp = NULL;
	
	//쐬̏
	mK7InitProc();
	//if( mK7CheckInitEnd() == false )
	//{
	//	K7SCR_RETSYS();
	//}
	
	screenImageFullColor.SetFormat(GX_TF_RGBA8);		// ̐x~߂ł
	screenImageFullColor.AllocBuffer();

	if( mTemp == NULL )
	{
		mFile.mK7FileReadB( "Mat/007101e.jmb", &((void*)mTemp) );
		gpEngTelop->mDataSet( mTemp );
	}
	
	ghmGcMemSetAllocName("MTypos");
	typo0 = new MK7Typos;
	ghmGcMemSetAllocName("MTypos");
	typo1 = new MK7Typos;
	ghmGcMemSetAllocName("MChrDisp");
	gName0 = new MK7CharaDisp;
	ghmGcMemSetAllocName("MChrDisp");
	gName1 = new MK7CharaDisp;
	
	return true;
}

//-----------------------------------------------------------------------------
//IR[obN
//-----------------------------------------------------------------------------
bool
MK7TestTask::TerminateCallBack(void)
{
	GHM_SAFE_DELETE( typo0 );
	GHM_SAFE_DELETE( typo1 );

	//SẴTEh~
	//gpSound->mStopAllSound();
	
	//쐬̏I
	mK7TermProc();
	
	GHM_SAFE_DELETE( gName0 );
	GHM_SAFE_DELETE( gName1 );
	GHM_SAFE_DELETE( mTemp );
	
	screenImageFullColor.FreeBuffer();
	
	//ʂ̐Fɖ߂
//	HSD_VISetClearClr((GXColor){0x00,0x00,0x40,0x00});
	
	ghmGcApp		*pApp = GetApplication();
	
	delete this;
	
	ghmGcMemSetAllocName("MenuTask");
	new WK7MenuTask(pApp);
	return true;
}

//-----------------------------------------------------------------------------
//pbh
//-----------------------------------------------------------------------------
void
MK7TestTask::zkTestPadProc( void )
{
	static s16 no = -1;
	
	//^C|\
	switch( HSD_PadGetTrigger(0) )
	{
		case	PAD_BUTTON_RIGHT:
			break;
		
		case	PAD_BUTTON_LEFT:
			if( gpJimaku->mGetStatus() == eJimakuStandby )
			{
			//	gpJimaku->mReadReq( "02test.jmb" );
			//	gpJimaku->mReadReq( "testrubi.jmb" );
			//	gpJimaku->mReadReq( "00010101.jmb" );
			//	gpJimaku->mReadReq( "Message/Stage/208/Stage208_M00.jmb" );
			//	gpJimaku->mReadReq( "Message/Stage/208/Stage208_M00.jmb" );
			//	gpJimaku->mReadReq( "Mat/Stage208_M00.jmb" );
			}
			break;
		
		case	PAD_BUTTON_UP:
			if( mTemp != NULL )
			{
				gName0->mRequest( (s16)HSD_Randi(((stEngSentence*)mTemp)->num), 32, 200, 4800 );
				gName1->mRequest( (s16)HSD_Randi(((stEngSentence*)mTemp)->num), 32, 240, 4800*3 );
			}
			break;
		
		case	PAD_BUTTON_DOWN:
			switch( HSD_Randi(3) )
			{
				case	0:
					if( typo0->mCreate( "hotel", "Entrance", eTypoDisp00, (u32)HSD_Randi(1<<24) ) == true )
					{
						typo0->mDispXY( (s16)HSD_Randi(500), (s16)HSD_Randi(400) );
					}
					if( typo1->mCreate( "hotel", "Lobby", eTypoDisp00 ) == true )
					{
						typo1->mDispXY( (s16)HSD_Randi(500), (s16)HSD_Randi(400) );
					}
					break;
				case	1:
					if( typo0->mCreate( "hotel", "Lobby", eTypoDisp00, (u32)HSD_Randi(1<<24) ) == true )
					{
						typo0->mDispXY( (s16)HSD_Randi(500), (s16)HSD_Randi(400) );
					}
					if( typo1->mCreate( "hotel", "The Ground Floor", eTypoDisp00 ) == true )
					{
						typo1->mDispXY( (s16)HSD_Randi(500), (s16)HSD_Randi(400) );
					}
					break;
				case	2:
					if( typo0->mCreate( "hotel", "The Ground Floor", eTypoDisp00, (u32)HSD_Randi(1<<24) ) == true )
					{
						typo0->mDispXY( (s16)HSD_Randi(500), (s16)HSD_Randi(400) );
					}
					if( typo1->mCreate( "hotel", "Entrance", eTypoDisp00 ) == true )
					{
						typo1->mDispXY( (s16)HSD_Randi(500), (s16)HSD_Randi(400) );
					}
					break;
				default:
					break;
			}
			break;
		
		case	PAD_BUTTON_A:
		//	typo0->mSetReverse( (bool)HSD_Randi(2) );
		//	typo1->mSetReverse( (bool)HSD_Randi(2) );
		//	gpEngTelop->mReleasePause();
		//	gpSound->mPrepareStreamNo( HPS_HORKIN_TOWER );
		//	gpSound->mPlayStreamNo( HPS_TOILET_KEY );
		//	gpMovie->mRequest( "Mat/q800tractor.h4m" );
		//	gpMovie->mRequest( "Mat/ffa15standard.h4m" );
		//	gpMovie->mRequest( "/Movie/clemence.h4m" );
		//	gpMovie->mRequest( "Mat/cloudman.h4m" );
		//	gpMovie->mRequest( "Mat/drugstore.h4m" );
		//	gpMovie->mRequest( "Mat/gurad.h4m" );
		//	gpMovie->mRequest( "Mat/postman.h4m" );
		//	gpMovie->mRequest( "Mat/tractor.h4m" );
		//	gpNoise->mUpDownStrRequest("abc","","","",4200);
		//	gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue );
		//	gpNoise->mSandRequest( eSandLongNoise );
		//	gpNoise->mSandRequest( eSandShortNoise );
			gpNoise->mRequest( 2400,  800, 1600, true );
		//	gpSound->mFadeVolumeStream( 0, 200 );
		//	TRACE( "MUSIC? %d\n", gpSound->mCheckStream(eTrackMusic0) );
		//	gpFlush->mRequest();
		//	gpSound->mPlaySEP( SFX_SYS_KEY_GET, (s16)((HSD_Randi(132)*100)-10800) );
		//	gpTNoise->mRequest( 4800*3 );
		//	gpSound->mPlayEventSE( 0 );
		//	TRACE( "typo w:%3d h:%3d\n", typo0->mGetWidth(), typo0->mGetHeight() );
			break;
		
		case	PAD_BUTTON_B:
		//	gpSound->mJustPlayStream();
		//	gpSound->mCheckStream();
			gpJimaku->mReleasePause();
			if( gpMovie->mGetPauseFlag() == false )
			{
				gpMovie->mSetPause();
			}else
			{
				gpMovie->mReleasePause();
			}
			gpNoise->mUpDownStrRelease(4200);
			break;
		
		case	PAD_BUTTON_Y:
			gpDim->mStop();
		//	gpNoise->mRelease();
		//	gpNoise->mSandRelease();
		//	gpNoise->mSandRelease( "!abc", "ABC", "012", "345" );
		//	gpNoise->mSandRelease( "opqrstuvwxyz", "largeroom", "abcdefghijklmn", "12ټ" );
		//	gpNoise->mSandRelease( "opqrstuvwxyz", "largeroom", "abcdefghijklmn", "" );
		//	gpNoise->mSandRelease( "ABCDEFG", "ZXCVBN", "abcdefghijklmn", hsftjhsjsr" );
			gpNoise->mSandRelease( "ABCDEFG", "", "", "hsftjhsjsr" );
			gpTNoise->mStop();
			gpJimaku->mDispStop();
			//gpTypoMng->mDispAllStop();
			//gpSound->mStopEventSE( 0 );
			if( HSD_Randi(2) )
			{
				typo0->mSetRGB( 0x80000000 );
				typo0->mUnDisp( eTypoSelect );
				typo1->mUnDisp( eTypoUnselect );
			}else
			{
				typo0->mUnDisp( eTypoUnselect );
				typo1->mSetRGB( 0x80000000 );
				typo1->mUnDisp( eTypoSelect );
			}
			break;
		
		case	PAD_TRIGGER_L:
			gpDim->mRequest( 4800*3 );
			break;

		case	PAD_TRIGGER_R:
			break;

		case	PAD_TRIGGER_Z:
			gpMovie->mStop();
			break;

		default:
			break;
	}
}

//-----------------------------------------------------------------------------
//t[
//-----------------------------------------------------------------------------
bool
MK7TestTask::FrameProcess(void)
{
	if( HSD_PadGetTrigger(0) & PAD_BUTTON_X ){
		if( DeleteTerminate()==true ){
			return true;
		}
	}
	
	//XN[Rs[
	screenImageFullColor.ScreenCopy();
	
	//pbhĂяo
	zkTestPadProc();
	
	//쐬̃t[
	mK7FrameProc();
	
	return true;
}

//-----------------------------------------------------------------------------
//_O
//-----------------------------------------------------------------------------
bool
MK7TestTask::RenderProcess(void)
{
	//[r[_O
	if(gpMovie!=NULL)gpMovie->mRender();
	
	// sysdolphinԖ
	HSD_StateInvalidate(HSD_STATE_ALL);
	
	//
	GXSetCopyFilter(GX_FALSE,NULL,GX_FALSE,NULL);
	
	//K7pgp3D`揈
	mK7Render3D();
	
	//쐬̃_[
	mK7RenderProc();
	
	return true;
}

