////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7Flush
//
// mK7Flush.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 04/22/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7FLUSH_H__
#define	__MK7FLUSH_H__

//---- include ----
#include "..\wat\WK7Define.h"
#include "mK7Sprite.h"




//---- enum ----
//t[vZX̏
typedef	enum{
	eFlushInit,				//
	eFlushExec,				//s
	eFlushDecrease,			//邳
	eFlushStandby,			//ҋ@
	eFlushFrameProcMax,
}enFlushFrameProc;

//---- struct ----

//---- class ----
//tbVNX
class MK7Flush{
protected:
public:
	//---- ֐ ----
	//RXgN^
	MK7Flush();
	
	//fXgN^
	~MK7Flush();
	
	//
	static
	void	Init( void );
	
	//㏈
	static
	void	Term( void );
	
	//tbVNGXg
	void	mRequest( u32 inRgb = 0xffff00, s32 inUpTick = 100, s32 inDownTick = 300 );
	
	//t[
	void	mFrameProcess( void );
	
	//`揈
	void	mRender( void );
	
private:
	//---- ֐ ----
	//---- ϐ ----
	enFlushFrameProc	mFrameProc;
	u32					mRgba;		//ڕWRGBAl
	u8					mOrgA;		//ŏ̃l
	u8					mToA;		//ڕWƂȂ郿l
	f32					mNowA;		//݂̃l
	s32					mUpTick;	//邭Ȃ̂ɂ鎞
	s32					mDownTick;	//ÂȂ̂ɂ鎞
	s32					mNowTick;	//tF[hɂ鎞
};



//extern
extern	MK7Flush*	gpFlush;



#endif	//__MK7FLUSH_H__




