////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7PosInfo
//
// mK7PosInfo.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/28/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7POSINFO_H__
#define	__MK7POSINFO_H__

//---- include ----
#include ".\mK7Common.h"
#include ".\mK7Sprite.h"
#include ".\mK7Jimaku.h"

//---- define ----
#define	PI_W_NUM	(20)	//
#define	PI_H_NUM	(16)	//c
#define	PI_WIDTH	(K7APP_SCREEN_WIDTH/PI_W_NUM)
#define	PI_HEIGHT	(K7APP_SCREEN_HEIGHT/PI_H_NUM)
#define	PI_PRIM_MAX	(PI_W_NUM*PI_H_NUM)

//---- enum ----
//|WVCtHt[
typedef	enum{
	ePiInit,			//
	ePiFadeIn,			//tF[hC
	ePiPieceDrop1st,	//lpPiK
	ePiPieceDrop2nd,	//lpQiK
	ePiCharFadeOut,		//tF[hAEg
	ePiWaitFadeReq,		//tF[hNGXg҂
	ePiStandby,
}enPiFrameProc;

//---- struct ----

//---- class ----
class MK7PosInfo{
protected:
public:
	//---- ֐ ----
	//RXgN^
	MK7PosInfo();
	
	//fXgN^
	~MK7PosInfo();
	
	//
	static
	void	Init( void );
	
	//㏈
	static
	void	Term( void );
	
	//
	void	mInit( void );
	
	//㏈
	void	mTerm( void );
	
	//NGXg
	bool	mRequest( char* inString );
	
	//tF[hAEg悤ɐݒ
	bool	mRequestFadeOut( void );
	
	//t[
	void	mFrameProcess( void );
	
	//`揈
	void	mRender( void );
	
	//Ԏ擾
	enPiFrameProc	mGetFrameProc( void ){return(mFrameProc);}
	
private:
	//---- ֐ ----
	//tF[hI`FbN
	bool	mCheckFadeEnd( void );
	
	//tF[hI`FbN
	bool	mCheckFadeEndSprt( void );

	//1stlp悤ɐݒ
	void	mSet1stDrop( void );

	//2ndlp悤ɐݒ
	void	mSet2ndDrop( void );
	
	//悤ɐݒ
	void	mSetSprtDrop( void );
	
	//---- ϐ ----
	enPiFrameProc	mFrameProc;
	mK7Sprite		mBackBox[PI_W_NUM][PI_H_NUM];
	char*			mString;
	mK7Sprite*		mSprt;
	mK7Sprite*		mSprtS;
	size_t			mLength;
	stFontParam*	mFontParam;	//tHg̕p[^
};




//---- extern ----
extern	MK7PosInfo*	gpPosInfo;




#endif	//__MK7POSINFO_H__




