////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7TNoise
//
// mK7TNoise.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 07/18/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7TNOISE_H__
#define	__MK7TNOISE_H__

//---- include ----
#include "..\wat\WK7Define.h"
#include "mK7Sprite.h"

//---- define ----

//---- enum ----
//t[vZX̏
typedef	enum{
	eTNoiseInit,			//
	eTNoiseExec,			//mCYs
	eTNoiseFadeOut,			//tF[hAEg
	eTNoiseStandby,			//ҋ@
	eTNoiseFrameProcMax,
}enTNoiseFrameProc;

//---- struct ----

//---- class ----
//u[NX
class MK7TNoise{
protected:
public:
	//---- ֐ ----
	//RXgN^
	MK7TNoise();
	
	//fXgN^
	~MK7TNoise();
	
	//
	static
	void	Init( void );
	//㏈
	static
	void	Term( void );
	
	//
	void	mInit( void );
	//㏈
	void	mTerm( void );
	
	//NGXg
	void	mRequest( s32 inTick );
	
	//~
	void	mStop( bool inFadeout=true );
	
	//t[
	void	mFrameProcess( void );
	
	//`揈
	void	mRender( void );
	
private:
	//---- ֐ ----
	//---- ϐ ----
	enTNoiseFrameProc	mFrameProc;
	s16					mLineNum;
	s32					mFadeTime;
};




//---- extern ----
extern	MK7TNoise*	gpTNoise;




#endif	//__MK7DIM_H__




