////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Comming
//
// SK7PanelComming.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/15/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELCOMMING_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelComming.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../wat/WK7Event.h"
#include "../Yam/YK7EffectMessage2.h"

#if 1
#define		COMING_MESSAGE			"/Message/panel/00/Comming.jmb"
#define		COMING_SPACE_X			(30.0f)
#define		COMING_FONT_Y			(200.0f)
#define		COMING_FIRST_X			(-400.0f)
#define		COMING_START_X			(115.0f)
#define		COMING_START_Y			(70.0f)
#define		COMING_END_X			(525)
#define		COMING_GYO_Y			(55)
#define		COMING_SCROLL_TIME		(10)
#define		COMING_SCROLL_TIME_ONE	(10)
#define		COMING_CLOSE_TIME		(6)
#define		FIRST_WAIT_TIME			(90)
#define		COMING_BETWEEN_X		(30)
#define		COMING_BETWEEN_TIME		(20)
#define		FRAME_CLOSE_TIME		(60)
#define		COMING_KILLER_TIME		(80)
#define		FONT_COLOR_ALPHA		(15)

#define		COMING_CLOSE_TIME		(6)
#define		FIRST_WAIT_TIME			(90)
#define		COMING_BETWEEN_X		(30)
#define		COMING_BETWEEN_TIME		(20)
#define		FRAME_CLOSE_TIME		(60)
#define		COMING_KILLER_TIME		(80)
#define		FONT_COLOR_ALPHA		(15)
#else
#define		COMING_MESSAGE			"/Message/panel/00/Comming.jmb"
#define		COMING_SPACE_X			(30.0f)
#define		COMING_FONT_Y			(200.0f)
#define		COMING_FIRST_X			(-400.0f)
#define		COMING_START_X			(115.0f)
#define		COMING_START_Y			(70.0f)
#define		COMING_GYO_Y			(55)
#define		COMING_SCROLL_TIME		(10)
#define		COMING_SCROLL_TIME_ONE	(10)
#define		COMING_CLOSE_TIME		(10)
#define		FIRST_WAIT_TIME			(90)
#define		COMING_BETWEEN_X		(30)
#define		COMING_BETWEEN_TIME		(10)
#define		FRAME_CLOSE_TIME		(60)
#define		COMING_KILLER_TIME		(80)
#define		FONT_COLOR_ALPHA		(8)
#endif

//	sԃTCYiTL[j
f32	tblGapSizeThank[]=
{
	30.0f,//ӖȂ
	32.0f,//THANK
	50.0f,//YOU
	50.0f,//FOR,
	55.0f,//PLAYING
	55.0f,//KILLER7,
	55.0f,//
};

//	sԂ̃TCYiJ~OX[j
f32	tblGapSizeComing[]=
{
	45.0f,//ӖȂ?
	45.0f,//coming
	40.0f,//soon
	37.0f,//to
	36.0f,//a
	39.0f,//game
	38.0f,//store
	37.0f,//near
	39.0f,//you
	35.0f,
};

//	ŏ̃tHg|WV
f32	tblFirstFontPos[]={	95.0f, 70.0f };

//	s邩B
int tblMoveFontOne[]={ 5, 13 };

//	s̕@jmtŁAs邽߁A2sڂЂƂ₷
int tblOneFontNum[]=
{
	5, 4, 4, 8, 9, 			//	Thank You for playing Killer7.
	6, 5, 3, 2, 5, 6, 5, 5, // 	Coming soon to a game store near you. 
};

//	s̕
int tblOneFontNum2[]=
{
	5, 3, 3, 7, 8, 			//	Thank You for playing Killer7.
	6, 4, 2, 1, 4, 5, 4, 4, // 	Coming soon to a game store near you. 
};


//========================================================================
//					RXgN^
//========================================================================
SK7PanelComming::SK7PanelComming( s32 Now ) : SK7PanelBase( Now, -1, false )
{	
	//vZX	----------------------------------------------
	m_Proc 			= PROC_LOAD;
	m_TexProc 		= LOAD_BG;

	m_bFontDrawFlag	= false;
	m_Tex.Header	= NULL;
	m_bMoveStopFlag	= false;
	
	SetCursolDisp( FALSE );
	m_iSelectNo 	= (int)Now;
	m_iScrollTime 	= 0;
	m_iMoveNum		= 0;
	m_iMoveNum2		= 0;
	m_iFontNo		= 0;
	m_iGyoNo		= 0;
	m_iGyoNo2		= 0;
	m_iTime			= 0;
	memset( &m_fFontDiff, 0, sizeof(f32)*COMING_FONT_NUM );
	memset( &m_fFontDiffSpeed, 0, sizeof(f32)*COMING_FONT_NUM );
	
	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0( 0, 0 );
	m_spBG.SetFlag( true, RENDER_FLAG );
	m_spBG.SetColor( 0xffffff00 );
	
	//	tF[h
	m_spFade.SetXYTwo( -10, -10, 650, 490 );
	m_spFade.SetFlag( true, RENDER_FLAG|NOTEX_FLAG|VTX4_FLAG );
	m_spFade.SetColor( 0x00000000 );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelComming::~SK7PanelComming()
{ 
	m_spBG.Delete();
	//eNX`	-----------------------------
	GHMGCMEM_SAFE_FREE(m_Data);
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelComming::FrameProcess(void)
{
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() ){
			m_bFontDrawFlag = true;
			SetFontVertex();
			SetMoveFont();
			m_Proc = PROC_TIME;
		}
		break;
		
	case	PROC_TIME:
		if( ++m_iTime > FIRST_WAIT_TIME ){
//			gpSound->mStopStream();
//			gpSound->mPlayStreamNo(HPS_COMING_SOON);
			m_iTime = 0;
			m_Proc = PROC_MOVE_FONT1;
		}
		break;
		
	case	PROC_MOVE_FONT1:
		//	ړ	===========================================
		if( MoveFontOne() ){
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	ړ	-------------------------------------------------
	case	PROC_SELECT_MAIN:		
		//	ړ
		if( MoveFont() ){
			m_Proc = PROC_CLOSE_TIME;
		}
		break;
		
	//	܂ł܂	-------------------------------------------------
	case	PROC_CLOSE_TIME:
		if( ++m_iTime > FRAME_CLOSE_TIME ){
			m_iTime = 0;
			if( m_iFontNo == 1 ){
				m_Proc = PROC_FADE_FONT;
			}else{
				m_Proc = PROC_CLOSE;
			}
		}
		break;
	
	//		-----------------------------------------------
	case	PROC_CLOSE:
		if( CloseFont() ){
			m_iFontNo++;
//			m_fFontDiff	= 0.0f;
			m_iGyoNo 	= 0;
			SetFontVertex();
			SetMoveFont();
			m_Proc = PROC_MOVE_FONT1;
		}
		break;
		
	case	PROC_FADE_FONT:
		if( m_spFade.AddAlpha(80) ){
			m_Proc = PROC_FADE_BG;
		}
		break;

	case	PROC_FADE_BG:
		if( m_spBG.AddAlpha(10) ){
			m_Proc = PROC_KILLER_TIME;
		}
		break;
		
	case	PROC_KILLER_TIME:
		if( ++m_iTime > COMING_KILLER_TIME ){
			k7app.FadeStart(0xff,4800);
			m_iTime = 0;
			m_Proc = PROC_FADE_MAIN;
		}
		break;
		
	case	PROC_FADE_MAIN:
		if( !k7app.IsFade() ){
			m_Proc = PROC_CANCEL;
		}
		break;
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelComming::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
		
	RenderFont();
	m_spFade.Render();
	m_spBG.Render();					//	wi

	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelComming::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelComming::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelComming::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelComming::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( "/scenario/logo/k7Logo.BIN" ) ){
			m_TexProc = LOAD_FONT;
		}
		break;
		
	case	LOAD_FONT:
		if( SetFontProcess( COMING_MESSAGE ) ){
			return true;
		}
		break;
	}
	return false;
}

//========================================================================
//					[h
//========================================================================
bool		SK7PanelComming::SetFontProcess( char* FileName )
{
	if( m_Tex.Header != NULL )	return true;
	
	//	f[^ݒ
	if( m_File.OpenDataFile( FileName, &((void*)m_Data)))
	{
		//̓f[^ւ̃AhXݒ
		m_SentenceDat = (stOneSentence*)((char*)m_Data + m_Data->offset);
		//uvwhf[^ւ̃AhXݒ
		m_FParam = (stFontParam*)((char*)m_Data + m_Data->charOffset);
		//eNX`AhẌn
		m_Tex.Header = (GhmGcTexHeader*)((char*)m_Data + m_Data->texOffset);
		//eNX`̏
		InitTexture( &m_Tex );
					
		return true;
	}
	return false;
}


//========================================================================
//					tHgړ
//========================================================================
bool		SK7PanelComming::MoveFontOne()
{
#if 0
	f32 ScrollX = (-COMING_FIRST_X/COMING_SCROLL_TIME);

	//	sړ	===========================================
	for( int i = m_iGyoNo; i < m_iGyoNo + tblOneFontNum[m_iMoveNum]; i++ ){
		m_vFontPos[i].x += ScrollX;
	}
	//	ړI	===========================================
	if( ++m_iScrollTime > COMING_SCROLL_TIME_ONE ){
		m_iGyoNo += tblOneFontNum[m_iMoveNum];			//	
		m_iMoveNum++;					
		m_iScrollTime = 0;
	}
	
	//	tHgړI`FbN
	if( m_iMoveNum >= tblMoveFontOne[m_iFontNo] ){
		m_iScrollTime = 0;
		return true;
	}
	return false;
#endif
	int	color = 0;
	for( int i = m_iGyoNo; i < m_iGyoNo + tblOneFontNum[m_iMoveNum]; i++ ){
		color = (u8)(m_lFontColor[i]) + FONT_COLOR_ALPHA;
		if( color >= 255 ){
			m_lFontColor[i] += FONT_COLOR_ALPHA - (color - 255);
		}else{
			m_lFontColor[i] += FONT_COLOR_ALPHA;
		}
	}
	if( (u8)m_lFontColor[m_iGyoNo+1] == 255 ){
		m_iGyoNo += tblOneFontNum[m_iMoveNum];			//	
		m_iMoveNum++;
	}
	if( m_iMoveNum >= tblMoveFontOne[m_iFontNo] ){
		return true;
	}
	return false;
}

//========================================================================
//					tHgN[Y
//========================================================================
bool		SK7PanelComming::CloseFont()
{
	for( int i = 0; i < COMING_FONT_NUM; i++ ){
		f32 ScrollY = ((m_fUnderY[i] - m_vFontPos[i].y)/COMING_CLOSE_TIME)/2.0f;
		m_vFontPos[i].y += ScrollY;
		m_fUnderY[i] 	-= ScrollY;
	}
	if( ++m_iScrollTime > COMING_CLOSE_TIME ){
		m_iScrollTime = 0;
		return true;
	}
	return false;
}

//========================================================================
//					tHgZbg
//========================================================================
void		SK7PanelComming::SetMoveFont()
{
	memset( &m_fFontDiff, 		0, sizeof(f32)*COMING_FONT_NUM );
	memset( &m_fFontDiffSpeed, 	0, sizeof(f32)*COMING_FONT_NUM );
	
	int iNo = 0;
	//	̍s̃Xs[hݒ
	while(1){
		for( int m = m_iGyoNo2; m < tblOneFontNum2[m_iMoveNum2]+m_iGyoNo2; m++, iNo++ ){
			if( tblOneFontNum2[m_iMoveNum2]-1 != 0 ){
				m_fFontDiffSpeed[iNo] = (( (COMING_END_X-COMING_START_X) / (f32)(tblOneFontNum2[m_iMoveNum2]-1) ) * (f32)(m-m_iGyoNo2) );
			}
		}
		iNo++;
		m_iGyoNo2 += tblOneFontNum2[m_iMoveNum2]+1;
		if( ++m_iMoveNum2 >= tblMoveFontOne[m_iFontNo] ){
			break;
		}
	}
}


//========================================================================
//					tHgړ
//========================================================================
bool		SK7PanelComming::MoveFont()
{	
	for( int i = 0; i < COMING_FONT_NUM; i++ ){
		if( m_fFontDiffSpeed[i] != 0.0f ){
			m_fFontDiff[i] += (((m_fFontDiffSpeed[i]+COMING_START_X) - m_vFontPos[i].x)/COMING_BETWEEN_TIME);
		}
	}
	if( ++m_iScrollTime >= COMING_BETWEEN_TIME ){
		m_iScrollTime = 0;
		return true;
	}
	return false;
}


//========================================================================
//					tHg`
//========================================================================
void		SK7PanelComming::RenderFont()
{
	int string =0, SpaceNum=0, iFontNo=0;
	f32	NameSize=0.0f;
	f32 PosX=0.0f;
	f32 LastFontSize=0.0f;

	if( !m_bFontDrawFlag )		return;

	for( int g = 0; g < tblMoveFontOne[m_iFontNo]; g++ ){
		//	|C^擾	=================================================
		stJimaku* pJimaku = &m_SentenceDat[m_iFontNo+1].jimaku[g];

		//	Ƃ؁[}	=================================================
		for( string = 0, SpaceNum = 0; (u16)pJimaku->chardat[string] != JIMAKU_NO_FONT; string++ ){
			if( (u16)pJimaku->chardat[string] == JIMAKU_RETURN 	||
				(u16)pJimaku->chardat[string] == JIMAKU_SPACE_H ||
				(u16)pJimaku->chardat[string] == JIMAKU_SPACE_Z )
			{
				SpaceNum++;
			}
		}
		//	񐔂B(Xy[X)	======================================
		u16 sFontNum =(u16)(string - SpaceNum);
		
		//	XvCgݒ	==========================================================	
		Set2DCamera();
		SetGraphMode();
		SetTevStage();
		SetVertex();

		//	eNX`[Zbg	======================================================
		GXLoadTexObj( &m_Tex.Obj, GX_TEXMAP0 );			//	p
		
		f32 X1, X0, Y1, Y0, U0, U1, T0, T1;
		u32	Color = 0xffffffff;
		
		//	v~eBu쐬	========================================================
		GXBegin( GX_QUADS, GX_VTXFMT0, (u16)(4 * sFontNum) );
		
		//	s`	================================================================
		for( int i = 0; i < string; i++ , iFontNo++ )
		{
			//	Xy[X`FbN	====================================================
			if( (u16)pJimaku->chardat[i] == JIMAKU_SPACE_Z ||
				(u16)pJimaku->chardat[i] == JIMAKU_RETURN  ||
				(u16)pJimaku->chardat[i] == JIMAKU_SPACE_H ){
				continue;
			}
			//	ꕶW`FbN	================================================
			if( i > 0 ){
				if( (u16)pJimaku->chardat[i-1] == JIMAKU_SPACE_Z ){
					PosX += COMING_SPACE_X;
				}else{
					PosX += m_FParam[pJimaku->chardat[i-1]].w;
				}
			}
			//	uEvuv̕傫Ȃ	==============================
			if( (s16)(pJimaku->chardat[i] & (s16)JIMAKU_FLAG_SATSU) ){
				pJimaku->chardat[i] =  (s16)(pJimaku->chardat[i] & ~(s16)JIMAKU_FLAG_SATSU);
			}
			if( (s16)(pJimaku->chardat[i] & (s16)JIMAKU_FLAG_SHI) ){
				pJimaku->chardat[i] =  (s16)(pJimaku->chardat[i] & ~(s16)JIMAKU_FLAG_SHI);
			}
			
			//	WvZ	==========================================================
			X0 		= m_vFontPos[iFontNo].x + m_fFontDiff[iFontNo];
			X1 		= X0 + m_FParam[pJimaku->chardat[i]].w;
			Y0 		= m_vFontPos[iFontNo].y;
			Y1 		= m_fUnderY[iFontNo];

			U0		= (f32)m_FParam[pJimaku->chardat[i]].u / (f32)m_Tex.Header->mWidth;
			U1		= ((f32)m_FParam[pJimaku->chardat[i]].u+(f32)m_FParam[pJimaku->chardat[i]].w) / (f32)m_Tex.Header->mWidth;
			T0		= (f32)m_FParam[pJimaku->chardat[i]].v / (f32)m_Tex.Header->mHeight;
			T1		= ((f32)m_FParam[pJimaku->chardat[i]].v+(f32)m_FParam[pJimaku->chardat[i]].h) / (f32)m_Tex.Header->mHeight;

			GXPosition3f32( X0,	Y0, 0 );
			GXColor1u32( m_lFontColor[iFontNo] );
			GXTexCoord2f32( U0, T0 );
			
			GXPosition3f32( X1,	Y0, 0 );
			GXColor1u32( m_lFontColor[iFontNo] );
			GXTexCoord2f32( U1, T0 );
			
			GXPosition3f32( X1,	Y1, 0 );
			GXColor1u32( m_lFontColor[iFontNo] );
			GXTexCoord2f32( U1, T1 );	

			GXPosition3f32( X0, Y1, 0 );
			GXColor1u32( m_lFontColor[iFontNo] );
			GXTexCoord2f32( U0, T1 );
		}
		GXEnd();
	}
}


//========================================================================
//					WZbg
//========================================================================
void		SK7PanelComming::SetFontVertex()
{
	int string, SpaceNum, iFontNo = 0, num = 0, iRubiNo = 0;
	f32 KanjiSize = 0.0f;
	f32 LastFontSize = 0.0f;
	
	//	s
	for( int a = 0; a < tblMoveFontOne[m_iFontNo]; a++ )
	{
		string = SpaceNum = 0;
		stJimaku* pJimaku = &m_SentenceDat[m_iFontNo+1].jimaku[a];
		
		//	XgO`FbN
		if( (u16)pJimaku->chardat[string] == JIMAKU_NO_FONT ||
			(u16)pJimaku->chardat[string] == JIMAKU_RETURN ){
			continue;
		}
		
		//	}
		for( string = 0; (u16)pJimaku->chardat[string] != JIMAKU_NO_FONT; string++ ){
			if( (u16)pJimaku->chardat[string] == JIMAKU_RETURN 	||
				(u16)pJimaku->chardat[string] == JIMAKU_SPACE_H ||
				(u16)pJimaku->chardat[string] == JIMAKU_SPACE_Z )
			{
				SpaceNum++;
			}
		}
		//	񐔂B(Xy[X)
		u16 sFontNum =(u16)(string - SpaceNum);

		f32 PosX=0.0f;
		u32 Color = 0xffffff00;
				
		//	
		for( int i = 0; i < string; i++ , iFontNo++ )
		{
			if( (u16)pJimaku->chardat[i] == JIMAKU_SPACE_Z ||
				(u16)pJimaku->chardat[i] == JIMAKU_RETURN  ||
				(u16)pJimaku->chardat[i] == JIMAKU_SPACE_H ){
				continue;
			}
			if( i > 0 ){
				if( (u16)pJimaku->chardat[i-1] == JIMAKU_SPACE_Z ){
					PosX += COMING_SPACE_X;
				}else{
					PosX += m_FParam[pJimaku->chardat[i-1]].w;
				}
			}
			if( (s16)(pJimaku->chardat[i] & (s16)JIMAKU_FLAG_SATSU) ){
				pJimaku->chardat[i] =  (s16)(pJimaku->chardat[i] & ~(s16)JIMAKU_FLAG_SATSU);
			}
			if( (s16)(pJimaku->chardat[i] & (s16)JIMAKU_FLAG_SHI) ){
				pJimaku->chardat[i] =  (s16)(pJimaku->chardat[i] & ~(s16)JIMAKU_FLAG_SHI);
			}
			//	J[`FbN	======================================================
			if( m_iFontNo == 0 && a == 4 ) Color = 0xff101000;
			else if( m_iFontNo == 1 && (a == 4 || a == 5) ) Color = 0x1010ff00;
			else	Color = 0xffffff00;
			m_lFontColor[iFontNo] = Color;

			m_vFontPos[iFontNo].x = COMING_START_X + PosX + LastFontSize;
			if( m_iFontNo == 0 ){
				m_vFontPos[iFontNo].y = tblFirstFontPos[m_iFontNo]  + a * tblGapSizeThank[a];
			}else{
				m_vFontPos[iFontNo].y = tblFirstFontPos[m_iFontNo]  + a * tblGapSizeComing[a];
			}
			m_fUnderY[iFontNo] = m_vFontPos[iFontNo].y + m_FParam[pJimaku->chardat[i]].h;
		}
		//	sڍŌ̃TCY	====================================================
//		LastFontSize = (m_FParam[pJimaku->chardat[string-3]].w + COMING_SPACE_X-4.0f);
	}
}
