////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Secom
//
// SK7PanelKakejiku.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELKAKEJIKU_H__
#define	__SK7PANELKAKEJIKU_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//		
#define		KAKEJIKU_SWITCH_OFF		(0)
#define		KAKEJIKU_SWITCH_OPEN	(1)

//	߂l 
#define		KAKEJIKU_ON		(0)
#define		KAKEJIKU_CANCEL	(-1)


//---- class ----
class SK7PanelKakejiku : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CANCEL,
		PROC_WAIT,
		PROC_END,
		PROC_CHECK,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_SWITCH,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spSwitch;
	s8						m_chSelect;
	int						m_iTime;
	
public:
	SK7PanelKakejiku( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelKakejiku();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELKAKEJIKU_H__
