////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel ManageKey2
//
// SK7PanelManageKey2.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELMANAGEKEY2_H__
#define	__SK7PANELMANAGEKEY2_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"


//	߂l
#define	OPEN_NOT				(-1)
#define	OPEN_FLOOR_1			(0)		//	傩PK
#define	OPEN_FLOOR_2			(1)
#define	OPEN_FLOOR_3			(2)
#define	OPEN_FLOOR_4			(3)
#define	OPEN_FLOOR_5			(4)

//	
#define	FLOOR_CLEAR_NONE		(0)		//	PK
#define	FLOOR_CLEAR_2			(1)		//	Q
#define	FLOOR_CLEAR_3			(2)
#define	FLOOR_CLEAR_4			(3)
#define	FLOOR_CLEAR_5			(4)


//	eNX`[pX
#define	PNL011304TEX_TV				"Texture/011304/admini_panel_monita.BIN"
#define	PNL011304TEX_NOBG			"Texture/011304/Number12345_BG.BIN"
#define	PNL011304TEX_NUMBER			"Texture/011304/Number12345_lgt.BIN"

#ifdef __SK7PANELMANAGEKEY2_CPP__
//	t@Cl[
char* tblBgName[]=
{
	"Texture/011304/admini_panel1F_BG.BIN",
	"Texture/011304/admini_panel2F_BG.BIN",
	"Texture/011304/admini_panel3F_BG.BIN",
	"Texture/011304/admini_panel4F_BG.BIN",
	"Texture/011304/admini_panel5F_BG.BIN",
};

#endif


#define		ROOM_NUM			(7)
#define		FLOOR_NUM			(5)

//---- class ----
class SK7PanelManageKey2 : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_MESSAGE,
		PROC_SELECT_MAIN,
		PROC_MOVE_WINDOW,
		PROC_LOAD_BG,
		PROC_TV_DRAW,
		PROC_TV,
		PROC_TIME,
		PROC_CANCEL,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		
		LOAD_TV,
		LOAD_NOBG,
		LOAD_NUMBER,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spTV[ROOM_NUM];
	SK7Sprite				m_spNoBG;
	SK7Sprite				m_spNumber[FLOOR_NUM];
	
	int						m_iSelect;
	int						m_iClearFloor;
	int						m_iWindowTime;
	int						m_iTvTime;
	int						m_iTvNum;
	bool					m_bWindowFlag;
	

public:
	SK7PanelManageKey2( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelManageKey2();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
	
};

#endif	//__SK7PANELMANAGEKEY2_H__
