////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Secom
//
// SK7PanelSafe.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELSAFE_H__
#define	__SK7PANELSAFE_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	߂l
#define	SAFE_CANCEL				(-1)//
#define	SAFE_ON					(0)	//	XCb`I


//---- class ----
class SK7PanelSafe : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CANCEL,
		PROC_MESSAGE,
		PROC_END,
		PROC_TIME,
		PROC_CHECK,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_NOBU,
		LOAD_NOBU2,
		LOAD_DIAL,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spDial;
	SK7Sprite				m_spNobu;
	SK7Sprite				m_spNobu2;
	s8						m_chSelect;
	int						m_iTime;
	f32						m_fAngle;
	s8						m_chNum;
	
public:
	SK7PanelSafe( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelSafe();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELSAFE_H__
