////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Switch 05 pjbN[̃XCb`
//
// mK7PanelSwitch05.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 11/04/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7PANELSWITCH05_H__
#define	__MK7PANELSWITCH05_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"

//---- enum ----
typedef	enum{
	ePanelSwitch05ReadTex00,
	ePanelSwitch05ReadTex01,
	ePanelSwitch05ReadTex02,
	ePanelSwitch05DispOff,
	ePanelSwitch05DispOn,
	ePanelSwitch05Decide,
	ePanelSwitch05Cancel,
	ePanelSwitch05Message,
	ePanelSwitch05MessageEnd,
	ePanelSwitch05StatsuMax,
}ePanelSwitch05Proc;



//---- class ----
class mK7PanelSwitch05 : public SK7PanelBase
{
protected:
	ePanelSwitch05Proc	mProc;
	
	SK7Sprite			mSpClose;		//close
	SK7Sprite			mSpOpen;		//open
	SK7Sprite			mSpBg;			//wi
	
	bool				mSelectFlag;	//IʃtO
	bool				mLastCheck;		//Ō̊mFtO
	bool				mInitSelectFlag;//ItO
	
//	EFFECT*				mEfSight;		//TCgGtFNg
	u32					mKeyTime;		//key
	
public:
	mK7PanelSwitch05( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~mK7PanelSwitch05();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );
	
	// 싖ݒ֐
	virtual void mSetCtrlFlag( bool inBool );

	// _Oݒ֐
	virtual void mSetRender( bool inBool );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
};

#endif	//__MK7PANELSWITCH03_H__
