////////////////////////////////////////////////////////////////////////////////
//
// Killer7 PlayEf0010  : LGtFNg0010iwuX}C̉j
//
// WK7PlayEf0010.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7PLAYEF0010_CPP__

#include ".\K7PlayEf0010.h"
#include ".\K7PlayEfHSScan.h"

K7PlayEf0010Instance::K7PlayEf0010Instance(WK7PlayEffect *pContainer,ghmGcListObj *pAnchor,WK7JObj *pJObj) : WK7PlayEffectInstance(pContainer,pAnchor,pJObj)
{
	if( (mpJObj = ((K7PlayEf0010 *)pContainer)->mpJObj)==NULL ){
		return;
	}
	mpJObj->Disp(false,true);
	mpJObj->CreateAlphaControl(0.0f,false);
	mpJObj->SetAlpha(K7PLAYEFFECT_HSNONSCAN_ALPHA,4800);
}

K7PlayEf0010Instance::~K7PlayEf0010Instance()
{
}

bool K7PlayEf0010Instance::FrameProcess(bool stopReq)
{
	if( stopReq==true || mpJObj==NULL ){
		return false;
	}
	if( mpJObj->IsAnimatingAlpha()==false ){
		return false;
	}
	return true;
}

K7PlayEf0010::K7PlayEf0010(WK7Play *pPlay,ghmGcListObj *pAnchor,WK7JObj *pJObj) : WK7PlayEffect(pPlay,pAnchor,pJObj)
{
	WK7PlayEffectInfo	*pEffectInfo = GetEffectInfo();
	WK7Model			*pModel;
	mpJObj = NULL;
	if( pEffectInfo==NULL ){
		return;
	}
	if( (pModel = pEffectInfo->mpModel)!=NULL && (mpJObj = pModel->GetObj("Root"))!=NULL ){
		mpJObj->Hide(false,true);
		mpJObj->SetDstAlpha(WK7RenderObj::ConvRenderIDToAlpha(WK7RENDEROBJ_RENDERID_HALF+1),false,true);
	}
}

WK7PlayEffectInstance* K7PlayEf0010::CreateInstance(WK7JObj *pJObj)
{
	return new K7PlayEf0010Instance(this,&mInstanceAnchor,pJObj);
}

