////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Logo Task
//
// SK7ChangeDisk.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/05/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7CHANGEDISK_H__
#define	__SK7CHANGEDISK_H__

#include "SK7Common.h"
#include "SK7Sprite.h"
#include "../Yam/YK7String.h"
#include "../yam/YK7Effect.h"


//	`FbNNX
class SK7ChangeDisk : public ghmGcAppTask
{
	typedef enum{
		eKana=0,
		eFont,
		eLoadEffect,
		eTV,
	}eLoadProc;
	
	typedef enum{
		eLoad=0,
		eFade,
		eCheck,
		eSet,
		eEnd,
	}eProc;
	
protected:
	YK7StrImage* 		m_pYFont;	//tHg
	YK7StrImage* 		m_pYKana;	//J^Ji
	SK7Sprite			m_spTV;
	SK7Sprite			m_spBack;
	SK7File*			m_pFile;
	eLoadProc			m_eLoad;
	eProc				m_eProc;
	bool				m_bRender;
	bool				m_bMotorFlag;
	int					m_iDiskID;
	EFFECT*				m_pNoiseEffect;
	ghmGcTaskController *m_pTaskControl;	//	^XNRg[[

	bool				_FrameProcess();	//
public:
	SK7ChangeDisk(ghmGcApp *pApp,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~SK7ChangeDisk();

	// R[obN
	virtual bool InitializeCallBack(void);
	
	// IR[obN
	virtual bool TerminateCallBack(void);
	
	// t[
	virtual bool FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);

	bool Load();
};

#endif	//__SK7CHANGEDISK_H__



