////////////////////////////////////////////////////////////////////////////////
//
//
// Killer7 IMenuHato
//
// SK7IMenuHato.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/02/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7IMENUHATO_CPP__	
//#define		__DEBUG_MEMO__	
//	static int FRAME=1;
//	static f32 MOVERR = 0.1f;
//	static f32 MOVERAN = 1.5f;
//#define		__DEBUG_HATO__

#include "../wat/WK7GameInfo.h"
#include "../wat/K7GlobalFlag.h"
#include "../wat/WK7EventScript.h"
#include "../wat/WK7EventItem.h"
#include "../wat/WK7Event.h"
#include "SK7IMenuHato.h"
#include "../matsu/mK7Sound.h"
#include "../wat/WK7Stage.h"
#include "../wat/WK7Cam.h"
#include "../wat/WK7Light.h"
#include "SK7Common.h"

#define		LIGHT_FIRST_X		(30.53797f)
#define		LIGHT_FIRST_Y		(-7.761319f)
#define		LIGHT_Z				(9.562421f)
#define		HATO_POS_JUMP_Y			(0.7625057f)
#define		MEMO1_X					(50)
#define		MEMO1_Y					(70)
#define		MEMO1_Y2				(455)
#define		HATO_NAME_X				(500)
#define		HATO_NAME_Y				(190) 
#define		TITLE_SELECT_PLUS_X		(14)//(20)
#define		TITLE_LINE_SIZE			(25)
#define		TITLE_LINE_PLUS_Y		(30)
#define		LINE_UNDER_Y			(7.0f)
#define		TITLE_MEMO_SPEED		(5.0f)
#define		MEMO_LINE_NUM			(7)
#define		MEMO_SCROLL_FRAME		(5.0f)
#define		MEMO_TITLE_GAP_Y		(50)//(64)
#define		MEMO_RUBI_GAP_Y			(-15.0f)
#define		MEMO_RUBI_SIZE_W		(15)//13)
#define		MEMO_RUBI_SIZE_H		(16)
#define		MEMO_RUBI_NUM_X			(34)
#define		MEMO_RUBI_W				(15)
#define		MEMO_RUBI_H				(16)//(17)
#define		MEMO_MOVE_R				(2.0f)
#define		MEMO_MOVE_FRAME			(4.0f)//3.0f)
#define		MOVE_RANGE_X			(2.6f)//5.0f)			
#define		MOVE_RANGE_Y			(2.6f)//(5.0f)
#define		TITLE_SPACE_SIZE		(10.0f)
#define		HATO_MOVE_FRAME		(20)
#define		FONT_MEMO_GAPY		(48)//(42)//(24)//(23)
#define		FONT_MEMO_HNUM		(16)
#define		MOVE_ALPHA_FRAME	(16)
#define		MOVE_ALPHA_FRAME2	(32)
#define		MEMO_TITLE_FIRST_X	(50)
#define		MEMO_TWO_GAP_Y		(13)	
#define		SPACE_Z_SIZE		(26.0f)
#define		SPACE_Z_FONT_SIZE	(14.0f)
#define		MEMO_TITLE_SIZE		(23)
#define		TLINE_SIZE			(50)
#define		FONT_MEMOTITLE_Y	(40)
#define		MEMO_SIZE_PLUSY		(320)
#define		MEMO_UNDER_Y		(10.0f)
#define		FONT_COLOR_NUM		(5)
#define		FONT_RUBI_COLOR_P	(0x0051)
#define		FONT_RUBI_COLOR_Y	(0x0050)
#define		FONT_JIMAKU_COLOR	(0x0053)
#define		SCROLL_X			(520)
#define		SCROLL_Y			(425)
#define		SCROLL_FONT_SIZEX	(24)//2)
#define		SCROLL_FONT_TIME	(6)
#define		SCROLL_UP_Y			(-3.0f)
#define		COLOR_FIRST			(0xff2043ff)
#define		COLOR_SECOND		(0x32ccffff)
#define		HATO_PACK_DATA		"/item/Hato/hato.pak"


//	Cgݒ 	
static	HSD_WObjDesc shadow_dir_light_pos_wobjdesc = {
	NULL,
	{ LIGHT_FIRST_X, LIGHT_FIRST_Y, LIGHT_Z },		// wobj position
};
static	float	dir_light_shininess = 40.0f;
static	HSD_LightDesc dir_light = {
	NULL,
	NULL,										// CgN
	LOBJ_INFINITE|LOBJ_DIFFUSE|LOBJ_SPECULAR,	// CgtO
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	{0xff,0xff,0xff,0xff},						// color
	&shadow_dir_light_pos_wobjdesc,				// position
	NULL,
	&dir_light_shininess,
};

#define	SK7HATO_LIGHT_TYPE		(0xbfffffff)
#define	SK7HATO_LIGHT_ID		(3)

//	͂ƍW	-----------------------------------------------------------------
const Vec HatoPos={ 5.712502f, -5.0f, 3.275f };
const Vec HatoRot={ 0, -1.837499f, 0 };
//	Xe[WW	------------------------------------------------------------
const Vec StagePos={ 32.9f, -19.5f, 7.285f };
const Vec StageRot={ 0, -1.6f, 0 };


#define		HATO_TITLE_NAME		"item/hato/title/hatotitle.jmb"
const int tblMemoNo[]={ 
	K7GLFL_HATO_CEL_0, 
	K7GLFL_HATO_CEL_1,
	K7GLFL_HATO_FUK_0,	
	K7GLFL_HATO_FUK_1,	
	K7GLFL_HATO_FUK_2,	
	K7GLFL_HATO_TXS_0,	
	K7GLFL_HATO_CUR_0,	
	K7GLFL_HATO_SCL_0,
};

const u32 tblHatoFileNo[]={
	0x007201,
	0x007301,
	0x010001,
	0x010002,
	0x010003,
	0x020105,
	0x035001,
	0x055600,
};
	
const u8 tblEndTexNo[]={ HAT_TEX_E, HAT_TEX_N, HAT_TEX_D };
	
//========================================================================
//					RXgN^
//========================================================================
SK7IMenuHato::SK7IMenuHato( u32 MemoID ) : SK7IMenuBase()
{
	int i;
	
	m_bMemoVisibleFlag 		= false;
	m_bMemoTitleVisibleFlag = false;
	m_bScrollDir			= true;
	m_bHatoMoveFlag			= false;
	m_bMoveEffectFlag		= false;
	m_bOneFlag				= false;
	m_bReverseFlag			= false;
	m_ucMemoNo				= 0;
	m_fTitleSizeX			= 0.0f;
	m_fScrollX				= 0.0f;
	m_iScrollTime			= 0;
	m_ucMemoNum				= 0;
	m_iHatoMoveTime			= 0;
	m_fMoveTime				= 0;
	m_iScrollMoveTime		= 0;
	m_iKeyTime				= 0;
	m_iTitleMoveTime		= 0;
	m_ucPageNum				= 0;
	m_chScrollMoveNo		= (s8)0;
	m_MemoID				= MemoID;
	m_pEffect				= NULL;
	m_pLight				= NULL;
	m_eLoadProc 			= LOAD_PACK;
	m_Proc 					= PROC_LOAD;
	m_eSelectProc			= 0;
	m_sScenarioNo 			= 0;
	m_iTitleNo 				= 0;
	ghmGcMemSetAllocName("SK7HATO");
	m_pPack					= new SK7PackData;
	
	memset( &m_vEffectMove, 0,	sizeof( VEC2 ) * MEMO_MAX_FONT );
	memset( &m_vFontPos,	0,	sizeof( VEC2 ) * MEMO_MAX_FONT );
	memset( &m_vFontSavePos,0, 	sizeof( VEC2 ) * MEMO_MAX_FONT );
	memset( &m_vRubiPos,	0,	sizeof( VEC2 ) * MEMO_MAX_RUBI );
	memset( &m_vRubiSavePos,0,	sizeof( VEC2 ) * MEMO_MAX_RUBI );	
	memset( &m_fTitleMoveX, 0, 	sizeof( f32 ) * STAGE_MEMO_NUM );

	//	t@Cf[^	--------------------------------------------
	m_Data 				= NULL;
	m_SentenceDat 		= NULL;
	m_FParam 			= NULL;				
	m_Tex.Header 		= NULL;
	m_RubiTex.Header	= NULL;
	m_pMotionStageArc	= NULL;

	m_pModel 			= NULL;
	m_pStageModel		= NULL;
	m_pStageMotion		= NULL;		
	memset( m_pMotion, NULL, sizeof( WK7ModelMotion ) * HATO_MOT_MAX );

	//	ViIio[`FbN	----------------------------------------
	m_sScenarioNo = (u16)GameInfo.GetScenarioFlow();
	if( (s16)m_sScenarioNo == -1 )	m_sScenarioNo = 0;
	
	//	ng`FbN	---------------------------------------------
	memset(&m_bHasItem, 0, sizeof(bool)*STAGE_MEMO_NUM );
	
	for( i = 0; i < HATO_MEMO_MAX_NUM; i++ ){
		if( WK7EventItem::HasItem(K7EVITEM_HATOMEMOID( tblHatoFileNo[i] ))==true ){
			K7SCR_SET_GLOBAL_FLAG( tblMemoNo[i] );
		}
		if( K7SCR_GET_GLOBAL_FLAG( tblMemoNo[i] )==true ){
			m_bHasItem[i] = true;
			m_ucMemoNum++;
		}
	}

	//	Cg쐬	-----------------------------------
	ghmGcMemSetAllocName("SK7HATOLIGHT");
	m_pLight = WK7Light::Create(&dir_light,SK7HATO_LIGHT_TYPE,SK7HATO_LIGHT_ID);
}

//========================================================================
//					fXgN^
//========================================================================
SK7IMenuHato::~SK7IMenuHato()
{
	for( int i = 0; i < MEMO_PAGE_MAX; i++ ){
		m_FontTitle[i].Release();
	}	
	for( int i = 0; i < HATO_MOT_MAX; i++ ){
		GHM_SAFE_DELETE( m_pMotion[i] );
	}
	GHM_SAFE_DELETE( m_pStageMotion );
	GHM_SAFE_DELETE( m_pModel );
	GHM_SAFE_DELETE( m_pStageModel );

//	GHMGCMEM_SAFE_FREE( m_RubiTex.Header );
	
	GHMGCMEM_SAFE_FREE(m_Data);
	
//	for( int i = 0; i < SCROLL_FONT_NUM; i++ ){
//		m_spScroll[i].Delete();
//	}
	m_FontTitle[0].Delete();
	
	// Cg	--------------------------------------------------
	if( m_pLight != NULL )	WK7Light::Release(SK7HATO_LIGHT_TYPE,SK7HATO_LIGHT_ID);
	
	//	RcGtFNgJ	------------------------------------------
	if( m_pEffect != NULL )		DeleteEffect( m_pEffect );
	
	GHM_SAFE_DELETE( m_pPack );

}


//========================================================================
//	 				PĂяo悤
//========================================================================
bool  	SK7IMenuHato::FrameProcessOne(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	
	case PROC_LOAD:
		//	t@C`FbN		--------------------------------------------
		char name[255];
		sprintf( name, "item/hato/00/hato%06x.jmb", m_MemoID  );
		if( LoadDataOne(name) ){
			m_bOneFlag = true;
			SetMemoVertex();
			//	J̃|WV	-------------------------------------------------
			WK7CAM->SetPosition			(0.0f,0.0f,20.0f);
			WK7CAM->SetTargetPosition	(0.0f,0.0f,0.0f);
			WK7CAM->SetFov( 42.185f );
			
			m_bMemoVisibleFlag = true;
			gpSound->mPlaySE(SFX_SYS_MEM_PIGEONFLY,180);
			for( int i = 0; i < SCROLL_FONT_NUM; i++ ){
				m_spScroll[i].SetVisible( true );
			}
			
			m_Proc = PROC_MEMO_FONT;
		}
		break;
	
	//	eXN[	
	case PROC_MEMO_SCROLL:
		if( ScrollProcess( m_bScrollDir ) ){
			m_Proc = PROC_MEMO_FONT;
		}
		break;

	//		
	case PROC_MEMO_FONT:
		if( !m_bCtrl ){
			break;
		}
#ifdef __DEBUG_HATO__
		DEBUG_GET_MODEL_POS( m_pModel );
#endif
//	XN[tHgGtFNg
		MoveScrollFont();
		//	`
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_A ){
			gpSound->mPlaySE(SFX_SYS_MEM_MEKURU);
			m_bScrollDir = true;
			InitScroll();
			m_eSelectProc++;
			if( m_eSelectProc == m_ucPageNum-2 ){
				for( int a = 0; a < SCROLL_FONT_NUM-1; a++ ){
					m_spScroll[a].SetTexture( &m_Texture[tblEndTexNo[a]] );
					m_spScroll[a].SetColor( 0xe0202000 );
				}
				m_spScroll[SCROLL_FONT_NUM-1].SetVisible( false );
			}
			if( m_eSelectProc == m_ucPageNum-1 ){
				gpSound->mStopSE(SFX_SYS_MEM_PIGEONFLY);
				m_Proc = PROC_END;
				break;
			}
			m_Proc = PROC_MEMO_SCROLL;
			break;
		}
		//	a
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_B ){
			m_bScrollDir = false;
			if( m_eSelectProc == 0 )	break;
			InitScroll();		
			gpSound->mPlaySE(SFX_SYS_MEM_MEKURU);
			m_eSelectProc--;
			for( int i = 0; i < SCROLL_FONT_NUM; i++ ){
				m_spScroll[i].SetTexture( &m_Texture[i] );
				m_spScroll[i].SetColor( 0x00ff0000 );
				m_spScroll[i].SetVisible( true );
			}
			m_Proc = PROC_MEMO_SCROLL;
			break;
		}
		break;
		
	//	I	
	case PROC_END:
		break;
	}
	if( m_pModel != NULL )			m_pModel->FrameProcess();
	if( m_pStageModel != NULL )		m_pStageModel->FrameProcess();
	return true;
}

//========================================================================
//					t[
//========================================================================
bool  	SK7IMenuHato::FrameProcess(void)
{
	m_iKeyTime++;
	
	switch( m_Proc )
	{
	//	f[^[h@	
	case PROC_LOAD:
		if( LoadData() )
		{
			m_Proc = PROC_CAMERA;//PROC_MEMO_TITLE;
		}
		break;
		
	case PROC_CAMERA:
		//	J̃|WV	-------------------------------------------------
		WK7CAM->SetPosition(-1.558594f,1.367132f,19.57390f);
		WK7CAM->SetTargetPosition(-0.5478001f,0.1318155f,7.680528f);
		WK7CAM->SetFov( 42.185f );
		WK7CAM->SetMode				( WK7Cam::WK7CAM_FREE_TARGET );
		m_Proc = PROC_MEMO_TITLE;
		break;
		
	//	^Cg	
	case PROC_MEMO_TITLE:
		
		//	̈ړ^C{{	-----------------------------------------------
		m_iTitleMoveTime++;
		for( int i = 0; i < HATO_MEMO_MAX_NUM; i++ ){
			if( i == m_iTitleNo ){
				m_fTitleMoveX[i] += TITLE_MEMO_SPEED;
				if( m_fTitleMoveX[i] >= TITLE_SELECT_PLUS_X ){
					m_fTitleMoveX[i] = TITLE_SELECT_PLUS_X;
				}
			}else{
				m_fTitleMoveX[i] -= TITLE_MEMO_SPEED;
				if( m_fTitleMoveX[i] <= 0.0f ){
					m_fTitleMoveX[i] = 0.0f;
				}		
			}
			m_FontTitle[i].SetBetween( m_fTitleMoveX[i], 0.0f );
		}
	
#ifdef __DEBUG_HATO__
	if( HSD_PadGetTrigger(0) & PAD_BUTTON_START )
	{
		m_pModel->AttachMotion( m_pMotion[HATO_MOT_JUMP] );
		m_pModel->PlayMotion(0.0f, true, 10);
		m_Proc = PROC_HATO_CHECK;
	}
	break;
#else
		if( !m_bCtrl ) break;
		//	
		if( CheckKeyR( SK7_KEY_UP ) ){
			m_iKeyTime = 0;
			if( m_ucMemoNum == 0 ) break;
			if( --m_iTitleNo < 0 ){
				m_iTitleNo = m_ucMemoNum-1;
				break;
			}
			gpSound->mPlaySE(SFX_SYS_MEMO_SEL);
			break;
		}
		//	
		if( CheckKeyR( SK7_KEY_DOWN )){
			m_iKeyTime = 0;
			if( m_ucMemoNum == 0 ) break;
			if( ++m_iTitleNo > m_ucMemoNum-1 ){
				m_iTitleNo = 0;//m_ucMemoNum-1;
				break;
			}
			gpSound->mPlaySE(SFX_SYS_MEMO_SEL);
			break;
		}
		//	`
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			if( m_ucMemoNum <= 0 ){
				gpSound->mPlaySE( SFX_SYS_SUBSCREEN_BOO );
				break;
			}
//			if( !m_bHasItem[m_iTitleNo] )	break;
			//	memo
			gpSound->mPlaySE(SFX_SYS_MEM_PIGEONFLY,180);
			gpSound->mPlaySE(SFX_SYS_DECIDE);
			m_pModel->DetachMotion();
			m_pModel->AttachMotion( m_pMotion[HATO_MOT_JUMP] );
			m_pModel->PlayMotion(0.0f, true, 10);
			m_pModel->SetMotionLoop(false);
			m_Proc = PROC_HATO_CHECK;
			break;
		}
		//	a
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			gpSound->mPlaySE( SFX_SYS_SUBSCREEN_CANSEL );
			m_Proc = PROC_END;
			break;
		}
#endif
		break;
	
	//	^Cg莞̂͂ƃ`FbN		
	case PROC_HATO_CHECK:
		MoveJumpHato(true);
		bool LoadFlag = LoadFont();
		if( m_bHatoMoveFlag && LoadFlag && AOBJ_ANIM_LOOP != m_pModel->GetMotionState() ){
			SetMemoVertex();

			m_bHatoMoveFlag			= false;
			m_bMemoTitleVisibleFlag = false;
			m_bMemoVisibleFlag 		= true;
	
			m_pModel->DetachMotion();
			m_pModel->AttachMotion( m_pMotion[HATO_MOT_LOOP] );
			m_pModel->PlayMotion(0.0f, true, 10);
			m_pModel->SetMotionLoop(true);

			for( int i = 0; i < SCROLL_FONT_NUM; i++ ){
				m_spScroll[i].SetVisible( true );
			}
			m_Proc = PROC_MEMO_FONT;
		}
		break;
		
	//	^Cgɖ߂͂Ƃ̃`FbN		
	case PROC_HATO_CHECK_RETURN:
		MoveJumpHato(false);
		if( m_bHatoMoveFlag && AOBJ_ANIM_LOOP != m_pModel->GetMotionState() )
		{
			gpSound->mStopSE(SFX_SYS_MEM_PIGEONFLY);
			m_Tex.Header = NULL;
			m_bMemoTitleVisibleFlag = true;
			m_bMemoVisibleFlag 		= false;
			m_bHatoMoveFlag 		= false;

			m_pModel->DetachMotion();
			m_pModel->AttachMotion( m_pMotion[HATO_MOT_STOP] );
			m_pModel->PlayMotion(0.0f, true, 10);
			m_pModel->SetMotionLoop(true);
			GHMGCMEM_SAFE_FREE(m_Data);
			
			m_Proc = PROC_MEMO_TITLE;
		}
		break;

	//	eXN[	
	case PROC_MEMO_SCROLL:
		if( ScrollProcess( m_bScrollDir ) ){
			m_Proc = PROC_MEMO_FONT;
		}
		break;

	//		
	case PROC_MEMO_FONT:

		//	XN[tHgGtFNg
		MoveScrollFont();
		
		//	`
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_A ){
			gpSound->mPlaySE(SFX_SYS_MEM_MEKURU);
			m_bScrollDir = true;
			InitScroll();
			m_eSelectProc++;
			if( m_eSelectProc == m_ucPageNum-2 ){
				for( int a = 0; a < SCROLL_FONT_NUM-1; a++ ){
					m_spScroll[a].SetTexture( &m_Texture[tblEndTexNo[a]] );
					m_spScroll[a].SetColor( 0xe0202000 );
				}
				m_spScroll[SCROLL_FONT_NUM-1].SetVisible( false );
			}
			if( m_eSelectProc == m_ucPageNum-1 ){
				gpSound->mStopSE(SFX_SYS_MEM_PIGEONFLY);
				m_Proc = PROC_END;
				break;
			}
			m_Proc = PROC_MEMO_SCROLL;
			break;
		}
		//	a
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_B ){
			gpSound->mPlaySE(SFX_SYS_MEM_MEKURU);
			m_bScrollDir = false;
			InitScroll();
			if( m_eSelectProc == 0 ){
				m_pModel->DetachMotion();
				m_pModel->AttachMotion( m_pMotion[HATO_MOT_LAND] );
				m_pModel->PlayMotion(0.0f, true, 10);
				m_pModel->SetMotionLoop(false);
				for( int i = 0; i < SCROLL_FONT_NUM; i++ ){
					m_spScroll[i].SetVisible( false );
				}
								
				m_Proc = PROC_HATO_CHECK_RETURN;
				break;
			}
			for( int i = 0; i < SCROLL_FONT_NUM; i++ ){
				m_spScroll[i].SetTexture( &m_Texture[i] );
				m_spScroll[i].SetColor( 0x00ff0000 );
				m_spScroll[i].SetVisible( true );
			}
			m_eSelectProc--;
			m_Proc = PROC_MEMO_SCROLL;
			break;
		}
		break;
		
	//	I	
	case PROC_END:
		break;
	}

	if( m_pModel != NULL )			m_pModel->FrameProcess();
	if( m_pStageModel != NULL )		m_pStageModel->FrameProcess();
	return true;
}

//========================================================================
//					_O
//========================================================================
bool 	SK7IMenuHato::RenderProcess(void)
{
	if( !m_bRender )	return true;
			
	//	[hύXifwi̐OɁj
	GXSetZMode( GX_TRUE, GX_LEQUAL, GX_TRUE );
	
	// JgJݒ
	if(WK7CAM->SetCurrent()==true ){
		WK7Light::DispStart();
		m_pLight->Disp();
		WK7Light::DispEnd();
		
		if( m_pStageModel	!= NULL )	m_pStageModel->RenderProcess();
		if( m_pModel 		!= NULL )	m_pModel->RenderProcess();
		WK7CAM->RenderProcess();

		// JgJł̕`I
		WK7CAM->EndCurrent();
	}

	RenderMemo();
	
	for( int i =  0; i < SCROLL_FONT_NUM; i++ ){
		m_spScroll[i].Render();
	}
	
	RenderMemoTitle();

	return true;
}

//========================================================================
//					t@CǂݍݏI擾֐
//========================================================================
bool 	SK7IMenuHato::GetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD ){
		return true;
	}
	return false;
}

//========================================================================
//					j[I֐
//========================================================================
bool 	SK7IMenuHato::GetMenuEnd(void)
{
	if( m_Proc == PROC_END ){
		return true;
	}
	return false;
}

//========================================================================
//					f[^[h
//========================================================================
bool	SK7IMenuHato::LoadData(void)
{
	int i;
	switch( m_eLoadProc )
	{
	case LOAD_PACK:
		if( m_pPack->OpenPack( HATO_PACK_DATA )){
			//	͂	-------------------------------------------------
			m_pPack->GetModel( &m_pArchive, &m_pModel, HAT_DATA_HATO );
			m_pModel->Disp();
			m_pModel->SetPosition( HatoPos.x, HatoPos.y, HatoPos.z );
			m_pModel->SetRotation( HatoRot.x, HatoRot.y, HatoRot.z );
			//	Xe[W	--------------------------------------------
			m_pPack->GetModel( &m_pStageArchive, &m_pStageModel, HAT_DATA_STAGE );			
			m_pStageModel->SetPosition( StagePos.x,	StagePos.y, StagePos.z );
			m_pStageModel->SetRotation( 0.0f, 			StageRot.y, 	0.0f );
			m_pStageModel->Disp();
			//	Xe[W[V		--------------------------------
			m_pPack->GetMotion( &m_pMotionStageArc, &m_pStageMotion, HAT_DATA_STAGE_MOTION );			
			m_pStageModel->AttachMotionAll( m_pStageMotion );
			m_pStageModel->PlayMotionAll(0.0F);
			//	͂ƃ[V		--------------------------------
			for( i = 0; i < HATO_MOT_MAX; i++ ){
				m_pPack->GetMotion( &m_pMotionArc[HATO_MOT_STOP+i], &m_pMotion[HATO_MOT_STOP+i], HAT_DATA_MOTION_STOP+i );
			}
			m_pModel->AttachMotion( m_pMotion[HATO_MOT_STOP] );
			m_pModel->PlayMotion(0.0F);
			//	XN[	------------------------------------------
			for( int i = 0; i < HAT_TEX_MAX; i++ ){
				m_pPack->GetTexture( &m_Texture[i], HAT_DATA_MAX+HAT_TEX_N+i );
				if( i < SCROLL_FONT_NUM ){
					m_spScroll[i].SetTexSprite( SCROLL_X+SCROLL_FONT_SIZEX*i,SCROLL_Y, &m_Texture[i] );
					m_spScroll[i].SetVisible(false);
					m_spScroll[i].SetColor( 0x00ff0000 );
				}
			}
			//	r	------------------------------------------
			m_RubiTex.Header = gpJimaku->mGetRubiTexPtr();
			InitTexture( &m_RubiTex );
			m_eLoadProc = LOAD_FONT;
		}
		break;

	case LOAD_FONT:
		if( m_FontTitle[0].LoadFont( HATO_TITLE_NAME ) ){
			int num=0;
			for( int i = 0; i < HATO_MEMO_MAX_NUM; i++ ){
				if( m_bHasItem[i] ){
					m_FontTitle[num].SetData	( m_FontTitle[0].GetData(), 0, (u8)i );					
					m_FontTitle[num].SetSpace( TITLE_SPACE_SIZE );
					num++;
				}
				if( i < m_ucMemoNum ){
					m_FontTitle[i].SetPos	( MEMO_TITLE_FIRST_X + m_fScrollX, FONT_MEMOTITLE_Y + i * MEMO_TITLE_GAP_Y );
					m_FontTitle[i].SetColor	( 0xffffff7f );
					m_FontTitle[i].SetFlag	( true, FONT_EFC_RENDER );
				}else{
					m_FontTitle[i].SetFlag	( false, FONT_EFC_RENDER );
				}
			}
			m_bMemoTitleVisibleFlag = true;
			return true;
		}
		break;
	}
	return false;
}

//========================================================================
//					tHgf[^[h
//========================================================================
bool	SK7IMenuHato::LoadFont(void)
{	
	char filename[255];	
	for( int i = 0, num=0; i < HATO_MEMO_MAX_NUM; i++ ){
		if( m_bHasItem[i] ){
			if( num == m_iTitleNo ){
				sprintf( filename, "item/hato/00/hato%06x.jmb", tblHatoFileNo[i] );
				break;
			}else{
				num++;
			}
		}
	}
	if( SetFontProcess( filename )){
		return true;
	}	
	return false;
}

//========================================================================
//					1tHgf[^[h
//========================================================================
bool	SK7IMenuHato::LoadDataOne( char* MemoData )
{
	switch( m_eLoadProc )
	{
	case LOAD_PACK:
		if( m_pPack->OpenPack( HATO_PACK_DATA )){
			//	͂	-------------------------------------------------
			m_pPack->GetModel( &m_pArchive, &m_pModel, HAT_DATA_HATO );
			m_pModel->Disp();
			m_pModel->SetPosition( HatoPos.x, HATO_POS_JUMP_Y, HatoPos.z );
			m_pModel->SetRotation( HatoRot.x, HatoRot.y, HatoRot.z );
			//	Xe[W	--------------------------------------------
			m_pPack->GetModel( &m_pStageArchive, &m_pStageModel, HAT_DATA_STAGE );			
			m_pStageModel->SetPosition( StagePos.x,	StagePos.y, StagePos.z );
			m_pStageModel->SetRotation( 0.0f, 			StageRot.y, 	0.0f );
			m_pStageModel->Disp();
			//	Xe[W[V		--------------------------------
			m_pPack->GetMotion( &m_pMotionStageArc, &m_pStageMotion, HAT_DATA_STAGE_MOTION );			
			m_pStageModel->AttachMotionAll( m_pStageMotion );
			m_pStageModel->PlayMotionAll(0.0F);
			//	͂ƃ[V		--------------------------------
			m_pPack->GetMotion( &m_pMotionArc[HATO_MOT_LOOP], &m_pMotion[HATO_MOT_LOOP], HAT_DATA_MOTION_LOOP );
			m_pModel->AttachMotion( m_pMotion[HATO_MOT_LOOP] );
			m_pModel->PlayMotion(0.0F);
			//	XN[	------------------------------------------
			for( int i = 0; i < HAT_TEX_MAX; i++ ){
				m_pPack->GetTexture( &m_Texture[i], HAT_DATA_MAX+HAT_TEX_N+i );
				if( i < SCROLL_FONT_NUM ){
					m_spScroll[i].SetTexSprite( SCROLL_X+SCROLL_FONT_SIZEX*i,SCROLL_Y, &m_Texture[i] );
					m_spScroll[i].SetVisible(false);
					m_spScroll[i].SetColor( 0x00ff0000 );
				}
			}
			//	r	------------------------------------------
			m_RubiTex.Header = gpJimaku->mGetRubiTexPtr();
			InitTexture( &m_RubiTex );
			m_eLoadProc = LOAD_FONT;
		}
		break;
	case LOAD_FONT:
		if( SetFontProcess( MemoData ) ){
			return true;
		}
		break;
	}
	return false;
}
			

//========================================================================
//					XN[
//========================================================================
bool 	SK7IMenuHato::ScrollProcess( bool State )
{	
	if( State ){
		m_fScrollX 		-= (640.0f/MEMO_SCROLL_FRAME);
	}else{
		m_fScrollX 		+= (640.0f/MEMO_SCROLL_FRAME);
	}
	
	if( ++m_iScrollTime >= MEMO_SCROLL_FRAME ){
		m_iScrollTime = 0;
		return true;
	}
	
	return false;
}

//========================================================================
//					͂Ƃ̈ړ
//========================================================================
bool		SK7IMenuHato::MoveJumpHato( bool State )
{
	if( m_bHatoMoveFlag )	return true;
	
	Vec vPos;
	m_pModel->GetPosition( vPos );

	if( State ){
		vPos.y += (HATO_POS_JUMP_Y - HatoPos.y) / HATO_MOVE_FRAME;
	}else{
		vPos.y -= (HATO_POS_JUMP_Y - HatoPos.y) / HATO_MOVE_FRAME;
	}
	m_pModel->SetPosition( vPos );
	
	if( ++m_iHatoMoveTime >= HATO_MOVE_FRAME ){
		m_iHatoMoveTime = 0;
		m_bHatoMoveFlag	= true;
		return true;
	}
	return false;
}

//========================================================================
//					GtFNg
//========================================================================
void		SK7IMenuHato::InitScroll()
{
	for( int i = 0; i < SCROLL_FONT_NUM; i++ ){
		m_spScroll[i].SetAlpha( 0 );
		m_bEndFontFlag[i] = false;
	}
	m_iScrollMoveTime = 0;
	m_bReverseFlag = false;
}


//========================================================================
//					tHg̓GtFNg
//========================================================================
void		SK7IMenuHato::MoveScrollFont(void)
{
	int i;
	for( i = 0; i < m_iScrollMoveTime+1; i++ ){
		if( m_bEndFontFlag[i] ){
			if( m_spScroll[i].DownAlpha(MOVE_ALPHA_FRAME2) ){
				m_bEndFontFlag[i] = false;
			}
		}else{
			if( m_spScroll[i].AddAlpha(MOVE_ALPHA_FRAME2) ){
				m_bEndFontFlag[i] = true;
			}
			if( m_spScroll[m_iScrollMoveTime].GetAlpha() >= 255/3 ){
				m_iScrollMoveTime++;
				if( m_eSelectProc == m_ucPageNum-2 ){
					if( m_iScrollMoveTime >= 2 ){
						m_iScrollMoveTime = 2;
					}
				}else{
					if( m_iScrollMoveTime >= 3 ){
						m_iScrollMoveTime = 3;
					}
				}
			}
		}
	}
#if 0
	if( m_eSelectProc == m_ucPageNum-2 ){
		for( i = 0; i < m_iScrollMoveTime+1; i++ ){
			if( m_bEndFontFlag[i] ){
				if( m_spScroll[i].DownAlpha(MOVE_ALPHA_FRAME2) ){
					m_bEndFontFlag[i] = false;
				}
			}else{
				if( m_spScroll[i].AddAlpha(MOVE_ALPHA_FRAME2) ){
					m_bEndFontFlag[i] = true;
				}
				if( m_spScroll[m_iScrollMoveTime].GetAlpha() >= 255/3 ){
					if( ++m_iScrollMoveTime >= 2 ){
						m_iScrollMoveTime = 2;
					}
				}
			}
		}
	}else{
		if( !m_bReverseFlag ){
			if( m_spScroll[m_iScrollMoveTime].AddAlpha(MOVE_ALPHA_FRAME) ){
				m_iScrollMoveTime++;		
			}
		}else{
			if( m_spScroll[m_iScrollMoveTime].DownAlpha(MOVE_ALPHA_FRAME) ){
				m_iScrollMoveTime++;		
			}
		}
		if( m_iScrollMoveTime > SCROLL_FONT_NUM-1 ){
			m_bReverseFlag = (m_bReverseFlag==true) ? false : true;
			m_iScrollMoveTime = 0;
		}
	}
#endif
}

//========================================================================
//					tHgf[^`FbN
//========================================================================
int		SK7IMenuHato::CheckMemoNoFirst(void)
{
	for( int i = 0; i < STAGE_MEMO_NUM; i++ ){
		if( m_bHasItem[i] ){
			return i;
		}
	}
	return 0;
}

//========================================================================
//					tHgf[^`FbN
//========================================================================
int		SK7IMenuHato::CheckMemoNoMove(bool flag)
{
	int i = 0;
	//	Eړ̂Ƃ{{
	if( flag ){
		for( i = (int)m_iTitleNo+1; i < STAGE_MEMO_NUM; i++ ){
			if( m_bHasItem[i] ){
				return i;
			}
		}
		for( i = 0; i < m_iTitleNo+1; i++ ){
			if( m_bHasItem[i] ){
				return i; 
			}
		}
	}else{
		for( i = m_iTitleNo-1; i >= 0; i-- ){
			if( m_bHasItem[i] ){
				return i;
			}
		}
		for( i = STAGE_MEMO_NUM-1; i > m_iTitleNo-1; i-- ){
			if( m_bHasItem[i] ){
				return i;
			}
		}
	}
	return m_iTitleNo;
}


//========================================================================
//					[h
//========================================================================
bool		SK7IMenuHato::SetFontProcess( char* FileName )
{
	if( m_Tex.Header != NULL )	return true;
	
	//	f[^ݒ
	if( m_File.OpenDataFile( FileName, &((void*)m_Data)))
	{
		//̓f[^ւ̃AhXݒ
		m_SentenceDat = (stOneSentence*)((char*)m_Data + m_Data->offset);
		//uvwhf[^ւ̃AhXݒ
		m_FParam = (stFontParam*)((char*)m_Data + m_Data->charOffset);
		//eNX`AhẌn
		m_Tex.Header = (GhmGcTexHeader*)((char*)m_Data + m_Data->texOffset);
		//eNX`̏
		InitTexture( &m_Tex );
		
		m_ucPageNum = (u8)m_Data->num;
					
		return true;
	}
	return false;
}

#if 0
//========================================================================
//					y[W擾
//========================================================================
void		SK7IMenuHato::GetPageNum()
{
	for( int b = 0; b < MEMO_PAGE_MAX; b++ ){
		stJimaku* pJimaku = &m_SentenceDat[b].jimaku;
	}
}
#endif

//========================================================================
//					WZbg
//========================================================================
void		SK7IMenuHato::SetMemoVertex()
{
	int string, SpaceNum, iFontNo = 0, num = 0, iRubiNo = 0;
	f32 KanjiSize = 0.0f;
	
	//	p^[
	for( int b = 0; b < m_ucPageNum-1; b++ ){
		//	s
		for( int a = 0; a < FONT_MEMO_HNUM; a++ ){
			string = SpaceNum = 0;
			stJimaku* pJimaku = &m_SentenceDat[b].jimaku[a];
			
			//	XgO`FbN
			if( (u16)pJimaku->chardat[string] == JIMAKU_NO_FONT ||
				(u16)pJimaku->chardat[string] == JIMAKU_RETURN ){
				continue;
			}
			
			//	}
			for( string = 0; (u16)pJimaku->chardat[string] != JIMAKU_NO_FONT; string++ ){
				if( (u16)pJimaku->chardat[string] == JIMAKU_RETURN 	||
					(u16)pJimaku->chardat[string] == JIMAKU_SPACE_H ||
					(u16)pJimaku->chardat[string] == JIMAKU_SPACE_Z ){
						SpaceNum++;
				}
			}
			//	񐔂B(Xy[X)
			u16 sFontNum =(u16)(string - SpaceNum);

			//	s̃r̐𐔂	--------------------------------------------
			num = 0;
			int r;
			int	WordNum[10];
			memset( &WordNum, 0, sizeof(int)*10 );
			
			while(1)
			{
				if( pJimaku->rubidat[num].fromNum == -1 || pJimaku->rubidat[num].toNum == -1 ){
					break;
				}
				r = 0;
				while( (u16)pJimaku->rubidat[num].charID[r] != JIMAKU_NO_FONT ){
					r++;
				}
				WordNum[num] = r;
				num++;
			}
			
			f32 PosX=0.0f;
			
			//	
			for( int i = 0; i < string; i++ , iFontNo++ )
			{
				if( (u16)pJimaku->chardat[i] == JIMAKU_SPACE_Z ||
					(u16)pJimaku->chardat[i] == JIMAKU_RETURN  ||
					(u16)pJimaku->chardat[i] == JIMAKU_SPACE_H ){
					continue;
				}

				if( i > 0 ){
					if( (u16)pJimaku->chardat[i-1] == JIMAKU_SPACE_Z ){
						if( i-1 == 0 ){
							PosX += 20.0f;
						}else{						
							PosX += 32.0f;
						}
					}else{
						PosX += m_FParam[pJimaku->chardat[i-1]].w;
					}
				}
				if( (s16)(pJimaku->chardat[i] & (s16)JIMAKU_FLAG_SATSU) ){
					pJimaku->chardat[i] =  (s16)(pJimaku->chardat[i] & ~(s16)JIMAKU_FLAG_SATSU);
				}
				if( (s16)(pJimaku->chardat[i] & (s16)JIMAKU_FLAG_SHI) ){
					pJimaku->chardat[i] =  (s16)(pJimaku->chardat[i] & ~(s16)JIMAKU_FLAG_SHI);
				}
								
				m_vFontSavePos[iFontNo].x = m_vFontPos[iFontNo].x = MEMO1_X + PosX + ( b * 640.0f );
				m_vFontSavePos[iFontNo].y = m_vFontPos[iFontNo].y = ((MEMO1_Y2-MEMO1_Y)/MEMO_LINE_NUM)*a+MEMO1_Y; //MEMO1_Y + a * FONT_MEMO_GAPY;
			}
			
			//		r	
			
			num = 0;
			while(1)
			{
				//	rf[^`FbN
				if( pJimaku->rubidat[num].fromNum == -1 || pJimaku->rubidat[num].toNum == -1 ){
					break;
				}
				if( pJimaku->rubidat[num].charID[0] == FONT_JIMAKU_COLOR ){
					break;
				}
				
				for( int c = 0; pJimaku->rubidat[num].charID[c] >= 0; c++, iRubiNo++ )
				{
					if( (u16)pJimaku->rubidat[num].charID[c] == FONT_RUBI_COLOR_Y ){		//	rf[^̐F
						iRubiNo--;
						continue;
					}
					if( (u16)pJimaku->rubidat[num].charID[c] == FONT_RUBI_COLOR_P ){
						iRubiNo--;
						continue;
					}
					KanjiSize = GetKanjiSize( pJimaku, (int)pJimaku->rubidat[num].fromNum, (int)pJimaku->rubidat[num].toNum );
					f32 HalfX = ( KanjiSize - ( WordNum[num] * MEMO_RUBI_SIZE_W )) / 2.0f;

					m_vRubiSavePos[iRubiNo].x = m_vRubiPos[iRubiNo].x = HalfX + MEMO1_X + ( c * MEMO_RUBI_SIZE_W ) + GetFontPosition( pJimaku, (int)pJimaku->rubidat[num].fromNum ) + ( b * 640.0f );
					m_vRubiSavePos[iRubiNo].y = m_vRubiPos[iRubiNo].y = ((MEMO1_Y2-MEMO1_Y)/MEMO_LINE_NUM)*a+MEMO1_Y+MEMO_RUBI_GAP_Y;//MEMO1_Y + a * FONT_MEMO_GAPY + MEMO_RUBI_GAP_Y;
				}
				num++;
			}
		}
	}
}



//========================================================================
//					`
//========================================================================
void		SK7IMenuHato::RenderMemo()
{
#ifdef	__DEBUG_MEMO__
	if( HSD_PadGetRepeat(0) & HSD_PAD_UP )		FRAME++;
	if( HSD_PadGetRepeat(0) & HSD_PAD_DOWN )	FRAME--;
	if( HSD_PadGetRepeat(0) & HSD_PAD_RIGHT )	MOVERR+=0.1f;
	if( HSD_PadGetRepeat(0) & HSD_PAD_LEFT )	MOVERR-=0.1f;
	if( HSD_PadGetRepeat(0) & HSD_PAD_R )		MOVERAN+=0.1f;
	if( HSD_PadGetRepeat(0) & HSD_PAD_L )		MOVERAN-=0.1f;
#endif

	int string, SpaceNum, RubiNum, iFontNo = 0, iRubiNo = 0;
	f32	NameSize=0.0f;
	
	if( !m_bMemoVisibleFlag )		return;
	
	//	̕`FW	-------------------------------------------
	if( m_fMoveTime++ > MEMO_MOVE_FRAME*2 ){
		m_fMoveTime = 0;
		SetEffectMove();
	}
	
	for( int b = 0; b < m_ucPageNum; b++ ){
		//	͂Ƃ̖OoȂB
//		if( b == MEMO_FONT_NUM-1 && m_Proc == PROC_HATO_CHECK_RETURN ){
//			continue;
//		}
		
		for( int a = 0; a < FONT_MEMO_HNUM; a++ ){
			string = SpaceNum = 0;
			stJimaku* pJimaku = &m_SentenceDat[b].jimaku[a];
			
			//	XgO`FbN
			if( (u16)pJimaku->chardat[string] == JIMAKU_NO_FONT ||
				(u16)pJimaku->chardat[string] == JIMAKU_RETURN ){
				continue;
			}
			
			//	}
			for( string = 0; (u16)pJimaku->chardat[string] != JIMAKU_NO_FONT; string++ ){
				if( (u16)pJimaku->chardat[string] == JIMAKU_RETURN 	||
					(u16)pJimaku->chardat[string] == JIMAKU_SPACE_H ||
					(u16)pJimaku->chardat[string] == JIMAKU_SPACE_Z )
				{
					SpaceNum++;
				}else{
					if( b == m_ucPageNum-1 ){
						NameSize += (u16)m_FParam[pJimaku->chardat[string]].w;
					}
				}
			}
			//	񐔂B(Xy[X)
			u16 sFontNum =(u16)(string - SpaceNum);
			
			//	s̃r̐𐔂	--------------------------------------------
			RubiNum = 0;
			int r, _rubinum=0,  num = 0, ColorNum = 0;
			FONT_COLOR	FontColor[FONT_COLOR_NUM];
			memset( &FontColor, -1, sizeof(FONT_COLOR)*FONT_COLOR_NUM );
			
			while(1){
				if( pJimaku->rubidat[num].fromNum == -1 || pJimaku->rubidat[num].toNum == -1 ){
					break;
				}
				r = 0;
				_rubinum=0;
				while( (u16)pJimaku->rubidat[num].charID[r] != JIMAKU_NO_FONT ){
					if( (u16)pJimaku->rubidat[num].charID[0] == FONT_JIMAKU_COLOR ){		//	rf[^uvł͂܂̂ŐFÂB
						FontColor[ColorNum].FirstNo	= pJimaku->rubidat[num].fromNum;
						FontColor[ColorNum].LastNo 	= pJimaku->rubidat[num].toNum;
						FontColor[ColorNum].ColorNo = ( pJimaku->rubidat[num].charID[1] == 0x000C ) ? (s8)0 : (s8)1;
						ColorNum++;
						break;
					}
					if( (u16)pJimaku->rubidat[num].charID[r] == FONT_RUBI_COLOR_Y ){		//	rf[^̐F
						_rubinum--;
					}
					if( (u16)pJimaku->rubidat[num].charID[r] == FONT_RUBI_COLOR_P ){
						_rubinum--;
					}
					_rubinum++;
					r++;
				}
				RubiNum += _rubinum;
				num++;
			}
			
			//	ݒ	--------------------------------------------
			Set2DCamera();
			SetGraphMode();
			SetTevStage();
			SetVertex();

			//	eNX`[Zbg	---------------------------------------------------------------------
			GXLoadTexObj( &m_Tex.Obj, GX_TEXMAP0 );			//	p
			
			f32 PosX=0.0f;
			f32 X1, X0, Y1, Y0;
			u32	Color = 0xffffffff;
			ColorNum = 0;			//	J[ԍ

			const int PlusX[]={0,0,1,-1};
			const int PlusY[]={1,-1,0,0};
			int n = 0;
			u32	SColor = 0x000000ff;
			
			//	v~eBu쐬	----------------------------------------------------------------------
			GXBegin( GX_QUADS, GX_VTXFMT0, (u16)(4 * sFontNum * 5) );
			
			for( int i = 0; i < string; i++ , iFontNo++ ){
				if( (u16)pJimaku->chardat[i] == JIMAKU_SPACE_Z ||
					(u16)pJimaku->chardat[i] == JIMAKU_RETURN  ||
					(u16)pJimaku->chardat[i] == JIMAKU_SPACE_H ){
					continue;
				}
				if( i > 0 ){
					if( (u16)pJimaku->chardat[i-1] == JIMAKU_SPACE_Z ){
						if( i-1 == 0 ){
							PosX += 20.0f;
						}else{
							PosX += 32.0f;
						}
					}else{
						PosX += m_FParam[pJimaku->chardat[i-1]].w;
					}
				}

				if( (s16)(pJimaku->chardat[i] & (s16)JIMAKU_FLAG_SATSU) ){
					pJimaku->chardat[i] =  (s16)(pJimaku->chardat[i] & ~(s16)JIMAKU_FLAG_SATSU);
				}
				if( (s16)(pJimaku->chardat[i] & (s16)JIMAKU_FLAG_SHI) ){
					pJimaku->chardat[i] =  (s16)(pJimaku->chardat[i] & ~(s16)JIMAKU_FLAG_SHI);
				}
				//	WJ[ݒ	------------------------------------------------
				if( b == m_ucPageNum-1 ){
					X0 		= HATO_NAME_X + PosX + (130.0f-NameSize)*0.5f;
					X1 		= HATO_NAME_X + PosX + m_FParam[pJimaku->chardat[i]].w+(130.0f-NameSize)*0.5f;
					Y0 		= HATO_NAME_Y;
					Y1 		= HATO_NAME_Y + m_FParam[pJimaku->chardat[i]].h;
					Color	= 0x009000ff;
				}else{
						f32	EffectMoveX = 0.0f;
						f32	EffectMoveY	= 0.0f;
#ifdef __DEBUG_MEMO__
						if( m_vFontPos[iFontNo].x >= m_vFontSavePos[iFontNo].x + MOVERAN ){
							m_vFontPos[iFontNo].x = m_vFontSavePos[iFontNo].x + MOVERAN;
//							m_vEffectMove[iFontNo].x = -m_vEffectMove[iFontNo].x;
						}
						if( m_vFontPos[iFontNo].x <= m_vFontSavePos[iFontNo].x - MOVERAN ){
							m_vFontPos[iFontNo].x = m_vFontSavePos[iFontNo].x - MOVERAN;
//							m_vEffectMove[iFontNo].x = -m_vEffectMove[iFontNo].x;
						}
						if( m_vFontPos[iFontNo].y >= m_vFontSavePos[iFontNo].y + MOVERAN ){
							m_vFontPos[iFontNo].y = m_vFontSavePos[iFontNo].y + MOVERAN;
//							m_vEffectMove[iFontNo].y = -m_vEffectMove[iFontNo].y;
						}
						if( m_vFontPos[iFontNo].y <= m_vFontSavePos[iFontNo].y - MOVERAN ){
							m_vFontPos[iFontNo].y = m_vFontSavePos[iFontNo].y - MOVERAN;
//							m_vEffectMove[iFontNo].y = -m_vEffectMove[iFontNo].y;
						}
#else
						if( m_vFontPos[iFontNo].x >= m_vFontSavePos[iFontNo].x + MOVE_RANGE_X ){
							m_vFontPos[iFontNo].x = m_vFontSavePos[iFontNo].x + MOVE_RANGE_X;
//							m_vEffectMove[iFontNo].x = -m_vEffectMove[iFontNo].x;
						}
						if( m_vFontPos[iFontNo].x <= m_vFontSavePos[iFontNo].x - MOVE_RANGE_X ){
							m_vFontPos[iFontNo].x = m_vFontSavePos[iFontNo].x - MOVE_RANGE_X;
//							m_vEffectMove[iFontNo].x = -m_vEffectMove[iFontNo].x;
						}
						if( m_vFontPos[iFontNo].y >= m_vFontSavePos[iFontNo].y + MOVE_RANGE_Y ){
							m_vFontPos[iFontNo].y = m_vFontSavePos[iFontNo].y + MOVE_RANGE_Y;
//							m_vEffectMove[iFontNo].y = -m_vEffectMove[iFontNo].y;
						}
						if( m_vFontPos[iFontNo].y <= m_vFontSavePos[iFontNo].y - MOVE_RANGE_Y ){
							m_vFontPos[iFontNo].y = m_vFontSavePos[iFontNo].y - MOVE_RANGE_Y;
//							m_vEffectMove[iFontNo].y = -m_vEffectMove[iFontNo].y;
						}
#endif
						if( b == m_eSelectProc ){
							m_vFontPos[iFontNo].x += m_vEffectMove[iFontNo].x;
							m_vFontPos[iFontNo].y += m_vEffectMove[iFontNo].y;
						}

						X0 		= m_vFontPos[iFontNo].x + m_fScrollX;
						X1 		= X0 + m_FParam[pJimaku->chardat[i]].w;
						Y0 		= m_vFontPos[iFontNo].y;
						Y1 		= Y0 + m_FParam[pJimaku->chardat[i]].h;
						
						bool ColorFlag=false;
					
				}
				
				for( n = 0; n < 4; n++ ){
					GXPosition3f32( X0+PlusX[n],	Y0+PlusY[n], 0 );
					GXColor1u32( SColor );
					GXTexCoord2f32( (f32)m_FParam[pJimaku->chardat[i]].u / (f32)m_Tex.Header->mWidth, (f32)m_FParam[pJimaku->chardat[i]].v / (f32)m_Tex.Header->mHeight );
					
					GXPosition3f32( X1+PlusX[n],	Y0+PlusY[n], 0 );
					GXColor1u32( SColor );
					GXTexCoord2f32( ((f32)m_FParam[pJimaku->chardat[i]].u+(f32)m_FParam[pJimaku->chardat[i]].w) / (f32)m_Tex.Header->mWidth, (f32)m_FParam[pJimaku->chardat[i]].v / (f32)m_Tex.Header->mHeight );
					
					GXPosition3f32( X1+PlusX[n],	Y1+PlusY[n], 0 );
					GXColor1u32( SColor );
					GXTexCoord2f32( ((f32)m_FParam[pJimaku->chardat[i]].u+(f32)m_FParam[pJimaku->chardat[i]].w) / (f32)m_Tex.Header->mWidth, ((f32)m_FParam[pJimaku->chardat[i]].v+(f32)m_FParam[pJimaku->chardat[i]].h) / (f32)m_Tex.Header->mHeight );	

					GXPosition3f32( X0+PlusX[n], Y1+PlusY[n], 0 );
					GXColor1u32( SColor );
					GXTexCoord2f32( (f32)m_FParam[pJimaku->chardat[i]].u / (f32)m_Tex.Header->mWidth, ((f32)m_FParam[pJimaku->chardat[i]].v+(f32)m_FParam[pJimaku->chardat[i]].h) / (f32)m_Tex.Header->mHeight );					
				}

				GXPosition3f32( X0,	Y0, 0 );
				GXColor1u32( Color );
				GXTexCoord2f32( (f32)m_FParam[pJimaku->chardat[i]].u / (f32)m_Tex.Header->mWidth, (f32)m_FParam[pJimaku->chardat[i]].v / (f32)m_Tex.Header->mHeight );
				
				GXPosition3f32( X1,	Y0, 0 );
				GXColor1u32( Color );
				GXTexCoord2f32( ((f32)m_FParam[pJimaku->chardat[i]].u+(f32)m_FParam[pJimaku->chardat[i]].w) / (f32)m_Tex.Header->mWidth, (f32)m_FParam[pJimaku->chardat[i]].v / (f32)m_Tex.Header->mHeight );
				
				GXPosition3f32( X1,	Y1, 0 );
				GXColor1u32( Color );
				GXTexCoord2f32( ((f32)m_FParam[pJimaku->chardat[i]].u+(f32)m_FParam[pJimaku->chardat[i]].w) / (f32)m_Tex.Header->mWidth, ((f32)m_FParam[pJimaku->chardat[i]].v+(f32)m_FParam[pJimaku->chardat[i]].h) / (f32)m_Tex.Header->mHeight );	

				GXPosition3f32( X0, Y1, 0 );
				GXColor1u32( Color );
				GXTexCoord2f32( (f32)m_FParam[pJimaku->chardat[i]].u / (f32)m_Tex.Header->mWidth, ((f32)m_FParam[pJimaku->chardat[i]].v+(f32)m_FParam[pJimaku->chardat[i]].h) / (f32)m_Tex.Header->mHeight );

			}
			GXEnd();

			

//		с@	

			if( RubiNum <= 0 ) continue;
			//	ݒ	--------------------------------------------	
			Set2DCamera();
			SetGraphMode();
			SetTevStage();
			SetVertex();
			
			GXLoadTexObj( &m_RubiTex.Obj, GX_TEXMAP0 );		//	reNX`
			
			//	v~eBu쐬	----------------------------------------------------------------------
			GXBegin( GX_QUADS, GX_VTXFMT0, (u16)(4 * RubiNum) );
			
			f32 U0, U1, V0, V1;
			f32 KanjiSize = 0.0f;			
			
			num = 0;

			while(1){
				//	rf[^`FbN
				if( pJimaku->rubidat[num].fromNum == -1 || pJimaku->rubidat[num].toNum == -1 ){
					break;
				}
				//	J[ZNgRej[	--------------------------------------------------------
				if( pJimaku->rubidat[num].charID[0] == FONT_JIMAKU_COLOR ){
					break;
				}
				Color = 0xffffffff;
				if( (u16)pJimaku->rubidat[num].charID[0] == FONT_RUBI_COLOR_Y ){		//	rf[^̐F
						Color = COLOR_SECOND;
				}
				if( (u16)pJimaku->rubidat[num].charID[0] == FONT_RUBI_COLOR_P ){
					Color = COLOR_FIRST;
				}

				for( int c = 0; pJimaku->rubidat[num].charID[c] >= 0; c++, iRubiNo++ )
				{
					if(( 	(u16)pJimaku->rubidat[num].charID[c] == FONT_RUBI_COLOR_Y ) ||
							(u16)pJimaku->rubidat[num].charID[c] == FONT_RUBI_COLOR_P )
					{
						iRubiNo--;
						continue;
					}
					f32 EffectMoveX = 0.0f;
					f32	EffectMoveY	= 0.0f;
				
					if( m_vRubiPos[iRubiNo].x >= m_vRubiSavePos[iRubiNo].x + MOVE_RANGE_X ){
						m_vRubiPos[iRubiNo].x = m_vRubiSavePos[iRubiNo].x + MOVE_RANGE_X;
					}
					if( m_vRubiPos[iRubiNo].x <= m_vRubiSavePos[iRubiNo].x - MOVE_RANGE_X ){
						m_vRubiPos[iRubiNo].x = m_vRubiSavePos[iRubiNo].x - MOVE_RANGE_X;
					}
					if( m_vRubiPos[iRubiNo].y >= m_vRubiSavePos[iRubiNo].y + MOVE_RANGE_Y ){
						m_vRubiPos[iRubiNo].y = m_vRubiSavePos[iRubiNo].y + MOVE_RANGE_Y;
					}
					if( m_vRubiPos[iRubiNo].y <= m_vRubiSavePos[iRubiNo].y - MOVE_RANGE_Y ){
						m_vRubiPos[iRubiNo].y = m_vRubiSavePos[iRubiNo].y - MOVE_RANGE_Y;
					}

					if( b == m_eSelectProc ){
						m_vRubiPos[iRubiNo].x += m_vEffectMove[iRubiNo].x;
						m_vRubiPos[iRubiNo].y += m_vEffectMove[iRubiNo].y;
					}

					X0 		= m_vRubiPos[iRubiNo].x + m_fScrollX;
					X1 		= X0 + MEMO_RUBI_SIZE_W;
					Y0 		= m_vRubiPos[iRubiNo].y;
					Y1 		= Y0 + MEMO_RUBI_SIZE_H;

					U0 = (f32) (pJimaku->rubidat[num].charID[c] % MEMO_RUBI_NUM_X) * MEMO_RUBI_W / (f32)m_RubiTex.Header->mWidth; 
					U1 = (( (f32)( pJimaku->rubidat[num].charID[c] % MEMO_RUBI_NUM_X )+1) * MEMO_RUBI_W) / (f32)m_RubiTex.Header->mWidth;
					V0 = (( pJimaku->rubidat[num].charID[c] / MEMO_RUBI_NUM_X ) * MEMO_RUBI_H ) / (f32)m_RubiTex.Header->mHeight;
					V1 = ((((pJimaku->rubidat[num].charID[c]+MEMO_RUBI_NUM_X) / MEMO_RUBI_NUM_X) ) * MEMO_RUBI_H ) / (f32)m_RubiTex.Header->mHeight;
					
					GXPosition3f32( X0,	Y0, 0 );
					GXColor1u32( Color );
					GXTexCoord2f32( U0, V0 );
					
					GXPosition3f32( X1,	Y0, 0 );
					GXColor1u32( Color );
					GXTexCoord2f32( U1, V0 );
					
					GXPosition3f32( X1,	Y1, 0 );
					GXColor1u32( Color );
					GXTexCoord2f32( U1, V1 );	

					GXPosition3f32( X0, Y1, 0 );
					GXColor1u32( Color );
					GXTexCoord2f32( U0, V1 );
				}
				num++;
			}
			GXEnd();
		}
	}
}


//========================================================================
//					wtHg̃|WVQbg
//========================================================================
f32			SK7IMenuHato::GetFontPosition( stJimaku* pJimaku, int No )
{
	f32 PosX = 0;
	for( int s = 0; (u16)pJimaku->chardat[s] != JIMAKU_NO_FONT; s++ )
	{
		if( s >= No )	break;
		
		if( (u16)pJimaku->chardat[s] == JIMAKU_SPACE_Z ){
			PosX += 20.0f;
		}else{
			PosX += m_FParam[pJimaku->chardat[s]].w;
		}
	}
	return PosX;
}

//========================================================================
//					̍W擾
//========================================================================
f32			SK7IMenuHato::GetKanjiSize( stJimaku* pJimaku, int No, int Num )
{
	f32 size = 0;
	
	for( int i = 0; i < Num; i++ )
	{
		size += m_FParam[pJimaku->chardat[No+i]].w;
	}
	return size;
}


//========================================================================
//					̈ړGtFNgZbg
//========================================================================
void		SK7IMenuHato::SetEffectMove()
{
	f32 SpeedAngle;
	for( int i = 0; i < MEMO_MAX_FONT; i++ )
	{
		SpeedAngle = MTXDegToRad(rand()%360);
		m_vEffectMove[i].x = (MEMO_MOVE_R*cosf(SpeedAngle))/MEMO_MOVE_FRAME;
		m_vEffectMove[i].y = (MEMO_MOVE_R*sinf(SpeedAngle))/MEMO_MOVE_FRAME;
	}
}


//========================================================================
//					^Cg`
//========================================================================
void		SK7IMenuHato::RenderMemoTitle()
{
	int string = 0;
	int	SpaceNum = 0;
	f32 FontPlusY = 0.0f;
	int	PlusNo = 0;
	bool PlusYFlag = false;

	if( !m_bMemoTitleVisibleFlag )	return;
	if( m_ucMemoNum <= 0 )			return;
	
//		^CgIC		
	f32 	Line_y = FONT_MEMOTITLE_Y + m_iTitleNo * MEMO_TITLE_GAP_Y + TITLE_LINE_PLUS_Y;
	m_spTitleLine.SetLineSprite	( MEMO_TITLE_FIRST_X, Line_y-LINE_UNDER_Y, MEMO_TITLE_FIRST_X+m_FontTitle[m_iTitleNo].GetFontLengthX(true), Line_y-LINE_UNDER_Y, TITLE_LINE_SIZE, 0xff00007f  );
	m_spTitleLine.SetVisible	( true );
	if( m_ucMemoNum > 0 ) m_spTitleLine.Render();

	const int PlusX[]={0,0,1,-1,0};
	const int PlusY[]={1,-1,0,0,0};
	for( int i = 0; i < HATO_MEMO_MAX_NUM; i++ ){
		for( int n = 0; n < 5; n++ ){
			m_FontTitle[i].SetPos( MEMO_TITLE_FIRST_X+m_fScrollX+PlusX[n], FONT_MEMOTITLE_Y+i*MEMO_TITLE_GAP_Y+PlusY[n] );
			if( n == 4 )	m_FontTitle[i].SetColor( 0xffffff7f );
			else			m_FontTitle[i].SetColor( 0x000000ff );	
			m_FontTitle[i].RenderLine();
		}		
	}
}

