////////////////////////////////////////////////////////////////////////////////
//
// Killer7 LoadProcess
//
// SK7LoadProcess.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 02/12/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7LOADPROCESS_H__
#define	__SK7LOADPROCESS_H__

#include "SK7Sprite.h"
#include "SK7SaveData.h"
#include "SK7SaveBase.h"




class SK7LoadProcess : public SK7SaveBase 
{

protected:
	s32					m_ScenarioNo;				//	[hViIԍ

	void 		InitCheck(void);
	void		ReadSaveData(void);
	void		CheckReadEnd(void);
	void 		CheckInitCard(void);
	bool		CheckModeFlag(void);
	void		FrameDeleteProcess(void);
	void		RenderMoveComment(void);
public:
	SK7LoadProcess();
	~SK7LoadProcess();
	virtual bool FrameProcess(void);						// t[	
	virtual bool RenderProcess(void);						// _O	
	virtual bool GetMenuEnd(void);							// II擾֐
	virtual void SetCtrlFlag(bool flag){ m_bCtrl=flag; }	// 싖ݒ֐
	virtual void SetRender(bool flag){ m_bRender=flag; }	// _O
	
	s32			GetScenarioNo(){ return m_ScenarioNo; }
};

#endif	//__SK7SAVEPROCESS_H__
