////////////////////////////////////////////////////////////////////////////////
//
// Killer7 
//
// SK7PanelCreate.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 04/19/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifdef __SK7PANELCREATE_INCLUDE__
#include "mK7PanelSwitch01.h"
#include "mK7PanelSwitch02.h"
#include "mK7PanelSwitch03.h"

#include "SK7PanelInputCode.h"
#include "SK7PanelNiou.h"
#include "SK7PanelToilet.h"

#include "SK7PanelKeiba.h"
#include "SK7PanelChinChiro.h"
#include "SK7PanelCards.h"
#include "SK7PanelIno.h"

#include "SK7PanelPoster.h"
#include "SK7PanelGacha.h"
#include "SK7PanelPsychoTest.h"
#include "SK7PanelGum.h"
//#include "SK7PanelBreaker.h"
#include "SK7PanelMainBreaker.h"
//#include "SK7PanelSofa.h"

#include "SK7PanelNine.h"
#include "SK7PanelSecom.h"
#include "SK7PanelCock.h"
#include "SK7PanelBook.h"
#include "SK7PanelCandle.h"
#include "SK7PanelLock.h"
#include "SK7PanelKouro.h"
//#include "SK7PanelKakejiku.h"
#include "SK7PanelInputCode6.h"
#include "SK7PanelDonCho.h"
#include "SK7PanelSecurity.h"
#include "SK7PanelToilet2.h"
#include "SK7PanelSafe.h"
#include "SK7PanelRobot.h"
#include "SK7PanelKeyBoard.h"
#include "SK7PanelHotelElevator.h"
#include "SK7PanelEleChange.h"
#include "SK7PanelVending.h"
#include "SK7PanelColor.h"
#include "SK7PanelMatsu.h"
#include "SK7PanelEnd.h"
#include "SK7PanelStaff1.h"
#include "SK7PanelStaff2.h"
#include "SK7PanelTutorial.h"


#undef	__SK7PANELCREATE_INCLUDE__

#else

#ifndef	__SK7PANELCREATE_H__
#define	__SK7PANELCREATE_H__

#ifdef	__K7SCN01_CPP__
//	case	K7EVENTNO(010401): return new SK7PanelKouro(0);
//	case	K7EVENTNO(010402): return new SK7PanelKouro(1);
//	case	K7EVENTNO(010403): return new SK7PanelKouro(2);
//	case	K7EVENTNO(015201): return new SK7PanelKakejiku(now);
//	case 	K7EVENTNO(010600): return new SK7PanelNiou(now);
	case 	K7EVENTNO(011305): return new SK7PanelChinChiro(now);
	case	K7EVENTNO(011402): return new SK7PanelCards(0);
	case	K7EVENTNO(011403): return new SK7PanelCards(1);
	case	K7EVENTNO(011404): return new SK7PanelCards(2);
	case	K7EVENTNO(011502): return new SK7PanelKeiba(now);
	case	K7EVENTNO(011602): return new SK7PanelIno(GAME_INO);
	case	K7EVENTNO(011603): return new SK7PanelIno(GAME_SHIKA);
	case	K7EVENTNO(011604): return new SK7PanelIno(GAME_CHO);
	case	K7EVENTNO(011310): return new mK7PanelSwitch02(now);
	case	K7EVENTNO(011202): return new SK7PanelEleChange(now);
	case	K7EVENTNO(011302): return new SK7PanelVending(now);
#endif

#ifdef	__K7SCN02_CPP__
	case	K7EVENTNO(020202): return new SK7PanelGacha(now);
	case	K7EVENTNO(020109): return new SK7PanelInputCode6(now);
	case	K7EVENTNO(020301): return new SK7PanelPsychoTest(now);
	case	K7EVENTNO(020303): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020304): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020305): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020306): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020307): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020308): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020309): return new SK7PanelPoster((s32)evno, 0);
//	case	K7EVENTNO(020114): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020208): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020203): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020201): return new SK7PanelPoster((s32)evno, 0);
#endif

#ifdef	__K7SCN03_CPP__
	case	K7EVENTNO(030201): return new SK7PanelGum(now,GUM_PHOENIX);
	case	K7EVENTNO(030202): return new SK7PanelGum(now,GUM_COWGIRL);
	case	K7EVENTNO(030203): return new SK7PanelGum(now,GUM_BIKE);
	case	K7EVENTNO(030204): return new SK7PanelGum(now,GUM_GUN);
	case	K7EVENTNO(030205): return new SK7PanelGum(now,GUM_MISSILE);
//	case	K7EVENTNO(030401): return new SK7PanelBreaker(now);
//	case	K7EVENTNO(030402): return new SK7PanelBreaker(now);
//	case	K7EVENTNO(030403): return new SK7PanelBreaker(now);
//	case	K7EVENTNO(030404): return new SK7PanelBreaker(now);
	case	K7EVENTNO(030409): return new SK7PanelMainBreaker(now);
	case	K7EVENTNO(035003): return new SK7PanelNine(now);
	case	K7EVENTNO(035005): return new SK7PanelSecom(now);
	case	K7EVENTNO(035006): return new SK7PanelSecom(now);
	case	K7EVENTNO(035007): return new SK7PanelSecom(now);
	case	K7EVENTNO(035008): return new SK7PanelSecom(now);
	case	K7EVENTNO(035009): return new SK7PanelSecom(now);
	case	K7EVENTNO(035010): return new SK7PanelSecom(now);
	case	K7EVENTNO(035012): return new SK7PanelLock(now);
	case	K7EVENTNO(035014): return new SK7PanelCock(now);
//	case	K7EVENTNO(030901): return new SK7PanelSofa(now);
	case	K7EVENTNO(030301): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(030414): return new SK7PanelPoster((s32)evno, 0);
#endif

#ifdef	__K7SCN04_CPP__
	case	K7EVENTNO(040402): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(040405): return new SK7PanelColor(now);
#endif

#ifdef	__K7SCN05_CPP__
	case 	K7EVENTNO(050103): return new SK7PanelHotelElevator(now);
	case	K7EVENTNO(055300): return new SK7PanelDoncho(now);
	case	K7EVENTNO(055700): return new SK7PanelSecurity(now);
	case	K7EVENTNO(055600): return new SK7PanelToilet2(now);
	case	K7EVENTNO(055702): return new SK7PanelSafe(now);
	case	K7EVENTNO(055100): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(055101): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(055102): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(055103): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(055104): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(055105): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(055106): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(055107): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(055500): return new SK7PanelKeyBoard(now);
	case	K7EVENTNO(055501): return new SK7PanelRobot(now);
	case	K7EVENTNO(055703): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(059000): return new SK7PanelStaff1(now);
#endif

#ifdef 	__K7SCN06_CPP__
	case 	K7EVENTNO(057500): return new SK7PanelMatsu(now);
	case 	K7EVENTNO(060000): return new SK7PanelEnd(now);
	case 	K7EVENTNO(060001): return new SK7PanelStaff2(now);
#endif

#ifdef 	__K7SCN07_CPP__
	case 	K7EVENTNO(007301): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(000304): return new SK7PanelInputCode(now);
	case	K7EVENTNO(000102): return new mK7PanelSwitch01(now);//SK7PanelLaundry(now);
	case	K7EVENTNO(007201): return new SK7PanelCandle(now);
//	case 	K7EVENTNO(007307): return new SK7PanelBook(now);
	case	K7EVENTNO(000501): return new mK7PanelSwitch03(now);
	case	K7EVENTNO(000603): return new SK7PanelToilet(now);
#endif

#ifdef	__SK7PANELBASE_CPP__
//	case	K7EVENTNO(010700): return new SK7PanelCook2(now);
//	case	K7EVENTNO(010701): return new SK7PanelCook(now);
//	case	K7EVENTNO(011201): return new SK7PanelLocker(now);
//	case	K7EVENTNO(011301): return new SK7PanelElevator(now);
//	case	K7EVENTNO(011304): return new SK7PanelManageKey2(now);
//	case	K7EVENTNO(011308): return new SK7PanelElevator2(now);
//	case	K7EVENTNO(011309): return new SK7PanelPoster((s32)evno, 0);
//	case	K7EVENTNO(011406): return new SK7PanelPoster((s32)evno, 0);
//	case	K7EVENTNO(011503): return new SK7PanelRoulette(now);
//	case	K7EVENTNO(011506): return new SK7PanelPoster((s32)evno, 0);
//	case	K7EVENTNO(011606): return new SK7PanelPoster((s32)evno, 0);
//	case	K7EVENTNO(011607): return new SK7PanelPoster((s32)evno, 0);
//	case	K7EVENTNO(011608): return new SK7PanelPoster((s32)evno, 0);

//	case	K7EVENTNO(020118): return new SK7PanelMailbox(0);
//	case	K7EVENTNO(020119): return new SK7PanelMailbox(1);
//	case	K7EVENTNO(020120): return new SK7PanelMailbox(2);
//	case	K7EVENTNO(020121): return new SK7PanelMailbox(3);
//	case	K7EVENTNO(020122): return new SK7PanelMailbox(4);
//	case	K7EVENTNO(020123): return new SK7PanelMailbox(5);
//	case	K7EVENTNO(020124): return new SK7PanelMailbox(6);
//	case	K7EVENTNO(020125): return new SK7PanelMailbox(7);

//	case	K7EVENTNO(030102): return new SK7PanelVisitor(now);
//	case	K7EVENTNO(030101): return new SK7PanelPoster((s32)evno, 0);
//	case	K7EVENTNO(030103): return new SK7PanelPoster((s32)evno, 0);
//	case	K7EVENTNO(030104): return new SK7PanelPoster((s32)evno, 0);
//	case	K7EVENTNO(030105): return new SK7PanelPoster((s32)evno, 0);
//	case	K7EVENTNO(030106): return new SK7PanelPoster((s32)evno, 0);
//	case	K7EVENTNO(030206): return new SK7PanelPopcorn(now);
//	case	K7EVENTNO(030515): return new SK7PanelPoster(K7EVENTNO(030515));
//	case	K7EVENTNO(030516): return new SK7PanelPoster(K7EVENTNO(030516));
//	case	K7EVENTNO(030517): return new SK7PanelPoster(K7EVENTNO(030517));
//	case	K7EVENTNO(030518): return new SK7PanelPoster(K7EVENTNO(030518));
//	case	K7EVENTNO(030519): return new SK7PanelPoster(K7EVENTNO(030519));
//	case	K7EVENTNO(030520): return new SK7PanelPoster(K7EVENTNO(030520));

//	case	K7EVENTNO(035015): return new SK7PanelValve(now);
//	case	K7EVENTNO(000101): return new mK7PanelSwitch00(now);
//	case	K7EVENTNO(000104): return new SK7PanelManageKey(now);
//	case	K7EVENTNO(000201): return new mK7PanelSwitch02(now);
//	case	K7EVENTNO(000401): return new SK7PanelDarts(now);
//	case	K7EVENTNO(000502): return new mK7PanelSwitch04(now);
//	case	K7EVENTNO(000606): return new mK7PanelSwitch05(now);
	case	K7EVENTNO(070000): return new SK7PanelTutorial(now);
#endif

#endif


#endif	//__SK7PANELCREATE_H__
