////////////////////////////////////////////////////////////////////////////////
//
// Killer7 SK7SaveLoadMessage
//
// SK7SaveLoadMessage.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 02/12/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7SAVELOADMESSAGE_H__
#define	__SK7SAVELOADMESSAGE_H__

#include "SK7Sprite.h"
#include "SK7Font.h"
#include "../Yam/YK7String.h"

#define		Y_KANA_TEX				"/Yam/CharChange/TVKana_GC.BIN"
#define		SLOT_FONT_X				(210)
#define		SLOT_FONT_Y				(150)
#define		SLOT_FONT_Y2			(200)
#define		UNDER_MESSAGE_X			(50.0f)	
#define		UNDER_MESSAGE_Y			(150)//(380.0f)

#define		MESSAGE_NUM				(4)
#define		ANS_CURSOL_X			(200.0f)
#define		ANS_CURSOL_X2			(320.0f)
#define		AB_FONT_X				(110.0f)
#define		CARD_ANS_X				(260)
#define		CARD_ANS_Y				(330)
#define		CARD_MES_SIZE			(40)
#define		CARD_ANSWER_NUM			(3)
#define		CARD_SELECT_X			(50)
#define		CARD_SELECT_Y			(CARD_FONT_Y-10)
#define		SLOT_FONT_COLOR			(0x00ff00A5)
#define		SLOT_NOT_COLOR			(0x009f008f)
#define		CARD_NOT_COLOR			(0x00ff0023)
#define		SELECT_FONT_GAP_X		(40.0f)
#define		SELECT_FONT_GAPY		(5)
#define		TV_CENTER_X				(265)
#define		CHAN_BIG_X				(310)
#define		CHAN_BIG_Y				(80)
#define		CHAN_POS_X				(340)
#define		CHAN_POS_Y				(73)
#define		CHAN_EX_NORMAL			(3.5f)
#define		CHAN_EX_BIG				(6.0f)

//	쐬bZ[WNo	===================================================================
enum{
	CERROR_MES_NOTCARD=0,			//	J[hȂW
	CERROR_MES_NOSAVE,				//	Z[uł܂񂪂ł?
	CERROR_MES_NOSLOT,				//	J[hĂȂ
	CERROR_MES_CHECK,				//	񂶂˂B
	CERROR_MES_INITCHECK,			//	`FbN
	CERROR_MES_DELETECHECK,			//	폜`FbN
	CERROR_MES_FORMAT,				//	Kv
	CERROR_MES_INIT_CHECK,			//	?
	CERROR_MES_BREAK_DATA,			//	Ƃ邪 [ԂH
	CERROR_MES_BREAK_CARD,			//	J[h
	CERROR_MES_BREAK_SAVE,			//	L[f[^Ă܂
	CERROR_MES_BREAK_SAVE_A,		//	L[f[^Ă܂
	CERROR_MES_BREAK_SAVE_NO,		//	Ă邯Ǎ폜Ȃ
	CERROR_MES_IPL,					//	hokɂĂ
	CERROR_MES_NO_SPACE,			//	󂫂˂
	CERROR_MES_FILE_REQ,			//	ꂾt@CKv
	CERROR_MES_SPACE_REQ,			//	˂炭
//	CERROR_MES_OVER_WRITE,			//	킪ĂłH
	CERROR_MES_ANSWER_NORMAL,		//	
	CERROR_MES_ANSWER_INIT,			//	񓚏
	CERROR_MES_ANSWER_IPL,			//	IPL
	CERROR_MES_YESNO,				//	YESNO
	CERROR_MES_INIT_YN,				//	
	CERROR_MES_INIT_MISS,			//	Ɏs܂
	CERROR_MES_INIT_OK,				//	܂B
	CERROR_MES_NOT_DATA,			//	L[̃f[^Ȃł
	CERROR_MES_NODATA_HOPPER7,		//	قρ[Ṽf[^Ȃ
	CERROR_MES_NODATA_KILLER8,		//	L[W̃f[^Ȃ
	CERROR_MES_END,					//	Z[u܂
	CERROR_MES_DELETE_OK,			//	폜܂B
	CERROR_MES_DELETE_MISS,			//	폜s
	CERROR_MES_NONE,				//	G[Ȃ
	
	//	ŏ̃`FbNʗpbZ[W	-------------------------------------------------
	CERROR_CHECK_NOSLOT,			//	J[h͂Ă܂
	CERROR_CHECK_NOTCARD,			//	J[hȊÔ
	CERROR_CHECK_INIT,				//	Kv
	CERROR_CHECK_INIT_CHECK,		//	܂?
	CERROR_CHECK_BREAK,				//	Ă܂
	CERROR_CHECK_SIZE,				//	[܂
	CERROR_CHECK_CHECK,				//	`FbNł
	CERROR_INIT_CHECK,				//	łB
	CERROR_CHECK_INIT_OK,			//	܂B
	CERROR_CHECK_INIT_MISS,			//	s܂B
	CERROR_CHECK_NO_INIT,			//	J[hgƂo܂B
};

//	su艺̃bZ[Wm	============================================================
enum{
	CHECK_MES_OVER_WRITE=0,			//	㏑܂H	
	CHECK_MES_START_NOW,			//	̂܂܃Q[͂߂܂H
	CHECK_MES_SAVEEND,				//	Z[u܂B
	CHECK_MES_CHECK,				//	GȂł
	CHECK_MES_SAVECHECK,			//	Z[ułB
	CHECK_MES_LOADCHECK,			//	[hłB
	CHECK_MES_LOAD,					//	̃f[^[ǂH
	
	//	ŏIZ[u`FbNp
	CHECK_MES_ENDSAVE_CHECK,		//	܂ł̃f[^
	CHECK_MES_NONE,					//	ȂɂȂ
};
 
//	`FbNpbZ[Wm	=============================================================
enum{
	CHECK_MESUP_INIT_CHECK = 0,		//	܂?
	CHECK_MESUP_DELETE_CHECK,		//	폜`FbN
	CHECK_MESUP_NONE,				//	ȂɂȂ
};

//	ZNgԍ	=========================================================================
enum{
	CARD_SELECT_NORMAL=0,			//	Z[uȂAւ
	CARD_SELECT_INIT,				//	NORMAL+
	CARD_SELECT_IPL,				//	NORMAL+IPLʂ
	CARD_SELECT_CHECK_INIT,			//	`FbN
	CARD_SELECT_BREAK,				//	jp	
};

//	̃ZNgԍ	=====================================================================
enum{
	CARD_ANSWER_NOSAVE=0,			//	Z[uȂ
	CARD_ANSWER_CHANGE,				//	ւ
	CARD_ANSWER_INIT,				//	
	CARD_ANSWER_IPL,				//	ʂ
	CARD_ANSWER_YES,				//	Yes
	CARD_ANSWER_NO,					//	No
};
//	Z[u[hNX̎ށiRXgN^ցj===========================================
enum{
	SAVE_STATE_CHECK=0,				//	ԍŏ̃`FbN
	SAVE_STATE_SAVE,				//	Z[u
	SAVE_STATE_LOAD,				//	[h
	SAVE_STATE_ENDSAVE,				//	ViIĨZ[u
};

//	eNX`[ԍ	-------------------------------------------------------------------
enum{
	FONT_SAVELOAD_GC=0,
	FONT_SAVEFONT_GC,
	FONT_DATA_NUM,
};

enum{
	TEX_TV=0,
	TEX_SAVE_LOAD,
	TEX_A_BOTTAN,
	TEX_A_B,
	TEX_MAX_NUM,
};


//********************************************	Z[u[hbZ[WNX	********************************************
class SK7SaveLoadMessage
{
	typedef enum{
		PROC_MES_PACK=0,
		PROC_MES_KANA,
	}eLoadMes;
	
protected:
	YK7StrImage* 		m_pYFont;						//	p
	YK7StrImage* 		m_pYKana;						//	J^Ji
	YK7StrImage* 		m_pYEng;						//	J^Ji
	YK7StrImage* 		m_pYHira;						//	qMm
	
	SK7Sprite			m_spBack;						//	FobN
	SK7Sprite			m_spSelect;						//	g	
	SK7Sprite			m_spCM;			
	SK7Sprite			m_spChan;
	SK7Sprite			m_spAButton;
	SK7Sprite			m_spAB[2];

	eLoadMes			m_eLoadProc;						
	
	u8					m_ucMesNo;
	u8					m_ucCheckNo;
	u8					m_ucCheckUpNo;
	
	int					m_iButtonTime;
	
	//	pbNt@C	-----------------------------------
	SK7File						m_File;
	ghmGcResLink*				m_pResLink;			//	N\[X
	void*						m_pPackData;		//	f[^
	TEX_DATA*					m_pTexture;			//	eNX`[f[^
	
public:
	SK7SaveLoadMessage();
	~SK7SaveLoadMessage();

	//	[h
	bool		LoadMessage(void);
	//	f[g
	void		DeleteMessage(void);
	
	// _O
	bool  		RenderFont			( s8 SlotNo, bool SaveFlag );		
	void		RenderFontFirst		( s8 SlotNo, s8 select, s8 state );
	void		RenderSlotName		( u8, u32,u32,bool,bool );
	void		RenderCheckFontError( u8 select );
	void		RenderCheckFont		( u8 select);
	
	//	G[bZ[W	---------------------------------
	void		CreateMessage	( u8 No ){ m_ucMesNo = No; }
	void		CreateCheck		( u8 No ){ m_ucCheckNo = No; }
	void		CreateCheckUp	( u8 No ){ m_ucCheckUpNo = No; }
	u8			GetMesNo()				{	return m_ucMesNo; }
	u8			GetCheckMesNo()			{	return m_ucCheckNo; }
	u8			GetCheckUpNo()			{	return m_ucCheckUpNo; }
	
	//	`lZbg	
	void		SetChannel( u16 no ){ 
					m_spChan.SetTexSprite	( CHAN_BIG_X, CHAN_BIG_Y, m_spChan.GetTexture(), 1, 2, no );
					m_spChan.SetEX			( CHAN_EX_BIG );
					m_spChan.SetVisible		( true ); 
					m_spChan.SetColor		( SLOT_FONT_COLOR );
				}
	void		SetChannelNomral(){
					m_spChan.SetXY0		( CHAN_POS_X, CHAN_POS_Y );
					m_spChan.SetEX		( CHAN_EX_NORMAL );
				}
	//	G[bZ[W`p
	f32			DrawMessageHira( f32 y, char* Mes ){
					f32 retY = m_pYHira->DrawFSStr( 0, 0, false, false, Mes );
					m_pYHira->DrawFSStr( TV_CENTER_X-retY*0.5f, y, false, true, Mes  );
					return retY;
				}
	f32			DrawMessageHira( f32 y, char* Mes, int No ){
					f32 retY = m_pYHira->DrawFSStr( 0, 0, false, false, Mes, No );
					m_pYHira->DrawFSStr( TV_CENTER_X-retY*0.5f, y, false, true, Mes, No  );
					return retY;
				}
	//	`FbN̂Ƃ̃ZNgtHg	---------------------------------
	void		SetCheckSelectFont( u8 state, s8 select );
};

#endif	//__SK7SAVELOADMESSAGE_H__
