////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage706M01
//
// K7Stage707M01.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/23/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE707M01_CPP__

#include "..\..\Scn\K7Scn07.h"
#include ".\K7Stage707M01.h"
#include "..\..\Wat\WK7Item.h"

#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Enm\EnmANG.h"
#include "..\..\..\Enm\EnmKUN.h"
#include "..\..\..\Fujita\c_impulse.h"
#include "..\..\..\Yam\YK7EffectFeather.h"

#define STG707M01_BULLET_CAM_FRAME	(30.0f)		//eԉoɂ鎞

K7Stage707M01::K7Stage707M01(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage707M01_Camera );
#if 0
	mKan.mSetXY0     (0,0);
	mKan.mSetWH      (0,0);
	mKan.mSetUV0     (0,0);
	mKan.mSetRGBA    (0);
	mKan.mSetDispFlag(false);
	mKanTexture.tex  = NULL;
	mpKanTextureData = NULL;
	mpFile           = NULL;
#endif
	mScnEnd.LoadData();
	GameInfo.SetMenuMapEnable(false);
	GameInfo.SetBossFlag     (true );
}

K7Stage707M01::~K7Stage707M01()
{
#if 0
	ReleaseData();
#endif
	mScnEnd.Release();
	GameInfo.SetMenuMapEnable(true );
	GameInfo.SetBossFlag     (false);
}

//------------------------------------------------------------------------------
// iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage707M01::CreateCallBack( void )
{
	gpSound->mReadSsm( "seBossAngKun.ssm", eBankBoss );
	return( true );
}

//------------------------------------------------------------------------------
// Iȉj
//------------------------------------------------------------------------------
bool
K7Stage707M01::TerminateCallBack( void )
{
	gpSound->mReleaseSsm( "seBossAngKun.ssm" );
	return( true );
}

//------------------------------------------------------------------------------
// JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
#if 1
bool K7Stage707M01::SetCurrentCallBack( void )
{
	WK7Play		*pPlay;
	
	//߂̃hA͕
	K7SCR_EVNO_SETENABLE( K7EVENTDOOR(007605), false );
	WK7CAM->SetFar(100000.0f);
	gpSound->mFadeVolumeStream( 0, 200 );
	
#if 1
  WK7PLAYERCONTROL->SetOperateEnable(false);
  //ǂJɂȂ܂ő҂
  while( WK7Stage::IsChanging() != false ){
	K7SCR_RETSYS();
  }

  {//todo
	//tF[hCB
  }

  while( K7EnmANG::GetInstance() == 0 || K7EnmKUN::GetInstance() == 0 ){
	K7SCR_RETSYS();
  }
  ANG.SetGameState( ANG_GAME_STATE1 );
  KUN.SetGameState( KUN_GAME_STATE0 );

  {//퓬B
	WK7PLAYERCONTROL->SetOperateEnable(true);
	K7EnmKUN::Start();
//	gpSound->mPlayStreamNo(HPS_BOSS_KUN);

	while( K7EnmKUN::IsAlive() ){
	  K7SCR_RETSYS();
	}
//	gpSound->mPlaySE( SFX_BOSS_ANGKUN_KUNDIE );
  }

	KK7BattleMainTask::BattleMainTaskExit(2);
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	SetCurrentPath(	GetPathNurbsAll("curve2_camera2_fix"),
					1.000f,
					0,									// 0:forward 1:back
					WK7PATHINFO_INITDIR_TGTDIR );		// : wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
	
	{
	  Vec e_={33.697f, 1.820f, -475.494f};
	  Vec t_={35.871f, 3.004f, -485.183f};
	  WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	  WK7CAM->SetPosition(e_);
	  WK7CAM->SetTargetPosition(t_);
	}
	//WK7CAM->SetCinemaScopeMode(true);
	
	//HƉ
	EFFECT   *pEffect[2]   = {NULL,};
	WK7Model *pKunModel = NULL;
	WK7Model *pAngModel = NULL;
	{
	  K7EnmKUN *pNpcKun   = (K7EnmKUN*)WK7Npc::Find(ENENO_KUN);
	  if( pNpcKun != NULL )
		{
		  WK7Chara *pCharaTmp = pNpcKun->pCurrentChara();
		  if( pCharaTmp != NULL )
			{
			  pKunModel = pCharaTmp->GetModel();
			  if( pKunModel != NULL )
				{
				  pKunModel->Hide();
				  pEffect[0] = 	CreateFeatherEffect( VParam[ED_FEATHER][13], 
													 (Vec){0.0f,0.0f,0.0f},
													 VParam[ED_FEATHER][7] * 0.05F, PI_2 * VParam[ED_FEATHER][8] / 360, 
													 (u8)VParam[ED_FEATHER][3], VParam[ED_FEATHER][4] * 0.1F, VParam[ED_FEATHER][5] * 0.01F,
													 (u8)VParam[ED_FEATHER][1], (u8)VParam[ED_FEATHER][2], VParam[ED_FEATHER][9] * 0.001F, 
													 VParam[ED_FEATHER][10] * 10.0F,	0, pKunModel->GetObj( "Root_joint" ), 30/*(s8)VParam[ED_FEATHER][14]*/ ) ;
				}
			}
		}
	}
	{
	  if( K7EnmANG::GetInstance() )
		{
		  WK7Chara *pCharaTmp = ANG.pCurrentChara();
		  if( pCharaTmp != NULL )
			{
			  pAngModel = pCharaTmp->GetModel();
			  if( pAngModel != NULL )
				{
				  pAngModel->Hide();
				  pEffect[1] = 	CreateFeatherEffect( VParam[ED_FEATHER][13], 
													 (Vec){0.0f,0.0f,0.0f},
													 VParam[ED_FEATHER][7] * 0.05F, PI_2 * VParam[ED_FEATHER][8] / 360, 
													 (u8)VParam[ED_FEATHER][3], VParam[ED_FEATHER][4] * 0.1F, VParam[ED_FEATHER][5] * 0.01F,
													 (u8)VParam[ED_FEATHER][1], (u8)VParam[ED_FEATHER][2], VParam[ED_FEATHER][9] * 0.001F, 
													 VParam[ED_FEATHER][10] * 10.0F,	0, pAngModel->GetObj( "Root_joint" ), 30/*(s8)VParam[ED_FEATHER][14]*/ ) ;
				}
			}
		}
	}
	K7SCR_TIMEWAIT( 4800 );
	gpSound->mPlaySE( SFX_BOSS_ANGKUN_KUNDIE );
	//K7SCR_TIMEWAIT( 4800 );
	//WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );

  {//^B
	//KK7BattleMainTask::BattleMainTaskExit(2);
	WK7PLAYERCONTROL->SetOperateEnable(false);
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	//WK7CAM->SetCinemaScopeMode(true);
	s32 c_ = 0, f_ = 30;
	HSD_FogDesc fog_desc_ = {
	  GX_FOG_LIN,                                  /* fog type */
	  NULL,                                        /* adjdesc */
	  300.0f,                                        /* startz */
	  (512.f + 1024.0f),                              /* endz */
	  {255, 255, 255, 255},                         /* color */
	};
	HSD_Fog *fog_ = HSD_FogLoadDesc(&fog_desc_);
	while( ++c_ < f_ ){
	  //f32 val = sinf( (f32)M_PI * c_ / (f32)f_ );
	  f32 val = c_ / (f32)f_;
	  fog_->startz = (1.f-val) * fog_desc_.startz;
	  fog_->endz = fog_->startz + 70.f;
	  //fog_->startz + 10.f + 127.f*(1.f-val);
	  WK7RenderObj::SetFog( fog_ );
	  K7SCR_RETSYS();	  
	}
	//WK7CAM->SetCinemaScopeMode(false);
	HSD_FogUnref( fog_ );
	K7SCR_EXIT_DEMOPAUSE();
	K7SCR_EXIT_PLAYMODE();
  }

  gpSound->mPlaySE( SFX_BOSS_ANGKUN_FLASH );
  {//todo
	//tF[hCB
	k7app.FadeStart(0xff,0);
	k7app.SetFadeColor(0xffffffff);
	//k7app.FadeStart(0x00,WK7_DEFAULT_FADE_TICK * 8);
  }

  {//Θb̃[r[B
	WK7PLAYERCONTROL->SetOperateEnable(false);
	KK7BattleMainTask::BattleMainTaskExit(2);

	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();

	WK7Play::StorePlayTB();
	//HGtFNg~
	if( pEffect[0] != NULL )
	{
	//	while( GetEffectValidState(pEffect) == true )
	//	{
	//		K7SCR_RETSYS();
	//	}
		DeleteEffect( pEffect[0] );
	}
	if( pEffect[1] != NULL )
	{
	//	while( GetEffectValidState(pEffect) == true )
	//	{
	//		K7SCR_RETSYS();
	//	}
		DeleteEffect( pEffect[1] );
	}
	
	//LĐ
	while( (pPlay=WK7Play::Create(K7EVENTPLAY(00020709)))==NULL ){
		K7SCR_RETSYS();
	}
	pPlay->Prepare();
	while( pPlay->GetState()!=WK7Play::PREPARED ){
		K7SCR_RETSYS();
	}
	//tF[h𐰂炷
//	k7app.FadeStart(0x00,4800*6);
	pPlay->Start();
	K7SCR_RETSYS();
	while( pPlay->GetState()!=WK7Play::PLAYED ){
		K7SCR_RETSYS();
	}
	WK7Play::PlayReleaseAll();
	k7app.FadeStart( 0x0, 0 );
	
	K7SCR_NOISE_REQUEST();
	WK7Play::RestorePlayTB();
	//BGM͒~
	gpSound->mStopStream();
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
	while( K7EnmANG::GetInstance() == 0 || K7EnmKUN::GetInstance() == 0 ){
	  K7SCR_RETSYS();
	}
	if( pKunModel != NULL )
	{
		pKunModel->Disp();
	}
	ANG.SetGameState( ANG_GAME_STATE2 );
	KUN.SetGameState( KUN_GAME_STATE1 );
	KUN.SetAlive();
	//LI܂ő҂
	while( WK7Play::GetTop() != NULL )
	{
		K7SCR_RETSYS();
	}
	
	//NłL
	WK7Play::SetSkipCancel( true );
	WK7Play::SetDontReleasePlayerSsm( true );	//vC[SE͉Ȃ
	while( (pPlay=WK7Play::Create(K7EVENTPLAY(00020711)))==NULL ){
		K7SCR_RETSYS();
	}
	pPlay->Prepare();
	while( pPlay->GetState()!=WK7Play::PREPARED ){
		K7SCR_RETSYS();
	}
	
	//inGame֖߂
//	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_EXIT_DEMOPAUSE();
	WK7PLAYERCONTROL->SetOperateEnable(false);
	K7EnmKUN::Start();
//	KK7BattleMainTask::BattleMainTaskExit(2);
	K7SCR_RETSYS();
//	K7SCR_ENTER_PLAYMODE();
//	K7SCR_ENTER_DEMOPAUSE();
	while( true == WK7PLAYERCONTROL->IsLoading() ){
		K7SCR_RETSYS();
	}
	Vec newPos = {52.0f, 0.050f, -339.500f};
	WK7PLAYERCONTROL->SetPosition(&newPos);
	K7SCR_NOISE_RELEASE();
	WK7PLAYERCONTROL->SetOperateEnable(true);
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
  }
  
  {//퓬2B
//	K7EnmKUN::Start();
	gpSound->mPlaySE( SFX_BOSS_ANGKUN_WINGSNOW, SOUND_SYSTEM_SE_VOLUME/4 );
	//gpSound->mPlayStreamNo(HPS_BOSS_KUN);

	while( K7EnmKUN::IsAlive() ){
	  K7SCR_RETSYS();
	}
	
	KK7BattleMainTask::BattleMainTaskExit(2);
  }

	//NɌĔłe
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	//WK7CAM->SetCinemaScopeMode(true);
	FixCam( BULLET_START );
	K7SCR_TIMEWAIT( 100 );
	WK7CAM->StartLinearInterpolateOnLinearPath( mpOneShotCamera[BULLET_TERM].pos, mpOneShotCamera[BULLET_TERM].tgt, STG707M01_BULLET_CAM_FRAME );
//	k7app.FadeStart( 0x0, 0 );
//	k7app.SetFadeColor( 0xffffffff );
//	k7app.FadeStart( 0xff, WK7_FRAME_TO_TICK((u32)STG707M01_BULLET_CAM_FRAME) );
	K7SCR_TIMEWAIT( WK7_FRAME_TO_TICK((u32)(STG707M01_BULLET_CAM_FRAME-16)) );
//	k7app.FadeStart( 0x0, 0 );
	//WK7CAM->SetCinemaScopeMode(false);
	
	//NłL
    WK7Chara::SetRenderChara(false);
    WK7Stage::SetRenderStage(false);
    WK7Item::SetRenderItem(false);
    
	WK7CAM->SetFar(100000.0f);
	gpSound->mStopSE( SFX_BOSS_ANGKUN_WINGSNOW );
	
	WK7Play::SetSkipCancel( false );
	WK7Play::SetDontStopStream( true );	//LIɃLōĐXg[~Ȃ
	pPlay->Start();
	K7SCR_RETSYS();
gpSound->mStopSE( SFX_PC_HAC_MODORI );
	while( pPlay->GetState()!=WK7Play::PLAYED ){
		K7SCR_RETSYS();
	}
	WK7Play::PlayReleaseAll();
	
    WK7Chara::SetRenderChara(false);
    WK7Stage::SetRenderStage(false);
    WK7Item::SetRenderItem(false);

#if	0  
  {//Ō̃[r[
    K7SCR_NOISE_REQUEST();
	k7app.FadeStart( 0x0, 0 );
  
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	gpSound->mStopStream();

    WK7Chara::SetRenderChara(false);
    WK7Stage::SetRenderStage(false);
    WK7Item::SetRenderItem(false);
    
//	WK7Play::StorePlayTB();
	WK7CAM->SetFar(100000.0f);
	K7SCR_NOISE_RELEASE();
	
	WK7Play::SetDontStopStream( true );
	WK7Play::PlayTB( K7EVENTPLAY(00020711) );
//	WK7Play::RestorePlayTB(false);
	
    WK7Chara::SetRenderChara(false);
    WK7Stage::SetRenderStage(false);
    WK7Item::SetRenderItem(false);
  }
#endif

#endif
  
//  k7app.SetFadeColor(0x00000000);
//  k7app.FadeStart(0xff,0);
//  k7app.FadeStart(0xff,600);
//  k7app.FadeStart(0xff,WK7_SEC_TO_TICK(3));

  mScnEnd.FrameProcess();

  {//todo 
	//̎͂ǂ֍ŝ낤H
	GameInfo.SetMode     (WK7GameInfo::TERM           );
	GameInfo.SetTermState(WK7GameInfo::TERMSTATE_CLEAR);
  }
  
  //Ō̃LŃXg[~߂Ȃ̂łŎ~߂ăsb`߂
  gpSound->mStopStream();
  gpSound->mSetPitchStream(0);
  
  return false;
}
#else
bool K7Stage707M01::SetCurrentCallBack( void )
{
	
#if 0
  while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
	GHMGCTASK_RETSYS();
  }
	
  K7SCR_ENTER_PLAYMODE();
  K7SCR_ENTER_DEMOPAUSE();
	
  k7app.SetFadeColor(0);
  k7app.FadeStart(0,0);
  WK7Play::StorePlayTB();
  WK7Play::PlayTB(K7EVENTPLAY(00020703));
  WK7Play::PlayTB(K7EVENTPLAY(00020707));
  WK7Play::RestorePlayTB();
  k7app.FadeStart(0xff,0);
	
  k7app.SetFadeColor(0);
  k7app.FadeStart(0,WK7_DEFAULT_FADE_TICK);
  while( k7app.IsFade()==true ){
	K7SCR_RETSYS();
  }
#endif	

  //eLg[B
  gpSound->mReadSsm( "seBossAngKun.ssm", eBankBoss );

	
  WK7PLAYERCONTROL->SetGameOver(); // lQ[I[o[[hɂ

  //	WK7Stage::GetCurrentStage()->ChangePriority( WK7Stage::GetCurrentStage()->GetPriority()-2 );
  ChangePriority( GetPriority()-2 );
	
  HSD_CameraDesc	*pDesc = GetCameraDesc(0);
  if( pDesc!=NULL ){  K7EV_CAM->SetDesc(pDesc);}

  //JB
  WK7Cam *cam = K7EV_MAINTASK->GetCamera();
  cam->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);

#if 0
  gpSound->mPlayStreamNo(HPS_BOSS_ANG);
	
  K7SCR_EXIT_PLAYMODE();
  K7SCR_EXIT_DEMOPAUSE();

  while( 1 ){
	//ANGSB
	//if( !K7EnmANG::IsAlive() ) break;
	if( !ANG.IsAlive() ) break;
	K7SCR_RETSYS();
  }

  K7SCR_ENTER_PLAYMODE();
  K7SCR_ENTER_DEMOPAUSE();
	
  gpSound->mFadeVolumeStream(0,30);
  gpSound->mStopStream();

  //ogIB
  KK7BattleMainTask::BattleMainTaskExit(2);

  //HJ
  cam->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
  cam->StopMotion();
  cam->DetachMotion();
  //Vec tpos={50.f,12.f,-517.f};
  //Vec cpos={46.f,17.f,-491.f};
  Vec tpos={51.829f,14.718f,-515.599f};
  Vec cpos={44.949f,2.551f,-483.269f};
  cam->SetPosition(cpos);
  cam->SetTargetPosition(tpos);
  cam->SetFov(59.84f);
  while( 1 ){
	//ʐ^B
	if( K7EnmANG::IsFaded() ) break;
	K7SCR_RETSYS();
  }
#endif

#if 1
  s32		ac = 0;
  KK7BattleMainTask::BattleMainTaskExit(2);
  WK7PLAYERCONTROL->SetOperateEnable(false);
	
#if 0
  while( ac < EXPLOSION_WAIT+140 ){
	ac++;
	K7SCR_RETSYS();
  }
#endif
	
  gpSound->mPlayStreamNo(HPS_BOSS_KUN);
	
#if 0
  // ܂ő҂
  while( !K7EnmKUN::IsAppeard() ){
	K7SCR_RETSYS();
  }
#endif
	
  // Θb̃L
#if 1
  K7SCR_ENTER_PLAYMODE();
  K7SCR_ENTER_DEMOPAUSE();
	
  //k7app.SetFadeColor(0);
  //k7app.FadeStart(0xff,WK7_DEFAULT_FADE_TICK);
  //while( k7app.IsFade()==true ){
  //	K7SCR_RETSYS();
  //}
	
  {
	WK7Play	*pPlay;
	if( (pPlay=WK7Play::Create("00020709"))!=NULL ){
	  pPlay->Prepare();
	  while( pPlay->GetState()!=WK7Play::PREPARED ){
		GHMGCTASK_RETSYS();
	  }
	  k7app.FadeStart(0,WK7_TICK_PER_SEC * 3);
	  WK7Play::StorePlayTB();
	  pPlay->Start();
	  while( pPlay->GetState()!=WK7Play::PLAYED ){
		GHMGCTASK_RETSYS();
	  }
	  WK7PLAYERCONTROL->SetOperateEnable(false);
	  pPlay->SetVisibleAll(false);
	  GHMGCTASK_RETSYS();
	  GHMGCTASK_RETSYS();
	}
	GHM_SAFE_DELETE(pPlay);
	WK7Play::RestorePlayTB();
	WK7PLAYERCONTROL->SetOperateEnable(false);
  }
	
  k7app.FadeStart(0xff,0);
  k7app.SetFadeColor(0);
  k7app.FadeStart(0,WK7_DEFAULT_FADE_TICK);
  while( k7app.IsFade()==true ){
	K7SCR_RETSYS();
  }
  WK7PLAYERCONTROL->SetOperateEnable(false);
  K7SCR_EXIT_PLAYMODE();
  K7SCR_EXIT_DEMOPAUSE();
#endif
	
  //	cam->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
  //	WK7PLAYERCONTROL->SetOperateEnable(true);
  //	K7SCR_RETSYS();
	

  //Na
  K7EnmKUN::Start();

  // ʂ܂Ń[v
  while( K7EnmKUN::IsAlive() ){
	K7SCR_RETSYS();
  }
#else
  bool flg = false;
  s32 ac = 0;
  while( 1 ){
	//KUNSB
	if( !K7EnmKUN::IsAlive() ) break;
	if( !K7EnmKUN::IsAppeard() ){		//ogႾ߁B
	  KK7BattleMainTask::BattleMainTaskExit(2);
	  if( ac++ == (EXPLOSION_WAIT+140) ) gpSound->mPlayStreamNo(HPS_BOSS_KUN);
	  WK7PLAYERCONTROL->SetOperateEnable(false);
	}else{
	  if( !flg ){  //P񂾂B
		cam->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		WK7PLAYERCONTROL->SetOperateEnable(true);
		flg = true;
	  }
	  //cam->SetMode(WK7Cam::WK7CAM_PATH_ANIM);
	}

	K7SCR_RETSYS();
  }
#endif

  K7SCR_ENTER_PLAYMODE();
  K7SCR_ENTER_DEMOPAUSE();
	
  gpSound->mFadeVolumeStream(0,30);
  gpSound->mStopStream();

  //ogIB
  KK7BattleMainTask::BattleMainTaskExit(2);
#define BULLET_CAM 0

#if BULLET_CAM
  cam->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
  cam->StopMotion();
  cam->DetachMotion();
  //cam->SetCinemaScopeMode(true);
  //eJB
  Vec pos={54.f,8.f,-351.f},hand_pos={49.f,16.f,-515.f};
	
#endif
  WK7Play				*pPlay;
	
  while( (pPlay = WK7Play::Create("00020711"))==NULL ){
	K7SCR_RETSYS();
  }
	
#if BULLET_CAM
#if 0
  HSD_JObj *jobj = WK7PLAYERCONTROL->GetHandBone()->GetJObj();
  HSD_JObjSetupMatrix( jobj );
  HSD_MtxGetTranslate( jobj->mtx, &pos );
  pos.y += 7.f;
  pos.z -= 15.f;
#endif
  WK7PLAYERCONTROL->GetCharaPtr()->GetModel()->SetMotionRate( 0.5f );
  {
	//C_ShockWaveSet *bullet = IMPULSE.Request( &pos, K7EnmKUN::GetHitPos(), 0.3f );
	C_ShockWaveSet *bullet = IMPULSE.Request( &pos, &hand_pos, 0.3f );

	f32 counter = 0.f;
	bool flg = false;;
	while( 1 ){
	  //eJIB
	  Vec *tpos=IMPULSE.GetPos( bullet );
	  if( !tpos ) break;
	  //ā[B
	  //if( !flg && VECDistance( tpos, K7EnmKUN::GetHitPos() ) < 1.0f ){
	  if( !flg && VECDistance( tpos, &hand_pos ) < 1.0f ){
		//gpSound->mPlaySE( SFX_BOSS_ANGKUN_KUNDIE );
		flg = true;
		IMPULSE.TerminateAll();
		K7EnmANG::StopFeather();
		K7EnmKUN::StopHand();
		//k7app.FadeStart(0xff,4800);
		//k7app.SetFadeColor(0xffffffff);
		break;
	  }
	  KK7BattleMainTask::BattleMainTaskExit(2);
	  f32 rad = (f32)M_PI * counter / 180.f;
	  f32 val = sinf( rad );
	  Vec cpos={0.f, val - 0.5f, -(5.f+val*5.f)};
	  Mtx m;
	  MTXRotRad( m, 'y', 2.f*rad );
	  MTXMultVec( m, &cpos, &cpos );
	  VECAdd( tpos, &cpos, &cpos );
	  cam->SetPosition(cpos);
	  cam->SetTargetPosition(*tpos);
	  cam->SetFov(59.f);
	  //pLb
	  if( val > 0.05f && val < 0.95f ) counter += 15.f;
	  else counter += 0.1f;
	  //counter += (0.3f + 1.0f * val * val * val);
	  if( counter > 180.f ) counter = 0.f;
	  K7SCR_RETSYS();
	  //OSReport( "%f : %f\n", counter, val );
	}
  }

#endif
  cam->SetFar(32768.f);

  while( pPlay->GetState()!=WK7Play::LOADED ){
	K7SCR_RETSYS();
  }
	
  pPlay->Prepare();
	
  while( pPlay->GetState()!=WK7Play::PREPARED ){
	K7SCR_RETSYS();
  }
	
  gpSound->mStopSE(SFX_BOSS_ANGKUN_WINGSNOW);
  pPlay->Start();
  WK7Stage::SetRenderStage(false);
  WK7Chara::SetRenderChara(false);
  WK7Item::SetRenderItem  (false);
	
  while( pPlay->GetState()!=WK7Play::PLAYED ){
	K7SCR_RETSYS();
  }
  pPlay->SetVisibleAll(false);
  GHMGCTASK_RETSYS();
  GHMGCTASK_RETSYS();
	
  delete pPlay;
	
  //	GameInfo.SetMode     (WK7GameInfo::TERM           );
  //	GameInfo.SetTermState(WK7GameInfo::TERMSTATE_CLEAR);
	
  gpSound->mReleaseSsm( "seBossAngKun.ssm");
	
  //	k7app.FadeStart(0x00,4800);
  //	k7app.SetFadeColor(0);
	
  //IB
  //	while( k7app.IsFade()==true ){
  //	  K7SCR_RETSYS();
  //	}
	
  // I
  gpSound->mStopStream();
	
  K7SCR_EXIT_PLAYMODE();
  K7SCR_EXIT_DEMOPAUSE();
  //cam->SetCinemaScopeMode(false);
	
  GameInfo.SetMode     (WK7GameInfo::TERM           );
  GameInfo.SetTermState(WK7GameInfo::TERMSTATE_CLEAR);
	
  return true;
}
#endif

bool K7Stage707M01::PlayEventCallBack(WK7PlayEventInfo &info)
{
#pragma	unused(info)
	return false;
}

