////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage772M02
//
// K7Stage772M02.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE772M02_CPP__

#include "..\..\..\Scn\K7Scn07.h"
#include ".\K7Stage772M02.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Wat\WK7CharaPresent.h"
#include "..\..\..\Wat\K7GlobalFlag.h"
#include "..\..\..\Kaw\KK7Sound.h"

//bZ[W
#define	MES772M02_00	(0)		//Α献Ă悤


K7Stage772M02::K7Stage772M02(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage772M02_Camera);
	mAmbPlaySE = false;
}

K7Stage772M02::~K7Stage772M02()
{
}

//K7STAGE_KIHANKUITABLE_START(K7Stage772M02Kui)
//	K7STAGE_KIHANKUITABLE_CAM(1,K7EVENTTAMA(007201),142.905f, 16.557f, -130.700f, 154.855f, 14.045f, -74.328f)
//	K7STAGE_KIHANKUITABLE_CAM(2,K7EVENTTAMA(007202),142.905f, 16.557f, -130.700f, 154.855f, 14.045f, -74.328f)
//K7STAGE_KIHANKUITABLE_END()
bool K7Stage772M02::InitializeCallBack(void)
{
//	CreateKui(K7Stage772M02Kui);
	HereComeANewHSInit( PR_HS_TEN, ENENO_7_772M02_4 );
	
	return true;
}

bool K7Stage772M02::CondChangeCallBack(void)
{
//	WK7JObj		*pJObj;
//	bool		flag;
//	if( (pJObj=GetJObj("secret1_wall"))!=NULL ){
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_SP_772M02_0)==TRUE ){
//			flag = true;
//			K7SCR_JOBJ_HIDE(pJObj);
//		}else{
//			flag = false;
//			K7SCR_JOBJ_DISP(pJObj);
//		}
//		K7SCR_STG_SET_PATHENABLE("secret1_way",flag);
//	}
//	return WK7Stage::CondChangeCallBack();
//	return K7StageKihanBase::CondChangeCallBack();
	return true;
}

bool K7Stage772M02::SpAbilityCallBack(WK7SpAbilityInfo &info)
{
#pragma	unused(info)
	return true;
}

bool K7Stage772M02::ZanEventCallBack(WK7ZanEventInfo &info)
{
#pragma	unused(info)
//	switch( info.mEventNo ){
//	case	K7EVENTZAN(007201):
//		K7SCR_EVSETITEM(K7EVENTTAMA(007202),true);
//		break;
//	default:
//		break;
//	}
	return true;
}

//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool
K7Stage772M02::DoorEventCallBack( WK7DoorEventInfo &info )
{
	switch( info.mEventNo )
	{
		//h[[ւ̔
		case	K7EVENTDOOR( 007202 ):
			//h[[献JĂȂΒʉ߂łȂ
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007203) == FALSE )
			{
				FixCamMes( CAM772DOOR2LAUNDLY, MES772M02_00 );
				return( false );
			}
	    	break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

bool K7Stage772M02::BpLeaveCallBack(WK7BpInfo &info)
{
	u32 eventNo = GetBpEventNo(info);
	int pathNo  = GetBpPathNo( info );
	switch( eventNo ){
#if 0
	case	K7EVENTNO(007204):
		if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_CP_TRAVIS)==TRUE ){
			return true;
		}
		K7SCR_SET_GLOBAL_FLAG(K7GLFL_CP_TRAVIS);
		
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE(false);
		
		FixCam(TRAVIS);
		
		K7SCR_CHARAPRESENT_DEBUGSTART();
		K7SCR_RESERVENAME(K7SCR_CP_STARTTICK,0,  275,  222, 206,  54, 156, 297);
		K7SCR_TIMEWAIT(K7SCR_CP_WAITTIME);
		K7SCR_CHARAPRESENT_DEBUGEND();
		
		K7SCR_PC_SETVISIBLE(true);
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_EXIT_PLAYMODE();
		
		break;
#endif
	//ȈՃL
	case	K7EVENTNO(007204):
		//BOMB!Cxg
		if( (pathNo == 0) && (K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007291) == false) )
		{
			//CxgtOON
			K7SCR_SET_SCENARIO_FLAG(K7SCN07_EVFL_007291);
			////ȈՃLĐ
			//PlayOneShotCharaGeki( CAM772M01BOMB, 4800*3, true, SFX_BT_BOMB_SMILE );
			gpSound->mPlaySE( SFX_SCE0_3F_BOMB );
		}
		break;
	default:
		return true;
	}
	return true;
}

//------------------------------------------------------------------------------
// JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage772M02::SetCurrentCallBack( void )
{
	if( mAmbPlaySE == false )
	{
		KK7SoundLoopSePlayVolumeChange((Vec){-178.049f, 5.414f, -549.775f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		KK7SoundLoopSePlayVolumeChange((Vec){177.793f, 5.636f, -509.752f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		KK7SoundLoopSePlayVolumeChange((Vec){178.439f, 5.382f, -428.463f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		KK7SoundLoopSePlayVolumeChange((Vec){177.603f, 5.882f, -350.162f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		KK7SoundLoopSePlayVolumeChange((Vec){177.849f, 5.550f, -115.518f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		mAmbPlaySE = true;
	}
	
	//V^HSЉ
	if( false == HereComeANewHS(	PR_HS_TEN,
									ENENO_7_772M02_4,								// GID
									NULL,
									CAM772M02_HS_PRESEN_START,
									CAM772M02_HS_PRESEN_END,
									2,
									142,  273, -59, 153, 758, 111 )				// OЉp
	){
		SetManualBranch(false);
		return( true );
	}
	
	return( true );
}