////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage773M01
//
// K7Stage773M01.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE773M01_CPP__

#include "..\..\..\Scn\K7Scn07.h"
#include ".\K7Stage773M01.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Kaw\KK7Sound.h"

//K7STAGE_BROKENWALLINFO_START(K7Stage773M01_BrokenWallInfo)
//	K7STAGE_BROKENWALLINFO_CAM(K7EVENTNO(007303) , "event_007303" , "pass_msk1" , K7SCN07_SP_773M01_0 , BROKEN_WALL_0)
//	K7STAGE_BROKENWALLINFO_CAM(K7EVENTNO(007304) , "event_007304" , "pass_msk2" , K7SCN07_SP_773M01_1 , BROKEN_WALL_1)
//	K7STAGE_BROKENWALLINFO_CAM(K7EVENTNO(007305) , "event_007305" , "pass_msk3" , K7SCN07_SP_773M01_2 , BROKEN_WALL_2)
//K7STAGE_BROKENWALLINFO_END()

K7Stage773M01::K7Stage773M01(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
//	SetOneShotCamLocTbl(K7Stage773M01_Camera);
//	SetBrokenWallInfo  (K7Stage773M01_BrokenWallInfo);
	mAmbPlaySE = false;
}

K7Stage773M01::~K7Stage773M01()
{
}

//bool K7Stage773M01::CondChangeCallBack(void)
//{
//	int			i;
//	WK7JObj		*pJObj;
//	for(i=0 ; i<3 ; i++){
//		pJObj = GetJObj(k7Stage773M01_BrokenWallInfo[i].mpWallName);
//		if( K7SCR_GET_SCENARIO_FLAG(k7Stage773M01_BrokenWallInfo[i].mFlagID)==true ){
//			K7SCR_JOBJ_HIDE(pJObj);
//			K7SCR_STG_SET_PATHENABLE(k7Stage773M01_BrokenWallInfo[i].mpPathName,true );
//		}else{
//			K7SCR_JOBJ_DISP(pJObj);
//			K7SCR_STG_SET_PATHENABLE(k7Stage773M01_BrokenWallInfo[i].mpPathName,false);
//		}
//	}
//	return true;
//}

//K7Stage773M01_BrokenWallInfo* K7Stage773M01::GetWallInfo(u32 eventNo)
//{
//	switch( eventNo ){
//	case	K7EVENTNO(007303): return &k7Stage773M01_BrokenWallInfo[0];
//	case	K7EVENTNO(007304): return &k7Stage773M01_BrokenWallInfo[1];
//	case	K7EVENTNO(007305): return &k7Stage773M01_BrokenWallInfo[2];
//	default:
//		break;
//	}
//	return NULL;
//}

//bool K7Stage773M01::HitObjCallBack(WK7HitObjInfo &info)
//{
//	if( WK7PLAYERCONTROL->GetMainID()!=K7MSK ){
//		info.SetHitObjEnable(true);
////		if( info.mpHitObj!=NULL ){
////			info.mpHitObj->SetEnable(true);
////		}
//		return false;
//	}
//	
//	K7StageBrokenWallInfo	*pWallInfo = GetWallInfo(info.mEventNo);
//	if( pWallInfo==NULL ){
//		return true;
//	}
//	
//	KK7BattleMainTask::BattleMainTaskExit(2);
//	K7SCR_RETSYS();
//	K7SCR_RETSYS();
//	
//	while( GameInfo.SetMode(WK7GameInfo::PLAY)==false ){
//		K7SCR_RETSYS();
//	}
//	K7SCR_ENTER_PLAYMODE();
//	K7SCR_ENTER_DEMOPAUSE();
//	K7SCR_PC_SETVISIBLE(false);
//	
//	WK7JObj		*pJObj;
//	pJObj = GetJObj(pWallInfo->mpWallName);
//	K7SCR_JOBJ_HIDE         (pJObj);
//	K7SCR_SET_SCENARIO_FLAG (pWallInfo->mFlagID);
//	K7SCR_STG_SET_PATHENABLE(pWallInfo->mpPathName,true);
//	
//	FixCam((u32)pWallInfo->mCamID);
//	
//	K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_BREAK_WALL);
//	K7SCR_PC_RETURNVISIBLE();
//	K7SCR_EXIT_PLAYMODE();
//	K7SCR_EXIT_DEMOPAUSE();
//	
//	return false;
//}

//------------------------------------------------------------------------------
// JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage773M01::SetCurrentCallBack( void )
{
	if( mAmbPlaySE == false )
	{
		KK7SoundLoopSePlayVolumeChange((Vec){9.541f, 5.691f, -77.054f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		KK7SoundLoopSePlayVolumeChange((Vec){-8.006f, 5.691f, -76.680f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		KK7SoundLoopSePlayVolumeChange((Vec){-24.984f, 5.691f, -76.825f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		KK7SoundLoopSePlayVolumeChange((Vec){-58.237f, 5.691f, -232.049f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		mAmbPlaySE = true;
	}
	
	return( true );
}