////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage773M03
//
// K7Stage773M03.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE773M03_CPP__

#include "..\..\..\Scn\K7Scn07.h"
#include ".\K7Stage773M03.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Wat\WK7CharaPresent.h"
#include "..\..\..\Wat\K7GlobalFlag.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"

#define	STG773M03_DARTS_NUM		(3)		//_[c̓I_




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage773M03::K7Stage773M03(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage773M03_Camera );
	mAmbPlaySE = false;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage773M03::~K7Stage773M03()
{
}

//------------------------------------------------------------------------------
//iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
//------------------------------------------------------------------------------
bool
K7Stage773M03::InitializeCallBack( void )
{
	//_[c
	mInitDarts();
	
	return( true );
}

//------------------------------------------------------------------------------
// JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage773M03::SetCurrentCallBack( void )
{
	if( mAmbPlaySE == false )
	{
		KK7SoundLoopSePlayVolumeChange((Vec){49.770f, 23.841f, -232.461f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		mAmbPlaySE = true;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//ԕύX
//------------------------------------------------------------------------------
bool
K7Stage773M03::CondChangeCallBack( void )
{
	//doCxg͔Ȃ
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007301) == TRUE )
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(007301), false );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage773M03::EventCallBack( WK7EventInfo &info )
{
//#pragma	unused(info)
	switch( info.mEventNo )
	{
//		case	K7EVENTNO(007301):
//			K7SCR_EVSETITEM(K7EVENTTAMA(007302),true);
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_GETTAMA);
//			K7SCR_EVCONDCHANGE();
//			return false;
		
		case	K7EVENTNO(007301):
			//inGame~
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			//vC[PB_[cQ[Jn
			if( WK7PLAYERCONTROL->GetMainID() == K7KVN )
			{
				//plĂяo
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(007301), -1 );
				K7SCR_PANEL_START();
				K7SCR_PANEL_TERMWAIT();
				K7SCR_RETSYS();
				K7SCR_PANEL_EXIT();
				//mCYOɃXe[WPC\
				K7SCR_STG_VISIBLE( mID, false );
				K7SCR_PC_SETVISIBLE( false );
				K7SCR_PANEL_EXITWAIT();
				//_[cQ[doĂ
				if( mPlayDarts() == true )
				{
					//\
					KK7BattleMainTask::BattleMainTaskExit(2);
					K7SCR_ENTER_PLAYMODE_B();
					//\֎~
					WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_KAMAE_NO);
					//dotOON
					K7SCR_SET_SCENARIO_FLAG( K7SCN07_EVFL_007301 );
					//Cxg
					K7SCR_EVNO_SETENABLE( K7EVENTNO(007301), false );
					//do
					mAppearFairy();
					//\֎~
					WK7PLAYERCONTROL->BattlePadRegulationClear();
				}
				K7SCR_PC_SETVISIBLE( true );
			}else
			{
				//䂩
				FixCamWithRiddle( EV_DARTS_RIDDLE );
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			break;
		
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//qbgIuWF
//------------------------------------------------------------------------------
bool
K7Stage773M03::HitObjCallBack( WK7HitObjInfo &info )
{
	//_[cQ[̂݃qbgIuWFɔ
	if( mPlayDartsFlag == true )
	{
		switch( info.mEventNo )
		{
			//_[c̓I1
			case	K7EVENTNO( 007304 ):
				//I1tOON
				mDartsTarget1 = true;
				//IuWF
				info.mpJObj->Hide( false, true );
				//SEĐ
				gpSound->mPlaySE(SFX_SYS_TRUE);
				break;
			
			case	K7EVENTNO( 007305 ):
				//I2tOON
				mDartsTarget2 = true;
				//IuWF
				info.mpJObj->Hide( false, true );
				//SEĐ
				gpSound->mPlaySE(SFX_SYS_TRUE);
				break;
			
			case	K7EVENTNO( 007306 ):
				//I3tOON
				mDartsTarget3 = true;
				//IuWF
				info.mpJObj->Hide( false, true );
				//SEĐ
				gpSound->mPlaySE(SFX_SYS_TRUE);
				break;
			
			default:
				break;
		}
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//qbgIuWF̏
//------------------------------------------------------------------------------
void
K7Stage773M03::mInitHitObj( u32 inEvNo )
{
	WK7HitObj*     pHitObj;
	WK7HitObjJObj* pHitJObj;
	WK7JObj*       pJObj;
	
	if( (pHitObj=WK7HitObj::FindEvent(inEvNo)) != NULL )
	{
		pHitObj->SetEnable( true );
	}
	if( (pHitJObj=WK7HitObj::FindEventNo(inEvNo)) != NULL )
	{
		if( (pJObj=pHitJObj->GetJObj()) != NULL )
		{
			pJObj->Disp( true, true );
		}
	}
}

//------------------------------------------------------------------------------
//_[cQ[̏
//------------------------------------------------------------------------------
void
K7Stage773M03::mInitDarts( void )
{
	WK7JObj* pJObj;
	
	//qbgIuWFNA
	mInitHitObj( K7EVENTNO(007304) );
	mInitHitObj( K7EVENTNO(007305) );
	mInitHitObj( K7EVENTNO(007306) );
	
	//_[cϐ
	mDartsTarget1  = false;
	mDartsTarget2  = false;
	mDartsTarget3  = false;
	mPlayDartsFlag = false;
	
	//iCtf\
	if( (pJObj=GetJObj("knife1")) != NULL )
	{
		pJObj->Hide( false, true );
	}
	if( (pJObj=GetJObj("knife2")) != NULL )
	{
		pJObj->Hide( false, true );
	}
	if( (pJObj=GetJObj("knife3")) != NULL )
	{
		pJObj->Hide( false, true );
	}
	
	//etO
	mCheckFire = false;
}

//------------------------------------------------------------------------------
//_[cQ[̃|WVݒƎˌ
//------------------------------------------------------------------------------
void
K7Stage773M03::mSetDartsPosAndShot( int inPosNo )
{
	f32 tempX, tempZ;

#if	0
	//LN^̍Wݒ
	WK7PLAYERCONTROL->SetPosition( &mpOneShotCamera[inPosNo].pos );
	tempX = mpOneShotCamera[inPosNo].tgt.x - mpOneShotCamera[inPosNo].pos.x;
	tempZ = mpOneShotCamera[inPosNo].tgt.z - mpOneShotCamera[inPosNo].pos.z;
	WK7PLAYERCONTROL->SetRotY( atan2(tempX,tempZ) );
#else
	//LN^̍Wݒ
	tempX = mpOneShotCamera[inPosNo].tgt.x - mpOneShotCamera[inPosNo].pos.x;
	tempZ = mpOneShotCamera[inPosNo].tgt.z - mpOneShotCamera[inPosNo].pos.z;
	//\
	while( WK7PLAYERCONTROL->SetPcBattleMode(&mpOneShotCamera[inPosNo].pos,atan2(tempX,tempZ)) == NULL )
	{
		K7SCR_RETSYS();
	}
#endif
	//Xe[W؂ւȂ悤ɒ
	K7SCR_TIMEWAIT( 1200 );	
	K7SCR_STG_VISIBLE( mID, true );
	
	//1I܂Ń[v
	while( mCheckFire == false )
	{
		K7SCR_RETSYS();
	}
	
	//\畜A
	WK7PLAYERCONTROL->ExitPcBattleMode( 2 );
	
	// og^XNȂ烋[v
	while( WK7PLAYERCONTROL->PcBattleTaskTest() == true )
	{
		K7SCR_RETSYS();
	}
	
	K7SCR_TIMEWAIT(4);
	
	//etO
	mCheckFire = false;
}

//------------------------------------------------------------------------------
//_[cQ[
//------------------------------------------------------------------------------
bool
K7Stage773M03::mPlayDarts( void )
{
	f32 mKamaeDirBk;
	Vec mKamaePosBk;

	//_[cQ[tO𗧂Ă
	mPlayDartsFlag = true;
	
	//PC싖
//	K7SCR_EXIT_PLAYMODE();

	WK7PLAYERCONTROL->GetRotY(&mKamaeDirBk);
	WK7PLAYERCONTROL->GetPosition(&mKamaePosBk);
	
#ifdef	DEBUG_MATSUZAKI
	mSetDartsPosAndShot( EV_DARTS_POS1_1 + 2 );
	mSetDartsPosAndShot( EV_DARTS_POS2_1 + 2 );
	mSetDartsPosAndShot( EV_DARTS_POS3_1 + 2 );
#else
	//1
	mSetDartsPosAndShot( EV_DARTS_POS1_1 + 2 );
//	mSetDartsPosAndShot( EV_DARTS_POS1_1 + HSD_Randi(3) );
	//2
	mSetDartsPosAndShot( EV_DARTS_POS2_1 + 2 );
//	mSetDartsPosAndShot( EV_DARTS_POS2_1 + HSD_Randi(3) );
	//3
	mSetDartsPosAndShot( EV_DARTS_POS3_1 + 2 );
//	mSetDartsPosAndShot( EV_DARTS_POS3_1 + HSD_Randi(3) );
#endif
	//PCs
//	K7SCR_ENTER_PLAYMODE();
	
	WK7PLAYERCONTROL->SetRotY(mKamaeDirBk);
	WK7PLAYERCONTROL->SetPosition(&mKamaePosBk);
	
	//3`FbN
	if( (mDartsTarget1 == true) && (mDartsTarget2 == true) && (mDartsTarget3 == true) )
	{
		mInitDarts();
		return( true );
	}
	
	mInitDarts();
	return( false );
}

//------------------------------------------------------------------------------
//v[[̍U
//------------------------------------------------------------------------------
bool
K7Stage773M03::AttackCallBack( WK7AttackInfo &info )
{
#pragma unused(info)
	
	//_[cQ[H
	if( mPlayDartsFlag == true )
	{
		//etOON
		mCheckFire = true;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//~NHSo
//------------------------------------------------------------------------------
void
K7Stage773M03::mAppearFairy( void )
{
#if	1
	Vec	initpos;
	
	//inGame~
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_EXIT_DEMOPAUSE();
	K7SCR_PC_SETVISIBLE( false );
	
	FixCam( EV_POP_FAIRY );
	gpSound->mPlaySE( SFX_BT_HS_WARAI04 );
	K7SCR_TIMEWAIT( 4800*3 );
	
	K7SCR_NOISE_REQUEST();
	K7SCR_PC_SETVISIBLE( true );
	FixCam( EV_AFTER_DARTS_CLEAR );
	SetCurrentPath(	GetPathNurbsAll("curve38"),
					1.000f,
					1,									// 0:forward 1:back
					WK7PATHINFO_INITDIR_TGTDIR );		// : wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
	WK7PLAYERPATHCONTROL->GetCurrentPosition(&initpos);
	WK7CAMPATHFOLLOWINFO->SetStageStartMode              (true);
	WK7CAMPATHFOLLOWINFO->SetStageStartCamPosition       ((Vec){98.622f, 12.478f, -141.638f});
	WK7CAMPATHFOLLOWINFO->SetStageStartCamTargetPosition ((Vec){95.715f, 13.528f, -164.894f});
	WK7CAMPATHFOLLOWINFO->SetStageStartTargetInitPosition(initpos);
	WK7CAMPATHFOLLOWINFO->SetStageStartDist( 3.0f );
	K7SCR_TIMEWAIT( 4800 );
	K7SCR_NOISE_RELEASE();
	
	//inGameĊJ
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
#endif
#if	0
	WK7Npc* pNpc;
	
	//inGame~
	K7SCR_ENTER_PLAYMODE();
//	K7SCR_ENTER_DEMOPAUSE();
	K7SCR_PC_SETVISIBLE( false );
	
	pNpc = WK7Npc::Find( ENENO_7_773M03_1 );
	if( NULL != pNpc )
	{
		if( pNpc->AiModeSet_TestPop() == true )
		{
			pNpc->AiModeSet_PopGo();
		}
	}
	FixCam( EV_POP_FAIRY );
	gpSound->mPlaySE( SFX_SYS_HATO_IKU );
	
//	K7SCR_CHARAPRESENT_DEBUGSTART();
//	K7SCR_RESERVENAME(    9600,0,  294,  286, 240, 160, 160, 160);
	K7SCR_TIMEWAIT(K7SCR_CP_WAITTIME);
//	K7SCR_CHARAPRESENT_DEBUGEND();
	
//	K7SCR_TIMEWAIT( 4800 * 5 );
	
	//inGameĊJ
	K7SCR_EXIT_PLAYMODE();
//	K7SCR_EXIT_DEMOPAUSE();
	K7SCR_PC_SETVISIBLE( true );
#endif
}
