////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage775M01
//
// K7Stage775M01.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE775M01_CPP__

#include "..\..\..\Scn\K7Scn07.h"
#include ".\K7Stage775M01.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Yam\YK7EffectVapor.h"

#define	MDL775M01_STEAM_00	"steam1"
#define	MDL775M01_STEAM_01	"steam2"

K7Stage775M01::K7Stage775M01(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mpEffectVapor00 = NULL;
	mpEffectVapor01 = NULL;
	mAmbPlaySE      = false;
}

K7Stage775M01::~K7Stage775M01()
{
}

//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
bool
K7Stage775M01::CondChangeCallBack(void)
{
	if( mpEffectVapor00 == NULL )
	{
		mpEffectVapor00 = CreateVaporEffect( VP_775M01, GetJObj(MDL775M01_STEAM_00) );
	}
	if( mpEffectVapor01 == NULL )
	{
		mpEffectVapor01 = CreateVaporEffect( VP_775M01, GetJObj(MDL775M01_STEAM_01) );
	}
	return( true );
}

//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
bool
K7Stage775M01::TerminateCallBack( void )
{
	if( mpEffectVapor00 != NULL )
	{
		DeleteEffect( mpEffectVapor00 );
	}
	if( mpEffectVapor01 != NULL )
	{
		DeleteEffect( mpEffectVapor01 );
	}
	return( true );
}

//------------------------------------------------------------------------------
// JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage775M01::SetCurrentCallBack( void )
{
	if( mAmbPlaySE == false )
	{
		KK7SoundLoopSePlayVolumeChange((Vec){-43.359f, 6.100f, 143.093f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		KK7SoundLoopSePlayVolumeChange((Vec){-43.359f, 6.100f, 143.093f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		mAmbPlaySE = true;
	}
	
	return( true );
}
