////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage100M00
//
// K7Stage100M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE100M00_H__
#define	__K7STAGE100M00_H__

#include "..\K7Stage.h"

class K7Stage100M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	WK7RenderObjEffect		*mpRainEffect;
	
	K7Stage100M00();
	K7Stage100M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage100M00();
	
	virtual bool InitializeCallBack(void);
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
	virtual bool SetCurrentCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool HitObjCallBack    (WK7HitObjInfo    &);
	virtual bool PlayEventCallBack (WK7PlayEventInfo &);
};

#ifdef	__K7STAGE100M00_CPP__

enum K7STAGE100M00_ONESHOTCAM{
	DOOR_010009,
	DOOR_010010,
	DOOR_010016,
};

K7StageEventOneShotCamera	K7Stage100M00_Camera[] = {
	{{1.639f, 5.491f, 12.805f},{5.526f, 4.915f, 43.529f}},			// JȂ
	{{25.953f, 5.000f, 229.651f},{16.037f, 7.922f, 201.903f}},		// J
	{{-0.118f, 8.720f, -360.089f},{8.823f, 5.070f, -321.868f}},		// ւ̔
};

enum{
	K7STAGE100M00_MES_DONT_OPEN_DOOR = 0		,		// ͊JȂ
	K7STAGE100M00_MES_BROKEN_BY_POWERFUL_WEAPON	,		// ̔͋͂ȉΊŔjł
	K7STAGE100M00_MES_BROKEN_DOOR				,		// ւ̔j󂵂
	K7STAGE100M00_MES_OPEN_GATE					,		// J
	K7STAGE100M00_MES_USE_KEY					,		// uq̌vg
	K7STAGE100M00_MES_LOCKED_KEY				,		// |Ă
};

#endif

#endif	//__K7STAGE100M00_H__

