////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage107M00
//
// K7Stage107M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE107M00_H__
#define	__K7STAGE107M00_H__

#include "..\K7Stage.h"

class K7Stage107M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	WK7RenderObjEffect	*mpFireEffect;
	WK7ModelMotion		*mpMskMotion;

	EFFECT *Impact ;
	u32 ImpactID ;
	EFFECT *Screen ;
	u32 ScreenID ;
	EFFECT *Smoke ;
	u32 SmokeID ;
	
	K7Stage107M00();
	K7Stage107M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage107M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
};

#ifdef	__K7STAGE107M00_CPP__

enum K7STAGE107M00_ONESHOTCAM{
	DOOR_010014,
	EVENT_015301,
	EVENT_015301_2,
};

K7StageEventOneShotCamera	K7Stage107M00_Camera[] = {
	{{-1257.862f, 11.118f, -299.442f},{-1209.739f, 14.312f, -324.765f}},		// }XNŒʂ
	{{-12.912f, 10.041f, -294.194f},{6.234f, 1.051f, -284.559f}},				// ޖ؂זĂ
	{{0.789f, 11.272f, -287.167f},{8.723f, 13.708f, -266.376f}},				// }XN̓[V
};

enum{
	K7STAGE107M00_MES_CANT_ADVANCE_BY_FLAME = 0	,		// Ői߂Ȃ
	K7STAGE107M00_MES_EXIST_OBSTACLE			,		// ޖ؂זĂ
};

#endif

#endif	//__K7STAGE107M00_H__

