////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage112M00
//
// K7Stage112M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE112M00_CPP__

#include ".\K7Stage112M00.h"
//#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn01.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"

K7Stage112M00::K7Stage112M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mpRainEffect = NULL;
	SetOneShotCamLocTbl(K7Stage112M00_Camera);
}

K7Stage112M00::~K7Stage112M00()
{
//	gpSound->mStopSE(SFX_SCE1_FUKU_RAIN);
	ReleaseEffect(mpRainEffect);
}

bool K7Stage112M00::CreateCallBack(void)
{
	CreateOwnStageMotion(   0);
	//LLGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	return true;
}

bool K7Stage112M00::TerminateCallBack(void)
{
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	return true;
}

#define	K7SCN01_STG112M00_CLOSEPATH		"BridgePath01"
bool K7Stage112M00::InitializeCallBack(void)
{
//	mpRainEffect = CreateEffectRain(40.0f,0.0f);
	HereComeANewHSInit( PR_HS_ANOT, ENENO_1_112M00_2 );
	
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_0101)!=TRUE ){
		WK7PathNurbs	*pPathNurbs = SearchPath(K7SCN01_STG112M00_CLOSEPATH);
		if( pPathNurbs!=NULL ){
			pPathNurbs->SetEnable  (false);
			pPathNurbs->SetEnableEx(false);
		}
	}
	SetZanEnable(K7EVENTTAMA(010000),false);
	return true;
}

bool K7Stage112M00::SetCurrentCallBack(void)
{
	KK7SoundLoopSePlayVolumeChange((Vec){ 402.514f,  8.072f, -1258.130f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_AMB_MUSHI2);
	KK7SoundLoopSePlayVolumeChange((Vec){ 700.934f, -0.800f, -1479.582f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_AMB_MUSHI_LOOP );
	KK7SoundLoopSePlayVolumeChange((Vec){1141.927f,  2.618f, -1414.045f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_AMB_MUSHI2);
	KK7SoundLoopSePlayVolumeChange((Vec){1070.879f,  6.254f, -1053.826f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_AMB_MUSHI_LOOP );
	KK7SoundLoopSePlayVolumeChange((Vec){ 815.779f,  1.345f, - 814.459f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_AMB_MUSHI2);
	KK7SoundLoopSePlayVolumeChange((Vec){ 382.531f,  2.400f, - 834.163f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_AMB_MUSHI_LOOP );
	KK7SoundLoopSePlayVolumeChange((Vec){ 164.499f, -2.255f, - 499.567f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_AMB_MUSHI2);
	KK7SoundLoopSePlayVolumeChange((Vec){  87.818f, -0.800f, - 313.615f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_AMB_MUSHI_LOOP );
	
	//V^HSЉ
	if( false == HereComeANewHS(	PR_HS_ANOT,
									ENENO_1_112M00_2,								// GID
									NULL,
									CAM112M00_HS_PRESEN_START,
									CAM112M00_HS_PRESEN_END,
									0,
									197,  301, -30, 119, 706, 167 )				// OЉp
	){
		SetManualBranch(false);
//		return( false );
	}
	
	// `FbN
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010100)==FALSE ||
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010101)==FALSE ||
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010102)==FALSE ||
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010103)==FALSE ){
//	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010100_1)!=FALSE ||
//	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010100_2)!=TRUE  ||
//	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010100_3)!=TRUE  ||
//	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010101_1)!=FALSE ||
//	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010101_2)!=TRUE  ||
//	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010101_3)!=TRUE  ||
//	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010102_1)!=FALSE ||
//	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010102_2)!=TRUE  ||
//	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010102_3)!=TRUE  ||
//	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010103_1)!=FALSE ||
//	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010103_2)!=TRUE  ||
//	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010103_3)!=TRUE  ){
		SetZanEnable(K7EVENTTAMA(010000),true);
		K7SCR_EVCONDCHANGE();
		return true;
	}
	
	// o`FbN
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_0101)==TRUE ){
		K7SCR_EVCONDCHANGE();
		if( K7SCR_EVHASITEM(K7EVENTTAMA(010000))==false ){
			K7SCR_EVNO_SETENABLE(K7EVENTTAMA(010000),true);
		}
		return true;
	}
	
	SetManualBranch(true);
	
	while( WK7Stage::IsChanging()==true ){
		K7SCR_RETSYS();
	}
	
	SetManualBranch(false);
	
	WK7StagePlaceInfo		*pPlaceInfo = NULL;
	const char				*pBpName;
	switch( GetPrevStageID() ){
	case	K7STGID(113,0): pBpName="branchB"; break;
	case	K7STGID(113,1): pBpName="branchC"; break;
	case	K7STGID(113,2): pBpName="branchE"; break;
	case	K7STGID(113,3): pBpName="branchF"; break;
	default:                pBpName=NULL     ; break;
	}
	if( pBpName!=NULL ){
		pPlaceInfo = GetPlaceInfo(pBpName);
		SetCameraStartPosition(pPlaceInfo);
	}
	SandRelease(pPlaceInfo);
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	WK7JObj		*pTamaJObj = GetTamaJObj(K7EVENTTAMA(010000));
	
	if( pTamaJObj!=NULL ){
		pTamaJObj->Disp(false,true);
	}
	CreateTamaEffect(K7EVENTTAMA(010000));
	
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	K7SCR_TIMEWAIT(2400);
	
	if( PlayMotion(0,0.0f)==true ){
		WK7CameraMotion	*pCameraMotion = GetOwnCameraMotion(0);
		if( pCameraMotion!=NULL ){
			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
			WK7CAM->AttachMotion(pCameraMotion);
			WK7CAM->PlayMotion();
			WK7CAM->SetMotionLoop(false);
		}
		gpSound->mPlaySE(SFX_SCE1_TSURIBASHI);
		SetMotionLoop(false);
		while( GetMotionState()!=WK7MODEL_NOANIM ){
			K7SCR_RETSYS();
		}
		while( WK7CAM->GetMotionState()!=WK7MODEL_NOANIM ){
			K7SCR_RETSYS();
		}
		WK7CAM->StopMotion();
		WK7CAM->DetachMotion();
	}
	
	gpSound->mPlaySE(SFX_SYS_CAMERA_ZOOM);						// Y[op SE
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
	
//	K7SCR_TIMEWAIT(2400);
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	WK7PathNurbs	*pPathNurbs = SearchPath(K7SCN01_STG112M00_CLOSEPATH);
	if( pPathNurbs!=NULL ){
		pPathNurbs->SetEnable  (true);
		pPathNurbs->SetEnableEx(true);
	}
	
	K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_0101);
	
	SetZanEnable(K7EVENTTAMA(010000),true);
	
	return true;
}

bool K7Stage112M00::CondChangeCallBack(void)
{
	bool	tama;
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_0101)==TRUE ){
		if( PlayMotion(0,-1.0f)==true ){
			SetMotionLoop(false);
		}
		if( K7SCR_EVHASITEM(K7EVITEM_TAMA(010000))==FALSE ){
			tama = true;
		}else{
			tama = false;
		}
	}else{
		tama = false;
	}
	SetVisibleTamaJObj(K7EVENTTAMA(010000),tama);
	if( tama==true ){
		CreateTamaEffect(K7EVENTTAMA(010000));
	}else{
		ReleaseTamaEffect();
	}
	return true;
}

//bool K7Stage112M00::DoorEventCallBack(WK7DoorEventInfo &info)
//{
//	switch( info.mEventNo ){
//	case	K7EVENTDOOR(015004):
//		info.mNextStageID = K7STGID(108,0);
//		strncpy(info.mNextBpName,"door_010008",WK7DOOREVENT_BPNAME_MAX-1);
//		break;
//	default:
//		break;
//	}
//	return true;
//}

bool K7Stage112M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(010117):
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		
		FixCam(EVENT_010117);
		
		K7SCR_STG_MESSAGE_B(K7STAGE112M00_MES_MAP);
//		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(3.0f));
		
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		break;
	default:
		break;
	}
	return true;
}


