////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage112M00
//
// K7Stage112M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE112M00_H__
#define	__K7STAGE112M00_H__

#include "..\K7Stage.h"

class K7Stage112M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	WK7RenderObjEffect		*mpRainEffect;
	
	K7Stage112M00();
	K7Stage112M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage112M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool TerminateCallBack (void);
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool SetCurrentCallBack(void);
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
	virtual bool EventCallBack     (WK7EventInfo     &);
};

#ifdef	__K7STAGE112M00_CPP__

enum K7STAGE112M00_ONESHOTCAM{
	DOOR_010002,
	EVENT_010117,
	CAM112M00_HS_PRESEN_START,
	CAM112M00_HS_PRESEN_END,
};

K7StageEventOneShotCamera	K7Stage112M00_Camera[] = {
	{{161.231f, 15.841f, -2086.322f},{180.573f, 9.601f, -2029.759f}},		// uꉮ̌vgƂ̉o
//	{{320.228f, 6.450f, -726.910f},{321.804f, 5.317f, -722.594f}},			// pl
	{{314.021f, 7.641f, -746.759f},{331.542f, 5.302f, -731.449f}},			// pl
	{{136.563f, 7.923f, -358.263f},{136.539f, 5.264f, -335.138f}},			// HSЉp
	{{136.438f, 30.223f, -516.938f},{136.414f, 27.564f, -493.813f}},		// HSЉpY[
};

enum{
//	K7STAGE112M00_MES_BUILT_BRIDGE = 0	,	// ˂
	K7STAGE112M00_MES_MAP = 0	,	// 
};

#endif

#endif	//__K7STAGE112M00_H__

