////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage113M00
//
// K7Stage113M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE113M00_H__
#define	__K7STAGE113M00_H__

#include "..\K7Stage.h"

#define	K7SCN01_STG113_FUSUMA_MOTION		"Fusumagroup"

class K7Stage113 : public WK7Stage{
protected:
	K7Stage113();
	K7Stage113(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	bool MotionPlay(int evflag,u32 mesid,int id,int camid=-1);
public:
	virtual ~K7Stage113();
};

class K7Stage113M00 : public K7Stage113{
	friend class WK7Stage;
protected:
	K7Stage113M00();
	K7Stage113M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
public:
	virtual ~K7Stage113M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
};

#ifdef	__K7STAGE113M00_CPP__

enum K7STAGE113M00_ONESHOTCAM{
	DOOR_010002,
	EVENT_010105,
	EVENT_010106,
	EVENT_010107,
};

K7StageEventOneShotCamera	K7Stage113M00_Camera[] = {
	{{ -201.578f, 11.170f, -280.252f},{-188.038f, 9.804f, -272.835f}},		// uq̌vgƂ̉o
	{{31.644f, 11.664f, -1.913f},{9.260f, 9.900f, -1.912f}},
	{{-33.062f, 11.664f, -1.094f},{-10.713f, 9.515f, -0.933f}},
	{{0.450f, 11.664f, -31.296f},{0.213f, 9.009f, -9.001f}},
};

enum{
	K7STAGE113M00_MES_CLOSE_FUSUMA_EVENT_010105 = 0		,		// ̂ӂ܂߂EVENT_010105
	K7STAGE113M00_MES_OPEN_FUSUMA_EVENT_010105			,		// ̂ӂ܂JEVENT_010105
	K7STAGE113M00_MES_CLOSE_FUSUMA_EVENT_010106			,		// Ղ̂ӂ܂߂EVENT_010106
	K7STAGE113M00_MES_OPEN_FUSUMA_EVENT_010106			,		// Ղ̂ӂ܂JEVENT_010106
	K7STAGE113M00_MES_CLOSE_FUSUMA_EVENT_010107			,		// ̂ӂ܂߂EVENT_010107
	K7STAGE113M00_MES_OPEN_FUSUMA_EVENT_010107			,		// ̂ӂ܂JEVENT_010107
};

#endif

#endif	//__K7STAGE113M00_H__

