////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage113M01
//
// K7Stage113M01.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE113M01_H__
#define	__K7STAGE113M01_H__

#include ".\K7Stage113M00.h"

class K7Stage113M01 : public K7Stage113{
	friend class WK7Stage;
protected:
	K7Stage113M01();
	K7Stage113M01(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage113M01();
	
	virtual bool CreateCallBack    (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
};

#ifdef	__K7STAGE113M01_CPP__

enum K7STAGE113M01_ONESHOTCAM{
	DOOR_010002,
	EVENT_010108,
	EVENT_010109,
	EVENT_010110,
};

K7StageEventOneShotCamera	K7Stage113M01_Camera[] = {
	{{ -201.578f, 11.170f, -280.252f},{-188.038f, 9.804f, -272.835f}},		// uq̌vgƂ̉o
	{{-33.096f, 10.014f, -1.001f},{-9.085f, 8.024f, -1.278f}},
	{{32.025f, 10.014f, -0.790f},{7.981f, 8.456f, -0.715f}},
	{{-0.695f, 10.014f, -34.011f},{-0.255f, 10.262f, -9.921f}},
};

enum{
	K7STAGE113M01_MES_GET_MAP2 = 0						,		// tNV}̒n}2ɓꂽ
	K7STAGE113M01_MES_CLOSE_FUSUMA_EVENT_010108			,		// Ղ̂ӂ܂߂EVENT_010108
	K7STAGE113M01_MES_OPEN_FUSUMA_EVENT_010108			,		// Ղ̂ӂ܂JEVENT_010108
	K7STAGE113M01_MES_CLOSE_FUSUMA_EVENT_010109			,		// ̂ӂ܂߂EVENT_010109
	K7STAGE113M01_MES_OPEN_FUSUMA_EVENT_010109			,		// ̂ӂ܂JEVENT_010109
	K7STAGE113M01_MES_CLOSE_FUSUMA_EVENT_010110			,		// ̂ӂ܂߂EVENT_010110
	K7STAGE113M01_MES_OPEN_FUSUMA_EVENT_010110			,		// ̂ӂ܂JEVENT_010110
};

#endif

#endif	//__K7STAGE113M01_H__

