////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage113M02
//
// K7Stage113M02.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE113M02_CPP__

#include ".\K7Stage113M02.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn01.h"

K7Stage113M02::K7Stage113M02(ghmGcListObj *pAnchor,int prio) : K7Stage113(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage113M02_Camera);
}

K7Stage113M02::~K7Stage113M02()
{
}

bool K7Stage113M02::CreateCallBack(void)
{
	CreateOwnStageMotion(   0);
	CreateOwnStageMotion(   1);
	return true;
}

bool K7Stage113M02::SetCurrentCallBack(void)
{
	return true;
}

bool K7Stage113M02::CondChangeCallBack(void)
{
	int			i;
	for(i=1 ; i<=3 ; i++){
		MotionPlay(K7SCN01_EVFL_010102_1,0xffffffff,i);
	}
	return true;
}

bool K7Stage113M02::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(010113):
		MotionPlay(K7SCN01_EVFL_010102_1,K7STAGE113M02_MES_CLOSE_FUSUMA_EVENT_010113,1,EVENT_010113);
		break;
	case	K7EVENTNO(010112):
		MotionPlay(K7SCN01_EVFL_010102_1,K7STAGE113M02_MES_CLOSE_FUSUMA_EVENT_010112,2,EVENT_010112);
		break;
	case	K7EVENTNO(010111):
		MotionPlay(K7SCN01_EVFL_010102_1,K7STAGE113M02_MES_CLOSE_FUSUMA_EVENT_010111,3,EVENT_010111);
		break;
	default:
		break;
	}
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010102_1)==FALSE &&
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010102_2)==TRUE  &&
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010102_3)==TRUE  ){
	    K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010102);
	}else{
	    K7SCR_RESET_SCENARIO_FLAG(K7SCN01_EVFL_010102);
	}
	return true;
}

