////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage116M00
//
// K7Stage116M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE116M00_H__
#define	__K7STAGE116M00_H__

#include "..\K7Stage.h"

class K7Stage116M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	WK7Chara				*mpKis;
	WK7Model				*mpKisModel;
	WK7ModelMotion			*mpKisMotion;
	
	K7Stage116M00();
	K7Stage116M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage116M00();
	
	virtual bool CreateCallBack(void);
	virtual bool SetCurrentCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool DoorEventCallBack(WK7DoorEventInfo &info);
	virtual bool InitializeCallBack(void);
	virtual bool TerminateCallBack(void);
};


#ifdef	__K7STAGE116M00_CPP__

enum K7STAGE116M00_ONESHOTCAM{
	CHANGE_CHARA0,
	CHANGE_CHARA0_1,
	CHANGE_CHARA1,
	CHANGE_CHARA1_1,
};

K7StageEventOneShotCamera	K7Stage116M00_Camera[] = {
	{{17.183f, 25.384f, 69.980f},{32.019f, 20.041f, 55.797f}},
	{{34.284f, 14.300f, 36.263f},{32.295f, 29.029f, 48.427f}},
	{{-22.268f, 22.156f, 71.005f},{-12.296f, 22.024f, 52.288f}},
	{{0.860f, 18.409f, 40.672f},{-10.268f, 28.044f, 53.009f}},
};

//enum{
//	K7STAGE116M00_MES_JUMP = 0			,		// ɏ
//};

#endif

#endif	//__K7STAGE116M00_H__

