////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage190M00
//
// K7Stage190M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/05/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE190M00_CPP__

#include "..\..\..\Scn\K7Scn01.h"
#include ".\K7Stage190M00.h"

K7Stage190M00::K7Stage190M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mpRainEffect = NULL;
//	SetOneShotCamLocTbl( K7Stage190M00_Camera );
}

K7Stage190M00::~K7Stage190M00()
{
	gpSound->mStopSE(SFX_SCE1_FUKU_RAIN);
	ReleaseEffect(mpRainEffect);
}

bool K7Stage190M00::InitializeCallBack(void)
{
	mpRainEffect = CreateEffectRain(40.0f,-5.5f);
	return true;
}

//bool K7Stage190M00::SetCurrentCallBack(void)
//{
//	return true;
//}

bool K7Stage190M00::CondChangeCallBack(void)
{
	SetVisibleJObj("RockCombined",!K7SCR_GET_SCENARIO_FLAG(K7SCN01_BREAK_ENTROCK),false,true);
	return false;
}

