////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage132M00
//
// K7Stage132M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE132M00_H__
#define	__K7STAGE132M00_H__

#include "..\K7Stage.h"

class K7Stage132M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage132M00();
	K7Stage132M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	bool mDeskOpen;
	bool DeskOpen(int se=0);
public:
	virtual ~K7Stage132M00();
	virtual bool CreateCallBack    (void);
	virtual bool TerminateCallBack (void);
	virtual bool InitializeCallBack(void);
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &);		// hACxg
	virtual bool EventCallBack     (WK7EventInfo     &);		// Cxg
	virtual bool SetCurrentCallBack(void);
	virtual bool CondChangeCallBack(void);
	
//	virtual bool TerminateCallBack (void)              { return true; }		// Iȉj
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
};

#ifdef __K7STAGE132M00_CPP__


enum K7STAGE132M00_ONESHOTCAM{
	ONESHOTCAM_011406,
	ONESHOTCAM_011406_RESULT,
};


K7StageEventOneShotCamera K7Stage132M00_Camera[] = {
	{{366.740f, 17.280f, 40.811f},{357.080f, 21.396f, 34.030f}},		// |[J[|X^[
	{{113.085f, 3.150f, -226.148f},{100.736f, 11.111f, -229.820f}},		// eo
};

#endif

#endif	//__K7STAGE132M00_H__

