////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage134M01
//
// K7Stage134M01.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE134M01_H__
#define	__K7STAGE134M01_H__

#include "..\K7Stage.h"

class K7Stage134M01 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage134M01();
	K7Stage134M01(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage134M01();
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &);		// hACxg
	virtual bool EventCallBack     (WK7EventInfo     &);		// Cxg
	virtual bool SetCurrentCallBack(void);
//	virtual bool CondChangeCallBack(void);
//	virtual bool BpLeaveCallBack( WK7BpInfo &info );
//	virtual bool HitObjCallBack    (WK7HitObjInfo    &);
//	virtual bool SpAbilityCallBack(WK7SpAbilityInfo &info);
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &);

//	virtual bool TerminateCallBack (void)              { return true; }		// Iȉj
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
};


#ifdef __K7STAGE134M01_CPP__


enum K7STAGE134M01_ONESHOTCAM{
	ELEV_CAMERA_POS,
	ELEV_PLAYER_POS,
};


K7StageEventOneShotCamera K7Stage134M01_Camera[] = {
	{{-10.381f, 11.568f, -107.046f},{-32.396f, 11.239f, -107.996f}},		//Gx[^ւ̃J
	{{-10.787f, -0.000f, -100.182f},{-17.787f, -0.000f, -100.182f}},		//Gx[^̃vC[̍W
};

#endif

#endif	//__K7STAGE134M01_H__

