////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage20M00
//
// K7Stage208M00.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 04/16/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE208M00_CPP__

#include ".\K7Stage208M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn02.h"
#include "..\..\..\Sato\SK7PanelBase.h"
#include "..\..\..\Yam\YK7EffectLensFlare.h"

#define	K7STAGE208M00_BRANCH208M00		"door_021001"


//`````````````````````````````````````````````````
//			RXgN^
//`````````````````````````````````````````````````
K7Stage208M00::K7Stage208M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	m_bMysterySound = false;
	SetOneShotCamLocTbl( K7Stage208M00_Camera );		//	J
	pNpcSu = NULL;	

	K7SCR_RESET_SCENARIO_FLAG	( K7SCN02_ENFL_POP22 );
	K7SCR_RESET_SCENARIO_FLAG	( K7SCN02_ENFL_POP23 );
	K7SCR_RESET_SCENARIO_FLAG	( K7SCN02_DRFL_020800_SHORT );
	if( GetPrevStageID() == K7STGID(201,1) ){
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN02_DRFL_020101_SHORT)==true ){
			K7SCR_SET_SCENARIO_FLAG		( K7SCN02_ENFL_POP22 );
		}else{
			K7SCR_SET_SCENARIO_FLAG		( K7SCN02_ENFL_POP23 );
		}
		K7SCR_RESET_SCENARIO_FLAG	( K7SCN02_DRFL_020101_SHORT );
	}
}

//`````````````````````````````````````````````````
//			fXgN^
//`````````````````````````````````````````````````
K7Stage208M00::~K7Stage208M00()
{
	// n
	::DeleteEffect( LensFlare ) ;
	::ReleaseLensFlareTexture() ;
}

//`````````````````````````````````````````````````
//		iǂݍݏÎɑ΂鏉j 
//`````````````````````````````````````````````````
bool	K7Stage208M00::InitializeCallBack( void )
{
	// YtA
	if( GetJObj("sun") != NULL )
	{
		::SetupLensFlareTexture() ;
		while( ::CheckLensFlareTexture() == FALSE ){
			K7SCR_RETSYS() ;
		}
		LensFlare = ::CreateLensFlareEffect( GetJObj("sun") ) ;
	}

	return true ;
}


//`````````````````````````````````````````````````
//			ԕύXitOɂԕύX邽߂ɗpj
//`````````````````````````````````````````````````
bool K7Stage208M00::CondChangeCallBack(void)
{	
	//R[êJ
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN02_DRFL_020801) == false )
	{
		SimpleModelDisp( "cyo_padlock_on" );
		SimpleModelHide( "cyo_padlock_off" );
	}else
	{
		SimpleModelHide( "cyo_padlock_on" );
		SimpleModelDisp( "cyo_padlock_off" );
	}
	
	//	wuX}C̑|ǂ	
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_HS_NEST )==true ){
		K7SCR_STG_SET_PATHENABLE( "pass_dan", true );
		K7SCR_STG_SET_DISABLEPATHCAMERA("event_020814_0",true);
	}
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN02_EVFL_ULCLSECRET) && K7SCR_GET_SCENARIO_FLAG( K7SCN02_DRFL_GETKEY ) ){
		K7SCR_STG_SET_DISABLEPATHCAMERA("event_020813_0",true);
	}
	
	SetSelectObjFlag(K7STGID(210,0),K7STAGE208M00_BRANCH208M00,-1,false);
	SetPassPathFlag (K7STGID(210,0),K7STAGE208M00_BRANCH208M00,-1,false);
	
	return true;
}

#if 0
//`````````````````````````````````````````````````
//			Cxg
//`````````````````````````````````````````````````
bool K7Stage208M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){		
		
	default:
		return true;
	}
	return false;
}
#endif

//`````````````````````````````````````````````````
//			hACxg
//`````````````````````````````````````````````````
bool K7Stage208M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
	case 	K7EVENTDOOR(020801):		
		if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_DRFL_020801 )==false ){			//	CxgĂȂ
			if( WK7PLAYERCONTROL->GetMainID() == K7CYO ){
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				WK7Npc::NpcVisibleAll(false);
				SimpleCyoPicking( "cyo_picking", 14 );
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_SET_SCENARIO_FLAG( K7SCN02_DRFL_020801 );
				K7SCR_EVCONDCHANGE();
				K7SCR_RETSYS();
//				info.mCinemaScopeClear = true;
				WK7Npc::NpcVisibleAll(true);
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
			}else{
				gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );		//䉹
				FixCamMes( 15, 2 );
//				FixCamSysMes( 15, K7SCR_SYSMES_CLOSED_BY_KEY );
				return( false );
			}
		}
		break;
		
	case	K7EVENTDOOR(020802):
		if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_DRFL_021301 ) ){			//	Cxg
			return true;
		}else{
			//inGame~
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );

			FixCam( 16 );									//Jݒ
			K7SCR_STGC_MESSAGE_B( 1 );
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );				

			return false;
		}
		break;
	case K7EVENTDOOR(020803):
		K7SCR_SET_SCENARIO_FLAG	( K7SCN02_DRFL_020800_SHORT );
		break;

	}
	return true;
}


//`````````````````````````````````````````````````
//			_o
//`````````````````````````````````````````````````
bool	K7Stage208M00::BpLeaveCallBack( WK7BpInfo &info )
{
	u32	evno   = GetBpEventNo( info );
	int	pathNo = GetBpPathNo( info );
	if( evno==0xffffffff )		return true;
		
	switch( evno ){
		
//		䉹		
	case	K7EVENTNO( 020813 ):
		//	XyVV[Nbg & `擾Ă炳Ȃ
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN02_EVFL_ULCLSECRET) && K7SCR_GET_SCENARIO_FLAG( K7SCN02_DRFL_GETKEY ) ){
			return true;
		}
		//	pXOł܂ȂĂȂƂ	
		if( pathNo == 0 && !m_bMysterySound ){
			//	䉹	
			gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );
			m_bMysterySound = true;
		}
		break;
	}
	return true;
}


//`````````````````````````````````````````````````
//			\̓Cxg
//`````````````````````````````````````````````````
bool K7Stage208M00::SpAbilityCallBack(WK7SpAbilityInfo &info)
{
//	u[XgWv	

	switch( info.mAbilityID ){
	case	PC_SPA_BOOST_JUMP:
		Vec vPos;
		WK7PLAYERCONTROL->GetPosition( &vPos );
		WK7PlayerSpInfoCyo*	pCyoInfo = WK7PLAYERCONTROL->GetSpInfoCyo();
		WK7PlayerSpInfoCyo*	pInfo 	= &tblK7Stage208M00_SpInfoParam[info.mType];
		pCyoInfo->mpToBpName 		= pInfo->mpToBpName;
		pCyoInfo->mFromPos	 		= vPos;//pInfo->mFromPos;
		pCyoInfo->mFromRotY			= pInfo->mFromRotY;
		pCyoInfo->mToPos			= pInfo->mToPos;
		pCyoInfo->mToRotY			= pInfo->mToRotY;
		pCyoInfo->mStageMessage 	= pInfo->mStageMessage;
		pCyoInfo->mStageMessageID	= pInfo->mStageMessageID;

		FixCam(info.mType);
		while( WK7PLAYERCONTROL->GetSpProc() < SPCYO_JUMPWAIT ){
			K7SCR_RETSYS();
		}
		FixCam(info.mType+7);
		while( WK7PLAYERCONTROL->GetSpProc()!=SPCYO_IDLE ){
			K7SCR_RETSYS();
		}
		return false;
		break;

	default:
		break;
	}
	return true;
}


//`````````````````````````````````````````````````
//			G񂾂Ƃ̃EC_RC擾Cxg
//`````````````````````````````````````````````````
bool K7Stage208M00::DieNpcCallBack(WK7DieNpcInfo &info)
{
	WK7Npc *pNpc = info.mpNpc;
	
	//	EC_r
	switch( pNpc->GetEneNo() ){
	case ENENO_2_208M00_1_KEY:
	case ENENO_2_208M00_2:
	case ENENO_2_208M00_3:
	case ENENO_2_208M00_11:	//iEC_j
	case ENENO_2_208M00_12:	//iEC_j
	case ENENO_2_208M00_13:	//iEC_j
	case ENENO_2_208M00_14:	//iEC_j
	case ENENO_2_208M00_15:	//iEC_j
	case ENENO_2_208M00_16:	//iEC_j
	case ENENO_2_208M00_17:	//iEC_j
	
		K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL)++;		//_Qbg
//		gpSound->mPlaySE( SFX_SCE2_ULMAYDA_MEDAL_GET );
		if( K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL) > K7SCN02_ULMEDAL_MAX ){
			K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL) = K7SCN02_ULMEDAL_MAX;
		}
		if( pNpc->GetEneNo() == ENENO_2_208M00_1_KEY ){
			K7SCR_SET_SCENARIO_FLAG( K7SCN02_ENFL_POP2 );
		}
		break;
		
	case ENENO_2_208M00_7_KEY:
		K7SCR_SET_SCENARIO_FLAG( K7SCN02_ENFL_POP3 );
		K7SCR_SET_SCENARIO_FLAG( K7SCN02_EVFL_HS_NEST );
		K7SCR_STG_SET_PATHENABLE( "pass_dan", true );
		K7SCR_STG_SET_DISABLEPATHCAMERA("event_020814_0",true);
		break;		
	}	
	return true;
}

// ̐ݒ
#define CORE_NUM	(2)
bool K7Stage208M00::SetCurrentCallBack(void)
{	
	pNpcSu = (K7EnmK *)WK7Npc::Find(ENENO_2_208M00_7_KEY);
	
	if ( pNpcSu != NULL ) {
		while( pNpcSu->SetUpTest()==false ){
			K7SCR_RETSYS();
		}
		pNpcSu->HitObjMake(WK7Stage::GetCurrentStage(), CORE_NUM);
	}
	
	SetCurrentCallBackDefaultProc();
	
	while( K7SCR_STG_GET_CURRENTID() == K7STGID(208,0) ){
		Vec pcPos;
		
		WK7PLAYERCONTROL->GetPosition(pcPos);
		if ( pcPos.y > 20.f ){						// Gȍ
			WK7PLAYERCONTROL->SetMuteki();
		}else{
			WK7PLAYERCONTROL->ClearMuteki();
		}
		K7SCR_RETSYS();
	}
	
	return true;
}
bool K7Stage208M00::HitObjCallBack(WK7HitObjInfo &info)
{
	if ( pNpcSu != NULL ) {
		if( (info.mEventNo >= pNpcSu->GetHitObjID()) && (info.mEventNo < (pNpcSu->GetHitObjID()+CORE_NUM) ) ){
			if ( false == pNpcSu->CoreHit((int )info.mEventNo, info.mTypeID, info.mHitPos) ) {
				// RAj󂵂ĂȂ
				// qbgIuWF𕜊
				info.SetHitObjEnable(true);
//				info.mpHitObj->SetEnable(true);
			}
			return false;
		}
	}
	return true;
}

bool K7Stage208M00::TerminateCallBack(void)
{
	// GԂ̂肠
	WK7PLAYERCONTROL->ClearMuteki();
	return true;
}



