////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage306M00 ~Xe[nEX
//
// K7Stage306M00.cpp 
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE306M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage306M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Kaw\KK7Sound.h"

//[V
#define	MOT306M00CATSLIDING_SLOW	K7MOTID(K7CAT,510)	//Lbg̃XCfBOEX[
#define	MOT306M00CATSLIDING			K7MOTID(K7CAT,520)	//Lbg̃XCfBOEʏ
#define	MOT306M00CATCAM				(0)					//Lbg̃XCfBOJ

// bZ[W
#define MES306M00_00				(0)					// ̐

K7Stage306M00::K7Stage306M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage306M00_Camera );
}

K7Stage306M00::~K7Stage306M00()
{
}

/*
	
	Jg
	
	
*/
bool K7Stage306M00::SetCurrentCallBack(void)
{
	if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_0305XX_ALL)==TRUE){		// S̓I SNAV[gJbgo
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(030509), true);				// ̃Cxg
	}else{
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(030509), false);				// ̃Cxg֎~
	}
	return true;
}

bool K7Stage306M00::CreateCallBack( void )
{
	//Lbĝ胂[V
	WK7RenderObj::CreateOwnMotionObj( K7MOT_ATTR|K7OBJTYPE_CHR, MOT306M00CATSLIDING_SLOW );
	WK7RenderObj::CreateOwnMotionObj( K7MOT_ATTR|K7OBJTYPE_CHR, MOT306M00CATSLIDING );
	CreateOwnStageMotion( MOT306M00CATCAM );
	
	return( true );
}

bool
K7Stage306M00::InitializeCallBack( void )
{
	//Lbĝ胂[V
	mpCatMotionSlow  = GetOwnModelMotion( K7MOT_ATTR|K7OBJTYPE_CHR, MOT306M00CATSLIDING_SLOW );
	mpCatMotion      = GetOwnModelMotion( K7MOT_ATTR|K7OBJTYPE_CHR, MOT306M00CATSLIDING );
	
	return( true );
}


/*
	
	
	Cxg
	
	
*/
bool K7Stage306M00::EventCallBack(WK7EventInfo &info)
{
	WK7StagePlaceInfo		*pPlaceInfo;
	
	switch( info.mEventNo )
	{
		//Lbgłisj
		case	K7EVENTNO( 030528 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			//Lbg炭Ēʉ
			if( WK7PLAYERCONTROL->GetMainID() == K7CAT )
			{
				if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030528) == false)
				{
					CatSliding( true );
					K7SCR_SET_SCENARIO_FLAG( K7SCN03_EVFL_030528 );
				}else
				{
					CatSliding( false, CAM306M00CATGOMOT );
				}
				K7SCR_NOISE_REQUEST();
//				WK7CAM->SetCinemaScopeMode( false );
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				//ړݒ
				SetCurrentPath(	GetPathNurbsAll("event_030529_0"),
								1.000f,
								0,									// 0:forward 1:back
								WK7PATHINFO_INITDIR_TGTDIR );		// : wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
				WK7PLAYERCONTROL->SetEnable( true );
				K7SCR_TIMEWAIT( 1200 );
				WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
				
				// ŒJ
				pPlaceInfo = GetPlaceInfo(mID,"event_030529_0");
				SetCameraStartPosition(pPlaceInfo);
				WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
				
				K7SCR_NOISE_RELEASE();
			}else
			{
				//J
				FixCamWithRiddle( CAM306M00CATGO );
			}
			//inGameĊJ
			WK7PLAYERCONTROL->NextMotionHokanEnableRequest();
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			break;
		
		//LbgłiAj
		case	K7EVENTNO( 030529 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			//Lbg炭Ēʉ
			if( WK7PLAYERCONTROL->GetMainID() == K7CAT )
			{
				CatSliding( false, CAM306M00CATBACKMOT );
				K7SCR_NOISE_REQUEST();
//				WK7CAM->SetCinemaScopeMode( false );
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				SetCurrentPath(	GetPathNurbsAll("event_030528_0"),
								0.340f,
								1,									// 0:forward 1:back
								WK7PATHINFO_INITDIR_TGTDIR );		// : wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
				WK7PLAYERCONTROL->SetEnable( true );
				WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
				K7SCR_TIMEWAIT( 1200 );
				
				// ŒJ
				pPlaceInfo = GetPlaceInfo(mID,"event_030528_0");
				SetCameraStartPosition(pPlaceInfo);
				WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
				K7SCR_NOISE_RELEASE();
			}else
			{
				//J
				FixCamWithRiddle( CAM306M00CATBACK );
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			break;
		//{[h
		case	K7EVENTNO( 030515 ):
			// L|[Y
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			FixCamMes2( CAM306M_030515, MES306M00_00 );
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}


//------------------------------------------------------------------------------
//Lbg
//------------------------------------------------------------------------------
void K7Stage306M00::CatSliding( bool inCamMotion, u32 inCamID )
{
	WK7Model*			pPcModel = WK7PLAYERCONTROL->GetCharaModel();
	WK7CameraMotion*	pCamMot  = GetOwnCameraMotion( MOT306M00CATCAM );
	
	K7SCR_NOISE_REQUEST();
//	WK7CAM->SetCinemaScopeMode( true );
	if( inCamMotion == true )
	{
		//Lbĝ胂[VĐ
		if( (pPcModel != NULL) && (pCamMot != NULL) )
		{
			WK7PLAYERCONTROL->SetEnable( false );
			//Lbg[VĐ
			pPcModel->AttachMotion( mpCatMotionSlow );
			pPcModel->PlayMotion();
			pPcModel->SetMotionLoop( false );
			//J[VĐ
			WK7CAM->SetMode( WK7Cam::WK7CAM_FREE_TARGET );
			WK7CAM->AttachMotion( pCamMot );
			WK7CAM->PlayMotion();
			WK7CAM->SetMotionLoop( false );
			gpSound->mPlaySE( SFX_PC_CAT_THROUGH_SLOW );
			WK7Npc::NpcVisibleAll(false);
			K7SCR_NOISE_RELEASE();
			//ĐI҂
			while( (pPcModel->GetMotionState() != WK7MODEL_NOANIM) || (WK7CAM->GetMotionState() != WK7CAM_NOANIM) )
			{
				K7SCR_RETSYS();
			}
			WK7CAM->DetachMotion();
		}
	}else
	{
		//Lbĝ胂[VĐ
		if( pPcModel != NULL )
		{
			if( inCamID != 0xffffffff )
			{
				FixCam( inCamID );
			}
			WK7PLAYERCONTROL->SetEnable( false );
			//Lbg[VĐ
			pPcModel->AttachMotion( mpCatMotion );
			pPcModel->PlayMotion();
			pPcModel->SetMotionLoop( false );
			gpSound->mPlaySE( SFX_PC_CAT_THROUGH_FAST );
			WK7Npc::NpcVisibleAll(false);
			K7SCR_NOISE_RELEASE();
			//ĐI҂
			while( pPcModel->GetMotionState() != WK7MODEL_NOANIM )
			{
				K7SCR_RETSYS();
			}
		}
	}
	WK7PLAYERCONTROL->NextMotionHokanEnableRequest();
	WK7Npc::NpcVisibleAll(true);
}

