////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage308M00 [bgi˂ݕj
//
// K7Stage308M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE308M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage308M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Kaw\KK7Effect.h"

// f
#define	MDL308M00_ROOM			"room"					// S
#define	MDL308M00_DAIZA			"attack"				// ܂Ȃ̓I
#define	MDL308M00_DAIZABROKEN	"mask_attack"			// 
#define	MDL308M00_DAIZAHIT		"event_030515"			// 

// [V
#define	MOT308M00_MATOROUND	(002)				// I
#define	MOT308M00_ROOM		(003)				// S̉]
#define	MOT308M00_BOMB		(004)				// `[`[A^bN

//bZ[W
#define	MES308M00_00		(0)							//
#define	MES308M00_01		(1)							//
#define	MES308M00_02		(2)							//

K7Stage308M00::K7Stage308M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
}

K7Stage308M00::~K7Stage308M00()
{
}


/*
	
	NGCg
	
*/
bool K7Stage308M00::CreateCallBack(void)
{
	// EStage308_0000i˂݊炾j
	// EStage308_0001i˂݊߁j	ԍOCPՂɂ邱ƁAdvIIII
	// EStage308_0002 Ŕ]
	// EStage308_0003 S̉]
	CreateOwnStageMotion(0000);
	CreateOwnStageMotion(0001);
	CreateOwnStageMotion(0002);
	CreateOwnStageMotion(0003);
	CreateOwnStageMotion(0004);
	return true;
}


/*
	
	
	
*/
bool K7Stage308M00::InitializeCallBack(void)
{
	NuigurumiInit();
	DaizaPlayMotion();
	RoomPlayMotion();
	
	K7SCR_EVCONDCHANGE();
	
	return true;
}

/*
	
	
	ԕω
	
	
*/
bool K7Stage308M00::CondChangeCallBack(void)
{
	if ( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030515) == true ){					// Ԃ킵ĂƂ
		WK7JObj		*pJObj;
		
		pJObj = GetJObj(MDL308M00_DAIZAHIT);
		pJObj->Hide(true,true);														// qbgIuWF
		DaizaBrokenMotion(-1.f);
	}
	return true;
}

/*
	
	Jg
	
	
*/
bool K7Stage308M00::SetCurrentCallBack(void)
{
	int i;
	Vec ppos, epos;
	WK7JObj		*pJObj = NULL;
	f32 dir;

	gpSound->mSetDspRateAll(K7SCN03_REVERB_DEF);

	// Ȃ̔
	if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_NUIGURUMI_START)==true){				// ʂ݃Q[Jn
		gpSound->mPlayStreamNo(HPS_ISZK_H);
	}else{
		if ( K7SCR_GET_SCENARIO_FLAG(K7SCN03_DRFL_030502)==true ) {
			// NAorj󂵂
			gpSound->mPlayStreamNo(HPS_ISZK_O);
		}else{
			// Q[JnĂȂ
			gpSound->mPlayStreamNo(HPS_ISZK_B);
		}
	}
	
	// ʂ݃Q[
	while( K7SCR_STG_GET_CURRENTID() == K7STGID(308,0) ){
		
		if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_NUIGURUMI_START)==true){			// ʂ݃Q[Jn
			for(i=0; i<NUI_event_MAX; i++){
				if (K7SCR_GET_SCENARIO_FLAG(nuigurumi[i].evFlag)==false){			// ܂ʂݐĂH
					nuigurumi[i].frame--;
					if ( (nuigurumi[i].frame) < 0 ){
						// [VĐ
						nuigurumi[i].pJObj = NuigurumiPlayMotion(nuigurumi[i].pObjName, nuigurumi[i].motNo);
						nuigurumi[i].motNo ^= 1;
						nuigurumi[i].frame = (s16 )((int )(rand()%60 + 30));
					}
				}
			}
			
			// ʂݏICxg
			NuigurumiEndTest();
			
		}
		
		// l̍\̃Zbg(ʂ݃Q[)
		if( true == IsNuigurumiGame() ){
			
			if ( NULL != WK7PLAYERCONTROL->GetWaistObjPtr() ) {
				WK7PLAYERCONTROL->GetWaistPosition(&ppos);
			}
			pJObj=GetJObj(MDL308M00_DAIZA);
			if ( NULL != pJObj ) {
				pJObj->GetWorldPosition(epos);
			}
			dir = atan2f((f32 )epos.x - ppos.x, (f32 )epos.z - ppos.z);
			WK7PLAYERCONTROL->SetKamaeDir(dir);
			
		}else{
			if ( WK7PLAYERCONTROL->TestKamaeDir() ){
				WK7PLAYERCONTROL->InitKamaeDir();
			}
		}
		
		K7SCR_RETSYS();
	}
	
	// [V~߂ [V͏Ɏ~܂̂ŕu
	
	return true;
}


void K7Stage308M00::NuigurumiInit(void)
{
	int i;

	for(i=0; i<NUI_event_MAX; i++){
		nuigurumi[i].motNo		= 1;							// fŊoOn܂̂ŁAPɃZbg
		nuigurumi[i].frame		= 0;
		nuigurumi[i].evFlag		= K7SCN03_EVFL_030507 + i;
		nuigurumi[i].pObjName	= (s8 *)pNuigurumiName[i];
		nuigurumi[i].pJObj		= NULL;
	}
}

WK7JObj *K7Stage308M00::NuigurumiPlayMotion(s8 *pObjName, u8 motNo)
{
	WK7JObj		*pJObj = NULL;

	if( (pJObj=PlayMotion((const char *)pObjName, (int )motNo, "event_030507"))!=NULL ){
		pJObj->SetMotionLoop(false);
	}
	return pJObj;
}


bool K7Stage308M00::DaizaPlayMotion(void)
{
	WK7JObj		*pJObj = NULL;

	if( true == IsNuigurumiGame() ){
		if( (pJObj=PlayMotion((const char *)MDL308M00_DAIZA, (int )MOT308M00_MATOROUND))!=NULL ){
			pJObj->SetMotionLoop(true);
			return true;
		}
	}
	return false;
}


bool K7Stage308M00::DaizaBrokenMotion(f32 sFrame)
{
	WK7JObj		*pJObj = NULL;

	if( (pJObj=PlayMotion((const char *)MDL308M00_DAIZABROKEN, (int )MOT308M00_BOMB, NULL, sFrame))!=NULL ){
		pJObj->SetMotionLoop(false);
		return true;
	}
	return false;
}


bool K7Stage308M00::RoomPlayMotion(void)
{
	WK7JObj		*pJObj = NULL;

	if( true == IsNuigurumiGame() ){
		if( (pJObj=PlayMotion(MDL308M00_ROOM, MOT308M00_ROOM))!=NULL ){
			if( pJObj != NULL ){
				pJObj->SetMotionLoop(true);
				return true;
			}
		}
	}
	
	return false;
}


bool K7Stage308M00::NuigurumiEndTest(int mode)
{
	int i;
	WK7JObj		*pJObj = NULL;

	if ( !mode ){
		for(i=0; i<NUI_event_MAX; i++){
			if (K7SCR_GET_SCENARIO_FLAG(nuigurumi[i].evFlag)==false){			// ܂ʂݐĂH
				return false;
			}
		}
	}
	
	if ( K7SCR_GET_SCENARIO_FLAG(K7SCN03_DRFL_030502) == false ){
		K7SCR_SET_SCENARIO_FLAG(K7SCN03_DRFL_030502);
		
		// NAorj󂵂
		gpSound->mPlayStreamNo(HPS_ISZK_O);
		
		// hAJf
		// ʂ݃Q[I[
		StopMotion(MDL308M00_DAIZA);											// [V~߂
		StopMotion(MDL308M00_ROOM);												// [V~߂
		
		//ogIB
		KK7BattleMainTask::BattleMainTaskExit(2);
		
		// L|[Y
		K7SCR_PC_SETVISIBLE(false);
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		
		// Wait
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
		
		// JύX
		WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
		WK7CAM->SetPosition      (K7Stage308M00_Camera[EV_030502_NO].pos);
		WK7CAM->SetTargetPosition(K7Stage308M00_Camera[EV_030502_NO].tgt);
		K7SCR_PC_SETVISIBLE(false);											// l
		
		// bZ[W ܔMnւ̃bNOꂽ
		gpSound->mPlaySE(SFX_SYS_EV_CLEAR);
		K7SCR_STGC_MESSAGE_B(MES308M00_01);
		
		// L|[Y
		K7SCR_PC_SETVISIBLE(true);
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
	}
	
	// SI
	return true;
}

/*
	
	qbgIuWF
	
*/
bool K7Stage308M00::HitObjCallBack(WK7HitObjInfo &info)
{
	int no = -1;
	int	evFlag;
	int i, num;

	// Ō̂PCǂׂ
	for(i=0, num=0; i<NUI_event_MAX; i++){
		if (K7SCR_GET_SCENARIO_FLAG(nuigurumi[i].evFlag)==true){			// ܂ʂݐĂH
			num++;
		}
	}
	
	// VFtʂ
	switch( info.mEventNo ){
	case	K7EVENTNO(030507):
		no		= 0;
		evFlag	= K7SCN03_EVFL_030507;
		break;
	case	K7EVENTNO(030508):
		no		= 1;
		evFlag	= K7SCN03_EVFL_030508;
		break;
	case	K7EVENTNO(030509):
		no		= 2;
		evFlag	= K7SCN03_EVFL_030509;
		break;
	case	K7EVENTNO(030510):
		no		= 3;
		evFlag	= K7SCN03_EVFL_030510;
		break;
	case	K7EVENTNO(030511):
		no		= 4;
		evFlag	= K7SCN03_EVFL_030511;
		break;
	case	K7EVENTNO(030512):
		no		= 5;
		evFlag	= K7SCN03_EVFL_030512;
		break;
	case	K7EVENTNO(030513):
		no		= 6;
		evFlag	= K7SCN03_EVFL_030513;
		break;
	case	K7EVENTNO(030514):
		no		= 7;
		evFlag	= K7SCN03_EVFL_030514;
		break;
	case	K7EVENTNO(030515):								// ɂǂi}XNȂj\j
		if( true == IsNuigurumiGame() ){
			
			if ((WK7HITOBJINFO_TYPE_GRENADE_FIRE  == info.mTypeID)
			||	(WK7HITOBJINFO_TYPE_GRENADE_THUND == info.mTypeID)
			||	(WK7HITOBJINFO_TYPE_GRENADE_GRAVI == info.mTypeID)
			){
				
				WK7JObj		*pJObj;
				
				pJObj = GetJObj(MDL308M00_DAIZAHIT);
				pJObj->Hide(true,true);						// qbgIuWF
				
				StopMotion(MDL308M00_DAIZA);									// [V~߂
				StopMotion(MDL308M00_ROOM);										// [V~߂
				
				KK7DoorSmokeEffect( (Vec){-2261.750f, 11.354f, -1858.776f} );
				gpSound->mPlaySE(SFX_SCE3_CUR_STATUE_BREAK);
				
				DaizaBrokenMotion();
				
				K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_030515);			// ꂽtO
				
				//ogIB
				KK7BattleMainTask::BattleMainTaskExit(2);
				
				K7SCR_PC_SETVISIBLE(false);
				
				// L|[Y
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				
				// Wait
				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(3));
				
				NuigurumiEndTest(1);						// ʂ݃Q[I
				
			}else{
				// 蔻ėL
				// qbgIuWF𕜊
//				info.mpHitObj->SetEnable(true);
				info.SetHitObjEnable(true);
			}
			return false;
			
		}else{
			// 蔻ėL
			// qbgIuWF𕜊
//			info.mpHitObj->SetEnable(true);
			info.SetHitObjEnable(true);
			return true;
		}
		break;
	default:
		return true;
	}
	
	// قۂqbg
	if ( no != -1 ){
		if ( num < 7 ){
			gpSound->mPlaySE(SFX_SCE3_AHOHIT);
		}else{
			gpSound->mPlaySE(SFX_SCE3_ISZK_TORI_GREAT);								// LOOP THE LOOP Ō̈̂Ƀqbg
		}
	}
	
	BrokenObj((const char *)nuigurumi[no].pObjName);
	
	// CxgtOĂ
	K7SCR_SET_SCENARIO_FLAG(nuigurumi[no].evFlag);
	
	return false;
}


/*
	
	
	hACxg
	
	
*/
bool K7Stage308M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTDOOR(030502):			// ΂̋ւ̔
		if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_NUIGURUMI_START)==false){			// ʂ݃Q[JnĂȂ
			NuigurumiStartDemo();
		}else{
			if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_DRFL_030502)==false){				// ʂ݃Q[NAĂȂ
				// L|[Y
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				
				// JύX
				WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
				WK7CAM->SetPosition      (K7Stage308M00_Camera[EV_030502_NO].pos);
				WK7CAM->SetTargetPosition(K7Stage308M00_Camera[EV_030502_NO].tgt);
				K7SCR_PC_SETVISIBLE(false);							// l
				
				// bZ[W
				K7SCR_STGC_MESSAGE_B(MES308M00_00);
				
				// L|[Y
				K7SCR_PC_RETURNVISIBLE();							// l߂Ao
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
			}else{
				return true;
			}
		}
		return false;
		break;
	}
	return true;
}



/*
	
	
	ʂ݃Q[Jn
	
	
*/
void K7Stage308M00::NuigurumiStartDemo(void)
{
	int i;
	
	// L|[Y
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	// JύX
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	WK7CAM->SetPosition      (K7Stage308M00_Camera[EV_030502].pos);
	WK7CAM->SetTargetPosition(K7Stage308M00_Camera[EV_030502].tgt);
	
	// tOĂ
	K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_NUIGURUMI_START);
	
	// ˂݂Ƀ[VĐ
	for(i=0; i<NUI_event_MAX; i++){
		// [VĐ
		nuigurumi[i].pJObj = NuigurumiPlayMotion(nuigurumi[i].pObjName, 0);
		nuigurumi[i].frame = (s16 )((int )(rand()%60 + 30));
	}
	
	// 肾
	gpSound->mPlayStreamNo(HPS_ISZK_H);
	
	// bZ[W
	K7SCR_STGC_MESSAGE_B(MES308M00_02);				// X^[gI
	
	// ]
	RoomPlayMotion();
	
	// ]
	DaizaPlayMotion();
	
	// L|[Y
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
}

/*
	
	
	ʂ݃Q[sԂǂH
	
	true		ʂݒ
	false		ʂ݃Q[Ŗ
	
*/
bool K7Stage308M00::IsNuigurumiGame(void)
{
	if ( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030515) == true ){				// Ԃ킵ĂƂ
		return false;
	}
	
	if ((K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_NUIGURUMI_START)==true)			// ʂ݃Q[Jn
	&&	(K7SCR_GET_SCENARIO_FLAG(K7SCN03_DRFL_030502)==false)
	){																			// ʂ݃Q[NAĂȂ
		return true;
	}
	return false;
}

