////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage314M00 \t@[[h
//
// K7Stage314M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE314M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage314M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"

// [V
#define MOT314M00SOFASPEED_60SEC		(1)
#define MOT314M00SOFASPEED_30SEC		(2)
#define MOT314M00SOFASPEED_60SEC_NOROT	(3)
#define MOT314M00SOFASPEED_30SEC_NOROT	(4)

K7Stage314M00::K7Stage314M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage314M00_Camera);
}

K7Stage314M00::~K7Stage314M00()
{
}

/*
	
	NGCg
	
*/
bool K7Stage314M00::CreateCallBack(void)
{
	// [Vǂݍ
	CreateOwnStageMotion(MOT314M00SOFASPEED_60SEC_NOROT);
	CreateOwnStageMotion(MOT314M00SOFASPEED_30SEC_NOROT);
	return true;
}

/*
	
	
	
*/
bool K7Stage314M00::InitializeCallBack(void)
{
	// 蓮Xe[Wnm
	SetManualBranch(true);
	return true;
}




/*
	
	Jg
	
	
*/
bool K7Stage314M00::SetCurrentCallBack(void)
{
	WK7CameraMotion*	pCamMot;
	u32	oldColor;
	Vec camPos, camTgt;
	
	while(WK7Stage::IsChanging() == true){
		GHMGCTASK_RETSYS();
	}
	
	if ( rand()&1 ){
		pCamMot = GetOwnCameraMotion( MOT314M00SOFASPEED_30SEC_NOROT );
	}else{
		pCamMot = GetOwnCameraMotion( MOT314M00SOFASPEED_60SEC_NOROT );
	}
	
	// Ƃ肠
	pCamMot = GetOwnCameraMotion( MOT314M00SOFASPEED_60SEC_NOROT );

	// mCY炷
#if 1
	// L|[Y
//	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	SandRelease();																// mCYJiXe[Wj
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
#else
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
#endif
	
	// og[h
	while( false == WK7PLAYERCONTROL->SetPcBattleMode() ){
		GHMGCTASK_RETSYS();
	}
	
	// og[hɓ`FbN
	while( false == pBattleMain->GetBattleTask() ){
		GHMGCTASK_RETSYS();
	}
	
#if 0
	SandRelease();																// mCYJiXe[Wj
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	K7SCR_TIMEWAIT( 4800*2 );
#endif

	
	//J[VĐ
	WK7CAM->SetMode( WK7Cam::WK7CAM_FREE_TARGET );
	oldColor = WK7CAM->GetCinemaScopeColor();
	WK7CAM->SetCinemaScopeColor( 0x000000ff );
	WK7CAM->SetCinemaScopeMode( true );
	WK7CAM->AttachMotion( pCamMot );
	WK7CAM->PlayMotion();
	WK7CAM->SetMotionLoop( false );
	
	WK7CAM->GetPosition(camPos);
	WK7CAM->GetTargetPosition(camTgt);
	
	pBattleMain->SetBasePosition(&camPos);
	
	//ĐI҂
	K7SCR_RETSYS();
	while( WK7CAM->GetMotionState() != WK7CAM_NOANIM )
	{
		K7SCR_RETSYS();
	}
	WK7CAM->DetachMotion();
	WK7CAM->SetCinemaScopeMode( false );
	WK7CAM->SetCinemaScopeColor( oldColor );
	
	WK7PLAYERCONTROL->ExitPcBattleMode();
	
#if 1
	{
		u32		stgid = K7STGID(315, 0);
		
		// L|[Y
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		gpNoise->mSandRequest(eSandLongNoise);
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			K7SCR_RETSYS();
		}
		
		SetManualBranch(false);
		
		K7SCR_STG_RELEASE    (mID);
		K7SCR_STG_CREATE_B   (stgid);
		K7SCR_STG_SET_CURRENT(stgid);
		K7SCR_STG_VISIBLE    (stgid,true);
		
		WK7Stage::SandRelease(stgid);
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}
		
		// L|[Y
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
	}
	
#else
	
	// L|[Y
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	SetManualBranch(false);
#endif
	return true;
}


