////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage316M00 ԏ iAJlXe[Wj
//
// K7Stage316M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE316M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage316M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Enm\EnmAkn.h"
#include "..\..\..\Wat\WK7Item.h"
#include "..\..\..\Yam\YK7MapSelect.h"
#include "..\..\..\Wat\WK7Item.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"

#define AKANE_DISP_MODEL		"akane"

K7Stage316M00::K7Stage316M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mEnd				= false;
	mAkaneHide			= false;
//	mScnEnd.LoadData();
	GameInfo.SetMenuMapEnable(false);			// }bv
	GameInfo.SetBossFlag     (true );
}

K7Stage316M00::~K7Stage316M00()
{
	mAkaneHide			= false;
	GameInfo.SetSpecialEnable(true );			// TuʗLɖ߂
	GameInfo.SetMenuMapEnable(true );			// }bvLɖ߂
	GameInfo.SetBossFlag     (false);
//	mScnEnd.Release();
}

bool K7Stage316M00::InitializeCallBack(void)
{
	if( mEnd==true ){
		return true;
	}
	
	if ( K7SCR_GET_SCENARIO_FLAG(FIRST_AKN_DEMO) == true ){
		// 蓮Xe[WnmiĐ
		SetManualBranch(true);
	}
	
	// AJl퓬ėĂtO 040425 YȂ
//	GameInfo.SetScenarioFlow( K7SCNF_CUR );
	
	return true;
}

bool K7Stage316M00::CreateCallBack(void)
{
	// [Vǂݍ
	// ̃Xe[W͎蓮œǂݍ܂
	return false;
}

bool K7Stage316M00::TerminateCallBack(void)
{
//	K7SCR_RESET_SCENARIO_FLAG(K7SCN03_EVFL_031101);
	return true;
}


bool K7Stage316M00::SetCurrentCallBack(void)
{
	K7EnmAKN	*pNpcAkn;
	int exit = 1;
	int bossEnd;
	
	if( mEnd==true ){
		return true;
	}
	
	SetCurrentCallBackDefaultProc();
	
	// {X ǂݍ
	while( (pNpcAkn = (K7EnmAKN *)WK7Npc::Create(ENENO_AKN))==NULL ){
		K7SCR_RETSYS();
	}
	while( pNpcAkn->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	
	// mCY炷
	if ( K7SCR_GET_SCENARIO_FLAG(FIRST_AKN_DEMO) == true ){
		
		while( IsChanging()==true ){
			K7SCR_RETSYS();
		}
		
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		// pXړ
		WK7Stage::SetCurrentPath(	WK7Stage::GetPathNurbsAll("curve9"),
									0.988f,
										1,						// Forward
//									WK7PATHINFO_INITDIR_TGTDIR	// 
									WK7PATHINFO_INITDIR_TGTDIR_REV		// wォ
		);
		mAkaneHide = true;										// l`AJl̕\
		WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
		K7SCR_EVCONDCHANGE();
		K7SCR_NOISE_RELEASE();
		
		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		
		while( pNpcAkn->GetNpcState() == NPC_STATE_INIT ){
			K7SCR_RETSYS();
		}
		
		// {XJn
		K7EnmAKN::mAKNBattleStart = 1;
		SetManualBranch(false);
	}
	
	while(exit){
		
		pNpcAkn->StageProc(WK7Stage::GetCurrentStage());
		
		GHMGCTASK_RETSYS();
		
		if ( 1 == K7EnmAKN::mAKNBattleStart ){
			if ( false == WK7RenderObj::IsValid(this) ){			// Ă܂ǂHiob
				WK7PLAYERCONTROL->BattlePadRegulationSet();
				return true;
			}
		}
		// {X픲
		if (((bossEnd = pNpcAkn->AKNBossEnd()) != 0)				//	{XI
		||	(WK7Stage::GetCurrentStage() == NULL)					//	Xe[W܂
		||	(WK7Stage::GetCurrentStage()->GetID()!=K7STGID(316,0))	//	Xe[WύX
		){
			exit = 0;
		}
	}
	
	if ( 1 != bossEnd ){											// PCŏIꍇ
		return true;
	}
	// ɂ gpNoise->mSandRequest(eSandLongNoise); ɂAmCY|Ă 040429
	
	mEnd = true;
	
	// 蓮Xe[Wnm
	SetManualBranch(false);
	
//	WK7PLAYERCONTROL->BattlePadRegulationSet();
	
	// ̃Xe[W쐬
	KK7BattleMainTask::BattleMainTaskExit(2);
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	u32			playno;
	
//	gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
	
	WK7Chara::SetRenderChara(false);
	WK7Stage::SetRenderStage(false);
	WK7Item::SetRenderItem  (false);
	
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7PLAYERCONTROL->Reset();
	WK7PLAYERCONTROL->ReleaseAll();
	K7SCR_STG_RELEASE(mID);
	
#ifndef	K7APP_MASTER
//		while( !(HSD_PadGetTrigger(1) & HSD_PAD_LEFT) ){
//			K7SCR_RETSYS();
//		}
#endif
	
	WK7Play::PlayInit   (false,false);
	playno = K7EVENTPLAY(03040105);			// AJl
	WK7Play::Prepare    (playno);
	WK7Play::PrepareWait(playno,false);
	WK7Play::StartB     (playno,false);
	WK7Play::PlayReleaseAll();
	K7SCR_RETSYS();
	WK7Play::RestorePlayTB();
	while( WK7Play::Find(playno)!=NULL ){
		K7SCR_RETSYS();
	}
	K7SCR_RETSYS();
	
	WK7Chara::SetRenderChara(true );
	WK7Stage::SetRenderStage(true );
	WK7Item::SetRenderItem  (true );
	
//	gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
//	K7SCR_RETSYS();
//	K7SCR_RETSYS();
//	WK7Play::RestorePlayTB();
	
	SK7ScenarioEnd	scnEnd;
	scnEnd.LoadData();
	
//	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
//		K7SCR_RETSYS();
//	}
	
	gpSound->mStopStream();
	
	//ViII
//	mScnEnd.FrameProcess();
	scnEnd.FrameProcess();
	k7app.FadeStart( 0, 1 );
	K7SCR_RETSYS();
	scnEnd.Release();
	
	K7SCR_MOON_START2();
	K7SCR_MOON_WAIT();
	
//	//}bvړ
//	SimpleMapMove( MAP_ISZKLAND, MAP_SPORTCLUB, K7STGID_INVALID );
	//yhƃJ[eBXÊP
//	gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue, NOISE_SE_NORMAL );
//	while( gpNoise->mGetSandFrameProc() != eSandExec )		K7SCR_RETSYS();
	WK7Play::StorePlayTB();
//	while( gpNoise->mSandRelease() == false )				K7SCR_RETSYS();
//	while( gpNoise->mGetSandFrameProc() != eSandStandby )	K7SCR_RETSYS();
	WK7Play::PlayTB( K7EVENTPLAY(03060101) );
	gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue, NOISE_SE_NORMAL );
	while( gpNoise->mGetSandFrameProc() != eSandExec )		K7SCR_RETSYS();
	WK7Play::RestorePlayTB();
//	while( gpNoise->mSandRelease() == false )				K7SCR_RETSYS();
//	while( gpNoise->mGetSandFrameProc() != eSandStandby )	K7SCR_RETSYS();
	
	K7SCR_NOISE_RELEASE_TO_MAP();
											// }bvZNg
	GameInfo.MapSelectInit(MAP_SPORTCLUB, MAP_GAL_HOME);
	while( GameInfo.CheckMapSelectEnd()==false ){
		K7SCR_RETSYS();
	}
	GameInfo.MapSelectEnd();
	
	gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue, NOISE_SE_NORMAL );
//	gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
	
											// ViIԍuJ[eBX@v
	GameInfo.SetScenarioFlow(K7SCNF_CUR);
	K7SCR_CHANGE_SCENARIO_DATA();
	// LN^X^[gn_Zbg
	WK7PLAYERCONTROL->ChangeStartChkPoint();
	
	u32		stgid = K7STGID(120,0);
	u32		chrid = K7CHRID(K7GAL,0);
	
	K7SCR_STG_CREATE_B   (stgid);
	K7SCR_PC_CREATE      (chrid);			// fǂݍ
	K7SCR_PC_MOTIONCREATE(chrid);			// [Vǂݍ
	K7SCR_PC_CREATEWAIT();					// ǂݍݑ҂
	K7SCR_STG_SET_CURRENT(stgid);
	
	K7SCR_PC_VISIBLE     (true);
	K7SCR_STG_VISIBLE    (stgid,true);
//	WK7PLAYERCONTROL->BattlePadRegulationSet();
	
//	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
//		K7SCR_RETSYS();
//	}
//	
//	while( gpNoise->mSandRelease()==false ){
//		GHMGCTASK_RETSYS();
//	}
//	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
//		GHMGCTASK_RETSYS();
//	}
//	
//	K7SCR_EXIT_PLAYMODE();
//	K7SCR_EXIT_DEMOPAUSE();
	
	return true;
}


/*
	
	
	pX
	
	
*/
bool K7Stage316M00::BpArriveCallBack(WK7BpInfo &info)
{
	u32		eventNo = GetBpEventNo(info);
	
	switch( eventNo ){
	case	K7EVENTNO(031101):												// AJlJñL
		if(	(WK7Play::HasPlayed(K7EVENTPLAY(03040103)) == false)
		&&	(false == K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_031101))
		){
			//inGame~
			K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_031101);
			
			K7SCR_SET_SCENARIO_FLAG(FIRST_AKN_DEMO);
			
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
			K7SCR_NOISE_REQUEST();
			K7SCR_CHARAGEKI_PREPARE( K7EVENTPLAY(03040103) );
			K7SCR_NOISE_RELEASE();
			K7SCR_CHARAGEKI_END_WAIT( K7EVENTPLAY(03040103) );
			K7SCR_NOISE_REQUEST();
			K7SCR_CHARAGEKI_TERM( K7EVENTPLAY(03040103) );
			// pXړ
			WK7Stage::SetCurrentPath(	WK7Stage::GetPathNurbsAll("curve9"),
										0.988f,
											1,						// Forward
//										WK7PATHINFO_INITDIR_TGTDIR	// 
										WK7PATHINFO_INITDIR_TGTDIR_REV		// wォ
			);
			mAkaneHide = true;										// l`AJl̕\
			WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
			WK7Play::SetPlayed(K7EVENTPLAY(03040103),false);		// LĂȂƂɂ
			K7SCR_EVCONDCHANGE();
			K7SCR_NOISE_RELEASE();
			
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			
			// {XJn
			K7EnmAKN::mAKNBattleStart = 1;
			return true;
		}
		break;
	}
	return false;
}

bool K7Stage316M00::CondChangeCallBack(void)
{
	WK7JObj		*pJObj;

	pJObj = GetJObj(AKANE_DISP_MODEL);
	if( mAkaneHide == true ){
		K7SCR_JOBJ_HIDE(pJObj);
	}else{
		K7SCR_JOBJ_DISP(pJObj);
	}
	return true;
}






