////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage321M00 A[P[h
//
// K7Stage321M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE321M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage321M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Panel\SK7PanelGum.h"
#include "..\..\..\Panel\SK7PanelPopcorn.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Yam\YK7EffectLight.h"
#include "..\..\..\Yam\YK7EffectPopCorn.h"
#include "..\..\..\Yam\YK7EffectConfetti.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"

static f32 HOKAN_START_FRAME = (730.f);
static f32 ANIM_ENDFRAME	 = (730.f*2.f);

//#define POPCORN_ALLCLEAR		(5)
#define POPCORN_ALLCLEAR		(1)

#define POPMACHINE_YANE_NAME	"yane"

#define	K7STAGE321M00_KED_CLOSE_PATHNAME		"curve10"				// E̕pXO
#define	K7STAGE321M00_KED_RIDDLE_PATHNAME		"event_030209_0"		// JpXO

#define	MDL_POP_BEFORE			"before_clear"							// |bvR[
#define	MDL_POP_AFTER			"after_clear"							// |bvR[قڂȂ
#define	MDL_TAMA				"FrankenBullet_Pack"					// ef

// bZ[W
#define MES321M00_0				(0)

K7Stage321M00::K7Stage321M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage321M00_Camera );
	
	NeonPlayNo = (u32 )(rand()%NEON_MAX);
	NowFrame = 0.f;
	NowFrameHokan = 0.f;
	PopCornDemoFlag = 0;
	zuruPanel = 0;
}

K7Stage321M00::~K7Stage321M00()
{
}

/*
	
	NGCg
	
*/
bool K7Stage321M00::CreateCallBack(void)
{
	pPopCornEffect= NULL;
	pLgtEffect = NULL;
	PopCornDemoFlag = 0;
	
	// lĨAj[V[V
	CreateOwnStageMotion(0);
	CreateOwnStageMotion(1);
	
	// Cgӗp̃eNX`ǂݍ
	loadLgtTex = rand()%7;
	SetupLightTex(loadLgtTex);
	
	// |bvR[}VNAƂɂĂ
#if 1
	K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_JIHANKI_BINGO);
#endif
	
	// |bvR[ǰGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	return true;
}


/*
	
	
	
*/
bool K7Stage321M00::InitializeCallBack(void)
{
	HereComeANewHSInit( PR_HS_PROT, ENENO_3_321M00_4 );
	
	// V⊮Aj[VŐ߂Ă
	PlayMotion("neon_hokan", 000, "neon_bike", HOKAN_START_FRAME);
	
	K7SCR_EVCONDCHANGE();
	return true;
}


/*
	
	󋵕ω
	
*/
bool K7Stage321M00::CondChangeCallBack(void)
{
	WK7JObj *pJObj;
	
	// |bvR[I
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_JIHANKI_BINGO)==TRUE ) {
		K7SCR_EVNO_SETENABLE(K7EVENTNO(030205), false);						// ̃Cxg֎~
	}
	
//	if ( POPCORN_ALLCLEAR == PopCornMachinePopTest() ){
//		// uevɓĂ
//		pJObj = GetJObj(MDL_TAMA);
//		if( K7SCR_EVHASITEM(K7EVITEM_TAMA(030201)) == true ){
//			K7SCR_EVNO_SETENABLE(K7EVITEM_TAMA(030201), false);				// ̃Cxg֎~
//			// e
//			if ( pJObj != NULL ){
//				pJObj->Hide(false, true);
//			}
//			ReleaseTamaEffect();
//		}else{
//			K7SCR_EVNO_SETENABLE(K7EVITEM_TAMA(030201), true);
//			if ( pJObj != NULL ){
//				pJObj->Disp(false, true);
//			}
//			CreateTamaEffect(pJObj);
//		}
//		// |bvR[}Vf
		if ( true == PopCornDemoPlay() ){
			// |bvR[̉
			
			pJObj = GetJObj(POPMACHINE_YANE_NAME);
			if ( pJObj != NULL ){
				pJObj->Hide(false, true);
			}
			
			// |bvR[ɂ
			pJObj = GetJObj(MDL_POP_BEFORE);
			if ( pJObj != NULL ){
				pJObj->Hide(false, true);
			}
		}
//	}else{
//		K7SCR_EVNO_SETENABLE(K7EVITEM_TAMA(030201), false);
//	}
	
	// JGf̌E
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_SP_321M00_KED)==TRUE ){
		K7SCR_STG_SET_PATHENABLE       (K7STAGE321M00_KED_CLOSE_PATHNAME ,true);
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE321M00_KED_RIDDLE_PATHNAME,true);
		
		pJObj = GetJObj("event_030209_ked");
		if ( pJObj != NULL ){
			pJObj->Hide(false, true);
		}
	}else{
		K7SCR_STG_SET_PATHENABLE       (K7STAGE321M00_KED_CLOSE_PATHNAME ,false);
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE321M00_KED_RIDDLE_PATHNAME,false);
	}

	return true;
}



bool K7Stage321M00::PopCornDemoPlay(void)
{
	WK7JObj *pJObj;
	
	if ( !PopCornDemoFlag ){
		
		// |bvR[}Vf
		pJObj = GetJObj("Pop");
		pPopCornEffect = CreatePopCornEffect(	pJObj,
												(f32)VParam[ED_POPCORN][8] * 0.01F,
												0.0F ) ;
		
		pJObj = GetJObj("Flash");
		pLgtEffect = CreateLightEffect( pJObj,
										(s32)loadLgtTex,
										(f32)VParam[ED_LIGHT][1] * 0.1F, (f32)VParam[ED_LIGHT][2] * 0.1F,
										(f32)VParam[ED_LIGHT][3] * PI_2 / 360, (f32)VParam[ED_LIGHT][4] * PI_2 / 360, 
										(f32)VParam[ED_LIGHT][5] * 0.01F ) ;
		
		
//		gpSound->mPlayStreamNo(HPS_POP);		// |bvR[
		
		PopCornDemoFlag = 1;
		return true;
	}
	return false;
}

/*
	
	Jg
	
	
*/
bool K7Stage321M00::SetCurrentCallBack(void)
{
	Vec eye;
	EFFECT *pEfc;
	bool	HokanGo;
	f32 Speed = 2.f;
	
	gpSound->mSetDspRateAll(K7SCN03_REVERB_DEF);

	// ԂтGtFNgJn
	WK7CAM->GetPosition(eye);
//	pStageEfc = CreateEffectConfetti(eye, 2000);
	pStageEfc = NULL;
	
	// Init
	pJObjHokan = pJObj = NULL;
	HokanGo = false;
	
	//V^HSЉ
	if( false == HereComeANewHS(	PR_HS_PROT,
									ENENO_3_321M00_4,								// GID
									NULL,
									CAM321M00_HS_PRESEN_START,
									CAM321M00_HS_PRESEN_END,
									0,
									199,  220, -90,  74, 992, 138 )					// OЉp
	){
		SetManualBranch(false);
//		return( false );
	}
	
		// V⊮Aj[VŐ߂Ă
	PlayMotion("neon_hokan", 000, "neon_bike", HOKAN_START_FRAME);
	
	// VɗGiAjjĎ
	while(	(K7SCR_STG_GET_CURRENTID() == K7STGID(321,0))
	&&		(POPCORN_ALLCLEAR != PopCornMachinePopTest())
	){
		
		if ( pJObj == NULL ){									// ̃AjĐIIII
			// [VĐ i[V̓oCN̕gpj
			if( (pJObj=PlayMotion(pNeonNameTable[NeonPlayNo], 000, "neon_bike", NowFrame))!=NULL ){
				if( pJObj != NULL ){
					pJObj->SetMotionLoop(false);
					if ( WK7GameInfo::ZAN != GameInfo.GetMode() ){					// cOCxg͖炳Ȃ
						if ((gpSound->mGetPlayStreamNo() == -1)
						||	(gpSound->mGetPlayStreamNo() != NeonPCMTable[NeonPlayNo])
						){
							gpSound->mPlayStreamNo((int )NeonPCMTable[NeonPlayNo]);		// Ȗ炵Ȃ
						}
					}
					goto MAIN_ANIM_PLAY_OK;
				}
			}
		}else{																		// Đ
			if( pJObj != NULL ){
MAIN_ANIM_PLAY_OK:
				NowFrame = pJObj->GetCurrentMotionFrame();
				if ( NowFrame >= HOKAN_START_FRAME ){
					HokanGo = true;
				}
				if ( NowFrame >= ANIM_ENDFRAME ){
//				if( pJObj->GetMotionState(false,true) == WK7MODEL_NOANIM ){			// Aj[VI܂Ŗ
					NeonPlayNo = (u32 )SeachNeonNo();
					pJObj = NULL;
					NowFrame = 0.f;
				}
			}
		}
		
		// ۊǗpAj
		if (((true == HokanGo) && (pJObjHokan == NULL))
		||	((NowFrameHokan > 0.f) && (pJObjHokan == NULL))
		){
			// ۊǗp̃Aj[VĐ i[V̓oCN̕gpj
			if( (pJObjHokan=PlayMotion("neon_hokan", 000, "neon_bike", NowFrameHokan))!=NULL ){
				if( pJObjHokan != NULL ){
					pJObjHokan->SetMotionLoop(false);
					HokanGo = false;
					goto HOKAN_ANIM_PLAY_OK;
				}
			}
		}else{
			if ( NULL != pJObjHokan ){
HOKAN_ANIM_PLAY_OK:
				NowFrameHokan = pJObjHokan->GetCurrentMotionFrame();
#if 1
				if ( NowFrameHokan >= ANIM_ENDFRAME ){
#else
				if( pJObjHokan->GetMotionState(false,true) == WK7MODEL_NOANIM ){		// Aj[VI܂Ŗ
#endif
					pJObjHokan = NULL;
					NowFrameHokan = 0.f;
				}
			}
		}
		
		// ԂтGtFNg
		if ( pStageEfc != NULL ){
			pEfc = pStageEfc->GetEffect();
			WK7CAM->GetPosition(eye);
			SetConfettiEffectPoint(pEfc, eye);
		}
		
		SetMotionRate(Speed);
		
		K7SCR_RETSYS();
	}
	
	return true;
}


/*
	
	I
	
	
*/
bool K7Stage321M00::TerminateCallBack(void)
{
	// [V~߂
	if ( NULL != pJObj ){
		pJObj     ->StopMotion(pNeonNameTable[NeonPlayNo]);
	}
	if ( NULL != pJObjHokan ){
		pJObjHokan->StopMotion("neon_hokan");
	}
	
	if ( NULL != pPopCornEffect ){
		::DelReqEffect(pPopCornEffect);
	}
	
	if ( NULL != pLgtEffect ){
		::DelReqEffect(pLgtEffect);
	}
	
	ReleaseLightTex(loadLgtTex);
	
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	
	return true;
}

/*
	
	Cxg
	
*/
bool K7Stage321M00::EventCallBack(WK7EventInfo &info)
{
	s32  result;
	u32 evNo;
	ePanelID panelNo;
	s32 panelParam = GUM_NORMAL_ANS;
	bool panelOK = false;
	
	switch( info.mEventNo ){
	case	K7EVENTNO(030205):			// K̔@Ti~TCj
		panelNo = ePanel030205;
		if ( NeonPlayNo == neon_rocket ){
			panelParam = GUM_GOLD_ANS;
		}
		
PANEL_GO:
		// EVENT_030201 K̋@
		
		evNo = info.mEventNo;
		
		K7SCR_PANEL_SETPANELID(panelNo, panelParam);
		
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		if( (result = K7SCR_PANEL_GETRESULT()) == GUM_GOLD_ANS ){					// I
			K7SCR_EVNO_SETENABLE(evNo, false);										// ̃Cxg֎~
		}
		
		K7SCR_RETSYS();
		K7SCR_PANEL_EXIT();
		K7SCR_EVCONDCHANGE();
		
		if ( result == GUM_GOLD_ANS ){
			
			K7SCR_PANEL_EXITWAIT();
			
//			GumOKDemo(evNo);
			
			switch( evNo ){
			case	K7EVENTNO(030205):
				K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_JIHANKI_BINGO);
				break;
			}
			
			if ( POPCORN_ALLCLEAR == PopCornMachinePopTest() ){
				Demo030206();
			}
			
			K7SCR_EVCONDCHANGE();
			
		}
		break;
	default:
		return true;
	}
	
	return false;
}


/*
	
	|bvR[}V {K[
	
*/
void K7Stage321M00::Demo030206(void)
{
	WK7JObj *pJObj;

	// L|[Y
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	// Jς
	FixCam( ONESHOTCAM_POPCORN_DEMO );
	
	// Wait
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
	
	{
		WK7JObj 		*pAnim;
		// [VĐ̃f
		// |bvR[}Vf
		gpSound->mPlaySE(SFX_SCE3_GOGAAN);
		PopCornDemoPlay();
		
		// ۊǗp̃Aj[VĐ i[V̓oCN̕gpj
		if( (pAnim=PlayMotion(POPMACHINE_YANE_NAME, 001))!=NULL ){
			if( pAnim != NULL ){
				pAnim->SetMotionLoop(false);
			}
		}
	}
	
	// Wait
	gpSound->mPlaySE(SFX_SYS_EV_CLEAR);
	
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(3.5));
	
	// |bvR[ɂ
	pJObj = GetJObj(MDL_POP_BEFORE);
	if ( pJObj != NULL ){
		pJObj->Hide(false, true);
	}
	// Jς
#if 0
//	FixCamMes( ONESHOTCAM_GINDAN, MES321M00_0 );
#else
	FixCam( ONESHOTCAM_GINDAN );
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
#endif
	
	// L|[Y
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	K7SCR_EVCONDCHANGE();
}


/*
	
	
	|bvR[}V|bv
	
	<return>
	
	NEON_MAX
	
*/
int K7Stage321M00::PopCornMachinePopTest(void)
{
	int num = 0;

	if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_JIHANKI_BINGO)==TRUE ) num++;
	return num;
}

/*	
	
	
	qbgIuWF
	
	
*/
bool K7Stage321M00::HitObjCallBack(WK7HitObjInfo &info)
{
	Vec Pos;

	switch( info.mEventNo ){
	case	K7EVENTNO(030207):						// |^N
	case	K7EVENTNO(030208):						// |^N
		info.mpJObj->GetPosition(Pos);
		BombObj(info.mpJObj);
		return false;
		break;
	}
	return true;
}


/*
	
	
	ꂷlIԍT[`
	
	
*/
u32 K7Stage321M00::SeachNeonNo(void)
{
	u32 randamNo;
//	int cnt;
	
#if 1
	// TɈ͂Ȃ炸̃pl𗬂
	randamNo =  (u32 )(rand()%NEON_MAX);
	zuruPanel++;
	if ( randamNo == neon_rocket ){
		zuruPanel = 0;
	}
	if ( zuruPanel >= 3 ){
		zuruPanel = 0;
		randamNo = neon_rocket;
	}
#else
	for(;;){
		randamNo =  (u32 )(rand()%NEON_MAX);
		cnt = PopCornMachinePopTest();
		if( NEON_MAX > cnt ){
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_JIHANKI_BINGO)==FALSE ) {
				if ( randamNo == neon_cowgirl )   return randamNo;
			}
		}else{
			return randamNo;
		}
	}
#endif
	
	return randamNo;
}


/*
	
	
	\͎gp
	̃V[
	
	
*/
bool K7Stage321M00::SpAbilityCallBack(WK7SpAbilityInfo &info)
{
//	WK7JObj		*pJObj;
	WK7PlayerSpInfoKed	*pKedInfo = WK7PLAYERCONTROL->GetSpInfoKed();
	switch( info.mAbilityID ){
	case	PC_SPA_BLOODY_SHOWER:
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_SP_321M00_KED)==TRUE ){
			WK7PLAYERCONTROL->SetSpAbilityCancel(true);
			return false;
		}
		
		K7SCR_SET_SCENARIO_FLAG(K7SCN03_SP_321M00_KED);
		WK7PLAYERCONTROL->SetSpInfoType(0);
		pKedInfo->mpTargetJObj = GetJObj("event_030209_ked");
		pKedInfo->mKedPos .x = -31.040f;
		pKedInfo->mKedPos .y = -0.0f;
		pKedInfo->mKedPos .z = -441.869f;
		pKedInfo->mKedRotY   = -1.57f;
		pKedInfo->mZanPos .x = -48.338f;
		pKedInfo->mZanPos .y = -0.0f;
		pKedInfo->mZanPos .z = -432.102f;
		pKedInfo->mZanRotY   = -3.14f;
		while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_MOTSTART     ){
			K7SCR_RETSYS();
		}
		FixCam(SECTRET_0);
		while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_ZANAPPEAR    ){
			K7SCR_RETSYS();
		}
		FixCam(SECTRET_1);
		WK7CAM->StartLinearInterpolateOnLinearPath(mpOneShotCamera[SECTRET_2].pos,
		                                           mpOneShotCamera[SECTRET_2].tgt,
		                                           180.0f);
		// wbang
		while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_BAAN ){
			K7SCR_RETSYS();
		}
		
		FixCam(SECTRET_3);
		
		// E
		while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_BREAKOBJ ){
			K7SCR_RETSYS();
		}
		FixCam(SECTRET_4);
		
		while( WK7PLAYERCONTROL->SpAtkEffectEndTest(mID,K7KED)==false ){
			K7SCR_RETSYS();
		}
		return false;
	default:
		break;
	}
	return true;
}


bool K7Stage321M00::BpLeaveCallBack(WK7BpInfo &info)
{
	u32		eventNo = GetBpEventNo(info);
	int		pathNo  = GetBpPathNo (info);
	if( pathNo!=0 ){
		return true;
	}
	switch( eventNo ){
	case	K7EVENTNO(030209):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_SP_321M00_KED)==TRUE ){			// Eς
			return true;
		}
		break;
	default:
		return true;
	}
	gpSound->mPlaySE(SFX_SYS_APPEAR_RIDDLE);
	return true;
}



