////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage326M00
//
// K7Stage326M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE326M00_H__
#define	__K7STAGE326M00_H__

#include "..\K7Stage.h"

class K7Stage326M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage326M00();
	K7Stage326M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	bool mWallMove;
	bool WallMoveB(f32 sframe=-1.f);
	WK7RenderObjEffect *mpWindEffect;
	int seNo;
	
	bool	mManualPathChange;
public:
	virtual ~K7Stage326M00();
	
	virtual bool SetCurrentCallBack(void);
	virtual bool BpLeaveCallBack(WK7BpInfo &);
	virtual bool CondChangeCallBack(void);
	virtual bool HitObjCallBack(WK7HitObjInfo &);
	virtual bool InitializeCallBack(void);
	
//	virtual bool EventCallBack     (WK7EventInfo     &);
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &){ return true; }		// hACxg retrun true  pXɊ܂܂郊NɃWvB
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
	virtual bool PathChangeCallBack(WK7PathChangeInfo &);
	
};

#ifdef __K7STAGE326M00_CPP__

enum K7STAGE326M00_ONESHOTCAM{
	EV_WALL_START,
	EV_WALL_BROKEN,
};

K7StageEventOneShotCamera K7Stage326M00_Camera[] = {
	{{-36.798f, -56.988f, -1082.006f},{-40.658f, -54.346f, -1073.168f}},			// ̕ǂłĂAj
	{{-36.798f, -56.988f, -1082.006f},{-40.658f, -54.346f, -1073.168f}},			// ̕ǂƂ̃J
};

#endif

#endif	//__K7STAGE326M00_H__

