////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage362M00 J[eBX̉Ɓ@v[
//
// K7Stage362M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 01/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE362M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage362M00.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Kaw\KK7Effect.h"
#include "..\..\..\Yam\YK7EffectPool.h"
#include "..\..\..\Yam\YK7EffectDraft.h"

//v[̑傫\W
#define	LOC362M00POOL_X			(-375.295f)
#define	LOC362M00POOL_Y			(12.857f)
#define	LOC362M00POOL_Z			(-1124.98f)
#define	LOC362M00POOL_X_SIZE	(280.000f)
#define	LOC362M00POOL_Z_SIZE	(180.000f)
#define	LOC362M00POOL_ANMTICK	(4800*5)

//bZ[W
#define	MES362M00_UNLOCKDOOR	(0)	//J
#define	MES362M00_LOCKDOOR		(1)	//Ă
//pX
#define	PATH362M00_MSKWALL_1	"event_035114_0"	//JpX1
#define	PATH362M00_MSKWALL_2	"event_035115_0"	//JpX2
//[V
#define	MOT362M00_LOSTWATER			(0)	//
#define	MOT362M00_BULBCAP_OP		(1)	//oůWJ
#define	MOT362M00_CATCAM			(2)					//Lbg̃XCfBOJ
#define	MOT362M00_CATSLIDING_SLOW	K7MOTID(K7CAT,510)	//Lbg̃XCfBOEX[
#define	MOT362M00_CATSLIDING		K7MOTID(K7CAT,520)	//Lbg̃XCfBOEʏ
//f
#define	MDL362M00_BULBCAP			"huta_01"				//oůW
#define	MDL362M00_STRANGE1			"sphere"				//svcȑ`E
#define	MDL362M00_STRANGE2			"cylinder"				//svcȑ`ELbg
#define	MDL362M00_WALL				"event_035110"			//󂹂
#define	MDL362M00_LEVER_OFF			"before"				//o[O
#define	MDL362M00_LEVER_ON			"after"					//o[
#define	MDL362M00_WIND				"hibi"					//n_
#define	MDL362M00_CYO_PICKING_352	"cyo_picking_352"		//R[eJW
#define	MDL362M00_LOCK_ON352		"cyo_padlock_on352"		//̂Ă
#define	MDL362M00_LOCK_OFF352		"cyo_padlock_off352"	//̊JĂ
#define	MDL362M00_CYO_PICKING_354	"cyo_picking_354"		//R[eJW
#define	MDL362M00_LOCK_ON354		"cyo_padlock_on354"		//̂Ă
#define	MDL362M00_LOCK_OFF354		"cyo_padlock_off354"	//̊JĂ


static Vec windPos = {-301.148f, -2.288f, -1197.177f};


//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage362M00::K7Stage362M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage362M00_Camera );
	mpPool       = NULL;
	mpWindEffect = NULL;
	mAmbPlaySE   = false;
	mpLoopSE     = NULL;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage362M00::~K7Stage362M00()
{
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage362M00::CreateCallBack( void )
{
	//[Vt@C
	CreateOwnStageMotion( MOT362M00_LOSTWATER );
	CreateOwnStageMotion( MOT362M00_BULBCAP_OP );
	CreateOwnStageMotion( MOT362M00_CATCAM );
	WK7RenderObj::CreateOwnMotionObj( K7MOT_ATTR|K7OBJTYPE_CHR, MOT362M00_CATSLIDING_SLOW );
	WK7RenderObj::CreateOwnMotionObj( K7MOT_ATTR|K7OBJTYPE_CHR, MOT362M00_CATSLIDING );
	
	return( true );
}

//------------------------------------------------------------------------------
//iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
//------------------------------------------------------------------------------
bool
K7Stage362M00::InitializeCallBack( void )
{
	//Lbĝ胂[V
	mpCatMotionSlow  = GetOwnModelMotion( K7MOT_ATTR|K7OBJTYPE_CHR, MOT362M00_CATSLIDING_SLOW );
	mpCatMotion      = GetOwnModelMotion( K7MOT_ATTR|K7OBJTYPE_CHR, MOT362M00_CATSLIDING );
	
	K7SCR_EVCONDCHANGE();
	
	return( true );
}

//------------------------------------------------------------------------------
//Iȉj
//------------------------------------------------------------------------------
bool
K7Stage362M00::TerminateCallBack( void )
{
	PoolUndisp();
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage362M00::SetCurrentCallBack( void )
{
	//ǂ󂵂
	if( K7SCR_GET_SCENARIO_FLAG(EV035110) == true )
	{
		//3D-SEĐĂ
		if( mpLoopSE != NULL )
		{
			mpLoopSE->taskEnd = -1;
			mAmbPlaySE = false;
			mpLoopSE   = NULL;
		}
		return( true );
	}
	
	if( (mAmbPlaySE == false)							//3D-SEĐĂȂ
	 && (K7SCR_GET_SCENARIO_FLAG(EV035110) == false)	//ǂ󂵂ĂȂ
	 && (K7SCR_GET_SCENARIO_FLAG(EV035108) == true)		//v[̐Ă
	 && (WK7PLAYERCONTROL->GetMainID() == K7CAT) )		//vC[̓Lbg
	{
		mpLoopSE = KK7SoundLoopSePlayVolumeChange((Vec){-296.227f, -3.162f, -1194.382f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE3_SUKIMAKAZE );
		if( mpLoopSE != NULL )
		{
			mAmbPlaySE = true;
		}
	}else
	{
		if( (mpLoopSE != NULL)							//3D-SEĐĂ
		 && (WK7PLAYERCONTROL->GetMainID() != K7CAT) )	//vC[̓Lbgł͂Ȃ
		{
			mpLoopSE->taskEnd = -1;
			mAmbPlaySE = false;
			mpLoopSE   = NULL;
		}
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage362M00::CondChangeCallBack( void )
{
	WK7JObj*	pJObj;
	EFFECT*		pWindEffect;
	
	//svcȑ`1
	if( K7SCR_GET_SCENARIO_FLAG(EV035108_1) == true )	//͂߂H
	{
		SimpleModelDisp( MDL362M00_STRANGE1 );
	}else
	{
		SimpleModelHide( MDL362M00_STRANGE1 );
	}
	//svcȑ`2
	if( K7SCR_GET_SCENARIO_FLAG(EV035108_2) == true )	//͂߂H
	{
		SimpleModelDisp( MDL362M00_STRANGE2 );
	}else
	{
		SimpleModelHide( MDL362M00_STRANGE2 );
	}
	
	//v[̐H
	if( K7SCR_GET_SCENARIO_FLAG(EV035108) == false )
	{
		//---- ĂȂ ----
		//o[̕\
		SimpleModelDisp( MDL362M00_LEVER_OFF );
		SimpleModelHide( MDL362M00_LEVER_ON );
		//ouWNV\
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035108), true );
		//v[ւ̃pX
		K7SCR_STG_SET_PATHENABLE( "AfterValve", false );
		//v[\
		PoolDisp();
	}else
	{
		//----  ----
		//o[̕\
		SimpleModelHide( MDL362M00_LEVER_OFF );
		SimpleModelDisp( MDL362M00_LEVER_ON );
		//ouWNV
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035108), false );
		//v[ւ̃pX\
		K7SCR_STG_SET_PATHENABLE( "AfterValve", true );
		//v[\
		PoolUndisp();
	}
	//oůWJ
	if( K7SCR_GET_SCENARIO_FLAG(EV035108_0) == false )
	{
		SimpleSetStartMotion( MDL362M00_BULBCAP, MOT362M00_BULBCAP_OP );
	}else
	{
		SimpleSetLastMotion( MDL362M00_BULBCAP, MOT362M00_BULBCAP_OP );
	}
	
	//ǂH
	if( K7SCR_GET_SCENARIO_FLAG(EV035110) == false )
	{
		//---- ĂȂ ----
		K7SCR_STG_SET_PATHENABLE( "passmask", false );
		SimpleModelDisp( MDL362M00_WALL );
		K7SCR_STG_SET_DISABLEPATHCAMERA( PATH362M00_MSKWALL_1, false );
		K7SCR_STG_SET_DISABLEPATHCAMERA( PATH362M00_MSKWALL_2, false );
		if( (WK7PLAYERCONTROL->GetMainID() == K7CAT) && (K7SCR_GET_SCENARIO_FLAG(EV035108) == true) )
		{
			WK7RenderObjEffectInfo	info;
			info.Create();
			if( ((pJObj=GetJObj(MDL362M00_WIND)) != NULL)
			 && (IsValidEffect(mpWindEffect) == false)
			 && ((pWindEffect = ::CreateDraft2Effect(pJObj,(s32)VParam[ED_DRAFT][2])) != NULL) )
			{
				mpWindEffect = CreateEffect( pWindEffect ,&info);
			}
			//CatWindSePlay(windPos, EV035110, SFX_SCE3_SUKIMAKAZE);
		}else
		{
			if( mpWindEffect != NULL )
			{
//				ReleaseEffect( mpWindEffect );
				DelReqEffect( mpWindEffect );
				mpWindEffect = NULL;
			}
		}
	}else
	{
		//---- Ĕjς ----
		K7SCR_STG_SET_PATHENABLE( "passmask", true );
		SimpleModelHide( MDL362M00_WALL );
		K7SCR_STG_SET_DISABLEPATHCAMERA( PATH362M00_MSKWALL_1, true );
		K7SCR_STG_SET_DISABLEPATHCAMERA( PATH362M00_MSKWALL_2, true );
		if( mpWindEffect != NULL )
		{
			ReleaseEffect( mpWindEffect );
			mpWindEffect = NULL;
		}
	}
	
	//ւ̔
	if( K7SCR_GET_SCENARIO_FLAG(DR035003) == false )
	{
		SimpleModelDisp( MDL362M00_LOCK_ON354 );
		SimpleModelHide( MDL362M00_LOCK_OFF354 );
	}else
	{
		SimpleModelHide( MDL362M00_LOCK_ON354 );
		SimpleModelDisp( MDL362M00_LOCK_OFF354 );
	}
	
	//ւ̔
	if( K7SCR_GET_SCENARIO_FLAG(DR036200) == false )
	{
		SimpleModelDisp( MDL362M00_LOCK_ON352 );
		SimpleModelHide( MDL362M00_LOCK_OFF352 );
	}else
	{
		SimpleModelHide( MDL362M00_LOCK_ON352 );
		SimpleModelDisp( MDL362M00_LOCK_OFF352 );
	}
	
	//v[̒̉ǂ̌ԕĐJn
	SetCurrentCallBack();
	
	return( true );
}

//------------------------------------------------------------------------------
//L`FW
//------------------------------------------------------------------------------
bool
K7Stage362M00::CharaChangeCallBack( WK7CharaChangeInfo &info )
{
#pragma	unused(info)
	K7SCR_EVCONDCHANGE();
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage362M00::EventCallBack( WK7EventInfo &info )
{
	WK7JObj*	pJObj;
	
	switch( info.mEventNo )
	{
		//oũpl
		case	K7EVENTNO( 035108 ):
			//GtFNg
			if( mpWindEffect != NULL )
			{
				ReleaseEffect( mpWindEffect );
				mpWindEffect = NULL;
			}
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			//svcȑ`1
			if( (K7SCR_GET_SCENARIO_FLAG(EV035013STRANGE) == true)	//ĂH
			 && (K7SCR_GET_SCENARIO_FLAG(EV035108_1) == false)		//͂߂H
			 && ((pJObj=GetJObj(MDL362M00_STRANGE1)) != NULL ) )	//fH
			{
				FixCam( CAM362M00BULBCAP );
				K7SCR_TIMEWAIT( 4800 );
				gpSound->mPlaySE( SFX_SYS_AKASICITEM_SET );
				pJObj->Disp( false, true );
				K7SCR_TIMEWAIT( 4800 );
				K7SCR_SET_SCENARIO_FLAG( EV035108_1 );
				K7SCR_EVSETITEM( K7EVITEM_KEY(035013), false );
			}
			//svcȑ`2
			if( (K7SCR_GET_SCENARIO_FLAG(EV035107STRANGE) == true)	//ĂH
			 && (K7SCR_GET_SCENARIO_FLAG(EV035108_2) == false)		//͂߂H
			 && ((pJObj=GetJObj(MDL362M00_STRANGE2)) != NULL ) )	//fH
			{
				FixCam( CAM362M00BULBCAP );
				K7SCR_TIMEWAIT( 4800 );
				gpSound->mPlaySE( SFX_SYS_AKASICITEM_SET );
				pJObj->Disp( false, true );
				K7SCR_TIMEWAIT( 4800 );
				K7SCR_SET_SCENARIO_FLAG( EV035108_2 );
				K7SCR_EVSETITEM( K7EVITEM_KEY(035107), false );
			}
			//`2Ƃ͂܂Ăou\
			if( (K7SCR_GET_SCENARIO_FLAG(EV035108_1) == true )
			 && (K7SCR_GET_SCENARIO_FLAG(EV035108_2) == true ) )
			{
				//̊Joς?
				if( K7SCR_GET_SCENARIO_FLAG(EV035108_0) == false )
				{
					//oůWJ[VĐ
					FixCam( CAM362M00BULBCAP );
					gpSound->mPlaySE( SFX_SCE3_CUR_POOL_PANEL_OPEN );
					if( (pJObj=PlayMotion(MDL362M00_BULBCAP,MOT362M00_BULBCAP_OP)) != NULL )
					{
						pJObj->SetMotionLoop( false );
						while( pJObj->GetMotionState() != WK7MODEL_NOANIM )
						{
							K7SCR_RETSYS();
						}
					}
					K7SCR_SET_SCENARIO_FLAG( EV035108_0 );
				}
				//v[\
				PoolUndisp();
				//plĂяo
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(035014), 0 );
				K7SCR_PANEL_START();
				K7SCR_PANEL_TERMWAIT();
				K7SCR_RETSYS();
				WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
				GameInfo.SetPanelNoiseCancel( true );
				K7SCR_PANEL_EXIT();
				K7SCR_PANEL_EXITWAIT();
				GameInfo.SetPanelNoiseCancel( false );
				if( K7SCR_PANEL_GETRESULT() == 1 )
				{
					//o[̕\
					if( (pJObj=GetJObj(MDL362M00_LEVER_OFF)) != NULL )
					{
						pJObj->Hide( false, true );
					}
					if( (pJObj=GetJObj(MDL362M00_LEVER_ON)) != NULL )
					{
						pJObj->Disp( false, true );
					}
					//v[̐郂[VĐ
					PoolDisp();
					FixCam( CAM362M00POOL );
					K7SCR_NOISE_RELEASE();
					//inGame~
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					gpSound->mPlaySE( SFX_SCE3_CUR_POOL_HIKU );
					PoolWaterLost();
					K7SCR_NOISE_REQUEST();
					gpSound->mStopSE( SFX_SCE3_CUR_POOL_HIKU );
					PoolUndisp();
					//v[̐tOON
					K7SCR_SET_SCENARIO_FLAG( EV035108 );
					//ԕύX
					K7SCR_EVCONDCHANGE();
					WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
					K7SCR_NOISE_RELEASE();
				}else
				{
					PoolDisp();
					K7SCR_NOISE_RELEASE();
				}
			}else
			{
				FixCamWithRiddle( CAM362M00BULBCAP );
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			break;
		
#if	0
		//LbĝE
		case	K7EVENTNO( 035117 ):
			if( WK7PLAYERCONTROL->GetMainID() != K7CAT )
			{
				FixCamWithRiddle( CAM362M00_RIDDLE_CAT_SLIDING_GARDEN );
			}else
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				if( K7SCR_GET_SCENARIO_FLAG(EV035106) == false)
				{
					CatSliding( true );
					K7SCR_SET_SCENARIO_FLAG( EV035106 );
				}else
				{
					CatSliding( false, CAM362M00_CAT_SLIDING_GARDEN );
				}
				K7SCR_SET_SCENARIO_FLAG( EV0362CAT_SLIDING );
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				//ړݒ
				K7SCR_STG_SET_CURRENT_PATH( "branch7", "curve35" );
				//inGameĊJ
				WK7PLAYERCONTROL->SetEnable( true );
				K7SCR_TIMEWAIT( 1200 );
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
			}
			break;
		
		//LbĝEv[
		case	K7EVENTNO( 035118 ):
			if( WK7PLAYERCONTROL->GetMainID() != K7CAT )
			{
				FixCamWithRiddle( CAM362M00_RIDDLE_CAT_SLIDING_POOL );
			}else
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				CatSliding( false, CAM362M00_CAT_SLIDING_POOL );
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_STG_SET_CURRENT_PATH( "branch8", "curve31" );
				//inGameĊJ
				WK7PLAYERCONTROL->SetEnable( true );
				K7SCR_TIMEWAIT( 1200 );
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
			}
			break;
#endif
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool
K7Stage362M00::DoorEventCallBack( WK7DoorEventInfo &info )
{
	switch( info.mEventNo )
	{
		//ւ̃V[gJbg
		case	K7EVENTDOOR( 035109 ):
			if( K7SCR_GET_SCENARIO_FLAG(DR035003) == false )
			{
				if( WK7PLAYERCONTROL->GetMainID() == K7CYO )
				{
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					SimpleCyoPicking( MDL362M00_CYO_PICKING_354, CAM362M00_CYO_PICKING );
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					K7SCR_SET_SCENARIO_FLAG( DR035003 );
					K7SCR_EVCONDCHANGE();
					K7SCR_PC_SETVISIBLE( false );
					FixCam( CAM362M00_LOCKDOOR );
					K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
					info.mCinemaScopeClear = true;
					//K7SCR_STGC_MESSAGE_B( MES362M00_UNLOCKDOOR );
					K7SCR_PC_SETVISIBLE( true );
					K7SCR_EXIT_PLAYMODE();
					K7SCR_EXIT_DEMOPAUSE();
				}else
				{
					FixCamMesWithRiddle( CAM362M00_LOCKDOOR, MES362M00_LOCKDOOR );
					return( false );
				}
			}
			break;
		
		//ւ̃V[gJbg
		case	K7EVENTDOOR( 035111 ):
			if( K7SCR_GET_SCENARIO_FLAG(DR036200) == false )
			{
				if( WK7PLAYERCONTROL->GetMainID() == K7CYO )
				{
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					SimpleCyoPicking( MDL362M00_CYO_PICKING_352, CAM362M00_CYO_PICKING_352 );
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					K7SCR_SET_SCENARIO_FLAG( DR036200 );
					K7SCR_EVCONDCHANGE();
					K7SCR_PC_SETVISIBLE( false );
					FixCam( CAM362M00_LOCKDOOR_352 );
					K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
					info.mCinemaScopeClear = true;
					//K7SCR_STGC_MESSAGE_B( MES362M00_UNLOCKDOOR );
					K7SCR_PC_SETVISIBLE( true );
					K7SCR_EXIT_PLAYMODE();
					K7SCR_EXIT_DEMOPAUSE();
				}else
				{
					FixCamMesWithRiddle( CAM362M00_LOCKDOOR_352, MES362M00_LOCKDOOR );
					return( false );
				}
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//_o
//------------------------------------------------------------------------------
bool
K7Stage362M00::BpLeaveCallBack( WK7BpInfo &info )
{
	u32	evno   = GetBpEventNo( info );
	int	pathNo = GetBpPathNo( info );
	if( evno==0xffffffff )
		return( true );
	
	//0ȊO͊֌WȂ
	if( pathNo != 0 )
	{
		return( true );
	}
	
	//ǂ󂵂ĂȂ
	if( K7SCR_GET_SCENARIO_FLAG(EV035110) == false )
	{
		switch( evno )
		{
			case	K7EVENTNO( 035114 ):
				gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );
				break;
			
			case	K7EVENTNO( 035115 ):
				gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );
				break;
			
			default:
				break;
		}
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//qbgIuWF
//------------------------------------------------------------------------------
bool
K7Stage362M00::HitObjCallBack( WK7HitObjInfo &info )
{
	switch( info.mEventNo )
	{
		//
		case	K7EVENTNO( 035110 ):
			if( (WK7PLAYERCONTROL->GetMainID() == K7MSK)
			 && (K7SCR_GET_SCENARIO_FLAG(EV035108) == true) )
			{
				//퓬I
				KK7BattleMainTask::BattleMainTaskExit(2);
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				//ǂtOON
				K7SCR_SET_SCENARIO_FLAG( EV035110 );
				K7SCR_STG_SET_PATHENABLE( "passmask", true );
				K7SCR_STG_SET_DISABLEPATHCAMERA( PATH362M00_MSKWALL_1, true );
				K7SCR_STG_SET_DISABLEPATHCAMERA( PATH362M00_MSKWALL_2, true );
				if( mpLoopSE != NULL )
				{
					mpLoopSE->taskEnd = -1;
				}
				//IuWF
				info.mpJObj->Hide( false, true );
				BrokenObj( MDL362M00_WALL );
				//
				KK7DoorSmokeEffect( (Vec){-294.990f, -7.223f, -1194.504f} );
				//Jݒ
				SetMskWallCam( CAM362M00_MSK_WALL );
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
			}
			//v[̐ЂĂȂƂ̓tOQ
			if( K7SCR_GET_SCENARIO_FLAG(EV035108) == false )
			{
//				info.mpHitObj->SetEnable( true );
				info.SetHitObjEnable(true);
				return( false );
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//v[\
//------------------------------------------------------------------------------
void
K7Stage362M00::PoolDisp( void )
{
	if( mpPool == NULL )
	{
		mpPool = CreatePoolEffect( LOC362M00POOL_X_SIZE, LOC362M00POOL_Z_SIZE,
								   VParam[ED_POOL][7] * 0.1F,
								   (Vec){ LOC362M00POOL_X, LOC362M00POOL_Y, LOC362M00POOL_Z } ) ;
	}
	ChangePoolColor( mpPool, CMK( VParam[ED_POOL][13], VParam[ED_POOL][14], VParam[ED_POOL][15], VParam[ED_POOL][16] ) ) ;
}

//------------------------------------------------------------------------------
//v[
//------------------------------------------------------------------------------
void
K7Stage362M00::PoolUndisp( void )
{
	if( mpPool != NULL )
	{
		DeleteEffect( mpPool );
		mpPool = NULL;
	}
}

//------------------------------------------------------------------------------
//v[
//------------------------------------------------------------------------------
void
K7Stage362M00::PoolWaterLost( void )
{
	WK7AnimLinearF	posY;
	Vec				pos = { LOC362M00POOL_X, LOC362M00POOL_Y, LOC362M00POOL_Z };
	
	posY.SetValue( LOC362M00POOL_Y );
	posY.Play( -12.0f, LOC362M00POOL_ANMTICK );
	do{
		pos.y = posY.GetValue();
		ChangePoolPos( mpPool, pos );
		K7SCR_RETSYS();
		posY.FrameProcess();
	}while( posY.IsAnimating() == true );
}

//------------------------------------------------------------------------------
//Lbg
//------------------------------------------------------------------------------
#if	0
void
K7Stage362M00::CatSliding( bool inCamMotion, u32 inCamID )
{
	WK7Model*			pPcModel = WK7PLAYERCONTROL->GetCharaModel();
	WK7CameraMotion*	pCamMot  = GetOwnCameraMotion( MOT362M00_CATCAM );
	u32	oldColor;
	
	if( inCamMotion == true )
	{
		//Lbĝ胂[VĐ
		if( (pPcModel != NULL) && (pCamMot != NULL) )
		{
			WK7PLAYERCONTROL->SetEnable( false );
			gpSound->mPlaySE( SFX_SYS_TRUE );
			//Lbg[VĐ
			pPcModel->AttachMotion( mpCatMotionSlow );
			pPcModel->PlayMotion();
			pPcModel->SetMotionLoop( false );
			//J[VĐ
			WK7CAM->SetMode( WK7Cam::WK7CAM_FREE_TARGET );
			oldColor = WK7CAM->GetCinemaScopeColor();
			WK7CAM->SetCinemaScopeColor( 0x000000ff );
			WK7CAM->SetCinemaScopeMode( true );
			WK7CAM->AttachMotion( pCamMot );
			WK7CAM->PlayMotion();
			WK7CAM->SetMotionLoop( false );
			//ĐI҂
			while( (pPcModel->GetMotionState() != WK7MODEL_NOANIM) || (WK7CAM->GetMotionState() != WK7CAM_NOANIM) )
			{
				K7SCR_RETSYS();
			}
			WK7CAM->DetachMotion();
			WK7CAM->SetCinemaScopeMode( false );
			WK7CAM->SetCinemaScopeColor( oldColor );
		}
	}else
	{
		//Lbĝ胂[VĐ
		if( pPcModel != NULL )
		{
			if( inCamID != 0xffffffff )
			{
				FixCam( inCamID );
			}
			WK7PLAYERCONTROL->SetEnable( false );
			//Lbg[VĐ
			pPcModel->AttachMotion( mpCatMotion );
			pPcModel->PlayMotion();
			pPcModel->SetMotionLoop( false );
			//ĐI҂
			while( pPcModel->GetMotionState() != WK7MODEL_NOANIM )
			{
				K7SCR_RETSYS();
			}
		}
	}
	WK7PLAYERCONTROL->NextMotionHokanEnableRequest();
}
#endif

