////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage410M00 yh~jJzO
//
// K7Stage410M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE410M00_CPP__

#include "..\..\..\Scn\K7Scn04.h"
#include ".\K7Stage410M00.h"

//VK[
#define	MDL410M00_SNG_CHRID		K7CHRID(K7SNG,0)
#define	MOT410M00_SNG_STANDBY	K7MOTID(K7SNG,20)




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage410M00::K7Stage410M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage410M00_Camera );
	mpSng              = NULL;
	mpSngModel         = NULL;
	mpSngMotionStandby = NULL;
	mpEffectLensFlare = NULL;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage410M00::~K7Stage410M00()
{
	ReleaseEffectLensFlare();
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage410M00::CreateCallBack( void )
{
	mpSng = CreateOwnChara( MDL410M00_SNG_CHRID );
	WK7RenderObj::CreateOwnMotionObj( K7MOT_ATTR|K7OBJTYPE_CHR, MOT410M00_SNG_STANDBY );
	// YtA
	SetupEffectLensFlare();
	return( true );
}

//------------------------------------------------------------------------------
//iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
//------------------------------------------------------------------------------
bool
K7Stage410M00::InitializeCallBack( void )
{
	WK7JObj*	pJObj;
	Vec			loc;
	f32			rot;
	
	mpSng              = GetOwnChara( MDL410M00_SNG_CHRID );
	mpSngModel         = GetOwnModel( K7OBJTYPE_CHR, MDL410M00_SNG_CHRID );
	mpSngMotionStandby = GetOwnModelMotion( K7MOT_ATTR|K7OBJTYPE_CHR, MOT410M00_SNG_STANDBY );
	
	//W擾
	if( (pJObj=GetJObj("sng_pos")) != NULL )
	{
		pJObj->GetWorldPosition( loc );
		rot = pJObj->GetRotY();
	}else
	{
		loc.x = loc.y = loc.z = rot = 0.0f;
	}
	//[VĐ&fݒu
	if( (mpSngModel != NULL) && (mpSngMotionStandby != NULL) )
	{
		mpSngModel->AttachMotion( mpSngMotionStandby );
		mpSngModel->PlayMotion();
		mpSngModel->SetMotionLoop( true );
		mpSngModel->SetPosition( loc );
		mpSngModel->SetRotY( rot );
		mpSng->SetRenderFlag( true );
	}
	
	while( CheckSetupEffectLensFlare()==false ){
		K7SCR_RETSYS() ;
	}
	mpEffectLensFlare = CreateEffectLensFlare("sun_alpha");
	
	return( true );
}



/*
//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool
K7Stage410M00::DoorEventCallBack( WK7DoorEventInfo &info )
{
	switch( info.mEventNo )
	{
		//OL
		case	K7EVENTDOOR( 040101 ):
			if( K7SCR_GET_SCENARIO_FLAG(MV040002) == false )
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				//KVA_ɑĂȂΕς
				if( WK7PLAYERCONTROL->GetMainID() != K7DAN )
				{
					//ĎJŃL
					FixCam( CAM410M00_CAMERA );
					K7SCR_TIMEWAIT( WK7_SEC_TO_TICK(2) );
					WatchCameraB( K7Stage410M00_Camera[CAM410M00_PC].tgt,
								  K7Stage410M00_Camera[CAM410M00_PC].pos,
								  K7CHRID(K7DAN,0), 1 );
				}
				K7SCR_NOISE_REQUEST();
				K7SCR_STG_VISIBLE( mID, false );
				K7SCR_STAGE_RELEASE();
				K7SCR_NOISE_RELEASE();
				//[r[ĐE_ƃVK[
				K7SCR_MOVIE_PLAY_NO_NOISE( K7MOV_GURAD );
				K7SCR_SET_SCENARIO_FLAG( MV040002 );
				K7SCR_STAGE_RESTORE();
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				strcpy( info.mNextBpName, "position_dan" );
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}
*/
