////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage411M00 yh~jJzOL
//
// K7Stage411M00.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE411M00_H__
#define	__K7STAGE411M00_H__

#include "..\K7Stage.h"

class K7Stage411M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage411M00();
	K7Stage411M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);

	EFFECT *Impact ;
	u32 ImpactID ;
	EFFECT *Screen ;
	u32 ScreenID ;
	EFFECT *Smoke ;
	u32 SmokeID ;
	
	bool			mPlayAmbSE;
	
	WK7ModelMotion*	mpMskMotion;
	
	WK7Chara*		mpSng;
	WK7Model*		mpSngModel;
	WK7ModelMotion*	mpSngMotionStandby;
	
	WK7RenderObjEffect*	mpEffectLensFlare;	//YtAGtFNg
public:
	virtual ~K7Stage411M00();
	
	virtual bool CreateCallBack    (void);					//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
	virtual bool InitializeCallBack(void);					//iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
	virtual bool CondChangeCallBack(void);					//ԕύXitOɂԕύX邽߂ɗpj
//	virtual bool TerminateCallBack (void);					//Iȉj
	virtual bool SetCurrentCallBack(void);					//JgXe[Wɐݒ莞
	virtual bool EventCallBack     (WK7EventInfo     &);	//Cxg
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);	//hACxg
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &);	//L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &);	//}bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &);	//Cxg
	virtual bool BpLeaveCallBack   (WK7BpInfo        &);	//_o
//	virtual bool BpArriveCallBack  (WK7BpInfo        &);	//_
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &);	//mobS
//	virtual bool HitObjCallBack    (WK7HitObjInfo    &);	//qbgIuWF
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &);	//XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &);	//erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &);	//erCxgiZ[u|Cgj

};

#ifdef __K7STAGE411M00_CPP__


enum K7STAGE411M00_ONESHOTCAM{
	CAM411M00_MSK_ATTACK,		//}XNvXZy
	CAM411M00_BARREL,			//M
	CAM411M00_BARREL_RIDDLE,	//M̓
	CAM411M00_SHORTCUT_DOOR,	//V[gJbg̔
	CAM411M00_CAMERA,			//ĎJ
	CAM411M00_PC,				//LN^
};

K7StageEventOneShotCamera K7Stage411M00_Camera[] = {
	{{-14.717f, 5.526f, -405.446f},{-19.597f, -0.032f, -412.176f}},		//}XNvXZy
	{{-11.079f, 4.049f, -413.402f},{-11.080f, 0.588f, -422.784f}},		//M
	{{-16.681f, 7.685f, -389.882f},{-20.105f, 9.715f, -380.709f}},		//M̓
	{{260.557f, 9.468f, -302.474f},{240.102f, 2.410f, -310.687f}},		//V[gJbg̔
	{{-347.904f, 44.546f, -259.747f},{-340.497f, 44.495f, -258.385f}},	//ĎJ
	{{-338.376f, 22.691f, -247.520f},{-346.195f, 39.841f, -258.251f}},	//LN^
};

#endif

#endif	//__K7STAGE411M00_H__

