////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage412M00 yh~jJz̊X
//
// K7Stage412M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 05/09/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE412M00_H__
#define	__K7STAGE412M00_H__

#include "..\K7Stage.h"

#define	K7STAGE412M00_SE_VOLBASE	(4800)
#define	K7STAGE412M00_SE_PANBASE	(4800)
#if 0
class K7Stage412M00_Singer{
protected:
	static u32			mMaxVol;
	static u32			mMinVol;
	
	int					mSeID;
	Vec					mPos;
	u32					mPan;
	u32					mVol;
	int					mProc;
	int					mTaskID;
	ghmGcTaskController	*mpTaskController;
public:
	K7Stage412M00_Singer(ghmGcTaskController *pTaskController);
	~K7Stage412M00_Singer();
	
	static void SetVolRange(u32 max,u32 min){ mMaxVol=max*K7STAGE412M00_SE_VOLBASE; mMinVol=min*K7STAGE412M00_SE_VOLBASE; }
	
	bool Start(void);
	bool Stop(void);
	bool SetPos(const Vec &pos);
	
	bool FrameProcess(void);
	
	static void SingerTask(ghmGcTask *);
	static void SingerTaskTerm(ghmGcTask *);
};
#endif

class K7Stage412M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	WK7RenderObjEffect		*mpSeenSound;
	s8						mSeenSoundPos;
	u32						mVol;
	bool					mRight;
	
	WK7RenderObjEffect*	mpEffectLensFlare;	//YtAGtFNg
	
	K7Stage412M00();
	K7Stage412M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	bool SetVol(bool right);
//	bool SetVolPan(void);
	u32 GetRightEventNo(void);
	int GetRightPosID(void);
//	bool GetRightPos(Vec &pos);
	bool SetPathEnable(u32 evno,int pathno,bool flag);
	bool SetNextPath(int next,const char *ppathname,int pathno,bool rev);
	bool GetEventNo(WK7PathInfo *pPathInfo,u32 &evno,int &pathno);
	int GetNextGate(int curGate);
	bool MainStreetProc(u32 evno,int pathno);
	bool SideGateProc(u32 evno,int pathno);
public:
	virtual ~K7Stage412M00();
	
	virtual bool CreateCallBack    (void);					//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
	virtual bool InitializeCallBack(void);					//iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
	virtual bool CondChangeCallBack(void);
//	virtual bool TerminateCallBack (void);					//Iȉj
	virtual bool SetCurrentCallBack(void);					//JgXe[Wɐݒ莞
//	virtual bool EventCallBack     (WK7EventInfo     &);	//Cxg
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &);	//hACxg
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &);	//L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &);	//}bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &);	//Cxg
	virtual bool BpLeaveCallBack   (WK7BpInfo        &);
	virtual bool BpArriveCallBack  (WK7BpInfo        &);	//_
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &);	//mobS
//	virtual bool HitObjCallBack    (WK7HitObjInfo    &);	//qbgIuWF
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &);	//XyVA^bNgp
//	virtual bool SpAbilityCallBack (WK7SpAbilityInfo &);	//XyVAreBgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &);	//erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &);	//erCxgiZ[u|Cgj
	virtual bool CharaChangeCallBack(WK7CharaChangeInfo &);	//L`FW
	virtual bool PathTurnCallBack   (WK7PathTurnInfo    &);
};

#ifdef __K7STAGE412M00_CPP__


//enum K7STAGE412M00_ONESHOTCAM{
//	CAM412M00_CAMERA,		//ĎJ
//	CAM412M00_PC,			//LN^
//};

//K7StageEventOneShotCamera K7Stage412M00_Camera[] = {
//	{{-506.839f, 25.059f, -268.047f},{-489.701f, 18.742f, -252.287f}},	//ĎJ
//	{{-485.794f, 17.236f, -250.260f},{-503.715f, 26.889f, -263.210f}},	//LN^
//};

#endif

#endif	//__K7STAGE412M00_H__

