////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage422M00 yh~jJzB
//
// K7Stage422M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE422M00_CPP__

#include "..\..\..\Scn\K7Scn04.h"
#include ".\K7Stage422M00.h"

//pX
#define	PAT422M00_TO_INNER	"pass_dan"			//HS̑|ʂpX
#define	PAT422M00_RIDDLE	"event_040202_0"	//ĴpX




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage422M00::K7Stage422M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage422M00::~K7Stage422M00()
{
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage422M00::CondChangeCallBack( void )
{
	//HS̑|
	if( K7SCR_GET_SCENARIO_FLAG(EV040202) == false )
	{
		K7SCR_STG_SET_PATHENABLE( PAT422M00_TO_INNER, false );
		K7SCR_STG_SET_DISABLEPATHCAMERA( PAT422M00_RIDDLE, false );
	}else
	{
		K7SCR_STG_SET_PATHENABLE( PAT422M00_TO_INNER, true );
		K7SCR_STG_SET_DISABLEPATHCAMERA( PAT422M00_RIDDLE, true );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
// ̐ݒ
#define CORE_NUM	(4)
bool
K7Stage422M00::SetCurrentCallBack(void)
{
	pNpcSu = (K7EnmK *)WK7Npc::Find(ENENO_4_422M00_1);
	
	//HS̑|
	if( K7SCR_GET_SCENARIO_FLAG(EV040202) == false )
	{	//ʉ߂ĂȂ
		gpSound->mPlayStreamEx( HPS_BUNSIN_M );
	}else
	{	//ʉ߂
		gpSound->mPlayStreamEx( HPS_SAFE_PLACE, 50 );
	}
	
	if ( pNpcSu != NULL ) {
		while( pNpcSu->SetUpTest()==false ){
			K7SCR_RETSYS();
		}
		pNpcSu->HitObjMake(WK7Stage::GetCurrentStage(), CORE_NUM);
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//_o
//------------------------------------------------------------------------------
bool
K7Stage422M00::BpLeaveCallBack( WK7BpInfo &info )
{
	u32	eventNo  = GetBpEventNo( info );
	int	pathNo   = GetBpPathNo( info );
	
	switch( eventNo )
	{
		//HS̑
		case	K7EVENTNO( 040202 ):
			if( (K7SCR_GET_SCENARIO_FLAG(EV040202) == false) && (pathNo == 0) )
			{
				gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );
			}
			break;
		
		//ftHg
		default:
			return( true );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//mobS
//------------------------------------------------------------------------------
bool
K7Stage422M00::DieNpcCallBack( WK7DieNpcInfo &info )
{
	if( info.mpNpc==NULL )
	{
		return true;
	}
	
	switch( info.mpNpc->GetEneNo() )
	{
		//HSj
		case	ENENO_4_422M00_1:
			K7SCR_SET_SCENARIO_FLAG( EV040202 );
			K7SCR_EVCONDCHANGE();
			gpSound->mPlayStreamEx( HPS_SAFE_PLACE, 50 );
			break;
		
		default:
			break;
	}
	
	return( true );
}


bool K7Stage422M00::HitObjCallBack(WK7HitObjInfo &info)
{
	if ( pNpcSu != NULL ) {
		if( (info.mEventNo >= pNpcSu->GetHitObjID()) && (info.mEventNo < (pNpcSu->GetHitObjID()+CORE_NUM) ) ){
			if ( false == pNpcSu->CoreHit((int )info.mEventNo, info.mTypeID, info.mHitPos) ) {
				// RAj󂵂ĂȂ
				// qbgIuWF𕜊
//				info.mpHitObj->SetEnable(true);
				info.SetHitObjEnable(true);
			}
			return false;
		}
	}
	return true;
}



