////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage443M00 yh~jJzԍL
//
// K7Stage443M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE443M00_CPP__

#include "..\..\..\Scn\K7Scn04.h"
#include ".\K7Stage443M00.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Wat\WK7SceneBlur.h"

//[V
#define	MOT443M00_WINDMILL		(1)				//ԉ]
//f
#define	MDL443M00_WINDMILL		"windmill"		//




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage443M00::K7Stage443M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mWindmillWorking = false;
	mAmbPlaySE       = false;
	mOldBlurVisible  = SceneBlur.GetVisible();
	SceneBlur.SetVisible( false );
	mpEffectLensFlare = NULL;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage443M00::~K7Stage443M00()
{
	SceneBlur.SetVisible( mOldBlurVisible );
	ReleaseEffectLensFlare();
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage443M00::CreateCallBack( void )
{
	CreateOwnStageMotion( MOT443M00_WINDMILL );
	// YtA
	SetupEffectLensFlare();
	return( true );
}

bool
K7Stage443M00::InitializeCallBack( void )
{
	while( CheckSetupEffectLensFlare()==false ){
		K7SCR_RETSYS() ;
	}
	mpEffectLensFlare = CreateEffectLensFlare("sun_alpha");
	return true;
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage443M00::CondChangeCallBack( void )
{
	WK7JObj*	pJObj;
	
	//Ԃ񂵂
	if( K7SCR_GET_SCENARIO_FLAG(EV040404) == false )
	{
		SimpleSetStartMotion( MDL443M00_WINDMILL, MOT443M00_WINDMILL );
		mWindmillWorking = false;
	}else
	{
		if( mWindmillWorking == false )
		{
			pJObj = PlayMotion( MDL443M00_WINDMILL, MOT443M00_WINDMILL );
			pJObj->SetMotionLoop( true ,true, true );
			mWindmillWorking = true;
		}
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage443M00::SetCurrentCallBack( void )
{
//	SetCurrentCallBackDefaultProc();
//	while( WK7RenderObj::IsValid(this)==true && GetState()==LOADED ){
//		K7SCR_RETSYS();
//	}
//	return( false );
	mWindmillWorking = false;
	
	if( mAmbPlaySE == false )
	{
		KK7SoundLoopSePlayVolumeChange((Vec){-130.555f, 93.950f, -982.268f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE4_AMB_SPARROW);
		KK7SoundLoopSePlayVolumeChange((Vec){-436.687f, 77.259f, -1012.872f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE4_AMB_SPARROW);
		KK7SoundLoopSePlayVolumeChange((Vec){-603.741f, 15.445f, -830.016f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE4_AMB_WIND);
		KK7SoundLoopSePlayVolumeChange((Vec){-380.379f, 10.077f, -892.662f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE4_AMB_WIND);
		KK7SoundLoopSePlayVolumeChange((Vec){-210.047f, 12.313f, -866.925f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE4_AMB_WIND);
		mAmbPlaySE = true;
	}
	
	//GpoptOݒ
	if( GetPrevStageID() == K7STGID(442,0) )
	{
		K7SCR_SET_SCENARIO_FLAG( EN443M00_FROM442M00 );
		K7SCR_RESET_SCENARIO_FLAG( EN443M00_FROM444M00 );
	}else
	if( GetPrevStageID() == K7STGID(444,0) )
	{
		K7SCR_RESET_SCENARIO_FLAG( EN443M00_FROM442M00 );
		K7SCR_SET_SCENARIO_FLAG( EN443M00_FROM444M00 );
	}else
	{
		K7SCR_RESET_SCENARIO_FLAG( EN443M00_FROM442M00 );
		K7SCR_RESET_SCENARIO_FLAG( EN443M00_FROM444M00 );
	}
	
	return( true );
}
