////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage444M00 yh~jJzg@[@
//
// K7Stage444M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE444M00_CPP__

#include "..\..\..\Scn\K7Scn04.h"
#include ".\K7Stage444M00.h"
#include "..\..\..\sato\SK7SpecialData.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Wat\WK7SceneBlur.h"

//[V
#define	MOT444M00_WINDMILL				(1)					//ԉ]
#define	MOT444M00_DOOR_OPEN_WINDMILL	(2)					//J()
#define	MOT444M00_DOOR_OPEN_PANELL		(3)					//pl̔J
//f
#define	MDL444M00_WINDMILL				"windmill"			//
#define	MDL444M00_DOOR_WINDMILL			"gate"				//ԂŊJ
#define	MDL444M00_DOOR_PANEL			"color_panel"		//pl̔
#define	MDL444M00_STRANGE				"obj_12"			//svcȑ`
#define	MDL444M00_SHORTCUT413_LIGHT		"ON_413"			//V[gJbg413̓
#define	MDL444M00_SHORTCUT413_DARK		"OFF_413"			//V[gJbg413̈
#define	MDL444M00_WARP_CANDLE_413		"warp_candle_413"	//V[gJbg413̃E\N
#define	MDL444M00_SHORTCUT420_LIGHT		"ON_420"			//V[gJbg420̓
#define	MDL444M00_SHORTCUT420_DARK		"OFF_420"			//V[gJbg420̈
#define	MDL444M00_WARP_CANDLE_420		"warp_candle_420"	//V[gJbg413̃E\N
#define	MDL444M00_SHORTCUT441_LIGHT		"ON_441"			//V[gJbg441̓
#define	MDL444M00_SHORTCUT441_DARK		"OFF_441"			//V[gJbg441̈
#define	MDL444M00_WARP_CANDLE_441		"warp_candle_441"	//V[gJbg413̃E\N
//bZ[W
#define	MES444M00_DOOR_CLOSE_WINDMILL	(0)					//Ă
#define	MES444M00_DOOR_CLOSE_TREVER		(1)					//|Ă
#define	MES444M00_USE_FIRE_RING			(2)					//̎wւg
//pX
#define	PAT444M00_WINDMILL_INNER		"event_040413_0"	//Ԃ𓮂ƒʂpX
#define	PAT444M00_SHORTCUT413			"event_040407_0"	//413ւ̃V[gJbgpX
#define	PAT444M00_SHORTCUT420			"event_040408_0"	//413ւ̃V[gJbgpX
#define	PAT444M00_SHORTCUT441			"event_040409_0"	//413ւ̃V[gJbgpX

#define	STG444M00_SHADOW_ELASE_TICK		(4800)				//E\Nŉe鎞




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage444M00::K7Stage444M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage444M00_Camera );
	mWindmillWorking = false;
	mpEffectFire413  = NULL;
	mpEffectFire420  = NULL;
	mpEffectFire441  = NULL;
	mAmbPlaySE       = false;
	mOldBlurVisible  = SceneBlur.GetVisible();
	SceneBlur.SetVisible( false );
	mpEffectLensFlare = NULL;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage444M00::~K7Stage444M00()
{
	SceneBlur.SetVisible( mOldBlurVisible );
	ReleaseEffectLensFlare();
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage444M00::CreateCallBack( void )
{
	CreateOwnStageMotion( MOT444M00_WINDMILL );
	CreateOwnStageMotion( MOT444M00_DOOR_OPEN_WINDMILL );
	CreateOwnStageMotion( MOT444M00_DOOR_OPEN_PANELL );
	// YtA
	SetupEffectLensFlare();
	//GtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_FIRE) == NULL )
	{
		K7SCR_RETSYS();
	}
	return( true );
}

bool
K7Stage444M00::InitializeCallBack( void )
{
	while( CheckSetupEffectLensFlare()==false ){
		K7SCR_RETSYS() ;
	}
	mpEffectLensFlare = CreateEffectLensFlare("sun_alpha");
	return true;
}

//------------------------------------------------------------------------------
//Iȉj
//------------------------------------------------------------------------------
bool
K7Stage444M00::TerminateCallBack( void )
{
	//̃GtFNgI
	EffectFireStop( mpEffectFire413 );
	EffectFireStop( mpEffectFire420 );
	EffectFireStop( mpEffectFire441 );
	while( WK7RenderObj::ReleaseEffectAnimResource(ANIMID_FIRE) == NULL )
	{
		K7SCR_RETSYS();
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage444M00::CondChangeCallBack( void )
{
	WK7JObj*	pJObj;
	
	//Ԃ񂵂
	if( K7SCR_GET_SCENARIO_FLAG(EV040404) == false )
	{
		SimpleSetStartMotion( MDL444M00_DOOR_WINDMILL, MOT444M00_DOOR_OPEN_WINDMILL );
		K7SCR_STG_SET_PATHENABLE( PAT444M00_WINDMILL_INNER, false );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040413), true );
		SimpleSetStartMotion( MDL444M00_WINDMILL, MOT444M00_WINDMILL );
		mWindmillWorking = false;
	}else
	{
		SimpleSetLastMotion( MDL444M00_DOOR_WINDMILL, MOT444M00_DOOR_OPEN_WINDMILL );
		K7SCR_STG_SET_PATHENABLE( PAT444M00_WINDMILL_INNER, true );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040413), false );
		if( mWindmillWorking == false )
		{
			if( (pJObj=PlayMotion(MDL444M00_WINDMILL,MOT444M00_WINDMILL)) != NULL )
			{
				pJObj->SetMotionLoop( true ,false, true );
			}
			mWindmillWorking = true;
		}
	}
	
	//svcȑ`͂߂
	if( K7SCR_GET_SCENARIO_FLAG(EV040405_0) == false )
	{
		SimpleModelHide( MDL444M00_STRANGE );
		SimpleSetStartMotion( MDL444M00_DOOR_PANEL, MOT444M00_DOOR_OPEN_PANELL );
	}else
	{
		SimpleModelDisp( MDL444M00_STRANGE );
		SimpleSetLastMotion( MDL444M00_DOOR_PANEL, MOT444M00_DOOR_OPEN_PANELL );
	}
	
	//J[plɐ
	if( K7SCR_GET_SCENARIO_FLAG(EV040405) == false )
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040405), true );
	}else
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040405), false );
	}
	
	//V[gJbg413
	if( K7SCR_GET_SCENARIO_FLAG(EV444413) == true )
	{
	//	if( K7SCR_GET_SCENARIO_FLAG(EV413444) == true )
	//	{
			K7SCR_STG_SET_PATHENABLE( PAT444M00_SHORTCUT413, true );
	//	}else
	//	{
	//		K7SCR_STG_SET_PATHENABLE( PAT444M00_SHORTCUT413, false );
	//	}
		SimpleModelDisp( MDL444M00_SHORTCUT413_LIGHT );
		SimpleModelHide( MDL444M00_SHORTCUT413_DARK );
		EffectFireDisp( GetJObj(MDL444M00_WARP_CANDLE_413), mpEffectFire413 );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040407), false );
	}else
	{
		K7SCR_STG_SET_PATHENABLE( PAT444M00_SHORTCUT413, false );
		SimpleModelHide( MDL444M00_SHORTCUT413_LIGHT );
		SimpleModelDisp( MDL444M00_SHORTCUT413_DARK );
		EffectFireStop( mpEffectFire413 );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040407), true );
	}
	//V[gJbg420
	if( K7SCR_GET_SCENARIO_FLAG(EV444420) == true )
	{
	//	if( K7SCR_GET_SCENARIO_FLAG(EV420444) == true )
	//	{
			K7SCR_STG_SET_PATHENABLE( PAT444M00_SHORTCUT420, true );
	//	}else
	//	{
	//		K7SCR_STG_SET_PATHENABLE( PAT444M00_SHORTCUT420, false );
	//	}
		SimpleModelDisp( MDL444M00_SHORTCUT420_LIGHT );
		SimpleModelHide( MDL444M00_SHORTCUT420_DARK );
		EffectFireDisp( GetJObj(MDL444M00_WARP_CANDLE_420), mpEffectFire420 );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040408), false );
	}else
	{
		K7SCR_STG_SET_PATHENABLE( PAT444M00_SHORTCUT420, false );
		SimpleModelHide( MDL444M00_SHORTCUT420_LIGHT );
		SimpleModelDisp( MDL444M00_SHORTCUT420_DARK );
		EffectFireStop( mpEffectFire420 );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040408), true );
	}
	//V[gJbg441
	if( K7SCR_GET_SCENARIO_FLAG(EV444441) == true )
	{
	//	if( K7SCR_GET_SCENARIO_FLAG(EV441444) == true )
	//	{
			K7SCR_STG_SET_PATHENABLE( PAT444M00_SHORTCUT441, true );
	//	}else
	//	{
	//		K7SCR_STG_SET_PATHENABLE( PAT444M00_SHORTCUT441, false );
	//	}
		SimpleModelDisp( MDL444M00_SHORTCUT441_LIGHT );
		SimpleModelHide( MDL444M00_SHORTCUT441_DARK );
		EffectFireDisp( GetJObj(MDL444M00_WARP_CANDLE_441), mpEffectFire441 );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040409), false );
	}else
	{
		K7SCR_STG_SET_PATHENABLE( PAT444M00_SHORTCUT441, false );
		SimpleModelHide( MDL444M00_SHORTCUT441_LIGHT );
		SimpleModelDisp( MDL444M00_SHORTCUT441_DARK );
		EffectFireStop( mpEffectFire441 );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040409), true );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage444M00::SetCurrentCallBack( void )
{
	mWindmillWorking = false;
	
	if( mAmbPlaySE == false )
	{
		KK7SoundLoopSePlayVolumeChange((Vec){-754.839f, 195.216f, -530.604f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE4_AMB_SPARROW);
		KK7SoundLoopSePlayVolumeChange((Vec){-757.023f, 35.387f, -702.017f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE4_AMB_WIND);
		mAmbPlaySE = true;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage444M00::EventCallBack( WK7EventInfo & info )
{
	switch( info.mEventNo )
	{
		//ԂŊJ
		case	K7EVENTNO( 040413 ):
			if( K7SCR_GET_SCENARIO_FLAG(EV040404) == false )
			{
				FixCamMes( CAM444M00_DOOR_WINDMILL, MES444M00_DOOR_CLOSE_WINDMILL );
			}
			break;
		
		//J[pl
		case	K7EVENTNO( 040405 ):
			if( K7SCR_GET_SCENARIO_FLAG(EV040405) == false )
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				//svcȑ`擾Ă邩
				if( K7SCR_GET_SCENARIO_FLAG(EV040401) == false )
				{
					FixCamWithRiddle( CAM444M00_COL_PANEL );
				}else
				{
					//svcȑ`͂߂
					if( K7SCR_GET_SCENARIO_FLAG(EV040405_0) == false )
					{
						K7SCR_SET_SCENARIO_FLAG( EV040405_0 );
						K7SCR_EVSETITEM( K7EVITEM_KEY(040401), false );
						FixCam( CAM444M00_COL_PANEL );
						K7SCR_TIMEWAIT( 2400 );
						gpSound->mPlaySE( SFX_SYS_AKASICITEM_SET );
						SimpleModelDisp( MDL444M00_STRANGE );
						K7SCR_TIMEWAIT( 1200 );
						gpSound->mPlaySE( SFX_SCE4_COLOR_PANEL_OPEN );
						SimplePlayMotionB( MDL444M00_DOOR_PANEL, MOT444M00_DOOR_OPEN_PANELL );
					}
					K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(040405), 0 );
					K7SCR_PANEL_START();
					K7SCR_PANEL_TERMWAIT();
					K7SCR_RETSYS();
					GameInfo.SetPanelNoiseCancel( true );
					K7SCR_PANEL_EXIT();
					K7SCR_PANEL_EXITWAIT();
					GameInfo.SetPanelNoiseCancel( false );
					//inGame~
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					K7SCR_PC_SETVISIBLE( false );
					//plɐ
					if( K7SCR_PANEL_GETRESULT() == 1 )
					{
						K7SCR_SET_SCENARIO_FLAG( EV040405 );
						K7SCR_EVNO_SETENABLE( K7EVENTNO(040405), false );
						K7SCR_PC_SETVISIBLE( true );
						FixCam( CAM444M00_DOOR_TREVER );
						K7SCR_NOISE_RELEASE();
						K7SCR_TIMEWAIT( 1200 );
						gpSound->mPlaySE( SFX_SYS_KEY_USE );
						K7SCR_TIMEWAIT( 4800 );
					}else
					{
						K7SCR_PC_SETVISIBLE( true );
						WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
						K7SCR_NOISE_RELEASE();
					}
				}
				K7SCR_PC_SETVISIBLE( true );
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
			}
			break;
		
		//E\N413
		case	K7EVENTNO( 040407 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			//̎wւ𑕔ĂȂ
			if( K7SCR_EVEQUIPRING(RING_FIRE) == false )
			{
				FixCamWithRiddle( CAM444M00_CANDLE_413 );
			}else
			{
				FixCam( CAM444M00_CANDLE_413 );
				K7SCR_STGC_MESSAGE_B( MES444M00_USE_FIRE_RING );
				EffectFireStart( GetJObj(MDL444M00_WARP_CANDLE_413), mpEffectFire413, CAM444M00_CANDLE_413, GetJObj(MDL444M00_SHORTCUT413_LIGHT), GetJObj(MDL444M00_SHORTCUT413_DARK) );
				K7SCR_SET_SCENARIO_FLAG( EV444413 );
				K7SCR_EVCONDCHANGE();
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
			break;
		
		//E\N420
		case	K7EVENTNO( 040408 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			//̎wւ𑕔ĂȂ
			if( K7SCR_EVEQUIPRING(RING_FIRE) == false )
			{
				FixCamWithRiddle( CAM444M00_CANDLE_420 );
			}else
			{
				FixCam( CAM444M00_CANDLE_420 );
				K7SCR_STGC_MESSAGE_B( MES444M00_USE_FIRE_RING );
				EffectFireStart( GetJObj(MDL444M00_WARP_CANDLE_420), mpEffectFire420, CAM444M00_CANDLE_420, GetJObj(MDL444M00_SHORTCUT420_LIGHT), GetJObj(MDL444M00_SHORTCUT420_DARK) );
				K7SCR_SET_SCENARIO_FLAG( EV444420 );
				K7SCR_EVCONDCHANGE();
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
			break;
		
		//E\N441
		case	K7EVENTNO( 040409 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			//̎wւ𑕔ĂȂ
			if( K7SCR_EVEQUIPRING(RING_FIRE) == false )
			{
				FixCamWithRiddle( CAM444M00_CANDLE_441 );
			}else
			{
				FixCam( CAM444M00_CANDLE_441 );
				K7SCR_STGC_MESSAGE_B( MES444M00_USE_FIRE_RING );
				EffectFireStart( GetJObj(MDL444M00_WARP_CANDLE_441), mpEffectFire441, CAM444M00_CANDLE_441, GetJObj(MDL444M00_SHORTCUT441_LIGHT), GetJObj(MDL444M00_SHORTCUT441_DARK) );
				K7SCR_SET_SCENARIO_FLAG( EV444441 );
				K7SCR_EVCONDCHANGE();
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool
K7Stage444M00::DoorEventCallBack( WK7DoorEventInfo &info )
{
	switch( info.mEventNo )
	{
		//g@[@
		case	K7EVENTDOOR( 040403 ):
			if( K7SCR_GET_SCENARIO_FLAG(EV040405) == false )
			{
				FixCamMes( CAM444M00_DOOR_TREVER, MES444M00_DOOR_CLOSE_TREVER );
				return( false );
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

