////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage511M00
//
// K7Stage511M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE511M00_H__
#define	__K7STAGE511M00_H__

#include ".\K7StageHotelElev.h"

class K7Stage511M00 : public K7StageHotelElev{
	friend class WK7Stage;
protected:
	K7Stage511M00();
	K7Stage511M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage511M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool TerminateCallBack (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
	virtual bool BpLeaveCallBack   (WK7BpInfo        &);
//	virtual bool BpArriveCallBack  (WK7BpInfo        &){ return true; }		// _
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
//	virtual bool HitObjCallBack    (WK7HitObjInfo    &){ return true; }		// qbgIuWF
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &){ return true; }		// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &){ return true; }		// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &){ return true; }		// erCxgiZ[u|Cgj
	virtual bool SpAbilityCallBack (WK7SpAbilityInfo &);

};

#ifdef __K7STAGE511M00_CPP__


enum K7STAGE511M00_ONESHOTCAM{
	EVENT_051101_1,
	EVENT_051101_2,
	EVENT_051101_3,
	EVENT_051101_4,
	ELEVCAM,
	ELEVPLAYER,
};


K7StageEventOneShotCamera K7Stage511M00_Camera[] = {
	{{103.595f, 9.313f, -93.360f},{107.273f, 12.391f, -76.011f}},
	{{97.683f, 13.375f, -92.757f},{92.616f, 16.210f, -84.615f}},
	{{104.282f, 13.375f, -87.125f},{96.393f, 15.666f, -81.423f}},
	{{120.606f, 14.577f, -94.458f},{103.043f, 11.179f, -92.459f}},
	{{-185.472f, 12.539f, -274.599f},{-207.774f, 11.206f, -277.424f}},
	{{-143.179f, 0.0f, -276.492f},{-192.803f, 0.0f, -275.263f}},
};

#endif

#endif	//__K7STAGE511M00_H__

