////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage512M00
//
// K7Stage512M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE512M00_H__
#define	__K7STAGE512M00_H__

#include ".\K7StageHotelElev.h"
#include "..\..\..\Wat\WK7Player.h"
#include "..\..\..\Enm\EnmK.h"

class K7Stage512M00 : public K7StageHotelElev{
	friend class WK7Stage;
protected:
	K7Stage512M00();
	K7Stage512M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	K7EnmK	*pNpcSu;
public:
	virtual ~K7Stage512M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
//	virtual bool TerminateCallBack (void)              { return true; }		// Iȉj
	virtual bool SetCurrentCallBack(void);
//	virtual bool EventCallBack     (WK7EventInfo     &){ return true; }		// Cxg
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool BpLeaveCallBack   (WK7BpInfo        &);
//	virtual bool BpArriveCallBack  (WK7BpInfo        &){ return true; }		// _
	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &);
	virtual bool HitObjCallBack    (WK7HitObjInfo    &);
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &){ return true; }		// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &){ return true; }		// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &){ return true; }		// erCxgiZ[u|Cgj
//	virtual bool SpAbilityCallBack (WK7SpAbilityInfo &);

};

#ifdef __K7STAGE512M00_CPP__

enum K7STAGE512M00_ONESHOTCAM{
	ELEVCAM,
	ELEVPLAYER,
};

K7StageEventOneShotCamera K7Stage512M00_Camera[] = {
	{{-185.472f, 12.539f, -274.599f},{-207.774f, 11.206f, -277.424f}},
	{{-143.179f, 0.0f, -276.492f},{-192.803f, 0.0f, -275.263f}},
};

#endif

#endif	//__K7STAGE512M00_H__

