////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage526M00
//
// K7Stage526M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE526M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage526M00.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"

K7Stage526M00::K7Stage526M00(ghmGcListObj *pAnchor,int prio) : K7StageHotelBase(pAnchor,prio)
{
//	SetOneShotCamLocTbl(K7Stage526M00_Camera);
}

K7Stage526M00::~K7Stage526M00()
{
}

bool K7Stage526M00::CreateCallBack(void)
{
	//LLGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	return true;
}

bool K7Stage526M00::TerminateCallBack(void)
{
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	return true;
}

bool K7Stage526M00::SetCurrentCallBack(void)
{
	gpSound->mSetDspRateAll(20);
	if( GameInfo.GetScenarioFlow()==K7SCNF_HT2 ){
		gpSound->mPlayStreamEx(HPS_HOTEL_B,K7SCR05_HOTEL_ROOM_VOLUME);
	}else{
		gpSound->mPlayStreamEx(HPS_HOTEL_A,K7SCR05_HOTEL_ROOM_VOLUME);
	}
	return false;
}

bool K7Stage526M00::CondChangeCallBack(void)
{
	bool		tamaevflag,evDan;
	InitPath();
	if( GameInfo.GetScenarioFlow()!=K7SCNF_HT2 ){
		evDan = false;
		if( K7SCR_EVHASITEM(K7EVITEM_ZAN(051601))==FALSE || K7SCR_EVHASITEM(K7EVITEM_TAMA(051601))==TRUE ){
			tamaevflag = false;
		}else{
			tamaevflag = true;
		}
	}else{
		tamaevflag = false;
		if( WK7Play::HasPlayed(K7EVENTPLAY(05090702))==true ){
			evDan = false;
			K7SCR_SET_SCENARIO_FLAG( K7SCN05_CGFL_052600 );
		}else{
			evDan = true;
		}
		SetZanEventEnable(K7EVENTZAN(051601),false);
	}
	K7SCR_EVNO_SETENABLE(K7EVENTNO  (050601),evDan);
	K7SCR_EVNO_SETENABLE(K7EVENTTAMA(051601),tamaevflag);
	if( tamaevflag==true ){
		CreateTamaEffect(K7EVENTTAMA(051601));
	}else{
		ReleaseTamaEffect();
	}
//	RenewTamaEffect(K7EVENTTAMA(051601));
	SetVisibleTamaJObj(K7EVENTTAMA(051601),tamaevflag);
	SetVisibleJObj("Bloodstain",GameInfo.GetScenarioFlow()==K7SCNF_HT2,false,true);
	return true;
}

bool K7Stage526M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(050601):
		WK7PlayEventInfo	playEventInfo;
		playEventInfo.Initialize();
		playEventInfo.mEventNo = K7EVENTPLAY(05090702);
		PlayEventTask(playEventInfo);
		return false;
	default:
		break;
	}
	return true;
}

