////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage553M00 ywZz̈
//
// K7Stage553M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 04/17/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE553M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage553M00.h"
#include "..\..\..\Kaw\KK7BattleCtrl.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Yam\YK7MapSelect.h"
#include "..\..\..\Yam\YK7EffectSmokeObj2.h"
#include "..\..\..\Enm\EnmHNG.h"
#include "..\..\..\Wat\WK7Item.h"

//bZ[W
#define	MES553M00_GET_GAL_GUN	(0)				//e擾
#define MES553M00_LOOK_GAL_GUN	(1)				//KVȀe
#define	MES553M00_CON_GAL_GUN	(2)				//CATKVȀe낤Ƃ
#define	MES553M00_CYO_GAL_GUN	(3)				//CYOKVȀe낤Ƃ
#define	MES553M00_DAN_GAL_GUN	(4)				//DANKVȀe낤Ƃ
#define	MES553M00_MSK_GAL_GUN	(5)				//MSKKVȀe낤Ƃ
#define	MES553M00_KVN_GAL_GUN	(6)				//KVNKVȀe낤Ƃ
#define	MES553M00_KED_GAL_GUN	(7)				//KEDKVȀe낤Ƃ
#define	MES553M00_HAY_GAL_GUN	(8)				//HAYKVȀe낤Ƃ
//f
#define	MDL553M00_ANMAKU			"curtain"		//Ö
#define	MDL553M00_GAL_GUN			"SWM29MB"		//KVȀe
#define	MDL553M00_CURTAIN_OPEN_L	"CurtainL1"		//JĂJ[e
#define	MDL553M00_CURTAIN_OPEN_R	"CurtainL2"		//JĂJ[eE
#define	MDL553M00_CURTAIN_CLOSE_L	"CurtainL"		//ĂJ[e
#define	MDL553M00_CURTAIN_CLOSE_R	"CurtainR"		//ĂJ[eE
#define MDL553M00_DOOR				"Door_A4"		//pl̃hA
#define MDL553M00_COLLISION			"Collision"		//Gl~[EH[N
#define MDL553M00_FOOTSE			"footse01"		//w胁bV
#define MDL553M00_LIGHT				"Light"			//Cg
#define MDL553M00_SPOTON			"Fl2"			//X|bgCgL
#define MDL553M00_SPOTOFF			"Fl1"			//X|bgCg
#define MDL553M00_M00				"Stage553_M00"	//Stage553M00
#define MDL553M00_M01				"Stage553_M01"	//Stage553M01
//[V
#define	MOT553M00_ANMAKU_OPEN	(0)				//ÖJ
//pX
#define	PAT553M00_BOSS			"pass01"		//{XppX
#define	PAT553M00_GAL_GUN		"curve6"		//KVȀeւ̃pX
#define	PAT553M00_PANEL			"curve3"		//plւ̃pX




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage553M00::K7Stage553M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage553M00_Camera );
	pNpcHng = NULL;
//	mScnEnd.LoadData();
	GameInfo.SetMenuMapEnable(false);
	GameInfo.SetBossFlag     (true );
	//SĂ̓GoȂtONA
	WK7Npc::NpcPopAllEnable( false );
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage553M00::~K7Stage553M00()
{
//	mScnEnd.Release();
	GameInfo.SetMenuMapEnable(true );
	GameInfo.SetBossFlag     (false);
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage553M00::CreateCallBack( void )
{
	//[Vt@C
	CreateOwnStageMotion( MOT553M00_ANMAKU_OPEN );
	
	return( true );
}
//------------------------------------------------------------------------------
//I
//------------------------------------------------------------------------------
bool
K7Stage553M00::TerminateCallBack( void )
{
	WK7PLAYERCONTROL->ClearGameOver();
	return( true );
}


//------------------------------------------------------------------------------
//iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
//------------------------------------------------------------------------------
bool
K7Stage553M00::InitializeCallBack(void)
{
	// ݂蒷擾
	pNpcHng    = (K7EnmHNG *)WK7Npc::Find(ENENO_HNG);
	mBHSDieNum = 0;
	
	// hA߂
	SimpleModelDisp( MDL553M00_DOOR ) ;
	
	// Â͏Ă
	GetJObj( MDL553M00_M01 )->Hide( false, true ) ;
	GetJObj( MDL553M00_M00 )->GetObj( "Collision" )->Hide( false, true ) ;
	GetJObj( MDL553M00_M00 )->GetObj( "footse01" )->Hide( false, true ) ;

	// CgĂ
	GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_LIGHT )->Hide( false, true ) ;
	GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_SPOTOFF )->Hide( false, true ) ;
	GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_SPOTON )->Hide( false, true ) ;

	return( true );
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage553M00::CondChangeCallBack( void )
{
	//---- Öpl ----
	if( K7SCR_GET_SCENARIO_FLAG(EV055300) == false )
	{	//ÖグĂȂ
		K7SCR_EVNO_SETENABLE( K7EVENTNO(055300), true );	//pl
	//	SimpleSetStartMotion( MDL553M00_ANMAKU, MOT553M00_ANMAKU_OPEN );
		K7SCR_STG_SET_PATHENABLE( PAT553M00_BOSS, false );
		GetJObj( MDL553M00_M00 )->GetObj( MDL553M00_CURTAIN_OPEN_L )->Hide( false, true ) ;
		GetJObj( MDL553M00_M00 )->GetObj( MDL553M00_CURTAIN_OPEN_R )->Hide( false, true ) ;
		GetJObj( MDL553M00_M00 )->GetObj( MDL553M00_CURTAIN_CLOSE_L )->Disp( false, true ) ;
		GetJObj( MDL553M00_M00 )->GetObj( MDL553M00_CURTAIN_CLOSE_R )->Disp( false, true ) ;

		GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_CURTAIN_OPEN_L )->Hide( false, true ) ;
		GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_CURTAIN_OPEN_R )->Hide( false, true ) ;
		GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_CURTAIN_CLOSE_L )->Disp( false, true ) ;
		GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_CURTAIN_CLOSE_R )->Disp( false, true ) ;
	}else
	{	//Öグ
		K7SCR_EVNO_SETENABLE( K7EVENTNO(055300), false );	//plȂ
	//	SimpleSetLastMotion( MDL553M00_ANMAKU, MOT553M00_ANMAKU_OPEN );
		K7SCR_STG_SET_PATHENABLE( PAT553M00_BOSS, true );
		GetJObj( MDL553M00_M00 )->GetObj( MDL553M00_CURTAIN_OPEN_L )->Disp( false, true ) ;
		GetJObj( MDL553M00_M00 )->GetObj( MDL553M00_CURTAIN_OPEN_R )->Disp( false, true ) ;
		GetJObj( MDL553M00_M00 )->GetObj( MDL553M00_CURTAIN_CLOSE_L )->Hide( false, true ) ;
		GetJObj( MDL553M00_M00 )->GetObj( MDL553M00_CURTAIN_CLOSE_R )->Hide( false, true ) ;

		GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_CURTAIN_OPEN_L )->Disp( false, true ) ;
		GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_CURTAIN_OPEN_R )->Disp( false, true ) ;
		GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_CURTAIN_CLOSE_L )->Hide( false, true ) ;
		GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_CURTAIN_CLOSE_R )->Hide( false, true ) ;
		SimpleModelHide( MDL553M00_DOOR );
	}
	
	//---- KVȀe ----
	//{Xe𗎂ƂH
	if( K7SCR_GET_SCENARIO_FLAG(EV055302) == false )
	{
		GetJObj( MDL553M00_M00 )->GetObj( MDL553M00_GAL_GUN )->Hide( false, true ) ;
		GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_GAL_GUN )->Hide( false, true ) ;
		K7SCR_EVNO_SETENABLE( K7EVENTNO(055301), false );
		K7SCR_STG_SET_PATHENABLE( PAT553M00_GAL_GUN, false );
	}else
	{
		//KVAeEH
		if( K7SCR_GET_SCENARIO_FLAG(EV055303) == false )
		{
			GetJObj( MDL553M00_M00 )->GetObj( MDL553M00_GAL_GUN )->Hide( false, true ) ;
			GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_GAL_GUN )->Disp( false, true ) ;
			K7SCR_EVNO_SETENABLE( K7EVENTNO(055301), true );
			K7SCR_STG_SET_PATHENABLE( PAT553M00_GAL_GUN, true );
		}else
		{
			GetJObj( MDL553M00_M00 )->GetObj( MDL553M00_GAL_GUN )->Hide( false, true ) ;
			GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_GAL_GUN )->Hide( false, true ) ;
			K7SCR_EVNO_SETENABLE( K7EVENTNO(055301), false );
			//const char	*pCurrentPathName = WK7PLAYERPATHCONTROL->GetCurrentPathName();
			if( strcmp(WK7PLAYERPATHCONTROL->GetCurrentPathName(),PAT553M00_GAL_GUN) != 0 )
			{
				K7SCR_STG_SET_PATHENABLE( PAT553M00_GAL_GUN, false );
			}
		}
	}
	
	//plH
	if( K7SCR_GET_SCENARIO_FLAG(EV055300) == false )
	{
		K7SCR_STG_SET_PATHENABLE( PAT553M00_PANEL, true );
	}else
	{
		K7SCR_STG_SET_PATHENABLE( PAT553M00_PANEL, false );
	}
	
	//hACxg
	if( K7SCR_GET_SCENARIO_FLAG(EV055301) == false )
	{
		K7SCR_EVNO_SETENABLE( K7EVENTDOOR(055300), false );
	}else
	{
		K7SCR_EVNO_SETENABLE( K7EVENTDOOR(055300), true );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage553M00::SetCurrentCallBack( void )
{
	int i, id, exit = 1;
	WK7Npc	**pNpcBHS;
	
	//ǂJɂȂ܂ő҂
	while( WK7Stage::IsChanging() != false )
	{
		K7SCR_RETSYS();
	}
	
	//ÖJ܂Ń{X͎n܂Ȃ
	gpSound->mPlayStreamEx( HPS_SCHOOL_F );
	while( K7SCR_GET_SCENARIO_FLAG(EV055300) == false )
	{
		K7SCR_RETSYS();
		if( (WK7Stage::GetCurrentStage() == NULL)						//Xe[W܂
		 ||	(WK7Stage::GetCurrentStage()->GetID()!=K7STGID(553,0)) )	//Xe[WύX
		{
			return( true );
		}
	}
	
	//{XJn炵

	/// LA
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_BOSSBATTLE);
	
	gpSound->mPlayStreamEx( HPS_BOSS_CHO );
	while( exit )
	{
		//{X
		if ( pNpcHng != NULL )
		{
			pNpcHng->StageProc(WK7Stage::GetCurrentStage());
			//e𗎂Ƃ`FbN
			if( (pNpcHng->GetGunOtosiState() == true) && (K7SCR_GET_SCENARIO_FLAG(EV055302) == false) )
			{
				//e𗎂ƂtOON
				K7SCR_SET_SCENARIO_FLAG( EV055302 );
				K7SCR_EVCONDCHANGE();
				
				// Cg
				GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_LIGHT )->Disp( false, true ) ;
				GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_SPOTON )->Disp( false, true ) ;
				GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_SPOTOFF )->Hide( false, true ) ;
				
				//ubNHSo
				id         = ENENO_5_553M00_BLHS_0;
				pNpcBHS    = mpNpcBHS;
				for( i = 0; i < STG553M00_BHS_NUM; i++, id++, pNpcBHS++ )
				{
					*pNpcBHS = WK7Npc::Find( (u32)id );
/*					if( NULL != *pNpcBHS )
					{
						if( (*pNpcBHS)->AiModeSet_TestPop() == true )
						{
							(*pNpcBHS)->AiModeSet_PopGo();
						}
					}
*/					//CG͈͂傫
					if( i == 0 )
					{
						(*pNpcBHS)->SetSakuteki( 2000.0f );
					}else
					{
						(*pNpcBHS)->SetSakuteki( 0.0f );
					}
				}

				// eCxg
				{
					//ogIB
					KK7BattleMainTask::BattleMainTaskExit(2);
					K7SCR_RETSYS() ;
					
					//inGame~
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					K7SCR_PC_SETVISIBLE( false );
					FixCamMes( CAM553M00_GAL_GUN2, MES553M00_LOOK_GAL_GUN );
					//inGameĊJ
					K7SCR_EXIT_PLAYMODE();
					K7SCR_EXIT_DEMOPAUSE();
					K7SCR_PC_SETVISIBLE( true );
				}
			}
		}
		
		//ubNHS KVȀeES
		if( K7SCR_GET_SCENARIO_FLAG(EV055303) == true )
		{
			id      = ENENO_5_553M00_BLHS_0;
			pNpcBHS = mpNpcBHS;
			for( i = 0; i < STG553M00_BHS_NUM; i++, id++, pNpcBHS++ )
			{
				*pNpcBHS = WK7Npc::Find( (u32)id );
				(*pNpcBHS)->SetSakuteki( 2000.0f );
			}
		}
		//ubNHSSłĎ
		if( mBHSDieNum == STG553M00_BHS_NUM )
		{
			pNpcHng->SetBarrierFlag( false );
		}
		
		K7SCR_RETSYS();
		
		//{XI`FbN
		pNpcHng = (K7EnmHNG *)WK7Npc::Find(ENENO_HNG) ;
		if ( pNpcHng != NULL )
		{
			if (
			 (WK7Stage::GetCurrentStage() == NULL)						//Xe[W܂
			 ||	(WK7Stage::GetCurrentStage()->GetID()!=K7STGID(553,0))	//Xe[WύX
			 || (0 != pNpcHng->HNGBossEnd())
			  )							//{XI
			{
				/// LANA
				WK7PLAYERCONTROL->BattlePadRegulationSet();
			
				//{XS=wZNAtO𗧂Ă
				if( pNpcHng != NULL && 0 != pNpcHng->HNGBossEnd() )
				{
					gpSound->mPlayStreamEx( HPS_SCHOOL_F );
					K7SCR_SET_SCENARIO_FLAG( EV055301 );
					K7SCR_EVCONDCHANGE();
					
					// WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
				}
				//vC[񂾂ƂɎ̃vC[ݒ肵Ȃ
				WK7PLAYERCONTROL->ClearGameOver();
				exit = 0;
			}
		}else
		{
			exit = 0;
		}
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//L`FW
//------------------------------------------------------------------------------
bool
K7Stage553M00::CharaChangeCallBack( WK7CharaChangeInfo &info )
{
#pragma	unused(info)
//	mSetAlivePc();
	WK7PLAYERCONTROL->SetGameOver( PC_GAMEOVER_HNGBATTLE, mGetNextAlivePc(K7CHR_MAINID(info.mCurrCharaID)) );
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage553M00::EventCallBack( WK7EventInfo &info )
{
	switch( info.mEventNo )
	{
		case	K7EVENTNO( 055300 ):
			if( K7SCR_GET_SCENARIO_FLAG(EV055300) == false )
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				//Öpl
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(055300), 0 );
				K7SCR_PANEL_START();
				K7SCR_PANEL_TERMWAIT();
				K7SCR_RETSYS();
				GameInfo.SetPanelNoiseCancel( true );
				K7SCR_PANEL_EXIT();
				K7SCR_PANEL_EXITWAIT();
				GameInfo.SetPanelNoiseCancel( false );
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				//KVAɃL`FW
				if( WK7PLAYERCONTROL->GetMainID() != K7GAL )
				{
					//vC[ړ
					SetCurrentPath(	GetPathNurbsAll("curve4"),
									1.000f,
									0,									// 0:forward 1:back
									WK7PATHINFO_INITDIR_TGTDIR );		// :WK7PATHINFO_INITDIR_TGTDIR wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
					FixCam( CAM553M00_WATCHCAMERA );
					K7SCR_NOISE_RELEASE();
					K7SCR_TIMEWAIT( 4800 * 2 );
					WatchCameraB( K7Stage553M00_Camera[CAM553M00_PLAYER].tgt,
								  K7Stage553M00_Camera[CAM553M00_PLAYER].pos,
								  K7CHRID(K7GAL,0), 1 );
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					//LĐ
					K7SCR_NOISE_REQUEST();
				}
				//LĐ
				WK7Play*	pPlay;
				u32			playno;
				WK7Play::SetTermCaptureRenderOn(true);
				playno = K7EVENTPLAY(05080202);
				K7SCR_CHARAGEKI_PREPARE( playno );
				K7SCR_NOISE_RELEASE();
				//LĐ
				K7SCR_CHARAGEKI_END_WAIT( playno );
				pPlay = WK7Play::Find( playno );
				pPlay->SetVisibleAll( false );
				K7SCR_RETSYS();
				K7SCR_RETSYS();
				GHM_SAFE_DELETE( pPlay );
				K7SCR_RETSYS();
				K7SCR_RETSYS();
				WK7Play::SetPlayed( playno, true );
				K7SCR_BLACK_FADEOUT();
				//LĐ2
				WK7Play::SetInitCaptureRenderOff(true);
				WK7Play::SetTermCaptureRenderOn (false);
				//L
				playno = K7EVENTPLAY(05500301);
				while( (pPlay=WK7Play::Create(playno)) == NULL ){ K7SCR_RETSYS(); }
				pPlay->Prepare();
				while( pPlay->GetState() != WK7Play::PREPARED ){ K7SCR_RETSYS(); }
				pPlay->Start();
				K7SCR_RETSYS();
				K7SCR_BLACK_FADEIN();
				//LI҂
				while( pPlay->GetState() != WK7Play::PLAYED ){ K7SCR_RETSYS(); }
				K7SCR_NOISE_REQUEST();
				WK7Play::SetInitCaptureRenderOff(false);
				//LI
				pPlay->SetVisibleAll( false );
				K7SCR_RETSYS();
				K7SCR_RETSYS();
				GHM_SAFE_DELETE( pPlay );
				WK7Play::SetPlayed( playno, true );
#if	0
				WK7Play::PlayTB( K7EVENTPLAY(05500301) );
				K7SCR_NOISE_REQUEST();
#endif
				//ÖグtOON
				K7SCR_SET_SCENARIO_FLAG( EV055300 );
				K7SCR_EVCONDCHANGE();
				// Xe[Wf̃`FW
				GetJObj( MDL553M00_M01 )->Disp( false, true ) ;
				GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_CURTAIN_OPEN_L )->Disp( false, true ) ;
				GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_CURTAIN_OPEN_R )->Disp( false, true ) ;
				GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_CURTAIN_CLOSE_L )->Hide( false, true ) ;
				GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_CURTAIN_CLOSE_R )->Hide( false, true ) ;
				GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_COLLISION )->Hide( false, true ) ;
				GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_FOOTSE )->Hide( false, true ) ;
				GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_SPOTOFF )->Disp( false, true ) ;
				GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_SPOTON )->Hide( false, true ) ;
				GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_LIGHT )->Hide( false, true ) ;
				GetJObj( MDL553M00_M01 )->GetObj( MDL553M00_GAL_GUN )->Hide( false, true ) ;
				GetJObj( MDL553M00_M00 )->Hide( false, true ) ;
				// Xe[WOɈړ
				SetCurrentPath(GetPathNurbsAll("pass01"),
				               1.0000f,
				               0,									// 0:forward 1:back
				               WK7PATHINFO_INITDIR_TGTDIR_REV );	// : wォ:WK7PATHINFO_INITDIR_TGTDIR_REV0
				WK7Play::RestorePlayTB();
				FixCam( CAM553M00_WATCHCAMERA2 );
				K7SCR_NOISE_RELEASE();
				//KVAȊÕLɃ`FW
				K7SCR_PC_SETVISIBLE( true );
				K7SCR_TIMEWAIT( 4800 * 2 );
				//ĂvC[ɐݒ肷(ł邾KVAȊO)
				WatchCameraB( K7Stage553M00_Camera[CAM553M00_PLAYER2].tgt,
							  K7Stage553M00_Camera[CAM553M00_PLAYER2].pos,
							  mSetAlivePc(), 1 );
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
//				GameInfo.SetMode(WK7GameInfo::MOVECAM);
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
				pNpcHng->BattleStart() ;
//				WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//				WK7CAM->SetPosition      (K7Stage553M00_Camera[CAM553M00_BHS].pos);
//				WK7CAM->SetTargetPosition(K7Stage553M00_Camera[CAM553M00_BHS].tgt);
			}
			break;
		
		//KVȀe
		case	K7EVENTNO( 055301 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			//KVAH
			if( WK7PLAYERCONTROL->GetMainID() == K7GAL )
			{
				FixCam( CAM553M00_GAL_GUN );
				K7SCR_TIMEWAIT( 4800 * 2 );
				//bZ[W\
				K7SCR_STG_ITEMGET( MES553M00_GET_GAL_GUN );
				K7SCR_STG_ITEMGET_NOTDISPLAYED_B( MES553M00_GET_GAL_GUN );
				SimpleModelHide( MDL553M00_GAL_GUN );
				
				WK7PLAYERCONTROL->ReleaseArchive();
				while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
					K7SCR_RETSYS();
				}
				BattleCtrl.GalPowerUp();
				WK7PLAYERCONTROL->RestoreArchive();
				while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::LOADED ){
					K7SCR_RETSYS();
				}
				K7SCR_SET_SCENARIO_FLAG( EV055303 );
				K7SCR_EVNO_SETENABLE( K7EVENTNO(055301), false );
				K7SCR_PC_SETVISIBLE( true );
				pNpcHng->SetNewGunFlag() ;
				SetCurrentPath(	GetPathNurbsAll(PAT553M00_GAL_GUN),
								1.000f,
								0,									// 0:forward 1:back
								WK7PATHINFO_INITDIR_TGTDIR );		// : wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
				WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
				//bZ[W\EGCg
				K7SCR_STG_ITEMGET_VALID_B( MES553M00_GET_GAL_GUN );
			}else
			{
				switch( WK7PLAYERCONTROL->GetMainID() )
				{
				case K7CON : FixCamMes( CAM553M00_GAL_GUN, MES553M00_CON_GAL_GUN ); break ;
				case K7CYO : FixCamMes( CAM553M00_GAL_GUN, MES553M00_CYO_GAL_GUN ); break ;
				case K7DAN : FixCamMes( CAM553M00_GAL_GUN, MES553M00_DAN_GAL_GUN ); break ;
				case K7MSK : FixCamMes( CAM553M00_GAL_GUN, MES553M00_MSK_GAL_GUN ); break ;
				case K7KVN : FixCamMes( CAM553M00_GAL_GUN, MES553M00_KVN_GAL_GUN ); break ;
				case K7KED : FixCamMes( CAM553M00_GAL_GUN, MES553M00_KED_GAL_GUN ); break ;
				case K7HAY : FixCamMes( CAM553M00_GAL_GUN, MES553M00_HAY_GAL_GUN ); break ;
				}
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool
K7Stage553M00::DoorEventCallBack( WK7DoorEventInfo &info )
{
	switch( info.mEventNo )
	{
		//ُ̈o
		case	K7EVENTDOOR( 055300 ):
			//{X|Ă玟ViI
			if( K7SCR_GET_SCENARIO_FLAG(EV055301) == true )
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				
				// ̃Gl~[nEg̒ǉ
				BattleCtrl.IncTotalEnemyHunt(1);
				
//				K7SCR_CHANGE_SCENARIO_DATA();		// hACxgōsȂ
				//---- KVẢƂ ----
				//}bvړ
				K7SCR_NOISE_REQUEST();
				gpSound->mFadeVolumeStream( 0, 80 );
				K7SCR_TIMEWAIT( 2400 );
				//Xe[W\
				K7SCR_STG_VISIBLE( K7STGID(553,0), false );
				K7SCR_PC_VISIBLE( false );
				K7SCR_NOISE_RELEASE();
				//ViII
//				mScnEnd.FrameProcess();
				k7app.FadeStart( 0, 1 );
				K7SCR_RETSYS();
				K7SCR_MOON_START2();
				K7SCR_MOON_WAIT();
				//ViIֈڍs
				GameInfo.SetScenarioFlow( K7SCNF_HT2 );
				//}bvړʕ`
//				GameInfo.MapSelectInit( MAP_SCHOOL, MAP_GAL_HOME );
//				while( GameInfo.CheckMapSelectEnd() == false )
//				{
////					MapSelectFrameProcess();
////					MapSelectRenderProcess();
//					K7SCR_RETSYS();
//				}
//				GameInfo.MapSelectEnd();
				//KVẢƂ
				info.mNextStageID = K7STGID( 120, 0 );
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//GS
//------------------------------------------------------------------------------
bool
K7Stage553M00::DieNpcCallBack( WK7DieNpcInfo &info )
{
	if( info.mpNpc==NULL )
	{
		return true;
	}
	
	switch( info.mpNpc->GetEneNo() )
	{
		//{XS
		case	ENENO_HNG:
			//ȍĐ
			gpSound->mPlayStreamNo( HPS_SAFE_PLACE );
			//{XStOON
			K7SCR_SET_SCENARIO_FLAG( EV055301 );
			break;
		
		//ubNHS
		case	ENENO_5_553M00_BLHS_0:
			mpNpcBHS[1]->SetSakuteki( 2000.0f );
			mBHSDieNum++;
			break;
		case	ENENO_5_553M00_BLHS_1:
			mpNpcBHS[2]->SetSakuteki( 2000.0f );
			mBHSDieNum++;
			break;
		case	ENENO_5_553M00_BLHS_2:
			mpNpcBHS[3]->SetSakuteki( 2000.0f );
			mBHSDieNum++;
			break;
		case	ENENO_5_553M00_BLHS_3:
			mpNpcBHS[4]->SetSakuteki( 2000.0f );
			mBHSDieNum++;
			break;
		case	ENENO_5_553M00_BLHS_4:
			mpNpcBHS[5]->SetSakuteki( 2000.0f );
			mBHSDieNum++;
			break;
		case	ENENO_5_553M00_BLHS_5:
			mpNpcBHS[6]->SetSakuteki( 2000.0f );
			mBHSDieNum++;
			break;
		case	ENENO_5_553M00_BLHS_6:
			mBHSDieNum++;
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//ĂvC[ݒ肷
//------------------------------------------------------------------------------
u32
K7Stage553M00::mSetAlivePc( void )
{
	u32	pcID;
	
	if( BattleCtrl.PcDieTest( K7DAN ) == false )
	{
		pcID = K7CHRID( K7DAN, 0 );
		WK7PLAYERCONTROL->SetGameOver( PC_GAMEOVER_HNGBATTLE, mGetNextAlivePc(K7DAN) );
	}else
	if( BattleCtrl.PcDieTest( K7KED ) == false )
	{
		pcID = K7CHRID( K7KED, 0 );
		WK7PLAYERCONTROL->SetGameOver( PC_GAMEOVER_HNGBATTLE, mGetNextAlivePc(K7KED) );
	}else
	if( BattleCtrl.PcDieTest( K7KVN ) == false )
	{
		pcID = K7CHRID( K7KVN, 0 );
		WK7PLAYERCONTROL->SetGameOver( PC_GAMEOVER_HNGBATTLE, mGetNextAlivePc(K7KVN) );
	}else
	if( BattleCtrl.PcDieTest( K7CYO ) == false )
	{
		pcID = K7CHRID( K7CYO, 0 );
		WK7PLAYERCONTROL->SetGameOver( PC_GAMEOVER_HNGBATTLE, mGetNextAlivePc(K7CYO) );
	}else
	if( BattleCtrl.PcDieTest( K7CAT ) == false )
	{
		pcID = K7CHRID( K7CAT, 0 );
		WK7PLAYERCONTROL->SetGameOver( PC_GAMEOVER_HNGBATTLE, mGetNextAlivePc(K7CAT) );
	}else
	if( BattleCtrl.PcDieTest( K7MSK ) == false )
	{
		pcID = K7CHRID( K7MSK, 0 );
		WK7PLAYERCONTROL->SetGameOver( PC_GAMEOVER_HNGBATTLE, mGetNextAlivePc(K7MSK) );
	}else
	if( (BattleCtrl.PcDieTest(K7HAY) == false) && (K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1) == true) )
	{
		pcID = K7CHRID( K7HAY, 0 );
		WK7PLAYERCONTROL->SetGameOver( PC_GAMEOVER_HNGBATTLE, mGetNextAlivePc(K7HAY) );
	}else
	if( BattleCtrl.PcDieTest( K7GAL ) == false )
	{
		pcID = K7CHRID( K7GAL, 0 );
		WK7PLAYERCONTROL->ClearGameOver();		
	}
	
	return( pcID );
}
//------------------------------------------------------------------------------
//ɐĂvC[ݒ肷
//------------------------------------------------------------------------------
u32
K7Stage553M00::mGetNextAlivePc( u32 inPcID )
{
	u32	pcID;
	
	if( (inPcID != K7DAN) && (BattleCtrl.PcDieTest(K7DAN) == false) )
	{
		pcID = K7CHRID( K7DAN, 0 );
	}else
	if( (inPcID != K7KED) && (BattleCtrl.PcDieTest(K7KED) == false) )
	{
		pcID = K7CHRID( K7KED, 0 );
	}else
	if( (inPcID != K7KVN) && (BattleCtrl.PcDieTest(K7KVN) == false) )
	{
		pcID = K7CHRID( K7KVN, 0 );
	}else
	if( (inPcID != K7CYO) && (BattleCtrl.PcDieTest(K7CYO) == false) )
	{
		pcID = K7CHRID( K7CYO, 0 );
	}else
	if( (inPcID != K7CAT) && (BattleCtrl.PcDieTest(K7CAT) == false) )
	{
		pcID = K7CHRID( K7CAT, 0 );
	}else
	if( (inPcID != K7MSK) && (BattleCtrl.PcDieTest(K7MSK) == false) )
	{
		pcID = K7CHRID( K7MSK, 0 );
	}else
	if( (inPcID != K7HAY) && (BattleCtrl.PcDieTest(K7HAY) == false) && (K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1) == true) )
	{
		pcID = K7CHRID( K7HAY, 0 );
	}else
	{
		pcID = K7CHRID( K7GAL, 0 );
		WK7PLAYERCONTROL->ClearGameOver();		
	}
	
	return( pcID );
#if	0
	switch( inPcID )
	{
		case	K7DAN:
			if( BattleCtrl.PcDieTest( K7KED ) == false )
			{
				pcID = K7CHRID( K7KED, 0 );
				break;
			}
		case	K7KED:
			if( BattleCtrl.PcDieTest( K7KVN ) == false )
			{
				pcID = K7CHRID( K7KVN, 0 );
				break;
			}
		case	K7KVN:
			if( BattleCtrl.PcDieTest( K7CYO ) == false )
			{
				pcID = K7CHRID( K7CYO, 0 );
				break;
			}
		case	K7CYO:
			if( BattleCtrl.PcDieTest( K7CAT ) == false )
			{
				pcID = K7CHRID( K7CAT, 0 );
				break;
			}
		case	K7CAT:
			if( BattleCtrl.PcDieTest( K7MSK ) == false )
			{
				pcID = K7CHRID( K7MSK, 0 );
				break;
			}
		case	K7MSK:
			pcID = K7CHRID( K7GAL, 0 );
			break;
		
		default:
			pcID = K7CHRID( K7GAL, 0 );
			break;
	}
	
	return( pcID );
#endif
}
