////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage557M00 ywZz}
//
// K7Stage557M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 04/17/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE557M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage557M00.h"
#include "..\..\..\Wat\WK7CharaPresent.h"

//pX
#define	PAT557M00_INNER		"K7_pass00"	//HS|ɒʉ߂ł
#define	PAT557M00_RETURN	"K7_pass01"	//KiO߂
#define	PAT557M00_ADVANCE	"K7_pass02"	//KiOi
#define	PAT557M00_ENTRANCE	"K7_pass03"	//
//bZ[W
#define	MES557M00_GET_TAPE	(0)			//e[vɓꂽ
//f
#define	MDL557M00_TAPE		"Tape"		//e[v




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage557M00::K7Stage557M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage557M00_Camera );
	GameInfo.SetMenuMapEnable(false);
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage557M00::~K7Stage557M00()
{
	GameInfo.SetMenuMapEnable(true);
	GameInfo.SetBossFlag(false);
	WK7PLAYERCONTROL->BattlePadRegulationClear();
}

bool K7Stage557M00::InitializeCallBack(void)
{
	if( WK7Npc::GetEnemyDieTest(K7STAGE557M00_KIHAN_HS)==false ){
		// LnX}C͐Ă	}jAu`ݒ
		SetManualBranch( true );
	}
	return true;
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage557M00::CondChangeCallBack( void )
{
	//߂̃pX͋
	K7SCR_STG_SET_PATHENABLE( PAT557M00_ENTRANCE, false );
	//LnHS|Ă邩
	if( K7SCR_GET_SCENARIO_FLAG(EV055710) == false )
	{	//|ĂȂ
		K7SCR_STG_SET_PATHENABLE( PAT557M00_INNER, false );		//pX
	}else
	{	//|Ă
		K7SCR_STG_SET_PATHENABLE( PAT557M00_INNER, true );		//pX
	}
	
	//e[v
	if( K7SCR_GET_SCENARIO_FLAG(VRTAPE09) == false )
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(055705), true );
		SimpleModelDisp( MDL557M00_TAPE );
		K7SCR_STG_SET_PATHENABLE( PAT557M00_RETURN, true );
		K7SCR_STG_SET_PATHENABLE( PAT557M00_ADVANCE, false );
	}else
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(055705), false );
		SimpleModelHide( MDL557M00_TAPE );
		K7SCR_STG_SET_PATHENABLE( PAT557M00_RETURN, false );
		K7SCR_STG_SET_PATHENABLE( PAT557M00_ADVANCE, true );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage557M00::SetCurrentCallBack( void )
{
	K7EnmGYA *pEnemy = (K7EnmGYA *)WK7Npc::Find( K7STAGE557M00_KIHAN_HS );
	
	if( WK7Npc::GetEnemyDieTest(K7STAGE557M00_KIHAN_HS)==true ){
		//ȍĐ
		gpSound->mPlayStreamNo( HPS_SPEED_HS );
		return true;
	}else{
		/// LA
		WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_BOSSBATTLE);
	}
	
	GameInfo.SetBossFlag(true);
	
	//G`FbN
	if( pEnemy != NULL ){
		
		WK7Stage::SetCurrentPath(	WK7Stage::GetPathNurbsAll("curve2"),
									0.431f,
									0,									// Forward
	//								WK7PATHINFO_INITDIR_TGTDIR			// 
									WK7PATHINFO_INITDIR_TGTDIR_REV		// wォ
		);
		SetCameraStartPosition();

		while( pEnemy->GetNpcState() == NPC_STATE_INIT ){
			K7SCR_RETSYS();
		}
		
		// ~TC_[IDU
		pEnemy->HitObjMake(WK7Stage::GetCurrentStage());
		
		// ȍĐ
		gpSound->mPlayStreamNo( HPS_SPEED_HS );
		
		while( WK7Stage::IsChanging() != false ){
			K7SCR_RETSYS();
		}
		
		
		//inGame~
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_KIHAN_GAKO) == false ){
			K7SCR_SET_SCENARIO_FLAG(K7SCN05_KIHAN_GAKO);
			
			// Ln叉߂
			
			KihanDemoFirst(pEnemy, CAM557M00HSINIT, CAM557M00HSTERM, 0,  95,  377,-177,  80,1043, 291,
			1	);
			
		}else{
			
			// LnQڈȍ~
			
			KihanDemo(K7STAGE557M00_KIHAN_HS, CAM557M00HSTERM);
			
		}
		
		// {XsJn
		while( pEnemy->KihanBoss_AiRun() == false ){
			K7SCR_RETSYS();
		}
		
		K7SCR_PC_SETVISIBLE(true);
		SetCameraStartPosition(WK7Stage::GetCurrentStageBpName());
		//JPCtH[ɖ߂
		WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
		
		K7SCR_RETSYS();
		K7SCR_CHARAPRESENT_DEBUGEND();
		K7SCR_TIMEWAIT(K7SCR_CP_RELEASETIME);
		
		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
	}

	// }jAu`NA
	SetManualBranch( false );

	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage557M00::EventCallBack( WK7EventInfo &info )
{
	switch( info.mEventNo )
	{
		//e[v
		case	K7EVENTNO( 055705 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			//e[v擾
			FixCam( CAM557M00_TAPE );
			K7SCR_TIMEWAIT( 4800 );
			SimpleItemGetMes( MES557M00_GET_TAPE, MDL557M00_TAPE, true );
			K7SCR_SET_SCENARIO_FLAG( VRTAPE09 );
			K7SCR_EVCONDCHANGE();
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//GS
//------------------------------------------------------------------------------
bool
K7Stage557M00::DieNpcCallBack( WK7DieNpcInfo &info )
{
	if( info.mpNpc==NULL )
	{
		return true;
	}
	
	switch( info.mpNpc->GetEneNo() )
	{
		//LnHS|
		case	K7STAGE557M00_KIHAN_HS:
			if ( info.mpNpc->GetDieMode() != NPC_DIE_JIBAKU ){
				//gpSound->mPlayStreamNo( HPS_SCHOOL_E );
			}
			GameInfo.SetBossFlag(false);
			K7SCR_SET_SCENARIO_FLAG( EV055710 );
			K7SCR_EVCONDCHANGE();
			//SĂ̓GoȂ
			WK7Npc::NpcPopAllEnable( true );
			break;
		
		default:
			break;
	}
	
	return( true );
}


/*
	
	
	{X퐧pɎgp
	
	
*/
bool K7Stage557M00::HitObjCallBack(WK7HitObjInfo &info)
{
	K7EnmGYA *pEnemy = (K7EnmGYA *)WK7Npc::Find( ENENO_5_557M00_1 );
	
	// ~TCj
	if ( pEnemy != NULL ){
		if( (info.mEventNo >= 0) && (info.mEventNo < 8) ){
			pEnemy->MissileBroken((int )info.mEventNo);
			
			// qbgIuWF𕜊
//			info.mpHitObj->SetEnable(true);
			info.SetHitObjEnable(true);
			return false;
		}
	}
	return true;
}



