////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage560M00 ywZzH
//
// K7Stage560M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 04/17/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE560M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage560M00.h"

//pX
#define	PAT560M00_EXIT_1	"HSpass01"		//HS̑|ʉ߂łpX
#define	PAT560M00_EXIT_2	"HSpass02"		//HS̑|ʉ߂łpX




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage560M00::K7Stage560M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	pNpcSu = NULL;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage560M00::~K7Stage560M00()
{
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage560M00::CondChangeCallBack( void )
{
	//HS̑|
	if( K7SCR_GET_SCENARIO_FLAG(EV056000) == false )
	{	//ʉ߂ĂȂ
		K7SCR_STG_SET_PATHENABLE( PAT560M00_EXIT_1, false );	//pX
		K7SCR_STG_SET_PATHENABLE( PAT560M00_EXIT_2, false );	//pX
	}else
	{	//ʉ߂
		K7SCR_STG_SET_PATHENABLE( PAT560M00_EXIT_1, true );		//pX
		K7SCR_STG_SET_PATHENABLE( PAT560M00_EXIT_2, true );		//pX
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
// ̐ݒ
#define CORE_NUM	(7)
bool
K7Stage560M00::SetCurrentCallBack( void )
{
	pNpcSu = (K7EnmK *)WK7Npc::Find(ENENO_5_560M00_1);
	
	//HS̑|
	if( K7SCR_GET_SCENARIO_FLAG(EV056000) == false )
	{	//ʉ߂ĂȂ
		gpSound->mPlayStreamEx( HPS_BUNSIN_M );
	}else
	{	//ʉ߂
		gpSound->mPlayStreamEx( HPS_SCHOOL_C );
	}
	
	if ( pNpcSu != NULL ) {
		while( pNpcSu->SetUpTest()==false ){
			K7SCR_RETSYS();
		}
		pNpcSu->HitObjMake(WK7Stage::GetCurrentStage(), CORE_NUM);
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//GS
//------------------------------------------------------------------------------
bool
K7Stage560M00::DieNpcCallBack( WK7DieNpcInfo &info )
{
	if( info.mpNpc==NULL )
	{
		return true;
	}
	
	switch( info.mpNpc->GetEneNo() )
	{
		//HSj
		case	ENENO_5_560M00_1:
			K7SCR_SET_SCENARIO_FLAG( EV056000 );
			K7SCR_EVCONDCHANGE();
			gpSound->mPlayStreamEx( HPS_SCHOOL_C );
			break;
		
		default:
			break;
	}
	
	return( true );
}

bool K7Stage560M00::HitObjCallBack(WK7HitObjInfo &info)
{
	if ( pNpcSu != NULL ) {
		if( (info.mEventNo >= pNpcSu->GetHitObjID()) && (info.mEventNo < (pNpcSu->GetHitObjID()+CORE_NUM) ) ){
			if ( false == pNpcSu->CoreHit((int )info.mEventNo, info.mTypeID, info.mHitPos) ) {
				// RAj󂵂ĂȂ
				// qbgIuWF𕜊
//				info.mpHitObj->SetEnable(true);
				info.SetHitObjEnable(true);
			}
			return false;
		}
	}
	return true;
}




