////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage121M01 yKVA@zn[}
//
// K7Stage121M01.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/11/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE121M01_CPP__

#include "..\..\..\Scn\K7Scn06.h"
#include ".\K7Stage121M01.h"
#include "..\Wat\WK7SceneBlur.h"
#include "..\Wat\WK7Chara.h"
#include "..\Wat\WK7Item.h"
#include "..\Matsu\MK7Noise.h"
#include "..\Yam\YK7CharChange.h"
#include "..\Kaw\KK7BattleCtrl.h"
#include "..\Kaw\KK7Sound.h"

//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage121M01::K7Stage121M01(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage121M01_Camera);
	mStageInit = false;
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_KAMAE_NO);
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_NO_MANUALRELOAD);
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage121M01::~K7Stage121M01()
{
	GameInfo.SetItemEnable(true);
	GameInfo.SetSpecialEnable(true);
	GameInfo.SetMenuMapEnable(true );
	WK7PLAYERCONTROL->BattlePadRegulationClear();
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool K7Stage121M01::CondChangeCallBack(void)
{
	K7SCR_EVNO_SETENABLE(K7EVENTNO(992100),false);
	bool	sw;
	if( WK7Stage::GetHarmanTvFlag(K7STGID(121,1),0)==true ){
		sw = true;
	}else{
		sw = false;
	}
	SetVisibleJObj("Display_ON" , sw,false,true);
	SetVisibleJObj("Display_OFF",!sw,false,true);
	return true;
}

bool K7Stage121M01::SetCurrentCallBack(void)
{
	SetCurrentCallBackDefaultProc();
	GameInfo.SetItemEnable(false);
	GameInfo.SetSpecialEnable(false);
	GameInfo.SetMenuMapEnable(false);
	if( mStageInit==false ){
		if( GetPrevStageID()==WK7STAGE_GALSTAGEID ){
			SetManualBranch(true);
			while( WK7Stage::IsChanging()==true ){
				K7SCR_RETSYS();
			}
			SetManualBranch(false);
			WK7StagePlaceInfo		*pPlaceInfo;
			int						seNo;
			pPlaceInfo = GetPlaceInfo(WK7Stage::GetCurrentStageBpName());
			SetOrigPathCamera(WK7PLAYERPATHCONTROL->GetCurrentPathName());
			if( GetPrevStageID() == K7STGID(120,0) ){
				seNo = SFX_SYS_MAP_CHANGE_HACROOM_DEFOUT;
			}else{
				seNo = SFX_SCE6_MAP_CHANGE_DOOR_IRON_CLOSE;
			}
			while( SandRelease(pPlaceInfo,seNo)==false ){
				K7SCR_RETSYS();
			}
		}
		mStageInit = true;
	}
	
	LOOPSE2	*pLoopSE = NULL;
	if( WK7Stage::GetHarmanTvFlag(K7STGID(121,1),0)==true ){
		pLoopSE = KK7SoundLoopSePlayVolumeChange2((Vec){-33.420f, 9.563f, -4.364f},
		                                          mID,
		                                          SFX_SYS_TV_WHITENOIZ,
		                                          192,		// SOUND_EVENT_SE_VOLUME=255
		                                          32,
		                                          200.0f,
		                                          8.0f);
	}
	
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		TvNoise();
		K7SCR_RETSYS();
	}
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	while( WK7RenderObj::IsValid(this)==true && GetState()==LOADED ){
		TvNoise();
		K7SCR_RETSYS();
	}
	
	if( WK7RenderObj::IsValid(this)==true && pLoopSE!=NULL ){
		pLoopSE->taskEnd = -1;
	}
	
	return false;
}

bool K7Stage121M01::TvEventCallBack(WK7TvEventInfo &info)
{
	bool	blurVisible = SceneBlur.GetVisible();
	bool	result = false;
	
	info.SetSelectObjEnable(true);
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed)==false ){
		K7SCR_RETSYS();
	}
	
	GHMGCTASK_RETSYS();
	GHMGCTASK_RETSYS();
	
	while( WK7Stage::ReleaseStageArchive()==false ){
		GHMGCTASK_RETSYS();
	}
	
	while( WK7Stage::IsReleasedStageArchive()==false ){
		GHMGCTASK_RETSYS();
	}
	
//	BattleCtrl.PcReCallSet (K7HAC, 0);
//	
//	ClearChangeChara();
//	SetChangeChara(K7DAN,false);
//	SetChangeChara(K7GAL,false);
//	SetChangeChara(K7CON,false);
//	SetChangeChara(K7HAC,false);
//	SetChangeChara(K7CYO,false);
//	SetChangeChara(K7KED,false);
//	SetChangeChara(K7KVN,false);
//	SetChangeChara(K7MSK,false);
//	
//	// LI\}bv
//	ClearCharChangeMask();
//	
//	// ̃LN^IłȂ悤ɂ( InitCharChange ̑OɈړ܂ (Rc) )
//	SetCharChangeMask(K7DAN);
//	SetCharChangeMask(K7GAL);
//	SetCharChangeMask(K7CON);
//	SetCharChangeMask(K7HAC);
//	SetCharChangeMask(K7HAS);
//	SetCharChangeMask(K7HAY);
//	SetCharChangeMask(K7CYO);
//	SetCharChangeMask(K7KED);
//	SetCharChangeMask(K7KVN);
//	SetCharChangeMask(K7MSK);
	
	// LN^`FW̏
	// extern s8	InitCharChange( u8 NotCancelFlag = FALSE, s32 CurrentChar = K7GAL, u8 SwitchOnFlag = FALSE ) ;	// LN^`FW̏
	WK7Stage::InitCharChange(false, K7HAC, (u8 )WK7Stage::GetHarmanTvFlag(K7STGID(121,1),0));
	WK7Stage::SetHarmanTvFlag(K7STGID(121,1),0,true);
	
	// mCYI҂
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	
	while( CheckCharChangeSetup()==FALSE ){
		GHMGCTASK_RETSYS();
	}
	
	WK7Chara::SetRenderChara(false);
	WK7Stage::SetRenderStage(false);
	WK7Item::SetRenderItem  (false);
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7CAM->StoreState();
	
	while( gpNoise->mSandRelease()==false ){
		GHMGCTASK_RETSYS();
	}
	
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	// LN^`FW̏Ԃ𓾂( TRUE:s  FALSE:I͊ɏIĂ ) 
	while( GetCharChangeState()==TRUE ){
		K7SCR_RETSYS();
	}
	
	while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed)==false ){
		GHMGCTASK_RETSYS();
	}
	
	// LN^`FW̌ns
	EndCharChange();
	
	GHMGCTASK_RETSYS();
	GHMGCTASK_RETSYS();
	
	while( WK7Stage::RestoreStageArchive()==false ){
		GHMGCTASK_RETSYS();
	}
	
	// mCYI҂
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	
	while( WK7Stage::IsRestoredStageArchive()==false ){
		GHMGCTASK_RETSYS();
	}
	
	// tF[hAEg
	WK7PLAYERCONTROL->ChangeChkPoint();			// `FbN|Cg̕ύXs
	
	WK7CAM->RestoreState();
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	
	SceneBlur.SetVisible(blurVisible);
	WK7Chara::SetRenderChara(true);
	WK7Stage::SetRenderStage(true);
	WK7Item::SetRenderItem  (true);
	WK7PLAYERCONTROL->SetOperateEnable(false);
	
	K7SCR_EVCONDCHANGE();
	
	while( gpNoise->mSandRelease()==false ){
		GHMGCTASK_RETSYS();
	}
	
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	WK7PLAYERCONTROL->SetVisible(true);
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return false;
}

bool K7Stage121M01::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(060003):
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE(false);
		
		FixCam(HARMAN);
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(3.0f));
		
		K7SCR_PC_SETVISIBLE(true);
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		break;
	default:
		break;
	}
	return true;
}

#define	K7STAGE121M01_FIXCAM_PATH		"door_990001"
static HSD_WObjDesc fixCamEyepos   = {
	NULL,
	{ 0.0f, 20.0f, 20.0f, },
	NULL,
};
static HSD_WObjDesc fixCamInterest = {
	NULL,
	{ 0.0f, 15.0f, 0.0f, },
	NULL,
};
static	HSD_CameraDescPerspective		fixCamDesc = {
	NULL,
	0,
	1,
	{ 0,640,0,480 },
	{ 0,640,0,480 },
	&fixCamEyepos,
	&fixCamInterest,
	0.0f,
	NULL,
	0.1f,
	1000.0f,
	42.184677f,
	1.18f,
};
bool K7Stage121M01::PathChangeCallBack(WK7PathChangeInfo &info)
{
	if( SetOrigPathCamera(info.mpPathName)==true ){
		return false;
	}
	return true;
}
bool K7Stage121M01::SetOrigPathCamera(const char *pPathName)
{
	if( pPathName==NULL ){
		return false;
	}
	WK7CAMPATHFOLLOWINFO->SetStageStartMode(false);
	if( strstr(pPathName,K7STAGE121M01_FIXCAM_PATH)==pPathName ){
		WK7StagePlaceInfo	*pPlaceInfo = GetPlaceInfo(K7STGID(121,0),K7STAGE121M01_FIXCAM_PATH);
		SetVisibleJObj("Door",false,false,true);
		SetVisibleJObj("DoorWall",false,false,true);
		if( pPlaceInfo!=NULL ){
			HSD_CameraDesc	*pDescDefault = WK7Cam::GetDescDefault();
			fixCamEyepos  .position = pPlaceInfo->mCamPos;
			fixCamInterest.position = pPlaceInfo->mCamTgt;
			fixCamDesc.nnear  = pDescDefault->perspective.nnear;
			fixCamDesc.ffar   = pDescDefault->perspective.ffar;
			fixCamDesc.fov    = pDescDefault->perspective.fov;
			fixCamDesc.aspect = pDescDefault->perspective.aspect;
			WK7CAMPATHFOLLOWINFO->SetMode(WK7CamPathFollowInfo::FIXED_MODE);
			WK7CAMPATHFOLLOWINFO->SetPathCamera((HSD_CameraDesc *)&fixCamDesc);
			return true;
		}
	}else{
		SetVisibleJObj("Door",true ,false,true);
		SetVisibleJObj("DoorWall",true ,false,true);
	}
	return false;
}

