////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage575M00 yR͓znʘH
//
// K7Stage575M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE575M00_CPP__

#include "..\..\..\Scn\K7Scn06.h"
#include ".\K7Stage575M00.h"
#include "..\..\..\Wat\WK7Item.h"
#include "..\..\..\Wat\WK7SceneBlur.h"
#include "..\..\..\Wat\WK7MainTask.h"
#include "..\..\..\Panel\SK7PanelMatsu.h"

//f
#define	STG575M00_MAT_CHRID		K7CHRID(K7MAT,0)
//[V
#define	MOT575M00_MAT_SIT		K7MOTID(K7MAT,20)
#define	MOT575M00_MAT_DOWN		K7MOTID(K7MAT,30)




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage575M00::K7Stage575M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mpSetAlpha = NULL;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage575M00::~K7Stage575M00()
{
	GHM_SAFE_DELETE( mpSetAlpha );
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage575M00::CreateCallBack( void )
{
	mpMat = CreateOwnChara( STG575M00_MAT_CHRID );
	WK7RenderObj::CreateOwnMotionObj( K7MOT_ATTR|K7OBJTYPE_CHR, MOT575M00_MAT_SIT );
	WK7RenderObj::CreateOwnMotionObj( K7MOT_ATTR|K7OBJTYPE_CHR, MOT575M00_MAT_DOWN );
	return( true );
}

//------------------------------------------------------------------------------
//iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
//------------------------------------------------------------------------------
bool
K7Stage575M00::InitializeCallBack( void )
{
	WK7JObj* pJObj;
	mpMat           = GetOwnChara( STG575M00_MAT_CHRID );
	mpMatModel      = GetOwnModel( K7OBJTYPE_CHR, STG575M00_MAT_CHRID );
	mpMatMotionSit  = GetOwnModelMotion( K7MOT_ATTR|K7OBJTYPE_CHR, MOT575M00_MAT_SIT );
	mpMatMotionDown = GetOwnModelMotion( K7MOT_ATTR|K7OBJTYPE_CHR, MOT575M00_MAT_DOWN );
	if( (pJObj=mpMat->GetJObj("HIT_Obj00")) != NULL )
	{
		if( (mpSetAlpha = new C_SetAlpha( pJObj->GetJObj(), 0.0f,false ))!=NULL ){
			mpSetAlpha->SetVal(0.0f,true);
		}
		SetHitObj( pJObj, K7EVENTNO(057500) );
	}
	return( true );
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage575M00::CondChangeCallBack( void )
{
	WK7JObj*	pJObj;
	Vec			loc;
	f32			rot;
	
	if( WK7Play::HasPlayed(K7EVENTPLAY(05100103))==false ){
		// hACxg͔Ȃ
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(057500),false);
	}else{
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(057500),true );
	}
	
	//֎qW擾
	if( (pJObj=GetJObj("chair")) != NULL )
	{
		pJObj->GetWorldPosition( loc );
		rot = pJObj->GetRotY();
	}else
	{
		loc.x = loc.y = loc.z = rot = 0.0f;
	}
	
	//}cP
	if( K7SCR_GET_SCENARIO_FLAG(EV057500) == false )
	{
		if( (mpMatModel != NULL) && (mpMatMotionSit != NULL) )
		{
			mpMatModel->AttachMotion( mpMatMotionSit );
			mpMatModel->PlayMotion();
			mpMatModel->SetMotionLoop( true );
			mpMatModel->SetPosition( loc );
			mpMatModel->SetRotY( rot );
			mpMat->SetRenderFlag( true );
		}
	}else
	{
		if( (mpMatModel != NULL) && (mpMatMotionDown != NULL) )
		{
			mpMatModel->AttachMotion( mpMatMotionDown );
			mpMatModel->PlayMotion();
			mpMatModel->SetMotionLoop( false );
			mpMatModel->SetPosition( loc );
			mpMatModel->SetRotY( rot );
			mpMat->SetRenderFlag( true );
		}
	}
	
	return( true );
}

////------------------------------------------------------------------------------
////hACxg
////------------------------------------------------------------------------------
//bool
//K7Stage575M00::DoorEventCallBack( WK7DoorEventInfo &info )
//{
//	return( true );
//	
//	switch( info.mEventNo )
//	{
//		//KVẢƂ
//		case	K7EVENTDOOR( 057500 ):
//			if( K7SCR_GET_SCENARIO_FLAG(EV057500) == false )
//			{
//				if( WK7Play::HasPlayed(K7EVENTPLAY(05100105)) == false )
//				{
//					//inGame~
//					K7SCR_ENTER_PLAYMODE();
//					K7SCR_ENTER_DEMOPAUSE();
//					//LĐE}cPȂ
//					gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue, NOISE_SE_NORMAL );
//					while(gpNoise->mGetSandFrameProc() != eSandExec){K7SCR_RETSYS();}
//					WK7Play::StorePlayTB();
//					while( gpNoise->mSandRelease() == false ){K7SCR_RETSYS();}
//					while( gpNoise->mGetSandFrameProc() != eSandStandby ){K7SCR_RETSYS();}
//					WK7Play::PlayTB( K7EVENTPLAY(05100105) );
//					WK7Play::PlayTB( K7EVENTPLAY(05100202) );
//					WK7Play::RestorePlayTB();
//					//inGameĊJ
//					K7SCR_EXIT_PLAYMODE();
//					K7SCR_EXIT_DEMOPAUSE();
//				}
//			}else
//			{
//				if( WK7Play::HasPlayed(K7EVENTPLAY(05100201)) == false )
//				{
//					//inGame~
//					K7SCR_ENTER_PLAYMODE();
//					K7SCR_ENTER_DEMOPAUSE();
//					//LĐE}cP
//					gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue, NOISE_SE_NORMAL );
//					while(gpNoise->mGetSandFrameProc() != eSandExec){K7SCR_RETSYS();}
//					WK7Play::StorePlayTB();
//					while( gpNoise->mSandRelease() == false ){K7SCR_RETSYS();}
//					while( gpNoise->mGetSandFrameProc() != eSandStandby ){K7SCR_RETSYS();}
//					WK7Play::PlayTB( K7EVENTPLAY(05100201) );
//					WK7Play::RestorePlayTB();
//					//inGameĊJ
//					K7SCR_EXIT_PLAYMODE();
//					K7SCR_EXIT_DEMOPAUSE();
//				}
//			}
//			break;
//		
//		//ftHg
//		default:
//			break;
//	}
//	
//	return( true );
//}

////------------------------------------------------------------------------------
////qbgIuWF
////------------------------------------------------------------------------------
//bool
//K7Stage575M00::HitObjCallBack( WK7HitObjInfo &info )
//{
//	return( true );
//	
//	switch( info.mEventNo )
//	{
//		//}cP
//		case	K7EVENTNO( 057500 ):
//			if( K7SCR_GET_SCENARIO_FLAG(EV057500) == false )
//			{
//				if( WK7Play::HasPlayed(K7EVENTPLAY(05100103)) == true )
//				{
//					//inGame~
//					K7SCR_ENTER_PLAYMODE();
//					K7SCR_ENTER_DEMOPAUSE();
//					//LĐE}cP
//					gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue, NOISE_SE_NORMAL );
//					while(gpNoise->mGetSandFrameProc() != eSandExec){K7SCR_RETSYS();}
//					WK7Play::StorePlayTB();
//					while( gpNoise->mSandRelease() == false ){K7SCR_RETSYS();}
//					while( gpNoise->mGetSandFrameProc() != eSandStandby ){K7SCR_RETSYS();}
//					WK7Play::PlayTB( K7EVENTPLAY(05100106) );
//					gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue, NOISE_SE_NORMAL );
//					while(gpNoise->mGetSandFrameProc() != eSandExec){K7SCR_RETSYS();}
//					WK7Play::RestorePlayTB();
//					//ǂtOON
//					K7SCR_SET_SCENARIO_FLAG( EV057500 );
//					//}cP|ĂԂɂ
//					K7SCR_EVCONDCHANGE();
//					while( gpNoise->mSandRelease() == false ){K7SCR_RETSYS();}
//					while( gpNoise->mGetSandFrameProc() != eSandStandby ){K7SCR_RETSYS();}
//					//inGameĊJ
//					K7SCR_EXIT_PLAYMODE();
//					K7SCR_EXIT_DEMOPAUSE();
//				}
//			}
//			break;
//		
//		//ftHg
//		default:
//			break;
//	}
//	
//	return( true );
//}

////------------------------------------------------------------------------------
////_o
////------------------------------------------------------------------------------
//bool
//K7Stage575M00::BpLeaveCallBack( WK7BpInfo &info )
//{
//	u32	eventNo = GetBpEventNo( info );
//	int	pathNo  = GetBpPathNo( info );
//	u32	stgid   = K7STGID( 121, 1 );
//	
//	switch( eventNo )
//	{
//		//}cPL
//		case	K7EVENTNO( 057500 ):
//			if( (WK7Play::HasPlayed(K7EVENTPLAY(05100103)) == false) && (pathNo == 0) )
//			{
//				//inGame~
//				K7SCR_ENTER_PLAYMODE_B();
//				K7SCR_ENTER_DEMOPAUSE();
//				//LĐEb}cP
//				K7SCR_NOISE_REQUEST();
//				WK7Play::StorePlayTB();
//				K7SCR_NOISE_RELEASE();
//				WK7Play::PlayTB( K7EVENTPLAY(05100103) );
//				WK7Play::RestorePlayTB();
//				//pl
//				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(999999), 0 );
//				K7SCR_PANEL_START();
//				K7SCR_PANEL_TERMWAIT();
//				K7SCR_RETSYS();
//				K7SCR_PANEL_EXIT();
//				//}cPH
//				if( K7SCR_PANEL_GETRESULT() == 0 )
//				{	//Ȃ
//					WK7Play::StorePlayTB();
//					K7SCR_PANEL_EXITWAIT();
//					WK7Play::PlayTB( K7EVENTPLAY(05100105) );
//					WK7Play::PlayTB( K7EVENTPLAY(05100202) );
//					WK7Play::RestorePlayTB();
//				}else
//				{	//
//					WK7Play::StorePlayTB();
//					K7SCR_PANEL_EXITWAIT();
//					WK7Play::PlayTB( K7EVENTPLAY(05100106) );
//					WK7Play::PlayTB( K7EVENTPLAY(05100201) );
//					WK7Play::RestorePlayTB();
//				}
//				//Xe[W؂ւ
//				K7SCR_NOISE_REQUEST();
//				//Xe[W
//				WK7Stage::DeleteStage(this);
//				//Xe[Wǂݍ
//				K7SCR_STG_CREATE_B( stgid );
//				K7SCR_STG_VISIBLE( stgid, true );
//				K7SCR_STG_SET_CURRENT( stgid );
//				SetCurrentPath(	GetPathNurbsAll("curve3"),
//								0.000f,
//								0,									// 0:forward 1:back
//								WK7PATHINFO_INITDIR_TGTDIR );		// : wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
//				WK7Stage::SetCameraStartPosition( stgid );
//				K7SCR_NOISE_RELEASE();
//				K7SCR_RETSYS();
//				//inGameĊJ
//				K7SCR_EXIT_PLAYMODE();
//				K7SCR_EXIT_DEMOPAUSE();
//			}
//			break;
//		
//		//ftHg
//		default:
//			return( true );
//	}
//	
//	return( true );
//}

bool K7Stage575M00::BpLeaveCallBack( WK7BpInfo &info )
{
	u32	eventNo = GetBpEventNo(info);
	int	pathNo  = GetBpPathNo (info);
	WK7Play*	pPlay;
	
	if( eventNo!=K7EVENTNO(057500) || pathNo!=0 || WK7Play::HasPlayed(K7EVENTPLAY(05100103))==true ){
		return true;
	}
	
	u32	stgid   = K7STGID( 121, 1 );
	
	SceneBlur.SetVisible(false);
	
	//}cPL
	//inGame~
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	//LĐEb}cP
	K7SCR_NOISE_REQUEST();
	//Xe[W
	K7SCR_PC_VISIBLE( false );
	WK7Chara::SetRenderChara(false);
	WK7Stage::SetRenderStage(false);
	WK7Item::SetRenderItem  (false);
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	WK7Play::StorePlayTB();
	WK7PLAYERCONTROL->ReleaseArchive();
	WK7Stage::DeleteStage(this);
	while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
		GHMGCTASK_RETSYS();
	}
#if	1
	WK7Play::SetTermCaptureRenderOn (true);
	WK7Play::SetTermCapturePreRender(true);
	while( (pPlay=WK7Play::Create(K7EVENTPLAY(05100103))) == NULL ){ K7SCR_RETSYS(); }
	pPlay->Prepare();
	while( pPlay->GetState() != WK7Play::PREPARED ){ K7SCR_RETSYS(); }
	pPlay->Start();
	K7SCR_RETSYS();
	K7SCR_NOISE_RELEASE();
	while(pPlay->GetState()!=WK7Play::PLAYED){ K7SCR_RETSYS(); }
	pPlay->SetVisibleAll( false );
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	GHM_SAFE_DELETE( pPlay );
	WK7Play::SetTermCaptureRenderOn(false);
	WK7Play::RestorePlayTB();
	WK7CAM->SetCinemaScopeMode(true);
	WK7Play::SetPlayed( K7EVENTPLAY(05100103), true );
#else
	K7SCR_NOISE_RELEASE();
	WK7Play::SetTermCaptureRenderOn (true);
	WK7Play::SetTermCapturePreRender(true);
	WK7Play::PlayTB( K7EVENTPLAY(05100103) );
	WK7Play::SetTermCaptureRenderOn(false);
	WK7Play::RestorePlayTB();
	WK7CAM->SetCinemaScopeMode(true);
#endif
	
	K7SCR_PANEL_SETPANELEVNO(K7EVENTNO(057500),0);
	GameInfo.SetPanelReleaseCancel(true);
	GameInfo.SetPanelNoiseCancel(true);
	GameInfo.SetPanelCtrlOffWait(true);
	GameInfo.SetPanelInitHideWait(true);
	K7SCR_PANEL_START();
	K7SCR_RETSYS();
	K7SCR_PANEL_INITWAIT();
	GameInfo.SetPanelInitHideWait(false);
	screenImageFullColor.SetRender   (false);
	screenImageFullColor.SetPreRender(false);
	K7SCR_PANEL_CTRLOFFWAIT();
	u32		playno;
	int		result = K7SCR_PANEL_GETRESULT();
	if( result != MATSU_KILL ){
		playno = K7EVENTPLAY(05100105);
	}else{
		playno = K7EVENTPLAY(05100106);
	}
	WK7Play::StorePlayTB();
	WK7Play::SetInitCaptureRenderOff(true);
	while( (pPlay=WK7Play::Create(playno))==NULL ){
		K7SCR_RETSYS();
	}
	while( pPlay->GetState()!=WK7Play::LOADED ){
		K7SCR_RETSYS();
	}
	pPlay->Prepare();
	while( pPlay->GetState()!=WK7Play::PREPARED ){
		K7SCR_RETSYS();
	}
	pPlay->Start();
	GameInfo.SetPanelCtrlOffWait(false);
	GameInfo.SetPanelTermHideWait(true);
	K7SCR_PANEL_TERMWAIT();
	GameInfo.SetPanelTermHideWait(false);
	K7SCR_RETSYS();
	K7SCR_PANEL_EXIT();
	K7SCR_PANEL_EXITWAIT();
	GameInfo.SetPanelNoiseCancel(false);
	GameInfo.SetPanelReleaseCancel(false);
	if( result != MATSU_KILL ){
		// }cPȂ
		K7SCR_RESET_SCENARIO_FLAG(EV057500);
	}else{
		// }cP
		K7SCR_SET_SCENARIO_FLAG(EV057500);
	}
	while( pPlay->GetState()!=WK7Play::PLAYED ){
		K7SCR_RETSYS();
	}
	
	//Xe[W؂ւ
	K7SCR_NOISE_REQUEST();
	
	WK7Play::PlayReleaseAll();
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	WK7Play::SetInitCaptureRenderOff(false);
	WK7Play::RestorePlayTB();
	
	//Xe[Wǂݍ
	SceneBlur.SetVisible(true);
	K7SCR_STG_CREATE_B   (stgid);
	WK7PLAYERCONTROL->RestoreArchive();
	while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::LOADED ){
		K7SCR_RETSYS();
	}
	while( gpNoise->mGetSandFrameProc() != eSandExec ){
		K7SCR_RETSYS();
	}
	K7SCR_PC_VISIBLE     (true);
	K7SCR_STG_VISIBLE    (stgid,true);
	K7SCR_STG_SET_CURRENT(stgid);
	WK7PLAYERCONTROL->_MotSet_Wait(false);
	WK7PLAYERPATHCONTROL->ReverseCancel();
	SetCurrentPath(	GetPathNurbsAll("curve3"),
					0.000f,
					0,									// 0:forward 1:back
					WK7PATHINFO_INITDIR_TGTDIR );		// : wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
	WK7Stage::SetCameraStartPosition( stgid );
	
	K7SCR_NOISE_RELEASE();
	K7SCR_RETSYS();
	//inGameĊJ
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return( true );
}

