////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage Place Info
//
// K7StagePlaceInfo.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 01/27/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGEPLACEINFO_H__
#define	__K7STAGEPLACEINFO_H__

#ifdef	__K7SCN01_CPP__
	//==== ViI1EEtNV} ====
	
	//---------------------------------------------------------------------
	//@ftHg
	WK7STGPLINF_DEF(190, 0,"Main Gate"                 ,""            )
	//*@Jn
	WK7STGPLINF_CAM(190, 0,"Main Gate"                 ,""            ,"start"     , 56.728f, 2.645f, 562.717f, 43.038f, 11.942f, 576.411f)
	//*@ւ
	WK7STGPLINF_CAM(190, 0,"Main Gate"                 ,""            ,"door_015000"    , 20.126f, -3.647f, 262.622f, 14.559f, 4.945f, 243.092f)
	
	//---------------------------------------------------------------------
	//֑O@ftHg
	WK7STGPLINF_DEF(190, 1,"Main Gate"                 ,"ݶϴ"            )
	//֑O@Jn
	WK7STGPLINF_CAM(190, 1,"Main Gate"                 ,"ݶϴ"            ,"branchA"     , 45.278f, -4.234f, 234.919f, 31.517f, 3.976f, 219.845f)
	//֑O@ւ
	WK7STGPLINF_CAM(190, 1,"Main Gate"                 ,"ݶϴ"            ,"branchF"    , 24.125f, -2.817f, 58.668f, 10.582f, 4.535f, 42.801f)
	//֑O@n[}x
	WK7STGPLINF_CAM(190, 1,"Main Gate"                 ,"ݶϴ"            ,"branchH"    , 69.349f, -3.086f, -98.243f, 59.323f, 3.032f, -79.957f)
	
	//---------------------------------------------------------------------
	//ց@ftHg
	WK7STGPLINF_DEF(100, 0,"Entrance"                  ,"ݶ"           )
	//*ց@Jn
//	WK7STGPLINF_CAM(100, 0,"Entrance"                 ,"ݶ"            ,"door_010010", 8.663f+26.342f, 1.874f-5.0f, -41.494f+230.464f, -6.355f+26.342f, 13.127f-5.0f, -31.696f+230.464f)
	//*ց@
	WK7STGPLINF_CAM(100, 0,"Entrance"                  ,"ݶ"           ,"branchF"    , 11.381f, -4.095f, 8.874f, -13.438f, 16.420f, -35.294f)
	//*ց@ҍ
	WK7STGPLINF_CAM(100, 0,"Entrance"                  ,"ݶ"           ,"branchD"    , 0.255f, 26.987f, -205.567f, 1.133f, 18.032f, -228.053f)
	//*ց@ʘH
	WK7STGPLINF_CAM(100, 0,"Entrance"                  ,"ݶ"           ,"branchC"    , 0.255f, 26.987f, -205.567f, 1.133f, 18.032f, -228.053f)
	//*ց@
	WK7STGPLINF_CAM(100, 0,"Entrance"                  ,"ݶ"           ,"door_010016"    , 15.601f, -1.483f, -321.875f, -2.607f, 4.226f, -336.962f)
	
	//---------------------------------------------------------------------
	//@ftHg
	WK7STGPLINF_DEF(101, 0,"Courtyard"                 ,"Ŷ"            )
	//*@ւ
	WK7STGPLINF_CAM(101, 0,"Courtyard"                 ,"Ŷ"            ,"branchA"    , 5.160f, 7.122f, 0.196f, 0.661f, 10.572f, 26.632f)
	
	//*@r[
	WK7STGPLINF_CAM(101, 0,"Courtyard"                 ,"Ŷ"            ,"branchB"    , -9.806f, 10.639f, -766.409f, 0.050f, 17.884f, -740.064f)
	
	//---------------------------------------------------------------------
	//뉮̏@ftHg
	WK7STGPLINF_DEF(101, 1,"Courtyard Roof"                 ,"Ŷ³"            )
	//*@ɖʂLE
	WK7STGPLINF_CAM(101, 1,"Courtyard Roof"                 ,"Ŷ³"            ,"branchA"    , 310.917f, 48.106f, 205.409f, 292.760f, 63.105f, 180.295f)
	
	//*@2FX[W[̕
	WK7STGPLINF_CAM(101, 1,"Courtyard Roof"                 ,"Ŷ³"            ,"door_015001"    , -287.572f, 60.247f, 177.668f, -284.088f, 60.115f, 168.296f)
	//*QF@
	WK7STGPLINF_CAM(101, 1,"Courtyard Roof"                 ,"Ŷ³"            ,"door_015002"    , -238.535f, 66.219f, 145.222f, -257.591f, 58.802f, 176.146f)

	
	//---------------------------------------------------------------------
	//q@ftHg
	WK7STGPLINF_DEF(102, 0,"Room of two Deva kings"    ,"Ը"           )
	//*q@r[
	WK7STGPLINF_CAM(102, 0,"Room of two Deva kings"    ,"Ը"           ,"branchA"    , -37.247f, 8.528f, 242.261f, -90.722f, 13.411f, 269.827f)
//	WK7STGPLINF_CAM(102, 0,"Room of two Deva kings"    ,"Ը"           ,"branchA"    , -606.665f, 6.824f, -260.997f, -591.383f, 7.704f, -282.911f)
//	WK7STGPLINF_CAM(102, 0,"Room of two Deva kings"    ,"Ը"           ,"branchA"    , -15.729f, 16.559f, 186.926f, -41.397f, 9.122f, 186.303f)
	//*q@ʎ
	WK7STGPLINF_CAM(102, 0,"Room of two Deva kings"    ,"Ը"           ,"door_010003", -78.650f, -0.561f, -208.747f, -130.657f, 20.800f, -234.031f)
//	WK7STGPLINF_CAM(102, 0,"Room of two Deva kings"    ,"Ը"           ,"door_010003", -1009.307f, 7.066f, -350.678f, -1038.276f, 7.757f, -316.200f)
//	WK7STGPLINF_CAM(102, 0,"Room of two Deva kings"    ,"Ը"           ,"door_010003", -49.329f, 6.366f, -222.447f, -76.110f, 6.287f, -214.799f)
	
	//---------------------------------------------------------------------
	//r[@ftHg
	WK7STGPLINF_DEF(103, 0,"Lobby"             ,"޲"       )
	//*r[@
	//WK7STGPLINF_CAM(103, 0,"Lobby"             ,"޲"       ,"branchB"    , -21.635f, 0.254f, -27.407f, -22.736f, 9.332f, 1.179f)
	WK7STGPLINF_CAM(103, 0,"Lobby"             ,"޲"       ,"branchB"    , -20.394f, 11.433f, -37.929f, -23.110f, 9.332f, -8.113f)
	//*r[@]ƈʘH
	WK7STGPLINF_CAM(103, 0,"Lobby"             ,"޲"       ,"door_010009", 49.839f, -1.626f, -23.144f, 56.249f, 19.636f, -4.394f)
	//*r[@LԂ
//	WK7STGPLINF_CAM(103, 0,"Lobby"             ,"޲"       ,"branchC"    , -112.555f, 1.741f, -445.065f, -85.532f, 5.786f, -453.389f)
	WK7STGPLINF_CAM(103, 0,"Lobby"             ,"޲"       ,"branchC"    , -195.271f, 2.067f, -457.368f, -167.610f, 13.506f, -466.197f)
	//*r[@q
//	WK7STGPLINF_CAM(103, 0,"Lobby"             ,"޲"       ,"door_010002", -174.964f, 4.739f, 47.387f, -181.436f, 12.159f, 19.915f)
	WK7STGPLINF_CAM(103, 0,"Lobby"             ,"޲"       ,"door_010002", -490.358f, 11.981f, -317.354f, -519.324f, 7.945f, -308.093f)

	//*r[@n[}x
	WK7STGPLINF_CAM(103, 0,"Lobby"             ,"޲"       ,"branchH"    , 74.661f, -3.303f, -208.932f, 97.553f, 6.082f, -209.328f)
	//*r[@̑OʘH
	WK7STGPLINF_CAM(103, 0,"Lobby"             ,"޲"       ,"branch7"    , -120.542f, 2.693f, -420.857f, -106.278f, 9.614f, -435.666f)
	
	//---------------------------------------------------------------------
	//ʘH@ftHg
	WK7STGPLINF_DEF(104, 0,"TeaRoom Passage"           ,"Լ³"         )
	//*ʘH@ւ
	WK7STGPLINF_CAM(104, 0,"TeaRoom Passage"           ,"Լ³"         ,"branchC"    , 302.728f, 0.780f, -20.810f, 324.906f, 20.236f, -19.244f)
	//*ʘH@
	WK7STGPLINF_CAM(104, 0,"TeaRoom Passage"           ,"Լ³"         ,"door_010001", 143.850f, 14.592f, -23.605f, 115.774f, 17.377f, -15.751f)
	
	//---------------------------------------------------------------------
	//ҍ@ftHg
	WK7STGPLINF_DEF(105, 0,"Waiting Room"              ,""          )
	//*ҍ@ւ
	WK7STGPLINF_CAM(105, 0,"Waiting Room"              ,""          ,"branchD"    , 421.892f, 21.382f, -21.461f, 395.850f, 8.600f, -21.431f)
	//*ҍ@n[}x
	WK7STGPLINF_CAM(105, 0,"Waiting Room"              ,""          ,"branchH"    , 421.892f, 21.382f, -21.461f, 395.850f, 8.600f, -21.431f)


	//*ҍ@O
	WK7STGPLINF_CAM(105, 0,"Waiting Room"              ,""          ,"branchA"    , 601.714f, 37.020f, -7.089f, 614.872f, 44.175f, 9.881f)

	//Wv
	WK7STGPLINF_CAM(105, 0,"Waiting Room"              ,""          ,"branchJ"    , 597.274f, 36.292f, 82.739f, 606.695f, 43.546f, 65.832f)
	//Wv~
	WK7STGPLINF_CAM(105, 0,"Waiting Room"              ,""          ,"set1"    , 553.686f, 8.175f, 73.942f, 562.931f, 8.939f, 70.208f)
	//*ҍ@X[W[
	WK7STGPLINF_CAM(105, 0,"Waiting Room"              ,""          ,"door_015001"    ,-300.166f, 51.104f, 116.014f, -294.877f, 53.693f, 124.097f)



	
	//---------------------------------------------------------------------
	//Lԁ@ftHg
	WK7STGPLINF_DEF(106, 0,"Large Room"                ,""           )
	//*Lԁ@Ki
	WK7STGPLINF_CAM(106, 0,"Large Room"                ,""           ,"branch69"    , 125.302f, 21.848f, 197.058f, 73.892f, -2.018f, 204.947f)
	//*Lԁ@tEJ
	WK7STGPLINF_CAM(106, 0,"Large Room"                ,""           ,"branchC"    , -76.243f, -36.644f, 485.799f, -60.783f, -31.000f, 478.623f)

	
	//---------------------------------------------------------------------
	//ʎ@ftHg
	WK7STGPLINF_DEF(107, 0,"Special Room"              ,"ĸ¼"         )
	//*ʎ@q
	WK7STGPLINF_CAM(107, 0,"Special Room"              ,"ĸ¼"         ,"branchB"    , -28.393f, 4.164f, -16.447f, 9.758f, 16.013f, 22.848f)

	//*ʎ@n[}x
	WK7STGPLINF_CAM(107, 0,"Special Room"              ,"ĸ¼"         ,"branchE"    , 89.528f, 19.522f, 18.221f, 82.463f, 10.523f, -3.134f)
	//*ʎ@ە
	WK7STGPLINF_CAM(107, 0,"Special Room"              ,"ĸ¼"         ,"branchD"    , 8.353f, 2.314f, -410.982f, -3.501f, 9.401f, -428.040f)

	
	//---------------------------------------------------------------------
	//ꉮ@ftHg
	WK7STGPLINF_DEF(108, 0,"Instrument Room"                ,"ޯ"             )
	//*ꉮ@ni
	WK7STGPLINF_CAM(108, 0,"Instrument Room"                ,"ޯ"             ,"branchD"    , 149.923f, 3.194f, 174.949f, 126.743f, 6.156f, 192.687f)
	//*ꉮ@̉L
	WK7STGPLINF_CAM(108, 0,"Instrument Room"                ,"ޯ"             ,"door_010008", -314.593f, 9.823f, -737.595f, -315.578f, 13.695f, -708.547f)
	//*ꉮ@gC
	WK7STGPLINF_CAM(108, 0,"Instrument Room"                ,"ޯ"             ,"branch0", 95.535f, 26.315f, -50.169f, 113.580f, 14.723f, -49.747f)
	//*ꉮ@n[}x
	WK7STGPLINF_CAM(108, 0,"Instrument Room"                ,"ޯ"             ,"branchE", 21.179f, 27.498f, -14.367f, 20.346f, 14.896f, -31.707f)

	
	//---------------------------------------------------------------------
	//ni@ftHg
	WK7STGPLINF_DEF(112, 0,"Detached House"            ,""             )

	//*ni@]ƈʘH
	WK7STGPLINF_CAM(112, 0,"Detached House"            ,""             ,"door_015004"    , 107.841f, 2.424f, -298.747f, 126.988f, 10.168f, -304.681f)
	//*ni@̊Ԃ
	WK7STGPLINF_CAM(112, 0,"Detached House"            ,""             ,"branchC"    , 446.814f, 5.527f, -951.233f, 442.646f, 10.500f, -972.075f)
	//*ni@k̊Ԃ
	WK7STGPLINF_CAM(112, 0,"Detached House"            ,""             ,"branchF"    , 749.046f, 24.645f, -1406.303f, 748.548f, 20.451f, -1432.761f)
	//*ni@̊Ԃ
	WK7STGPLINF_CAM(112, 0,"Detached House"            ,""             ,"branchB"    , 1185.336f, 4.480f, -1192.324f, 1191.114f, 10.082f, -1216.690f)
	//*ni@̊Ԃ
	WK7STGPLINF_CAM(112, 0,"Detached House"            ,""             ,"branchE"    , 899.408f, 5.917f, -848.905f, 877.078f, 10.314f, -839.212f)
	//*ni@Ԃ
	WK7STGPLINF_CAM(112, 0,"Detached House"            ,""             ,"door_015002"    , 853.987f, 2.823f, -1196.379f, 876.468f, 13.599f, -1210.910f)
	//*ni@n[}x
	WK7STGPLINF_CAM(112, 0,"Detached House"            ,""             ,"branchH"    , 436.303f, 19.135f, -1415.732f, 445.515f, 12.554f, -1435.932f)

	
	//---------------------------------------------------------------------
	//̊ԁ@ftHg
	WK7STGPLINF_DEF(113, 0,"East Room"                 ,"˶޼"          )
	//*̊ԁ@ni
	WK7STGPLINF_CAM(113, 0,"East Room"                 ,"˶޼"          ,"branchC"    , 3.334f, 7.965f, 23.837f, -16.161f, 4.870f, 30.231f)
	//WK7STGPLINF_CAM(113, 0,"East Room"                 ,"˶޼"          ,"branchC"    , -3.334f, 7.965f, -23.837f, 16.161f, 4.870f, -30.231f)
	//---------------------------------------------------------------------
	//̊ԁ@ftHg
	WK7STGPLINF_DEF(113, 1,"West Room"                 ,"Ƽ"            )
	//*̊ԁ@ni
	WK7STGPLINF_CAM(113, 1,"West Room"                 ,"Ƽ"            ,"branchB"    , -19.718f, 11.256f, 28.424f, 1.561f, 4.970f, 23.959f)
	//WK7STGPLINF_CAM(113, 1,"West Room"                 ,"Ƽ"            ,"branchB"    , 19.718f, 11.256f, -28.424f, -1.561f, 4.970f, -23.959f)
	//---------------------------------------------------------------------
	//̊ԁ@ftHg
	WK7STGPLINF_DEF(113, 2,"South Room"                ,""           )
	//*̊ԁ@ni
	WK7STGPLINF_CAM(113, 2,"South Room"                ,""           ,"branchF"    , -0.998f, 16.107f, 8.993f, -0.733f, 21.175f, -19.116f)
	//WK7STGPLINF_CAM(113, 2,"South Room"                ,""           ,"branchF"    , 0.998f, 16.107f, -8.993f, 0.733f, 21.175f, 19.116f)
	//---------------------------------------------------------------------
	//k̊ԁ@ftHg
	WK7STGPLINF_DEF(113, 3,"North Room"                ,""            )
	//*k̊ԁ@ni
	WK7STGPLINF_CAM(113, 3,"North Room"                ,""            ,"branchE"    , 30.191f, 6.128f, -28.777f, 27.876f, 4.970f, -7.654f)
	//WK7STGPLINF_CAM(113, 3,"North Room"                ,""            ,"branchE"    , -30.191f, 6.128f, 28.777f, -27.876f, 4.970f, 7.654f)
	
	//---------------------------------------------------------------------
	//piRNV@ftHg
	WK7STGPLINF_DEF(115, 0,"Work-of-art Collection"    ,"޼ݺڸ"  )

	//---------------------------------------------------------------------

	//piRNV@ftHg
	WK7STGPLINF_DEF(115, 1,"Work-of-art Collection"    ,"޼ݺڸ"  )
	//piRNV@
	WK7STGPLINF_CAM(115, 1,"Work-of-art Collection"    ,"޼ݺڸ"  ,"curveT"     , -0.169f, 20.588f, -366.236f, 0.179f, -2.136f, -305.703f)
	//piRNV@tNV}
	WK7STGPLINF_CAM(115, 1,"Work-of-art Collection"    ,"޼ݺڸ"  ,"branchB"     , 4.529f, 1.768f, -442.034f, -2.200f, 11.059f, -420.980f)
	//piRNV@n[}x
	WK7STGPLINF_CAM(115, 1,"Work-of-art Collection"    ,"޼ݺڸ"  ,"branchT"     , 0.437f, 0.742f, -367.070f, 0.274f, 4.718f, -352.028f)

	
	//---------------------------------------------------------------------
	//I[i[OL
	WK7STGPLINF_DEF(116, 0,"Hallway"    ,"۳"  )
	//I[i[@Ln
	WK7STGPLINF_CAM(116, 0,"Hallway"    ,"۳"  ,"branchA"     , 81.139f, 7.086f, 166.399f, 70.326f, 6.436f, 147.885f)
	//I[i[@I[i[
	WK7STGPLINF_CAM(116, 0,"Hallway"    ,"۳"  ,"door_010011"     , -12.720f, 2.215f, -308.235f, 5.051f, 10.727f, -293.432f)
	//I[i[@pi
	WK7STGPLINF_CAM(116, 0,"Hallway"    ,"۳"  ,"door_015006"     , -16.887f, 4.133f, 21.849f, 2.490f, 14.141f, 12.133f)

	//I[i[@`FW
	WK7STGPLINF_CAM(116, 0,"Hallway"    ,"۳"  ,"door_015005"     , -2.346f, 1.235f, 45.098f, 16.587f, 21.709f, -10.966f)
	//I[i[@`FW
	WK7STGPLINF_CAM(116, 0,"Hallway"    ,"۳"  ,"door_015004"     , 43.932f, 1.326f, 47.334f, 35.350f, 10.353f, 28.194f)


	//---------------------------------------------------------------------
	//ɖʂL@ftHg
	WK7STGPLINF_DEF(117, 0,"GuestRoom Alley"                 ,"ݶ۳"            )
	//*ɖʂL@r[
	WK7STGPLINF_CAM(117, 0,"GuestRoom Alley"                 ,"ݶ۳"            ,"branch3"     , -127.670f, 2.518f, -456.774f, -111.325f, 9.891f, -470.427f)
	//*ɖʂL@2F
//	WK7STGPLINF_CAM(117, 0,"GuestRoom Alley"                 ,"ݶ۳"            ,"branchR"    , -125.505f, 2.806f, -804.237f, -107.267f, 9.832f, -813.524f)
	//*ɖʂL@2F
	WK7STGPLINF_CAM(117, 0,"GuestRoom Alley"                 ,"ݶ۳"            ,"branchC"    , -119.312f, 4.153f, -829.710f, -106.260f, 9.964f, -809.150f)

	//---------------------------------------------------------------------
	//Ln@ftHg
	WK7STGPLINF_DEF(118, 0,"Hand In Grove"                 ,""            )
	//*Ln@Ԃ
	WK7STGPLINF_CAM(118, 0,"Hand In Grove"                 ,""            ,"branchB"     , 888.143f, 12.929f, -1689.385f, 879.679f, 13.546f, -1709.017f)
	//*Ln@NA
	WK7STGPLINF_CAM(118, 0,"Hand In Grove"                 ,""            ,"door_015003"    , 882.310f, 10.193f, -2067.669f, 874.601f, 15.956f, -2078.451f)
	
	//---------------------------------------------------------------------
	//Ki@ftHg
	WK7STGPLINF_DEF(119, 0,"Stairway"                 ,""            )
	//*Ki@m
	WK7STGPLINF_CAM(119, 0,"Stairway"                 ,""            ,"branchA"     , 121.915f, -39.256f, 53.484f, 102.981f, -24.704f, 78.415f)
	//*Ki@2F
	WK7STGPLINF_CAM(119, 0,"Stairway"                 ,""            ,"branch96"    , 120.281f, -1.802f, 150.162f, 90.845f, 13.733f, 171.290f)
	//*Ki@n[}x
	WK7STGPLINF_CAM(119, 0,"Stairway"                 ,""            ,"branchB"    , 124.880f, 16.506f, 129.455f, 88.761f, -26.513f, 137.647f)
	
	//---------------------------------------------------------------------
	//gC@ftHg
	WK7STGPLINF_DEF(180, 0,"Rest Room"                 ,"Ĳ"            )
	//gC@KbLVc
	WK7STGPLINF_CAM(180, 0,"Rest Room"                 ,"Ĳ"            ,"branch0"     , 157.163f, 2.046f, -74.897f, 149.620f, 10.477f, -51.960f)
	
	//---------------------------------------------------------------------
	//[Ձ@ftHg
	WK7STGPLINF_DEF(181, 0,"Alley"                 ,"۳"            )
	//*[Ձ@y킵
	WK7STGPLINF_CAM(181, 0,"Alley"                 ,"۳"            ,"branch8"     , -23.310f, 1.695f, -154.354f, -34.868f, 9.241f, -137.869f)
	//*[Ձ@n[}x
	WK7STGPLINF_CAM(181, 0,"Alley"                 ,"۳"            ,"branchH"    , -20.134f, 18.381f, -231.871f, -46.414f, -0.632f, -275.952f)
	//*[Ձ@ni
	WK7STGPLINF_CAM(181, 0,"Alley"                 ,"۳"            ,"branchZ"     , -20.764f, 17.999f, -377.163f, -31.432f, 6.663f, -397.109f)


	//---------------------------------------------------------------------
	//΃LXM{X@ftHg
	WK7STGPLINF_DEF(182, 0,"Owner Room"                 ,"Ű"            )
	//*΃LXM{X@EJ
	WK7STGPLINF_CAM(182, 0,"Owner Room"                 ,"Ű"            ,"branchB"     , -3.502f, 9.123f, -10.064f, -21.571f, 4.541f, -1.851f)
	//*΃LXM{X@EJ
	WK7STGPLINF_CAM(182, 0,"Owner Room"                 ,"Ű"            ,"door_015006"     , -34.347f, 1.664f, 24.353f, -17.016f, 9.118f, 12.362f)


	//==== ViI1EEpr ====
	
	//---------------------------------------------------------------------
	//pr@ftHg
	WK7STGPLINF_DEF(137, 0,"Kaku bldg. Entrance"       ,"  ظ"    )
	//*pr@Jn
	WK7STGPLINF_CAM(137, 0,"Kaku bldg. Entrance"       ,"  ظ"    ,"curve3"     , -252.188f, 1.375f, 319.438f, -300.208f, 19.419f, 302.165f)
	//*pr@1KL
	WK7STGPLINF_CAM(137, 0,"Kaku bldg. Entrance"       ,"  ظ"    ,"door_011305", 37.795f, 14.144f, 61.450f, 33.055f, 15.846f, 40.466f)
	//*pr@n[}
	WK7STGPLINF_CAM(137, 0,"Kaku bldg. Entrance"       ,"  ظ"    ,"branchS", 3.591f, 17.499f, 330.618f, 56.549f, 5.000f, 311.003f)
	
	//---------------------------------------------------------------------
	//Ki@ftHg
	WK7STGPLINF_DEF(130, 0,"Stairs"                  ,""           )
	//*Ki@n
//	WK7STGPLINF_CAM(130, 0,"Stairs"                  ,""           ,"branchB"    , 243.740f, -0.525f, -184.820f, 232.288f, -42.617f, -149.422f)
	//*Ki@1K
//	WK7STGPLINF_CAM(130, 0,"Stairs"                  ,""           ,"branchD"    , 249.640f, 22.972f, -120.957f, 234.219f, 6.405f, -134.857f)
	//*Ki@2K
//	WK7STGPLINF_CAM(130, 0,"Stairs"                  ,""           ,"branchF"    , 261.494f, 88.480f, -122.880f, 219.792f, 43.601f, -159.387f)
	//*Ki@3K
//	WK7STGPLINF_CAM(130, 0,"Stairs"                  ,""           ,"branchH"    , 261.724f, 146.521f, -117.058f, 232.233f, 115.891f, -149.811f)
	//*Ki@4K
//	WK7STGPLINF_CAM(130, 0,"Stairs"                  ,""           ,"branchJ"    , 260.495f, 211.085f, -121.769f, 224.858f, 151.444f, -168.045f)
	
	//---------------------------------------------------------------------
	//1KL@ftHg
	WK7STGPLINF_DEF(131, 0,"1st-floor Hallway"         ,"1 ۳"         )
	//*1KL@pr
	WK7STGPLINF_CAM(131, 0,"1st-floor Hallway"         ,"1 ۳"         ,"branchE"    , 377.565f, 3.440f, -113.677f, 396.603f, 9.973f, -92.453f)
	//*1KL@n[}x
	WK7STGPLINF_CAM(131, 0,"1st-floor Hallway"         ,"1 ۳"         ,"branchH", 318.317f, 5.315f, -77.878f, 307.091f, 9.491f, -56.544f)
	//*1KL@Ki
	WK7STGPLINF_CAM(131, 0,"1st-floor Hallway"         ,"1 ۳"         ,"branchD"    , 342.631f, 16.473f, -104.498f, 324.113f, 11.864f, -104.511f)
	//*1KL@101
//	WK7STGPLINF_CAM(131, 0,"1st-floor Hallway"         ,"1 ۳"         ,"door_010102", -1.304f, 7.155f, -95.234f, 26.536f, 6.414f, -99.644f)
	//*1KL@105
//	WK7STGPLINF_CAM(131, 0,"1st-floor Hallway"         ,"1 ۳"         ,"door_010103", -1.304f, 7.155f, -95.234f, 26.536f, 6.414f, -99.644f)
	//*1KL@106
	WK7STGPLINF_CAM(131, 0,"1st-floor Hallway"         ,"1 ۳"         ,"door_010104", -1.304f, 7.155f, -95.234f, 26.536f, 6.414f, -99.644f)
	
	//---------------------------------------------------------------------
	//Ǘl@ftHg
	WK7STGPLINF_DEF(140, 0,"Building Manager Room"     ,"ݼ"         )
	//*Ǘl@1KL
	WK7STGPLINF_CAM(140, 0,"Building Manager Room"     ,"ݼ"         ,"branchG"    , -37.933f, 14.783f, -69.830f, -25.128f, 8.650f, -95.500f)
	
	//---------------------------------------------------------------------
	//101@ftHg
	WK7STGPLINF_DEF(141, 0,"Room 101"                  ,"101޳"        )
	//*101@1KL
	WK7STGPLINF_CAM(141, 0,"Room 101"                  ,"101޳"        ,"branchA"    , 19.258f, 19.560f, -48.886f, -7.530f, 7.850f, -50.281f)
	
	//---------------------------------------------------------------------
	//105@ftHg
	WK7STGPLINF_DEF(141, 1,"Room 105"                  ,"105޳"        )
	//*105@1KL
	WK7STGPLINF_CAM(141, 1,"Room 105"                  ,"105޳"        ,"branchA"    , 18.346f, 10.468f, -34.862f, -5.778f, 8.141f, -51.273f)
	
	//---------------------------------------------------------------------
	//106@ftHg
	WK7STGPLINF_DEF(141, 2,"Room 106"                  ,"106޳"        )
	//*106@1KL
	WK7STGPLINF_CAM(141, 2,"Room 106"                  ,"106޳"        ,"branchA"    , -12.144f, 15.860f, -40.814f, -0.257f, 6.696f, -76.535f)
	
	//---------------------------------------------------------------------
	//n@ftHg
	WK7STGPLINF_DEF(136, 0,"Basement"                  ,""            )
	//*n@Ki
	WK7STGPLINF_CAM(136, 0,"Basement"                  ,""            ,"branchB"    , 230.181f, 0.440f, -111.497f, 239.658f, 10.000f, -135.262f)
	
	//---------------------------------------------------------------------
	//2KL@ftHg
	WK7STGPLINF_DEF(132, 0,"2nd-floor Hallway"         ,"2 ۳"         )
	//*2KL@Ki
	WK7STGPLINF_CAM(132, 0,"2nd-floor Hallway"         ,"2 ۳"         ,"branchF"    , 330.344f, 15.243f, -117.501f, 312.331f, 12.723f, -107.953f )
	//*2KL@n[}x
	WK7STGPLINF_CAM(132, 0,"2nd-floor Hallway"         ,"2 ۳"         ,"branchU"    , 317.687f, 4.979f, -102.900f, 310.944f, 8.063f, -89.209f)
	//*2KL@n[}
	WK7STGPLINF_CAM(132, 0,"2nd-floor Hallway"         ,"2 ۳"         ,"branchT", 193.208f, 5.927f, -104.242f, 170.972f, 11.173f, -101.200f)
	
	//---------------------------------------------------------------------
	//207@ftHg
	WK7STGPLINF_DEF(142, 0,"Room 207"                  ,"207޳"        )
	//*207@2KL
	WK7STGPLINF_CAM(142, 0,"Room 207"                  ,"207޳"        ,"branchG"    , 29.925f, 16.482f, -113.101f, 2.083f, 17.363f, -122.275f)

	//---------------------------------------------------------------------
	//203@ftHg
	WK7STGPLINF_DEF(143, 0,"Room 203"                  ,"203޳"        )
	//*203@2KL
	WK7STGPLINF_CAM(143, 0,"Room 203"                  ,"203޳"        ,"branchA"    , 4.230f, 10.281f, 3.754f, -5.328f, 5.909f, -20.385f)
	
	//---------------------------------------------------------------------
	//205@ftHg
	WK7STGPLINF_DEF(143, 1,"Room 205"                  ,"205޳"        )
	//*205@2KL
	WK7STGPLINF_CAM(143, 1,"Room 205"                  ,"205޳"        ,"branchA"    , -5.876f, 10.561f, 5.684f, 1.603f, 10.000f, -22.754f)
	
	//---------------------------------------------------------------------
	//206@ftHg
	WK7STGPLINF_DEF(143, 2,"Room 206"                  ,"206޳"        )
	//*206@2KL
	WK7STGPLINF_CAM(143, 2,"Room 206"                  ,"206޳"        ,"branchA"    , -1.059f, 9.086f, 3.458f, 7.816f, -2.795f, -22.091f)
	
	//---------------------------------------------------------------------
	//3KL@ftHg
	WK7STGPLINF_DEF(133, 0,"3rd-floor Hallway"         ,"3 ۳"         )
	//*3KL@Ki
	WK7STGPLINF_CAM(133, 0,"3rd-floor Hallway"         ,"3 ۳"         ,"branchH"    , 332.267f, 18.186f, -114.474f, 291.632f, 6.169f, -97.217f)
	//*3KL@Wv
	WK7STGPLINF_CAM(133, 0,"3rd-floor Hallway"         ,"3 ۳"         ,"branchJ"    , 237.622f, 42.194f, -198.211f, 231.961f, 38.997f, -218.213f)

//Wv
	WK7STGPLINF_CAM(133, 0,"3rd-floor Hallway"         ,"3 ۳"         ,"setJUMP"    , 241.116f, 1.599f, -187.387f, 232.783f, 9.755f, -206.368f)

	//*3KL@n[}
	WK7STGPLINF_CAM(133, 0,"3rd-floor Hallway"         ,"3 ۳"         ,"branchH2", 316.201f, 6.441f, -90.227f, 303.826f, 10.261f, -66.390f)
	
	//---------------------------------------------------------------------
	//307@ftHg
	WK7STGPLINF_DEF(144, 0,"Room 307"                  ,"307޳"        )
	//*307@3KL
	WK7STGPLINF_CAM(144, 0,"Room 307"                  ,"307޳"        ,"branchG"    , 15.099f, 11.452f, -125.205f, -12.208f, 14.482f, -114.944f)
	
	//---------------------------------------------------------------------
	//303@ftHg
	WK7STGPLINF_DEF(145, 0,"Room 303"                  ,"303޳"        )
	//*303@3KL
	WK7STGPLINF_CAM(145, 0,"Room 303"                  ,"303޳"        ,"branchA"    , -21.488f, 16.673f, -56.859f, 7.079f, 10.641f, -60.391f)
	
	//---------------------------------------------------------------------
	//304@ftHg
	WK7STGPLINF_DEF(145, 1,"Room 304"                  ,"304޳"        )
	//*304@3KL
	WK7STGPLINF_CAM(145, 1,"Room 304"                  ,"304޳"        ,"branchA"    , -12.645f, 11.021f, -60.685f, -3.597f, -0.732f, -35.257f)
	
	//---------------------------------------------------------------------
	//305@ftHg
	WK7STGPLINF_DEF(145, 2,"Room 305"                  ,"305޳"        )
	//*305@3KL
	WK7STGPLINF_CAM(145, 2,"Room 305"                  ,"305޳"        ,"branchA"    , -4.775f, 13.572f, 7.663f, -5.314f, 8.082f, -21.222f)
	
	//---------------------------------------------------------------------
	//306@ftHg
	WK7STGPLINF_DEF(145, 3,"Room 306"                  ,"306޳"        )
	//*306@3KL
	WK7STGPLINF_CAM(145, 3,"Room 306"                  ,"306޳"        ,"branchA"    , 11.216f, 10.864f, -56.401f, -17.881f, 15.068f, -57.214f)
	
	//---------------------------------------------------------------------
	//4KL@ftHg
	WK7STGPLINF_DEF(134, 0,"4th-floor Hallway"         ,"4 ۳"         )
	//*4KL@Ki
	WK7STGPLINF_CAM(134, 0,"4th-floor Hallway"         ,"4 ۳"         ,"branchJ"    , 325.469f, 20.229f, -95.980f, 315.826f, 17.884f, -97.207f)
	//4KL@407
	WK7STGPLINF_CAM(134, 0,"4th-floor Hallway"         ,"4 ۳"         ,"door_010401", 242.342f, 14.709f, -28.607f, 226.942f, 10.000f, -53.931f)
	//*4KL@403
	WK7STGPLINF_CAM(134, 0,"4th-floor Hallway"         ,"4 ۳"         ,"door_010402", -2.299f, 18.610f, -109.992f, 23.691f, 19.536f, -98.575f)
	//*4KL@Ln
	WK7STGPLINF_CAM(134, 0,"4th-floor Hallway"         ,"4 ۳"         ,"door_011601", 64.555f, 4.635f, -111.857f, 84.126f, 12.905f, -100.953f)
	//*4KL@n[}
	WK7STGPLINF_CAM(134, 0,"4th-floor Hallway"         ,"4 ۳"         ,"branchT", 299.145f, 23.241f, 6.665f, 276.684f, -1.877f, -39.630f)

	//---------------------------------------------------------------------
	//4KL@ftHg
	WK7STGPLINF_DEF(134, 1,"4th-floor Elevator Hall"         ,"ްΰ")
	//*4KL@Ԑl̕
	WK7STGPLINF_CAM(134, 1,"4th-floor Elevator Hall"         ,"ްΰ"         ,"branchE",10.016f, 30.051f, -56.057f, 25.226f, 12.677f, -98.316f)
	//*4KL@n[}
	WK7STGPLINF_CAM(134, 1,"4th-floor Elevator Hall"         ,"ްΰ"         ,"branchH", 10.016f, 30.051f, -56.057f, 25.226f, 12.677f, -98.316f)
	//*4KL@Gx[^
	WK7STGPLINF_CAM(134, 1,"4th-floor Elevator Hall"         ,"ްΰ"         ,"event_011605", 10.016f, 30.051f, -56.057f, 25.226f, 12.677f, -98.316f)
	//*4KL@Gx[^QƂ肠
	WK7STGPLINF_CAM(134, 1,"4th-floor Elevator Hall"         ,"ްΰ"         ,"ElevatorHallPath", 10.016f, 30.051f, -56.057f, 25.226f, 12.677f, -98.316f)
	//*4KL@Gx[^QƂ肠
	WK7STGPLINF_CAM(134, 1,"4th-floor Elevator Hall"         ,"ްΰ"         ,"ElevatorPath", 10.016f, 30.051f, -56.057f, 25.226f, 12.677f, -98.316f)


	
	//---------------------------------------------------------------------
	//4KLn@ftHg
	WK7STGPLINF_DEF(138, 0,"Hand In Grove"         ,""         )
	//*4KLn@R͓
	WK7STGPLINF_CAM(138, 0,"Hand In Grove"         ,""         ,"branchG"    , 256.907f, 3.531f, -107.763f, 271.516f, 16.259f, -99.312f)
	//*4KLn@Ԑl̕
	WK7STGPLINF_CAM(138, 0,"Hand In Grove"         ,""         ,"door_011602"    , 86.180f, 26.279f, -121.479f, 72.103f, 14.181f, -109.015f)

	//---------------------------------------------------------------------
	//403@ftHg
	WK7STGPLINF_DEF(146, 0,"Room 403"                  ,"403޳"        )
	//*403@4KL
	WK7STGPLINF_CAM(146, 0,"Room 403"                  ,"403޳"        ,"door_011201"    , -3.600f, 11.033f, 5.811f, -4.929f, 4.982f, -22.228f)
	
	//---------------------------------------------------------------------
	//n@ftHg
	WK7STGPLINF_DEF(136, 0,"Basement"                  ,""        )
	//n@
	WK7STGPLINF_CAM(136, 0,"Basement"                  ,""        ,"door_011201"    , 255.316f, 0.224f, -34.875f, 246.153f, 8.964f, -52.325f)
	//n@Gx[^
	WK7STGPLINF_CAM(136, 0,"Basement"                  ,""        ,"event_011207"    , -0.430f, 1.123f, -90.428f, 17.755f, 8.946f, -98.791f)
	
	//---------------------------------------------------------------------
	//n@ftHg
	WK7STGPLINF_DEF(147, 0,"Recreation Room"                  ,"ܼ"        )
	//*403@
	WK7STGPLINF_CAM(147, 0,"Recreation Room"                  ,"ܼ"        ,"door_011201"    , 55.672f, 10.459f, 27.944f, 38.763f, 9.876f, 14.710f)
	
	//---------------------------------------------------------------------
	// 5KL@ftHg
	WK7STGPLINF_DEF(135, 0,"Roof"         ,"ޮ"         )
	//*5KL@Gx[^
	WK7STGPLINF_CAM(135, 0,"Roof"         ,"ޮ"         ,"curve10"    , 25.500f, 0.069f, -85.859f, 11.408f, 20.605f, -102.020f)
	//*5KL@c
	WK7STGPLINF_CAM(135, 0,"Roof"         ,"ޮ"         ,"door_010501", -3.227f, 10.639f, -114.158f, 22.847f, 10.000f, -102.605f)
	//*5KL@n[}
	WK7STGPLINF_CAM(135, 0,"Roof"         ,"ޮ"         ,"branchS", 288.774f, 8.961f, -88.918f, 234.216f, 12.000f, -96.881f)
	
	//---------------------------------------------------------------------
	//c@ftHg
	WK7STGPLINF_DEF(160, 0,"Board Room"                ,"޼"          )
	//*c@5KL
	WK7STGPLINF_CAM(160, 0,"Board Room"                ,"޼"          ,"branchA"    , 121.050f, 0.431f, -51.799f, 100.339f, 10.722f, -58.665f)
	
#endif

#ifdef	__K7SCN02_CPP__
	//==== ViI2E_j====
	
	//---------------------------------------------------------------------
	//CQ[g@ftHg
	WK7STGPLINF_DEF(200, 0,"Main Gate"                 ,"Ҳݹް"         )
	//*CQ[g@Jn
	WK7STGPLINF_CAM(200, 0,"Main Gate"                 ,"Ҳݹް"         ,"texas_start"     , 2.148f, 1.111f, 701.292f, -1.031f, 11.270f, 678.204f)
	//*CQ[g@H
	WK7STGPLINF_CAM(200, 0,"Main Gate"                 ,"Ҳݹް"         ,"door_020001"    , -48.174f, 2.034f, 96.860f, -30.203f, 9.964f, 85.400f)
	
	//---------------------------------------------------------------------
	//H@ftHg
	WK7STGPLINF_DEF(201, 0,"Central Road"              ,"޳"       )
	//*H@CQ[g
	WK7STGPLINF_CAM(201, 0,"Central Road"              ,"޳"       ,"branchA"    , -12.476f, -0.601f, -43.145f, -0.782f, 13.564f, -30.022f)
	//*H@n[}
	WK7STGPLINF_CAM(201, 0,"Central Road"              ,"޳"       ,"branchP"    , -71.468f, 1.555f, -381.805f, -77.936f, 10.964f, -401.695f)
	//*H@plQ[g
	WK7STGPLINF_CAM(201, 0,"Central Road"              ,"޳"       ,"branchK"    , -11.927f, 1.336f, -1227.017f, -12.485f, 7.645f, -1205.955f)
	
	//---------------------------------------------------------------------
	//H@ftHg
	WK7STGPLINF_DEF(201, 1,"Central Road"              ,"޳"       )
	//H@
	WK7STGPLINF_CAM(201, 1,"Central Road"              ,"޳"       ,"branchK"    , -10.547f, 3.609f, -1261.568f, -16.082f, 8.409f, -1241.846f)
	//H@ZX
	WK7STGPLINF_CAM(201, 1,"Central Road"              ,"޳"       ,"door_020103"    , -196.095f, 4.681f, -1338.797f, -214.027f, 9.545f, -1349.364f)
	//H@ZXR[e
	WK7STGPLINF_CAM(201, 1,"Central Road"              ,"޳"       ,"door_020102"    ,-91.443f, 1.931f, -1911.830f, -71.199f, 15.754f, -1962.998f)
	//H@pYQ[g
	WK7STGPLINF_CAM(201, 1,"Central Road"              ,"޳"       ,"door_020101"    ,-52.412f, 2.895f, -2199.980f, -45.501f, 9.964f, -2178.943f)


	//---------------------------------------------------------------------
	//_Ci[t@NX@ftHg
	WK7STGPLINF_DEF(202, 0,"Diner Funcs"               ,"޲Ű ̧ݸ"     )
	//*_Ci[t@NX@H
	WK7STGPLINF_CAM(202, 0,"Diner Funcs"               ,"޲Ű ̧ݸ"     ,"branchD"    , -198.177f, 23.357f, -3324.748f, -183.535f, 21.545f, -3307.134f)
	//*_Ci[t@NX@H
	WK7STGPLINF_CAM(202, 0,"Diner Funcs"               ,"޲Ű ̧ݸ"     ,"branchA"    , -276.179f, 19.738f, -3275.623f, -295.174f, 22.243f, -3283.630f)

	//---------------------------------------------------------------------
	//⓹@ftHg
	WK7STGPLINF_DEF(203, 0,"Sloping Road"              ,""            )
	//*⓹@H
	WK7STGPLINF_CAM(203, 0,"Sloping Road"              ,""            ,"branchF"    , -10.982f, 0.061f, -4597.853f, 0.449f, 10.577f, -4614.542f)
	//⓹@́[}
	WK7STGPLINF_CAM(203, 0,"Sloping Road"              ,""            ,"branchY"    , 521.950f, 170.936f, -5613.846f, 492.435f, 189.690f, -5648.818f)
	//⓹@Ԃ
	WK7STGPLINF_CAM(203, 0,"Sloping Road"              ,""            ,"branchZ"    , 239.543f, 188.080f, -5742.277f, 222.066f, 194.185f, -5754.345f)
	//---------------------------------------------------------------------
	//⓹@ftHg
	WK7STGPLINF_DEF(203, 1,"Sloping Road"              ,""            )
	//⓹@Ԃ
	WK7STGPLINF_CAM(203, 1,"Sloping Road"              ,""            ,"branchZ"    , 15.980f, 262.698f, -5843.433f, 34.284f, 259.144f, -5835.940f)
	//⓹@t@[XgCt
	WK7STGPLINF_CAM(203, 1,"Sloping Road"              ,""            ,"door_020301"    , 36.056f, 243.691f, -6210.311f, 42.029f, 249.904f, -6229.933f)


	//---------------------------------------------------------------------
	//t@[XgCt@ftHg
	WK7STGPLINF_DEF(204, 0,"Firstlife Maingate"        ,"̧ײ "   )
	//t@[XgCt@⓹
	WK7STGPLINF_CAM(204, 0,"Firstlife Maingate"        ,"̧ײ "   ,"branchG"    , -11.986f, 244.689f, -6320.337f, -3.511f, 251.413f, -6303.107f)
	//t@[XgCt@r
	WK7STGPLINF_CAM(204, 0,"Firstlife Maingate"        ,"̧ײ "   ,"branchI"    , 92.575f, 276.481f, -7231.890f, 79.039f, 279.733f, -7247.068f)
	//t@[XgCt@́[}
	WK7STGPLINF_CAM(204, 0,"Firstlife Maingate"        ,"̧ײ "   ,"branchR"    , -8.021f, 247.322f, -7305.039f, 124.009f, 298.914f, -7375.662f)

	
	//---------------------------------------------------------------------
	//r@ftHg
	WK7STGPLINF_DEF(205, 0,"Wilderness"        ,""   )
	//r@ftHg
	WK7STGPLINF_CAM(205, 0,"Wilderness"        ,""    ,"door_020501"    , 7.165f, 272.370f, -7804.053f, 8.940f, 280.373f, -7784.475f)

	//---------------------------------------------------------------------
	//ً}ԗ@ftHg
	WK7STGPLINF_DEF(206, 0,"Emergency Vehicle"         ,"ݷخ"      )
	
	//ً}p@r
	WK7STGPLINF_CAM(206, 0,"Emergency Vehicle"         ,"ݷخ"      ,"setA"    , -13.479f, 3.954f, -16.364f, 0.545f, 12.464f, -3.082f)

	//---------------------------------------------------------------------
	//ZX@ftHg
	WK7STGPLINF_DEF(208, 0,"Housing"                ,"ޭ޲"             )
	//ZX@ʂ
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"door_020803"    , -267.716f, 3.086f, -1335.661f, -287.562f, 12.541f, -1335.959f)
	//ZX@208ZWv
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"branch8"    , -418.256f, 36.091f, -1453.475f, -409.607f, 46.332f, -1435.368f)
	//ZX@209Wv
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"branch7"    , -665.923f, 40.130f, -1454.194f, -672.034f, 45.500f, -1433.186f)
	//ZX@QPOWv
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"branch6"    , -941.539f, 37.541f, -1497.680f, -941.606f, 45.118f, -1476.451f)
	//ZX@217Wv
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"branch1"    , -419.233f, 36.970f, -1258.999f, -409.375f, 46.768f, -1276.719f)
	//ZX@218Wv
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"branch2"    , -668.586f, 36.266f, -1281.217f, -668.265f, 45.377f, -1301.971f)
	//ZX@219Wv
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"branch3"    , -941.110f, 42.731f, -1319.754f, -926.239f, 45.864f, -1336.575f)
	//ZX@206Wv
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"branch0"    , -830.623f, 37.323f, -1851.667f, -828.984f, 45.673f, -1872.527f)


	//ZX@212Z
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"branchE"    , -449.050f, 37.726f, -1203.571f, -429.133f, 45.055f, -1212.051f)
	//ZX@213Z
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"branchF"    , -704.307f, 39.594f, -1238.088f, -685.559f, 48.223f, -1229.366f)
	//ZX@214Z
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"branchG"    , -969.664f, 46.439f, -1265.433f, -960.519f, 54.155f, -1284.363f)
	//ZX@208Z
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"branchK"    , -440.078f, 37.028f, -1512.017f, -425.642f, 45.055f, -1496.877f)
	//ZX@210Z
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"branchB"    , -949.520f, 38.153f, -1560.066f, -936.795f, 47.360f, -1544.099f)
	//ZX@207Z
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"branchL"    , -699.053f, 36.524f, -1513.140f, -685.227f, 45.055f, -1497.709f)
	//ZX@207Z
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"branchI"    , -666.844f, 38.457f, -1484.098f, -677.545f, 46.269f, -1502.609f)
	//ZX@210Z
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"branchC"    , -883.507f, 38.076f, -1804.428f, -865.747f, 48.046f, -1814.503f)



	//ZX@208ZWvA
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"set208"    , -421.183f, 1.736f, -1401.167f, -415.337f, 6.132f, -1407.986f)
	//ZX@201WvA
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"set201"    , -427.066f, 2.749f, -1301.720f, -418.306f, 6.221f, -1298.373f)
	//ZX@207WvA
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"set207"    , -648.476f, 2.733f, -1416.409f, -657.913f, 5.068f, -1414.068f)
	//ZX@206WvA
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"set206"    , -922.338f, 2.586f, -1456.753f, -931.842f, 5.605f, -1457.496f)
	//ZX@203WvA
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"set203"    , -898.432f, 5.410f, -1341.532f, -906.147f, 7.440f, -1347.561f)
	//ZX@210WvA
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"set210"    , -885.064f, 2.101f, -1894.747f, -875.707f, 5.118f, -1896.575f)
	//ZX@209WvA
	WK7STGPLINF_CAM(209, 0,"Housing"                ,"ޭ޲"             ,"set202"    , -656.571f, 4.595f, -1303.516f, -662.653f, 7.894f, -1310.736f)



	//ZX@n[}
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"branchA"    , -1289.652f, 2.719f, -1361.174f, -1273.977f, 9.089f, -1375.518f)
	//ZX@H
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"door_020801"    , -100.761f, 3.117f, -1923.660f, -120.636f, 10.537f, -1933.496f)
	//ZX@_Ci[
	WK7STGPLINF_CAM(208, 0,"Housing"                ,"ޭ޲"             ,"door_020802"    , -1098.562f, 4.190f, -2008.942f, -1107.136f, 10.965f, -2026.311f)


	//---------------------------------------------------------------------
	//H㔼@ftHg
	WK7STGPLINF_DEF(209, 0,"Central Road"                ,"޳"             )
	//ʘH㔼@ftHg
	WK7STGPLINF_CAM(209, 0,"Central Road"                ,"޳"             ,"branchC"    , 62.509f, 2.066f, -2336.764f, 48.935f, 8.573f, -2320.002f)
	//ʘH㔼@_Ci[
	WK7STGPLINF_CAM(209, 0,"Central Road"                ,"޳"             ,"branchD"    , -69.493f, 2.772f, -3242.118f, -62.852f, 14.028f, -3297.506f)
	//ʘH㔼@VKn[}
	WK7STGPLINF_CAM(209, 0,"Central Road"                ,"޳"             ,"branchZ"    , 100.525f, 5.170f, -2585.827f, 89.184f, 12.619f, -2602.759f)
	//ʘH㔼@dԂ
	WK7STGPLINF_CAM(209, 0,"Central Road"                ,"޳"             ,"branchM"    , 21.736f, 1.850f, -3677.855f, 19.610f, 5.766f, -3656.102f)
	//---------------------------------------------------------------------
	//H㔼2@ftHg
	WK7STGPLINF_DEF(209, 1,"Central Road"                ,"޳"             )
	//H㔼2@dԑ
	WK7STGPLINF_CAM(209, 1,"Central Road"                ,"޳"              ,"branchM"    , -27.724f, 2.393f, -3739.513f, -23.947f, 9.041f, -3720.597f)
	//H㔼2@́[}
	WK7STGPLINF_CAM(209, 1,"Central Road"                ,"޳"              ,"branchQ"    , -185.608f, 2.143f, -4280.957f, -202.822f, 9.936f, -4288.750f)
	//H㔼2@X֋ǂ
	WK7STGPLINF_CAM(209, 1,"Central Road"                ,"޳"              ,"door_020203"    , 23.241f, 1.812f, -4395.144f, 6.921f, 8.980f, -4406.270f)

	//---------------------------------------------------------------------
	//͂ꕔ@ftHg
	WK7STGPLINF_DEF(210, 0,"House"                ,"ʳ"             )
	//ʘH㔼@ftHg
	WK7STGPLINF_CAM(210, 0,"House"                ,"ʳ"             ,"door_021001"    , 0.246f, 5.555f, -40.356f, 5.801f, 12.463f, -59.339f)

	//---------------------------------------------------------------------
	//𕔉`@ftHg
	WK7STGPLINF_DEF(211, 0,"House"                ,"ʳ"             )
	//ʘH㔼@ftHg
	WK7STGPLINF_CAM(211, 0,"House"                ,"ʳ"             ,"branchB"    , 0.529f, 5.441f, -43.722f, 4.318f, 12.354f, -63.211f)
	//---------------------------------------------------------------------
	//𕔉`@ftHg
	WK7STGPLINF_DEF(212, 0,"House"                ,"ʳ"             )
	//ʘH㔼@ftHg
	WK7STGPLINF_CAM(212, 0,"House"                ,"ʳ"             ,"branchC"    , 39.667f, 0.784f, -196.765f, 28.023f, 6.885f, -180.359f)
	//---------------------------------------------------------------------
	//V[gJbgʘH@ftHg
	WK7STGPLINF_DEF(213, 0,"Shortcut Road"                ,""             )
	//V[gJbgʘH@_Ci[
	WK7STGPLINF_CAM(213, 0,"Shortcut Road"                ,""           ,"branchA"    , -377.989f, 2.251f, -2699.355f, -358.976f, 10.836f, -2704.658f)
	//V[gJbgʘH@ZX
	WK7STGPLINF_CAM(213, 0,"Shortcut Road"                ,""           ,"door_021301"    , -540.287f, 3.637f, -2407.418f, -551.301f, 10.964f, -2388.916f)


#endif

#ifdef	__K7SCN03_CPP__
	//==== ViI3E琁EVn  ====
	
	//---------------------------------------------------------------------
	//@ftHg
	WK7STGPLINF_DEF(300, 0,"Main Entrance"          ,"ƭޮ"          )
	//@X^[g
	WK7STGPLINF_CAM(300, 0,"Main Entrance"          ,"ƭޮ"             ,"branchA"    ,-0.446f, 22.478f, 365.705f, 0.079f, 21.313f, 342.629f)
	//@n[}
	WK7STGPLINF_CAM(300, 0,"Main Entrance"          ,"ƭޮ"             ,"branchB"    , 26.819f, 12.258f, 269.913f, 16.502f, 13.690f, 251.513f)
	
	//ʘH㔼@A[P[h
	WK7STGPLINF_CAM(300, 0,"Main Entrance"          ,"ƭޮ"             ,"branchC"    , -41.799f, 3.495f, -100.528f, -21.663f, 9.991f, -100.585f)
	
	//---------------------------------------------------------------------
	//A[P[h@ftHg
	WK7STGPLINF_DEF(321, 0,"Arcade"                    ,""          )
	//A[P[h@
	WK7STGPLINF_CAM(321, 0,"Arcade"         		 ,""             ,"branchA"    , -20.102f, 6.672f, -169.094f, -12.744f, 7.482f, -188.897f)
	//A[P[h@]ƈpnʘH
	WK7STGPLINF_CAM(321, 0,"Arcade"         		 ,""             ,"branchD"    , -174.393f, 7.818f, -452.356f, -151.098f, 9.577f, -453.100f)
	//A[P[h@A[P[h02
	WK7STGPLINF_CAM(321, 0,"Arcade"         		 ,""             ,"branchE"    , -6.636f, 4.538f, -761.961f, -5.352f, 12.555f, -741.754f)
	
	//---------------------------------------------------------------------
	//]ƈpnʘH@ftHg
//	WK7STGPLINF_DEF(322, 0,"Staff Passage"                    ,"ޭޮֳ ³"          )
	//]ƈpnʘH@A[P[h
//	WK7STGPLINF_CAM(322, 0,"Staff Passage"         	 ,"ޭޮֳ ³"   ,"branchA"    , -159.245f, 2.409f, -575.284f, -158.713f, 7.800f, -554.848f)
	//]ƈpnʘH@n[}
//	WK7STGPLINF_CAM(322, 0,"Staff Passage"         	 ,"ޭޮֳ ³"   ,"branchB"    , -294.497f, -14.370f, -546.553f, -315.333f, -11.755f, -556.224f)
	//]ƈpnʘH@]ƈpn
//	WK7STGPLINF_CAM(322, 0,"Staff Passage"         	 ,"ޭޮֳ ³"   ,"branchC"    , -428.632f, 2.803f, -546.559f, -446.564f, 5.882f, -557.640f)
	
	//---------------------------------------------------------------------
	//]ƈpn@ftHg
//	WK7STGPLINF_DEF(323, 0,"Staff Gate"                    ,"ޭޮֳ"          )
	//]ƈpn@]ƈpnʘH
//	WK7STGPLINF_CAM(323, 0,"Staff Gate"         	 ,"ޭޮֳ"   ,"branchA"    , -504.083f, 1.263f, -536.306f, -556.987f, 11.400f, -614.051f)
	//]ƈpn@ߏ֕
//	WK7STGPLINF_CAM(323, 0,"Staff Gate"         	 ,"ޭޮֳ"   ,"branchD"    , -513.255f, 2.907f, -629.532f, -528.428f, 7.846f, -622.662f)
	//]ƈpn@H
//	WK7STGPLINF_CAM(323, 0,"Staff Gate"         	 ,"ޭޮֳ"   ,"branchB"    , -668.569f, 2.333f, -344.535f, -653.031f, 8.137f, -349.702f)
	//]ƈpn@H
//	WK7STGPLINF_CAM(323, 0,"Staff Gate"         	 ,"ޭޮֳ"   ,"branchC"    , -711.008f, 21.395f, -356.151f, -728.324f, 22.127f, -357.348f)
	//]ƈpn@O
//	WK7STGPLINF_CAM(323, 0,"Staff Gate"         	 ,"ޭޮֳ"   ,"door_030302"    , -881.570f, 16.730f, -819.143f, -833.490f, 12.609f, -799.273f)
	//]ƈpn@́[}
//	WK7STGPLINF_CAM(323, 0,"Staff Gate"         	 ,"ޭޮֳ"   ,"branchZ"    , -881.570f, 16.730f, -819.143f, -833.490f, 12.609f, -799.273f)



	//---------------------------------------------------------------------
	//H@ftHg
//	WK7STGPLINF_DEF(323, 1,"Staff Cafeteria"                    ,"ݼ޳"          )
	//H@]ƈpn
//	WK7STGPLINF_CAM(323, 1,"Staff Cafeteria"         	 ,"ݼ޳"   ,"branchA"    , -624.041f, 3.640f, -252.947f, -615.855f, 7.118f, -267.871f)
	//H@]ƈpn
//	WK7STGPLINF_CAM(323, 1,"Staff Cafeteria"         	 ,"ݼ޳"   ,"branchB"    , -825.852f, 11.404f, -278.036f, -812.325f, 14.855f, -288.377f)

	//---------------------------------------------------------------------
	//ߏ֕@ftHg
//	WK7STGPLINF_DEF(323, 2,"Costume Room"                    ,""          )
//	//ߏ֕@]ƈpn
//	WK7STGPLINF_CAM(323, 2,"Costume Room"         	 ,""   ,"branchA"    , -624.861f, 3.385f, -683.182f, -605.093f, 9.535f, -674.783f)
//	//ߏ֕@O
//	WK7STGPLINF_CAM(323, 2,"Costume Room"         	 ,""   ,"door_030301"    , -518.019f, 7.644f, -732.689f, -532.612f, 11.517f, -749.157f)

	//---------------------------------------------------------------------
	//O@ftHg
	WK7STGPLINF_DEF(324, 0,"ISZK String Quartet"                    ,"ISZK ݸ ï"          )
	//O@ߏ֕
	WK7STGPLINF_CAM(324, 0,"ISZK String Quartet"   ,"ISZK ݸ ï"   ,"branchZ"    , 529.907f, 13.004f, -1103.540f, 505.539f, 13.239f, -1106.838f)
	//O@Vl}S
	WK7STGPLINF_CAM(324, 0,"ISZK String Quartet"   ,"ISZK ݸ ï"   ,"door_030403"    , -443.620f, 8.205f, -1136.105f, -421.389f, 12.680f, -1121.175f)
	//O@Vl}R
	WK7STGPLINF_CAM(324, 0,"ISZK String Quartet"   ,"ISZK ݸ ï"   ,"door_030404"    , -208.872f, 5.487f, -1152.448f, -189.449f, 9.962f, -1134.011f)
	//O@Vl}Q
	WK7STGPLINF_CAM(324, 0,"ISZK String Quartet"   ,"ISZK ݸ ï"   ,"door_030405"    , 52.501f, 45.986f, -1160.802f, 53.155f, 37.034f, -1135.178f)
	//O@Vl}P
	WK7STGPLINF_CAM(324, 0,"ISZK String Quartet"   ,"ISZK ݸ ï"   ,"door_030406"    , 331.929f, 3.842f, -1147.931f, 312.959f, 8.553f, -1137.110f)
	//O@ʘH
	WK7STGPLINF_CAM(324, 0,"ISZK String Quartet"   ,"ISZK ݸ ï"   ,"branchF"    , -568.174f, 4.369f, -1116.880f, -520.178f, 15.266f, -1145.099f)
	//O@ϑ̏
	WK7STGPLINF_CAM(324, 0,"ISZK String Quartet"   ,"ISZK ݸ ï"   ,"door_030402"    , -518.673f, 2.846f, -875.955f, -529.001f, 6.321f, -862.296f)
	//O@́[}
	WK7STGPLINF_CAM(324, 0,"ISZK String Quartet"   ,"ISZK ݸ ï"   ,"branchH"    , -572.773f, 8.388f, -899.829f, -539.920f, 22.953f, -946.545f)


	//---------------------------------------------------------------------
	//Vl}S@ftHg
	WK7STGPLINF_DEF(325, 0,"Cinema4"                    ,"4"          )
	//Vl}S@O
	WK7STGPLINF_CAM(325, 0,"Cinema4"   ,"4"   ,"branchA"    , -439.604f, -25.828f, -1529.637f, -419.469f, -19.813f, -1538.292f)

	//---------------------------------------------------------------------
	//Vl}R@ftHg
	WK7STGPLINF_DEF(325, 1,"Cinema3"                    ,"3"          )
	//Vl}R@O
	WK7STGPLINF_CAM(325, 1,"Cinema3"   ,"3"   ,"branchA"    , -403.205f, -15.388f, -1439.495f, -403.365f, -17.040f, -1462.161f)

	//---------------------------------------------------------------------
	//Vl}Q@ftHg
	WK7STGPLINF_DEF(325, 2,"Cinema2"                    ,"2"          )
	//Vl}Q@O
	WK7STGPLINF_CAM(325, 2,"Cinema2"   ,"2"   ,"branchA"    , -435.159f, -26.069f, -1565.858f, -417.250f, -20.258f, -1553.131f)
	//Vl}Q@́[}
	WK7STGPLINF_CAM(325, 2,"Cinema2"   ,"2"   ,"branchZ"    , -376.211f, 9.108f, -1295.819f, -490.576f, -18.141f, -1235.314f)


	//---------------------------------------------------------------------
	//Vl}P@ftHg
	WK7STGPLINF_DEF(325, 3,"Cinema1"                    ,"1"          )
	//Vl}P@O
	WK7STGPLINF_CAM(325, 3,"Cinema1"   ,"1"   ,"branchA"    , -325.053f, -22.861f, -1553.036f, -346.837f, -17.722f, -1549.089f)

	//---------------------------------------------------------------------
	//~Xe[nEX@ftHg
	WK7STGPLINF_DEF(306, 0,"Freaky Fun House"                    ,"нذʳ"          )
	//~Xe[nEX@Lꂩ
	WK7STGPLINF_CAM(306, 0,"Freaky Fun House"   ,"нذʳ"   ,"branchE"    , -2454.345f, 48.624f, -1694.243f, -2453.510f, 39.055f, -1634.310f)
	//~Xe[nEX@[vL
	WK7STGPLINF_CAM(306, 0,"Freaky Fun House"   ,"нذʳ"   ,"door_030501"    , -2079.464f, 17.274f, -1599.176f, -2057.673f, 16.666f, -1598.422f)
	//~Xe[nEX@Lbgs
	WK7STGPLINF_CAM(306, 0,"Freaky Fun House"   ,"нذʳ"   ,"event_030529_0"    , -2117.677f, 13.617f, -1598.631f, -2096.976f, 7.664f, -1598.232f)
	//~Xe[nEX@LbgA
	WK7STGPLINF_CAM(306, 0,"Freaky Fun House"   ,"нذʳ"   ,"event_030528_0"    , -2145.907f, 11.843f, -1598.307f, -2167.199f, 8.568f, -1598.802f)
	//~Xe[nEX@SSL
	WK7STGPLINF_CAM(306, 0,"Freaky Fun House"   ,"нذʳ"   ,"door_030509"    , -2463.604f, 27.885f, -1724.598f, -2443.790f, 6.145f, -1674.252f)

	//---------------------------------------------------------------------
	//~Xe[nEX[vL@ftHg
	WK7STGPLINF_DEF(307, 0,"Loop da Loop"                    ,"ٰ  ٰ"          )
	//~Xe[nEX[vL@
	WK7STGPLINF_CAM(307, 0,"Loop da Loop"   ,"ٰ  ٰ"   ,"door_030505"    , -2046.365f, 1.316f, -1684.571f, -2067.776f, 9.277f, -1678.144f)
	//~Xe[nEX[vL@[bg
	WK7STGPLINF_CAM(307, 0,"Loop da Loop"   ,"ٰ  ٰ"   ,"branchB"    , -2273.438f, 1.446f, -2016.938f, -2254.818f, 42.050f, -1841.371f)

	//---------------------------------------------------------------------
	//~Xe[nEX[bg@ftHg
	WK7STGPLINF_DEF(308, 0,"Squeaker's Attack!"                    ,""          )
	//~Xe[nEX[bg@[vL
	WK7STGPLINF_CAM(308, 0,"Squeaker's Attack!"   ,""   ,"branchB"    , -2241.078f, 4.924f, -2012.981f, -2250.543f, 10.259f, -1994.454f)
	//~Xe[nEX[bg@΂̋
	WK7STGPLINF_CAM(308, 0,"Squeaker's Attack!"   ,""   ,"door_030502"    , -2229.063f, 2.738f, -1733.330f, -2249.754f, 7.959f, -1730.894f)

	//---------------------------------------------------------------------
	//~Xe[nEX΂̋@ftHg
	WK7STGPLINF_DEF(309, 0,"Burning Hot Hell!"                    ,"¼޺޸"          )
	//~Xe[nEX΂̋@[bg
	WK7STGPLINF_CAM(309, 0,"Burning Hot Hell!"   ,"¼޺޸"   ,"branchA"    , -2396.141f, 6.945f, -1825.784f, -2423.741f, 14.708f, -1875.381f)
	//~Xe[nEX΂̋@
	WK7STGPLINF_CAM(309, 0,"Burning Hot Hell!"   ,"¼޺޸"   ,"door_030508"    , -2986.644f, 5.119f, -1717.504f, -3010.387f, 15.948f, -1670.162f)
	//~Xe[nEX΂̋@邭X
	WK7STGPLINF_CAM(309, 0,"Burning Hot Hell!"   ,"¼޺޸"   ,"door_030503"    , -2983.535f, 10.416f, -1720.356f, -2994.319f, 11.323f, -1703.093f)


	//---------------------------------------------------------------------
	//~Xe[nEX邭Q@ftHg
	WK7STGPLINF_DEF(310, 0,"Spinny-Spinny"                    ,"ٸ9"          )
	//~Xe[nEX邭Q@΂̋
	WK7STGPLINF_CAM(310, 0,"Spinny-Spinny"   ,"ٸ9"   ,"branchB"    , -3025.832f, 5.855f, -1813.650f, -2977.997f, 8.318f, -1842.770f)

	//---------------------------------------------------------------------
	//L[ĂǂPF@ftHg
	WK7STGPLINF_DEF(312, 0,"Killered Mansion 1F"                    ,"װïݼ1F"          )
	//L[ĂǂPF@O
	WK7STGPLINF_CAM(312, 0,"Killered Mansion 1F"     ,"װïݼ1F"           ,"door_030704"    , -59.274f, 9.530f, -2292.448f, -61.014f, 10.500f, -2256.203f)

	//---------------------------------------------------------------------
	//L[ĂǂQF@ftHg
	WK7STGPLINF_DEF(312, 1,"Killered Mansion 2F"     ,"װïݼ2F"          )
	//L[ĂǂQF@
	WK7STGPLINF_CAM(312, 1,"Killered Mansion 2F"     ,"װïݼ2F"           ,"branchA"    , -457.753f, 55.946f, -2253.555f, -447.297f, 58.800f, -2235.491f)
	//L[ĂǂQF@
	WK7STGPLINF_CAM(312, 1,"Killered Mansion 2F"     ,"װïݼ2F"           ,"curve1"    , -444.604f, 79.513f, -2216.066f, -435.024f, 73.281f, -2196.296f)


	//---------------------------------------------------------------------
	//L[ĂǂRF@ftHg
	WK7STGPLINF_DEF(312, 2,"Killered Mansion 3F"     ,"װïݼ3F"          )
	//L[ĂǂRF@
	WK7STGPLINF_CAM(312, 2,"Killered Mansion 3F"     ,"װïݼ3F"           ,"branchA"    , -250.253f, 101.140f, -2172.907f, -271.092f, 104.729f, -2170.861f)
	//L[ĂǂRF@
	WK7STGPLINF_CAM(312, 2,"Killered Mansion 3F"     ,"װïݼ3F"           ,"curve1"    , -313.950f, 128.691f, -2179.183f, -295.950f, 118.988f, -2171.370f)


	//---------------------------------------------------------------------
	//L[Ăǒ@ftHg
	WK7STGPLINF_DEF(313, 0,"Killerted Mansion TOP"     ,"ޮ"          )
	//L[ĂǂRF@Wv
	WK7STGPLINF_CAM(313, 0,"Killered Mansion TOP"     ,"ޮ"           ,"branchC"    , -345.438f, 181.899f, -2305.567f, -344.517f, 183.715f, -2291.597f)
	//L[ĂǂRF@
	WK7STGPLINF_CAM(313, 0,"Killered Mansion TOP"     ,"ޮ"           ,"branchB"    , -382.480f, 214.778f, -2261.750f, -362.251f, 207.032f, -2261.535f)

	//---------------------------------------------------------------------

	//~Xe[nEXoO@ftHg
//	WK7STGPLINF_DEF(315, 0,"Exit to Heaven"                    ,"ͳݽޱ޸"          )
	//~Xe[nEXoO@\t@[[h
//	WK7STGPLINF_CAM(315, 0,"Exit to Heaven"   ,"ͳݽޱ޸"   ,"curve2"    , -1556.123f, 6.507f, -2214.857f, -1534.679f, 5.115f, -2215.226f)

	//---------------------------------------------------------------------
	//A[P[h02@ftHg
	WK7STGPLINF_DEF(326, 0,"Passage"                    ,"³"          )
	//A[P[h02@Lꂩ
//	WK7STGPLINF_CAM(326, 0,"Passage"   ,"³"   ,"branchC"    , -20.448f, -77.039f, -1071.631f, -16.529f, -72.864f, -1092.530f)

	//---------------------------------------------------------------------
	//L@ftHg
	WK7STGPLINF_DEF(327, 0,"Adventure Plaza"                    ,""          )
	//L@A[P[h02
	WK7STGPLINF_CAM(327, 0,"Adventure Plaza"   ,""   ,"branchA"    , 11.601f, -74.196f, -1171.031f, 3.019f, -70.905f, -1190.654f)
	//L@n[}
	WK7STGPLINF_CAM(327, 0,"Adventure Plaza"   ,""   ,"branchY"    , 305.004f, -64.938f, -1274.703f, 258.680f, -60.939f, -1308.595f)
	//L@n[}iLn΁j
	WK7STGPLINF_CAM(327, 0,"Adventure Plaza"   ,""   ,"branchZ"    , -21.145f, -76.476f, -1646.994f, -5.026f, -72.493f, -1660.326f)
	//L@Ln
	WK7STGPLINF_CAM(327, 0,"Adventure Plaza"   ,""   ,"door_030602"    , -1.112f, -46.325f, -1609.458f, -0.514f, -54.620f, -1629.061f)
	//L@\t@[h
	WK7STGPLINF_CAM(327, 0,"Adventure Plaza"   ,""   ,"curve17"    , 215.856f, -65.785f, -1232.949f, 317.314f, -60.267f, -1285.567f)
	//L@~Xe[nEX
	WK7STGPLINF_CAM(327, 0,"Adventure Plaza"   ,""   ,"event_030601"    ,-321.056f, -67.684f, -1268.920f, -299.093f, -62.151f, -1285.662f )
	//L@L[ĂǓ
	WK7STGPLINF_CAM(327, 0,"Adventure Plaza"   ,""   ,"branchE"    , 204.664f, -40.335f, -1610.399f, 268.105f, -30.671f, -1692.730f)
	//L@~Xe[nEX
	WK7STGPLINF_CAM(327, 0,"Adventure Plaza"   ,""   ,"door_030601"    ,-221.332f, -21.215f, -1755.004f, -316.912f, -45.211f, -1679.573f)


	//---------------------------------------------------------------------
	//Ln@ftHg
	WK7STGPLINF_DEF(328, 0,"Hand In Grove"                    ,""          )
	//Ln@Lꂩ
	WK7STGPLINF_CAM(328, 0,"Hand In Grove"   ,""   ,"door_030603"    , 0.297f, 21.085f, 35.917f, 0.188f, 14.775f, 60.852f)
	//Ln@Ԑl
	WK7STGPLINF_CAM(328, 0,"Hand In Grove"   ,""   ,"door_030604"    , 13.388f, 4.298f, -47.848f, 8.499f, 5.594f, -68.760f)
	
	//---------------------------------------------------------------------
	
	//ԏO@ftHg
	WK7STGPLINF_DEF(329, 0,"Lobby"                    ,"ް"          )
	//ԏO@Ln
	WK7STGPLINF_CAM(329, 0,"Lobby"   ,"ް"   ,"door_030605"    , 85.647f, -77.596f, -2176.491f, 73.128f, -74.083f, -2159.198f)
	//ԏO@n[}
	WK7STGPLINF_CAM(329, 0,"Lobby"   ,"ް"   ,"branchB"    , 16.543f, -76.267f, -2046.516f, 25.296f, -72.738f, -2065.984f)
	//---------------------------------------------------------------------
	//ԏ@ftHg
	WK7STGPLINF_DEF(316, 0,"Parking Lot"          ,"ޮ"          )
	//ԏ@ftHg
	WK7STGPLINF_CAM(316, 0,"Parking Lot"          ,"ޮ"  ,   "branchA"    ,-37.148f, 5.646f, 313.696f, -46.274f, 10.306f, 293.785f )


	
	//==== ViI3E琁EJ[eBX̉ ====
	
	//---------------------------------------------------------------------
	//S@ftHg
	WK7STGPLINF_DEF(350, 0,"Under Iron Tower"          ,"ïĳ"          )
	//S@X^[g
	WK7STGPLINF_CAM(350, 0,"Under Iron Tower"                ,"ïĳ"             ,"curve1"    , 62.884f, 0.188f, -53.730f, 49.841f, 8.460f, -38.582f)
	//S@X^[g
	WK7STGPLINF_CAM(350, 0,"Under Iron Tower"                ,"ïĳ"             ,"set3"    , 73.932f, 0.403f, -64.153f, 62.320f, 8.282f, -47.520f)

	//S@
	WK7STGPLINF_CAM(350, 0,"Under Iron Tower"                ,"ïĳ"             ,"branchA"    , 116.865f, 1.550f, -140.891f, 100.874f, 8.197f, -127.955f)
	
	//---------------------------------------------------------------------
	//@ftHg
	WK7STGPLINF_DEF(351, 0,"Entrance"                  ,"ظ"           )
	//@S
	WK7STGPLINF_CAM(351, 0,"Entrance"                  ,"ظ"           ,"branchA"    , 96.072f, 2.473f, -192.967f, 89.726f, 8.197f, -173.113f)
	//@n[}
	WK7STGPLINF_CAM(351, 0,"Entrance"                  ,"ظ"           ,"branchB"    , -151.746f, 44.675f, -462.699f, -171.896f, 44.380f, -469.812f)
	//@
	WK7STGPLINF_CAM(351, 0,"Entrance"                  ,"ظ"           ,"door_035002"    ,-460.137f, 26.382f, -444.249f, -440.512f, 32.382f, -455.646f)

	
	//---------------------------------------------------------------------
	//@ftHg
	WK7STGPLINF_DEF(352, 0,"Garden"                    ,""              )
	//@
	WK7STGPLINF_CAM(352, 0,"Garden"                    ,""               ,"branchA"    ,-421.487f, 26.092f, -521.112f, -424.349f, 35.817f, -540.531f)
	//@ԏ
	WK7STGPLINF_CAM(352, 0,"Garden"                    ,""               ,"door_035001"    ,-119.759f, 30.357f, -673.077f, -138.321f, 32.114f, -686.713f)
	//@
	WK7STGPLINF_CAM(352, 0,"Garden"                    ,""               ,"branchC"    ,-414.251f, 34.910f, -905.098f, -412.540f, 32.648f, -926.217f)
	//@v[
	WK7STGPLINF_CAM(352, 0,"Garden"                    ,""               ,"door_035005"    ,-681.773f, 27.589f, -1099.172f, -661.004f, 36.116f, -1112.621f)

	
	//---------------------------------------------------------------------
	//K[W@ftHg
	WK7STGPLINF_DEF(353, 0,"Garage"                    ,"ڰ"          )
	//K[W@
	WK7STGPLINF_CAM(353, 0,"Garage"                    ,"ڰ"          ,"branchA"    ,-92.415f, 36.206f, -654.311f, -91.405f, 35.937f, -664.257f)
	

	
	//---------------------------------------------------------------------
	//@ftHg
	WK7STGPLINF_DEF(354, 0,"Main Room"                      ,""            )
	//@
	WK7STGPLINF_CAM(354, 0,"Main Room"                      ,""           ,"branchC"    ,-439.310f, 33.070f, -1018.727f, -417.570f, 37.648f, -1012.241f)
	//@n[}
	WK7STGPLINF_CAM(354, 0,"Main Room"                      ,""           ,"branchH"    ,-474.812f, 28.285f, -1171.988f, -455.291f, 30.521f, -1184.218f)
	//@ʘH
	WK7STGPLINF_CAM(354, 0,"Main Room"                      ,""           ,"branchA"    ,-190.378f, 29.367f, -1415.744f, -210.858f, 33.254f, -1405.689f)
	//@v[
	WK7STGPLINF_CAM(354, 0,"Main Room"                      ,""           ,"door_035003"    ,-509.098f, 29.440f, -1417.923f, -520.478f, 33.034f, -1400.035f)
	//@ˏ
	WK7STGPLINF_CAM(354, 0,"Main Room"                      ,""           ,"tama_035002"    ,-163.980f, 25.223f, -1132.129f, -155.562f, 30.619f, -1132.099f)


	
	//---------------------------------------------------------------------
	//ʘH@ftHg
	WK7STGPLINF_DEF(355, 0,"Passage"                      ,"Ŷ³"            )
	//ʘH@
	WK7STGPLINF_CAM(355, 0,"Passage"                      ,"Ŷ³"            ,"branchA"    ,-241.545f, 45.812f, -1513.754f, -249.526f, 50.445f, -1492.530f)
	//ʘH@v[
	WK7STGPLINF_CAM(355, 0,"Passage"                      ,"Ŷ³"            ,"door_035103"    ,-223.154f, 40.938f, -1613.550f, -244.553f, 48.308f, -1583.361f)
	//ʘH@n[}
	WK7STGPLINF_CAM(355, 0,"Passage"                      ,"Ŷ³"            ,"branchC"    ,-125.358f, 159.517f, -2602.396f, -135.484f, 163.458f, -2622.830f)
	//ʘH@ʑ
	WK7STGPLINF_CAM(355, 0,"Passage"                      ,"Ŷ³"            ,"branchB"    ,-125.358f, 159.517f, -2602.396f, -135.484f, 163.458f, -2622.830f)

	
	//---------------------------------------------------------------------
	//ʑʘH@ftHg
	WK7STGPLINF_DEF(356, 0,"HallWay"              ,"ޯ۳"         )
	//ʑʘH@ʘH
	WK7STGPLINF_CAM(356, 0,"HallWay"              ,"ޯ۳"          ,"branchC"    ,-169.468f, 160.883f, -2808.145f, -159.360f, 166.135f, -2787.999f)
	//ʑʘH@357xbh[
	WK7STGPLINF_CAM(356, 0,"Hallway"              ,"ޯ۳"          ,"branchE"    ,-485.620f, 161.068f, -2540.615f, -508.306f, 165.490f, -2539.419f)
	//ʑʘH@358xbh[Q
	WK7STGPLINF_CAM(356, 0,"Hallway"              ,"ޯ۳"          ,"branchA"    ,237.483f, 160.132f, -2532.484f, 257.476f, 165.490f, -2542.837f)
	//ʑʘH@n[}
	WK7STGPLINF_CAM(356, 0,"Hallway"              ,"ޯ۳"          ,"branchH"    ,-111.011f, 163.427f, -2972.579f, -126.508f, 163.380f, -2989.768f)
	//ʑʘH@LԂ
	WK7STGPLINF_CAM(356, 0,"Hallway"              ,"ޯ۳"          ,"door_035102"    ,-154.568f, 174.995f, -3002.426f, -152.895f, 176.935f, -3025.427f)

	
	//---------------------------------------------------------------------
	//v@ftHg
	WK7STGPLINF_DEF(357, 0,"Bedroom"     ,"ޯٰ"       )
	//v@ʑʘH
	WK7STGPLINF_CAM(357, 0,"Bedroom"     ,"ޯٰ"       ,"branchA"    ,-380.755f, 34.225f, -1413.088f, -355.160f, 35.165f, -1393.431f)
	
	//---------------------------------------------------------------------
	//QQ@ftHg
	WK7STGPLINF_DEF(358, 0,"Big Bedroom"               ,"ޯٰ"        )
	//QQ@ʑʘH
	WK7STGPLINF_CAM(358, 0,"Big Bedroom"               ,"ޯٰ"        ,"branchA"    ,117.562f, 29.662f, -1483.682f, 14.318f, 46.274f, -1407.105f)

	
	//---------------------------------------------------------------------
	//Lԁ@ftHg
	WK7STGPLINF_DEF(361, 0,"Hall"                      ,""           )
	//Lԁ@ʑʘH
	WK7STGPLINF_CAM(361, 0,"Hall"                      ,""           ,"door_035103"    ,-59.880f, 23.720f, -1579.739f, -40.345f, 30.859f, -1595.785f)



	//---------------------------------------------------------------------
	//v[@ftHg
	WK7STGPLINF_DEF(362, 0,"Pool"                      ,"߰"           )
	//v[@ʘH
	WK7STGPLINF_CAM(362, 0,"Pool"                      ,"߰"          ,"branchA"    ,-321.792f, 16.167f, -1033.828f, -305.772f, 23.745f, -1046.006f)
	//v[@Ԑl̕
	WK7STGPLINF_CAM(362, 0,"Pool"                      ,"߰"          ,"door_035105"    ,-449.458f, 8.640f, -1093.914f, -460.273f, -0.773f, -1109.939f)
	//v[@
	WK7STGPLINF_CAM(362, 0,"Pool"                      ,"߰"          ,"door_035111"    ,-584.011f, 53.612f, -702.891f, -585.360f, 36.116f, -683.474f)
	//v[@́[}
	WK7STGPLINF_CAM(362, 0,"Pool"                      ,"߰"          ,"branchH"    ,-300.456f, -5.549f, -1245.397f, -293.196f, -3.641f, -1222.415f)
	//v[@
	WK7STGPLINF_CAM(362, 0,"Pool"                      ,"߰"          ,"door_035109"    ,-417.234f, 24.504f, -972.179f, -412.761f, 30.637f, -965.669f)



	//---------------------------------------------------------------------
	//v[@ftHg
	WK7STGPLINF_DEF(362, 1,"Pool"                      ,"߰"           )
	//v[@ʘH
	WK7STGPLINF_CAM(362, 1,"Pool"                      ,"߰"            ,"branchA"    ,-202.925f, 30.146f, -983.715f, -202.721f, 31.691f, -1005.161f)
	
	//v[@ʘH
	WK7STGPLINF_CAM(362, 1,"Pool"                      ,"߰"            ,"door_035109"    ,-445.404f, 34.389f, -966.075f, -422.105f, 35.086f, -970.616f)
	//v[@ʘH
	WK7STGPLINF_CAM(362, 1,"Pool"                      ,"߰"            ,"door_035112"    ,-605.144f, 43.824f, -705.967f, -591.112f, 34.025f, -686.168f)



	//---------------------------------------------------------------------
	//v[BʘH@ftHg
	WK7STGPLINF_DEF(364, 0,"Pocket Way"                ,"³"          )
	//v[BʘH@v[
	WK7STGPLINF_CAM(364, 0,"Pocket Way"                ,"³"          ,"door_035108"    ,-530.596f, -20.355f, -1121.179f, -509.613f, -14.058f, -1120.661f)
	//v[BʘH@n[}
	WK7STGPLINF_CAM(364, 0,"Pocket Way"                ,"³"          ,"branchB"    ,-583.388f, -58.606f, -1120.316f, -604.362f, -52.276f, -1120.830f)
	
	//---------------------------------------------------------------------
	//v[@ftHg
	WK7STGPLINF_DEF(363, 0,"Stuffed Animal Room"       ,"ʸ"         )

	//---------------------------------------------------------------------
	//Ln@ftHg
	WK7STGPLINF_DEF(365, 0,"Hand In Grove"       ,""         )
	//Ln@R͓
	WK7STGPLINF_CAM(365, 0,"Hand In Grove"       ,""         ,"door_035106"    ,-28.225f, 0.924f, 68.970f, -15.483f, 8.267f, 84.736f)
	//Ln@ԕ
	WK7STGPLINF_CAM(365, 0,"Hand In Grove"       ,""         ,"door_035107"    ,-40.650f, 20.856f, -15.368f, -25.964f, 16.686f, -30.593f)

#endif

#ifdef	__K7SCN04_CPP__
	
	
	//==== ViI4EgEh~jJ ====
	//---------------------------------------------------------------------
	//X^[gn_O
	WK7STGPLINF_DEF(410, 0,"Campanile"          ,"۳"          )
	//O@X^[gn_
	WK7STGPLINF_CAM(410, 0,"Campanile"          ,"۳"          ,"branchB"    ,-352.009f, 5.542f, -249.337f, -373.509f, 10.282f, -241.555f)
	//O@X^[gn_
	WK7STGPLINF_CAM(410, 0,"Campanile"          ,"۳"          ,"dominica_start"    ,-498.123f, 2.067f, -226.125f, -515.216f, 11.373f, -235.257f)

	//---------------------------------------------------------------------
	//VK[
	WK7STGPLINF_DEF(411, 0,"Back of Campanile"          ,"۳"          )
	//VK[O
	WK7STGPLINF_CAM(411, 0,"Back of Campanile"          ,"۳"          ,"branchB"    ,-321.590f, 4.325f, -247.832f, -339.403f, 13.827f, -246.920f)
	//VK[@n[}
	WK7STGPLINF_CAM(411, 0,"Back of Campanile"          ,"۳"          ,"branchC"    ,-11.596f, 18.056f, -356.252f, -13.857f, 12.345f, -379.582f)
	//VK[@V[gJbg
	WK7STGPLINF_CAM(411, 0,"Back of Campanile"          ,"۳"          ,"door_040102"    ,210.470f, 12.317f, -311.427f, 232.586f, 12.964f, -301.810f)
	//VK[@̒
	WK7STGPLINF_CAM(411, 0,"Back of Campanile"          ,"۳"          ,"branchD"    ,154.103f, 26.029f, -375.385f, 121.115f, 2.963f, -415.359f)

	//---------------------------------------------------------------------
	//
	WK7STGPLINF_DEF(412, 0,"Random Town"          ,"ֲ"          )
	//̒@VK[
	WK7STGPLINF_CAM(412, 0,"Random Town"          ,"ֲ"          ,"branchE"    ,-142.957f, 10.136f, 720.031f, -147.950f, 13.886f, 663.309f)
	//̒@ʂ
	WK7STGPLINF_CAM(412, 0,"Random Town"          ,"ֲ"          ,"branchC2"    ,-4.654f, 34.349f, -434.290f, -37.521f, 5.227f, -468.878f)

	//---------------------------------------------------------------------
	//
	WK7STGPLINF_DEF(413, 0,"Avenu"          ,"޵"          )
	//ʂ@̒
	WK7STGPLINF_CAM(413, 0,"Avenu"          ,"޵"          ,"branchD1"    ,537.230f, 10.559f, -1564.104f, 546.439f, 10.913f, -1616.982f)
	//ʂ@n[}
	WK7STGPLINF_CAM(413, 0,"Avenu"          ,"޵"          ,"branchZ"    ,1142.796f, 10.675f, -1695.697f, 1160.286f, 16.550f, -1704.896f)
	//ʂ@O
	WK7STGPLINF_CAM(413, 0,"Avenu"          ,"޵"          ,"branchG"    ,1316.211f, 6.984f, -1723.562f, 1297.430f, 13.586f, -1729.096f)
	//ʂ@V[gJbg
	WK7STGPLINF_CAM(413, 0,"Avenu"          ,"޵"          ,"door_040410"    ,808.592f, 11.574f, -1621.661f, 809.012f, 13.827f, -1601.153f)


	//---------------------------------------------------------------------
	//
	WK7STGPLINF_DEF(415, 0,"Housing Estate"          ,"ޭ޲"          )
	//O@ʂ
	WK7STGPLINF_CAM(415, 0,"Housing Estate"          ,"ޭ޲"          ,"branchG"    ,947.173f, 4.856f, -1776.560f, 953.938f, 13.859f, -1759.698f)
	//O@
	WK7STGPLINF_CAM(415, 0,"Housing Estate"          ,"ޭ޲"          ,"branchB"    ,1179.055f, 6.640f, -929.214f, 1162.225f, 10.909f, -945.812f)
	//O@V[gJbg
	WK7STGPLINF_CAM(415, 0,"Housing Estate"          ,"ޭ޲"          ,"door_040103"    ,703.110f, 5.929f, -1086.293f, 723.648f, 15.791f, -1077.556f)
	//O@Wv
	WK7STGPLINF_CAM(415, 0,"Housing Estate"          ,"ޭ޲"          ,"branchI"    ,1024.379f, 47.375f, -1354.486f, 1014.328f, 38.855f, -1337.685f)
	//O@Wv
	WK7STGPLINF_CAM(415, 0,"Housing Estate"          ,"ޭ޲"          ,"branchH"    ,962.000f, 1.112f, -1334.874f, 970.766f, 5.132f, -1337.521f)

	//---------------------------------------------------------------------
	//
	WK7STGPLINF_DEF(420, 0,"Shrine 1F"          ,"޳1"          )
	// O
	WK7STGPLINF_CAM(420, 0,"Shrine 1F"          ,"޳1"          ,"branchA1"    ,18.405f, 20.717f, 313.926f, 2.627f, 9.055f, 260.742f)
	// n[}
	WK7STGPLINF_CAM(420, 0,"Shrine 1F"          ,"޳1"          ,"branchK"    ,92.944f, 29.744f, 67.960f, 88.020f, 21.318f, 88.316f)
	// 2F
	WK7STGPLINF_CAM(420, 0,"Shrine 1F"          ,"޳1"          ,"branchA2"    ,-72.459f, 23.589f, 79.204f, -104.175f, 1.305f, 120.137f)

	//---------------------------------------------------------------------
	//
	WK7STGPLINF_DEF(420, 1,"Shrine 2F"          ,"޳2"          )
	//QF ʘH
	WK7STGPLINF_CAM(420, 1,"Shrine 2F"          ,"޳2"          ,"branchC1"    ,5.181f, 59.820f, 219.444f, -49.278f, 53.914f, 237.889f)
	//QF ʘHB
	WK7STGPLINF_CAM(420, 1,"Shrine 2F"          ,"޳2"          ,"branchC2"    ,65.001f, 102.466f, 91.666f, 83.664f, 59.714f, 112.405f)
	//QF V[gJbgF
	WK7STGPLINF_CAM(420, 1,"Shrine 2F"          ,"޳2"          ,"door_040411"    ,-78.456f, 50.994f, 97.516f, -73.753f, 56.341f, 40.867f)

	//---------------------------------------------------------------------
	//
	WK7STGPLINF_DEF(421, 0,"Shrine Alley"          ,"޳³"          )
	//ʘH@1F
	WK7STGPLINF_CAM(421, 0,"Shrine Alley"          ,"޳³"           ,"branchB1"    ,-110.759f, 4.249f, -121.114f, -123.271f, 8.663f, -119.181f)
	//ʘH@2F
	WK7STGPLINF_CAM(421, 0,"Shrine Alley"          ,"޳³"        ,"branchB2"    ,-122.568f, 52.898f, 51.713f, -119.384f, 51.409f, 29.431f)
	//ʘH@2FB
	WK7STGPLINF_CAM(421, 0,"Shrine Alley"          ,"޳³"        ,"branchB3"    ,163.153f, 45.234f, -138.414f, 116.549f, 51.062f, -115.835f)
	//ʘH 
	WK7STGPLINF_CAM(421, 0,"Shrine Alley"          ,"޳³"        ,"branchB4"    ,-0.771f, 7.917f, -828.551f, -0.331f, 10.418f, -853.917f)

	//---------------------------------------------------------------------
	//z[
	WK7STGPLINF_DEF(422, 0,"Old Shrine"          ,"޳"          )
	//z[
	WK7STGPLINF_CAM(422, 0,"Old Shrine"          ,"޳"          ,"branchD1"    ,-10.286f, 14.353f, -340.364f, -5.495f, 11.250f, -361.511f)
	//z[
	WK7STGPLINF_CAM(422, 0,"Old Shrine"          ,"޳"          ,"branchD2"    ,18.272f, -1.410f, -685.955f, 9.108f, 7.700f, -695.975f)

	//---------------------------------------------------------------------
	//
	WK7STGPLINF_DEF(423, 0,"Waiting Room"          ,""          )
	//ҍ@z[
	WK7STGPLINF_CAM(423, 0,"Waiting Room"          ,""          ,"branchE1"    ,5.584f, 6.419f, -573.967f, 1.356f, 13.209f, -555.555f)
	//ҍ@n[}
	WK7STGPLINF_CAM(423, 0,"Waiting Room"          ,""          ,"branchK"    ,87.834f, 2.499f, -685.570f, 119.061f, 25.627f, -645.080f)
	//ҍ@Ki
	WK7STGPLINF_CAM(423, 0,"Waiting Room"          ,""          ,"branchE2"    ,-134.728f, 2.513f, -671.202f, -119.007f, 12.677f, -657.590f)

	//---------------------------------------------------------------------
	//
	WK7STGPLINF_DEF(425, 0,"Grand Stairs"          ,"޲"          )
	//Ki@ҍ
	WK7STGPLINF_CAM(425, 0,"Grand Stairs"          ,"޲"          ,"branchG1"    ,-115.699f, 1.483f, -637.371f, -77.502f, 31.355f, -615.594f)
	//Ki@ZʘH
	WK7STGPLINF_CAM(425, 0,"Grand Stairs"          ,"޲"          ,"branchB"    ,-557.971f, 88.554f, -640.617f, -532.349f, 93.286f, -616.493f)


	//---------------------------------------------------------------------
	//
	WK7STGPLINF_DEF(441, 0,"Housing Street"          ,"ޭ³"          )
	//ZʘH@Ki
	WK7STGPLINF_CAM(441, 0,"Housing Street"          ,"ޭ³"          ,"branchA"    ,-9.098f, -0.725f, -200.153f, -10.202f, 10.645f, -216.914f)
	//ZʘH@n[}
	WK7STGPLINF_CAM(441, 0,"Housing Street"          ,"ޭ³"          ,"branchB"    ,91.982f, 0.693f, -274.911f, 71.759f, 9.641f, -268.850f)
	//ZʘH@AgG
	WK7STGPLINF_CAM(441, 0,"Housing Street"          ,"ޭ³"          ,"branchC"    ,-496.991f, 4.924f, -171.100f, -497.383f, 11.832f, -190.103f)
	//ZʘH@KiʘH
	WK7STGPLINF_CAM(441, 0,"Housing Street"          ,"ޭ³"          ,"branchD"    ,-235.378f, 2.164f, -264.693f, -248.100f, 10.650f, -283.341f)
	//ZʘH@V[gJbgsN
	WK7STGPLINF_CAM(441, 0,"Housing Street"          ,"ޭ³"          ,"door_040412"    ,-391.655f, 0.761f, -163.203f, -387.917f, 20.650f, -120.943f)


	//---------------------------------------------------------------------
	//
	WK7STGPLINF_DEF(441, 1,"Atelier"          ,"ش"          )
	//AgG@ZʘH
	WK7STGPLINF_CAM(441, 1,"Atelier"          ,"ش"          ,"branchC"    ,-585.231f, 22.968f, -129.165f, -567.905f, 7.968f, -136.976f)

	//---------------------------------------------------------------------
	//
	WK7STGPLINF_DEF(442, 0,"Stairs"          ,"³"          )
	//KiʘH@ZʘH
	WK7STGPLINF_CAM(442, 0,"Stairs"          ,"³"          ,"branchB"    ,-219.047f, 5.754f, -233.252f, -234.383f, 19.086f, -261.929f)
	//KiʘH@ԍL
	WK7STGPLINF_CAM(442, 0,"Stairs"          ,"³"          ,"branchA"    ,-101.274f, 31.855f, -602.499f, -108.031f, 32.012f, -575.202f)
	//KiʘH@n[}
	WK7STGPLINF_CAM(442, 0,"Stairs"          ,"³"          ,"branchC"    ,-408.643f, 27.528f, -361.341f, -398.622f, 34.155f, -380.724f)

	//---------------------------------------------------------------------
	//
	WK7STGPLINF_DEF(443, 0,"Wind Mill"          ,"̳"          )
	//ԍL@KiʘH
	WK7STGPLINF_CAM(443, 0,"Wind Mill"          ,"̳"          ,"branchB"    ,-100.026f, 3.154f, -616.411f, -109.143f, 16.995f, -628.394f)
	//ԍL@KiʘH
	WK7STGPLINF_CAM(443, 0,"Wind Mill"          ,"̳"          ,"branchA"    ,-632.161f, 7.955f, -718.655f, -630.674f, 15.295f, -741.962f)

	//---------------------------------------------------------------------
	//
	WK7STGPLINF_DEF(444, 0,"Trevor's Home"          ,"ڳާòظ"          )
	//go[̉Ɓ@Ԃ
	WK7STGPLINF_CAM(444, 0,"Trevor's Home"          ,"ڳާòظ"          ,"branchB"    ,-630.931f, 17.785f, -713.606f, -641.617f, 9.477f, -681.267f)
	//go[̉Ɓ@n[}
	WK7STGPLINF_CAM(444, 0,"Trevor's Home"          ,"ڳާòظ"          ,"zan_040154"    ,-741.313f, 21.181f, -645.345f, -728.697f, 35.773f, -673.922f)
	//go[̉Ɓ@u
	WK7STGPLINF_CAM(444, 0,"Trevor's Home"          ,"ڳާòظ"          ,"branchA"    ,-776.266f, 48.986f, -365.219f, -805.764f, 58.859f, -401.208f)
	//go[̉Ɓ@Ƃ̒
	WK7STGPLINF_CAM(444, 0,"Trevor's Home"          ,"ڳާòظ"          ,"door_040403"    ,-953.517f, 54.133f, -491.205f, -982.122f, 53.605f, -510.425f)
	//go[̉Ɓ@V[gJbg
	WK7STGPLINF_CAM(444, 0,"Trevor's Home"          ,"ڳާòظ"          ,"door_040407"    ,-1089.808f, 49.799f, -720.363f, -1118.950f, 54.900f, -672.410f)
	//go[̉Ɓ@V[gJbgF
	WK7STGPLINF_CAM(444, 0,"Trevor's Home"          ,"ڳާòظ"          ,"door_040408"    ,-1098.666f, 49.878f, -744.788f, -1132.476f, 56.814f, -744.167f)
	//go[̉Ɓ@V[gJbgsN
	WK7STGPLINF_CAM(444, 0,"Trevor's Home"          ,"ڳާòظ"          ,"door_040409"    ,-1087.609f, 51.728f, -761.819f, -1103.980f, 55.208f, -792.481f)


	//---------------------------------------------------------------------
	//
	WK7STGPLINF_DEF(444, 1,"Hill"          ,""          )
	//u@g@[@
	WK7STGPLINF_CAM(444, 1,"Hill"          ,""          ,"branchA"    ,-699.026f, 45.486f, -345.104f, -720.977f, 48.654f, -372.436f)

	//---------------------------------------------------------------------
	//
	WK7STGPLINF_DEF(445, 0,"Trevor's Corridor"          ,"ڳާò۳"          )
	//ƃ@[@Ƃ
	WK7STGPLINF_CAM(445, 0,"Trevor's Corridor"          ,"ڳާò۳"          ,"branchB"    ,298.169f, 69.158f, -239.952f, 271.109f, 70.709f, -226.988f)

	//---------------------------------------------------------------------
	//==== ViISEgEj[[N ====
	//---------------------------------------------------------------------
	//u[hEFC
	WK7STGPLINF_DEF(430, 0,"BroadWay"          ,"۰޳"          )

	WK7STGPLINF_CAM(430, 0,"BroadWay"          ,"۰޳"          ,"branchA"    ,58.856f, 3.553f, 534.213f, 80.766f, 10.481f, 539.945f)

#endif

#ifdef	__K7SCN05_CPP__
	//==== ViI5EΊEzeP ====
	//---------------------------------------------------------------------
	//ze1F
	WK7STGPLINF_DEF(511, 0,"Lobby"          ,"ް"          )
	//ze1F@n[}
 	WK7STGPLINF_CAM(511, 0,"Lobby"          ,"ް"         ,"branchH"    ,-133.716f, 21.169f, -141.559f, -154.625f, 9.700f, -163.463f )
	//zeJnʒu
	WK7STGPLINF_CAM(511, 0,"Lobby"          ,"ް"         ,"Front"      ,54.583f, 3.455f, -163.127f, 75.508f, 16.621f, -140.506f )
	//ze1F@Gx[^[
	WK7STGPLINF_CAM(511, 0,"Lobby"          ,"ް"         ,"door_051101"    ,-166.557f, 15.227f, -293.540f, -138.694f, -1.595f, -244.208f)

	//---------------------------------------------------------------------
	//ze2F
	WK7STGPLINF_DEF(512, 0,"2F Hallway"          ,"2F۳"          )
	//ze2F Gx[^[
	WK7STGPLINF_CAM(512, 0,"2F Hallway"          ,"2F۳"          ,"door_051201"    ,-133.822f, 1.931f, -262.841f, -159.683f, 12.963f, -284.667f)
	//ze2F QOR
	WK7STGPLINF_CAM(512, 0,"2F Hallway"          ,"2F۳"          ,"branch4"    ,-135.051f, 4.040f, -465.544f, -102.136f, 14.182f, -452.320f)
	//ze2F QOP
	WK7STGPLINF_CAM(512, 0,"2F Hallway"          ,"2F۳"          ,"branch6"    ,77.573f, 26.742f, -459.427f, 102.163f, 7.900f, -479.368f)
	//ze2F n[}
	WK7STGPLINF_CAM(512, 0,"2F Hallway"          ,"2F۳"          ,"branch2"    ,107.078f, 14.289f, -21.458f, 90.910f, 10.381f, 4.573f)


	//---------------------------------------------------------------------
	//ze3F
	WK7STGPLINF_DEF(513, 0,"3F Hallway"          ,"3F۳"          )
	//ze3F Gx[^
	WK7STGPLINF_CAM(513, 0,"3F Hallway"          ,"3F۳"          ,"door_051301"    ,-145.186f, 4.588f, -289.195f, -174.547f, 12.377f, -271.194f)
	//ze3F @306
	WK7STGPLINF_CAM(513, 0,"3F Hallway"          ,"3F۳"          ,"branch1"    ,-66.040f, 10.009f, 86.247f, -100.402f, 12.277f, 72.115f)
	//ze3F @303
	WK7STGPLINF_CAM(513, 0,"3F Hallway"          ,"3F۳"          ,"branch4"    ,-138.270f, 15.224f, -465.538f, -104.010f, 10.636f, -453.631f)
	//ze3F @n[}
	WK7STGPLINF_CAM(513, 0,"3F Hallway"          ,"3F۳"          ,"branch2"    ,109.952f, 20.597f, -17.510f, 89.040f, 12.182f, 14.683f)


	//---------------------------------------------------------------------
	//ze4F
	WK7STGPLINF_DEF(514, 0,"4F Hallway"          ,"4F۳"          )
	//ze4F Gx[^
	WK7STGPLINF_CAM(514, 0,"4F Hallway"          ,"4F۳"          ,"door_051401"    ,-144.381f, 4.538f, -290.849f, -170.839f, 13.281f, -269.673f)
	//ze4F 404
	WK7STGPLINF_CAM(514, 0,"4F Hallway"          ,"4F۳"          ,"branch3"    ,99.146f, 21.235f, -249.246f, 74.678f, 0.545f, -190.516f)
	//ze4F 406
	WK7STGPLINF_CAM(514, 0,"4F Hallway"          ,"4F۳"          ,"branch1"    ,-73.202f, 28.777f, 57.791f, -104.967f, 10.931f, 65.416f)
	//ze4F n[}
	WK7STGPLINF_CAM(514, 0,"4F Hallway"          ,"4F۳"          ,"branch2"    ,104.308f, 28.135f, -11.967f, 93.930f, 18.756f, 5.715f)

	//---------------------------------------------------------------------
	//ze5F
	WK7STGPLINF_DEF(515, 0,"5F Hallway"          ,"5F۳"          )
	//ze5F Gx[^
	WK7STGPLINF_CAM(515, 0,"5F Hallway"          ,"5F۳"          ,"door_051501"    ,-146.131f, 23.658f, -287.437f, -193.138f, -5.236f, -259.251f)
	//ze5F 502
	WK7STGPLINF_CAM(515, 0,"5F Hallway"          ,"5F۳"          ,"branch5"    ,-23.082f, 19.608f, -407.335f, -24.303f, 13.195f, -441.658f)
	//ze5F n[}
	WK7STGPLINF_CAM(515, 0,"5F Hallway"          ,"5F۳"          ,"branch2"    ,95.739f, 18.940f, 0.536f, 76.230f, 8.341f, 31.623f)

	//---------------------------------------------------------------------
	//ze6F
	WK7STGPLINF_DEF(516, 0,"6F Hallway"          ,"6F۳"          )
	//ze6F Gx[^
	WK7STGPLINF_CAM(516, 0,"6F Hallway"          ,"6F۳"          ,"door_051601"    ,-145.774f, 21.801f, -286.615f, -173.985f, 5.683f, -272.777f)
	//ze6F 601
	WK7STGPLINF_CAM(516, 0,"6F Hallway"          ,"6F۳"          ,"door_051603"    ,76.975f, 27.396f, -462.642f, 105.228f, 9.322f, -475.863f)
	//ze6F n[}
	WK7STGPLINF_CAM(516, 0,"6F Hallway"          ,"6F۳"          ,"branch2"    ,101.041f, 20.028f, 0.546f, 76.085f, 10.049f, 26.417f)

	//---------------------------------------------------------------------
	//ze7F
	WK7STGPLINF_DEF(517, 0,"7F Hallway"          ,"7F۳"          )
	//ze7F Gx[^
	WK7STGPLINF_CAM(517, 0,"7F Hallway"          ,"7F۳"          ,"door_051701"    ,-121.348f, 3.414f, -283.640f, -173.017f, 14.709f, -278.965f)
	//ze7F Ԑl̕
	WK7STGPLINF_CAM(517, 0,"7F Hallway"          ,"7F۳"          ,"door_051704"    ,-68.985f, 8.544f, -285.265f, -106.622f, 11.614f, -273.721f)
	//ze7F n[}
	WK7STGPLINF_CAM(517, 0,"7F Hallway"          ,"7F۳"          ,"branchH"    ,-134.801f, 4.841f, -250.345f, -173.245f, 9.291f, -286.695f)

	//---------------------------------------------------------------------
	//ze
	WK7STGPLINF_DEF(518, 0,"Roof"          ,"ޮ"          )
	//ze
	WK7STGPLINF_CAM(518, 0,"Roof"          ,"ޮ"          ,"door_051801"    ,-142.074f, 28.786f, -279.020f, -165.354f, 3.723f, -285.066f)
	//ze ォKi
	WK7STGPLINF_CAM(518, 0,"Roof"          ,"ޮ"          ,"door_051804"    ,-133.579f, 62.317f, -250.642f, -105.729f, 76.096f, -277.661f)
	//ze Ki牮
	WK7STGPLINF_CAM(518, 0,"Roof"          ,"ޮ"          ,"door_051803"    ,-121.960f, 61.016f, -307.979f, -137.234f, 75.383f, -277.628f)
	//ze 
	WK7STGPLINF_CAM(518, 0,"Roof"          ,"ޮ"          ,"door_051802"    ,-3.578f, 9.905f, -267.250f, 30.895f, 17.585f, -270.996f)

	//---------------------------------------------------------------------
	//ze 7KXC[g[
	WK7STGPLINF_DEF(519, 0,"Suite"          ,"ٰ"          )
	//ze7F Gx[^z[
	WK7STGPLINF_CAM(519, 0,"Suite"          ,"ٰ"          ,"door_051705"    ,-141.257f, 10.975f, -304.439f, -113.155f, 10.328f, -325.583f)
	//ze7F obNCg̒j̕
	WK7STGPLINF_CAM(519, 0,"Suite"          ,"ٰ"          ,"door_051706"    ,-87.211f, 9.909f, -426.742f, -72.107f, 14.159f, -457.855f)
	//---------------------------------------------------------------------
	//ze Ln
	WK7STGPLINF_DEF(520, 0,"Hand In Grove"          ,""          )
	//ze Ln
	WK7STGPLINF_CAM(520, 0,"Hand In Grove"          ,""           ,"branchH"    ,107.443f, 22.993f, 99.896f, 90.868f, 13.955f, 128.909f)
	//ze Ln
	WK7STGPLINF_CAM(520, 0,"Hand In Grove"          ,""           ,"door_051706"    ,108.847f, 22.129f, -207.440f, 91.431f, 12.085f, -236.132f)

	//---------------------------------------------------------------------
	//ze 2K
	WK7STGPLINF_DEF(522, 0,"2F GuestRoom"          ,"2"          )
	//ze 2fheya
	WK7STGPLINF_CAM(522, 0,"2F GuestRoom"          ,"2"          ,"branch4"    ,-124.503f, 2.214f, -409.128f, -102.465f, 13.313f, -433.897f)
	//ze 2fheya
	WK7STGPLINF_CAM(522, 0,"2F GuestRoom"          ,"2"          ,"branch6"    ,95.204f, 8.999f, -507.546f, 116.979f, 26.632f, -485.599f)
	//---------------------------------------------------------------------
	//ze 3K
	WK7STGPLINF_DEF(523, 0,"3F GuestRoom"          ,"3"          )
	//ze RK
	WK7STGPLINF_CAM(523, 0,"3F GuestRoom"          ,"3"          ,"branch4"    ,-127.960f, 19.640f, -397.180f, -115.564f, 5.922f, -426.932f)
	//ze RK
	WK7STGPLINF_CAM(523, 0,"3F GuestRoom"          ,"3"          ,"branch1"    ,-114.693f, 19.931f, 20.404f, -131.891f, 5.900f, 47.531f)
	//---------------------------------------------------------------------
	//ze 4K
	WK7STGPLINF_DEF(524, 0,"4F GuestRoom"          ,"4"          )
	//ze 4K
	WK7STGPLINF_CAM(524, 0,"4F GuestRoom"          ,"4"          ,"branch3"    ,36.879f, 2.464f, -194.873f, 57.987f, 13.845f, -220.591f)
	//ze 4K
	WK7STGPLINF_CAM(524, 0,"4F GuestRoom"          ,"4"          ,"branch1"    ,-135.385f, 22.052f, -2.566f, -118.110f, 9.782f, 25.218f)
	//---------------------------------------------------------------------
	//ze 5K
	WK7STGPLINF_DEF(525, 0,"5F GuestRoom"          ,"5"          )
	//ze 5K
	WK7STGPLINF_CAM(525, 0,"5F GuestRoom"          ,"5"          ,"branch5"    ,-36.515f, 11.326f, -506.456f, -12.453f, 22.977f, -483.140f)
	//ze 5K
	WK7STGPLINF_CAM(525, 0,"5F GuestRoom"          ,"5"          ,"branch2"    ,16.316f, 7.788f, 15.260f, 45.437f, 11.250f, 34.521f)
	//---------------------------------------------------------------------
	//ze 6K
	WK7STGPLINF_DEF(526, 0,"6F GuestRoom"          ,"6"          )
	//ze 6K
	WK7STGPLINF_CAM(526, 0,"6F GuestRoom"          ,"6"          ,"branch6"    ,87.814f, 2.917f, -516.792f, 110.468f, 13.659f, -491.533f)
	//---------------------------------------------------------------------



	//==== ViI5EΊEwZ ====
	
	//---------------------------------------------------------------------
	// 1K쑤L@ftHg
	WK7STGPLINF_DEF(551, 0,"Entrance"          ,"ݽ"          )
	// 1K쑤L@O
	WK7STGPLINF_CAM(551, 0,"Entrance"          ,"ݽ"             ,"door_055113"    , 818.171f, 9.496f, 15.015f, 878.846f, 18.570f, 0.710f)
	// 1K쑤L@n[}x
	WK7STGPLINF_CAM(551, 0,"Entrance"          ,"ݽ"             ,"branchJ"    , 804.460f, 51.851f, -3.232f, 805.474f, 49.753f, -24.616f)
	// 1K쑤L@ʘH
	WK7STGPLINF_CAM(551, 0,"Entrance"          ,"ݽ"             ,"branchA"    , 881.670f, 2.491f, -60.901f, 779.381f, 27.386f, -183.196f)
	// 1K쑤L@f[^[
	WK7STGPLINF_CAM(551, 0,"Entrance"          ,"ݽ"             ,"branchB"    ,844.856f, 46.629f, 51.883f, 825.671f, 45.001f, 33.016f )


	//---------------------------------------------------------------------
	// 1KkL@ftHg
	WK7STGPLINF_DEF(551, 1,"1F Passage"          ,"1F ۳"          )

	// 1KkL@554M02Q
	WK7STGPLINF_CAM(551, 1,"1F Passage"          ,"1F ۳"             ,"branchF"    , 498.774f, 10.968f, -264.280f, 511.593f, 10.568f, -255.256f)
	// 1KkL@554M04
	WK7STGPLINF_CAM(551, 1,"1F Passage"          ,"1F ۳"             ,"branchB"    , 238.394f, 1.216f, 95.967f, 258.157f, 5.605f, 99.335f)
	// 1KkL@554M07
	WK7STGPLINF_CAM(551, 1,"1F Passage"          ,"1F ۳"             ,"branchJ"    , 437.506f, 1.604f, 27.549f, 427.289f, 6.486f, 44.529f)
	// 1KkL@554M10
	WK7STGPLINF_CAM(551, 1,"1F Passage"          ,"1F ۳"             ,"branchE"    , 241.411f, 15.165f, -261.904f, 261.209f, 12.150f, -253.348f)
	// 1KkL@554M11
	WK7STGPLINF_CAM(551, 1,"1F Passage"          ,"1F ۳"             ,"branchI"    , 566.157f, 9.235f, 106.480f, 511.640f, 10.973f, 85.793f)
	// 1KkL@554M12
	WK7STGPLINF_CAM(551, 1,"1F Passage"          ,"1F ۳"             ,"branchK"    , 218.296f, 15.860f, -234.811f, 265.179f, 6.209f, -262.279f)

	// 1KkL@n[}[
	WK7STGPLINF_CAM(551, 1,"1F Passage"          ,"1F ۳"             ,"branchL"    , 83.931f, 8.600f, 115.015f, 97.627f, 10.586f, 94.142f)
	// 1KkL@1K쑤L
	WK7STGPLINF_CAM(551, 1,"1F Passage"          ,"1F ۳"             ,"branchA"    , 554.770f, 17.374f, -244.928f, 534.948f, 9.740f, -246.819f )

	// 1KkL@2K̘L
	WK7STGPLINF_CAM(551, 1,"1F Passage"          ,"1F ۳"             ,"door_055101"    , 150.382f, 5.048f, 110.008f, 166.802f, 9.327f, 91.537f)
	
	//---------------------------------------------------------------------
	// 2KL@ftHg
	WK7STGPLINF_DEF(551, 2,"2F Passage"          ,"2F ۳"          )
	// 2KL@H
	WK7STGPLINF_CAM(551, 2,"2F Passage"          ,"2F ۳"             ,"branchL"    , 328.918f, 72.511f, 114.702f, 343.199f, 72.211f, 98.431f)
	// 2KL@}كLn
	WK7STGPLINF_CAM(551, 2,"2F Passage"          ,"2F ۳"             ,"branchI"    , 419.291f, 64.300f, -28.006f, 430.289f, 70.074f, -49.739f)
	// 2KL@}كLno
	WK7STGPLINF_CAM(551, 2,"2F Passage"          ,"2F ۳"             ,"branchH"    , 612.194f, 63.847f, -260.566f, 633.309f, 68.630f, -249.565f)
	// 2KL@Z
	WK7STGPLINF_CAM(551, 2,"2F Passage"          ,"2F ۳"             ,"door_055102"    , 935.491f, 104.107f, -237.333f, 944.926f, 108.475f, -218.174f)
	// 2KL@n[}x
	WK7STGPLINF_CAM(551, 2,"2F Passage"          ,"2F ۳"             ,"branchB"    , 407.597f, 63.310f, 119.264f, 419.092f, 68.900f, 100.309f)
	// 2KL@n[}x2
	WK7STGPLINF_CAM(551, 2,"2F Passage"          ,"2F ۳"             ,"branchC"    , 663.356f, 71.562f, -234.085f, 680.653f, 72.019f, -243.584f)

	// 2KL@2K̖kx
	WK7STGPLINF_CAM(551, 2,"2F Passage"          ,"2F ۳"             ,"branchA"    , 337.299f, 66.468f, -266.148f, 320.041f, 70.908f, -247.442f)


	//---------------------------------------------------------------------
	// 2KLk@ftHg
	WK7STGPLINF_DEF(551, 3,"2F OpenSpace"          ,"2F ݽ߰"          )
	// 2KLk@1KkEJ
	WK7STGPLINF_CAM(551, 3,"2F OpenSpace"          ,"2F ݽ߰"          ,"branchA"    , 161.538f, 3.336f, 36.741f, 173.100f, 10.213f, 58.816f)
	// 2KLk@
	WK7STGPLINF_CAM(551, 3,"2F OpenSpace"          ,"2F ݽ߰"          ,"door_055700"    , 166.470f, 69.091f, -291.391f, 183.459f, 72.481f, -344.635f)
	// 2KLk@n[}x
	WK7STGPLINF_CAM(551, 3,"2F OpenSpace"          ,"2F ݽ߰"          ,"branchK"    , 216.455f, 65.957f, -244.624f, 239.982f, 71.204f, -253.796f)
	// 2KLk@H
	WK7STGPLINF_CAM(551, 3,"2F OpenSpace"          ,"2F ݽ߰"          ,"branchF"    ,209.654f, 63.862f, -69.666f, 232.704f, 72.822f, -77.289f)
	// 2KLk@2񃍃EJ
	WK7STGPLINF_CAM(551, 3,"2F OpenSpace"          ,"2F ݽ߰"          ,"branchB"    ,256.957f, 87.299f, -236.543f, 277.103f, 74.256f, -246.217f)


	//---------------------------------------------------------------------
	// 1KLQ@ftHg
	WK7STGPLINF_DEF(551, 4,"1F Passage"          ,"1F ۳"          )
	// 1KL@1K쑤L̂ق
	WK7STGPLINF_CAM(551, 4,"1F Passage"          ,"1F ۳"             ,"branchB"    , 844.310f, 3.499f, -116.050f, 863.580f, 11.318f, -110.083f)
	// 1KL@1K544M00OO
	WK7STGPLINF_CAM(551, 4,"1F Passage"          ,"1F ۳"             ,"branchF"    , 588.820f, 9.839f, -237.874f, 565.862f, 11.677f, -251.147f)
	// 1KL@1K̃EJ
	WK7STGPLINF_CAM(551, 4,"1F Passage"          ,"1F ۳"             ,"branchD"    , 603.741f, 13.086f, -245.829f, 577.077f, 11.850f, -252.285f)
	// 1KL@1KgC
	WK7STGPLINF_CAM(551, 4,"1F Passage"          ,"1F ۳"             ,"door_055001"    , 822.643f, 7.705f, -102.507f, 766.086f, 10.568f, -98.790f)

	
	//---------------------------------------------------------------------
	// wZ̈ف@ftHg
	WK7STGPLINF_DEF(552, 0,"Courtyard"          ,"Ŷ"          )
	//wZO@X^[g
	WK7STGPLINF_CAM(552, 0,"Courtyard"          ,"Ŷ"             ,"School_start"    ,1093.300f, -31.234f, -6.477f, 1073.845f, -21.695f, -4.806f)
	//wZO@
	WK7STGPLINF_CAM(552, 0,"Courtyard"          ,"Ŷ"             ,"door_055202"    , 969.880f, 11.966f, 9.702f, 945.705f, 10.001f, -2.565f)
	//wZO@Z
	WK7STGPLINF_CAM(552, 0,"Courtyard"          ,"Ŷ"             ,"branchE"    ,971.135f, 7.890f, -321.341f, 946.547f, 42.498f, -271.267f )
	//wZO@̈ق
	WK7STGPLINF_CAM(552, 0,"Courtyard"          ,"Ŷ"             ,"door_055201"    , 715.032f, -14.790f, -422.182f, 723.960f, -12.608f, -442.504f)


	//---------------------------------------------------------------------
	// ̈ف@ftHg
	WK7STGPLINF_DEF(553, 0,"Gymnasium"          ,""          )
	//̈ف@
	WK7STGPLINF_CAM(553, 0,"Gymnasium"          ,""             ,"door_055300"    , -115.335f, 1.368f, -293.729f, -94.951f, 8.136f, -293.059f)
	
	//---------------------------------------------------------------------
	// O@ftHg
	WK7STGPLINF_DEF(554, 0,"L2F#Classroom"          ,"L2F "          )
//	WK7STGPLINF_CAM(554, 0,"L2F#Classroom"          ,"L2F "             ,"branchF"    , )
	
	//---------------------------------------------------------------------
	// Q@ftHg
	WK7STGPLINF_DEF(554, 2,"L3A#Classroom"          ,"L3A "          )
	
	//---------------------------------------------------------------------
	// S@ftHg
	WK7STGPLINF_DEF(554, 4,"L4A#Classroom"          ,"L4A "          )
	
	//---------------------------------------------------------------------
	// V@ftHg
	WK7STGPLINF_DEF(554, 7,"L3F#Classroom"          ,"L3F "          )
	
	//---------------------------------------------------------------------
	// PO@ftHg
	WK7STGPLINF_DEF(554, 10,"L3D#Classroom"          ,"L3D "          )
	
	//---------------------------------------------------------------------
	// PP@ftHgv[g
	WK7STGPLINF_DEF(554, 11,"L4B#Classroom"          ,"L4B "          )
//	WK7STGPLINF_CAM(554, 11,"L4B#Classroom"          ,"L4B "             ,"branchF"    , )
	
	//---------------------------------------------------------------------
	// PQ@ftHg
	WK7STGPLINF_DEF(554, 12,"L3C#Classroom"          ,"L3C "          )
//	WK7STGPLINF_CAM(554, 12,"L3C#Classroom"          ,"L3C "             ,"branchF"    , )
	//---------------------------------------------------------------------
	// f[^@ftHg
	WK7STGPLINF_DEF(555, 0,"Data Room"          ,"ް"          )
	WK7STGPLINF_CAM(555, 0,"Data Room"          ,"ް"             ,"branchA"    ,696.614f, 57.149f, 49.067f, 724.863f, 51.991f, 33.670f)

	//---------------------------------------------------------------------
	// gC@ftHg
	WK7STGPLINF_DEF(556, 0,"Woman's Restroom"          ,"ޮĲ"          )
	WK7STGPLINF_CAM(556, 0,"Woman's Restroom"          ,"ޮĲ"             ,"branchA"    ,825.639f, 12.048f, 124.925f, 814.858f, 12.137f, 143.883f )

	//---------------------------------------------------------------------
	// }@ftHg
	WK7STGPLINF_DEF(557, 00,"Hand In Grove"          ,""              )

	WK7STGPLINF_CAM(557, 00,"Hand In Grove"          ,""             ,"branchC"    , 526.744f, 65.874f, -94.646f, 483.332f, 73.823f, -58.318f)
	//---------------------------------------------------------------------
	// Z@ftHg
	WK7STGPLINF_DEF(558, 00,"Principal's Office"          ,""              )
	//Z@
	WK7STGPLINF_CAM(558, 00,"Principal's Office"          ,""             ,"branchA"    ,1016.603f, 110.127f, -193.572f, 1000.825f, 110.911f, -209.473f)

	WK7STGPLINF_CAM(558, 00,"Principal's Office"          ,""             ,"branchB"    , 1076.138f, 104.922f, -245.508f, 1064.107f, 111.659f, -261.766f)
	// Z@
	WK7STGPLINF_CAM(558, 00,"Principal's Office"          ,""             ,"branchC"    , 966.378f, 105.940f, -205.417f, 976.540f, 110.307f, -186.820f)

	//---------------------------------------------------------------------
	// @ftHg
	WK7STGPLINF_DEF(559, 00,"Chairman Office"          ,"ؼ"              )
	WK7STGPLINF_CAM(559, 00,"Chairman Office"          ,"ؼ"            ,"branchA"    , 105.597f, 68.276f, -404.073f, 84.735f, 70.262f, -388.695f)
	//---------------------------------------------------------------------
	// H@ftHg
	WK7STGPLINF_DEF(560, 00,"Cafeteria"          ,"޳"              )
	//H@
	WK7STGPLINF_CAM(560, 00,"Cafeteria"          ,"޳"            ,"branchB"    , 145.394f, 62.907f, -55.863f, 119.287f, 74.513f, -102.861f)
	//H@o
	WK7STGPLINF_CAM(560, 00,"Cafeteria"          ,"޳"            ,"branchD"    , 379.935f, 87.378f, 39.007f, 341.794f, 60.289f, 69.913f)
	//---------------------------------------------------------------------

#endif

#ifdef	__K7SCN06_CPP__
	//==== ViIUEqE͓ ====
	//---------------------------------------------------------------------
	// @ftHg
	WK7STGPLINF_DEF(570, 00,"Entrance"          ,"ݶĳظ"              )
	//@X^[g
	WK7STGPLINF_CAM(570, 00,"Entrance"          ,"ݶĳظ"         ,"branchA"    , 6.986f, 5.710f, 788.849f, -1.052f, 24.356f, 796.706f)
	//@
	WK7STGPLINF_CAM(570, 00,"Entrance"          ,"ݶĳظ"         ,"branchB"    , 303.582f, 1.318f, -150.901f, 302.410f, 25.701f, -101.308f)
	//---------------------------------------------------------------------
	// Ap[g@ftHg
	WK7STGPLINF_DEF(571, 00,"Apartment"          ,"߰"              )
	// Ap[g@
	WK7STGPLINF_CAM(571, 00,"Apartment"          ,"߰"             ,"branchA"    , 421.939f, 52.027f, -93.132f, 335.802f, 10.000f, -97.269f)
	// Ap[g@
	WK7STGPLINF_CAM(571, 00,"Apartment"          ,"߰"             ,"branchB"    , 422.722f, 49.721f, -544.493f, 335.370f, 10.003f, -547.334f)


	//---------------------------------------------------------------------
	// RVA܂Ł@ftHg
	WK7STGPLINF_DEF(572, 00,"Open Space"          ,""              )
	//RVA܂Ł@X^[g
	WK7STGPLINF_CAM(572, 00,"Open Space"          ,""         ,"branchA"    , 316.201f, 8.902f, -555.956f, 266.913f, 31.763f, -539.383f)
	//RVA܂Ł@h[
	WK7STGPLINF_CAM(572, 00,"Open Space"          ,""         ,"branchB"    , -608.430f, 11.665f, -573.767f, -654.273f, 28.668f, -541.334f)

	//---------------------------------------------------------------------
	// Ki@ftHg
	WK7STGPLINF_DEF(574, 00,"Stairs"          ,""              )

	//---------------------------------------------------------------------
	// A@ftHg
	WK7STGPLINF_DEF(575, 00,"Hallway"          ,"³"              )
	//A@X^[g
	WK7STGPLINF_CAM(575, 00,"Hallway"          ,"³"         ,"branchA1"    , 398.492f, 9.707f, -440.929f, 381.110f, 11.771f, -428.448f)

	//---------------------------------------------------------------------
	// Ō̃n[}x@ftHg
	WK7STGPLINF_DEF(121, 01,"Harman's Room"          ,"ʰ"              )
	//Ō̃n[}@X^[g
	WK7STGPLINF_CAM(121, 01,"Harman's Room"          ,"ʰ"         ,"curve3"    , 270.351f, 1.667f, 2.585f, 286.583f, 9.964f, 15.109f)
	//Ō̃n[}x@³ۂ
	WK7STGPLINF_CAM(121, 01,"Harman's Room"          ,"ʰ"         ,"door_990001"    , -17.568f, 23.106f, 15.235f, -27.873f, -10.432f, -26.183f)
	//---------------------------------------------------------------------
	// Ō̃n[}x@ftHg
	WK7STGPLINF_DEF(122, 00,"Basement"          ,""              )
	//Ō̃n[}@X^[g
//	WK7STGPLINF_CAM(122, 00,"Basement"          ,""         ,"branchB2"    , 270.351f, 1.667f, 2.585f, 286.583f, 9.964f, 15.109f)

	//---------------------------------------------------------------------

#endif

#ifdef	__K7SCN07_CPP__
	//==== ViI0EVgEVZeBbN ====
	
	//---------------------------------------------------------------------
	// 1K 00
	WK7STGPLINF_DEF(771, 0,"Lobby"                     ,"ް"            )
	// 1K 01
	WK7STGPLINF_CAM(771, 0,"Lobby"                     ,"ް"            ,"branchA"    ,-37.283f, 23.673f, 92.920f, -22.616f, 24.705f, 71.382f)
	// 1K n[}̕1
	WK7STGPLINF_CAM(771, 0,"Lobby"                     ,"ް"            ,"branchE"    ,-35.062f, 27.061f, 73.441f, -25.489f, 26.645f, 49.190f)
	// 1K 03 u`
//	WK7STGPLINF_CAM(771, 0,"Lobby"                     ,"ް"            ,"branchF"    ,-8.031f, 16.417f, 111.914f, -10.960f, 8.813f, 132.660f)
	WK7STGPLINF_CAM(771, 0,"Lobby"                     ,"ް"            ,"branchF"    ,-3.503f, 2.732f, 105.017f, -8.844f, 12.745f, 124.201f)

	// 1K 04 `[gA
	WK7STGPLINF_CAM(771, 0,"Lobby"                     ,"ް"            ,"branchZ"    ,-42.383f, 1.877f, 16.567f, -66.359f, 6.027f, 19.797f)
	
	//---------------------------------------------------------------------
	// 1K 01
	WK7STGPLINF_DEF(771, 1,"Elevator Hall"                   ,"ްΰ"     )
	// 1K 00
//	WK7STGPLINF_CAM(771, 1,"Elevator Hall"                   ,"ްΰ"     ,"branchA"    ,-76.480f, 2.973f, -40.999f, -54.029f, 7.194f, -53.637f)
	WK7STGPLINF_CAM(771, 1,"Elevator Hall"                   ,"ްΰ"     ,"branchA"    ,-8.340f, 6.398f, -32.090f, -5.302f, 14.130f, -56.841f)

	// 1K n[}̕
	WK7STGPLINF_CAM(771, 1,"Elevator Hall"                   ,"ްΰ"     ,"branchD"    , -30.069f, 7.621f, -297.733f, -48.571f, 8.682f, -316.240f)
	// 1K 02ԏ
//	WK7STGPLINF_CAM(771, 1,"Elevator Hall"                   ,"ްΰ"     ,"branchC"    , 129.429f, 5.108f, -392.426f, 122.525f, 12.987f, -416.358f)
	WK7STGPLINF_CAM(771, 1,"Elevator Hall"                   ,"ްΰ"     ,"branchC"    , 130.481f, 1.098f, -390.569f, 130.622f, 11.387f, -414.582f)
	
	//---------------------------------------------------------------------
	// 1K 02
	WK7STGPLINF_DEF(771, 2,"Parking Lot"               ,"ޮ"       )
	// 1K 01
	WK7STGPLINF_CAM(771, 2,"Parking Lot"               ,"ޮ"       ,"branchC"    ,126.369f, 3.381f, -425.287f, 146.624f, 10.482f, -434.567f)
	// 1K 2K00
//	WK7STGPLINF_CAM(771, 2,"Parking Lot"               ,"ޮ"       ,"door_007101",-216.178f, 43.794f, 159.914f, -196.151f, 42.468f, 143.217f)
	
	//---------------------------------------------------------------------
	// 1K 03
	WK7STGPLINF_DEF(771, 3,"Entrance"                  ,"èظ"     )
	// 1K X^[g
//	WK7STGPLINF_CAM(771, 3,"Entrance"                  ,"èظ"     ,"curve19"    ,-9.533f, 17.794f, 284.642f, -12.266f, 13.855f, 305.597f)
	WK7STGPLINF_CAM(771, 3,"Entrance"                  ,"èظ"     ,"curve19"    ,-8.339f, 17.794f, 283.512f, -11.072f, 13.855f, 304.467f)

	// 1K 00
	WK7STGPLINF_CAM(771, 3,"Entrance"                  ,"èظ"     ,"door_007101"    ,-23.060f, 1.654f, 140.877f, -10.429f, 13.059f, 157.365f)
	
	//---------------------------------------------------------------------
	// 1K 04 [Ƃ肠
	WK7STGPLINF_DEF(771, 4,"Tutorial"                  ,"ر"     )
	// 1K X^[g
	WK7STGPLINF_CAM(771, 4,"Tutorial"                  ,"ر"     ,"branchZ"    ,-97.813f, 3.444f, -56.081f, -91.360f, 7.859f, -37.056f)

	//---------------------------------------------------------------------
	// 2K 00
	WK7STGPLINF_DEF(772, 0,"2F Stairs"                 ,"2F "        )
	// 2K 1K02
	WK7STGPLINF_CAM(772, 0,"2F Stairs"                 ,"2F "        ,"branchD"    , -205.037f, 5.495f, 285.858f, -193.822f, 17.368f, 265.392f)

	
	// 2K 01
	WK7STGPLINF_CAM(772, 0,"2F Stairs"                 ,"2F "        ,"branchA"    , -205.914f, 39.735f, 170.583f, -199.817f, 38.491f, 145.228f)
	
	//---------------------------------------------------------------------
	// 2K 01
	WK7STGPLINF_DEF(772, 1,"2F Passage"                ,"2F ۳"          )
	// 2K 00
	WK7STGPLINF_CAM(772, 1,"2F Passage"                ,"2F ۳"          ,"branchA"    , -210.700f, 2.035f, -100.894f, -205.057f, 11.377f, -77.305f)
	// 2K n[}̕
	WK7STGPLINF_CAM(772, 1,"2F Passage"                ,"2F ۳"          ,"branchC"    , -152.955f, 2.782f, -281.326f, -135.843f, 17.286f, -335.163f)
	// 2K 02
	WK7STGPLINF_CAM(772, 1,"2F Passage"                ,"2F ۳"          ,"branchB"    , -156.915f, 3.771f, -420.595f, -159.448f, 10.482f, -441.849f)
	
	//---------------------------------------------------------------------
	// 2K 02
	WK7STGPLINF_DEF(772, 2,"Stairs For Residents"      ,"ޭֳ³"     )
	// 2K 01
	WK7STGPLINF_CAM(772, 2,"Stairs For Residents"      ,"ޭֳ³"     ,"branchB"    , -147.939f, 5.484f, -467.780f, -138.931f, 6.162f, -492.389f)
	// 2K 3K00
	WK7STGPLINF_CAM(772, 2,"Stairs For Residents"      ,"ޭֳ³"     ,"door_007201", 134.106f, 42.016f, -151.337f, 132.272f, 27.533f, -129.769f)
	// 2K 03
	WK7STGPLINF_CAM(772, 2,"Stairs For Residents"      ,"ޭֳ³"     ,"branchK"    , 143.436f, 23.422f, -489.485f, 144.070f, 6.832f, -440.129f)
	// 3K 04@ݒuKv
	WK7STGPLINF_CAM(772, 2,"Stairs For Residents"      ,"ޭֳ³"     ,"door_007202"    ,164.011f, 3.014f, -579.724f, 164.940f, 8.486f, -557.397f)

	
	//---------------------------------------------------------------------
	// 2K 03
	WK7STGPLINF_DEF(772, 3,"212 Room"                  ,"212޳"        )
	// 2K 02
	WK7STGPLINF_CAM(772, 3,"212 Room"                  ,"212޳"        ,"branchB"    , -167.180f, 8.137f, -466.565f, -150.739f, 10.267f, -486.871f)
	
	//---------------------------------------------------------------------
	// 3K 00
	WK7STGPLINF_DEF(773, 0,"3F Stairs"                 ,"3F "        )
	// 3K 2K02
	WK7STGPLINF_CAM(773, 0,"3F Stairs"                 ,"3F "        ,"branchA"    ,155.865f, 1.655f, 128.190f, 156.342f, 10.146f, 103.091f)
	// 3K 01
	WK7STGPLINF_CAM(773, 0,"3F Stairs"                 ,"3F "        ,"branchB"    ,205.449f, 51.981f, -72.659f, 179.542f, 53.377f, -78.057f)
	// 3K ́[}
//	WK7STGPLINF_CAM(773, 0,"3F Stairs"                 ,"3F "        ,"branchZ"    ,223.186f, 53.305f, -101.292f, 184.862f, 50.491f, -92.768f)
	
	//---------------------------------------------------------------------
	// 3K 01
	WK7STGPLINF_DEF(773, 1,"Hall"                      ,"ΰ"             )
	// 3K 00
	WK7STGPLINF_CAM(773, 1,"Hall"                      ,"ΰ"             ,"branchA"    , 12.719f, 2.735f, -109.075f, 34.175f, 12.045f, -97.565f)
	// 3K 03
	WK7STGPLINF_CAM(773, 1,"Hall"                      ,"ΰ"             ,"branchC"    ,-49.264f, 1.982f, -195.262f, -30.474f, 9.218f, -208.622f)
	// 3K 02
	WK7STGPLINF_CAM(773, 1,"Hall"                      ,"ΰ"             ,"branchD"    , -10.335f, 0.075f, -198.976f, -7.763f, 6.785f, -221.937f)
	// 3K 05
	WK7STGPLINF_CAM(773, 1,"Hall"                      ,"ΰ"             ,"branchE"    ,-123.184f, 2.392f, -79.749f, -101.319f, 10.053f, -86.240f)
		//---------------------------------------------------------------------
	// 3K 02
	WK7STGPLINF_DEF(773, 2,"Library"                    ,"ļ"           )
	// 3K 01
	WK7STGPLINF_CAM(773, 2,"Library"                    ,"ļ"           ,"branchA"    , 36.511f, 8.394f, -323.099f, -6.410f, 11.322f, -339.587f)
	// 3K 04
	WK7STGPLINF_CAM(773, 2,"Library"                    ,"ļ"           ,"branchB"    ,-120.478f, 3.091f, -322.031f, -129.977f, 4.773f, -324.378f)
	// 3K 4K00
	WK7STGPLINF_CAM(773, 2,"Library"                    ,"ļ"           ,"door_007301", -7.598f, 0.846f, -569.033f, -11.095f, 6.218f, -543.756f)

	//---------------------------------------------------------------------
//	// 3K 03
//	WK7STGPLINF_DEF(773, 3,"Game Room"                 ,"ճ޼ޮ"        )
//	// 3K 01
//	WK7STGPLINF_CAM(773, 3,"Game Room"                 ,"ճ޼ޮ"        ,"branchA"    , 86.263f, 13.471f, -220.734f, 70.505f, 6.700f, -240.214f)
	
	//---------------------------------------------------------------------
	// 3K 04
	WK7STGPLINF_DEF(773, 4,"Laundry Room"              ,"ذݸ޼"       )
	// 3K 02
//	WK7STGPLINF_CAM(773, 4,"Laundry Room"              ,"ذݸ޼"       ,"branchA"    ,-203.164f, 1.645f, -98.364f, -179.334f, 15.176f, -161.097f)
	// 2K 02
	WK7STGPLINF_CAM(773, 4,"Laundry Room"              ,"ذݸ޼"       ,"door_007302"    ,167.457f, 1.969f, 6.012f, 159.768f, 9.055f, -13.831f)
	// 3K ́[}
	WK7STGPLINF_CAM(773, 4,"Laundry Room"              ,"ذݸ޼"       ,"branchZ"    ,-209.102f, 26.859f, -202.749f, -197.023f, 29.586f, -223.807f)

	
	//---------------------------------------------------------------------
	// 3K 05
	WK7STGPLINF_DEF(773, 5,"Rest Room"                    ,"Ĳ"             )
	// 3K 01
	WK7STGPLINF_CAM(773, 5,"Rest Room"                    ,"Ĳ"             ,"branchE"    , -66.388f, 12.636f, -219.188f, -85.944f, 11.604f, -213.933f)
	
	//---------------------------------------------------------------------
	// 4K 00
	WK7STGPLINF_DEF(774, 0,"4F Stairs"                 ,"4F "        )
	// 4K 3K02
	WK7STGPLINF_CAM(774, 0,"4F Stairs"                 ,"4F "        ,"branchA"    ,-17.371f, 45.046f, -593.407f, 6.761f, 54.422f, -598.402f)
	
	// 4K 01
	WK7STGPLINF_CAM(774, 0,"4F Stairs"                 ,"4F "        ,"branchB"    , -218.904f, 89.366f, -794.157f, -183.890f, 88.600f, -794.597f)
	// 4K ́[}
	WK7STGPLINF_CAM(774, 0,"4F Stairs"                 ,"4F "        ,"branchZ"    , -128.373f, 84.887f, -817.086f, -101.703f, 91.295f, -802.667f)

	
	//---------------------------------------------------------------------
	// 4K 01
	WK7STGPLINF_DEF(774, 1,"Stairs Hall"               ,"ΰ"        )
	// 4K 00
	WK7STGPLINF_CAM(774, 1,"Stairs Hall"               ,"ΰ"        ,"branchA"    , 56.605f, 4.618f, -29.262f, 32.348f, 10.659f, -22.347f)
	// 4K 02
	WK7STGPLINF_CAM(774, 1,"Stairs Hall"               ,"ΰ"        ,"branchB"    , 174.664f, 1.865f, -85.631f, 167.904f, 10.632f, -62.233f)
	//---------------------------------------------------------------------
	// 4K 02
	WK7STGPLINF_DEF(774, 2,"4F Passage"                ,"4F ۳"          )
	// 4K 01
	WK7STGPLINF_CAM(774, 2,"4F Passage"                ,"4F ۳"          ,"branchA"    , 178.342f, 6.342f, -197.202f, 166.174f, 8.809f, -174.428f)
	// 4K 03
	WK7STGPLINF_CAM(774, 2,"4F Passage"                ,"4F ۳"          ,"door_007401",-77.596f, 15.695f, -127.738f, -52.121f, 10.068f, -128.891f)
	// 4K 04
	WK7STGPLINF_CAM(774, 2,"4F Passage"                ,"4F ۳"          ,"branchC"    , -77.193f, 10.716f, -402.257f, -69.368f, 9.422f, -424.694f)
	// 4K n[}̕
	WK7STGPLINF_CAM(774, 2,"4F Passage"                ,"4F ۳"          ,"branchD"    , -173.025f, 1.625f, -436.625f, -146.323f, 12.292f, -485.048f)
	// 4K 5K01
	WK7STGPLINF_CAM(774, 2,"4F Passage"                ,"4F ۳"          ,"door_007402", -151.652f, 23.704f, -524.943f, -155.595f, 17.100f, -550.120f)
	
	//---------------------------------------------------------------------
	// 4K 03
	WK7STGPLINF_DEF(774, 3,"406 Room"                  ,"406޳"        )
	// 4K 02
	WK7STGPLINF_CAM(774, 3,"406 Room"                  ,"406޳"        ,"branchA"    ,31.816f, 11.412f, -123.412f, 11.427f, 12.755f, -114.449f)
	
	//---------------------------------------------------------------------

	
	//---------------------------------------------------------------------
	// 5K 01
	WK7STGPLINF_DEF(775, 1,"5F Passage"                ,"5F ۳"          )
	// 5K 4K02
	WK7STGPLINF_CAM(775, 1,"5F Passage"                ,"5F ۳"          ,"branchA"    ,-166.928f, 35.698f, -42.408f, -167.766f, 27.768f, -17.549f)
	// 5K n[}̕
	WK7STGPLINF_CAM(775, 1,"5F Passage"                ,"5F ۳"          ,"branchB"    , -30.031f, 15.417f, 49.737f, -8.430f, 9.891f, 101.542f)
	// 5K 02
	WK7STGPLINF_CAM(775, 1,"5F Passage"                ,"5F ۳"          ,"branchC"    , 36.912f, 13.346f, 203.955f, 31.475f, 9.891f, 259.959f)
	// ԑO 02
	WK7STGPLINF_CAM(775, 1,"5F Passage"                ,"5F ۳"          ,"door_007502"    , 38.124f, 27.048f, 232.402f, 21.518f, 11.245f, 258.005f)
	
	//---------------------------------------------------------------------
	// 5K 02
	WK7STGPLINF_DEF(775, 2,"Hand In Grove"          ,""         )
	// 5K 01
	WK7STGPLINF_CAM(775, 2,"Hand In Grove"          ,""          ,"branchA"    , 24.207f, 5.096f, 284.041f, 24.098f, 7.564f, 310.292f)
	// 5K 6K00
	WK7STGPLINF_CAM(775, 2,"Hand In Grove"          ,""          ,"door_007501", 40.426f, 3.636f, 540.339f, 34.096f, 10.222f, 559.682f)
	
	//---------------------------------------------------------------------
	// 6K 00
	WK7STGPLINF_DEF(776, 0,"Elevator"                  ,"ް"          )
	// 6K 5K02
	WK7STGPLINF_CAM(776, 0,"Elevator"                  ,"ް"          ,"branchD"    , 264.774f, 18.383f, 112.582f, 257.710f, 8.609f, 135.753f)
	// 6K 01
	WK7STGPLINF_CAM(776, 0,"Elevator"                  ,"ް"          ,"event_007601_0" , 262.431f, 4.906f, 542.088f, 258.916f, 10.608f, 518.506f)
	// 6K R͓
	WK7STGPLINF_CAM(776, 0,"Elevator"                  ,"ް"          ,"door_007606"    , 254.071f, 22.273f, 510.789f, 254.407f, 21.618f, 489.302f)
	// 6K ́[}
	WK7STGPLINF_CAM(776, 0,"Elevator"                  ,"ް"          ,"branchZ"    , 266.691f, 6.092f, 433.665f, 257.816f, 9.068f, 452.065f)

	
	//---------------------------------------------------------------------
	// 6K 01
	WK7STGPLINF_DEF(776, 1,"6F Passage"                 ,"6F ۳"          )
	// 6K 00
	WK7STGPLINF_CAM(776, 1,"6F Passage"                 ,"6F ۳"          ,"event_007602_0" , 51.585f, -25.063f, 630.126f, 65.209f, 3.713f, 645.809f)
	// 6K n[}̕
	WK7STGPLINF_CAM(776, 1,"6F Passage"                 ,"6F ۳"          ,"branchC"    ,-16.518f, 18.434f, 398.069f, -24.340f, 8.523f, 343.543f)
	// 6K 02
	WK7STGPLINF_CAM(776, 1,"6F Passage"                 ,"6F ۳"          ,"branchB"    ,52.378f, 20.561f, 297.125f, 51.926f, 15.686f, 271.208f)
	
	//---------------------------------------------------------------------
	// 6K 02
	WK7STGPLINF_DEF(776, 2,"Dance Hall"                 ,"ݽΰ"         )
	// 6K 01
	WK7STGPLINF_CAM(776, 2,"Dance Hall"                 ,"ݽΰ"          ,"branchA"    ,46.715f, 5.054f, 228.821f, 52.626f, 12.345f, 210.762f)
	// 6K 03
	WK7STGPLINF_CAM(776, 2,"Dance Hall"                 ,"ݽΰ"          ,"branchB"    , 47.349f, -18.331f, 390.678f, 53.648f, -18.000f, 365.068f)
	//---------------------------------------------------------------------
	// 6K 03
	WK7STGPLINF_DEF(776, 3,"Hallway"                    ,"³"             )
	// 6K 02
	WK7STGPLINF_CAM(776, 3,"Hallway"                    ,"³"              ,"branchA"    , 52.000f, 0.876f, -180.188f, 49.992f, 7.845f, -160.844f)
	//---------------------------------------------------------------------
	//ŏK@ftHg
	WK7STGPLINF_DEF(707, 1,"Top-floor"                 ,"ֳ"        )
	//*ŏK@ŏKL
	WK7STGPLINF_CAM(707, 1,"Top-floor"                 ,"ֳ"        ,"door_007605"    , 45.533f, 2.795f, -156.676f, 51.352f, 13.064f, -137.740f)
	//---------------------------------------------------------------------

#endif

#ifdef	__K7STAGE_CPP__
	
	//==== SViIʁER͓ELnO ====
	
	//==== ViI1EEKVẢ ====
	
	//---------------------------------------------------------------------
	//@ftHg
	WK7STGPLINF_DEF(120, 0,"Garcian's House"                 ,"ټɲ"            )
	//@Jn
	WK7STGPLINF_CAM(120, 0,"Garcian's House"                 ,"ټɲ"            ,"door_990000", -41.604f, 11.913f, -24.686f, -27.828f, 13.673f, 2.550f)
	//@n[}̕
	WK7STGPLINF_CAM(120, 0,"Garcian's House"                 ,"ټɲ"            ,"door_990001", 14.845f, 1.298f, 33.548f, 40.992f, 11.932f, 22.273f)
	//@
	WK7STGPLINF_CAM(120, 0,"Garcian's House"                 ,"ټɲ"            ,"door_990003", 77.797f, 2.929f, 19.159f, 91.208f, 8.727f, 30.958f)
	

	//---------------------------------------------------------------------
	//n[}̕@ftHg
	WK7STGPLINF_DEF(121, 0,"Harman's Room"            ,"ʰ"          )
	//n[}̕@
//	WK7STGPLINF_CAM(121, 0,"Harman's Room"            ,"ʰ"          ,"door_990001", -18.122f, 27.875f, 20.138f, -27.729f, -9.048f, -18.474f)
	WK7STGPLINF_CAM(121, 0,"Harman's Room"            ,"ʰ"          ,"door_990001", -19.885f, 35.104f, 27.284f, -26.223f, -2.098f, -11.734f)
	
	
	//---------------------------------------------------------------------
	// Ԑl̂镔 00
	WK7STGPLINF_DEF(578, 0,"Gate Man"                     ,""            )
	// Ԑl̕ LnO̔ok
	WK7STGPLINF_CAM(578, 0,"Gate Man"                     ,""            ,"door_980001"    ,8.015f, 11.348f, 61.079f, -4.251f, 12.842f, 5.992f)
	// Ԑl̕ Kiok
	WK7STGPLINF_CAM(578, 0,"Gate Man"                     ,""            ,"door_980101"   ,19.782f, 17.325f, -19.554f, 18.042f, 10.269f, -39.354f)

	// Ki Ԑl̕ok
	WK7STGPLINF_CAM(578, 0,"Gate Man"                     ,""            ,"door_980102"    ,23.184f, 0.887f, -128.394f, 22.999f, 9.968f, -107.868f)
	// Ki 8p`̕ok
	WK7STGPLINF_CAM(578, 0,"Gate Man"                     ,""            ,"door_980004"    ,18.718f, 65.220f, -178.030f, 24.453f, 63.145f, -198.696f)

	// Ԑl̕ Ln
	WK7STGPLINF_CAM(578, 0,"Gate Man"                     ,""            ,"door_980002"   ,-27.070f, 2.750f, 56.003f, -29.158f, 12.000f, 36.541f)
	// Ԑl̕ LnKi
	WK7STGPLINF_CAM(578, 0,"Gate Man"                     ,""            ,"door_980103"   ,-34.560f, 2.762f, -13.168f, -28.338f, 11.132f, -31.502f)

	// LnKi Ԑl̕ok
	WK7STGPLINF_CAM(578, 0,"Gate Man"                     ,""            ,"door_980104"   ,-25.388f, 1.187f, -141.348f, -30.988f, 6.235f, -107.139f)
	// LnKi Lňok
	WK7STGPLINF_CAM(578, 0,"Gate Man"                     ,""            ,"door_980003"   ,-16.254f, -30.891f, -211.313f, -23.721f, -23.022f, -177.507f)
	

	//---------------------------------------------------------------------	
	// 8p`̕ 00
	WK7STGPLINF_DEF(573, 0,"Colosseum"                     ,"ۼ"            )
	// 8p`̕ Ki
	WK7STGPLINF_CAM(573, 0,"Colosseum"                     ,"ۼ"            ,"branchA1"    ,348.371f, 0.952f, -15.048f, 340.964f, 9.219f, 3.859f)
	WK7STGPLINF_CAM(573, 0,"Colosseum"                     ,"ۼ"            ,"branchA2"    ,348.371f, 0.952f, -15.048f, 340.964f, 9.219f, 3.859f)
	WK7STGPLINF_CAM(573, 0,"Colosseum"                     ,"ۼ"            ,"branchA3"    ,348.371f, 0.952f, -15.048f, 340.964f, 9.219f, 3.859f)
	WK7STGPLINF_CAM(573, 0,"Colosseum"                     ,"ۼ"            ,"branchA4"    ,348.371f, 0.952f, -15.048f, 340.964f, 9.219f, 3.859f)
	WK7STGPLINF_CAM(573, 0,"Colosseum"                     ,"ۼ"            ,"branchA5"    ,348.371f, 0.952f, -15.048f, 340.964f, 9.219f, 3.859f)
	WK7STGPLINF_CAM(573, 0,"Colosseum"                     ,"ۼ"            ,"branchA6"    ,348.371f, 0.952f, -15.048f, 340.964f, 9.219f, 3.859f)
	WK7STGPLINF_CAM(573, 0,"Colosseum"                     ,"ۼ"            ,"branchA7"    ,348.371f, 0.952f, -15.048f, 340.964f, 9.219f, 3.859f)
	WK7STGPLINF_CAM(573, 0,"Colosseum"                     ,"ۼ"            ,"branchA8"    ,348.371f, 0.952f, -15.048f, 340.964f, 9.219f, 3.859f)


	// 8p`̕ ZeBbNLn
	WK7STGPLINF_CAM(573, 0,"Colosseum"                     ,"ۼ"            ,"branchB"    ,-335.605f, 5.525f, 184.374f, -315.981f, 12.573f, 189.854f)
	// 8p`̕ tNV}Ln
	WK7STGPLINF_CAM(573, 0,"Colosseum"                     ,"ۼ"            ,"branchC"    ,216.833f, 5.220f, 269.520f, 232.275f, 13.018f, 216.116f)
	// 8p`̕ prLn
	WK7STGPLINF_CAM(573, 0,"Colosseum"                     ,"ۼ"            ,"branchG"    ,19.420f, 7.479f, -326.371f, -22.499f, 32.395f, -298.402f)
	// 8p`̕ VnLn
	WK7STGPLINF_CAM(573, 0,"Colosseum"                     ,"ۼ"            ,"branchD"    ,10.533f, 12.468f, 326.628f, 3.884f, 12.100f, 304.165f)
	// 8p`̕ J[eBX@Ln
	WK7STGPLINF_CAM(573, 0,"Colosseum"                     ,"ۼ"            ,"branchE"    ,-246.769f, 2.768f, -239.419f, -223.182f, 11.268f, -240.525f)
	// 8p`̕ zeLn
	WK7STGPLINF_CAM(573, 0,"Colosseum"                     ,"ۼ"            ,"branchH"    ,-348.497f, 0.911f, -12.552f, -329.194f, 10.572f, -3.167f)
	// 8p`̕ wZLn
	WK7STGPLINF_CAM(573, 0,"Colosseum"                     ,"ۼ"            ,"branchF"    ,274.305f, 5.702f, -229.689f, 250.299f, 11.977f, -232.651f)



	// 8p`̕ ͓Ki
	WK7STGPLINF_CAM(573, 0,"Colosseum"                     ,"ۼ"            ,"door_057399"    ,30.705f, 0.402f, 25.666f, 20.924f, 13.518f, 6.153f)

	//---------------------------------------------------------------------	

#endif

	
#endif	//__K7STAGEPLACEINFO_H__

