////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Cam Set
//
// CamSet.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/26/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifdef	__WK7CAM_CPP__

#ifndef	__CAMSET_H__
#define	__CAMSET_H__

//		WK7CAMSET_DECL_CHR( 15.000f ,  2.862f ,  18.064f ,  10.000f ,   0.000f ,  12.000f )	// O
//		WK7CAMSET_DECL_CHR( 15.000f ,  2.862f ,  18.064f ,  10.000f ,   0.000f ,  12.000f )	// EO
//		WK7CAMSET_DECL_CHR(  7.000f ,  2.538f ,  18.641f ,  10.000f ,   0.000f ,  12.000f )	// 
//		WK7CAMSET_DECL_CHR(  7.000f ,  2.538f ,  18.641f ,  10.000f ,   0.000f ,  12.000f )	// E

WK7CAMSET_DECL_BEGIN(0)
	
	WK7CAMSET_DECL_CHR_BEGIN(K7DAN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(8.137f, 4.812f, 6.314f, 10.000f, -0.013f, 13.427f)	// O
		WK7CAMSET_DECL_CHR(8.137f, 4.812f, 6.314f, 10.000f, -0.013f, 13.827f)	// EO
		WK7CAMSET_DECL_CHR(10.088f, 6.212f, 0.837f, 10.000f, -0.013f, 10.032f)	// 
		WK7CAMSET_DECL_CHR(10.888f, 6.274f, 0.837f, 10.000f, -0.013f, 10.077f)	// E

	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7GAL)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(11.000f, 3.912f, 11.073f, 10.000f, 3.000f, 14.432f)	// O
		WK7CAMSET_DECL_CHR(10.987f, 4.412f, 10.314f, 10.000f, 3.000f, 14.750f)	// EO
		WK7CAMSET_DECL_CHR(12.462f, 5.487f, 0.541f, 10.000f, 3.038f, 11.268f)	// 
		WK7CAMSET_DECL_CHR(10.950f, 7.612f, 0.837f, 9.913f, 3.938f, 10.077f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CAT)
						//      fd        ph         pv         tf         th         tv
//		WK7CAMSET_DECL_CHR(9.325f, 3.450f, 3.600f, 10.000f, 2.613f, 12.000f)	// O
//		WK7CAMSET_DECL_CHR(9.325f, 3.450f, 3.600f, 10.000f, 2.613f, 12.000f)	// EO
		WK7CAMSET_DECL_CHR(15.238f, 2.650f, 3.600f, 10.000f, 2.613f, 12.000f)	// O
		WK7CAMSET_DECL_CHR(15.238f, 2.650f, 3.600f, 10.000f, 2.613f, 12.000f)	// EO
		WK7CAMSET_DECL_CHR(10.175f, 6.625f, 0.782f, 8.225f, 0.163f, 8.936f)		// 
		WK7CAMSET_DECL_CHR(10.175f, 6.625f, 0.782f, 10.000f, 0.163f, 8.759f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CYO)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(9.962f, 4.187f, 7.873f, 10.000f, 1.700f, 13.595f)	// O
		WK7CAMSET_DECL_CHR(11.375f, 4.212f, 5.873f, 10.000f, 3.375f, 12.850f)	// EO
		WK7CAMSET_DECL_CHR(10.487f, 6.762f, 0.637f, 10.000f, 3.375f, 9.964f)	// 
		WK7CAMSET_DECL_CHR(10.487f, 6.762f, 0.637f, 10.000f, 3.375f, 9.055f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KED)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(12.275f, 3.787f, 5.678f, 10.000f, 3.600f, 11.627f)	// O
		WK7CAMSET_DECL_CHR(11.412f, 3.650f, 6.646f, 10.000f, 3.600f, 10.614f)	// EO
		WK7CAMSET_DECL_CHR(10.100f, 4.825f, 0.637f, 10.000f, 3.375f, 9.055f)	// 
		WK7CAMSET_DECL_CHR(10.100f, 4.825f, 0.637f, 10.000f, 3.375f, 9.055f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KVN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(11.512f, 4.212f, 4.478f, 9.675f, 0.300f, 13.086f)	// O
		WK7CAMSET_DECL_CHR(11.512f, 4.212f, 4.478f, 10.000f, 0.300f, 12.905f)	// EO
		WK7CAMSET_DECL_CHR(10.987f, 6.137f, 1.364f, 10.000f, 4.400f, 9.368f)	// 
		WK7CAMSET_DECL_CHR(10.600f, 5.875f, 1.364f, 10.000f, 4.400f, 8.600f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7MSK)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(10.687f, 3.412f, 6.569f, 9.525f, 3.875f, 15.018f)	// O
		WK7CAMSET_DECL_CHR(10.687f, 3.412f, 6.569f, 10.000f, 3.875f, 15.036f)	// EO
		WK7CAMSET_DECL_CHR(11.937f, 6.837f, 0.664f, 10.000f, 4.400f, 10.514f)	// 
		WK7CAMSET_DECL_CHR(12.787f, 6.837f, 0.664f, 10.000f, 4.400f, 10.541f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7HAY)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(15.408f, 6.710f, 0.806f, 10.000f, -0.013f, 10.077f)	// O
		WK7CAMSET_DECL_CHR(15.408f, 6.710f, 0.806f, 10.000f, -0.013f, 10.077f)	// EO
		WK7CAMSET_DECL_CHR(10.088f, 6.212f, 0.837f, 10.000f, -0.013f, 10.032f)	// 
		WK7CAMSET_DECL_CHR(10.888f, 6.274f, 0.837f, 10.000f, -0.013f, 10.077f)	// E

	WK7CAMSET_DECL_CHR_END()
	
WK7CAMSET_DECL_END()

WK7CAMSET_DECL_BEGIN(1)
	
	WK7CAMSET_DECL_CHR_BEGIN(K7DAN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(15.875f, 3.150f, 11.655f, 9.488f, 1.475f, 12.000f)	// O
		WK7CAMSET_DECL_CHR(14.937f, 5.400f, 11.655f, 10.000f, 3.638f, 12.000f)	// EO
		WK7CAMSET_DECL_CHR(7.425f, 2.212f, 14.632f, 10.000f, 3.375f, 12.000f)	// 
		WK7CAMSET_DECL_CHR(5.787f, 8.062f, 14.632f, 9.763f, 0.000f, 12.000f)	// E

	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7GAL)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(11.375f, 3.075f, 17.528f, 8.987f, 5.038f, 12.000f)	// O
		WK7CAMSET_DECL_CHR(11.375f, 3.075f, 17.528f, 10.000f, 5.038f, 12.000f)	// EO
		WK7CAMSET_DECL_CHR(6.625f, 6.399f, 15.309f, 10.101f, 0.388f, 13.345f)	// 
		WK7CAMSET_DECL_CHR(6.625f, 6.399f, 15.309f, 10.101f, 0.388f, 13.345f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CAT)
						//      fd        ph         pv         tf         th         tv
//		WK7CAMSET_DECL_CHR(15.550f, 5.512f, 5.714f, 10.000f, 3.250f, 12.000f)	// O
//		WK7CAMSET_DECL_CHR(15.550f, 5.512f, 5.714f, 10.000f, 3.250f, 13.668f)	// EO
		WK7CAMSET_DECL_CHR(23.725f, 7.675f, 5.714f, 10.000f, 3.250f, 13.668f)	// O
		WK7CAMSET_DECL_CHR(23.725f, 7.675f, 5.714f, 10.000f, 3.250f, 13.668f)	// EO
		WK7CAMSET_DECL_CHR(6.625f, 6.399f, 9.032f, 10.101f, 0.388f, 7.377f)	// 
		WK7CAMSET_DECL_CHR(6.625f, 6.399f, 9.032f, 10.101f, 0.388f, 7.377f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CYO)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(12.887f, 2.762f, 14.132f, 10.000f, 2.188f, 12.223f)	// O
		WK7CAMSET_DECL_CHR(13.437f, 2.062f, 15.250f, 13.100f, 1.813f, 9.914f)	// EO
		WK7CAMSET_DECL_CHR(6.625f, 6.399f, 14.714f, 10.076f, 1.350f, 10.805f)	// 
		WK7CAMSET_DECL_CHR(6.625f, 6.399f, 14.714f, 9.988f, 0.475f, 10.805f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KED)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(13.662f, 2.937f, 13.696f, 8.875f, 6.038f, 12.000f)	// O
		WK7CAMSET_DECL_CHR(13.662f, 2.937f, 13.696f, 8.875f, 6.038f, 12.000f)	// EO
		WK7CAMSET_DECL_CHR(6.500f, 7.099f, 12.637f, 9.988f, 0.475f, 10.805f)	// 
		WK7CAMSET_DECL_CHR(6.500f, 7.099f, 12.637f, 9.988f, 0.475f, 10.805f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KVN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(17.412f, 4.012f, 11.941f, 10.000f, 4.325f, 12.000f)	// O
		WK7CAMSET_DECL_CHR(17.412f, 4.012f, 11.941f, 10.000f, 4.325f, 12.000f)	// EO
		WK7CAMSET_DECL_CHR(5.375f, 6.862f, 11.264f, 9.988f, 0.475f, 9.073f)	// 
		WK7CAMSET_DECL_CHR(5.375f, 6.862f, 11.264f, 9.988f, 0.475f, 9.073f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7MSK)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(15.237f, 3.525f, 13.723f, 9.525f, 4.663f, 15.018f)	// O
		WK7CAMSET_DECL_CHR(15.275f, 3.612f, 14.169f, 9.525f, 4.663f, 15.591f)	// EO
		WK7CAMSET_DECL_CHR(8.437f, 5.912f, 13.346f, 9.988f, 0.475f, 9.891f)	// 
		WK7CAMSET_DECL_CHR(8.437f, 5.912f, 13.346f, 9.988f, 0.475f, 9.891f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7HAY)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(15.875f, 3.150f, 11.655f, 9.488f, 1.475f, 12.000f)	// O
		WK7CAMSET_DECL_CHR(14.937f, 5.400f, 11.655f, 10.000f, 3.638f, 12.000f)	// EO
		WK7CAMSET_DECL_CHR(7.425f, 2.212f, 14.632f, 10.000f, 3.375f, 12.000f)	// 
		WK7CAMSET_DECL_CHR(5.787f, 8.062f, 14.632f, 9.763f, 0.000f, 12.000f)	// E

	WK7CAMSET_DECL_CHR_END()
	
WK7CAMSET_DECL_END()

WK7CAMSET_DECL_BEGIN(2)
	
	WK7CAMSET_DECL_CHR_BEGIN(K7DAN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(12.300f, 0.550f, 12.560f, 10.000f, 6.012f, 13.427f)	// O
		WK7CAMSET_DECL_CHR(12.687f, 1.487f, 12.560f, 10.000f, 6.012f, 14.836f)	// EO
		WK7CAMSET_DECL_CHR(7.200f, 2.625f, 8.019f, 10.000f, 4.200f, 14.377f)	// 
		WK7CAMSET_DECL_CHR(6.600f, 4.675f, 7.782f, 9.913f, 4.200f, 13.278f)		// E

	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7GAL)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(13.037f, 1.487f, 15.319f, 10.000f, 6.012f, 15.473f)	// O
		WK7CAMSET_DECL_CHR(12.700f, 0.750f, 15.319f, 10.000f, 6.012f, 18.863f)	// EO
		WK7CAMSET_DECL_CHR(5.737f, 6.700f, 7.532f, 9.475f, 0.875f, 11.268f)		// 
		WK7CAMSET_DECL_CHR(6.950f, 3.362f, 8.655f, 10.000f, 6.012f, 13.945f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CAT)
						//      fd        ph         pv         tf         th         tv
//		WK7CAMSET_DECL_CHR(15.825f, 2.137f, 5.210f, 10.000f, 5.775f, 13.091f)	// O
//		WK7CAMSET_DECL_CHR(14.175f, 3.862f, 6.428f, 10.000f, -0.175f, 12.000f)	// EO
		WK7CAMSET_DECL_CHR(26.312f, 7.400f, 4.928f, 8.225f, 5.775f, 9.809f)	// O
		WK7CAMSET_DECL_CHR(26.312f, 7.400f, 4.928f, 8.225f, 5.775f, 9.809f)	// O
		WK7CAMSET_DECL_CHR(6.275f, 2.225f, 3.978f, 8.225f, 5.775f, 8.936f)	// 
		WK7CAMSET_DECL_CHR(8.012f, 3.825f, 3.978f, 8.225f, 5.775f, 9.809f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CYO)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(13.725f, 3.537f, 10.405f, 10.000f, 2.925f, 13.595f)	// O
		WK7CAMSET_DECL_CHR(13.725f, 1.762f, 10.405f, 10.000f, 2.925f, 13.595f)	// EO
		WK7CAMSET_DECL_CHR(7.662f, 4.462f, 7.669f, 9.050f, 2.200f, 12.428f)		// 
		WK7CAMSET_DECL_CHR(4.687f, 5.162f, 7.228f, 8.475f, 1.063f, 12.709f)		// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KED)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(11.662f, -0.325f, 11.128f, 10.000f, 5.000f, 11.627f)	// O
		WK7CAMSET_DECL_CHR(11.575f, 2.475f, 11.128f, 9.625f, 5.000f, 11.627f)	// EO
		WK7CAMSET_DECL_CHR(8.775f, 2.375f, 7.505f, 10.025f, 4.513f, 11.678f)	// 
		WK7CAMSET_DECL_CHR(5.800f, 3.350f, 7.792f, 9.875f, 3.887f, 11.587f)		// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KVN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(13.950f, 1.000f, 11.042f, 9.675f, 6.212f, 13.086f)	// O
		WK7CAMSET_DECL_CHR(13.950f, 2.212f, 11.632f, 10.000f, 6.212f, 9.368f)	// EO
		WK7CAMSET_DECL_CHR(3.150f, 4.350f, 5.310f, 8.687f, 0.750f, 10.136f)		// 
		WK7CAMSET_DECL_CHR(3.787f, 3.350f, 6.464f, 10.000f, 6.212f, 9.368f)		// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7MSK)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(12.625f, 2.862f, 9.996f, 9.525f, 3.187f, 18.113f)	// O
		WK7CAMSET_DECL_CHR(12.550f, 3.212f, 12.532f, 9.250f, 3.187f, 18.400f)	// EO
		WK7CAMSET_DECL_CHR(4.625f, 6.337f, 6.405f, 10.000f, 0.750f, 11.086f)	// 
		WK7CAMSET_DECL_CHR(5.100f, 6.587f, 6.160f, 10.000f, 0.750f, 10.514f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7HAY)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(12.300f, 0.550f, 12.560f, 10.000f, 6.012f, 13.427f)	// O
		WK7CAMSET_DECL_CHR(12.687f, 1.487f, 12.560f, 10.000f, 6.012f, 14.836f)	// EO
		WK7CAMSET_DECL_CHR(7.200f, 2.625f, 8.019f, 10.000f, 4.200f, 14.377f)	// 
		WK7CAMSET_DECL_CHR(6.600f, 4.675f, 7.782f, 9.913f, 4.200f, 13.278f)		// E

	WK7CAMSET_DECL_CHR_END()
	
WK7CAMSET_DECL_END()

WK7CAMSET_DECL_BEGIN(3)
	
	WK7CAMSET_DECL_CHR_BEGIN(K7DAN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(23.837f, 4.774f, 9.946f, 10.000f, 0.000f, 17.627f)	// O
		WK7CAMSET_DECL_CHR(23.837f, 4.774f, 9.946f, 10.000f, 0.000f, 17.627f)	// EO
		WK7CAMSET_DECL_CHR(22.450f, 10.575f, 14.687f, 10.000f, 0.000f, 15.387f)	// 
		WK7CAMSET_DECL_CHR(22.450f, 10.575f, 14.687f, 10.000f, 0.000f, 15.387f)		// E

	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7GAL)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(23.837f, 4.774f, 9.946f, 10.000f, 0.000f, 17.627f)	// O
		WK7CAMSET_DECL_CHR(23.837f, 4.774f, 9.946f, 10.000f, 0.000f, 17.627f)	// EO
		WK7CAMSET_DECL_CHR(22.450f, 10.575f, 14.687f, 10.000f, 0.000f, 15.387f)		// 
		WK7CAMSET_DECL_CHR(22.450f, 10.575f, 14.687f, 10.000f, 0.000f, 15.387f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CAT)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(23.837f, 4.774f, 9.946f, 10.000f, 0.000f, 17.627f)	// O
		WK7CAMSET_DECL_CHR(23.837f, 4.774f, 9.946f, 10.000f, 0.000f, 17.627f)	// EO
		WK7CAMSET_DECL_CHR(22.450f, 10.575f, 14.687f, 10.000f, 0.000f, 15.387f)	// 
		WK7CAMSET_DECL_CHR(22.450f, 10.575f, 14.687f, 10.000f, 0.000f, 15.387f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CYO)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(23.837f, 4.774f, 9.946f, 10.000f, 0.000f, 17.627f)	// O
		WK7CAMSET_DECL_CHR(23.837f, 4.774f, 9.946f, 10.000f, 0.000f, 17.627f)	// EO
		WK7CAMSET_DECL_CHR(22.450f, 10.575f, 14.687f, 10.000f, 0.000f, 15.387f)		// 
		WK7CAMSET_DECL_CHR(22.450f, 10.575f, 14.687f, 10.000f, 0.000f, 15.387f)		// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KED)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(23.837f, 4.774f, 9.946f, 10.000f, 0.000f, 17.627f)	// O
		WK7CAMSET_DECL_CHR(23.837f, 4.774f, 9.946f, 10.000f, 0.000f, 17.627f)	// EO
		WK7CAMSET_DECL_CHR(22.450f, 10.575f, 14.687f, 10.000f, 0.000f, 15.387f)	// 
		WK7CAMSET_DECL_CHR(22.450f, 10.575f, 14.687f, 10.000f, 0.000f, 15.387f)		// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KVN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(23.837f, 4.774f, 9.946f, 10.000f, 0.000f, 17.627f)	// O
		WK7CAMSET_DECL_CHR(23.837f, 4.774f, 9.946f, 10.000f, 0.000f, 17.627f)	// EO
		WK7CAMSET_DECL_CHR(22.450f, 10.575f, 14.687f, 10.000f, 0.000f, 15.387f)		// 
		WK7CAMSET_DECL_CHR(22.450f, 10.575f, 14.687f, 10.000f, 0.000f, 15.387f)		// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7MSK)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(23.837f, 4.774f, 9.946f, 10.000f, 0.000f, 17.627f)	// O
		WK7CAMSET_DECL_CHR(23.837f, 4.774f, 9.946f, 10.000f, 0.000f, 17.627f)	// EO
		WK7CAMSET_DECL_CHR(22.450f, 10.575f, 14.687f, 10.000f, 0.000f, 15.387f)	// 
		WK7CAMSET_DECL_CHR(22.450f, 10.575f, 14.687f, 10.000f, 0.000f, 15.387f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7HAY)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(23.837f, 4.774f, 9.946f, 10.000f, 0.000f, 17.627f)	// O
		WK7CAMSET_DECL_CHR(23.837f, 4.774f, 9.946f, 10.000f, 0.000f, 17.627f)	// EO
		WK7CAMSET_DECL_CHR(22.450f, 10.575f, 14.687f, 10.000f, 0.000f, 15.387f)	// 
		WK7CAMSET_DECL_CHR(22.450f, 10.575f, 14.687f, 10.000f, 0.000f, 15.387f)		// E

	WK7CAMSET_DECL_CHR_END()
	
WK7CAMSET_DECL_END()

WK7CAMSET_DECL_BEGIN(4)
	
	WK7CAMSET_DECL_CHR_BEGIN(K7DAN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// O
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// EO
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// 
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// E

	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7GAL)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// O
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// EO
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// 
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CAT)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// O
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// EO
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// 
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CYO)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// O
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// EO
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// 
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KED)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// O
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// EO
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// 
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KVN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// O
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// EO
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// 
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7MSK)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// O
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// EO
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// 
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// E
		
	WK7CAMSET_DECL_CHR_END()

	WK7CAMSET_DECL_CHR_BEGIN(K7DAN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// O
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// EO
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// 
		WK7CAMSET_DECL_CHR(14.475f, 3.475f, 18.778f, 10.000f, 3.375f, 8.523f)	// E

	WK7CAMSET_DECL_CHR_END()
	
WK7CAMSET_DECL_END()

WK7CAMSET_DECL_BEGIN(5)
	
	WK7CAMSET_DECL_CHR_BEGIN(K7DAN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(15.875f, 4.137f, 8.350f, 10.638f, 1.125f, 1.423f)	// O
		WK7CAMSET_DECL_CHR(15.875f, 4.137f, 8.350f, 10.638f, 1.125f, 1.423f)	// EO
		WK7CAMSET_DECL_CHR(6.487f, 3.438f, 0.977f, 10.638f, 1.125f, 7.419f)	// 
		WK7CAMSET_DECL_CHR(6.487f, 3.438f, 0.977f, 10.638f, 1.125f, 7.419f)	// E

	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7GAL)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(15.875f, 4.137f, 8.350f, 10.638f, 1.125f, 1.423f)	// O
		WK7CAMSET_DECL_CHR(15.875f, 4.137f, 8.350f, 10.638f, 1.125f, 1.423f)	// EO
		WK7CAMSET_DECL_CHR(6.487f, 3.438f, 0.977f, 10.638f, 1.125f, 7.419f)	// 
		WK7CAMSET_DECL_CHR(6.487f, 3.438f, 0.977f, 10.638f, 1.125f, 7.419f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CAT)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(15.875f, 4.137f, 8.350f, 10.638f, 1.125f, 1.423f)	// O
		WK7CAMSET_DECL_CHR(15.875f, 4.137f, 8.350f, 10.638f, 1.125f, 1.423f)	// EO
		WK7CAMSET_DECL_CHR(6.487f, 3.438f, 0.977f, 10.638f, 1.125f, 7.419f)	// 
		WK7CAMSET_DECL_CHR(6.487f, 3.438f, 0.977f, 10.638f, 1.125f, 7.419f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CYO)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(15.875f, 4.137f, 8.350f, 10.638f, 1.125f, 1.423f)	// O
		WK7CAMSET_DECL_CHR(15.875f, 4.137f, 8.350f, 10.638f, 1.125f, 1.423f)	// EO
		WK7CAMSET_DECL_CHR(6.487f, 3.438f, 0.977f, 10.638f, 1.125f, 7.419f)	// 
		WK7CAMSET_DECL_CHR(6.487f, 3.438f, 0.977f, 10.638f, 1.125f, 7.419f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KED)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(15.875f, 4.137f, 8.350f, 10.638f, 1.125f, 1.423f)	// O
		WK7CAMSET_DECL_CHR(15.875f, 4.137f, 8.350f, 10.638f, 1.125f, 1.423f)	// EO
		WK7CAMSET_DECL_CHR(6.487f, 3.438f, 0.977f, 10.638f, 1.125f, 7.419f)	// 
		WK7CAMSET_DECL_CHR(6.487f, 3.438f, 0.977f, 10.638f, 1.125f, 7.419f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KVN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(15.875f, 4.137f, 8.350f, 10.638f, 1.125f, 1.423f)	// O
		WK7CAMSET_DECL_CHR(15.875f, 4.137f, 8.350f, 10.638f, 1.125f, 1.423f)	// EO
		WK7CAMSET_DECL_CHR(6.487f, 3.438f, 0.977f, 10.638f, 1.125f, 7.419f)	// 
		WK7CAMSET_DECL_CHR(6.487f, 3.438f, 0.977f, 10.638f, 1.125f, 7.419f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7MSK)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(15.875f, 4.137f, 8.350f, 10.638f, 1.125f, 1.423f)	// O
		WK7CAMSET_DECL_CHR(15.875f, 4.137f, 8.350f, 10.638f, 1.125f, 1.423f)	// EO
		WK7CAMSET_DECL_CHR(6.487f, 3.438f, 0.977f, 10.638f, 1.125f, 7.419f)	// 
		WK7CAMSET_DECL_CHR(6.487f, 3.438f, 0.977f, 10.638f, 1.125f, 7.419f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7HAY)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(15.875f, 4.137f, 8.350f, 10.638f, 1.125f, 1.423f)	// O
		WK7CAMSET_DECL_CHR(15.875f, 4.137f, 8.350f, 10.638f, 1.125f, 1.423f)	// EO
		WK7CAMSET_DECL_CHR(6.487f, 3.438f, 0.977f, 10.638f, 1.125f, 7.419f)	// 
		WK7CAMSET_DECL_CHR(6.487f, 3.438f, 0.977f, 10.638f, 1.125f, 7.419f)	// E

	WK7CAMSET_DECL_CHR_END()
	
WK7CAMSET_DECL_END()

WK7CAMSET_DECL_BEGIN(6)
	
	WK7CAMSET_DECL_CHR_BEGIN(K7DAN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// O
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// EO
		WK7CAMSET_DECL_CHR(12.012f, 2.937f, 7.427f, 7.838f, 5.413f, 16.850f)	// 
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// E

	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7GAL)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// O
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// EO
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// 
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CAT)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// O
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// EO
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// 
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CYO)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// O
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// EO
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// 
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KED)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// O
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// EO
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// 
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KVN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// O
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// EO
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// 
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7MSK)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// O
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// EO
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// 
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7HAY)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// O
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// EO
		WK7CAMSET_DECL_CHR(12.012f, 2.937f, 7.427f, 7.838f, 5.413f, 16.850f)	// 
		WK7CAMSET_DECL_CHR(11.837f, 3.312f, 7.427f, 8.238f, 6.688f, 16.850f)	// E

	WK7CAMSET_DECL_CHR_END()
	
WK7CAMSET_DECL_END()

WK7CAMSET_DECL_BEGIN(7)
	
	WK7CAMSET_DECL_CHR_BEGIN(K7DAN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// O
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// EO
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// 
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// E

	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7GAL)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// O
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// EO
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// 
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CAT)
						//      fd        ph         pv         tf         th         tv
//		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// O
//		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// EO
		WK7CAMSET_DECL_CHR(36.213f, 4.850f, 27.237f, 7.101f, 2.013f, 15.136f)	// O
		WK7CAMSET_DECL_CHR(36.213f, 4.850f, 27.237f, 7.101f, 2.013f, 15.136f)	// EO
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// 
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CYO)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// O
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// EO
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// 
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KED)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// O
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// EO
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// 
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KVN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// O
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// EO
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// 
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7MSK)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// O
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// EO
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// 
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7HAY)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// O
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// EO
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// 
		WK7CAMSET_DECL_CHR(24.425f, 5.312f, 27.237f, 7.101f, 2.013f, 15.136f)	// E

	WK7CAMSET_DECL_CHR_END()
	
WK7CAMSET_DECL_END()

WK7CAMSET_DECL_BEGIN(8)
	
	WK7CAMSET_DECL_CHR_BEGIN(K7DAN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(8.137f, 4.812f, 6.314f, 10.000f, -0.013f, 13.427f)	// O
		WK7CAMSET_DECL_CHR(8.137f, 4.812f, 6.314f, 10.000f, -0.013f, 13.827f)	// EO
		WK7CAMSET_DECL_CHR(10.088f, 6.212f, 2.619f, 10.000f, -0.013f, 10.032f)	// 
		WK7CAMSET_DECL_CHR(10.888f, 6.274f, 2.619f, 10.000f, -0.013f, 10.077f)	// E

	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7GAL)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(11.000f, 3.912f, 11.073f, 10.000f, 3.000f, 14.432f)	// O
		WK7CAMSET_DECL_CHR(10.987f, 4.412f, 10.314f, 10.000f, 3.000f, 14.750f)	// EO
		WK7CAMSET_DECL_CHR(12.462f, 5.487f, 2.293f, 10.000f, 3.038f, 11.268f)	// 
		WK7CAMSET_DECL_CHR(10.950f, 7.612f, 2.589f, 9.913f, 3.938f, 10.077f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CAT)
						//      fd        ph         pv         tf         th         tv
//		WK7CAMSET_DECL_CHR(9.325f, 3.450f, 3.600f, 10.000f, 2.613f, 12.000f)	// O
//		WK7CAMSET_DECL_CHR(9.325f, 3.450f, 3.600f, 10.000f, 2.613f, 12.000f)	// EO
		WK7CAMSET_DECL_CHR(18.225f, 4.475f, 3.600f, 10.000f, 2.613f, 12.000f)	// O
		WK7CAMSET_DECL_CHR(18.225f, 4.475f, 3.600f, 10.000f, 2.613f, 12.000f)	// EO
		WK7CAMSET_DECL_CHR(10.175f, 6.625f, 2.534f, 8.225f, 0.163f, 8.936f)		// 
		WK7CAMSET_DECL_CHR(10.175f, 6.625f, 2.534f, 10.000f, 0.163f, 8.759f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CYO)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(9.962f, 4.187f, 7.873f, 10.000f, 1.700f, 13.595f)	// O
		WK7CAMSET_DECL_CHR(11.375f, 4.212f, 5.873f, 10.000f, 3.375f, 12.850f)	// EO
		WK7CAMSET_DECL_CHR(10.487f, 6.762f, 2.419f, 10.000f, 3.375f, 9.964f)	// 
		WK7CAMSET_DECL_CHR(10.487f, 6.762f, 2.419f, 10.000f, 3.375f, 9.055f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KED)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(12.275f, 3.787f, 5.678f, 10.000f, 3.600f, 11.627f)	// O
		WK7CAMSET_DECL_CHR(11.412f, 3.650f, 6.646f, 10.000f, 3.600f, 10.614f)	// EO
		WK7CAMSET_DECL_CHR(10.100f, 4.825f, 2.419f, 10.000f, 3.375f, 9.055f)	// 
		WK7CAMSET_DECL_CHR(10.100f, 4.825f, 2.419f, 10.000f, 3.375f, 9.055f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KVN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(11.512f, 4.212f, 4.478f, 9.675f, 0.300f, 13.086f)	// O
		WK7CAMSET_DECL_CHR(11.512f, 4.212f, 4.478f, 10.000f, 0.300f, 12.905f)	// EO
		WK7CAMSET_DECL_CHR(10.987f, 6.137f, 3.146f, 10.000f, 4.400f, 9.368f)	// 
		WK7CAMSET_DECL_CHR(10.600f, 5.875f, 3.146f, 10.000f, 4.400f, 8.600f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7MSK)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(10.687f, 3.412f, 6.569f, 9.525f, 3.875f, 15.018f)	// O
		WK7CAMSET_DECL_CHR(10.687f, 3.412f, 6.569f, 10.000f, 3.875f, 15.036f)	// EO
		WK7CAMSET_DECL_CHR(11.937f, 6.837f, 2.446f, 10.000f, 4.400f, 10.514f)	// 
		WK7CAMSET_DECL_CHR(12.787f, 6.837f, 2.446f, 10.000f, 4.400f, 10.541f)	// E
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7HAY)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(8.137f, 4.812f, 6.314f, 10.000f, -0.013f, 13.427f)	// O
		WK7CAMSET_DECL_CHR(8.137f, 4.812f, 6.314f, 10.000f, -0.013f, 13.827f)	// EO
		WK7CAMSET_DECL_CHR(10.088f, 6.212f, 2.619f, 10.000f, -0.013f, 10.032f)	// 
		WK7CAMSET_DECL_CHR(10.888f, 6.274f, 2.619f, 10.000f, -0.013f, 10.077f)	// E

	WK7CAMSET_DECL_CHR_END()
	
WK7CAMSET_DECL_END()

WK7CAMSET_DECL_BEGIN(9)
	// EC_{Xp
	WK7CAMSET_DECL_CHR_BEGIN(K7DAN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(10.088f, 6.212f, 6.201f, 10.000f, 0.013f, 10.032f)	// O
		WK7CAMSET_DECL_CHR(10.088f, 6.212f, 6.201f, 10.000f, 0.013f, 10.032f)	// EO
		WK7CAMSET_DECL_CHR(10.088f, 6.212f, 6.201f, 10.000f, 0.013f, 10.032f)	// 
		WK7CAMSET_DECL_CHR(10.088f, 6.212f, 6.201f, 10.000f, 0.013f, 10.032f)	// E

	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7GAL)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(12.462f, 5.487f, 10.373f, 10.000f, 3.038f, 11.268f)	// O
		WK7CAMSET_DECL_CHR(12.462f, 5.487f, 10.373f, 10.000f, 3.038f, 11.268f)	// EO
		WK7CAMSET_DECL_CHR(12.462f, 5.487f, 10.373f, 10.000f, 3.038f, 11.268f)	// 
		WK7CAMSET_DECL_CHR(12.462f, 5.487f, 10.373f, 10.000f, 3.038f, 11.268f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CAT)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(10.175f, 6.625f, 8.446f, 8.225f, 0.163f, 8.936f)	// O
		WK7CAMSET_DECL_CHR(10.175f, 6.625f, 8.446f, 8.225f, 0.163f, 8.936f)	// EO
		WK7CAMSET_DECL_CHR(10.175f, 6.625f, 8.446f, 8.225f, 0.163f, 8.936f)	// 
		WK7CAMSET_DECL_CHR(10.175f, 6.625f, 8.446f, 8.225f, 0.163f, 8.936f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CYO)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(10.487f, 6.762f, 6.546f, 10.000f, 3.375f, 9.964f)	// O
		WK7CAMSET_DECL_CHR(10.487f, 6.762f, 6.546f, 10.000f, 3.375f, 9.964f)	// EO
		WK7CAMSET_DECL_CHR(10.487f, 6.762f, 6.546f, 10.000f, 3.375f, 9.964f)	// 
		WK7CAMSET_DECL_CHR(10.487f, 6.762f, 6.546f, 10.000f, 3.375f, 9.964f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KED)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(10.100f, -4.825f, 5.855f, 10.000f, -3.375f, 9.055f)	// O
		WK7CAMSET_DECL_CHR(10.100f, -4.825f, 5.855f, 10.000f, -3.375f, 9.055f)	// EO
		WK7CAMSET_DECL_CHR(10.100f, -4.825f, 5.855f, 10.000f, -3.375f, 9.055f)	// 
		WK7CAMSET_DECL_CHR(10.100f, -4.825f, 5.855f, 10.000f, -3.375f, 9.055f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KVN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(10.987f, 6.137f, 7.373f, 10.000f, 4.400f, 9.368f)	// O
		WK7CAMSET_DECL_CHR(10.987f, 6.137f, 7.373f, 10.000f, 4.400f, 9.368f)	// EO
		WK7CAMSET_DECL_CHR(10.987f, 6.137f, 7.373f, 10.000f, 4.400f, 9.368f)	// 
		WK7CAMSET_DECL_CHR(10.987f, 6.137f, 7.373f, 10.000f, 4.400f, 9.368f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7MSK)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(11.937f, 6.837f, 6.305f, 10.000f, 4.400f, 10.514f)	// O
		WK7CAMSET_DECL_CHR(11.937f, 6.837f, 6.305f, 10.000f, 4.400f, 10.514f)	// EO
		WK7CAMSET_DECL_CHR(11.937f, 6.837f, 6.305f, 10.000f, 4.400f, 10.514f)	// 
		WK7CAMSET_DECL_CHR(11.937f, 6.837f, 6.305f, 10.000f, 4.400f, 10.514f)	// E
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7HAY)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(10.088f, 6.212f, 6.201f, 10.000f, 0.013f, 10.032f)	// O
		WK7CAMSET_DECL_CHR(10.088f, 6.212f, 6.201f, 10.000f, 0.013f, 10.032f)	// EO
		WK7CAMSET_DECL_CHR(10.088f, 6.212f, 6.201f, 10.000f, 0.013f, 10.032f)	// 
		WK7CAMSET_DECL_CHR(10.088f, 6.212f, 6.201f, 10.000f, 0.013f, 10.032f)	// E

	WK7CAMSET_DECL_CHR_END()
	
WK7CAMSET_DECL_END()

WK7CAMSET_DECL_BEGIN(10)
	// eLTXRp
	WK7CAMSET_DECL_CHR_BEGIN(K7DAN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(17.187f, 5.250f, 7.568f, 10.000f, 3.375f, 9.964f)	// O
		WK7CAMSET_DECL_CHR(17.187f, 5.250f, 7.568f, 10.000f, 3.375f, 9.964f)	// EO
		WK7CAMSET_DECL_CHR(15.937f, 4.762f, 5.814f, 10.000f, 3.375f, 9.964f)	// 
		WK7CAMSET_DECL_CHR(15.937f, 4.762f, 5.814f, 10.000f, 3.375f, 9.964f)	// E

	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7GAL)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(18.176f, 8.812f, 9.797f, 10.000f, 0.013f, 10.032f)	// O
		WK7CAMSET_DECL_CHR(18.176f, 8.812f, 9.797f, 10.000f, 0.013f, 10.032f)	// EO
		WK7CAMSET_DECL_CHR(18.176f, 8.812f, 9.797f, 10.000f, 0.013f, 10.032f)	// 
		WK7CAMSET_DECL_CHR(14.038f, 9.112f, 4.256f, 10.000f, 0.013f, 10.032f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CAT)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(10.175f, 6.625f, 8.446f, 8.225f, 0.163f, 8.936f)	// O
		WK7CAMSET_DECL_CHR(10.175f, 6.625f, 8.446f, 8.225f, 0.163f, 8.936f)	// EO
		WK7CAMSET_DECL_CHR(8.287f, 4.362f, 1.737f, 8.225f, 0.163f, 8.936f)	// 
		WK7CAMSET_DECL_CHR(8.287f, 4.362f, 1.737f, 8.225f, 0.163f, 8.936f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7CYO)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(14.287f, 9.925f, 6.037f, 8.225f, 0.163f, 8.936f)	// O
		WK7CAMSET_DECL_CHR(14.287f, 9.925f, 6.037f, 8.225f, 0.163f, 8.936f)	// EO
		WK7CAMSET_DECL_CHR(14.287f, 9.925f, 6.037f, 8.225f, 0.163f, 8.936f)	// 
		WK7CAMSET_DECL_CHR(10.575f, 8.462f, 3.537f, 8.225f, 0.163f, 8.936f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KED)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(14.725f, 7.275f, 4.774f, 10.000f, 3.375f, 9.055f)	// O
		WK7CAMSET_DECL_CHR(14.725f, 7.275f, 4.774f, 10.000f, 3.375f, 9.055f)	// EO
		WK7CAMSET_DECL_CHR(14.925f, 7.362f, 5.851f, 10.000f, 3.375f, 9.055f)	// 
		WK7CAMSET_DECL_CHR(14.150f, 7.275f, 5.451f, 10.000f, 3.375f, 9.055f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7KVN)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(18.075f, 6.712f, 10.845f, 10.000f, 4.400f, 9.368f)	// O
		WK7CAMSET_DECL_CHR(18.075f, 6.712f, 10.845f, 10.000f, 4.400f, 9.368f)	// EO
		WK7CAMSET_DECL_CHR(10.987f, 6.137f, 7.619f, 10.000f, 4.400f, 9.368f)	// 
		WK7CAMSET_DECL_CHR(10.987f, 6.137f, 7.619f, 10.000f, 4.400f, 9.368f)	// E
		
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7MSK)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(17.762f, 4.762f, 6.055f, 10.000f, 4.400f, 10.514f)	// O
		WK7CAMSET_DECL_CHR(17.762f, 4.762f, 6.055f, 10.000f, 4.400f, 10.514f)	// EO
		WK7CAMSET_DECL_CHR(12.499f, 6.837f, 2.669f, 10.000f, 4.400f, 10.514f)	// 
		WK7CAMSET_DECL_CHR(12.499f, 6.837f, 2.669f, 10.000f, 4.400f, 10.514f)	// E
	WK7CAMSET_DECL_CHR_END()
	
	WK7CAMSET_DECL_CHR_BEGIN(K7HAY)
						//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR(15.263f, 9.087f, 6.683f, 10.000f, 0.013f, 10.032f)	// O
		WK7CAMSET_DECL_CHR(15.263f, 9.087f, 6.683f, 10.000f, 0.013f, 10.032f)	// EO
		WK7CAMSET_DECL_CHR(15.263f, 9.087f, 6.683f, 10.000f, 0.013f, 10.032f)	// 
		WK7CAMSET_DECL_CHR(15.263f, 9.087f, 6.683f, 10.000f, 0.013f, 10.032f)	// E

	WK7CAMSET_DECL_CHR_END()
	
WK7CAMSET_DECL_END()

WK7CAMSET_BEGIN()
	WK7CAMSET(0)
	WK7CAMSET(1)
	WK7CAMSET(2)
	WK7CAMSET(3)
	WK7CAMSET(4)
	WK7CAMSET(5)
	WK7CAMSET(6)
	WK7CAMSET(7)
	WK7CAMSET(8)
	WK7CAMSET(9)
	WK7CAMSET(10)
WK7CAMSET_END()

#endif

#endif

