////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Kubi 
//
// Kubi.h
//
//
////////////////////////////////////////////////////////////////////////////////


#ifndef	__KUBI_H__
#define	__KUBI_H__

// ̃WṽXg
typedef struct _KUBIJUMPLIST{
	u32		deadStgid;			// SXe[WID
	u32		jumpStgid;			// WṽXe[WID
	Vec		pos;				// ̈ʒu
	u32		eventFlag;			// CxgtO
}KUBIJUMPLIST;


#ifdef	__WK7PLAYER_CPP__

#include "..\Scn\K7Scn00.h"
#include "..\Scn\K7Scn01.h"
#include "..\Scn\K7Scn02.h"
#include "..\Scn\K7Scn03.h"
#include "..\Scn\K7Scn04.h"
#include "..\Scn\K7Scn05.h"
#include "..\Scn\K7Scn06.h"
#include "..\Scn\K7Scn07.h"
#include "..\Scn\K7Scn97.h"
#include "..\Scn\K7Scn98.h"
#include "..\Scn\K7Scn99.h"


// eventFlag [0] Cxg̔r͍s܂iK̓Wvɓ]܂j

static KUBIJUMPLIST Scenario0_KubiJumpTbl[] = {
// ViI00
//	deadStgid			jumpStgid			pos										eventFlag
	{K7STGID(771,1),	K7STGID(771,0),		{ -10.862f, 0.f, 64.464f},		K7SCN07_DRFL_000113},
	{K7STGID(775,2),	K7STGID(775,1),		{ 31.708f,		0.f,	249.287f},		0},			//Ln
	{K7STGID(776,2),	K7STGID(776,1),		{ 53.771f,		0.f,	278.674f},		0},			//{X
	{0xffffffff,		0xffffffff,			{ 0.f,			0.f,		0.f},		0},			// IR[h

};

static KUBIJUMPLIST Scenario1_KubiJumpTbl[] = {
// ViI01
//	deadStgid			jumpStgid			pos										eventFlag
	{K7STGID(000,0),	K7STGID(000,0),		{ 0.f,			0.f,		0.f},		0},
	{K7STGID(101,1),	K7STGID(105,0),		{ 586.900f, 	0.f, 	57.372f},		0},			//tNV}@2KX[W[̕
//	{K7STGID(105,0),	K7STGID(100,0),		{ 11.717f, 		0.f, 	-253.353f},		0},			//tNV}@V䗠Ƃ̈K
	{K7STGID(105,0),	K7STGID(105,0),		{ 408.036f, 	0.f, 	-22.301f},		0},			//tNV}@V䗠Ƃ̈K
	{K7STGID(115,0),	K7STGID(115,1),		{ -0.435f,		0.f,	-192.681f},		0},			//tNV}@{X
	{K7STGID(118,0),	K7STGID(112,0),		{ 863.646f,		0.f,		-1196.6f},	0},			//tNV}@Ln
	{K7STGID(180,0),	K7STGID(108,0),		{ 121.0f,		0.f,		-49.3f},	0},			//tNV}@gC
	{K7STGID(133,0),	K7STGID(133,0),		{ 279.2f, 		0.f, 		-100.8f},	0},			//pr@3FiR[eWv΍j
	{K7STGID(134,0),	K7STGID(134,0),		{ 279.2f, 		0.f, 		-100.8f},	0},			//pr@4Fi[U[΍j
	{K7STGID(138,0),	K7STGID(134,0),		{ 154.7f, 		0.f, 		-100.1f},	0},			//pr@Ln
	{K7STGID(160,0),	K7STGID(135,0),		{ 56.28f, 		0.f, 		-99.868f},	0},			//pr@{X
	{0xffffffff,		0xffffffff,			{ 0.f,			0.f,		0.f},		0},			// IR[h

};

static KUBIJUMPLIST Scenario2_KubiJumpTbl[] = {
// ViI02
//	deadStgid			jumpStgid			pos										eventFlag
	{K7STGID(000,0),	K7STGID(000,0),		{ 0.f,			0.f,		0.f},		0},
	{K7STGID(201,0),	K7STGID(201,0),		{ 19.922f, 		0.f, 	-614.483f},		0},			//^N[[̉~h~
	{K7STGID(208,0),	K7STGID(208,0),		{ -1114.5f, 	0.f, 	-1478.4f},		0},			//Zn
	{K7STGID(210,0),	K7STGID(208,0),		{ -411.138f, 	0.f, 	-1421.053f},	K7SCN02_ENFL_POP_R208},		//nỶƁiRoom208j
	{K7STGID(210,0),	K7STGID(208,0),		{ -670.386f, 	0.f, 	-1401.271f},	K7SCN02_ENFL_POP_R209},		//nỶƁiRoom209j
	{K7STGID(210,0),	K7STGID(208,0),		{ -412.247f, 	0.f, 	-1320.196f},	K7SCN02_ENFL_POP_R217},		//nỶƁiRoom217j
	{K7STGID(210,0),	K7STGID(208,0),		{ -669.196f, 	0.f, 	-1339.909f},	K7SCN02_ENFL_POP_R218},		//nỶƁiRoom218j
	{K7STGID(210,0),	K7STGID(208,0),		{ -931.310f, 	0.f, 	-1402.759f},	K7SCN02_ENFL_POP_R219},		//nỶƁiRoom219j
	{K7STGID(211,0),	K7STGID(208,0),		{ -937.178f, 	0.f, 	-1438.084f},	0},			//	`̕iRoom210j
	{K7STGID(212,0),	K7STGID(208,0),		{ -835.128f, 	0.f, 	-1931.880f},	0},			//	`̕iRoom206j
	{K7STGID(206,0),	K7STGID(205,0),		{ 54.029f, 		270.f, -8006.572f},		0},			//{X
	{0xffffffff,		0xffffffff,			{ 0.f,			0.f,		0.f},		0},					// IR[h

};

static KUBIJUMPLIST Scenario3_KubiJumpTbl[] = {
// ViI03
//	deadStgid			jumpStgid			pos										eventFlag
	{K7STGID(000,0),	K7STGID(000,0),		{ 0.f,			0.f,		0.f},		0},
	{K7STGID(328,0),	K7STGID(327,0),		{ 0.060f, 		-79.9f, -1672.988f},	0},			//Vn@Ln
	{K7STGID(306,0),	K7STGID(327,0),		{ -243.447f, 	-40.7f, -1708.278f},	0},			//Vn@~Xe[nEX@
	{K7STGID(307,0),	K7STGID(327,0),		{ -243.447f, 	-40.7f, -1708.278f},	0},			//Vn@~Xe[nEX@[vL
	{K7STGID(308,0),	K7STGID(327,0),		{ -243.447f, 	-40.7f, -1708.278f},	0},			//Vn@~Xe[nEX@[bg
	{K7STGID(309,0),	K7STGID(327,0),		{ -243.447f, 	-40.7f, -1708.278f},	0},			//Vn@~Xe[nEX@΂̋
	{K7STGID(310,0),	K7STGID(327,0),		{ -243.447f, 	-40.7f, -1708.278f},	0},			//Vn@{XuZ~bNv
	{K7STGID(312,0),	K7STGID(327,0),		{ 268.315f, 	-40.691f, -1692.792f},	0},			//Vn@L[ebh@Pe
	{K7STGID(312,1),	K7STGID(327,0),		{ 268.315f, 	-40.691f, -1692.792f},	0},			//Vn@L[ebh@Qe
	{K7STGID(312,2),	K7STGID(327,0),		{ 268.315f, 	-40.691f, -1692.792f},	0},			//Vn@L[ebh@Re
	{K7STGID(316,0),	K7STGID(329,0),		{ 53.125f, 		-80.4f, -2161.210f},	0},			//Vn@{XuAJl1ځv
	{K7STGID(354,0),	K7STGID(354,0),		{ -329.416f, 	25.07f, -1000.916f},	0},			//J[eBX@@igFj
	{K7STGID(357,0),	K7STGID(357,0),		{ -348.3f, 		25.f, 	-1465.1f},		0},			//J[eBX@@Q
	{K7STGID(361,0),	K7STGID(356,0),		{ -141.319f, 156.991f, -3076.523f},		0},			//J[eBX@@{XuAJl2ځv
	{K7STGID(365,0),	K7STGID(362,0),		{ -464.421f,	-14.4f,	-1119.747f},	0},			//J[eBX@@Ln
	{K7STGID(363,0),	K7STGID(364,0),		{ -695.572f,	-56.677f,-1120.305f},	0},			//J[eBX@@{X
	{0xffffffff,		0xffffffff,			{ 0.f,			0.f,		0.f},		0},					// IR[h

};

static KUBIJUMPLIST Scenario4_KubiJumpTbl[] = {
// ViI04
//	deadStgid			jumpStgid			pos										eventFlag
	{K7STGID(000,0),	K7STGID(000,0),		{ 0.f,			0.f,		0.f},		0},
	{K7STGID(412,0),	K7STGID(411,0),		{ 137.043f, 	0.f,	-393.727f},		0},			//h~jJ@̊X
	{K7STGID(415,0),	K7STGID(415,0),		{ 980.897f, 	0.f, 	-1521.975f},	0},			//h~jJ@O
	{0xffffffff,		0xffffffff,			{ 0.f,			0.f,		0.f},		0},					// IR[h

};

static KUBIJUMPLIST Scenario5_KubiJumpTbl[] = {
// ViI05
//	deadStgid			jumpStgid			pos										eventFlag
	{K7STGID(000,0),	K7STGID(000,0),		{ 0.f,			0.f,		0.f},		0},
	{K7STGID(520,0),	K7STGID(517,0),		{ -108.5f,		0.f,	-276.9f},		0},			//ze@Ln
	{K7STGID(557,0),	K7STGID(551,2),		{ 431.744f, 	60.f,	 -90.694f},		0},			//wZ@Ln
	{K7STGID(553,0),	K7STGID(552,0),		{ 728.762f, 	-22.4f,	 -441.039f},	0},			//wZ@{X
	{0xffffffff,		0xffffffff,			{ 0.f,			0.f,		0.f},		0},					// IR[h

};

static KUBIJUMPLIST Scenario6_KubiJumpTbl[] = {
// ViI06
//	deadStgid			jumpStgid			pos										eventFlag
	{0xffffffff,		0xffffffff,			{ 0.f,			0.f,		0.f},		0},					// IR[h

};


#endif

#endif

