////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Event Script
//
// WK7EventScript.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/08/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7EVENTSCRIPT_H__
#define	__WK7EVENTSCRIPT_H__

//#include "..\Lib\ghmGcTask.h"
//#include ".\WK7Define.h"
//#include ".\K7ID.h"


////////////////////////////////////////////////////////////////////////////////
// CxgfXNv^錾
//

//
// CxgfXNv^^Cv
//
enum{
	K7EV_DESC_TYPE_SCNINIT = 0,				//. ViI
	K7EV_DESC_TYPE_SCNCONTINUE,				//. ViIReBj[
	K7EV_DESC_TYPE_SCNTERM,					//. ViII
	K7EV_DESC_TYPE_STGCREATE,				// Xe[W
	K7EV_DESC_TYPE_STGINIT,					// Xe[W
	K7EV_DESC_TYPE_STGCONDCHANGE,			// Xe[WԕύX
	K7EV_DESC_TYPE_STGTERM,					// Xe[WI
	K7EV_DESC_TYPE_STGSETCURRENT,			// Xe[WJgɃZbgiLN^wpXɈړj
	
//	K7EV_DESC_TYPE_STGBPARRIVE,				//. _
	K7EV_DESC_TYPE_STGBPARRIVE_DEFMOVE,		//o Xe[WԈړi_ɃCxgݒ肪قɂȂꍇj
	K7EV_DESC_TYPE_STGBPARRIVE_DEFMOVE2,	//o Xe[WԈړQiIIuWFNgɃCxgݒ肪قɂȂꍇj
	K7EV_DESC_TYPE_STGBPARRIVE_DEFPLAY,		//o Xe[WLi_ɃCxgݒ肪قɂȂꍇj
	K7EV_DESC_TYPE_STGBPARRIVE_DOOR,		//o Xe[WhACxg
	K7EV_DESC_TYPE_STGBPTV,					//o erICxg
	K7EV_DESC_TYPE_STGBPLTV,				//o erICxg
	K7EV_DESC_TYPE_STGHITOBJ,				//o 蔻IuWFNgCxg
	
	K7EV_DESC_TYPE_STGBPLEAVE,				//x _oCxg
	K7EV_DESC_TYPE_STGBPARRIVEEVNO,			//x _CxgiCxgԍŁj
	K7EV_DESC_TYPE_STGBPLEAVEEVNO,			//x _oCxgiCxgԍŁj
	K7EV_DESC_TYPE_STGBPLEAVEEVNOPN,		//x _oCxgiCxgԍpXԍŁj
	
	K7EV_DESC_TYPE_STGBPMAP,				//o }bvCxg
	K7EV_DESC_TYPE_STGBPKEY,				//o L[Cxg
	K7EV_DESC_TYPE_STGBPMEMO,				//o Cxg
	K7EV_DESC_TYPE_STGSPATTACK,				//. XyVA^bN
};

//
// CxgfXNv^^`ii[\́j
//
struct K7EventDesc{
	u32						mID;
	int						mType;
	inline u32 GetID(void){ return mID; }
	inline int GetType(void){ return mType; }
};

// ViI
typedef	K7EventDesc		K7EventDescScnInit;
// ViIReBj[
typedef	K7EventDesc		K7EventDescScnContinue;
// ViII
typedef	K7EventDesc		K7EventDescScnTerm;

// Xe[W
struct K7EventDescStgInit{
	K7EventDesc				mBase;
	u32						mStgID;
};

// ViI
typedef	K7EventDescStgInit	K7EventDescStgCreate;

// Xe[WI
typedef	K7EventDescStgInit	K7EventDescStgTerm;

// Xe[WԕύX
typedef	K7EventDescStgInit	K7EventDescStgCondChange;

// JgXe[Wݒ
typedef	K7EventDescStgInit	K7EventDescStgSetCurrent;

// Xe[W_
//struct K7EventDescStgBpArrive{
//	K7EventDesc				mBase;
//	u32						mStgID;
//	const char				*mpBpName;
//};

// Xe[W_o
struct K7EventDescStgBpLeave{
	K7EventDesc				mBase;
	u32						mStgID;
	const char				*mpBpName;
	const char				*mpPathName;
};

// Xe[W_iCxgԍŁj
struct K7EventDescStgBpArriveEventNo{
	K7EventDesc				mBase;
	u32						mEventNo;
};

// Xe[W_oiCxgԍŁj
struct K7EventDescStgBpLeaveEventNo{
	K7EventDesc				mBase;
	u32						mEventNo;
	u32						mPathNo;
};

// Xe[W_oiCxgԍpXwŁj
struct K7EventDescStgBpLeaveEventNoPathName{
	K7EventDesc				mBase;
	u32						mEventNo;
	const char				*mpPathName;
};

// Xe[WԈړiftHgj
typedef	K7EventDesc			K7EventDescStgBpArriveDefMove;

// Xe[WLiftHgj
typedef	K7EventDesc			K7EventDescStgBpArriveDefPlay;

// Xe[WԈړQiftHgj
typedef	K7EventDesc			K7EventDescStgBpArriveDefMove2;

// erICxg
typedef	K7EventDesc			K7EventDescStgBpTv;

// erICxg
typedef	K7EventDesc			K7EventDescStgBpLtv;

// }bvCxg
struct K7EventDescStgBpMap
{
	K7EventDesc				mBase;
	u32						mEventNo;
};

// L[Cxg
struct K7EventDescStgBpKey
{
	K7EventDesc				mBase;
	u32						mEventNo;
};

// Cxg
struct K7EventDescStgBpMemo
{
	K7EventDesc				mBase;
	u32						mEventNo;
};

// 蔻IuWFNgCxg
struct K7EventDescStgHitObj{
	K7EventDesc				mBase;
	u32						mEventNo;
};

// Xe[WhACxgiftHgj
typedef	K7EventDesc			K7EventDescStgBpArriveDoor;

// LN^XyVA^bN
struct K7EventDescStgSpAttack{
	K7EventDesc				mBase;
	u32						mStgID;
	u32						mChrMainID;
};

//
// CxgfXNv^iCxg̔`ɉĒǉj
//
// XNvgŎې錾Lq̂͂̃}N̂݁II
//

// VXe֘A ----------------------------------------------------------------

// ViIJnɌĂ΂
#define	K7EV_DESC_SCNINIT(evid)		K7EV_DESC(evid,K7EventDescScnInit,K7EV_DESC_TYPE_SCNINIT)

// ViIReBj[
#define	K7EV_DESC_SCNCONTINUE(evid) K7EV_DESC(evid,K7EventDescScnContinue,K7EV_DESC_TYPE_SCNCONTINUE)

// ViIIɌĂ΂
#define	K7EV_DESC_SCNTERM(evid)		K7EV_DESC(evid,K7EventDescScnTerm,K7EV_DESC_TYPE_SCNTERM)

// Xe[W֘A ----------------------------------------------------------------

// Xe[W
#define	K7EV_DESC_STGCREATE(evid,stgid) \
										K7EV_DESC(evid,K7EventDescStgCreate,K7EV_DESC_TYPE_STGCREATE,stgid)

// Xe[W
#define	K7EV_DESC_STGINIT(evid,stgid) \
										K7EV_DESC(evid,K7EventDescStgInit,K7EV_DESC_TYPE_STGINIT,stgid)

// Xe[WI
#define	K7EV_DESC_STGTERM(evid,stgid) \
										K7EV_DESC(evid,K7EventDescStgTerm,K7EV_DESC_TYPE_STGTERM,stgid)

// Xe[WԕύX
#define	K7EV_DESC_STGCONDCHANGE(evid,stgid) \
										K7EV_DESC(evid,K7EventDescStgCondChange,K7EV_DESC_TYPE_STGCONDCHANGE,stgid)

// JgXe[Wݒ莞
#define	K7EV_DESC_STGSETCURRENT(evid,stgid) \
										K7EV_DESC(evid,K7EventDescStgSetCurrent,K7EV_DESC_TYPE_STGSETCURRENT,stgid)

// Xe[W̃pX_
//#define	K7EV_DESC_STGBPARRIVE(evid,stgid,bpname) \
//										K7EV_DESC(evid,K7EventDescStgBpArrive,K7EV_DESC_TYPE_STGBPARRIVE,stgid,bpname)

// Xe[W̃pX_iCxgԍŁj
#define	K7EV_DESC_STGBPARRIVE_EVNO(evid,evno) \
										K7EV_DESC(evid,K7EventDescStgBpArriveEventNo,K7EV_DESC_TYPE_STGBPARRIVEEVNO,evno)

// Xe[W̃pX_o
#define	K7EV_DESC_STGBPLEAVE(evid,stgid,bpname) \
										K7EV_DESC(evid,K7EventDescStgBpLeave,K7EV_DESC_TYPE_STGBPLEAVE,stgid,bpname)

// Xe[W̃pX_oiCxgԍŁj
#define	K7EV_DESC_STGBPLEAVE_EVNO(evid,evno,pathno) \
										K7EV_DESC(evid,K7EventDescStgBpLeaveEventNo,K7EV_DESC_TYPE_STGBPLEAVEEVNO,evno,pathno)

// Xe[W̃pX_oiCxgԍpXwŁj
#define	K7EV_DESC_STGBPLEAVE_EVNO_PN(evid,evno,pathname) \
										K7EV_DESC(evid,K7EventDescStgBpLeaveEventNoPathName,K7EV_DESC_TYPE_STGBPLEAVEEVNOPN,evno,pathname)

// Xe[WԈړiftHgj
#define	K7EV_DESC_STGBPARRIVE_DEFMOVE(evid) \
										K7EV_DESC(evid,K7EventDescStgBpArriveDefMove,K7EV_DESC_TYPE_STGBPARRIVE_DEFMOVE)

// Xe[WLiftHgj
#define	K7EV_DESC_STGBPARRIVE_DEFPLAY(evid) \
										K7EV_DESC(evid,K7EventDescStgBpArriveDefPlay,K7EV_DESC_TYPE_STGBPARRIVE_DEFPLAY)

// Xe[WԈړQiftHgj
#define	K7EV_DESC_STGBPARRIVE_DEFMOVE2(evid) \
										K7EV_DESC(evid,K7EventDescStgBpArriveDefMove2,K7EV_DESC_TYPE_STGBPARRIVE_DEFMOVE2)

// erICxg
#define	K7EV_DESC_STGBPTV(evid) \
										K7EV_DESC(evid,K7EventDescStgBpTv,K7EV_DESC_TYPE_STGBPTV)

// erICxg
#define	K7EV_DESC_STGBPLTV(evid) \
										K7EV_DESC(evid,K7EventDescStgBpLtv,K7EV_DESC_TYPE_STGBPLTV)

// 蔻IuWFNgCxg
#define	K7EV_DESC_STGHITOBJ(evid,evno) \
										K7EV_DESC(evid,K7EventDescStgHitObj,K7EV_DESC_TYPE_STGHITOBJ,evno)

// }bvCxg
#define	K7EV_DESC_STGBPMAP(evid,evno) \
										K7EV_DESC(evid,K7EventDescStgBpMap,K7EV_DESC_TYPE_STGBPMAP,evno)

// L[Cxg
#define	K7EV_DESC_STGBPKEY(evid,evno) \
										K7EV_DESC(evid,K7EventDescStgBpKey,K7EV_DESC_TYPE_STGBPKEY,evno)

// Cxg
#define	K7EV_DESC_STGBPMEMO(evid,evno) \
										K7EV_DESC(evid,K7EventDescStgBpMemo,K7EV_DESC_TYPE_STGBPMEMO,evno)

// hAxg
#define	K7EV_DESC_STGBPARRIVE_DOOR(evid) \
										K7EV_DESC(evid,K7EventDescStgBpArriveDoor,K7EV_DESC_TYPE_STGBPARRIVE_DOOR)

// XyVA^bN
#define	K7EV_DESC_STGSPATTACK(evid,stgid,chrmainid) \
										K7EV_DESC(evid,K7EventDescStgSpAttack,K7EV_DESC_TYPE_STGSPATTACK,stgid,chrmainid)

//
// CxgfXNv^錾
////////////////////////////////////////////////////////////////////////////////

// -----------------------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////
// XNvgR}hꗗ
//

// VXe֘A ----------------------------------------------------------------

// VXeɐ߂
#define	K7SCR_RETSYS()					GHMGCTASK_RETSYS()

// XNvgI
#define	K7SCR_EXIT()					GHMGCTASK_EXIT()

// ԑ҂iPʁFTick = 1/4800(s)j
#define	K7SCR_TIMEWAIT(wait)			\
	{ \
		ghmGcTask	*pTask = ghmGcTaskController::GetCurrentTask(); \
		if( pTask!=NULL ){ \
			int		time = (wait); \
			while( time > 0 ){ \
				pTask->RetSys(); \
				time -= WK7_TICK_PER_FRAME; \
			} \
		} \
	}

// ViIt[ݒ
#define	K7SCR_SET_SCENARIO_FLOW(id)			GameInfo.SetScenarioFlow((id))
#define	K7SCR_GET_SCENARIO_FLOW()			GameInfo.GetScenarioFlow()

// GAݒ
#define	K7SCR_SET_AREA(id)					GameInfo.SetAreaID((id))
#define	K7SCR_GET_AREA()					GameInfo.GetAreaID()

// O[otOZbg
#define	K7SCR_SET_GLOBAL_FLAG(id)			GameInfo.SetGlobalFlag((id))

// O[otOZbg
#define	K7SCR_RESET_GLOBAL_FLAG(id)			GameInfo.ResetGlobalFlag((id))

// O[otO擾
#define	K7SCR_GET_GLOBAL_FLAG(id)			GameInfo.GetGlobalFlag((id))

// O[otO]
#define	K7SCR_REVERSE_GLOBAL_FLAG(id)		GameInfo.ReverseGlobalFlag((id))

// ViItOZbg
#define	K7SCR_SET_SCENARIO_FLAG(id)			GameInfo.SetScenarioFlag((id))
//#define	K7SCR_SET_SCN_FLAG(id,scnid)		GameInfo.SetScenarioFlag((id),(scnid))

// ViItOZbg
#define	K7SCR_RESET_SCENARIO_FLAG(id)		GameInfo.ResetScenarioFlag((id))
//#define	K7SCR_RESET_SCN_FLAG(id,scnid)		GameInfo.ResetScenarioFlag((id),(scnid))

// ViItO擾
#define	K7SCR_GET_SCENARIO_FLAG(id)			GameInfo.GetScenarioFlag((id))
//#define	K7SCR_GET_SCN_FLAG(id,scnid)		GameInfo.GetScenarioFlag((id),(scnid))

// ViItO]
#define	K7SCR_REVERSE_SCENARIO_FLAG(id)		GameInfo.ReverseScenarioFlag((id))
//#define	K7SCR_REVERSE_SCN_FLAG(id,scnid)	GameInfo.ReverseScenarioFlag((id),(scnid))

#define	K7SCR_SET_SNR_FLAG(id,flag) \
	{ \
		if( (flag) == false ){ \
			K7SCR_RESET_SCENARIO_FLAG((id)); \
		}else{ \
			K7SCR_SET_SCENARIO_FLAG((id)); \
		} \
	}

// Gl~[֘A ---------------------------------------------------------------

// Gl~[
#define	K7SCR_ENM_CREATE(enemyid)				WK7Enemy::Create((enemyid))
#define	K7SCR_ENM_CREATE_STGENM(enemyid,stgid)	WK7Enemy::Create((enemyid),(stgid))

// Gl~[
#define	K7SCR_ENM_CREATE_B(enemyid)		\
	{ \
		WK7Enemy	*pEnemy; \
		if( (pEnemy = WK7Enemy::Create((enemyid))) != NULL ){ \
			while( pEnemy->IsLoading()==true ){ \
				K7SCR_RETSYS(); \
			} \
		} \
	}
#define	K7SCR_ENM_CREATE_STGENM_B(enemyid,stgid)		\
	{ \
		WK7Enemy	*pEnemy; \
		if( (pEnemy = WK7Enemy::Create((enemyid),(stgid))) != NULL ){ \
			while( pEnemy->IsLoading()==true ){ \
				K7SCR_RETSYS(); \
			} \
		} \
	}

// Gl~[
#define	K7SCR_ENM_RELEASE(enemyid)		\
	{ \
		WK7Enemy	*pEnemy; \
		if( (pEnemy = WK7Enemy::Find((enemyid))) != NULL ){ \
			delete pEnemy; \
		} \
	}
//#define	K7SCR_ENM_RELEASE_STGENM(enemyid,stgid)		\
//	{ \
//		WK7Enemy	*pEnemy; \
//		if( (pEnemy = WK7Enemy::Find((enemyid),(stgid))) != NULL ){ \
//			delete pEnemy; \
//		} \
//	}

// Xe[WGl~[
#define	K7SCR_ENM_RELEASE_STGENM(stgid)	WK7Enemy::ReleaseStageEnemy((stgid))

// Gl~[\\
#define	K7SCR_ENM_VISIBLE(enemyid,flag)		\
	{ \
		WK7Enemy	*pEnemy; \
		if( (pEnemy = WK7Enemy::Find((enemyid))) != NULL ){ \
			pEnemy->SetVisible(flag); \
		} \
	}
#define	K7SCR_ENM_VISIBLE_STGENM(enemyid,stgid,flag)		\
	{ \
		WK7Enemy	*pEnemy; \
		if( (pEnemy = WK7Enemy::Find((enemyid),(stgid))) != NULL ){ \
			pEnemy->SetVisible(flag); \
		} \
	}

// LN^֘A -------------------------------------------------------------

/*
	
	JgőLɎw肵ĂLN^[ɑ΂LȂ
	
*/

// LN^
#define	K7SCR_PC_CREATE(charaid)		WK7PLAYERCONTROL->CreateModel(charaid)
// WK7RenderObj::CreateChara((charaid))
//	

// LN^i[Vj҂
#define	K7SCR_PC_CREATEWAIT()	\
	{ \
			while( true == WK7PLAYERCONTROL->IsLoading() ){ \
				K7SCR_RETSYS(); \
			} \
	}
	
// LN^҂
#define	K7SCR_PC_CREATE_B(charaid)		K7SCR_PC_CREATE(charaid); K7SCR_PC_CREATEWAIT()


// LN^[Vǂݍ
#define	K7SCR_PC_MOTIONCREATE(charaid)	WK7PLAYERCONTROL->CreatePackMotion(charaid)


// LN^\\
#define	K7SCR_PC_VISIBLE(flag)			WK7PLAYERCONTROL->SetVisible(flag)


//	// Jgv[[LN^ɐݒ kawa  98?   
//	#define	K7SCR_PC_SET_CURRENT_PLAYER(charaid) \
//		{ \
//			WK7PLAYERCONTROL->SetID(charaid); \
//		}



//	
//	// LN^|WVݒ
//	#define	K7SCR_CHR_SETPOSITION(charaid,x,y,z)		\
//		{ \
//			WK7Model		*pModel = K7EV_CHR_MODEL(charaid); \
//			if( pModel!=NULL ){ \
//				pModel->SetPosition(x,y,z); \
//			} \
//			OSDebugReportExp(pModel==NULL,"CharaModel  Not Found !! %08x\n",(charaid)); \
//		}
//	
//	// LN^]lݒ
//	#define	K7SCR_CHR_SETROTATION(charaid,x,y,z)		\
//		{ \
//			WK7Model		*pModel = K7EV_CHR_MODEL(charaid); \
//			if( pModel!=NULL ){ \
//				pChara->SetRotation(x,y,z); \
//			} \
//			OSDebugReportExp(pModel==NULL,"CharaModel  Not Found !! %08x\n",(charaid)); \
//		}
//	
//	// LN^XP[ݒ
//	#define	K7SCR_CHR_SETSCALE(charaid,x,y,z)		\
//		{ \
//			WK7Model		*pModel = K7EV_CHR_MODEL(charaid); \
//			if( pModel!=NULL ){ \
//				pChara->SetScale(x,y,z); \
//			} \
//			OSDebugReportExp(pModel==NULL,"CharaModel  Not Found !! %08x\n",(charaid)); \
//		}
//	
//	// LN^[VA^b`
//	#define	K7SCR_CHR_ATTACHMOTION(charaid,motid)		\
//		{ \
//			WK7Model		*pModel = K7EV_CHR_MODEL(charaid); \
//			if( pModel!=NULL ){ \
//				WK7ModelMotion	*pModelMotion = K7EV_CHR_MODELMOTION(motid); \
//				if( pModelMotion!=NULL ){ \
//					pModel->AttachMotion(pModelMotion); \
//				} \
//				OSDebugReportExp(pModelMotion==NULL,"CharaMotion Not Found !! %08x\n",(motid)); \
//			} \
//			OSDebugReportExp(pModel==NULL,"CharaModel  Not Found !! %08x\n",(charaid)); \
//		}
//	
//	// LN^[VA^b`iNVJj
//	#define	K7SCR_CHR_ATTACHMOTION_CLASSIC(charaid,motid)		\
//		{ \
//			WK7Model		*pModel = K7EV_CHR_MODEL(charaid); \
//			if( pModel!=NULL ){ \
//				WK7ModelMotion	*pModelMotion = K7EV_CHR_MODELMOTION(motid); \
//				if( pModelMotion!=NULL ){ \
//					pModel->AttachMotionClassic(pModelMotion); \
//				} \
//				OSDebugReportExp(pModelMotion==NULL,"CharaMotion Not Found !! %08x\n",(motid)); \
//			} \
//			OSDebugReportExp(pModel==NULL,"CharaModel  Not Found !! %08x\n",(charaid)); \
//		}
//	
//	// LN^[Vf^b`
//	#define	K7SCR_CHR_DETACHMOTION(charaid)		\
//		{ \
//			WK7Model		*pModel = K7EV_CHR_MODEL(charaid); \
//			if( pModel!=NULL ){ \
//				pModel->DetachMotion(); \
//			} \
//			OSDebugReportExp(pModel      ==NULL,"CharaModel  Not Found !! %08x\n",(charaid)); \
//		}
//	
//	// LN^[VĐ
//	#define	K7SCR_CHR_PLAYMOTION(charaid)		\
//		{ \
//			WK7Model		*pModel = K7EV_CHR_MODEL(charaid); \
//			if( pModel!=NULL ){ \
//				pModel->PlayMotion(); \
//			} \
//			OSDebugReportExp(pModel      ==NULL,"CharaModel  Not Found !! %08x\n",(charaid)); \
//		}
//	
//	// LN^[VĐiI҂j
//	#define	K7SCR_CHR_PLAYMOTION_B(charaid)		\
//		{ \
//			WK7Model		*pModel = K7EV_CHR_MODEL(charaid); \
//			if( pModel!=NULL ){ \
//				pModel->PlayMotion(); \
//				while( pModel->GetMotionState()!=K7EV_NOANIM ){ \
//					pTask->RetSys(); \
//				} \
//			} \
//			OSDebugReportExp(pModel      ==NULL,"CharaModel  Not Found !! %08x\n",(charaid)); \
//		}
//	
//	// LN^[V~
//	#define	K7SCR_CHR_STOPMOTION(charaid)		\
//		{ \
//			WK7Model		*pModel = K7EV_CHR_MODEL(charaid); \
//			if( pModel!=NULL ){ \
//				pModel->StopMotion(); \
//			} \
//			OSDebugReportExp(pModel      ==NULL,"CharaModel  Not Found !! %08x\n",(charaid)); \
//		}
//	
//	// LN^[V[vݒ
//	#define	K7SCR_CHR_SETMOTIONLOOP(charaid,flag)		\
//		{ \
//			WK7Model		*pModel = K7EV_CHR_MODEL(charaid); \
//			if( pModel!=NULL ){ \
//				pModel->SetMotionLoop((flag)); \
//			} \
//			OSDebugReportExp(pModel      ==NULL,"CharaModel  Not Found !! %08x\n",(charaid)); \
//		}
//	
//	// LN^[VԎ擾
//	#define	K7SCR_CHR_GETMOTIONSTATE(charaid)		K7EV_CHR_MODEL(charaid)!=NULL? K7EV_CHR_MODEL(charaid)->GetMotionState() : K7EV_NOANIM
//	
//	// LN^[VĐI
//	#define	K7SCR_CHR_MOTION_WAIT(charaid)		\
//		{ \
//			WK7Model		*pModel = K7EV_CHR_MODEL(charaid); \
//			while( pModel->GetMotionState()!=K7EV_NOANIM ){ \
//				pTask->RetSys(); \
//			} \
//		}
//	
//	// LN^[V
//	#define	K7SCR_CHRMOT_CREATE(motid)		WK7MotionObj::CreateCharaMotion((motid))
//	
//	// LN^[V҂
//	#define	K7SCR_CHRMOT_CREATEWAIT(motid)	\
//		{ \
//			WK7CharaMotion		*pMotion; \
//			if( (pMotion = WK7MotionObj::GetCharaMotion((motid)))!=NULL ){ \
//				while( pMotion->GetState()!=WK7MotionObj::LOADED ){ \
//					K7SCR_RETSYS(); \
//				} \
//			} \
//			OSDebugReportExp(pMotion==NULL,"CharaMotion Not Found !! %08x\n",(motid)); \
//		}
//	
//	// LN^[V҂
//	#define	K7SCR_CHRMOT_CREATE_B(motid)	K7SCR_CHRMOT_CREATE(motid); K7SCR_CHRMOT_CREATEWAIT(motid);
//	

// Xe[W֘A ----------------------------------------------------------------

// Xe[W
#define	K7SCR_STG_CREATE(stageid)		WK7RenderObj::CreateStage((stageid))

// Xe[W҂
#define	K7SCR_STG_CREATEWAIT(stageid)	\
	{ \
		WK7Stage		*pStage; \
		if( (pStage = WK7RenderObj::GetStage((stageid)))!=NULL ){ \
			while( pStage->GetState()!=WK7RenderObj::LOADED ){ \
				K7SCR_RETSYS(); \
			} \
		} \
		OSDebugReportExp(pStage==NULL,"Stage Not Found !! %08x\n",(stageid)); \
	}

// Xe[W҂
#define	K7SCR_STG_CREATE_B(stageid)		K7SCR_STG_CREATE(stageid); K7SCR_STG_CREATEWAIT(stageid);

// Xe[W\\
#define	K7SCR_STG_VISIBLE(stageid,flag)		\
	{ \
		WK7Stage		*pStage; \
		if( (pStage = WK7RenderObj::GetStage((stageid)))!=NULL ){ \
			pStage->SetRenderFlag(flag); \
		} \
		OSDebugReportExp(pStage==NULL,"Stage Not Found !! %08x\n",(stageid)); \
	}

// Xe[W[X
#define	K7SCR_STG_RELEASE(stageid)	\
	{	\
		WK7Stage		*pStage;	\
		if( (pStage = WK7RenderObj::GetStage((stageid)))!=NULL ){	\
			WK7Stage::DeleteStage(pStage);	\
		}	\
	}


// Xe[W[V
#define	K7SCR_STGMOT_CREATE(motid)		WK7MotionObj::CreateStageMotion((motid))

// Xe[W[V҂
#define	K7SCR_STGMOT_CREATEWAIT(motid)	\
	{ \
		WK7StageMotion		*pMotion; \
		if( (pMotion = WK7MotionObj::GetStageMotion((motid)))!=NULL ){ \
			while( pMotion->GetState()!=WK7MotionObj::LOADED ){ \
				K7SCR_RETSYS(); \
			} \
		} \
		OSDebugReportExp(pMotion==NULL,"StageMotion Not Found !! %08x\n",(motid)); \
	}

// Xe[W[V҂
#define	K7SCR_STGMOT_CREATE_B(motid)	K7SCR_STGMOT_CREATE(motid); K7SCR_STGMOT_CREATEWAIT(motid);

// JgXe[Wɐݒ
#define	K7SCR_STG_SET_CURRENT(stgid)	K7EV_MAINTASK->SetCurrentStage((stgid))

// hc擾
#define	K7SCR_STG_GET_PREVID()			WK7Stage::GetPrevStageID()
#define	K7SCR_STG_GET_CURRENTID()		WK7Stage::GetCurrentStageID()
// OXe[WIp[^擾
#define	K7SCR_STG_GET_PREVTERMPARAM()	WK7Stage::GetPrevStageTermParam()
// JgXe[W擾
#define	K7SCR_STG_GET_CURRENT()			WK7Stage::GetCurrentStage()

// X^[g`FbN|Cgݒ
//#define	K7SCR_STG_STARTCHKPOINTSET(stgid)	WK7PLAYERCONTROL->ChangeStartChkPoint(stgid)

// pXݒ
#define	K7SCR_STG_SET_CURRENT_PATH(bpname,pathname)									WK7Stage::SetCurrentPath((bpname),(pathname))
#define	K7SCR_STG_SET_CURRENT_PATH_PARAM(bpname,pathname,dparam)					WK7Stage::SetCurrentPath((bpname),(pathname),(dparam))
#define	K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR(bpname,pathname,dparam,initdir)		WK7Stage::SetCurrentPath((bpname),(pathname),(dparam),(initdir))
#define	K7SCR_STG_SET_CURRENT_PATH_POINT(bpname)									WK7Stage::SetCurrentPath((bpname),(char *)NULL)
#define	K7SCR_STG_SET_CURRENT_PATH_TOBP(bpname,pathname)							WK7Stage::SetCurrentPathToBp((bpname),(pathname))
#define	K7SCR_STG_SET_CURRENT_PATH_TOBP_PARAM(bpname,pathname,dparam)				WK7Stage::SetCurrentPathToBp((bpname),(pathname),(dparam))
#define	K7SCR_STG_SET_CURRENT_PATH_TOBP_PARAM_DIR(bpname,pathname,dparam,initdir)	WK7Stage::SetCurrentPathToBp((bpname),(pathname),(dparam),(initdir))

#define	K7SCR_STG_SET_PATHENABLE(name,flag)										SetPathEnable((name),(flag))
#define	K7SCR_STG_SET_PATHENABLEONLY(name,flag)									SetPathEnableOnly((name),(flag))
#define	K7SCR_STG_SET_PATHENABLEEX(name,flag)									SetPathEnableEx((name),(flag))
#define	K7SCR_STG_SET_DISABLEPATHCAMERA(pathname,flag)							SetDisablePathCamera((pathname),(flag))
#define	K7SCR_STG_SET_BPCAMDISABLE(bpname,flag)									SetBpCamDisable((bpname),(flag))

#define	K7SCR_CAM_PATHDIR			(WK7PATHINFO_INITDIR_TGTDIR)
#define	K7SCR_CAM_PATHDIR_REV		(WK7PATHINFO_INITDIR_TGTDIR_REV)


#define	K7SCR_PLAY_INIT()						WK7Play::PlayInit(true)
#define	K7SCR_PLAY_INIT_KEEP_PLAYER()			WK7Play::PlayInit(false)
#define	K7SCR_PLAY_CREATE(no)					while( WK7Play::Create(no)==false ){ K7SCR_RETSYS(); }
#define	K7SCR_PLAY_LOADWAIT(no)					while( WK7Play::LoadWait(no)==false ){ K7SCR_RETSYS(); }
#define	K7SCR_PLAY_PREPARE(no)					while( WK7Play::Prepare(no)==false ){ K7SCR_RETSYS(); }
#define	K7SCR_PLAY_PREPAREWAIT(no)				while( WK7Play::PrepareWait(no)==false ){ K7SCR_RETSYS(); }
#define	K7SCR_PLAY_START(no)					while( WK7Play::Start(no)==false ){ K7SCR_RETSYS(); }
#define	K7SCR_PLAY_PLAYWAIT(no)					while( WK7Play::PlayWait(no)==false ){ K7SCR_RETSYS(); }
#define	K7SCR_PLAY_START_B(no)					while( WK7Play::StartB(no)==false ){ K7SCR_RETSYS(); }
#define	K7SCR_PLAY_RELEASE(no)					while( WK7Play::Release(no)==false ){ K7SCR_RETSYS(); }
#define	K7SCR_PLAY_TERM()						while( WK7Play::PlayTerm()==false ){ K7SCR_RETSYS(); }

// ACe֘A ----------------------------------------------------------------

// ACe
#define	K7SCR_ITEM_CREATE(itemid)		WK7RenderObj::CreateItem((itemid))

// ACe҂
#define	K7SCR_ITEM_CREATEWAIT(itemid)	\
	{ \
		WK7Item		*pItem; \
		if( (pItem = WK7RenderObj::GetItem((itemid)))!=NULL ){ \
			while( pItem->GetState()!=WK7RenderObj::LOADED ){ \
				K7SCR_RETSYS(); \
			} \
		} \
		OSDebugReportExp(pItem==NULL,"Item Not Found !! %08x\n",(itemid)); \
	}

// ACe҂
#define	K7SCR_ITEM_CREATE_B(itemid)		K7SCR_ITEM_CREATE(itemid); K7SCR_ITEM_CREATEWAIT(itemid);

// ACe\\
#define	K7SCR_ITEM_VISIBLE(itemid,flag)		\
	{ \
		WK7Item		*pItem; \
		if( (pItem = WK7RenderObj::GetItem((itemid)))!=NULL ){ \
			pItem->SetRenderFlag(flag); \
		} \
		OSDebugReportExp(pItem==NULL,"Item Not Found !! %08x\n",(itemid)); \
	}

// ACe[V
#define	K7SCR_ITEMMOT_CREATE(motid)		WK7MotionObj::CreateItemMotion((motid))

// ACe[V҂
#define	K7SCR_ITEMMOT_CREATEWAIT(motid)	\
	{ \
		WK7ItemMotion		*pMotion; \
		if( (pMotion = WK7MotionObj::GetItemMotion((motid)))!=NULL ){ \
			while( pMotion->GetState()!=WK7MotionObj::LOADED ){ \
				K7SCR_RETSYS(); \
			} \
		} \
		OSDebugReportExp(pMotion==NULL,"ItemMotion Not Found !! %08x\n",(motid)); \
	}

// ACe[V҂
#define	K7SCR_ITEMMOT_CREATE_B(motid)	K7SCR_ITEMMOT_CREATE(motid); K7SCR_ITEMMOT_CREATEWAIT(motid);


// J֘A ------------------------------------------------------------------

// Xe[WJݒ
#define	K7SCR_CAM_SETSTGCAM(stageid,camname)		\
	{ \
		WK7Stage		*pStage; \
		if( (pStage = WK7RenderObj::GetStage((stageid)))!=NULL ){ \
			HSD_CameraDesc	*pDesc = pStage->GetCameraDesc((camname)); \
			if( pDesc!=NULL ){ \
				K7EV_CAM->SetDesc(pDesc); \
			} \
			OSDebugReportExp(pDesc==NULL,"Stage Camera Not Found !! %08x , %s\n",(stageid),(camname)); \
		} \
		OSDebugReportExp(pStage==NULL,"Stage Not Found !! %08x\n",(stageid)); \
	}

#define	K7SCR_CAM_SETSTGCAMINDEX(stageid,index)		\
	{ \
		WK7Stage		*pStage; \
		if( (pStage = WK7RenderObj::GetStage((stageid)))!=NULL ){ \
			HSD_CameraDesc	*pDesc = pStage->GetCameraDesc((index)); \
			if( pDesc!=NULL ){ \
				K7EV_CAM->SetDesc(pDesc); \
			} \
			OSDebugReportExp(pDesc==NULL,"Stage Camera Not Found !! %08x , %d\n",(stageid),(index)); \
		} \
		OSDebugReportExp(pStage==NULL,"Stage Not Found !! %08x\n",(stageid)); \
	}

// JgXe[WJݒ
#define	K7SCR_CAM_SETCURSTGCAM(camname)		\
	{ \
		if( K7EV_CUR_STG!=NULL ){ \
			HSD_CameraDesc	*pDesc = K7EV_CUR_STG->GetCameraDesc((camname)); \
			if( pDesc!=NULL ){ \
				K7EV_CAM->SetDesc(pDesc); \
			} \
			OSDebugReportExp(pDesc==NULL,"Current Stage Camera Not Found !! %08x , %s\n",(K7EV_CUR_STG->GetID()),(camname)); \
		} \
		OSDebugReportExp(K7EV_CUR_STG==NULL,"Current Stage Not Found !!\n"); \
	}

// Cg֘A ------------------------------------------------------------------

// Xe[WCgݒ
#define	K7SCR_LIGHT_SETSTGLIGHT(stageid,lightname)		\
	{ \
		WK7Stage		*pStage; \
		if( (pStage = WK7RenderObj::GetStage((stageid)))!=NULL ){ \
			C_LightSet		*pLightSet = pStage->GetLightSet(lightname); \
			if( pLightSet!=NULL ){ \
				K7EV_LIGHT->SetDesc(pLightSet); \
			} \
			OSDebugReportExp(pLightSet==NULL,"Stage Light Not Found !! %08x , %s\n",(stageid),(lightname)); \
		} \
		OSDebugReportExp(pStage==NULL,"Stage Not Found !! %08x\n",(stageid)); \
	}

#define	K7SCR_LIGHT_SETSTGLIGHTINDEX(stageid,index)		\
	{ \
		WK7Stage		*pStage; \
		if( (pStage = WK7RenderObj::GetStage((stageid)))!=NULL ){ \
			C_LightSet		*pLightSet = pStage->GetLightSet(index); \
			if( pLightSet!=NULL ){ \
				K7EV_LIGHT->SetDesc(pLightSet); \
			} \
			OSDebugReportExp(pLightSet==NULL,"Stage Light Not Found !! %08x , %d\n",(stageid),(index)); \
		} \
		OSDebugReportExp(pStage==NULL,"Stage Not Found !! %08x\n",(stageid)); \
	}

// JgXe[WCgݒ
#define	K7SCR_LIGHT_SETCURSTGLIGHT(lightname)		\
	{ \
		if( K7EV_CUR_STG!=NULL ){ \
			C_LightSet		*pLightSet = K7EV_CUR_STG->GetLightSet((lightname)); \
			if( pLightSet!=NULL ){ \
				K7EV_LIGHT->SetDesc(pLightSet); \
			} \
			OSDebugReportExp(pLightSet==NULL,"Current Stage Light Not Found !! %08x , %s\n",(K7EV_CUR_STG->GetID()),(lightname)); \
		} \
		OSDebugReportExp(K7EV_CUR_STG==NULL,"Current Stage Not Found !!\n"); \
	}

#define	K7SCR_LIGHT_SETCURSTGLIGHTINDEX(index)		\
	{ \
		if( K7EV_CUR_STG!=NULL ){ \
			C_LightSet		*pLightSet = K7EV_CUR_STG->GetLightSet((index)); \
			if( pLightSet!=NULL ){ \
				K7EV_LIGHT->SetDesc(pLightSet); \
			} \
			OSDebugReportExp(pLightSet==NULL,"Current Stage Light Not Found !! %08x , %d\n",(K7EV_CUR_STG->GetID()),(index)); \
		} \
		OSDebugReportExp(K7EV_CUR_STG==NULL,"Current Stage Not Found !!\n"); \
	}


#define	K7SCR_DEF_CALLDOOREVENT()				WK7Stage::DoorEventTask(pTask)
#define	K7SCR_DEF_CALLMEMOEVENT()				WK7Stage::MemoEventTask(pTask)

// bZ[W֘A -----------------------------------------------------------------------------------

// bZ[WR[ mubN
#define	K7SCR_STG_MESSAGE_IS(mesid,icon,snd)				CallMessage((mesid),(icon),(snd))
#define	K7SCR_STG_MESSAGE(mesid)							K7SCR_STG_MESSAGE_IS((mesid),-1,-1)
#define	K7SCR_STG_MESSAGE_I(mesid,icon)						K7SCR_STG_MESSAGE_IS((mesid),(icon),-1)
#define	K7SCR_STG_MESSAGE_S(mesid,snd)						K7SCR_STG_MESSAGE_IS((mesid),-1,(snd))

// bZ[WR[ ubN
#define	K7SCR_STG_MESSAGE_IS_B(mesid,icon,snd)				CallMessageB((mesid),(icon),(snd))
#define	K7SCR_STG_MESSAGE_B(mesid)							K7SCR_STG_MESSAGE_IS_B((mesid),-1,-1)
#define	K7SCR_STG_MESSAGE_I_B(mesid,icon)					K7SCR_STG_MESSAGE_IS_B((mesid),(icon),-1)
#define	K7SCR_STG_MESSAGE_S_B(mesid,snd)					K7SCR_STG_MESSAGE_IS_B((mesid),-1,(snd))

// bZ[WR[ ubN
#define	K7SCR_STG_MESSAGE_IS_B2(mesid,icon,snd)				CallMessageB2((mesid),(icon),(snd))
#define	K7SCR_STG_MESSAGE_B2(mesid)							K7SCR_STG_MESSAGE_IS_B2((mesid),-1,-1)
#define	K7SCR_STG_MESSAGE_I_B2(mesid,icon)					K7SCR_STG_MESSAGE_IS_B2((mesid),(icon),-1)
#define	K7SCR_STG_MESSAGE_S_B2(mesid,snd)					K7SCR_STG_MESSAGE_IS_B2((mesid),-1,(snd))

#define	K7SCR_STG_MESSAGE_ISVALID(mesid)					IsValidMessage((mesid))
#define	K7SCR_STG_MESSAGE_VALID_B(mesid)					while( IsValidMessage((mesid))==true ){ K7SCR_RETSYS(); }

#define	K7SCR_STG_MESSAGE_ISDISPLAYED(mesid)				IsDisplayedMessage((mesid))
#define	K7SCR_STG_MESSAGE_ISDISPLAYED_B(mesid)				while( IsDisplayedMessage((mesid))==true  ){ K7SCR_RETSYS(); }
#define	K7SCR_STG_MESSAGE_NOTDISPLAYED_B(mesid)				while( IsDisplayedMessage((mesid))==false ){ K7SCR_RETSYS(); }

// bZ[WR[ mubNAJgXe[W
#define	K7SCR_STGC_MESSAGE_IS(mesid,icon,snd)				\
	{ \
		if( WK7Stage::GetCurrentStage()!=NULL ){ \
			WK7Stage::GetCurrentStage()->CallMessage((mesid),(icon),(snd)); \
		} \
	}
#define	K7SCR_STGC_MESSAGE(mesid)							K7SCR_STGC_MESSAGE_IS((mesid),-1,-1)
#define	K7SCR_STGC_MESSAGE_I(mesid,icon)					K7SCR_STGC_MESSAGE_IS((mesid),(icon),-1)
#define	K7SCR_STGC_MESSAGE_S(mesid,snd)						K7SCR_STGC_MESSAGE_IS((mesid),-1,(snd))

// bZ[WR[ ubNAJgXe[W
#define	K7SCR_STGC_MESSAGE_IS_B(mesid,icon,snd)				\
	{ \
		if( WK7Stage::GetCurrentStage()!=NULL ){ \
			WK7Stage::GetCurrentStage()->CallMessageB((mesid),(icon),(snd)); \
		} \
	}
#define	K7SCR_STGC_MESSAGE_B(mesid)							K7SCR_STGC_MESSAGE_IS_B((mesid),-1,-1)
#define	K7SCR_STGC_MESSAGE_I_B(mesid,icon)					K7SCR_STGC_MESSAGE_IS_B((mesid),(icon),-1)
#define	K7SCR_STGC_MESSAGE_S_B(mesid,snd)					K7SCR_STGC_MESSAGE_IS_B((mesid),-1,(snd))

#define	K7SCR_STGC_MESSAGE_ISVALID(mesid)					(WK7Stage::GetCurrentStage()!=NULL? WK7Stage::GetCurrentStage()->IsValidMessage((mesid)) : false)
#define	K7SCR_STGC_MESSAGE_VALID_B(mesid)					while( K7SCR_STGC_MESSAGE_ISVALID(mesid)==true ){ K7SCR_RETSYS(); }

// mubN
#define	K7SCR_SYS_MESSAGE_IS(mesid,icon,snd)				WK7EVENTCONTROLLER->CallMessage((mesid),(icon),(snd))
#define	K7SCR_SYS_MESSAGE(mesid)							K7SCR_SYS_MESSAGE_IS((mesid),-1,-1)
#define	K7SCR_SYS_MESSAGE_I(mesid,icon)						K7SCR_SYS_MESSAGE_IS((mesid),(icon),-1)
#define	K7SCR_SYS_MESSAGE_S(mesid,snd)						K7SCR_SYS_MESSAGE_IS((mesid),-1,(snd))

// ubN
#define	K7SCR_SYS_MESSAGE_IS_B(mesid,icon,snd)				WK7EVENTCONTROLLER->CallMessageB((mesid),(icon),(snd))
#define	K7SCR_SYS_MESSAGE_B(mesid)							K7SCR_SYS_MESSAGE_IS_B((mesid),-1,-1)
#define	K7SCR_SYS_MESSAGE_I_B(mesid,icon)					K7SCR_SYS_MESSAGE_IS_B((mesid),(icon),-1)
#define	K7SCR_SYS_MESSAGE_S_B(mesid,snd)					K7SCR_SYS_MESSAGE_IS_B((mesid),-1,(snd))

#define	K7SCR_SYS_MESSAGE_IS_B2(mesid,icon,snd)				WK7EVENTCONTROLLER->CallMessageB2((mesid),(icon),(snd))
#define	K7SCR_SYS_MESSAGE_B2(mesid)							K7SCR_SYS_MESSAGE_IS_B2((mesid),-1,-1)
#define	K7SCR_SYS_MESSAGE_I_B2(mesid,icon)					K7SCR_SYS_MESSAGE_IS_B2((mesid),(icon),-1)
#define	K7SCR_SYS_MESSAGE_S_B2(mesid,snd)					K7SCR_SYS_MESSAGE_IS_B2((mesid),-1,(snd))

#define	K7SCR_SYS_MESSAGE_ISVALID(mesid)					WK7EVENTCONTROLLER->IsValidMessage((mesid))
#define	K7SCR_SYS_MESSAGE_VALID_B(mesid)					while( WK7EVENTCONTROLLER->IsValidMessage((mesid))==true ){ K7SCR_RETSYS(); }

#define	K7SCR_SYS_MESSAGE_ISDISPLAYED(mesid)				WK7EVENTCONTROLLER->IsDisplayedMessage((mesid))
#define	K7SCR_SYS_MESSAGE_ISDISPLAYED_B(mesid)				while( WK7EVENTCONTROLLER->IsDisplayedMessage((mesid))==true  ){ K7SCR_RETSYS(); }
#define	K7SCR_SYS_MESSAGE_NOTDISPLAYED_B(mesid)				while( WK7EVENTCONTROLLER->IsDisplayedMessage((mesid))==false ){ K7SCR_RETSYS(); }

// bZ[W֘A -----------------------------------------------------------------------------------

// ACe擾bZ[W֘A -----------------------------------------------------------------------

// bZ[WR[ mubN
#define	K7SCR_STG_ITEMGET_IS(mesid,icon,snd)				CallItemGet((mesid),true,(icon),(snd))
#define	K7SCR_STG_ITEMGET(mesid)							K7SCR_STG_ITEMGET_IS((mesid),-1,-1)
#define	K7SCR_STG_ITEMGET_I(mesid,icon)						K7SCR_STG_ITEMGET_IS((mesid),(icon),-1)
#define	K7SCR_STG_ITEMGET_S(mesid,snd)						K7SCR_STG_ITEMGET_IS((mesid),-1,(snd))

// bZ[WR[ ubN
#define	K7SCR_STG_ITEMGET_IS_B(mesid,icon,snd)				CallItemGetB((mesid),true,(icon),(snd))
#define	K7SCR_STG_ITEMGET_B(mesid)							K7SCR_STG_ITEMGET_IS_B((mesid),-1,-1)
#define	K7SCR_STG_ITEMGET_I_B(mesid,icon)					K7SCR_STG_ITEMGET_IS_B((mesid),(icon),-1)
#define	K7SCR_STG_ITEMGET_S_B(mesid,snd)					K7SCR_STG_ITEMGET_IS_B((mesid),-1,(snd))

// bZ[WR[ ubN
#define	K7SCR_STG_ITEMGET_IS_B2(mesid,icon,snd)				CallItemGetB2((mesid),true,(icon),(snd))
#define	K7SCR_STG_ITEMGET_B2(mesid)							K7SCR_STG_ITEMGET_IS_B2((mesid),-1,-1)
#define	K7SCR_STG_ITEMGET_I_B2(mesid,icon)					K7SCR_STG_ITEMGET_IS_B2((mesid),(icon),-1)
#define	K7SCR_STG_ITEMGET_S_B2(mesid,snd)					K7SCR_STG_ITEMGET_IS_B2((mesid),-1,(snd))

#define	K7SCR_STG_ITEMGET_ISVALID(mesid)					IsValidItemGet((mesid))
#define	K7SCR_STG_ITEMGET_VALID_B(mesid)					while( IsValidItemGet((mesid))==true ){ K7SCR_RETSYS(); }

#define	K7SCR_STG_ITEMGET_ISDISPLAYED(mesid)				IsDisplayedItemGet((mesid))
#define	K7SCR_STG_ITEMGET_ISDISPLAYED_B(mesid)				while( IsDisplayedItemGet((mesid))==true  ){ K7SCR_RETSYS(); }
#define	K7SCR_STG_ITEMGET_NOTDISPLAYED_B(mesid)				while( IsDisplayedItemGet((mesid))==false ){ K7SCR_RETSYS(); }

// mubN
#define	K7SCR_SYS_ITEMGET_IS(mesid,icon,snd)				WK7EVENTCONTROLLER->CallItemGet((mesid),true,(icon),(snd))
#define	K7SCR_SYS_ITEMGET(mesid)							K7SCR_SYS_ITEMGET_IS((mesid),-1,-1)
#define	K7SCR_SYS_ITEMGET_I(mesid,icon)						K7SCR_SYS_ITEMGET_IS((mesid),(icon),-1)
#define	K7SCR_SYS_ITEMGET_S(mesid,snd)						K7SCR_SYS_ITEMGET_IS((mesid),-1,(snd))

// ubN
#define	K7SCR_SYS_ITEMGET_IS_B(mesid,icon,snd)				WK7EVENTCONTROLLER->CallItemGetB((mesid),true,(icon),(snd))
#define	K7SCR_SYS_ITEMGET_B(mesid)							K7SCR_SYS_ITEMGET_IS_B((mesid),-1,-1)
#define	K7SCR_SYS_ITEMGET_I_B(mesid,icon)					K7SCR_SYS_ITEMGET_IS_B((mesid),(icon),-1)
#define	K7SCR_SYS_ITEMGET_S_B(mesid,snd)					K7SCR_SYS_ITEMGET_IS_B((mesid),-1,(snd))

#define	K7SCR_SYS_ITEMGET_IS_B2(mesid,icon,snd)				WK7EVENTCONTROLLER->CallItemGetB2((mesid),true,(icon),(snd))
#define	K7SCR_SYS_ITEMGET_B2(mesid)							K7SCR_SYS_ITEMGET_IS_B2((mesid),-1,-1)
#define	K7SCR_SYS_ITEMGET_I_B2(mesid,icon)					K7SCR_SYS_ITEMGET_IS_B2((mesid),(icon),-1)
#define	K7SCR_SYS_ITEMGET_S_B2(mesid,snd)					K7SCR_SYS_ITEMGET_IS_B2((mesid),-1,(snd))

#define	K7SCR_SYS_ITEMGET_ISVALID(mesid)					WK7EVENTCONTROLLER->IsValidItemGet((mesid))
#define	K7SCR_SYS_ITEMGET_VALID_B(mesid)					while( WK7EVENTCONTROLLER->IsValidItemGet((mesid))==true ){ K7SCR_RETSYS(); }

#define	K7SCR_SYS_ITEMGET_ISDISPLAYED(mesid)				WK7EVENTCONTROLLER->IsDisplayedItemGet((mesid))
#define	K7SCR_SYS_ITEMGET_ISDISPLAYED_B(mesid)				while( WK7EVENTCONTROLLER->IsDisplayedItemGet((mesid))==true  ){ K7SCR_RETSYS(); }
#define	K7SCR_SYS_ITEMGET_NOTDISPLAYED_B(mesid)				while( WK7EVENTCONTROLLER->IsDisplayedItemGet((mesid))==false ){ K7SCR_RETSYS(); }

// ACe擾bZ[W֘A -----------------------------------------------------------------------

#define	K7SCR_EVCONDCHANGE()								WK7Event::CallCondChangeAll()
#define	K7SCR_EVSETENABLE(evid,flag)						WK7Event::SetEventEnableAll((evid),(flag))
#define	K7SCR_EVNO_SETENABLE(evno,flag)						WK7Event::SetEventNoEnableAll((evno),(flag))

#define	K7SCR_EVSETITEM(itemno,flag)						WK7EventItem::SetItem((itemno),(flag))
#define	K7SCR_EVHASITEM(itemno)								WK7EventItem::HasItem((itemno))
#define	K7SCR_EVGETITEM(itemno)								K7SCR_EVHASITEM((item))
#define	K7SCR_EVUSEITEM(itemno,flag)						WK7EventItem::UseItem((itemno),(flag))
#define	K7SCR_EVISUSEDITEM(itemno)							WK7EventItem::IsUsedItem((itemno))

//ȗ
#define	K7SetItem(itemno,flag)								K7SCR_EVSETITEM((itemno),(flag))
#define	K7ChkItem(itemno)									K7SCR_EVHASITEM((itemno))

// w֊֘A
#define	K7SCR_EVHASRING(ringid)								WK7PLAYERCONTROL->HasRing((ringid))
#define	K7SCR_EVEQUIPRING(ringid)							WK7PLAYERCONTROL->EquipRing((ringid))

#define	K7SCR_PANEL_SETPANELID_NOPARAM(id)					GameInfo.SetRequestPanelID((id))
#define	K7SCR_PANEL_SETPANELID(id,param)					GameInfo.SetRequestPanelID((id),(param))
#define	K7SCR_PANEL_SETPANELEVNO_NOPARAM(evno)				GameInfo.SetRequestPanelEventNo((evno))
#define	K7SCR_PANEL_SETPANELEVNO(evno,param)				GameInfo.SetRequestPanelEventNo((evno),(param))
#define	K7SCR_PANEL_START()									GameInfo.SetMode(WK7GameInfo::PANELMODE)
#define	K7SCR_PANEL_GETSTATE()								GameInfo.GetPanelModeState()
#define	K7SCR_PANEL_INITWAIT()								\
	while( GameInfo.GetPanelModeState()!=WK7GameInfo::PMSTATE_INIT_FADEWAIT ){ \
		K7SCR_RETSYS(); \
	}
#define	K7SCR_PANEL_DELETEWAIT()							\
	while( GameInfo.GetPanelModeState()!=WK7GameInfo::PMSTATE_TERM_DELETEWAIT ){ \
		K7SCR_RETSYS(); \
	}
#define	K7SCR_PANEL_CTRLOFFWAIT()							\
	while( GameInfo.GetPanelModeState()!=WK7GameInfo::PMSTATE_TERM_CTRLOFFWAIT ){ \
		K7SCR_RETSYS(); \
	}
#define	K7SCR_PANEL_TERMWAIT()								\
	while( GameInfo.GetPanelModeState()!=WK7GameInfo::PMSTATE_TERM_FADEWAIT ){ \
		K7SCR_RETSYS(); \
	}
#define	K7SCR_PANEL_GETRESULT()								GameInfo.GetPanelResult()
#define	K7SCR_PANEL_EXIT()									GameInfo.SetPanelTermHideWait(false)
#define	K7SCR_PANEL_EXITWAIT()								\
		while( GameInfo.GetPanelModeState()!=WK7GameInfo::PMSTATE_STANDBY ){ \
			K7SCR_RETSYS(); \
		}
#define	K7SCR_GETPANEL()									GameInfo.GetPanel()
#define	K7SCR_GETPANEL_B()									GameInfo.GetPanelB()

#define	K7SCR_EVHASITEM(itemno)								WK7EventItem::HasItem((itemno))
#define	K7SCR_EVGETITEM(itemno)								K7SCR_EVHASITEM((item))

#define	K7SCR_ENTER_PLAYMODE()								GameInfo.SetMode(WK7GameInfo::PLAY)
#define	K7SCR_ENTER_PLAYMODE_B()							while( GameInfo.GetBattleTask()==true ){ K7SCR_RETSYS(); } \
															while( GameInfo.SetMode(WK7GameInfo::PLAY)==false ){ K7SCR_RETSYS(); }
#define	K7SCR_EXIT_PLAYMODE()								GameInfo.SetMode(WK7GameInfo::MOVE)
#define	K7SCR_ENTER_DEMOPAUSE()								\
	{	\
		WK7PLAYERCONTROL->SetOperateEnable(false);			\
		WK7Npc::NpcPauseAll();								\
	}
#define	K7SCR_EXIT_DEMOPAUSE()								\
	{	\
		WK7PLAYERCONTROL->SetOperateEnable(true);			\
		WK7Npc::NpcResetPauseAll();							\
	}
#define	K7SCR_STG_OBJ_VISIBLE(stgid,objname,visible)		WK7RenderObj::GetStage((stgid))->SetVisible((objname),(visible))
#define	K7SCR_STG_EVOBJ_VISIBLE(stgid,evid,visible)			WK7RenderObj::GetStage((stgid))->SetObjVisible((evid),(visible))
#define	K7SCR_STG_EVOBJEVNO_VISIBLE(stgid,evno,visible)		WK7RenderObj::GetStage((stgid))->SetObjVisibleEventNo((evno),(visible))
#define	K7SCR_STGC_OBJ_VISIBLE(objname,visible)				K7SCR_STG_GET_CURRENT()->SetVisible((objname),(visible))
#define	K7SCR_STGC_EVOBJ_VISIBLE(evid,visible)				K7SCR_STG_GET_CURRENT()->SetObjVisible(((evid),(visible))
#define	K7SCR_STGC_EVOBJEVNO_VISIBLE(evno,visible)			K7SCR_STG_GET_CURRENT()->SetObjVisibleEventNo(((evno),(visible))

// L̃Cxgp̕\\
#define	K7SCR_PC_SETVISIBLE(visible)						WK7PLAYERCONTROL->StackVisible(visible)
#define	K7SCR_PC_RETURNVISIBLE()							WK7PLAYERCONTROL->PullVisible()


#define	K7SCR_CALL_EVENT(evid)								WK7EVENTCONTROLLER->Call((evid))
#define	K7SCR_CALLIM_EVENT(evid)							WK7EVENTCONTROLLER->CallIM((evid))

#define	K7SCR_MOON_START()									GameInfo.SetMode(WK7GameInfo::MOON); k7app.SetFadeColor(0xff000000); k7app.FadeStart(0xff,0);
#define	K7SCR_MOON_START2()									GameInfo.SetMode(WK7GameInfo::MOON); k7app.SetFadeColor(0x00000000); k7app.FadeStart(0xff,0);
#define	K7SCR_MOON_WAIT()									\
		while( GameInfo.GetMode()==WK7GameInfo::MOON ){ \
			K7SCR_RETSYS(); \
		}
#define	K7SCR_MOON_START_B()								K7SCR_MOON_START(); K7SCR_MOON_WAIT();

#define	K7SCR_JOBJ_DISP(jobj)								if( (jobj)!=NULL ){ (jobj)->Disp(false,true); }
#define	K7SCR_JOBJONLY_DISP(jobj)							if( (jobj)!=NULL ){ (jobj)->Disp(false,false); }
#define	K7SCR_JOBJ_HIDE(jobj)								if( (jobj)!=NULL ){ (jobj)->Hide(false,true); }
#define	K7SCR_JOBJONLY_HIDE(jobj)							if( (jobj)!=NULL ){ (jobj)->Hide(false,false); }

#define	K7SCR_NPC_POPGO(enmno)			{ \
		WK7Npc		*pNpc; \
		if( (pNpc = WK7Npc::Find((enmno)))!=NULL ){ \
			pNpc->AiModeSet_PopGo(); \
			pNpc->ResetPause(); \
		} \
	}

#define	K7SCR_NPC_SAKUTEKIGO_AREA(enmno,area)			{ \
		WK7Npc		*pNpc; \
		if( (pNpc = WK7Npc::Find((enmno)))!=NULL ){ \
			pNpc->SetSakuteki((area)); \
		} \
	}

#define	K7SCR_NPC_SAKUTEKIGO(enmno)				K7SCR_NPC_SAKUTEKIGO_AREA(enmno,200.0f)

#define	K7SCR_RESERVENAME(tick,id,nx,ny,wx,wy,ww,wh,dispTick)	\
				SetNameData(); \
				WK7CHARAPRESENT->ReserveEnable((tick)); \
				WK7CHARAPRESENT->ReserveDelete((dispTick)); \
				WK7CHARAPRESENT->AddMaskWindow((wx),(wy),(ww),(wh)); \
				ReserveCharaName((tick),(id),(nx),(ny),(dispTick));

#define	K7SCR_RESERVENAME_COND(tick,id,nx,ny,wx,wy,ww,wh,fl,dispTick)	\
				if( (fl)<0 || GameInfo.GetGlobalFlag((fl))==false ){ \
					SetNameData(); \
					WK7CHARAPRESENT->ReserveEnable((tick)); \
					WK7CHARAPRESENT->ReserveDelete((dispTick)) \
					WK7CHARAPRESENT->AddMaskWindow((wx),(wy),(ww),(wh)); \
					ReserveCharaName((tick),(id),(nx),(ny),(dispTick)); \
					GameInfo.SetGlobalFlag((fl)); \
				}

#define	K7SCR_PATHCHANGECANCEL()				WK7Stage::PathChangeCancel()

//WNVIԂɂ
#define	K7SCR_STG_SET_JUNCTION_SELECT_EVNO(evno)	SetSelectObjFlag((evno),0,true)
#define	K7SCR_STG_SET_JUNCTION_SELECT(tostgid,name)	\
												SetSelectObjFlag((tostgid),(name),0,true); \
												SetPassPathFlag ((tostgid),(name),-3,true);
//WNVʉ߂Ԃɂ
#define	K7SCR_STG_SET_JUNCTION_PASS_EVNO(evno)		SetSelectObjFlag((evno),1,true)
#define	K7SCR_STG_SET_JUNCTION_PASS(tostgid,name)	\
												SetSelectObjFlag((tostgid),(name),1,true); \
												SetPassPathFlag ((tostgid),(name),-1,true);

#define	K7SCR_HITOBJ_SETENABLE(info,flag)		if( (info)!=NULL ){ (info)->SetHitObjEnable(flag); }
												//if( (info)!=NULL && (info)->mpHitObj!=NULL ){ (info)->mpHitObj->SetEnable(flag); }

#define	K7SCR_SCENARIO_TITLE_DISP(no)			WK7Stage::ScenarioTitleDisp(no)

// fobO\
#ifdef	_DEBUG
#define	K7SCR_CHARAPRESENT_DEBUGSTART()			WK7CHARAPRESENT_DEBUGSTART()
#define	K7SCR_CHARAPRESENT_DEBUGEND()			WK7CHARAPRESENT_DEBUGEND()
#define	K7SCR_DEBUGPRINT(str)					WK7Event::DebugPrint((str))
#else
#define	K7SCR_DEBUGPRINT(str)					
#define	K7SCR_CHARAPRESENT_DEBUGSTART()
#define	K7SCR_CHARAPRESENT_DEBUGEND()
#endif

#define	K7SCR_MOVIE_PLAY(id)					WK7Stage::PlayMovie((id))
#define	K7SCR_MOVIE_PLAY_NO_NOISE(id)			WK7Stage::PlayMovie2((id))

#define	K7SCR_CHANGE_SCENARIO_DATA()			WK7EVENTCONTROLLER->ReleaseTempData3(); \
												while( WK7EVENTCONTROLLER->IsReleasedTempData3()==false ){ \
													K7SCR_RETSYS(); \
												} \
												while( WK7EVENTCONTROLLER->LoadData()==false ){ \
													K7SCR_RETSYS(); \
												} \
												while( WK7EVENTCONTROLLER->IsLoadedData()==false ){ \
													K7SCR_RETSYS(); \
												}

//mCY֌W
#define	K7SCR_NOISE_REQUEST()					while( gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue, NOISE_SE_NORMAL )==false ){K7SCR_RETSYS();}
#define	K7SCR_NOISE_RELEASE()					while( gpNoise->mGetSandFrameProc() != eSandExec ){K7SCR_RETSYS();} \
												while( gpNoise->mSandRelease() == false ){K7SCR_RETSYS();} \
												while( gpNoise->mGetSandFrameProc() != eSandStandby ){K7SCR_RETSYS();}
#define	K7SCR_NOISE_RELEASE_TO_MAP()			while( gpNoise->mGetSandFrameProc() != eSandExec ){K7SCR_RETSYS();} \
												while( gpNoise->mSandRelease(NULL,NULL,NULL,NULL,NOISE_SE_NORMAL,true) == false ){K7SCR_RETSYS();} \
												while( gpNoise->mGetSandFrameProc() != eSandStandby ){K7SCR_RETSYS();}
#define	K7SCR_NOISE_REQUEST_WAIT()				while( gpNoise->mGetSandFrameProc() != eSandExec ){K7SCR_RETSYS();}

//Xe[W/
#define	K7SCR_STAGE_RELEASE()					while( WK7Stage::ReleaseStageArchive() == false ){GHMGCTASK_RETSYS();} \
												while( WK7Stage::IsReleasedStageArchive() == false ){GHMGCTASK_RETSYS();}
#define	K7SCR_STAGE_RESTORE()					while( WK7Stage::RestoreStageArchive() == false ){GHMGCTASK_RETSYS();} \
												while( WK7Stage::IsRestoredStageArchive() == false ){GHMGCTASK_RETSYS();}

//---- L֌W ----
//L
#define	K7SCR_CHARAGEKI_PREPARE(cgno)	{ \
		WK7Play*	pPlay; \
		WK7Chara::SetRenderChara(false); \
		WK7Stage::SetRenderStage(false); \
		WK7Item::SetRenderItem  (false); \
		K7SCR_RETSYS(); \
		K7SCR_RETSYS(); \
		WK7Play::StorePlayTB(); \
		while( (pPlay=WK7Play::Create(cgno)) == NULL ){ K7SCR_RETSYS(); } \
		pPlay->Prepare(); \
		while( pPlay->GetState() != WK7Play::PREPARED ){ K7SCR_RETSYS(); } \
		pPlay->Start(); \
		K7SCR_RETSYS(); \
	}
//LI҂
#define	K7SCR_CHARAGEKI_END_WAIT(cgno)		while(WK7Play::Find(cgno)->GetState()!=WK7Play::PLAYED){ K7SCR_RETSYS(); } \
//LI
#define	K7SCR_CHARAGEKI_TERM(cgno)	{ \
		WK7Play*	pPlay = WK7Play::Find(cgno); \
		pPlay->SetVisibleAll( false ); \
		K7SCR_RETSYS(); \
		K7SCR_RETSYS(); \
		GHM_SAFE_DELETE( pPlay ); \
		WK7Play::RestorePlayTB(); \
		K7SCR_RETSYS(); \
		K7SCR_RETSYS(); \
		WK7Play::SetPlayed( cgno,true ); \
		WK7Chara::SetRenderChara(true); \
		WK7Stage::SetRenderStage(true); \
		WK7Item::SetRenderItem  (true); \
	}
//ubNAEg
#define	K7SCR_BLACK_FADEOUT()	{ \
	k7app.FadeStart(0x00,0); \
	k7app.SetFadeColor(0x00000000); \
	k7app.FadeStart(0xff,1200); \
	K7SCR_TIMEWAIT(1200); \
	}
//ubNC
#define	K7SCR_BLACK_FADEIN()	{ \
	k7app.FadeStart(0x00,800); \
	K7SCR_TIMEWAIT(800); \
	}
//	tʐݒ	
#define	K7SCR_SET_BLOOD_THICK(point)			if( GameInfo.GetSpOption() != NULL ) GameInfo.GetSpOption()->SetBloodGauge(BP_THICK, point);
#define	K7SCR_SET_BLOOD_THIN(point)				if( GameInfo.GetSpOption() != NULL ) GameInfo.GetSpOption()->SetBloodGauge(BP_THIN, point);



//
// XNvgR}hꗗ
////////////////////////////////////////////////////////////////////////////////
//EGCgꗗ
#define	K7SCR_EVENT_RESULT_DISP_TICK						(9600)		//Cxgʂ鎞
#define	K7SCR_MSK_WALL_BEFORE_TICK							(4800)		//}XNǔjFJύXSEĐ܂ł̊
#define	K7SCR_MSK_WALL_AFTER_TICK							(4800*3)	//}XNǔjFSEĐJ܂ł̃EGCg
// VXebZ[Wꗗ
#define	K7SCR_SYSMES_GETKEY									(0)		// JMɓꂽ
//#define	K7SCR_SYSMES_GETHSID								(1)		// wuX}Chcɓꂽ
#define	K7SCR_SYSMES_GETMEMO								(2)		// ɓꂽ
//#define	K7SCR_SYSMES_GETMAP									(3)		// }bvɓꂽ
//#define	K7SCR_SYSMES_GETVMEMO								(4)		// e[vɓꂽ
#define	K7SCR_SYSMES_DONTOPENDOOR							(5)		// JȂ
//#define	K7SCR_SYSMES_DUMMY									(6)		// _~[
#define	K7SCR_SYSMES_GETTAMA								(7)		// eɓꂽ
#define	K7SCR_SYSMES_OPENKEKKAI								(8)		// E
//#define	K7SCR_SYSMES_RELEASE_GIMMICK						(9)		// d|
//#define	K7SCR_SYSMES_BREAK_KUI								(10)	// Yj󂵂
#define	K7SCR_SYSMES_CLOSED_BY_KEY							(11)	// Ă
#define	K7SCR_SYSMES_BREAK_WALL								(12)	// ǂj󂵂
#define	K7SCR_SYSMES_NO_REACTION							(13)	// NȂ
#define	K7SCR_SYSMES_OPEN_KEY								(14)	// J
#define	K7SCR_SYSMES_ABSORB_BLOOD							(15)	// z
#define	K7SCR_SYSMES_COLORCHIP_R							(16)	// F{ɓꂽ
#define	K7SCR_SYSMES_COLORCHIP_G							(17)	// F{ɓꂽ
#define	K7SCR_SYSMES_COLORCHIP_B							(18)	// F{ɓꂽ
#define	K7SCR_SYSMES_COLORCHIP_RG							(19)	// F{ɓꂽ
#define	K7SCR_SYSMES_COLORCHIP_GB							(20)	// F{ɓꂽ
#define	K7SCR_SYSMES_COLORCHIP_RGB							(21)	// F{ɓꂽ

#endif

