////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Extra Object
//
// WK7Extra.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 06/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7EXTRA_H__
#define	__WK7EXTRA_H__

//#include <sysdolphin\baselib.h>
//#include "..\Lib\ghmGcDefine.h"
#include ".\WK7Chara.h"
#include ".\WK7Obj.h"
#include ".\WK7Npc.h"
#include ".\K7ID.h"

//
// Extra Object
//
class WK7Extra : public WK7Npc{
protected:
	f32								mSelectObjRadius;
	WK7PathBranchPointObj			*mpPathBranchPointObj;
	
	WK7Extra();				// ftHgRXgN^֎~
	WK7Extra(u32 extraid,ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	virtual bool StateInit(void);
	virtual bool Ai(void);
	virtual bool MotSet_Dmg(void);
	
public:
	virtual ~WK7Extra();
	
	inline WK7Extra* GetPrev(void){ return (WK7Extra *)ghmGcListObj::GetPrev(); }
	inline WK7Extra* GetNext(void){ return (WK7Extra *)ghmGcListObj::GetNext(); }
	
	virtual bool Initialize(void);
	
	
//	virtual bool ControlProcess(void);
//	virtual bool FrameProcess(void);
	
	virtual bool SetRotY(f32 targety,f32 roty=0.0f);
	
//	static WK7Extra* Create(u32 extraid,u32 stgid,u32 param=0);
	static WK7Extra* Find(u32 extraid,u32 stgid=0xffffffff,u32 param=0);
	static bool ReleaseStageExtra(u32 stgid);
	static bool ReleasePathBranchPointObj(WK7PathBranchPointObj *pPathBranchPointObj);
	
	inline void SetPathBranchPointObj(WK7PathBranchPointObj* pObj){ mpPathBranchPointObj=pObj; }
	inline WK7PathBranchPointObj* GetPathBranchPointObj(void){ return mpPathBranchPointObj; }
	
	bool SetSelectObjEnable(bool flag);
	bool GetSelectObjEnable(void);
	bool SetSelectObjPlayEnable(bool flag);
	bool GetSelectObjPlayEnable(void);
	
	bool SetSelectObjName(int index,const char *pName);
	bool SetSelectObjName(const char *pName0,const char *pName1);
	const char* GetSelectObjName(int index);
	
	bool SetSelectEventID(u32 eventid);
	u32 GetSelectEventID(void);
	
	virtual int SelectCallback(void);
	static int SelectCallback(WK7SelectObj *pObj);
};

#endif	//__WK7EXTRA_H__

