////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Menu Task
//
// WK7Menu Task.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/13/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7MENUTASK_H__
#define	__WK7MENUTASK_H__

//#include "..\Lib\ghmGcAppTask.h"
//#include "..\Lib\ghmGcMem.h"

class WK7MenuTask : public ghmGcAppTask{
public:
	enum ItemID{
		MI_START = 0,
		MI_MAIN = MI_START,
		MI_LOGO,
		MI_TITLE,
		MI_VIEWER,
		MI_SOUND,
		MI_SATO,
		MI_YAM,
		MI_FUJITA,
		MI_MATSU,
		MI_KAW,
		MI_WAT,
		MI_MAX
	};
	struct Item{
		ItemID				mID;
		char				*mpName;
	};
protected:
	int						mDelay;
	ItemID					mSelectID;
	static	Item			mItem[MI_MAX];
public:
	WK7MenuTask(ghmGcApp *pApp,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~WK7MenuTask();
	
	// R[obN
	virtual bool InitializeCallBack(void);
	
	// IR[obN
	virtual bool TerminateCallBack(void);
	
	// t[
	virtual bool FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);
};

class WK7SelectScenarioTask : public ghmGcAppTask{
protected:
	int						mDelay;
	int						mCursorV;
	int						mScenarioID;
	bool					mContinue;
public:
	WK7SelectScenarioTask(ghmGcApp *pApp,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~WK7SelectScenarioTask();
	
	// R[obN
	virtual bool InitializeCallBack(void);
	
	// IR[obN
	virtual bool TerminateCallBack(void);
	
	// t[
	virtual bool FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);
};


#endif	//__WK7MENUTASK_H__

