///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectBarrett
//
// YK7EffectBarrett.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/19/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectBarrett.h"
#include "./YK7EffectDent.h"
#include "./YK7EffectKLine.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

BARRETTUNION BarUnion ;

// function code --------------------------------

// obgGtFNg̋ʃf[^
extern s8 InitBarrettData( void )
{
	BARRETTUNION *BarrettUnion = &BarUnion ;

	MEMINIT(BarUnion) ;

	// ɂ邱ƂȂ
	BarrettUnion = NULL ;
	
	// I
	return 0 ;
}

// obgGtFNg̏풓f[^̓ǂݍ݂ǂ𓾂
extern s8 CheckBarrettData( void )
{
	// ɂȂ
	return TRUE ;
}


// obgGtFNg̋ʃf[^n
extern s8 EndBarrettData( void )
{
	BARRETTUNION *BarrettUnion = &BarUnion ;
	
	// ɂ邱ƂȂ
	BarrettUnion = NULL ;
	
	// I
	return 0 ;
}

// obgGtFNg쐬
extern EFFECT *CreateBarrettEffect( Vec Point, f32 Power, f32 Ritu, u32 Time, s32 Priority )
{
	BARRETTEFFECT *Barrett ;
	EFFECT *Effect, *DentEffect ;
	
	// VobgGtFNgf[^쐬
	Effect = AddEffectData( EFF_BARRETT, (void**)&Barrett, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// obgGtFNgf[^
	Point.x = Point.x ;
	Point.y = Point.y ;
	Barrett->Point = Point ;
	Barrett->Power = Power * 10000.0F ;
	Barrett->Ritu = Ritu ;
	Barrett->Time = Time * 8 / 11 ;
	Barrett->Counter = 0 ;
	Barrett->Mode = 0 ;

	// ʉ݃GtFNg𔭐
	DentEffect = CreateDentEffect( FALSE, Point, Power, Ritu, Time, FALSE, Priority + 1500 ) ;
	if( DentEffect == NULL )
	{
		CHKDELEFFECT( Effect ) ;
		return NULL ;
	}
	
	// WGtFNg𔭐
	if( CreateKLineEffect( 1, 0, 2.0F, Point, 50, 15.0F, 6.0F, 4, 80.0F, 10, (GXColor){255,255,255,180}, 0, Priority + 1700 ) == NULL )
	{
		CHKDELEFFECT( DentEffect ) ;
		CHKDELEFFECT( Effect ) ;
		return NULL ;
	}

	// I
	return Effect ;
}

// obgGtFNǧns
extern s8 ReleaseBarrettEffect( EFFECT *Effect )
{
	BARRETTEFFECT *BarrettEffect = ( BARRETTEFFECT * )Effect->Data ;
	
	// ɂ邱ƂȂ
	return 0 ;
}

// obgGtFNgPt[
extern s8 MoveBarrettEffect( EFFECT *Effect )
{
	BARRETTEFFECT *BarrettEffect = ( BARRETTEFFECT * )Effect->Data ;
	
	// ɍ폜
	DeleteEffect( Effect ) ;
	
	// I
	return 0 ;
}
	
// obgGtFNg`悷
extern s8 DrawBarrettEffect( EFFECT *Effect )
{
	BARRETTEFFECT *BarrettEffect = ( BARRETTEFFECT * )Effect->Data ;

	// I
	return 0 ;
}
