///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectBreak
//
// YK7EffectBreak.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 10/08/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectBreak.h"
#include "./YK7EffectShutter.h"
#include "./YK7Break.h"
#include "../Wat/WK7Event.h"

// define ---------------------------------------

#define CIR_DIVNUM			30				// ~̕		

// R[obNp֐
static void BreakEffectInitCallBack( WK7JObj *JObj, void *Data ) ;
static void BreakEffectInitGetNumCallBack( WK7JObj *JObj, void *Data ) ;


// datatype -------------------------------------

// data -----------------------------------------

BREAKUNION BrkUnion ;

// function code --------------------------------

// GtFNg̋ʃf[^
extern s8 InitBreakData( void )
{
	MEMINIT( BrkUnion ) ;

	// I
	return 0 ;
}

// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckBreakData( void )
{
	return TRUE ;
}

// GtFNg̋ʃf[^n
extern s8 EndBreakData( void )
{
	MEMINIT( BrkUnion ) ;
	
	// I
	return 0 ;
}

// R[obNp֐
	// R[obNp\
	typedef struct tagBREAKEFFECTCALLBACK
	{
		BREAKEFFECT *Data ;
		BREAKEFFECTTASKPARAM *Param ;
	} BREAKEFFECTCALLBACK ;
static void BreakEffectInitCallBack( WK7JObj *JObj, void *Data )
{
	BREAKEFFECTCALLBACK *Call = ( BREAKEFFECTCALLBACK * )Data ;
	BREAKEFFECT *Break = Call->Data ;
	BREAKEFFECTTASKPARAM *Param = Call->Param ;
	BREAKOBJECT *Obj ;
	
	// gpIuWFNgZbg
	Obj = &Break->ObjP[Break->ObjNum] ;
	
	// s̃ZbgAbv
	HSD_JObjSetupMatrix( JObj->GetJObj() ) ;
	
	// gptO𗧂Ă
	Obj->UseFlag = TRUE ;
	
	// JObj ̃|C^ۑ
	Obj->JObj = JObj ;
	
	// W̕ۑ
	JObj->GetPosition( &Obj->Point ) ;
	
	// ]l̎擾
	JObj->GetRotation( &Obj->Rotate.x, &Obj->Rotate.y, &Obj->Rotate.z ) ; 
	
	// Xs[h̃Zbg
	{
		f32 Speed ;
		Vec Dir, Point ;
		
		Point.x = JObj->GetJObj()->mtx[0][3] ;
		Point.y = JObj->GetJObj()->mtx[1][3] ;
		Point.z = JObj->GetJObj()->mtx[2][3] ;
		Speed = (f32)rand() * ( Param->MaxPower - Param->MinPower ) / RAND_MAX + Param->MinPower ;
		Dir.x = Point.x - Param->BasePoint.x ;
		Dir.y = Point.y - Param->BasePoint.y ;
		Dir.z = Point.z - Param->BasePoint.z ;
		if( Dir.x + Dir.y + Dir.z == 0.0F )
		{
			Obj->Speed.x = Obj->Speed.y = Obj->Speed.z = 0.0F ;
		}
		else
		{
			PSVECNormalize( &Dir, &Obj->Speed ) ;
			PSVECScale( &Obj->Speed, &Obj->Speed, Speed ) ;
		}
	}

	// ]xZbg
	{
		f32 Speed ;

		Speed = (f32)rand() * ( Param->MaxRotSpeed - Param->MinRotSpeed ) / RAND_MAX + Param->MinRotSpeed ;
		Obj->RotSpeed.x = rand() * PI_2 / RAND_MAX - PI ;
		Obj->RotSpeed.y = rand() * PI_2 / RAND_MAX - PI ;
		Obj->RotSpeed.z = rand() * PI_2 / RAND_MAX - PI ;
		PSVECNormalize( &Obj->RotSpeed, &Obj->RotSpeed ) ;
		PSVECScale( &Obj->RotSpeed, &Obj->RotSpeed, Speed ) ;
	}
	
	// At@̕ωxZbg
	{
		Obj->Alpha = 1.0F ;
		Obj->AlphaSpeed = rand() * ( Param->MaxAlphaSpeed - Param->MinAlphaSpeed ) / RAND_MAX  + Param->MinAlphaSpeed ;
	}
	
	// At@l𑀍삷邽߂̃NXIuWFNg̍쐬
//	Obj->CAlpha = new C_SetAlpha( JObj->GetJObj(), 1.0F ) ;
//	if( Obj->CAlpha == NULL ) return ;

	// 𑝂₷
	Break->ObjNum ++ ;
}

static void BreakEffectInitGetNumCallBack( WK7JObj *, void *Data )
{
	BREAKEFFECT *Break = ( BREAKEFFECT * )Data ;
	Break->ObjNum ++ ;
}

// ̃GtFNg쐬
extern EFFECT *CreateBreakEffect( WK7JObj *JObj, Vec BasePoint,
									f32 MaxPower, f32 MinPower, Vec SSpeed,
									f32 MaxRotSpeed, f32 MinRotSpeed,
									f32 MaxAlphaSpeed, f32 MinAlphaSpeed, s32 Priority )
{
	BREAKEFFECT *Break, BTemp ;
	EFFECT *Effect ;
	BREAKEFFECTCALLBACK Call ;
	BREAKEFFECTTASKPARAM Param ;
	
	// xۑ
	BTemp.SSpeed = SSpeed ;

	// nꂽ JObj ̎qŃbVׂ̂͂ė񋓂A𐔂
	BTemp.ObjNum = 0 ;
	ScanPrimitiveJObj( JObj, BreakEffectInitGetNumCallBack, &BTemp ) ;
	BTemp.RunObjNum = BTemp.ObjNum ;

	// ̃f[^i[ł郁̈m
	BTemp.ObjP = ( BREAKOBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( BREAKOBJECT ) * BTemp.ObjNum ), "Y_BrkObj" ) ;
	if( BTemp.ObjP == NULL ) return NULL ;

	// f[^
	{
		BTemp.ObjNum = 0 ;
		Param.JObj = JObj ;
		Param.BasePoint = BasePoint ;
		Param.MaxPower = MaxPower ;				Param.MinPower = MinPower ;
		Param.SSpeed = SSpeed ;
		Param.MaxRotSpeed = MaxRotSpeed ;		Param.MinRotSpeed = MinRotSpeed ;
		Param.MaxAlphaSpeed = MaxAlphaSpeed ;	Param.MinAlphaSpeed = MinAlphaSpeed ;
		Call.Param = &Param ;
		Call.Data = &BTemp ;
		ScanPrimitiveJObj( JObj, BreakEffectInitCallBack, &Call ) ;
	}
	
	// Ȃ폜
	if( BTemp.ObjNum != BTemp.RunObjNum )
	{
/*		u16 i ;
		
		for( i = 0 ; i < BTemp.ObjNum ; i ++ )
		{
			delete BTemp.ObjP[i].CAlpha ;
		}
*/		K7AppSmallMemFree( BTemp.ObjP ) ;
		return NULL ;
	}

	// At@l֌W̏
	{
		BTemp.Alpha = 1.0F ;
		BTemp.AlphaSpeed = rand() * ( MaxAlphaSpeed - MinAlphaSpeed ) / RAND_MAX + MinAlphaSpeed ;
		
		// At@l𑀍삷邽߂̃NXIuWFNg̍쐬
		BTemp.CAlpha = new C_SetAlpha( JObj->GetJObj(), 1.0F ) ;
		if( BTemp.CAlpha == NULL )
		{
			K7AppSmallMemFree( BTemp.ObjP ) ;
			return NULL ;
		}
	}
		

	// Vf[^쐬
	Effect = AddEffectData( EFF_BREAK, (void**)&Break, Priority ) ;
	if( Effect == NULL )
	{
		K7AppSmallMemFree( BTemp.ObjP ) ;
		return NULL ;
	}

	// f[^Rs[
	*Break = BTemp ;

	// I
	return Effect ;
}

// ̃GtFNǧns
extern s8 ReleaseBreakEffect( EFFECT *Effect )
{
	BREAKEFFECT *Break = ( BREAKEFFECT * )Effect->Data ;
	u16 i ;

	for( i = 0 ; i < Break->ObjNum ; i ++ )
	{
		Break->ObjP[i].JObj->Hide( false, true ) ;
	}
	
/*	for( i = 0 ; i < Break->ObjNum ; i ++ )
	{
		delete Break->ObjP[i].CAlpha ;
	}
*/
	delete Break->CAlpha ;

	// ̉
	CHKMEMFREE2( Break->ObjP ) ;

	// I
	return 0 ;
}

// ̃GtFNgPt[
extern s8 MoveBreakEffect( EFFECT *Effect )
{
	BREAKEFFECT *Break = ( BREAKEFFECT * )Effect->Data ;
	BREAKOBJECT *Obj ;
	s32 i ;

	if( (BREAKEFFECT *)NULL == Break ) return 0 ;
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// At@l֌W̏
	{
		// At@l̕ύX
		Break->Alpha -= Break->AlphaSpeed ;
		if( Break->Alpha < 0 ) Break->Alpha = 0 ;
		
		// Ԃ𔽉f
		Break->CAlpha->SetVal( Break->Alpha ) ;
	}

	// ׂẴIuWFNg
	Obj = Break->ObjP ;
	for( i = 0 ; i < Break->ObjNum ; i ++, Obj ++ )
	{
		// gptO|Ă牽I
		if( Obj->UseFlag == FALSE ) continue ;
		
		// WύX
		Obj->Point.x += Obj->Speed.x ;
		Obj->Point.y += Obj->Speed.y ;
		Obj->Point.z += Obj->Speed.z ;
		
		// x^
		Obj->Speed.x += Break->SSpeed.x ;
		Obj->Speed.y += Break->SSpeed.y ;
		Obj->Speed.z += Break->SSpeed.z ;
		
		// ]pxύX
		Obj->Rotate.x += Obj->RotSpeed.x ;
		Obj->Rotate.y += Obj->RotSpeed.y ;
		Obj->Rotate.z += Obj->RotSpeed.z ;
		
		// At@l̕ύX
		Obj->Alpha -= Obj->AlphaSpeed ;
		if( Obj->Alpha < 0 ) Obj->Alpha = 0 ;
		
		// Ԃ𔽉f
		Obj->JObj->SetPosition( Obj->Point.x, Obj->Point.y, Obj->Point.z ) ;
		Obj->JObj->SetRotation( Obj->Rotate.x, Obj->Rotate.y, Obj->Rotate.z ) ;

//		Obj->CAlpha->SetVal( Obj->Alpha ) ;
		
		// I`FbN
		if( Obj->Alpha <= 0 )
		{
			Obj->UseFlag = FALSE ;
			Break->RunObjNum -- ;
		}
	}
	
	// ĂIuWFNg̐OɂȂI
	if( Break->RunObjNum == 0 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// I
	return 0 ;
}


// ̃GtFNg`悷
extern s8 DrawBreakEffect( EFFECT *Effect )
{
	BREAKEFFECT *Break = ( BREAKEFFECT * )Effect->Data ;
	
	if( (BREAKEFFECT *)NULL == Break ) return 0 ;
	
	// ɂ邱ƂȂ
	return 0 ;
}
