///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCartridge
//
// YK7EffectCartridge.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/28/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTCARTRIDGE_H
#define __YK7EFFECTCARTRIDGE_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Item.h"
#include "../Wat/WK7Model.h"

// define ---------------------------------------

// datatype -------------------------------------

// J[gbWGtFNgʃf[^
typedef struct tagCARTRIDGEUNION
{
//	WK7Archive *CartModel[GUN_NUM] ;
//	s8 Dummy ;
	bool Sound3DFlag ;
} CARTRIDGEUNION ;

// J[gbWGtFNgf[^
typedef struct tagCARTRIDGEEFFECT
{
	WK7Item *CartItem ;				// J[gbW WK7Item
	WK7Model *CartModel ;			// J[gbW WK7Model
	f32 YukaY ;						// ̍
	s32 Sound ;						// nʂɒƂɖ炷

	Vec Point ;						// W
	Vec RotSp ;						// ]x
	Vec Speed ;						// xNg

	u16 Counter ;					// JE^[
	u8 Flag ;
	u8 Sound3DFlag ;				// RctO
} CARTRIDGEEFFECT ;

// J[gbWGtFNg^XNɓnf[^
typedef struct tagCARTRIDGEEFFECTTACKPARAM
{
	WK7JObj *CartridgeJObj ;		// J[gbW WK7JObj
	f32 YukaY ;						// ̍
} CARTRIDGEEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitCartridgeData( void ) ;				// J[gbWGtFNg̋ʃf[^
extern s8 CheckCartridgeData( void ) ;				// J[gbWGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndCartridgeData( void ) ;				// J[gbWGtFNg̋ʃf[^n

extern EFFECT *CreateCartridgeEffect( WK7JObj *CartridgeJObj, f32 YukaY, s32 Sound, s32 Priority = -1 ) ;		// J[gbW̃GtFNg쐬
extern s8 ReleaseCartridgeEffect( EFFECT *Effect ) ;			// J[gbW̃GtFNǧns
extern s8 MoveCartridgeEffect( EFFECT *Effect ) ;				// J[gbW̃GtFNgPt[
extern s8 DrawCartridgeEffect( EFFECT *Effect ) ;				// J[gbW̃GtFNg`悷

extern s8 GetCartridgeJObj( WK7JObj *JObj, WK7JObj **Dest ) ;	// J[gbW WK7JObj TĎ擾
extern s8 SetCartridgeSound3DFlag( bool Flag ) ;				// ɍ쐬J[gbW 3D Đ邩ǂ̃tOZbg

#endif