///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCharge
//
// YK7EffectCharge.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/21/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTCHARGE_H
#define __YK7EFFECTCHARGE_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"
#include "./YK7File.h"
#include "./YK7Move.h"

// define ---------------------------------------

#define MAX_TUBENUM			(5)			// ǂ̍ő吔

// datatype -------------------------------------

// `[WGtFNgʃf[^
typedef struct tagCHARGEUNION
{
	u8 SetupState ;			// ZbgAbv̐is

	YK7ResLink *Pack ;		// pbNt@C
	TEXDATA texnum[6] ;		// eeNX`
	TEXDATA texkasan[5] ;
	TEXDATA texkasanb[5] ;
	TEXDATA texmoji ;
	TEXDATA texmoji_shadow ;
	TEXDATA texblood_8 ;
	TEXDATA texplate ;
	TEXDATA texplate_line ;
	TEXDATA texsikenkan ;
	TEXDATA texwaku ;
} CHARGEUNION ;

// `[WGtFNgf[^
typedef struct tagCHARGEEFFECT
{
	bool InFlag ;					// ̑ѕ\tO
	CMov inrate ;					// ̑тoĂ闦
	bool AutoFlag ;					// ̑т̍WIɓtO
	
	s32 num ;						// ǂ̐
	s32 chargenum ;					// ܂Ă鎎ǂ̐
	s32 fronttube ;					// ԎOɗ鎎ǂ̃CfbNX
	CMov tuberate[MAX_TUBENUM] ;	// ǂ̂܂
	CMov tubemov ;					// ǂ̈ړ( 0.0F:ړȂ  1.0F:̈ʒu֊Sړ )
	f32 frontchagerate ;			// `[W̃`[W
	
	s32 mod ;						// 
	s32 con ;						// ėpJE^
	
	s32 brinkcon ;					// _ŃJE^
	bool brinkflag ;				// _ŃtO
} CHARGEEFFECT ;



// prototype ------------------------------------

extern s8 InitChargeData( void ) ;			// `[WGtFNg̋ʃf[^
extern s8 CheckChargeData( void ) ;			// `[WGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndChargeData( void ) ;			// `[WGtFNg̋ʃf[^n

extern EFFECT *CreateChargeEffect(
									s32 TubeNum,						// ǂ̐
									s32 Priority = 100 ) ;				// `[WGtFNg쐬

extern s8 ReleaseChargeEffect( EFFECT *Effect ) ;						// `[WGtFNǧns
extern s8 MoveChargeEffect( EFFECT *Effect ) ;							// `[WGtFNgPt[
extern s8 DrawChargeEffect( EFFECT *Effect ) ;							// `[WGtFNg`悷

extern bool SetupChargeEffect( void ) ;						// `[WGtFNg̏s
extern bool CheckSetupChargeEffect( void ) ;				// `[WGtFNg̏̊Ԃ𒲂ׂ( false:܂  true: )
extern bool ReleaseChargeEffect( void ) ;					// `[WGtFNg̏̌n

extern bool SetChargeEffectTubeNum( EFFECT *Effect, s32 TubeNum ) ;		// `[WGtFNg̎ǂ̐ύX
extern bool SetChargeEffectInFlag( EFFECT *Effect, bool InFlag ) ;		// `[WGtFNg̕\tOZbg( true:\  false:\Ȃ )
extern s32 GetChargeEffectChargeNum( EFFECT *Effect ) ;					// `[WGtFNgŗ܂Ă鎎ǂ̐
extern bool SetChargeEffectBrinkFlag( EFFECT *Effect, bool brinkflag ) ;	// `[WGtFNg̓_ł̃IEItݒ肷

extern bool SetChargeEffectAutoFlag( EFFECT *Effect, bool AutoFlag ) ;		// `[WGtFNg̑эW̎ݒ@\̃IԂύX
extern bool SetChargeEffectInRate( EFFECT *Effect, f32 rate ) ;				// `[WGtFNg̏oύX
extern f32 GetChargeEffectInRate( EFFECT *Effect ) ;						// `[WGtFNg̏o擾
extern f32 GetChargeEffectObiWidth( void ) ;								// `[WGtFNg̍т̕𓾂

#endif

