///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectConveBlood
//
// YK7EffectConveBlood.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/19/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTCONVEBLOOD_H
#define __YK7EFFECTCONVEBLOOD_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "./YK7Break.h"
#include "./YK7EffectBlood.h"
#include "./YK7EffectBloodPack.h"

// define ---------------------------------------

#define CONVEBLOODPAT_ONELINENUM		(2)
#define CONVEBLOODPAT_NUM				(CONVEBLOODPAT_ONELINENUM*CONVEBLOODPAT_ONELINENUM)
#define CONVEBLOODONE_SIZE				( UVSCALE / CONVEBLOODPAT_ONELINENUM )
#define CONVEBLOOD_TARGETMAXPOS			(10)

// datatype -------------------------------------

// GtFNgʃf[^
typedef struct tagCONVEBLOODUNION
{
	Vec TargetP ;								// ڕWW
	Vec FlowerTargetP ;							// ԖڕWW
	f32 FlowerTargetSize ;						// ԖڕWTCY
	u8 ConveBloodFlag ;							// tO
	void (*ConveBloodCallBack)(void *Data) ;	// R[obN֐
	void *ConveBloodCallBackData ;				// R[obN֐ɓnf[^
} CONVEBLOODUNION ;

// GtFNgf[^
typedef struct tagCONVEBLOODEFFECT
{
	EFFECT *BloodEffect ;				// GtFNg̃|C^
	BLOODEFFECT	*BloodEffectData ;		// GtFNg̎spf[^ւ̃|C^
	BLOODPACKMETER *packmeter ;			// pbN֋zꍇ̋z̃[^[
	u32 ObjNum ;						// IuWFNg̐
//	u32 EndNum ;
	u32 DrawNum ;						// `悷IuWFNg̐
	
	s32 FadeoutCounter ;				// tF[hAEgJE^[
	f32 ObjectAlpha ;					// IuWFNg̃l

	u8 WaitTime ;						// zނ܂ő҂
	u32 Counter ;						// JE^[	
	f32 SSPower ;						// ͂̋̉x̉x
	f32 SPower ;						// ͂̉x
	f32 Power ;							// ͂̑x
	
	Vec TargetPos[CONVEBLOOD_TARGETMAXPOS] ;	// ڕWW
	s32 TargetPosNum ;
} CONVEBLOODEFFECT ;

// GtFNg^XNɓnf[^
typedef struct tagCONVEBLOODEFFECTTACKPARAM
{
	EFFECT *BloodEffectData ;			// GtFNg̎spf[^ւ̃|C^
	u8 WaitTime ;						// zނ܂ő҂
	f32 Power ;							// ͂̋
} CONVEBLOODEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitConveBloodData( void ) ;				// GtFNg̋ʃf[^
extern s8 CheckConveBloodData( void ) ;				// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndConveBloodData( void ) ;				// GtFNg̋ʃf[^n

extern EFFECT *CreateConveBloodEffect( EFFECT *BloodEffect, u8 WaitTime, f32 Power,
														 s32 Priority = 129 ) ;		// ̃GtFNg쐬
extern s8 ReleaseConveBloodEffect( EFFECT *Effect ) ;							// ̃GtFNǧns
extern s8 MoveConveBloodEffect( EFFECT *Effect ) ;								// ̃GtFNgPt[
extern s8 DrawConveBloodEffect( EFFECT *Effect ) ;								// ̃GtFNg`悷

extern s8 GetConveBloodRunFlag( EFFECT * Effect ) ;			// Ă邩ǂ擾( TRUE:Ă FALSE:܂ )

extern s8 SetConveBloodTargetPoint( Vec Point ) ;			// GtFNg̎W̐ݒ
extern s8 SetConveFlowerTargetPoint( Vec Point ) ;			// ԃGtFNg̎W̐ݒ
extern s8 SetConveFlowerTargetSize( f32 Size ) ;			// ԃGtFNg̎̃TCYݒ

extern s8 SetConveBloodFlag( u8 ConveFlag ) ;				// tOZbg
extern s8 GetConveBloodFlag( void ) ;						// tO擾

extern s8 SetConveBloodIncBloodCallBackFunction( void (*CallBack)( void *Data ), void *Data ) ;		// R[obN֐o^

#endif