///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCut
//
// YK7EffectCut.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/22/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectCut.h"
#include "./YK7File.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

#define PRM				(s32)VParam[ED_CUT]

#define CUTCOLOR(x)		(CMK(255,255,255,(x) * 255 * PRM[3] / 255))
#define CUTCOLOR2(x)	(CMK(PRM[0],PRM[1],PRM[2],(x) * 255 * PRM[3] / 255))
#define CUTSIZE			(1.0F)			// JbgGtFNg̃TCY
#define CUTTIME			(10)			// JbgGtFNgoĂ鎞

#define TEX01PATH		"/Yam/Effect/Cut/KVN_effect_a01.BIN"
#define TEX02PATH		"/Yam/Effect/Cut/KVN_effect_a02.BIN"

// eeNX`̑傫
#define USIZE		(64.0F)
#define CW			((81.0F)	/USIZE)
#define CH			((121.0F)	/USIZE)
#define LW			((64.0F)	/USIZE)
#define LH			((8.0F)		/USIZE)

// data -----------------------------------------

CUTUNION cutu ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// JbgGtFNg̋ʃf[^
extern s8 InitCutData( void )
{
	MEMINIT( cutu ) ;

	return 0 ;
}

// JbgGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckCutData( void )
{
	return TRUE ;
}

// JbgGtFNg̋ʃf[^n
extern s8 EndCutData( void )
{
	MEMINIT( cutu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// JbgGtFNg쐬
extern EFFECT *CreateCutEffect(
									Vec Pos,
									s32 Priority )				// JbgGtFNg쐬
{
	EFFECT *Effect ;
	CUTEFFECT *ct ;

	// eNX`̏łĂȂꍇ͉Ȃ
	if( cutu.SetupState != 2 ) return NULL ;

	// VJbgf[^쐬
	Effect = AddEffectData( EFF_CUT, (void**)&ct, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	// lۑ
	ct->pos = Pos ;
	
	// ̑̏
	ct->mod = 0 ;
	ct->con = 0 ;

	// I
	return Effect ;
}

// JbgGtFNǧns
extern s8 ReleaseCutEffect( EFFECT *Effect )
{
	CUTEFFECT *ct = ( CUTEFFECT * )Effect->Data ;

	// I
	return 0 ;
}

// JbgGtFNgPt[
extern s8 MoveCutEffect( EFFECT *Effect )
{
	CUTEFFECT *ct = ( CUTEFFECT * )Effect->Data ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// JE^
	ct->con ++ ;
	if( ct->con == CUTTIME )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// I
	return 0 ;
}

// JbgGtFNg`悷
extern s8 DrawCutEffect( EFFECT *Effect )
{
	CUTEFFECT *ct = ( CUTEFFECT * )Effect->Data ;
	Mtx mt ;
	f32 w, h, a ;

	if( ct->con == 0 ) return 0 ;

/*	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ADD, EF_TEV_USETEX, TRUE ) ;
	DrawTex( 0, 0, &cutu.tex01 ) ;
	DrawTex( 0, 0, &cutu.tex02 ) ;
	
	return 0 ;
*/	
	// `̏
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ADD, EF_TEV_USETEX, TRUE ) ;
	
	// ts̎擾
	EffectGetInvViewMatrix( mt ) ;
	
	// aGtFNg`
	switch( ct->con )
	{
	case 1 : w = h = 0.2F ; break ;
	case 2 : w = 0.68F ; h = 0.20F ; break ;
	case 3 :
		w = ( 1.0F - 0.68F ) / 2.0F + 0.68F ;
		h = ( 1.0F - 0.20F ) / 2.0F + 0.20F ;
		break ;
	case 4 : w = h = 1.0F ; break ;

	case 5 :	case 6 :	case 7 :
		w = ( 1.50F - 1.00F ) * (f32)( ct->con - 4 ) / 3.0F + 1.00F ;
		h = ( 4.00F - 1.00F ) * (f32)( ct->con - 4 ) / 3.0F + 1.00F ;
		break ;

	default :
		w = 1.50F ;
		h = 4.00F ;
		break ;
	}
	switch( ct->con )
	{
	case 1 :	case 2 :
	case 3 :	case 4 :
	case 5 :	case 6 :	case 7 :
		a = ( 1.0F - 0.20F ) * (f32)( ct->con - 1 ) / 7.0F + 0.20F ;
		break ;
		
	default :
		a = 0.0F ;
		break ;
	}
	DrawExTex3D( mt, w * CW, h * CH, 0.0F, CUTSIZE, ct->pos, &cutu.tex01, CUTCOLOR(a) ) ;
	DrawExTex3D( mt, w * CW, h * CH, 0.0F, CUTSIZE, ct->pos, &cutu.tex01, CUTCOLOR2(a) ) ;
	
	// ɐLтeNX`̕`
	if( ct->con >= 3 )
	{
		w = ( 12.00F - 1.0F ) * (f32)( ct->con - 3.0F ) / 4.0F + 1.0F ;
		h = 1.0F ;
		a = 1.0F ;
		DrawExTex3D( mt, w * LW, h * LH, 0.0F, CUTSIZE, ct->pos, &cutu.tex02, CUTCOLOR(a) ) ;
		DrawExTex3D( mt, w * LW, h * LH, 0.0F, CUTSIZE, ct->pos, &cutu.tex02, CUTCOLOR2(a) ) ;
	}

	// I
	return 0 ;
}


// JbgGtFNg̏s
extern bool SetupCutEffect( void )
{
	// ZbgAbvĂ牽Ȃ
	if( cutu.SetupState == 2 ) return true ;
	if( cutu.SetupState == 1 ) return false ;
	
	// ǂݍ݊Jn
//	TexLoadSet( TEX01PATH, &cutu.tex01 ) ;
//	TexLoadSet( TEX02PATH, &cutu.tex02 ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_KVN_effect_a01 ), &cutu.tex01 ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_KVN_effect_a02 ), &cutu.tex02 ) ;
	
	// Ԃ𐄈
	cutu.SetupState = 1 ;
	
	// I
	return 0 ;
}

// JbgGtFNg̏̊Ԃ𒲂ׂ( false:܂  true: )
extern bool CheckSetupCutEffect( void )
{
	// ɓǂݍ܂Ă牽Ȃ
	if( cutu.SetupState == 2 ) return true ;
	if( cutu.SetupState == 0 ) return false ;
	
	// ǂݍݏI`FbN
//	if( TexLoadChk( &cutu.tex01 ) == FALSE ) return false ;
//	if( TexLoadChk( &cutu.tex02 ) == FALSE ) return false ;
	
	// ԂύX
	cutu.SetupState = 2 ;
	
	// I
	return 0 ;
}

// JbgGtFNg̏̌n
extern bool ReleaseCutEffect( void )
{
	// ɉĂ牽I
	if( cutu.SetupState == 0 ) return true ;
	
	// eNX`̉
	TexRelease( &cutu.tex01 ) ;
	TexRelease( &cutu.tex02 ) ;
	
	// Ԃ
	cutu.SetupState = 0 ;
	
	// I
	return 0 ;
}
