///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectDropWater
//
// YK7EffectDropWater.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 10/02/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTDROPWATER_H
#define __YK7EFFECTDROPWATER_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// HGtFNgʃf[^
typedef struct tagDROPWATERUNION
{
	u8 Dummy ;
} DROPWATERUNION ;

// HGtFNgf[^
typedef struct tagDROPWATEREFFECT
{
	Vec CreatePoint ;			// W

	s8 FastDeleteFlag ;			// 폜tO
	s8 DrawFlag ;				// `tO

	EFFECT *DropAnim ;			// HAj[VGtFNgւ̃|C^
	EFFECT *RippleAnim ;		// gAj[VGtFNgւ̃|C^
	u32 DropID, RippleID ;

	u8 WaterValidFlag ;			// H݂Ă邩tO
	u8 RippleValidFlag ;		// g䂪݂Ă邩tO
	Vec Point ;					// ݂̐H̍W
	f32 DropSpeed ;				// x
	f32 SpeedY ;				// x
	f32 YukaY ;					// ̍
	s16 CreateWaitTime ;		// oԊu
	s16 CreateWaitRange ;		// oԊu͈̔
	s16 CreateWait ;			// ɏo܂ł̎
} DROPWATEREFFECT ;

// HGtFNgf[^p\
typedef struct tagDROPWATEREFFECTTASKPARAM
{
	Vec CreatePoint ;			// Hon߂W
	f32 YukaY ;					// ̍
	u16 CreateWaitTime ;		// oԊu
	u16 CreateWaitRange ;		// oԊu͈̔
	f32 DorpSpeed ;				// H鑬x
} DROPWATEREFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitDropWaterData( void ) ;			// HGtFNg̋ʃf[^
extern s8 CheckDropWaterData( void ) ;			// HGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndDropWaterData( void ) ;			// HGtFNg̋ʃf[^n

extern EFFECT *CreateDropWaterEffect( Vec CreatePoint, f32 YukaY,
										s16 CreateWaitTime = -1, s16 CreateWaitRange = -1,
										f32 DropSpeed = -1.0F, s32 Priority = -1 ) ;	// HGtFNg쐬
extern s8 ReleaseDropWaterEffect( EFFECT *Effect ) ;						// HGtFNǧns
extern s8 MoveDropWaterEffect( EFFECT *Effect ) ;							// HGtFNgPt[
extern s8 DrawDropWaterEffect( EFFECT *Effect ) ;							// HGtFNg`悷

extern s8 FastDelReqDropWaterEffect( EFFECT *Effect ) ;						// 폜NGXgs
extern s8 SetDropWaterDrawFlag( EFFECT *Effect, s8 DrawFlag ) ;				// `tOZbg( TRUE:`  FALSE:` )

#endif
