///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectElec
//
// YK7EffectElec.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/11/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTELEC_H
#define __YK7EFFECTELEC_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

enum ELEC_TYPE
{
	EL_TEST = 0,			// eXgp
	EL_MSK_BOM,				// }XN̓dVbgp(̒тт)
	EL_HS_DMG1,				// wuX}CdTCYP
	EL_HS_DMG2,				// wuX}CdTCYQ
	EL_HS_DMG3,				// wuX}CdTCYR
	EL_MSK_GRAV,			// }XN̏WVbgp
	EL_HS_GRV1,				// wuX}CWddTCYP
	EL_HS_GRV2,				// wuX}CWdTCYQ
	EL_HS_GRV3,				// wuX}CWdTCYR
	EL_MAX, 
} ;

#define MAXDIVDIVNUM	(7)
#define MAXDIVNUM		(100)
#define MAXROTNUM		(20)

#define MAXPDIVNUM		(20)

// datatype -------------------------------------

// dGtFNgʃf[^
typedef struct tagELECUNION
{
	u8 dummy ;
} ELECUNION ;

// dGtFNgf[^
typedef struct tagELECEFFECT
{
	DIR3 dir ;

	void *databuf ;
	Vec *parent ;
	Vec *buf ;
	f32 *size ;

	f32 len ;
	s32 pdivnum ;
	Vec pos, target ;
	
	f32 rot[MAXROTNUM] ;
	f32 rotsp[MAXROTNUM] ;
	f32 rotw[MAXROTNUM] ;
	f32 rotrate[MAXROTNUM] ;
	
	f32 onedivlen ;						// ꕪ̍ő咷
	f32 maxwidth, minwidth ;			// őEŏ̑
	f32 biaswidth ;						// ̕򂲂ƂɌ銄
	s32 billnum ;						// ԉ摜̐
	u32 color ;							// F
	f32 burewidthbig, burewidthsmall ;	// 傫ȂԂ̃TCYƏȂԂ̃TCY
	s32 divnum ;						// ꕪԂԂ镪
	s32 div2num ;						// 򃉃C̒_
	f32 div2addz ;						// 򃉃C̈꒸_ӂ̑Oi
	s32 div2ainum ;						// 򃉃C̕ԃr{[h̐

	s32 blendmode ;						// uh[h
	bool endPosLockFlag ;				// Ō̒_Œɂ邩ǂ̃tO
	bool startPosLockFlag ;				// ŏ̒_Œɂ邩ǂ̃tO
	
	s32 brinkcon ;						// _ŗpJE^
	s32 brinkwait ;						// _ő҂
	bool drawflag ;						// `

	s32 maxbrinkwait, minbrinkwait ;	// _ōő҂Ԃƍŏ҂
} ELECEFFECT ;

// prototype ------------------------------------

extern s8 InitElecData( void ) ;		// dGtFNg̋ʃf[^
extern s8 CheckElecData( void ) ;		// dGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndElecData( void ) ;			// dGtFNg̋ʃf[^n

extern EFFECT *CreateElecEffect( ELEC_TYPE type,
									Vec pos, Vec target,
									s32 Priority = -1 ) ;		// dGtFNg쐬

extern EFFECT *CreateElecEffect(
								Vec pos, Vec target,
								f32 onedivlen,						// ꕪ̍ő咷
								f32 maxwidth, f32 minwidth,			// őEŏ̑
								f32 biaswidth,						// ̕򂲂ƂɌ銄
								s32 billnum,						// ԉ摜̐
								u32 color,							// F
								f32 burewidthbig, f32 burewidthsmall,	// 傫ȂԂ̃TCYƏȂԂ̃TCY
								s32 divnum,							// ꕪԂԂ镪
								s32 div2num,						// 򃉃C̒_
								f32 div2addz,						// 򃉃C̈꒸_ӂ̑Oi
								s32 blendmode,						// uh[h
								bool endPosLockFlag,				// Ō̒_Œɂ邩ǂ̃tO
								bool startPosLockFlag,				// ŏ̒_Œɂ邩ǂ̃tO
								s32 maxbrinkwait, s32 minbrinkwait,	// _ōő҂Ԃƍŏ҂
								s32 Priority = -2 ) ;			// dGtFNg쐬

extern s8 ReleaseElecEffect( EFFECT *Effect ) ;				// dGtFNǧns
extern s8 MoveElecEffect( EFFECT *Effect ) ;				// dGtFNgPt[
extern s8 DrawElecEffect( EFFECT *Effect ) ;				// dGtFNg`悷

extern s8 SetElecPos( EFFECT *Effect, Vec pos, Vec target ) ;	// dGtFNg̍WύX

 
#endif

