///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectExplode
//
// YK7EffectExplode.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/04/2003
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

#define __SMOKE_LENGTH_REVISE

// include --------------------------------------
#include "../fujita/c_font.h"

#include "../Wat/WK7Archive.h"
#include "./YK7EffectExplode.h"
#include "./YK7EffectFlash.h"
#include "./YK7EffectLine.h"
#include "./YK7EffectImpact.h"
#include "./YK7EffectWhirl.h"
#include "./YK7EffectHSExplode.h"
#include "../matsu/mk7Sound.h"
#include "./YK7EffectElec.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

#define ANIMERATE		2
#define ANIMENUM		12

char *TextureName[ANIMENUM] =
{
	"/Yam/Effect/Explode/12frame64_64/Explode1.00", 
	"/Yam/Effect/Explode/12frame64_64/Explode1.01", 
	"/Yam/Effect/Explode/12frame64_64/Explode1.02", 
	"/Yam/Effect/Explode/12frame64_64/Explode1.03", 
	"/Yam/Effect/Explode/12frame64_64/Explode1.04", 
	"/Yam/Effect/Explode/12frame64_64/Explode1.05", 
	"/Yam/Effect/Explode/12frame64_64/Explode1.06", 
	"/Yam/Effect/Explode/12frame64_64/Explode1.07", 
	"/Yam/Effect/Explode/12frame64_64/Explode1.08", 
	"/Yam/Effect/Explode/12frame64_64/Explode1.09", 
	"/Yam/Effect/Explode/12frame64_64/Explode1.10", 
	"/Yam/Effect/Explode/12frame64_64/Explode1.11", 
} ;

#define ANIME_FILENAME		"/Yam/Effect/Explode/Explosion1.dat"

#define PR1				VParam[ED_SMOKEEXP]
#define PR2				VParam[ED_SMOKEEXP2]

// datatype -------------------------------------

// data -----------------------------------------

EXPLODEUNION ExpUnion ;

// function proto type --------------------------

//s8 LoadExplodeAnim( char *FileName, EXPLODEANIME *ExAnim ) ;	// Aj[Vf[^ǂݍ
u8 CreateFreeExplodeAnim( void ) ;								// gĂȂAj[Vhc쐬
EXPLODEANIME *GetExplodeAnim( u8 AnimeID ) ;					// whc̔Aj[Vf[^𓾂

// function code --------------------------------

/*
// Aj[Vf[^ǂݍ
s8 LoadExplodeAnim( char *FileName, EXPLODEANIME *ExAnim )
{
	// A[JCuf[^擾
	ExAnim->Archive = WK7Archive::Create() ;
	ExAnim->Archive->LoadArchiveB( FileName ) ;
	ExAnim->Archive->SetStatic( true ) ;
	
	// ff[^ƃ[Vf[^̎擾
	ExAnim->Model = ExAnim->Archive->CreateModel() ;
	ExAnim->Anim = ExAnim->Archive->CreateModelMotion() ;
	ExAnim->TopObj = ExAnim->Model->GetObj(0) ;

	// gptO|
	ExAnim->UseFlag = FALSE ;
	
	// I
	return 0 ;
}
*/

// gĂȂAj[Vhc쐬
u8 CreateFreeExplodeAnim( void )
{
	EXPLODEUNION *ExplodeUnion = &ExpUnion ;

	// ݂̂hc̃Aj[Vf[^gĂȂΉɏI
	if( ExplodeUnion->Anime[ExplodeUnion->NextUseID].UseFlag == FALSE ) return ExplodeUnion->NextUseID ;
	
	// gĂ玟̃AhXɈړ
	ExplodeUnion->NextUseID ++ ;
	if( ExplodeUnion->NextUseID == MAX_EXPLODE ) ExplodeUnion->NextUseID = 0 ;
	
	// gp疳폜
	if( ExplodeUnion->Anime[ExplodeUnion->NextUseID].UseFlag == TRUE )
	{
		DeleteEffect( ExplodeUnion->Anime[ExplodeUnion->NextUseID].UseEffect ) ;
		
		// gĂȂԂɂ
		ExplodeUnion->Anime[ExplodeUnion->NextUseID].UseFlag = FALSE ;
	}
	
	// hcԂ
	return ExplodeUnion->NextUseID ;
}

// whc̔Aj[Vf[^𓾂
EXPLODEANIME *GetExplodeAnim( u8 AnimeID )
{
	EXPLODEUNION *ExplodeUnion = &ExpUnion ;

	// AhXԂ
	return &ExplodeUnion->Anime[AnimeID] ;
}
	


// GtFNg̋ʃf[^
extern s8 InitExplodeData( void )
{
	EXPLODEUNION *ExplodeUnion = &ExpUnion ;
	s32 i/*, hr*/ ;
	
	MEMINIT( ExpUnion ) ;
	
	// A[JCuǂݍ
	ExpUnion.ModelArc = WK7Archive::Create() ;
//	ExpUnion.ModelArc->LoadArchive( ANIME_FILENAME ) ;
	ExpUnion.ModelArc->LoadArchive( EffSys.PackFile->GetGroup()->GetGroup( STDAT_EXPLODE )->GetResource( STDAT_EXP_MOTION ) ) ;
	ExpUnion.ModelArc->SetStatic( true ) ;

	// eNX`̓ǂݍ	
	for( i = 0 ; i < ANIMENUM ; i ++ )
		TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_EXPLODE )->GetResource( STDAT_EXP_00 + i ), &ExpUnion.TestRgbTex[i] ) ;
//	{
//		hr = TexLoad2( TextureName[i], &ExpUnion.TestAlphaTex[i], &ExpUnion.TestRgbTex[i], &ExpUnion.TexFileTestAlpha[i], &ExpUnion.TexFileTestRgb[i] ) ;
//	}

	// I
	return 0 ;
}

// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckExplodeData( void )
{
	// A[JCu܂ǂݍݏIĂȂ牽I
//	if( CHKARCLOAD( ExpUnion.ModelArc ) == FALSE ) return FALSE ;
	
	// eNX`ׂēǂݏIĂȂ牽I
//	for( s32 i = 0 ; i < MAX_ANIMENUM ; i ++ )
//		if( CHKFILELOAD( ExpUnion.TexFileTestRgb[i] ) == FALSE ||
//			CHKFILELOAD( ExpUnion.TexFileTestAlpha[i] ) == FALSE ) return FALSE ;
			
	return TRUE ;
}
	


// GtFNg̋ʃf[^n
extern s8 EndExplodeData( void )
{
	EXPLODEUNION *ExplodeUnion = &ExpUnion ;
	u32 i ;

	// eNX`̃J
	for( i = 0 ; i < ANIMENUM ; i ++ )
		TexRelease( &ExpUnion.TestRgbTex[i] ) ;
//	{
//		CLOSECHK( ExpUnion.TexFileTestRgb[i] ) ;
//		CLOSECHK( ExpUnion.TexFileTestAlpha[i] ) ;
//		ghmGcMemFree( ExpUnion.TestRgbTex[i].Header ) ;
//		ghmGcMemFree( ExpUnion.TestAlphaTex[i].Header ) ;
//	}
	
	// A[JCu폜
	DELCHK( ExpUnion.ModelArc ) ;

	// I
	return 0 ;
}



#define SMEXPDEF_NUM		5
static SMEXPDEF SmExpTable[SMEXPDEF_NUM] =
{
//		Length			Num			Size	ASize	
	{	2998.952F/*27.0F*/,			0.2115F,	1.0F,	0.7142F	},
	{	1462.091F/*55.0F*/,			0.3557F,	1.0F,	0.8571F	},
	{	1131.511F/*71.0F*/,			0.4423F,	1.0F,	1.0F	},
	{	882.502F/*91.0F*/,			0.6923F,	1.0F,	1.0F	},
	{	663.514F/*121.0F*/,			1.0F,		1.0F,	1.0F	}
} ;

const u16 _SmokeExpTable[][30] = 
{
// d
{	110,	140,	214,	70,		80,
	94,		111,	140,	215,		0,

	0,		0,		3,		12,		5,
	21,		104,	5,		7,		25,

	25,		90,		134,	0,		0,
	1,		1,		0,		0,		0 },
} ;



// GtFNg쐬
extern EFFECT *CreateSmokeExplodeEffect( Vec Point, f32 Size, u8 ExplodeTypeNumber, u32 Color, EFFECT **Effect1, EFFECT **Effect2 )
{
	GXColor Color1, Color2, Color3, Color4 ;
	SMEXPDEF TBDef ;
	EFFECT *eff1, *eff2 ;
	
	// 𑪂ăp[^
	GetSmokeExDef( Point, &TBDef ) ;
	
	eff1 = eff2 = NULL ;

	switch( ExplodeTypeNumber ) 
	{
	case 4 :		// MSK_SPARK
		{
			u16 *tb = (u16 *)_SmokeExpTable[0] ;
			
			// F̃Zbg
			if( Color != 0 )
			{
				Color1 = *((GXColor *)&Color) ;
				Color2 = *((GXColor *)&Color) ;
				Color3 = *((GXColor *)&Color) ;
			}
			else
			{
				*((u32 *)&Color1) = CMK( tb[0],tb[1],tb[2], 255 ) ;
				*((u32 *)&Color2) = CMK( tb[3],tb[4],tb[5], 255 ) ;
				*((u32 *)&Color3) = CMK( tb[6],tb[7],tb[8], 255 ) ;
			}

			// grGtFNg쐬
			if( tb[23] )
			{
				eff1 = CreateHSExplodeEffect2( Point, Size,
											(u8)tb[9], 0, (u8)tb[10],
											(u8)tb[11], 0,
											0, tb[13], 0.0F,
											(GXColor){0,0,0,0},(GXColor){0,0,0,0},(GXColor){0,0,0,0},
											(u16)( tb[15] * TBDef.Size ), (u8)tb[17], (u16)( tb[16] * TBDef.Num ), (u16)( tb[18] * TBDef.ASize ),
											tb[19], tb[20], 161,
											(u8)tb[14], (u8)tb[12],
											TRUE, FALSE, TRUE, TRUE, FALSE, FALSE,
											FALSE, 1.0F,
											FALSE, 0,
											Color1, Color2, Color3, 0 ) ;
			}
			eff2 = CreateHSExplodeEffect2( Point, Size,
											(u8)tb[9], 0, (u8)tb[10],
											(u8)tb[11], 0,
											0, tb[13], 0.0F,
											Color1, Color2, Color3,
											(u16)( tb[15] * TBDef.Size ), (u8)tb[17], (u16)( tb[16] * TBDef.Num ), (u16)( tb[18] * TBDef.ASize ),
											tb[19], tb[20], 161,
											(u8)tb[14], (u8)tb[12],
											(u8)tb[25], FALSE, (u8)tb[26], (u8)tb[24], FALSE, FALSE,
											TRUE, 1.0F,
											FALSE, 0,
											Color1, Color2, Color3, 0 ) ;
		}
		break ;
		
	case 0 :		// MSK_NORMAL
		// F̃Zbg
		if( Color != 0 )
		{
			Color1 = *((GXColor *)&Color) ;
			Color2 = *((GXColor *)&Color) ;
			Color3 = *((GXColor *)&Color) ;
		}
		else
		{
			*((u32 *)&Color1) = CMK( PR1[0],PR1[1],PR1[2], 255 ) ;
			*((u32 *)&Color2) = CMK( PR1[3],PR1[4],PR1[5], 255 ) ;
			*((u32 *)&Color3) = CMK( PR1[6],PR1[7],PR1[8], 255 ) ;
		}
	
		// grGtFNg쐬
		if( PR1[23] )
		{
//			SetHSExplodeEffectSmokeAreaSize( PR1[27] * 0.01F ) ;
			SetHSExplodeEffectSmokeAlphaX4Flag() ;
			eff1 = CreateHSExplodeEffect2( Point, Size,
										(u8)PR1[9], 0, (u8)PR1[10],
										(u8)PR1[11], 0,
										0, PR1[13], 0.0F,
										(GXColor){0,0,0,0},(GXColor){0,0,0,0},(GXColor){0,0,0,0},
	#ifdef __SMOKE_LENGTH_REVISE
										(u16)( PR1[15] * TBDef.Size ), (u8)PR1[17], (u16)( PR1[16] * TBDef.Num ), (u16)( PR1[18] * TBDef.ASize * PR1[29] * 0.01F ),
	#else
										PR1[15], (u8)PR1[17], PR1[16], PR1[18],
	#endif
										PR1[19], PR1[20], 255,
										(u8)PR1[14], (u8)PR1[12],
										TRUE, FALSE, TRUE, TRUE, FALSE, FALSE,
										FALSE, 0.0F,
										FALSE, 0,
										Color1, Color2, Color3, 0 ) ;
		}
		SetHSExplodeEffectSmokeAlphaX4Flag() ;
		eff2 = CreateHSExplodeEffect2( Point, Size,
										(u8)PR1[9], 0, (u8)PR1[10],
										(u8)PR1[11], 0,
										0, PR1[13], 0.0F,
										Color1, Color2, Color3,
#ifdef __SMOKE_LENGTH_REVISE
										(u16)( PR1[15] * TBDef.Size ), (u8)PR1[17], (u16)( PR1[16] * TBDef.Num ), (u16)( PR1[18] * TBDef.ASize ),
#else
										PR1[15], (u8)PR1[17], PR1[16], PR1[18],
#endif
										PR1[19], PR1[20], (u8)PR1[28],
										(u8)PR1[14], (u8)PR1[12],
										(u8)PR1[25], FALSE, (u8)PR1[26], (u8)PR1[24], FALSE, FALSE,
										TRUE, PR1[27] * 0.01F,
										FALSE, 0,
										Color1, Color2, Color3, 0 ) ;
		break ;
										
	case 1 :
	
		// F̃Zbg
		Color1.r = (u8)PR2[0] ;
		Color1.g = (u8)PR2[1] ;
		Color1.b = (u8)PR2[2] ;
		
		Color2.r = (u8)PR2[3] ;
		Color2.g = (u8)PR2[4] ;
		Color2.b = (u8)PR2[5] ;
		
		Color3.r = (u8)PR2[6] ;
		Color3.g = (u8)PR2[7] ;
		Color3.b = (u8)PR2[8] ;
		
		Color4.r = (u8)PR2[23] ;
		Color4.g = (u8)PR2[23] ;
		Color4.b = (u8)PR2[23] ;

		eff1 = CreateHSExplodeEffect2( Point, Size,
										(u8)PR2[9], 0, (u8)PR2[10],
										(u8)PR2[11], 0,
										0, 12/*PR2[13]*/, 0.0F,
										Color1, Color2, Color3,
#ifdef __SMOKE_LENGTH_REVISE
										(u16)( PR2[15] * TBDef.Size ), (u8)PR2[17], (u16)( PR2[16] * TBDef.Num ), (u16)( PR2[18] * TBDef.ASize ),
#else
										PR2[15], (u8)PR2[17], PR2[16], PR2[18],
#endif
										PR2[19], PR2[20], (u8)PR2[13],
										(u8)PR2[14], (u8)PR2[12],
	//									TRUE, FALSE, TRUE, TRUE, FALSE, FALSE,
										FALSE, FALSE, TRUE, FALSE, FALSE, FALSE,
										TRUE, PR2[21] * 0.01F,
										TRUE, (u8)PR2[22],
										Color4, Color4, Color4, 0,
										100 ) ;
		 break ;
		 
	case 2 :			// 쐬
		// F̃Zbg
		Color1.r = (u8)PR1[0] ;
		Color1.g = (u8)PR1[1] ;
		Color1.b = (u8)PR1[2] ;
		
		Color2.r = (u8)PR1[3] ;
		Color2.g = (u8)PR1[4] ;
		Color2.b = (u8)PR1[5] ;
		
		Color3.r = (u8)PR1[6] ;
		Color3.g = (u8)PR1[7] ;
		Color3.b = (u8)PR1[8] ;
		
		// hʔjGtFNg쐬
		eff1 = CreateHSExplodeEffect2( Point, Size,
									(u8)PR1[9], 0, (u8)PR1[10],
									(u8)PR1[11], 0,
									0, PR1[13], 0.0F,
									(GXColor){0,0,0,0},(GXColor){0,0,0,0},(GXColor){0,0,0,0},
									(u16)( PR1[15] * TBDef.Size ), (u8)PR1[17], (u16)( PR1[16] * TBDef.Num ), (u16)( PR1[18] * TBDef.ASize ),
									70, 60, 161,
									(u8)PR1[14], (u8)PR1[12],
									TRUE, FALSE, TRUE, TRUE, FALSE, FALSE,
									FALSE, 1.0F,
									FALSE, 0,
									Color1, Color2, Color3, 0 ) ;
		eff2 = CreateHSExplodeEffect2( Point, Size,
										(u8)PR1[9], 0, (u8)PR1[10],
										(u8)PR1[11], 0,
										0, PR1[13], 0.0F,
										Color1, Color2, Color3,
										(u16)( PR1[15] * TBDef.Size ), (u8)PR1[17], (u16)( PR1[16] * TBDef.Num ), (u16)( PR1[18] * TBDef.ASize ),
										70, 60, 161,
										(u8)PR1[14], (u8)PR1[12],
										TRUE, FALSE, TRUE, TRUE, FALSE, FALSE,
										TRUE, 1.0F,
										FALSE, 0,
										Color1, Color2, Color3, 0 ) ;
		break ;

	case 3 :
		// F̃Zbg
		Color1.r = (u8)VParam[ED_KUNSMOKE][0] ;
		Color1.g = (u8)VParam[ED_KUNSMOKE][1] ;
		Color1.b = (u8)VParam[ED_KUNSMOKE][2] ;
		
		Color2.r = (u8)VParam[ED_KUNSMOKE][3] ;
		Color2.g = (u8)VParam[ED_KUNSMOKE][4] ;
		Color2.b = (u8)VParam[ED_KUNSMOKE][5] ;
		
		Color3.r = (u8)VParam[ED_KUNSMOKE][6] ;
		Color3.g = (u8)VParam[ED_KUNSMOKE][7] ;
		Color3.b = (u8)VParam[ED_KUNSMOKE][8] ;
		
		Color4.r = (u8)VParam[ED_KUNSMOKE][23] ;
		Color4.g = (u8)VParam[ED_KUNSMOKE][23] ;
		Color4.b = (u8)VParam[ED_KUNSMOKE][23] ;
		
		eff1 = CreateHSExplodeEffect2( Point, Size,
										(u8)VParam[ED_KUNSMOKE][9], 0, (u8)VParam[ED_KUNSMOKE][10],
										(u8)VParam[ED_KUNSMOKE][11], 0,
										0, 12/*VParam[ED_KUNSMOKE][13]*/, 0.0F,
										Color1, Color2, Color3,
#ifdef __SMOKE_LENGTH_REVISE
										(u16)( VParam[ED_KUNSMOKE][15] * TBDef.Size ), (u8)VParam[ED_KUNSMOKE][17], (u16)( VParam[ED_KUNSMOKE][16] * TBDef.Num ), (u16)( VParam[ED_KUNSMOKE][18] * TBDef.ASize ),
#else
										VParam[ED_KUNSMOKE][15], (u8)VParam[ED_KUNSMOKE][17], VParam[ED_KUNSMOKE][16], VParam[ED_KUNSMOKE][18],
#endif
										VParam[ED_KUNSMOKE][19], VParam[ED_KUNSMOKE][20], (u8)VParam[ED_KUNSMOKE][13],
										(u8)VParam[ED_KUNSMOKE][14], (u8)VParam[ED_KUNSMOKE][12],
	//									TRUE, FALSE, TRUE, TRUE, FALSE, FALSE,
										FALSE, FALSE, TRUE, FALSE, FALSE, FALSE,
										TRUE, VParam[ED_KUNSMOKE][21] * 0.01F,
										TRUE, (u8)VParam[ED_KUNSMOKE][22],
										Color4, Color4, Color4, 0,
										100 ) ;
		 break ;
	
	}
	
	if( Effect1 != NULL ) *Effect1 = eff1 ;
	if( Effect2 != NULL ) *Effect2 = eff2 ;
	
	// I
	return 0 ;
}			
	


// GtFNg쐬
extern EFFECT *CreateExplodeEffect( Vec Point, f32 Size, u8 BomAnimFlag, s32 Priority )
{
	EFFECT *Effect ;
	EXPLODEEFFECT *ExplodeP ;
	
	// 풓f[^ǂݍݏIĂȂ牽I
	if( CheckExplodeData() == FALSE ) return 0 ;

	// Vf[^쐬
	Effect = AddEffectData( EFF_EXPLODE, (void**)&ExplodeP, Priority ) ;
	if( Effect == NULL ) return NULL ;
	ExplodeP->TopObj = NULL ;
	ExplodeP->Anim = NULL ;
	ExplodeP->Model = NULL ;
	ExplodeP->BomAnimFlag = BomAnimFlag ;
	
	// Aj[Vf[^𓾂
	ExplodeP->Model = ExpUnion.ModelArc->CreateModel() ;
	if( ExplodeP->Model == NULL ){ DeleteEffect( Effect ) ; return NULL ; }
	ExplodeP->Anim = ExpUnion.ModelArc->CreateModelMotion() ;
	if( ExplodeP->Anim == NULL ){ DeleteEffect( Effect ) ; return NULL ; }
	ExplodeP->TopObj = ExplodeP->Model->GetObj(0) ;
	if( ExplodeP->TopObj == NULL ){ DeleteEffect( Effect ) ; return NULL ; }
	
	// [V̍Đn߂
	{
		WK7JObj *ExplodeModel ;
		HSD_AnimJoint *ExplodeAnime ;
		s8 hr ;
		
		ExplodeModel = ExplodeP->TopObj ;
		hr = ExplodeP->Anim->GetAnimJoint( ExplodeModel->GetName(), &ExplodeAnime ) ;
		ExplodeModel->DetachMotion() ;
		ExplodeModel->AttachMotion( ExplodeAnime ) ;
		ExplodeModel->SetMotionLoop( false ) ;
		ExplodeModel->PlayMotion( 0.0F ) ;
		ExplodeModel->SetMotionRate( 1.0F ) ;
		ExplodeModel->FrameProcess() ;
		
		// tbVGtFNgf[^쐬
		CreateFlashEffect( FALSE, Point, Size * ExplodeModel->GetJObj()->scale.x * 6, (GXColor){130,110,60,255}, 1, 8, FALSE, Priority + 2 ) ; 
		CreateFlashEffect( FALSE, Point, Size * ExplodeModel->GetJObj()->scale.x * 6, (GXColor){100,80,45,255}, 1, 8, TRUE, Priority + 3 ) ; 
	}
						
	// f[^
	ExplodeP->Size = Size ;
	ExplodeP->Point = Point ;
	ExplodeP->Counter = 0 ;

	// I
	return Effect ;
}

// GtFNǧns
extern s8 ReleaseExplodeEffect( EFFECT *Effect )
{
	EXPLODEEFFECT *ExplodeEffect = ( EXPLODEEFFECT * )Effect->Data ;
	
	// ff[^폜
	if( ExplodeEffect->Model != NULL )
		delete ExplodeEffect->Model ;
	
	// Aj[Vf[^폜
	if( ExplodeEffect->Anim != NULL )
		delete ExplodeEffect->Anim ;

	// I
	return 0 ;
}

// GtFNgPt[
extern s8 MoveExplodeEffect( EFFECT *Effect )
{
	EXPLODEEFFECT *ExplodeEffect = ( EXPLODEEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// ɂ邱ƂȂ	
	ExplodeEffect->Counter ++ ;

	// Aj[VII
	if( ExplodeEffect->Model->GetMotionState() == WK7MODEL_NOANIM )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	else
	{
		// ff[^Pt[
		ExplodeEffect->TopObj->FrameProcess() ;
	}

	// I
	return 0 ;
}

// GtFNg`悷
extern s8 DrawExplodeEffect( EFFECT *Effect )
{
	EXPLODEEFFECT *ExplodeEffect = ( EXPLODEEFFECT * )Effect->Data ;
	u16 Color ;
	EXPLODEUNION *ExplodeUnion = &ExpUnion ;
	HSD_JObj *JObj ;
	
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;		// `̏
								
	JObj = ExplodeEffect->TopObj->GetJObj() ;		// HSD_JObj 𓾂
	HSD_JObjSetupMatrix( JObj ) ;					// ZbgAbv

	GXSetAlphaCompare( GX_GREATER, 20, GX_AOP_AND, GX_ALWAYS, 0);				// J[̐ݒ
	GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY ) ;	// eNX`Wݒ
	GXSetTexCoordGen( GX_TEXCOORD1, GX_TG_MTX2x4, GX_TG_TEX1, GX_IDENTITY ) ;
	GXSetTevOp(GX_TEVSTAGE0, GX_REPLACE );										// TEVݒ
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_U16, UVSHFTBIT ) ;	// _tH[}bg̃Zbg
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX1, GX_TEX_ST, GX_U16, UVSHFTBIT ) ;

	// GXFIFOɓnf[^̃Zbg	
    GXClearVtxDesc();
	GXSetVtxDesc(GX_VA_POS, GX_DIRECT) ;
	GXSetVtxDesc(GX_VA_CLR0, GX_DIRECT) ;
	GXSetVtxDesc(GX_VA_TEX0, GX_DIRECT) ;
	GXSetVtxDesc(GX_VA_TEX1, GX_DIRECT) ;

	// eNX`̃[h
	f32 NumberFloat = JObj->rotate.y * 360 / ( PI * 2 ) + 0.1F ;
	u32 Number = (u16)NumberFloat ;
	GTLOAD2( ExplodeUnion->TestRgbTex[Number] ) ;

	Color = GXPackedRGBA4( 255, 255, 255, 255 ) ;

	// r{[hꖇ`
	if( ( JObj->flags & JOBJ_HIDDEN ) == 0 )
	{
		Mtx Mtemp ;
		Vec p[4], move ;
		f32 r ;

		// r[s̓]ns𓾂
		EffectGetInvViewMatrix( Mtemp ) ;
		
		// _Zbg
		r = JObj->scale.x * ExplodeEffect->Size / 2.0F ;
		p[0].x = -r ;	p[0].y = r ;	p[0].z = 0.0F ;
		p[1].x = r ;	p[1].y = r ;	p[1].z = 0.0F ;
		p[2].x = r ;	p[2].y = -r ;	p[2].z = 0.0F ;
		p[3].x = -r ;	p[3].y = -r ;	p[3].z = 0.0F ;
		
		// ړlZo
		if( ExplodeEffect->BomAnimFlag > 0 )
		{
			move.x = ExplodeEffect->Point.x + JObj->mtx[0][3] * r ;
			move.y = ExplodeEffect->Point.y + JObj->mtx[1][3] * r ;
			move.z = ExplodeEffect->Point.z + JObj->mtx[2][3] * r ;
		}
		else
		{
			move.x = ExplodeEffect->Point.x /*+ JObj->mtx[0][3] * r*/ ;
			move.y = ExplodeEffect->Point.y /*+ JObj->mtx[1][3] * r*/ ;
			move.z = ExplodeEffect->Point.z /*+ JObj->mtx[2][3] * r*/ ;
		}
		
		// _]
		MTXMultVec( Mtemp, &p[0], &p[0] ) ;
		MTXMultVec( Mtemp, &p[1], &p[1] ) ;
		MTXMultVec( Mtemp, &p[2], &p[2] ) ;
		MTXMultVec( Mtemp, &p[3], &p[3] ) ;

		GXSetZMode( GX_TRUE, GX_LEQUAL, GX_ENABLE ) ;					// Zobt@̓샂[hݒ肷
		GXSetAlphaCompare( GX_GEQUAL, 253, GX_AOP_AND, GX_ALWAYS, 0 ) ;	// At@l̃Zbg
	
		// `
		GXBegin( GX_QUADS, GX_VTXFMT0, 4 ) ;
		{
			GP3( p[0].x + move.x, p[0].y + move.y, p[0].z + move.z ) ;
			GCX( 0xffffffff ) ; 
			GT2( 0, 0 ) ;				GT2( 0, 0 ) ;
			
			GP3( p[1].x + move.x, p[1].y + move.y, p[1].z + move.z ) ;
			GCX( 0xffffffff ) ; 
			GT2( UVSCALE, 0 ) ;			GT2( UVSCALE, 0 ) ;
			
			GP3( p[2].x + move.x, p[2].y + move.y, p[2].z + move.z ) ;
			GCX( 0xffffffff ) ; 
			GT2( UVSCALE, UVSCALE ) ;	GT2( UVSCALE, UVSCALE ) ;
		
			GP3( p[3].x + move.x, p[3].y + move.y, p[3].z + move.z ) ;
			GCX( 0xffffffff ) ; 
			GT2( 0, UVSCALE ) ;			GT2( 0, UVSCALE ) ;
		}
		GXEnd() ;
		
		GXSetZMode( GX_TRUE, GX_LEQUAL, GX_DISABLE ) ;					// Zobt@̓샂[hݒ肷
		GXSetAlphaCompare( GX_LESS, 253, GX_AOP_AND, GX_ALWAYS, 0 ) ;	// At@l̃Zbg

		// `
		GXBegin( GX_QUADS, GX_VTXFMT0, 4 ) ;
		{
			GP3( p[0].x + move.x, p[0].y + move.y, p[0].z + move.z ) ;
			GCX( 0xffffffff ) ; 
			GT2( 0, 0 ) ;				GT2( 0, 0 ) ;
			
			GP3( p[1].x + move.x, p[1].y + move.y, p[1].z + move.z ) ;
			GCX( 0xffffffff ) ; 
			GT2( UVSCALE, 0 ) ;			GT2( UVSCALE, 0 ) ;
			
			GP3( p[2].x + move.x, p[2].y + move.y, p[2].z + move.z ) ;
			GCX( 0xffffffff ) ; 
			GT2( UVSCALE, UVSCALE ) ;	GT2( UVSCALE, UVSCALE ) ;
		
			GP3( p[3].x + move.x, p[3].y + move.y, p[3].z + move.z ) ;
			GCX( 0xffffffff ) ; 
			GT2( 0, UVSCALE ) ;			GT2( 0, UVSCALE ) ;
		}
		GXEnd() ;
	}
	
	// I
	return 0 ;
}					

extern s8 GetSmokeExDef( Vec Pos, SMEXPDEF *buf )
{
	Vec BPoint ;
	f32 /*Length,*/size,  f ;
	s32 i ;

	BPoint = Pos ;
	
	size = GetScreenSize( &BPoint, 100.0F ) ;
	
	// ǂ̃e[uɓ邩o
	for( i = 0 ; i < SMEXPDEF_NUM && size < SmExpTable[i].Length ; i ++ ){}

	{
		f32 size, Length ;
		Vec CPoint ;

		HSD_CObjGetEyePosition( GetEffectCamera(), &CPoint ) ;
		Length = sqrt( VECSquareDistance( &BPoint, &CPoint ) ) ;

		size = GetScreenSize( &BPoint, 100.0F ) ;
#ifdef YAMADADEBUG
		OSReport( "length:%.3f  size:%.3f  ind:%d\n", Length, size, i ) ;
#endif
	}
	
	if( i == SMEXPDEF_NUM )
	{
		*buf = SmExpTable[i-1] ;
	}
	else
	if( i == 0 )
	{
		*buf = SmExpTable[0] ;
	}
	else
	{
		SMEXPDEF *BDef1, *BDef2 ;
		
		BDef2 = &SmExpTable[i] ;
		BDef1 = &SmExpTable[i-1] ;
		
		f = ( size - BDef2->Length ) / ( BDef1->Length - BDef2->Length + 0.01F ) ;
		buf->Num = 		( 1.0F - f ) * BDef2->Num 	+ f * BDef1->Num ;
		buf->Size = 	( 1.0F - f ) * BDef2->Size 	+ f * BDef1->Size ;
		buf->ASize = 	( 1.0F - f ) * BDef2->ASize	+ f * BDef1->ASize ;
	}
	
	return 0 ;
}






