///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectFlash2
//
// YK7EffectFlash2.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 02/02/2004
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectFlash2.h"

// define ---------------------------------------

#define POLYDIVNUM 10

// data -----------------------------------------

FLASH2UNION fl2u ;

// datatype -------------------------------------

// function code --------------------------------

// tbVQGtFNg̋ʃf[^
extern s8 InitFlash2Data( void )
{
	MEMINIT( fl2u ) ;
	
	fl2u.Flash2Valid = true ;	
	fl2u.Flash2Wait = (u8)VParam[ED_FLASH2][15] ;
	fl2u.Flash2Color = CMK( VParam[ED_FLASH2][18], VParam[ED_FLASH2][19], VParam[ED_FLASH2][20], VParam[ED_FLASH2][21] ) ;

	return 0 ;
}

// tbVQGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckFlash2Data( void )
{
	return TRUE ;
}

// tbVQGtFNg̋ʃf[^n
extern s8 EndFlash2Data( void )
{
	MEMINIT( fl2u ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// tbVQGtFNg쐬
extern EFFECT *CreateFlash2Effect( 	Vec Pos,							// 钆S_
									f32 Wait,							// oԊu
									f32 Length,							// 

									f32 MaxWidth, f32 MinWidth,			// ̍ő̕ƍŏ̕
									GXColor Color,						// F
									s32 Priority )
{
	EFFECT *Effect ;
	FLASH2EFFECT *Fl ;
	
	// VtbVQf[^쐬
	Effect = AddEffectData( EFF_FLASH2, (void**)&Fl, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	// tbVQf[^
	Fl->Pos = Pos ;
	Fl->ObjNum = 0 ;
	Fl->Wait = Wait ;
	Fl->Counter = Wait ;
	Fl->Length = Length ;
	Fl->MaxWidth = MaxWidth ;
	Fl->MinWidth = MinWidth ;
	Fl->Color = Color ;
	Fl->Fl1Width = 0 ;
	Fl->a = 1.0F; 
	
	Fl->Flash2Valid = fl2u.Flash2Valid ;
	Fl->Flash2Wait = fl2u.Flash2Wait ;
	Fl->FlCounter = 0 ;
	Fl->Fl2Width = 0.0F ;
	Fl->Fl2Color = fl2u.Flash2Color ;
	fl2u.Flash2Valid = true ;
	fl2u.Flash2Wait = (u8)VParam[ED_FLASH2][15] ;
	fl2u.Flash2Color = CMK( VParam[ED_FLASH2][18], VParam[ED_FLASH2][19], VParam[ED_FLASH2][20], VParam[ED_FLASH2][21] ) ;


	// I
	return Effect ;
}

// tbVQGtFNǧns
extern s8 ReleaseFlash2Effect( EFFECT *Effect )
{
	FLASH2EFFECT *Flash2Effect = ( FLASH2EFFECT * )Effect->Data ;

	// ɂ邱ƂȂ

	// I
	return 0 ;
}

// tbVQGtFNgPt[
extern s8 MoveFlash2Effect( EFFECT *Effect )
{
	FLASH2EFFECT *Fl = ( FLASH2EFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂ폜
/*	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
*/

	Fl->FlCounter ++ ;
	if( Fl->FlCounter > Fl->Flash2Wait && Fl->Flash2Valid == true )
	{
		Fl->Fl2Width += VParam[ED_FLASH2][16] ;
	}

	Fl->Fl1Width += VParam[ED_FLASH2][8] ;
		
	if( Effect->DelReqFlag == FALSE )
	{
		// ڏ
		Fl->Counter += 1.0F ;
		while( Fl->Counter >= Fl->Wait && Fl->ObjNum < FLASH2_DIRMAXNUM )
		{
			FLASH2OBJ *ob ;
		
			// ǉ
			ob = &Fl->Obj[Fl->ObjNum] ;

			ob->xzrot = rand() * PI_2 / RAND_MAX ;
			ob->oirrot = rand() * PI / RAND_MAX - PI / 2.0F ;
			ob->Width = rand() * ( Fl->MaxWidth - Fl->MinWidth ) / RAND_MAX + Fl->MinWidth ;
			
			Fl->ObjNum ++ ;
			Fl->Counter -= Fl->Wait ;
		}
	}
	else
	{
		Fl->a -= VParam[ED_FLASH2][12] * 0.01F ;
		if( Fl->a < 0.0F )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
	}

	// I
	return 0 ;
}

// tbVQGtFNg`悷
extern s8 DrawFlash2Effect( EFFECT *Effect )
{
	FLASH2EFFECT *Fl = ( FLASH2EFFECT * )Effect->Data ;
	FLASH2OBJ *ob ; 
	s32 i, j ;
	Vec p ;
	f32 w, f, Sin, Cos ;
	u32 drawnum, divnum, drawnum2 ;

	// IuWFNg牽Ȃ
	if( Fl->ObjNum == 0 ) return 0 ;

	// ׂẴIuWFNg

	// `̏
	if( Effect->DelReqFlag == FALSE )
	{
		EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ADD, EF_TEV_NOTEX ) ;

		ob = Fl->Obj ;
		for( i = 0 ; i < Fl->ObjNum ; i ++, ob ++ )
		{
			// ~̑Zbg
			w = /*ob->Width **/ Fl->Length ;
		
			// `Jn
//			if( rand() * 100 / RAND_MAX > VParam[ED_FLASH2][22] )
			ob->Brink = (u8)( ob->Brink == 1 ? 0 : 1 ) ;
			if( ob->Brink == 1 )
			{
				GXBegin( GX_TRIANGLEFAN, GX_VTXFMT0, (u16)( POLYDIVNUM + 1 ) ) ;
				{
					// ŏ̒_o
					GPV( Fl->Pos ) ;
					GC4( Fl->Color.r, Fl->Color.g, Fl->Color.b, (u8)( Fl->Color.a * Fl->a ) ) ;
					
					// ̒_o
					for( j = 0 ; j < POLYDIVNUM ; j ++ )
					{
						p.z = COSF( PI_2 / ( POLYDIVNUM - 1 ) * j ) * ob->Width ;
						p.y = SINF( PI_2 / ( POLYDIVNUM - 1 ) * j ) * ob->Width ;
						p.x = w ;

						Sin = SINF( ob->oirrot ) ;	Cos = COSF( ob->oirrot ) ;
						f = p.x * Cos - p.y * Sin ;
						p.y = p.x * Sin + p.y * Cos ;
						p.x = f ;
						
						Sin = SINF( ob->xzrot ) ;	Cos = COSF( ob->xzrot ) ;
						f = p.x * Cos - p.z * Sin ;
						p.z = p.x * Sin + p.z * Cos ;
						p.x = f ;
						
						GP3( Fl->Pos.x + p.x, Fl->Pos.y + p.y, Fl->Pos.z + p.z ) ;
						GC4( Fl->Color.r, Fl->Color.g, Fl->Color.b, (u8)( 0/*Fl->Color.a * Fl->a*/ ) ) ;
					}
				}
				GXEnd() ;
			}
		}
	}

	// `̏
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ADD, EF_TEV_NOTEX ) ;

	if( VParam[ED_FLASH2][13] == 0 ) VParam[ED_FLASH2][13] = 1 ;
	drawnum = VParam[ED_FLASH2][13] ;

	if( VParam[ED_FLASH2][17] == 0 ) VParam[ED_FLASH2][17] = 1 ;
	drawnum2 = VParam[ED_FLASH2][17] ;
	if( Fl->Flash2Valid == FALSE || Fl->Fl2Width == 0.0F ) drawnum2 = 0 ;

	if( VParam[ED_FLASH2][14] < 3 ) VParam[ED_FLASH2][14] = 3 ;
	divnum = VParam[ED_FLASH2][14] ;

	GBGN( GX_TRIANGLEFAN, ( divnum + 1 ) * ( drawnum + drawnum2 ) ) ;
	{
		Vec Pos ;
		f32 Size ;
		
		GetScreenPosition( &Fl->Pos, &Pos ) ;

		for( j = 0 ; j < drawnum ; j ++ )
		{
			GP2( Pos.x, Pos.y ) ;
			GC4( Fl->Color.r, Fl->Color.g, Fl->Color.b, (u8)( Fl->Color.a * Fl->a ) ) ;

			Size = GetScreenSize( &Fl->Pos, Fl->Fl1Width ) ;

			for( i = 0 ; i < divnum ; i ++ )	
			{
				GP2( 	Pos.x + COSF( PI_2 / ( divnum - 1 ) * i ) * Size,
						Pos.y + SINF( PI_2 / ( divnum - 1 ) * i ) * Size ) ;
				GC4( 0, 0, 0, (u8)( Fl->Color.a * Fl->a ) ) ;
			}
		}

		for( j = 0 ; j < drawnum2 ; j ++ )
		{
			GP2( Pos.x, Pos.y ) ;
			GCX( CMKC2( Fl->Fl2Color, ( Fl->Fl2Color & 0xff ) * Fl->a ) ) ;

			Size = GetScreenSize( &Fl->Pos, Fl->Fl2Width ) ;

			for( i = 0 ; i < divnum ; i ++ )	
			{
				GP2( 	Pos.x + COSF( PI_2 / ( divnum - 1 ) * i ) * Size,
						Pos.y + SINF( PI_2 / ( divnum - 1 ) * i ) * Size ) ;
				GC4( 0, 0, 0, (u8)( Fl->Color.a * Fl->a ) ) ;
			}
		}
	}
	GXEnd() ;


	// I
	return 0 ;
}					


// Q̃tbṼZbgAbv
extern s8 Flash2EffectFlash2Setup( bool Valid, u8 Wait, u32 Color )
{
	fl2u.Flash2Valid = Valid ;
	fl2u.Flash2Wait = Wait ;
	fl2u.Flash2Color = Color ;

	return 0 ;
}



