///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectFlyBullet
//
// YK7EffectFlyBullet.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 07/16/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTFlyBullet_H
#define __YK7EFFECTFlyBullet_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// eGtFNgʃf[^
typedef struct tagFLYBULLETUNION
{
	TEXDATA DebrisTex ;
} FLYBULLETUNION ;

// eGtFNgf[^
typedef struct tagFLYBULLETEFFECT
{
	u8 Dummy ;
} FLYBULLETEFFECT ;

// eGtFNg^XNɓnf[^
typedef struct tagFLYBULLETEFFECTTACKPARAM
{
	Vec Point ;					// W
	GXColor Color ;				// ǂ̐F
	f32 Power ;					// j
	f32 Gravity ;				// d
	f32 YukaY ;					// ̍
} FLYBULLETEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitFlyBulletData( void ) ;				// eGtFNg̋ʃf[^
extern s8 CheckFlyBulletData( void ) ;				// eGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndFlyBulletData( void ) ;				// eGtFNg̋ʃf[^n

extern EFFECT *CreateFlyBulletEffect(
								 Vec		Point,
								 GXColor	Color,
								 f32 		Power 		= 2.5F,
								 f32 		Gravity 	= 2.1F,
								 f32 		YukaY 		= 0.0F,
								 f32 		Bias 		= 1.0F,
								 u32		FlashColor	= CMK( 255, 255, 128, 200 ),
								 s32 		Priority = -1 ) ;	// eGtFNg쐬
extern s8 ReleaseFlyBulletEffect( EFFECT *Effect ) ;							// eGtFNǧns
extern s8 MoveFlyBulletEffect( EFFECT *Effect ) ;								// eGtFNgPt[
extern s8 DrawFlyBulletEffect( EFFECT *Effect ) ;								// eGtFNg`悷

#endif