///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectImpact
//
// YK7EffectImpact.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/09/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTIMPACT_H
#define __YK7EFFECTIMPACT_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// ʗhGtFNgʃf[^
typedef struct tagIMPACTUNION
{
	u8 Dummy ;
} IMPACTUNION ;

// ʗhGtFNgf[^
typedef struct tagIMPACTEFFECT
{
	f32 MaxImpact ;				// h̍őp[
	f32 MinImpact ;				// h̍ŏp[
	Vec Direction ;				// h(SOŊS_)
	u16 Time ;					// hĂ鎞
	u16 Wait ;					// ̗hꂲƂ̑҂
	u8 LinerFlag ;				// ĥ܂肩͐`ǂ(TRUEŐ`AԂƂƂɎ܂)
	u16 Counter ;				// JE^[
	f32 Ix, Iy ;				// h̑傫
	u16 Counter2 ;				// JE^[Q
	u8 Flag ;					// tO
} IMPACTEFFECT ;

// ʗhGtFNgf[^p\
typedef struct tagIMPACTEFFECTTASKPARAM
{
	f32 MaxImpact ;				// h̍őp[
	f32 MinImpact ;				// h̍ŏp[
	Vec Direction ;				// h(SOŊS_)
	u16 Time ;					// hĂ鎞
	u16 Wait ;					// ̗hꂲƂ̑҂
	u8 LinerFlag ;				// ĥ܂肩͐`ǂ(TRUEŐ`AԂƂƂɎ܂)
} IMPACTEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitImpactData( void ) ;				// ʗhGtFNg̋ʃf[^
extern s8 CheckImpactData( void ) ;				// ʗhGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndImpactData( void ) ;				// ʗhGtFNg̋ʃf[^n

//extern void ImpactEffectTask( ghmGcTask *pTask ) ;						// ʗhGtFNg^XN

extern EFFECT *CreateImpactEffect( f32 MaxImpact, f32 MinImpact, Vec Direction, u16 Time, u16 Wait,
									 u8 LinerFlag, s32 Priority = 3000 ) ;	// ʗhGtFNg쐬
extern s8 ReleaseImpactEffect( EFFECT *Effect ) ;							// ʗhGtFNǧns
extern s8 MoveImpactEffect( EFFECT *Effect ) ;								// ʗhGtFNgPt[
extern s8 DrawImpactEffect( EFFECT *Effect ) ;								// ʗhGtFNg`悷

#endif