///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectConveItemGet
//
// YK7EffectConveItemGet.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 03/25/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTITEMGET_H
#define __YK7EFFECTITEMGET_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "./YK7Move.h"

// define ---------------------------------------

// data type ------------------------------------

// ACe擾GtFNgʃf[^
typedef struct tagITEMGETUNION
{
	s32 ShutterPriority ;
	TEXDATA side ;				// [eNX`
	TEXDATA hikari ;			// eNX`
} ITEMGETUNION ;

// ACe擾GtFNgf[^
typedef struct tagITEMGETEFFECT
{
	EFFECT *efMes ;				// bZ[WGtFNg
	u32 efMesID ;				// bZ[WGtFNĝhc
	EFFECT *efShutter ;			// Vb^[GtFNg
	u32 efShutterID ;			// bZ[WGtFNĝhc

	s8	PackID ;				// bZ[W̃pbNhc
	u16	MessageID ;				// bZ[Ŵhc
	s8	ButtonCancelFlag ;		// {^LZ\tO
	s32	IconID ;				// ACR̂hc
	s32	SoundID ;				// TEĥhc
	
	u32 color ;					// Vb^[̐F
	
	s8 FlashCounter ;			// JE^
	
	u8 Mode ;					// ڏ
	s32 Counter ;				// JE^[
	s32 Counter2 ;
	CMov left ;					// т̏o
	CMov icon ;					// ACR̍W
	f32 iconback[7] ;
} ITEMGETEFFECT ;

// prototype ------------------------------------

extern s8 InitItemGetData( void ) ;				// ACe擾GtFNg̋ʃf[^
extern s8 CheckItemGetData( void ) ;			// ACe擾GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndItemGetData( void ) ;				// ACe擾GtFNg̋ʃf[^n

extern EFFECT *CreateItemGetEffect( 
									s8	PackID,						// bZ[W̃pbNhc
									u16	MessageID,					// bZ[Ŵhc
									s8	ButtonCancelFlag = TRUE,	// {^LZ\tO
									s32	IconID = -1,				// ACR̂hc
									s32	SoundID = -1,				// TEĥhc
									
									u32 color = 0x0,				// Vb^[̐F
									s32 Priority = 7000 ) ;			// ACe擾GtFNg쐬
extern s8 ReleaseItemGetEffect( EFFECT *Effect ) ;					// ACe擾GtFNǧns
extern s8 MoveItemGetEffect( EFFECT *Effect ) ;						// ACe擾GtFNgPt[
extern s8 DrawItemGetEffect( EFFECT *Effect ) ;						// ACe擾GtFNg`悷

extern void SetItemGetShutterPriority( s32 Priority ) ;				// ɍ쐬ACe擾GtFNgŎgpVb^[̕`D揇ʂύX
extern s8 GetItemGetState( EFFECT *Effect ) ;			// ACe擾GtFNg̏Ԃ𓾂( 0:bZ[WoO  1:bZ[Wo )

#endif	// __YK7EFFECTITEMGET_H

