///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectKLine
//
// YK7EffectKLine.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/06/2003
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectKLine.h"
#include "./YK7EffectLine.h"

// define ---------------------------------------

#define TEST_TEXTURE	"/Yam/Effect/KLine/KLine1.bin"

// datatype -------------------------------------

// data -----------------------------------------

KLINEUNION KLUnion ;

// function proto type --------------------------

// function code --------------------------------

// ʐGtFNg̋ʃf[^
extern s8 InitKLineData( void )
{
//	u32 hr ;

	MEMINIT( KLUnion ) ;

	// eNX`̓ǂݍ	
//	hr = TexLoad( TEST_TEXTURE, &KLineUnion->TestTex, &KLineUnion-> ) ;

	// I
	return 0 ;
}

// ʐGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckKLineData( void )
{
	return TRUE ;
}


// ʐGtFNg̋ʃf[^n
extern s8 EndKLineData( void )
{
	MEMINIT( KLUnion ) ;

	// eNX`̃J
//	K7AppSmallMemFree( KLineUnion->TestTex.Header ) ;
	
	// I
	return 0 ;
}




// ʐGtFNg쐬
extern EFFECT *CreateKLineEffect( u8 Mode, u8 TexNumber, f32 Size, Vec Point, u16 LineNum, f32 Width,
									f32 Length, /*u8 FlashFlag,*/ u8 FlashTime,/* u8 DepthFlag,*/
									 f32 Speed, s16 Time, GXColor Color, u8 ColorRand, s32 Priority )
{
	EFFECT *Effect ;
	KLINEEFFECT *KLineP ;
	
	// Vʐf[^쐬
	Effect = AddEffectData( EFF_KLINE, (void**)&KLineP, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	// p[^ׂĕۑ
	KLineP->Mode = Mode ;
	KLineP->TexNumber = TexNumber ;
	KLineP->Point = Point ;
	KLineP->LineNum = LineNum ;
	KLineP->Width = Width ;
	KLineP->Length = Length ;
//	KLineP->FlashFlag = FlashFlag ;
	KLineP->FlashTime = FlashTime ;
	KLineP->Speed = Speed ;
//	KLineP->DepthFlag = DepthFlag ;
	KLineP->Size = Size ;
	KLineP->Time = Time ;
	KLineP->Color = Color ;
	KLineP->Counter = 0 ;
	KLineP->DelFlag = FALSE ;
	KLineP->ColorRand = ColorRand ;

	// I
	return Effect ;
}

// ʐGtFNǧns
extern s8 ReleaseKLineEffect( EFFECT *Effect )
{
	KLINEEFFECT *KLineEffect = ( KLINEEFFECT * )Effect->Data ;

	// I
	return 0 ;
}

// ʐGtFNgPt[
extern s8 MoveKLineEffect( EFFECT *Effect )
{
	KLINEEFFECT *KLine = ( KLINEEFFECT * )Effect->Data ;
	HSD_CObj *Camera ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// ԂĂ폜
	if( ( KLine->Time != -1 && KLine->Time == KLine->Counter ) || Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// 莞ԂĂʐ𔭐
	if( KLine->Counter % KLine->FlashTime == 0 )
	{
		Vec Point, Direction ;
	
		// Qc[hǂɂď𕪊
		if( KLine->Mode == 0 )
		{
			Direction.x = 1.0F ; Direction.y = Direction.z = 0.0F ;
			
			// w̍W𒆐SɏW𔭐
			CreateLineEffect( (u8)( KLine->Mode == 0 ? TRUE : FALSE ), 0, KLine->Color, KLine->Point,
							 KLine->Size, KLine->Width, KLine->Length,
							 KLine->Speed, KLine->Speed / 3 * 2, Direction,
							 0.0F, 1.0F, 0.0F,
							 KLine->LineNum, 1, 1,
							 TRUE, LINE_TYPE_NORMAL, 1,
							 0.0F, NULL, KLine->ColorRand, Effect->Priority ) ;
		}
		else
		{
			// J̏擾
			Camera = GetEffectCamera() ;
		
			// J̍W𓾂
			HSD_CObjGetEyePosition( Camera, &Point ) ;
			
			Direction.x = Point.x - KLine->Point.x ;
			Direction.y = Point.y - KLine->Point.y ;
			Direction.z = Point.z - KLine->Point.z ;
			VECNormalize( &Direction, &Direction ) ;
			
			// J̕ɃC𔭐
			CreateLineEffect( (u8)( KLine->Mode == 0 ? TRUE : FALSE ), 0, KLine->Color, KLine->Point,
							 KLine->Size, KLine->Width, KLine->Length,
							 KLine->Speed, KLine->Speed / 3 * 2, Direction,
							 PI / 9.0F, 0.0F, 0.0F,
							 KLine->LineNum, 1, 1,
							 TRUE, LINE_TYPE_OUTCIRCLE, 1,
							 0.0F, NULL, KLine->ColorRand, Effect->Priority ) ;
		}
	}

	// JEgi߂
	KLine->Counter ++ ;


	// I
	return 0 ;
}

// ʐGtFNg`悷
extern s8 DrawKLineEffect( EFFECT *Effect )
{
	KLINEEFFECT *KLineEffect = ( KLINEEFFECT * )Effect->Data ;
	
	// I
	return 0 ;
}					
	

// ʐGtFNg̒SWύX
extern s8 SetKLineEffectPoint( EFFECT *Effect, Vec Pos )
{
	KLINEEFFECT *KLineEffect = ( KLINEEFFECT * )Effect->Data ;
	
	KLineEffect->Point = Pos ;

	// I
	return 0 ;
}					




