///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectKLine
//
// YK7EffectKLine.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/06/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTKLINE_H
#define __YK7EFFECTKLINE_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// ʐGtFNgʃf[^
typedef struct tagKLINEUNION
{
	TEXTURE TestTex ;					// eXgeNX`
} KLINEUNION ;

// ʐGtFNgIuWFNg
typedef struct tagKLINEOBJECT
{
	u8 Dummy ;
} KLINEOBJECT;
	

// ʐGtFNgf[^
typedef struct tagKLINEEFFECT
{
	u8 DelFlag ;			// 폜tO
	
	u8 Mode ;				// ʐGtFNg̃^Cv(0:Qc^Cv  1:Rc^Cv)
	u8 TexNumber ;			// eNX`io[(݂͖)
	f32 Size ;				// S̃TCY
	Vec Point ;				// W
	u16 LineNum ;			// ̐
	f32 Width ;				// {̕
	f32 Length ;			// {̒(Oȉœr؂ȂC)
//	u8 FlashFlag ;			// 莞ԂƂɔzuς邩AtO
	u8 FlashTime ;			// zuςԊut[(tbVLȏꍇ̂)
//	u8 DepthFlag ;			// s̊TO邩AtO(TRUEŉʒSɋ߂Âقǐ̑xxȂ)
	f32 Speed ;				// ʐ̈ړxA{ŉʉɁA|ŉʎOɈړ
	s16 Time ;				// ʐoĂt[
	u16 Counter ;			// ėpJE^
	GXColor Color ;			// ̐F
	u8 ColorRand ;			// _F
} KLINEEFFECT ;

// ʐGtFNg^XNɓnf[^
typedef struct tagKLINEEFFECTTACKPARAM
{
	u8 Mode ;				// ʐGtFNg̃^Cv(0:Qc^Cv  1:Rc^Cv)
	u8 TexNumber ;			// eNX`io[(݂͖)
	f32 Size ;				// S̃TCY
	Vec Point ;				// W
	u16 LineNum ;			// ̐
	f32 Width ;				// {̕
	f32 Length ;			// {̒
//	u8 FlashFlag ;			// 莞ԂƂɔzuς邩AtO
	u8 FlashTime ;			// zuςԊut[(tbVLȏꍇ̂)
//	u8 DepthFlag ;			// s̊TO邩AtO(TRUEŉʒSɋ߂Âقǐ̑xxȂAׂȂ)
	f32 Speed ;				// ʐ̈ړxA{ŉʉɁA|ŉʎOɈړ
	s16 Time ;				// ʐoĂt[
	GXColor Color ;			// ̐F
	u8 ColorRand ;			// _F
} KLINEEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitKLineData( void ) ;				// ʐGtFNg̋ʃf[^
extern s8 CheckKLineData( void ) ;				// ʐGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndKLineData( void ) ;				// ʐGtFNg̋ʃf[^n

//extern void KLineEffectTask( ghmGcTask *pTask ) ;								// ʐGtFNg^XN

extern EFFECT *CreateKLineEffect( u8 Mode, u8 TexNumber, f32 Size,
									Vec Point, u16 LineNum, f32 Width,
									f32 Length, /*u8 FlashFlag,*/ u8 FlashTime,/* u8 DepthFlag,*/
									 f32 Speed, s16 Time, GXColor Color, u8 ColorRand, s32 Priority = -1 ) ;// ʐGtFNg쐬
extern s8 ReleaseKLineEffect( EFFECT *Effect ) ;									// ʐGtFNǧns
extern s8 MoveKLineEffect( EFFECT *Effect ) ;										// ʐGtFNgPt[
extern s8 DrawKLineEffect( EFFECT *Effect ) ;										// ʐGtFNg`悷

extern s8 SetKLineEffectPoint( EFFECT *Effect, Vec Pos ) ;					// ʐGtFNg̒SWύX

#endif
