///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectKiraKira
//
// YK7EffectKiraKira.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 03/30/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTKIRAKIRA_H
#define __YK7EFFECTKIRAKIRA_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

#define KIRAKIRA_MAXNUM			400			// LL̍ő吔

// datatype -------------------------------------

// LLGtFNgʃf[^
typedef struct tagKIRAKIRAUNION
{
//	TEXDATA KiraKiraTex ;
	u8 Dummy ;
} KIRAKIRAUNION ;

// LLIuWFNgf[^
typedef struct tagKIRAKIRAOBJECT
{
	u8 vflag ;					// LtO
	Vec pos ;					// W
	f32 rot ;					// ]px
	f32 alpha ;					// At@l
	f32 alphaspeed ;			// Xs[h
	u8 boundnum ;				// oEh
} KIRAKIRAOBJECT ;

// LLGtFNgf[^
typedef struct tagKIRAKIRAEFFECT
{
	KIRAKIRAOBJECT Obj[KIRAKIRA_MAXNUM] ;		// ̃f[^ւ̃|C^
	s32 ObjNum ;								// LL̐

	f32 Rot ;
	Vec Pos ;						// W
	u32 Color ;						// F
	f32 Size ;						// TCY
	f32 CreateCost ;				// 쐬RXg
	f32 CreateCounter ;				// 쐬JE^
} KIRAKIRAEFFECT ;

// LLGtFNg^XNɓnf[^
typedef struct tagKIRAKIRAEFFECTTACKPARAM
{
	Vec Pos ;						// W
	u32 Color ;						// F
	f32 Size ;						// TCY
	f32 CreateCost ;				// 쐬RXg
} KIRAKIRAEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitKiraKiraData( void ) ;				// LLGtFNg̋ʃf[^
extern s8 CheckKiraKiraData( void ) ;				// LLGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndKiraKiraData( void ) ;					// LLGtFNg̋ʃf[^n

extern EFFECT *CreateKiraKiraEffect( 					// LLGtFNg쐬
						Vec Pos,						// W
						u32 Color,						// F
						f32 Size,						// TCY
						f32 CreateCost,					// 쐬RXg
						s32 Priority = -3 ) ;	
extern s8 ReleaseKiraKiraEffect( EFFECT *Effect ) ;						// LLGtFNǧns
extern s8 MoveKiraKiraEffect( EFFECT *Effect ) ;						// LLGtFNgPt[
extern s8 DrawKiraKiraEffect( EFFECT *Effect ) ;						// LLGtFNg`悷

extern s8 SetKiraKiraEffectPos( Vec Pos, EFFECT *Effect ) ;			// LLGtFNg̍WύX

#endif
