///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectLineRoll
//
// YK7EffectLineRoll.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 11/04/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTLINEROLL_H
#define __YK7EFFECTLINEROLL_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

#define MAXROLLLINE_NUM			1000				// C̍ő吔

// datatype -------------------------------------

// W]GtFNgʃf[^
typedef struct tagLINEROLLUNION
{
} LINEROLLUNION ;

// CIuWFNgf[^
typedef struct tagLINEROLLOBJECT
{
	f32 Length 	;				// C̒
	GXColor Color ;				// F
	f32 Rot ;					// \ʒu
} LINEROLLOBJECT ;

// W]GtFNgf[^
typedef struct tagLINEROLLEFFECT
{
	LINEROLLOBJECT *Obj ;				// ̃f[^ւ̃|C^
	s32 ObjNum ;						// ̐

	u8 FastDeleteFlag ;					// 폜tO
	
	u8 Mode ;							// [h
	s32 Counter1, Counter2 ;			// ėpJE^
	
	f32 BaseRot ;						// ]l
	f32 RotSpeed ;						// ]x
	f32 Adjust ;						// ␳l(1.0F:o  0.0F:SɌȂ
	f32 Alpha ;							// C̓ߓx(1.0F:s  0.0F:)

	f32 InSpeed ;						// ̏x
	s32 InTime ;						// Ɋ|t[
	s32 OutTime ;						// ޏoɊ|t[

	u8 LineWidth ;						// ̑
	
	EFFECT *ScreenEffect ;				// ʃGtFNgւ̃|C^
} LINEROLLEFFECT ;

// W]GtFNg^XNɓnf[^
typedef struct tagLINEROLLEFFECTTACKPARAM
{
	s32 LineNum ;				// ̐
	f32 RotSpeed ;				// ]x

	f32 InSpeed ;				// ̏x
	s32 InTime ;				// Ɋ|t[
	s32 OutTime ;				// ޏoɊ|t[

	f32 MaxLength ;				// ̍ő咷
	f32 MinLength ;				// ̍ŏ
	
	u8 LineWidth ;				// ̑
	
	GXColor Color1, Color2 ;	// F
	u8 RandColor ;				// F̂Ԃꕝ
	f32 Rate ;					// ̐F̕z̔䗦( 1.0F:SColor1̂  0.0F:SColor2̂ )
} LINEROLLEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitLineRollData( void ) ;				// W]GtFNg̋ʃf[^
extern s8 CheckLineRollData( void ) ;				// W]GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndLineRollData( void ) ;					// W]GtFNg̋ʃf[^n


extern EFFECT *CreateLineRollEffect( s32 LineNum, f32 RotSpeed,
									 f32 InSpeed, s32 InTime, s32 OutTime,
									 f32 MaxLength, f32 MinLength,
									 u8 LineWidth,
									 GXColor Color1, GXColor Color2,
									 u8 RandColor, f32 Rate,
									  s32 Priority = 2000 ) ;	// W]GtFNg쐬
extern s8 ReleaseLineRollEffect( EFFECT *Effect ) ;							// W]GtFNǧns
extern s8 MoveLineRollEffect( EFFECT *Effect ) ;							// W]GtFNgPt[
extern s8 DrawLineRollEffect( EFFECT *Effect ) ;							// W]GtFNg`悷

extern s8 DelReqLineRollEffect( EFFECT *Effect ) ;							// 폜NGXgs
extern s8 FastDelReqLineRollEffect( EFFECT *Effect ) ;						// 폜NGXgs

#endif
