///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectLockOn
//
// YK7EffectLockOn.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 01/03/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTLOCKON_H
#define __YK7EFFECTLOCKON_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// bNIGtFNgʃf[^
typedef struct tagLOCKONUNION
{
	u8 Dummy ;
} LOCKONUNION ;

// bNIGtFNgf[^
typedef struct tagLOCKONEFFECT
{
	Vec TargetPos ;				// ڕWW
	f32 t, bt ;					// oߎ
	f32 alpha ;					// At@l
	GXColor Color ;				// F

	s8 DrawFlag ;				// `tO
} LOCKONEFFECT ;

// bNIGtFNgf[^p\
typedef struct tagLOCKONEFFECTTASKPARAM
{
	u8 dummy ;				// ɂȂ
} LOCKONEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitLockOnData( void ) ;				// bNIGtFNg̋ʃf[^
extern s8 CheckLockOnData( void ) ;				// bNIGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndLockOnData( void ) ;				// bNIGtFNg̋ʃf[^n

extern EFFECT *CreateLockOnEffect( Vec *TargetPoint, GXColor *Color = NULL, s32 Priority = 1800 ) ;			// bNIGtFNg쐬
extern s8 ReleaseLockOnEffect( EFFECT *Effect ) ;							// bNIGtFNǧns
extern s8 MoveLockOnEffect( EFFECT *Effect ) ;								// bNIGtFNgPt[
extern s8 DrawLockOnEffect( EFFECT *Effect ) ;								// bNIGtFNg`悷

extern s8 ChangeLockOnPoint( Vec *TargetPos, EFFECT *Effect ) ;				// bNI̕\WύX
extern s8 SetLockOnDrawFlag( u8 DrawFlag, EFFECT *Effect ) ;				// bNIGtFNg`悷邩ǂ̃tOZbg

#endif