///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectMessage2
//
// YK7EffectMessage2.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 12/09/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTMESSAGE2_H
#define __YK7EFFECTMESSAGE2_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../matsu/mk7Jimaku.h"
#include "./YK7EffectMessage.h"

// define ---------------------------------------

#define MAX_MESSAGE2NUM		(1)		// xɏo郁bZ[WQ̍ő吔
#define MES2_MAX_STRLEN		(80)	// ̍ő咷
#define MES2_MAX_RUBILEN	(40)	// r̍ő咷
#define MES2_MAX_LINENUM	(5)		// xɏoős

// datatype -------------------------------------

// ̈
typedef struct tagMESSAGE2RECT
{
	f32 y, height ;
} MESSAGE2RECT ;

// bZ[WQGtFNgʃf[^
typedef struct tagMESSAGE2UNION
{
	u8 Object[MAX_MESSAGE2NUM] ;	// \Ă郁bZ[WQIuWFNg̃tO
	u8 ObjectNum ;					// IuWFNg̐
	EFFECT *RunMes ;				// sbZ[W

	TEXDATA ButTex ;				// {^eNX`
} MESSAGE2UNION ;

// ꕶ̃Aj[V
typedef struct tagMESSAGE2OBJECTANIM
{
	f32 x, y ;
	f32 sx, sy ;
	f32 ExRate ;
	s8 WaitCounter ;
	f32 Alpha ;
	s8 Mode ;
	s8 MoveCounter ;
} MESSAGE2OBJECTANIM ;

// ꕶ̃f[^\
typedef struct tagMESSAGE2OBJECT
{
	MESSAGE2OBJECTANIM d[2] ;	// ( 0:e 1:\ )
	f32 BaseX, BaseY ;			// {W
	f32 w, h ;					// ̑傫
	u16 CharID ;				// ̂hc
} MESSAGE2OBJECT ;

// s̕f[^\
typedef struct tagMESSAGE2LINE
{
	u16 CharID[MES2_MAX_STRLEN] ;					// ̂hc̗
	stFontParam *StrBuf[MES2_MAX_STRLEN] ;			// ̃eNX`̗
	MESSAGE2OBJECT StrInfo[MES2_MAX_STRLEN] ;		// ̏
	MESSAGE2OBJECT RubiInfo[MES2_MAX_RUBILEN] ;		// ȑ
	u16 RubiNum ;									// r̐
	MESSAGERUBI RubiInfo2[JIMAKU_RUBI_DAT_MAX] ;	// r
	s32 StrLen, StrWidth, Height, y ;
} MESSAGE2LINE ;
	
// bZ[WQGtFNgf[^
typedef struct tagMESSAGE2EFFECT
{
	EFFECT *MatiMes ;			// sÎ҂Ă郁bZ[W
	u32 MatiMesID ;				// ҂bZ[WGtFNĝhc

	s8 PackID ;					// bZ[WpbNhc
	s32 IconID ;				// \ACR̂hc
	s32 SoundID ;				// ĐTEĥhc
	u16 MessageID ;				// bZ[Whc
	s8 PostID ;					// IuWFNĝhc
	s8 IconNotDrawFlag ;		// ACR͕`悵ȂtO

	EFFECT *IconCursor ;		// ACRꍇ̃ACRp̃ObhGtFNg
	s8 IconMode ;
	u16 IconCounter1, IconCounter2 ;
	f32 IconY ;
	MESSAGE2OBJECT IconObj ;
	
	MESSAGE2OBJECT ButObj ;		// {^IuWFNg

	EFFECT *Cursor ;			// J[\GtFNgւ̃|C^
	MESSAGE2LINE StrData[MES2_MAX_LINENUM] ;		// bZ[Wf[^
	u8 StrDataNum ;				// f[^̐
	
	s32 MaxWidth, Height ;		// Əc
	s32 MaxStrLen ;				// ő啶

	u16 Mode ;					// [h
	u32 Counter1, Counter2 ;	// ėpJE^[
	
	s16 x, y ;					// bZ[W`悷xW
	s8 StopFlag ;				// Xgbv悤ɂ
	s8 StopFlag2 ;				// XgbvtO
	s16 SoundFlag ;				// 炵tO

	GXColor Color ;				// F
	s8 ColorTableIndex ;		// J[e[ugꍇ̃CfbNX

	s8 StrDrawFlag ;

	s8 ButtonCancelFlag ;			// {^LZLǂ̃tO
	s32 WinX, WinY, WinW, WinH ;	// ObhEChE̋`
	s32 LRGridNum, TBGridNum ;		// EObhƏ㉺Obh̐
} MESSAGE2EFFECT ;

// bZ[WQGtFNgf[^p\
typedef struct tagMESSAGE2EFFECTTASKPARAM
{
	s8 PackID ;				// bZ[WpbNhc
	u16 MessageID ;			// bZ[Whc
	s32 IconID ;			// ACRhc
	s32 SoundID ;			// TEhhc
	s16 y ;					// bZ[W`悷xW
	s8 StopFlag ;			// Xgbv悤ɂ
	GXColor *Color ;		// ̐Fւ̃|C^
	s8 ColorTableIndex ;	// J[e[ugꍇ̃CfbNX
} MESSAGE2EFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitMessage2Data( void ) ;			// bZ[WQGtFNg̋ʃf[^
extern s8 CheckMessage2Data( void ) ;			// bZ[WQGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndMessage2Data( void ) ;				// bZ[WQGtFNg̋ʃf[^n

extern EFFECT *CreateMessage2Effect( s8 PackID, u16 MessageID, s8 ButtonCancelFlag = TRUE,
									s32 IconID = -1, s32 SoundID = -1,
									s16 x = -1, s16 y = -1,
									GXColor *Color = NULL, s8 ColorTableIndex = 2,
									s8 IconNotDrawFlag = FALSE, s8 CenterXFlag = FALSE, s8 CenterYFlag = FALSE,
									s32 Priority = 6000 ) ;		// bZ[WQGtFNg쐬
extern s8 ReleaseMessage2Effect( EFFECT *Effect ) ;		// bZ[WQGtFNǧns
extern s8 MoveMessage2Effect( EFFECT *Effect ) ;		// bZ[WQGtFNgPt[
extern s8 DrawMessage2Effect( EFFECT *Effect ) ;		// bZ[WQGtFNg`悷

extern u8 ResetMessage2WaitCount( void ) ;					// ҂ԂZbg
extern u8 FrameProcessMessage2WaitCount( void ) ;			// ҂ԏ

extern u8 StopReleaseMessage2Effect( EFFECT *Effect ) ;		// ~Ԃ
extern s8 GetStopStateMessage2Effect( EFFECT *Effect ) ;	// ~Ԃł邩ǂ擾( TRUE:~ FALSE: )
extern s8 GetMessage2EffectCompState( EFFECT *Effect ) ;	// ޏoJnĂ邩ǂ擾( TRUE:JnĂ  FALSE:܂ ) 

#endif
