///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectModelFire
//
// YK7EffectModelFire.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 08/27/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTMODELFIRE_H
#define __YK7EFFECTMODELFIRE_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "./YK7Break.h"
#include "../Wat/WK7Model.h"
#include "../matsu/mk7Sound.h"


// define ---------------------------------------

#define SINTABLENUM			1
#define FIREMAXNUM			2000

// ȈՑI̗񋓌^
enum
{
	MFIRE_HS = 0,			// 0:wuX}CS
	MFIRE_MSK,				// 1:}XN\
	MFIRE_CANDLE,			// 2:낤R
	MFIRE_WALL,				// 3:ǔR
	MFIRE_RUMP,				// 4:vR
	MFIRE_KIS,				// 5:LXM 
	MFIRE_KIS_115,			// 6:LXMR(Stage115M00)
	MFIRE_ISZK_309,			// 7:ISZKh(Stage309M00)
	MFIRE_FUK_107,			// 8:tNV}R(Stage107M00)
	MFIRE_KIS_115_2,		// 9:LXMR(Stage115M00)
	MFIRE_ENEMY,			// 10:GR
} ;

// datatype -------------------------------------

// ft@CGtFNgʃf[^
typedef struct tagMODELFIREUNION
{
	TEXDATA ModelFireTexAlpha ;		// ft@C̃At@eNX`f[^
	TEXTURE ModelFireTexRgb ;		// ft@ĈqfaeNX`f[^
	ghmGcFile *TexFileRgb ;		// ft@ĈqfaeNX`p ghmGcFile
	u8 FireCount ;
	
	u8 FireNotDrawFlag ;		// `悵ȂtO
	f32 MaxNumRate ;			// őIuWFNgɑ΂oCAX
	bool MaxNumRateFlag ;		// MaxNumRate ̗LtO
} MODELFIREUNION ;

// ft@CIuWFNgf[^
typedef struct tagMODELFIREOBJECT
{
	u8 UseFlag ;					// gptO
	Vec Point, BackP ;				// W
	Vec Speed ;						// xւ̃Xs[h
	f32 SSpeed ;					// xւ̉x
	u8 a, sa ;						// At@l(0`255)ƃAt@Xs[h
	f32 Size, SSize ;				// 傫ƏȂ鑬x

	
	f32 SinTable[SINTABLENUM] ;		// TCe[u
	f32 SinSpeed[SINTABLENUM] ;		// TCXs[h

	u8 Counter ;					// ėpJE^
	u8 DeadTime ;					// Ɏn߂鎞

	GXColor Color ;					// F

	u8 tu, tv ;						// tuW
	u8 ReverseFlag ;				// ㉺]tO
} MODELFIREOBJECT ;

// ft@CGtFNgf[^
typedef struct tagMODELFIREEFFECT
{
	MODELFIREOBJECT *ObjP ;				// ft@CIuWFNgf[^zւ̃|C^
	u32 ObjNum ;						// IuWFNg̐
	u32 ObjMaxNum ;						// IuWFNg̍ő吔
	u32 PolyCounter ;

	bool HSModeFlag ;						// wuX}Cp[htO

	WK7JObj *JObj ;						// Rオ点IuWFNgւ̃|C^
	MODEL *Model ;						// JObj ͂f[^

	Vec FirePoint ;						// ̒SW(JObjNULL̎Ɏgp)
	f32 FireSize ;						// ̏o͈(JObjNULL̎Ɏgp)
	u8 FireFlatFlag ;					// ̏o XZʂ݂̂AtO
	
	f32 MaxPower, MinPower ;			// őp[ŏp[(ɃXs[h)
	f32 MaxSinSpeed, MinSinSpeed ;		// őTCXs[hŏTCXs[h
	f32 MaxSize, MinSize ;				// őTCYŏTCY
	f32 MaxSizeSpeed, MinSizeSpeed ;	// őTCYXs[hAŏTCYXs[h
	u8 MaxTime, MinTime ;				// ő吶c^Cƍŏc^C
	f32 MaxASpeed, MinASpeed ;			// őAt@Xs[hƍŏAt@Xs[h
	u8 AlphaInTime ;					// w̃At@lɂȂ܂ł̎
	f32 CreateRate, TriRate ;			// Vɉp[eBNm
	s32 FireSparkID ;					// ΂̕GtFNghc
	f32 FireSparkRate ;					// ΂̕oꍇ̍쐬[gtO
	EFFECT *FireSparkEffect ;			// ΂̕oꍇ̉΂̕GtFNg|C^
	u16 FireSparkMaxNum ;				// ΂̍̕ő吔
	
	GXColor Color ;						// F
	u8 ColorRand ;						// F̕ϓl
	
	Vec Wind ;							// ̕
	f32 WindPower ;						// ̋
	
	f32 RandPower ;						// _ɉZړ

	u8 FastDeleteFlag ;					// 폜]tO

	s32 SoundID ;						// 炵̂hc
	s32 CreateCounter ;
} MODELFIREEFFECT ;

// ft@CGtFNg^XNɓnf[^
typedef struct tagMODELFIREEFFECTTACKPARAM
{
	WK7JObj *JObj ;						// Rオ点IuWFNgւ̃|C^
	Vec FirePoint ;						// ̒SW(JObjNULL̎Ɏgp)
	f32 FireSize ;						// ̏o͈(JObjNULL̎Ɏgp)
	u8 FireFlatFlag ;					// ̏o XZʂ݂̂AtO

	f32 MaxPower, MinPower ;			// őp[ŏp[(ɃXs[h)
	f32 MaxSinSpeed, MinSinSpeed ;		// őTCXs[hŏTCXs[h
	f32 MaxSize, MinSize ;				// őTCYŏTCY
	f32 MaxSizeSpeed, MinSizeSpeed ;	// őTCYXs[hAŏTCYXs[h
	u8 MaxTime, MinTime ;				// ő吶c^Cƍŏc^C
	f32 MaxASpeed, MinASpeed ;			// őAt@Xs[hƍŏAt@Xs[h
	u8 AlphaInTime ;					// w̃At@lɂȂ܂ł̎
	f32 CreateRate, TriRate ;			// Vɉp[eBNm

	Vec Wind ;							// ̕
	f32 WindPower ;						// ̋
	
	GXColor Color ;						// F
	u8 ColorRand ;						// F̕ϓl
	
	f32 RandPower ;						// _ɉZړ
	
	u32 ObjMaxNum ;						// IuWFNg̍ő吔
	s32 FireSparkID ;					// ΂̕GtFNghc
	f32 FireSparkRate ;					// ΂̕oꍇ̍쐬[gtO
	u16 FireSparkMaxNum ;				// ΂̍̕ő吔
	
	s32 SoundID ;						// 炷
} MODELFIREEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitModelFireData( void ) ;				// ft@CGtFNg̋ʃf[^
extern s8 CheckModelFireData( void ) ;				// ft@CGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndModelFireData( void ) ;				// ft@CGtFNg̋ʃf[^n

// FireType
// 0:wuX}CS
// 1:}XN\
// 2:낤R
// 3:ǔR
// 4:vR
// 5:LXM 
// 6:LXMR(Stage115M00)
// 7:ISZKh(Stage309M00)
// 8:tNV}R(Stage107M00)
// 9:LXMR(Stage115M00)

extern EFFECT *CreateModelFireEffectEasy( 	WK7JObj *JObj, u8 FireType, Vec Point,
											f32 Size = 0.0F, s32 SoundID = SFX_BT_EF_FIRE_MERAMERA, s32 Priority = -130 ) ;		// ft@CGtFNg쐬ȈՔ
extern EFFECT *CreateModelFireEffect( WK7JObj *JObj,
										Vec FirePoint, f32 FireSize, u8 FireFlatFlag,
										f32 MaxPower, f32 MinPower,
										f32 MaxSinSpeed, f32 MinSinSpeed,
										f32 MaxSize, f32 MinSize,
										f32 MaxSizeSpeed, f32 MinSizeSpeed,
										u8 MaxTime, u8 MinTime,
										f32 MaxASpeed, f32 MinASpeed, u8 AlphaInTime,
										f32 CreateRate, f32 TriRate,
										GXColor Color, u8 ColorRand, u32 ObjMaxNum = 2000,
										f32 RandPower = 0.0F,
										s32 FireSparkID = -1, f32 FireSparkRate = 0.0F, u16 FireSparkMaxNum = 1000,
										s32 SoundID = SFX_BT_EF_FIRE_MERAMERA, 
										bool HSModeFlag = false, 
										s32 Priority = -130 ) ;					// ft@C̃GtFNg쐬
extern s8 ReleaseModelFireEffect( EFFECT *Effect ) ;							// ft@C̃GtFNǧns
extern s8 MoveModelFireEffect( EFFECT *Effect ) ;								// ft@C̃GtFNgPt[
extern s8 DrawModelFireEffect( EFFECT *Effect ) ;								// ft@C̃GtFNg`悷

extern s8 FastDelReqModelFireEffect( EFFECT *Effect ) ;							// 폜NGXgs
extern s8 SetWindModelFireEffect( EFFECT *Effect, Vec Wind, f32 WindPower ) ;	// ̋Zbg
extern s8 SetModelFireDrawFlag( s8 DrawFlag ) ;									// `悷邩ǂ̃tOZbg
extern s8 SetModelFireMaxNumRate( f32 MaxNumRate ) ;							// 쐬łIuWFNg̍ő吔ɑ΂oCAXZbg

#endif
