///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectMoon
//
// YK7EffectMoon.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 12/23/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTMOON_H
#define __YK7EFFECTMOON_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

#define MOON_IMG_NUM	12			// OtBbN̐

// datatype -------------------------------------

// GtFNgʃf[^
typedef struct tagMOONUNION
{
	TEXDATA Moon[MOON_IMG_NUM] ;
} MOONUNION ;

// GtFNgf[^
typedef struct tagMOONEFFECT
{
	f32 Rate ;						// ( 0.0F:  0.0F`0.5F:錎̊ԁ@ 0.5F:錎@0.5`1.0F:錎疞̊ )
	f32 RateSpeed ;					// Xs[h
	s8 FlashFlag ;					// tbVtO

	s8 Mode ;						// ( 0:oĂȂ  1:\Ă )
	s32 DrawCounter ;				// \Ă鎞Ԃ̃JE^

	f32 RedPlaneAlpha ;				// Ԗʂ̃At@l
	s32 RedPlaneAlphaCounter ;
	f32 MoonAlpha ;					// ̃At@l
	s32 MoonAlphaCounter ;

	u8 DrawFlag ;					// `tO
} MOONEFFECT ;

// GtFNgf[^p\
typedef struct tagMOONEFFECTTASKPARAM
{
	f32 CycleSpeed ;				// ̃Xs[h( 1.0F:Pt[ň  0.01F:100t[ň )
} MOONEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitMoonData( void ) ;			// GtFNg̋ʃf[^
extern s8 CheckMoonData( void ) ;			// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndMoonData( void ) ;				// GtFNg̋ʃf[^n

extern EFFECT *CreateMoonEffect( f32 CycleSpeed, s32 Priority = 2000 ) ;	// GtFNg쐬
extern s8 ReleaseMoonEffect( EFFECT *Effect ) ;								// GtFNǧns
extern s8 MoveMoonEffect( EFFECT *Effect ) ;								// GtFNgPt[
extern s8 DrawMoonEffect( EFFECT *Effect ) ;								// GtFNg`悷

extern s8 SetMoonEffectRate( f32 MoonRate, EFFECT *Effect ) ;	// Zbg
extern s8 MoonEffectFlash( EFFECT *Effect ) ;					// u\
extern s8 SetMoonEffectDrawFlag( s8 Flag, EFFECT *Effect ) ;	// \邩ǂ̃tOZbg
extern s8 GetMoonEffectFullMoonCheck( EFFECT *Effect ) ;		// ł邩ǂ擾( TRUE:  FALSE:ł͂Ȃ )

extern s8 MoonEffectCycleProcess( EFFECT *Effect ) ;				// ̃JE^i߂
extern s8 SetMoonEffectCycleSpped( f32 Speed, EFFECT *Effect ) ;	// ̖̑Zbg
extern s8 MoonEffectCycleReset( EFFECT *Effect ) ;					// ̃TCNZbg( 錎ɂ )

#endif