///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectNoise
//
// YK7EffectNoise.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 08/07/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTNOISE_H
#define __YK7EFFECTNOISE_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../matsu/mk7Sound.h"

// define ---------------------------------------

#define NOISE_MAXNUM	40				// mCYC̍ő吔

// datatype -------------------------------------

// mCYGtFNgʃf[^
typedef struct tagNOISEUNION
{
	u8 Dummy ;
} NOISEUNION ;

// mCYIuWFNgf[^
typedef struct tagNOISEOBJECT
{
	u8 UseFlag ;			// gptO
	f32 Width ;				// Gꕝ
	u16 Speed ;				// Xs[h
	s32 Point ;				// |Cg
	s32 Helz ;				// x
} NOISEOBJECT ;

// mCYGtFNgf[^
typedef struct tagNOISEEFFECT
{
	NOISEOBJECT Data[NOISE_MAXNUM] ;		// mCYf[^
	u8 Num ;								// mCY̐
	u16 Line ;
	s8 UseTexAlphaFlag ;					// `掞ɃeNX`̃At@gp邩AtO
	bool NotNoizeLineFlag ;					// mCYC͕`悵ȂtO
	bool CharGekiModeFlag ;					// VlXRltO
} NOISEEFFECT ;

// mCYGtFNg^XNɓnf[^
typedef struct tagNOISEEFFECTTACKPARAM
{
	s8 UseTexAlphaFlag ;				// `掞ɃeNX`̃At@gp邩AtO
} NOISEEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitNoiseData( void ) ;					// mCYGtFNg̋ʃf[^
extern s8 CheckNoiseData( void ) ;					// mCYGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndNoiseData( void ) ;					// mCYGtFNg̋ʃf[^n

extern EFFECT *CreateNoiseEffect( s8 UseTexAlphaFlag = FALSE, bool NotNoizeLineFlag = false, s32 Priority = 6000 ) ;		// mCỸGtFNg쐬
extern s8 ReleaseNoiseEffect( EFFECT *Effect ) ;				// mCỸGtFNǧns
extern s8 MoveNoiseEffect( EFFECT *Effect ) ;					// mCỸGtFNgPt[
extern s8 DrawNoiseEffect( EFFECT *Effect ) ;					// mCỸGtFNg`悷

extern s8 AddNoiseLine( EFFECT *Effect, u8 AddNum, u16 Width, u16 Speed, u16 RotSpeed, s32 Sound = SFX_SYS_CHARA_CHANGE ) ;		// mCYGtFNg̃mCY𑝂₷
extern s8 GetNoiseLineNum( EFFECT *Effect ) ;					// mCYC̐擾
extern s8 SetNoiseCharGekiModeFlag( EFFECT *Effect, bool flag ) ;	// VlXRl[hɂ邩ǂ̃tOZbg

#endif