///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectNoiseOut
//
// YK7EffectNoiseOut.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 01/08/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectNoiseOut.h"
#include "./YK7EffectNoise.h"
#include "../Wat/WK7MainTask.h"
#include "../Wat/WK7Cam.h"
#include "../Wat/WK7Light.h"
#include "../Wat/WK7Player.h"

// define ---------------------------------------

#define PRM		VParam[ED_NOISEOUT]

// datatype -------------------------------------

// data -----------------------------------------

NOISEOUTUNION NOUnion ;

// function proto type --------------------------

s8 NoiseOutTexLoadCheck( void ) ;				// [hǂ𒲂ׂ

// function code --------------------------------

// [hǂ𒲂ׂ
s8 NoiseOutTexLoadCheck( void )
{
	// I
	return TRUE ;
}



// mCYAEgGtFNg̋ʃf[^
extern s8 InitNoiseOutData( void )
{
	MEMINIT( NOUnion ) ;
	
	// I
	return 0 ;
}

// mCYAEgGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckNoiseOutData( void )
{
	return TRUE ;
}



// mCYAEgGtFNg̋ʃf[^n
extern s8 EndNoiseOutData( void )
{
	MEMINIT( NOUnion ) ;
	
	// I
	return 0 ;
}


// mCYAEg̃GtFNg쐬
extern EFFECT *CreateNoiseOutEffect( WK7JObj *JObj, s8 Type, s8 NoiseType, s32 Priority )
{
	NOISEOUTEFFECT *Ns ;
	EFFECT *Effect = NULL, *Noise = NULL ;
	WK7ScreenImage *Image = NULL ;
	bool NotAutoDelete = NOUnion.NotAutoDelete ;
	
	NOUnion.NotAutoDelete = false ;
	
	Image = new WK7ScreenImage ;
	if( Image == NULL ) return NULL ;
	if( Image->AllocBuffer() == false ) goto ER ;
	
	Noise = CreateNoiseEffect( TRUE ) ;
	if( Noise == NULL ) goto ER ;
	SetEffectIndeManageFlag( Noise, TRUE ) ;

	// VmCYAEgf[^쐬
	Effect = AddEffectData( EFF_NOISEOUT, (void**)&Ns, Priority ) ;
	if( Effect == NULL ) goto ER ;
	memset( Ns, 0, sizeof( NOISEOUTEFFECT ) ) ;

	// mCYAEgf[^
	Ns->JObj 			= JObj ;
	Ns->Image 			= Image ;
	Ns->Noise 			= Noise ;
	Ns->Counter 		= 0 ;
	Ns->Type 			= Type ;
	Ns->NoiseType		= NoiseType ;
	Ns->NotAutoDelete	= NotAutoDelete ;

	//  JObj ͔\
	JObj->Hide( false, true ) ;

	// mCY𔭐
	switch( NoiseType )
	{
	case 0 : AddNoiseLine( Ns->Noise, 20, 50, 70, 50 ) ; break ;
	case 1 : AddNoiseLine( Ns->Noise, (u8)PRM[3], PRM[4], PRM[5], PRM[6] ) ; break ;
	}

	// I
	return Effect ;
	
ER :
	if( Image ) delete Image ;
	if( Noise ) DeleteEffect( Noise ) ;
	if( Effect ) DeleteEffect( Effect ) ;
	
	return NULL ;
}

// mCYAEg̃GtFNǧns
extern s8 ReleaseNoiseOutEffect( EFFECT *Effect )
{
	NOISEOUTEFFECT *Ns = ( NOISEOUTEFFECT * )Effect->Data ;
	
	// 폜
	if( Ns->Image ) delete Ns->Image ;
	if( Ns->Noise ) DeleteEffect( Ns->Noise ) ;

	if( Ns->JObj && Ns->Type == 0 )
	{
		WK7JObj *j ;
	
		Ns->JObj->Disp( false, true ) ;
		j = Ns->JObj->GetObj( "ClothCollision_Coat" ) ;
		if( j != NULL ) j->Hide( false, true ) ;
		j = Ns->JObj->GetObj( "ClothCollision_Scarf" ) ;
		if( j != NULL ) j->Hide( false, true ) ;
	}

	// ɂ邱ƂȂ
	return 0 ;
}

// mCYAEg̃GtFNgPt[
extern s8 MoveNoiseOutEffect( EFFECT *Effect )
{
	NOISEOUTEFFECT *Ns = ( NOISEOUTEFFECT * )Effect->Data ;

	if( (NOISEOUTEFFECT *)NULL == Ns ) return 0 ;
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( NoiseOutTexLoadCheck() == FALSE ) return 0 ;
	
	// JE^CNg
	Ns->Counter += VParam[ED_NOISEOUT][0] ;
/*	if(	Effect->DelReqFlag == TRUE ||
	      ( Ns->Counter >= SCH && 
		    ( Ns->Type == 1 ||
			  ( Ns->Type == 0 && GetNoiseLineNum( Ns->Noise ) == 0 )
			)
		  )
	  )
*/
	if( CheckNoiseOutEndState( Effect ) == true )
	{
		if( Ns->NotAutoDelete == false )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
	}
	
	// mCYGtFNg̃t[vZXs
	MoveEffect( Ns->Noise ) ;
	
	// I
	return 0 ;
}

// mCYAEg̃GtFNg`悷
extern s8 DrawNoiseOutEffect( EFFECT *Effect )
{
	NOISEOUTEFFECT *Ns = ( NOISEOUTEFFECT * )Effect->Data ;

	if( (NOISEOUTEFFECT *)NULL == Ns ) return 0 ;
	if( NoiseOutTexLoadCheck() == FALSE ) return 0 ;

	//VUO͈̔͐ݒ(!?)
	GXSetScissor( 0, 0, SCW, SCH );

	//r[|[g̐ݒ
	GXSetViewport( 0.0f, 0.0f, (f32)K7APP_SCREEN_WIDTH, (f32)K7APP_SCREEN_HEIGHT, 0.0f, 1.0f );

	// ܂ʂ荞
	Ns->Image->ScreenCopy() ;
	
	// ʂ
	{
		EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_NONE, EF_TEV_NOTEX ) ;
		GXSetAlphaUpdate( TRUE ) ;
		GXSetColorUpdate( TRUE ) ;
		GXSetDstAlpha( TRUE, 0 ) ;
		DrawBox( 0, 0, SCW, SCH, 0xff ) ;
	}

	// f`悷
	{
		WK7JObj *j ;
		s32 i ;
		Ns->JObj->Disp( false, true ) ;
	
		j = Ns->JObj->GetObj( "ClothCollision_Coat" ) ;
		if( j != NULL ) j->Hide( false, true ) ;
		j = Ns->JObj->GetObj( "ClothCollision_Scarf" ) ;
		if( j != NULL ) j->Hide( false, true ) ;
		
		Ns->JObj->SetDstAlpha( 255, false, true ) ;
		// sysdolphinԖ
		if( WK7PLAYERCONTROL->GetLight(0) == NULL )
		{
			WK7CAM->SetCurrent() ;
			Ns->JObj->RenderProcess() ;
			WK7CAM->EndCurrent() ;
		}
		else
		{
			HSD_StateInvalidate( HSD_STATE_ALL ) ;
			HSD_CObjSetCurrent( WK7CAM->GetCObjCurrent() ) ;
			WK7Light::DispStart();
			for( i = 0 ; WK7PLAYERCONTROL->GetLight(i) != NULL ; i ++ )
				WK7PLAYERCONTROL->GetLight(i)->Disp() ;
			WK7Light::DispEnd();
			Ns->JObj->RenderProcess() ;
			HSD_CObjEndCurrent() ;
		}
		Ns->JObj->Hide( false, true ) ;
	}

	//VUO͈̔͐ݒ(!?)
	GXSetScissor( 0, 0, SCW, SCH );

	//r[|[g̐ݒ
	GXSetViewport( 0.0f, 0.0f, (f32)K7APP_SCREEN_WIDTH, (f32)K7APP_SCREEN_HEIGHT, 0.0f, 1.0f );
	
	// ̈
	{
		EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_NONE, EF_TEV_NOTEX ) ;
		GXSetAlphaUpdate( TRUE ) ;
		GXSetColorUpdate( TRUE ) ;
		GXSetDstAlpha( TRUE, 0 ) ;
		if( Ns->Type == 1 )
		{
			DrawBox( 0, 0, SCW, Ns->Counter, 0xff ) ;
		}
		else
		{
			DrawBox( 0, Ns->Counter, SCW, SCH, 0xff ) ;
		}
	}

	// ʂ荞
	screenImageFullColor.ScreenCopy() ;
	
	// X摜`悷
	GTLOAD( Ns->Image->GetTexObj() ) ;
	EffectTevSetup( EF_TEV_USETEX ) ;
	DrawTex3( 0, 0, SCW, SCH ) ;

	// mCYGtFNg`悷
	DrawEffect( Ns->Noise ) ;

	// I
	return 0 ;
}

// mCYAEgGtFNgɏȂ悤ɂ
extern s8 SetNoiseOutNotAutoDelete( void )
{
	NOUnion.NotAutoDelete = true ;
	
	return 0 ;
}

// mCYAEgGtFNgIǂ擾( false:܂  true:I )
extern bool CheckNoiseOutEndState( EFFECT *Effect )
{
	NOISEOUTEFFECT *Ns = ( NOISEOUTEFFECT * )Effect->Data ;
	
	if(	Effect->DelReqFlag == TRUE ||
	      ( Ns->Counter >= SCH && 
		    ( Ns->Type == 1 ||
			  ( Ns->Type == 0 && GetNoiseLineNum( Ns->Noise ) == 0 )
			)
		  )
	  )
	{
		return true ;
	}
	else
	{
		return false ;
	}
}




