///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectRope
//
// YK7EffectRope.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/08/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTROPE_H
#define __YK7EFFECTROPE_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"

// define ---------------------------------------

// datatype -------------------------------------

// [vGtFNgʃf[^
typedef struct tagROPEUNION
{
	u8 Dummy ;
} ROPEUNION ;

// [vGtFNgf[^
typedef struct tagROPEEFFECT
{
	Vec Pos1, Pos2 ;			// [v𒣂W
	WK7JObj *JObj1, *JObj2 ;	// [v𒣂in
} ROPEEFFECT ;

// prototype ------------------------------------

extern s8 InitRopeData( void ) ;			// [vGtFNg̋ʃf[^
extern s8 CheckRopeData( void ) ;			// [vGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndRopeData( void ) ;				// [vGtFNg̋ʃf[^n

extern EFFECT *CreateRopeEffect(	Vec *Pos1 = NULL, 		Vec *Pos2 = NULL,
									WK7JObj *JObj1 = NULL,	WK7JObj *JObj2 = NULL,		// [v𒣂in
									s32 Priority = -2 ) ;				// [vGtFNg쐬
extern s8 ReleaseRopeEffect( EFFECT *Effect ) ;							// [vGtFNǧns
extern s8 MoveRopeEffect( EFFECT *Effect ) ;							// [vGtFNgPt[
extern s8 DrawRopeEffect( EFFECT *Effect ) ;							// [vGtFNg`悷

#endif

