///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectScreen
//
// YK7EffectScreen.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 12/16/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSCREEN_H
#define __YK7EFFECTSCREEN_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7MainTask.h"

// define ---------------------------------------

// datatype -------------------------------------

// XN[GtFNgʃf[^
typedef struct tagSCREENUNION
{
	u8 Dummy ;
} SCREENUNION ;

// XN[GtFNgf[^
typedef struct tagSCREENEFFECT
{
	WK7ScreenImage *Image ;
	u8 InitFlag ;

	s32 DeleteCounter ;

	s8 DrawFlag ;			// `tO
	f32 ExRate ;			// g嗦
	f32 Alpha ;				// At@
	s8 AddFlag ;			// ZuhtO
} SCREENEFFECT ;

// XN[GtFNg^XNɓnf[^
typedef struct tagSCREENEFFECTTACKPARAM
{
	u8 Dummy ;
} SCREENEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitScreenData( void ) ;								// XN[GtFNg̋ʃf[^
extern s8 CheckScreenData( void ) ;								// XN[GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndScreenData( void ) ;								// XN[GtFNg̋ʃf[^n

extern EFFECT *CreateScreenEffect( s32 Priority = 500 /*-1*/ ) ;		// XN[̃GtFNg쐬
extern s8 ReleaseScreenEffect( EFFECT *Effect ) ;				// XN[̃GtFNǧns
extern s8 MoveScreenEffect( EFFECT *Effect ) ;					// XN[̃GtFNgPt[
extern s8 DrawScreenEffect( EFFECT *Effect ) ;					// XN[̃GtFNg`悷

extern s8 SetScreenEffectExRate( EFFECT *Effect, f32 ExRate ) ;		// g嗦ύX
extern s8 SetScreenEffectAddFlag( EFFECT *Effect, s8 Flag ) ;		// Z`邩ǂ̃tOZbg
extern s8 SetScreenEffectAlpha( EFFECT *Effect, f32 Alpha ) ;		// `掞̃At@lZbg
extern s8 SetScreenEffectDrawFlag( EFFECT *Effect, s8 Flag ) ;		// `悷邩ǂZbg

#endif