///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSight2
//
// YK7EffectSight2.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 10/07/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectSight2.h"
#include "./YK7EffectShutter.h"

// define ---------------------------------------

#define CIR_DIVNUM			30				// ~̕		

// datatype -------------------------------------

// data -----------------------------------------

SIGHT2UNION Sig2Union ;

// function code --------------------------------

// TCgQGtFNg̋ʃf[^
extern s8 InitSight2Data( void )
{
	MEMINIT( Sig2Union ) ;

	// I
	return 0 ;
}

// TCgQGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckSight2Data( void )
{
	return TRUE ;
}

// TCgQGtFNg̋ʃf[^n
extern s8 EndSight2Data( void )
{
	MEMINIT( Sig2Union ) ;

	// I
	return 0 ;
}


// TCgQ̃GtFNg쐬
extern EFFECT *CreateSight2Effect( f32 r, GXColor Color, s32 Priority )
{
	SIGHT2EFFECT *Sight2 ;
	EFFECT *Effect ;
	
	// VTCgQf[^쐬
	Effect = AddEffectData( EFF_SIGHT2, (void**)&Sight2, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// TCgQf[^
	Sight2->r = r ;
	Sight2->DrawFlag = FALSE ;
	Sight2->Color = Color ;
	Sight2->CRTFlag = FALSE ;
	Sight2->CRTFlagTemp = FALSE ;
	Sight2->Shutter = NULL ;

	// I
	return Effect ;
}

// TCgQ̃GtFNǧns
extern s8 ReleaseSight2Effect( EFFECT *Effect )
{
	SIGHT2EFFECT *Sight2 = ( SIGHT2EFFECT * )Effect->Data ;

	// ɂ邱ƂȂ
	return 0 ;
}

// TCgQ̃GtFNgPt[
extern s8 MoveSight2Effect( EFFECT *Effect )
{
	SIGHT2EFFECT *Sight2 = ( SIGHT2EFFECT * )Effect->Data ;

	if( (SIGHT2EFFECT *)NULL == Sight2 ) return 0 ;
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂ폜
	if(Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// \tOƕ\tOꍇ̓Vb^[Ɣf
	GetSight2Shutter( Effect ) ;
	if( Sight2->CRTFlag != Sight2->CRTFlagTemp )
	{
		// Vb^[uԂɃtO𓙂
		if( GetSight2Shutter( Effect ) == 0 )
		{
			Sight2->CRTFlagTemp = Sight2->CRTFlag ;
		}
	}

	// I
	return 0 ;
}

#define CIRCLE_TEST															\
			if( x1 >= 0 && x1 < SCW && y1 >= 0 && y1 < SCH )			\
			{																	\
				if( y1 < top ) top = y1 ;										\
				if( y1 > bottom ) bottom = y1 ;									\
				VertexNum += 2 ;												\
			}

#define CIRCLE_L															\
			if( x1 >= 0 && x1 < SCW && y1 >= 0 && y1 < SCH )			\
			{																					\
				GP2( x1, y1 ) ; GXColor1u16( Color1 ) ;	\
				GP2( 0, y1 ) ; 	GXColor1u16( Color1 ) ;	\
				VertexNum += 2 ;																					\
			}

#define CIRCLE_R															\
			if( x1 >= 0 && x1 < SCW && y1 >= 0 && y1 < SCH )			\
			{																					\
				GP2( x1, y1 ) ; GXColor1u16( Color1 ) ;	\
				GP2( SCW, y1 ) ; GXColor1u16( Color1 ) ;	\
				VertexNum += 2 ;																								\
			}


// TCgQ̃GtFNg`悷
extern s8 DrawSight2Effect( EFFECT *Effect )
{
	SIGHT2EFFECT *Sight2 = ( SIGHT2EFFECT * )Effect->Data ;

	if( (SIGHT2EFFECT *)NULL == Sight2 ) return 0 ;
	if( Sight2->DrawFlag == FALSE ) return 0 ;
	if( Sight2->CRTFlagTemp == FALSE ) return 0 ;

	// `揀
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_NONE, EF_TEV_NOTEX ) ;
	
	// _tH[}bg̃Zbg
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA4, 0 ) ;

	// `揈
	{
		s32 top, bottom ;
		s32 x1, y1, x, y ;
		s32 Dx, Dy, F, VertexNum ;
		u16 Color1 ;

		// W̃Zbg
		x = (s32)Sight2->x ;
		y = (s32)Sight2->y ;
			
		// `撸_̐Ƌ`̈ԏƈԉ𒲂ׂ
		{
			VertexNum = 0 ;
		
			// lZbg
			top = SCH ;
			bottom = 0 ;
			Dx = (s32)Sight2->r ; Dy = 0 ; F = -2 * (s32)Sight2->r + 3 ;
			VertexNum = 0 ;
		
			// ŏ̓_`
			{
				x1 = -Dx + x ; y1 = Dy + y ;
				CIRCLE_TEST ;
				x1 = Dx + x ;  
				CIRCLE_TEST ;

//				x1 = Dy + x ; y1 = Dx + y ;
				x1 = SCW - 1 ;		y1 = Dx + y ;
				CIRCLE_TEST ;

//				x1 = Dy + x ; y1 = -Dx + y;
				x1 = SCW - 1 ;		y1 = -Dx + y;
				CIRCLE_TEST ;

				// Wf[^i߂
				if( F >= 0 )
				{
					Dx -- ;
					F -= 4 * Dx ;
				}	

				Dy ++ ;
				F += 4 * Dy + 2 ;
			}

			while( Dx >= Dy )
			{
				x1 = -Dx + x ; y1 = Dy + y ;
				CIRCLE_TEST ;
				x1 = Dx + x ;  
				CIRCLE_TEST ;

				x1 = Dy + x ; y1 = Dx + y ;
				CIRCLE_TEST ;
				x1 = -Dy + x ; 
				CIRCLE_TEST ;
			
				x1 = Dx + x ; y1 = -Dy + y;
				CIRCLE_TEST ;
				x1 = -Dx + x ; 
				CIRCLE_TEST ;

				x1 = Dy + x ; y1 = -Dx + y;
				CIRCLE_TEST ;
				x1 = -Dy + x ; 
				CIRCLE_TEST ;

				// Wf[^i߂
				if( F >= 0 )
				{
					Dx -- ;
					F -= 4 * Dx ;
				}

				Dy ++ ;
				F += 4 * Dy + 2 ;
			}
		}
		
		// `悷
		GXSetLineWidth( 6, GX_TO_ONE ) ;
		GXBegin( GX_LINES, GX_VTXFMT0, (u16)( VertexNum ) ) ;
		{
			// F̃Zbg
			Color1 = GXPackedRGBA4( Sight2->Color.r, Sight2->Color.g, Sight2->Color.b, Sight2->Color.a ) ;
			VertexNum = 0 ;
			
			// lZbg
			Dx = (s32)Sight2->r ; Dy = 0 ; F = -2 * (s32)Sight2->r + 3 ;

			// ŏ̓_`
			{
				x1 = -Dx + x ; y1 = Dy + y ;
				CIRCLE_L ;
				x1 = Dx + x ;  
				CIRCLE_R ;

//				x1 = Dy + x ; y1 = Dx + y ;
				x1 = SCW - 1 ;		y1 = Dx + y ;
				CIRCLE_L ;

//				x1 = Dy + x ; y1 = -Dx + y;
				x1 = SCW - 1 ;		y1 = -Dx + y;
				CIRCLE_L ;

				// Wf[^i߂
				if( F >= 0 )
				{
					Dx -- ;
					F -= 4 * Dx ;
				}	

				Dy ++ ;
				F += 4 * Dy + 2 ;
			}

			while( Dx >= Dy )
			{
				x1 = -Dx + x ; y1 = Dy + y ;
				CIRCLE_L ;
				x1 = Dx + x ;  
				CIRCLE_R ;

				x1 = Dy + x ; y1 = Dx + y ;
				CIRCLE_R ;
				x1 = -Dy + x ; 
				CIRCLE_L ;
			
				x1 = Dx + x ; y1 = -Dy + y;
				CIRCLE_R ;
				x1 = -Dx + x ; 
				CIRCLE_L ;

				x1 = Dy + x ; y1 = -Dx + y;
				CIRCLE_R ;
				x1 = -Dy + x ; 
				CIRCLE_L ;

				// Wf[^i߂
				if( F >= 0 )
				{
					Dx -- ;
					F -= 4 * Dx ;
				}

				Dy ++ ;
				F += 4 * Dy + 2 ;
			}
		}
		GXEnd() ;
		
		// `悵ĂȂhԂ	
		GBGN( GX_QUADS, 8 ) ;
		{
			GP2( 0, 0 ) ; 		GXColor1u16( Color1 ) ;
			GP2( SCW, 0 ) ; 	GXColor1u16( Color1 ) ;
			GP2( SCW, top ) ;	GXColor1u16( Color1 ) ;
			GP2( 0, top ) ; 	GXColor1u16( Color1 ) ;

			GP2( 0, bottom ) ; 		GXColor1u16( Color1 ) ;
			GP2( SCW, bottom ) ; 	GXColor1u16( Color1 ) ;
			GP2( SCW, SCH ) ;		GXColor1u16( Color1 ) ;
			GP2( 0, SCH ) ; 		GXColor1u16( Color1 ) ;
		}
		GXEnd() ;
		
		// TCg̒S`
		GBGN( GX_TRIANGLEFAN, VParam[ED_SIG_HAC][8] + 2 ) ;
		{
			u16 i ;

			// S_o
			GP2( Sight2->x, Sight2->y ) ;
			GXColor1u16( GXPackedRGBA4( VParam[ED_SIG_HAC][9], VParam[ED_SIG_HAC][10], VParam[ED_SIG_HAC][11], VParam[ED_SIG_HAC][12] ) ) ;

			// ~`
			for( i = 0 ; i < VParam[ED_SIG_HAC][8] + 1 ; i ++ )
			{
				GP2( Sight2->x + cosf( PI_2 / VParam[ED_SIG_HAC][8] * i ) * VParam[ED_SIG_HAC][5],
					Sight2->y + sinf( PI_2 / VParam[ED_SIG_HAC][8] * i ) * VParam[ED_SIG_HAC][5] ) ;
				GXColor1u16( GXPackedRGBA4( VParam[ED_SIG_HAC][9], VParam[ED_SIG_HAC][10], VParam[ED_SIG_HAC][11], 0 ) ) ;
			}
		}
		GXEnd() ;
		
		// TCg̎`
		GBGN( GX_LINES, 8 ) ;
		{
			f32 Len1, Len2 ;

			Len1 = VParam[ED_SIG_HAC][13] * 0.01F * Sight2->r ;
			Len2 = VParam[ED_SIG_HAC][14] * 0.01F * Sight2->r ;
			Color1 = GXPackedRGBA4( VParam[ED_SIG_HAC][9], VParam[ED_SIG_HAC][10], VParam[ED_SIG_HAC][11], VParam[ED_SIG_HAC][12] ) ;

			// ㉺Ȅŕ`
			GP2( Sight2->x, Sight2->y - Len1 ) ;	GXColor1u16( Color1 ) ;
			GP2( Sight2->x, Sight2->y - Len2 ) ;	GXColor1u16( Color1 ) ;
			GP2( Sight2->x, Sight2->y + Len1 ) ;	GXColor1u16( Color1 ) ;
			GP2( Sight2->x, Sight2->y + Len2 ) ;	GXColor1u16( Color1 ) ;
			GP2( Sight2->x - Len1, Sight2->y ) ;	GXColor1u16( Color1 ) ;
			GP2( Sight2->x - Len2, Sight2->y ) ;	GXColor1u16( Color1 ) ;
			GP2( Sight2->x + Len1, Sight2->y ) ;	GXColor1u16( Color1 ) ;
			GP2( Sight2->x + Len2, Sight2->y ) ;	GXColor1u16( Color1 ) ;
		}
		GXEnd() ;
	}

		
	// I
	return 0 ;
}

// TCgQ̕\WύX
extern s8 SetSight2Point( s16 x, s16 y, EFFECT *Effect )
{
	SIGHT2EFFECT *Sight2 = ( SIGHT2EFFECT * )Effect->Data ;
	
	Sight2->x = x ;
	Sight2->y = y ;
	
	// I
	return 0 ;
}
	

// TCgQGtFNg`悷邩ǂ̃tOZbg
extern s8 SetSight2DrawFlag( u8 DrawFlag, EFFECT *Effect )
{
	SIGHT2EFFECT *Sight2 = ( SIGHT2EFFECT * )Effect->Data ;
	
	Sight2->DrawFlag = DrawFlag ;
	
	// I
	return 0 ;
}
	

// TCg[hɂ邩ǂZbg( TRUE:߂  FALSE:J )
extern s8 SetSight2Shutter( u8 OpenFlag, EFFECT *Effect )
{
	SIGHT2EFFECT *Sight2 = ( SIGHT2EFFECT * )Effect->Data ;

	// ݊]̏ԂƓꍇ͉I
	if( Sight2->CRTFlag == OpenFlag ) return 0 ;

	// Ⴄꍇ̓Vb^[N
	Sight2->Shutter = CreateShutterEffect( (u8)VParam[ED_SHUTTER][0], (u8)VParam[ED_SHUTTER][1], (u8)VParam[ED_SHUTTER][2] ) ;
	
	// tOZbg
	Sight2->CRTFlag = OpenFlag ;

	// I
	return 0 ;
}

// Vb^[̏Ԃ擾( 0:܂肫Ă  1:JĂ )
extern s8 GetSight2Shutter( EFFECT *Effect )
{
	SIGHT2EFFECT *Sight2 = ( SIGHT2EFFECT * )Effect->Data ;

	// Vb^[̏ԂԂ
	if( GetEffectValidState( Sight2->Shutter ) == FALSE ) Sight2->Shutter = NULL ;
	return (s8)( Sight2->Shutter != NULL ? GetShutterState( Sight2->Shutter ) : 1 ) ;
}

// TCg`悳Ă邩ǂ擾( TRUE:`悳Ă FALSE:`悳ĂȂ )
extern s8 GetSight2DrawState( EFFECT *Effect )
{
	SIGHT2EFFECT *Sight2 = ( SIGHT2EFFECT * )Effect->Data ;

	return (s8)Sight2->CRTFlagTemp ;
}