///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSight2
//
// YK7EffectSight2.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 10/07/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSIGHT2_H
#define __YK7EFFECTSIGHT2_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// TCgQGtFNgʃf[^
typedef struct tagSIGHT2UNION
{
	u8 Dummy ;
} SIGHT2UNION ;

// TCgQGtFNgf[^
typedef struct tagSIGHT2EFFECT
{
	f32 r ;							// TCg̃TCY(P:hbg)
	f32 x, y ;						// TCg̒SW
	GXColor Color ;					// F
	EFFECT *Shutter ;				// Vb^[GtFNgւ̃|C^

	u8 ShutterFlag ;				// Vb^[Ă邩tO
	u8 CRTFlag ;					// \邩tO(Vb^[ɂď𕪊)
	u8 CRTFlagTemp ;				// ݂̕\͂ǂȂĂ邩tO
	u8 DrawFlag ;					// `tO
} SIGHT2EFFECT ;

// TCgQGtFNgf[^p\
typedef struct tagSIGHT2EFFECTTASKPARAM
{
	u8 dummy ;				// ɂȂ
} SIGHT2EFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitSight2Data( void ) ;				// TCgQGtFNg̋ʃf[^
extern s8 CheckSight2Data( void ) ;				// TCgQGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndSight2Data( void ) ;				// TCgQGtFNg̋ʃf[^n

extern EFFECT *CreateSight2Effect( f32 r, GXColor Color, s32 Priority = 1800 ) ;			// TCgQGtFNg쐬
extern s8 ReleaseSight2Effect( EFFECT *Effect ) ;							// TCgQGtFNǧns
extern s8 MoveSight2Effect( EFFECT *Effect ) ;								// TCgQGtFNgPt[
extern s8 DrawSight2Effect( EFFECT *Effect ) ;								// TCgQGtFNg`悷

extern s8 SetSight2Point( s16 x, s16 y, EFFECT *Effect ) ;			// TCgQ̕\WύX
extern s8 SetSight2DrawFlag( u8 DrawFlag, EFFECT *Effect ) ;		// TCgQGtFNg`悷邩ǂ̃tOZbg
extern s8 SetSight2Shutter( u8 OpenFlag, EFFECT *Effect ) ;			// TCg[hɂ邩ǂZbg( TRUE:TCg\  FALSE:TCg\ɂ )
extern s8 GetSight2DrawState( EFFECT *Effect ) ;					// TCg`悳Ă邩ǂ擾( TRUE:`悳Ă FALSE:`悳ĂȂ )
extern s8 GetSight2Shutter( EFFECT *Effect ) ;						// Vb^[̏Ԃ擾( 0:܂肫Ă  1:JĂ )


#endif