///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSkillExe
//
// YK7EffectSkillExe.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 08/30/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectSkillExe.h"
#include "./YK7EffectWave.h"

// define ---------------------------------------

#define SCREEN_XDIVNUM			20									// ʂ̉̕
#define SCREEN_YDIVNUM			(u32)(SCREEN_XDIVNUM * 0.75F)		// ʂ̏c̕

// datatype -------------------------------------

// data -----------------------------------------

SKILLEXEUNION SkEUnion ;

// function code --------------------------------

// \͔GtFNg̋ʃf[^
extern s8 InitSkillExeData( void )
{
	MEMINIT( SkEUnion ) ;
	
	// I
	return 0 ;
}

// \͔GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckSkillExeData( void )
{
	return TRUE ;
}

// \͔GtFNg̋ʃf[^n
extern s8 EndSkillExeData( void )
{
	MEMINIT( SkEUnion ) ;
	
	// I
	return 0 ;
}


// \͔̃GtFNg쐬
extern EFFECT *CreateSkillExeEffect( Vec Point, u8 Type, s32 Priority )
{
	EFFECT *Effect ;
	SKILLEXEEFFECT *SExe ;

	// V\͔GtFNgf[^쐬
	Effect = AddEffectData( EFF_SKILLEXE, (void**)&SExe, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// f[^
	SExe->NumCounter = 0 ;
	SExe->Type = Type ;
	
	// f[^ۑ
	switch( SExe->Type )
	{
	case 0 :
		SExe->Wait = (f32)VParam[ED_SKILLEXE][9] * 0.1F ;
		SExe->WaitSub = (f32)VParam[ED_SKILLEXE][10] * 0.1F ;
		SExe->Speed = VParam[ED_SKILLEXE][4] * 0.1F ;
		SExe->AddSpeed = (f32)VParam[ED_SKILLEXE][11] * 0.1F,
		SExe->Num = (u8)VParam[ED_SKILLEXE][12] ;
		SExe->Point = Point ;
		break ;
	}

	SExe->WaitCounter = SExe->Wait ;
	
	// I
	return Effect ;
}

// \͔̃GtFNǧns
extern s8 ReleaseSkillExeEffect( EFFECT *Effect )
{
	SKILLEXEEFFECT *SExe = ( SKILLEXEEFFECT * )Effect->Data ;

	// I	
	return 0 ;
}

// \͔̃GtFNgPt[
extern s8 MoveSkillExeEffect( EFFECT *Effect )
{
	SKILLEXEEFFECT *SExe = ( SKILLEXEEFFECT * )Effect->Data ;

	// JEg
	SExe->WaitCounter += 1.0F ;

	// JE^lɗĂgGtFNg쐬
	if( SExe->WaitCounter >= SExe->Wait )
	{
		GXColor Color ;
	
		switch( SExe->Type )
		{
		case 0 :
			Color.r = (u8)VParam[ED_SKILLEXE][6] ;
			Color.g = (u8)VParam[ED_SKILLEXE][7] ;
			Color.b = (u8)VParam[ED_SKILLEXE][8] ;
			Color.a = 255 ;
		
			CreateWaveEffect( SExe->Point, 
								VParam[ED_SKILLEXE][0] * 1.0F, VParam[ED_SKILLEXE][1] * 0.1F,
								VParam[ED_SKILLEXE][2] * 1.0F, VParam[ED_SKILLEXE][3] * 0.01F,
								SExe->Speed, VParam[ED_SKILLEXE][5] * 0.01F,
								TRUE, Color, 2000 ) ;
			break ;
		}
		
		// Xs[h𑫂
		SExe->Speed += SExe->AddSpeed ;
		
		// JE^
		SExe->WaitCounter = 0.0F ;
		
		// ҂Ԃ炷
		SExe->Wait -= SExe->WaitSub ;
		if( SExe->Wait < 0.0F ) SExe->Wait = 0.0F ;
		
		// 񐔃JE^𑝂₷
		SExe->NumCounter ++ ;
		if( SExe->NumCounter == SExe->Num )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
	}
	
	// I
	return 0 ;
}
	
// \͔̃GtFNg`悷
extern s8 DrawSkillExeEffect( EFFECT *Effect )
{
	SKILLEXEEFFECT *SExe = ( SKILLEXEEFFECT * )Effect->Data ;
	
	// I
	return 0 ;
}
