///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSmokeObj2
//
// YK7EffectSmokeObj2.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/31/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectSmokeObj2.h"
#include "./YK7EffectSmokeObj.h"
#include "./YK7File.h"
#include "./YK7EffectSmoke.h"

// define ---------------------------------------

#define PRM				(s32)VParam[ED_SMOKEOBJ]


// data -----------------------------------------

SMOKEOBJ2UNION sb2u ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// IuWFNgGtFNg̋ʃf[^
extern s8 InitSmokeObj2Data( void )
{
	MEMINIT( sb2u ) ;

	return 0 ;
}

// IuWFNgGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckSmokeObj2Data( void )
{
	return TRUE ;
}

// IuWFNgGtFNg̋ʃf[^n
extern s8 EndSmokeObj2Data( void )
{
	MEMINIT( sb2u ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}



// IuWFNgGtFNg쐬
extern EFFECT *CreateSmokeObj2Effect(
								Vec start, Vec end,		// X^[gn_ƍs
								s32 smoketype1,			// ̃^Cvԍ(΍Wn)
								s32 smoketype2,			// ̃^Cvԍ(΍Wn)
								f32 speed,				// x
								s32 Priority )
{
	EFFECT *Effect, *smoke1, *smoke2 ;
	SMOKEOBJ2EFFECT *sb ;
	
	smoketype2 = smoketype2 ;	
	speed = speed ;
	
	// IuWFNg̍쐬
	smoke1 = CreateSmokeObjEffect( (u8)smoketype1, start ) ;
	if( smoke1 == NULL ) return NULL ;
//	smoke2 = CreateSmokeObjEffect( (u8)smoketype2, start ) ;
//	if( smoke2 == NULL ) return NULL ;
	smoke2 = NULL ;

	// VIuWFNgf[^쐬
	Effect = AddEffectData( EFF_SMOKEOBJ2, (void**)&sb, Priority ) ;
	if( Effect == NULL )
	{
		DeleteEffect( smoke1 ) ;
//		DeleteEffect( smoke2 ) ;
		return NULL ;
	}
	
	// lۑ
	sb->effect[0]	= smoke1 ;	sb->effectid[0]	= GetEffectID( smoke1 ) ;
//	sb->effect[1]	= smoke2 ;	sb->effectid[1]	= GetEffectID( smoke2 ) ;
	sb->start 		= start ;
	sb->end 		= end ;
	VECSubtract( &sb->end, &sb->start, &sb->dir );
	sb->rate 		= 0.0F ;
	sb->speed 		= speed ;
	sb->con			= 0 ;

	// I
	return Effect ;
}

// IuWFNgGtFNǧns
extern s8 ReleaseSmokeObj2Effect( EFFECT *Effect )
{
	SMOKEOBJ2EFFECT *sb = ( SMOKEOBJ2EFFECT * )Effect->Data ;
	s32 i ;
	
	for( i = 0 ; i < 1 ; i ++ )
		if( sb->effect[0] != NULL && CheckEffectValidState( sb->effect[0], sb->effectid[0] ) == TRUE )
			DeleteEffect( sb->effect[0] ) ;

	// I
	return 0 ;
}

// IuWFNgGtFNgPt[
extern s8 MoveSmokeObj2Effect( EFFECT *Effect )
{
	SMOKEOBJ2EFFECT *sb = ( SMOKEOBJ2EFFECT * )Effect->Data ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( Effect->DelReqFlag == TRUE )
	{
		s32 f1, f2 ;
	
		if( ( f1 = CheckEffectValidState( sb->effect[0], sb->effectid[0] ) ) == TRUE ||
			( f2 = CheckEffectValidState( sb->effect[1], sb->effectid[1] ) ) == TRUE )
		{
			if( f1 == TRUE ) DelReqEffect( sb->effect[0] ) ;
			if( f2 == TRUE ) DelReqEffect( sb->effect[1] ) ;
		}
		else
		{
			DeleteEffect( Effect ) ;
		}
		return 0 ;
	}
	
	// ړ
	sb->rate += sb->speed ;
	if( sb->rate > 1.0F )
	{
		sb->rate = 1.0F ;
		DelReqEffect( Effect ) ;
	}
	
	// W̃Zbg
	{
		Vec v ;
		
		v.x = sb->start.x + sb->dir.x * sb->rate ;
		v.y = sb->start.y + sb->dir.y * sb->rate ;
		v.z = sb->start.z + sb->dir.z * sb->rate ;
		
		SetSmokeObjEffectPos( sb->effect[0], v ) ;
//		SetSmokeObjEffectPos( sb->effect[1], v ) ;
	}

	// I
	return 0 ;
}

// IuWFNgGtFNg`悷
extern s8 DrawSmokeObj2Effect( EFFECT *Effect )
{
	SMOKEOBJ2EFFECT *sb = ( SMOKEOBJ2EFFECT * )Effect->Data ;

	// I
	return 0 ;
}

const u16 _SB2Table[][3] =
{
	{	// 0:775M01p
		0,		1,		10,
	},
} ;


// IuWFNgGtFNg쐬
extern EFFECT *CreateSmokeObj2Effect(
								u8 type,
								Vec start, Vec end,
								s32 Priority )
{
	if( type == 0 )
	{
		return CreateSmokeObj2Effect(
								start, end,			// X^[gn_ƍs
								(s32)PRM[20],		// ̃^Cvԍ(΍Wn)
								(s32)PRM[21],		// ̃^Cvԍ(΍Wn)
								PRM[22] * 0.01F,	// x
								Priority ) ;			// IuWFNgGtFNg쐬
	}
	else
	{
		type -- ;
		return CreateSmokeObj2Effect(
								start, end,			// X^[gn_ƍs
								(s32)_SB2Table[type][0],	// ̃^Cvԍ(΍Wn)
								(s32)_SB2Table[type][1],	// ̃^Cvԍ(΍Wn)
								_SB2Table[type][2] * 0.01F,	// x
								Priority ) ;			// IuWFNgGtFNg쐬
	}
	
	return NULL ;
}




