///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSnow
//
// YK7EffectSnow.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 12/02/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSNOW_H
#define __YK7EFFECTSNOW_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// GtFNgʃf[^
typedef struct tagSNOWUNION
{
	TEXDATA SnowTex ;							// ̃eNX`f[^
	s8 NotAllDrawFlag ;					// `tO
} SNOWUNION ;

// IuWFNgf[^
typedef struct tagSNOWOBJECT
{
	u8 ValidFlag ;				// LtO
	u8 BotFlag ;				// ntO
	Vec Point ;					// W
	Vec Speed ;					// Xs[h
	f32 Rot ;					// Ԃ]
	f32 RotSp ;					// Ԃ]x
	f32 BureWidth ;				// Ԃꕝ
	u16 Counter ;				// JE^[
} SNOWOBJECT ;

// GtFNgf[^
typedef struct tagSNOWEFFECT
{
	SNOWOBJECT *ObjP ;				// IuWFNgf[^zւ̃|C^
	u16 *RenderList ;				// `惊Xg
	u16 RenderNum ;					// `搔
	u16 *BotRenderList ;			// nXg
	u16 BotRenderNum ;				// n
	u16 ObjNum ;					// IuWFNg̐
	u16 Counter ;					// pJE^[
	u8 Mode ;						// `惂[h(0:Add  1:Alpha)

	u16 MaxObjNum ;					// IuWFNg̍ő吔
	Vec Point ;						// W
	f32 MaxSpeed, MinSpeed ;		// Ⴊ鑬x
	f32 MaxRotSpeed, MinRotSpeed ;	// ႪԂ鑬x
	f32 MaxBureWidth, MinBureWidth ;// Ԃ̕
	f32 SnowR ;						// Ⴊ~锼a
	f32 YukaY ;						// ̍
	GXColor Color ;					// F

	f32 SnowCounter ;				// ~点JE^
	f32 OneSnowPoint ;				// ႪꖇôɕKvȃJEgl

	s32 ValidCounter ;
} SNOWEFFECT ;

// GtFNg^XNɓnf[^
typedef struct tagSNOWEFFECTTACKPARAM
{
	Vec Point ;						// GtFNg郏[hW
	f32 YukaY ;						// ̍
	f32 MaxSpeed, MinSpeed ;		// Ⴊ鑬x
	f32 MaxRotSpeed, MinRotSpeed ;	// ႪԂ鑬x
	f32 SnowR ;						// Ⴊ~锼a
	u16 MaxNum ;					// IuWFNg̍ő吔
	GXColor *Color ;				// F
} SNOWEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitSnowData( void ) ;				// GtFNg̋ʃf[^
extern s8 CheckSnowData( void ) ;				// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndSnowData( void ) ;					// GtFNg̋ʃf[^n

extern EFFECT *CreateSnowEffect( Vec Point, f32 YukaY,
									f32 MaxSpeed, f32 MinSpeed,
									f32 MaxRotSpeed, f32 MinRotSpeed,
									f32 MaxBureWidth, f32 MinBureWidth,
									f32 SnowR, u16 MaxNum,
									GXColor *Color, s32 Priority = -1 ) ;			// ̃GtFNg쐬
extern s8 ReleaseSnowEffect( EFFECT *Effect ) ;							// ̃GtFNǧns
extern s8 MoveSnowEffect( EFFECT *Effect ) ;							// ̃GtFNgPt[
extern s8 DrawSnowEffect( EFFECT *Effect ) ;							// ̃GtFNg`悷

extern s8 SetSnowEffectPoint( EFFECT *Effect, Vec Point ) ;				// Ⴊ钆S_ύX

extern s8 SetSnowAllDrawFlag( s8 Flag ) ;				// GtFNg̑SĂ`悷邩ǂݒ肷

#endif

