///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectTime
//
// YK7EffectTime.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/08/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTTIME_H
#define __YK7EFFECTTIME_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------
#define VIBTIME			(6)

// datatype -------------------------------------

typedef struct tagVIBTABLE
{
	f32 ex ;
	s8 x, y ;
} VIBTABLE ;

// ԕ\GtFNgʃf[^
typedef struct tagTIMEUNION
{
	TEXDATA numtex[2][9] ;		// ԍ̃eNX`(0:u[ 1:)
	TEXDATA num0tex[4] ;		// ԍÕeNX`
	TEXDATA num0blur ;			// ԍÕu[eNX`
	TEXDATA hittex[2] ;			// qbgƂ̃eNX`(0:u[  1:)
	TEXDATA colontex[2] ;		// u:ṽeNX`(0:u[ 1:)
} TIMEUNION ;

// ԕ\GtFNgf[^
typedef struct tagTIMEEFFECT
{
	s32 frame ;			// c莞
	u32 vibcounter ;	// h炵JE^[
	bool vibflag ;		// hĂtO
	bool posvibflag ;
	bool endflag ;
	
	u16 brinktime ;
	f32 exrate ;
	
	f32 alpha ;
	bool stopflag ;
} TIMEEFFECT ;

// ԕ\GtFNg^XNɓnf[^
typedef struct tagTIMEEFFECTTACKPARAM
{
	u32 Time ;				// b
} TIMEEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitTimeData( void ) ;			// ԕ\GtFNg̋ʃf[^
extern s8 CheckTimeData( void ) ;			// ԕ\GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndTimeData( void ) ;				// ԕ\GtFNg̋ʃf[^n

extern EFFECT *CreateTimeEffect(
									u32 Time,				// b
									s32 Priority = -1 ) ;	// ԕ\GtFNg쐬

extern s8 ReleaseTimeEffect( EFFECT *Effect ) ;		// ԕ\GtFNǧns
extern s8 MoveTimeEffect( EFFECT *Effect ) ;		// ԕ\GtFNgPt[
extern s8 DrawTimeEffect( EFFECT *Effect ) ;		// ԕ\GtFNg`悷

extern s8 GetTimeEffectState( EFFECT *Effect ) ;	// ԕ\GtFNg̏Ԃ𓾂( 0:X^[g҂  1:JEg_E  2:~ )
extern s8 StartTimeEffect( EFFECT *Effect ) ;		// JEgJn
extern s8 PauseTimeEffect( EFFECT *Effect ) ;		// JEg~

#endif

