///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectVLoss
//
// YK7EffectVLoss.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/02/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectVLoss.h"
#include "./YK7EffectBlood.h"
#include "./YK7EffectConveBlood.h"
#include "../Wat/WK7MainTask.h"
#include "../matsu/mk7Sound.h"

// define ---------------------------------------

#define TEST_TEXTURE "/yam/wall4.BIN"		// eXgpeNX`

// datatype -------------------------------------

// data -----------------------------------------

VLOSSUNION VUnion ;

// function code --------------------------------

#if 0

// uGtFNg̋ʃf[^
extern s8 InitVLossData( void )
{
	TEXTURE *Tex ;
	s32 Size ;
	DVDFileInfo FileInfo ;
	VLOSSUNION *VLossUnion = &VUnion ;

	MEMINIT(VUnion);

	// bṼeNX`[ǂݍ
	Tex = &VLossUnion->TestTex ;

	// eNX`t@CJ
	if( DVDOpen( TEST_TEXTURE, &FileInfo ) == GX_FALSE )
		 return -1 ;

	// t@C̃TCY𓾂
	Size = (s32)OSRoundUp32B( DVDGetLength( &FileInfo ) ) ;

	// mۂ
	Tex->Header = ( GhmGcTexHeader * )ghmGcMemAlloc( Size ) ;
	if( Tex->Header == NULL )
		return -1 ;

	// ۂƃ[h
	DVDRead( &FileInfo, Tex->Header, Size, 0 ) ;

	// t@C
	DVDClose( &FileInfo ) ;

	// eNX`쐬
	GXInitTexObj( &Tex->Obj, GHMGCTEX_GETIMAGE(Tex->Header),
					 Tex->Header->mWidth, Tex->Header->mHeight, Tex->Header->mFormat,
					  GX_REPEAT, GX_REPEAT, GX_FALSE ) ;
	GXInitTexObjLOD( &Tex->Obj, GX_LINEAR, GX_LINEAR, Tex->Header->mMinLOD, Tex->Header->mMaxLOD, 0.0F,
						GX_FALSE, GX_FALSE, GX_ANISO_1 ) ;

	// I
	return 0 ;
}

// uGtFNg̋ʃf[^n
extern s8 EndVLossData( void )
{
	VLOSSUNION *VLossUnion = &VUnion ;
	
	// eNX`̃J
	ghmGcMemFree( VLossUnion->TestTex.Header ) ;
	
	// I
	return 0 ;
}




// uGtFNg쐬
extern EFFECT *CreateVLossEffect( HSD_PObj *PObj, Vec Point, f32 YukaHeight, s32 Priority )
{
	EFFECT *Effect ;
	VLOSSEFFECT *VLossP ;
	
	// VbVf[^쐬
	Effect = AddEffectData( EFF_VLOSS, (void**)&VLossP, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// bVf[^ƊȈՃbVf[^쐬
	CreatePrimitiveMeshData( PObj, &VLossP->Mesh ) ;
	DismemberPrimitiveMeshData( VLossP->Mesh, &VLossP->BasMesh ) ;
	
	// h炷
	CreateImpactEffect( 10, 5, (Vec){0.0F, 0.0F, 0.0F}, 10, 0, TRUE ) ;
	
	// uf[^
	VLossP->Point = Point ;
	VLossP->Counter = 0 ;
	
	YukaHeight = YukaHeight ;		// dummy
//	VLossP->YukaHeight = YukaHeight ;
//	VLossP->ObjectNum = ( u32 )( VLossP->BasMesh.IndexNum / ( 8 * 3 ) ) ;
//	VLossP->Object = ( VLOSSOBJ * )ghmGcMemAlloc( (s32)( sizeof( VLOSSOBJ ) * VLossP->ObjectNum ) ) ;
//	if( VLossP->Object == NULL ) return NULL ;

	// bVf[^i[郁̈쐬
/*	VLossP->BasMesh = ( BASICMESH * )ghmGcMemAlloc( sizeof( BASICMESH ) ) ;
	if( VLossP->BasMesh == NULL ) return NULL ;
	VLossP->BasMesh->VertexNum = BasMesh->VertexNum ;
	VLossP->BasMesh->Vert = ( BASVERT * )ghmGcMemAlloc( (s32)( sizeof( BASVERT ) * BasMesh->VertexNum ) ) ;
	if( VLossP->BasMesh->Vert == NULL ) return NULL ;
	memcpy( VLossP->BasMesh->Vert, BasMesh->Vert, sizeof( BASVERT ) * BasMesh->VertexNum ) ;
	VLossP->BasMesh->IndexNum = BasMesh->IndexNum ;
	VLossP->BasMesh->Index = ( u16 * )ghmGcMemAlloc( (s32)( sizeof( u16 ) * BasMesh->IndexNum ) ) ;
	if( VLossP->BasMesh->Index == NULL ) return NULL ;
	memcpy( VLossP->BasMesh->Index, BasMesh->Index, sizeof( u16 ) * BasMesh->IndexNum ) ;
*/
	// IuWFNgf[^pɕϊ
/*	{
		BASVERT *Vert ;
		Vec temp ;
		u32 Num, i ;

		Num = VLossP->BasMesh.VertexNum / 6U ;
		Vert = VLossP->BasMesh.Vert ;
		for( i = 0 ; i < Num ; i ++, Vert += 6 )
		{
			temp.x = ( Vert[0].Point.x + Vert[1].Point.x + Vert[2].Point.x +
					   Vert[3].Point.x + Vert[4].Point.x + Vert[5].Point.x ) / 6.0F ;
			temp.y = ( Vert[0].Point.y + Vert[1].Point.y + Vert[2].Point.y +
					   Vert[3].Point.y + Vert[4].Point.y + Vert[5].Point.y ) / 6.0F ;
			temp.z = ( Vert[0].Point.z + Vert[1].Point.z + Vert[2].Point.z +
					   Vert[3].Point.z + Vert[4].Point.z + Vert[5].Point.z ) / 6.0F ;
			Vert[0].Point.x -= temp.x ;	Vert[0].Point.y -= temp.y ;	Vert[0].Point.z -= temp.z ;
			Vert[1].Point.x -= temp.x ;	Vert[1].Point.y -= temp.y ;	Vert[1].Point.z -= temp.z ;
			Vert[2].Point.x -= temp.x ;	Vert[2].Point.y -= temp.y ;	Vert[2].Point.z -= temp.z ;
			Vert[3].Point.x -= temp.x ;	Vert[3].Point.y -= temp.y ;	Vert[3].Point.z -= temp.z ;
			Vert[4].Point.x -= temp.x ;	Vert[4].Point.y -= temp.y ;	Vert[4].Point.z -= temp.z ;
			Vert[5].Point.x -= temp.x ;	Vert[5].Point.y -= temp.y ;	Vert[5].Point.z -= temp.z ;

			VLossP->Object[i].Point.x = temp.x + VLossP->Point.x ;
			VLossP->Object[i].Point.y = temp.y + VLossP->Point.y ;
			VLossP->Object[i].Point.z = temp.z + VLossP->Point.z ;
			VECNormalize( &temp, &temp ) ;
			VECScale( &temp, &temp, 0.04F ) ;
			VLossP->Object[i].Speed = temp ;
		}
	}
*/	
	// bVf[^̒_f[^k
/*	{
		Vec *Point ;
		u16 i, Num ;
		
		Point = VLossP->Mesh.Point ;
		Num = VLossP->Mesh.PointNum ;
		for( i = 0 ; i < Num ; i ++, Point ++ )
		{
			Point->x *= 0.8F ;	Point->y *= 0.8F ;	Point->z *= 0.8F ;
		}
	}
*/
	// f[^LbVtbV
//	DCStoreRange( VLossP->BasMesh.Vert, sizeof( BASVERT ) * VLossP->BasMesh.VertexNum ) ;
//	DCStoreRange( VLossP->BasMesh.Index, sizeof( u16 ) * VLossP->BasMesh.IndexNum ) ;
//	DCStoreRange( VLossP->Mesh.Point, sizeof( Vec ) * VLossP->Mesh.PointNum ) ;

	// I
	return Effect ;
}

// uGtFNǧns
extern s8 ReleaseVLossEffect( EFFECT *Effect )
{
	VLOSSEFFECT *VLossEffect = ( VLOSSEFFECT * )Effect->Data ;

	// ȈՃbVf[^ƃbVf[^̌ns
	DeleteBasicMeshData( VLossEffect->BasMesh ) ;
	DeletePrimitiveMeshData( VLossEffect->Mesh ) ;	
	
	// eIuWFNg̍WێĂ̈J
//	ghmGcMemFree( VLossEffect->Object ) ;

	// I
	return 0 ;
}

// uGtFNgPt[
extern s8 MoveVLossEffect( EFFECT *Effect )
{
	VLOSSEFFECT *VLossEffect = ( VLOSSEFFECT * )Effect->Data ;

	// ɂ邱ƂȂ	
	VLossEffect->Counter ++ ;

	// I
	return 0 ;
}

// uGtFNg`悷
extern s8 DrawVLossEffect( EFFECT *Effect )
{
	VLOSSEFFECT *VLossEffect = ( VLOSSEFFECT * )Effect->Data ;
	Mtx View ;
	HSD_CObj *Camera ;
	BASICMESH *BasMesh ;
	GXLightObj Light ;
	VLOSSUNION *VLossUnion = &VUnion ;

	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;

	// J̏擾
	Camera = GetEffectCamera() ;
	
	// bṼ|C^Ă
	BasMesh = VLossEffect->BasMesh ;

	// CgIuWFNg̃Zbg
	GXInitLightColor( &Light, (GXColor){255, 255, 255, 255} ) ;
	GXInitLightPos( &Light, sin( PI / 20 * VLossEffect->Counter ) * 100000.0F,
							cos( PI / 20 * VLossEffect->Counter ) * 100000.0F, 100000.0F ) ;
	GXInitLightDir( &Light, (f32) -sin( PI / 20 * VLossEffect->Counter ),
							(f32) -cos( PI / 20 * VLossEffect->Counter ), -1.0F ) ;
	GXInitLightSpot( &Light, 0.0F, GX_SP_OFF ) ;
	GXInitLightDistAttn( &Light, 0.0F, 0.0F, GX_DA_OFF ) ;
	GXLoadLightObjImm( &Light, GX_LIGHT1 ) ;

	// J[̐ݒ
    GXSetNumChans(1);
    GXSetAlphaCompare( GX_GREATER, 20, GX_AOP_AND, GX_ALWAYS, 0);
    GXSetChanAmbColor( GX_COLOR0A0, (GXColor){128, 128, 128, 255} ) ;
    GXSetChanMatColor( GX_COLOR0A0, (GXColor){128, 128, 128, 255} ) ;
    GXSetChanCtrl( GX_COLOR0A0, GX_ENABLE, GX_SRC_REG, GX_SRC_REG,
  				GX_LIGHT1, GX_DF_CLAMP, GX_AF_SPOT ) ;

	// _tH[}bg̃Zbg
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_NRM, GX_NRM_XYZ, GX_F32, 0 ) ;

	// Zobt@̓샂[hݒ肷
	GXSetZMode( GX_TRUE, GX_LEQUAL, GX_TRUE ) ;

	// bVf[^`悷
	{
		MESH *Mesh = VLossEffect->Mesh ;

		// r[}gbNXZbg
		{
			Mtx temp ;
			
			MTXTrans( temp, VLossEffect->Point.x, VLossEffect->Point.y, VLossEffect->Point.z ) ;

			// r[s擾
			HSD_CObjGetViewingMtx( Camera, View ) ; 
			
			MTXConcat( View, temp, View ) ;

			// }gbNXZbg
			GXLoadPosMtxImm( View, 0 ) ;
			GXLoadNrmMtxImm( View, 0 ) ;
			GXSetCurrentMtx( 0 ) ;
		}
		
		// GXFIFOɓnf[^̃Zbg	
	    GXClearVtxDesc();
		GXSetVtxDesc(GX_VA_POS, GX_INDEX16) ;
		GXSetVtxDesc(GX_VA_NRM, GX_INDEX16) ;
		GXSetVtxDesc(GX_VA_TEX0, GX_INDEX16) ;

		// eNX`̃[h
		GTLOAD( &VLossUnion->TestTex.Obj ) ;
		
		// ACZbg
		GXSetArray( GX_VA_POS, Mesh->Point, sizeof( Vec ) ) ;
		GXSetArray( GX_VA_NRM, Mesh->Normal, sizeof( Vec ) ) ;
		GXSetArray( GX_VA_TEX0, Mesh->Uv, sizeof( UV ) ) ;

		// `Jn
		GXBegin( Mesh->PrimitiveType, GX_VTXFMT0, Mesh->IndexDataNum ) ;
		{
			u32 i, Num ;
			
			Num = Mesh->IndexDataNum ;
			for( i = 0 ; i < Num ; i ++ )
			{
				GXPosition1x16( Mesh->PointIndex[i] ) ;
				GXNormal1x16( Mesh->NormalIndex[i] ) ;
				GXTexCoord1x16( Mesh->UvIndex[i] ) ;
			}
		}
		GXEnd() ;
	}
	
	// I
	return 0 ;
}					

#else


// uGtFNg̋ʃf[^
extern s8 InitVLossData( void )
{
	MEMINIT(VUnion) ;

	// I
	return 0 ;
}

// uGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckVLossData( void )
{
	return TRUE ;
}	


// uGtFNg̋ʃf[^n
extern s8 EndVLossData( void )
{
	MEMINIT(VUnion) ;

	// I
	return 0 ;
}




// uGtFNg쐬
extern EFFECT *CreateVLossEffect( WK7JObj *JObj, Vec Direction, f32 Power, f32 YukaY,
									u16 BloodNum, u8 Wait,
									u8 ConveFlag, u8 ConveWaitTime, f32 ConvePower,
									u8 BloodTexNumber, s32 Priority )
{
	EFFECT *Effect ;
	GXColor Color1, Color2 ;
	f32 CPower ;
	u8 Time, Flag ;
	
	// j󉹂炷
	{
		Vec Point ;
		
		Point.x = JObj->GetJObj()->mtx[0][3] ;
		Point.y = JObj->GetJObj()->mtx[1][3] ;
		Point.z = JObj->GetJObj()->mtx[2][3] ;
//		PlayEffectSE( SFX_BT_DAN_SYAGEKI ) ;
		if( GetEffectSoundOffFlag() == FALSE ) PlayEffectSE3D( SFX_BT_WEAK_DEATH, Point, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env ) ;
	}
	
	// 
	if( ConveFlag == FALSE )
	{
		Flag = (u8)GetConveBloodFlag() ;
		Time = (u8)VParam[ED_CBLOOD][2];
		CPower = VParam[ED_CBLOOD][1] * 0.0001F ;
	}
	else
	{
		Flag = ConveFlag ;
		Time = ConveWaitTime ;
		CPower = ConvePower ;
	}
		
	// l̃GtFNg𔭐
	Color1.r = (u8)VParam[ED_VLS][9] ;	Color1.g = (u8)VParam[ED_VLS][10] ;	Color1.b = (u8)VParam[ED_VLS][11] ;
	Color2.r = (u8)VParam[ED_VLS][12] ;	Color2.g = (u8)VParam[ED_VLS][13] ;	Color2.b = (u8)VParam[ED_VLS][14] ;
	Effect = CreateVLossBloodEffect( JObj->GetJObj(), Direction, Power, 0.0F,
									BloodNum, YukaY, TRUE,
									0.1F, 0.5F,
									PI / 4.0F, 0.32F * VParam[ED_VLS][5] * 0.01F, 2, Wait,
									VParam[ED_VLS][3], VParam[ED_VLS][4],
									0.0F, 0.0F, 0.0F,
									VParam[ED_VLS][6],
									Color1, Color2,
									VParam[ED_VLS][8], (u8)VParam[ED_VLS][15],
									0.0F, -1,
									VParam[ED_VLS][16], VParam[ED_VLS][17],
									Flag, Time, CPower,
									BloodTexNumber, TRUE, Priority ) ;

	// I
	return Effect ;
}

// uGtFNǧns
extern s8 ReleaseVLossEffect( EFFECT *Effect )
{
	VLOSSEFFECT *VLossEffect = ( VLOSSEFFECT * )Effect->Data ;

	// I
	return 0 ;
}

// uGtFNgPt[
extern s8 MoveVLossEffect( EFFECT *Effect )
{
	VLOSSEFFECT *VLossEffect = ( VLOSSEFFECT * )Effect->Data ;

	// I
	return 0 ;
}

// uGtFNg`悷
extern s8 DrawVLossEffect( EFFECT *Effect )
{
	VLOSSEFFECT *VLossEffect = ( VLOSSEFFECT * )Effect->Data ;
	
	// I
	return 0 ;
}					

#endif
