///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectWash
//
// YK7EffectWash.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/08/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTWASH_H
#define __YK7EFFECTWASH_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"

// define ---------------------------------------

// datatype -------------------------------------

// EHbVGtFNgʃf[^
typedef struct tagWASHUNION
{
	TEXDATA WashTex ;
} WASHUNION ;

// EHbVIuWFNgf[^
typedef struct tagWASHOBJECT
{
	u8 validf ;			// LtO
	Vec pos ;			// W
	Vec speed ;			// x
} WASHOBJECT ;

// EHbVGtFNgf[^
typedef struct tagWASHEFFECT
{
	WASHOBJECT *Obj ;			// IuWFNg
	s32 ObjNum ;				// IuWFNg̐
	s32 MaxNum ;				// ő吔
	f32 CreateRate ;			// IuWFNg쐬鑬x
	f32 CreateCounter ;			// IuWFNg쐬鎞ɎgpJE^[
	
	WK7JObj *JObj ;				// EIbV̍ŏʈʒuW JObj
	f32 Len ;					// EIbV̒
	
	f32 YukaY ;					// ̍
	
	f32 SpeedRate ;				// Xs[hɑ΂oCAX
	f32 Gravity ;				// d
	f32 MaxSpeed, MinSpeed ;	// ő呬xAŏx

	u32 color ;					// F
	f32 colorrate ;				// F̃uh( 1.0F:color2  0.0F:color1 )
	GXColor color1 ;			// FP
	GXColor color2 ;			// FQ
} WASHEFFECT ;

// prototype ------------------------------------

extern s8 InitWashData( void ) ;			// EHbVGtFNg̋ʃf[^
extern s8 CheckWashData( void ) ;			// EHbVGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndWashData( void ) ;				// EHbVGtFNg̋ʃf[^n

extern EFFECT *CreateWashEffect(
						s32 MaxNum,					// ő吔
						f32 CreateRate,				// IuWFNg쐬鑬x
						
						WK7JObj *JObj,				// EIbV̍ŏʈʒuW JObj
						f32 Len,					// EIbV̒

						f32 YukaY,					// ̍

						f32 Gravity,				// d
						f32 MaxSpeed, f32 MinSpeed,	// ő呬xAŏx

						GXColor color1,				// FP
						GXColor color2,				// FQ
						s32 Priority = -1 ) ;		// EHbVGtFNg쐬

extern s8 ReleaseWashEffect( EFFECT *Effect ) ;							// EHbVGtFNǧns
extern s8 MoveWashEffect( EFFECT *Effect ) ;							// EHbVGtFNgPt[
extern s8 DrawWashEffect( EFFECT *Effect ) ;							// EHbVGtFNg`悷

extern s8 SetWashSpeedRate( EFFECT *Effect, f32 rate ) ;				// EHbṼXs[hɑ΂oCAXZbg
extern s8 SetWashColorRate( EFFECT *Effect, f32 colorrate ) ;			// EIbV̐F̊ύX

#endif

