///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectWind
//
// YK7EffectWind.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/26/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTWIND_H
#define __YK7EFFECTWIND_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"

// define ---------------------------------------

#define WIND_AIMAGENUM		(10)

// datatype -------------------------------------

// GtFNgʃf[^
typedef struct tagWINDUNION
{
	u8 Dummy ;
} WINDUNION ;

// IuWFNgf[^
typedef struct tagWINDOBJECT
{
	u8 valid ;					// L
	
	Vec pos[WIND_AIMAGENUM] ;	// W
	Vec dir ;					// 
	
	f32 alpha ;					// At@l
} WINDOBJECT ;

// GtFNgf[^
typedef struct tagWINDEFFECT
{
	WINDOBJECT *obj ;		// IuWFNg̃|C^
	s32 objnum ;			// IuWFNg̐
	s32 objmaxnum ;			// IuWFNg̍ő吔

	Vec pos ;				// SW
	f32 r ;					// a

	f32 speed ;				// x
	Vec dir ;				// 
	Vec adddir ; 			// Z
	Vec xv, yv, zv ;		// ɑ΂R
	
	f32 alpha ;				// At@
	f32 alphaspeed ;		// At@Xs[h
	
	f32 crerate ;			// 쐬x
	f32 crecounter ;		// 쐬JE^[
	
	f32 basealpha ;			// {̃At@l
	
	u32 color ;				// F
} WINDEFFECT ;

// prototype ------------------------------------

extern s8 InitWindData( void ) ;		// GtFNg̋ʃf[^
extern s8 CheckWindData( void ) ;		// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndWindData( void ) ;			// GtFNg̋ʃf[^n

extern EFFECT *CreateWindEffect(
								s32 objmaxnum,			// IuWFNg̍ő吔

								Vec pos,				// SW
								f32 r,					// a

								f32 speed,				// x
								Vec dir,				// 
								Vec adddir, 			// Z

								s32 lifetime,			// \
								f32 alphaspeed,			// At@Xs[h

								f32 crerate,			// 쐬x

								u32 color,				// F
								s32 Priority = -130 ) ;	// GtFNg쐬
extern s8 ReleaseWindEffect( EFFECT *Effect ) ;		// GtFNǧns
extern s8 MoveWindEffect( EFFECT *Effect ) ;			// GtFNgPt[
extern s8 DrawWindEffect( EFFECT *Effect ) ;			// GtFNg`悷

extern s8 SetWindEffectStart( EFFECT *Effect ) ;		// GtFNgJn

#endif

