// ============================================================================
//
//		Ԑڏ⏕NX
//
//	YK7Move.h
//
//	Creator			: Takumi Yamada(GHM)
//	Creation Date	: 02/24/04
//
// ============================================================================

#define __MODE

#ifndef __CMOVE
#define __CMOVE

// include --------------------------------------
//#include <types.h>
#include <math.h>
#include <string.h>

// define ---------------------------------------

// ZkLq}N`
#ifndef u32
#define u32				unsigned long
#endif

#ifndef u16
#define u16				unsigned short
#endif

#ifndef u8
#define u8				unsigned char
#endif


#ifndef s32
#define s32				signed long
#endif

#ifndef s16
#define s16				signed short
#endif

#ifndef s8
#define s8				signed char
#endif

#ifndef f32
#define f32				float
#endif

#ifndef f64
#define f64				double 
#endif

#ifndef NULL
#define NULL			(0)
#endif

// ֐錾ȗp
#define CMOVF(x)			static void x##init( CMov *cm ) ; static void x##proc( CMov *cm ) ; static bool x##eop( CMov *cm ) ;

// ԐڏNX buf ȊÕf[^
#define CMOVSIZE	\
(\
4 * 3 +		/* f32 x, y, z ; W */ \
4 * 3 +		/* f32 xt, yt, zt ; ꎞۑpWl */ \
1 +			/* u8 Type ; ڕ@ */ \
4 * 3 +		/* f32 mx, my, mz ; ڕWW */ \
4 +			/* f32 time ; ړɗv鎞(Gc) */ \
4 +			/* f32 speed ; Xs[h */ \
4 +			/* f32 sspeed ; x */ \
4 +			/* CMOVFUNC *func ;	gp̏Ԑڏ֐Q|C^\̂ւ̃|C^ */ \
1 +			/* u8 state ;  */ \
4 +			/* f32 count ; JE^ */ \
1 +			/* u8 singlef ; XlgĂȂAtO */ \
4 			/* class CMov *c ; qړ⏕NX */ \
)




// data type ------------------------------------

class CMov ;		// O錾

// Ԑڏ֐Q|C^\
typedef struct tagCMOVFUNC
{
	void (*init)( CMov *cm ) ;
	void (*proc)( CMov *cm ) ;
	bool (*eop)( CMov *cm ) ;
} CMOVFUNC ;

// data -----------------------------------------

// class ----------------------------------------

// Ԑڕ⏕NX
class CMov
{
public :
	f32 x, y, z ;			// W

protected :
	f32 xt, yt, zt ;			// ꎞۑpWl
	u8 Type ;					// ڕ@
	f32 mx, my, mz ;			// ڕWW
	f32 time ;					// ړɗv鎞(Gc)
	f32 speed ;					// Xs[h
	f32 sspeed ;				// x
	CMOVFUNC *func ;			// gp̏Ԑڏ֐Q|C^\̂ւ̃|C^
	u8 state ;					// 
	f32 count ;					// JE^
	u8 singlef ;				// XlgĂȂAtO
	class CMov *c ;				// qړ⏕NX
	u8 buf[CMOVSIZE] ;			// qNXpobt@

	inline void getsa( f32 &sx, f32 &sy, f32 &sz ) ;	// ڕWlƌݒn̍𓾂
	inline void getdir( f32 &dx, f32 &dy, f32 &dz ) ;	// ڕWlɌKꂽxNg𓾂
	inline void movpos( f32 len ) ;						// ڕWlɌĎw苗ړ
	inline void csetup( void ) ;						// qg߂̃ZbgAbvs
	inline void copycpos( void ) ;						// q̈ړ⏕NX̍Wëړ⏕NXɃRs[

public :

	CMov(){} ;
	~CMov(){} ;

	f32 getlen( void ) ;							// ڕWl܂ł̒𓾂
	
	void init( bool singleflag = false ) ;										// 삵Ȃ悤ɂ
	void spos( f32 X, f32 Y = 0.0F, f32 Z = 0.0F )								// WlZbg
	{ x = X ; y = Y ; z = Z ; func = NULL ; }
	void spos2( f32 X, f32 Y = 0.0F, f32 Z = 0.0F )								// WlZbg(Βlw)
	{ x += X ; y += Y ; z += Z ; func = NULL ; }
	void mov( u8 type, f32 Time, f32 X, f32 Y = 0.0F, f32 Z = 0.0F ) ;			// ړJn
	void proc( void ){ if( func != NULL ) func->proc( this ) ; }				// ړ
	bool eop( void ){ return ( func != NULL ) ? func->eop( this ) : true ;}		// ړIԂ𓾂( true:I  false:܂ )
	void movend( void ) ;														// ړI
	void setSingle( void ){ singlef = 1 ; }										// wgȂtO𗧂Ă

	CMOVF(m1)		// w莞ԓ`ړ
	CMOVF(m2)		// Zړ
	CMOVF(m3)		// w葬x`ړ
	CMOVF(m4)		// ړ
	CMOVF(m5)		// wxړ
	CMOVF(m6)		// ړ㊄Zړ
	CMOVF(m7)		// ʂ߂ړ
	CMOVF(m8)		// ړ
	CMOVF(m9)		// ʂ߂ړ2
	CMOVF(m10)		// ʂ߂ړ3
	CMOVF(m11)		// I_ړ
	CMOVF(m12)		// I_ړ
} ;

#endif	// __CMOVE

