#ifndef ___C_BLOODLINES_H___
#define ___C_BLOODLINES_H___

//#include "common.h"
#include "c_envelope.h"
#include "c_seawead.h"

//CvOgāA̃^Cv̌ւB
//type1,RXgĈȂ́B
//type2,AtɃRXgCꂽ́B

class C_BloodLine{
  friend class C_BloodLines;
 public:
 private:
  C_SeaWead *seawead;
  s16 tri_idx;
  u16 kill_frm;
  u16 counter;
  u16 val;
  f32 length;
};
class C_BloodLines{
 public:
  C_BloodLines( HSD_JObj *_body_jobj, HSD_JObj *_tgt_jobj, s32 _num_type1, s32 _num_type2 );
  ~C_BloodLines();
  void Proc( void );
  void Disp( void );
  void DispEnvelope( void ) {envelope->Disp();}
  void DispEnvelopeNodePos( void ) {envelope->DispNodePos();}
  void Start( void );
  void Stop( void );
  void Kill( void );
  bool IsStarted( void ){ return started; }
  void SetFun( C_Vec &w, C_Vec &f ){ 
	if( fun_flg == 2 ) return;
	else{
	  fun_pos[fun_flg] = w; fun_force[fun_flg++] = f;
	}
  }
  C_Vec GetPos( s32 type, s32 no );
  void SetTip( const C_Vec &t_ ){ tip_pos = t_; tip_flg = true;}
  bool IsTipReached( void ) const {return tip_reached;}
 private:
  HSD_JObj *tgt_jobj;
  C_Envelope *envelope;
  C_BloodLine *type1;
  C_BloodLine *type2;
  s32 num_type1;
  s32 num_type2;
  bool started;
  s32 fun_flg;
  C_Vec fun_pos[2],fun_force[2];
  C_Vec tip_pos;
  bool tip_flg;
  bool tip_reached;
  s32 killed;
};
#endif
