#ifndef ___C_EDGE_H___
#define ___C_EDGE_H___
//#include "common.h"
#include "c_vec.h"
#include "vector.h"
#include "c_trigon.h"

class C_Edge{
 public:
  C_Edge( C_Vec p0, C_Vec p1, s16 i0, s16 i1 ){
	p[0] = p0; p[1] = p1;
	v_idx[0] = i0; v_idx[1] = i1;
	//lŕ̒lĂB
	t_idx[0] = t_idx[1] = -1;
	flg = 0;
  }
  C_Edge( C_Vec p0, C_Vec p1 ){
	p[0] = p0; p[1] = p1;
	//lŕ̒lĂB
	v_idx[0] = v_idx[1] = -1;
	t_idx[0] = t_idx[1] = -1;
	flg = 0;
  }
  void SetShareTrigon( s16 no, s16 i ){
	t_idx[no] = i;
  }
  //`(Jg̃JŁj
  void Disp( u32 col=(u32)(0xff<<24 | 0xff<<16 | 0x88<<8 |0x88), u32 flg=0 );
  s16* VtxIdx( void ){ return v_idx; }
  s16* TriIdx( void ){ return t_idx; }
  void SetFlg( s32 f ){ flg = f; }
  s32 GetFlg( void ){ return flg; }
  C_Vec& GetVtx( u32 idx ){ return p[idx]; }
 private:
  C_Vec p[2];
  s16 v_idx[2];
  s16 t_idx[2];
  s32 flg;
};


class C_EdgeArray{
 public:
  //f̃gSłɂꍇ͂B(Փ˔ŎgĂ𗬗pƂj
  C_EdgeArray( C_TrigonArray& t );
  //f̃gS쐬B(Pɉep̃f̏ꍇj
  C_EdgeArray( HSD_PObj *pobj, HSD_JObj *j );
  virtual ~C_EdgeArray();

  void Proc( void );
  void DispStart( void );
  void DispEnd( void );
  void Disp( u32 idx, u32 flg=0, u32 col=(u32)(0x88<<24 | 0xff<<16 | 0x88<<8 |0x88) );
  void DispAll( void ){
	DispStart();
	for( int i=0; i<edge_num; i++ ){
	  Disp( (u32)i, 0 );
	}
	DispEnd();
  }
  bool IsDirty( void ){ return trigon.IsDirty(); }
  void RecalcFlg( C_Vec& pos );
  C_TrigonArray& GetTrigon( void ){ return trigon; }
  C_Edge& GetEdge( u32 idx ){ return edge[idx]; }
  u32 GetNum( void ){ return edge_num; }
  void Print( void );
 protected:
  enum{
	TRIGON_MAX = 20000
  };
  vector<C_Edge> edge;
  C_TrigonArray& trigon;
  C_TrigonArray trigon_body;
  u32 edge_num;
  virtual void Init( void );
};
#endif


