#ifndef ___C_FOG_H___
#define ___C_FOG_H___

//#include "common.h"
#include "c_scenedesc.h"

//sysdolphinfogbp[B
//܂gȂ̂ŁAfobOĂȂB
class C_Fog {
public:
	C_Fog(const C_FogSet* fs) : fog_set(fs){
		fog = HSD_FogLoadDesc(fs->desc);
	}
	C_Fog() : fog_set(0){ fog = HSD_FogAlloc(); }

	C_Fog(const C_Fog& f) : fog_set(f.fog_set), fog(f.fog){
		HSD_FogRef(fog);
	}
	virtual ~C_Fog(){ if(fog) HSD_FogUnref(fog); }

	const HSD_SceneFogSet* GetFogSet() const { return fog_set; }

	u32 GetActionNum() const { return fog_set->GetActionNum(); }

	void SetAction(const char* name){
		HSD_FogAddAnim(fog, fog_set->GetAction(name)->fog_aobjdesc);
	}
	void SetAction(u32 no){
		HSD_FogAddAnim(fog, fog_set->GetAction(no)->fog_aobjdesc);
	}
	void SetRate(f32 rate){
		HSD_ForeachAnim(fog, FOG_TYPE, ALL_TYPE_BITS
			, (HSD_ForeachFunc)HSD_AObjSetRate, AOBJ_ARG_AF, rate);
	}
	void SetCurrentFrame(f32 time){
		HSD_ForeachAnim(fog, FOG_TYPE, ALL_TYPE_BITS
			, (HSD_ForeachFunc)HSD_AObjSetCurrentFrame, AOBJ_ARG_AF, time);
	}
	virtual void Proc(){ HSD_FogInterpretAnim(fog); }

	virtual void Disp(){}
private:
	HSD_Fog*		fog;
	const C_FogSet*	fog_set;
};

#endif
