#ifndef ___C_RADIALBLUR_H___
#define ___C_RADIALBLUR_H___
//#include "common.h"

/*  1,u[p[c(OBJ)_OB */
/*  2,OBJ̎́A͈(RECT)eNX`ƂĎ荞ށB */
/*  3,RECT̑傫̃r{[h(JOBJ)pӂāA2ō쐬eNX`𒣂B */
/*  @JOBJ𕡐_OB̂ƂAtukău[B */

class C_RadialBlur{
 public:
  C_RadialBlur( HSD_JObj *_root_jobj, HSD_JObj *_target_jobj, HSD_JObj *_additional_jobj=0 );
  ~C_RadialBlur();
  void Proc( HSD_CObj *cobj );
  void Disp( void );
  void DrawTex( void );
  inline void SetRadius( f32 r ){ radius = r; }
  inline void SetScale( f32 s ){ max_scale = s; }
  inline void SetOfstX( f32 x_ ) {ofst_x = x_; }
  inline void SetOfstZ( f32 z_ ) {ofst_z = z_; }
  static void RenderProcessAll( void );
  static C_RadialBlur *GetInstance( void ){ return instance[0]; }
 protected:
 private:
  enum {
	JOBJ_NUM = 16,
	MAX_BLUR = 1,
	MAX_PTCL = 100,
	MAX_PTCL_PER_FRAME = 10
  };
  static C_RadialBlur *instance[MAX_BLUR];
  GXColor col;
  HSD_ImageDesc *img_desc,*img_desc_ptcl;
  HSD_JObj *root_jobj,*target_jobj,*additional_jobj,*jobjs[JOBJ_NUM];
  HSD_JObj *ptcl_jobj[ MAX_PTCL ];
  HSD_CObj *tex_cobj;
  bool done_flg;
  u32 tex_size;
  u32 counter,speed,min_blink,max_blink;
  f32 radius;
  f32 max_scale;
  s32 ptcl_num;
  f32 ofst_x, ofst_z;
  bool DispStart( HSD_CObj *cobj );
  ghmGcFile		file;
  void DispEnd( void );
};

#endif
