/* $Id: pslist.h,v 1.1 2003/06/30 10:42:17 fujita! Exp $ */
/*
 * Particle system
 *
 * Copyright 1999-2001 HAL Laboratory, Inc. All rights reserved.
 */
#ifndef __PSLIST_H__
#define __PSLIST_H__

int _psLinkInit(int num);
void _psListClear(void);
Particle *_psListNew(Particle *p, int linkNo);
void _psListDelete(Particle *pp, Particle *parent);
Particle *_psListGetFirst(int linkNo);

inline Particle *_psListGetNext(Particle *pp)
{
#if 0
  assert(pp);
#endif
  return pp->next;
}

Particle *particleSort(int linkNo, Particle **texedge, Particle **xlu);

#endif /* __PSLIST_H__ */
